//
// The Open Toolkit Library License
//
// Copyright (c) 2006 - 2013 Stefanos Apostolopoulos for the Open Toolkit Library
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights to 
// use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
// the Software, and to permit persons to whom the Software is furnished to do
// so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.
//



namespace OpenTK.Graphics.OpenGL
{
    using System;
    using System.Text;
    using System.Runtime.InteropServices;
    #pragma warning disable 3019
    #pragma warning disable 1591
    #pragma warning disable 1572
    #pragma warning disable 1573
    #pragma warning disable 626

    partial class GL
    {
        static GL()
        {
            EntryPointNames = new string[]
            {
                "glAccum",
                "glAccumxOES",
                "glActiveProgramEXT",
                "glActiveShaderProgram",
                "glActiveShaderProgramEXT",
                "glActiveStencilFaceEXT",
                "glActiveTexture",
                "glActiveTextureARB",
                "glActiveVaryingNV",
                "glAlphaFragmentOp1ATI",
                "glAlphaFragmentOp2ATI",
                "glAlphaFragmentOp3ATI",
                "glAlphaFunc",
                "glAlphaFuncxOES",
                "glApplyTextureEXT",
                "glAreProgramsResidentNV",
                "glAreTexturesResident",
                "glAreTexturesResidentEXT",
                "glArrayElement",
                "glArrayElementEXT",
                "glArrayObjectATI",
                "glAsyncMarkerSGIX",
                "glAttachObjectARB",
                "glAttachShader",
                "glBegin",
                "glBeginConditionalRender",
                "glBeginConditionalRenderNV",
                "glBeginConditionalRenderNVX",
                "glBeginFragmentShaderATI",
                "glBeginOcclusionQueryNV",
                "glBeginPerfMonitorAMD",
                "glBeginQuery",
                "glBeginQueryARB",
                "glBeginQueryIndexed",
                "glBeginTransformFeedback",
                "glBeginTransformFeedbackEXT",
                "glBeginTransformFeedbackNV",
                "glBeginVertexShaderEXT",
                "glBeginVideoCaptureNV",
                "glBindAttribLocation",
                "glBindAttribLocationARB",
                "glBindBuffer",
                "glBindBufferARB",
                "glBindBufferBase",
                "glBindBufferBaseEXT",
                "glBindBufferBaseNV",
                "glBindBufferOffsetEXT",
                "glBindBufferOffsetNV",
                "glBindBufferRange",
                "glBindBufferRangeEXT",
                "glBindBufferRangeNV",
                "glBindBuffersBase",
                "glBindBuffersRange",
                "glBindFragDataLocation",
                "glBindFragDataLocationEXT",
                "glBindFragDataLocationIndexed",
                "glBindFragmentShaderATI",
                "glBindFramebuffer",
                "glBindFramebufferEXT",
                "glBindImageTexture",
                "glBindImageTextureEXT",
                "glBindImageTextures",
                "glBindLightParameterEXT",
                "glBindMaterialParameterEXT",
                "glBindMultiTextureEXT",
                "glBindParameterEXT",
                "glBindProgramARB",
                "glBindProgramNV",
                "glBindProgramPipeline",
                "glBindProgramPipelineEXT",
                "glBindRenderbuffer",
                "glBindRenderbufferEXT",
                "glBindSampler",
                "glBindSamplers",
                "glBindTexGenParameterEXT",
                "glBindTexture",
                "glBindTextureEXT",
                "glBindTextures",
                "glBindTextureUnitParameterEXT",
                "glBindTransformFeedback",
                "glBindTransformFeedbackNV",
                "glBindVertexArray",
                "glBindVertexArrayAPPLE",
                "glBindVertexBuffer",
                "glBindVertexBuffers",
                "glBindVertexShaderEXT",
                "glBindVideoCaptureStreamBufferNV",
                "glBindVideoCaptureStreamTextureNV",
                "glBinormal3bEXT",
                "glBinormal3bvEXT",
                "glBinormal3dEXT",
                "glBinormal3dvEXT",
                "glBinormal3fEXT",
                "glBinormal3fvEXT",
                "glBinormal3iEXT",
                "glBinormal3ivEXT",
                "glBinormal3sEXT",
                "glBinormal3svEXT",
                "glBinormalPointerEXT",
                "glBitmap",
                "glBitmapxOES",
                "glBlendBarrierNV",
                "glBlendColor",
                "glBlendColorEXT",
                "glBlendColorxOES",
                "glBlendEquation",
                "glBlendEquationEXT",
                "glBlendEquationi",
                "glBlendEquationiARB",
                "glBlendEquationIndexedAMD",
                "glBlendEquationSeparate",
                "glBlendEquationSeparateEXT",
                "glBlendEquationSeparatei",
                "glBlendEquationSeparateiARB",
                "glBlendEquationSeparateIndexedAMD",
                "glBlendFunc",
                "glBlendFunci",
                "glBlendFunciARB",
                "glBlendFuncIndexedAMD",
                "glBlendFuncSeparate",
                "glBlendFuncSeparateEXT",
                "glBlendFuncSeparatei",
                "glBlendFuncSeparateiARB",
                "glBlendFuncSeparateIndexedAMD",
                "glBlendFuncSeparateINGR",
                "glBlendParameteriNV",
                "glBlitFramebuffer",
                "glBlitFramebufferEXT",
                "glBufferAddressRangeNV",
                "glBufferData",
                "glBufferDataARB",
                "glBufferParameteriAPPLE",
                "glBufferStorage",
                "glBufferSubData",
                "glBufferSubDataARB",
                "glCallList",
                "glCallLists",
                "glCheckFramebufferStatus",
                "glCheckFramebufferStatusEXT",
                "glCheckNamedFramebufferStatusEXT",
                "glClampColor",
                "glClampColorARB",
                "glClear",
                "glClearAccum",
                "glClearAccumxOES",
                "glClearBufferData",
                "glClearBufferfi",
                "glClearBufferfv",
                "glClearBufferiv",
                "glClearBufferSubData",
                "glClearBufferuiv",
                "glClearColor",
                "glClearColorIiEXT",
                "glClearColorIuiEXT",
                "glClearColorxOES",
                "glClearDepth",
                "glClearDepthdNV",
                "glClearDepthf",
                "glClearDepthfOES",
                "glClearDepthxOES",
                "glClearIndex",
                "glClearNamedBufferDataEXT",
                "glClearNamedBufferSubDataEXT",
                "glClearStencil",
                "glClearTexImage",
                "glClearTexSubImage",
                "glClientActiveTexture",
                "glClientActiveTextureARB",
                "glClientActiveVertexStreamATI",
                "glClientAttribDefaultEXT",
                "glClientWaitSync",
                "glClipPlane",
                "glClipPlanefOES",
                "glClipPlanexOES",
                "glColor3b",
                "glColor3bv",
                "glColor3d",
                "glColor3dv",
                "glColor3f",
                "glColor3fv",
                "glColor3fVertex3fSUN",
                "glColor3fVertex3fvSUN",
                "glColor3hNV",
                "glColor3hvNV",
                "glColor3i",
                "glColor3iv",
                "glColor3s",
                "glColor3sv",
                "glColor3ub",
                "glColor3ubv",
                "glColor3ui",
                "glColor3uiv",
                "glColor3us",
                "glColor3usv",
                "glColor3xOES",
                "glColor3xvOES",
                "glColor4b",
                "glColor4bv",
                "glColor4d",
                "glColor4dv",
                "glColor4f",
                "glColor4fNormal3fVertex3fSUN",
                "glColor4fNormal3fVertex3fvSUN",
                "glColor4fv",
                "glColor4hNV",
                "glColor4hvNV",
                "glColor4i",
                "glColor4iv",
                "glColor4s",
                "glColor4sv",
                "glColor4ub",
                "glColor4ubv",
                "glColor4ubVertex2fSUN",
                "glColor4ubVertex2fvSUN",
                "glColor4ubVertex3fSUN",
                "glColor4ubVertex3fvSUN",
                "glColor4ui",
                "glColor4uiv",
                "glColor4us",
                "glColor4usv",
                "glColor4xOES",
                "glColor4xvOES",
                "glColorFormatNV",
                "glColorFragmentOp1ATI",
                "glColorFragmentOp2ATI",
                "glColorFragmentOp3ATI",
                "glColorMask",
                "glColorMaski",
                "glColorMaskIndexedEXT",
                "glColorMaterial",
                "glColorP3ui",
                "glColorP3uiv",
                "glColorP4ui",
                "glColorP4uiv",
                "glColorPointer",
                "glColorPointerEXT",
                "glColorPointerListIBM",
                "glColorPointervINTEL",
                "glColorSubTable",
                "glColorSubTableEXT",
                "glColorTable",
                "glColorTableEXT",
                "glColorTableParameterfv",
                "glColorTableParameterfvSGI",
                "glColorTableParameteriv",
                "glColorTableParameterivSGI",
                "glColorTableSGI",
                "glCombinerInputNV",
                "glCombinerOutputNV",
                "glCombinerParameterfNV",
                "glCombinerParameterfvNV",
                "glCombinerParameteriNV",
                "glCombinerParameterivNV",
                "glCombinerStageParameterfvNV",
                "glCompileShader",
                "glCompileShaderARB",
                "glCompileShaderIncludeARB",
                "glCompressedMultiTexImage1DEXT",
                "glCompressedMultiTexImage2DEXT",
                "glCompressedMultiTexImage3DEXT",
                "glCompressedMultiTexSubImage1DEXT",
                "glCompressedMultiTexSubImage2DEXT",
                "glCompressedMultiTexSubImage3DEXT",
                "glCompressedTexImage1D",
                "glCompressedTexImage1DARB",
                "glCompressedTexImage2D",
                "glCompressedTexImage2DARB",
                "glCompressedTexImage3D",
                "glCompressedTexImage3DARB",
                "glCompressedTexSubImage1D",
                "glCompressedTexSubImage1DARB",
                "glCompressedTexSubImage2D",
                "glCompressedTexSubImage2DARB",
                "glCompressedTexSubImage3D",
                "glCompressedTexSubImage3DARB",
                "glCompressedTextureImage1DEXT",
                "glCompressedTextureImage2DEXT",
                "glCompressedTextureImage3DEXT",
                "glCompressedTextureSubImage1DEXT",
                "glCompressedTextureSubImage2DEXT",
                "glCompressedTextureSubImage3DEXT",
                "glConvolutionFilter1D",
                "glConvolutionFilter1DEXT",
                "glConvolutionFilter2D",
                "glConvolutionFilter2DEXT",
                "glConvolutionParameterf",
                "glConvolutionParameterfEXT",
                "glConvolutionParameterfv",
                "glConvolutionParameterfvEXT",
                "glConvolutionParameteri",
                "glConvolutionParameteriEXT",
                "glConvolutionParameteriv",
                "glConvolutionParameterivEXT",
                "glConvolutionParameterxOES",
                "glConvolutionParameterxvOES",
                "glCopyBufferSubData",
                "glCopyColorSubTable",
                "glCopyColorSubTableEXT",
                "glCopyColorTable",
                "glCopyColorTableSGI",
                "glCopyConvolutionFilter1D",
                "glCopyConvolutionFilter1DEXT",
                "glCopyConvolutionFilter2D",
                "glCopyConvolutionFilter2DEXT",
                "glCopyImageSubData",
                "glCopyImageSubDataNV",
                "glCopyMultiTexImage1DEXT",
                "glCopyMultiTexImage2DEXT",
                "glCopyMultiTexSubImage1DEXT",
                "glCopyMultiTexSubImage2DEXT",
                "glCopyMultiTexSubImage3DEXT",
                "glCopyPathNV",
                "glCopyPixels",
                "glCopyTexImage1D",
                "glCopyTexImage1DEXT",
                "glCopyTexImage2D",
                "glCopyTexImage2DEXT",
                "glCopyTexSubImage1D",
                "glCopyTexSubImage1DEXT",
                "glCopyTexSubImage2D",
                "glCopyTexSubImage2DEXT",
                "glCopyTexSubImage3D",
                "glCopyTexSubImage3DEXT",
                "glCopyTextureImage1DEXT",
                "glCopyTextureImage2DEXT",
                "glCopyTextureSubImage1DEXT",
                "glCopyTextureSubImage2DEXT",
                "glCopyTextureSubImage3DEXT",
                "glCoverFillPathInstancedNV",
                "glCoverFillPathNV",
                "glCoverStrokePathInstancedNV",
                "glCoverStrokePathNV",
                "glCreateProgram",
                "glCreateProgramObjectARB",
                "glCreateShader",
                "glCreateShaderObjectARB",
                "glCreateShaderProgramEXT",
                "glCreateShaderProgramv",
                "glCreateShaderProgramvEXT",
                "glCreateSyncFromCLeventARB",
                "glCullFace",
                "glCullParameterdvEXT",
                "glCullParameterfvEXT",
                "glCurrentPaletteMatrixARB",
                "glDebugMessageCallback",
                "glDebugMessageCallbackAMD",
                "glDebugMessageCallbackARB",
                "glDebugMessageCallbackKHR",
                "glDebugMessageControl",
                "glDebugMessageControlARB",
                "glDebugMessageControlKHR",
                "glDebugMessageEnableAMD",
                "glDebugMessageInsert",
                "glDebugMessageInsertAMD",
                "glDebugMessageInsertARB",
                "glDebugMessageInsertKHR",
                "glDeformationMap3dSGIX",
                "glDeformationMap3fSGIX",
                "glDeformSGIX",
                "glDeleteAsyncMarkersSGIX",
                "glDeleteBuffers",
                "glDeleteBuffersARB",
                "glDeleteFencesAPPLE",
                "glDeleteFencesNV",
                "glDeleteFragmentShaderATI",
                "glDeleteFramebuffers",
                "glDeleteFramebuffersEXT",
                "glDeleteLists",
                "glDeleteNamedStringARB",
                "glDeleteNamesAMD",
                "glDeleteObjectARB",
                "glDeleteOcclusionQueriesNV",
                "glDeletePathsNV",
                "glDeletePerfMonitorsAMD",
                "glDeleteProgram",
                "glDeleteProgramPipelines",
                "glDeleteProgramPipelinesEXT",
                "glDeleteProgramsARB",
                "glDeleteProgramsNV",
                "glDeleteQueries",
                "glDeleteQueriesARB",
                "glDeleteRenderbuffers",
                "glDeleteRenderbuffersEXT",
                "glDeleteSamplers",
                "glDeleteShader",
                "glDeleteSync",
                "glDeleteTextures",
                "glDeleteTexturesEXT",
                "glDeleteTransformFeedbacks",
                "glDeleteTransformFeedbacksNV",
                "glDeleteVertexArrays",
                "glDeleteVertexArraysAPPLE",
                "glDeleteVertexShaderEXT",
                "glDepthBoundsdNV",
                "glDepthBoundsEXT",
                "glDepthFunc",
                "glDepthMask",
                "glDepthRange",
                "glDepthRangeArrayv",
                "glDepthRangedNV",
                "glDepthRangef",
                "glDepthRangefOES",
                "glDepthRangeIndexed",
                "glDepthRangexOES",
                "glDetachObjectARB",
                "glDetachShader",
                "glDetailTexFuncSGIS",
                "glDisable",
                "glDisableClientState",
                "glDisableClientStateiEXT",
                "glDisableClientStateIndexedEXT",
                "glDisablei",
                "glDisableIndexedEXT",
                "glDisableVariantClientStateEXT",
                "glDisableVertexArrayAttribEXT",
                "glDisableVertexArrayEXT",
                "glDisableVertexAttribAPPLE",
                "glDisableVertexAttribArray",
                "glDisableVertexAttribArrayARB",
                "glDispatchCompute",
                "glDispatchComputeGroupSizeARB",
                "glDispatchComputeIndirect",
                "glDrawArrays",
                "glDrawArraysEXT",
                "glDrawArraysIndirect",
                "glDrawArraysInstanced",
                "glDrawArraysInstancedARB",
                "glDrawArraysInstancedBaseInstance",
                "glDrawArraysInstancedEXT",
                "glDrawBuffer",
                "glDrawBuffers",
                "glDrawBuffersARB",
                "glDrawBuffersATI",
                "glDrawElementArrayAPPLE",
                "glDrawElementArrayATI",
                "glDrawElements",
                "glDrawElementsBaseVertex",
                "glDrawElementsIndirect",
                "glDrawElementsInstanced",
                "glDrawElementsInstancedARB",
                "glDrawElementsInstancedBaseInstance",
                "glDrawElementsInstancedBaseVertex",
                "glDrawElementsInstancedBaseVertexBaseInstance",
                "glDrawElementsInstancedEXT",
                "glDrawMeshArraysSUN",
                "glDrawPixels",
                "glDrawRangeElementArrayAPPLE",
                "glDrawRangeElementArrayATI",
                "glDrawRangeElements",
                "glDrawRangeElementsBaseVertex",
                "glDrawRangeElementsEXT",
                "glDrawTextureNV",
                "glDrawTransformFeedback",
                "glDrawTransformFeedbackInstanced",
                "glDrawTransformFeedbackNV",
                "glDrawTransformFeedbackStream",
                "glDrawTransformFeedbackStreamInstanced",
                "glEdgeFlag",
                "glEdgeFlagFormatNV",
                "glEdgeFlagPointer",
                "glEdgeFlagPointerEXT",
                "glEdgeFlagPointerListIBM",
                "glEdgeFlagv",
                "glElementPointerAPPLE",
                "glElementPointerATI",
                "glEnable",
                "glEnableClientState",
                "glEnableClientStateiEXT",
                "glEnableClientStateIndexedEXT",
                "glEnablei",
                "glEnableIndexedEXT",
                "glEnableVariantClientStateEXT",
                "glEnableVertexArrayAttribEXT",
                "glEnableVertexArrayEXT",
                "glEnableVertexAttribAPPLE",
                "glEnableVertexAttribArray",
                "glEnableVertexAttribArrayARB",
                "glEnd",
                "glEndConditionalRender",
                "glEndConditionalRenderNV",
                "glEndConditionalRenderNVX",
                "glEndFragmentShaderATI",
                "glEndList",
                "glEndOcclusionQueryNV",
                "glEndPerfMonitorAMD",
                "glEndQuery",
                "glEndQueryARB",
                "glEndQueryIndexed",
                "glEndTransformFeedback",
                "glEndTransformFeedbackEXT",
                "glEndTransformFeedbackNV",
                "glEndVertexShaderEXT",
                "glEndVideoCaptureNV",
                "glEvalCoord1d",
                "glEvalCoord1dv",
                "glEvalCoord1f",
                "glEvalCoord1fv",
                "glEvalCoord1xOES",
                "glEvalCoord1xvOES",
                "glEvalCoord2d",
                "glEvalCoord2dv",
                "glEvalCoord2f",
                "glEvalCoord2fv",
                "glEvalCoord2xOES",
                "glEvalCoord2xvOES",
                "glEvalMapsNV",
                "glEvalMesh1",
                "glEvalMesh2",
                "glEvalPoint1",
                "glEvalPoint2",
                "glExecuteProgramNV",
                "glExtractComponentEXT",
                "glFeedbackBuffer",
                "glFeedbackBufferxOES",
                "glFenceSync",
                "glFinalCombinerInputNV",
                "glFinish",
                "glFinishAsyncSGIX",
                "glFinishFenceAPPLE",
                "glFinishFenceNV",
                "glFinishObjectAPPLE",
                "glFinishTextureSUNX",
                "glFlush",
                "glFlushMappedBufferRange",
                "glFlushMappedBufferRangeAPPLE",
                "glFlushMappedNamedBufferRangeEXT",
                "glFlushPixelDataRangeNV",
                "glFlushRasterSGIX",
                "glFlushStaticDataIBM",
                "glFlushVertexArrayRangeAPPLE",
                "glFlushVertexArrayRangeNV",
                "glFogCoordd",
                "glFogCoorddEXT",
                "glFogCoorddv",
                "glFogCoorddvEXT",
                "glFogCoordf",
                "glFogCoordfEXT",
                "glFogCoordFormatNV",
                "glFogCoordfv",
                "glFogCoordfvEXT",
                "glFogCoordhNV",
                "glFogCoordhvNV",
                "glFogCoordPointer",
                "glFogCoordPointerEXT",
                "glFogCoordPointerListIBM",
                "glFogf",
                "glFogFuncSGIS",
                "glFogfv",
                "glFogi",
                "glFogiv",
                "glFogxOES",
                "glFogxvOES",
                "glFragmentColorMaterialSGIX",
                "glFragmentLightfSGIX",
                "glFragmentLightfvSGIX",
                "glFragmentLightiSGIX",
                "glFragmentLightivSGIX",
                "glFragmentLightModelfSGIX",
                "glFragmentLightModelfvSGIX",
                "glFragmentLightModeliSGIX",
                "glFragmentLightModelivSGIX",
                "glFragmentMaterialfSGIX",
                "glFragmentMaterialfvSGIX",
                "glFragmentMaterialiSGIX",
                "glFragmentMaterialivSGIX",
                "glFramebufferDrawBufferEXT",
                "glFramebufferDrawBuffersEXT",
                "glFramebufferParameteri",
                "glFramebufferReadBufferEXT",
                "glFramebufferRenderbuffer",
                "glFramebufferRenderbufferEXT",
                "glFramebufferTexture",
                "glFramebufferTexture1D",
                "glFramebufferTexture1DEXT",
                "glFramebufferTexture2D",
                "glFramebufferTexture2DEXT",
                "glFramebufferTexture3D",
                "glFramebufferTexture3DEXT",
                "glFramebufferTextureARB",
                "glFramebufferTextureEXT",
                "glFramebufferTextureFaceARB",
                "glFramebufferTextureFaceEXT",
                "glFramebufferTextureLayer",
                "glFramebufferTextureLayerARB",
                "glFramebufferTextureLayerEXT",
                "glFrameTerminatorGREMEDY",
                "glFrameZoomSGIX",
                "glFreeObjectBufferATI",
                "glFrontFace",
                "glFrustum",
                "glFrustumfOES",
                "glFrustumxOES",
                "glGenAsyncMarkersSGIX",
                "glGenBuffers",
                "glGenBuffersARB",
                "glGenerateMipmap",
                "glGenerateMipmapEXT",
                "glGenerateMultiTexMipmapEXT",
                "glGenerateTextureMipmapEXT",
                "glGenFencesAPPLE",
                "glGenFencesNV",
                "glGenFragmentShadersATI",
                "glGenFramebuffers",
                "glGenFramebuffersEXT",
                "glGenLists",
                "glGenNamesAMD",
                "glGenOcclusionQueriesNV",
                "glGenPathsNV",
                "glGenPerfMonitorsAMD",
                "glGenProgramPipelines",
                "glGenProgramPipelinesEXT",
                "glGenProgramsARB",
                "glGenProgramsNV",
                "glGenQueries",
                "glGenQueriesARB",
                "glGenRenderbuffers",
                "glGenRenderbuffersEXT",
                "glGenSamplers",
                "glGenSymbolsEXT",
                "glGenTextures",
                "glGenTexturesEXT",
                "glGenTransformFeedbacks",
                "glGenTransformFeedbacksNV",
                "glGenVertexArrays",
                "glGenVertexArraysAPPLE",
                "glGenVertexShadersEXT",
                "glGetActiveAtomicCounterBufferiv",
                "glGetActiveAttrib",
                "glGetActiveAttribARB",
                "glGetActiveSubroutineName",
                "glGetActiveSubroutineUniformiv",
                "glGetActiveSubroutineUniformName",
                "glGetActiveUniform",
                "glGetActiveUniformARB",
                "glGetActiveUniformBlockiv",
                "glGetActiveUniformBlockName",
                "glGetActiveUniformName",
                "glGetActiveUniformsiv",
                "glGetActiveVaryingNV",
                "glGetArrayObjectfvATI",
                "glGetArrayObjectivATI",
                "glGetAttachedObjectsARB",
                "glGetAttachedShaders",
                "glGetAttribLocation",
                "glGetAttribLocationARB",
                "glGetBooleani_v",
                "glGetBooleanIndexedvEXT",
                "glGetBooleanv",
                "glGetBufferParameteri64v",
                "glGetBufferParameteriv",
                "glGetBufferParameterivARB",
                "glGetBufferParameterui64vNV",
                "glGetBufferPointerv",
                "glGetBufferPointervARB",
                "glGetBufferSubData",
                "glGetBufferSubDataARB",
                "glGetClipPlane",
                "glGetClipPlanefOES",
                "glGetClipPlanexOES",
                "glGetColorTable",
                "glGetColorTableEXT",
                "glGetColorTableParameterfv",
                "glGetColorTableParameterfvEXT",
                "glGetColorTableParameterfvSGI",
                "glGetColorTableParameteriv",
                "glGetColorTableParameterivEXT",
                "glGetColorTableParameterivSGI",
                "glGetColorTableSGI",
                "glGetCombinerInputParameterfvNV",
                "glGetCombinerInputParameterivNV",
                "glGetCombinerOutputParameterfvNV",
                "glGetCombinerOutputParameterivNV",
                "glGetCombinerStageParameterfvNV",
                "glGetCompressedMultiTexImageEXT",
                "glGetCompressedTexImage",
                "glGetCompressedTexImageARB",
                "glGetCompressedTextureImageEXT",
                "glGetConvolutionFilter",
                "glGetConvolutionFilterEXT",
                "glGetConvolutionParameterfv",
                "glGetConvolutionParameterfvEXT",
                "glGetConvolutionParameteriv",
                "glGetConvolutionParameterivEXT",
                "glGetConvolutionParameterxvOES",
                "glGetDebugMessageLog",
                "glGetDebugMessageLogAMD",
                "glGetDebugMessageLogARB",
                "glGetDebugMessageLogKHR",
                "glGetDetailTexFuncSGIS",
                "glGetDoublei_v",
                "glGetDoublei_vEXT",
                "glGetDoubleIndexedvEXT",
                "glGetDoublev",
                "glGetError",
                "glGetFenceivNV",
                "glGetFinalCombinerInputParameterfvNV",
                "glGetFinalCombinerInputParameterivNV",
                "glGetFixedvOES",
                "glGetFloati_v",
                "glGetFloati_vEXT",
                "glGetFloatIndexedvEXT",
                "glGetFloatv",
                "glGetFogFuncSGIS",
                "glGetFragDataIndex",
                "glGetFragDataLocation",
                "glGetFragDataLocationEXT",
                "glGetFragmentLightfvSGIX",
                "glGetFragmentLightivSGIX",
                "glGetFragmentMaterialfvSGIX",
                "glGetFragmentMaterialivSGIX",
                "glGetFramebufferAttachmentParameteriv",
                "glGetFramebufferAttachmentParameterivEXT",
                "glGetFramebufferParameteriv",
                "glGetFramebufferParameterivEXT",
                "glGetGraphicsResetStatusARB",
                "glGetHandleARB",
                "glGetHistogram",
                "glGetHistogramEXT",
                "glGetHistogramParameterfv",
                "glGetHistogramParameterfvEXT",
                "glGetHistogramParameteriv",
                "glGetHistogramParameterivEXT",
                "glGetHistogramParameterxvOES",
                "glGetImageHandleARB",
                "glGetImageHandleNV",
                "glGetImageTransformParameterfvHP",
                "glGetImageTransformParameterivHP",
                "glGetInfoLogARB",
                "glGetInstrumentsSGIX",
                "glGetInteger64i_v",
                "glGetInteger64v",
                "glGetIntegeri_v",
                "glGetIntegerIndexedvEXT",
                "glGetIntegerui64i_vNV",
                "glGetIntegerui64vNV",
                "glGetIntegerv",
                "glGetInternalformati64v",
                "glGetInternalformativ",
                "glGetInvariantBooleanvEXT",
                "glGetInvariantFloatvEXT",
                "glGetInvariantIntegervEXT",
                "glGetLightfv",
                "glGetLightiv",
                "glGetLightxOES",
                "glGetLightxvOES",
                "glGetListParameterfvSGIX",
                "glGetListParameterivSGIX",
                "glGetLocalConstantBooleanvEXT",
                "glGetLocalConstantFloatvEXT",
                "glGetLocalConstantIntegervEXT",
                "glGetMapAttribParameterfvNV",
                "glGetMapAttribParameterivNV",
                "glGetMapControlPointsNV",
                "glGetMapdv",
                "glGetMapfv",
                "glGetMapiv",
                "glGetMapParameterfvNV",
                "glGetMapParameterivNV",
                "glGetMapxvOES",
                "glGetMaterialfv",
                "glGetMaterialiv",
                "glGetMaterialxOES",
                "glGetMaterialxvOES",
                "glGetMinmax",
                "glGetMinmaxEXT",
                "glGetMinmaxParameterfv",
                "glGetMinmaxParameterfvEXT",
                "glGetMinmaxParameteriv",
                "glGetMinmaxParameterivEXT",
                "glGetMultisamplefv",
                "glGetMultisamplefvNV",
                "glGetMultiTexEnvfvEXT",
                "glGetMultiTexEnvivEXT",
                "glGetMultiTexGendvEXT",
                "glGetMultiTexGenfvEXT",
                "glGetMultiTexGenivEXT",
                "glGetMultiTexImageEXT",
                "glGetMultiTexLevelParameterfvEXT",
                "glGetMultiTexLevelParameterivEXT",
                "glGetMultiTexParameterfvEXT",
                "glGetMultiTexParameterIivEXT",
                "glGetMultiTexParameterIuivEXT",
                "glGetMultiTexParameterivEXT",
                "glGetNamedBufferParameterivEXT",
                "glGetNamedBufferParameterui64vNV",
                "glGetNamedBufferPointervEXT",
                "glGetNamedBufferSubDataEXT",
                "glGetNamedFramebufferAttachmentParameterivEXT",
                "glGetNamedFramebufferParameterivEXT",
                "glGetNamedProgramivEXT",
                "glGetNamedProgramLocalParameterdvEXT",
                "glGetNamedProgramLocalParameterfvEXT",
                "glGetNamedProgramLocalParameterIivEXT",
                "glGetNamedProgramLocalParameterIuivEXT",
                "glGetNamedProgramStringEXT",
                "glGetNamedRenderbufferParameterivEXT",
                "glGetNamedStringARB",
                "glGetNamedStringivARB",
                "glGetnColorTableARB",
                "glGetnCompressedTexImageARB",
                "glGetnConvolutionFilterARB",
                "glGetnHistogramARB",
                "glGetnMapdvARB",
                "glGetnMapfvARB",
                "glGetnMapivARB",
                "glGetnMinmaxARB",
                "glGetnPixelMapfvARB",
                "glGetnPixelMapuivARB",
                "glGetnPixelMapusvARB",
                "glGetnPolygonStippleARB",
                "glGetnSeparableFilterARB",
                "glGetnTexImageARB",
                "glGetnUniformdvARB",
                "glGetnUniformfvARB",
                "glGetnUniformivARB",
                "glGetnUniformuivARB",
                "glGetObjectBufferfvATI",
                "glGetObjectBufferivATI",
                "glGetObjectLabel",
                "glGetObjectLabelEXT",
                "glGetObjectLabelKHR",
                "glGetObjectParameterfvARB",
                "glGetObjectParameterivAPPLE",
                "glGetObjectParameterivARB",
                "glGetObjectPtrLabel",
                "glGetObjectPtrLabelKHR",
                "glGetOcclusionQueryivNV",
                "glGetOcclusionQueryuivNV",
                "glGetPathColorGenfvNV",
                "glGetPathColorGenivNV",
                "glGetPathCommandsNV",
                "glGetPathCoordsNV",
                "glGetPathDashArrayNV",
                "glGetPathLengthNV",
                "glGetPathMetricRangeNV",
                "glGetPathMetricsNV",
                "glGetPathParameterfvNV",
                "glGetPathParameterivNV",
                "glGetPathSpacingNV",
                "glGetPathTexGenfvNV",
                "glGetPathTexGenivNV",
                "glGetPerfMonitorCounterDataAMD",
                "glGetPerfMonitorCounterInfoAMD",
                "glGetPerfMonitorCountersAMD",
                "glGetPerfMonitorCounterStringAMD",
                "glGetPerfMonitorGroupsAMD",
                "glGetPerfMonitorGroupStringAMD",
                "glGetPixelMapfv",
                "glGetPixelMapuiv",
                "glGetPixelMapusv",
                "glGetPixelMapxv",
                "glGetPixelTexGenParameterfvSGIS",
                "glGetPixelTexGenParameterivSGIS",
                "glGetPixelTransformParameterfvEXT",
                "glGetPixelTransformParameterivEXT",
                "glGetPointeri_vEXT",
                "glGetPointerIndexedvEXT",
                "glGetPointerv",
                "glGetPointervEXT",
                "glGetPointervKHR",
                "glGetPolygonStipple",
                "glGetProgramBinary",
                "glGetProgramEnvParameterdvARB",
                "glGetProgramEnvParameterfvARB",
                "glGetProgramEnvParameterIivNV",
                "glGetProgramEnvParameterIuivNV",
                "glGetProgramInfoLog",
                "glGetProgramInterfaceiv",
                "glGetProgramiv",
                "glGetProgramivARB",
                "glGetProgramivNV",
                "glGetProgramLocalParameterdvARB",
                "glGetProgramLocalParameterfvARB",
                "glGetProgramLocalParameterIivNV",
                "glGetProgramLocalParameterIuivNV",
                "glGetProgramNamedParameterdvNV",
                "glGetProgramNamedParameterfvNV",
                "glGetProgramParameterdvNV",
                "glGetProgramParameterfvNV",
                "glGetProgramPipelineInfoLog",
                "glGetProgramPipelineInfoLogEXT",
                "glGetProgramPipelineiv",
                "glGetProgramPipelineivEXT",
                "glGetProgramResourceIndex",
                "glGetProgramResourceiv",
                "glGetProgramResourceLocation",
                "glGetProgramResourceLocationIndex",
                "glGetProgramResourceName",
                "glGetProgramStageiv",
                "glGetProgramStringARB",
                "glGetProgramStringNV",
                "glGetProgramSubroutineParameteruivNV",
                "glGetQueryIndexediv",
                "glGetQueryiv",
                "glGetQueryivARB",
                "glGetQueryObjecti64v",
                "glGetQueryObjecti64vEXT",
                "glGetQueryObjectiv",
                "glGetQueryObjectivARB",
                "glGetQueryObjectui64v",
                "glGetQueryObjectui64vEXT",
                "glGetQueryObjectuiv",
                "glGetQueryObjectuivARB",
                "glGetRenderbufferParameteriv",
                "glGetRenderbufferParameterivEXT",
                "glGetSamplerParameterfv",
                "glGetSamplerParameterIiv",
                "glGetSamplerParameterIuiv",
                "glGetSamplerParameteriv",
                "glGetSeparableFilter",
                "glGetSeparableFilterEXT",
                "glGetShaderInfoLog",
                "glGetShaderiv",
                "glGetShaderPrecisionFormat",
                "glGetShaderSource",
                "glGetShaderSourceARB",
                "glGetSharpenTexFuncSGIS",
                "glGetString",
                "glGetStringi",
                "glGetSubroutineIndex",
                "glGetSubroutineUniformLocation",
                "glGetSynciv",
                "glGetTexBumpParameterfvATI",
                "glGetTexBumpParameterivATI",
                "glGetTexEnvfv",
                "glGetTexEnviv",
                "glGetTexEnvxvOES",
                "glGetTexFilterFuncSGIS",
                "glGetTexGendv",
                "glGetTexGenfv",
                "glGetTexGeniv",
                "glGetTexGenxvOES",
                "glGetTexImage",
                "glGetTexLevelParameterfv",
                "glGetTexLevelParameteriv",
                "glGetTexLevelParameterxvOES",
                "glGetTexParameterfv",
                "glGetTexParameterIiv",
                "glGetTexParameterIivEXT",
                "glGetTexParameterIuiv",
                "glGetTexParameterIuivEXT",
                "glGetTexParameteriv",
                "glGetTexParameterPointervAPPLE",
                "glGetTexParameterxvOES",
                "glGetTextureHandleARB",
                "glGetTextureHandleNV",
                "glGetTextureImageEXT",
                "glGetTextureLevelParameterfvEXT",
                "glGetTextureLevelParameterivEXT",
                "glGetTextureParameterfvEXT",
                "glGetTextureParameterIivEXT",
                "glGetTextureParameterIuivEXT",
                "glGetTextureParameterivEXT",
                "glGetTextureSamplerHandleARB",
                "glGetTextureSamplerHandleNV",
                "glGetTrackMatrixivNV",
                "glGetTransformFeedbackVarying",
                "glGetTransformFeedbackVaryingEXT",
                "glGetTransformFeedbackVaryingNV",
                "glGetUniformBlockIndex",
                "glGetUniformBufferSizeEXT",
                "glGetUniformdv",
                "glGetUniformfv",
                "glGetUniformfvARB",
                "glGetUniformi64vNV",
                "glGetUniformIndices",
                "glGetUniformiv",
                "glGetUniformivARB",
                "glGetUniformLocation",
                "glGetUniformLocationARB",
                "glGetUniformOffsetEXT",
                "glGetUniformSubroutineuiv",
                "glGetUniformui64vNV",
                "glGetUniformuiv",
                "glGetUniformuivEXT",
                "glGetVariantArrayObjectfvATI",
                "glGetVariantArrayObjectivATI",
                "glGetVariantBooleanvEXT",
                "glGetVariantFloatvEXT",
                "glGetVariantIntegervEXT",
                "glGetVariantPointervEXT",
                "glGetVaryingLocationNV",
                "glGetVertexArrayIntegeri_vEXT",
                "glGetVertexArrayIntegervEXT",
                "glGetVertexArrayPointeri_vEXT",
                "glGetVertexArrayPointervEXT",
                "glGetVertexAttribArrayObjectfvATI",
                "glGetVertexAttribArrayObjectivATI",
                "glGetVertexAttribdv",
                "glGetVertexAttribdvARB",
                "glGetVertexAttribdvNV",
                "glGetVertexAttribfv",
                "glGetVertexAttribfvARB",
                "glGetVertexAttribfvNV",
                "glGetVertexAttribIiv",
                "glGetVertexAttribIivEXT",
                "glGetVertexAttribIuiv",
                "glGetVertexAttribIuivEXT",
                "glGetVertexAttribiv",
                "glGetVertexAttribivARB",
                "glGetVertexAttribivNV",
                "glGetVertexAttribLdv",
                "glGetVertexAttribLdvEXT",
                "glGetVertexAttribLi64vNV",
                "glGetVertexAttribLui64vARB",
                "glGetVertexAttribLui64vNV",
                "glGetVertexAttribPointerv",
                "glGetVertexAttribPointervARB",
                "glGetVertexAttribPointervNV",
                "glGetVideoCaptureivNV",
                "glGetVideoCaptureStreamdvNV",
                "glGetVideoCaptureStreamfvNV",
                "glGetVideoCaptureStreamivNV",
                "glGetVideoi64vNV",
                "glGetVideoivNV",
                "glGetVideoui64vNV",
                "glGetVideouivNV",
                "glGlobalAlphaFactorbSUN",
                "glGlobalAlphaFactordSUN",
                "glGlobalAlphaFactorfSUN",
                "glGlobalAlphaFactoriSUN",
                "glGlobalAlphaFactorsSUN",
                "glGlobalAlphaFactorubSUN",
                "glGlobalAlphaFactoruiSUN",
                "glGlobalAlphaFactorusSUN",
                "glHint",
                "glHintPGI",
                "glHistogram",
                "glHistogramEXT",
                "glIglooInterfaceSGIX",
                "glImageTransformParameterfHP",
                "glImageTransformParameterfvHP",
                "glImageTransformParameteriHP",
                "glImageTransformParameterivHP",
                "glImportSyncEXT",
                "glIndexd",
                "glIndexdv",
                "glIndexf",
                "glIndexFormatNV",
                "glIndexFuncEXT",
                "glIndexfv",
                "glIndexi",
                "glIndexiv",
                "glIndexMask",
                "glIndexMaterialEXT",
                "glIndexPointer",
                "glIndexPointerEXT",
                "glIndexPointerListIBM",
                "glIndexs",
                "glIndexsv",
                "glIndexub",
                "glIndexubv",
                "glIndexxOES",
                "glIndexxvOES",
                "glInitNames",
                "glInsertComponentEXT",
                "glInsertEventMarkerEXT",
                "glInstrumentsBufferSGIX",
                "glInterleavedArrays",
                "glInterpolatePathsNV",
                "glInvalidateBufferData",
                "glInvalidateBufferSubData",
                "glInvalidateFramebuffer",
                "glInvalidateSubFramebuffer",
                "glInvalidateTexImage",
                "glInvalidateTexSubImage",
                "glIsAsyncMarkerSGIX",
                "glIsBuffer",
                "glIsBufferARB",
                "glIsBufferResidentNV",
                "glIsEnabled",
                "glIsEnabledi",
                "glIsEnabledIndexedEXT",
                "glIsFenceAPPLE",
                "glIsFenceNV",
                "glIsFramebuffer",
                "glIsFramebufferEXT",
                "glIsImageHandleResidentARB",
                "glIsImageHandleResidentNV",
                "glIsList",
                "glIsNameAMD",
                "glIsNamedBufferResidentNV",
                "glIsNamedStringARB",
                "glIsObjectBufferATI",
                "glIsOcclusionQueryNV",
                "glIsPathNV",
                "glIsPointInFillPathNV",
                "glIsPointInStrokePathNV",
                "glIsProgram",
                "glIsProgramARB",
                "glIsProgramNV",
                "glIsProgramPipeline",
                "glIsProgramPipelineEXT",
                "glIsQuery",
                "glIsQueryARB",
                "glIsRenderbuffer",
                "glIsRenderbufferEXT",
                "glIsSampler",
                "glIsShader",
                "glIsSync",
                "glIsTexture",
                "glIsTextureEXT",
                "glIsTextureHandleResidentARB",
                "glIsTextureHandleResidentNV",
                "glIsTransformFeedback",
                "glIsTransformFeedbackNV",
                "glIsVariantEnabledEXT",
                "glIsVertexArray",
                "glIsVertexArrayAPPLE",
                "glIsVertexAttribEnabledAPPLE",
                "glLabelObjectEXT",
                "glLightEnviSGIX",
                "glLightf",
                "glLightfv",
                "glLighti",
                "glLightiv",
                "glLightModelf",
                "glLightModelfv",
                "glLightModeli",
                "glLightModeliv",
                "glLightModelxOES",
                "glLightModelxvOES",
                "glLightxOES",
                "glLightxvOES",
                "glLineStipple",
                "glLineWidth",
                "glLineWidthxOES",
                "glLinkProgram",
                "glLinkProgramARB",
                "glListBase",
                "glListParameterfSGIX",
                "glListParameterfvSGIX",
                "glListParameteriSGIX",
                "glListParameterivSGIX",
                "glLoadIdentity",
                "glLoadIdentityDeformationMapSGIX",
                "glLoadMatrixd",
                "glLoadMatrixf",
                "glLoadMatrixxOES",
                "glLoadName",
                "glLoadProgramNV",
                "glLoadTransposeMatrixd",
                "glLoadTransposeMatrixdARB",
                "glLoadTransposeMatrixf",
                "glLoadTransposeMatrixfARB",
                "glLoadTransposeMatrixxOES",
                "glLockArraysEXT",
                "glLogicOp",
                "glMakeBufferNonResidentNV",
                "glMakeBufferResidentNV",
                "glMakeImageHandleNonResidentARB",
                "glMakeImageHandleNonResidentNV",
                "glMakeImageHandleResidentARB",
                "glMakeImageHandleResidentNV",
                "glMakeNamedBufferNonResidentNV",
                "glMakeNamedBufferResidentNV",
                "glMakeTextureHandleNonResidentARB",
                "glMakeTextureHandleNonResidentNV",
                "glMakeTextureHandleResidentARB",
                "glMakeTextureHandleResidentNV",
                "glMap1d",
                "glMap1f",
                "glMap1xOES",
                "glMap2d",
                "glMap2f",
                "glMap2xOES",
                "glMapBuffer",
                "glMapBufferARB",
                "glMapBufferRange",
                "glMapControlPointsNV",
                "glMapGrid1d",
                "glMapGrid1f",
                "glMapGrid1xOES",
                "glMapGrid2d",
                "glMapGrid2f",
                "glMapGrid2xOES",
                "glMapNamedBufferEXT",
                "glMapNamedBufferRangeEXT",
                "glMapObjectBufferATI",
                "glMapParameterfvNV",
                "glMapParameterivNV",
                "glMapTexture2DINTEL",
                "glMapVertexAttrib1dAPPLE",
                "glMapVertexAttrib1fAPPLE",
                "glMapVertexAttrib2dAPPLE",
                "glMapVertexAttrib2fAPPLE",
                "glMaterialf",
                "glMaterialfv",
                "glMateriali",
                "glMaterialiv",
                "glMaterialxOES",
                "glMaterialxvOES",
                "glMatrixFrustumEXT",
                "glMatrixIndexPointerARB",
                "glMatrixIndexubvARB",
                "glMatrixIndexuivARB",
                "glMatrixIndexusvARB",
                "glMatrixLoaddEXT",
                "glMatrixLoadfEXT",
                "glMatrixLoadIdentityEXT",
                "glMatrixLoadTransposedEXT",
                "glMatrixLoadTransposefEXT",
                "glMatrixMode",
                "glMatrixMultdEXT",
                "glMatrixMultfEXT",
                "glMatrixMultTransposedEXT",
                "glMatrixMultTransposefEXT",
                "glMatrixOrthoEXT",
                "glMatrixPopEXT",
                "glMatrixPushEXT",
                "glMatrixRotatedEXT",
                "glMatrixRotatefEXT",
                "glMatrixScaledEXT",
                "glMatrixScalefEXT",
                "glMatrixTranslatedEXT",
                "glMatrixTranslatefEXT",
                "glMemoryBarrier",
                "glMemoryBarrierEXT",
                "glMinmax",
                "glMinmaxEXT",
                "glMinSampleShading",
                "glMinSampleShadingARB",
                "glMultiDrawArrays",
                "glMultiDrawArraysEXT",
                "glMultiDrawArraysIndirect",
                "glMultiDrawArraysIndirectAMD",
                "glMultiDrawArraysIndirectBindlessNV",
                "glMultiDrawArraysIndirectCountARB",
                "glMultiDrawElementArrayAPPLE",
                "glMultiDrawElements",
                "glMultiDrawElementsBaseVertex",
                "glMultiDrawElementsEXT",
                "glMultiDrawElementsIndirect",
                "glMultiDrawElementsIndirectAMD",
                "glMultiDrawElementsIndirectBindlessNV",
                "glMultiDrawElementsIndirectCountARB",
                "glMultiDrawRangeElementArrayAPPLE",
                "glMultiModeDrawArraysIBM",
                "glMultiModeDrawElementsIBM",
                "glMultiTexBufferEXT",
                "glMultiTexCoord1bOES",
                "glMultiTexCoord1bvOES",
                "glMultiTexCoord1d",
                "glMultiTexCoord1dARB",
                "glMultiTexCoord1dv",
                "glMultiTexCoord1dvARB",
                "glMultiTexCoord1f",
                "glMultiTexCoord1fARB",
                "glMultiTexCoord1fv",
                "glMultiTexCoord1fvARB",
                "glMultiTexCoord1hNV",
                "glMultiTexCoord1hvNV",
                "glMultiTexCoord1i",
                "glMultiTexCoord1iARB",
                "glMultiTexCoord1iv",
                "glMultiTexCoord1ivARB",
                "glMultiTexCoord1s",
                "glMultiTexCoord1sARB",
                "glMultiTexCoord1sv",
                "glMultiTexCoord1svARB",
                "glMultiTexCoord1xOES",
                "glMultiTexCoord1xvOES",
                "glMultiTexCoord2bOES",
                "glMultiTexCoord2bvOES",
                "glMultiTexCoord2d",
                "glMultiTexCoord2dARB",
                "glMultiTexCoord2dv",
                "glMultiTexCoord2dvARB",
                "glMultiTexCoord2f",
                "glMultiTexCoord2fARB",
                "glMultiTexCoord2fv",
                "glMultiTexCoord2fvARB",
                "glMultiTexCoord2hNV",
                "glMultiTexCoord2hvNV",
                "glMultiTexCoord2i",
                "glMultiTexCoord2iARB",
                "glMultiTexCoord2iv",
                "glMultiTexCoord2ivARB",
                "glMultiTexCoord2s",
                "glMultiTexCoord2sARB",
                "glMultiTexCoord2sv",
                "glMultiTexCoord2svARB",
                "glMultiTexCoord2xOES",
                "glMultiTexCoord2xvOES",
                "glMultiTexCoord3bOES",
                "glMultiTexCoord3bvOES",
                "glMultiTexCoord3d",
                "glMultiTexCoord3dARB",
                "glMultiTexCoord3dv",
                "glMultiTexCoord3dvARB",
                "glMultiTexCoord3f",
                "glMultiTexCoord3fARB",
                "glMultiTexCoord3fv",
                "glMultiTexCoord3fvARB",
                "glMultiTexCoord3hNV",
                "glMultiTexCoord3hvNV",
                "glMultiTexCoord3i",
                "glMultiTexCoord3iARB",
                "glMultiTexCoord3iv",
                "glMultiTexCoord3ivARB",
                "glMultiTexCoord3s",
                "glMultiTexCoord3sARB",
                "glMultiTexCoord3sv",
                "glMultiTexCoord3svARB",
                "glMultiTexCoord3xOES",
                "glMultiTexCoord3xvOES",
                "glMultiTexCoord4bOES",
                "glMultiTexCoord4bvOES",
                "glMultiTexCoord4d",
                "glMultiTexCoord4dARB",
                "glMultiTexCoord4dv",
                "glMultiTexCoord4dvARB",
                "glMultiTexCoord4f",
                "glMultiTexCoord4fARB",
                "glMultiTexCoord4fv",
                "glMultiTexCoord4fvARB",
                "glMultiTexCoord4hNV",
                "glMultiTexCoord4hvNV",
                "glMultiTexCoord4i",
                "glMultiTexCoord4iARB",
                "glMultiTexCoord4iv",
                "glMultiTexCoord4ivARB",
                "glMultiTexCoord4s",
                "glMultiTexCoord4sARB",
                "glMultiTexCoord4sv",
                "glMultiTexCoord4svARB",
                "glMultiTexCoord4xOES",
                "glMultiTexCoord4xvOES",
                "glMultiTexCoordP1ui",
                "glMultiTexCoordP1uiv",
                "glMultiTexCoordP2ui",
                "glMultiTexCoordP2uiv",
                "glMultiTexCoordP3ui",
                "glMultiTexCoordP3uiv",
                "glMultiTexCoordP4ui",
                "glMultiTexCoordP4uiv",
                "glMultiTexCoordPointerEXT",
                "glMultiTexEnvfEXT",
                "glMultiTexEnvfvEXT",
                "glMultiTexEnviEXT",
                "glMultiTexEnvivEXT",
                "glMultiTexGendEXT",
                "glMultiTexGendvEXT",
                "glMultiTexGenfEXT",
                "glMultiTexGenfvEXT",
                "glMultiTexGeniEXT",
                "glMultiTexGenivEXT",
                "glMultiTexImage1DEXT",
                "glMultiTexImage2DEXT",
                "glMultiTexImage3DEXT",
                "glMultiTexParameterfEXT",
                "glMultiTexParameterfvEXT",
                "glMultiTexParameteriEXT",
                "glMultiTexParameterIivEXT",
                "glMultiTexParameterIuivEXT",
                "glMultiTexParameterivEXT",
                "glMultiTexRenderbufferEXT",
                "glMultiTexSubImage1DEXT",
                "glMultiTexSubImage2DEXT",
                "glMultiTexSubImage3DEXT",
                "glMultMatrixd",
                "glMultMatrixf",
                "glMultMatrixxOES",
                "glMultTransposeMatrixd",
                "glMultTransposeMatrixdARB",
                "glMultTransposeMatrixf",
                "glMultTransposeMatrixfARB",
                "glMultTransposeMatrixxOES",
                "glNamedBufferDataEXT",
                "glNamedBufferStorageEXT",
                "glNamedBufferSubDataEXT",
                "glNamedCopyBufferSubDataEXT",
                "glNamedFramebufferParameteriEXT",
                "glNamedFramebufferRenderbufferEXT",
                "glNamedFramebufferTexture1DEXT",
                "glNamedFramebufferTexture2DEXT",
                "glNamedFramebufferTexture3DEXT",
                "glNamedFramebufferTextureEXT",
                "glNamedFramebufferTextureFaceEXT",
                "glNamedFramebufferTextureLayerEXT",
                "glNamedProgramLocalParameter4dEXT",
                "glNamedProgramLocalParameter4dvEXT",
                "glNamedProgramLocalParameter4fEXT",
                "glNamedProgramLocalParameter4fvEXT",
                "glNamedProgramLocalParameterI4iEXT",
                "glNamedProgramLocalParameterI4ivEXT",
                "glNamedProgramLocalParameterI4uiEXT",
                "glNamedProgramLocalParameterI4uivEXT",
                "glNamedProgramLocalParameters4fvEXT",
                "glNamedProgramLocalParametersI4ivEXT",
                "glNamedProgramLocalParametersI4uivEXT",
                "glNamedProgramStringEXT",
                "glNamedRenderbufferStorageEXT",
                "glNamedRenderbufferStorageMultisampleCoverageEXT",
                "glNamedRenderbufferStorageMultisampleEXT",
                "glNamedStringARB",
                "glNewList",
                "glNewObjectBufferATI",
                "glNormal3b",
                "glNormal3bv",
                "glNormal3d",
                "glNormal3dv",
                "glNormal3f",
                "glNormal3fv",
                "glNormal3fVertex3fSUN",
                "glNormal3fVertex3fvSUN",
                "glNormal3hNV",
                "glNormal3hvNV",
                "glNormal3i",
                "glNormal3iv",
                "glNormal3s",
                "glNormal3sv",
                "glNormal3xOES",
                "glNormal3xvOES",
                "glNormalFormatNV",
                "glNormalP3ui",
                "glNormalP3uiv",
                "glNormalPointer",
                "glNormalPointerEXT",
                "glNormalPointerListIBM",
                "glNormalPointervINTEL",
                "glNormalStream3bATI",
                "glNormalStream3bvATI",
                "glNormalStream3dATI",
                "glNormalStream3dvATI",
                "glNormalStream3fATI",
                "glNormalStream3fvATI",
                "glNormalStream3iATI",
                "glNormalStream3ivATI",
                "glNormalStream3sATI",
                "glNormalStream3svATI",
                "glObjectLabel",
                "glObjectLabelKHR",
                "glObjectPtrLabel",
                "glObjectPtrLabelKHR",
                "glObjectPurgeableAPPLE",
                "glObjectUnpurgeableAPPLE",
                "glOrtho",
                "glOrthofOES",
                "glOrthoxOES",
                "glPassTexCoordATI",
                "glPassThrough",
                "glPassThroughxOES",
                "glPatchParameterfv",
                "glPatchParameteri",
                "glPathColorGenNV",
                "glPathCommandsNV",
                "glPathCoordsNV",
                "glPathCoverDepthFuncNV",
                "glPathDashArrayNV",
                "glPathFogGenNV",
                "glPathGlyphRangeNV",
                "glPathGlyphsNV",
                "glPathParameterfNV",
                "glPathParameterfvNV",
                "glPathParameteriNV",
                "glPathParameterivNV",
                "glPathStencilDepthOffsetNV",
                "glPathStencilFuncNV",
                "glPathStringNV",
                "glPathSubCommandsNV",
                "glPathSubCoordsNV",
                "glPathTexGenNV",
                "glPauseTransformFeedback",
                "glPauseTransformFeedbackNV",
                "glPixelDataRangeNV",
                "glPixelMapfv",
                "glPixelMapuiv",
                "glPixelMapusv",
                "glPixelMapx",
                "glPixelStoref",
                "glPixelStorei",
                "glPixelStorex",
                "glPixelTexGenParameterfSGIS",
                "glPixelTexGenParameterfvSGIS",
                "glPixelTexGenParameteriSGIS",
                "glPixelTexGenParameterivSGIS",
                "glPixelTexGenSGIX",
                "glPixelTransferf",
                "glPixelTransferi",
                "glPixelTransferxOES",
                "glPixelTransformParameterfEXT",
                "glPixelTransformParameterfvEXT",
                "glPixelTransformParameteriEXT",
                "glPixelTransformParameterivEXT",
                "glPixelZoom",
                "glPixelZoomxOES",
                "glPNTrianglesfATI",
                "glPNTrianglesiATI",
                "glPointAlongPathNV",
                "glPointParameterf",
                "glPointParameterfARB",
                "glPointParameterfEXT",
                "glPointParameterfSGIS",
                "glPointParameterfv",
                "glPointParameterfvARB",
                "glPointParameterfvEXT",
                "glPointParameterfvSGIS",
                "glPointParameteri",
                "glPointParameteriNV",
                "glPointParameteriv",
                "glPointParameterivNV",
                "glPointParameterxOES",
                "glPointParameterxvOES",
                "glPointSize",
                "glPointSizexOES",
                "glPollAsyncSGIX",
                "glPollInstrumentsSGIX",
                "glPolygonMode",
                "glPolygonOffset",
                "glPolygonOffsetEXT",
                "glPolygonOffsetxOES",
                "glPolygonStipple",
                "glPopAttrib",
                "glPopClientAttrib",
                "glPopDebugGroup",
                "glPopDebugGroupKHR",
                "glPopGroupMarkerEXT",
                "glPopMatrix",
                "glPopName",
                "glPresentFrameDualFillNV",
                "glPresentFrameKeyedNV",
                "glPrimitiveRestartIndex",
                "glPrimitiveRestartIndexNV",
                "glPrimitiveRestartNV",
                "glPrioritizeTextures",
                "glPrioritizeTexturesEXT",
                "glPrioritizeTexturesxOES",
                "glProgramBinary",
                "glProgramBufferParametersfvNV",
                "glProgramBufferParametersIivNV",
                "glProgramBufferParametersIuivNV",
                "glProgramEnvParameter4dARB",
                "glProgramEnvParameter4dvARB",
                "glProgramEnvParameter4fARB",
                "glProgramEnvParameter4fvARB",
                "glProgramEnvParameterI4iNV",
                "glProgramEnvParameterI4ivNV",
                "glProgramEnvParameterI4uiNV",
                "glProgramEnvParameterI4uivNV",
                "glProgramEnvParameters4fvEXT",
                "glProgramEnvParametersI4ivNV",
                "glProgramEnvParametersI4uivNV",
                "glProgramLocalParameter4dARB",
                "glProgramLocalParameter4dvARB",
                "glProgramLocalParameter4fARB",
                "glProgramLocalParameter4fvARB",
                "glProgramLocalParameterI4iNV",
                "glProgramLocalParameterI4ivNV",
                "glProgramLocalParameterI4uiNV",
                "glProgramLocalParameterI4uivNV",
                "glProgramLocalParameters4fvEXT",
                "glProgramLocalParametersI4ivNV",
                "glProgramLocalParametersI4uivNV",
                "glProgramNamedParameter4dNV",
                "glProgramNamedParameter4dvNV",
                "glProgramNamedParameter4fNV",
                "glProgramNamedParameter4fvNV",
                "glProgramParameter4dNV",
                "glProgramParameter4dvNV",
                "glProgramParameter4fNV",
                "glProgramParameter4fvNV",
                "glProgramParameteri",
                "glProgramParameteriARB",
                "glProgramParameteriEXT",
                "glProgramParameters4dvNV",
                "glProgramParameters4fvNV",
                "glProgramStringARB",
                "glProgramSubroutineParametersuivNV",
                "glProgramUniform1d",
                "glProgramUniform1dEXT",
                "glProgramUniform1dv",
                "glProgramUniform1dvEXT",
                "glProgramUniform1f",
                "glProgramUniform1fEXT",
                "glProgramUniform1fv",
                "glProgramUniform1fvEXT",
                "glProgramUniform1i",
                "glProgramUniform1i64NV",
                "glProgramUniform1i64vNV",
                "glProgramUniform1iEXT",
                "glProgramUniform1iv",
                "glProgramUniform1ivEXT",
                "glProgramUniform1ui",
                "glProgramUniform1ui64NV",
                "glProgramUniform1ui64vNV",
                "glProgramUniform1uiEXT",
                "glProgramUniform1uiv",
                "glProgramUniform1uivEXT",
                "glProgramUniform2d",
                "glProgramUniform2dEXT",
                "glProgramUniform2dv",
                "glProgramUniform2dvEXT",
                "glProgramUniform2f",
                "glProgramUniform2fEXT",
                "glProgramUniform2fv",
                "glProgramUniform2fvEXT",
                "glProgramUniform2i",
                "glProgramUniform2i64NV",
                "glProgramUniform2i64vNV",
                "glProgramUniform2iEXT",
                "glProgramUniform2iv",
                "glProgramUniform2ivEXT",
                "glProgramUniform2ui",
                "glProgramUniform2ui64NV",
                "glProgramUniform2ui64vNV",
                "glProgramUniform2uiEXT",
                "glProgramUniform2uiv",
                "glProgramUniform2uivEXT",
                "glProgramUniform3d",
                "glProgramUniform3dEXT",
                "glProgramUniform3dv",
                "glProgramUniform3dvEXT",
                "glProgramUniform3f",
                "glProgramUniform3fEXT",
                "glProgramUniform3fv",
                "glProgramUniform3fvEXT",
                "glProgramUniform3i",
                "glProgramUniform3i64NV",
                "glProgramUniform3i64vNV",
                "glProgramUniform3iEXT",
                "glProgramUniform3iv",
                "glProgramUniform3ivEXT",
                "glProgramUniform3ui",
                "glProgramUniform3ui64NV",
                "glProgramUniform3ui64vNV",
                "glProgramUniform3uiEXT",
                "glProgramUniform3uiv",
                "glProgramUniform3uivEXT",
                "glProgramUniform4d",
                "glProgramUniform4dEXT",
                "glProgramUniform4dv",
                "glProgramUniform4dvEXT",
                "glProgramUniform4f",
                "glProgramUniform4fEXT",
                "glProgramUniform4fv",
                "glProgramUniform4fvEXT",
                "glProgramUniform4i",
                "glProgramUniform4i64NV",
                "glProgramUniform4i64vNV",
                "glProgramUniform4iEXT",
                "glProgramUniform4iv",
                "glProgramUniform4ivEXT",
                "glProgramUniform4ui",
                "glProgramUniform4ui64NV",
                "glProgramUniform4ui64vNV",
                "glProgramUniform4uiEXT",
                "glProgramUniform4uiv",
                "glProgramUniform4uivEXT",
                "glProgramUniformHandleui64ARB",
                "glProgramUniformHandleui64NV",
                "glProgramUniformHandleui64vARB",
                "glProgramUniformHandleui64vNV",
                "glProgramUniformMatrix2dv",
                "glProgramUniformMatrix2dvEXT",
                "glProgramUniformMatrix2fv",
                "glProgramUniformMatrix2fvEXT",
                "glProgramUniformMatrix2x3dv",
                "glProgramUniformMatrix2x3dvEXT",
                "glProgramUniformMatrix2x3fv",
                "glProgramUniformMatrix2x3fvEXT",
                "glProgramUniformMatrix2x4dv",
                "glProgramUniformMatrix2x4dvEXT",
                "glProgramUniformMatrix2x4fv",
                "glProgramUniformMatrix2x4fvEXT",
                "glProgramUniformMatrix3dv",
                "glProgramUniformMatrix3dvEXT",
                "glProgramUniformMatrix3fv",
                "glProgramUniformMatrix3fvEXT",
                "glProgramUniformMatrix3x2dv",
                "glProgramUniformMatrix3x2dvEXT",
                "glProgramUniformMatrix3x2fv",
                "glProgramUniformMatrix3x2fvEXT",
                "glProgramUniformMatrix3x4dv",
                "glProgramUniformMatrix3x4dvEXT",
                "glProgramUniformMatrix3x4fv",
                "glProgramUniformMatrix3x4fvEXT",
                "glProgramUniformMatrix4dv",
                "glProgramUniformMatrix4dvEXT",
                "glProgramUniformMatrix4fv",
                "glProgramUniformMatrix4fvEXT",
                "glProgramUniformMatrix4x2dv",
                "glProgramUniformMatrix4x2dvEXT",
                "glProgramUniformMatrix4x2fv",
                "glProgramUniformMatrix4x2fvEXT",
                "glProgramUniformMatrix4x3dv",
                "glProgramUniformMatrix4x3dvEXT",
                "glProgramUniformMatrix4x3fv",
                "glProgramUniformMatrix4x3fvEXT",
                "glProgramUniformui64NV",
                "glProgramUniformui64vNV",
                "glProgramVertexLimitNV",
                "glProvokingVertex",
                "glProvokingVertexEXT",
                "glPushAttrib",
                "glPushClientAttrib",
                "glPushClientAttribDefaultEXT",
                "glPushDebugGroup",
                "glPushDebugGroupKHR",
                "glPushGroupMarkerEXT",
                "glPushMatrix",
                "glPushName",
                "glQueryCounter",
                "glQueryMatrixxOES",
                "glRasterPos2d",
                "glRasterPos2dv",
                "glRasterPos2f",
                "glRasterPos2fv",
                "glRasterPos2i",
                "glRasterPos2iv",
                "glRasterPos2s",
                "glRasterPos2sv",
                "glRasterPos2xOES",
                "glRasterPos2xvOES",
                "glRasterPos3d",
                "glRasterPos3dv",
                "glRasterPos3f",
                "glRasterPos3fv",
                "glRasterPos3i",
                "glRasterPos3iv",
                "glRasterPos3s",
                "glRasterPos3sv",
                "glRasterPos3xOES",
                "glRasterPos3xvOES",
                "glRasterPos4d",
                "glRasterPos4dv",
                "glRasterPos4f",
                "glRasterPos4fv",
                "glRasterPos4i",
                "glRasterPos4iv",
                "glRasterPos4s",
                "glRasterPos4sv",
                "glRasterPos4xOES",
                "glRasterPos4xvOES",
                "glReadBuffer",
                "glReadInstrumentsSGIX",
                "glReadnPixelsARB",
                "glReadPixels",
                "glRectd",
                "glRectdv",
                "glRectf",
                "glRectfv",
                "glRecti",
                "glRectiv",
                "glRects",
                "glRectsv",
                "glRectxOES",
                "glRectxvOES",
                "glReferencePlaneSGIX",
                "glReleaseShaderCompiler",
                "glRenderbufferStorage",
                "glRenderbufferStorageEXT",
                "glRenderbufferStorageMultisample",
                "glRenderbufferStorageMultisampleCoverageNV",
                "glRenderbufferStorageMultisampleEXT",
                "glRenderMode",
                "glReplacementCodePointerSUN",
                "glReplacementCodeubSUN",
                "glReplacementCodeubvSUN",
                "glReplacementCodeuiColor3fVertex3fSUN",
                "glReplacementCodeuiColor3fVertex3fvSUN",
                "glReplacementCodeuiColor4fNormal3fVertex3fSUN",
                "glReplacementCodeuiColor4fNormal3fVertex3fvSUN",
                "glReplacementCodeuiColor4ubVertex3fSUN",
                "glReplacementCodeuiColor4ubVertex3fvSUN",
                "glReplacementCodeuiNormal3fVertex3fSUN",
                "glReplacementCodeuiNormal3fVertex3fvSUN",
                "glReplacementCodeuiSUN",
                "glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN",
                "glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN",
                "glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN",
                "glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN",
                "glReplacementCodeuiTexCoord2fVertex3fSUN",
                "glReplacementCodeuiTexCoord2fVertex3fvSUN",
                "glReplacementCodeuiVertex3fSUN",
                "glReplacementCodeuiVertex3fvSUN",
                "glReplacementCodeuivSUN",
                "glReplacementCodeusSUN",
                "glReplacementCodeusvSUN",
                "glRequestResidentProgramsNV",
                "glResetHistogram",
                "glResetHistogramEXT",
                "glResetMinmax",
                "glResetMinmaxEXT",
                "glResizeBuffersMESA",
                "glResumeTransformFeedback",
                "glResumeTransformFeedbackNV",
                "glRotated",
                "glRotatef",
                "glRotatexOES",
                "glSampleCoverage",
                "glSampleCoverageARB",
                "glSampleCoverageOES",
                "glSampleCoveragexOES",
                "glSampleMapATI",
                "glSampleMaskEXT",
                "glSampleMaski",
                "glSampleMaskIndexedNV",
                "glSampleMaskSGIS",
                "glSamplePatternEXT",
                "glSamplePatternSGIS",
                "glSamplerParameterf",
                "glSamplerParameterfv",
                "glSamplerParameteri",
                "glSamplerParameterIiv",
                "glSamplerParameterIuiv",
                "glSamplerParameteriv",
                "glScaled",
                "glScalef",
                "glScalexOES",
                "glScissor",
                "glScissorArrayv",
                "glScissorIndexed",
                "glScissorIndexedv",
                "glSecondaryColor3b",
                "glSecondaryColor3bEXT",
                "glSecondaryColor3bv",
                "glSecondaryColor3bvEXT",
                "glSecondaryColor3d",
                "glSecondaryColor3dEXT",
                "glSecondaryColor3dv",
                "glSecondaryColor3dvEXT",
                "glSecondaryColor3f",
                "glSecondaryColor3fEXT",
                "glSecondaryColor3fv",
                "glSecondaryColor3fvEXT",
                "glSecondaryColor3hNV",
                "glSecondaryColor3hvNV",
                "glSecondaryColor3i",
                "glSecondaryColor3iEXT",
                "glSecondaryColor3iv",
                "glSecondaryColor3ivEXT",
                "glSecondaryColor3s",
                "glSecondaryColor3sEXT",
                "glSecondaryColor3sv",
                "glSecondaryColor3svEXT",
                "glSecondaryColor3ub",
                "glSecondaryColor3ubEXT",
                "glSecondaryColor3ubv",
                "glSecondaryColor3ubvEXT",
                "glSecondaryColor3ui",
                "glSecondaryColor3uiEXT",
                "glSecondaryColor3uiv",
                "glSecondaryColor3uivEXT",
                "glSecondaryColor3us",
                "glSecondaryColor3usEXT",
                "glSecondaryColor3usv",
                "glSecondaryColor3usvEXT",
                "glSecondaryColorFormatNV",
                "glSecondaryColorP3ui",
                "glSecondaryColorP3uiv",
                "glSecondaryColorPointer",
                "glSecondaryColorPointerEXT",
                "glSecondaryColorPointerListIBM",
                "glSelectBuffer",
                "glSelectPerfMonitorCountersAMD",
                "glSeparableFilter2D",
                "glSeparableFilter2DEXT",
                "glSetFenceAPPLE",
                "glSetFenceNV",
                "glSetFragmentShaderConstantATI",
                "glSetInvariantEXT",
                "glSetLocalConstantEXT",
                "glSetMultisamplefvAMD",
                "glShadeModel",
                "glShaderBinary",
                "glShaderOp1EXT",
                "glShaderOp2EXT",
                "glShaderOp3EXT",
                "glShaderSource",
                "glShaderSourceARB",
                "glShaderStorageBlockBinding",
                "glSharpenTexFuncSGIS",
                "glSpriteParameterfSGIX",
                "glSpriteParameterfvSGIX",
                "glSpriteParameteriSGIX",
                "glSpriteParameterivSGIX",
                "glStartInstrumentsSGIX",
                "glStencilClearTagEXT",
                "glStencilFillPathInstancedNV",
                "glStencilFillPathNV",
                "glStencilFunc",
                "glStencilFuncSeparate",
                "glStencilFuncSeparateATI",
                "glStencilMask",
                "glStencilMaskSeparate",
                "glStencilOp",
                "glStencilOpSeparate",
                "glStencilOpSeparateATI",
                "glStencilOpValueAMD",
                "glStencilStrokePathInstancedNV",
                "glStencilStrokePathNV",
                "glStopInstrumentsSGIX",
                "glStringMarkerGREMEDY",
                "glSwizzleEXT",
                "glSyncTextureINTEL",
                "glTagSampleBufferSGIX",
                "glTangent3bEXT",
                "glTangent3bvEXT",
                "glTangent3dEXT",
                "glTangent3dvEXT",
                "glTangent3fEXT",
                "glTangent3fvEXT",
                "glTangent3iEXT",
                "glTangent3ivEXT",
                "glTangent3sEXT",
                "glTangent3svEXT",
                "glTangentPointerEXT",
                "glTbufferMask3DFX",
                "glTessellationFactorAMD",
                "glTessellationModeAMD",
                "glTestFenceAPPLE",
                "glTestFenceNV",
                "glTestObjectAPPLE",
                "glTexBuffer",
                "glTexBufferARB",
                "glTexBufferEXT",
                "glTexBufferRange",
                "glTexBumpParameterfvATI",
                "glTexBumpParameterivATI",
                "glTexCoord1bOES",
                "glTexCoord1bvOES",
                "glTexCoord1d",
                "glTexCoord1dv",
                "glTexCoord1f",
                "glTexCoord1fv",
                "glTexCoord1hNV",
                "glTexCoord1hvNV",
                "glTexCoord1i",
                "glTexCoord1iv",
                "glTexCoord1s",
                "glTexCoord1sv",
                "glTexCoord1xOES",
                "glTexCoord1xvOES",
                "glTexCoord2bOES",
                "glTexCoord2bvOES",
                "glTexCoord2d",
                "glTexCoord2dv",
                "glTexCoord2f",
                "glTexCoord2fColor3fVertex3fSUN",
                "glTexCoord2fColor3fVertex3fvSUN",
                "glTexCoord2fColor4fNormal3fVertex3fSUN",
                "glTexCoord2fColor4fNormal3fVertex3fvSUN",
                "glTexCoord2fColor4ubVertex3fSUN",
                "glTexCoord2fColor4ubVertex3fvSUN",
                "glTexCoord2fNormal3fVertex3fSUN",
                "glTexCoord2fNormal3fVertex3fvSUN",
                "glTexCoord2fv",
                "glTexCoord2fVertex3fSUN",
                "glTexCoord2fVertex3fvSUN",
                "glTexCoord2hNV",
                "glTexCoord2hvNV",
                "glTexCoord2i",
                "glTexCoord2iv",
                "glTexCoord2s",
                "glTexCoord2sv",
                "glTexCoord2xOES",
                "glTexCoord2xvOES",
                "glTexCoord3bOES",
                "glTexCoord3bvOES",
                "glTexCoord3d",
                "glTexCoord3dv",
                "glTexCoord3f",
                "glTexCoord3fv",
                "glTexCoord3hNV",
                "glTexCoord3hvNV",
                "glTexCoord3i",
                "glTexCoord3iv",
                "glTexCoord3s",
                "glTexCoord3sv",
                "glTexCoord3xOES",
                "glTexCoord3xvOES",
                "glTexCoord4bOES",
                "glTexCoord4bvOES",
                "glTexCoord4d",
                "glTexCoord4dv",
                "glTexCoord4f",
                "glTexCoord4fColor4fNormal3fVertex4fSUN",
                "glTexCoord4fColor4fNormal3fVertex4fvSUN",
                "glTexCoord4fv",
                "glTexCoord4fVertex4fSUN",
                "glTexCoord4fVertex4fvSUN",
                "glTexCoord4hNV",
                "glTexCoord4hvNV",
                "glTexCoord4i",
                "glTexCoord4iv",
                "glTexCoord4s",
                "glTexCoord4sv",
                "glTexCoord4xOES",
                "glTexCoord4xvOES",
                "glTexCoordFormatNV",
                "glTexCoordP1ui",
                "glTexCoordP1uiv",
                "glTexCoordP2ui",
                "glTexCoordP2uiv",
                "glTexCoordP3ui",
                "glTexCoordP3uiv",
                "glTexCoordP4ui",
                "glTexCoordP4uiv",
                "glTexCoordPointer",
                "glTexCoordPointerEXT",
                "glTexCoordPointerListIBM",
                "glTexCoordPointervINTEL",
                "glTexEnvf",
                "glTexEnvfv",
                "glTexEnvi",
                "glTexEnviv",
                "glTexEnvxOES",
                "glTexEnvxvOES",
                "glTexFilterFuncSGIS",
                "glTexGend",
                "glTexGendv",
                "glTexGenf",
                "glTexGenfv",
                "glTexGeni",
                "glTexGeniv",
                "glTexGenxOES",
                "glTexGenxvOES",
                "glTexImage1D",
                "glTexImage2D",
                "glTexImage2DMultisample",
                "glTexImage2DMultisampleCoverageNV",
                "glTexImage3D",
                "glTexImage3DEXT",
                "glTexImage3DMultisample",
                "glTexImage3DMultisampleCoverageNV",
                "glTexImage4DSGIS",
                "glTexPageCommitmentARB",
                "glTexParameterf",
                "glTexParameterfv",
                "glTexParameteri",
                "glTexParameterIiv",
                "glTexParameterIivEXT",
                "glTexParameterIuiv",
                "glTexParameterIuivEXT",
                "glTexParameteriv",
                "glTexParameterxOES",
                "glTexParameterxvOES",
                "glTexRenderbufferNV",
                "glTexStorage1D",
                "glTexStorage2D",
                "glTexStorage2DMultisample",
                "glTexStorage3D",
                "glTexStorage3DMultisample",
                "glTexStorageSparseAMD",
                "glTexSubImage1D",
                "glTexSubImage1DEXT",
                "glTexSubImage2D",
                "glTexSubImage2DEXT",
                "glTexSubImage3D",
                "glTexSubImage3DEXT",
                "glTexSubImage4DSGIS",
                "glTextureBarrierNV",
                "glTextureBufferEXT",
                "glTextureBufferRangeEXT",
                "glTextureColorMaskSGIS",
                "glTextureImage1DEXT",
                "glTextureImage2DEXT",
                "glTextureImage2DMultisampleCoverageNV",
                "glTextureImage2DMultisampleNV",
                "glTextureImage3DEXT",
                "glTextureImage3DMultisampleCoverageNV",
                "glTextureImage3DMultisampleNV",
                "glTextureLightEXT",
                "glTextureMaterialEXT",
                "glTextureNormalEXT",
                "glTexturePageCommitmentEXT",
                "glTextureParameterfEXT",
                "glTextureParameterfvEXT",
                "glTextureParameteriEXT",
                "glTextureParameterIivEXT",
                "glTextureParameterIuivEXT",
                "glTextureParameterivEXT",
                "glTextureRangeAPPLE",
                "glTextureRenderbufferEXT",
                "glTextureStorage1DEXT",
                "glTextureStorage2DEXT",
                "glTextureStorage2DMultisampleEXT",
                "glTextureStorage3DEXT",
                "glTextureStorage3DMultisampleEXT",
                "glTextureStorageSparseAMD",
                "glTextureSubImage1DEXT",
                "glTextureSubImage2DEXT",
                "glTextureSubImage3DEXT",
                "glTextureView",
                "glTrackMatrixNV",
                "glTransformFeedbackAttribsNV",
                "glTransformFeedbackStreamAttribsNV",
                "glTransformFeedbackVaryings",
                "glTransformFeedbackVaryingsEXT",
                "glTransformFeedbackVaryingsNV",
                "glTransformPathNV",
                "glTranslated",
                "glTranslatef",
                "glTranslatexOES",
                "glUniform1d",
                "glUniform1dv",
                "glUniform1f",
                "glUniform1fARB",
                "glUniform1fv",
                "glUniform1fvARB",
                "glUniform1i",
                "glUniform1i64NV",
                "glUniform1i64vNV",
                "glUniform1iARB",
                "glUniform1iv",
                "glUniform1ivARB",
                "glUniform1ui",
                "glUniform1ui64NV",
                "glUniform1ui64vNV",
                "glUniform1uiEXT",
                "glUniform1uiv",
                "glUniform1uivEXT",
                "glUniform2d",
                "glUniform2dv",
                "glUniform2f",
                "glUniform2fARB",
                "glUniform2fv",
                "glUniform2fvARB",
                "glUniform2i",
                "glUniform2i64NV",
                "glUniform2i64vNV",
                "glUniform2iARB",
                "glUniform2iv",
                "glUniform2ivARB",
                "glUniform2ui",
                "glUniform2ui64NV",
                "glUniform2ui64vNV",
                "glUniform2uiEXT",
                "glUniform2uiv",
                "glUniform2uivEXT",
                "glUniform3d",
                "glUniform3dv",
                "glUniform3f",
                "glUniform3fARB",
                "glUniform3fv",
                "glUniform3fvARB",
                "glUniform3i",
                "glUniform3i64NV",
                "glUniform3i64vNV",
                "glUniform3iARB",
                "glUniform3iv",
                "glUniform3ivARB",
                "glUniform3ui",
                "glUniform3ui64NV",
                "glUniform3ui64vNV",
                "glUniform3uiEXT",
                "glUniform3uiv",
                "glUniform3uivEXT",
                "glUniform4d",
                "glUniform4dv",
                "glUniform4f",
                "glUniform4fARB",
                "glUniform4fv",
                "glUniform4fvARB",
                "glUniform4i",
                "glUniform4i64NV",
                "glUniform4i64vNV",
                "glUniform4iARB",
                "glUniform4iv",
                "glUniform4ivARB",
                "glUniform4ui",
                "glUniform4ui64NV",
                "glUniform4ui64vNV",
                "glUniform4uiEXT",
                "glUniform4uiv",
                "glUniform4uivEXT",
                "glUniformBlockBinding",
                "glUniformBufferEXT",
                "glUniformHandleui64ARB",
                "glUniformHandleui64NV",
                "glUniformHandleui64vARB",
                "glUniformHandleui64vNV",
                "glUniformMatrix2dv",
                "glUniformMatrix2fv",
                "glUniformMatrix2fvARB",
                "glUniformMatrix2x3dv",
                "glUniformMatrix2x3fv",
                "glUniformMatrix2x4dv",
                "glUniformMatrix2x4fv",
                "glUniformMatrix3dv",
                "glUniformMatrix3fv",
                "glUniformMatrix3fvARB",
                "glUniformMatrix3x2dv",
                "glUniformMatrix3x2fv",
                "glUniformMatrix3x4dv",
                "glUniformMatrix3x4fv",
                "glUniformMatrix4dv",
                "glUniformMatrix4fv",
                "glUniformMatrix4fvARB",
                "glUniformMatrix4x2dv",
                "glUniformMatrix4x2fv",
                "glUniformMatrix4x3dv",
                "glUniformMatrix4x3fv",
                "glUniformSubroutinesuiv",
                "glUniformui64NV",
                "glUniformui64vNV",
                "glUnlockArraysEXT",
                "glUnmapBuffer",
                "glUnmapBufferARB",
                "glUnmapNamedBufferEXT",
                "glUnmapObjectBufferATI",
                "glUnmapTexture2DINTEL",
                "glUpdateObjectBufferATI",
                "glUseProgram",
                "glUseProgramObjectARB",
                "glUseProgramStages",
                "glUseProgramStagesEXT",
                "glUseShaderProgramEXT",
                "glValidateProgram",
                "glValidateProgramARB",
                "glValidateProgramPipeline",
                "glValidateProgramPipelineEXT",
                "glVariantArrayObjectATI",
                "glVariantbvEXT",
                "glVariantdvEXT",
                "glVariantfvEXT",
                "glVariantivEXT",
                "glVariantPointerEXT",
                "glVariantsvEXT",
                "glVariantubvEXT",
                "glVariantuivEXT",
                "glVariantusvEXT",
                "glVDPAUFiniNV",
                "glVDPAUGetSurfaceivNV",
                "glVDPAUInitNV",
                "glVDPAUIsSurfaceNV",
                "glVDPAUMapSurfacesNV",
                "glVDPAURegisterOutputSurfaceNV",
                "glVDPAURegisterVideoSurfaceNV",
                "glVDPAUSurfaceAccessNV",
                "glVDPAUUnmapSurfacesNV",
                "glVDPAUUnregisterSurfaceNV",
                "glVertex2bOES",
                "glVertex2bvOES",
                "glVertex2d",
                "glVertex2dv",
                "glVertex2f",
                "glVertex2fv",
                "glVertex2hNV",
                "glVertex2hvNV",
                "glVertex2i",
                "glVertex2iv",
                "glVertex2s",
                "glVertex2sv",
                "glVertex2xOES",
                "glVertex2xvOES",
                "glVertex3bOES",
                "glVertex3bvOES",
                "glVertex3d",
                "glVertex3dv",
                "glVertex3f",
                "glVertex3fv",
                "glVertex3hNV",
                "glVertex3hvNV",
                "glVertex3i",
                "glVertex3iv",
                "glVertex3s",
                "glVertex3sv",
                "glVertex3xOES",
                "glVertex3xvOES",
                "glVertex4bOES",
                "glVertex4bvOES",
                "glVertex4d",
                "glVertex4dv",
                "glVertex4f",
                "glVertex4fv",
                "glVertex4hNV",
                "glVertex4hvNV",
                "glVertex4i",
                "glVertex4iv",
                "glVertex4s",
                "glVertex4sv",
                "glVertex4xOES",
                "glVertex4xvOES",
                "glVertexArrayBindVertexBufferEXT",
                "glVertexArrayColorOffsetEXT",
                "glVertexArrayEdgeFlagOffsetEXT",
                "glVertexArrayFogCoordOffsetEXT",
                "glVertexArrayIndexOffsetEXT",
                "glVertexArrayMultiTexCoordOffsetEXT",
                "glVertexArrayNormalOffsetEXT",
                "glVertexArrayParameteriAPPLE",
                "glVertexArrayRangeAPPLE",
                "glVertexArrayRangeNV",
                "glVertexArraySecondaryColorOffsetEXT",
                "glVertexArrayTexCoordOffsetEXT",
                "glVertexArrayVertexAttribBindingEXT",
                "glVertexArrayVertexAttribDivisorEXT",
                "glVertexArrayVertexAttribFormatEXT",
                "glVertexArrayVertexAttribIFormatEXT",
                "glVertexArrayVertexAttribIOffsetEXT",
                "glVertexArrayVertexAttribLFormatEXT",
                "glVertexArrayVertexAttribLOffsetEXT",
                "glVertexArrayVertexAttribOffsetEXT",
                "glVertexArrayVertexBindingDivisorEXT",
                "glVertexArrayVertexOffsetEXT",
                "glVertexAttrib1d",
                "glVertexAttrib1dARB",
                "glVertexAttrib1dNV",
                "glVertexAttrib1dv",
                "glVertexAttrib1dvARB",
                "glVertexAttrib1dvNV",
                "glVertexAttrib1f",
                "glVertexAttrib1fARB",
                "glVertexAttrib1fNV",
                "glVertexAttrib1fv",
                "glVertexAttrib1fvARB",
                "glVertexAttrib1fvNV",
                "glVertexAttrib1hNV",
                "glVertexAttrib1hvNV",
                "glVertexAttrib1s",
                "glVertexAttrib1sARB",
                "glVertexAttrib1sNV",
                "glVertexAttrib1sv",
                "glVertexAttrib1svARB",
                "glVertexAttrib1svNV",
                "glVertexAttrib2d",
                "glVertexAttrib2dARB",
                "glVertexAttrib2dNV",
                "glVertexAttrib2dv",
                "glVertexAttrib2dvARB",
                "glVertexAttrib2dvNV",
                "glVertexAttrib2f",
                "glVertexAttrib2fARB",
                "glVertexAttrib2fNV",
                "glVertexAttrib2fv",
                "glVertexAttrib2fvARB",
                "glVertexAttrib2fvNV",
                "glVertexAttrib2hNV",
                "glVertexAttrib2hvNV",
                "glVertexAttrib2s",
                "glVertexAttrib2sARB",
                "glVertexAttrib2sNV",
                "glVertexAttrib2sv",
                "glVertexAttrib2svARB",
                "glVertexAttrib2svNV",
                "glVertexAttrib3d",
                "glVertexAttrib3dARB",
                "glVertexAttrib3dNV",
                "glVertexAttrib3dv",
                "glVertexAttrib3dvARB",
                "glVertexAttrib3dvNV",
                "glVertexAttrib3f",
                "glVertexAttrib3fARB",
                "glVertexAttrib3fNV",
                "glVertexAttrib3fv",
                "glVertexAttrib3fvARB",
                "glVertexAttrib3fvNV",
                "glVertexAttrib3hNV",
                "glVertexAttrib3hvNV",
                "glVertexAttrib3s",
                "glVertexAttrib3sARB",
                "glVertexAttrib3sNV",
                "glVertexAttrib3sv",
                "glVertexAttrib3svARB",
                "glVertexAttrib3svNV",
                "glVertexAttrib4bv",
                "glVertexAttrib4bvARB",
                "glVertexAttrib4d",
                "glVertexAttrib4dARB",
                "glVertexAttrib4dNV",
                "glVertexAttrib4dv",
                "glVertexAttrib4dvARB",
                "glVertexAttrib4dvNV",
                "glVertexAttrib4f",
                "glVertexAttrib4fARB",
                "glVertexAttrib4fNV",
                "glVertexAttrib4fv",
                "glVertexAttrib4fvARB",
                "glVertexAttrib4fvNV",
                "glVertexAttrib4hNV",
                "glVertexAttrib4hvNV",
                "glVertexAttrib4iv",
                "glVertexAttrib4ivARB",
                "glVertexAttrib4Nbv",
                "glVertexAttrib4NbvARB",
                "glVertexAttrib4Niv",
                "glVertexAttrib4NivARB",
                "glVertexAttrib4Nsv",
                "glVertexAttrib4NsvARB",
                "glVertexAttrib4Nub",
                "glVertexAttrib4NubARB",
                "glVertexAttrib4Nubv",
                "glVertexAttrib4NubvARB",
                "glVertexAttrib4Nuiv",
                "glVertexAttrib4NuivARB",
                "glVertexAttrib4Nusv",
                "glVertexAttrib4NusvARB",
                "glVertexAttrib4s",
                "glVertexAttrib4sARB",
                "glVertexAttrib4sNV",
                "glVertexAttrib4sv",
                "glVertexAttrib4svARB",
                "glVertexAttrib4svNV",
                "glVertexAttrib4ubNV",
                "glVertexAttrib4ubv",
                "glVertexAttrib4ubvARB",
                "glVertexAttrib4ubvNV",
                "glVertexAttrib4uiv",
                "glVertexAttrib4uivARB",
                "glVertexAttrib4usv",
                "glVertexAttrib4usvARB",
                "glVertexAttribArrayObjectATI",
                "glVertexAttribBinding",
                "glVertexAttribDivisor",
                "glVertexAttribDivisorARB",
                "glVertexAttribFormat",
                "glVertexAttribFormatNV",
                "glVertexAttribI1i",
                "glVertexAttribI1iEXT",
                "glVertexAttribI1iv",
                "glVertexAttribI1ivEXT",
                "glVertexAttribI1ui",
                "glVertexAttribI1uiEXT",
                "glVertexAttribI1uiv",
                "glVertexAttribI1uivEXT",
                "glVertexAttribI2i",
                "glVertexAttribI2iEXT",
                "glVertexAttribI2iv",
                "glVertexAttribI2ivEXT",
                "glVertexAttribI2ui",
                "glVertexAttribI2uiEXT",
                "glVertexAttribI2uiv",
                "glVertexAttribI2uivEXT",
                "glVertexAttribI3i",
                "glVertexAttribI3iEXT",
                "glVertexAttribI3iv",
                "glVertexAttribI3ivEXT",
                "glVertexAttribI3ui",
                "glVertexAttribI3uiEXT",
                "glVertexAttribI3uiv",
                "glVertexAttribI3uivEXT",
                "glVertexAttribI4bv",
                "glVertexAttribI4bvEXT",
                "glVertexAttribI4i",
                "glVertexAttribI4iEXT",
                "glVertexAttribI4iv",
                "glVertexAttribI4ivEXT",
                "glVertexAttribI4sv",
                "glVertexAttribI4svEXT",
                "glVertexAttribI4ubv",
                "glVertexAttribI4ubvEXT",
                "glVertexAttribI4ui",
                "glVertexAttribI4uiEXT",
                "glVertexAttribI4uiv",
                "glVertexAttribI4uivEXT",
                "glVertexAttribI4usv",
                "glVertexAttribI4usvEXT",
                "glVertexAttribIFormat",
                "glVertexAttribIFormatNV",
                "glVertexAttribIPointer",
                "glVertexAttribIPointerEXT",
                "glVertexAttribL1d",
                "glVertexAttribL1dEXT",
                "glVertexAttribL1dv",
                "glVertexAttribL1dvEXT",
                "glVertexAttribL1i64NV",
                "glVertexAttribL1i64vNV",
                "glVertexAttribL1ui64ARB",
                "glVertexAttribL1ui64NV",
                "glVertexAttribL1ui64vARB",
                "glVertexAttribL1ui64vNV",
                "glVertexAttribL2d",
                "glVertexAttribL2dEXT",
                "glVertexAttribL2dv",
                "glVertexAttribL2dvEXT",
                "glVertexAttribL2i64NV",
                "glVertexAttribL2i64vNV",
                "glVertexAttribL2ui64NV",
                "glVertexAttribL2ui64vNV",
                "glVertexAttribL3d",
                "glVertexAttribL3dEXT",
                "glVertexAttribL3dv",
                "glVertexAttribL3dvEXT",
                "glVertexAttribL3i64NV",
                "glVertexAttribL3i64vNV",
                "glVertexAttribL3ui64NV",
                "glVertexAttribL3ui64vNV",
                "glVertexAttribL4d",
                "glVertexAttribL4dEXT",
                "glVertexAttribL4dv",
                "glVertexAttribL4dvEXT",
                "glVertexAttribL4i64NV",
                "glVertexAttribL4i64vNV",
                "glVertexAttribL4ui64NV",
                "glVertexAttribL4ui64vNV",
                "glVertexAttribLFormat",
                "glVertexAttribLFormatNV",
                "glVertexAttribLPointer",
                "glVertexAttribLPointerEXT",
                "glVertexAttribP1ui",
                "glVertexAttribP1uiv",
                "glVertexAttribP2ui",
                "glVertexAttribP2uiv",
                "glVertexAttribP3ui",
                "glVertexAttribP3uiv",
                "glVertexAttribP4ui",
                "glVertexAttribP4uiv",
                "glVertexAttribParameteriAMD",
                "glVertexAttribPointer",
                "glVertexAttribPointerARB",
                "glVertexAttribPointerNV",
                "glVertexAttribs1dvNV",
                "glVertexAttribs1fvNV",
                "glVertexAttribs1hvNV",
                "glVertexAttribs1svNV",
                "glVertexAttribs2dvNV",
                "glVertexAttribs2fvNV",
                "glVertexAttribs2hvNV",
                "glVertexAttribs2svNV",
                "glVertexAttribs3dvNV",
                "glVertexAttribs3fvNV",
                "glVertexAttribs3hvNV",
                "glVertexAttribs3svNV",
                "glVertexAttribs4dvNV",
                "glVertexAttribs4fvNV",
                "glVertexAttribs4hvNV",
                "glVertexAttribs4svNV",
                "glVertexAttribs4ubvNV",
                "glVertexBindingDivisor",
                "glVertexBlendARB",
                "glVertexBlendEnvfATI",
                "glVertexBlendEnviATI",
                "glVertexFormatNV",
                "glVertexP2ui",
                "glVertexP2uiv",
                "glVertexP3ui",
                "glVertexP3uiv",
                "glVertexP4ui",
                "glVertexP4uiv",
                "glVertexPointer",
                "glVertexPointerEXT",
                "glVertexPointerListIBM",
                "glVertexPointervINTEL",
                "glVertexStream1dATI",
                "glVertexStream1dvATI",
                "glVertexStream1fATI",
                "glVertexStream1fvATI",
                "glVertexStream1iATI",
                "glVertexStream1ivATI",
                "glVertexStream1sATI",
                "glVertexStream1svATI",
                "glVertexStream2dATI",
                "glVertexStream2dvATI",
                "glVertexStream2fATI",
                "glVertexStream2fvATI",
                "glVertexStream2iATI",
                "glVertexStream2ivATI",
                "glVertexStream2sATI",
                "glVertexStream2svATI",
                "glVertexStream3dATI",
                "glVertexStream3dvATI",
                "glVertexStream3fATI",
                "glVertexStream3fvATI",
                "glVertexStream3iATI",
                "glVertexStream3ivATI",
                "glVertexStream3sATI",
                "glVertexStream3svATI",
                "glVertexStream4dATI",
                "glVertexStream4dvATI",
                "glVertexStream4fATI",
                "glVertexStream4fvATI",
                "glVertexStream4iATI",
                "glVertexStream4ivATI",
                "glVertexStream4sATI",
                "glVertexStream4svATI",
                "glVertexWeightfEXT",
                "glVertexWeightfvEXT",
                "glVertexWeighthNV",
                "glVertexWeighthvNV",
                "glVertexWeightPointerEXT",
                "glVideoCaptureNV",
                "glVideoCaptureStreamParameterdvNV",
                "glVideoCaptureStreamParameterfvNV",
                "glVideoCaptureStreamParameterivNV",
                "glViewport",
                "glViewportArrayv",
                "glViewportIndexedf",
                "glViewportIndexedfv",
                "glWaitSync",
                "glWeightbvARB",
                "glWeightdvARB",
                "glWeightfvARB",
                "glWeightivARB",
                "glWeightPathsNV",
                "glWeightPointerARB",
                "glWeightsvARB",
                "glWeightubvARB",
                "glWeightuivARB",
                "glWeightusvARB",
                "glWindowPos2d",
                "glWindowPos2dARB",
                "glWindowPos2dMESA",
                "glWindowPos2dv",
                "glWindowPos2dvARB",
                "glWindowPos2dvMESA",
                "glWindowPos2f",
                "glWindowPos2fARB",
                "glWindowPos2fMESA",
                "glWindowPos2fv",
                "glWindowPos2fvARB",
                "glWindowPos2fvMESA",
                "glWindowPos2i",
                "glWindowPos2iARB",
                "glWindowPos2iMESA",
                "glWindowPos2iv",
                "glWindowPos2ivARB",
                "glWindowPos2ivMESA",
                "glWindowPos2s",
                "glWindowPos2sARB",
                "glWindowPos2sMESA",
                "glWindowPos2sv",
                "glWindowPos2svARB",
                "glWindowPos2svMESA",
                "glWindowPos3d",
                "glWindowPos3dARB",
                "glWindowPos3dMESA",
                "glWindowPos3dv",
                "glWindowPos3dvARB",
                "glWindowPos3dvMESA",
                "glWindowPos3f",
                "glWindowPos3fARB",
                "glWindowPos3fMESA",
                "glWindowPos3fv",
                "glWindowPos3fvARB",
                "glWindowPos3fvMESA",
                "glWindowPos3i",
                "glWindowPos3iARB",
                "glWindowPos3iMESA",
                "glWindowPos3iv",
                "glWindowPos3ivARB",
                "glWindowPos3ivMESA",
                "glWindowPos3s",
                "glWindowPos3sARB",
                "glWindowPos3sMESA",
                "glWindowPos3sv",
                "glWindowPos3svARB",
                "glWindowPos3svMESA",
                "glWindowPos4dMESA",
                "glWindowPos4dvMESA",
                "glWindowPos4fMESA",
                "glWindowPos4fvMESA",
                "glWindowPos4iMESA",
                "glWindowPos4ivMESA",
                "glWindowPos4sMESA",
                "glWindowPos4svMESA",
                "glWriteMaskEXT",
            };
            EntryPoints = new IntPtr[EntryPointNames.Length];
        }

        public static partial class GL_3dfx
        {
            /// <summary>[requires: 3DFX_tbuffer]</summary>
            [AutoGenerated(Category = "3DFX_tbuffer", Version = "", EntryPoint = "glTbufferMask3DFX")]
            public static extern void TbufferMask(Int32 mask);

            /// <summary>[requires: 3DFX_tbuffer]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "3DFX_tbuffer", Version = "", EntryPoint = "glTbufferMask3DFX")]
            public static extern void TbufferMask(UInt32 mask);

        }

        public static partial class Amd
        {
            /// <summary>[requires: AMD_performance_monitor]</summary>
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glBeginPerfMonitorAMD")]
            public static extern void BeginPerfMonitor(Int32 monitor);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glBeginPerfMonitorAMD")]
            public static extern void BeginPerfMonitor(UInt32 monitor);

            /// <summary>[requires: AMD_draw_buffers_blend]</summary>
            [AutoGenerated(Category = "AMD_draw_buffers_blend", Version = "", EntryPoint = "glBlendEquationIndexedAMD")]
            public static extern void BlendEquationIndexed(Int32 buf, OpenTK.Graphics.OpenGL.AmdDrawBuffersBlend mode);

            /// <summary>[requires: AMD_draw_buffers_blend]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_draw_buffers_blend", Version = "", EntryPoint = "glBlendEquationIndexedAMD")]
            public static extern void BlendEquationIndexed(UInt32 buf, OpenTK.Graphics.OpenGL.AmdDrawBuffersBlend mode);

            /// <summary>[requires: AMD_draw_buffers_blend]</summary>
            [AutoGenerated(Category = "AMD_draw_buffers_blend", Version = "", EntryPoint = "glBlendEquationSeparateIndexedAMD")]
            public static extern void BlendEquationSeparateIndexed(Int32 buf, OpenTK.Graphics.OpenGL.AmdDrawBuffersBlend modeRGB, OpenTK.Graphics.OpenGL.AmdDrawBuffersBlend modeAlpha);

            /// <summary>[requires: AMD_draw_buffers_blend]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_draw_buffers_blend", Version = "", EntryPoint = "glBlendEquationSeparateIndexedAMD")]
            public static extern void BlendEquationSeparateIndexed(UInt32 buf, OpenTK.Graphics.OpenGL.AmdDrawBuffersBlend modeRGB, OpenTK.Graphics.OpenGL.AmdDrawBuffersBlend modeAlpha);

            /// <summary>[requires: AMD_draw_buffers_blend]</summary>
            [AutoGenerated(Category = "AMD_draw_buffers_blend", Version = "", EntryPoint = "glBlendFuncIndexedAMD")]
            public static extern void BlendFuncIndexed(Int32 buf, OpenTK.Graphics.OpenGL.AmdDrawBuffersBlend src, OpenTK.Graphics.OpenGL.AmdDrawBuffersBlend dst);

            /// <summary>[requires: AMD_draw_buffers_blend]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_draw_buffers_blend", Version = "", EntryPoint = "glBlendFuncIndexedAMD")]
            public static extern void BlendFuncIndexed(UInt32 buf, OpenTK.Graphics.OpenGL.AmdDrawBuffersBlend src, OpenTK.Graphics.OpenGL.AmdDrawBuffersBlend dst);

            /// <summary>[requires: AMD_draw_buffers_blend]</summary>
            [AutoGenerated(Category = "AMD_draw_buffers_blend", Version = "", EntryPoint = "glBlendFuncSeparateIndexedAMD")]
            public static extern void BlendFuncSeparateIndexed(Int32 buf, OpenTK.Graphics.OpenGL.AmdDrawBuffersBlend srcRGB, OpenTK.Graphics.OpenGL.AmdDrawBuffersBlend dstRGB, OpenTK.Graphics.OpenGL.AmdDrawBuffersBlend srcAlpha, OpenTK.Graphics.OpenGL.AmdDrawBuffersBlend dstAlpha);

            /// <summary>[requires: AMD_draw_buffers_blend]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_draw_buffers_blend", Version = "", EntryPoint = "glBlendFuncSeparateIndexedAMD")]
            public static extern void BlendFuncSeparateIndexed(UInt32 buf, OpenTK.Graphics.OpenGL.AmdDrawBuffersBlend srcRGB, OpenTK.Graphics.OpenGL.AmdDrawBuffersBlend dstRGB, OpenTK.Graphics.OpenGL.AmdDrawBuffersBlend srcAlpha, OpenTK.Graphics.OpenGL.AmdDrawBuffersBlend dstAlpha);

            /// <summary>[requires: AMD_debug_output]
            /// Specify a callback to receive debugging messages from the GL
            /// </summary>
            /// <param name="callback">
            /// <para>
            /// The address of a callback function that will be called when a debug message is generated.
            /// </para>
            /// </param>
            /// <param name="userParam">
            /// <para>
            /// A user supplied pointer that will be passed on each invocation of callback.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "AMD_debug_output", Version = "", EntryPoint = "glDebugMessageCallbackAMD")]
            public static extern void DebugMessageCallback(DebugProcAmd callback, [OutAttribute] IntPtr userParam);

            /// <summary>[requires: AMD_debug_output]
            /// Specify a callback to receive debugging messages from the GL
            /// </summary>
            /// <param name="callback">
            /// <para>
            /// The address of a callback function that will be called when a debug message is generated.
            /// </para>
            /// </param>
            /// <param name="userParam">
            /// <para>
            /// A user supplied pointer that will be passed on each invocation of callback.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "AMD_debug_output", Version = "", EntryPoint = "glDebugMessageCallbackAMD")]
            public static extern void DebugMessageCallback<T1>(DebugProcAmd callback, [InAttribute, OutAttribute] T1[] userParam)
                where T1 : struct
            ;

            /// <summary>[requires: AMD_debug_output]
            /// Specify a callback to receive debugging messages from the GL
            /// </summary>
            /// <param name="callback">
            /// <para>
            /// The address of a callback function that will be called when a debug message is generated.
            /// </para>
            /// </param>
            /// <param name="userParam">
            /// <para>
            /// A user supplied pointer that will be passed on each invocation of callback.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "AMD_debug_output", Version = "", EntryPoint = "glDebugMessageCallbackAMD")]
            public static extern void DebugMessageCallback<T1>(DebugProcAmd callback, [InAttribute, OutAttribute] T1[,] userParam)
                where T1 : struct
            ;

            /// <summary>[requires: AMD_debug_output]
            /// Specify a callback to receive debugging messages from the GL
            /// </summary>
            /// <param name="callback">
            /// <para>
            /// The address of a callback function that will be called when a debug message is generated.
            /// </para>
            /// </param>
            /// <param name="userParam">
            /// <para>
            /// A user supplied pointer that will be passed on each invocation of callback.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "AMD_debug_output", Version = "", EntryPoint = "glDebugMessageCallbackAMD")]
            public static extern void DebugMessageCallback<T1>(DebugProcAmd callback, [InAttribute, OutAttribute] T1[,,] userParam)
                where T1 : struct
            ;

            /// <summary>[requires: AMD_debug_output]
            /// Specify a callback to receive debugging messages from the GL
            /// </summary>
            /// <param name="callback">
            /// <para>
            /// The address of a callback function that will be called when a debug message is generated.
            /// </para>
            /// </param>
            /// <param name="userParam">
            /// <para>
            /// A user supplied pointer that will be passed on each invocation of callback.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "AMD_debug_output", Version = "", EntryPoint = "glDebugMessageCallbackAMD")]
            public static extern void DebugMessageCallback<T1>(DebugProcAmd callback, [InAttribute, OutAttribute] ref T1 userParam)
                where T1 : struct
            ;

            /// <summary>[requires: AMD_debug_output]</summary>
            [AutoGenerated(Category = "AMD_debug_output", Version = "", EntryPoint = "glDebugMessageEnableAMD")]
            public static extern void DebugMessageEnable(OpenTK.Graphics.OpenGL.AmdDebugOutput category, OpenTK.Graphics.OpenGL.AmdDebugOutput severity, Int32 count, Int32[] ids, bool enabled);

            /// <summary>[requires: AMD_debug_output]</summary>
            [AutoGenerated(Category = "AMD_debug_output", Version = "", EntryPoint = "glDebugMessageEnableAMD")]
            public static extern void DebugMessageEnable(OpenTK.Graphics.OpenGL.AmdDebugOutput category, OpenTK.Graphics.OpenGL.AmdDebugOutput severity, Int32 count, ref Int32 ids, bool enabled);

            /// <summary>[requires: AMD_debug_output]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_debug_output", Version = "", EntryPoint = "glDebugMessageEnableAMD")]
            public static extern unsafe void DebugMessageEnable(OpenTK.Graphics.OpenGL.AmdDebugOutput category, OpenTK.Graphics.OpenGL.AmdDebugOutput severity, Int32 count, Int32* ids, bool enabled);

            /// <summary>[requires: AMD_debug_output]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_debug_output", Version = "", EntryPoint = "glDebugMessageEnableAMD")]
            public static extern void DebugMessageEnable(OpenTK.Graphics.OpenGL.AmdDebugOutput category, OpenTK.Graphics.OpenGL.AmdDebugOutput severity, Int32 count, UInt32[] ids, bool enabled);

            /// <summary>[requires: AMD_debug_output]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_debug_output", Version = "", EntryPoint = "glDebugMessageEnableAMD")]
            public static extern void DebugMessageEnable(OpenTK.Graphics.OpenGL.AmdDebugOutput category, OpenTK.Graphics.OpenGL.AmdDebugOutput severity, Int32 count, ref UInt32 ids, bool enabled);

            /// <summary>[requires: AMD_debug_output]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_debug_output", Version = "", EntryPoint = "glDebugMessageEnableAMD")]
            public static extern unsafe void DebugMessageEnable(OpenTK.Graphics.OpenGL.AmdDebugOutput category, OpenTK.Graphics.OpenGL.AmdDebugOutput severity, Int32 count, UInt32* ids, bool enabled);

            /// <summary>[requires: AMD_debug_output]
            /// Inject an application-supplied message into the debug message queue
            /// </summary>
            /// <param name="source">
            /// <para>
            /// The source of the debug message to insert.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the debug message insert.
            /// </para>
            /// </param>
            /// <param name="id">
            /// <para>
            /// The user-supplied identifier of the message to insert.
            /// </para>
            /// </param>
            /// <param name="severity">
            /// <para>
            /// The severity of the debug messages to insert.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The length string contained in the character array whose address is given by message.
            /// </para>
            /// </param>
            /// <param name="message">
            /// <para>
            /// The address of a character array containing the message to insert.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "AMD_debug_output", Version = "", EntryPoint = "glDebugMessageInsertAMD")]
            public static extern void DebugMessageInsert(OpenTK.Graphics.OpenGL.AmdDebugOutput category, OpenTK.Graphics.OpenGL.AmdDebugOutput severity, Int32 id, Int32 length, String buf);

            /// <summary>[requires: AMD_debug_output]
            /// Inject an application-supplied message into the debug message queue
            /// </summary>
            /// <param name="source">
            /// <para>
            /// The source of the debug message to insert.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the debug message insert.
            /// </para>
            /// </param>
            /// <param name="id">
            /// <para>
            /// The user-supplied identifier of the message to insert.
            /// </para>
            /// </param>
            /// <param name="severity">
            /// <para>
            /// The severity of the debug messages to insert.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The length string contained in the character array whose address is given by message.
            /// </para>
            /// </param>
            /// <param name="message">
            /// <para>
            /// The address of a character array containing the message to insert.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_debug_output", Version = "", EntryPoint = "glDebugMessageInsertAMD")]
            public static extern void DebugMessageInsert(OpenTK.Graphics.OpenGL.AmdDebugOutput category, OpenTK.Graphics.OpenGL.AmdDebugOutput severity, UInt32 id, Int32 length, String buf);

            /// <summary>[requires: AMD_name_gen_delete]</summary>
            [AutoGenerated(Category = "AMD_name_gen_delete", Version = "", EntryPoint = "glDeleteNamesAMD")]
            public static extern void DeleteNames(OpenTK.Graphics.OpenGL.AmdNameGenDelete identifier, Int32 num, Int32[] names);

            /// <summary>[requires: AMD_name_gen_delete]</summary>
            [AutoGenerated(Category = "AMD_name_gen_delete", Version = "", EntryPoint = "glDeleteNamesAMD")]
            public static extern void DeleteNames(OpenTK.Graphics.OpenGL.AmdNameGenDelete identifier, Int32 num, ref Int32 names);

            /// <summary>[requires: AMD_name_gen_delete]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_name_gen_delete", Version = "", EntryPoint = "glDeleteNamesAMD")]
            public static extern unsafe void DeleteNames(OpenTK.Graphics.OpenGL.AmdNameGenDelete identifier, Int32 num, Int32* names);

            /// <summary>[requires: AMD_name_gen_delete]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_name_gen_delete", Version = "", EntryPoint = "glDeleteNamesAMD")]
            public static extern void DeleteNames(OpenTK.Graphics.OpenGL.AmdNameGenDelete identifier, UInt32 num, UInt32[] names);

            /// <summary>[requires: AMD_name_gen_delete]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_name_gen_delete", Version = "", EntryPoint = "glDeleteNamesAMD")]
            public static extern void DeleteNames(OpenTK.Graphics.OpenGL.AmdNameGenDelete identifier, UInt32 num, ref UInt32 names);

            /// <summary>[requires: AMD_name_gen_delete]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_name_gen_delete", Version = "", EntryPoint = "glDeleteNamesAMD")]
            public static extern unsafe void DeleteNames(OpenTK.Graphics.OpenGL.AmdNameGenDelete identifier, UInt32 num, UInt32* names);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glDeletePerfMonitorsAMD")]
            public static extern void DeletePerfMonitor(Int32 monitors);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glDeletePerfMonitorsAMD")]
            public static extern void DeletePerfMonitor(UInt32 monitors);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glDeletePerfMonitorsAMD")]
            public static extern void DeletePerfMonitors(Int32 n, Int32[] monitors);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glDeletePerfMonitorsAMD")]
            public static extern void DeletePerfMonitors(Int32 n, ref Int32 monitors);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glDeletePerfMonitorsAMD")]
            public static extern unsafe void DeletePerfMonitors(Int32 n, Int32* monitors);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glDeletePerfMonitorsAMD")]
            public static extern void DeletePerfMonitors(Int32 n, UInt32[] monitors);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glDeletePerfMonitorsAMD")]
            public static extern void DeletePerfMonitors(Int32 n, ref UInt32 monitors);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glDeletePerfMonitorsAMD")]
            public static extern unsafe void DeletePerfMonitors(Int32 n, UInt32* monitors);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glEndPerfMonitorAMD")]
            public static extern void EndPerfMonitor(Int32 monitor);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glEndPerfMonitorAMD")]
            public static extern void EndPerfMonitor(UInt32 monitor);

            /// <summary>[requires: AMD_name_gen_delete]</summary>
            [AutoGenerated(Category = "AMD_name_gen_delete", Version = "", EntryPoint = "glGenNamesAMD")]
            public static extern void GenNames(OpenTK.Graphics.OpenGL.AmdNameGenDelete identifier, Int32 num, [OutAttribute] Int32[] names);

            /// <summary>[requires: AMD_name_gen_delete]</summary>
            [AutoGenerated(Category = "AMD_name_gen_delete", Version = "", EntryPoint = "glGenNamesAMD")]
            public static extern void GenNames(OpenTK.Graphics.OpenGL.AmdNameGenDelete identifier, Int32 num, [OutAttribute] out Int32 names);

            /// <summary>[requires: AMD_name_gen_delete]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_name_gen_delete", Version = "", EntryPoint = "glGenNamesAMD")]
            public static extern unsafe void GenNames(OpenTK.Graphics.OpenGL.AmdNameGenDelete identifier, Int32 num, [OutAttribute] Int32* names);

            /// <summary>[requires: AMD_name_gen_delete]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_name_gen_delete", Version = "", EntryPoint = "glGenNamesAMD")]
            public static extern void GenNames(OpenTK.Graphics.OpenGL.AmdNameGenDelete identifier, UInt32 num, [OutAttribute] UInt32[] names);

            /// <summary>[requires: AMD_name_gen_delete]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_name_gen_delete", Version = "", EntryPoint = "glGenNamesAMD")]
            public static extern void GenNames(OpenTK.Graphics.OpenGL.AmdNameGenDelete identifier, UInt32 num, [OutAttribute] out UInt32 names);

            /// <summary>[requires: AMD_name_gen_delete]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_name_gen_delete", Version = "", EntryPoint = "glGenNamesAMD")]
            public static extern unsafe void GenNames(OpenTK.Graphics.OpenGL.AmdNameGenDelete identifier, UInt32 num, [OutAttribute] UInt32* names);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGenPerfMonitorsAMD")]
            public static extern Int32 GenPerfMonitor();

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGenPerfMonitorsAMD")]
            public static extern void GenPerfMonitors(Int32 n, [OutAttribute] Int32[] monitors);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGenPerfMonitorsAMD")]
            public static extern void GenPerfMonitors(Int32 n, [OutAttribute] out Int32 monitors);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGenPerfMonitorsAMD")]
            public static extern unsafe void GenPerfMonitors(Int32 n, [OutAttribute] Int32* monitors);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGenPerfMonitorsAMD")]
            public static extern void GenPerfMonitors(Int32 n, [OutAttribute] UInt32[] monitors);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGenPerfMonitorsAMD")]
            public static extern void GenPerfMonitors(Int32 n, [OutAttribute] out UInt32 monitors);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGenPerfMonitorsAMD")]
            public static extern unsafe void GenPerfMonitors(Int32 n, [OutAttribute] UInt32* monitors);

            /// <summary>[requires: AMD_debug_output]
            /// Retrieve messages from the debug message log
            /// </summary>
            /// <param name="count">
            /// <para>
            /// The number of debug messages to retrieve from the log.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The size of the buffer whose address is given by messageLog.
            /// </para>
            /// </param>
            /// <param name="sources">
            /// <para>
            /// The address of an array of variables to receive the sources of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="types">
            /// <para>
            /// The address of an array of variables to receive the types of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// The address of an array of unsigned integers to receive the ids of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="severities">
            /// <para>
            /// The address of an array of variables to receive the severites of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="lengths">
            /// <para>
            /// The address of an array of variables to receive the lengths of the received messages.
            /// </para>
            /// </param>
            /// <param name="messageLog">
            /// <para>
            /// The address of an array of characters that will receive the messages.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "AMD_debug_output", Version = "", EntryPoint = "glGetDebugMessageLogAMD")]
            public static extern Int32 GetDebugMessageLog(Int32 count, Int32 bufsize, [OutAttribute] OpenTK.Graphics.OpenGL.AmdDebugOutput[] categories, [OutAttribute] Int32[] severities, [OutAttribute] Int32[] ids, [OutAttribute] Int32[] lengths, [OutAttribute] StringBuilder message);

            /// <summary>[requires: AMD_debug_output]
            /// Retrieve messages from the debug message log
            /// </summary>
            /// <param name="count">
            /// <para>
            /// The number of debug messages to retrieve from the log.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The size of the buffer whose address is given by messageLog.
            /// </para>
            /// </param>
            /// <param name="sources">
            /// <para>
            /// The address of an array of variables to receive the sources of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="types">
            /// <para>
            /// The address of an array of variables to receive the types of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// The address of an array of unsigned integers to receive the ids of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="severities">
            /// <para>
            /// The address of an array of variables to receive the severites of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="lengths">
            /// <para>
            /// The address of an array of variables to receive the lengths of the received messages.
            /// </para>
            /// </param>
            /// <param name="messageLog">
            /// <para>
            /// The address of an array of characters that will receive the messages.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "AMD_debug_output", Version = "", EntryPoint = "glGetDebugMessageLogAMD")]
            public static extern Int32 GetDebugMessageLog(Int32 count, Int32 bufsize, [OutAttribute] out OpenTK.Graphics.OpenGL.AmdDebugOutput categories, [OutAttribute] out Int32 severities, [OutAttribute] out Int32 ids, [OutAttribute] out Int32 lengths, [OutAttribute] StringBuilder message);

            /// <summary>[requires: AMD_debug_output]
            /// Retrieve messages from the debug message log
            /// </summary>
            /// <param name="count">
            /// <para>
            /// The number of debug messages to retrieve from the log.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The size of the buffer whose address is given by messageLog.
            /// </para>
            /// </param>
            /// <param name="sources">
            /// <para>
            /// The address of an array of variables to receive the sources of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="types">
            /// <para>
            /// The address of an array of variables to receive the types of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// The address of an array of unsigned integers to receive the ids of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="severities">
            /// <para>
            /// The address of an array of variables to receive the severites of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="lengths">
            /// <para>
            /// The address of an array of variables to receive the lengths of the received messages.
            /// </para>
            /// </param>
            /// <param name="messageLog">
            /// <para>
            /// The address of an array of characters that will receive the messages.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_debug_output", Version = "", EntryPoint = "glGetDebugMessageLogAMD")]
            public static extern unsafe Int32 GetDebugMessageLog(Int32 count, Int32 bufsize, [OutAttribute] OpenTK.Graphics.OpenGL.AmdDebugOutput* categories, [OutAttribute] Int32* severities, [OutAttribute] Int32* ids, [OutAttribute] Int32* lengths, [OutAttribute] StringBuilder message);

            /// <summary>[requires: AMD_debug_output]
            /// Retrieve messages from the debug message log
            /// </summary>
            /// <param name="count">
            /// <para>
            /// The number of debug messages to retrieve from the log.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The size of the buffer whose address is given by messageLog.
            /// </para>
            /// </param>
            /// <param name="sources">
            /// <para>
            /// The address of an array of variables to receive the sources of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="types">
            /// <para>
            /// The address of an array of variables to receive the types of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// The address of an array of unsigned integers to receive the ids of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="severities">
            /// <para>
            /// The address of an array of variables to receive the severites of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="lengths">
            /// <para>
            /// The address of an array of variables to receive the lengths of the received messages.
            /// </para>
            /// </param>
            /// <param name="messageLog">
            /// <para>
            /// The address of an array of characters that will receive the messages.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_debug_output", Version = "", EntryPoint = "glGetDebugMessageLogAMD")]
            public static extern Int32 GetDebugMessageLog(UInt32 count, Int32 bufsize, [OutAttribute] OpenTK.Graphics.OpenGL.AmdDebugOutput[] categories, [OutAttribute] UInt32[] severities, [OutAttribute] UInt32[] ids, [OutAttribute] Int32[] lengths, [OutAttribute] StringBuilder message);

            /// <summary>[requires: AMD_debug_output]
            /// Retrieve messages from the debug message log
            /// </summary>
            /// <param name="count">
            /// <para>
            /// The number of debug messages to retrieve from the log.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The size of the buffer whose address is given by messageLog.
            /// </para>
            /// </param>
            /// <param name="sources">
            /// <para>
            /// The address of an array of variables to receive the sources of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="types">
            /// <para>
            /// The address of an array of variables to receive the types of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// The address of an array of unsigned integers to receive the ids of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="severities">
            /// <para>
            /// The address of an array of variables to receive the severites of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="lengths">
            /// <para>
            /// The address of an array of variables to receive the lengths of the received messages.
            /// </para>
            /// </param>
            /// <param name="messageLog">
            /// <para>
            /// The address of an array of characters that will receive the messages.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_debug_output", Version = "", EntryPoint = "glGetDebugMessageLogAMD")]
            public static extern Int32 GetDebugMessageLog(UInt32 count, Int32 bufsize, [OutAttribute] out OpenTK.Graphics.OpenGL.AmdDebugOutput categories, [OutAttribute] out UInt32 severities, [OutAttribute] out UInt32 ids, [OutAttribute] out Int32 lengths, [OutAttribute] StringBuilder message);

            /// <summary>[requires: AMD_debug_output]
            /// Retrieve messages from the debug message log
            /// </summary>
            /// <param name="count">
            /// <para>
            /// The number of debug messages to retrieve from the log.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The size of the buffer whose address is given by messageLog.
            /// </para>
            /// </param>
            /// <param name="sources">
            /// <para>
            /// The address of an array of variables to receive the sources of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="types">
            /// <para>
            /// The address of an array of variables to receive the types of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// The address of an array of unsigned integers to receive the ids of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="severities">
            /// <para>
            /// The address of an array of variables to receive the severites of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="lengths">
            /// <para>
            /// The address of an array of variables to receive the lengths of the received messages.
            /// </para>
            /// </param>
            /// <param name="messageLog">
            /// <para>
            /// The address of an array of characters that will receive the messages.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_debug_output", Version = "", EntryPoint = "glGetDebugMessageLogAMD")]
            public static extern unsafe Int32 GetDebugMessageLog(UInt32 count, Int32 bufsize, [OutAttribute] OpenTK.Graphics.OpenGL.AmdDebugOutput* categories, [OutAttribute] UInt32* severities, [OutAttribute] UInt32* ids, [OutAttribute] Int32* lengths, [OutAttribute] StringBuilder message);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorCounterDataAMD")]
            public static extern void GetPerfMonitorCounterData(Int32 monitor, OpenTK.Graphics.OpenGL.AmdPerformanceMonitor pname, Int32 dataSize, [OutAttribute] Int32[] data, [OutAttribute] out Int32 bytesWritten);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorCounterDataAMD")]
            public static extern void GetPerfMonitorCounterData(Int32 monitor, OpenTK.Graphics.OpenGL.AmdPerformanceMonitor pname, Int32 dataSize, [OutAttribute] out Int32 data, [OutAttribute] out Int32 bytesWritten);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorCounterDataAMD")]
            public static extern unsafe void GetPerfMonitorCounterData(Int32 monitor, OpenTK.Graphics.OpenGL.AmdPerformanceMonitor pname, Int32 dataSize, [OutAttribute] Int32* data, [OutAttribute] Int32* bytesWritten);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorCounterDataAMD")]
            public static extern void GetPerfMonitorCounterData(UInt32 monitor, OpenTK.Graphics.OpenGL.AmdPerformanceMonitor pname, Int32 dataSize, [OutAttribute] UInt32[] data, [OutAttribute] out Int32 bytesWritten);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorCounterDataAMD")]
            public static extern void GetPerfMonitorCounterData(UInt32 monitor, OpenTK.Graphics.OpenGL.AmdPerformanceMonitor pname, Int32 dataSize, [OutAttribute] out UInt32 data, [OutAttribute] out Int32 bytesWritten);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorCounterDataAMD")]
            public static extern unsafe void GetPerfMonitorCounterData(UInt32 monitor, OpenTK.Graphics.OpenGL.AmdPerformanceMonitor pname, Int32 dataSize, [OutAttribute] UInt32* data, [OutAttribute] Int32* bytesWritten);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorCounterInfoAMD")]
            public static extern void GetPerfMonitorCounterInfo(Int32 group, Int32 counter, OpenTK.Graphics.OpenGL.AmdPerformanceMonitor pname, [OutAttribute] IntPtr data);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorCounterInfoAMD")]
            public static extern void GetPerfMonitorCounterInfo<T3>(Int32 group, Int32 counter, OpenTK.Graphics.OpenGL.AmdPerformanceMonitor pname, [InAttribute, OutAttribute] T3[] data)
                where T3 : struct
            ;

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorCounterInfoAMD")]
            public static extern void GetPerfMonitorCounterInfo<T3>(Int32 group, Int32 counter, OpenTK.Graphics.OpenGL.AmdPerformanceMonitor pname, [InAttribute, OutAttribute] T3[,] data)
                where T3 : struct
            ;

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorCounterInfoAMD")]
            public static extern void GetPerfMonitorCounterInfo<T3>(Int32 group, Int32 counter, OpenTK.Graphics.OpenGL.AmdPerformanceMonitor pname, [InAttribute, OutAttribute] T3[,,] data)
                where T3 : struct
            ;

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorCounterInfoAMD")]
            public static extern void GetPerfMonitorCounterInfo<T3>(Int32 group, Int32 counter, OpenTK.Graphics.OpenGL.AmdPerformanceMonitor pname, [InAttribute, OutAttribute] ref T3 data)
                where T3 : struct
            ;

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorCounterInfoAMD")]
            public static extern void GetPerfMonitorCounterInfo(UInt32 group, UInt32 counter, OpenTK.Graphics.OpenGL.AmdPerformanceMonitor pname, [OutAttribute] IntPtr data);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorCounterInfoAMD")]
            public static extern void GetPerfMonitorCounterInfo<T3>(UInt32 group, UInt32 counter, OpenTK.Graphics.OpenGL.AmdPerformanceMonitor pname, [InAttribute, OutAttribute] T3[] data)
                where T3 : struct
            ;

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorCounterInfoAMD")]
            public static extern void GetPerfMonitorCounterInfo<T3>(UInt32 group, UInt32 counter, OpenTK.Graphics.OpenGL.AmdPerformanceMonitor pname, [InAttribute, OutAttribute] T3[,] data)
                where T3 : struct
            ;

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorCounterInfoAMD")]
            public static extern void GetPerfMonitorCounterInfo<T3>(UInt32 group, UInt32 counter, OpenTK.Graphics.OpenGL.AmdPerformanceMonitor pname, [InAttribute, OutAttribute] T3[,,] data)
                where T3 : struct
            ;

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorCounterInfoAMD")]
            public static extern void GetPerfMonitorCounterInfo<T3>(UInt32 group, UInt32 counter, OpenTK.Graphics.OpenGL.AmdPerformanceMonitor pname, [InAttribute, OutAttribute] ref T3 data)
                where T3 : struct
            ;

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorCountersAMD")]
            public static extern void GetPerfMonitorCounters(Int32 group, [OutAttribute] out Int32 numCounters, [OutAttribute] out Int32 maxActiveCounters, Int32 counterSize, [OutAttribute] Int32[] counters);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorCountersAMD")]
            public static extern void GetPerfMonitorCounters(Int32 group, [OutAttribute] out Int32 numCounters, [OutAttribute] out Int32 maxActiveCounters, Int32 counterSize, [OutAttribute] out Int32 counters);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorCountersAMD")]
            public static extern unsafe void GetPerfMonitorCounters(Int32 group, [OutAttribute] Int32* numCounters, [OutAttribute] Int32* maxActiveCounters, Int32 counterSize, [OutAttribute] Int32* counters);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorCountersAMD")]
            public static extern void GetPerfMonitorCounters(UInt32 group, [OutAttribute] out Int32 numCounters, [OutAttribute] out Int32 maxActiveCounters, Int32 counterSize, [OutAttribute] UInt32[] counters);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorCountersAMD")]
            public static extern void GetPerfMonitorCounters(UInt32 group, [OutAttribute] out Int32 numCounters, [OutAttribute] out Int32 maxActiveCounters, Int32 counterSize, [OutAttribute] out UInt32 counters);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorCountersAMD")]
            public static extern unsafe void GetPerfMonitorCounters(UInt32 group, [OutAttribute] Int32* numCounters, [OutAttribute] Int32* maxActiveCounters, Int32 counterSize, [OutAttribute] UInt32* counters);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorCounterStringAMD")]
            public static extern void GetPerfMonitorCounterString(Int32 group, Int32 counter, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder counterString);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorCounterStringAMD")]
            public static extern unsafe void GetPerfMonitorCounterString(Int32 group, Int32 counter, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder counterString);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorCounterStringAMD")]
            public static extern void GetPerfMonitorCounterString(UInt32 group, UInt32 counter, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder counterString);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorCounterStringAMD")]
            public static extern unsafe void GetPerfMonitorCounterString(UInt32 group, UInt32 counter, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder counterString);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorGroupsAMD")]
            public static extern void GetPerfMonitorGroups([OutAttribute] out Int32 numGroups, Int32 groupsSize, [OutAttribute] Int32[] groups);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorGroupsAMD")]
            public static extern void GetPerfMonitorGroups([OutAttribute] out Int32 numGroups, Int32 groupsSize, [OutAttribute] out Int32 groups);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorGroupsAMD")]
            public static extern void GetPerfMonitorGroups([OutAttribute] out Int32 numGroups, Int32 groupsSize, [OutAttribute] UInt32[] groups);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorGroupsAMD")]
            public static extern void GetPerfMonitorGroups([OutAttribute] out Int32 numGroups, Int32 groupsSize, [OutAttribute] out UInt32 groups);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorGroupsAMD")]
            public static extern unsafe void GetPerfMonitorGroups([OutAttribute] Int32* numGroups, Int32 groupsSize, [OutAttribute] Int32* groups);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorGroupsAMD")]
            public static extern unsafe void GetPerfMonitorGroups([OutAttribute] Int32* numGroups, Int32 groupsSize, [OutAttribute] UInt32* groups);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorGroupStringAMD")]
            public static extern void GetPerfMonitorGroupString(Int32 group, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder groupString);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorGroupStringAMD")]
            public static extern unsafe void GetPerfMonitorGroupString(Int32 group, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder groupString);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorGroupStringAMD")]
            public static extern void GetPerfMonitorGroupString(UInt32 group, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder groupString);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glGetPerfMonitorGroupStringAMD")]
            public static extern unsafe void GetPerfMonitorGroupString(UInt32 group, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder groupString);

            /// <summary>[requires: AMD_name_gen_delete]</summary>
            [AutoGenerated(Category = "AMD_name_gen_delete", Version = "", EntryPoint = "glIsNameAMD")]
            public static extern bool IsName(OpenTK.Graphics.OpenGL.AmdNameGenDelete identifier, Int32 name);

            /// <summary>[requires: AMD_name_gen_delete]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_name_gen_delete", Version = "", EntryPoint = "glIsNameAMD")]
            public static extern bool IsName(OpenTK.Graphics.OpenGL.AmdNameGenDelete identifier, UInt32 name);

            /// <summary>[requires: AMD_multi_draw_indirect]
            /// Render multiple sets of primitives from array data, taking parameters from memory
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="indirect">
            /// <para>
            /// Specifies the address of an array of structures containing the draw parameters.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the the number of elements in the array of draw parameter structures.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the distance in basic machine units between elements of the draw parameter array.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "AMD_multi_draw_indirect", Version = "", EntryPoint = "glMultiDrawArraysIndirectAMD")]
            public static extern void MultiDrawArraysIndirect(OpenTK.Graphics.OpenGL.AmdMultiDrawIndirect mode, IntPtr indirect, Int32 primcount, Int32 stride);

            /// <summary>[requires: AMD_multi_draw_indirect]
            /// Render multiple sets of primitives from array data, taking parameters from memory
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="indirect">
            /// <para>
            /// Specifies the address of an array of structures containing the draw parameters.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the the number of elements in the array of draw parameter structures.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the distance in basic machine units between elements of the draw parameter array.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "AMD_multi_draw_indirect", Version = "", EntryPoint = "glMultiDrawArraysIndirectAMD")]
            public static extern void MultiDrawArraysIndirect<T1>(OpenTK.Graphics.OpenGL.AmdMultiDrawIndirect mode, [InAttribute, OutAttribute] T1[] indirect, Int32 primcount, Int32 stride)
                where T1 : struct
            ;

            /// <summary>[requires: AMD_multi_draw_indirect]
            /// Render multiple sets of primitives from array data, taking parameters from memory
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="indirect">
            /// <para>
            /// Specifies the address of an array of structures containing the draw parameters.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the the number of elements in the array of draw parameter structures.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the distance in basic machine units between elements of the draw parameter array.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "AMD_multi_draw_indirect", Version = "", EntryPoint = "glMultiDrawArraysIndirectAMD")]
            public static extern void MultiDrawArraysIndirect<T1>(OpenTK.Graphics.OpenGL.AmdMultiDrawIndirect mode, [InAttribute, OutAttribute] T1[,] indirect, Int32 primcount, Int32 stride)
                where T1 : struct
            ;

            /// <summary>[requires: AMD_multi_draw_indirect]
            /// Render multiple sets of primitives from array data, taking parameters from memory
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="indirect">
            /// <para>
            /// Specifies the address of an array of structures containing the draw parameters.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the the number of elements in the array of draw parameter structures.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the distance in basic machine units between elements of the draw parameter array.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "AMD_multi_draw_indirect", Version = "", EntryPoint = "glMultiDrawArraysIndirectAMD")]
            public static extern void MultiDrawArraysIndirect<T1>(OpenTK.Graphics.OpenGL.AmdMultiDrawIndirect mode, [InAttribute, OutAttribute] T1[,,] indirect, Int32 primcount, Int32 stride)
                where T1 : struct
            ;

            /// <summary>[requires: AMD_multi_draw_indirect]
            /// Render multiple sets of primitives from array data, taking parameters from memory
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="indirect">
            /// <para>
            /// Specifies the address of an array of structures containing the draw parameters.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the the number of elements in the array of draw parameter structures.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the distance in basic machine units between elements of the draw parameter array.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "AMD_multi_draw_indirect", Version = "", EntryPoint = "glMultiDrawArraysIndirectAMD")]
            public static extern void MultiDrawArraysIndirect<T1>(OpenTK.Graphics.OpenGL.AmdMultiDrawIndirect mode, [InAttribute, OutAttribute] ref T1 indirect, Int32 primcount, Int32 stride)
                where T1 : struct
            ;

            /// <summary>[requires: AMD_multi_draw_indirect]
            /// Render indexed primitives from array data, taking parameters from memory
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of data in the buffer bound to the GL_ELEMENT_ARRAY_BUFFER binding.
            /// </para>
            /// </param>
            /// <param name="indirect">
            /// <para>
            /// Specifies the address of a structure containing an array of draw parameters.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the number of elements in the array addressed by indirect.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the distance in basic machine units between elements of the draw parameter array.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "AMD_multi_draw_indirect", Version = "", EntryPoint = "glMultiDrawElementsIndirectAMD")]
            public static extern void MultiDrawElementsIndirect(OpenTK.Graphics.OpenGL.AmdMultiDrawIndirect mode, OpenTK.Graphics.OpenGL.AmdMultiDrawIndirect type, IntPtr indirect, Int32 primcount, Int32 stride);

            /// <summary>[requires: AMD_multi_draw_indirect]
            /// Render indexed primitives from array data, taking parameters from memory
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of data in the buffer bound to the GL_ELEMENT_ARRAY_BUFFER binding.
            /// </para>
            /// </param>
            /// <param name="indirect">
            /// <para>
            /// Specifies the address of a structure containing an array of draw parameters.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the number of elements in the array addressed by indirect.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the distance in basic machine units between elements of the draw parameter array.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "AMD_multi_draw_indirect", Version = "", EntryPoint = "glMultiDrawElementsIndirectAMD")]
            public static extern void MultiDrawElementsIndirect<T2>(OpenTK.Graphics.OpenGL.AmdMultiDrawIndirect mode, OpenTK.Graphics.OpenGL.AmdMultiDrawIndirect type, [InAttribute, OutAttribute] T2[] indirect, Int32 primcount, Int32 stride)
                where T2 : struct
            ;

            /// <summary>[requires: AMD_multi_draw_indirect]
            /// Render indexed primitives from array data, taking parameters from memory
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of data in the buffer bound to the GL_ELEMENT_ARRAY_BUFFER binding.
            /// </para>
            /// </param>
            /// <param name="indirect">
            /// <para>
            /// Specifies the address of a structure containing an array of draw parameters.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the number of elements in the array addressed by indirect.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the distance in basic machine units between elements of the draw parameter array.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "AMD_multi_draw_indirect", Version = "", EntryPoint = "glMultiDrawElementsIndirectAMD")]
            public static extern void MultiDrawElementsIndirect<T2>(OpenTK.Graphics.OpenGL.AmdMultiDrawIndirect mode, OpenTK.Graphics.OpenGL.AmdMultiDrawIndirect type, [InAttribute, OutAttribute] T2[,] indirect, Int32 primcount, Int32 stride)
                where T2 : struct
            ;

            /// <summary>[requires: AMD_multi_draw_indirect]
            /// Render indexed primitives from array data, taking parameters from memory
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of data in the buffer bound to the GL_ELEMENT_ARRAY_BUFFER binding.
            /// </para>
            /// </param>
            /// <param name="indirect">
            /// <para>
            /// Specifies the address of a structure containing an array of draw parameters.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the number of elements in the array addressed by indirect.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the distance in basic machine units between elements of the draw parameter array.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "AMD_multi_draw_indirect", Version = "", EntryPoint = "glMultiDrawElementsIndirectAMD")]
            public static extern void MultiDrawElementsIndirect<T2>(OpenTK.Graphics.OpenGL.AmdMultiDrawIndirect mode, OpenTK.Graphics.OpenGL.AmdMultiDrawIndirect type, [InAttribute, OutAttribute] T2[,,] indirect, Int32 primcount, Int32 stride)
                where T2 : struct
            ;

            /// <summary>[requires: AMD_multi_draw_indirect]
            /// Render indexed primitives from array data, taking parameters from memory
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of data in the buffer bound to the GL_ELEMENT_ARRAY_BUFFER binding.
            /// </para>
            /// </param>
            /// <param name="indirect">
            /// <para>
            /// Specifies the address of a structure containing an array of draw parameters.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the number of elements in the array addressed by indirect.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the distance in basic machine units between elements of the draw parameter array.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "AMD_multi_draw_indirect", Version = "", EntryPoint = "glMultiDrawElementsIndirectAMD")]
            public static extern void MultiDrawElementsIndirect<T2>(OpenTK.Graphics.OpenGL.AmdMultiDrawIndirect mode, OpenTK.Graphics.OpenGL.AmdMultiDrawIndirect type, [InAttribute, OutAttribute] ref T2 indirect, Int32 primcount, Int32 stride)
                where T2 : struct
            ;

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glSelectPerfMonitorCountersAMD")]
            public static extern void SelectPerfMonitorCounters(Int32 monitor, bool enable, Int32 group, Int32 numCounters, [OutAttribute] Int32[] counterList);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glSelectPerfMonitorCountersAMD")]
            public static extern void SelectPerfMonitorCounters(Int32 monitor, bool enable, Int32 group, Int32 numCounters, [OutAttribute] out Int32 counterList);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glSelectPerfMonitorCountersAMD")]
            public static extern unsafe void SelectPerfMonitorCounters(Int32 monitor, bool enable, Int32 group, Int32 numCounters, [OutAttribute] Int32* counterList);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glSelectPerfMonitorCountersAMD")]
            public static extern void SelectPerfMonitorCounters(UInt32 monitor, bool enable, UInt32 group, Int32 numCounters, [OutAttribute] UInt32[] counterList);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glSelectPerfMonitorCountersAMD")]
            public static extern void SelectPerfMonitorCounters(UInt32 monitor, bool enable, UInt32 group, Int32 numCounters, [OutAttribute] out UInt32 counterList);

            /// <summary>[requires: AMD_performance_monitor]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_performance_monitor", Version = "", EntryPoint = "glSelectPerfMonitorCountersAMD")]
            public static extern unsafe void SelectPerfMonitorCounters(UInt32 monitor, bool enable, UInt32 group, Int32 numCounters, [OutAttribute] UInt32* counterList);

            /// <summary>[requires: AMD_sample_positions]</summary>
            [AutoGenerated(Category = "AMD_sample_positions", Version = "", EntryPoint = "glSetMultisamplefvAMD")]
            public static extern void SetMultisample(OpenTK.Graphics.OpenGL.AmdSamplePositions pname, Int32 index, Single[] val);

            /// <summary>[requires: AMD_sample_positions]</summary>
            [AutoGenerated(Category = "AMD_sample_positions", Version = "", EntryPoint = "glSetMultisamplefvAMD")]
            public static extern void SetMultisample(OpenTK.Graphics.OpenGL.AmdSamplePositions pname, Int32 index, ref Single val);

            /// <summary>[requires: AMD_sample_positions]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_sample_positions", Version = "", EntryPoint = "glSetMultisamplefvAMD")]
            public static extern unsafe void SetMultisample(OpenTK.Graphics.OpenGL.AmdSamplePositions pname, Int32 index, Single* val);

            /// <summary>[requires: AMD_sample_positions]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_sample_positions", Version = "", EntryPoint = "glSetMultisamplefvAMD")]
            public static extern void SetMultisample(OpenTK.Graphics.OpenGL.AmdSamplePositions pname, UInt32 index, Single[] val);

            /// <summary>[requires: AMD_sample_positions]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_sample_positions", Version = "", EntryPoint = "glSetMultisamplefvAMD")]
            public static extern void SetMultisample(OpenTK.Graphics.OpenGL.AmdSamplePositions pname, UInt32 index, ref Single val);

            /// <summary>[requires: AMD_sample_positions]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_sample_positions", Version = "", EntryPoint = "glSetMultisamplefvAMD")]
            public static extern unsafe void SetMultisample(OpenTK.Graphics.OpenGL.AmdSamplePositions pname, UInt32 index, Single* val);

            /// <summary>[requires: AMD_stencil_operation_extended]</summary>
            [AutoGenerated(Category = "AMD_stencil_operation_extended", Version = "", EntryPoint = "glStencilOpValueAMD")]
            public static extern void StencilOpValue(OpenTK.Graphics.OpenGL.AmdStencilOperationExtended face, Int32 value);

            /// <summary>[requires: AMD_stencil_operation_extended]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_stencil_operation_extended", Version = "", EntryPoint = "glStencilOpValueAMD")]
            public static extern void StencilOpValue(OpenTK.Graphics.OpenGL.AmdStencilOperationExtended face, UInt32 value);

            /// <summary>[requires: AMD_vertex_shader_tessellator]</summary>
            [AutoGenerated(Category = "AMD_vertex_shader_tessellator", Version = "", EntryPoint = "glTessellationFactorAMD")]
            public static extern void TessellationFactor(Single factor);

            /// <summary>[requires: AMD_vertex_shader_tessellator]</summary>
            [Obsolete("Use AmdVertexShaderTessellator overload instead")]
            [AutoGenerated(Category = "AMD_vertex_shader_tessellator", Version = "", EntryPoint = "glTessellationModeAMD")]
            public static extern void TessellationMode(OpenTK.Graphics.OpenGL.AmdVertexShaderTesselator mode);

            /// <summary>[requires: AMD_vertex_shader_tessellator]</summary>
            [AutoGenerated(Category = "AMD_vertex_shader_tessellator", Version = "", EntryPoint = "glTessellationModeAMD")]
            public static extern void TessellationMode(OpenTK.Graphics.OpenGL.AmdVertexShaderTessellator mode);

            /// <summary>[requires: AMD_sparse_texture]</summary>
            [AutoGenerated(Category = "AMD_sparse_texture", Version = "", EntryPoint = "glTexStorageSparseAMD")]
            public static extern void TexStorageSparse(OpenTK.Graphics.OpenGL.AmdSparseTexture target, OpenTK.Graphics.OpenGL.AmdSparseTexture internalFormat, Int32 width, Int32 height, Int32 depth, Int32 layers, Int32 flags);

            /// <summary>[requires: AMD_sparse_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_sparse_texture", Version = "", EntryPoint = "glTexStorageSparseAMD")]
            public static extern void TexStorageSparse(OpenTK.Graphics.OpenGL.AmdSparseTexture target, OpenTK.Graphics.OpenGL.AmdSparseTexture internalFormat, Int32 width, Int32 height, Int32 depth, Int32 layers, UInt32 flags);

            /// <summary>[requires: AMD_sparse_texture]</summary>
            [AutoGenerated(Category = "AMD_sparse_texture", Version = "", EntryPoint = "glTextureStorageSparseAMD")]
            public static extern void TextureStorageSparse(Int32 texture, OpenTK.Graphics.OpenGL.AmdSparseTexture target, OpenTK.Graphics.OpenGL.AmdSparseTexture internalFormat, Int32 width, Int32 height, Int32 depth, Int32 layers, Int32 flags);

            /// <summary>[requires: AMD_sparse_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_sparse_texture", Version = "", EntryPoint = "glTextureStorageSparseAMD")]
            public static extern void TextureStorageSparse(UInt32 texture, OpenTK.Graphics.OpenGL.AmdSparseTexture target, OpenTK.Graphics.OpenGL.AmdSparseTexture internalFormat, Int32 width, Int32 height, Int32 depth, Int32 layers, UInt32 flags);

            /// <summary>[requires: AMD_interleaved_elements]</summary>
            [AutoGenerated(Category = "AMD_interleaved_elements", Version = "", EntryPoint = "glVertexAttribParameteriAMD")]
            public static extern void VertexAttribParameter(Int32 index, OpenTK.Graphics.OpenGL.AmdInterleavedElements pname, Int32 param);

            /// <summary>[requires: AMD_interleaved_elements]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "AMD_interleaved_elements", Version = "", EntryPoint = "glVertexAttribParameteriAMD")]
            public static extern void VertexAttribParameter(UInt32 index, OpenTK.Graphics.OpenGL.AmdInterleavedElements pname, Int32 param);

        }

        public static partial class Apple
        {
            /// <summary>[requires: APPLE_vertex_array_object]
            /// Bind a vertex array object
            /// </summary>
            /// <param name="array">
            /// <para>
            /// Specifies the name of the vertex array to bind.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "APPLE_vertex_array_object", Version = "", EntryPoint = "glBindVertexArrayAPPLE")]
            public static extern void BindVertexArray(Int32 array);

            /// <summary>[requires: APPLE_vertex_array_object]
            /// Bind a vertex array object
            /// </summary>
            /// <param name="array">
            /// <para>
            /// Specifies the name of the vertex array to bind.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_vertex_array_object", Version = "", EntryPoint = "glBindVertexArrayAPPLE")]
            public static extern void BindVertexArray(UInt32 array);

            /// <summary>[requires: APPLE_flush_buffer_range]</summary>
            [AutoGenerated(Category = "APPLE_flush_buffer_range", Version = "", EntryPoint = "glBufferParameteriAPPLE")]
            public static extern void BufferParameter(OpenTK.Graphics.OpenGL.BufferTarget target, OpenTK.Graphics.OpenGL.BufferParameterApple pname, Int32 param);

            /// <summary>[requires: APPLE_fence]</summary>
            [AutoGenerated(Category = "APPLE_fence", Version = "", EntryPoint = "glDeleteFencesAPPLE")]
            public static extern void DeleteFence(Int32 fences);

            /// <summary>[requires: APPLE_fence]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_fence", Version = "", EntryPoint = "glDeleteFencesAPPLE")]
            public static extern void DeleteFence(UInt32 fences);

            /// <summary>[requires: APPLE_fence]</summary>
            [AutoGenerated(Category = "APPLE_fence", Version = "", EntryPoint = "glDeleteFencesAPPLE")]
            public static extern void DeleteFences(Int32 n, Int32[] fences);

            /// <summary>[requires: APPLE_fence]</summary>
            [AutoGenerated(Category = "APPLE_fence", Version = "", EntryPoint = "glDeleteFencesAPPLE")]
            public static extern void DeleteFences(Int32 n, ref Int32 fences);

            /// <summary>[requires: APPLE_fence]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_fence", Version = "", EntryPoint = "glDeleteFencesAPPLE")]
            public static extern unsafe void DeleteFences(Int32 n, Int32* fences);

            /// <summary>[requires: APPLE_fence]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_fence", Version = "", EntryPoint = "glDeleteFencesAPPLE")]
            public static extern void DeleteFences(Int32 n, UInt32[] fences);

            /// <summary>[requires: APPLE_fence]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_fence", Version = "", EntryPoint = "glDeleteFencesAPPLE")]
            public static extern void DeleteFences(Int32 n, ref UInt32 fences);

            /// <summary>[requires: APPLE_fence]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_fence", Version = "", EntryPoint = "glDeleteFencesAPPLE")]
            public static extern unsafe void DeleteFences(Int32 n, UInt32* fences);

            /// <summary>[requires: APPLE_vertex_array_object]</summary>
            [AutoGenerated(Category = "APPLE_vertex_array_object", Version = "", EntryPoint = "glDeleteVertexArraysAPPLE")]
            public static extern void DeleteVertexArray(Int32 arrays);

            /// <summary>[requires: APPLE_vertex_array_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_vertex_array_object", Version = "", EntryPoint = "glDeleteVertexArraysAPPLE")]
            public static extern void DeleteVertexArray(UInt32 arrays);

            /// <summary>[requires: APPLE_vertex_array_object]
            /// Delete vertex array objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of vertex array objects to be deleted.
            /// </para>
            /// </param>
            /// <param name="arrays">
            /// <para>
            /// Specifies the address of an array containing the n names of the objects to be deleted.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "APPLE_vertex_array_object", Version = "", EntryPoint = "glDeleteVertexArraysAPPLE")]
            public static extern void DeleteVertexArrays(Int32 n, Int32[] arrays);

            /// <summary>[requires: APPLE_vertex_array_object]
            /// Delete vertex array objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of vertex array objects to be deleted.
            /// </para>
            /// </param>
            /// <param name="arrays">
            /// <para>
            /// Specifies the address of an array containing the n names of the objects to be deleted.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "APPLE_vertex_array_object", Version = "", EntryPoint = "glDeleteVertexArraysAPPLE")]
            public static extern void DeleteVertexArrays(Int32 n, ref Int32 arrays);

            /// <summary>[requires: APPLE_vertex_array_object]
            /// Delete vertex array objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of vertex array objects to be deleted.
            /// </para>
            /// </param>
            /// <param name="arrays">
            /// <para>
            /// Specifies the address of an array containing the n names of the objects to be deleted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_vertex_array_object", Version = "", EntryPoint = "glDeleteVertexArraysAPPLE")]
            public static extern unsafe void DeleteVertexArrays(Int32 n, Int32* arrays);

            /// <summary>[requires: APPLE_vertex_array_object]
            /// Delete vertex array objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of vertex array objects to be deleted.
            /// </para>
            /// </param>
            /// <param name="arrays">
            /// <para>
            /// Specifies the address of an array containing the n names of the objects to be deleted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_vertex_array_object", Version = "", EntryPoint = "glDeleteVertexArraysAPPLE")]
            public static extern void DeleteVertexArrays(Int32 n, UInt32[] arrays);

            /// <summary>[requires: APPLE_vertex_array_object]
            /// Delete vertex array objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of vertex array objects to be deleted.
            /// </para>
            /// </param>
            /// <param name="arrays">
            /// <para>
            /// Specifies the address of an array containing the n names of the objects to be deleted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_vertex_array_object", Version = "", EntryPoint = "glDeleteVertexArraysAPPLE")]
            public static extern void DeleteVertexArrays(Int32 n, ref UInt32 arrays);

            /// <summary>[requires: APPLE_vertex_array_object]
            /// Delete vertex array objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of vertex array objects to be deleted.
            /// </para>
            /// </param>
            /// <param name="arrays">
            /// <para>
            /// Specifies the address of an array containing the n names of the objects to be deleted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_vertex_array_object", Version = "", EntryPoint = "glDeleteVertexArraysAPPLE")]
            public static extern unsafe void DeleteVertexArrays(Int32 n, UInt32* arrays);

            /// <summary>[requires: APPLE_vertex_program_evaluators]</summary>
            [AutoGenerated(Category = "APPLE_vertex_program_evaluators", Version = "", EntryPoint = "glDisableVertexAttribAPPLE")]
            public static extern void DisableVertexAttrib(Int32 index, OpenTK.Graphics.OpenGL.AppleVertexProgramEvaluators pname);

            /// <summary>[requires: APPLE_vertex_program_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_vertex_program_evaluators", Version = "", EntryPoint = "glDisableVertexAttribAPPLE")]
            public static extern void DisableVertexAttrib(UInt32 index, OpenTK.Graphics.OpenGL.AppleVertexProgramEvaluators pname);

            /// <summary>[requires: APPLE_element_array]</summary>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "APPLE_element_array", Version = "", EntryPoint = "glDrawElementArrayAPPLE")]
            public static extern void DrawElementArray(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 first, Int32 count);

            /// <summary>[requires: APPLE_element_array]</summary>
            [AutoGenerated(Category = "APPLE_element_array", Version = "", EntryPoint = "glDrawElementArrayAPPLE")]
            public static extern void DrawElementArray(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 first, Int32 count);

            /// <summary>[requires: APPLE_element_array]</summary>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "APPLE_element_array", Version = "", EntryPoint = "glDrawRangeElementArrayAPPLE")]
            public static extern void DrawRangeElementArray(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 start, Int32 end, Int32 first, Int32 count);

            /// <summary>[requires: APPLE_element_array]</summary>
            [Obsolete("Use PrimitiveType overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_element_array", Version = "", EntryPoint = "glDrawRangeElementArrayAPPLE")]
            public static extern void DrawRangeElementArray(OpenTK.Graphics.OpenGL.BeginMode mode, UInt32 start, UInt32 end, Int32 first, Int32 count);

            /// <summary>[requires: APPLE_element_array]</summary>
            [AutoGenerated(Category = "APPLE_element_array", Version = "", EntryPoint = "glDrawRangeElementArrayAPPLE")]
            public static extern void DrawRangeElementArray(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 start, Int32 end, Int32 first, Int32 count);

            /// <summary>[requires: APPLE_element_array]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_element_array", Version = "", EntryPoint = "glDrawRangeElementArrayAPPLE")]
            public static extern void DrawRangeElementArray(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 start, UInt32 end, Int32 first, Int32 count);

            /// <summary>[requires: APPLE_element_array]</summary>
            [AutoGenerated(Category = "APPLE_element_array", Version = "", EntryPoint = "glElementPointerAPPLE")]
            public static extern void ElementPointer(OpenTK.Graphics.OpenGL.AppleElementArray type, IntPtr pointer);

            /// <summary>[requires: APPLE_element_array]</summary>
            [AutoGenerated(Category = "APPLE_element_array", Version = "", EntryPoint = "glElementPointerAPPLE")]
            public static extern void ElementPointer<T1>(OpenTK.Graphics.OpenGL.AppleElementArray type, [InAttribute, OutAttribute] T1[] pointer)
                where T1 : struct
            ;

            /// <summary>[requires: APPLE_element_array]</summary>
            [AutoGenerated(Category = "APPLE_element_array", Version = "", EntryPoint = "glElementPointerAPPLE")]
            public static extern void ElementPointer<T1>(OpenTK.Graphics.OpenGL.AppleElementArray type, [InAttribute, OutAttribute] T1[,] pointer)
                where T1 : struct
            ;

            /// <summary>[requires: APPLE_element_array]</summary>
            [AutoGenerated(Category = "APPLE_element_array", Version = "", EntryPoint = "glElementPointerAPPLE")]
            public static extern void ElementPointer<T1>(OpenTK.Graphics.OpenGL.AppleElementArray type, [InAttribute, OutAttribute] T1[,,] pointer)
                where T1 : struct
            ;

            /// <summary>[requires: APPLE_element_array]</summary>
            [AutoGenerated(Category = "APPLE_element_array", Version = "", EntryPoint = "glElementPointerAPPLE")]
            public static extern void ElementPointer<T1>(OpenTK.Graphics.OpenGL.AppleElementArray type, [InAttribute, OutAttribute] ref T1 pointer)
                where T1 : struct
            ;

            /// <summary>[requires: APPLE_vertex_program_evaluators]</summary>
            [AutoGenerated(Category = "APPLE_vertex_program_evaluators", Version = "", EntryPoint = "glEnableVertexAttribAPPLE")]
            public static extern void EnableVertexAttrib(Int32 index, OpenTK.Graphics.OpenGL.AppleVertexProgramEvaluators pname);

            /// <summary>[requires: APPLE_vertex_program_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_vertex_program_evaluators", Version = "", EntryPoint = "glEnableVertexAttribAPPLE")]
            public static extern void EnableVertexAttrib(UInt32 index, OpenTK.Graphics.OpenGL.AppleVertexProgramEvaluators pname);

            /// <summary>[requires: APPLE_fence]</summary>
            [AutoGenerated(Category = "APPLE_fence", Version = "", EntryPoint = "glFinishFenceAPPLE")]
            public static extern void FinishFence(Int32 fence);

            /// <summary>[requires: APPLE_fence]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_fence", Version = "", EntryPoint = "glFinishFenceAPPLE")]
            public static extern void FinishFence(UInt32 fence);

            /// <summary>[requires: APPLE_fence]</summary>
            [AutoGenerated(Category = "APPLE_fence", Version = "", EntryPoint = "glFinishObjectAPPLE")]
            public static extern void FinishObject(OpenTK.Graphics.OpenGL.AppleFence @object, Int32 name);

            /// <summary>[requires: APPLE_flush_buffer_range]
            /// Indicate modifications to a range of a mapped buffer
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target of the flush operation. target must be GL_ARRAY_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
            /// </para>
            /// </param>
            /// <param name="offset">
            /// <para>
            /// Specifies the start of the buffer subrange, in basic machine units.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// Specifies the length of the buffer subrange, in basic machine units.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "APPLE_flush_buffer_range", Version = "", EntryPoint = "glFlushMappedBufferRangeAPPLE")]
            public static extern void FlushMappedBufferRange(OpenTK.Graphics.OpenGL.BufferTarget target, IntPtr offset, IntPtr size);

            /// <summary>[requires: APPLE_vertex_array_range]</summary>
            [AutoGenerated(Category = "APPLE_vertex_array_range", Version = "", EntryPoint = "glFlushVertexArrayRangeAPPLE")]
            public static extern void FlushVertexArrayRange(Int32 length, [OutAttribute] IntPtr pointer);

            /// <summary>[requires: APPLE_vertex_array_range]</summary>
            [AutoGenerated(Category = "APPLE_vertex_array_range", Version = "", EntryPoint = "glFlushVertexArrayRangeAPPLE")]
            public static extern void FlushVertexArrayRange<T1>(Int32 length, [InAttribute, OutAttribute] T1[] pointer)
                where T1 : struct
            ;

            /// <summary>[requires: APPLE_vertex_array_range]</summary>
            [AutoGenerated(Category = "APPLE_vertex_array_range", Version = "", EntryPoint = "glFlushVertexArrayRangeAPPLE")]
            public static extern void FlushVertexArrayRange<T1>(Int32 length, [InAttribute, OutAttribute] T1[,] pointer)
                where T1 : struct
            ;

            /// <summary>[requires: APPLE_vertex_array_range]</summary>
            [AutoGenerated(Category = "APPLE_vertex_array_range", Version = "", EntryPoint = "glFlushVertexArrayRangeAPPLE")]
            public static extern void FlushVertexArrayRange<T1>(Int32 length, [InAttribute, OutAttribute] T1[,,] pointer)
                where T1 : struct
            ;

            /// <summary>[requires: APPLE_vertex_array_range]</summary>
            [AutoGenerated(Category = "APPLE_vertex_array_range", Version = "", EntryPoint = "glFlushVertexArrayRangeAPPLE")]
            public static extern void FlushVertexArrayRange<T1>(Int32 length, [InAttribute, OutAttribute] ref T1 pointer)
                where T1 : struct
            ;

            /// <summary>[requires: APPLE_fence]</summary>
            [AutoGenerated(Category = "APPLE_fence", Version = "", EntryPoint = "glGenFencesAPPLE")]
            public static extern Int32 GenFence();

            /// <summary>[requires: APPLE_fence]</summary>
            [AutoGenerated(Category = "APPLE_fence", Version = "", EntryPoint = "glGenFencesAPPLE")]
            public static extern void GenFences(Int32 n, [OutAttribute] Int32[] fences);

            /// <summary>[requires: APPLE_fence]</summary>
            [AutoGenerated(Category = "APPLE_fence", Version = "", EntryPoint = "glGenFencesAPPLE")]
            public static extern void GenFences(Int32 n, [OutAttribute] out Int32 fences);

            /// <summary>[requires: APPLE_fence]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_fence", Version = "", EntryPoint = "glGenFencesAPPLE")]
            public static extern unsafe void GenFences(Int32 n, [OutAttribute] Int32* fences);

            /// <summary>[requires: APPLE_fence]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_fence", Version = "", EntryPoint = "glGenFencesAPPLE")]
            public static extern void GenFences(Int32 n, [OutAttribute] UInt32[] fences);

            /// <summary>[requires: APPLE_fence]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_fence", Version = "", EntryPoint = "glGenFencesAPPLE")]
            public static extern void GenFences(Int32 n, [OutAttribute] out UInt32 fences);

            /// <summary>[requires: APPLE_fence]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_fence", Version = "", EntryPoint = "glGenFencesAPPLE")]
            public static extern unsafe void GenFences(Int32 n, [OutAttribute] UInt32* fences);

            /// <summary>[requires: APPLE_vertex_array_object]</summary>
            [AutoGenerated(Category = "APPLE_vertex_array_object", Version = "", EntryPoint = "glGenVertexArraysAPPLE")]
            public static extern Int32 GenVertexArray();

            /// <summary>[requires: APPLE_vertex_array_object]
            /// Generate vertex array object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of vertex array object names to generate.
            /// </para>
            /// </param>
            /// <param name="arrays">
            /// <para>
            /// Specifies an array in which the generated vertex array object names are stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "APPLE_vertex_array_object", Version = "", EntryPoint = "glGenVertexArraysAPPLE")]
            public static extern void GenVertexArrays(Int32 n, [OutAttribute] Int32[] arrays);

            /// <summary>[requires: APPLE_vertex_array_object]
            /// Generate vertex array object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of vertex array object names to generate.
            /// </para>
            /// </param>
            /// <param name="arrays">
            /// <para>
            /// Specifies an array in which the generated vertex array object names are stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "APPLE_vertex_array_object", Version = "", EntryPoint = "glGenVertexArraysAPPLE")]
            public static extern void GenVertexArrays(Int32 n, [OutAttribute] out Int32 arrays);

            /// <summary>[requires: APPLE_vertex_array_object]
            /// Generate vertex array object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of vertex array object names to generate.
            /// </para>
            /// </param>
            /// <param name="arrays">
            /// <para>
            /// Specifies an array in which the generated vertex array object names are stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_vertex_array_object", Version = "", EntryPoint = "glGenVertexArraysAPPLE")]
            public static extern unsafe void GenVertexArrays(Int32 n, [OutAttribute] Int32* arrays);

            /// <summary>[requires: APPLE_vertex_array_object]
            /// Generate vertex array object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of vertex array object names to generate.
            /// </para>
            /// </param>
            /// <param name="arrays">
            /// <para>
            /// Specifies an array in which the generated vertex array object names are stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_vertex_array_object", Version = "", EntryPoint = "glGenVertexArraysAPPLE")]
            public static extern void GenVertexArrays(Int32 n, [OutAttribute] UInt32[] arrays);

            /// <summary>[requires: APPLE_vertex_array_object]
            /// Generate vertex array object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of vertex array object names to generate.
            /// </para>
            /// </param>
            /// <param name="arrays">
            /// <para>
            /// Specifies an array in which the generated vertex array object names are stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_vertex_array_object", Version = "", EntryPoint = "glGenVertexArraysAPPLE")]
            public static extern void GenVertexArrays(Int32 n, [OutAttribute] out UInt32 arrays);

            /// <summary>[requires: APPLE_vertex_array_object]
            /// Generate vertex array object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of vertex array object names to generate.
            /// </para>
            /// </param>
            /// <param name="arrays">
            /// <para>
            /// Specifies an array in which the generated vertex array object names are stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_vertex_array_object", Version = "", EntryPoint = "glGenVertexArraysAPPLE")]
            public static extern unsafe void GenVertexArrays(Int32 n, [OutAttribute] UInt32* arrays);

            /// <summary>[requires: APPLE_object_purgeable]</summary>
            [AutoGenerated(Category = "APPLE_object_purgeable", Version = "", EntryPoint = "glGetObjectParameterivAPPLE")]
            public static extern void GetObjectParameter(OpenTK.Graphics.OpenGL.AppleObjectPurgeable objectType, Int32 name, OpenTK.Graphics.OpenGL.AppleObjectPurgeable pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: APPLE_object_purgeable]</summary>
            [AutoGenerated(Category = "APPLE_object_purgeable", Version = "", EntryPoint = "glGetObjectParameterivAPPLE")]
            public static extern void GetObjectParameter(OpenTK.Graphics.OpenGL.AppleObjectPurgeable objectType, Int32 name, OpenTK.Graphics.OpenGL.AppleObjectPurgeable pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: APPLE_object_purgeable]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_object_purgeable", Version = "", EntryPoint = "glGetObjectParameterivAPPLE")]
            public static extern unsafe void GetObjectParameter(OpenTK.Graphics.OpenGL.AppleObjectPurgeable objectType, Int32 name, OpenTK.Graphics.OpenGL.AppleObjectPurgeable pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: APPLE_object_purgeable]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_object_purgeable", Version = "", EntryPoint = "glGetObjectParameterivAPPLE")]
            public static extern void GetObjectParameter(OpenTK.Graphics.OpenGL.AppleObjectPurgeable objectType, UInt32 name, OpenTK.Graphics.OpenGL.AppleObjectPurgeable pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: APPLE_object_purgeable]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_object_purgeable", Version = "", EntryPoint = "glGetObjectParameterivAPPLE")]
            public static extern void GetObjectParameter(OpenTK.Graphics.OpenGL.AppleObjectPurgeable objectType, UInt32 name, OpenTK.Graphics.OpenGL.AppleObjectPurgeable pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: APPLE_object_purgeable]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_object_purgeable", Version = "", EntryPoint = "glGetObjectParameterivAPPLE")]
            public static extern unsafe void GetObjectParameter(OpenTK.Graphics.OpenGL.AppleObjectPurgeable objectType, UInt32 name, OpenTK.Graphics.OpenGL.AppleObjectPurgeable pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: APPLE_texture_range]</summary>
            [AutoGenerated(Category = "APPLE_texture_range", Version = "", EntryPoint = "glGetTexParameterPointervAPPLE")]
            public static extern void GetTexParameterPointer(OpenTK.Graphics.OpenGL.AppleTextureRange target, OpenTK.Graphics.OpenGL.AppleTextureRange pname, [OutAttribute] IntPtr @params);

            /// <summary>[requires: APPLE_texture_range]</summary>
            [AutoGenerated(Category = "APPLE_texture_range", Version = "", EntryPoint = "glGetTexParameterPointervAPPLE")]
            public static extern void GetTexParameterPointer<T2>(OpenTK.Graphics.OpenGL.AppleTextureRange target, OpenTK.Graphics.OpenGL.AppleTextureRange pname, [InAttribute, OutAttribute] T2[] @params)
                where T2 : struct
            ;

            /// <summary>[requires: APPLE_texture_range]</summary>
            [AutoGenerated(Category = "APPLE_texture_range", Version = "", EntryPoint = "glGetTexParameterPointervAPPLE")]
            public static extern void GetTexParameterPointer<T2>(OpenTK.Graphics.OpenGL.AppleTextureRange target, OpenTK.Graphics.OpenGL.AppleTextureRange pname, [InAttribute, OutAttribute] T2[,] @params)
                where T2 : struct
            ;

            /// <summary>[requires: APPLE_texture_range]</summary>
            [AutoGenerated(Category = "APPLE_texture_range", Version = "", EntryPoint = "glGetTexParameterPointervAPPLE")]
            public static extern void GetTexParameterPointer<T2>(OpenTK.Graphics.OpenGL.AppleTextureRange target, OpenTK.Graphics.OpenGL.AppleTextureRange pname, [InAttribute, OutAttribute] T2[,,] @params)
                where T2 : struct
            ;

            /// <summary>[requires: APPLE_texture_range]</summary>
            [AutoGenerated(Category = "APPLE_texture_range", Version = "", EntryPoint = "glGetTexParameterPointervAPPLE")]
            public static extern void GetTexParameterPointer<T2>(OpenTK.Graphics.OpenGL.AppleTextureRange target, OpenTK.Graphics.OpenGL.AppleTextureRange pname, [InAttribute, OutAttribute] ref T2 @params)
                where T2 : struct
            ;

            /// <summary>[requires: APPLE_fence]</summary>
            [AutoGenerated(Category = "APPLE_fence", Version = "", EntryPoint = "glIsFenceAPPLE")]
            public static extern bool IsFence(Int32 fence);

            /// <summary>[requires: APPLE_fence]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_fence", Version = "", EntryPoint = "glIsFenceAPPLE")]
            public static extern bool IsFence(UInt32 fence);

            /// <summary>[requires: APPLE_vertex_array_object]
            /// Determine if a name corresponds to a vertex array object
            /// </summary>
            /// <param name="array">
            /// <para>
            /// Specifies a value that may be the name of a vertex array object.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "APPLE_vertex_array_object", Version = "", EntryPoint = "glIsVertexArrayAPPLE")]
            public static extern bool IsVertexArray(Int32 array);

            /// <summary>[requires: APPLE_vertex_array_object]
            /// Determine if a name corresponds to a vertex array object
            /// </summary>
            /// <param name="array">
            /// <para>
            /// Specifies a value that may be the name of a vertex array object.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_vertex_array_object", Version = "", EntryPoint = "glIsVertexArrayAPPLE")]
            public static extern bool IsVertexArray(UInt32 array);

            /// <summary>[requires: APPLE_vertex_program_evaluators]</summary>
            [AutoGenerated(Category = "APPLE_vertex_program_evaluators", Version = "", EntryPoint = "glIsVertexAttribEnabledAPPLE")]
            public static extern bool IsVertexAttribEnabled(Int32 index, OpenTK.Graphics.OpenGL.AppleVertexProgramEvaluators pname);

            /// <summary>[requires: APPLE_vertex_program_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_vertex_program_evaluators", Version = "", EntryPoint = "glIsVertexAttribEnabledAPPLE")]
            public static extern bool IsVertexAttribEnabled(UInt32 index, OpenTK.Graphics.OpenGL.AppleVertexProgramEvaluators pname);

            /// <summary>[requires: APPLE_vertex_program_evaluators]</summary>
            [AutoGenerated(Category = "APPLE_vertex_program_evaluators", Version = "", EntryPoint = "glMapVertexAttrib1dAPPLE")]
            public static extern void MapVertexAttrib1(Int32 index, Int32 size, Double u1, Double u2, Int32 stride, Int32 order, Double[] points);

            /// <summary>[requires: APPLE_vertex_program_evaluators]</summary>
            [AutoGenerated(Category = "APPLE_vertex_program_evaluators", Version = "", EntryPoint = "glMapVertexAttrib1dAPPLE")]
            public static extern void MapVertexAttrib1(Int32 index, Int32 size, Double u1, Double u2, Int32 stride, Int32 order, ref Double points);

            /// <summary>[requires: APPLE_vertex_program_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_vertex_program_evaluators", Version = "", EntryPoint = "glMapVertexAttrib1dAPPLE")]
            public static extern unsafe void MapVertexAttrib1(Int32 index, Int32 size, Double u1, Double u2, Int32 stride, Int32 order, Double* points);

            /// <summary>[requires: APPLE_vertex_program_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_vertex_program_evaluators", Version = "", EntryPoint = "glMapVertexAttrib1dAPPLE")]
            public static extern void MapVertexAttrib1(UInt32 index, UInt32 size, Double u1, Double u2, Int32 stride, Int32 order, Double[] points);

            /// <summary>[requires: APPLE_vertex_program_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_vertex_program_evaluators", Version = "", EntryPoint = "glMapVertexAttrib1dAPPLE")]
            public static extern void MapVertexAttrib1(UInt32 index, UInt32 size, Double u1, Double u2, Int32 stride, Int32 order, ref Double points);

            /// <summary>[requires: APPLE_vertex_program_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_vertex_program_evaluators", Version = "", EntryPoint = "glMapVertexAttrib1dAPPLE")]
            public static extern unsafe void MapVertexAttrib1(UInt32 index, UInt32 size, Double u1, Double u2, Int32 stride, Int32 order, Double* points);

            /// <summary>[requires: APPLE_vertex_program_evaluators]</summary>
            [AutoGenerated(Category = "APPLE_vertex_program_evaluators", Version = "", EntryPoint = "glMapVertexAttrib1fAPPLE")]
            public static extern void MapVertexAttrib1(Int32 index, Int32 size, Single u1, Single u2, Int32 stride, Int32 order, Single[] points);

            /// <summary>[requires: APPLE_vertex_program_evaluators]</summary>
            [AutoGenerated(Category = "APPLE_vertex_program_evaluators", Version = "", EntryPoint = "glMapVertexAttrib1fAPPLE")]
            public static extern void MapVertexAttrib1(Int32 index, Int32 size, Single u1, Single u2, Int32 stride, Int32 order, ref Single points);

            /// <summary>[requires: APPLE_vertex_program_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_vertex_program_evaluators", Version = "", EntryPoint = "glMapVertexAttrib1fAPPLE")]
            public static extern unsafe void MapVertexAttrib1(Int32 index, Int32 size, Single u1, Single u2, Int32 stride, Int32 order, Single* points);

            /// <summary>[requires: APPLE_vertex_program_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_vertex_program_evaluators", Version = "", EntryPoint = "glMapVertexAttrib1fAPPLE")]
            public static extern void MapVertexAttrib1(UInt32 index, UInt32 size, Single u1, Single u2, Int32 stride, Int32 order, Single[] points);

            /// <summary>[requires: APPLE_vertex_program_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_vertex_program_evaluators", Version = "", EntryPoint = "glMapVertexAttrib1fAPPLE")]
            public static extern void MapVertexAttrib1(UInt32 index, UInt32 size, Single u1, Single u2, Int32 stride, Int32 order, ref Single points);

            /// <summary>[requires: APPLE_vertex_program_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_vertex_program_evaluators", Version = "", EntryPoint = "glMapVertexAttrib1fAPPLE")]
            public static extern unsafe void MapVertexAttrib1(UInt32 index, UInt32 size, Single u1, Single u2, Int32 stride, Int32 order, Single* points);

            /// <summary>[requires: APPLE_vertex_program_evaluators]</summary>
            [AutoGenerated(Category = "APPLE_vertex_program_evaluators", Version = "", EntryPoint = "glMapVertexAttrib2dAPPLE")]
            public static extern void MapVertexAttrib2(Int32 index, Int32 size, Double u1, Double u2, Int32 ustride, Int32 uorder, Double v1, Double v2, Int32 vstride, Int32 vorder, Double[] points);

            /// <summary>[requires: APPLE_vertex_program_evaluators]</summary>
            [AutoGenerated(Category = "APPLE_vertex_program_evaluators", Version = "", EntryPoint = "glMapVertexAttrib2dAPPLE")]
            public static extern void MapVertexAttrib2(Int32 index, Int32 size, Double u1, Double u2, Int32 ustride, Int32 uorder, Double v1, Double v2, Int32 vstride, Int32 vorder, ref Double points);

            /// <summary>[requires: APPLE_vertex_program_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_vertex_program_evaluators", Version = "", EntryPoint = "glMapVertexAttrib2dAPPLE")]
            public static extern unsafe void MapVertexAttrib2(Int32 index, Int32 size, Double u1, Double u2, Int32 ustride, Int32 uorder, Double v1, Double v2, Int32 vstride, Int32 vorder, Double* points);

            /// <summary>[requires: APPLE_vertex_program_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_vertex_program_evaluators", Version = "", EntryPoint = "glMapVertexAttrib2dAPPLE")]
            public static extern void MapVertexAttrib2(UInt32 index, UInt32 size, Double u1, Double u2, Int32 ustride, Int32 uorder, Double v1, Double v2, Int32 vstride, Int32 vorder, Double[] points);

            /// <summary>[requires: APPLE_vertex_program_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_vertex_program_evaluators", Version = "", EntryPoint = "glMapVertexAttrib2dAPPLE")]
            public static extern void MapVertexAttrib2(UInt32 index, UInt32 size, Double u1, Double u2, Int32 ustride, Int32 uorder, Double v1, Double v2, Int32 vstride, Int32 vorder, ref Double points);

            /// <summary>[requires: APPLE_vertex_program_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_vertex_program_evaluators", Version = "", EntryPoint = "glMapVertexAttrib2dAPPLE")]
            public static extern unsafe void MapVertexAttrib2(UInt32 index, UInt32 size, Double u1, Double u2, Int32 ustride, Int32 uorder, Double v1, Double v2, Int32 vstride, Int32 vorder, Double* points);

            /// <summary>[requires: APPLE_vertex_program_evaluators]</summary>
            [AutoGenerated(Category = "APPLE_vertex_program_evaluators", Version = "", EntryPoint = "glMapVertexAttrib2fAPPLE")]
            public static extern void MapVertexAttrib2(Int32 index, Int32 size, Single u1, Single u2, Int32 ustride, Int32 uorder, Single v1, Single v2, Int32 vstride, Int32 vorder, Single[] points);

            /// <summary>[requires: APPLE_vertex_program_evaluators]</summary>
            [AutoGenerated(Category = "APPLE_vertex_program_evaluators", Version = "", EntryPoint = "glMapVertexAttrib2fAPPLE")]
            public static extern void MapVertexAttrib2(Int32 index, Int32 size, Single u1, Single u2, Int32 ustride, Int32 uorder, Single v1, Single v2, Int32 vstride, Int32 vorder, ref Single points);

            /// <summary>[requires: APPLE_vertex_program_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_vertex_program_evaluators", Version = "", EntryPoint = "glMapVertexAttrib2fAPPLE")]
            public static extern unsafe void MapVertexAttrib2(Int32 index, Int32 size, Single u1, Single u2, Int32 ustride, Int32 uorder, Single v1, Single v2, Int32 vstride, Int32 vorder, Single* points);

            /// <summary>[requires: APPLE_vertex_program_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_vertex_program_evaluators", Version = "", EntryPoint = "glMapVertexAttrib2fAPPLE")]
            public static extern void MapVertexAttrib2(UInt32 index, UInt32 size, Single u1, Single u2, Int32 ustride, Int32 uorder, Single v1, Single v2, Int32 vstride, Int32 vorder, Single[] points);

            /// <summary>[requires: APPLE_vertex_program_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_vertex_program_evaluators", Version = "", EntryPoint = "glMapVertexAttrib2fAPPLE")]
            public static extern void MapVertexAttrib2(UInt32 index, UInt32 size, Single u1, Single u2, Int32 ustride, Int32 uorder, Single v1, Single v2, Int32 vstride, Int32 vorder, ref Single points);

            /// <summary>[requires: APPLE_vertex_program_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_vertex_program_evaluators", Version = "", EntryPoint = "glMapVertexAttrib2fAPPLE")]
            public static extern unsafe void MapVertexAttrib2(UInt32 index, UInt32 size, Single u1, Single u2, Int32 ustride, Int32 uorder, Single v1, Single v2, Int32 vstride, Int32 vorder, Single* points);

            /// <summary>[requires: APPLE_element_array]</summary>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "APPLE_element_array", Version = "", EntryPoint = "glMultiDrawElementArrayAPPLE")]
            public static extern void MultiDrawElementArray(OpenTK.Graphics.OpenGL.BeginMode mode, Int32[] first, Int32[] count, Int32 primcount);

            /// <summary>[requires: APPLE_element_array]</summary>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "APPLE_element_array", Version = "", EntryPoint = "glMultiDrawElementArrayAPPLE")]
            public static extern void MultiDrawElementArray(OpenTK.Graphics.OpenGL.BeginMode mode, ref Int32 first, ref Int32 count, Int32 primcount);

            /// <summary>[requires: APPLE_element_array]</summary>
            [Obsolete("Use PrimitiveType overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_element_array", Version = "", EntryPoint = "glMultiDrawElementArrayAPPLE")]
            public static extern unsafe void MultiDrawElementArray(OpenTK.Graphics.OpenGL.BeginMode mode, Int32* first, Int32* count, Int32 primcount);

            /// <summary>[requires: APPLE_element_array]</summary>
            [AutoGenerated(Category = "APPLE_element_array", Version = "", EntryPoint = "glMultiDrawElementArrayAPPLE")]
            public static extern void MultiDrawElementArray(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32[] first, Int32[] count, Int32 primcount);

            /// <summary>[requires: APPLE_element_array]</summary>
            [AutoGenerated(Category = "APPLE_element_array", Version = "", EntryPoint = "glMultiDrawElementArrayAPPLE")]
            public static extern void MultiDrawElementArray(OpenTK.Graphics.OpenGL.PrimitiveType mode, ref Int32 first, ref Int32 count, Int32 primcount);

            /// <summary>[requires: APPLE_element_array]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_element_array", Version = "", EntryPoint = "glMultiDrawElementArrayAPPLE")]
            public static extern unsafe void MultiDrawElementArray(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32* first, Int32* count, Int32 primcount);

            /// <summary>[requires: APPLE_element_array]</summary>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "APPLE_element_array", Version = "", EntryPoint = "glMultiDrawRangeElementArrayAPPLE")]
            public static extern void MultiDrawRangeElementArray(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 start, Int32 end, Int32[] first, Int32[] count, Int32 primcount);

            /// <summary>[requires: APPLE_element_array]</summary>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "APPLE_element_array", Version = "", EntryPoint = "glMultiDrawRangeElementArrayAPPLE")]
            public static extern void MultiDrawRangeElementArray(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 start, Int32 end, ref Int32 first, ref Int32 count, Int32 primcount);

            /// <summary>[requires: APPLE_element_array]</summary>
            [Obsolete("Use PrimitiveType overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_element_array", Version = "", EntryPoint = "glMultiDrawRangeElementArrayAPPLE")]
            public static extern unsafe void MultiDrawRangeElementArray(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 start, Int32 end, Int32* first, Int32* count, Int32 primcount);

            /// <summary>[requires: APPLE_element_array]</summary>
            [Obsolete("Use PrimitiveType overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_element_array", Version = "", EntryPoint = "glMultiDrawRangeElementArrayAPPLE")]
            public static extern void MultiDrawRangeElementArray(OpenTK.Graphics.OpenGL.BeginMode mode, UInt32 start, UInt32 end, Int32[] first, Int32[] count, Int32 primcount);

            /// <summary>[requires: APPLE_element_array]</summary>
            [Obsolete("Use PrimitiveType overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_element_array", Version = "", EntryPoint = "glMultiDrawRangeElementArrayAPPLE")]
            public static extern void MultiDrawRangeElementArray(OpenTK.Graphics.OpenGL.BeginMode mode, UInt32 start, UInt32 end, ref Int32 first, ref Int32 count, Int32 primcount);

            /// <summary>[requires: APPLE_element_array]</summary>
            [Obsolete("Use PrimitiveType overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_element_array", Version = "", EntryPoint = "glMultiDrawRangeElementArrayAPPLE")]
            public static extern unsafe void MultiDrawRangeElementArray(OpenTK.Graphics.OpenGL.BeginMode mode, UInt32 start, UInt32 end, Int32* first, Int32* count, Int32 primcount);

            /// <summary>[requires: APPLE_element_array]</summary>
            [AutoGenerated(Category = "APPLE_element_array", Version = "", EntryPoint = "glMultiDrawRangeElementArrayAPPLE")]
            public static extern void MultiDrawRangeElementArray(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 start, Int32 end, Int32[] first, Int32[] count, Int32 primcount);

            /// <summary>[requires: APPLE_element_array]</summary>
            [AutoGenerated(Category = "APPLE_element_array", Version = "", EntryPoint = "glMultiDrawRangeElementArrayAPPLE")]
            public static extern void MultiDrawRangeElementArray(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 start, Int32 end, ref Int32 first, ref Int32 count, Int32 primcount);

            /// <summary>[requires: APPLE_element_array]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_element_array", Version = "", EntryPoint = "glMultiDrawRangeElementArrayAPPLE")]
            public static extern unsafe void MultiDrawRangeElementArray(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 start, Int32 end, Int32* first, Int32* count, Int32 primcount);

            /// <summary>[requires: APPLE_element_array]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_element_array", Version = "", EntryPoint = "glMultiDrawRangeElementArrayAPPLE")]
            public static extern void MultiDrawRangeElementArray(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 start, UInt32 end, Int32[] first, Int32[] count, Int32 primcount);

            /// <summary>[requires: APPLE_element_array]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_element_array", Version = "", EntryPoint = "glMultiDrawRangeElementArrayAPPLE")]
            public static extern void MultiDrawRangeElementArray(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 start, UInt32 end, ref Int32 first, ref Int32 count, Int32 primcount);

            /// <summary>[requires: APPLE_element_array]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_element_array", Version = "", EntryPoint = "glMultiDrawRangeElementArrayAPPLE")]
            public static extern unsafe void MultiDrawRangeElementArray(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 start, UInt32 end, Int32* first, Int32* count, Int32 primcount);

            /// <summary>[requires: APPLE_object_purgeable]</summary>
            [AutoGenerated(Category = "APPLE_object_purgeable", Version = "", EntryPoint = "glObjectPurgeableAPPLE")]
            public static extern OpenTK.Graphics.OpenGL.AppleObjectPurgeable ObjectPurgeable(OpenTK.Graphics.OpenGL.AppleObjectPurgeable objectType, Int32 name, OpenTK.Graphics.OpenGL.AppleObjectPurgeable option);

            /// <summary>[requires: APPLE_object_purgeable]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_object_purgeable", Version = "", EntryPoint = "glObjectPurgeableAPPLE")]
            public static extern OpenTK.Graphics.OpenGL.AppleObjectPurgeable ObjectPurgeable(OpenTK.Graphics.OpenGL.AppleObjectPurgeable objectType, UInt32 name, OpenTK.Graphics.OpenGL.AppleObjectPurgeable option);

            /// <summary>[requires: APPLE_object_purgeable]</summary>
            [AutoGenerated(Category = "APPLE_object_purgeable", Version = "", EntryPoint = "glObjectUnpurgeableAPPLE")]
            public static extern OpenTK.Graphics.OpenGL.AppleObjectPurgeable ObjectUnpurgeable(OpenTK.Graphics.OpenGL.AppleObjectPurgeable objectType, Int32 name, OpenTK.Graphics.OpenGL.AppleObjectPurgeable option);

            /// <summary>[requires: APPLE_object_purgeable]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_object_purgeable", Version = "", EntryPoint = "glObjectUnpurgeableAPPLE")]
            public static extern OpenTK.Graphics.OpenGL.AppleObjectPurgeable ObjectUnpurgeable(OpenTK.Graphics.OpenGL.AppleObjectPurgeable objectType, UInt32 name, OpenTK.Graphics.OpenGL.AppleObjectPurgeable option);

            /// <summary>[requires: APPLE_fence]</summary>
            [AutoGenerated(Category = "APPLE_fence", Version = "", EntryPoint = "glSetFenceAPPLE")]
            public static extern void SetFence(Int32 fence);

            /// <summary>[requires: APPLE_fence]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_fence", Version = "", EntryPoint = "glSetFenceAPPLE")]
            public static extern void SetFence(UInt32 fence);

            /// <summary>[requires: APPLE_fence]</summary>
            [AutoGenerated(Category = "APPLE_fence", Version = "", EntryPoint = "glTestFenceAPPLE")]
            public static extern bool TestFence(Int32 fence);

            /// <summary>[requires: APPLE_fence]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_fence", Version = "", EntryPoint = "glTestFenceAPPLE")]
            public static extern bool TestFence(UInt32 fence);

            /// <summary>[requires: APPLE_fence]</summary>
            [AutoGenerated(Category = "APPLE_fence", Version = "", EntryPoint = "glTestObjectAPPLE")]
            public static extern bool TestObject(OpenTK.Graphics.OpenGL.AppleFence @object, Int32 name);

            /// <summary>[requires: APPLE_fence]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "APPLE_fence", Version = "", EntryPoint = "glTestObjectAPPLE")]
            public static extern bool TestObject(OpenTK.Graphics.OpenGL.AppleFence @object, UInt32 name);

            /// <summary>[requires: APPLE_texture_range]</summary>
            [AutoGenerated(Category = "APPLE_texture_range", Version = "", EntryPoint = "glTextureRangeAPPLE")]
            public static extern void TextureRange(OpenTK.Graphics.OpenGL.AppleTextureRange target, Int32 length, IntPtr pointer);

            /// <summary>[requires: APPLE_texture_range]</summary>
            [AutoGenerated(Category = "APPLE_texture_range", Version = "", EntryPoint = "glTextureRangeAPPLE")]
            public static extern void TextureRange<T2>(OpenTK.Graphics.OpenGL.AppleTextureRange target, Int32 length, [InAttribute, OutAttribute] T2[] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: APPLE_texture_range]</summary>
            [AutoGenerated(Category = "APPLE_texture_range", Version = "", EntryPoint = "glTextureRangeAPPLE")]
            public static extern void TextureRange<T2>(OpenTK.Graphics.OpenGL.AppleTextureRange target, Int32 length, [InAttribute, OutAttribute] T2[,] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: APPLE_texture_range]</summary>
            [AutoGenerated(Category = "APPLE_texture_range", Version = "", EntryPoint = "glTextureRangeAPPLE")]
            public static extern void TextureRange<T2>(OpenTK.Graphics.OpenGL.AppleTextureRange target, Int32 length, [InAttribute, OutAttribute] T2[,,] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: APPLE_texture_range]</summary>
            [AutoGenerated(Category = "APPLE_texture_range", Version = "", EntryPoint = "glTextureRangeAPPLE")]
            public static extern void TextureRange<T2>(OpenTK.Graphics.OpenGL.AppleTextureRange target, Int32 length, [InAttribute, OutAttribute] ref T2 pointer)
                where T2 : struct
            ;

            /// <summary>[requires: APPLE_vertex_array_range]</summary>
            [AutoGenerated(Category = "APPLE_vertex_array_range", Version = "", EntryPoint = "glVertexArrayParameteriAPPLE")]
            public static extern void VertexArrayParameter(OpenTK.Graphics.OpenGL.AppleVertexArrayRange pname, Int32 param);

            /// <summary>[requires: APPLE_vertex_array_range]</summary>
            [AutoGenerated(Category = "APPLE_vertex_array_range", Version = "", EntryPoint = "glVertexArrayRangeAPPLE")]
            public static extern void VertexArrayRange(Int32 length, [OutAttribute] IntPtr pointer);

            /// <summary>[requires: APPLE_vertex_array_range]</summary>
            [AutoGenerated(Category = "APPLE_vertex_array_range", Version = "", EntryPoint = "glVertexArrayRangeAPPLE")]
            public static extern void VertexArrayRange<T1>(Int32 length, [InAttribute, OutAttribute] T1[] pointer)
                where T1 : struct
            ;

            /// <summary>[requires: APPLE_vertex_array_range]</summary>
            [AutoGenerated(Category = "APPLE_vertex_array_range", Version = "", EntryPoint = "glVertexArrayRangeAPPLE")]
            public static extern void VertexArrayRange<T1>(Int32 length, [InAttribute, OutAttribute] T1[,] pointer)
                where T1 : struct
            ;

            /// <summary>[requires: APPLE_vertex_array_range]</summary>
            [AutoGenerated(Category = "APPLE_vertex_array_range", Version = "", EntryPoint = "glVertexArrayRangeAPPLE")]
            public static extern void VertexArrayRange<T1>(Int32 length, [InAttribute, OutAttribute] T1[,,] pointer)
                where T1 : struct
            ;

            /// <summary>[requires: APPLE_vertex_array_range]</summary>
            [AutoGenerated(Category = "APPLE_vertex_array_range", Version = "", EntryPoint = "glVertexArrayRangeAPPLE")]
            public static extern void VertexArrayRange<T1>(Int32 length, [InAttribute, OutAttribute] ref T1 pointer)
                where T1 : struct
            ;

        }

        public static partial class Arb
        {
            /// <summary>[requires: ARB_multitexture]
            /// Select active texture unit
            /// </summary>
            /// <param name="texture">
            /// <para>
            /// Specifies which texture unit to make active. The number of texture units is implementation dependent, but must be at least 80. texture must be one of GL_TEXTUREi, where i ranges from 0 (GL_MAX_COMBINED_TEXTURE_IMAGE_UNITS - 1). The initial value is GL_TEXTURE0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glActiveTextureARB")]
            public static extern void ActiveTexture(OpenTK.Graphics.OpenGL.TextureUnit texture);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glAttachObjectARB")]
            public static extern void AttachObject(Int32 containerObj, Int32 obj);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glAttachObjectARB")]
            public static extern void AttachObject(UInt32 containerObj, UInt32 obj);

            /// <summary>[requires: ARB_occlusion_query]
            /// Delimit the boundaries of a query object
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target type of query object established between glBeginQuery and the subsequent glEndQuery. The symbolic constant must be one of GL_SAMPLES_PASSED, GL_ANY_SAMPLES_PASSED, GL_ANY_SAMPLES_PASSED_CONSERVATIVE, GL_PRIMITIVES_GENERATED, GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN, or GL_TIME_ELAPSED.
            /// </para>
            /// </param>
            /// <param name="id">
            /// <para>
            /// Specifies the name of a query object.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_occlusion_query", Version = "", EntryPoint = "glBeginQueryARB")]
            public static extern void BeginQuery(OpenTK.Graphics.OpenGL.ArbOcclusionQuery target, Int32 id);

            /// <summary>[requires: ARB_occlusion_query]
            /// Delimit the boundaries of a query object
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target type of query object established between glBeginQuery and the subsequent glEndQuery. The symbolic constant must be one of GL_SAMPLES_PASSED, GL_ANY_SAMPLES_PASSED, GL_ANY_SAMPLES_PASSED_CONSERVATIVE, GL_PRIMITIVES_GENERATED, GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN, or GL_TIME_ELAPSED.
            /// </para>
            /// </param>
            /// <param name="id">
            /// <para>
            /// Specifies the name of a query object.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_occlusion_query", Version = "", EntryPoint = "glBeginQueryARB")]
            public static extern void BeginQuery(OpenTK.Graphics.OpenGL.ArbOcclusionQuery target, UInt32 id);

            /// <summary>[requires: ARB_vertex_shader]
            /// Associates a generic vertex attribute index with a named attribute variable
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program object in which the association is to be made.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be bound.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// Specifies a null terminated string containing the name of the vertex shader attribute variable to which index is to be bound.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_shader", Version = "", EntryPoint = "glBindAttribLocationARB")]
            public static extern void BindAttribLocation(Int32 programObj, Int32 index, String name);

            /// <summary>[requires: ARB_vertex_shader]
            /// Associates a generic vertex attribute index with a named attribute variable
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program object in which the association is to be made.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be bound.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// Specifies a null terminated string containing the name of the vertex shader attribute variable to which index is to be bound.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_shader", Version = "", EntryPoint = "glBindAttribLocationARB")]
            public static extern void BindAttribLocation(UInt32 programObj, UInt32 index, String name);

            /// <summary>[requires: ARB_vertex_buffer_object]
            /// Bind a named buffer object
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target to which the buffer object is bound. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
            /// </para>
            /// </param>
            /// <param name="buffer">
            /// <para>
            /// Specifies the name of a buffer object.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glBindBufferARB")]
            public static extern void BindBuffer(OpenTK.Graphics.OpenGL.BufferTargetArb target, Int32 buffer);

            /// <summary>[requires: ARB_vertex_buffer_object]
            /// Bind a named buffer object
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target to which the buffer object is bound. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
            /// </para>
            /// </param>
            /// <param name="buffer">
            /// <para>
            /// Specifies the name of a buffer object.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glBindBufferARB")]
            public static extern void BindBuffer(OpenTK.Graphics.OpenGL.BufferTargetArb target, UInt32 buffer);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glBindProgramARB")]
            public static extern void BindProgram(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 program);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glBindProgramARB")]
            public static extern void BindProgram(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 program);

            /// <summary>[requires: ARB_draw_buffers_blend]
            /// Specify the equation used for both the RGB blend equation and the Alpha blend equation
            /// </summary>
            /// <param name="buf">
            /// <para>
            /// for glBlendEquationi, specifies the index of the draw buffer for which to set the blend equation.
            /// </para>
            /// </param>
            /// <param name="mode">
            /// <para>
            /// specifies how source and destination colors are combined. It must be GL_FUNC_ADD, GL_FUNC_SUBTRACT, GL_FUNC_REVERSE_SUBTRACT, GL_MIN, GL_MAX.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_draw_buffers_blend", Version = "", EntryPoint = "glBlendEquationiARB")]
            public static extern void BlendEquation(Int32 buf, OpenTK.Graphics.OpenGL.BlendEquationMode mode);

            /// <summary>[requires: ARB_draw_buffers_blend]
            /// Specify the equation used for both the RGB blend equation and the Alpha blend equation
            /// </summary>
            /// <param name="buf">
            /// <para>
            /// for glBlendEquationi, specifies the index of the draw buffer for which to set the blend equation.
            /// </para>
            /// </param>
            /// <param name="mode">
            /// <para>
            /// specifies how source and destination colors are combined. It must be GL_FUNC_ADD, GL_FUNC_SUBTRACT, GL_FUNC_REVERSE_SUBTRACT, GL_MIN, GL_MAX.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_draw_buffers_blend", Version = "", EntryPoint = "glBlendEquationiARB")]
            public static extern void BlendEquation(UInt32 buf, OpenTK.Graphics.OpenGL.BlendEquationMode mode);

            /// <summary>[requires: ARB_draw_buffers_blend]
            /// Set the RGB blend equation and the alpha blend equation separately
            /// </summary>
            /// <param name="buf">
            /// <para>
            /// for glBlendEquationSeparatei, specifies the index of the draw buffer for which to set the blend equations.
            /// </para>
            /// </param>
            /// <param name="modeRGB">
            /// <para>
            /// specifies the RGB blend equation, how the red, green, and blue components of the source and destination colors are combined. It must be GL_FUNC_ADD, GL_FUNC_SUBTRACT, GL_FUNC_REVERSE_SUBTRACT, GL_MIN, GL_MAX.
            /// </para>
            /// </param>
            /// <param name="modeAlpha">
            /// <para>
            /// specifies the alpha blend equation, how the alpha component of the source and destination colors are combined. It must be GL_FUNC_ADD, GL_FUNC_SUBTRACT, GL_FUNC_REVERSE_SUBTRACT, GL_MIN, GL_MAX.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_draw_buffers_blend", Version = "", EntryPoint = "glBlendEquationSeparateiARB")]
            public static extern void BlendEquationSeparate(Int32 buf, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend modeRGB, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend modeAlpha);

            /// <summary>[requires: ARB_draw_buffers_blend]
            /// Set the RGB blend equation and the alpha blend equation separately
            /// </summary>
            /// <param name="buf">
            /// <para>
            /// for glBlendEquationSeparatei, specifies the index of the draw buffer for which to set the blend equations.
            /// </para>
            /// </param>
            /// <param name="modeRGB">
            /// <para>
            /// specifies the RGB blend equation, how the red, green, and blue components of the source and destination colors are combined. It must be GL_FUNC_ADD, GL_FUNC_SUBTRACT, GL_FUNC_REVERSE_SUBTRACT, GL_MIN, GL_MAX.
            /// </para>
            /// </param>
            /// <param name="modeAlpha">
            /// <para>
            /// specifies the alpha blend equation, how the alpha component of the source and destination colors are combined. It must be GL_FUNC_ADD, GL_FUNC_SUBTRACT, GL_FUNC_REVERSE_SUBTRACT, GL_MIN, GL_MAX.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_draw_buffers_blend", Version = "", EntryPoint = "glBlendEquationSeparateiARB")]
            public static extern void BlendEquationSeparate(UInt32 buf, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend modeRGB, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend modeAlpha);

            /// <summary>[requires: ARB_draw_buffers_blend]
            /// Specify pixel arithmetic
            /// </summary>
            /// <param name="buf">
            /// <para>
            /// For glBlendFunci, specifies the index of the draw buffer for which to set the blend function.
            /// </para>
            /// </param>
            /// <param name="sfactor">
            /// <para>
            /// Specifies how the red, green, blue, and alpha source blending factors are computed. The initial value is GL_ONE.
            /// </para>
            /// </param>
            /// <param name="dfactor">
            /// <para>
            /// Specifies how the red, green, blue, and alpha destination blending factors are computed. The following symbolic constants are accepted: GL_ZERO, GL_ONE, GL_SRC_COLOR, GL_ONE_MINUS_SRC_COLOR, GL_DST_COLOR, GL_ONE_MINUS_DST_COLOR, GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA, GL_DST_ALPHA, GL_ONE_MINUS_DST_ALPHA. GL_CONSTANT_COLOR, GL_ONE_MINUS_CONSTANT_COLOR, GL_CONSTANT_ALPHA, and GL_ONE_MINUS_CONSTANT_ALPHA. The initial value is GL_ZERO.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_draw_buffers_blend", Version = "", EntryPoint = "glBlendFunciARB")]
            public static extern void BlendFunc(Int32 buf, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend src, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend dst);

            /// <summary>[requires: ARB_draw_buffers_blend]
            /// Specify pixel arithmetic
            /// </summary>
            /// <param name="buf">
            /// <para>
            /// For glBlendFunci, specifies the index of the draw buffer for which to set the blend function.
            /// </para>
            /// </param>
            /// <param name="sfactor">
            /// <para>
            /// Specifies how the red, green, blue, and alpha source blending factors are computed. The initial value is GL_ONE.
            /// </para>
            /// </param>
            /// <param name="dfactor">
            /// <para>
            /// Specifies how the red, green, blue, and alpha destination blending factors are computed. The following symbolic constants are accepted: GL_ZERO, GL_ONE, GL_SRC_COLOR, GL_ONE_MINUS_SRC_COLOR, GL_DST_COLOR, GL_ONE_MINUS_DST_COLOR, GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA, GL_DST_ALPHA, GL_ONE_MINUS_DST_ALPHA. GL_CONSTANT_COLOR, GL_ONE_MINUS_CONSTANT_COLOR, GL_CONSTANT_ALPHA, and GL_ONE_MINUS_CONSTANT_ALPHA. The initial value is GL_ZERO.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_draw_buffers_blend", Version = "", EntryPoint = "glBlendFunciARB")]
            public static extern void BlendFunc(UInt32 buf, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend src, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend dst);

            /// <summary>[requires: ARB_draw_buffers_blend]
            /// Specify pixel arithmetic for RGB and alpha components separately
            /// </summary>
            /// <param name="buf">
            /// <para>
            /// For glBlendFuncSeparatei, specifies the index of the draw buffer for which to set the blend functions.
            /// </para>
            /// </param>
            /// <param name="srcRGB">
            /// <para>
            /// Specifies how the red, green, and blue blending factors are computed. The initial value is GL_ONE.
            /// </para>
            /// </param>
            /// <param name="dstRGB">
            /// <para>
            /// Specifies how the red, green, and blue destination blending factors are computed. The initial value is GL_ZERO.
            /// </para>
            /// </param>
            /// <param name="srcAlpha">
            /// <para>
            /// Specified how the alpha source blending factor is computed. The initial value is GL_ONE.
            /// </para>
            /// </param>
            /// <param name="dstAlpha">
            /// <para>
            /// Specified how the alpha destination blending factor is computed. The initial value is GL_ZERO.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_draw_buffers_blend", Version = "", EntryPoint = "glBlendFuncSeparateiARB")]
            public static extern void BlendFuncSeparate(Int32 buf, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend srcRGB, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend dstRGB, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend srcAlpha, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend dstAlpha);

            /// <summary>[requires: ARB_draw_buffers_blend]
            /// Specify pixel arithmetic for RGB and alpha components separately
            /// </summary>
            /// <param name="buf">
            /// <para>
            /// For glBlendFuncSeparatei, specifies the index of the draw buffer for which to set the blend functions.
            /// </para>
            /// </param>
            /// <param name="srcRGB">
            /// <para>
            /// Specifies how the red, green, and blue blending factors are computed. The initial value is GL_ONE.
            /// </para>
            /// </param>
            /// <param name="dstRGB">
            /// <para>
            /// Specifies how the red, green, and blue destination blending factors are computed. The initial value is GL_ZERO.
            /// </para>
            /// </param>
            /// <param name="srcAlpha">
            /// <para>
            /// Specified how the alpha source blending factor is computed. The initial value is GL_ONE.
            /// </para>
            /// </param>
            /// <param name="dstAlpha">
            /// <para>
            /// Specified how the alpha destination blending factor is computed. The initial value is GL_ZERO.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_draw_buffers_blend", Version = "", EntryPoint = "glBlendFuncSeparateiARB")]
            public static extern void BlendFuncSeparate(UInt32 buf, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend srcRGB, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend dstRGB, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend srcAlpha, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend dstAlpha);

            /// <summary>[requires: ARB_vertex_buffer_object]
            /// Creates and initializes a buffer object's data store
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Specifies the size in bytes of the buffer object's new data store.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to data that will be copied into the data store for initialization, or NULL if no data is to be copied.
            /// </para>
            /// </param>
            /// <param name="usage">
            /// <para>
            /// Specifies the expected usage pattern of the data store. The symbolic constant must be GL_STREAM_DRAW, GL_STREAM_READ, GL_STREAM_COPY, GL_STATIC_DRAW, GL_STATIC_READ, GL_STATIC_COPY, GL_DYNAMIC_DRAW, GL_DYNAMIC_READ, or GL_DYNAMIC_COPY.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glBufferDataARB")]
            public static extern void BufferData(OpenTK.Graphics.OpenGL.BufferTargetArb target, IntPtr size, IntPtr data, OpenTK.Graphics.OpenGL.BufferUsageArb usage);

            /// <summary>[requires: ARB_vertex_buffer_object]
            /// Creates and initializes a buffer object's data store
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Specifies the size in bytes of the buffer object's new data store.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to data that will be copied into the data store for initialization, or NULL if no data is to be copied.
            /// </para>
            /// </param>
            /// <param name="usage">
            /// <para>
            /// Specifies the expected usage pattern of the data store. The symbolic constant must be GL_STREAM_DRAW, GL_STREAM_READ, GL_STREAM_COPY, GL_STATIC_DRAW, GL_STATIC_READ, GL_STATIC_COPY, GL_DYNAMIC_DRAW, GL_DYNAMIC_READ, or GL_DYNAMIC_COPY.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glBufferDataARB")]
            public static extern void BufferData<T2>(OpenTK.Graphics.OpenGL.BufferTargetArb target, IntPtr size, [InAttribute, OutAttribute] T2[] data, OpenTK.Graphics.OpenGL.BufferUsageArb usage)
                where T2 : struct
            ;

            /// <summary>[requires: ARB_vertex_buffer_object]
            /// Creates and initializes a buffer object's data store
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Specifies the size in bytes of the buffer object's new data store.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to data that will be copied into the data store for initialization, or NULL if no data is to be copied.
            /// </para>
            /// </param>
            /// <param name="usage">
            /// <para>
            /// Specifies the expected usage pattern of the data store. The symbolic constant must be GL_STREAM_DRAW, GL_STREAM_READ, GL_STREAM_COPY, GL_STATIC_DRAW, GL_STATIC_READ, GL_STATIC_COPY, GL_DYNAMIC_DRAW, GL_DYNAMIC_READ, or GL_DYNAMIC_COPY.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glBufferDataARB")]
            public static extern void BufferData<T2>(OpenTK.Graphics.OpenGL.BufferTargetArb target, IntPtr size, [InAttribute, OutAttribute] T2[,] data, OpenTK.Graphics.OpenGL.BufferUsageArb usage)
                where T2 : struct
            ;

            /// <summary>[requires: ARB_vertex_buffer_object]
            /// Creates and initializes a buffer object's data store
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Specifies the size in bytes of the buffer object's new data store.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to data that will be copied into the data store for initialization, or NULL if no data is to be copied.
            /// </para>
            /// </param>
            /// <param name="usage">
            /// <para>
            /// Specifies the expected usage pattern of the data store. The symbolic constant must be GL_STREAM_DRAW, GL_STREAM_READ, GL_STREAM_COPY, GL_STATIC_DRAW, GL_STATIC_READ, GL_STATIC_COPY, GL_DYNAMIC_DRAW, GL_DYNAMIC_READ, or GL_DYNAMIC_COPY.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glBufferDataARB")]
            public static extern void BufferData<T2>(OpenTK.Graphics.OpenGL.BufferTargetArb target, IntPtr size, [InAttribute, OutAttribute] T2[,,] data, OpenTK.Graphics.OpenGL.BufferUsageArb usage)
                where T2 : struct
            ;

            /// <summary>[requires: ARB_vertex_buffer_object]
            /// Creates and initializes a buffer object's data store
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Specifies the size in bytes of the buffer object's new data store.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to data that will be copied into the data store for initialization, or NULL if no data is to be copied.
            /// </para>
            /// </param>
            /// <param name="usage">
            /// <para>
            /// Specifies the expected usage pattern of the data store. The symbolic constant must be GL_STREAM_DRAW, GL_STREAM_READ, GL_STREAM_COPY, GL_STATIC_DRAW, GL_STATIC_READ, GL_STATIC_COPY, GL_DYNAMIC_DRAW, GL_DYNAMIC_READ, or GL_DYNAMIC_COPY.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glBufferDataARB")]
            public static extern void BufferData<T2>(OpenTK.Graphics.OpenGL.BufferTargetArb target, IntPtr size, [InAttribute, OutAttribute] ref T2 data, OpenTK.Graphics.OpenGL.BufferUsageArb usage)
                where T2 : struct
            ;

            /// <summary>[requires: ARB_vertex_buffer_object]
            /// Updates a subset of a buffer object's data store
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
            /// </para>
            /// </param>
            /// <param name="offset">
            /// <para>
            /// Specifies the offset into the buffer object's data store where data replacement will begin, measured in bytes.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Specifies the size in bytes of the data store region being replaced.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the new data that will be copied into the data store.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glBufferSubDataARB")]
            public static extern void BufferSubData(OpenTK.Graphics.OpenGL.BufferTargetArb target, IntPtr offset, IntPtr size, IntPtr data);

            /// <summary>[requires: ARB_vertex_buffer_object]
            /// Updates a subset of a buffer object's data store
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
            /// </para>
            /// </param>
            /// <param name="offset">
            /// <para>
            /// Specifies the offset into the buffer object's data store where data replacement will begin, measured in bytes.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Specifies the size in bytes of the data store region being replaced.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the new data that will be copied into the data store.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glBufferSubDataARB")]
            public static extern void BufferSubData<T3>(OpenTK.Graphics.OpenGL.BufferTargetArb target, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] T3[] data)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_vertex_buffer_object]
            /// Updates a subset of a buffer object's data store
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
            /// </para>
            /// </param>
            /// <param name="offset">
            /// <para>
            /// Specifies the offset into the buffer object's data store where data replacement will begin, measured in bytes.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Specifies the size in bytes of the data store region being replaced.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the new data that will be copied into the data store.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glBufferSubDataARB")]
            public static extern void BufferSubData<T3>(OpenTK.Graphics.OpenGL.BufferTargetArb target, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] T3[,] data)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_vertex_buffer_object]
            /// Updates a subset of a buffer object's data store
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
            /// </para>
            /// </param>
            /// <param name="offset">
            /// <para>
            /// Specifies the offset into the buffer object's data store where data replacement will begin, measured in bytes.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Specifies the size in bytes of the data store region being replaced.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the new data that will be copied into the data store.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glBufferSubDataARB")]
            public static extern void BufferSubData<T3>(OpenTK.Graphics.OpenGL.BufferTargetArb target, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] T3[,,] data)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_vertex_buffer_object]
            /// Updates a subset of a buffer object's data store
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
            /// </para>
            /// </param>
            /// <param name="offset">
            /// <para>
            /// Specifies the offset into the buffer object's data store where data replacement will begin, measured in bytes.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Specifies the size in bytes of the data store region being replaced.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the new data that will be copied into the data store.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glBufferSubDataARB")]
            public static extern void BufferSubData<T3>(OpenTK.Graphics.OpenGL.BufferTargetArb target, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] ref T3 data)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_color_buffer_float]
            /// Specify whether data read via glReadPixels should be clamped
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Target for color clamping. target must be GL_CLAMP_READ_COLOR.
            /// </para>
            /// </param>
            /// <param name="clamp">
            /// <para>
            /// Specifies whether to apply color clamping. clamp must be GL_TRUE or GL_FALSE.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_color_buffer_float", Version = "", EntryPoint = "glClampColorARB")]
            public static extern void ClampColor(OpenTK.Graphics.OpenGL.ArbColorBufferFloat target, OpenTK.Graphics.OpenGL.ArbColorBufferFloat clamp);

            /// <summary>[requires: ARB_multitexture]
            /// Select active texture unit
            /// </summary>
            /// <param name="texture">
            /// <para>
            /// Specifies which texture unit to make active. The number of texture units is implementation dependent, but must be at least two. texture must be one of GL_TEXTURE, where i ranges from 0 to the value of GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value. The initial value is GL_TEXTURE0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glClientActiveTextureARB")]
            public static extern void ClientActiveTexture(OpenTK.Graphics.OpenGL.TextureUnit texture);

            /// <summary>[requires: ARB_shader_objects]
            /// Compiles a shader object
            /// </summary>
            /// <param name="shader">
            /// <para>
            /// Specifies the shader object to be compiled.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glCompileShaderARB")]
            public static extern void CompileShader(Int32 shaderObj);

            /// <summary>[requires: ARB_shader_objects]
            /// Compiles a shader object
            /// </summary>
            /// <param name="shader">
            /// <para>
            /// Specifies the shader object to be compiled.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glCompileShaderARB")]
            public static extern void CompileShader(UInt32 shaderObj);

            /// <summary>[requires: ARB_shading_language_include]</summary>
            [AutoGenerated(Category = "ARB_shading_language_include", Version = "", EntryPoint = "glCompileShaderIncludeARB")]
            public static extern void CompileShaderInclude(Int32 shader, Int32 count, String[] path, Int32[] length);

            /// <summary>[requires: ARB_shading_language_include]</summary>
            [AutoGenerated(Category = "ARB_shading_language_include", Version = "", EntryPoint = "glCompileShaderIncludeARB")]
            public static extern void CompileShaderInclude(Int32 shader, Int32 count, String[] path, ref Int32 length);

            /// <summary>[requires: ARB_shading_language_include]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shading_language_include", Version = "", EntryPoint = "glCompileShaderIncludeARB")]
            public static extern unsafe void CompileShaderInclude(Int32 shader, Int32 count, String[] path, Int32* length);

            /// <summary>[requires: ARB_shading_language_include]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shading_language_include", Version = "", EntryPoint = "glCompileShaderIncludeARB")]
            public static extern void CompileShaderInclude(UInt32 shader, Int32 count, String[] path, Int32[] length);

            /// <summary>[requires: ARB_shading_language_include]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shading_language_include", Version = "", EntryPoint = "glCompileShaderIncludeARB")]
            public static extern void CompileShaderInclude(UInt32 shader, Int32 count, String[] path, ref Int32 length);

            /// <summary>[requires: ARB_shading_language_include]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shading_language_include", Version = "", EntryPoint = "glCompileShaderIncludeARB")]
            public static extern unsafe void CompileShaderInclude(UInt32 shader, Int32 count, String[] path, Int32* length);

            /// <summary>[requires: ARB_texture_compression]
            /// Specify a one-dimensional texture image in a compressed format
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_1D or GL_PROXY_TEXTURE_1D.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// Specifies the format of the compressed image data stored at address data.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture image. All implementations support texture images that are at least 64 texels wide. The height of the 1D texture image is 1.
            /// </para>
            /// </param>
            /// <param name="border">
            /// <para>
            /// This value must be 0.
            /// </para>
            /// </param>
            /// <param name="imageSize">
            /// <para>
            /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the compressed image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_compression", Version = "", EntryPoint = "glCompressedTexImage1DARB")]
            public static extern void CompressedTexImage1D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 border, Int32 imageSize, IntPtr data);

            /// <summary>[requires: ARB_texture_compression]
            /// Specify a one-dimensional texture image in a compressed format
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_1D or GL_PROXY_TEXTURE_1D.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// Specifies the format of the compressed image data stored at address data.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture image. All implementations support texture images that are at least 64 texels wide. The height of the 1D texture image is 1.
            /// </para>
            /// </param>
            /// <param name="border">
            /// <para>
            /// This value must be 0.
            /// </para>
            /// </param>
            /// <param name="imageSize">
            /// <para>
            /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the compressed image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_compression", Version = "", EntryPoint = "glCompressedTexImage1DARB")]
            public static extern void CompressedTexImage1D<T6>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T6[] data)
                where T6 : struct
            ;

            /// <summary>[requires: ARB_texture_compression]
            /// Specify a one-dimensional texture image in a compressed format
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_1D or GL_PROXY_TEXTURE_1D.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// Specifies the format of the compressed image data stored at address data.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture image. All implementations support texture images that are at least 64 texels wide. The height of the 1D texture image is 1.
            /// </para>
            /// </param>
            /// <param name="border">
            /// <para>
            /// This value must be 0.
            /// </para>
            /// </param>
            /// <param name="imageSize">
            /// <para>
            /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the compressed image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_compression", Version = "", EntryPoint = "glCompressedTexImage1DARB")]
            public static extern void CompressedTexImage1D<T6>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T6[,] data)
                where T6 : struct
            ;

            /// <summary>[requires: ARB_texture_compression]
            /// Specify a one-dimensional texture image in a compressed format
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_1D or GL_PROXY_TEXTURE_1D.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// Specifies the format of the compressed image data stored at address data.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture image. All implementations support texture images that are at least 64 texels wide. The height of the 1D texture image is 1.
            /// </para>
            /// </param>
            /// <param name="border">
            /// <para>
            /// This value must be 0.
            /// </para>
            /// </param>
            /// <param name="imageSize">
            /// <para>
            /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the compressed image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_compression", Version = "", EntryPoint = "glCompressedTexImage1DARB")]
            public static extern void CompressedTexImage1D<T6>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T6[,,] data)
                where T6 : struct
            ;

            /// <summary>[requires: ARB_texture_compression]
            /// Specify a one-dimensional texture image in a compressed format
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_1D or GL_PROXY_TEXTURE_1D.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// Specifies the format of the compressed image data stored at address data.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture image. All implementations support texture images that are at least 64 texels wide. The height of the 1D texture image is 1.
            /// </para>
            /// </param>
            /// <param name="border">
            /// <para>
            /// This value must be 0.
            /// </para>
            /// </param>
            /// <param name="imageSize">
            /// <para>
            /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the compressed image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_compression", Version = "", EntryPoint = "glCompressedTexImage1DARB")]
            public static extern void CompressedTexImage1D<T6>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] ref T6 data)
                where T6 : struct
            ;

            /// <summary>[requires: ARB_texture_compression]
            /// Specify a two-dimensional texture image in a compressed format
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_PROXY_TEXTURE_2D, GL_TEXTURE_1D_ARRAY, GL_PROXY_TEXTURE_1D_ARRAY, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, or GL_PROXY_TEXTURE_CUBE_MAP.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// Specifies the format of the compressed image data stored at address data.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture image. All implementations support 2D texture and cube map texture images that are at least 16384 texels wide.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture image. All implementations support 2D texture and cube map texture images that are at least 16384 texels high.
            /// </para>
            /// </param>
            /// <param name="border">
            /// <para>
            /// This value must be 0.
            /// </para>
            /// </param>
            /// <param name="imageSize">
            /// <para>
            /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the compressed image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_compression", Version = "", EntryPoint = "glCompressedTexImage2DARB")]
            public static extern void CompressedTexImage2D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 border, Int32 imageSize, IntPtr data);

            /// <summary>[requires: ARB_texture_compression]
            /// Specify a two-dimensional texture image in a compressed format
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_PROXY_TEXTURE_2D, GL_TEXTURE_1D_ARRAY, GL_PROXY_TEXTURE_1D_ARRAY, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, or GL_PROXY_TEXTURE_CUBE_MAP.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// Specifies the format of the compressed image data stored at address data.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture image. All implementations support 2D texture and cube map texture images that are at least 16384 texels wide.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture image. All implementations support 2D texture and cube map texture images that are at least 16384 texels high.
            /// </para>
            /// </param>
            /// <param name="border">
            /// <para>
            /// This value must be 0.
            /// </para>
            /// </param>
            /// <param name="imageSize">
            /// <para>
            /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the compressed image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_compression", Version = "", EntryPoint = "glCompressedTexImage2DARB")]
            public static extern void CompressedTexImage2D<T7>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T7[] data)
                where T7 : struct
            ;

            /// <summary>[requires: ARB_texture_compression]
            /// Specify a two-dimensional texture image in a compressed format
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_PROXY_TEXTURE_2D, GL_TEXTURE_1D_ARRAY, GL_PROXY_TEXTURE_1D_ARRAY, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, or GL_PROXY_TEXTURE_CUBE_MAP.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// Specifies the format of the compressed image data stored at address data.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture image. All implementations support 2D texture and cube map texture images that are at least 16384 texels wide.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture image. All implementations support 2D texture and cube map texture images that are at least 16384 texels high.
            /// </para>
            /// </param>
            /// <param name="border">
            /// <para>
            /// This value must be 0.
            /// </para>
            /// </param>
            /// <param name="imageSize">
            /// <para>
            /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the compressed image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_compression", Version = "", EntryPoint = "glCompressedTexImage2DARB")]
            public static extern void CompressedTexImage2D<T7>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T7[,] data)
                where T7 : struct
            ;

            /// <summary>[requires: ARB_texture_compression]
            /// Specify a two-dimensional texture image in a compressed format
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_PROXY_TEXTURE_2D, GL_TEXTURE_1D_ARRAY, GL_PROXY_TEXTURE_1D_ARRAY, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, or GL_PROXY_TEXTURE_CUBE_MAP.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// Specifies the format of the compressed image data stored at address data.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture image. All implementations support 2D texture and cube map texture images that are at least 16384 texels wide.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture image. All implementations support 2D texture and cube map texture images that are at least 16384 texels high.
            /// </para>
            /// </param>
            /// <param name="border">
            /// <para>
            /// This value must be 0.
            /// </para>
            /// </param>
            /// <param name="imageSize">
            /// <para>
            /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the compressed image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_compression", Version = "", EntryPoint = "glCompressedTexImage2DARB")]
            public static extern void CompressedTexImage2D<T7>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T7[,,] data)
                where T7 : struct
            ;

            /// <summary>[requires: ARB_texture_compression]
            /// Specify a two-dimensional texture image in a compressed format
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_PROXY_TEXTURE_2D, GL_TEXTURE_1D_ARRAY, GL_PROXY_TEXTURE_1D_ARRAY, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, or GL_PROXY_TEXTURE_CUBE_MAP.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// Specifies the format of the compressed image data stored at address data.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture image. All implementations support 2D texture and cube map texture images that are at least 16384 texels wide.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture image. All implementations support 2D texture and cube map texture images that are at least 16384 texels high.
            /// </para>
            /// </param>
            /// <param name="border">
            /// <para>
            /// This value must be 0.
            /// </para>
            /// </param>
            /// <param name="imageSize">
            /// <para>
            /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the compressed image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_compression", Version = "", EntryPoint = "glCompressedTexImage2DARB")]
            public static extern void CompressedTexImage2D<T7>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] ref T7 data)
                where T7 : struct
            ;

            /// <summary>[requires: ARB_texture_compression]
            /// Specify a three-dimensional texture image in a compressed format
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_3D, GL_PROXY_TEXTURE_3D, GL_TEXTURE_2D_ARRAY or GL_PROXY_TEXTURE_2D_ARRAY.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// Specifies the format of the compressed image data stored at address data.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture image. All implementations support 3D texture images that are at least 16 texels wide.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture image. All implementations support 3D texture images that are at least 16 texels high.
            /// </para>
            /// </param>
            /// <param name="depth">
            /// <para>
            /// Specifies the depth of the texture image. All implementations support 3D texture images that are at least 16 texels deep.
            /// </para>
            /// </param>
            /// <param name="border">
            /// <para>
            /// This value must be 0.
            /// </para>
            /// </param>
            /// <param name="imageSize">
            /// <para>
            /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the compressed image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_compression", Version = "", EntryPoint = "glCompressedTexImage3DARB")]
            public static extern void CompressedTexImage3D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, Int32 imageSize, IntPtr data);

            /// <summary>[requires: ARB_texture_compression]
            /// Specify a three-dimensional texture image in a compressed format
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_3D, GL_PROXY_TEXTURE_3D, GL_TEXTURE_2D_ARRAY or GL_PROXY_TEXTURE_2D_ARRAY.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// Specifies the format of the compressed image data stored at address data.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture image. All implementations support 3D texture images that are at least 16 texels wide.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture image. All implementations support 3D texture images that are at least 16 texels high.
            /// </para>
            /// </param>
            /// <param name="depth">
            /// <para>
            /// Specifies the depth of the texture image. All implementations support 3D texture images that are at least 16 texels deep.
            /// </para>
            /// </param>
            /// <param name="border">
            /// <para>
            /// This value must be 0.
            /// </para>
            /// </param>
            /// <param name="imageSize">
            /// <para>
            /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the compressed image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_compression", Version = "", EntryPoint = "glCompressedTexImage3DARB")]
            public static extern void CompressedTexImage3D<T8>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T8[] data)
                where T8 : struct
            ;

            /// <summary>[requires: ARB_texture_compression]
            /// Specify a three-dimensional texture image in a compressed format
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_3D, GL_PROXY_TEXTURE_3D, GL_TEXTURE_2D_ARRAY or GL_PROXY_TEXTURE_2D_ARRAY.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// Specifies the format of the compressed image data stored at address data.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture image. All implementations support 3D texture images that are at least 16 texels wide.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture image. All implementations support 3D texture images that are at least 16 texels high.
            /// </para>
            /// </param>
            /// <param name="depth">
            /// <para>
            /// Specifies the depth of the texture image. All implementations support 3D texture images that are at least 16 texels deep.
            /// </para>
            /// </param>
            /// <param name="border">
            /// <para>
            /// This value must be 0.
            /// </para>
            /// </param>
            /// <param name="imageSize">
            /// <para>
            /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the compressed image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_compression", Version = "", EntryPoint = "glCompressedTexImage3DARB")]
            public static extern void CompressedTexImage3D<T8>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T8[,] data)
                where T8 : struct
            ;

            /// <summary>[requires: ARB_texture_compression]
            /// Specify a three-dimensional texture image in a compressed format
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_3D, GL_PROXY_TEXTURE_3D, GL_TEXTURE_2D_ARRAY or GL_PROXY_TEXTURE_2D_ARRAY.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// Specifies the format of the compressed image data stored at address data.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture image. All implementations support 3D texture images that are at least 16 texels wide.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture image. All implementations support 3D texture images that are at least 16 texels high.
            /// </para>
            /// </param>
            /// <param name="depth">
            /// <para>
            /// Specifies the depth of the texture image. All implementations support 3D texture images that are at least 16 texels deep.
            /// </para>
            /// </param>
            /// <param name="border">
            /// <para>
            /// This value must be 0.
            /// </para>
            /// </param>
            /// <param name="imageSize">
            /// <para>
            /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the compressed image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_compression", Version = "", EntryPoint = "glCompressedTexImage3DARB")]
            public static extern void CompressedTexImage3D<T8>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T8[,,] data)
                where T8 : struct
            ;

            /// <summary>[requires: ARB_texture_compression]
            /// Specify a three-dimensional texture image in a compressed format
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_3D, GL_PROXY_TEXTURE_3D, GL_TEXTURE_2D_ARRAY or GL_PROXY_TEXTURE_2D_ARRAY.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// Specifies the format of the compressed image data stored at address data.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture image. All implementations support 3D texture images that are at least 16 texels wide.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture image. All implementations support 3D texture images that are at least 16 texels high.
            /// </para>
            /// </param>
            /// <param name="depth">
            /// <para>
            /// Specifies the depth of the texture image. All implementations support 3D texture images that are at least 16 texels deep.
            /// </para>
            /// </param>
            /// <param name="border">
            /// <para>
            /// This value must be 0.
            /// </para>
            /// </param>
            /// <param name="imageSize">
            /// <para>
            /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the compressed image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_compression", Version = "", EntryPoint = "glCompressedTexImage3DARB")]
            public static extern void CompressedTexImage3D<T8>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] ref T8 data)
                where T8 : struct
            ;

            /// <summary>[requires: ARB_texture_compression]
            /// Specify a one-dimensional texture subimage in a compressed format
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_1D.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="xoffset">
            /// <para>
            /// Specifies a texel offset in the x direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format of the compressed image data stored at address data.
            /// </para>
            /// </param>
            /// <param name="imageSize">
            /// <para>
            /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the compressed image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_compression", Version = "", EntryPoint = "glCompressedTexSubImage1DARB")]
            public static extern void CompressedTexSubImage1D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, IntPtr data);

            /// <summary>[requires: ARB_texture_compression]
            /// Specify a one-dimensional texture subimage in a compressed format
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_1D.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="xoffset">
            /// <para>
            /// Specifies a texel offset in the x direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format of the compressed image data stored at address data.
            /// </para>
            /// </param>
            /// <param name="imageSize">
            /// <para>
            /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the compressed image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_compression", Version = "", EntryPoint = "glCompressedTexSubImage1DARB")]
            public static extern void CompressedTexSubImage1D<T6>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T6[] data)
                where T6 : struct
            ;

            /// <summary>[requires: ARB_texture_compression]
            /// Specify a one-dimensional texture subimage in a compressed format
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_1D.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="xoffset">
            /// <para>
            /// Specifies a texel offset in the x direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format of the compressed image data stored at address data.
            /// </para>
            /// </param>
            /// <param name="imageSize">
            /// <para>
            /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the compressed image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_compression", Version = "", EntryPoint = "glCompressedTexSubImage1DARB")]
            public static extern void CompressedTexSubImage1D<T6>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T6[,] data)
                where T6 : struct
            ;

            /// <summary>[requires: ARB_texture_compression]
            /// Specify a one-dimensional texture subimage in a compressed format
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_1D.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="xoffset">
            /// <para>
            /// Specifies a texel offset in the x direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format of the compressed image data stored at address data.
            /// </para>
            /// </param>
            /// <param name="imageSize">
            /// <para>
            /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the compressed image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_compression", Version = "", EntryPoint = "glCompressedTexSubImage1DARB")]
            public static extern void CompressedTexSubImage1D<T6>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T6[,,] data)
                where T6 : struct
            ;

            /// <summary>[requires: ARB_texture_compression]
            /// Specify a one-dimensional texture subimage in a compressed format
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_1D.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="xoffset">
            /// <para>
            /// Specifies a texel offset in the x direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format of the compressed image data stored at address data.
            /// </para>
            /// </param>
            /// <param name="imageSize">
            /// <para>
            /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the compressed image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_compression", Version = "", EntryPoint = "glCompressedTexSubImage1DARB")]
            public static extern void CompressedTexSubImage1D<T6>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] ref T6 data)
                where T6 : struct
            ;

            /// <summary>[requires: ARB_texture_compression]
            /// Specify a two-dimensional texture subimage in a compressed format
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, or GL_TEXTURE_CUBE_MAP_NEGATIVE_Z.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="xoffset">
            /// <para>
            /// Specifies a texel offset in the x direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="yoffset">
            /// <para>
            /// Specifies a texel offset in the y direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format of the compressed image data stored at address data.
            /// </para>
            /// </param>
            /// <param name="imageSize">
            /// <para>
            /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the compressed image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_compression", Version = "", EntryPoint = "glCompressedTexSubImage2DARB")]
            public static extern void CompressedTexSubImage2D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, IntPtr data);

            /// <summary>[requires: ARB_texture_compression]
            /// Specify a two-dimensional texture subimage in a compressed format
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, or GL_TEXTURE_CUBE_MAP_NEGATIVE_Z.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="xoffset">
            /// <para>
            /// Specifies a texel offset in the x direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="yoffset">
            /// <para>
            /// Specifies a texel offset in the y direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format of the compressed image data stored at address data.
            /// </para>
            /// </param>
            /// <param name="imageSize">
            /// <para>
            /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the compressed image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_compression", Version = "", EntryPoint = "glCompressedTexSubImage2DARB")]
            public static extern void CompressedTexSubImage2D<T8>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T8[] data)
                where T8 : struct
            ;

            /// <summary>[requires: ARB_texture_compression]
            /// Specify a two-dimensional texture subimage in a compressed format
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, or GL_TEXTURE_CUBE_MAP_NEGATIVE_Z.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="xoffset">
            /// <para>
            /// Specifies a texel offset in the x direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="yoffset">
            /// <para>
            /// Specifies a texel offset in the y direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format of the compressed image data stored at address data.
            /// </para>
            /// </param>
            /// <param name="imageSize">
            /// <para>
            /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the compressed image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_compression", Version = "", EntryPoint = "glCompressedTexSubImage2DARB")]
            public static extern void CompressedTexSubImage2D<T8>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T8[,] data)
                where T8 : struct
            ;

            /// <summary>[requires: ARB_texture_compression]
            /// Specify a two-dimensional texture subimage in a compressed format
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, or GL_TEXTURE_CUBE_MAP_NEGATIVE_Z.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="xoffset">
            /// <para>
            /// Specifies a texel offset in the x direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="yoffset">
            /// <para>
            /// Specifies a texel offset in the y direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format of the compressed image data stored at address data.
            /// </para>
            /// </param>
            /// <param name="imageSize">
            /// <para>
            /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the compressed image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_compression", Version = "", EntryPoint = "glCompressedTexSubImage2DARB")]
            public static extern void CompressedTexSubImage2D<T8>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T8[,,] data)
                where T8 : struct
            ;

            /// <summary>[requires: ARB_texture_compression]
            /// Specify a two-dimensional texture subimage in a compressed format
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, or GL_TEXTURE_CUBE_MAP_NEGATIVE_Z.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="xoffset">
            /// <para>
            /// Specifies a texel offset in the x direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="yoffset">
            /// <para>
            /// Specifies a texel offset in the y direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format of the compressed image data stored at address data.
            /// </para>
            /// </param>
            /// <param name="imageSize">
            /// <para>
            /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the compressed image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_compression", Version = "", EntryPoint = "glCompressedTexSubImage2DARB")]
            public static extern void CompressedTexSubImage2D<T8>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] ref T8 data)
                where T8 : struct
            ;

            /// <summary>[requires: ARB_texture_compression]
            /// Specify a three-dimensional texture subimage in a compressed format
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_3D.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="xoffset">
            /// <para>
            /// Specifies a texel offset in the x direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="yoffset">
            /// <para>
            /// Specifies a texel offset in the y direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="depth">
            /// <para>
            /// Specifies the depth of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format of the compressed image data stored at address data.
            /// </para>
            /// </param>
            /// <param name="imageSize">
            /// <para>
            /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the compressed image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_compression", Version = "", EntryPoint = "glCompressedTexSubImage3DARB")]
            public static extern void CompressedTexSubImage3D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, IntPtr data);

            /// <summary>[requires: ARB_texture_compression]
            /// Specify a three-dimensional texture subimage in a compressed format
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_3D.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="xoffset">
            /// <para>
            /// Specifies a texel offset in the x direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="yoffset">
            /// <para>
            /// Specifies a texel offset in the y direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="depth">
            /// <para>
            /// Specifies the depth of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format of the compressed image data stored at address data.
            /// </para>
            /// </param>
            /// <param name="imageSize">
            /// <para>
            /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the compressed image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_compression", Version = "", EntryPoint = "glCompressedTexSubImage3DARB")]
            public static extern void CompressedTexSubImage3D<T10>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T10[] data)
                where T10 : struct
            ;

            /// <summary>[requires: ARB_texture_compression]
            /// Specify a three-dimensional texture subimage in a compressed format
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_3D.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="xoffset">
            /// <para>
            /// Specifies a texel offset in the x direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="yoffset">
            /// <para>
            /// Specifies a texel offset in the y direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="depth">
            /// <para>
            /// Specifies the depth of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format of the compressed image data stored at address data.
            /// </para>
            /// </param>
            /// <param name="imageSize">
            /// <para>
            /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the compressed image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_compression", Version = "", EntryPoint = "glCompressedTexSubImage3DARB")]
            public static extern void CompressedTexSubImage3D<T10>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T10[,] data)
                where T10 : struct
            ;

            /// <summary>[requires: ARB_texture_compression]
            /// Specify a three-dimensional texture subimage in a compressed format
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_3D.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="xoffset">
            /// <para>
            /// Specifies a texel offset in the x direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="yoffset">
            /// <para>
            /// Specifies a texel offset in the y direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="depth">
            /// <para>
            /// Specifies the depth of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format of the compressed image data stored at address data.
            /// </para>
            /// </param>
            /// <param name="imageSize">
            /// <para>
            /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the compressed image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_compression", Version = "", EntryPoint = "glCompressedTexSubImage3DARB")]
            public static extern void CompressedTexSubImage3D<T10>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T10[,,] data)
                where T10 : struct
            ;

            /// <summary>[requires: ARB_texture_compression]
            /// Specify a three-dimensional texture subimage in a compressed format
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_3D.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="xoffset">
            /// <para>
            /// Specifies a texel offset in the x direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="yoffset">
            /// <para>
            /// Specifies a texel offset in the y direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="depth">
            /// <para>
            /// Specifies the depth of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format of the compressed image data stored at address data.
            /// </para>
            /// </param>
            /// <param name="imageSize">
            /// <para>
            /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the compressed image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_compression", Version = "", EntryPoint = "glCompressedTexSubImage3DARB")]
            public static extern void CompressedTexSubImage3D<T10>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] ref T10 data)
                where T10 : struct
            ;

            /// <summary>[requires: ARB_shader_objects]</summary>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glCreateProgramObjectARB")]
            public static extern Int32 CreateProgramObject();

            /// <summary>[requires: ARB_shader_objects]</summary>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glCreateShaderObjectARB")]
            public static extern Int32 CreateShaderObject(OpenTK.Graphics.OpenGL.ArbShaderObjects shaderType);

            /// <summary>[requires: ARB_cl_event]</summary>
            [AutoGenerated(Category = "ARB_cl_event", Version = "", EntryPoint = "glCreateSyncFromCLeventARB")]
            public static extern IntPtr CreateSyncFromCLevent([OutAttribute] IntPtr[] context, [OutAttribute] IntPtr[] @event, Int32 flags);

            /// <summary>[requires: ARB_cl_event]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_cl_event", Version = "", EntryPoint = "glCreateSyncFromCLeventARB")]
            public static extern IntPtr CreateSyncFromCLevent([OutAttribute] IntPtr[] context, [OutAttribute] IntPtr[] @event, UInt32 flags);

            /// <summary>[requires: ARB_cl_event]</summary>
            [AutoGenerated(Category = "ARB_cl_event", Version = "", EntryPoint = "glCreateSyncFromCLeventARB")]
            public static extern IntPtr CreateSyncFromCLevent([OutAttribute] out IntPtr context, [OutAttribute] out IntPtr @event, Int32 flags);

            /// <summary>[requires: ARB_cl_event]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_cl_event", Version = "", EntryPoint = "glCreateSyncFromCLeventARB")]
            public static extern IntPtr CreateSyncFromCLevent([OutAttribute] out IntPtr context, [OutAttribute] out IntPtr @event, UInt32 flags);

            /// <summary>[requires: ARB_cl_event]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_cl_event", Version = "", EntryPoint = "glCreateSyncFromCLeventARB")]
            public static extern unsafe IntPtr CreateSyncFromCLevent([OutAttribute] IntPtr* context, [OutAttribute] IntPtr* @event, Int32 flags);

            /// <summary>[requires: ARB_cl_event]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_cl_event", Version = "", EntryPoint = "glCreateSyncFromCLeventARB")]
            public static extern unsafe IntPtr CreateSyncFromCLevent([OutAttribute] IntPtr* context, [OutAttribute] IntPtr* @event, UInt32 flags);

            /// <summary>[requires: ARB_matrix_palette]</summary>
            [AutoGenerated(Category = "ARB_matrix_palette", Version = "", EntryPoint = "glCurrentPaletteMatrixARB")]
            public static extern void CurrentPaletteMatrix(Int32 index);

            /// <summary>[requires: ARB_debug_output]
            /// Specify a callback to receive debugging messages from the GL
            /// </summary>
            /// <param name="callback">
            /// <para>
            /// The address of a callback function that will be called when a debug message is generated.
            /// </para>
            /// </param>
            /// <param name="userParam">
            /// <para>
            /// A user supplied pointer that will be passed on each invocation of callback.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_debug_output", Version = "", EntryPoint = "glDebugMessageCallbackARB")]
            public static extern void DebugMessageCallback(DebugProcArb callback, IntPtr userParam);

            /// <summary>[requires: ARB_debug_output]
            /// Specify a callback to receive debugging messages from the GL
            /// </summary>
            /// <param name="callback">
            /// <para>
            /// The address of a callback function that will be called when a debug message is generated.
            /// </para>
            /// </param>
            /// <param name="userParam">
            /// <para>
            /// A user supplied pointer that will be passed on each invocation of callback.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_debug_output", Version = "", EntryPoint = "glDebugMessageCallbackARB")]
            public static extern void DebugMessageCallback<T1>(DebugProcArb callback, [InAttribute, OutAttribute] T1[] userParam)
                where T1 : struct
            ;

            /// <summary>[requires: ARB_debug_output]
            /// Specify a callback to receive debugging messages from the GL
            /// </summary>
            /// <param name="callback">
            /// <para>
            /// The address of a callback function that will be called when a debug message is generated.
            /// </para>
            /// </param>
            /// <param name="userParam">
            /// <para>
            /// A user supplied pointer that will be passed on each invocation of callback.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_debug_output", Version = "", EntryPoint = "glDebugMessageCallbackARB")]
            public static extern void DebugMessageCallback<T1>(DebugProcArb callback, [InAttribute, OutAttribute] T1[,] userParam)
                where T1 : struct
            ;

            /// <summary>[requires: ARB_debug_output]
            /// Specify a callback to receive debugging messages from the GL
            /// </summary>
            /// <param name="callback">
            /// <para>
            /// The address of a callback function that will be called when a debug message is generated.
            /// </para>
            /// </param>
            /// <param name="userParam">
            /// <para>
            /// A user supplied pointer that will be passed on each invocation of callback.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_debug_output", Version = "", EntryPoint = "glDebugMessageCallbackARB")]
            public static extern void DebugMessageCallback<T1>(DebugProcArb callback, [InAttribute, OutAttribute] T1[,,] userParam)
                where T1 : struct
            ;

            /// <summary>[requires: ARB_debug_output]
            /// Specify a callback to receive debugging messages from the GL
            /// </summary>
            /// <param name="callback">
            /// <para>
            /// The address of a callback function that will be called when a debug message is generated.
            /// </para>
            /// </param>
            /// <param name="userParam">
            /// <para>
            /// A user supplied pointer that will be passed on each invocation of callback.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_debug_output", Version = "", EntryPoint = "glDebugMessageCallbackARB")]
            public static extern void DebugMessageCallback<T1>(DebugProcArb callback, [InAttribute, OutAttribute] ref T1 userParam)
                where T1 : struct
            ;

            /// <summary>[requires: ARB_debug_output]
            /// Control the reporting of debug messages in a debug context
            /// </summary>
            /// <param name="source">
            /// <para>
            /// The source of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="severity">
            /// <para>
            /// The severity of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// The length of the array ids.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// The address of an array of unsigned integers contianing the ids of the messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="enabled">
            /// <para>
            /// A Boolean flag determining whether the selected messages should be enabled or disabled.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_debug_output", Version = "", EntryPoint = "glDebugMessageControlARB")]
            public static extern void DebugMessageControl(OpenTK.Graphics.OpenGL.ArbDebugOutput source, OpenTK.Graphics.OpenGL.ArbDebugOutput type, OpenTK.Graphics.OpenGL.ArbDebugOutput severity, Int32 count, Int32[] ids, bool enabled);

            /// <summary>[requires: ARB_debug_output]
            /// Control the reporting of debug messages in a debug context
            /// </summary>
            /// <param name="source">
            /// <para>
            /// The source of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="severity">
            /// <para>
            /// The severity of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// The length of the array ids.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// The address of an array of unsigned integers contianing the ids of the messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="enabled">
            /// <para>
            /// A Boolean flag determining whether the selected messages should be enabled or disabled.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_debug_output", Version = "", EntryPoint = "glDebugMessageControlARB")]
            public static extern void DebugMessageControl(OpenTK.Graphics.OpenGL.ArbDebugOutput source, OpenTK.Graphics.OpenGL.ArbDebugOutput type, OpenTK.Graphics.OpenGL.ArbDebugOutput severity, Int32 count, ref Int32 ids, bool enabled);

            /// <summary>[requires: ARB_debug_output]
            /// Control the reporting of debug messages in a debug context
            /// </summary>
            /// <param name="source">
            /// <para>
            /// The source of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="severity">
            /// <para>
            /// The severity of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// The length of the array ids.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// The address of an array of unsigned integers contianing the ids of the messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="enabled">
            /// <para>
            /// A Boolean flag determining whether the selected messages should be enabled or disabled.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_debug_output", Version = "", EntryPoint = "glDebugMessageControlARB")]
            public static extern unsafe void DebugMessageControl(OpenTK.Graphics.OpenGL.ArbDebugOutput source, OpenTK.Graphics.OpenGL.ArbDebugOutput type, OpenTK.Graphics.OpenGL.ArbDebugOutput severity, Int32 count, Int32* ids, bool enabled);

            /// <summary>[requires: ARB_debug_output]
            /// Control the reporting of debug messages in a debug context
            /// </summary>
            /// <param name="source">
            /// <para>
            /// The source of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="severity">
            /// <para>
            /// The severity of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// The length of the array ids.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// The address of an array of unsigned integers contianing the ids of the messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="enabled">
            /// <para>
            /// A Boolean flag determining whether the selected messages should be enabled or disabled.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_debug_output", Version = "", EntryPoint = "glDebugMessageControlARB")]
            public static extern void DebugMessageControl(OpenTK.Graphics.OpenGL.ArbDebugOutput source, OpenTK.Graphics.OpenGL.ArbDebugOutput type, OpenTK.Graphics.OpenGL.ArbDebugOutput severity, Int32 count, UInt32[] ids, bool enabled);

            /// <summary>[requires: ARB_debug_output]
            /// Control the reporting of debug messages in a debug context
            /// </summary>
            /// <param name="source">
            /// <para>
            /// The source of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="severity">
            /// <para>
            /// The severity of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// The length of the array ids.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// The address of an array of unsigned integers contianing the ids of the messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="enabled">
            /// <para>
            /// A Boolean flag determining whether the selected messages should be enabled or disabled.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_debug_output", Version = "", EntryPoint = "glDebugMessageControlARB")]
            public static extern void DebugMessageControl(OpenTK.Graphics.OpenGL.ArbDebugOutput source, OpenTK.Graphics.OpenGL.ArbDebugOutput type, OpenTK.Graphics.OpenGL.ArbDebugOutput severity, Int32 count, ref UInt32 ids, bool enabled);

            /// <summary>[requires: ARB_debug_output]
            /// Control the reporting of debug messages in a debug context
            /// </summary>
            /// <param name="source">
            /// <para>
            /// The source of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="severity">
            /// <para>
            /// The severity of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// The length of the array ids.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// The address of an array of unsigned integers contianing the ids of the messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="enabled">
            /// <para>
            /// A Boolean flag determining whether the selected messages should be enabled or disabled.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_debug_output", Version = "", EntryPoint = "glDebugMessageControlARB")]
            public static extern unsafe void DebugMessageControl(OpenTK.Graphics.OpenGL.ArbDebugOutput source, OpenTK.Graphics.OpenGL.ArbDebugOutput type, OpenTK.Graphics.OpenGL.ArbDebugOutput severity, Int32 count, UInt32* ids, bool enabled);

            /// <summary>[requires: ARB_debug_output]
            /// Inject an application-supplied message into the debug message queue
            /// </summary>
            /// <param name="source">
            /// <para>
            /// The source of the debug message to insert.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the debug message insert.
            /// </para>
            /// </param>
            /// <param name="id">
            /// <para>
            /// The user-supplied identifier of the message to insert.
            /// </para>
            /// </param>
            /// <param name="severity">
            /// <para>
            /// The severity of the debug messages to insert.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The length string contained in the character array whose address is given by message.
            /// </para>
            /// </param>
            /// <param name="message">
            /// <para>
            /// The address of a character array containing the message to insert.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_debug_output", Version = "", EntryPoint = "glDebugMessageInsertARB")]
            public static extern void DebugMessageInsert(OpenTK.Graphics.OpenGL.ArbDebugOutput source, OpenTK.Graphics.OpenGL.ArbDebugOutput type, Int32 id, OpenTK.Graphics.OpenGL.ArbDebugOutput severity, Int32 length, String buf);

            /// <summary>[requires: ARB_debug_output]
            /// Inject an application-supplied message into the debug message queue
            /// </summary>
            /// <param name="source">
            /// <para>
            /// The source of the debug message to insert.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the debug message insert.
            /// </para>
            /// </param>
            /// <param name="id">
            /// <para>
            /// The user-supplied identifier of the message to insert.
            /// </para>
            /// </param>
            /// <param name="severity">
            /// <para>
            /// The severity of the debug messages to insert.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The length string contained in the character array whose address is given by message.
            /// </para>
            /// </param>
            /// <param name="message">
            /// <para>
            /// The address of a character array containing the message to insert.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_debug_output", Version = "", EntryPoint = "glDebugMessageInsertARB")]
            public static extern void DebugMessageInsert(OpenTK.Graphics.OpenGL.ArbDebugOutput source, OpenTK.Graphics.OpenGL.ArbDebugOutput type, UInt32 id, OpenTK.Graphics.OpenGL.ArbDebugOutput severity, Int32 length, String buf);

            /// <summary>[requires: ARB_vertex_buffer_object]</summary>
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glDeleteBuffersARB")]
            public static extern void DeleteBuffer(Int32 buffers);

            /// <summary>[requires: ARB_vertex_buffer_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glDeleteBuffersARB")]
            public static extern void DeleteBuffer(UInt32 buffers);

            /// <summary>[requires: ARB_vertex_buffer_object]
            /// Delete named buffer objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of buffer objects to be deleted.
            /// </para>
            /// </param>
            /// <param name="buffers">
            /// <para>
            /// Specifies an array of buffer objects to be deleted.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glDeleteBuffersARB")]
            public static extern void DeleteBuffers(Int32 n, Int32[] buffers);

            /// <summary>[requires: ARB_vertex_buffer_object]
            /// Delete named buffer objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of buffer objects to be deleted.
            /// </para>
            /// </param>
            /// <param name="buffers">
            /// <para>
            /// Specifies an array of buffer objects to be deleted.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glDeleteBuffersARB")]
            public static extern void DeleteBuffers(Int32 n, ref Int32 buffers);

            /// <summary>[requires: ARB_vertex_buffer_object]
            /// Delete named buffer objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of buffer objects to be deleted.
            /// </para>
            /// </param>
            /// <param name="buffers">
            /// <para>
            /// Specifies an array of buffer objects to be deleted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glDeleteBuffersARB")]
            public static extern unsafe void DeleteBuffers(Int32 n, Int32* buffers);

            /// <summary>[requires: ARB_vertex_buffer_object]
            /// Delete named buffer objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of buffer objects to be deleted.
            /// </para>
            /// </param>
            /// <param name="buffers">
            /// <para>
            /// Specifies an array of buffer objects to be deleted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glDeleteBuffersARB")]
            public static extern void DeleteBuffers(Int32 n, UInt32[] buffers);

            /// <summary>[requires: ARB_vertex_buffer_object]
            /// Delete named buffer objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of buffer objects to be deleted.
            /// </para>
            /// </param>
            /// <param name="buffers">
            /// <para>
            /// Specifies an array of buffer objects to be deleted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glDeleteBuffersARB")]
            public static extern void DeleteBuffers(Int32 n, ref UInt32 buffers);

            /// <summary>[requires: ARB_vertex_buffer_object]
            /// Delete named buffer objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of buffer objects to be deleted.
            /// </para>
            /// </param>
            /// <param name="buffers">
            /// <para>
            /// Specifies an array of buffer objects to be deleted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glDeleteBuffersARB")]
            public static extern unsafe void DeleteBuffers(Int32 n, UInt32* buffers);

            /// <summary>[requires: ARB_shading_language_include]</summary>
            [AutoGenerated(Category = "ARB_shading_language_include", Version = "", EntryPoint = "glDeleteNamedStringARB")]
            public static extern void DeleteNamedString(Int32 namelen, String name);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glDeleteObjectARB")]
            public static extern void DeleteObject(Int32 obj);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glDeleteObjectARB")]
            public static extern void DeleteObject(UInt32 obj);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]
            /// Deletes a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be deleted.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glDeleteProgramsARB")]
            public static extern void DeleteProgram(Int32 programs);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]
            /// Deletes a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be deleted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glDeleteProgramsARB")]
            public static extern void DeleteProgram(UInt32 programs);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]
            /// Deletes a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be deleted.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glDeleteProgramsARB")]
            public static extern void DeleteProgram(Int32 n, Int32[] programs);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]
            /// Deletes a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be deleted.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glDeleteProgramsARB")]
            public static extern void DeleteProgram(Int32 n, ref Int32 programs);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]
            /// Deletes a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be deleted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glDeleteProgramsARB")]
            public static extern unsafe void DeleteProgram(Int32 n, Int32* programs);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]
            /// Deletes a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be deleted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glDeleteProgramsARB")]
            public static extern void DeleteProgram(Int32 n, UInt32[] programs);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]
            /// Deletes a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be deleted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glDeleteProgramsARB")]
            public static extern void DeleteProgram(Int32 n, ref UInt32 programs);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]
            /// Deletes a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be deleted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glDeleteProgramsARB")]
            public static extern unsafe void DeleteProgram(Int32 n, UInt32* programs);

            /// <summary>[requires: ARB_occlusion_query]</summary>
            [AutoGenerated(Category = "ARB_occlusion_query", Version = "", EntryPoint = "glDeleteQueriesARB")]
            public static extern void DeleteQuery(Int32 ids);

            /// <summary>[requires: ARB_occlusion_query]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_occlusion_query", Version = "", EntryPoint = "glDeleteQueriesARB")]
            public static extern void DeleteQuery(UInt32 ids);

            /// <summary>[requires: ARB_occlusion_query]
            /// Delete named query objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of query objects to be deleted.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// Specifies an array of query objects to be deleted.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_occlusion_query", Version = "", EntryPoint = "glDeleteQueriesARB")]
            public static extern void DeleteQueries(Int32 n, Int32[] ids);

            /// <summary>[requires: ARB_occlusion_query]
            /// Delete named query objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of query objects to be deleted.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// Specifies an array of query objects to be deleted.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_occlusion_query", Version = "", EntryPoint = "glDeleteQueriesARB")]
            public static extern void DeleteQueries(Int32 n, ref Int32 ids);

            /// <summary>[requires: ARB_occlusion_query]
            /// Delete named query objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of query objects to be deleted.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// Specifies an array of query objects to be deleted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_occlusion_query", Version = "", EntryPoint = "glDeleteQueriesARB")]
            public static extern unsafe void DeleteQueries(Int32 n, Int32* ids);

            /// <summary>[requires: ARB_occlusion_query]
            /// Delete named query objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of query objects to be deleted.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// Specifies an array of query objects to be deleted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_occlusion_query", Version = "", EntryPoint = "glDeleteQueriesARB")]
            public static extern void DeleteQueries(Int32 n, UInt32[] ids);

            /// <summary>[requires: ARB_occlusion_query]
            /// Delete named query objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of query objects to be deleted.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// Specifies an array of query objects to be deleted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_occlusion_query", Version = "", EntryPoint = "glDeleteQueriesARB")]
            public static extern void DeleteQueries(Int32 n, ref UInt32 ids);

            /// <summary>[requires: ARB_occlusion_query]
            /// Delete named query objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of query objects to be deleted.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// Specifies an array of query objects to be deleted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_occlusion_query", Version = "", EntryPoint = "glDeleteQueriesARB")]
            public static extern unsafe void DeleteQueries(Int32 n, UInt32* ids);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glDetachObjectARB")]
            public static extern void DetachObject(Int32 containerObj, Int32 attachedObj);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glDetachObjectARB")]
            public static extern void DetachObject(UInt32 containerObj, UInt32 attachedObj);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glDisableVertexAttribArrayARB")]
            public static extern void DisableVertexAttribArray(Int32 index);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glDisableVertexAttribArrayARB")]
            public static extern void DisableVertexAttribArray(UInt32 index);

            /// <summary>[requires: ARB_compute_variable_group_size]</summary>
            [AutoGenerated(Category = "ARB_compute_variable_group_size", Version = "", EntryPoint = "glDispatchComputeGroupSizeARB")]
            public static extern void DispatchComputeGroupSize(Int32 num_groups_x, Int32 num_groups_y, Int32 num_groups_z, Int32 group_size_x, Int32 group_size_y, Int32 group_size_z);

            /// <summary>[requires: ARB_compute_variable_group_size]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_compute_variable_group_size", Version = "", EntryPoint = "glDispatchComputeGroupSizeARB")]
            public static extern void DispatchComputeGroupSize(UInt32 num_groups_x, UInt32 num_groups_y, UInt32 num_groups_z, UInt32 group_size_x, UInt32 group_size_y, UInt32 group_size_z);

            /// <summary>[requires: ARB_draw_instanced]
            /// Draw multiple instances of a range of elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="first">
            /// <para>
            /// Specifies the starting index in the enabled arrays.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of indices to be rendered.
            /// </para>
            /// </param>
            /// <param name="primcount">
            /// <para>
            /// Specifies the number of instances of the specified range of indices to be rendered.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "ARB_draw_instanced", Version = "", EntryPoint = "glDrawArraysInstancedARB")]
            public static extern void DrawArraysInstanced(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 first, Int32 count, Int32 primcount);

            /// <summary>[requires: ARB_draw_instanced]
            /// Draw multiple instances of a range of elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="first">
            /// <para>
            /// Specifies the starting index in the enabled arrays.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of indices to be rendered.
            /// </para>
            /// </param>
            /// <param name="primcount">
            /// <para>
            /// Specifies the number of instances of the specified range of indices to be rendered.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_draw_instanced", Version = "", EntryPoint = "glDrawArraysInstancedARB")]
            public static extern void DrawArraysInstanced(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 first, Int32 count, Int32 primcount);

            /// <summary>[requires: ARB_draw_buffers]
            /// Specifies a list of color buffers to be drawn into
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of buffers in bufs.
            /// </para>
            /// </param>
            /// <param name="bufs">
            /// <para>
            /// Points to an array of symbolic constants specifying the buffers into which fragment colors or data values will be written.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_draw_buffers", Version = "", EntryPoint = "glDrawBuffersARB")]
            public static extern void DrawBuffers(Int32 n, OpenTK.Graphics.OpenGL.ArbDrawBuffers[] bufs);

            /// <summary>[requires: ARB_draw_buffers]
            /// Specifies a list of color buffers to be drawn into
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of buffers in bufs.
            /// </para>
            /// </param>
            /// <param name="bufs">
            /// <para>
            /// Points to an array of symbolic constants specifying the buffers into which fragment colors or data values will be written.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_draw_buffers", Version = "", EntryPoint = "glDrawBuffersARB")]
            public static extern void DrawBuffers(Int32 n, ref OpenTK.Graphics.OpenGL.ArbDrawBuffers bufs);

            /// <summary>[requires: ARB_draw_buffers]
            /// Specifies a list of color buffers to be drawn into
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of buffers in bufs.
            /// </para>
            /// </param>
            /// <param name="bufs">
            /// <para>
            /// Points to an array of symbolic constants specifying the buffers into which fragment colors or data values will be written.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_draw_buffers", Version = "", EntryPoint = "glDrawBuffersARB")]
            public static extern unsafe void DrawBuffers(Int32 n, OpenTK.Graphics.OpenGL.ArbDrawBuffers* bufs);

            /// <summary>[requires: ARB_draw_instanced]
            /// Draw multiple instances of a set of elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="primcount">
            /// <para>
            /// Specifies the number of instances of the specified range of indices to be rendered.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "ARB_draw_instanced", Version = "", EntryPoint = "glDrawElementsInstancedARB")]
            public static extern void DrawElementsInstanced(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 primcount);

            /// <summary>[requires: ARB_draw_instanced]
            /// Draw multiple instances of a set of elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="primcount">
            /// <para>
            /// Specifies the number of instances of the specified range of indices to be rendered.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "ARB_draw_instanced", Version = "", EntryPoint = "glDrawElementsInstancedARB")]
            public static extern void DrawElementsInstanced<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_draw_instanced]
            /// Draw multiple instances of a set of elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="primcount">
            /// <para>
            /// Specifies the number of instances of the specified range of indices to be rendered.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "ARB_draw_instanced", Version = "", EntryPoint = "glDrawElementsInstancedARB")]
            public static extern void DrawElementsInstanced<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_draw_instanced]
            /// Draw multiple instances of a set of elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="primcount">
            /// <para>
            /// Specifies the number of instances of the specified range of indices to be rendered.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "ARB_draw_instanced", Version = "", EntryPoint = "glDrawElementsInstancedARB")]
            public static extern void DrawElementsInstanced<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_draw_instanced]
            /// Draw multiple instances of a set of elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="primcount">
            /// <para>
            /// Specifies the number of instances of the specified range of indices to be rendered.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "ARB_draw_instanced", Version = "", EntryPoint = "glDrawElementsInstancedARB")]
            public static extern void DrawElementsInstanced<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_draw_instanced]
            /// Draw multiple instances of a set of elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="primcount">
            /// <para>
            /// Specifies the number of instances of the specified range of indices to be rendered.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_draw_instanced", Version = "", EntryPoint = "glDrawElementsInstancedARB")]
            public static extern void DrawElementsInstanced(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 primcount);

            /// <summary>[requires: ARB_draw_instanced]
            /// Draw multiple instances of a set of elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="primcount">
            /// <para>
            /// Specifies the number of instances of the specified range of indices to be rendered.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_draw_instanced", Version = "", EntryPoint = "glDrawElementsInstancedARB")]
            public static extern void DrawElementsInstanced<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_draw_instanced]
            /// Draw multiple instances of a set of elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="primcount">
            /// <para>
            /// Specifies the number of instances of the specified range of indices to be rendered.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_draw_instanced", Version = "", EntryPoint = "glDrawElementsInstancedARB")]
            public static extern void DrawElementsInstanced<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_draw_instanced]
            /// Draw multiple instances of a set of elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="primcount">
            /// <para>
            /// Specifies the number of instances of the specified range of indices to be rendered.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_draw_instanced", Version = "", EntryPoint = "glDrawElementsInstancedARB")]
            public static extern void DrawElementsInstanced<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_draw_instanced]
            /// Draw multiple instances of a set of elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="primcount">
            /// <para>
            /// Specifies the number of instances of the specified range of indices to be rendered.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_draw_instanced", Version = "", EntryPoint = "glDrawElementsInstancedARB")]
            public static extern void DrawElementsInstanced<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Enable or disable a generic vertex attribute array
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be enabled or disabled.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glEnableVertexAttribArrayARB")]
            public static extern void EnableVertexAttribArray(Int32 index);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Enable or disable a generic vertex attribute array
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be enabled or disabled.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glEnableVertexAttribArrayARB")]
            public static extern void EnableVertexAttribArray(UInt32 index);

            /// <summary>[requires: ARB_occlusion_query]</summary>
            [AutoGenerated(Category = "ARB_occlusion_query", Version = "", EntryPoint = "glEndQueryARB")]
            public static extern void EndQuery(OpenTK.Graphics.OpenGL.ArbOcclusionQuery target);

            /// <summary>[requires: ARB_geometry_shader4]
            /// Attach a level of a texture object as a logical buffer to the currently bound framebuffer object
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the framebuffer target. target must be GL_DRAW_FRAMEBUFFER, GL_READ_FRAMEBUFFER, or GL_FRAMEBUFFER. GL_FRAMEBUFFER is equivalent to GL_DRAW_FRAMEBUFFER.
            /// </para>
            /// </param>
            /// <param name="attachment">
            /// <para>
            /// Specifies the attachment point of the framebuffer. attachment must be GL_COLOR_ATTACHMENTi, GL_DEPTH_ATTACHMENT, GL_STENCIL_ATTACHMENT or GL_DEPTH_STENCIL_ATTACHMENT.
            /// </para>
            /// </param>
            /// <param name="textarget">
            /// <para>
            /// For glFramebufferTexture1D, glFramebufferTexture2D and glFramebufferTexture3D, specifies what type of texture is expected in the texture parameter, or for cube map textures, which face is to be attached.
            /// </para>
            /// </param>
            /// <param name="texture">
            /// <para>
            /// Specifies the texture object to attach to the framebuffer attachment point named by attachment.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the mipmap level of texture to attach.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_geometry_shader4", Version = "", EntryPoint = "glFramebufferTextureARB")]
            public static extern void FramebufferTexture(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, Int32 texture, Int32 level);

            /// <summary>[requires: ARB_geometry_shader4]
            /// Attach a level of a texture object as a logical buffer to the currently bound framebuffer object
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the framebuffer target. target must be GL_DRAW_FRAMEBUFFER, GL_READ_FRAMEBUFFER, or GL_FRAMEBUFFER. GL_FRAMEBUFFER is equivalent to GL_DRAW_FRAMEBUFFER.
            /// </para>
            /// </param>
            /// <param name="attachment">
            /// <para>
            /// Specifies the attachment point of the framebuffer. attachment must be GL_COLOR_ATTACHMENTi, GL_DEPTH_ATTACHMENT, GL_STENCIL_ATTACHMENT or GL_DEPTH_STENCIL_ATTACHMENT.
            /// </para>
            /// </param>
            /// <param name="textarget">
            /// <para>
            /// For glFramebufferTexture1D, glFramebufferTexture2D and glFramebufferTexture3D, specifies what type of texture is expected in the texture parameter, or for cube map textures, which face is to be attached.
            /// </para>
            /// </param>
            /// <param name="texture">
            /// <para>
            /// Specifies the texture object to attach to the framebuffer attachment point named by attachment.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the mipmap level of texture to attach.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_geometry_shader4", Version = "", EntryPoint = "glFramebufferTextureARB")]
            public static extern void FramebufferTexture(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, UInt32 texture, Int32 level);

            /// <summary>[requires: ARB_geometry_shader4]
            /// Attach a face of a cube map texture as a logical buffer to the currently bound framebuffer
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the framebuffer target. target must be GL_DRAW_FRAMEBUFFER, GL_READ_FRAMEBUFFER, or GL_FRAMEBUFFER. GL_FRAMEBUFFER is equivalent to GL_DRAW_FRAMEBUFFER.
            /// </para>
            /// </param>
            /// <param name="attachment">
            /// <para>
            /// Specifies the attachment point of the framebuffer. attachment must be GL_COLOR_ATTACHMENTi, GL_DEPTH_ATTACHMENT, GL_STENCIL_ATTACHMENT or GL_DEPTH_STENCIL_ATTACHMMENT.
            /// </para>
            /// </param>
            /// <param name="texture">
            /// <para>
            /// Specifies the texture object to attach to the framebuffer attachment point named by attachment. texture must be the name of an existing cube-map texture.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the mipmap level of texture to attach.
            /// </para>
            /// </param>
            /// <param name="face">
            /// <para>
            /// Specifies the face of texture to attach.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_geometry_shader4", Version = "", EntryPoint = "glFramebufferTextureFaceARB")]
            public static extern void FramebufferTextureFace(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, Int32 texture, Int32 level, OpenTK.Graphics.OpenGL.TextureTarget face);

            /// <summary>[requires: ARB_geometry_shader4]
            /// Attach a face of a cube map texture as a logical buffer to the currently bound framebuffer
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the framebuffer target. target must be GL_DRAW_FRAMEBUFFER, GL_READ_FRAMEBUFFER, or GL_FRAMEBUFFER. GL_FRAMEBUFFER is equivalent to GL_DRAW_FRAMEBUFFER.
            /// </para>
            /// </param>
            /// <param name="attachment">
            /// <para>
            /// Specifies the attachment point of the framebuffer. attachment must be GL_COLOR_ATTACHMENTi, GL_DEPTH_ATTACHMENT, GL_STENCIL_ATTACHMENT or GL_DEPTH_STENCIL_ATTACHMMENT.
            /// </para>
            /// </param>
            /// <param name="texture">
            /// <para>
            /// Specifies the texture object to attach to the framebuffer attachment point named by attachment. texture must be the name of an existing cube-map texture.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the mipmap level of texture to attach.
            /// </para>
            /// </param>
            /// <param name="face">
            /// <para>
            /// Specifies the face of texture to attach.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_geometry_shader4", Version = "", EntryPoint = "glFramebufferTextureFaceARB")]
            public static extern void FramebufferTextureFace(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, UInt32 texture, Int32 level, OpenTK.Graphics.OpenGL.TextureTarget face);

            /// <summary>[requires: ARB_geometry_shader4]
            /// Attach a single layer of a texture to a framebuffer
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the framebuffer target. target must be GL_DRAW_FRAMEBUFFER, GL_READ_FRAMEBUFFER, or GL_FRAMEBUFFER. GL_FRAMEBUFFER is equivalent to GL_DRAW_FRAMEBUFFER.
            /// </para>
            /// </param>
            /// <param name="attachment">
            /// <para>
            /// Specifies the attachment point of the framebuffer. attachment must be GL_COLOR_ATTACHMENTi, GL_DEPTH_ATTACHMENT, GL_STENCIL_ATTACHMENT or GL_DEPTH_STENCIL_ATTACHMENT.
            /// </para>
            /// </param>
            /// <param name="texture">
            /// <para>
            /// Specifies the texture object to attach to the framebuffer attachment point named by attachment.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the mipmap level of texture to attach.
            /// </para>
            /// </param>
            /// <param name="layer">
            /// <para>
            /// Specifies the layer of texture to attach.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_geometry_shader4", Version = "", EntryPoint = "glFramebufferTextureLayerARB")]
            public static extern void FramebufferTextureLayer(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, Int32 texture, Int32 level, Int32 layer);

            /// <summary>[requires: ARB_geometry_shader4]
            /// Attach a single layer of a texture to a framebuffer
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the framebuffer target. target must be GL_DRAW_FRAMEBUFFER, GL_READ_FRAMEBUFFER, or GL_FRAMEBUFFER. GL_FRAMEBUFFER is equivalent to GL_DRAW_FRAMEBUFFER.
            /// </para>
            /// </param>
            /// <param name="attachment">
            /// <para>
            /// Specifies the attachment point of the framebuffer. attachment must be GL_COLOR_ATTACHMENTi, GL_DEPTH_ATTACHMENT, GL_STENCIL_ATTACHMENT or GL_DEPTH_STENCIL_ATTACHMENT.
            /// </para>
            /// </param>
            /// <param name="texture">
            /// <para>
            /// Specifies the texture object to attach to the framebuffer attachment point named by attachment.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the mipmap level of texture to attach.
            /// </para>
            /// </param>
            /// <param name="layer">
            /// <para>
            /// Specifies the layer of texture to attach.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_geometry_shader4", Version = "", EntryPoint = "glFramebufferTextureLayerARB")]
            public static extern void FramebufferTextureLayer(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, UInt32 texture, Int32 level, Int32 layer);

            /// <summary>[requires: ARB_vertex_buffer_object]</summary>
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glGenBuffersARB")]
            public static extern Int32 GenBuffer();

            /// <summary>[requires: ARB_vertex_buffer_object]
            /// Generate buffer object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of buffer object names to be generated.
            /// </para>
            /// </param>
            /// <param name="buffers">
            /// <para>
            /// Specifies an array in which the generated buffer object names are stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glGenBuffersARB")]
            public static extern void GenBuffers(Int32 n, [OutAttribute] Int32[] buffers);

            /// <summary>[requires: ARB_vertex_buffer_object]
            /// Generate buffer object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of buffer object names to be generated.
            /// </para>
            /// </param>
            /// <param name="buffers">
            /// <para>
            /// Specifies an array in which the generated buffer object names are stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glGenBuffersARB")]
            public static extern void GenBuffers(Int32 n, [OutAttribute] out Int32 buffers);

            /// <summary>[requires: ARB_vertex_buffer_object]
            /// Generate buffer object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of buffer object names to be generated.
            /// </para>
            /// </param>
            /// <param name="buffers">
            /// <para>
            /// Specifies an array in which the generated buffer object names are stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glGenBuffersARB")]
            public static extern unsafe void GenBuffers(Int32 n, [OutAttribute] Int32* buffers);

            /// <summary>[requires: ARB_vertex_buffer_object]
            /// Generate buffer object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of buffer object names to be generated.
            /// </para>
            /// </param>
            /// <param name="buffers">
            /// <para>
            /// Specifies an array in which the generated buffer object names are stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glGenBuffersARB")]
            public static extern void GenBuffers(Int32 n, [OutAttribute] UInt32[] buffers);

            /// <summary>[requires: ARB_vertex_buffer_object]
            /// Generate buffer object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of buffer object names to be generated.
            /// </para>
            /// </param>
            /// <param name="buffers">
            /// <para>
            /// Specifies an array in which the generated buffer object names are stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glGenBuffersARB")]
            public static extern void GenBuffers(Int32 n, [OutAttribute] out UInt32 buffers);

            /// <summary>[requires: ARB_vertex_buffer_object]
            /// Generate buffer object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of buffer object names to be generated.
            /// </para>
            /// </param>
            /// <param name="buffers">
            /// <para>
            /// Specifies an array in which the generated buffer object names are stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glGenBuffersARB")]
            public static extern unsafe void GenBuffers(Int32 n, [OutAttribute] UInt32* buffers);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGenProgramsARB")]
            public static extern Int32 GenProgram();

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGenProgramsARB")]
            public static extern void GenProgram(Int32 n, [OutAttribute] Int32[] programs);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGenProgramsARB")]
            public static extern void GenProgram(Int32 n, [OutAttribute] out Int32 programs);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGenProgramsARB")]
            public static extern unsafe void GenProgram(Int32 n, [OutAttribute] Int32* programs);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGenProgramsARB")]
            public static extern void GenProgram(Int32 n, [OutAttribute] UInt32[] programs);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGenProgramsARB")]
            public static extern void GenProgram(Int32 n, [OutAttribute] out UInt32 programs);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGenProgramsARB")]
            public static extern unsafe void GenProgram(Int32 n, [OutAttribute] UInt32* programs);

            /// <summary>[requires: ARB_occlusion_query]</summary>
            [AutoGenerated(Category = "ARB_occlusion_query", Version = "", EntryPoint = "glGenQueriesARB")]
            public static extern Int32 GenQuery();

            /// <summary>[requires: ARB_occlusion_query]
            /// Generate query object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of query object names to be generated.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// Specifies an array in which the generated query object names are stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_occlusion_query", Version = "", EntryPoint = "glGenQueriesARB")]
            public static extern void GenQueries(Int32 n, [OutAttribute] Int32[] ids);

            /// <summary>[requires: ARB_occlusion_query]
            /// Generate query object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of query object names to be generated.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// Specifies an array in which the generated query object names are stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_occlusion_query", Version = "", EntryPoint = "glGenQueriesARB")]
            public static extern void GenQueries(Int32 n, [OutAttribute] out Int32 ids);

            /// <summary>[requires: ARB_occlusion_query]
            /// Generate query object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of query object names to be generated.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// Specifies an array in which the generated query object names are stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_occlusion_query", Version = "", EntryPoint = "glGenQueriesARB")]
            public static extern unsafe void GenQueries(Int32 n, [OutAttribute] Int32* ids);

            /// <summary>[requires: ARB_occlusion_query]
            /// Generate query object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of query object names to be generated.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// Specifies an array in which the generated query object names are stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_occlusion_query", Version = "", EntryPoint = "glGenQueriesARB")]
            public static extern void GenQueries(Int32 n, [OutAttribute] UInt32[] ids);

            /// <summary>[requires: ARB_occlusion_query]
            /// Generate query object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of query object names to be generated.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// Specifies an array in which the generated query object names are stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_occlusion_query", Version = "", EntryPoint = "glGenQueriesARB")]
            public static extern void GenQueries(Int32 n, [OutAttribute] out UInt32 ids);

            /// <summary>[requires: ARB_occlusion_query]
            /// Generate query object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of query object names to be generated.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// Specifies an array in which the generated query object names are stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_occlusion_query", Version = "", EntryPoint = "glGenQueriesARB")]
            public static extern unsafe void GenQueries(Int32 n, [OutAttribute] UInt32* ids);

            /// <summary>[requires: ARB_vertex_shader]
            /// Returns information about an active attribute variable for the specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the attribute variable to be queried.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// Specifies the maximum number of characters OpenGL is allowed to write in the character buffer indicated by name.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// Returns the number of characters actually written by OpenGL in the string indicated by name (excluding the null terminator) if a value other than NULL is passed.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Returns the size of the attribute variable.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Returns the data type of the attribute variable.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// Returns a null terminated string containing the name of the attribute variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_shader", Version = "", EntryPoint = "glGetActiveAttribARB")]
            public static extern void GetActiveAttrib(Int32 programObj, Int32 index, Int32 maxLength, [OutAttribute] out Int32 length, [OutAttribute] out Int32 size, [OutAttribute] out OpenTK.Graphics.OpenGL.ArbVertexShader type, [OutAttribute] StringBuilder name);

            /// <summary>[requires: ARB_vertex_shader]
            /// Returns information about an active attribute variable for the specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the attribute variable to be queried.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// Specifies the maximum number of characters OpenGL is allowed to write in the character buffer indicated by name.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// Returns the number of characters actually written by OpenGL in the string indicated by name (excluding the null terminator) if a value other than NULL is passed.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Returns the size of the attribute variable.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Returns the data type of the attribute variable.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// Returns a null terminated string containing the name of the attribute variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_shader", Version = "", EntryPoint = "glGetActiveAttribARB")]
            public static extern unsafe void GetActiveAttrib(Int32 programObj, Int32 index, Int32 maxLength, [OutAttribute] Int32* length, [OutAttribute] Int32* size, [OutAttribute] OpenTK.Graphics.OpenGL.ArbVertexShader* type, [OutAttribute] StringBuilder name);

            /// <summary>[requires: ARB_vertex_shader]
            /// Returns information about an active attribute variable for the specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the attribute variable to be queried.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// Specifies the maximum number of characters OpenGL is allowed to write in the character buffer indicated by name.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// Returns the number of characters actually written by OpenGL in the string indicated by name (excluding the null terminator) if a value other than NULL is passed.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Returns the size of the attribute variable.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Returns the data type of the attribute variable.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// Returns a null terminated string containing the name of the attribute variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_shader", Version = "", EntryPoint = "glGetActiveAttribARB")]
            public static extern void GetActiveAttrib(UInt32 programObj, UInt32 index, Int32 maxLength, [OutAttribute] out Int32 length, [OutAttribute] out Int32 size, [OutAttribute] out OpenTK.Graphics.OpenGL.ArbVertexShader type, [OutAttribute] StringBuilder name);

            /// <summary>[requires: ARB_vertex_shader]
            /// Returns information about an active attribute variable for the specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the attribute variable to be queried.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// Specifies the maximum number of characters OpenGL is allowed to write in the character buffer indicated by name.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// Returns the number of characters actually written by OpenGL in the string indicated by name (excluding the null terminator) if a value other than NULL is passed.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Returns the size of the attribute variable.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Returns the data type of the attribute variable.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// Returns a null terminated string containing the name of the attribute variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_shader", Version = "", EntryPoint = "glGetActiveAttribARB")]
            public static extern unsafe void GetActiveAttrib(UInt32 programObj, UInt32 index, Int32 maxLength, [OutAttribute] Int32* length, [OutAttribute] Int32* size, [OutAttribute] OpenTK.Graphics.OpenGL.ArbVertexShader* type, [OutAttribute] StringBuilder name);

            /// <summary>[requires: ARB_shader_objects]
            /// Returns information about an active uniform variable for the specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the uniform variable to be queried.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// Specifies the maximum number of characters OpenGL is allowed to write in the character buffer indicated by name.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// Returns the number of characters actually written by OpenGL in the string indicated by name (excluding the null terminator) if a value other than NULL is passed.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Returns the size of the uniform variable.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Returns the data type of the uniform variable.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// Returns a null terminated string containing the name of the uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetActiveUniformARB")]
            public static extern void GetActiveUniform(Int32 programObj, Int32 index, Int32 maxLength, [OutAttribute] out Int32 length, [OutAttribute] out Int32 size, [OutAttribute] out OpenTK.Graphics.OpenGL.ArbShaderObjects type, [OutAttribute] StringBuilder name);

            /// <summary>[requires: ARB_shader_objects]
            /// Returns information about an active uniform variable for the specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the uniform variable to be queried.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// Specifies the maximum number of characters OpenGL is allowed to write in the character buffer indicated by name.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// Returns the number of characters actually written by OpenGL in the string indicated by name (excluding the null terminator) if a value other than NULL is passed.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Returns the size of the uniform variable.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Returns the data type of the uniform variable.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// Returns a null terminated string containing the name of the uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetActiveUniformARB")]
            public static extern unsafe void GetActiveUniform(Int32 programObj, Int32 index, Int32 maxLength, [OutAttribute] Int32* length, [OutAttribute] Int32* size, [OutAttribute] OpenTK.Graphics.OpenGL.ArbShaderObjects* type, [OutAttribute] StringBuilder name);

            /// <summary>[requires: ARB_shader_objects]
            /// Returns information about an active uniform variable for the specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the uniform variable to be queried.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// Specifies the maximum number of characters OpenGL is allowed to write in the character buffer indicated by name.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// Returns the number of characters actually written by OpenGL in the string indicated by name (excluding the null terminator) if a value other than NULL is passed.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Returns the size of the uniform variable.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Returns the data type of the uniform variable.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// Returns a null terminated string containing the name of the uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetActiveUniformARB")]
            public static extern void GetActiveUniform(UInt32 programObj, UInt32 index, Int32 maxLength, [OutAttribute] out Int32 length, [OutAttribute] out Int32 size, [OutAttribute] out OpenTK.Graphics.OpenGL.ArbShaderObjects type, [OutAttribute] StringBuilder name);

            /// <summary>[requires: ARB_shader_objects]
            /// Returns information about an active uniform variable for the specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the uniform variable to be queried.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// Specifies the maximum number of characters OpenGL is allowed to write in the character buffer indicated by name.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// Returns the number of characters actually written by OpenGL in the string indicated by name (excluding the null terminator) if a value other than NULL is passed.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Returns the size of the uniform variable.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Returns the data type of the uniform variable.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// Returns a null terminated string containing the name of the uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetActiveUniformARB")]
            public static extern unsafe void GetActiveUniform(UInt32 programObj, UInt32 index, Int32 maxLength, [OutAttribute] Int32* length, [OutAttribute] Int32* size, [OutAttribute] OpenTK.Graphics.OpenGL.ArbShaderObjects* type, [OutAttribute] StringBuilder name);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetAttachedObjectsARB")]
            public static extern void GetAttachedObjects(Int32 containerObj, Int32 maxCount, [OutAttribute] out Int32 count, [OutAttribute] Int32[] obj);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetAttachedObjectsARB")]
            public static extern void GetAttachedObjects(Int32 containerObj, Int32 maxCount, [OutAttribute] out Int32 count, [OutAttribute] out Int32 obj);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetAttachedObjectsARB")]
            public static extern unsafe void GetAttachedObjects(Int32 containerObj, Int32 maxCount, [OutAttribute] Int32* count, [OutAttribute] Int32* obj);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetAttachedObjectsARB")]
            public static extern void GetAttachedObjects(UInt32 containerObj, Int32 maxCount, [OutAttribute] out Int32 count, [OutAttribute] UInt32[] obj);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetAttachedObjectsARB")]
            public static extern void GetAttachedObjects(UInt32 containerObj, Int32 maxCount, [OutAttribute] out Int32 count, [OutAttribute] out UInt32 obj);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetAttachedObjectsARB")]
            public static extern unsafe void GetAttachedObjects(UInt32 containerObj, Int32 maxCount, [OutAttribute] Int32* count, [OutAttribute] UInt32* obj);

            /// <summary>[requires: ARB_vertex_shader]
            /// Returns the location of an attribute variable
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// Points to a null terminated string containing the name of the attribute variable whose location is to be queried.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_shader", Version = "", EntryPoint = "glGetAttribLocationARB")]
            public static extern Int32 GetAttribLocation(Int32 programObj, String name);

            /// <summary>[requires: ARB_vertex_shader]
            /// Returns the location of an attribute variable
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// Points to a null terminated string containing the name of the attribute variable whose location is to be queried.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_shader", Version = "", EntryPoint = "glGetAttribLocationARB")]
            public static extern Int32 GetAttribLocation(UInt32 programObj, String name);

            /// <summary>[requires: ARB_vertex_buffer_object]
            /// Return parameters of a buffer object
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// Specifies the symbolic name of a buffer object parameter. Accepted values are GL_BUFFER_ACCESS, GL_BUFFER_MAPPED, GL_BUFFER_SIZE, or GL_BUFFER_USAGE.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Returns the requested parameter.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glGetBufferParameterivARB")]
            public static extern void GetBufferParameter(OpenTK.Graphics.OpenGL.ArbVertexBufferObject target, OpenTK.Graphics.OpenGL.BufferParameterNameArb pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: ARB_vertex_buffer_object]
            /// Return parameters of a buffer object
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// Specifies the symbolic name of a buffer object parameter. Accepted values are GL_BUFFER_ACCESS, GL_BUFFER_MAPPED, GL_BUFFER_SIZE, or GL_BUFFER_USAGE.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Returns the requested parameter.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glGetBufferParameterivARB")]
            public static extern void GetBufferParameter(OpenTK.Graphics.OpenGL.ArbVertexBufferObject target, OpenTK.Graphics.OpenGL.BufferParameterNameArb pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: ARB_vertex_buffer_object]
            /// Return parameters of a buffer object
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// Specifies the symbolic name of a buffer object parameter. Accepted values are GL_BUFFER_ACCESS, GL_BUFFER_MAPPED, GL_BUFFER_SIZE, or GL_BUFFER_USAGE.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Returns the requested parameter.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glGetBufferParameterivARB")]
            public static extern unsafe void GetBufferParameter(OpenTK.Graphics.OpenGL.ArbVertexBufferObject target, OpenTK.Graphics.OpenGL.BufferParameterNameArb pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: ARB_vertex_buffer_object]</summary>
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glGetBufferPointervARB")]
            public static extern void GetBufferPointer(OpenTK.Graphics.OpenGL.ArbVertexBufferObject target, OpenTK.Graphics.OpenGL.BufferPointerNameArb pname, [OutAttribute] IntPtr @params);

            /// <summary>[requires: ARB_vertex_buffer_object]</summary>
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glGetBufferPointervARB")]
            public static extern void GetBufferPointer<T2>(OpenTK.Graphics.OpenGL.ArbVertexBufferObject target, OpenTK.Graphics.OpenGL.BufferPointerNameArb pname, [InAttribute, OutAttribute] T2[] @params)
                where T2 : struct
            ;

            /// <summary>[requires: ARB_vertex_buffer_object]</summary>
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glGetBufferPointervARB")]
            public static extern void GetBufferPointer<T2>(OpenTK.Graphics.OpenGL.ArbVertexBufferObject target, OpenTK.Graphics.OpenGL.BufferPointerNameArb pname, [InAttribute, OutAttribute] T2[,] @params)
                where T2 : struct
            ;

            /// <summary>[requires: ARB_vertex_buffer_object]</summary>
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glGetBufferPointervARB")]
            public static extern void GetBufferPointer<T2>(OpenTK.Graphics.OpenGL.ArbVertexBufferObject target, OpenTK.Graphics.OpenGL.BufferPointerNameArb pname, [InAttribute, OutAttribute] T2[,,] @params)
                where T2 : struct
            ;

            /// <summary>[requires: ARB_vertex_buffer_object]</summary>
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glGetBufferPointervARB")]
            public static extern void GetBufferPointer<T2>(OpenTK.Graphics.OpenGL.ArbVertexBufferObject target, OpenTK.Graphics.OpenGL.BufferPointerNameArb pname, [InAttribute, OutAttribute] ref T2 @params)
                where T2 : struct
            ;

            /// <summary>[requires: ARB_vertex_buffer_object]
            /// Returns a subset of a buffer object's data store
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_RESULT_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
            /// </para>
            /// </param>
            /// <param name="offset">
            /// <para>
            /// Specifies the offset into the buffer object's data store from which data will be returned, measured in bytes.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Specifies the size in bytes of the data store region being returned.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the location where buffer object data is returned.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glGetBufferSubDataARB")]
            public static extern void GetBufferSubData(OpenTK.Graphics.OpenGL.BufferTargetArb target, IntPtr offset, IntPtr size, [OutAttribute] IntPtr data);

            /// <summary>[requires: ARB_vertex_buffer_object]
            /// Returns a subset of a buffer object's data store
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_RESULT_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
            /// </para>
            /// </param>
            /// <param name="offset">
            /// <para>
            /// Specifies the offset into the buffer object's data store from which data will be returned, measured in bytes.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Specifies the size in bytes of the data store region being returned.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the location where buffer object data is returned.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glGetBufferSubDataARB")]
            public static extern void GetBufferSubData<T3>(OpenTK.Graphics.OpenGL.BufferTargetArb target, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] T3[] data)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_vertex_buffer_object]
            /// Returns a subset of a buffer object's data store
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_RESULT_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
            /// </para>
            /// </param>
            /// <param name="offset">
            /// <para>
            /// Specifies the offset into the buffer object's data store from which data will be returned, measured in bytes.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Specifies the size in bytes of the data store region being returned.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the location where buffer object data is returned.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glGetBufferSubDataARB")]
            public static extern void GetBufferSubData<T3>(OpenTK.Graphics.OpenGL.BufferTargetArb target, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] T3[,] data)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_vertex_buffer_object]
            /// Returns a subset of a buffer object's data store
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_RESULT_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
            /// </para>
            /// </param>
            /// <param name="offset">
            /// <para>
            /// Specifies the offset into the buffer object's data store from which data will be returned, measured in bytes.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Specifies the size in bytes of the data store region being returned.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the location where buffer object data is returned.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glGetBufferSubDataARB")]
            public static extern void GetBufferSubData<T3>(OpenTK.Graphics.OpenGL.BufferTargetArb target, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] T3[,,] data)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_vertex_buffer_object]
            /// Returns a subset of a buffer object's data store
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_RESULT_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
            /// </para>
            /// </param>
            /// <param name="offset">
            /// <para>
            /// Specifies the offset into the buffer object's data store from which data will be returned, measured in bytes.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Specifies the size in bytes of the data store region being returned.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the location where buffer object data is returned.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glGetBufferSubDataARB")]
            public static extern void GetBufferSubData<T3>(OpenTK.Graphics.OpenGL.BufferTargetArb target, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] ref T3 data)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_texture_compression]
            /// Return a compressed texture image
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies which texture is to be obtained. GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, and GL_TEXTURE_CUBE_MAP_NEGATIVE_Z are accepted.
            /// </para>
            /// </param>
            /// <param name="lod">
            /// <para>
            /// Specifies the level-of-detail number of the desired image. Level 0 is the base image level. Level is the th mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="img">
            /// <para>
            /// Returns the compressed texture image.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_compression", Version = "", EntryPoint = "glGetCompressedTexImageARB")]
            public static extern void GetCompressedTexImage(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, [OutAttribute] IntPtr img);

            /// <summary>[requires: ARB_texture_compression]
            /// Return a compressed texture image
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies which texture is to be obtained. GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, and GL_TEXTURE_CUBE_MAP_NEGATIVE_Z are accepted.
            /// </para>
            /// </param>
            /// <param name="lod">
            /// <para>
            /// Specifies the level-of-detail number of the desired image. Level 0 is the base image level. Level is the th mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="img">
            /// <para>
            /// Returns the compressed texture image.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_compression", Version = "", EntryPoint = "glGetCompressedTexImageARB")]
            public static extern void GetCompressedTexImage<T2>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, [InAttribute, OutAttribute] T2[] img)
                where T2 : struct
            ;

            /// <summary>[requires: ARB_texture_compression]
            /// Return a compressed texture image
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies which texture is to be obtained. GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, and GL_TEXTURE_CUBE_MAP_NEGATIVE_Z are accepted.
            /// </para>
            /// </param>
            /// <param name="lod">
            /// <para>
            /// Specifies the level-of-detail number of the desired image. Level 0 is the base image level. Level is the th mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="img">
            /// <para>
            /// Returns the compressed texture image.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_compression", Version = "", EntryPoint = "glGetCompressedTexImageARB")]
            public static extern void GetCompressedTexImage<T2>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, [InAttribute, OutAttribute] T2[,] img)
                where T2 : struct
            ;

            /// <summary>[requires: ARB_texture_compression]
            /// Return a compressed texture image
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies which texture is to be obtained. GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, and GL_TEXTURE_CUBE_MAP_NEGATIVE_Z are accepted.
            /// </para>
            /// </param>
            /// <param name="lod">
            /// <para>
            /// Specifies the level-of-detail number of the desired image. Level 0 is the base image level. Level is the th mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="img">
            /// <para>
            /// Returns the compressed texture image.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_compression", Version = "", EntryPoint = "glGetCompressedTexImageARB")]
            public static extern void GetCompressedTexImage<T2>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, [InAttribute, OutAttribute] T2[,,] img)
                where T2 : struct
            ;

            /// <summary>[requires: ARB_texture_compression]
            /// Return a compressed texture image
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies which texture is to be obtained. GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, and GL_TEXTURE_CUBE_MAP_NEGATIVE_Z are accepted.
            /// </para>
            /// </param>
            /// <param name="lod">
            /// <para>
            /// Specifies the level-of-detail number of the desired image. Level 0 is the base image level. Level is the th mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="img">
            /// <para>
            /// Returns the compressed texture image.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_compression", Version = "", EntryPoint = "glGetCompressedTexImageARB")]
            public static extern void GetCompressedTexImage<T2>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, [InAttribute, OutAttribute] ref T2 img)
                where T2 : struct
            ;

            /// <summary>[requires: ARB_debug_output]
            /// Retrieve messages from the debug message log
            /// </summary>
            /// <param name="count">
            /// <para>
            /// The number of debug messages to retrieve from the log.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The size of the buffer whose address is given by messageLog.
            /// </para>
            /// </param>
            /// <param name="sources">
            /// <para>
            /// The address of an array of variables to receive the sources of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="types">
            /// <para>
            /// The address of an array of variables to receive the types of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// The address of an array of unsigned integers to receive the ids of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="severities">
            /// <para>
            /// The address of an array of variables to receive the severites of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="lengths">
            /// <para>
            /// The address of an array of variables to receive the lengths of the received messages.
            /// </para>
            /// </param>
            /// <param name="messageLog">
            /// <para>
            /// The address of an array of characters that will receive the messages.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_debug_output", Version = "", EntryPoint = "glGetDebugMessageLogARB")]
            public static extern Int32 GetDebugMessageLog(Int32 count, Int32 bufSize, [OutAttribute] OpenTK.Graphics.OpenGL.ArbDebugOutput[] sources, [OutAttribute] OpenTK.Graphics.OpenGL.ArbDebugOutput[] types, [OutAttribute] Int32[] ids, [OutAttribute] OpenTK.Graphics.OpenGL.ArbDebugOutput[] severities, [OutAttribute] Int32[] lengths, [OutAttribute] StringBuilder messageLog);

            /// <summary>[requires: ARB_debug_output]
            /// Retrieve messages from the debug message log
            /// </summary>
            /// <param name="count">
            /// <para>
            /// The number of debug messages to retrieve from the log.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The size of the buffer whose address is given by messageLog.
            /// </para>
            /// </param>
            /// <param name="sources">
            /// <para>
            /// The address of an array of variables to receive the sources of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="types">
            /// <para>
            /// The address of an array of variables to receive the types of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// The address of an array of unsigned integers to receive the ids of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="severities">
            /// <para>
            /// The address of an array of variables to receive the severites of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="lengths">
            /// <para>
            /// The address of an array of variables to receive the lengths of the received messages.
            /// </para>
            /// </param>
            /// <param name="messageLog">
            /// <para>
            /// The address of an array of characters that will receive the messages.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_debug_output", Version = "", EntryPoint = "glGetDebugMessageLogARB")]
            public static extern Int32 GetDebugMessageLog(Int32 count, Int32 bufSize, [OutAttribute] out OpenTK.Graphics.OpenGL.ArbDebugOutput sources, [OutAttribute] out OpenTK.Graphics.OpenGL.ArbDebugOutput types, [OutAttribute] out Int32 ids, [OutAttribute] out OpenTK.Graphics.OpenGL.ArbDebugOutput severities, [OutAttribute] out Int32 lengths, [OutAttribute] StringBuilder messageLog);

            /// <summary>[requires: ARB_debug_output]
            /// Retrieve messages from the debug message log
            /// </summary>
            /// <param name="count">
            /// <para>
            /// The number of debug messages to retrieve from the log.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The size of the buffer whose address is given by messageLog.
            /// </para>
            /// </param>
            /// <param name="sources">
            /// <para>
            /// The address of an array of variables to receive the sources of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="types">
            /// <para>
            /// The address of an array of variables to receive the types of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// The address of an array of unsigned integers to receive the ids of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="severities">
            /// <para>
            /// The address of an array of variables to receive the severites of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="lengths">
            /// <para>
            /// The address of an array of variables to receive the lengths of the received messages.
            /// </para>
            /// </param>
            /// <param name="messageLog">
            /// <para>
            /// The address of an array of characters that will receive the messages.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_debug_output", Version = "", EntryPoint = "glGetDebugMessageLogARB")]
            public static extern unsafe Int32 GetDebugMessageLog(Int32 count, Int32 bufSize, [OutAttribute] OpenTK.Graphics.OpenGL.ArbDebugOutput* sources, [OutAttribute] OpenTK.Graphics.OpenGL.ArbDebugOutput* types, [OutAttribute] Int32* ids, [OutAttribute] OpenTK.Graphics.OpenGL.ArbDebugOutput* severities, [OutAttribute] Int32* lengths, [OutAttribute] StringBuilder messageLog);

            /// <summary>[requires: ARB_debug_output]
            /// Retrieve messages from the debug message log
            /// </summary>
            /// <param name="count">
            /// <para>
            /// The number of debug messages to retrieve from the log.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The size of the buffer whose address is given by messageLog.
            /// </para>
            /// </param>
            /// <param name="sources">
            /// <para>
            /// The address of an array of variables to receive the sources of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="types">
            /// <para>
            /// The address of an array of variables to receive the types of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// The address of an array of unsigned integers to receive the ids of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="severities">
            /// <para>
            /// The address of an array of variables to receive the severites of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="lengths">
            /// <para>
            /// The address of an array of variables to receive the lengths of the received messages.
            /// </para>
            /// </param>
            /// <param name="messageLog">
            /// <para>
            /// The address of an array of characters that will receive the messages.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_debug_output", Version = "", EntryPoint = "glGetDebugMessageLogARB")]
            public static extern Int32 GetDebugMessageLog(UInt32 count, Int32 bufSize, [OutAttribute] OpenTK.Graphics.OpenGL.ArbDebugOutput[] sources, [OutAttribute] OpenTK.Graphics.OpenGL.ArbDebugOutput[] types, [OutAttribute] UInt32[] ids, [OutAttribute] OpenTK.Graphics.OpenGL.ArbDebugOutput[] severities, [OutAttribute] Int32[] lengths, [OutAttribute] StringBuilder messageLog);

            /// <summary>[requires: ARB_debug_output]
            /// Retrieve messages from the debug message log
            /// </summary>
            /// <param name="count">
            /// <para>
            /// The number of debug messages to retrieve from the log.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The size of the buffer whose address is given by messageLog.
            /// </para>
            /// </param>
            /// <param name="sources">
            /// <para>
            /// The address of an array of variables to receive the sources of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="types">
            /// <para>
            /// The address of an array of variables to receive the types of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// The address of an array of unsigned integers to receive the ids of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="severities">
            /// <para>
            /// The address of an array of variables to receive the severites of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="lengths">
            /// <para>
            /// The address of an array of variables to receive the lengths of the received messages.
            /// </para>
            /// </param>
            /// <param name="messageLog">
            /// <para>
            /// The address of an array of characters that will receive the messages.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_debug_output", Version = "", EntryPoint = "glGetDebugMessageLogARB")]
            public static extern Int32 GetDebugMessageLog(UInt32 count, Int32 bufSize, [OutAttribute] out OpenTK.Graphics.OpenGL.ArbDebugOutput sources, [OutAttribute] out OpenTK.Graphics.OpenGL.ArbDebugOutput types, [OutAttribute] out UInt32 ids, [OutAttribute] out OpenTK.Graphics.OpenGL.ArbDebugOutput severities, [OutAttribute] out Int32 lengths, [OutAttribute] StringBuilder messageLog);

            /// <summary>[requires: ARB_debug_output]
            /// Retrieve messages from the debug message log
            /// </summary>
            /// <param name="count">
            /// <para>
            /// The number of debug messages to retrieve from the log.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The size of the buffer whose address is given by messageLog.
            /// </para>
            /// </param>
            /// <param name="sources">
            /// <para>
            /// The address of an array of variables to receive the sources of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="types">
            /// <para>
            /// The address of an array of variables to receive the types of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// The address of an array of unsigned integers to receive the ids of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="severities">
            /// <para>
            /// The address of an array of variables to receive the severites of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="lengths">
            /// <para>
            /// The address of an array of variables to receive the lengths of the received messages.
            /// </para>
            /// </param>
            /// <param name="messageLog">
            /// <para>
            /// The address of an array of characters that will receive the messages.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_debug_output", Version = "", EntryPoint = "glGetDebugMessageLogARB")]
            public static extern unsafe Int32 GetDebugMessageLog(UInt32 count, Int32 bufSize, [OutAttribute] OpenTK.Graphics.OpenGL.ArbDebugOutput* sources, [OutAttribute] OpenTK.Graphics.OpenGL.ArbDebugOutput* types, [OutAttribute] UInt32* ids, [OutAttribute] OpenTK.Graphics.OpenGL.ArbDebugOutput* severities, [OutAttribute] Int32* lengths, [OutAttribute] StringBuilder messageLog);

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetGraphicsResetStatusARB")]
            public static extern OpenTK.Graphics.OpenGL.ArbRobustness GetGraphicsResetStatus();

            /// <summary>[requires: ARB_shader_objects]</summary>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetHandleARB")]
            public static extern Int32 GetHandle(OpenTK.Graphics.OpenGL.ArbShaderObjects pname);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glGetImageHandleARB")]
            public static extern Int64 GetImageHandle(Int32 texture, Int32 level, bool layered, Int32 layer, OpenTK.Graphics.OpenGL.ArbBindlessTexture format);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glGetImageHandleARB")]
            public static extern Int64 GetImageHandle(UInt32 texture, Int32 level, bool layered, Int32 layer, OpenTK.Graphics.OpenGL.ArbBindlessTexture format);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetInfoLogARB")]
            public static extern void GetInfoLog(Int32 obj, Int32 maxLength, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder infoLog);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetInfoLogARB")]
            public static extern unsafe void GetInfoLog(Int32 obj, Int32 maxLength, [OutAttribute] Int32* length, [OutAttribute] StringBuilder infoLog);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetInfoLogARB")]
            public static extern void GetInfoLog(UInt32 obj, Int32 maxLength, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder infoLog);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetInfoLogARB")]
            public static extern unsafe void GetInfoLog(UInt32 obj, Int32 maxLength, [OutAttribute] Int32* length, [OutAttribute] StringBuilder infoLog);

            /// <summary>[requires: ARB_shading_language_include]</summary>
            [AutoGenerated(Category = "ARB_shading_language_include", Version = "", EntryPoint = "glGetNamedStringARB")]
            public static extern void GetNamedString(Int32 namelen, String name, Int32 bufSize, [OutAttribute] out Int32 stringlen, [OutAttribute] StringBuilder @string);

            /// <summary>[requires: ARB_shading_language_include]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shading_language_include", Version = "", EntryPoint = "glGetNamedStringARB")]
            public static extern unsafe void GetNamedString(Int32 namelen, String name, Int32 bufSize, [OutAttribute] Int32* stringlen, [OutAttribute] StringBuilder @string);

            /// <summary>[requires: ARB_shading_language_include]</summary>
            [AutoGenerated(Category = "ARB_shading_language_include", Version = "", EntryPoint = "glGetNamedStringivARB")]
            public static extern void GetNamedString(Int32 namelen, String name, OpenTK.Graphics.OpenGL.ArbShadingLanguageInclude pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: ARB_shading_language_include]</summary>
            [AutoGenerated(Category = "ARB_shading_language_include", Version = "", EntryPoint = "glGetNamedStringivARB")]
            public static extern void GetNamedString(Int32 namelen, String name, OpenTK.Graphics.OpenGL.ArbShadingLanguageInclude pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: ARB_shading_language_include]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shading_language_include", Version = "", EntryPoint = "glGetNamedStringivARB")]
            public static extern unsafe void GetNamedString(Int32 namelen, String name, OpenTK.Graphics.OpenGL.ArbShadingLanguageInclude pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnColorTableARB")]
            public static extern void GetnColorTable(OpenTK.Graphics.OpenGL.ArbRobustness target, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [OutAttribute] IntPtr table);

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnColorTableARB")]
            public static extern void GetnColorTable<T4>(OpenTK.Graphics.OpenGL.ArbRobustness target, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [InAttribute, OutAttribute] T4[] table)
                where T4 : struct
            ;

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnColorTableARB")]
            public static extern void GetnColorTable<T4>(OpenTK.Graphics.OpenGL.ArbRobustness target, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [InAttribute, OutAttribute] T4[,] table)
                where T4 : struct
            ;

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnColorTableARB")]
            public static extern void GetnColorTable<T4>(OpenTK.Graphics.OpenGL.ArbRobustness target, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [InAttribute, OutAttribute] T4[,,] table)
                where T4 : struct
            ;

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnColorTableARB")]
            public static extern void GetnColorTable<T4>(OpenTK.Graphics.OpenGL.ArbRobustness target, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [InAttribute, OutAttribute] ref T4 table)
                where T4 : struct
            ;

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnCompressedTexImageARB")]
            public static extern void GetnCompressedTexImage(OpenTK.Graphics.OpenGL.ArbRobustness target, Int32 lod, Int32 bufSize, [OutAttribute] IntPtr img);

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnCompressedTexImageARB")]
            public static extern void GetnCompressedTexImage<T3>(OpenTK.Graphics.OpenGL.ArbRobustness target, Int32 lod, Int32 bufSize, [InAttribute, OutAttribute] T3[] img)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnCompressedTexImageARB")]
            public static extern void GetnCompressedTexImage<T3>(OpenTK.Graphics.OpenGL.ArbRobustness target, Int32 lod, Int32 bufSize, [InAttribute, OutAttribute] T3[,] img)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnCompressedTexImageARB")]
            public static extern void GetnCompressedTexImage<T3>(OpenTK.Graphics.OpenGL.ArbRobustness target, Int32 lod, Int32 bufSize, [InAttribute, OutAttribute] T3[,,] img)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnCompressedTexImageARB")]
            public static extern void GetnCompressedTexImage<T3>(OpenTK.Graphics.OpenGL.ArbRobustness target, Int32 lod, Int32 bufSize, [InAttribute, OutAttribute] ref T3 img)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnConvolutionFilterARB")]
            public static extern void GetnConvolutionFilter(OpenTK.Graphics.OpenGL.ArbRobustness target, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [OutAttribute] IntPtr image);

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnConvolutionFilterARB")]
            public static extern void GetnConvolutionFilter<T4>(OpenTK.Graphics.OpenGL.ArbRobustness target, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [InAttribute, OutAttribute] T4[] image)
                where T4 : struct
            ;

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnConvolutionFilterARB")]
            public static extern void GetnConvolutionFilter<T4>(OpenTK.Graphics.OpenGL.ArbRobustness target, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [InAttribute, OutAttribute] T4[,] image)
                where T4 : struct
            ;

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnConvolutionFilterARB")]
            public static extern void GetnConvolutionFilter<T4>(OpenTK.Graphics.OpenGL.ArbRobustness target, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [InAttribute, OutAttribute] T4[,,] image)
                where T4 : struct
            ;

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnConvolutionFilterARB")]
            public static extern void GetnConvolutionFilter<T4>(OpenTK.Graphics.OpenGL.ArbRobustness target, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [InAttribute, OutAttribute] ref T4 image)
                where T4 : struct
            ;

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnHistogramARB")]
            public static extern void GetnHistogram(OpenTK.Graphics.OpenGL.ArbRobustness target, bool reset, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [OutAttribute] IntPtr values);

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnHistogramARB")]
            public static extern void GetnHistogram<T5>(OpenTK.Graphics.OpenGL.ArbRobustness target, bool reset, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [InAttribute, OutAttribute] T5[] values)
                where T5 : struct
            ;

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnHistogramARB")]
            public static extern void GetnHistogram<T5>(OpenTK.Graphics.OpenGL.ArbRobustness target, bool reset, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [InAttribute, OutAttribute] T5[,] values)
                where T5 : struct
            ;

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnHistogramARB")]
            public static extern void GetnHistogram<T5>(OpenTK.Graphics.OpenGL.ArbRobustness target, bool reset, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [InAttribute, OutAttribute] T5[,,] values)
                where T5 : struct
            ;

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnHistogramARB")]
            public static extern void GetnHistogram<T5>(OpenTK.Graphics.OpenGL.ArbRobustness target, bool reset, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [InAttribute, OutAttribute] ref T5 values)
                where T5 : struct
            ;

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnMapdvARB")]
            public static extern void GetnMap(OpenTK.Graphics.OpenGL.ArbRobustness target, OpenTK.Graphics.OpenGL.ArbRobustness query, Int32 bufSize, [OutAttribute] Double[] v);

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnMapdvARB")]
            public static extern void GetnMap(OpenTK.Graphics.OpenGL.ArbRobustness target, OpenTK.Graphics.OpenGL.ArbRobustness query, Int32 bufSize, [OutAttribute] out Double v);

            /// <summary>[requires: ARB_robustness]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnMapdvARB")]
            public static extern unsafe void GetnMap(OpenTK.Graphics.OpenGL.ArbRobustness target, OpenTK.Graphics.OpenGL.ArbRobustness query, Int32 bufSize, [OutAttribute] Double* v);

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnMapfvARB")]
            public static extern void GetnMap(OpenTK.Graphics.OpenGL.ArbRobustness target, OpenTK.Graphics.OpenGL.ArbRobustness query, Int32 bufSize, [OutAttribute] Single[] v);

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnMapfvARB")]
            public static extern void GetnMap(OpenTK.Graphics.OpenGL.ArbRobustness target, OpenTK.Graphics.OpenGL.ArbRobustness query, Int32 bufSize, [OutAttribute] out Single v);

            /// <summary>[requires: ARB_robustness]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnMapfvARB")]
            public static extern unsafe void GetnMap(OpenTK.Graphics.OpenGL.ArbRobustness target, OpenTK.Graphics.OpenGL.ArbRobustness query, Int32 bufSize, [OutAttribute] Single* v);

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnMapivARB")]
            public static extern void GetnMap(OpenTK.Graphics.OpenGL.ArbRobustness target, OpenTK.Graphics.OpenGL.ArbRobustness query, Int32 bufSize, [OutAttribute] Int32[] v);

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnMapivARB")]
            public static extern void GetnMap(OpenTK.Graphics.OpenGL.ArbRobustness target, OpenTK.Graphics.OpenGL.ArbRobustness query, Int32 bufSize, [OutAttribute] out Int32 v);

            /// <summary>[requires: ARB_robustness]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnMapivARB")]
            public static extern unsafe void GetnMap(OpenTK.Graphics.OpenGL.ArbRobustness target, OpenTK.Graphics.OpenGL.ArbRobustness query, Int32 bufSize, [OutAttribute] Int32* v);

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnMinmaxARB")]
            public static extern void GetnMinmax(OpenTK.Graphics.OpenGL.ArbRobustness target, bool reset, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [OutAttribute] IntPtr values);

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnMinmaxARB")]
            public static extern void GetnMinmax<T5>(OpenTK.Graphics.OpenGL.ArbRobustness target, bool reset, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [InAttribute, OutAttribute] T5[] values)
                where T5 : struct
            ;

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnMinmaxARB")]
            public static extern void GetnMinmax<T5>(OpenTK.Graphics.OpenGL.ArbRobustness target, bool reset, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [InAttribute, OutAttribute] T5[,] values)
                where T5 : struct
            ;

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnMinmaxARB")]
            public static extern void GetnMinmax<T5>(OpenTK.Graphics.OpenGL.ArbRobustness target, bool reset, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [InAttribute, OutAttribute] T5[,,] values)
                where T5 : struct
            ;

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnMinmaxARB")]
            public static extern void GetnMinmax<T5>(OpenTK.Graphics.OpenGL.ArbRobustness target, bool reset, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [InAttribute, OutAttribute] ref T5 values)
                where T5 : struct
            ;

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnPixelMapfvARB")]
            public static extern void GetnPixelMap(OpenTK.Graphics.OpenGL.ArbRobustness map, Int32 bufSize, [OutAttribute] Single[] values);

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnPixelMapfvARB")]
            public static extern void GetnPixelMap(OpenTK.Graphics.OpenGL.ArbRobustness map, Int32 bufSize, [OutAttribute] out Single values);

            /// <summary>[requires: ARB_robustness]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnPixelMapfvARB")]
            public static extern unsafe void GetnPixelMap(OpenTK.Graphics.OpenGL.ArbRobustness map, Int32 bufSize, [OutAttribute] Single* values);

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnPixelMapuivARB")]
            public static extern void GetnPixelMap(OpenTK.Graphics.OpenGL.ArbRobustness map, Int32 bufSize, [OutAttribute] Int32[] values);

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnPixelMapuivARB")]
            public static extern void GetnPixelMap(OpenTK.Graphics.OpenGL.ArbRobustness map, Int32 bufSize, [OutAttribute] out Int32 values);

            /// <summary>[requires: ARB_robustness]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnPixelMapuivARB")]
            public static extern unsafe void GetnPixelMap(OpenTK.Graphics.OpenGL.ArbRobustness map, Int32 bufSize, [OutAttribute] Int32* values);

            /// <summary>[requires: ARB_robustness]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnPixelMapuivARB")]
            public static extern void GetnPixelMap(OpenTK.Graphics.OpenGL.ArbRobustness map, Int32 bufSize, [OutAttribute] UInt32[] values);

            /// <summary>[requires: ARB_robustness]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnPixelMapuivARB")]
            public static extern void GetnPixelMap(OpenTK.Graphics.OpenGL.ArbRobustness map, Int32 bufSize, [OutAttribute] out UInt32 values);

            /// <summary>[requires: ARB_robustness]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnPixelMapuivARB")]
            public static extern unsafe void GetnPixelMap(OpenTK.Graphics.OpenGL.ArbRobustness map, Int32 bufSize, [OutAttribute] UInt32* values);

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnPixelMapusvARB")]
            public static extern void GetnPixelMap(OpenTK.Graphics.OpenGL.ArbRobustness map, Int32 bufSize, [OutAttribute] Int16[] values);

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnPixelMapusvARB")]
            public static extern void GetnPixelMap(OpenTK.Graphics.OpenGL.ArbRobustness map, Int32 bufSize, [OutAttribute] out Int16 values);

            /// <summary>[requires: ARB_robustness]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnPixelMapusvARB")]
            public static extern unsafe void GetnPixelMap(OpenTK.Graphics.OpenGL.ArbRobustness map, Int32 bufSize, [OutAttribute] Int16* values);

            /// <summary>[requires: ARB_robustness]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnPixelMapusvARB")]
            public static extern void GetnPixelMap(OpenTK.Graphics.OpenGL.ArbRobustness map, Int32 bufSize, [OutAttribute] UInt16[] values);

            /// <summary>[requires: ARB_robustness]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnPixelMapusvARB")]
            public static extern void GetnPixelMap(OpenTK.Graphics.OpenGL.ArbRobustness map, Int32 bufSize, [OutAttribute] out UInt16 values);

            /// <summary>[requires: ARB_robustness]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnPixelMapusvARB")]
            public static extern unsafe void GetnPixelMap(OpenTK.Graphics.OpenGL.ArbRobustness map, Int32 bufSize, [OutAttribute] UInt16* values);

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnPolygonStippleARB")]
            public static extern Byte GetnPolygonStipple();

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnPolygonStippleARB")]
            public static extern void GetnPolygonStipple(Int32 bufSize, [OutAttribute] Byte[] pattern);

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnPolygonStippleARB")]
            public static extern void GetnPolygonStipple(Int32 bufSize, [OutAttribute] out Byte pattern);

            /// <summary>[requires: ARB_robustness]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnPolygonStippleARB")]
            public static extern unsafe void GetnPolygonStipple(Int32 bufSize, [OutAttribute] Byte* pattern);

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnSeparableFilterARB")]
            public static extern void GetnSeparableFilter(OpenTK.Graphics.OpenGL.ArbRobustness target, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 rowBufSize, [OutAttribute] IntPtr row, Int32 columnBufSize, [OutAttribute] IntPtr column, [OutAttribute] IntPtr span);

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnSeparableFilterARB")]
            public static extern void GetnSeparableFilter<T4,T6,T7>(OpenTK.Graphics.OpenGL.ArbRobustness target, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 rowBufSize, [InAttribute, OutAttribute] T4[] row, Int32 columnBufSize, [InAttribute, OutAttribute] T6[] column, [InAttribute, OutAttribute] T7[] span)
                where T4 : struct
                where T6 : struct
                where T7 : struct
            ;

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnSeparableFilterARB")]
            public static extern void GetnSeparableFilter<T4,T6,T7>(OpenTK.Graphics.OpenGL.ArbRobustness target, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 rowBufSize, [InAttribute, OutAttribute] T4[,] row, Int32 columnBufSize, [InAttribute, OutAttribute] T6[,] column, [InAttribute, OutAttribute] T7[,] span)
                where T4 : struct
                where T6 : struct
                where T7 : struct
            ;

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnSeparableFilterARB")]
            public static extern void GetnSeparableFilter<T4,T6,T7>(OpenTK.Graphics.OpenGL.ArbRobustness target, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 rowBufSize, [InAttribute, OutAttribute] T4[,,] row, Int32 columnBufSize, [InAttribute, OutAttribute] T6[,,] column, [InAttribute, OutAttribute] T7[,,] span)
                where T4 : struct
                where T6 : struct
                where T7 : struct
            ;

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnSeparableFilterARB")]
            public static extern void GetnSeparableFilter<T4,T6,T7>(OpenTK.Graphics.OpenGL.ArbRobustness target, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 rowBufSize, [InAttribute, OutAttribute] ref T4 row, Int32 columnBufSize, [InAttribute, OutAttribute] ref T6 column, [InAttribute, OutAttribute] ref T7 span)
                where T4 : struct
                where T6 : struct
                where T7 : struct
            ;

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnTexImageARB")]
            public static extern void GetnTexImage(OpenTK.Graphics.OpenGL.ArbRobustness target, Int32 level, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [OutAttribute] IntPtr img);

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnTexImageARB")]
            public static extern void GetnTexImage<T5>(OpenTK.Graphics.OpenGL.ArbRobustness target, Int32 level, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [InAttribute, OutAttribute] T5[] img)
                where T5 : struct
            ;

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnTexImageARB")]
            public static extern void GetnTexImage<T5>(OpenTK.Graphics.OpenGL.ArbRobustness target, Int32 level, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [InAttribute, OutAttribute] T5[,] img)
                where T5 : struct
            ;

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnTexImageARB")]
            public static extern void GetnTexImage<T5>(OpenTK.Graphics.OpenGL.ArbRobustness target, Int32 level, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [InAttribute, OutAttribute] T5[,,] img)
                where T5 : struct
            ;

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnTexImageARB")]
            public static extern void GetnTexImage<T5>(OpenTK.Graphics.OpenGL.ArbRobustness target, Int32 level, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [InAttribute, OutAttribute] ref T5 img)
                where T5 : struct
            ;

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnUniformdvARB")]
            public static extern void GetnUniform(Int32 program, Int32 location, Int32 bufSize, [OutAttribute] Double[] @params);

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnUniformdvARB")]
            public static extern void GetnUniform(Int32 program, Int32 location, Int32 bufSize, [OutAttribute] out Double @params);

            /// <summary>[requires: ARB_robustness]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnUniformdvARB")]
            public static extern unsafe void GetnUniform(Int32 program, Int32 location, Int32 bufSize, [OutAttribute] Double* @params);

            /// <summary>[requires: ARB_robustness]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnUniformdvARB")]
            public static extern void GetnUniform(UInt32 program, Int32 location, Int32 bufSize, [OutAttribute] Double[] @params);

            /// <summary>[requires: ARB_robustness]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnUniformdvARB")]
            public static extern void GetnUniform(UInt32 program, Int32 location, Int32 bufSize, [OutAttribute] out Double @params);

            /// <summary>[requires: ARB_robustness]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnUniformdvARB")]
            public static extern unsafe void GetnUniform(UInt32 program, Int32 location, Int32 bufSize, [OutAttribute] Double* @params);

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnUniformfvARB")]
            public static extern void GetnUniform(Int32 program, Int32 location, Int32 bufSize, [OutAttribute] Single[] @params);

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnUniformfvARB")]
            public static extern void GetnUniform(Int32 program, Int32 location, Int32 bufSize, [OutAttribute] out Single @params);

            /// <summary>[requires: ARB_robustness]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnUniformfvARB")]
            public static extern unsafe void GetnUniform(Int32 program, Int32 location, Int32 bufSize, [OutAttribute] Single* @params);

            /// <summary>[requires: ARB_robustness]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnUniformfvARB")]
            public static extern void GetnUniform(UInt32 program, Int32 location, Int32 bufSize, [OutAttribute] Single[] @params);

            /// <summary>[requires: ARB_robustness]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnUniformfvARB")]
            public static extern void GetnUniform(UInt32 program, Int32 location, Int32 bufSize, [OutAttribute] out Single @params);

            /// <summary>[requires: ARB_robustness]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnUniformfvARB")]
            public static extern unsafe void GetnUniform(UInt32 program, Int32 location, Int32 bufSize, [OutAttribute] Single* @params);

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnUniformivARB")]
            public static extern void GetnUniform(Int32 program, Int32 location, Int32 bufSize, [OutAttribute] Int32[] @params);

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnUniformivARB")]
            public static extern void GetnUniform(Int32 program, Int32 location, Int32 bufSize, [OutAttribute] out Int32 @params);

            /// <summary>[requires: ARB_robustness]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnUniformivARB")]
            public static extern unsafe void GetnUniform(Int32 program, Int32 location, Int32 bufSize, [OutAttribute] Int32* @params);

            /// <summary>[requires: ARB_robustness]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnUniformivARB")]
            public static extern void GetnUniform(UInt32 program, Int32 location, Int32 bufSize, [OutAttribute] Int32[] @params);

            /// <summary>[requires: ARB_robustness]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnUniformivARB")]
            public static extern void GetnUniform(UInt32 program, Int32 location, Int32 bufSize, [OutAttribute] out Int32 @params);

            /// <summary>[requires: ARB_robustness]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnUniformivARB")]
            public static extern unsafe void GetnUniform(UInt32 program, Int32 location, Int32 bufSize, [OutAttribute] Int32* @params);

            /// <summary>[requires: ARB_robustness]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnUniformuivARB")]
            public static extern void GetnUniform(UInt32 program, Int32 location, Int32 bufSize, [OutAttribute] UInt32[] @params);

            /// <summary>[requires: ARB_robustness]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnUniformuivARB")]
            public static extern void GetnUniform(UInt32 program, Int32 location, Int32 bufSize, [OutAttribute] out UInt32 @params);

            /// <summary>[requires: ARB_robustness]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glGetnUniformuivARB")]
            public static extern unsafe void GetnUniform(UInt32 program, Int32 location, Int32 bufSize, [OutAttribute] UInt32* @params);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetObjectParameterfvARB")]
            public static extern void GetObjectParameter(Int32 obj, OpenTK.Graphics.OpenGL.ArbShaderObjects pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetObjectParameterfvARB")]
            public static extern void GetObjectParameter(Int32 obj, OpenTK.Graphics.OpenGL.ArbShaderObjects pname, [OutAttribute] out Single @params);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetObjectParameterfvARB")]
            public static extern unsafe void GetObjectParameter(Int32 obj, OpenTK.Graphics.OpenGL.ArbShaderObjects pname, [OutAttribute] Single* @params);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetObjectParameterfvARB")]
            public static extern void GetObjectParameter(UInt32 obj, OpenTK.Graphics.OpenGL.ArbShaderObjects pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetObjectParameterfvARB")]
            public static extern void GetObjectParameter(UInt32 obj, OpenTK.Graphics.OpenGL.ArbShaderObjects pname, [OutAttribute] out Single @params);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetObjectParameterfvARB")]
            public static extern unsafe void GetObjectParameter(UInt32 obj, OpenTK.Graphics.OpenGL.ArbShaderObjects pname, [OutAttribute] Single* @params);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetObjectParameterivARB")]
            public static extern void GetObjectParameter(Int32 obj, OpenTK.Graphics.OpenGL.ArbShaderObjects pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetObjectParameterivARB")]
            public static extern void GetObjectParameter(Int32 obj, OpenTK.Graphics.OpenGL.ArbShaderObjects pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetObjectParameterivARB")]
            public static extern unsafe void GetObjectParameter(Int32 obj, OpenTK.Graphics.OpenGL.ArbShaderObjects pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetObjectParameterivARB")]
            public static extern void GetObjectParameter(UInt32 obj, OpenTK.Graphics.OpenGL.ArbShaderObjects pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetObjectParameterivARB")]
            public static extern void GetObjectParameter(UInt32 obj, OpenTK.Graphics.OpenGL.ArbShaderObjects pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetObjectParameterivARB")]
            public static extern unsafe void GetObjectParameter(UInt32 obj, OpenTK.Graphics.OpenGL.ArbShaderObjects pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramEnvParameterdvARB")]
            public static extern void GetProgramEnvParameter(OpenTK.Graphics.OpenGL.All target, Int32 index, [OutAttribute] Double[] @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramEnvParameterdvARB")]
            public static extern void GetProgramEnvParameter(OpenTK.Graphics.OpenGL.All target, Int32 index, [OutAttribute] out Double @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramEnvParameterdvARB")]
            public static extern unsafe void GetProgramEnvParameter(OpenTK.Graphics.OpenGL.All target, Int32 index, [OutAttribute] Double* @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramEnvParameterdvARB")]
            public static extern void GetProgramEnvParameter(OpenTK.Graphics.OpenGL.All target, UInt32 index, [OutAttribute] Double[] @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramEnvParameterdvARB")]
            public static extern void GetProgramEnvParameter(OpenTK.Graphics.OpenGL.All target, UInt32 index, [OutAttribute] out Double @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramEnvParameterdvARB")]
            public static extern unsafe void GetProgramEnvParameter(OpenTK.Graphics.OpenGL.All target, UInt32 index, [OutAttribute] Double* @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [Obsolete("Use All overload instead")]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramEnvParameterdvARB")]
            public static extern void GetProgramEnvParameter(OpenTK.Graphics.OpenGL.ArbVertexProgram target, Int32 index, [OutAttribute] Double[] @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [Obsolete("Use All overload instead")]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramEnvParameterdvARB")]
            public static extern void GetProgramEnvParameter(OpenTK.Graphics.OpenGL.ArbVertexProgram target, Int32 index, [OutAttribute] out Double @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [Obsolete("Use All overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramEnvParameterdvARB")]
            public static extern unsafe void GetProgramEnvParameter(OpenTK.Graphics.OpenGL.ArbVertexProgram target, Int32 index, [OutAttribute] Double* @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [Obsolete("Use All overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramEnvParameterdvARB")]
            public static extern void GetProgramEnvParameter(OpenTK.Graphics.OpenGL.ArbVertexProgram target, UInt32 index, [OutAttribute] Double[] @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [Obsolete("Use All overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramEnvParameterdvARB")]
            public static extern void GetProgramEnvParameter(OpenTK.Graphics.OpenGL.ArbVertexProgram target, UInt32 index, [OutAttribute] out Double @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [Obsolete("Use All overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramEnvParameterdvARB")]
            public static extern unsafe void GetProgramEnvParameter(OpenTK.Graphics.OpenGL.ArbVertexProgram target, UInt32 index, [OutAttribute] Double* @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramEnvParameterfvARB")]
            public static extern void GetProgramEnvParameter(OpenTK.Graphics.OpenGL.All target, Int32 index, [OutAttribute] Single[] @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramEnvParameterfvARB")]
            public static extern void GetProgramEnvParameter(OpenTK.Graphics.OpenGL.All target, Int32 index, [OutAttribute] out Single @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramEnvParameterfvARB")]
            public static extern unsafe void GetProgramEnvParameter(OpenTK.Graphics.OpenGL.All target, Int32 index, [OutAttribute] Single* @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramEnvParameterfvARB")]
            public static extern void GetProgramEnvParameter(OpenTK.Graphics.OpenGL.All target, UInt32 index, [OutAttribute] Single[] @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramEnvParameterfvARB")]
            public static extern void GetProgramEnvParameter(OpenTK.Graphics.OpenGL.All target, UInt32 index, [OutAttribute] out Single @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramEnvParameterfvARB")]
            public static extern unsafe void GetProgramEnvParameter(OpenTK.Graphics.OpenGL.All target, UInt32 index, [OutAttribute] Single* @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [Obsolete("Use All overload instead")]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramEnvParameterfvARB")]
            public static extern void GetProgramEnvParameter(OpenTK.Graphics.OpenGL.ArbVertexProgram target, Int32 index, [OutAttribute] Single[] @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [Obsolete("Use All overload instead")]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramEnvParameterfvARB")]
            public static extern void GetProgramEnvParameter(OpenTK.Graphics.OpenGL.ArbVertexProgram target, Int32 index, [OutAttribute] out Single @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [Obsolete("Use All overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramEnvParameterfvARB")]
            public static extern unsafe void GetProgramEnvParameter(OpenTK.Graphics.OpenGL.ArbVertexProgram target, Int32 index, [OutAttribute] Single* @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [Obsolete("Use All overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramEnvParameterfvARB")]
            public static extern void GetProgramEnvParameter(OpenTK.Graphics.OpenGL.ArbVertexProgram target, UInt32 index, [OutAttribute] Single[] @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [Obsolete("Use All overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramEnvParameterfvARB")]
            public static extern void GetProgramEnvParameter(OpenTK.Graphics.OpenGL.ArbVertexProgram target, UInt32 index, [OutAttribute] out Single @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [Obsolete("Use All overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramEnvParameterfvARB")]
            public static extern unsafe void GetProgramEnvParameter(OpenTK.Graphics.OpenGL.ArbVertexProgram target, UInt32 index, [OutAttribute] Single* @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]
            /// Returns a parameter from a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the object parameter. Accepted symbolic names are GL_DELETE_STATUS, GL_LINK_STATUS, GL_VALIDATE_STATUS, GL_INFO_LOG_LENGTH, GL_ATTACHED_SHADERS, GL_ACTIVE_ATOMIC_COUNTER_BUFFERS, GL_ACTIVE_ATTRIBUTES, GL_ACTIVE_ATTRIBUTE_MAX_LENGTH, GL_ACTIVE_UNIFORMS, GL_ACTIVE_UNIFORM_BLOCKS, GL_ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH, GL_ACTIVE_UNIFORM_MAX_LENGTH, GL_COMPUTE_WORK_GROUP_SIZE GL_PROGRAM_BINARY_LENGTH, GL_TRANSFORM_FEEDBACK_BUFFER_MODE, GL_TRANSFORM_FEEDBACK_VARYINGS, GL_TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH, GL_GEOMETRY_VERTICES_OUT, GL_GEOMETRY_INPUT_TYPE, and GL_GEOMETRY_OUTPUT_TYPE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested object parameter.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramivARB")]
            public static extern void GetProgram(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, OpenTK.Graphics.OpenGL.AssemblyProgramParameterArb pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]
            /// Returns a parameter from a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the object parameter. Accepted symbolic names are GL_DELETE_STATUS, GL_LINK_STATUS, GL_VALIDATE_STATUS, GL_INFO_LOG_LENGTH, GL_ATTACHED_SHADERS, GL_ACTIVE_ATOMIC_COUNTER_BUFFERS, GL_ACTIVE_ATTRIBUTES, GL_ACTIVE_ATTRIBUTE_MAX_LENGTH, GL_ACTIVE_UNIFORMS, GL_ACTIVE_UNIFORM_BLOCKS, GL_ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH, GL_ACTIVE_UNIFORM_MAX_LENGTH, GL_COMPUTE_WORK_GROUP_SIZE GL_PROGRAM_BINARY_LENGTH, GL_TRANSFORM_FEEDBACK_BUFFER_MODE, GL_TRANSFORM_FEEDBACK_VARYINGS, GL_TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH, GL_GEOMETRY_VERTICES_OUT, GL_GEOMETRY_INPUT_TYPE, and GL_GEOMETRY_OUTPUT_TYPE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested object parameter.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramivARB")]
            public static extern unsafe void GetProgram(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, OpenTK.Graphics.OpenGL.AssemblyProgramParameterArb pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramLocalParameterdvARB")]
            public static extern void GetProgramLocalParameter(OpenTK.Graphics.OpenGL.All target, Int32 index, [OutAttribute] Double[] @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramLocalParameterdvARB")]
            public static extern void GetProgramLocalParameter(OpenTK.Graphics.OpenGL.All target, Int32 index, [OutAttribute] out Double @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramLocalParameterdvARB")]
            public static extern unsafe void GetProgramLocalParameter(OpenTK.Graphics.OpenGL.All target, Int32 index, [OutAttribute] Double* @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramLocalParameterdvARB")]
            public static extern void GetProgramLocalParameter(OpenTK.Graphics.OpenGL.All target, UInt32 index, [OutAttribute] Double[] @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramLocalParameterdvARB")]
            public static extern void GetProgramLocalParameter(OpenTK.Graphics.OpenGL.All target, UInt32 index, [OutAttribute] out Double @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramLocalParameterdvARB")]
            public static extern unsafe void GetProgramLocalParameter(OpenTK.Graphics.OpenGL.All target, UInt32 index, [OutAttribute] Double* @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [Obsolete("Use All overload instead")]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramLocalParameterdvARB")]
            public static extern void GetProgramLocalParameter(OpenTK.Graphics.OpenGL.ArbVertexProgram target, Int32 index, [OutAttribute] Double[] @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [Obsolete("Use All overload instead")]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramLocalParameterdvARB")]
            public static extern void GetProgramLocalParameter(OpenTK.Graphics.OpenGL.ArbVertexProgram target, Int32 index, [OutAttribute] out Double @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [Obsolete("Use All overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramLocalParameterdvARB")]
            public static extern unsafe void GetProgramLocalParameter(OpenTK.Graphics.OpenGL.ArbVertexProgram target, Int32 index, [OutAttribute] Double* @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [Obsolete("Use All overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramLocalParameterdvARB")]
            public static extern void GetProgramLocalParameter(OpenTK.Graphics.OpenGL.ArbVertexProgram target, UInt32 index, [OutAttribute] Double[] @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [Obsolete("Use All overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramLocalParameterdvARB")]
            public static extern void GetProgramLocalParameter(OpenTK.Graphics.OpenGL.ArbVertexProgram target, UInt32 index, [OutAttribute] out Double @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [Obsolete("Use All overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramLocalParameterdvARB")]
            public static extern unsafe void GetProgramLocalParameter(OpenTK.Graphics.OpenGL.ArbVertexProgram target, UInt32 index, [OutAttribute] Double* @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramLocalParameterfvARB")]
            public static extern void GetProgramLocalParameter(OpenTK.Graphics.OpenGL.All target, Int32 index, [OutAttribute] Single[] @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramLocalParameterfvARB")]
            public static extern void GetProgramLocalParameter(OpenTK.Graphics.OpenGL.All target, Int32 index, [OutAttribute] out Single @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramLocalParameterfvARB")]
            public static extern unsafe void GetProgramLocalParameter(OpenTK.Graphics.OpenGL.All target, Int32 index, [OutAttribute] Single* @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramLocalParameterfvARB")]
            public static extern void GetProgramLocalParameter(OpenTK.Graphics.OpenGL.All target, UInt32 index, [OutAttribute] Single[] @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramLocalParameterfvARB")]
            public static extern void GetProgramLocalParameter(OpenTK.Graphics.OpenGL.All target, UInt32 index, [OutAttribute] out Single @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramLocalParameterfvARB")]
            public static extern unsafe void GetProgramLocalParameter(OpenTK.Graphics.OpenGL.All target, UInt32 index, [OutAttribute] Single* @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [Obsolete("Use All overload instead")]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramLocalParameterfvARB")]
            public static extern void GetProgramLocalParameter(OpenTK.Graphics.OpenGL.ArbVertexProgram target, Int32 index, [OutAttribute] Single[] @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [Obsolete("Use All overload instead")]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramLocalParameterfvARB")]
            public static extern void GetProgramLocalParameter(OpenTK.Graphics.OpenGL.ArbVertexProgram target, Int32 index, [OutAttribute] out Single @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [Obsolete("Use All overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramLocalParameterfvARB")]
            public static extern unsafe void GetProgramLocalParameter(OpenTK.Graphics.OpenGL.ArbVertexProgram target, Int32 index, [OutAttribute] Single* @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [Obsolete("Use All overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramLocalParameterfvARB")]
            public static extern void GetProgramLocalParameter(OpenTK.Graphics.OpenGL.ArbVertexProgram target, UInt32 index, [OutAttribute] Single[] @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [Obsolete("Use All overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramLocalParameterfvARB")]
            public static extern void GetProgramLocalParameter(OpenTK.Graphics.OpenGL.ArbVertexProgram target, UInt32 index, [OutAttribute] out Single @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [Obsolete("Use All overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramLocalParameterfvARB")]
            public static extern unsafe void GetProgramLocalParameter(OpenTK.Graphics.OpenGL.ArbVertexProgram target, UInt32 index, [OutAttribute] Single* @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramStringARB")]
            public static extern void GetProgramString(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, OpenTK.Graphics.OpenGL.AssemblyProgramParameterArb pname, [OutAttribute] IntPtr @string);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramStringARB")]
            public static extern void GetProgramString<T2>(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, OpenTK.Graphics.OpenGL.AssemblyProgramParameterArb pname, [InAttribute, OutAttribute] T2[] @string)
                where T2 : struct
            ;

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramStringARB")]
            public static extern void GetProgramString<T2>(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, OpenTK.Graphics.OpenGL.AssemblyProgramParameterArb pname, [InAttribute, OutAttribute] T2[,] @string)
                where T2 : struct
            ;

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramStringARB")]
            public static extern void GetProgramString<T2>(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, OpenTK.Graphics.OpenGL.AssemblyProgramParameterArb pname, [InAttribute, OutAttribute] T2[,,] @string)
                where T2 : struct
            ;

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glGetProgramStringARB")]
            public static extern void GetProgramString<T2>(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, OpenTK.Graphics.OpenGL.AssemblyProgramParameterArb pname, [InAttribute, OutAttribute] ref T2 @string)
                where T2 : struct
            ;

            /// <summary>[requires: ARB_occlusion_query]</summary>
            [AutoGenerated(Category = "ARB_occlusion_query", Version = "", EntryPoint = "glGetQueryivARB")]
            public static extern void GetQuery(OpenTK.Graphics.OpenGL.ArbOcclusionQuery target, OpenTK.Graphics.OpenGL.ArbOcclusionQuery pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: ARB_occlusion_query]</summary>
            [AutoGenerated(Category = "ARB_occlusion_query", Version = "", EntryPoint = "glGetQueryivARB")]
            public static extern void GetQuery(OpenTK.Graphics.OpenGL.ArbOcclusionQuery target, OpenTK.Graphics.OpenGL.ArbOcclusionQuery pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: ARB_occlusion_query]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_occlusion_query", Version = "", EntryPoint = "glGetQueryivARB")]
            public static extern unsafe void GetQuery(OpenTK.Graphics.OpenGL.ArbOcclusionQuery target, OpenTK.Graphics.OpenGL.ArbOcclusionQuery pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: ARB_occlusion_query]
            /// Return parameters of a query object
            /// </summary>
            /// <param name="id">
            /// <para>
            /// Specifies the name of a query object.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_occlusion_query", Version = "", EntryPoint = "glGetQueryObjectivARB")]
            public static extern void GetQueryObject(Int32 id, OpenTK.Graphics.OpenGL.ArbOcclusionQuery pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: ARB_occlusion_query]
            /// Return parameters of a query object
            /// </summary>
            /// <param name="id">
            /// <para>
            /// Specifies the name of a query object.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_occlusion_query", Version = "", EntryPoint = "glGetQueryObjectivARB")]
            public static extern void GetQueryObject(Int32 id, OpenTK.Graphics.OpenGL.ArbOcclusionQuery pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: ARB_occlusion_query]
            /// Return parameters of a query object
            /// </summary>
            /// <param name="id">
            /// <para>
            /// Specifies the name of a query object.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_occlusion_query", Version = "", EntryPoint = "glGetQueryObjectivARB")]
            public static extern unsafe void GetQueryObject(Int32 id, OpenTK.Graphics.OpenGL.ArbOcclusionQuery pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: ARB_occlusion_query]
            /// Return parameters of a query object
            /// </summary>
            /// <param name="id">
            /// <para>
            /// Specifies the name of a query object.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_occlusion_query", Version = "", EntryPoint = "glGetQueryObjectivARB")]
            public static extern void GetQueryObject(UInt32 id, OpenTK.Graphics.OpenGL.ArbOcclusionQuery pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: ARB_occlusion_query]
            /// Return parameters of a query object
            /// </summary>
            /// <param name="id">
            /// <para>
            /// Specifies the name of a query object.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_occlusion_query", Version = "", EntryPoint = "glGetQueryObjectivARB")]
            public static extern void GetQueryObject(UInt32 id, OpenTK.Graphics.OpenGL.ArbOcclusionQuery pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: ARB_occlusion_query]
            /// Return parameters of a query object
            /// </summary>
            /// <param name="id">
            /// <para>
            /// Specifies the name of a query object.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_occlusion_query", Version = "", EntryPoint = "glGetQueryObjectivARB")]
            public static extern unsafe void GetQueryObject(UInt32 id, OpenTK.Graphics.OpenGL.ArbOcclusionQuery pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: ARB_occlusion_query]
            /// Return parameters of a query object
            /// </summary>
            /// <param name="id">
            /// <para>
            /// Specifies the name of a query object.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_occlusion_query", Version = "", EntryPoint = "glGetQueryObjectuivARB")]
            public static extern void GetQueryObject(UInt32 id, OpenTK.Graphics.OpenGL.ArbOcclusionQuery pname, [OutAttribute] UInt32[] @params);

            /// <summary>[requires: ARB_occlusion_query]
            /// Return parameters of a query object
            /// </summary>
            /// <param name="id">
            /// <para>
            /// Specifies the name of a query object.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_occlusion_query", Version = "", EntryPoint = "glGetQueryObjectuivARB")]
            public static extern void GetQueryObject(UInt32 id, OpenTK.Graphics.OpenGL.ArbOcclusionQuery pname, [OutAttribute] out UInt32 @params);

            /// <summary>[requires: ARB_occlusion_query]
            /// Return parameters of a query object
            /// </summary>
            /// <param name="id">
            /// <para>
            /// Specifies the name of a query object.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_occlusion_query", Version = "", EntryPoint = "glGetQueryObjectuivARB")]
            public static extern unsafe void GetQueryObject(UInt32 id, OpenTK.Graphics.OpenGL.ArbOcclusionQuery pname, [OutAttribute] UInt32* @params);

            /// <summary>[requires: ARB_shader_objects]
            /// Returns the source code string from a shader object
            /// </summary>
            /// <param name="shader">
            /// <para>
            /// Specifies the shader object to be queried.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// Specifies the size of the character buffer for storing the returned source code string.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// Returns the length of the string returned in source (excluding the null terminator).
            /// </para>
            /// </param>
            /// <param name="source">
            /// <para>
            /// Specifies an array of characters that is used to return the source code string.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetShaderSourceARB")]
            public static extern void GetShaderSource(Int32 obj, Int32 maxLength, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder source);

            /// <summary>[requires: ARB_shader_objects]
            /// Returns the source code string from a shader object
            /// </summary>
            /// <param name="shader">
            /// <para>
            /// Specifies the shader object to be queried.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// Specifies the size of the character buffer for storing the returned source code string.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// Returns the length of the string returned in source (excluding the null terminator).
            /// </para>
            /// </param>
            /// <param name="source">
            /// <para>
            /// Specifies an array of characters that is used to return the source code string.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetShaderSourceARB")]
            public static extern unsafe void GetShaderSource(Int32 obj, Int32 maxLength, [OutAttribute] Int32* length, [OutAttribute] StringBuilder source);

            /// <summary>[requires: ARB_shader_objects]
            /// Returns the source code string from a shader object
            /// </summary>
            /// <param name="shader">
            /// <para>
            /// Specifies the shader object to be queried.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// Specifies the size of the character buffer for storing the returned source code string.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// Returns the length of the string returned in source (excluding the null terminator).
            /// </para>
            /// </param>
            /// <param name="source">
            /// <para>
            /// Specifies an array of characters that is used to return the source code string.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetShaderSourceARB")]
            public static extern void GetShaderSource(UInt32 obj, Int32 maxLength, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder source);

            /// <summary>[requires: ARB_shader_objects]
            /// Returns the source code string from a shader object
            /// </summary>
            /// <param name="shader">
            /// <para>
            /// Specifies the shader object to be queried.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// Specifies the size of the character buffer for storing the returned source code string.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// Returns the length of the string returned in source (excluding the null terminator).
            /// </para>
            /// </param>
            /// <param name="source">
            /// <para>
            /// Specifies an array of characters that is used to return the source code string.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetShaderSourceARB")]
            public static extern unsafe void GetShaderSource(UInt32 obj, Int32 maxLength, [OutAttribute] Int32* length, [OutAttribute] StringBuilder source);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glGetTextureHandleARB")]
            public static extern Int64 GetTextureHandle(Int32 texture);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glGetTextureHandleARB")]
            public static extern Int64 GetTextureHandle(UInt32 texture);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glGetTextureSamplerHandleARB")]
            public static extern Int64 GetTextureSamplerHandle(Int32 texture, Int32 sampler);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glGetTextureSamplerHandleARB")]
            public static extern Int64 GetTextureSamplerHandle(UInt32 texture, UInt32 sampler);

            /// <summary>[requires: ARB_shader_objects]
            /// Returns the value of a uniform variable
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be queried.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the value of the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetUniformfvARB")]
            public static extern void GetUniform(Int32 programObj, Int32 location, [OutAttribute] Single[] @params);

            /// <summary>[requires: ARB_shader_objects]
            /// Returns the value of a uniform variable
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be queried.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the value of the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetUniformfvARB")]
            public static extern void GetUniform(Int32 programObj, Int32 location, [OutAttribute] out Single @params);

            /// <summary>[requires: ARB_shader_objects]
            /// Returns the value of a uniform variable
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be queried.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the value of the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetUniformfvARB")]
            public static extern unsafe void GetUniform(Int32 programObj, Int32 location, [OutAttribute] Single* @params);

            /// <summary>[requires: ARB_shader_objects]
            /// Returns the value of a uniform variable
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be queried.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the value of the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetUniformfvARB")]
            public static extern void GetUniform(UInt32 programObj, Int32 location, [OutAttribute] Single[] @params);

            /// <summary>[requires: ARB_shader_objects]
            /// Returns the value of a uniform variable
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be queried.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the value of the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetUniformfvARB")]
            public static extern void GetUniform(UInt32 programObj, Int32 location, [OutAttribute] out Single @params);

            /// <summary>[requires: ARB_shader_objects]
            /// Returns the value of a uniform variable
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be queried.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the value of the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetUniformfvARB")]
            public static extern unsafe void GetUniform(UInt32 programObj, Int32 location, [OutAttribute] Single* @params);

            /// <summary>[requires: ARB_shader_objects]
            /// Returns the value of a uniform variable
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be queried.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the value of the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetUniformivARB")]
            public static extern void GetUniform(Int32 programObj, Int32 location, [OutAttribute] Int32[] @params);

            /// <summary>[requires: ARB_shader_objects]
            /// Returns the value of a uniform variable
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be queried.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the value of the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetUniformivARB")]
            public static extern void GetUniform(Int32 programObj, Int32 location, [OutAttribute] out Int32 @params);

            /// <summary>[requires: ARB_shader_objects]
            /// Returns the value of a uniform variable
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be queried.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the value of the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetUniformivARB")]
            public static extern unsafe void GetUniform(Int32 programObj, Int32 location, [OutAttribute] Int32* @params);

            /// <summary>[requires: ARB_shader_objects]
            /// Returns the value of a uniform variable
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be queried.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the value of the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetUniformivARB")]
            public static extern void GetUniform(UInt32 programObj, Int32 location, [OutAttribute] Int32[] @params);

            /// <summary>[requires: ARB_shader_objects]
            /// Returns the value of a uniform variable
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be queried.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the value of the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetUniformivARB")]
            public static extern void GetUniform(UInt32 programObj, Int32 location, [OutAttribute] out Int32 @params);

            /// <summary>[requires: ARB_shader_objects]
            /// Returns the value of a uniform variable
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be queried.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the value of the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetUniformivARB")]
            public static extern unsafe void GetUniform(UInt32 programObj, Int32 location, [OutAttribute] Int32* @params);

            /// <summary>[requires: ARB_shader_objects]
            /// Returns the location of a uniform variable
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// Points to a null terminated string containing the name of the uniform variable whose location is to be queried.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetUniformLocationARB")]
            public static extern Int32 GetUniformLocation(Int32 programObj, String name);

            /// <summary>[requires: ARB_shader_objects]
            /// Returns the location of a uniform variable
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// Points to a null terminated string containing the name of the uniform variable whose location is to be queried.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glGetUniformLocationARB")]
            public static extern Int32 GetUniformLocation(UInt32 programObj, String name);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Return a generic vertex attribute parameter
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the generic vertex attribute parameter to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested data.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glGetVertexAttribdvARB")]
            public static extern void GetVertexAttrib(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribParameterArb pname, [OutAttribute] Double[] @params);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Return a generic vertex attribute parameter
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the generic vertex attribute parameter to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested data.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glGetVertexAttribdvARB")]
            public static extern void GetVertexAttrib(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribParameterArb pname, [OutAttribute] out Double @params);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Return a generic vertex attribute parameter
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the generic vertex attribute parameter to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested data.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glGetVertexAttribdvARB")]
            public static extern unsafe void GetVertexAttrib(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribParameterArb pname, [OutAttribute] Double* @params);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Return a generic vertex attribute parameter
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the generic vertex attribute parameter to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested data.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glGetVertexAttribdvARB")]
            public static extern void GetVertexAttrib(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameterArb pname, [OutAttribute] Double[] @params);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Return a generic vertex attribute parameter
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the generic vertex attribute parameter to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested data.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glGetVertexAttribdvARB")]
            public static extern void GetVertexAttrib(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameterArb pname, [OutAttribute] out Double @params);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Return a generic vertex attribute parameter
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the generic vertex attribute parameter to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested data.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glGetVertexAttribdvARB")]
            public static extern unsafe void GetVertexAttrib(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameterArb pname, [OutAttribute] Double* @params);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Return a generic vertex attribute parameter
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the generic vertex attribute parameter to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested data.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glGetVertexAttribfvARB")]
            public static extern void GetVertexAttrib(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribParameterArb pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Return a generic vertex attribute parameter
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the generic vertex attribute parameter to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested data.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glGetVertexAttribfvARB")]
            public static extern void GetVertexAttrib(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribParameterArb pname, [OutAttribute] out Single @params);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Return a generic vertex attribute parameter
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the generic vertex attribute parameter to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested data.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glGetVertexAttribfvARB")]
            public static extern unsafe void GetVertexAttrib(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribParameterArb pname, [OutAttribute] Single* @params);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Return a generic vertex attribute parameter
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the generic vertex attribute parameter to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested data.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glGetVertexAttribfvARB")]
            public static extern void GetVertexAttrib(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameterArb pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Return a generic vertex attribute parameter
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the generic vertex attribute parameter to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested data.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glGetVertexAttribfvARB")]
            public static extern void GetVertexAttrib(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameterArb pname, [OutAttribute] out Single @params);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Return a generic vertex attribute parameter
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the generic vertex attribute parameter to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested data.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glGetVertexAttribfvARB")]
            public static extern unsafe void GetVertexAttrib(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameterArb pname, [OutAttribute] Single* @params);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Return a generic vertex attribute parameter
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the generic vertex attribute parameter to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested data.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glGetVertexAttribivARB")]
            public static extern void GetVertexAttrib(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribParameterArb pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Return a generic vertex attribute parameter
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the generic vertex attribute parameter to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested data.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glGetVertexAttribivARB")]
            public static extern void GetVertexAttrib(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribParameterArb pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Return a generic vertex attribute parameter
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the generic vertex attribute parameter to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested data.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glGetVertexAttribivARB")]
            public static extern unsafe void GetVertexAttrib(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribParameterArb pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Return a generic vertex attribute parameter
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the generic vertex attribute parameter to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested data.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glGetVertexAttribivARB")]
            public static extern void GetVertexAttrib(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameterArb pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Return a generic vertex attribute parameter
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the generic vertex attribute parameter to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested data.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glGetVertexAttribivARB")]
            public static extern void GetVertexAttrib(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameterArb pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Return a generic vertex attribute parameter
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the generic vertex attribute parameter to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested data.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glGetVertexAttribivARB")]
            public static extern unsafe void GetVertexAttrib(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameterArb pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glGetVertexAttribLui64vARB")]
            public static extern void GetVertexAttribL(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribParameterArb pname, [OutAttribute] Int64[] @params);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glGetVertexAttribLui64vARB")]
            public static extern void GetVertexAttribL(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribParameterArb pname, [OutAttribute] out Int64 @params);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glGetVertexAttribLui64vARB")]
            public static extern unsafe void GetVertexAttribL(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribParameterArb pname, [OutAttribute] Int64* @params);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glGetVertexAttribLui64vARB")]
            public static extern void GetVertexAttribL(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameterArb pname, [OutAttribute] UInt64[] @params);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glGetVertexAttribLui64vARB")]
            public static extern void GetVertexAttribL(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameterArb pname, [OutAttribute] out UInt64 @params);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glGetVertexAttribLui64vARB")]
            public static extern unsafe void GetVertexAttribL(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameterArb pname, [OutAttribute] UInt64* @params);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glGetVertexAttribPointervARB")]
            public static extern void GetVertexAttribPointer(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribPointerParameterArb pname, [OutAttribute] IntPtr pointer);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glGetVertexAttribPointervARB")]
            public static extern void GetVertexAttribPointer<T2>(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribPointerParameterArb pname, [InAttribute, OutAttribute] T2[] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glGetVertexAttribPointervARB")]
            public static extern void GetVertexAttribPointer<T2>(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribPointerParameterArb pname, [InAttribute, OutAttribute] T2[,] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glGetVertexAttribPointervARB")]
            public static extern void GetVertexAttribPointer<T2>(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribPointerParameterArb pname, [InAttribute, OutAttribute] T2[,,] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glGetVertexAttribPointervARB")]
            public static extern void GetVertexAttribPointer<T2>(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribPointerParameterArb pname, [InAttribute, OutAttribute] ref T2 pointer)
                where T2 : struct
            ;

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glGetVertexAttribPointervARB")]
            public static extern void GetVertexAttribPointer(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribPointerParameterArb pname, [OutAttribute] IntPtr pointer);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glGetVertexAttribPointervARB")]
            public static extern void GetVertexAttribPointer<T2>(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribPointerParameterArb pname, [InAttribute, OutAttribute] T2[] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glGetVertexAttribPointervARB")]
            public static extern void GetVertexAttribPointer<T2>(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribPointerParameterArb pname, [InAttribute, OutAttribute] T2[,] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glGetVertexAttribPointervARB")]
            public static extern void GetVertexAttribPointer<T2>(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribPointerParameterArb pname, [InAttribute, OutAttribute] T2[,,] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glGetVertexAttribPointervARB")]
            public static extern void GetVertexAttribPointer<T2>(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribPointerParameterArb pname, [InAttribute, OutAttribute] ref T2 pointer)
                where T2 : struct
            ;

            /// <summary>[requires: ARB_vertex_buffer_object]
            /// Determine if a name corresponds to a buffer object
            /// </summary>
            /// <param name="buffer">
            /// <para>
            /// Specifies a value that may be the name of a buffer object.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glIsBufferARB")]
            public static extern bool IsBuffer(Int32 buffer);

            /// <summary>[requires: ARB_vertex_buffer_object]
            /// Determine if a name corresponds to a buffer object
            /// </summary>
            /// <param name="buffer">
            /// <para>
            /// Specifies a value that may be the name of a buffer object.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glIsBufferARB")]
            public static extern bool IsBuffer(UInt32 buffer);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glIsImageHandleResidentARB")]
            public static extern bool IsImageHandleResident(Int64 handle);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glIsImageHandleResidentARB")]
            public static extern bool IsImageHandleResident(UInt64 handle);

            /// <summary>[requires: ARB_shading_language_include]</summary>
            [AutoGenerated(Category = "ARB_shading_language_include", Version = "", EntryPoint = "glIsNamedStringARB")]
            public static extern bool IsNamedString(Int32 namelen, String name);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]
            /// Determines if a name corresponds to a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies a potential program object.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glIsProgramARB")]
            public static extern bool IsProgram(Int32 program);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]
            /// Determines if a name corresponds to a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies a potential program object.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glIsProgramARB")]
            public static extern bool IsProgram(UInt32 program);

            /// <summary>[requires: ARB_occlusion_query]
            /// Determine if a name corresponds to a query object
            /// </summary>
            /// <param name="id">
            /// <para>
            /// Specifies a value that may be the name of a query object.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_occlusion_query", Version = "", EntryPoint = "glIsQueryARB")]
            public static extern bool IsQuery(Int32 id);

            /// <summary>[requires: ARB_occlusion_query]
            /// Determine if a name corresponds to a query object
            /// </summary>
            /// <param name="id">
            /// <para>
            /// Specifies a value that may be the name of a query object.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_occlusion_query", Version = "", EntryPoint = "glIsQueryARB")]
            public static extern bool IsQuery(UInt32 id);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glIsTextureHandleResidentARB")]
            public static extern bool IsTextureHandleResident(Int64 handle);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glIsTextureHandleResidentARB")]
            public static extern bool IsTextureHandleResident(UInt64 handle);

            /// <summary>[requires: ARB_shader_objects]
            /// Links a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program object to be linked.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glLinkProgramARB")]
            public static extern void LinkProgram(Int32 programObj);

            /// <summary>[requires: ARB_shader_objects]
            /// Links a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program object to be linked.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glLinkProgramARB")]
            public static extern void LinkProgram(UInt32 programObj);

            /// <summary>[requires: ARB_transpose_matrix]
            /// Replace the current matrix with the specified row-major ordered matrix
            /// </summary>
            /// <param name="m">
            /// <para>
            /// Specifies a pointer to 16 consecutive values, which are used as the elements of a 4 times 4 row-major matrix.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_transpose_matrix", Version = "", EntryPoint = "glLoadTransposeMatrixdARB")]
            public static extern void LoadTransposeMatrix(Double[] m);

            /// <summary>[requires: ARB_transpose_matrix]
            /// Replace the current matrix with the specified row-major ordered matrix
            /// </summary>
            /// <param name="m">
            /// <para>
            /// Specifies a pointer to 16 consecutive values, which are used as the elements of a 4 times 4 row-major matrix.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_transpose_matrix", Version = "", EntryPoint = "glLoadTransposeMatrixdARB")]
            public static extern void LoadTransposeMatrix(ref Double m);

            /// <summary>[requires: ARB_transpose_matrix]
            /// Replace the current matrix with the specified row-major ordered matrix
            /// </summary>
            /// <param name="m">
            /// <para>
            /// Specifies a pointer to 16 consecutive values, which are used as the elements of a 4 times 4 row-major matrix.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_transpose_matrix", Version = "", EntryPoint = "glLoadTransposeMatrixdARB")]
            public static extern unsafe void LoadTransposeMatrix(Double* m);

            /// <summary>[requires: ARB_transpose_matrix]
            /// Replace the current matrix with the specified row-major ordered matrix
            /// </summary>
            /// <param name="m">
            /// <para>
            /// Specifies a pointer to 16 consecutive values, which are used as the elements of a 4 times 4 row-major matrix.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_transpose_matrix", Version = "", EntryPoint = "glLoadTransposeMatrixfARB")]
            public static extern void LoadTransposeMatrix(Single[] m);

            /// <summary>[requires: ARB_transpose_matrix]
            /// Replace the current matrix with the specified row-major ordered matrix
            /// </summary>
            /// <param name="m">
            /// <para>
            /// Specifies a pointer to 16 consecutive values, which are used as the elements of a 4 times 4 row-major matrix.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_transpose_matrix", Version = "", EntryPoint = "glLoadTransposeMatrixfARB")]
            public static extern void LoadTransposeMatrix(ref Single m);

            /// <summary>[requires: ARB_transpose_matrix]
            /// Replace the current matrix with the specified row-major ordered matrix
            /// </summary>
            /// <param name="m">
            /// <para>
            /// Specifies a pointer to 16 consecutive values, which are used as the elements of a 4 times 4 row-major matrix.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_transpose_matrix", Version = "", EntryPoint = "glLoadTransposeMatrixfARB")]
            public static extern unsafe void LoadTransposeMatrix(Single* m);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glMakeImageHandleNonResidentARB")]
            public static extern void MakeImageHandleNonResident(Int64 handle);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glMakeImageHandleNonResidentARB")]
            public static extern void MakeImageHandleNonResident(UInt64 handle);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glMakeImageHandleResidentARB")]
            public static extern void MakeImageHandleResident(Int64 handle, OpenTK.Graphics.OpenGL.ArbBindlessTexture access);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glMakeImageHandleResidentARB")]
            public static extern void MakeImageHandleResident(UInt64 handle, OpenTK.Graphics.OpenGL.ArbBindlessTexture access);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glMakeTextureHandleNonResidentARB")]
            public static extern void MakeTextureHandleNonResident(Int64 handle);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glMakeTextureHandleNonResidentARB")]
            public static extern void MakeTextureHandleNonResident(UInt64 handle);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glMakeTextureHandleResidentARB")]
            public static extern void MakeTextureHandleResident(Int64 handle);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glMakeTextureHandleResidentARB")]
            public static extern void MakeTextureHandleResident(UInt64 handle);

            /// <summary>[requires: ARB_vertex_buffer_object]
            /// Map a buffer object's data store
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target buffer object being mapped. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER or GL_UNIFORM_BUFFER.
            /// </para>
            /// </param>
            /// <param name="access">
            /// <para>
            /// For glMapBuffer only, specifies the access policy, indicating whether it will be possible to read from, write to, or both read from and write to the buffer object's mapped data store. The symbolic constant must be GL_READ_ONLY, GL_WRITE_ONLY, or GL_READ_WRITE.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glMapBufferARB")]
            public static extern IntPtr MapBuffer(OpenTK.Graphics.OpenGL.BufferTargetArb target, OpenTK.Graphics.OpenGL.ArbVertexBufferObject access);

            /// <summary>[requires: ARB_matrix_palette]</summary>
            [AutoGenerated(Category = "ARB_matrix_palette", Version = "", EntryPoint = "glMatrixIndexPointerARB")]
            public static extern void MatrixIndexPointer(Int32 size, OpenTK.Graphics.OpenGL.ArbMatrixPalette type, Int32 stride, IntPtr pointer);

            /// <summary>[requires: ARB_matrix_palette]</summary>
            [AutoGenerated(Category = "ARB_matrix_palette", Version = "", EntryPoint = "glMatrixIndexPointerARB")]
            public static extern void MatrixIndexPointer<T3>(Int32 size, OpenTK.Graphics.OpenGL.ArbMatrixPalette type, Int32 stride, [InAttribute, OutAttribute] T3[] pointer)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_matrix_palette]</summary>
            [AutoGenerated(Category = "ARB_matrix_palette", Version = "", EntryPoint = "glMatrixIndexPointerARB")]
            public static extern void MatrixIndexPointer<T3>(Int32 size, OpenTK.Graphics.OpenGL.ArbMatrixPalette type, Int32 stride, [InAttribute, OutAttribute] T3[,] pointer)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_matrix_palette]</summary>
            [AutoGenerated(Category = "ARB_matrix_palette", Version = "", EntryPoint = "glMatrixIndexPointerARB")]
            public static extern void MatrixIndexPointer<T3>(Int32 size, OpenTK.Graphics.OpenGL.ArbMatrixPalette type, Int32 stride, [InAttribute, OutAttribute] T3[,,] pointer)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_matrix_palette]</summary>
            [AutoGenerated(Category = "ARB_matrix_palette", Version = "", EntryPoint = "glMatrixIndexPointerARB")]
            public static extern void MatrixIndexPointer<T3>(Int32 size, OpenTK.Graphics.OpenGL.ArbMatrixPalette type, Int32 stride, [InAttribute, OutAttribute] ref T3 pointer)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_matrix_palette]</summary>
            [AutoGenerated(Category = "ARB_matrix_palette", Version = "", EntryPoint = "glMatrixIndexubvARB")]
            public static extern void MatrixIndex(Int32 size, Byte[] indices);

            /// <summary>[requires: ARB_matrix_palette]</summary>
            [AutoGenerated(Category = "ARB_matrix_palette", Version = "", EntryPoint = "glMatrixIndexubvARB")]
            public static extern void MatrixIndex(Int32 size, ref Byte indices);

            /// <summary>[requires: ARB_matrix_palette]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_matrix_palette", Version = "", EntryPoint = "glMatrixIndexubvARB")]
            public static extern unsafe void MatrixIndex(Int32 size, Byte* indices);

            /// <summary>[requires: ARB_matrix_palette]</summary>
            [AutoGenerated(Category = "ARB_matrix_palette", Version = "", EntryPoint = "glMatrixIndexuivARB")]
            public static extern void MatrixIndex(Int32 size, Int32[] indices);

            /// <summary>[requires: ARB_matrix_palette]</summary>
            [AutoGenerated(Category = "ARB_matrix_palette", Version = "", EntryPoint = "glMatrixIndexuivARB")]
            public static extern void MatrixIndex(Int32 size, ref Int32 indices);

            /// <summary>[requires: ARB_matrix_palette]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_matrix_palette", Version = "", EntryPoint = "glMatrixIndexuivARB")]
            public static extern unsafe void MatrixIndex(Int32 size, Int32* indices);

            /// <summary>[requires: ARB_matrix_palette]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_matrix_palette", Version = "", EntryPoint = "glMatrixIndexuivARB")]
            public static extern void MatrixIndex(Int32 size, UInt32[] indices);

            /// <summary>[requires: ARB_matrix_palette]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_matrix_palette", Version = "", EntryPoint = "glMatrixIndexuivARB")]
            public static extern void MatrixIndex(Int32 size, ref UInt32 indices);

            /// <summary>[requires: ARB_matrix_palette]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_matrix_palette", Version = "", EntryPoint = "glMatrixIndexuivARB")]
            public static extern unsafe void MatrixIndex(Int32 size, UInt32* indices);

            /// <summary>[requires: ARB_matrix_palette]</summary>
            [AutoGenerated(Category = "ARB_matrix_palette", Version = "", EntryPoint = "glMatrixIndexusvARB")]
            public static extern void MatrixIndex(Int32 size, Int16[] indices);

            /// <summary>[requires: ARB_matrix_palette]</summary>
            [AutoGenerated(Category = "ARB_matrix_palette", Version = "", EntryPoint = "glMatrixIndexusvARB")]
            public static extern void MatrixIndex(Int32 size, ref Int16 indices);

            /// <summary>[requires: ARB_matrix_palette]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_matrix_palette", Version = "", EntryPoint = "glMatrixIndexusvARB")]
            public static extern unsafe void MatrixIndex(Int32 size, Int16* indices);

            /// <summary>[requires: ARB_matrix_palette]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_matrix_palette", Version = "", EntryPoint = "glMatrixIndexusvARB")]
            public static extern void MatrixIndex(Int32 size, UInt16[] indices);

            /// <summary>[requires: ARB_matrix_palette]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_matrix_palette", Version = "", EntryPoint = "glMatrixIndexusvARB")]
            public static extern void MatrixIndex(Int32 size, ref UInt16 indices);

            /// <summary>[requires: ARB_matrix_palette]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_matrix_palette", Version = "", EntryPoint = "glMatrixIndexusvARB")]
            public static extern unsafe void MatrixIndex(Int32 size, UInt16* indices);

            /// <summary>[requires: ARB_sample_shading]
            /// Specifies minimum rate at which sample shaing takes place
            /// </summary>
            /// <param name="value">
            /// <para>
            /// Specifies the rate at which samples are shaded within each covered pixel.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_sample_shading", Version = "", EntryPoint = "glMinSampleShadingARB")]
            public static extern void MinSampleShading(Single value);

            /// <summary>[requires: ARB_indirect_parameters]</summary>
            [AutoGenerated(Category = "ARB_indirect_parameters", Version = "", EntryPoint = "glMultiDrawArraysIndirectCountARB")]
            public static extern void MultiDrawArraysIndirectCount(OpenTK.Graphics.OpenGL.ArbIndirectParameters mode, IntPtr indirect, IntPtr drawcount, Int32 maxdrawcount, Int32 stride);

            /// <summary>[requires: ARB_indirect_parameters]</summary>
            [AutoGenerated(Category = "ARB_indirect_parameters", Version = "", EntryPoint = "glMultiDrawElementsIndirectCountARB")]
            public static extern void MultiDrawElementsIndirectCount(OpenTK.Graphics.OpenGL.ArbIndirectParameters mode, OpenTK.Graphics.OpenGL.ArbIndirectParameters type, IntPtr indirect, IntPtr drawcount, Int32 maxdrawcount, Int32 stride);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord1dARB")]
            public static extern void MultiTexCoord1(OpenTK.Graphics.OpenGL.TextureUnit target, Double s);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord1dvARB")]
            public static extern unsafe void MultiTexCoord1(OpenTK.Graphics.OpenGL.TextureUnit target, Double* v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord1fARB")]
            public static extern void MultiTexCoord1(OpenTK.Graphics.OpenGL.TextureUnit target, Single s);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord1fvARB")]
            public static extern unsafe void MultiTexCoord1(OpenTK.Graphics.OpenGL.TextureUnit target, Single* v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord1iARB")]
            public static extern void MultiTexCoord1(OpenTK.Graphics.OpenGL.TextureUnit target, Int32 s);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord1ivARB")]
            public static extern unsafe void MultiTexCoord1(OpenTK.Graphics.OpenGL.TextureUnit target, Int32* v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord1sARB")]
            public static extern void MultiTexCoord1(OpenTK.Graphics.OpenGL.TextureUnit target, Int16 s);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord1svARB")]
            public static extern unsafe void MultiTexCoord1(OpenTK.Graphics.OpenGL.TextureUnit target, Int16* v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord2dARB")]
            public static extern void MultiTexCoord2(OpenTK.Graphics.OpenGL.TextureUnit target, Double s, Double t);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord2dvARB")]
            public static extern void MultiTexCoord2(OpenTK.Graphics.OpenGL.TextureUnit target, Double[] v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord2dvARB")]
            public static extern void MultiTexCoord2(OpenTK.Graphics.OpenGL.TextureUnit target, ref Double v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord2dvARB")]
            public static extern unsafe void MultiTexCoord2(OpenTK.Graphics.OpenGL.TextureUnit target, Double* v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord2fARB")]
            public static extern void MultiTexCoord2(OpenTK.Graphics.OpenGL.TextureUnit target, Single s, Single t);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord2fvARB")]
            public static extern void MultiTexCoord2(OpenTK.Graphics.OpenGL.TextureUnit target, Single[] v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord2fvARB")]
            public static extern void MultiTexCoord2(OpenTK.Graphics.OpenGL.TextureUnit target, ref Single v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord2fvARB")]
            public static extern unsafe void MultiTexCoord2(OpenTK.Graphics.OpenGL.TextureUnit target, Single* v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord2iARB")]
            public static extern void MultiTexCoord2(OpenTK.Graphics.OpenGL.TextureUnit target, Int32 s, Int32 t);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord2ivARB")]
            public static extern void MultiTexCoord2(OpenTK.Graphics.OpenGL.TextureUnit target, Int32[] v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord2ivARB")]
            public static extern void MultiTexCoord2(OpenTK.Graphics.OpenGL.TextureUnit target, ref Int32 v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord2ivARB")]
            public static extern unsafe void MultiTexCoord2(OpenTK.Graphics.OpenGL.TextureUnit target, Int32* v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord2sARB")]
            public static extern void MultiTexCoord2(OpenTK.Graphics.OpenGL.TextureUnit target, Int16 s, Int16 t);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord2svARB")]
            public static extern void MultiTexCoord2(OpenTK.Graphics.OpenGL.TextureUnit target, Int16[] v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord2svARB")]
            public static extern void MultiTexCoord2(OpenTK.Graphics.OpenGL.TextureUnit target, ref Int16 v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord2svARB")]
            public static extern unsafe void MultiTexCoord2(OpenTK.Graphics.OpenGL.TextureUnit target, Int16* v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord3dARB")]
            public static extern void MultiTexCoord3(OpenTK.Graphics.OpenGL.TextureUnit target, Double s, Double t, Double r);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord3dvARB")]
            public static extern void MultiTexCoord3(OpenTK.Graphics.OpenGL.TextureUnit target, Double[] v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord3dvARB")]
            public static extern void MultiTexCoord3(OpenTK.Graphics.OpenGL.TextureUnit target, ref Double v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord3dvARB")]
            public static extern unsafe void MultiTexCoord3(OpenTK.Graphics.OpenGL.TextureUnit target, Double* v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord3fARB")]
            public static extern void MultiTexCoord3(OpenTK.Graphics.OpenGL.TextureUnit target, Single s, Single t, Single r);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord3fvARB")]
            public static extern void MultiTexCoord3(OpenTK.Graphics.OpenGL.TextureUnit target, Single[] v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord3fvARB")]
            public static extern void MultiTexCoord3(OpenTK.Graphics.OpenGL.TextureUnit target, ref Single v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord3fvARB")]
            public static extern unsafe void MultiTexCoord3(OpenTK.Graphics.OpenGL.TextureUnit target, Single* v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord3iARB")]
            public static extern void MultiTexCoord3(OpenTK.Graphics.OpenGL.TextureUnit target, Int32 s, Int32 t, Int32 r);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord3ivARB")]
            public static extern void MultiTexCoord3(OpenTK.Graphics.OpenGL.TextureUnit target, Int32[] v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord3ivARB")]
            public static extern void MultiTexCoord3(OpenTK.Graphics.OpenGL.TextureUnit target, ref Int32 v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord3ivARB")]
            public static extern unsafe void MultiTexCoord3(OpenTK.Graphics.OpenGL.TextureUnit target, Int32* v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord3sARB")]
            public static extern void MultiTexCoord3(OpenTK.Graphics.OpenGL.TextureUnit target, Int16 s, Int16 t, Int16 r);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord3svARB")]
            public static extern void MultiTexCoord3(OpenTK.Graphics.OpenGL.TextureUnit target, Int16[] v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord3svARB")]
            public static extern void MultiTexCoord3(OpenTK.Graphics.OpenGL.TextureUnit target, ref Int16 v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord3svARB")]
            public static extern unsafe void MultiTexCoord3(OpenTK.Graphics.OpenGL.TextureUnit target, Int16* v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord4dARB")]
            public static extern void MultiTexCoord4(OpenTK.Graphics.OpenGL.TextureUnit target, Double s, Double t, Double r, Double q);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord4dvARB")]
            public static extern void MultiTexCoord4(OpenTK.Graphics.OpenGL.TextureUnit target, Double[] v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord4dvARB")]
            public static extern void MultiTexCoord4(OpenTK.Graphics.OpenGL.TextureUnit target, ref Double v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord4dvARB")]
            public static extern unsafe void MultiTexCoord4(OpenTK.Graphics.OpenGL.TextureUnit target, Double* v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord4fARB")]
            public static extern void MultiTexCoord4(OpenTK.Graphics.OpenGL.TextureUnit target, Single s, Single t, Single r, Single q);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord4fvARB")]
            public static extern void MultiTexCoord4(OpenTK.Graphics.OpenGL.TextureUnit target, Single[] v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord4fvARB")]
            public static extern void MultiTexCoord4(OpenTK.Graphics.OpenGL.TextureUnit target, ref Single v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord4fvARB")]
            public static extern unsafe void MultiTexCoord4(OpenTK.Graphics.OpenGL.TextureUnit target, Single* v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord4iARB")]
            public static extern void MultiTexCoord4(OpenTK.Graphics.OpenGL.TextureUnit target, Int32 s, Int32 t, Int32 r, Int32 q);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord4ivARB")]
            public static extern void MultiTexCoord4(OpenTK.Graphics.OpenGL.TextureUnit target, Int32[] v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord4ivARB")]
            public static extern void MultiTexCoord4(OpenTK.Graphics.OpenGL.TextureUnit target, ref Int32 v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord4ivARB")]
            public static extern unsafe void MultiTexCoord4(OpenTK.Graphics.OpenGL.TextureUnit target, Int32* v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord4sARB")]
            public static extern void MultiTexCoord4(OpenTK.Graphics.OpenGL.TextureUnit target, Int16 s, Int16 t, Int16 r, Int16 q);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord4svARB")]
            public static extern void MultiTexCoord4(OpenTK.Graphics.OpenGL.TextureUnit target, Int16[] v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord4svARB")]
            public static extern void MultiTexCoord4(OpenTK.Graphics.OpenGL.TextureUnit target, ref Int16 v);

            /// <summary>[requires: ARB_multitexture]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_multitexture", Version = "", EntryPoint = "glMultiTexCoord4svARB")]
            public static extern unsafe void MultiTexCoord4(OpenTK.Graphics.OpenGL.TextureUnit target, Int16* v);

            /// <summary>[requires: ARB_transpose_matrix]
            /// Multiply the current matrix with the specified row-major ordered matrix
            /// </summary>
            /// <param name="m">
            /// <para>
            /// Points to 16 consecutive values that are used as the elements of a 4 times 4 row-major matrix.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_transpose_matrix", Version = "", EntryPoint = "glMultTransposeMatrixdARB")]
            public static extern void MultTransposeMatrix(Double[] m);

            /// <summary>[requires: ARB_transpose_matrix]
            /// Multiply the current matrix with the specified row-major ordered matrix
            /// </summary>
            /// <param name="m">
            /// <para>
            /// Points to 16 consecutive values that are used as the elements of a 4 times 4 row-major matrix.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_transpose_matrix", Version = "", EntryPoint = "glMultTransposeMatrixdARB")]
            public static extern void MultTransposeMatrix(ref Double m);

            /// <summary>[requires: ARB_transpose_matrix]
            /// Multiply the current matrix with the specified row-major ordered matrix
            /// </summary>
            /// <param name="m">
            /// <para>
            /// Points to 16 consecutive values that are used as the elements of a 4 times 4 row-major matrix.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_transpose_matrix", Version = "", EntryPoint = "glMultTransposeMatrixdARB")]
            public static extern unsafe void MultTransposeMatrix(Double* m);

            /// <summary>[requires: ARB_transpose_matrix]
            /// Multiply the current matrix with the specified row-major ordered matrix
            /// </summary>
            /// <param name="m">
            /// <para>
            /// Points to 16 consecutive values that are used as the elements of a 4 times 4 row-major matrix.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_transpose_matrix", Version = "", EntryPoint = "glMultTransposeMatrixfARB")]
            public static extern void MultTransposeMatrix(Single[] m);

            /// <summary>[requires: ARB_transpose_matrix]
            /// Multiply the current matrix with the specified row-major ordered matrix
            /// </summary>
            /// <param name="m">
            /// <para>
            /// Points to 16 consecutive values that are used as the elements of a 4 times 4 row-major matrix.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_transpose_matrix", Version = "", EntryPoint = "glMultTransposeMatrixfARB")]
            public static extern void MultTransposeMatrix(ref Single m);

            /// <summary>[requires: ARB_transpose_matrix]
            /// Multiply the current matrix with the specified row-major ordered matrix
            /// </summary>
            /// <param name="m">
            /// <para>
            /// Points to 16 consecutive values that are used as the elements of a 4 times 4 row-major matrix.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_transpose_matrix", Version = "", EntryPoint = "glMultTransposeMatrixfARB")]
            public static extern unsafe void MultTransposeMatrix(Single* m);

            /// <summary>[requires: ARB_shading_language_include]</summary>
            [AutoGenerated(Category = "ARB_shading_language_include", Version = "", EntryPoint = "glNamedStringARB")]
            public static extern void NamedString(OpenTK.Graphics.OpenGL.ArbShadingLanguageInclude type, Int32 namelen, String name, Int32 stringlen, String @string);

            /// <summary>[requires: ARB_point_parameters]
            /// Specify point parameters
            /// </summary>
            /// <param name="pname">
            /// <para>
            /// Specifies a single-valued point parameter. GL_POINT_FADE_THRESHOLD_SIZE, and GL_POINT_SPRITE_COORD_ORIGIN are accepted.
            /// </para>
            /// </param>
            /// <param name="param">
            /// <para>
            /// For glPointParameterf and glPointParameteri, specifies the value that pname will be set to.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// For glPointParameterfv and glPointParameteriv, specifies a pointer to an array where the value or values to be assigned to pname are stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_point_parameters", Version = "", EntryPoint = "glPointParameterfARB")]
            public static extern void PointParameter(OpenTK.Graphics.OpenGL.ArbPointParameters pname, Single param);

            /// <summary>[requires: ARB_point_parameters]
            /// Specify point parameters
            /// </summary>
            /// <param name="pname">
            /// <para>
            /// Specifies a single-valued point parameter. GL_POINT_FADE_THRESHOLD_SIZE, and GL_POINT_SPRITE_COORD_ORIGIN are accepted.
            /// </para>
            /// </param>
            /// <param name="param">
            /// <para>
            /// For glPointParameterf and glPointParameteri, specifies the value that pname will be set to.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// For glPointParameterfv and glPointParameteriv, specifies a pointer to an array where the value or values to be assigned to pname are stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_point_parameters", Version = "", EntryPoint = "glPointParameterfvARB")]
            public static extern void PointParameter(OpenTK.Graphics.OpenGL.ArbPointParameters pname, Single[] @params);

            /// <summary>[requires: ARB_point_parameters]
            /// Specify point parameters
            /// </summary>
            /// <param name="pname">
            /// <para>
            /// Specifies a single-valued point parameter. GL_POINT_FADE_THRESHOLD_SIZE, and GL_POINT_SPRITE_COORD_ORIGIN are accepted.
            /// </para>
            /// </param>
            /// <param name="param">
            /// <para>
            /// For glPointParameterf and glPointParameteri, specifies the value that pname will be set to.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// For glPointParameterfv and glPointParameteriv, specifies a pointer to an array where the value or values to be assigned to pname are stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_point_parameters", Version = "", EntryPoint = "glPointParameterfvARB")]
            public static extern unsafe void PointParameter(OpenTK.Graphics.OpenGL.ArbPointParameters pname, Single* @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramEnvParameter4dARB")]
            public static extern void ProgramEnvParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, Double x, Double y, Double z, Double w);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramEnvParameter4dARB")]
            public static extern void ProgramEnvParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Double x, Double y, Double z, Double w);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramEnvParameter4dvARB")]
            public static extern void ProgramEnvParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, Double[] @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramEnvParameter4dvARB")]
            public static extern void ProgramEnvParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, ref Double @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramEnvParameter4dvARB")]
            public static extern unsafe void ProgramEnvParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, Double* @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramEnvParameter4dvARB")]
            public static extern void ProgramEnvParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Double[] @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramEnvParameter4dvARB")]
            public static extern void ProgramEnvParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, ref Double @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramEnvParameter4dvARB")]
            public static extern unsafe void ProgramEnvParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Double* @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramEnvParameter4fARB")]
            public static extern void ProgramEnvParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, Single x, Single y, Single z, Single w);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramEnvParameter4fARB")]
            public static extern void ProgramEnvParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Single x, Single y, Single z, Single w);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramEnvParameter4fvARB")]
            public static extern void ProgramEnvParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, Single[] @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramEnvParameter4fvARB")]
            public static extern void ProgramEnvParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, ref Single @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramEnvParameter4fvARB")]
            public static extern unsafe void ProgramEnvParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, Single* @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramEnvParameter4fvARB")]
            public static extern void ProgramEnvParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Single[] @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramEnvParameter4fvARB")]
            public static extern void ProgramEnvParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, ref Single @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramEnvParameter4fvARB")]
            public static extern unsafe void ProgramEnvParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Single* @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramLocalParameter4dARB")]
            public static extern void ProgramLocalParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, Double x, Double y, Double z, Double w);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramLocalParameter4dARB")]
            public static extern void ProgramLocalParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Double x, Double y, Double z, Double w);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramLocalParameter4dvARB")]
            public static extern void ProgramLocalParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, Double[] @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramLocalParameter4dvARB")]
            public static extern void ProgramLocalParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, ref Double @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramLocalParameter4dvARB")]
            public static extern unsafe void ProgramLocalParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, Double* @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramLocalParameter4dvARB")]
            public static extern void ProgramLocalParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Double[] @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramLocalParameter4dvARB")]
            public static extern void ProgramLocalParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, ref Double @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramLocalParameter4dvARB")]
            public static extern unsafe void ProgramLocalParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Double* @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramLocalParameter4fARB")]
            public static extern void ProgramLocalParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, Single x, Single y, Single z, Single w);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramLocalParameter4fARB")]
            public static extern void ProgramLocalParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Single x, Single y, Single z, Single w);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramLocalParameter4fvARB")]
            public static extern void ProgramLocalParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, Single[] @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramLocalParameter4fvARB")]
            public static extern void ProgramLocalParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, ref Single @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramLocalParameter4fvARB")]
            public static extern unsafe void ProgramLocalParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, Single* @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramLocalParameter4fvARB")]
            public static extern void ProgramLocalParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Single[] @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramLocalParameter4fvARB")]
            public static extern void ProgramLocalParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, ref Single @params);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramLocalParameter4fvARB")]
            public static extern unsafe void ProgramLocalParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Single* @params);

            /// <summary>[requires: ARB_geometry_shader4]
            /// Specify a parameter for a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the name of a program object whose parameter to modify.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the name of the parameter to modify.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// Specifies the new value of the parameter specified by pname for program.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_geometry_shader4", Version = "", EntryPoint = "glProgramParameteriARB")]
            public static extern void ProgramParameter(Int32 program, OpenTK.Graphics.OpenGL.AssemblyProgramParameterArb pname, Int32 value);

            /// <summary>[requires: ARB_geometry_shader4]
            /// Specify a parameter for a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the name of a program object whose parameter to modify.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the name of the parameter to modify.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// Specifies the new value of the parameter specified by pname for program.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_geometry_shader4", Version = "", EntryPoint = "glProgramParameteriARB")]
            public static extern void ProgramParameter(UInt32 program, OpenTK.Graphics.OpenGL.AssemblyProgramParameterArb pname, Int32 value);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramStringARB")]
            public static extern void ProgramString(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, OpenTK.Graphics.OpenGL.All format, Int32 len, IntPtr @string);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramStringARB")]
            public static extern void ProgramString<T3>(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, OpenTK.Graphics.OpenGL.All format, Int32 len, [InAttribute, OutAttribute] T3[] @string)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramStringARB")]
            public static extern void ProgramString<T3>(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, OpenTK.Graphics.OpenGL.All format, Int32 len, [InAttribute, OutAttribute] T3[,] @string)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramStringARB")]
            public static extern void ProgramString<T3>(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, OpenTK.Graphics.OpenGL.All format, Int32 len, [InAttribute, OutAttribute] T3[,,] @string)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramStringARB")]
            public static extern void ProgramString<T3>(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, OpenTK.Graphics.OpenGL.All format, Int32 len, [InAttribute, OutAttribute] ref T3 @string)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [Obsolete("Use All overload instead")]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramStringARB")]
            public static extern void ProgramString(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, OpenTK.Graphics.OpenGL.ArbVertexProgram format, Int32 len, IntPtr @string);

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [Obsolete("Use All overload instead")]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramStringARB")]
            public static extern void ProgramString<T3>(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, OpenTK.Graphics.OpenGL.ArbVertexProgram format, Int32 len, [InAttribute, OutAttribute] T3[] @string)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [Obsolete("Use All overload instead")]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramStringARB")]
            public static extern void ProgramString<T3>(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, OpenTK.Graphics.OpenGL.ArbVertexProgram format, Int32 len, [InAttribute, OutAttribute] T3[,] @string)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [Obsolete("Use All overload instead")]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramStringARB")]
            public static extern void ProgramString<T3>(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, OpenTK.Graphics.OpenGL.ArbVertexProgram format, Int32 len, [InAttribute, OutAttribute] T3[,,] @string)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_fragment_program|ARB_vertex_program]</summary>
            [Obsolete("Use All overload instead")]
            [AutoGenerated(Category = "ARB_fragment_program|ARB_vertex_program", Version = "", EntryPoint = "glProgramStringARB")]
            public static extern void ProgramString<T3>(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, OpenTK.Graphics.OpenGL.ArbVertexProgram format, Int32 len, [InAttribute, OutAttribute] ref T3 @string)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glProgramUniformHandleui64ARB")]
            public static extern void ProgramUniformHandle(Int32 program, Int32 location, Int64 value);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glProgramUniformHandleui64ARB")]
            public static extern void ProgramUniformHandle(UInt32 program, Int32 location, UInt64 value);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glProgramUniformHandleui64vARB")]
            public static extern void ProgramUniformHandle(Int32 program, Int32 location, Int32 count, Int64[] values);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glProgramUniformHandleui64vARB")]
            public static extern void ProgramUniformHandle(Int32 program, Int32 location, Int32 count, ref Int64 values);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glProgramUniformHandleui64vARB")]
            public static extern unsafe void ProgramUniformHandle(Int32 program, Int32 location, Int32 count, Int64* values);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glProgramUniformHandleui64vARB")]
            public static extern void ProgramUniformHandle(UInt32 program, Int32 location, Int32 count, UInt64[] values);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glProgramUniformHandleui64vARB")]
            public static extern void ProgramUniformHandle(UInt32 program, Int32 location, Int32 count, ref UInt64 values);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glProgramUniformHandleui64vARB")]
            public static extern unsafe void ProgramUniformHandle(UInt32 program, Int32 location, Int32 count, UInt64* values);

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glReadnPixelsARB")]
            public static extern void ReadnPixels(Int32 x, Int32 y, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [OutAttribute] IntPtr data);

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glReadnPixelsARB")]
            public static extern void ReadnPixels<T7>(Int32 x, Int32 y, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [InAttribute, OutAttribute] T7[] data)
                where T7 : struct
            ;

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glReadnPixelsARB")]
            public static extern void ReadnPixels<T7>(Int32 x, Int32 y, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [InAttribute, OutAttribute] T7[,] data)
                where T7 : struct
            ;

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glReadnPixelsARB")]
            public static extern void ReadnPixels<T7>(Int32 x, Int32 y, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [InAttribute, OutAttribute] T7[,,] data)
                where T7 : struct
            ;

            /// <summary>[requires: ARB_robustness]</summary>
            [AutoGenerated(Category = "ARB_robustness", Version = "", EntryPoint = "glReadnPixelsARB")]
            public static extern void ReadnPixels<T7>(Int32 x, Int32 y, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [InAttribute, OutAttribute] ref T7 data)
                where T7 : struct
            ;

            /// <summary>[requires: ARB_multisample]
            /// Specify multisample coverage parameters
            /// </summary>
            /// <param name="value">
            /// <para>
            /// Specify a single floating-point sample coverage value. The value is clamped to the range [0 ,1]. The initial value is 1.0.
            /// </para>
            /// </param>
            /// <param name="invert">
            /// <para>
            /// Specify a single boolean value representing if the coverage masks should be inverted. GL_TRUE and GL_FALSE are accepted. The initial value is GL_FALSE.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_multisample", Version = "", EntryPoint = "glSampleCoverageARB")]
            public static extern void SampleCoverage(Single value, bool invert);

            /// <summary>[requires: ARB_shader_objects]
            /// Replaces the source code in a shader object
            /// </summary>
            /// <param name="shader">
            /// <para>
            /// Specifies the handle of the shader object whose source code is to be replaced.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements in the string and length arrays.
            /// </para>
            /// </param>
            /// <param name="string">
            /// <para>
            /// Specifies an array of pointers to strings containing the source code to be loaded into the shader.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// Specifies an array of string lengths.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glShaderSourceARB")]
            public static extern void ShaderSource(Int32 shaderObj, Int32 count, String[] @string, Int32[] length);

            /// <summary>[requires: ARB_shader_objects]
            /// Replaces the source code in a shader object
            /// </summary>
            /// <param name="shader">
            /// <para>
            /// Specifies the handle of the shader object whose source code is to be replaced.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements in the string and length arrays.
            /// </para>
            /// </param>
            /// <param name="string">
            /// <para>
            /// Specifies an array of pointers to strings containing the source code to be loaded into the shader.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// Specifies an array of string lengths.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glShaderSourceARB")]
            public static extern void ShaderSource(Int32 shaderObj, Int32 count, String[] @string, ref Int32 length);

            /// <summary>[requires: ARB_shader_objects]
            /// Replaces the source code in a shader object
            /// </summary>
            /// <param name="shader">
            /// <para>
            /// Specifies the handle of the shader object whose source code is to be replaced.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements in the string and length arrays.
            /// </para>
            /// </param>
            /// <param name="string">
            /// <para>
            /// Specifies an array of pointers to strings containing the source code to be loaded into the shader.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// Specifies an array of string lengths.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glShaderSourceARB")]
            public static extern unsafe void ShaderSource(Int32 shaderObj, Int32 count, String[] @string, Int32* length);

            /// <summary>[requires: ARB_shader_objects]
            /// Replaces the source code in a shader object
            /// </summary>
            /// <param name="shader">
            /// <para>
            /// Specifies the handle of the shader object whose source code is to be replaced.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements in the string and length arrays.
            /// </para>
            /// </param>
            /// <param name="string">
            /// <para>
            /// Specifies an array of pointers to strings containing the source code to be loaded into the shader.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// Specifies an array of string lengths.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glShaderSourceARB")]
            public static extern void ShaderSource(UInt32 shaderObj, Int32 count, String[] @string, Int32[] length);

            /// <summary>[requires: ARB_shader_objects]
            /// Replaces the source code in a shader object
            /// </summary>
            /// <param name="shader">
            /// <para>
            /// Specifies the handle of the shader object whose source code is to be replaced.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements in the string and length arrays.
            /// </para>
            /// </param>
            /// <param name="string">
            /// <para>
            /// Specifies an array of pointers to strings containing the source code to be loaded into the shader.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// Specifies an array of string lengths.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glShaderSourceARB")]
            public static extern void ShaderSource(UInt32 shaderObj, Int32 count, String[] @string, ref Int32 length);

            /// <summary>[requires: ARB_shader_objects]
            /// Replaces the source code in a shader object
            /// </summary>
            /// <param name="shader">
            /// <para>
            /// Specifies the handle of the shader object whose source code is to be replaced.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements in the string and length arrays.
            /// </para>
            /// </param>
            /// <param name="string">
            /// <para>
            /// Specifies an array of pointers to strings containing the source code to be loaded into the shader.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// Specifies an array of string lengths.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glShaderSourceARB")]
            public static extern unsafe void ShaderSource(UInt32 shaderObj, Int32 count, String[] @string, Int32* length);

            /// <summary>[requires: ARB_texture_buffer_object]
            /// Attach the storage for a buffer object to the active buffer texture
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target of the operation and must be GL_TEXTURE_BUFFER.
            /// </para>
            /// </param>
            /// <param name="internalFormat">
            /// <para>
            /// Specifies the internal format of the data in the store belonging to buffer.
            /// </para>
            /// </param>
            /// <param name="buffer">
            /// <para>
            /// Specifies the name of the buffer object whose storage to attach to the active buffer texture.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_texture_buffer_object", Version = "", EntryPoint = "glTexBufferARB")]
            public static extern void TexBuffer(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.ArbTextureBufferObject internalformat, Int32 buffer);

            /// <summary>[requires: ARB_texture_buffer_object]
            /// Attach the storage for a buffer object to the active buffer texture
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target of the operation and must be GL_TEXTURE_BUFFER.
            /// </para>
            /// </param>
            /// <param name="internalFormat">
            /// <para>
            /// Specifies the internal format of the data in the store belonging to buffer.
            /// </para>
            /// </param>
            /// <param name="buffer">
            /// <para>
            /// Specifies the name of the buffer object whose storage to attach to the active buffer texture.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_texture_buffer_object", Version = "", EntryPoint = "glTexBufferARB")]
            public static extern void TexBuffer(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.ArbTextureBufferObject internalformat, UInt32 buffer);

            /// <summary>[requires: ARB_sparse_texture]</summary>
            [AutoGenerated(Category = "ARB_sparse_texture", Version = "", EntryPoint = "glTexPageCommitmentARB")]
            public static extern void TexPageCommitment(OpenTK.Graphics.OpenGL.ArbSparseTexture target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, bool resident);

            /// <summary>[requires: ARB_shader_objects]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniform1fARB")]
            public static extern void Uniform1(Int32 location, Single v0);

            /// <summary>[requires: ARB_shader_objects]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniform1fvARB")]
            public static extern void Uniform1(Int32 location, Int32 count, Single[] value);

            /// <summary>[requires: ARB_shader_objects]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniform1fvARB")]
            public static extern void Uniform1(Int32 location, Int32 count, ref Single value);

            /// <summary>[requires: ARB_shader_objects]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniform1fvARB")]
            public static extern unsafe void Uniform1(Int32 location, Int32 count, Single* value);

            /// <summary>[requires: ARB_shader_objects]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniform1iARB")]
            public static extern void Uniform1(Int32 location, Int32 v0);

            /// <summary>[requires: ARB_shader_objects]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniform1ivARB")]
            public static extern void Uniform1(Int32 location, Int32 count, Int32[] value);

            /// <summary>[requires: ARB_shader_objects]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniform1ivARB")]
            public static extern void Uniform1(Int32 location, Int32 count, ref Int32 value);

            /// <summary>[requires: ARB_shader_objects]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniform1ivARB")]
            public static extern unsafe void Uniform1(Int32 location, Int32 count, Int32* value);

            /// <summary>[requires: ARB_shader_objects]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniform2fARB")]
            public static extern void Uniform2(Int32 location, Single v0, Single v1);

            /// <summary>[requires: ARB_shader_objects]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniform2fvARB")]
            public static extern void Uniform2(Int32 location, Int32 count, Single[] value);

            /// <summary>[requires: ARB_shader_objects]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniform2fvARB")]
            public static extern void Uniform2(Int32 location, Int32 count, ref Single value);

            /// <summary>[requires: ARB_shader_objects]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniform2fvARB")]
            public static extern unsafe void Uniform2(Int32 location, Int32 count, Single* value);

            /// <summary>[requires: ARB_shader_objects]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniform2iARB")]
            public static extern void Uniform2(Int32 location, Int32 v0, Int32 v1);

            /// <summary>[requires: ARB_shader_objects]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniform2ivARB")]
            public static extern void Uniform2(Int32 location, Int32 count, Int32[] value);

            /// <summary>[requires: ARB_shader_objects]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniform2ivARB")]
            public static extern unsafe void Uniform2(Int32 location, Int32 count, Int32* value);

            /// <summary>[requires: ARB_shader_objects]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniform3fARB")]
            public static extern void Uniform3(Int32 location, Single v0, Single v1, Single v2);

            /// <summary>[requires: ARB_shader_objects]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniform3fvARB")]
            public static extern void Uniform3(Int32 location, Int32 count, Single[] value);

            /// <summary>[requires: ARB_shader_objects]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniform3fvARB")]
            public static extern void Uniform3(Int32 location, Int32 count, ref Single value);

            /// <summary>[requires: ARB_shader_objects]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniform3fvARB")]
            public static extern unsafe void Uniform3(Int32 location, Int32 count, Single* value);

            /// <summary>[requires: ARB_shader_objects]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniform3iARB")]
            public static extern void Uniform3(Int32 location, Int32 v0, Int32 v1, Int32 v2);

            /// <summary>[requires: ARB_shader_objects]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniform3ivARB")]
            public static extern void Uniform3(Int32 location, Int32 count, Int32[] value);

            /// <summary>[requires: ARB_shader_objects]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniform3ivARB")]
            public static extern void Uniform3(Int32 location, Int32 count, ref Int32 value);

            /// <summary>[requires: ARB_shader_objects]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniform3ivARB")]
            public static extern unsafe void Uniform3(Int32 location, Int32 count, Int32* value);

            /// <summary>[requires: ARB_shader_objects]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniform4fARB")]
            public static extern void Uniform4(Int32 location, Single v0, Single v1, Single v2, Single v3);

            /// <summary>[requires: ARB_shader_objects]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniform4fvARB")]
            public static extern void Uniform4(Int32 location, Int32 count, Single[] value);

            /// <summary>[requires: ARB_shader_objects]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniform4fvARB")]
            public static extern void Uniform4(Int32 location, Int32 count, ref Single value);

            /// <summary>[requires: ARB_shader_objects]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniform4fvARB")]
            public static extern unsafe void Uniform4(Int32 location, Int32 count, Single* value);

            /// <summary>[requires: ARB_shader_objects]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniform4iARB")]
            public static extern void Uniform4(Int32 location, Int32 v0, Int32 v1, Int32 v2, Int32 v3);

            /// <summary>[requires: ARB_shader_objects]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniform4ivARB")]
            public static extern void Uniform4(Int32 location, Int32 count, Int32[] value);

            /// <summary>[requires: ARB_shader_objects]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniform4ivARB")]
            public static extern void Uniform4(Int32 location, Int32 count, ref Int32 value);

            /// <summary>[requires: ARB_shader_objects]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniform4ivARB")]
            public static extern unsafe void Uniform4(Int32 location, Int32 count, Int32* value);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glUniformHandleui64ARB")]
            public static extern void UniformHandle(Int32 location, Int64 value);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glUniformHandleui64ARB")]
            public static extern void UniformHandle(Int32 location, UInt64 value);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glUniformHandleui64vARB")]
            public static extern void UniformHandle(Int32 location, Int32 count, Int64[] value);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glUniformHandleui64vARB")]
            public static extern void UniformHandle(Int32 location, Int32 count, ref Int64 value);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glUniformHandleui64vARB")]
            public static extern unsafe void UniformHandle(Int32 location, Int32 count, Int64* value);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glUniformHandleui64vARB")]
            public static extern void UniformHandle(Int32 location, Int32 count, UInt64[] value);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glUniformHandleui64vARB")]
            public static extern void UniformHandle(Int32 location, Int32 count, ref UInt64 value);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glUniformHandleui64vARB")]
            public static extern unsafe void UniformHandle(Int32 location, Int32 count, UInt64* value);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniformMatrix2fvARB")]
            public static extern void UniformMatrix2(Int32 location, Int32 count, bool transpose, Single[] value);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniformMatrix2fvARB")]
            public static extern void UniformMatrix2(Int32 location, Int32 count, bool transpose, ref Single value);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniformMatrix2fvARB")]
            public static extern unsafe void UniformMatrix2(Int32 location, Int32 count, bool transpose, Single* value);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniformMatrix3fvARB")]
            public static extern void UniformMatrix3(Int32 location, Int32 count, bool transpose, Single[] value);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniformMatrix3fvARB")]
            public static extern void UniformMatrix3(Int32 location, Int32 count, bool transpose, ref Single value);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniformMatrix3fvARB")]
            public static extern unsafe void UniformMatrix3(Int32 location, Int32 count, bool transpose, Single* value);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniformMatrix4fvARB")]
            public static extern void UniformMatrix4(Int32 location, Int32 count, bool transpose, Single[] value);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniformMatrix4fvARB")]
            public static extern void UniformMatrix4(Int32 location, Int32 count, bool transpose, ref Single value);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUniformMatrix4fvARB")]
            public static extern unsafe void UniformMatrix4(Int32 location, Int32 count, bool transpose, Single* value);

            /// <summary>[requires: ARB_vertex_buffer_object]</summary>
            [AutoGenerated(Category = "ARB_vertex_buffer_object", Version = "", EntryPoint = "glUnmapBufferARB")]
            public static extern bool UnmapBuffer(OpenTK.Graphics.OpenGL.BufferTargetArb target);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUseProgramObjectARB")]
            public static extern void UseProgramObject(Int32 programObj);

            /// <summary>[requires: ARB_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glUseProgramObjectARB")]
            public static extern void UseProgramObject(UInt32 programObj);

            /// <summary>[requires: ARB_shader_objects]
            /// Validates a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program object to be validated.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glValidateProgramARB")]
            public static extern void ValidateProgram(Int32 programObj);

            /// <summary>[requires: ARB_shader_objects]
            /// Validates a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program object to be validated.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_shader_objects", Version = "", EntryPoint = "glValidateProgramARB")]
            public static extern void ValidateProgram(UInt32 programObj);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib1dARB")]
            public static extern void VertexAttrib1(Int32 index, Double x);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib1dARB")]
            public static extern void VertexAttrib1(UInt32 index, Double x);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib1dvARB")]
            public static extern unsafe void VertexAttrib1(Int32 index, Double* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib1dvARB")]
            public static extern unsafe void VertexAttrib1(UInt32 index, Double* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib1fARB")]
            public static extern void VertexAttrib1(Int32 index, Single x);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib1fARB")]
            public static extern void VertexAttrib1(UInt32 index, Single x);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib1fvARB")]
            public static extern unsafe void VertexAttrib1(Int32 index, Single* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib1fvARB")]
            public static extern unsafe void VertexAttrib1(UInt32 index, Single* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib1sARB")]
            public static extern void VertexAttrib1(Int32 index, Int16 x);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib1sARB")]
            public static extern void VertexAttrib1(UInt32 index, Int16 x);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib1svARB")]
            public static extern unsafe void VertexAttrib1(Int32 index, Int16* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib1svARB")]
            public static extern unsafe void VertexAttrib1(UInt32 index, Int16* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib2dARB")]
            public static extern void VertexAttrib2(Int32 index, Double x, Double y);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib2dARB")]
            public static extern void VertexAttrib2(UInt32 index, Double x, Double y);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib2dvARB")]
            public static extern void VertexAttrib2(Int32 index, Double[] v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib2dvARB")]
            public static extern void VertexAttrib2(Int32 index, ref Double v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib2dvARB")]
            public static extern unsafe void VertexAttrib2(Int32 index, Double* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib2dvARB")]
            public static extern void VertexAttrib2(UInt32 index, Double[] v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib2dvARB")]
            public static extern void VertexAttrib2(UInt32 index, ref Double v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib2dvARB")]
            public static extern unsafe void VertexAttrib2(UInt32 index, Double* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib2fARB")]
            public static extern void VertexAttrib2(Int32 index, Single x, Single y);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib2fARB")]
            public static extern void VertexAttrib2(UInt32 index, Single x, Single y);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib2fvARB")]
            public static extern void VertexAttrib2(Int32 index, Single[] v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib2fvARB")]
            public static extern void VertexAttrib2(Int32 index, ref Single v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib2fvARB")]
            public static extern unsafe void VertexAttrib2(Int32 index, Single* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib2fvARB")]
            public static extern void VertexAttrib2(UInt32 index, Single[] v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib2fvARB")]
            public static extern void VertexAttrib2(UInt32 index, ref Single v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib2fvARB")]
            public static extern unsafe void VertexAttrib2(UInt32 index, Single* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib2sARB")]
            public static extern void VertexAttrib2(Int32 index, Int16 x, Int16 y);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib2sARB")]
            public static extern void VertexAttrib2(UInt32 index, Int16 x, Int16 y);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib2svARB")]
            public static extern void VertexAttrib2(Int32 index, Int16[] v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib2svARB")]
            public static extern void VertexAttrib2(Int32 index, ref Int16 v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib2svARB")]
            public static extern unsafe void VertexAttrib2(Int32 index, Int16* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib2svARB")]
            public static extern void VertexAttrib2(UInt32 index, Int16[] v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib2svARB")]
            public static extern void VertexAttrib2(UInt32 index, ref Int16 v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib2svARB")]
            public static extern unsafe void VertexAttrib2(UInt32 index, Int16* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib3dARB")]
            public static extern void VertexAttrib3(Int32 index, Double x, Double y, Double z);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib3dARB")]
            public static extern void VertexAttrib3(UInt32 index, Double x, Double y, Double z);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib3dvARB")]
            public static extern void VertexAttrib3(Int32 index, Double[] v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib3dvARB")]
            public static extern void VertexAttrib3(Int32 index, ref Double v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib3dvARB")]
            public static extern unsafe void VertexAttrib3(Int32 index, Double* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib3dvARB")]
            public static extern void VertexAttrib3(UInt32 index, Double[] v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib3dvARB")]
            public static extern void VertexAttrib3(UInt32 index, ref Double v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib3dvARB")]
            public static extern unsafe void VertexAttrib3(UInt32 index, Double* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib3fARB")]
            public static extern void VertexAttrib3(Int32 index, Single x, Single y, Single z);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib3fARB")]
            public static extern void VertexAttrib3(UInt32 index, Single x, Single y, Single z);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib3fvARB")]
            public static extern void VertexAttrib3(Int32 index, Single[] v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib3fvARB")]
            public static extern void VertexAttrib3(Int32 index, ref Single v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib3fvARB")]
            public static extern unsafe void VertexAttrib3(Int32 index, Single* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib3fvARB")]
            public static extern void VertexAttrib3(UInt32 index, Single[] v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib3fvARB")]
            public static extern void VertexAttrib3(UInt32 index, ref Single v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib3fvARB")]
            public static extern unsafe void VertexAttrib3(UInt32 index, Single* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib3sARB")]
            public static extern void VertexAttrib3(Int32 index, Int16 x, Int16 y, Int16 z);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib3sARB")]
            public static extern void VertexAttrib3(UInt32 index, Int16 x, Int16 y, Int16 z);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib3svARB")]
            public static extern void VertexAttrib3(Int32 index, Int16[] v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib3svARB")]
            public static extern void VertexAttrib3(Int32 index, ref Int16 v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib3svARB")]
            public static extern unsafe void VertexAttrib3(Int32 index, Int16* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib3svARB")]
            public static extern void VertexAttrib3(UInt32 index, Int16[] v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib3svARB")]
            public static extern void VertexAttrib3(UInt32 index, ref Int16 v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib3svARB")]
            public static extern unsafe void VertexAttrib3(UInt32 index, Int16* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4bvARB")]
            public static extern void VertexAttrib4(UInt32 index, SByte[] v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4bvARB")]
            public static extern void VertexAttrib4(UInt32 index, ref SByte v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4bvARB")]
            public static extern unsafe void VertexAttrib4(UInt32 index, SByte* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4dARB")]
            public static extern void VertexAttrib4(Int32 index, Double x, Double y, Double z, Double w);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4dARB")]
            public static extern void VertexAttrib4(UInt32 index, Double x, Double y, Double z, Double w);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4dvARB")]
            public static extern void VertexAttrib4(Int32 index, Double[] v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4dvARB")]
            public static extern void VertexAttrib4(Int32 index, ref Double v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4dvARB")]
            public static extern unsafe void VertexAttrib4(Int32 index, Double* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4dvARB")]
            public static extern void VertexAttrib4(UInt32 index, Double[] v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4dvARB")]
            public static extern void VertexAttrib4(UInt32 index, ref Double v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4dvARB")]
            public static extern unsafe void VertexAttrib4(UInt32 index, Double* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4fARB")]
            public static extern void VertexAttrib4(Int32 index, Single x, Single y, Single z, Single w);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4fARB")]
            public static extern void VertexAttrib4(UInt32 index, Single x, Single y, Single z, Single w);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4fvARB")]
            public static extern void VertexAttrib4(Int32 index, Single[] v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4fvARB")]
            public static extern void VertexAttrib4(Int32 index, ref Single v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4fvARB")]
            public static extern unsafe void VertexAttrib4(Int32 index, Single* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4fvARB")]
            public static extern void VertexAttrib4(UInt32 index, Single[] v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4fvARB")]
            public static extern void VertexAttrib4(UInt32 index, ref Single v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4fvARB")]
            public static extern unsafe void VertexAttrib4(UInt32 index, Single* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4ivARB")]
            public static extern void VertexAttrib4(Int32 index, Int32[] v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4ivARB")]
            public static extern void VertexAttrib4(Int32 index, ref Int32 v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4ivARB")]
            public static extern unsafe void VertexAttrib4(Int32 index, Int32* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4ivARB")]
            public static extern void VertexAttrib4(UInt32 index, Int32[] v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4ivARB")]
            public static extern void VertexAttrib4(UInt32 index, ref Int32 v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4ivARB")]
            public static extern unsafe void VertexAttrib4(UInt32 index, Int32* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4NbvARB")]
            public static extern void VertexAttrib4N(UInt32 index, SByte[] v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4NbvARB")]
            public static extern void VertexAttrib4N(UInt32 index, ref SByte v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4NbvARB")]
            public static extern unsafe void VertexAttrib4N(UInt32 index, SByte* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4NivARB")]
            public static extern void VertexAttrib4N(Int32 index, Int32[] v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4NivARB")]
            public static extern void VertexAttrib4N(Int32 index, ref Int32 v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4NivARB")]
            public static extern unsafe void VertexAttrib4N(Int32 index, Int32* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4NivARB")]
            public static extern void VertexAttrib4N(UInt32 index, Int32[] v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4NivARB")]
            public static extern void VertexAttrib4N(UInt32 index, ref Int32 v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4NivARB")]
            public static extern unsafe void VertexAttrib4N(UInt32 index, Int32* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4NsvARB")]
            public static extern void VertexAttrib4N(Int32 index, Int16[] v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4NsvARB")]
            public static extern void VertexAttrib4N(Int32 index, ref Int16 v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4NsvARB")]
            public static extern unsafe void VertexAttrib4N(Int32 index, Int16* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4NsvARB")]
            public static extern void VertexAttrib4N(UInt32 index, Int16[] v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4NsvARB")]
            public static extern void VertexAttrib4N(UInt32 index, ref Int16 v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4NsvARB")]
            public static extern unsafe void VertexAttrib4N(UInt32 index, Int16* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4NubARB")]
            public static extern void VertexAttrib4N(Int32 index, Byte x, Byte y, Byte z, Byte w);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4NubARB")]
            public static extern void VertexAttrib4N(UInt32 index, Byte x, Byte y, Byte z, Byte w);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4NubvARB")]
            public static extern void VertexAttrib4N(Int32 index, Byte[] v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4NubvARB")]
            public static extern void VertexAttrib4N(Int32 index, ref Byte v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4NubvARB")]
            public static extern unsafe void VertexAttrib4N(Int32 index, Byte* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4NubvARB")]
            public static extern void VertexAttrib4N(UInt32 index, Byte[] v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4NubvARB")]
            public static extern void VertexAttrib4N(UInt32 index, ref Byte v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4NubvARB")]
            public static extern unsafe void VertexAttrib4N(UInt32 index, Byte* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4NuivARB")]
            public static extern void VertexAttrib4N(UInt32 index, UInt32[] v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4NuivARB")]
            public static extern void VertexAttrib4N(UInt32 index, ref UInt32 v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4NuivARB")]
            public static extern unsafe void VertexAttrib4N(UInt32 index, UInt32* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4NusvARB")]
            public static extern void VertexAttrib4N(UInt32 index, UInt16[] v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4NusvARB")]
            public static extern void VertexAttrib4N(UInt32 index, ref UInt16 v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4NusvARB")]
            public static extern unsafe void VertexAttrib4N(UInt32 index, UInt16* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4sARB")]
            public static extern void VertexAttrib4(Int32 index, Int16 x, Int16 y, Int16 z, Int16 w);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4sARB")]
            public static extern void VertexAttrib4(UInt32 index, Int16 x, Int16 y, Int16 z, Int16 w);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4svARB")]
            public static extern void VertexAttrib4(Int32 index, Int16[] v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4svARB")]
            public static extern void VertexAttrib4(Int32 index, ref Int16 v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4svARB")]
            public static extern unsafe void VertexAttrib4(Int32 index, Int16* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4svARB")]
            public static extern void VertexAttrib4(UInt32 index, Int16[] v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4svARB")]
            public static extern void VertexAttrib4(UInt32 index, ref Int16 v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4svARB")]
            public static extern unsafe void VertexAttrib4(UInt32 index, Int16* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4ubvARB")]
            public static extern void VertexAttrib4(Int32 index, Byte[] v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4ubvARB")]
            public static extern void VertexAttrib4(Int32 index, ref Byte v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4ubvARB")]
            public static extern unsafe void VertexAttrib4(Int32 index, Byte* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4ubvARB")]
            public static extern void VertexAttrib4(UInt32 index, Byte[] v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4ubvARB")]
            public static extern void VertexAttrib4(UInt32 index, ref Byte v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4ubvARB")]
            public static extern unsafe void VertexAttrib4(UInt32 index, Byte* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4uivARB")]
            public static extern void VertexAttrib4(UInt32 index, UInt32[] v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4uivARB")]
            public static extern void VertexAttrib4(UInt32 index, ref UInt32 v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4uivARB")]
            public static extern unsafe void VertexAttrib4(UInt32 index, UInt32* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4usvARB")]
            public static extern void VertexAttrib4(UInt32 index, UInt16[] v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4usvARB")]
            public static extern void VertexAttrib4(UInt32 index, ref UInt16 v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttrib4usvARB")]
            public static extern unsafe void VertexAttrib4(UInt32 index, UInt16* v);

            /// <summary>[requires: ARB_instanced_arrays]
            /// Modify the rate at which generic vertex attributes advance during instanced rendering
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specify the index of the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="divisor">
            /// <para>
            /// Specify the number of instances that will pass between updates of the generic attribute at slot index.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_instanced_arrays", Version = "", EntryPoint = "glVertexAttribDivisorARB")]
            public static extern void VertexAttribDivisor(Int32 index, Int32 divisor);

            /// <summary>[requires: ARB_instanced_arrays]
            /// Modify the rate at which generic vertex attributes advance during instanced rendering
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specify the index of the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="divisor">
            /// <para>
            /// Specify the number of instances that will pass between updates of the generic attribute at slot index.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_instanced_arrays", Version = "", EntryPoint = "glVertexAttribDivisorARB")]
            public static extern void VertexAttribDivisor(UInt32 index, UInt32 divisor);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glVertexAttribL1ui64ARB")]
            public static extern void VertexAttribL1(Int32 index, Int64 x);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glVertexAttribL1ui64ARB")]
            public static extern void VertexAttribL1(UInt32 index, UInt64 x);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glVertexAttribL1ui64vARB")]
            public static extern void VertexAttribL1(Int32 index, Int64[] v);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glVertexAttribL1ui64vARB")]
            public static extern unsafe void VertexAttribL1(Int32 index, Int64* v);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glVertexAttribL1ui64vARB")]
            public static extern void VertexAttribL1(UInt32 index, UInt64[] v);

            /// <summary>[requires: ARB_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_bindless_texture", Version = "", EntryPoint = "glVertexAttribL1ui64vARB")]
            public static extern unsafe void VertexAttribL1(UInt32 index, UInt64* v);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Define an array of generic vertex attribute data
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Specifies the number of components per generic vertex attribute. Must be 1, 2, 3, 4. Additionally, the symbolic constant GL_BGRA is accepted by glVertexAttribPointer. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each component in the array. The symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, and GL_UNSIGNED_INT are accepted by glVertexAttribPointer and glVertexAttribIPointer. Additionally GL_HALF_FLOAT, GL_FLOAT, GL_DOUBLE, GL_FIXED, GL_INT_2_10_10_10_REV, GL_UNSIGNED_INT_2_10_10_10_REV and GL_UNSIGNED_INT_10F_11F_11F_REV are accepted by glVertexAttribPointer. GL_DOUBLE is also accepted by glVertexAttribLPointer and is the only token accepted by the type parameter for that function. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For glVertexAttribPointer, specifies whether fixed-point data values should be normalized (GL_TRUE) or converted directly as fixed-point values (GL_FALSE) when they are accessed.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive generic vertex attributes. If stride is 0, the generic vertex attributes are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a offset of the first component of the first generic vertex attribute in the array in the data store of the buffer currently bound to the GL_ARRAY_BUFFER target. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttribPointerARB")]
            public static extern void VertexAttribPointer(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribPointerTypeArb type, bool normalized, Int32 stride, IntPtr pointer);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Define an array of generic vertex attribute data
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Specifies the number of components per generic vertex attribute. Must be 1, 2, 3, 4. Additionally, the symbolic constant GL_BGRA is accepted by glVertexAttribPointer. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each component in the array. The symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, and GL_UNSIGNED_INT are accepted by glVertexAttribPointer and glVertexAttribIPointer. Additionally GL_HALF_FLOAT, GL_FLOAT, GL_DOUBLE, GL_FIXED, GL_INT_2_10_10_10_REV, GL_UNSIGNED_INT_2_10_10_10_REV and GL_UNSIGNED_INT_10F_11F_11F_REV are accepted by glVertexAttribPointer. GL_DOUBLE is also accepted by glVertexAttribLPointer and is the only token accepted by the type parameter for that function. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For glVertexAttribPointer, specifies whether fixed-point data values should be normalized (GL_TRUE) or converted directly as fixed-point values (GL_FALSE) when they are accessed.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive generic vertex attributes. If stride is 0, the generic vertex attributes are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a offset of the first component of the first generic vertex attribute in the array in the data store of the buffer currently bound to the GL_ARRAY_BUFFER target. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttribPointerARB")]
            public static extern void VertexAttribPointer<T5>(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribPointerTypeArb type, bool normalized, Int32 stride, [InAttribute, OutAttribute] T5[] pointer)
                where T5 : struct
            ;

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Define an array of generic vertex attribute data
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Specifies the number of components per generic vertex attribute. Must be 1, 2, 3, 4. Additionally, the symbolic constant GL_BGRA is accepted by glVertexAttribPointer. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each component in the array. The symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, and GL_UNSIGNED_INT are accepted by glVertexAttribPointer and glVertexAttribIPointer. Additionally GL_HALF_FLOAT, GL_FLOAT, GL_DOUBLE, GL_FIXED, GL_INT_2_10_10_10_REV, GL_UNSIGNED_INT_2_10_10_10_REV and GL_UNSIGNED_INT_10F_11F_11F_REV are accepted by glVertexAttribPointer. GL_DOUBLE is also accepted by glVertexAttribLPointer and is the only token accepted by the type parameter for that function. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For glVertexAttribPointer, specifies whether fixed-point data values should be normalized (GL_TRUE) or converted directly as fixed-point values (GL_FALSE) when they are accessed.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive generic vertex attributes. If stride is 0, the generic vertex attributes are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a offset of the first component of the first generic vertex attribute in the array in the data store of the buffer currently bound to the GL_ARRAY_BUFFER target. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttribPointerARB")]
            public static extern void VertexAttribPointer<T5>(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribPointerTypeArb type, bool normalized, Int32 stride, [InAttribute, OutAttribute] T5[,] pointer)
                where T5 : struct
            ;

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Define an array of generic vertex attribute data
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Specifies the number of components per generic vertex attribute. Must be 1, 2, 3, 4. Additionally, the symbolic constant GL_BGRA is accepted by glVertexAttribPointer. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each component in the array. The symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, and GL_UNSIGNED_INT are accepted by glVertexAttribPointer and glVertexAttribIPointer. Additionally GL_HALF_FLOAT, GL_FLOAT, GL_DOUBLE, GL_FIXED, GL_INT_2_10_10_10_REV, GL_UNSIGNED_INT_2_10_10_10_REV and GL_UNSIGNED_INT_10F_11F_11F_REV are accepted by glVertexAttribPointer. GL_DOUBLE is also accepted by glVertexAttribLPointer and is the only token accepted by the type parameter for that function. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For glVertexAttribPointer, specifies whether fixed-point data values should be normalized (GL_TRUE) or converted directly as fixed-point values (GL_FALSE) when they are accessed.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive generic vertex attributes. If stride is 0, the generic vertex attributes are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a offset of the first component of the first generic vertex attribute in the array in the data store of the buffer currently bound to the GL_ARRAY_BUFFER target. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttribPointerARB")]
            public static extern void VertexAttribPointer<T5>(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribPointerTypeArb type, bool normalized, Int32 stride, [InAttribute, OutAttribute] T5[,,] pointer)
                where T5 : struct
            ;

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Define an array of generic vertex attribute data
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Specifies the number of components per generic vertex attribute. Must be 1, 2, 3, 4. Additionally, the symbolic constant GL_BGRA is accepted by glVertexAttribPointer. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each component in the array. The symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, and GL_UNSIGNED_INT are accepted by glVertexAttribPointer and glVertexAttribIPointer. Additionally GL_HALF_FLOAT, GL_FLOAT, GL_DOUBLE, GL_FIXED, GL_INT_2_10_10_10_REV, GL_UNSIGNED_INT_2_10_10_10_REV and GL_UNSIGNED_INT_10F_11F_11F_REV are accepted by glVertexAttribPointer. GL_DOUBLE is also accepted by glVertexAttribLPointer and is the only token accepted by the type parameter for that function. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For glVertexAttribPointer, specifies whether fixed-point data values should be normalized (GL_TRUE) or converted directly as fixed-point values (GL_FALSE) when they are accessed.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive generic vertex attributes. If stride is 0, the generic vertex attributes are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a offset of the first component of the first generic vertex attribute in the array in the data store of the buffer currently bound to the GL_ARRAY_BUFFER target. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttribPointerARB")]
            public static extern void VertexAttribPointer<T5>(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribPointerTypeArb type, bool normalized, Int32 stride, [InAttribute, OutAttribute] ref T5 pointer)
                where T5 : struct
            ;

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Define an array of generic vertex attribute data
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Specifies the number of components per generic vertex attribute. Must be 1, 2, 3, 4. Additionally, the symbolic constant GL_BGRA is accepted by glVertexAttribPointer. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each component in the array. The symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, and GL_UNSIGNED_INT are accepted by glVertexAttribPointer and glVertexAttribIPointer. Additionally GL_HALF_FLOAT, GL_FLOAT, GL_DOUBLE, GL_FIXED, GL_INT_2_10_10_10_REV, GL_UNSIGNED_INT_2_10_10_10_REV and GL_UNSIGNED_INT_10F_11F_11F_REV are accepted by glVertexAttribPointer. GL_DOUBLE is also accepted by glVertexAttribLPointer and is the only token accepted by the type parameter for that function. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For glVertexAttribPointer, specifies whether fixed-point data values should be normalized (GL_TRUE) or converted directly as fixed-point values (GL_FALSE) when they are accessed.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive generic vertex attributes. If stride is 0, the generic vertex attributes are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a offset of the first component of the first generic vertex attribute in the array in the data store of the buffer currently bound to the GL_ARRAY_BUFFER target. The initial value is 0.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttribPointerARB")]
            public static extern void VertexAttribPointer(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribPointerTypeArb type, bool normalized, Int32 stride, IntPtr pointer);

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Define an array of generic vertex attribute data
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Specifies the number of components per generic vertex attribute. Must be 1, 2, 3, 4. Additionally, the symbolic constant GL_BGRA is accepted by glVertexAttribPointer. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each component in the array. The symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, and GL_UNSIGNED_INT are accepted by glVertexAttribPointer and glVertexAttribIPointer. Additionally GL_HALF_FLOAT, GL_FLOAT, GL_DOUBLE, GL_FIXED, GL_INT_2_10_10_10_REV, GL_UNSIGNED_INT_2_10_10_10_REV and GL_UNSIGNED_INT_10F_11F_11F_REV are accepted by glVertexAttribPointer. GL_DOUBLE is also accepted by glVertexAttribLPointer and is the only token accepted by the type parameter for that function. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For glVertexAttribPointer, specifies whether fixed-point data values should be normalized (GL_TRUE) or converted directly as fixed-point values (GL_FALSE) when they are accessed.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive generic vertex attributes. If stride is 0, the generic vertex attributes are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a offset of the first component of the first generic vertex attribute in the array in the data store of the buffer currently bound to the GL_ARRAY_BUFFER target. The initial value is 0.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttribPointerARB")]
            public static extern void VertexAttribPointer<T5>(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribPointerTypeArb type, bool normalized, Int32 stride, [InAttribute, OutAttribute] T5[] pointer)
                where T5 : struct
            ;

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Define an array of generic vertex attribute data
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Specifies the number of components per generic vertex attribute. Must be 1, 2, 3, 4. Additionally, the symbolic constant GL_BGRA is accepted by glVertexAttribPointer. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each component in the array. The symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, and GL_UNSIGNED_INT are accepted by glVertexAttribPointer and glVertexAttribIPointer. Additionally GL_HALF_FLOAT, GL_FLOAT, GL_DOUBLE, GL_FIXED, GL_INT_2_10_10_10_REV, GL_UNSIGNED_INT_2_10_10_10_REV and GL_UNSIGNED_INT_10F_11F_11F_REV are accepted by glVertexAttribPointer. GL_DOUBLE is also accepted by glVertexAttribLPointer and is the only token accepted by the type parameter for that function. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For glVertexAttribPointer, specifies whether fixed-point data values should be normalized (GL_TRUE) or converted directly as fixed-point values (GL_FALSE) when they are accessed.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive generic vertex attributes. If stride is 0, the generic vertex attributes are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a offset of the first component of the first generic vertex attribute in the array in the data store of the buffer currently bound to the GL_ARRAY_BUFFER target. The initial value is 0.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttribPointerARB")]
            public static extern void VertexAttribPointer<T5>(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribPointerTypeArb type, bool normalized, Int32 stride, [InAttribute, OutAttribute] T5[,] pointer)
                where T5 : struct
            ;

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Define an array of generic vertex attribute data
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Specifies the number of components per generic vertex attribute. Must be 1, 2, 3, 4. Additionally, the symbolic constant GL_BGRA is accepted by glVertexAttribPointer. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each component in the array. The symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, and GL_UNSIGNED_INT are accepted by glVertexAttribPointer and glVertexAttribIPointer. Additionally GL_HALF_FLOAT, GL_FLOAT, GL_DOUBLE, GL_FIXED, GL_INT_2_10_10_10_REV, GL_UNSIGNED_INT_2_10_10_10_REV and GL_UNSIGNED_INT_10F_11F_11F_REV are accepted by glVertexAttribPointer. GL_DOUBLE is also accepted by glVertexAttribLPointer and is the only token accepted by the type parameter for that function. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For glVertexAttribPointer, specifies whether fixed-point data values should be normalized (GL_TRUE) or converted directly as fixed-point values (GL_FALSE) when they are accessed.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive generic vertex attributes. If stride is 0, the generic vertex attributes are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a offset of the first component of the first generic vertex attribute in the array in the data store of the buffer currently bound to the GL_ARRAY_BUFFER target. The initial value is 0.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttribPointerARB")]
            public static extern void VertexAttribPointer<T5>(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribPointerTypeArb type, bool normalized, Int32 stride, [InAttribute, OutAttribute] T5[,,] pointer)
                where T5 : struct
            ;

            /// <summary>[requires: ARB_vertex_program|ARB_vertex_shader]
            /// Define an array of generic vertex attribute data
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Specifies the number of components per generic vertex attribute. Must be 1, 2, 3, 4. Additionally, the symbolic constant GL_BGRA is accepted by glVertexAttribPointer. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each component in the array. The symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, and GL_UNSIGNED_INT are accepted by glVertexAttribPointer and glVertexAttribIPointer. Additionally GL_HALF_FLOAT, GL_FLOAT, GL_DOUBLE, GL_FIXED, GL_INT_2_10_10_10_REV, GL_UNSIGNED_INT_2_10_10_10_REV and GL_UNSIGNED_INT_10F_11F_11F_REV are accepted by glVertexAttribPointer. GL_DOUBLE is also accepted by glVertexAttribLPointer and is the only token accepted by the type parameter for that function. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For glVertexAttribPointer, specifies whether fixed-point data values should be normalized (GL_TRUE) or converted directly as fixed-point values (GL_FALSE) when they are accessed.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive generic vertex attributes. If stride is 0, the generic vertex attributes are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a offset of the first component of the first generic vertex attribute in the array in the data store of the buffer currently bound to the GL_ARRAY_BUFFER target. The initial value is 0.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_program|ARB_vertex_shader", Version = "", EntryPoint = "glVertexAttribPointerARB")]
            public static extern void VertexAttribPointer<T5>(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribPointerTypeArb type, bool normalized, Int32 stride, [InAttribute, OutAttribute] ref T5 pointer)
                where T5 : struct
            ;

            /// <summary>[requires: ARB_vertex_blend]</summary>
            [AutoGenerated(Category = "ARB_vertex_blend", Version = "", EntryPoint = "glVertexBlendARB")]
            public static extern void VertexBlend(Int32 count);

            /// <summary>[requires: ARB_vertex_blend]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_blend", Version = "", EntryPoint = "glWeightbvARB")]
            public static extern void Weight(Int32 size, SByte[] weights);

            /// <summary>[requires: ARB_vertex_blend]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_blend", Version = "", EntryPoint = "glWeightbvARB")]
            public static extern void Weight(Int32 size, ref SByte weights);

            /// <summary>[requires: ARB_vertex_blend]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_blend", Version = "", EntryPoint = "glWeightbvARB")]
            public static extern unsafe void Weight(Int32 size, SByte* weights);

            /// <summary>[requires: ARB_vertex_blend]</summary>
            [AutoGenerated(Category = "ARB_vertex_blend", Version = "", EntryPoint = "glWeightdvARB")]
            public static extern void Weight(Int32 size, Double[] weights);

            /// <summary>[requires: ARB_vertex_blend]</summary>
            [AutoGenerated(Category = "ARB_vertex_blend", Version = "", EntryPoint = "glWeightdvARB")]
            public static extern void Weight(Int32 size, ref Double weights);

            /// <summary>[requires: ARB_vertex_blend]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_blend", Version = "", EntryPoint = "glWeightdvARB")]
            public static extern unsafe void Weight(Int32 size, Double* weights);

            /// <summary>[requires: ARB_vertex_blend]</summary>
            [AutoGenerated(Category = "ARB_vertex_blend", Version = "", EntryPoint = "glWeightfvARB")]
            public static extern void Weight(Int32 size, Single[] weights);

            /// <summary>[requires: ARB_vertex_blend]</summary>
            [AutoGenerated(Category = "ARB_vertex_blend", Version = "", EntryPoint = "glWeightfvARB")]
            public static extern void Weight(Int32 size, ref Single weights);

            /// <summary>[requires: ARB_vertex_blend]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_blend", Version = "", EntryPoint = "glWeightfvARB")]
            public static extern unsafe void Weight(Int32 size, Single* weights);

            /// <summary>[requires: ARB_vertex_blend]</summary>
            [AutoGenerated(Category = "ARB_vertex_blend", Version = "", EntryPoint = "glWeightivARB")]
            public static extern void Weight(Int32 size, Int32[] weights);

            /// <summary>[requires: ARB_vertex_blend]</summary>
            [AutoGenerated(Category = "ARB_vertex_blend", Version = "", EntryPoint = "glWeightivARB")]
            public static extern void Weight(Int32 size, ref Int32 weights);

            /// <summary>[requires: ARB_vertex_blend]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_blend", Version = "", EntryPoint = "glWeightivARB")]
            public static extern unsafe void Weight(Int32 size, Int32* weights);

            /// <summary>[requires: ARB_vertex_blend]</summary>
            [AutoGenerated(Category = "ARB_vertex_blend", Version = "", EntryPoint = "glWeightPointerARB")]
            public static extern void WeightPointer(Int32 size, OpenTK.Graphics.OpenGL.ArbVertexBlend type, Int32 stride, IntPtr pointer);

            /// <summary>[requires: ARB_vertex_blend]</summary>
            [AutoGenerated(Category = "ARB_vertex_blend", Version = "", EntryPoint = "glWeightPointerARB")]
            public static extern void WeightPointer<T3>(Int32 size, OpenTK.Graphics.OpenGL.ArbVertexBlend type, Int32 stride, [InAttribute, OutAttribute] T3[] pointer)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_vertex_blend]</summary>
            [AutoGenerated(Category = "ARB_vertex_blend", Version = "", EntryPoint = "glWeightPointerARB")]
            public static extern void WeightPointer<T3>(Int32 size, OpenTK.Graphics.OpenGL.ArbVertexBlend type, Int32 stride, [InAttribute, OutAttribute] T3[,] pointer)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_vertex_blend]</summary>
            [AutoGenerated(Category = "ARB_vertex_blend", Version = "", EntryPoint = "glWeightPointerARB")]
            public static extern void WeightPointer<T3>(Int32 size, OpenTK.Graphics.OpenGL.ArbVertexBlend type, Int32 stride, [InAttribute, OutAttribute] T3[,,] pointer)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_vertex_blend]</summary>
            [AutoGenerated(Category = "ARB_vertex_blend", Version = "", EntryPoint = "glWeightPointerARB")]
            public static extern void WeightPointer<T3>(Int32 size, OpenTK.Graphics.OpenGL.ArbVertexBlend type, Int32 stride, [InAttribute, OutAttribute] ref T3 pointer)
                where T3 : struct
            ;

            /// <summary>[requires: ARB_vertex_blend]</summary>
            [AutoGenerated(Category = "ARB_vertex_blend", Version = "", EntryPoint = "glWeightsvARB")]
            public static extern void Weight(Int32 size, Int16[] weights);

            /// <summary>[requires: ARB_vertex_blend]</summary>
            [AutoGenerated(Category = "ARB_vertex_blend", Version = "", EntryPoint = "glWeightsvARB")]
            public static extern void Weight(Int32 size, ref Int16 weights);

            /// <summary>[requires: ARB_vertex_blend]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_blend", Version = "", EntryPoint = "glWeightsvARB")]
            public static extern unsafe void Weight(Int32 size, Int16* weights);

            /// <summary>[requires: ARB_vertex_blend]</summary>
            [AutoGenerated(Category = "ARB_vertex_blend", Version = "", EntryPoint = "glWeightubvARB")]
            public static extern void Weight(Int32 size, Byte[] weights);

            /// <summary>[requires: ARB_vertex_blend]</summary>
            [AutoGenerated(Category = "ARB_vertex_blend", Version = "", EntryPoint = "glWeightubvARB")]
            public static extern void Weight(Int32 size, ref Byte weights);

            /// <summary>[requires: ARB_vertex_blend]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_blend", Version = "", EntryPoint = "glWeightubvARB")]
            public static extern unsafe void Weight(Int32 size, Byte* weights);

            /// <summary>[requires: ARB_vertex_blend]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_blend", Version = "", EntryPoint = "glWeightuivARB")]
            public static extern void Weight(Int32 size, UInt32[] weights);

            /// <summary>[requires: ARB_vertex_blend]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_blend", Version = "", EntryPoint = "glWeightuivARB")]
            public static extern void Weight(Int32 size, ref UInt32 weights);

            /// <summary>[requires: ARB_vertex_blend]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_blend", Version = "", EntryPoint = "glWeightuivARB")]
            public static extern unsafe void Weight(Int32 size, UInt32* weights);

            /// <summary>[requires: ARB_vertex_blend]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_blend", Version = "", EntryPoint = "glWeightusvARB")]
            public static extern void Weight(Int32 size, UInt16[] weights);

            /// <summary>[requires: ARB_vertex_blend]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_blend", Version = "", EntryPoint = "glWeightusvARB")]
            public static extern void Weight(Int32 size, ref UInt16 weights);

            /// <summary>[requires: ARB_vertex_blend]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_vertex_blend", Version = "", EntryPoint = "glWeightusvARB")]
            public static extern unsafe void Weight(Int32 size, UInt16* weights);

            /// <summary>[requires: ARB_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_window_pos", Version = "", EntryPoint = "glWindowPos2dARB")]
            public static extern void WindowPos2(Double x, Double y);

            /// <summary>[requires: ARB_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_window_pos", Version = "", EntryPoint = "glWindowPos2dvARB")]
            public static extern void WindowPos2(Double[] v);

            /// <summary>[requires: ARB_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_window_pos", Version = "", EntryPoint = "glWindowPos2dvARB")]
            public static extern void WindowPos2(ref Double v);

            /// <summary>[requires: ARB_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_window_pos", Version = "", EntryPoint = "glWindowPos2dvARB")]
            public static extern unsafe void WindowPos2(Double* v);

            /// <summary>[requires: ARB_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_window_pos", Version = "", EntryPoint = "glWindowPos2fARB")]
            public static extern void WindowPos2(Single x, Single y);

            /// <summary>[requires: ARB_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_window_pos", Version = "", EntryPoint = "glWindowPos2fvARB")]
            public static extern void WindowPos2(Single[] v);

            /// <summary>[requires: ARB_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_window_pos", Version = "", EntryPoint = "glWindowPos2fvARB")]
            public static extern void WindowPos2(ref Single v);

            /// <summary>[requires: ARB_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_window_pos", Version = "", EntryPoint = "glWindowPos2fvARB")]
            public static extern unsafe void WindowPos2(Single* v);

            /// <summary>[requires: ARB_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_window_pos", Version = "", EntryPoint = "glWindowPos2iARB")]
            public static extern void WindowPos2(Int32 x, Int32 y);

            /// <summary>[requires: ARB_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_window_pos", Version = "", EntryPoint = "glWindowPos2ivARB")]
            public static extern void WindowPos2(Int32[] v);

            /// <summary>[requires: ARB_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_window_pos", Version = "", EntryPoint = "glWindowPos2ivARB")]
            public static extern void WindowPos2(ref Int32 v);

            /// <summary>[requires: ARB_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_window_pos", Version = "", EntryPoint = "glWindowPos2ivARB")]
            public static extern unsafe void WindowPos2(Int32* v);

            /// <summary>[requires: ARB_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_window_pos", Version = "", EntryPoint = "glWindowPos2sARB")]
            public static extern void WindowPos2(Int16 x, Int16 y);

            /// <summary>[requires: ARB_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_window_pos", Version = "", EntryPoint = "glWindowPos2svARB")]
            public static extern void WindowPos2(Int16[] v);

            /// <summary>[requires: ARB_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_window_pos", Version = "", EntryPoint = "glWindowPos2svARB")]
            public static extern void WindowPos2(ref Int16 v);

            /// <summary>[requires: ARB_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_window_pos", Version = "", EntryPoint = "glWindowPos2svARB")]
            public static extern unsafe void WindowPos2(Int16* v);

            /// <summary>[requires: ARB_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_window_pos", Version = "", EntryPoint = "glWindowPos3dARB")]
            public static extern void WindowPos3(Double x, Double y, Double z);

            /// <summary>[requires: ARB_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_window_pos", Version = "", EntryPoint = "glWindowPos3dvARB")]
            public static extern void WindowPos3(Double[] v);

            /// <summary>[requires: ARB_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_window_pos", Version = "", EntryPoint = "glWindowPos3dvARB")]
            public static extern void WindowPos3(ref Double v);

            /// <summary>[requires: ARB_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_window_pos", Version = "", EntryPoint = "glWindowPos3dvARB")]
            public static extern unsafe void WindowPos3(Double* v);

            /// <summary>[requires: ARB_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_window_pos", Version = "", EntryPoint = "glWindowPos3fARB")]
            public static extern void WindowPos3(Single x, Single y, Single z);

            /// <summary>[requires: ARB_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_window_pos", Version = "", EntryPoint = "glWindowPos3fvARB")]
            public static extern void WindowPos3(Single[] v);

            /// <summary>[requires: ARB_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_window_pos", Version = "", EntryPoint = "glWindowPos3fvARB")]
            public static extern void WindowPos3(ref Single v);

            /// <summary>[requires: ARB_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_window_pos", Version = "", EntryPoint = "glWindowPos3fvARB")]
            public static extern unsafe void WindowPos3(Single* v);

            /// <summary>[requires: ARB_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_window_pos", Version = "", EntryPoint = "glWindowPos3iARB")]
            public static extern void WindowPos3(Int32 x, Int32 y, Int32 z);

            /// <summary>[requires: ARB_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_window_pos", Version = "", EntryPoint = "glWindowPos3ivARB")]
            public static extern void WindowPos3(Int32[] v);

            /// <summary>[requires: ARB_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_window_pos", Version = "", EntryPoint = "glWindowPos3ivARB")]
            public static extern void WindowPos3(ref Int32 v);

            /// <summary>[requires: ARB_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_window_pos", Version = "", EntryPoint = "glWindowPos3ivARB")]
            public static extern unsafe void WindowPos3(Int32* v);

            /// <summary>[requires: ARB_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_window_pos", Version = "", EntryPoint = "glWindowPos3sARB")]
            public static extern void WindowPos3(Int16 x, Int16 y, Int16 z);

            /// <summary>[requires: ARB_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_window_pos", Version = "", EntryPoint = "glWindowPos3svARB")]
            public static extern void WindowPos3(Int16[] v);

            /// <summary>[requires: ARB_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ARB_window_pos", Version = "", EntryPoint = "glWindowPos3svARB")]
            public static extern void WindowPos3(ref Int16 v);

            /// <summary>[requires: ARB_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ARB_window_pos", Version = "", EntryPoint = "glWindowPos3svARB")]
            public static extern unsafe void WindowPos3(Int16* v);

        }

        public static partial class Ati
        {
            /// <summary>[requires: ATI_fragment_shader]</summary>
            [AutoGenerated(Category = "ATI_fragment_shader", Version = "", EntryPoint = "glAlphaFragmentOp1ATI")]
            public static extern void AlphaFragmentOp1(OpenTK.Graphics.OpenGL.AtiFragmentShader op, Int32 dst, Int32 dstMod, Int32 arg1, Int32 arg1Rep, Int32 arg1Mod);

            /// <summary>[requires: ATI_fragment_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_fragment_shader", Version = "", EntryPoint = "glAlphaFragmentOp1ATI")]
            public static extern void AlphaFragmentOp1(OpenTK.Graphics.OpenGL.AtiFragmentShader op, UInt32 dst, UInt32 dstMod, UInt32 arg1, UInt32 arg1Rep, UInt32 arg1Mod);

            /// <summary>[requires: ATI_fragment_shader]</summary>
            [AutoGenerated(Category = "ATI_fragment_shader", Version = "", EntryPoint = "glAlphaFragmentOp2ATI")]
            public static extern void AlphaFragmentOp2(OpenTK.Graphics.OpenGL.AtiFragmentShader op, Int32 dst, Int32 dstMod, Int32 arg1, Int32 arg1Rep, Int32 arg1Mod, Int32 arg2, Int32 arg2Rep, Int32 arg2Mod);

            /// <summary>[requires: ATI_fragment_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_fragment_shader", Version = "", EntryPoint = "glAlphaFragmentOp2ATI")]
            public static extern void AlphaFragmentOp2(OpenTK.Graphics.OpenGL.AtiFragmentShader op, UInt32 dst, UInt32 dstMod, UInt32 arg1, UInt32 arg1Rep, UInt32 arg1Mod, UInt32 arg2, UInt32 arg2Rep, UInt32 arg2Mod);

            /// <summary>[requires: ATI_fragment_shader]</summary>
            [AutoGenerated(Category = "ATI_fragment_shader", Version = "", EntryPoint = "glAlphaFragmentOp3ATI")]
            public static extern void AlphaFragmentOp3(OpenTK.Graphics.OpenGL.AtiFragmentShader op, Int32 dst, Int32 dstMod, Int32 arg1, Int32 arg1Rep, Int32 arg1Mod, Int32 arg2, Int32 arg2Rep, Int32 arg2Mod, Int32 arg3, Int32 arg3Rep, Int32 arg3Mod);

            /// <summary>[requires: ATI_fragment_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_fragment_shader", Version = "", EntryPoint = "glAlphaFragmentOp3ATI")]
            public static extern void AlphaFragmentOp3(OpenTK.Graphics.OpenGL.AtiFragmentShader op, UInt32 dst, UInt32 dstMod, UInt32 arg1, UInt32 arg1Rep, UInt32 arg1Mod, UInt32 arg2, UInt32 arg2Rep, UInt32 arg2Mod, UInt32 arg3, UInt32 arg3Rep, UInt32 arg3Mod);

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glArrayObjectATI")]
            public static extern void ArrayObject(OpenTK.Graphics.OpenGL.EnableCap array, Int32 size, OpenTK.Graphics.OpenGL.AtiVertexArrayObject type, Int32 stride, Int32 buffer, Int32 offset);

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glArrayObjectATI")]
            public static extern void ArrayObject(OpenTK.Graphics.OpenGL.EnableCap array, Int32 size, OpenTK.Graphics.OpenGL.AtiVertexArrayObject type, Int32 stride, UInt32 buffer, UInt32 offset);

            /// <summary>[requires: ATI_fragment_shader]</summary>
            [AutoGenerated(Category = "ATI_fragment_shader", Version = "", EntryPoint = "glBeginFragmentShaderATI")]
            public static extern void BeginFragmentShader();

            /// <summary>[requires: ATI_fragment_shader]</summary>
            [AutoGenerated(Category = "ATI_fragment_shader", Version = "", EntryPoint = "glBindFragmentShaderATI")]
            public static extern void BindFragmentShader(Int32 id);

            /// <summary>[requires: ATI_fragment_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_fragment_shader", Version = "", EntryPoint = "glBindFragmentShaderATI")]
            public static extern void BindFragmentShader(UInt32 id);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glClientActiveVertexStreamATI")]
            public static extern void ClientActiveVertexStream(OpenTK.Graphics.OpenGL.AtiVertexStreams stream);

            /// <summary>[requires: ATI_fragment_shader]</summary>
            [AutoGenerated(Category = "ATI_fragment_shader", Version = "", EntryPoint = "glColorFragmentOp1ATI")]
            public static extern void ColorFragmentOp1(OpenTK.Graphics.OpenGL.AtiFragmentShader op, Int32 dst, Int32 dstMask, Int32 dstMod, Int32 arg1, Int32 arg1Rep, Int32 arg1Mod);

            /// <summary>[requires: ATI_fragment_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_fragment_shader", Version = "", EntryPoint = "glColorFragmentOp1ATI")]
            public static extern void ColorFragmentOp1(OpenTK.Graphics.OpenGL.AtiFragmentShader op, UInt32 dst, UInt32 dstMask, UInt32 dstMod, UInt32 arg1, UInt32 arg1Rep, UInt32 arg1Mod);

            /// <summary>[requires: ATI_fragment_shader]</summary>
            [AutoGenerated(Category = "ATI_fragment_shader", Version = "", EntryPoint = "glColorFragmentOp2ATI")]
            public static extern void ColorFragmentOp2(OpenTK.Graphics.OpenGL.AtiFragmentShader op, Int32 dst, Int32 dstMask, Int32 dstMod, Int32 arg1, Int32 arg1Rep, Int32 arg1Mod, Int32 arg2, Int32 arg2Rep, Int32 arg2Mod);

            /// <summary>[requires: ATI_fragment_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_fragment_shader", Version = "", EntryPoint = "glColorFragmentOp2ATI")]
            public static extern void ColorFragmentOp2(OpenTK.Graphics.OpenGL.AtiFragmentShader op, UInt32 dst, UInt32 dstMask, UInt32 dstMod, UInt32 arg1, UInt32 arg1Rep, UInt32 arg1Mod, UInt32 arg2, UInt32 arg2Rep, UInt32 arg2Mod);

            /// <summary>[requires: ATI_fragment_shader]</summary>
            [AutoGenerated(Category = "ATI_fragment_shader", Version = "", EntryPoint = "glColorFragmentOp3ATI")]
            public static extern void ColorFragmentOp3(OpenTK.Graphics.OpenGL.AtiFragmentShader op, Int32 dst, Int32 dstMask, Int32 dstMod, Int32 arg1, Int32 arg1Rep, Int32 arg1Mod, Int32 arg2, Int32 arg2Rep, Int32 arg2Mod, Int32 arg3, Int32 arg3Rep, Int32 arg3Mod);

            /// <summary>[requires: ATI_fragment_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_fragment_shader", Version = "", EntryPoint = "glColorFragmentOp3ATI")]
            public static extern void ColorFragmentOp3(OpenTK.Graphics.OpenGL.AtiFragmentShader op, UInt32 dst, UInt32 dstMask, UInt32 dstMod, UInt32 arg1, UInt32 arg1Rep, UInt32 arg1Mod, UInt32 arg2, UInt32 arg2Rep, UInt32 arg2Mod, UInt32 arg3, UInt32 arg3Rep, UInt32 arg3Mod);

            /// <summary>[requires: ATI_fragment_shader]</summary>
            [AutoGenerated(Category = "ATI_fragment_shader", Version = "", EntryPoint = "glDeleteFragmentShaderATI")]
            public static extern void DeleteFragmentShader(Int32 id);

            /// <summary>[requires: ATI_fragment_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_fragment_shader", Version = "", EntryPoint = "glDeleteFragmentShaderATI")]
            public static extern void DeleteFragmentShader(UInt32 id);

            /// <summary>[requires: ATI_draw_buffers]
            /// Specifies a list of color buffers to be drawn into
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of buffers in bufs.
            /// </para>
            /// </param>
            /// <param name="bufs">
            /// <para>
            /// Points to an array of symbolic constants specifying the buffers into which fragment colors or data values will be written.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ATI_draw_buffers", Version = "", EntryPoint = "glDrawBuffersATI")]
            public static extern void DrawBuffers(Int32 n, OpenTK.Graphics.OpenGL.AtiDrawBuffers[] bufs);

            /// <summary>[requires: ATI_draw_buffers]
            /// Specifies a list of color buffers to be drawn into
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of buffers in bufs.
            /// </para>
            /// </param>
            /// <param name="bufs">
            /// <para>
            /// Points to an array of symbolic constants specifying the buffers into which fragment colors or data values will be written.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ATI_draw_buffers", Version = "", EntryPoint = "glDrawBuffersATI")]
            public static extern void DrawBuffers(Int32 n, ref OpenTK.Graphics.OpenGL.AtiDrawBuffers bufs);

            /// <summary>[requires: ATI_draw_buffers]
            /// Specifies a list of color buffers to be drawn into
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of buffers in bufs.
            /// </para>
            /// </param>
            /// <param name="bufs">
            /// <para>
            /// Points to an array of symbolic constants specifying the buffers into which fragment colors or data values will be written.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_draw_buffers", Version = "", EntryPoint = "glDrawBuffersATI")]
            public static extern unsafe void DrawBuffers(Int32 n, OpenTK.Graphics.OpenGL.AtiDrawBuffers* bufs);

            /// <summary>[requires: ATI_element_array]</summary>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "ATI_element_array", Version = "", EntryPoint = "glDrawElementArrayATI")]
            public static extern void DrawElementArray(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 count);

            /// <summary>[requires: ATI_element_array]</summary>
            [AutoGenerated(Category = "ATI_element_array", Version = "", EntryPoint = "glDrawElementArrayATI")]
            public static extern void DrawElementArray(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count);

            /// <summary>[requires: ATI_element_array]</summary>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "ATI_element_array", Version = "", EntryPoint = "glDrawRangeElementArrayATI")]
            public static extern void DrawRangeElementArray(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 start, Int32 end, Int32 count);

            /// <summary>[requires: ATI_element_array]</summary>
            [Obsolete("Use PrimitiveType overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_element_array", Version = "", EntryPoint = "glDrawRangeElementArrayATI")]
            public static extern void DrawRangeElementArray(OpenTK.Graphics.OpenGL.BeginMode mode, UInt32 start, UInt32 end, Int32 count);

            /// <summary>[requires: ATI_element_array]</summary>
            [AutoGenerated(Category = "ATI_element_array", Version = "", EntryPoint = "glDrawRangeElementArrayATI")]
            public static extern void DrawRangeElementArray(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 start, Int32 end, Int32 count);

            /// <summary>[requires: ATI_element_array]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_element_array", Version = "", EntryPoint = "glDrawRangeElementArrayATI")]
            public static extern void DrawRangeElementArray(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 start, UInt32 end, Int32 count);

            /// <summary>[requires: ATI_element_array]</summary>
            [AutoGenerated(Category = "ATI_element_array", Version = "", EntryPoint = "glElementPointerATI")]
            public static extern void ElementPointer(OpenTK.Graphics.OpenGL.AtiElementArray type, IntPtr pointer);

            /// <summary>[requires: ATI_element_array]</summary>
            [AutoGenerated(Category = "ATI_element_array", Version = "", EntryPoint = "glElementPointerATI")]
            public static extern void ElementPointer<T1>(OpenTK.Graphics.OpenGL.AtiElementArray type, [InAttribute, OutAttribute] T1[] pointer)
                where T1 : struct
            ;

            /// <summary>[requires: ATI_element_array]</summary>
            [AutoGenerated(Category = "ATI_element_array", Version = "", EntryPoint = "glElementPointerATI")]
            public static extern void ElementPointer<T1>(OpenTK.Graphics.OpenGL.AtiElementArray type, [InAttribute, OutAttribute] T1[,] pointer)
                where T1 : struct
            ;

            /// <summary>[requires: ATI_element_array]</summary>
            [AutoGenerated(Category = "ATI_element_array", Version = "", EntryPoint = "glElementPointerATI")]
            public static extern void ElementPointer<T1>(OpenTK.Graphics.OpenGL.AtiElementArray type, [InAttribute, OutAttribute] T1[,,] pointer)
                where T1 : struct
            ;

            /// <summary>[requires: ATI_element_array]</summary>
            [AutoGenerated(Category = "ATI_element_array", Version = "", EntryPoint = "glElementPointerATI")]
            public static extern void ElementPointer<T1>(OpenTK.Graphics.OpenGL.AtiElementArray type, [InAttribute, OutAttribute] ref T1 pointer)
                where T1 : struct
            ;

            /// <summary>[requires: ATI_fragment_shader]</summary>
            [AutoGenerated(Category = "ATI_fragment_shader", Version = "", EntryPoint = "glEndFragmentShaderATI")]
            public static extern void EndFragmentShader();

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glFreeObjectBufferATI")]
            public static extern void FreeObjectBuffer(Int32 buffer);

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glFreeObjectBufferATI")]
            public static extern void FreeObjectBuffer(UInt32 buffer);

            /// <summary>[requires: ATI_fragment_shader]</summary>
            [AutoGenerated(Category = "ATI_fragment_shader", Version = "", EntryPoint = "glGenFragmentShadersATI")]
            public static extern Int32 GenFragmentShaders(Int32 range);

            /// <summary>[requires: ATI_fragment_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_fragment_shader", Version = "", EntryPoint = "glGenFragmentShadersATI")]
            public static extern Int32 GenFragmentShaders(UInt32 range);

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glGetArrayObjectfvATI")]
            public static extern void GetArrayObject(OpenTK.Graphics.OpenGL.EnableCap array, OpenTK.Graphics.OpenGL.AtiVertexArrayObject pname, [OutAttribute] out Single @params);

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glGetArrayObjectfvATI")]
            public static extern unsafe void GetArrayObject(OpenTK.Graphics.OpenGL.EnableCap array, OpenTK.Graphics.OpenGL.AtiVertexArrayObject pname, [OutAttribute] Single* @params);

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glGetArrayObjectivATI")]
            public static extern void GetArrayObject(OpenTK.Graphics.OpenGL.EnableCap array, OpenTK.Graphics.OpenGL.AtiVertexArrayObject pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glGetArrayObjectivATI")]
            public static extern unsafe void GetArrayObject(OpenTK.Graphics.OpenGL.EnableCap array, OpenTK.Graphics.OpenGL.AtiVertexArrayObject pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glGetObjectBufferfvATI")]
            public static extern void GetObjectBuffer(Int32 buffer, OpenTK.Graphics.OpenGL.AtiVertexArrayObject pname, [OutAttribute] out Single @params);

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glGetObjectBufferfvATI")]
            public static extern unsafe void GetObjectBuffer(Int32 buffer, OpenTK.Graphics.OpenGL.AtiVertexArrayObject pname, [OutAttribute] Single* @params);

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glGetObjectBufferfvATI")]
            public static extern void GetObjectBuffer(UInt32 buffer, OpenTK.Graphics.OpenGL.AtiVertexArrayObject pname, [OutAttribute] out Single @params);

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glGetObjectBufferfvATI")]
            public static extern unsafe void GetObjectBuffer(UInt32 buffer, OpenTK.Graphics.OpenGL.AtiVertexArrayObject pname, [OutAttribute] Single* @params);

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glGetObjectBufferivATI")]
            public static extern void GetObjectBuffer(Int32 buffer, OpenTK.Graphics.OpenGL.AtiVertexArrayObject pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glGetObjectBufferivATI")]
            public static extern unsafe void GetObjectBuffer(Int32 buffer, OpenTK.Graphics.OpenGL.AtiVertexArrayObject pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glGetObjectBufferivATI")]
            public static extern void GetObjectBuffer(UInt32 buffer, OpenTK.Graphics.OpenGL.AtiVertexArrayObject pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glGetObjectBufferivATI")]
            public static extern unsafe void GetObjectBuffer(UInt32 buffer, OpenTK.Graphics.OpenGL.AtiVertexArrayObject pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: ATI_envmap_bumpmap]</summary>
            [AutoGenerated(Category = "ATI_envmap_bumpmap", Version = "", EntryPoint = "glGetTexBumpParameterfvATI")]
            public static extern Single GetTexBumpParameter(OpenTK.Graphics.OpenGL.AtiEnvmapBumpmap pname);

            /// <summary>[requires: ATI_envmap_bumpmap]</summary>
            [AutoGenerated(Category = "ATI_envmap_bumpmap", Version = "", EntryPoint = "glGetTexBumpParameterfvATI")]
            public static extern void GetTexBumpParameter(OpenTK.Graphics.OpenGL.AtiEnvmapBumpmap pname, [OutAttribute] Single[] param);

            /// <summary>[requires: ATI_envmap_bumpmap]</summary>
            [AutoGenerated(Category = "ATI_envmap_bumpmap", Version = "", EntryPoint = "glGetTexBumpParameterfvATI")]
            public static extern void GetTexBumpParameter(OpenTK.Graphics.OpenGL.AtiEnvmapBumpmap pname, [OutAttribute] out Single param);

            /// <summary>[requires: ATI_envmap_bumpmap]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_envmap_bumpmap", Version = "", EntryPoint = "glGetTexBumpParameterfvATI")]
            public static extern unsafe void GetTexBumpParameter(OpenTK.Graphics.OpenGL.AtiEnvmapBumpmap pname, [OutAttribute] Single* param);

            /// <summary>[requires: ATI_envmap_bumpmap]</summary>
            [AutoGenerated(Category = "ATI_envmap_bumpmap", Version = "", EntryPoint = "glGetTexBumpParameterivATI")]
            public static extern void GetTexBumpParameter(OpenTK.Graphics.OpenGL.AtiEnvmapBumpmap pname, [OutAttribute] Int32[] param);

            /// <summary>[requires: ATI_envmap_bumpmap]</summary>
            [AutoGenerated(Category = "ATI_envmap_bumpmap", Version = "", EntryPoint = "glGetTexBumpParameterivATI")]
            public static extern void GetTexBumpParameter(OpenTK.Graphics.OpenGL.AtiEnvmapBumpmap pname, [OutAttribute] out Int32 param);

            /// <summary>[requires: ATI_envmap_bumpmap]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_envmap_bumpmap", Version = "", EntryPoint = "glGetTexBumpParameterivATI")]
            public static extern unsafe void GetTexBumpParameter(OpenTK.Graphics.OpenGL.AtiEnvmapBumpmap pname, [OutAttribute] Int32* param);

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glGetVariantArrayObjectfvATI")]
            public static extern void GetVariantArrayObject(Int32 id, OpenTK.Graphics.OpenGL.AtiVertexArrayObject pname, [OutAttribute] out Single @params);

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glGetVariantArrayObjectfvATI")]
            public static extern unsafe void GetVariantArrayObject(Int32 id, OpenTK.Graphics.OpenGL.AtiVertexArrayObject pname, [OutAttribute] Single* @params);

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glGetVariantArrayObjectfvATI")]
            public static extern void GetVariantArrayObject(UInt32 id, OpenTK.Graphics.OpenGL.AtiVertexArrayObject pname, [OutAttribute] out Single @params);

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glGetVariantArrayObjectfvATI")]
            public static extern unsafe void GetVariantArrayObject(UInt32 id, OpenTK.Graphics.OpenGL.AtiVertexArrayObject pname, [OutAttribute] Single* @params);

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glGetVariantArrayObjectivATI")]
            public static extern void GetVariantArrayObject(Int32 id, OpenTK.Graphics.OpenGL.AtiVertexArrayObject pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glGetVariantArrayObjectivATI")]
            public static extern unsafe void GetVariantArrayObject(Int32 id, OpenTK.Graphics.OpenGL.AtiVertexArrayObject pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glGetVariantArrayObjectivATI")]
            public static extern void GetVariantArrayObject(UInt32 id, OpenTK.Graphics.OpenGL.AtiVertexArrayObject pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glGetVariantArrayObjectivATI")]
            public static extern unsafe void GetVariantArrayObject(UInt32 id, OpenTK.Graphics.OpenGL.AtiVertexArrayObject pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: ATI_vertex_attrib_array_object]</summary>
            [AutoGenerated(Category = "ATI_vertex_attrib_array_object", Version = "", EntryPoint = "glGetVertexAttribArrayObjectfvATI")]
            public static extern void GetVertexAttribArrayObject(Int32 index, OpenTK.Graphics.OpenGL.AtiVertexAttribArrayObject pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: ATI_vertex_attrib_array_object]</summary>
            [AutoGenerated(Category = "ATI_vertex_attrib_array_object", Version = "", EntryPoint = "glGetVertexAttribArrayObjectfvATI")]
            public static extern void GetVertexAttribArrayObject(Int32 index, OpenTK.Graphics.OpenGL.AtiVertexAttribArrayObject pname, [OutAttribute] out Single @params);

            /// <summary>[requires: ATI_vertex_attrib_array_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_attrib_array_object", Version = "", EntryPoint = "glGetVertexAttribArrayObjectfvATI")]
            public static extern unsafe void GetVertexAttribArrayObject(Int32 index, OpenTK.Graphics.OpenGL.AtiVertexAttribArrayObject pname, [OutAttribute] Single* @params);

            /// <summary>[requires: ATI_vertex_attrib_array_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_attrib_array_object", Version = "", EntryPoint = "glGetVertexAttribArrayObjectfvATI")]
            public static extern void GetVertexAttribArrayObject(UInt32 index, OpenTK.Graphics.OpenGL.AtiVertexAttribArrayObject pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: ATI_vertex_attrib_array_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_attrib_array_object", Version = "", EntryPoint = "glGetVertexAttribArrayObjectfvATI")]
            public static extern void GetVertexAttribArrayObject(UInt32 index, OpenTK.Graphics.OpenGL.AtiVertexAttribArrayObject pname, [OutAttribute] out Single @params);

            /// <summary>[requires: ATI_vertex_attrib_array_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_attrib_array_object", Version = "", EntryPoint = "glGetVertexAttribArrayObjectfvATI")]
            public static extern unsafe void GetVertexAttribArrayObject(UInt32 index, OpenTK.Graphics.OpenGL.AtiVertexAttribArrayObject pname, [OutAttribute] Single* @params);

            /// <summary>[requires: ATI_vertex_attrib_array_object]</summary>
            [AutoGenerated(Category = "ATI_vertex_attrib_array_object", Version = "", EntryPoint = "glGetVertexAttribArrayObjectivATI")]
            public static extern void GetVertexAttribArrayObject(Int32 index, OpenTK.Graphics.OpenGL.AtiVertexAttribArrayObject pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: ATI_vertex_attrib_array_object]</summary>
            [AutoGenerated(Category = "ATI_vertex_attrib_array_object", Version = "", EntryPoint = "glGetVertexAttribArrayObjectivATI")]
            public static extern void GetVertexAttribArrayObject(Int32 index, OpenTK.Graphics.OpenGL.AtiVertexAttribArrayObject pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: ATI_vertex_attrib_array_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_attrib_array_object", Version = "", EntryPoint = "glGetVertexAttribArrayObjectivATI")]
            public static extern unsafe void GetVertexAttribArrayObject(Int32 index, OpenTK.Graphics.OpenGL.AtiVertexAttribArrayObject pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: ATI_vertex_attrib_array_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_attrib_array_object", Version = "", EntryPoint = "glGetVertexAttribArrayObjectivATI")]
            public static extern void GetVertexAttribArrayObject(UInt32 index, OpenTK.Graphics.OpenGL.AtiVertexAttribArrayObject pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: ATI_vertex_attrib_array_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_attrib_array_object", Version = "", EntryPoint = "glGetVertexAttribArrayObjectivATI")]
            public static extern void GetVertexAttribArrayObject(UInt32 index, OpenTK.Graphics.OpenGL.AtiVertexAttribArrayObject pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: ATI_vertex_attrib_array_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_attrib_array_object", Version = "", EntryPoint = "glGetVertexAttribArrayObjectivATI")]
            public static extern unsafe void GetVertexAttribArrayObject(UInt32 index, OpenTK.Graphics.OpenGL.AtiVertexAttribArrayObject pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glIsObjectBufferATI")]
            public static extern bool IsObjectBuffer(Int32 buffer);

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glIsObjectBufferATI")]
            public static extern bool IsObjectBuffer(UInt32 buffer);

            /// <summary>[requires: ATI_map_object_buffer]</summary>
            [AutoGenerated(Category = "ATI_map_object_buffer", Version = "", EntryPoint = "glMapObjectBufferATI")]
            public static extern IntPtr MapObjectBuffer(Int32 buffer);

            /// <summary>[requires: ATI_map_object_buffer]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_map_object_buffer", Version = "", EntryPoint = "glMapObjectBufferATI")]
            public static extern IntPtr MapObjectBuffer(UInt32 buffer);

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glNewObjectBufferATI")]
            public static extern Int32 NewObjectBuffer(Int32 size, IntPtr pointer, OpenTK.Graphics.OpenGL.AtiVertexArrayObject usage);

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glNewObjectBufferATI")]
            public static extern Int32 NewObjectBuffer<T1>(Int32 size, [InAttribute, OutAttribute] T1[] pointer, OpenTK.Graphics.OpenGL.AtiVertexArrayObject usage)
                where T1 : struct
            ;

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glNewObjectBufferATI")]
            public static extern Int32 NewObjectBuffer<T1>(Int32 size, [InAttribute, OutAttribute] T1[,] pointer, OpenTK.Graphics.OpenGL.AtiVertexArrayObject usage)
                where T1 : struct
            ;

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glNewObjectBufferATI")]
            public static extern Int32 NewObjectBuffer<T1>(Int32 size, [InAttribute, OutAttribute] T1[,,] pointer, OpenTK.Graphics.OpenGL.AtiVertexArrayObject usage)
                where T1 : struct
            ;

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glNewObjectBufferATI")]
            public static extern Int32 NewObjectBuffer<T1>(Int32 size, [InAttribute, OutAttribute] ref T1 pointer, OpenTK.Graphics.OpenGL.AtiVertexArrayObject usage)
                where T1 : struct
            ;

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glNormalStream3bATI")]
            public static extern void NormalStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Byte nx, Byte ny, Byte nz);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glNormalStream3bATI")]
            public static extern void NormalStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, SByte nx, SByte ny, SByte nz);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glNormalStream3bvATI")]
            public static extern void NormalStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Byte[] coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glNormalStream3bvATI")]
            public static extern void NormalStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, ref Byte coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glNormalStream3bvATI")]
            public static extern unsafe void NormalStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Byte* coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glNormalStream3bvATI")]
            public static extern void NormalStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, SByte[] coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glNormalStream3bvATI")]
            public static extern void NormalStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, ref SByte coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glNormalStream3bvATI")]
            public static extern unsafe void NormalStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, SByte* coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glNormalStream3dATI")]
            public static extern void NormalStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Double nx, Double ny, Double nz);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glNormalStream3dvATI")]
            public static extern void NormalStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Double[] coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glNormalStream3dvATI")]
            public static extern void NormalStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, ref Double coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glNormalStream3dvATI")]
            public static extern unsafe void NormalStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Double* coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glNormalStream3fATI")]
            public static extern void NormalStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Single nx, Single ny, Single nz);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glNormalStream3fvATI")]
            public static extern void NormalStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Single[] coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glNormalStream3fvATI")]
            public static extern void NormalStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, ref Single coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glNormalStream3fvATI")]
            public static extern unsafe void NormalStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Single* coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glNormalStream3iATI")]
            public static extern void NormalStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int32 nx, Int32 ny, Int32 nz);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glNormalStream3ivATI")]
            public static extern void NormalStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int32[] coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glNormalStream3ivATI")]
            public static extern void NormalStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, ref Int32 coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glNormalStream3ivATI")]
            public static extern unsafe void NormalStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int32* coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glNormalStream3sATI")]
            public static extern void NormalStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int16 nx, Int16 ny, Int16 nz);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glNormalStream3svATI")]
            public static extern void NormalStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int16[] coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glNormalStream3svATI")]
            public static extern void NormalStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, ref Int16 coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glNormalStream3svATI")]
            public static extern unsafe void NormalStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int16* coords);

            /// <summary>[requires: ATI_fragment_shader]</summary>
            [AutoGenerated(Category = "ATI_fragment_shader", Version = "", EntryPoint = "glPassTexCoordATI")]
            public static extern void PassTexCoord(Int32 dst, Int32 coord, OpenTK.Graphics.OpenGL.AtiFragmentShader swizzle);

            /// <summary>[requires: ATI_fragment_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_fragment_shader", Version = "", EntryPoint = "glPassTexCoordATI")]
            public static extern void PassTexCoord(UInt32 dst, UInt32 coord, OpenTK.Graphics.OpenGL.AtiFragmentShader swizzle);

            /// <summary>[requires: ATI_pn_triangles]</summary>
            [AutoGenerated(Category = "ATI_pn_triangles", Version = "", EntryPoint = "glPNTrianglesfATI")]
            public static extern void PNTriangles(OpenTK.Graphics.OpenGL.AtiPnTriangles pname, Single param);

            /// <summary>[requires: ATI_pn_triangles]</summary>
            [AutoGenerated(Category = "ATI_pn_triangles", Version = "", EntryPoint = "glPNTrianglesiATI")]
            public static extern void PNTriangles(OpenTK.Graphics.OpenGL.AtiPnTriangles pname, Int32 param);

            /// <summary>[requires: ATI_fragment_shader]</summary>
            [AutoGenerated(Category = "ATI_fragment_shader", Version = "", EntryPoint = "glSampleMapATI")]
            public static extern void SampleMap(Int32 dst, Int32 interp, OpenTK.Graphics.OpenGL.AtiFragmentShader swizzle);

            /// <summary>[requires: ATI_fragment_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_fragment_shader", Version = "", EntryPoint = "glSampleMapATI")]
            public static extern void SampleMap(UInt32 dst, UInt32 interp, OpenTK.Graphics.OpenGL.AtiFragmentShader swizzle);

            /// <summary>[requires: ATI_fragment_shader]</summary>
            [AutoGenerated(Category = "ATI_fragment_shader", Version = "", EntryPoint = "glSetFragmentShaderConstantATI")]
            public static extern void SetFragmentShaderConstant(Int32 dst, Single[] value);

            /// <summary>[requires: ATI_fragment_shader]</summary>
            [AutoGenerated(Category = "ATI_fragment_shader", Version = "", EntryPoint = "glSetFragmentShaderConstantATI")]
            public static extern void SetFragmentShaderConstant(Int32 dst, ref Single value);

            /// <summary>[requires: ATI_fragment_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_fragment_shader", Version = "", EntryPoint = "glSetFragmentShaderConstantATI")]
            public static extern unsafe void SetFragmentShaderConstant(Int32 dst, Single* value);

            /// <summary>[requires: ATI_fragment_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_fragment_shader", Version = "", EntryPoint = "glSetFragmentShaderConstantATI")]
            public static extern void SetFragmentShaderConstant(UInt32 dst, Single[] value);

            /// <summary>[requires: ATI_fragment_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_fragment_shader", Version = "", EntryPoint = "glSetFragmentShaderConstantATI")]
            public static extern void SetFragmentShaderConstant(UInt32 dst, ref Single value);

            /// <summary>[requires: ATI_fragment_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_fragment_shader", Version = "", EntryPoint = "glSetFragmentShaderConstantATI")]
            public static extern unsafe void SetFragmentShaderConstant(UInt32 dst, Single* value);

            /// <summary>[requires: ATI_separate_stencil]
            /// Set front and/or back function and reference value for stencil testing
            /// </summary>
            /// <param name="face">
            /// <para>
            /// Specifies whether front and/or back stencil state is updated. Three symbolic constants are valid: GL_FRONT, GL_BACK, and GL_FRONT_AND_BACK.
            /// </para>
            /// </param>
            /// <param name="func">
            /// <para>
            /// Specifies the test function. Eight symbolic constants are valid: GL_NEVER, GL_LESS, GL_LEQUAL, GL_GREATER, GL_GEQUAL, GL_EQUAL, GL_NOTEQUAL, and GL_ALWAYS. The initial value is GL_ALWAYS.
            /// </para>
            /// </param>
            /// <param name="ref">
            /// <para>
            /// Specifies the reference value for the stencil test. ref is clamped to the range [0, 2 sup n - 1], where is the number of bitplanes in the stencil buffer. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="mask">
            /// <para>
            /// Specifies a mask that is ANDed with both the reference value and the stored stencil value when the test is done. The initial value is all 1's.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ATI_separate_stencil", Version = "", EntryPoint = "glStencilFuncSeparateATI")]
            public static extern void StencilFuncSeparate(OpenTK.Graphics.OpenGL.StencilFunction frontfunc, OpenTK.Graphics.OpenGL.StencilFunction backfunc, Int32 @ref, Int32 mask);

            /// <summary>[requires: ATI_separate_stencil]
            /// Set front and/or back function and reference value for stencil testing
            /// </summary>
            /// <param name="face">
            /// <para>
            /// Specifies whether front and/or back stencil state is updated. Three symbolic constants are valid: GL_FRONT, GL_BACK, and GL_FRONT_AND_BACK.
            /// </para>
            /// </param>
            /// <param name="func">
            /// <para>
            /// Specifies the test function. Eight symbolic constants are valid: GL_NEVER, GL_LESS, GL_LEQUAL, GL_GREATER, GL_GEQUAL, GL_EQUAL, GL_NOTEQUAL, and GL_ALWAYS. The initial value is GL_ALWAYS.
            /// </para>
            /// </param>
            /// <param name="ref">
            /// <para>
            /// Specifies the reference value for the stencil test. ref is clamped to the range [0, 2 sup n - 1], where is the number of bitplanes in the stencil buffer. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="mask">
            /// <para>
            /// Specifies a mask that is ANDed with both the reference value and the stored stencil value when the test is done. The initial value is all 1's.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_separate_stencil", Version = "", EntryPoint = "glStencilFuncSeparateATI")]
            public static extern void StencilFuncSeparate(OpenTK.Graphics.OpenGL.StencilFunction frontfunc, OpenTK.Graphics.OpenGL.StencilFunction backfunc, Int32 @ref, UInt32 mask);

            /// <summary>[requires: ATI_separate_stencil]
            /// Set front and/or back stencil test actions
            /// </summary>
            /// <param name="face">
            /// <para>
            /// Specifies whether front and/or back stencil state is updated. Three symbolic constants are valid: GL_FRONT, GL_BACK, and GL_FRONT_AND_BACK.
            /// </para>
            /// </param>
            /// <param name="sfail">
            /// <para>
            /// Specifies the action to take when the stencil test fails. Eight symbolic constants are accepted: GL_KEEP, GL_ZERO, GL_REPLACE, GL_INCR, GL_INCR_WRAP, GL_DECR, GL_DECR_WRAP, and GL_INVERT. The initial value is GL_KEEP.
            /// </para>
            /// </param>
            /// <param name="dpfail">
            /// <para>
            /// Specifies the stencil action when the stencil test passes, but the depth test fails. dpfail accepts the same symbolic constants as sfail. The initial value is GL_KEEP.
            /// </para>
            /// </param>
            /// <param name="dppass">
            /// <para>
            /// Specifies the stencil action when both the stencil test and the depth test pass, or when the stencil test passes and either there is no depth buffer or depth testing is not enabled. dppass accepts the same symbolic constants as sfail. The initial value is GL_KEEP.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "ATI_separate_stencil", Version = "", EntryPoint = "glStencilOpSeparateATI")]
            public static extern void StencilOpSeparate(OpenTK.Graphics.OpenGL.AtiSeparateStencil face, OpenTK.Graphics.OpenGL.StencilOp sfail, OpenTK.Graphics.OpenGL.StencilOp dpfail, OpenTK.Graphics.OpenGL.StencilOp dppass);

            /// <summary>[requires: ATI_envmap_bumpmap]</summary>
            [AutoGenerated(Category = "ATI_envmap_bumpmap", Version = "", EntryPoint = "glTexBumpParameterfvATI")]
            public static extern void TexBumpParameter(OpenTK.Graphics.OpenGL.AtiEnvmapBumpmap pname, Single[] param);

            /// <summary>[requires: ATI_envmap_bumpmap]</summary>
            [AutoGenerated(Category = "ATI_envmap_bumpmap", Version = "", EntryPoint = "glTexBumpParameterfvATI")]
            public static extern void TexBumpParameter(OpenTK.Graphics.OpenGL.AtiEnvmapBumpmap pname, ref Single param);

            /// <summary>[requires: ATI_envmap_bumpmap]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_envmap_bumpmap", Version = "", EntryPoint = "glTexBumpParameterfvATI")]
            public static extern unsafe void TexBumpParameter(OpenTK.Graphics.OpenGL.AtiEnvmapBumpmap pname, Single* param);

            /// <summary>[requires: ATI_envmap_bumpmap]</summary>
            [AutoGenerated(Category = "ATI_envmap_bumpmap", Version = "", EntryPoint = "glTexBumpParameterivATI")]
            public static extern void TexBumpParameter(OpenTK.Graphics.OpenGL.AtiEnvmapBumpmap pname, Int32[] param);

            /// <summary>[requires: ATI_envmap_bumpmap]</summary>
            [AutoGenerated(Category = "ATI_envmap_bumpmap", Version = "", EntryPoint = "glTexBumpParameterivATI")]
            public static extern void TexBumpParameter(OpenTK.Graphics.OpenGL.AtiEnvmapBumpmap pname, ref Int32 param);

            /// <summary>[requires: ATI_envmap_bumpmap]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_envmap_bumpmap", Version = "", EntryPoint = "glTexBumpParameterivATI")]
            public static extern unsafe void TexBumpParameter(OpenTK.Graphics.OpenGL.AtiEnvmapBumpmap pname, Int32* param);

            /// <summary>[requires: ATI_map_object_buffer]</summary>
            [AutoGenerated(Category = "ATI_map_object_buffer", Version = "", EntryPoint = "glUnmapObjectBufferATI")]
            public static extern void UnmapObjectBuffer(Int32 buffer);

            /// <summary>[requires: ATI_map_object_buffer]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_map_object_buffer", Version = "", EntryPoint = "glUnmapObjectBufferATI")]
            public static extern void UnmapObjectBuffer(UInt32 buffer);

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glUpdateObjectBufferATI")]
            public static extern void UpdateObjectBuffer(Int32 buffer, Int32 offset, Int32 size, IntPtr pointer, OpenTK.Graphics.OpenGL.AtiVertexArrayObject preserve);

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glUpdateObjectBufferATI")]
            public static extern void UpdateObjectBuffer<T3>(Int32 buffer, Int32 offset, Int32 size, [InAttribute, OutAttribute] T3[] pointer, OpenTK.Graphics.OpenGL.AtiVertexArrayObject preserve)
                where T3 : struct
            ;

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glUpdateObjectBufferATI")]
            public static extern void UpdateObjectBuffer<T3>(Int32 buffer, Int32 offset, Int32 size, [InAttribute, OutAttribute] T3[,] pointer, OpenTK.Graphics.OpenGL.AtiVertexArrayObject preserve)
                where T3 : struct
            ;

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glUpdateObjectBufferATI")]
            public static extern void UpdateObjectBuffer<T3>(Int32 buffer, Int32 offset, Int32 size, [InAttribute, OutAttribute] T3[,,] pointer, OpenTK.Graphics.OpenGL.AtiVertexArrayObject preserve)
                where T3 : struct
            ;

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glUpdateObjectBufferATI")]
            public static extern void UpdateObjectBuffer<T3>(Int32 buffer, Int32 offset, Int32 size, [InAttribute, OutAttribute] ref T3 pointer, OpenTK.Graphics.OpenGL.AtiVertexArrayObject preserve)
                where T3 : struct
            ;

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glUpdateObjectBufferATI")]
            public static extern void UpdateObjectBuffer(UInt32 buffer, UInt32 offset, Int32 size, IntPtr pointer, OpenTK.Graphics.OpenGL.AtiVertexArrayObject preserve);

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glUpdateObjectBufferATI")]
            public static extern void UpdateObjectBuffer<T3>(UInt32 buffer, UInt32 offset, Int32 size, [InAttribute, OutAttribute] T3[] pointer, OpenTK.Graphics.OpenGL.AtiVertexArrayObject preserve)
                where T3 : struct
            ;

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glUpdateObjectBufferATI")]
            public static extern void UpdateObjectBuffer<T3>(UInt32 buffer, UInt32 offset, Int32 size, [InAttribute, OutAttribute] T3[,] pointer, OpenTK.Graphics.OpenGL.AtiVertexArrayObject preserve)
                where T3 : struct
            ;

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glUpdateObjectBufferATI")]
            public static extern void UpdateObjectBuffer<T3>(UInt32 buffer, UInt32 offset, Int32 size, [InAttribute, OutAttribute] T3[,,] pointer, OpenTK.Graphics.OpenGL.AtiVertexArrayObject preserve)
                where T3 : struct
            ;

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glUpdateObjectBufferATI")]
            public static extern void UpdateObjectBuffer<T3>(UInt32 buffer, UInt32 offset, Int32 size, [InAttribute, OutAttribute] ref T3 pointer, OpenTK.Graphics.OpenGL.AtiVertexArrayObject preserve)
                where T3 : struct
            ;

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glVariantArrayObjectATI")]
            public static extern void VariantArrayObject(Int32 id, OpenTK.Graphics.OpenGL.AtiVertexArrayObject type, Int32 stride, Int32 buffer, Int32 offset);

            /// <summary>[requires: ATI_vertex_array_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_array_object", Version = "", EntryPoint = "glVariantArrayObjectATI")]
            public static extern void VariantArrayObject(UInt32 id, OpenTK.Graphics.OpenGL.AtiVertexArrayObject type, Int32 stride, UInt32 buffer, UInt32 offset);

            /// <summary>[requires: ATI_vertex_attrib_array_object]</summary>
            [Obsolete("Use VertexAttribPointerType overload instead")]
            [AutoGenerated(Category = "ATI_vertex_attrib_array_object", Version = "", EntryPoint = "glVertexAttribArrayObjectATI")]
            public static extern void VertexAttribArrayObject(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.AtiVertexAttribArrayObject type, bool normalized, Int32 stride, Int32 buffer, Int32 offset);

            /// <summary>[requires: ATI_vertex_attrib_array_object]</summary>
            [AutoGenerated(Category = "ATI_vertex_attrib_array_object", Version = "", EntryPoint = "glVertexAttribArrayObjectATI")]
            public static extern void VertexAttribArrayObject(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribPointerType type, bool normalized, Int32 stride, Int32 buffer, Int32 offset);

            /// <summary>[requires: ATI_vertex_attrib_array_object]</summary>
            [Obsolete("Use VertexAttribPointerType overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_attrib_array_object", Version = "", EntryPoint = "glVertexAttribArrayObjectATI")]
            public static extern void VertexAttribArrayObject(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.AtiVertexAttribArrayObject type, bool normalized, Int32 stride, UInt32 buffer, UInt32 offset);

            /// <summary>[requires: ATI_vertex_attrib_array_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_attrib_array_object", Version = "", EntryPoint = "glVertexAttribArrayObjectATI")]
            public static extern void VertexAttribArrayObject(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribPointerType type, bool normalized, Int32 stride, UInt32 buffer, UInt32 offset);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexBlendEnvfATI")]
            public static extern void VertexBlendEnv(OpenTK.Graphics.OpenGL.AtiVertexStreams pname, Single param);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexBlendEnviATI")]
            public static extern void VertexBlendEnv(OpenTK.Graphics.OpenGL.AtiVertexStreams pname, Int32 param);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream1dATI")]
            public static extern void VertexStream1(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Double x);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream1dvATI")]
            public static extern unsafe void VertexStream1(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Double* coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream1fATI")]
            public static extern void VertexStream1(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Single x);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream1fvATI")]
            public static extern unsafe void VertexStream1(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Single* coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream1iATI")]
            public static extern void VertexStream1(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int32 x);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream1ivATI")]
            public static extern unsafe void VertexStream1(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int32* coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream1sATI")]
            public static extern void VertexStream1(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int16 x);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream1svATI")]
            public static extern unsafe void VertexStream1(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int16* coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream2dATI")]
            public static extern void VertexStream2(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Double x, Double y);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream2dvATI")]
            public static extern void VertexStream2(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Double[] coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream2dvATI")]
            public static extern void VertexStream2(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, ref Double coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream2dvATI")]
            public static extern unsafe void VertexStream2(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Double* coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream2fATI")]
            public static extern void VertexStream2(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Single x, Single y);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream2fvATI")]
            public static extern void VertexStream2(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Single[] coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream2fvATI")]
            public static extern void VertexStream2(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, ref Single coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream2fvATI")]
            public static extern unsafe void VertexStream2(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Single* coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream2iATI")]
            public static extern void VertexStream2(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int32 x, Int32 y);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream2ivATI")]
            public static extern void VertexStream2(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int32[] coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream2ivATI")]
            public static extern void VertexStream2(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, ref Int32 coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream2ivATI")]
            public static extern unsafe void VertexStream2(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int32* coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream2sATI")]
            public static extern void VertexStream2(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int16 x, Int16 y);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream2svATI")]
            public static extern void VertexStream2(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int16[] coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream2svATI")]
            public static extern void VertexStream2(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, ref Int16 coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream2svATI")]
            public static extern unsafe void VertexStream2(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int16* coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream3dATI")]
            public static extern void VertexStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Double x, Double y, Double z);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream3dvATI")]
            public static extern void VertexStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Double[] coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream3dvATI")]
            public static extern void VertexStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, ref Double coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream3dvATI")]
            public static extern unsafe void VertexStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Double* coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream3fATI")]
            public static extern void VertexStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Single x, Single y, Single z);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream3fvATI")]
            public static extern void VertexStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Single[] coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream3fvATI")]
            public static extern void VertexStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, ref Single coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream3fvATI")]
            public static extern unsafe void VertexStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Single* coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream3iATI")]
            public static extern void VertexStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int32 x, Int32 y, Int32 z);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream3ivATI")]
            public static extern void VertexStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int32[] coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream3ivATI")]
            public static extern void VertexStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, ref Int32 coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream3ivATI")]
            public static extern unsafe void VertexStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int32* coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream3sATI")]
            public static extern void VertexStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int16 x, Int16 y, Int16 z);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream3svATI")]
            public static extern void VertexStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int16[] coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream3svATI")]
            public static extern void VertexStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, ref Int16 coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream3svATI")]
            public static extern unsafe void VertexStream3(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int16* coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream4dATI")]
            public static extern void VertexStream4(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Double x, Double y, Double z, Double w);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream4dvATI")]
            public static extern void VertexStream4(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Double[] coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream4dvATI")]
            public static extern void VertexStream4(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, ref Double coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream4dvATI")]
            public static extern unsafe void VertexStream4(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Double* coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream4fATI")]
            public static extern void VertexStream4(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Single x, Single y, Single z, Single w);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream4fvATI")]
            public static extern void VertexStream4(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Single[] coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream4fvATI")]
            public static extern void VertexStream4(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, ref Single coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream4fvATI")]
            public static extern unsafe void VertexStream4(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Single* coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream4iATI")]
            public static extern void VertexStream4(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int32 x, Int32 y, Int32 z, Int32 w);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream4ivATI")]
            public static extern void VertexStream4(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int32[] coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream4ivATI")]
            public static extern void VertexStream4(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, ref Int32 coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream4ivATI")]
            public static extern unsafe void VertexStream4(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int32* coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream4sATI")]
            public static extern void VertexStream4(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int16 x, Int16 y, Int16 z, Int16 w);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream4svATI")]
            public static extern void VertexStream4(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int16[] coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream4svATI")]
            public static extern void VertexStream4(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, ref Int16 coords);

            /// <summary>[requires: ATI_vertex_streams]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "ATI_vertex_streams", Version = "", EntryPoint = "glVertexStream4svATI")]
            public static extern unsafe void VertexStream4(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int16* coords);

        }

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Operate on the accumulation buffer
        /// </summary>
        /// <param name="op">
        /// <para>
        /// Specifies the accumulation buffer operation. Symbolic constants GL_ACCUM, GL_LOAD, GL_ADD, GL_MULT, and GL_RETURN are accepted.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// Specifies a floating-point value used in the accumulation buffer operation. op determines how value is used.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glAccum")]
        public static extern void Accum(OpenTK.Graphics.OpenGL.AccumOp op, Single value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Set the active program object for a program pipeline object
        /// </summary>
        /// <param name="pipeline">
        /// <para>
        /// Specifies the program pipeline object to set the active program object for.
        /// </para>
        /// </param>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to set as the active program pipeline object pipeline.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glActiveShaderProgram")]
        public static extern void ActiveShaderProgram(Int32 pipeline, Int32 program);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Set the active program object for a program pipeline object
        /// </summary>
        /// <param name="pipeline">
        /// <para>
        /// Specifies the program pipeline object to set the active program object for.
        /// </para>
        /// </param>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to set as the active program pipeline object pipeline.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glActiveShaderProgram")]
        public static extern void ActiveShaderProgram(UInt32 pipeline, UInt32 program);

        /// <summary>[requires: v1.3]
        /// Select active texture unit
        /// </summary>
        /// <param name="texture">
        /// <para>
        /// Specifies which texture unit to make active. The number of texture units is implementation dependent, but must be at least 80. texture must be one of GL_TEXTUREi, where i ranges from 0 (GL_MAX_COMBINED_TEXTURE_IMAGE_UNITS - 1). The initial value is GL_TEXTURE0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glActiveTexture")]
        public static extern void ActiveTexture(OpenTK.Graphics.OpenGL.TextureUnit texture);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the alpha test function
        /// </summary>
        /// <param name="func">
        /// <para>
        /// Specifies the alpha comparison function. Symbolic constants GL_NEVER, GL_LESS, GL_EQUAL, GL_LEQUAL, GL_GREATER, GL_NOTEQUAL, GL_GEQUAL, and GL_ALWAYS are accepted. The initial value is GL_ALWAYS.
        /// </para>
        /// </param>
        /// <param name="ref">
        /// <para>
        /// Specifies the reference value that incoming alpha values are compared to. This value is clamped to the range [0,1], where 0 represents the lowest possible alpha value and 1 the highest possible value. The initial reference value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glAlphaFunc")]
        public static extern void AlphaFunc(OpenTK.Graphics.OpenGL.AlphaFunction func, Single @ref);

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Determine if textures are loaded in texture memory
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of textures to be queried.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies an array containing the names of the textures to be queried.
        /// </para>
        /// </param>
        /// <param name="residences">
        /// <para>
        /// Specifies an array in which the texture residence status is returned. The residence status of a texture named by an element of textures is returned in the corresponding element of residences.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glAreTexturesResident")]
        public static extern bool AreTexturesResident(Int32 n, Int32[] textures, [OutAttribute] bool[] residences);

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Determine if textures are loaded in texture memory
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of textures to be queried.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies an array containing the names of the textures to be queried.
        /// </para>
        /// </param>
        /// <param name="residences">
        /// <para>
        /// Specifies an array in which the texture residence status is returned. The residence status of a texture named by an element of textures is returned in the corresponding element of residences.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glAreTexturesResident")]
        public static extern bool AreTexturesResident(Int32 n, ref Int32 textures, [OutAttribute] out bool residences);

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Determine if textures are loaded in texture memory
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of textures to be queried.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies an array containing the names of the textures to be queried.
        /// </para>
        /// </param>
        /// <param name="residences">
        /// <para>
        /// Specifies an array in which the texture residence status is returned. The residence status of a texture named by an element of textures is returned in the corresponding element of residences.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glAreTexturesResident")]
        public static extern unsafe bool AreTexturesResident(Int32 n, Int32* textures, [OutAttribute] bool* residences);

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Determine if textures are loaded in texture memory
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of textures to be queried.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies an array containing the names of the textures to be queried.
        /// </para>
        /// </param>
        /// <param name="residences">
        /// <para>
        /// Specifies an array in which the texture residence status is returned. The residence status of a texture named by an element of textures is returned in the corresponding element of residences.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glAreTexturesResident")]
        public static extern bool AreTexturesResident(Int32 n, UInt32[] textures, [OutAttribute] bool[] residences);

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Determine if textures are loaded in texture memory
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of textures to be queried.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies an array containing the names of the textures to be queried.
        /// </para>
        /// </param>
        /// <param name="residences">
        /// <para>
        /// Specifies an array in which the texture residence status is returned. The residence status of a texture named by an element of textures is returned in the corresponding element of residences.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glAreTexturesResident")]
        public static extern bool AreTexturesResident(Int32 n, ref UInt32 textures, [OutAttribute] out bool residences);

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Determine if textures are loaded in texture memory
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of textures to be queried.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies an array containing the names of the textures to be queried.
        /// </para>
        /// </param>
        /// <param name="residences">
        /// <para>
        /// Specifies an array in which the texture residence status is returned. The residence status of a texture named by an element of textures is returned in the corresponding element of residences.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glAreTexturesResident")]
        public static extern unsafe bool AreTexturesResident(Int32 n, UInt32* textures, [OutAttribute] bool* residences);

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Render a vertex using the specified vertex array element
        /// </summary>
        /// <param name="i">
        /// <para>
        /// Specifies an index into the enabled vertex data arrays.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glArrayElement")]
        public static extern void ArrayElement(Int32 i);

        /// <summary>[requires: v2.0]
        /// Attaches a shader object to a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to which a shader object will be attached.
        /// </para>
        /// </param>
        /// <param name="shader">
        /// <para>
        /// Specifies the shader object that is to be attached.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glAttachShader")]
        public static extern void AttachShader(Int32 program, Int32 shader);

        /// <summary>[requires: v2.0]
        /// Attaches a shader object to a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to which a shader object will be attached.
        /// </para>
        /// </param>
        /// <param name="shader">
        /// <para>
        /// Specifies the shader object that is to be attached.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glAttachShader")]
        public static extern void AttachShader(UInt32 program, UInt32 shader);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Delimit the vertices of a primitive or a group of like primitives
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies the primitive or primitives that will be created from vertices presented between glBegin and the subsequent glEnd. Ten symbolic constants are accepted: GL_POINTS, GL_LINES, GL_LINE_STRIP, GL_LINE_LOOP, GL_TRIANGLES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_QUADS, GL_QUAD_STRIP, and GL_POLYGON.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glBegin")]
        public static extern void Begin(OpenTK.Graphics.OpenGL.BeginMode mode);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Delimit the vertices of a primitive or a group of like primitives
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies the primitive or primitives that will be created from vertices presented between glBegin and the subsequent glEnd. Ten symbolic constants are accepted: GL_POINTS, GL_LINES, GL_LINE_STRIP, GL_LINE_LOOP, GL_TRIANGLES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_QUADS, GL_QUAD_STRIP, and GL_POLYGON.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glBegin")]
        public static extern void Begin(OpenTK.Graphics.OpenGL.PrimitiveType mode);

        /// <summary>[requires: v3.0]
        /// Start conditional rendering
        /// </summary>
        /// <param name="id">
        /// <para>
        /// Specifies the name of an occlusion query object whose results are used to determine if the rendering commands are discarded.
        /// </para>
        /// </param>
        /// <param name="mode">
        /// <para>
        /// Specifies how glBeginConditionalRender interprets the results of the occlusion query.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glBeginConditionalRender")]
        public static extern void BeginConditionalRender(Int32 id, OpenTK.Graphics.OpenGL.ConditionalRenderType mode);

        /// <summary>[requires: v3.0]
        /// Start conditional rendering
        /// </summary>
        /// <param name="id">
        /// <para>
        /// Specifies the name of an occlusion query object whose results are used to determine if the rendering commands are discarded.
        /// </para>
        /// </param>
        /// <param name="mode">
        /// <para>
        /// Specifies how glBeginConditionalRender interprets the results of the occlusion query.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glBeginConditionalRender")]
        public static extern void BeginConditionalRender(UInt32 id, OpenTK.Graphics.OpenGL.ConditionalRenderType mode);

        /// <summary>[requires: v1.5]
        /// Delimit the boundaries of a query object
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target type of query object established between glBeginQuery and the subsequent glEndQuery. The symbolic constant must be one of GL_SAMPLES_PASSED, GL_ANY_SAMPLES_PASSED, GL_ANY_SAMPLES_PASSED_CONSERVATIVE, GL_PRIMITIVES_GENERATED, GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN, or GL_TIME_ELAPSED.
        /// </para>
        /// </param>
        /// <param name="id">
        /// <para>
        /// Specifies the name of a query object.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glBeginQuery")]
        public static extern void BeginQuery(OpenTK.Graphics.OpenGL.QueryTarget target, Int32 id);

        /// <summary>[requires: v1.5]
        /// Delimit the boundaries of a query object
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target type of query object established between glBeginQuery and the subsequent glEndQuery. The symbolic constant must be one of GL_SAMPLES_PASSED, GL_ANY_SAMPLES_PASSED, GL_ANY_SAMPLES_PASSED_CONSERVATIVE, GL_PRIMITIVES_GENERATED, GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN, or GL_TIME_ELAPSED.
        /// </para>
        /// </param>
        /// <param name="id">
        /// <para>
        /// Specifies the name of a query object.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glBeginQuery")]
        public static extern void BeginQuery(OpenTK.Graphics.OpenGL.QueryTarget target, UInt32 id);

        /// <summary>[requires: v4.0 and ARB_transform_feedback3|VERSION_4_0]
        /// Delimit the boundaries of a query object on an indexed target
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target type of query object established between glBeginQueryIndexed and the subsequent glEndQueryIndexed. The symbolic constant must be one of GL_SAMPLES_PASSED, GL_ANY_SAMPLES_PASSED, GL_PRIMITIVES_GENERATED, GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN, or GL_TIME_ELAPSED.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the query target upon which to begin the query.
        /// </para>
        /// </param>
        /// <param name="id">
        /// <para>
        /// Specifies the name of a query object.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_transform_feedback3|VERSION_4_0", Version = "4.0", EntryPoint = "glBeginQueryIndexed")]
        public static extern void BeginQueryIndexed(OpenTK.Graphics.OpenGL.QueryTarget target, Int32 index, Int32 id);

        /// <summary>[requires: v4.0 and ARB_transform_feedback3|VERSION_4_0]
        /// Delimit the boundaries of a query object on an indexed target
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target type of query object established between glBeginQueryIndexed and the subsequent glEndQueryIndexed. The symbolic constant must be one of GL_SAMPLES_PASSED, GL_ANY_SAMPLES_PASSED, GL_PRIMITIVES_GENERATED, GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN, or GL_TIME_ELAPSED.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the query target upon which to begin the query.
        /// </para>
        /// </param>
        /// <param name="id">
        /// <para>
        /// Specifies the name of a query object.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_transform_feedback3|VERSION_4_0", Version = "4.0", EntryPoint = "glBeginQueryIndexed")]
        public static extern void BeginQueryIndexed(OpenTK.Graphics.OpenGL.QueryTarget target, UInt32 index, UInt32 id);

        /// <summary>[requires: v3.0]
        /// Start transform feedback operation
        /// </summary>
        /// <param name="primitiveMode">
        /// <para>
        /// Specify the output type of the primitives that will be recorded into the buffer objects that are bound for transform feedback.
        /// </para>
        /// </param>
        [Obsolete("Use TransformFeedbackPrimitiveType overload instead")]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glBeginTransformFeedback")]
        public static extern void BeginTransformFeedback(OpenTK.Graphics.OpenGL.BeginFeedbackMode primitiveMode);

        /// <summary>[requires: v3.0]
        /// Start transform feedback operation
        /// </summary>
        /// <param name="primitiveMode">
        /// <para>
        /// Specify the output type of the primitives that will be recorded into the buffer objects that are bound for transform feedback.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glBeginTransformFeedback")]
        public static extern void BeginTransformFeedback(OpenTK.Graphics.OpenGL.TransformFeedbackPrimitiveType primitiveMode);

        /// <summary>[requires: v2.0]
        /// Associates a generic vertex attribute index with a named attribute variable
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program object in which the association is to be made.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be bound.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// Specifies a null terminated string containing the name of the vertex shader attribute variable to which index is to be bound.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glBindAttribLocation")]
        public static extern void BindAttribLocation(Int32 program, Int32 index, String name);

        /// <summary>[requires: v2.0]
        /// Associates a generic vertex attribute index with a named attribute variable
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program object in which the association is to be made.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be bound.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// Specifies a null terminated string containing the name of the vertex shader attribute variable to which index is to be bound.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glBindAttribLocation")]
        public static extern void BindAttribLocation(UInt32 program, UInt32 index, String name);

        /// <summary>[requires: v1.5]
        /// Bind a named buffer object
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target to which the buffer object is bound. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
        /// </para>
        /// </param>
        /// <param name="buffer">
        /// <para>
        /// Specifies the name of a buffer object.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glBindBuffer")]
        public static extern void BindBuffer(OpenTK.Graphics.OpenGL.BufferTarget target, Int32 buffer);

        /// <summary>[requires: v1.5]
        /// Bind a named buffer object
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target to which the buffer object is bound. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
        /// </para>
        /// </param>
        /// <param name="buffer">
        /// <para>
        /// Specifies the name of a buffer object.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glBindBuffer")]
        public static extern void BindBuffer(OpenTK.Graphics.OpenGL.BufferTarget target, UInt32 buffer);

        /// <summary>[requires: v3.0]
        /// Bind a buffer object to an indexed buffer target
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the bind operation. target must be one of GL_ATOMIC_COUNTER_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, GL_UNIFORM_BUFFER or GL_SHADER_STORAGE_BUFFER.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specify the index of the binding point within the array specified by target.
        /// </para>
        /// </param>
        /// <param name="buffer">
        /// <para>
        /// The name of a buffer object to bind to the specified binding point.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glBindBufferBase")]
        public static extern void BindBufferBase(OpenTK.Graphics.OpenGL.BufferRangeTarget target, Int32 index, Int32 buffer);

        /// <summary>[requires: v3.0]
        /// Bind a buffer object to an indexed buffer target
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the bind operation. target must be one of GL_ATOMIC_COUNTER_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, GL_UNIFORM_BUFFER or GL_SHADER_STORAGE_BUFFER.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specify the index of the binding point within the array specified by target.
        /// </para>
        /// </param>
        /// <param name="buffer">
        /// <para>
        /// The name of a buffer object to bind to the specified binding point.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glBindBufferBase")]
        public static extern void BindBufferBase(OpenTK.Graphics.OpenGL.BufferRangeTarget target, UInt32 index, UInt32 buffer);

        /// <summary>[requires: v3.0]
        /// Bind a buffer object to an indexed buffer target
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the bind operation. target must be one of GL_ATOMIC_COUNTER_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, GL_UNIFORM_BUFFER or GL_SHADER_STORAGE_BUFFER.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specify the index of the binding point within the array specified by target.
        /// </para>
        /// </param>
        /// <param name="buffer">
        /// <para>
        /// The name of a buffer object to bind to the specified binding point.
        /// </para>
        /// </param>
        [Obsolete("Use BufferRangeTarget overload instead")]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glBindBufferBase")]
        public static extern void BindBufferBase(OpenTK.Graphics.OpenGL.BufferTarget target, Int32 index, Int32 buffer);

        /// <summary>[requires: v3.0]
        /// Bind a buffer object to an indexed buffer target
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the bind operation. target must be one of GL_ATOMIC_COUNTER_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, GL_UNIFORM_BUFFER or GL_SHADER_STORAGE_BUFFER.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specify the index of the binding point within the array specified by target.
        /// </para>
        /// </param>
        /// <param name="buffer">
        /// <para>
        /// The name of a buffer object to bind to the specified binding point.
        /// </para>
        /// </param>
        [Obsolete("Use BufferRangeTarget overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glBindBufferBase")]
        public static extern void BindBufferBase(OpenTK.Graphics.OpenGL.BufferTarget target, UInt32 index, UInt32 buffer);

        /// <summary>[requires: v3.0]
        /// Bind a range within a buffer object to an indexed buffer target
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the bind operation. target must be one of GL_ATOMIC_COUNTER_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, GL_UNIFORM_BUFFER, or GL_SHADER_STORAGE_BUFFER.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specify the index of the binding point within the array specified by target.
        /// </para>
        /// </param>
        /// <param name="buffer">
        /// <para>
        /// The name of a buffer object to bind to the specified binding point.
        /// </para>
        /// </param>
        /// <param name="offset">
        /// <para>
        /// The starting offset in basic machine units into the buffer object buffer.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// The amount of data in machine units that can be read from the buffet object while used as an indexed target.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glBindBufferRange")]
        public static extern void BindBufferRange(OpenTK.Graphics.OpenGL.BufferRangeTarget target, Int32 index, Int32 buffer, IntPtr offset, IntPtr size);

        /// <summary>[requires: v3.0]
        /// Bind a range within a buffer object to an indexed buffer target
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the bind operation. target must be one of GL_ATOMIC_COUNTER_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, GL_UNIFORM_BUFFER, or GL_SHADER_STORAGE_BUFFER.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specify the index of the binding point within the array specified by target.
        /// </para>
        /// </param>
        /// <param name="buffer">
        /// <para>
        /// The name of a buffer object to bind to the specified binding point.
        /// </para>
        /// </param>
        /// <param name="offset">
        /// <para>
        /// The starting offset in basic machine units into the buffer object buffer.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// The amount of data in machine units that can be read from the buffet object while used as an indexed target.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glBindBufferRange")]
        public static extern void BindBufferRange(OpenTK.Graphics.OpenGL.BufferRangeTarget target, UInt32 index, UInt32 buffer, IntPtr offset, IntPtr size);

        /// <summary>[requires: v3.0]
        /// Bind a range within a buffer object to an indexed buffer target
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the bind operation. target must be one of GL_ATOMIC_COUNTER_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, GL_UNIFORM_BUFFER, or GL_SHADER_STORAGE_BUFFER.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specify the index of the binding point within the array specified by target.
        /// </para>
        /// </param>
        /// <param name="buffer">
        /// <para>
        /// The name of a buffer object to bind to the specified binding point.
        /// </para>
        /// </param>
        /// <param name="offset">
        /// <para>
        /// The starting offset in basic machine units into the buffer object buffer.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// The amount of data in machine units that can be read from the buffet object while used as an indexed target.
        /// </para>
        /// </param>
        [Obsolete("Use BufferRangeTarget overload instead")]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glBindBufferRange")]
        public static extern void BindBufferRange(OpenTK.Graphics.OpenGL.BufferTarget target, Int32 index, Int32 buffer, IntPtr offset, IntPtr size);

        /// <summary>[requires: v3.0]
        /// Bind a range within a buffer object to an indexed buffer target
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the bind operation. target must be one of GL_ATOMIC_COUNTER_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, GL_UNIFORM_BUFFER, or GL_SHADER_STORAGE_BUFFER.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specify the index of the binding point within the array specified by target.
        /// </para>
        /// </param>
        /// <param name="buffer">
        /// <para>
        /// The name of a buffer object to bind to the specified binding point.
        /// </para>
        /// </param>
        /// <param name="offset">
        /// <para>
        /// The starting offset in basic machine units into the buffer object buffer.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// The amount of data in machine units that can be read from the buffet object while used as an indexed target.
        /// </para>
        /// </param>
        [Obsolete("Use BufferRangeTarget overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glBindBufferRange")]
        public static extern void BindBufferRange(OpenTK.Graphics.OpenGL.BufferTarget target, UInt32 index, UInt32 buffer, IntPtr offset, IntPtr size);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind one or more buffer objects to a sequence of indexed buffer targets
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the bind operation. target must be one of GL_ATOMIC_COUNTER_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, GL_UNIFORM_BUFFER or GL_SHADER_STORAGE_BUFFER.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specify the index of the first binding point within the array specified by target.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specify the number of contiguous binding points to which to bind buffers.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// A pointer to an array of names of buffer objects to bind to the targets on the specified binding point, or NULL.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindBuffersBase")]
        public static extern void BindBuffersBase(OpenTK.Graphics.OpenGL.BufferRangeTarget target, Int32 first, Int32 count, Int32[] buffers);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind one or more buffer objects to a sequence of indexed buffer targets
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the bind operation. target must be one of GL_ATOMIC_COUNTER_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, GL_UNIFORM_BUFFER or GL_SHADER_STORAGE_BUFFER.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specify the index of the first binding point within the array specified by target.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specify the number of contiguous binding points to which to bind buffers.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// A pointer to an array of names of buffer objects to bind to the targets on the specified binding point, or NULL.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindBuffersBase")]
        public static extern void BindBuffersBase(OpenTK.Graphics.OpenGL.BufferRangeTarget target, Int32 first, Int32 count, ref Int32 buffers);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind one or more buffer objects to a sequence of indexed buffer targets
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the bind operation. target must be one of GL_ATOMIC_COUNTER_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, GL_UNIFORM_BUFFER or GL_SHADER_STORAGE_BUFFER.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specify the index of the first binding point within the array specified by target.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specify the number of contiguous binding points to which to bind buffers.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// A pointer to an array of names of buffer objects to bind to the targets on the specified binding point, or NULL.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindBuffersBase")]
        public static extern unsafe void BindBuffersBase(OpenTK.Graphics.OpenGL.BufferRangeTarget target, Int32 first, Int32 count, Int32* buffers);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind one or more buffer objects to a sequence of indexed buffer targets
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the bind operation. target must be one of GL_ATOMIC_COUNTER_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, GL_UNIFORM_BUFFER or GL_SHADER_STORAGE_BUFFER.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specify the index of the first binding point within the array specified by target.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specify the number of contiguous binding points to which to bind buffers.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// A pointer to an array of names of buffer objects to bind to the targets on the specified binding point, or NULL.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindBuffersBase")]
        public static extern void BindBuffersBase(OpenTK.Graphics.OpenGL.BufferRangeTarget target, UInt32 first, Int32 count, UInt32[] buffers);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind one or more buffer objects to a sequence of indexed buffer targets
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the bind operation. target must be one of GL_ATOMIC_COUNTER_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, GL_UNIFORM_BUFFER or GL_SHADER_STORAGE_BUFFER.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specify the index of the first binding point within the array specified by target.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specify the number of contiguous binding points to which to bind buffers.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// A pointer to an array of names of buffer objects to bind to the targets on the specified binding point, or NULL.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindBuffersBase")]
        public static extern void BindBuffersBase(OpenTK.Graphics.OpenGL.BufferRangeTarget target, UInt32 first, Int32 count, ref UInt32 buffers);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind one or more buffer objects to a sequence of indexed buffer targets
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the bind operation. target must be one of GL_ATOMIC_COUNTER_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, GL_UNIFORM_BUFFER or GL_SHADER_STORAGE_BUFFER.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specify the index of the first binding point within the array specified by target.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specify the number of contiguous binding points to which to bind buffers.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// A pointer to an array of names of buffer objects to bind to the targets on the specified binding point, or NULL.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindBuffersBase")]
        public static extern unsafe void BindBuffersBase(OpenTK.Graphics.OpenGL.BufferRangeTarget target, UInt32 first, Int32 count, UInt32* buffers);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind ranges of one or more buffer objects to a sequence of indexed buffer targets
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the bind operation. target must be one of GL_ATOMIC_COUNTER_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, GL_UNIFORM_BUFFER or GL_SHADER_STORAGE_BUFFER.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specify the index of the first binding point within the array specified by target.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specify the number of contiguous binding points to which to bind buffers.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// A pointer to an array of names of buffer objects to bind to the targets on the specified binding point, or NULL.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindBuffersRange")]
        public static extern void BindBuffersRange(OpenTK.Graphics.OpenGL.BufferRangeTarget target, Int32 first, Int32 count, Int32[] buffers, IntPtr[] offsets, IntPtr[] sizes);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind ranges of one or more buffer objects to a sequence of indexed buffer targets
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the bind operation. target must be one of GL_ATOMIC_COUNTER_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, GL_UNIFORM_BUFFER or GL_SHADER_STORAGE_BUFFER.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specify the index of the first binding point within the array specified by target.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specify the number of contiguous binding points to which to bind buffers.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// A pointer to an array of names of buffer objects to bind to the targets on the specified binding point, or NULL.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindBuffersRange")]
        public static extern void BindBuffersRange(OpenTK.Graphics.OpenGL.BufferRangeTarget target, Int32 first, Int32 count, ref Int32 buffers, ref IntPtr offsets, ref IntPtr sizes);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind ranges of one or more buffer objects to a sequence of indexed buffer targets
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the bind operation. target must be one of GL_ATOMIC_COUNTER_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, GL_UNIFORM_BUFFER or GL_SHADER_STORAGE_BUFFER.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specify the index of the first binding point within the array specified by target.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specify the number of contiguous binding points to which to bind buffers.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// A pointer to an array of names of buffer objects to bind to the targets on the specified binding point, or NULL.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindBuffersRange")]
        public static extern unsafe void BindBuffersRange(OpenTK.Graphics.OpenGL.BufferRangeTarget target, Int32 first, Int32 count, Int32* buffers, IntPtr* offsets, IntPtr* sizes);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind ranges of one or more buffer objects to a sequence of indexed buffer targets
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the bind operation. target must be one of GL_ATOMIC_COUNTER_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, GL_UNIFORM_BUFFER or GL_SHADER_STORAGE_BUFFER.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specify the index of the first binding point within the array specified by target.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specify the number of contiguous binding points to which to bind buffers.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// A pointer to an array of names of buffer objects to bind to the targets on the specified binding point, or NULL.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindBuffersRange")]
        public static extern void BindBuffersRange(OpenTK.Graphics.OpenGL.BufferRangeTarget target, UInt32 first, Int32 count, UInt32[] buffers, IntPtr[] offsets, IntPtr[] sizes);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind ranges of one or more buffer objects to a sequence of indexed buffer targets
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the bind operation. target must be one of GL_ATOMIC_COUNTER_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, GL_UNIFORM_BUFFER or GL_SHADER_STORAGE_BUFFER.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specify the index of the first binding point within the array specified by target.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specify the number of contiguous binding points to which to bind buffers.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// A pointer to an array of names of buffer objects to bind to the targets on the specified binding point, or NULL.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindBuffersRange")]
        public static extern void BindBuffersRange(OpenTK.Graphics.OpenGL.BufferRangeTarget target, UInt32 first, Int32 count, ref UInt32 buffers, ref IntPtr offsets, ref IntPtr sizes);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind ranges of one or more buffer objects to a sequence of indexed buffer targets
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the bind operation. target must be one of GL_ATOMIC_COUNTER_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, GL_UNIFORM_BUFFER or GL_SHADER_STORAGE_BUFFER.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specify the index of the first binding point within the array specified by target.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specify the number of contiguous binding points to which to bind buffers.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// A pointer to an array of names of buffer objects to bind to the targets on the specified binding point, or NULL.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindBuffersRange")]
        public static extern unsafe void BindBuffersRange(OpenTK.Graphics.OpenGL.BufferRangeTarget target, UInt32 first, Int32 count, UInt32* buffers, IntPtr* offsets, IntPtr* sizes);

        /// <summary>[requires: v3.0]
        /// Bind a user-defined varying out variable to a fragment shader color number
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of the program containing varying out variable whose binding to modify
        /// </para>
        /// </param>
        /// <param name="colorNumber">
        /// <para>
        /// The color number to bind the user-defined varying out variable to
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The name of the user-defined varying out variable whose binding to modify
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glBindFragDataLocation")]
        public static extern void BindFragDataLocation(Int32 program, Int32 color, String name);

        /// <summary>[requires: v3.0]
        /// Bind a user-defined varying out variable to a fragment shader color number
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of the program containing varying out variable whose binding to modify
        /// </para>
        /// </param>
        /// <param name="colorNumber">
        /// <para>
        /// The color number to bind the user-defined varying out variable to
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The name of the user-defined varying out variable whose binding to modify
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glBindFragDataLocation")]
        public static extern void BindFragDataLocation(UInt32 program, UInt32 color, String name);

        /// <summary>[requires: v3.3 and ARB_blend_func_extended|VERSION_3_3]
        /// Bind a user-defined varying out variable to a fragment shader color number and index
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of the program containing varying out variable whose binding to modify
        /// </para>
        /// </param>
        /// <param name="colorNumber">
        /// <para>
        /// The color number to bind the user-defined varying out variable to
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// The index of the color input to bind the user-defined varying out variable to
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The name of the user-defined varying out variable whose binding to modify
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_blend_func_extended|VERSION_3_3", Version = "3.3", EntryPoint = "glBindFragDataLocationIndexed")]
        public static extern void BindFragDataLocationIndexed(Int32 program, Int32 colorNumber, Int32 index, String name);

        /// <summary>[requires: v3.3 and ARB_blend_func_extended|VERSION_3_3]
        /// Bind a user-defined varying out variable to a fragment shader color number and index
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of the program containing varying out variable whose binding to modify
        /// </para>
        /// </param>
        /// <param name="colorNumber">
        /// <para>
        /// The color number to bind the user-defined varying out variable to
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// The index of the color input to bind the user-defined varying out variable to
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The name of the user-defined varying out variable whose binding to modify
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_blend_func_extended|VERSION_3_3", Version = "3.3", EntryPoint = "glBindFragDataLocationIndexed")]
        public static extern void BindFragDataLocationIndexed(UInt32 program, UInt32 colorNumber, UInt32 index, String name);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Bind a framebuffer to a framebuffer target
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the framebuffer target of the binding operation.
        /// </para>
        /// </param>
        /// <param name="framebuffer">
        /// <para>
        /// Specifies the name of the framebuffer object to bind.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glBindFramebuffer")]
        public static extern void BindFramebuffer(OpenTK.Graphics.OpenGL.FramebufferTarget target, Int32 framebuffer);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Bind a framebuffer to a framebuffer target
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the framebuffer target of the binding operation.
        /// </para>
        /// </param>
        /// <param name="framebuffer">
        /// <para>
        /// Specifies the name of the framebuffer object to bind.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glBindFramebuffer")]
        public static extern void BindFramebuffer(OpenTK.Graphics.OpenGL.FramebufferTarget target, UInt32 framebuffer);

        /// <summary>[requires: v4.2 and ARB_shader_image_load_store|VERSION_4_2]
        /// Bind a level of a texture to an image unit
        /// </summary>
        /// <param name="unit">
        /// <para>
        /// Specifies the index of the image unit to which to bind the texture
        /// </para>
        /// </param>
        /// <param name="texture">
        /// <para>
        /// Specifies the name of the texture to bind to the image unit.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level of the texture that is to be bound.
        /// </para>
        /// </param>
        /// <param name="layered">
        /// <para>
        /// Specifies whether a layered texture binding is to be established.
        /// </para>
        /// </param>
        /// <param name="layer">
        /// <para>
        /// If layered is GL_FALSE, specifies the layer of texture to be bound to the image unit. Ignored otherwise.
        /// </para>
        /// </param>
        /// <param name="access">
        /// <para>
        /// Specifies a token indicating the type of access that will be performed on the image.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format that the elements of the image will be treated as for the purposes of formatted stores.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_shader_image_load_store|VERSION_4_2", Version = "4.2", EntryPoint = "glBindImageTexture")]
        public static extern void BindImageTexture(Int32 unit, Int32 texture, Int32 level, bool layered, Int32 layer, OpenTK.Graphics.OpenGL.TextureAccess access, OpenTK.Graphics.OpenGL.SizedInternalFormat format);

        /// <summary>[requires: v4.2 and ARB_shader_image_load_store|VERSION_4_2]
        /// Bind a level of a texture to an image unit
        /// </summary>
        /// <param name="unit">
        /// <para>
        /// Specifies the index of the image unit to which to bind the texture
        /// </para>
        /// </param>
        /// <param name="texture">
        /// <para>
        /// Specifies the name of the texture to bind to the image unit.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level of the texture that is to be bound.
        /// </para>
        /// </param>
        /// <param name="layered">
        /// <para>
        /// Specifies whether a layered texture binding is to be established.
        /// </para>
        /// </param>
        /// <param name="layer">
        /// <para>
        /// If layered is GL_FALSE, specifies the layer of texture to be bound to the image unit. Ignored otherwise.
        /// </para>
        /// </param>
        /// <param name="access">
        /// <para>
        /// Specifies a token indicating the type of access that will be performed on the image.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format that the elements of the image will be treated as for the purposes of formatted stores.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_shader_image_load_store|VERSION_4_2", Version = "4.2", EntryPoint = "glBindImageTexture")]
        public static extern void BindImageTexture(UInt32 unit, UInt32 texture, Int32 level, bool layered, Int32 layer, OpenTK.Graphics.OpenGL.TextureAccess access, OpenTK.Graphics.OpenGL.SizedInternalFormat format);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind one or more named texture images to a sequence of consecutive image units
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the first image unit to which a texture is to be bound.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of textures to bind.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies the address of an array of names of existing texture objects.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindImageTextures")]
        public static extern void BindImageTextures(Int32 first, Int32 count, Int32[] textures);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind one or more named texture images to a sequence of consecutive image units
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the first image unit to which a texture is to be bound.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of textures to bind.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies the address of an array of names of existing texture objects.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindImageTextures")]
        public static extern void BindImageTextures(Int32 first, Int32 count, ref Int32 textures);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind one or more named texture images to a sequence of consecutive image units
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the first image unit to which a texture is to be bound.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of textures to bind.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies the address of an array of names of existing texture objects.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindImageTextures")]
        public static extern unsafe void BindImageTextures(Int32 first, Int32 count, Int32* textures);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind one or more named texture images to a sequence of consecutive image units
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the first image unit to which a texture is to be bound.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of textures to bind.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies the address of an array of names of existing texture objects.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindImageTextures")]
        public static extern void BindImageTextures(UInt32 first, Int32 count, UInt32[] textures);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind one or more named texture images to a sequence of consecutive image units
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the first image unit to which a texture is to be bound.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of textures to bind.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies the address of an array of names of existing texture objects.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindImageTextures")]
        public static extern void BindImageTextures(UInt32 first, Int32 count, ref UInt32 textures);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind one or more named texture images to a sequence of consecutive image units
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the first image unit to which a texture is to be bound.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of textures to bind.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies the address of an array of names of existing texture objects.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindImageTextures")]
        public static extern unsafe void BindImageTextures(UInt32 first, Int32 count, UInt32* textures);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Bind a program pipeline to the current context
        /// </summary>
        /// <param name="pipeline">
        /// <para>
        /// Specifies the name of the pipeline object to bind to the context.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glBindProgramPipeline")]
        public static extern void BindProgramPipeline(Int32 pipeline);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Bind a program pipeline to the current context
        /// </summary>
        /// <param name="pipeline">
        /// <para>
        /// Specifies the name of the pipeline object to bind to the context.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glBindProgramPipeline")]
        public static extern void BindProgramPipeline(UInt32 pipeline);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Bind a renderbuffer to a renderbuffer target
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the renderbuffer target of the binding operation. target must be GL_RENDERBUFFER.
        /// </para>
        /// </param>
        /// <param name="renderbuffer">
        /// <para>
        /// Specifies the name of the renderbuffer object to bind.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glBindRenderbuffer")]
        public static extern void BindRenderbuffer(OpenTK.Graphics.OpenGL.RenderbufferTarget target, Int32 renderbuffer);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Bind a renderbuffer to a renderbuffer target
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the renderbuffer target of the binding operation. target must be GL_RENDERBUFFER.
        /// </para>
        /// </param>
        /// <param name="renderbuffer">
        /// <para>
        /// Specifies the name of the renderbuffer object to bind.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glBindRenderbuffer")]
        public static extern void BindRenderbuffer(OpenTK.Graphics.OpenGL.RenderbufferTarget target, UInt32 renderbuffer);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Bind a named sampler to a texturing target
        /// </summary>
        /// <param name="unit">
        /// <para>
        /// Specifies the index of the texture unit to which the sampler is bound.
        /// </para>
        /// </param>
        /// <param name="sampler">
        /// <para>
        /// Specifies the name of a sampler.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glBindSampler")]
        public static extern void BindSampler(Int32 unit, Int32 sampler);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Bind a named sampler to a texturing target
        /// </summary>
        /// <param name="unit">
        /// <para>
        /// Specifies the index of the texture unit to which the sampler is bound.
        /// </para>
        /// </param>
        /// <param name="sampler">
        /// <para>
        /// Specifies the name of a sampler.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glBindSampler")]
        public static extern void BindSampler(UInt32 unit, UInt32 sampler);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind one or more named sampler objects to a sequence of consecutive sampler units
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the first sampler unit to which a sampler object is to be bound.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of samplers to bind.
        /// </para>
        /// </param>
        /// <param name="samplers">
        /// <para>
        /// Specifies the address of an array of names of existing sampler objects.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindSamplers")]
        public static extern void BindSamplers(Int32 first, Int32 count, Int32[] samplers);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind one or more named sampler objects to a sequence of consecutive sampler units
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the first sampler unit to which a sampler object is to be bound.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of samplers to bind.
        /// </para>
        /// </param>
        /// <param name="samplers">
        /// <para>
        /// Specifies the address of an array of names of existing sampler objects.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindSamplers")]
        public static extern void BindSamplers(Int32 first, Int32 count, ref Int32 samplers);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind one or more named sampler objects to a sequence of consecutive sampler units
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the first sampler unit to which a sampler object is to be bound.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of samplers to bind.
        /// </para>
        /// </param>
        /// <param name="samplers">
        /// <para>
        /// Specifies the address of an array of names of existing sampler objects.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindSamplers")]
        public static extern unsafe void BindSamplers(Int32 first, Int32 count, Int32* samplers);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind one or more named sampler objects to a sequence of consecutive sampler units
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the first sampler unit to which a sampler object is to be bound.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of samplers to bind.
        /// </para>
        /// </param>
        /// <param name="samplers">
        /// <para>
        /// Specifies the address of an array of names of existing sampler objects.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindSamplers")]
        public static extern void BindSamplers(UInt32 first, Int32 count, UInt32[] samplers);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind one or more named sampler objects to a sequence of consecutive sampler units
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the first sampler unit to which a sampler object is to be bound.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of samplers to bind.
        /// </para>
        /// </param>
        /// <param name="samplers">
        /// <para>
        /// Specifies the address of an array of names of existing sampler objects.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindSamplers")]
        public static extern void BindSamplers(UInt32 first, Int32 count, ref UInt32 samplers);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind one or more named sampler objects to a sequence of consecutive sampler units
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the first sampler unit to which a sampler object is to be bound.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of samplers to bind.
        /// </para>
        /// </param>
        /// <param name="samplers">
        /// <para>
        /// Specifies the address of an array of names of existing sampler objects.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindSamplers")]
        public static extern unsafe void BindSamplers(UInt32 first, Int32 count, UInt32* samplers);

        /// <summary>[requires: v1.1]
        /// Bind a named texture to a texturing target
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target to which the texture is bound. Must be one of GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_RECTANGLE, GL_TEXTURE_CUBE_MAP, GL_TEXTURE_CUBE_MAP_ARRAY, GL_TEXTURE_BUFFER, GL_TEXTURE_2D_MULTISAMPLE or GL_TEXTURE_2D_MULTISAMPLE_ARRAY.
        /// </para>
        /// </param>
        /// <param name="texture">
        /// <para>
        /// Specifies the name of a texture.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glBindTexture")]
        public static extern void BindTexture(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 texture);

        /// <summary>[requires: v1.1]
        /// Bind a named texture to a texturing target
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target to which the texture is bound. Must be one of GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_RECTANGLE, GL_TEXTURE_CUBE_MAP, GL_TEXTURE_CUBE_MAP_ARRAY, GL_TEXTURE_BUFFER, GL_TEXTURE_2D_MULTISAMPLE or GL_TEXTURE_2D_MULTISAMPLE_ARRAY.
        /// </para>
        /// </param>
        /// <param name="texture">
        /// <para>
        /// Specifies the name of a texture.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glBindTexture")]
        public static extern void BindTexture(OpenTK.Graphics.OpenGL.TextureTarget target, UInt32 texture);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind one or more named textures to a sequence of consecutive texture units
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the first texture unit to which a texture is to be bound.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of textures to bind.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies the address of an array of names of existing texture objects.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindTextures")]
        public static extern void BindTextures(Int32 first, Int32 count, Int32[] textures);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind one or more named textures to a sequence of consecutive texture units
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the first texture unit to which a texture is to be bound.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of textures to bind.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies the address of an array of names of existing texture objects.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindTextures")]
        public static extern void BindTextures(Int32 first, Int32 count, ref Int32 textures);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind one or more named textures to a sequence of consecutive texture units
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the first texture unit to which a texture is to be bound.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of textures to bind.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies the address of an array of names of existing texture objects.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindTextures")]
        public static extern unsafe void BindTextures(Int32 first, Int32 count, Int32* textures);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind one or more named textures to a sequence of consecutive texture units
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the first texture unit to which a texture is to be bound.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of textures to bind.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies the address of an array of names of existing texture objects.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindTextures")]
        public static extern void BindTextures(UInt32 first, Int32 count, UInt32[] textures);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind one or more named textures to a sequence of consecutive texture units
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the first texture unit to which a texture is to be bound.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of textures to bind.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies the address of an array of names of existing texture objects.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindTextures")]
        public static extern void BindTextures(UInt32 first, Int32 count, ref UInt32 textures);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind one or more named textures to a sequence of consecutive texture units
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the first texture unit to which a texture is to be bound.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of textures to bind.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies the address of an array of names of existing texture objects.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindTextures")]
        public static extern unsafe void BindTextures(UInt32 first, Int32 count, UInt32* textures);

        /// <summary>[requires: v4.0 and ARB_transform_feedback2|VERSION_4_0]
        /// Bind a transform feedback object
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target to which to bind the transform feedback object id. target must be GL_TRANSFORM_FEEDBACK.
        /// </para>
        /// </param>
        /// <param name="id">
        /// <para>
        /// Specifies the name of a transform feedback object reserved by glGenTransformFeedbacks.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_transform_feedback2|VERSION_4_0", Version = "4.0", EntryPoint = "glBindTransformFeedback")]
        public static extern void BindTransformFeedback(OpenTK.Graphics.OpenGL.TransformFeedbackTarget target, Int32 id);

        /// <summary>[requires: v4.0 and ARB_transform_feedback2|VERSION_4_0]
        /// Bind a transform feedback object
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target to which to bind the transform feedback object id. target must be GL_TRANSFORM_FEEDBACK.
        /// </para>
        /// </param>
        /// <param name="id">
        /// <para>
        /// Specifies the name of a transform feedback object reserved by glGenTransformFeedbacks.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_transform_feedback2|VERSION_4_0", Version = "4.0", EntryPoint = "glBindTransformFeedback")]
        public static extern void BindTransformFeedback(OpenTK.Graphics.OpenGL.TransformFeedbackTarget target, UInt32 id);

        /// <summary>[requires: v3.0 and ARB_vertex_array_object|VERSION_3_0]
        /// Bind a vertex array object
        /// </summary>
        /// <param name="array">
        /// <para>
        /// Specifies the name of the vertex array to bind.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_vertex_array_object|VERSION_3_0", Version = "3.0", EntryPoint = "glBindVertexArray")]
        public static extern void BindVertexArray(Int32 array);

        /// <summary>[requires: v3.0 and ARB_vertex_array_object|VERSION_3_0]
        /// Bind a vertex array object
        /// </summary>
        /// <param name="array">
        /// <para>
        /// Specifies the name of the vertex array to bind.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_array_object|VERSION_3_0", Version = "3.0", EntryPoint = "glBindVertexArray")]
        public static extern void BindVertexArray(UInt32 array);

        /// <summary>[requires: v4.3 and ARB_vertex_attrib_binding|VERSION_4_3]
        /// Bind a buffer to a vertex buffer bind point
        /// </summary>
        /// <param name="bindingindex">
        /// <para>
        /// The index of the vertex buffer binding point to which to bind the buffer.
        /// </para>
        /// </param>
        /// <param name="buffer">
        /// <para>
        /// The name of an existing buffer to bind to the vertex buffer binding point.
        /// </para>
        /// </param>
        /// <param name="offset">
        /// <para>
        /// The offset of the first element of the buffer.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// The distance between elements within the buffer.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_vertex_attrib_binding|VERSION_4_3", Version = "4.3", EntryPoint = "glBindVertexBuffer")]
        public static extern void BindVertexBuffer(Int32 bindingindex, Int32 buffer, IntPtr offset, Int32 stride);

        /// <summary>[requires: v4.3 and ARB_vertex_attrib_binding|VERSION_4_3]
        /// Bind a buffer to a vertex buffer bind point
        /// </summary>
        /// <param name="bindingindex">
        /// <para>
        /// The index of the vertex buffer binding point to which to bind the buffer.
        /// </para>
        /// </param>
        /// <param name="buffer">
        /// <para>
        /// The name of an existing buffer to bind to the vertex buffer binding point.
        /// </para>
        /// </param>
        /// <param name="offset">
        /// <para>
        /// The offset of the first element of the buffer.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// The distance between elements within the buffer.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_attrib_binding|VERSION_4_3", Version = "4.3", EntryPoint = "glBindVertexBuffer")]
        public static extern void BindVertexBuffer(UInt32 bindingindex, UInt32 buffer, IntPtr offset, Int32 stride);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind one or more named buffer objects to a sequence of consecutive vertex buffer binding points
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the first vertex buffer binding point to which a buffer object is to be bound.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of buffers to bind.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// Specifies the address of an array of names of existing buffer objects.
        /// </para>
        /// </param>
        /// <param name="offsets">
        /// <para>
        /// Specifies the address of an array of offsets to associate with the binding points.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// Specifies the address of an array of strides to associate with the binding points.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindVertexBuffers")]
        public static extern void BindVertexBuffers(Int32 first, Int32 count, Int32[] buffers, IntPtr[] offsets, Int32[] strides);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind one or more named buffer objects to a sequence of consecutive vertex buffer binding points
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the first vertex buffer binding point to which a buffer object is to be bound.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of buffers to bind.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// Specifies the address of an array of names of existing buffer objects.
        /// </para>
        /// </param>
        /// <param name="offsets">
        /// <para>
        /// Specifies the address of an array of offsets to associate with the binding points.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// Specifies the address of an array of strides to associate with the binding points.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindVertexBuffers")]
        public static extern void BindVertexBuffers(Int32 first, Int32 count, ref Int32 buffers, ref IntPtr offsets, ref Int32 strides);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind one or more named buffer objects to a sequence of consecutive vertex buffer binding points
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the first vertex buffer binding point to which a buffer object is to be bound.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of buffers to bind.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// Specifies the address of an array of names of existing buffer objects.
        /// </para>
        /// </param>
        /// <param name="offsets">
        /// <para>
        /// Specifies the address of an array of offsets to associate with the binding points.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// Specifies the address of an array of strides to associate with the binding points.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindVertexBuffers")]
        public static extern unsafe void BindVertexBuffers(Int32 first, Int32 count, Int32* buffers, IntPtr* offsets, Int32* strides);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind one or more named buffer objects to a sequence of consecutive vertex buffer binding points
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the first vertex buffer binding point to which a buffer object is to be bound.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of buffers to bind.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// Specifies the address of an array of names of existing buffer objects.
        /// </para>
        /// </param>
        /// <param name="offsets">
        /// <para>
        /// Specifies the address of an array of offsets to associate with the binding points.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// Specifies the address of an array of strides to associate with the binding points.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindVertexBuffers")]
        public static extern void BindVertexBuffers(UInt32 first, Int32 count, UInt32[] buffers, IntPtr[] offsets, Int32[] strides);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind one or more named buffer objects to a sequence of consecutive vertex buffer binding points
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the first vertex buffer binding point to which a buffer object is to be bound.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of buffers to bind.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// Specifies the address of an array of names of existing buffer objects.
        /// </para>
        /// </param>
        /// <param name="offsets">
        /// <para>
        /// Specifies the address of an array of offsets to associate with the binding points.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// Specifies the address of an array of strides to associate with the binding points.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindVertexBuffers")]
        public static extern void BindVertexBuffers(UInt32 first, Int32 count, ref UInt32 buffers, ref IntPtr offsets, ref Int32 strides);

        /// <summary>[requires: v4.4 and ARB_multi_bind|VERSION_4_4]
        /// Bind one or more named buffer objects to a sequence of consecutive vertex buffer binding points
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the first vertex buffer binding point to which a buffer object is to be bound.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of buffers to bind.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// Specifies the address of an array of names of existing buffer objects.
        /// </para>
        /// </param>
        /// <param name="offsets">
        /// <para>
        /// Specifies the address of an array of offsets to associate with the binding points.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// Specifies the address of an array of strides to associate with the binding points.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_multi_bind|VERSION_4_4", Version = "4.4", EntryPoint = "glBindVertexBuffers")]
        public static extern unsafe void BindVertexBuffers(UInt32 first, Int32 count, UInt32* buffers, IntPtr* offsets, Int32* strides);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Draw a bitmap
        /// </summary>
        /// <param name="width">
        /// <para>
        /// Specify the pixel width and height of the bitmap image.
        /// </para>
        /// </param>
        /// <param name="xorig">
        /// <para>
        /// Specify the location of the origin in the bitmap image. The origin is measured from the lower left corner of the bitmap, with right and up being the positive axes.
        /// </para>
        /// </param>
        /// <param name="xmove">
        /// <para>
        /// Specify the x and y offsets to be added to the current raster position after the bitmap is drawn.
        /// </para>
        /// </param>
        /// <param name="bitmap">
        /// <para>
        /// Specifies the address of the bitmap image.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glBitmap")]
        public static extern void Bitmap(Int32 width, Int32 height, Single xorig, Single yorig, Single xmove, Single ymove, Byte[] bitmap);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Draw a bitmap
        /// </summary>
        /// <param name="width">
        /// <para>
        /// Specify the pixel width and height of the bitmap image.
        /// </para>
        /// </param>
        /// <param name="xorig">
        /// <para>
        /// Specify the location of the origin in the bitmap image. The origin is measured from the lower left corner of the bitmap, with right and up being the positive axes.
        /// </para>
        /// </param>
        /// <param name="xmove">
        /// <para>
        /// Specify the x and y offsets to be added to the current raster position after the bitmap is drawn.
        /// </para>
        /// </param>
        /// <param name="bitmap">
        /// <para>
        /// Specifies the address of the bitmap image.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glBitmap")]
        public static extern void Bitmap(Int32 width, Int32 height, Single xorig, Single yorig, Single xmove, Single ymove, ref Byte bitmap);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Draw a bitmap
        /// </summary>
        /// <param name="width">
        /// <para>
        /// Specify the pixel width and height of the bitmap image.
        /// </para>
        /// </param>
        /// <param name="xorig">
        /// <para>
        /// Specify the location of the origin in the bitmap image. The origin is measured from the lower left corner of the bitmap, with right and up being the positive axes.
        /// </para>
        /// </param>
        /// <param name="xmove">
        /// <para>
        /// Specify the x and y offsets to be added to the current raster position after the bitmap is drawn.
        /// </para>
        /// </param>
        /// <param name="bitmap">
        /// <para>
        /// Specifies the address of the bitmap image.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glBitmap")]
        public static extern unsafe void Bitmap(Int32 width, Int32 height, Single xorig, Single yorig, Single xmove, Single ymove, Byte* bitmap);

        /// <summary>[requires: v1.4 and ARB_imaging|VERSION_1_4]
        /// Set the blend color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// specify the components of GL_BLEND_COLOR
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging|VERSION_1_4", Version = "1.4", EntryPoint = "glBlendColor")]
        public static extern void BlendColor(Single red, Single green, Single blue, Single alpha);

        /// <summary>[requires: v1.4 and ARB_imaging|VERSION_1_4]
        /// Specify the equation used for both the RGB blend equation and the Alpha blend equation
        /// </summary>
        /// <param name="buf">
        /// <para>
        /// for glBlendEquationi, specifies the index of the draw buffer for which to set the blend equation.
        /// </para>
        /// </param>
        /// <param name="mode">
        /// <para>
        /// specifies how source and destination colors are combined. It must be GL_FUNC_ADD, GL_FUNC_SUBTRACT, GL_FUNC_REVERSE_SUBTRACT, GL_MIN, GL_MAX.
        /// </para>
        /// </param>
        [Obsolete("Use BlendEquationMode overload instead")]
        [AutoGenerated(Category = "ARB_imaging|VERSION_1_4", Version = "1.4", EntryPoint = "glBlendEquation")]
        public static extern void BlendEquation(OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend mode);

        /// <summary>[requires: v1.4 and ARB_imaging|VERSION_1_4]
        /// Specify the equation used for both the RGB blend equation and the Alpha blend equation
        /// </summary>
        /// <param name="buf">
        /// <para>
        /// for glBlendEquationi, specifies the index of the draw buffer for which to set the blend equation.
        /// </para>
        /// </param>
        /// <param name="mode">
        /// <para>
        /// specifies how source and destination colors are combined. It must be GL_FUNC_ADD, GL_FUNC_SUBTRACT, GL_FUNC_REVERSE_SUBTRACT, GL_MIN, GL_MAX.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging|VERSION_1_4", Version = "1.4", EntryPoint = "glBlendEquation")]
        public static extern void BlendEquation(OpenTK.Graphics.OpenGL.BlendEquationMode mode);

        /// <summary>[requires: v4.0]
        /// Specify the equation used for both the RGB blend equation and the Alpha blend equation
        /// </summary>
        /// <param name="buf">
        /// <para>
        /// for glBlendEquationi, specifies the index of the draw buffer for which to set the blend equation.
        /// </para>
        /// </param>
        /// <param name="mode">
        /// <para>
        /// specifies how source and destination colors are combined. It must be GL_FUNC_ADD, GL_FUNC_SUBTRACT, GL_FUNC_REVERSE_SUBTRACT, GL_MIN, GL_MAX.
        /// </para>
        /// </param>
        [Obsolete("Use BlendEquationMode overload instead")]
        [AutoGenerated(Category = "VERSION_4_0", Version = "4.0", EntryPoint = "glBlendEquationi")]
        public static extern void BlendEquation(Int32 buf, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend mode);

        /// <summary>[requires: v4.0]
        /// Specify the equation used for both the RGB blend equation and the Alpha blend equation
        /// </summary>
        /// <param name="buf">
        /// <para>
        /// for glBlendEquationi, specifies the index of the draw buffer for which to set the blend equation.
        /// </para>
        /// </param>
        /// <param name="mode">
        /// <para>
        /// specifies how source and destination colors are combined. It must be GL_FUNC_ADD, GL_FUNC_SUBTRACT, GL_FUNC_REVERSE_SUBTRACT, GL_MIN, GL_MAX.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_4_0", Version = "4.0", EntryPoint = "glBlendEquationi")]
        public static extern void BlendEquation(Int32 buf, OpenTK.Graphics.OpenGL.BlendEquationMode mode);

        /// <summary>[requires: v4.0]
        /// Specify the equation used for both the RGB blend equation and the Alpha blend equation
        /// </summary>
        /// <param name="buf">
        /// <para>
        /// for glBlendEquationi, specifies the index of the draw buffer for which to set the blend equation.
        /// </para>
        /// </param>
        /// <param name="mode">
        /// <para>
        /// specifies how source and destination colors are combined. It must be GL_FUNC_ADD, GL_FUNC_SUBTRACT, GL_FUNC_REVERSE_SUBTRACT, GL_MIN, GL_MAX.
        /// </para>
        /// </param>
        [Obsolete("Use BlendEquationMode overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_4_0", Version = "4.0", EntryPoint = "glBlendEquationi")]
        public static extern void BlendEquation(UInt32 buf, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend mode);

        /// <summary>[requires: v4.0]
        /// Specify the equation used for both the RGB blend equation and the Alpha blend equation
        /// </summary>
        /// <param name="buf">
        /// <para>
        /// for glBlendEquationi, specifies the index of the draw buffer for which to set the blend equation.
        /// </para>
        /// </param>
        /// <param name="mode">
        /// <para>
        /// specifies how source and destination colors are combined. It must be GL_FUNC_ADD, GL_FUNC_SUBTRACT, GL_FUNC_REVERSE_SUBTRACT, GL_MIN, GL_MAX.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_4_0", Version = "4.0", EntryPoint = "glBlendEquationi")]
        public static extern void BlendEquation(UInt32 buf, OpenTK.Graphics.OpenGL.BlendEquationMode mode);

        /// <summary>[requires: v2.0]
        /// Set the RGB blend equation and the alpha blend equation separately
        /// </summary>
        /// <param name="buf">
        /// <para>
        /// for glBlendEquationSeparatei, specifies the index of the draw buffer for which to set the blend equations.
        /// </para>
        /// </param>
        /// <param name="modeRGB">
        /// <para>
        /// specifies the RGB blend equation, how the red, green, and blue components of the source and destination colors are combined. It must be GL_FUNC_ADD, GL_FUNC_SUBTRACT, GL_FUNC_REVERSE_SUBTRACT, GL_MIN, GL_MAX.
        /// </para>
        /// </param>
        /// <param name="modeAlpha">
        /// <para>
        /// specifies the alpha blend equation, how the alpha component of the source and destination colors are combined. It must be GL_FUNC_ADD, GL_FUNC_SUBTRACT, GL_FUNC_REVERSE_SUBTRACT, GL_MIN, GL_MAX.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glBlendEquationSeparate")]
        public static extern void BlendEquationSeparate(OpenTK.Graphics.OpenGL.BlendEquationMode modeRGB, OpenTK.Graphics.OpenGL.BlendEquationMode modeAlpha);

        /// <summary>[requires: v4.0]
        /// Set the RGB blend equation and the alpha blend equation separately
        /// </summary>
        /// <param name="buf">
        /// <para>
        /// for glBlendEquationSeparatei, specifies the index of the draw buffer for which to set the blend equations.
        /// </para>
        /// </param>
        /// <param name="modeRGB">
        /// <para>
        /// specifies the RGB blend equation, how the red, green, and blue components of the source and destination colors are combined. It must be GL_FUNC_ADD, GL_FUNC_SUBTRACT, GL_FUNC_REVERSE_SUBTRACT, GL_MIN, GL_MAX.
        /// </para>
        /// </param>
        /// <param name="modeAlpha">
        /// <para>
        /// specifies the alpha blend equation, how the alpha component of the source and destination colors are combined. It must be GL_FUNC_ADD, GL_FUNC_SUBTRACT, GL_FUNC_REVERSE_SUBTRACT, GL_MIN, GL_MAX.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_4_0", Version = "4.0", EntryPoint = "glBlendEquationSeparatei")]
        public static extern void BlendEquationSeparate(Int32 buf, OpenTK.Graphics.OpenGL.BlendEquationMode modeRGB, OpenTK.Graphics.OpenGL.BlendEquationMode modeAlpha);

        /// <summary>[requires: v4.0]
        /// Set the RGB blend equation and the alpha blend equation separately
        /// </summary>
        /// <param name="buf">
        /// <para>
        /// for glBlendEquationSeparatei, specifies the index of the draw buffer for which to set the blend equations.
        /// </para>
        /// </param>
        /// <param name="modeRGB">
        /// <para>
        /// specifies the RGB blend equation, how the red, green, and blue components of the source and destination colors are combined. It must be GL_FUNC_ADD, GL_FUNC_SUBTRACT, GL_FUNC_REVERSE_SUBTRACT, GL_MIN, GL_MAX.
        /// </para>
        /// </param>
        /// <param name="modeAlpha">
        /// <para>
        /// specifies the alpha blend equation, how the alpha component of the source and destination colors are combined. It must be GL_FUNC_ADD, GL_FUNC_SUBTRACT, GL_FUNC_REVERSE_SUBTRACT, GL_MIN, GL_MAX.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_4_0", Version = "4.0", EntryPoint = "glBlendEquationSeparatei")]
        public static extern void BlendEquationSeparate(UInt32 buf, OpenTK.Graphics.OpenGL.BlendEquationMode modeRGB, OpenTK.Graphics.OpenGL.BlendEquationMode modeAlpha);

        /// <summary>[requires: v1.0]
        /// Specify pixel arithmetic
        /// </summary>
        /// <param name="buf">
        /// <para>
        /// For glBlendFunci, specifies the index of the draw buffer for which to set the blend function.
        /// </para>
        /// </param>
        /// <param name="sfactor">
        /// <para>
        /// Specifies how the red, green, blue, and alpha source blending factors are computed. The initial value is GL_ONE.
        /// </para>
        /// </param>
        /// <param name="dfactor">
        /// <para>
        /// Specifies how the red, green, blue, and alpha destination blending factors are computed. The following symbolic constants are accepted: GL_ZERO, GL_ONE, GL_SRC_COLOR, GL_ONE_MINUS_SRC_COLOR, GL_DST_COLOR, GL_ONE_MINUS_DST_COLOR, GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA, GL_DST_ALPHA, GL_ONE_MINUS_DST_ALPHA. GL_CONSTANT_COLOR, GL_ONE_MINUS_CONSTANT_COLOR, GL_CONSTANT_ALPHA, and GL_ONE_MINUS_CONSTANT_ALPHA. The initial value is GL_ZERO.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glBlendFunc")]
        public static extern void BlendFunc(OpenTK.Graphics.OpenGL.BlendingFactorSrc sfactor, OpenTK.Graphics.OpenGL.BlendingFactorDest dfactor);

        /// <summary>[requires: v4.0]
        /// Specify pixel arithmetic
        /// </summary>
        /// <param name="buf">
        /// <para>
        /// For glBlendFunci, specifies the index of the draw buffer for which to set the blend function.
        /// </para>
        /// </param>
        /// <param name="sfactor">
        /// <para>
        /// Specifies how the red, green, blue, and alpha source blending factors are computed. The initial value is GL_ONE.
        /// </para>
        /// </param>
        /// <param name="dfactor">
        /// <para>
        /// Specifies how the red, green, blue, and alpha destination blending factors are computed. The following symbolic constants are accepted: GL_ZERO, GL_ONE, GL_SRC_COLOR, GL_ONE_MINUS_SRC_COLOR, GL_DST_COLOR, GL_ONE_MINUS_DST_COLOR, GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA, GL_DST_ALPHA, GL_ONE_MINUS_DST_ALPHA. GL_CONSTANT_COLOR, GL_ONE_MINUS_CONSTANT_COLOR, GL_CONSTANT_ALPHA, and GL_ONE_MINUS_CONSTANT_ALPHA. The initial value is GL_ZERO.
        /// </para>
        /// </param>
        [Obsolete("Use BlendingFactorSrc overload instead")]
        [AutoGenerated(Category = "VERSION_4_0", Version = "4.0", EntryPoint = "glBlendFunci")]
        public static extern void BlendFunc(Int32 buf, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend src, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend dst);

        /// <summary>[requires: v4.0]
        /// Specify pixel arithmetic
        /// </summary>
        /// <param name="buf">
        /// <para>
        /// For glBlendFunci, specifies the index of the draw buffer for which to set the blend function.
        /// </para>
        /// </param>
        /// <param name="sfactor">
        /// <para>
        /// Specifies how the red, green, blue, and alpha source blending factors are computed. The initial value is GL_ONE.
        /// </para>
        /// </param>
        /// <param name="dfactor">
        /// <para>
        /// Specifies how the red, green, blue, and alpha destination blending factors are computed. The following symbolic constants are accepted: GL_ZERO, GL_ONE, GL_SRC_COLOR, GL_ONE_MINUS_SRC_COLOR, GL_DST_COLOR, GL_ONE_MINUS_DST_COLOR, GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA, GL_DST_ALPHA, GL_ONE_MINUS_DST_ALPHA. GL_CONSTANT_COLOR, GL_ONE_MINUS_CONSTANT_COLOR, GL_CONSTANT_ALPHA, and GL_ONE_MINUS_CONSTANT_ALPHA. The initial value is GL_ZERO.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_4_0", Version = "4.0", EntryPoint = "glBlendFunci")]
        public static extern void BlendFunc(Int32 buf, OpenTK.Graphics.OpenGL.BlendingFactorSrc src, OpenTK.Graphics.OpenGL.BlendingFactorDest dst);

        /// <summary>[requires: v4.0]
        /// Specify pixel arithmetic
        /// </summary>
        /// <param name="buf">
        /// <para>
        /// For glBlendFunci, specifies the index of the draw buffer for which to set the blend function.
        /// </para>
        /// </param>
        /// <param name="sfactor">
        /// <para>
        /// Specifies how the red, green, blue, and alpha source blending factors are computed. The initial value is GL_ONE.
        /// </para>
        /// </param>
        /// <param name="dfactor">
        /// <para>
        /// Specifies how the red, green, blue, and alpha destination blending factors are computed. The following symbolic constants are accepted: GL_ZERO, GL_ONE, GL_SRC_COLOR, GL_ONE_MINUS_SRC_COLOR, GL_DST_COLOR, GL_ONE_MINUS_DST_COLOR, GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA, GL_DST_ALPHA, GL_ONE_MINUS_DST_ALPHA. GL_CONSTANT_COLOR, GL_ONE_MINUS_CONSTANT_COLOR, GL_CONSTANT_ALPHA, and GL_ONE_MINUS_CONSTANT_ALPHA. The initial value is GL_ZERO.
        /// </para>
        /// </param>
        [Obsolete("Use BlendingFactorSrc overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_4_0", Version = "4.0", EntryPoint = "glBlendFunci")]
        public static extern void BlendFunc(UInt32 buf, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend src, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend dst);

        /// <summary>[requires: v4.0]
        /// Specify pixel arithmetic
        /// </summary>
        /// <param name="buf">
        /// <para>
        /// For glBlendFunci, specifies the index of the draw buffer for which to set the blend function.
        /// </para>
        /// </param>
        /// <param name="sfactor">
        /// <para>
        /// Specifies how the red, green, blue, and alpha source blending factors are computed. The initial value is GL_ONE.
        /// </para>
        /// </param>
        /// <param name="dfactor">
        /// <para>
        /// Specifies how the red, green, blue, and alpha destination blending factors are computed. The following symbolic constants are accepted: GL_ZERO, GL_ONE, GL_SRC_COLOR, GL_ONE_MINUS_SRC_COLOR, GL_DST_COLOR, GL_ONE_MINUS_DST_COLOR, GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA, GL_DST_ALPHA, GL_ONE_MINUS_DST_ALPHA. GL_CONSTANT_COLOR, GL_ONE_MINUS_CONSTANT_COLOR, GL_CONSTANT_ALPHA, and GL_ONE_MINUS_CONSTANT_ALPHA. The initial value is GL_ZERO.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_4_0", Version = "4.0", EntryPoint = "glBlendFunci")]
        public static extern void BlendFunc(UInt32 buf, OpenTK.Graphics.OpenGL.BlendingFactorSrc src, OpenTK.Graphics.OpenGL.BlendingFactorDest dst);

        /// <summary>[requires: v1.4]
        /// Specify pixel arithmetic for RGB and alpha components separately
        /// </summary>
        /// <param name="buf">
        /// <para>
        /// For glBlendFuncSeparatei, specifies the index of the draw buffer for which to set the blend functions.
        /// </para>
        /// </param>
        /// <param name="srcRGB">
        /// <para>
        /// Specifies how the red, green, and blue blending factors are computed. The initial value is GL_ONE.
        /// </para>
        /// </param>
        /// <param name="dstRGB">
        /// <para>
        /// Specifies how the red, green, and blue destination blending factors are computed. The initial value is GL_ZERO.
        /// </para>
        /// </param>
        /// <param name="srcAlpha">
        /// <para>
        /// Specified how the alpha source blending factor is computed. The initial value is GL_ONE.
        /// </para>
        /// </param>
        /// <param name="dstAlpha">
        /// <para>
        /// Specified how the alpha destination blending factor is computed. The initial value is GL_ZERO.
        /// </para>
        /// </param>
        [Obsolete("Use BlendingFactorSrc overload instead")]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glBlendFuncSeparate")]
        public static extern void BlendFuncSeparate(OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend sfactorRGB, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend dfactorRGB, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend sfactorAlpha, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend dfactorAlpha);

        /// <summary>[requires: v1.4]
        /// Specify pixel arithmetic for RGB and alpha components separately
        /// </summary>
        /// <param name="buf">
        /// <para>
        /// For glBlendFuncSeparatei, specifies the index of the draw buffer for which to set the blend functions.
        /// </para>
        /// </param>
        /// <param name="srcRGB">
        /// <para>
        /// Specifies how the red, green, and blue blending factors are computed. The initial value is GL_ONE.
        /// </para>
        /// </param>
        /// <param name="dstRGB">
        /// <para>
        /// Specifies how the red, green, and blue destination blending factors are computed. The initial value is GL_ZERO.
        /// </para>
        /// </param>
        /// <param name="srcAlpha">
        /// <para>
        /// Specified how the alpha source blending factor is computed. The initial value is GL_ONE.
        /// </para>
        /// </param>
        /// <param name="dstAlpha">
        /// <para>
        /// Specified how the alpha destination blending factor is computed. The initial value is GL_ZERO.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glBlendFuncSeparate")]
        public static extern void BlendFuncSeparate(OpenTK.Graphics.OpenGL.BlendingFactorSrc sfactorRGB, OpenTK.Graphics.OpenGL.BlendingFactorDest dfactorRGB, OpenTK.Graphics.OpenGL.BlendingFactorSrc sfactorAlpha, OpenTK.Graphics.OpenGL.BlendingFactorDest dfactorAlpha);

        /// <summary>[requires: v4.0]
        /// Specify pixel arithmetic for RGB and alpha components separately
        /// </summary>
        /// <param name="buf">
        /// <para>
        /// For glBlendFuncSeparatei, specifies the index of the draw buffer for which to set the blend functions.
        /// </para>
        /// </param>
        /// <param name="srcRGB">
        /// <para>
        /// Specifies how the red, green, and blue blending factors are computed. The initial value is GL_ONE.
        /// </para>
        /// </param>
        /// <param name="dstRGB">
        /// <para>
        /// Specifies how the red, green, and blue destination blending factors are computed. The initial value is GL_ZERO.
        /// </para>
        /// </param>
        /// <param name="srcAlpha">
        /// <para>
        /// Specified how the alpha source blending factor is computed. The initial value is GL_ONE.
        /// </para>
        /// </param>
        /// <param name="dstAlpha">
        /// <para>
        /// Specified how the alpha destination blending factor is computed. The initial value is GL_ZERO.
        /// </para>
        /// </param>
        [Obsolete("Use BlendingFactorSrc overload instead")]
        [AutoGenerated(Category = "VERSION_4_0", Version = "4.0", EntryPoint = "glBlendFuncSeparatei")]
        public static extern void BlendFuncSeparate(Int32 buf, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend srcRGB, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend dstRGB, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend srcAlpha, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend dstAlpha);

        /// <summary>[requires: v4.0]
        /// Specify pixel arithmetic for RGB and alpha components separately
        /// </summary>
        /// <param name="buf">
        /// <para>
        /// For glBlendFuncSeparatei, specifies the index of the draw buffer for which to set the blend functions.
        /// </para>
        /// </param>
        /// <param name="srcRGB">
        /// <para>
        /// Specifies how the red, green, and blue blending factors are computed. The initial value is GL_ONE.
        /// </para>
        /// </param>
        /// <param name="dstRGB">
        /// <para>
        /// Specifies how the red, green, and blue destination blending factors are computed. The initial value is GL_ZERO.
        /// </para>
        /// </param>
        /// <param name="srcAlpha">
        /// <para>
        /// Specified how the alpha source blending factor is computed. The initial value is GL_ONE.
        /// </para>
        /// </param>
        /// <param name="dstAlpha">
        /// <para>
        /// Specified how the alpha destination blending factor is computed. The initial value is GL_ZERO.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_4_0", Version = "4.0", EntryPoint = "glBlendFuncSeparatei")]
        public static extern void BlendFuncSeparate(Int32 buf, OpenTK.Graphics.OpenGL.BlendingFactorSrc srcRGB, OpenTK.Graphics.OpenGL.BlendingFactorDest dstRGB, OpenTK.Graphics.OpenGL.BlendingFactorSrc srcAlpha, OpenTK.Graphics.OpenGL.BlendingFactorDest dstAlpha);

        /// <summary>[requires: v4.0]
        /// Specify pixel arithmetic for RGB and alpha components separately
        /// </summary>
        /// <param name="buf">
        /// <para>
        /// For glBlendFuncSeparatei, specifies the index of the draw buffer for which to set the blend functions.
        /// </para>
        /// </param>
        /// <param name="srcRGB">
        /// <para>
        /// Specifies how the red, green, and blue blending factors are computed. The initial value is GL_ONE.
        /// </para>
        /// </param>
        /// <param name="dstRGB">
        /// <para>
        /// Specifies how the red, green, and blue destination blending factors are computed. The initial value is GL_ZERO.
        /// </para>
        /// </param>
        /// <param name="srcAlpha">
        /// <para>
        /// Specified how the alpha source blending factor is computed. The initial value is GL_ONE.
        /// </para>
        /// </param>
        /// <param name="dstAlpha">
        /// <para>
        /// Specified how the alpha destination blending factor is computed. The initial value is GL_ZERO.
        /// </para>
        /// </param>
        [Obsolete("Use BlendingFactorSrc overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_4_0", Version = "4.0", EntryPoint = "glBlendFuncSeparatei")]
        public static extern void BlendFuncSeparate(UInt32 buf, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend srcRGB, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend dstRGB, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend srcAlpha, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend dstAlpha);

        /// <summary>[requires: v4.0]
        /// Specify pixel arithmetic for RGB and alpha components separately
        /// </summary>
        /// <param name="buf">
        /// <para>
        /// For glBlendFuncSeparatei, specifies the index of the draw buffer for which to set the blend functions.
        /// </para>
        /// </param>
        /// <param name="srcRGB">
        /// <para>
        /// Specifies how the red, green, and blue blending factors are computed. The initial value is GL_ONE.
        /// </para>
        /// </param>
        /// <param name="dstRGB">
        /// <para>
        /// Specifies how the red, green, and blue destination blending factors are computed. The initial value is GL_ZERO.
        /// </para>
        /// </param>
        /// <param name="srcAlpha">
        /// <para>
        /// Specified how the alpha source blending factor is computed. The initial value is GL_ONE.
        /// </para>
        /// </param>
        /// <param name="dstAlpha">
        /// <para>
        /// Specified how the alpha destination blending factor is computed. The initial value is GL_ZERO.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_4_0", Version = "4.0", EntryPoint = "glBlendFuncSeparatei")]
        public static extern void BlendFuncSeparate(UInt32 buf, OpenTK.Graphics.OpenGL.BlendingFactorSrc srcRGB, OpenTK.Graphics.OpenGL.BlendingFactorDest dstRGB, OpenTK.Graphics.OpenGL.BlendingFactorSrc srcAlpha, OpenTK.Graphics.OpenGL.BlendingFactorDest dstAlpha);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Copy a block of pixels from the read framebuffer to the draw framebuffer
        /// </summary>
        /// <param name="srcX0">
        /// <para>
        /// Specify the bounds of the source rectangle within the read buffer of the read framebuffer.
        /// </para>
        /// </param>
        /// <param name="dstX0">
        /// <para>
        /// Specify the bounds of the destination rectangle within the write buffer of the write framebuffer.
        /// </para>
        /// </param>
        /// <param name="mask">
        /// <para>
        /// The bitwise OR of the flags indicating which buffers are to be copied. The allowed flags are GL_COLOR_BUFFER_BIT, GL_DEPTH_BUFFER_BIT and GL_STENCIL_BUFFER_BIT.
        /// </para>
        /// </param>
        /// <param name="filter">
        /// <para>
        /// Specifies the interpolation to be applied if the image is stretched. Must be GL_NEAREST or GL_LINEAR.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glBlitFramebuffer")]
        public static extern void BlitFramebuffer(Int32 srcX0, Int32 srcY0, Int32 srcX1, Int32 srcY1, Int32 dstX0, Int32 dstY0, Int32 dstX1, Int32 dstY1, OpenTK.Graphics.OpenGL.ClearBufferMask mask, OpenTK.Graphics.OpenGL.BlitFramebufferFilter filter);

        /// <summary>[requires: v1.5]
        /// Creates and initializes a buffer object's data store
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Specifies the size in bytes of the buffer object's new data store.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to data that will be copied into the data store for initialization, or NULL if no data is to be copied.
        /// </para>
        /// </param>
        /// <param name="usage">
        /// <para>
        /// Specifies the expected usage pattern of the data store. The symbolic constant must be GL_STREAM_DRAW, GL_STREAM_READ, GL_STREAM_COPY, GL_STATIC_DRAW, GL_STATIC_READ, GL_STATIC_COPY, GL_DYNAMIC_DRAW, GL_DYNAMIC_READ, or GL_DYNAMIC_COPY.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glBufferData")]
        public static extern void BufferData(OpenTK.Graphics.OpenGL.BufferTarget target, IntPtr size, IntPtr data, OpenTK.Graphics.OpenGL.BufferUsageHint usage);

        /// <summary>[requires: v1.5]
        /// Creates and initializes a buffer object's data store
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Specifies the size in bytes of the buffer object's new data store.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to data that will be copied into the data store for initialization, or NULL if no data is to be copied.
        /// </para>
        /// </param>
        /// <param name="usage">
        /// <para>
        /// Specifies the expected usage pattern of the data store. The symbolic constant must be GL_STREAM_DRAW, GL_STREAM_READ, GL_STREAM_COPY, GL_STATIC_DRAW, GL_STATIC_READ, GL_STATIC_COPY, GL_DYNAMIC_DRAW, GL_DYNAMIC_READ, or GL_DYNAMIC_COPY.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glBufferData")]
        public static extern void BufferData<T2>(OpenTK.Graphics.OpenGL.BufferTarget target, IntPtr size, [InAttribute, OutAttribute] T2[] data, OpenTK.Graphics.OpenGL.BufferUsageHint usage)
            where T2 : struct
        ;

        /// <summary>[requires: v1.5]
        /// Creates and initializes a buffer object's data store
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Specifies the size in bytes of the buffer object's new data store.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to data that will be copied into the data store for initialization, or NULL if no data is to be copied.
        /// </para>
        /// </param>
        /// <param name="usage">
        /// <para>
        /// Specifies the expected usage pattern of the data store. The symbolic constant must be GL_STREAM_DRAW, GL_STREAM_READ, GL_STREAM_COPY, GL_STATIC_DRAW, GL_STATIC_READ, GL_STATIC_COPY, GL_DYNAMIC_DRAW, GL_DYNAMIC_READ, or GL_DYNAMIC_COPY.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glBufferData")]
        public static extern void BufferData<T2>(OpenTK.Graphics.OpenGL.BufferTarget target, IntPtr size, [InAttribute, OutAttribute] T2[,] data, OpenTK.Graphics.OpenGL.BufferUsageHint usage)
            where T2 : struct
        ;

        /// <summary>[requires: v1.5]
        /// Creates and initializes a buffer object's data store
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Specifies the size in bytes of the buffer object's new data store.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to data that will be copied into the data store for initialization, or NULL if no data is to be copied.
        /// </para>
        /// </param>
        /// <param name="usage">
        /// <para>
        /// Specifies the expected usage pattern of the data store. The symbolic constant must be GL_STREAM_DRAW, GL_STREAM_READ, GL_STREAM_COPY, GL_STATIC_DRAW, GL_STATIC_READ, GL_STATIC_COPY, GL_DYNAMIC_DRAW, GL_DYNAMIC_READ, or GL_DYNAMIC_COPY.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glBufferData")]
        public static extern void BufferData<T2>(OpenTK.Graphics.OpenGL.BufferTarget target, IntPtr size, [InAttribute, OutAttribute] T2[,,] data, OpenTK.Graphics.OpenGL.BufferUsageHint usage)
            where T2 : struct
        ;

        /// <summary>[requires: v1.5]
        /// Creates and initializes a buffer object's data store
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Specifies the size in bytes of the buffer object's new data store.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to data that will be copied into the data store for initialization, or NULL if no data is to be copied.
        /// </para>
        /// </param>
        /// <param name="usage">
        /// <para>
        /// Specifies the expected usage pattern of the data store. The symbolic constant must be GL_STREAM_DRAW, GL_STREAM_READ, GL_STREAM_COPY, GL_STATIC_DRAW, GL_STATIC_READ, GL_STATIC_COPY, GL_DYNAMIC_DRAW, GL_DYNAMIC_READ, or GL_DYNAMIC_COPY.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glBufferData")]
        public static extern void BufferData<T2>(OpenTK.Graphics.OpenGL.BufferTarget target, IntPtr size, [InAttribute, OutAttribute] ref T2 data, OpenTK.Graphics.OpenGL.BufferUsageHint usage)
            where T2 : struct
        ;

        /// <summary>[requires: v4.4 and ARB_buffer_storage|VERSION_4_4]
        /// Creates and initializes a buffer object's immutable data store
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Specifies the size in bytes of the buffer object's new data store.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to data that will be copied into the data store for initialization, or NULL if no data is to be copied.
        /// </para>
        /// </param>
        /// <param name="flags">
        /// <para>
        /// Specifies the intended usage of the buffer's data store. Must be a bitwise combination of the following flags. GL_DYNAMIC_STORAGE_BIT, GL_MAP_READ_BIT GL_MAP_WRITE_BIT, GL_MAP_PERSISTENT_BIT, GL_MAP_COHERENT_BIT, and GL_CLIENT_STORAGE_BIT.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_buffer_storage|VERSION_4_4", Version = "4.4", EntryPoint = "glBufferStorage")]
        public static extern void BufferStorage(OpenTK.Graphics.OpenGL.BufferTarget target, IntPtr size, IntPtr data, OpenTK.Graphics.OpenGL.BufferStorageFlags flags);

        /// <summary>[requires: v4.4 and ARB_buffer_storage|VERSION_4_4]
        /// Creates and initializes a buffer object's immutable data store
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Specifies the size in bytes of the buffer object's new data store.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to data that will be copied into the data store for initialization, or NULL if no data is to be copied.
        /// </para>
        /// </param>
        /// <param name="flags">
        /// <para>
        /// Specifies the intended usage of the buffer's data store. Must be a bitwise combination of the following flags. GL_DYNAMIC_STORAGE_BIT, GL_MAP_READ_BIT GL_MAP_WRITE_BIT, GL_MAP_PERSISTENT_BIT, GL_MAP_COHERENT_BIT, and GL_CLIENT_STORAGE_BIT.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_buffer_storage|VERSION_4_4", Version = "4.4", EntryPoint = "glBufferStorage")]
        public static extern void BufferStorage<T2>(OpenTK.Graphics.OpenGL.BufferTarget target, IntPtr size, [InAttribute, OutAttribute] T2[] data, OpenTK.Graphics.OpenGL.BufferStorageFlags flags)
            where T2 : struct
        ;

        /// <summary>[requires: v4.4 and ARB_buffer_storage|VERSION_4_4]
        /// Creates and initializes a buffer object's immutable data store
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Specifies the size in bytes of the buffer object's new data store.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to data that will be copied into the data store for initialization, or NULL if no data is to be copied.
        /// </para>
        /// </param>
        /// <param name="flags">
        /// <para>
        /// Specifies the intended usage of the buffer's data store. Must be a bitwise combination of the following flags. GL_DYNAMIC_STORAGE_BIT, GL_MAP_READ_BIT GL_MAP_WRITE_BIT, GL_MAP_PERSISTENT_BIT, GL_MAP_COHERENT_BIT, and GL_CLIENT_STORAGE_BIT.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_buffer_storage|VERSION_4_4", Version = "4.4", EntryPoint = "glBufferStorage")]
        public static extern void BufferStorage<T2>(OpenTK.Graphics.OpenGL.BufferTarget target, IntPtr size, [InAttribute, OutAttribute] T2[,] data, OpenTK.Graphics.OpenGL.BufferStorageFlags flags)
            where T2 : struct
        ;

        /// <summary>[requires: v4.4 and ARB_buffer_storage|VERSION_4_4]
        /// Creates and initializes a buffer object's immutable data store
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Specifies the size in bytes of the buffer object's new data store.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to data that will be copied into the data store for initialization, or NULL if no data is to be copied.
        /// </para>
        /// </param>
        /// <param name="flags">
        /// <para>
        /// Specifies the intended usage of the buffer's data store. Must be a bitwise combination of the following flags. GL_DYNAMIC_STORAGE_BIT, GL_MAP_READ_BIT GL_MAP_WRITE_BIT, GL_MAP_PERSISTENT_BIT, GL_MAP_COHERENT_BIT, and GL_CLIENT_STORAGE_BIT.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_buffer_storage|VERSION_4_4", Version = "4.4", EntryPoint = "glBufferStorage")]
        public static extern void BufferStorage<T2>(OpenTK.Graphics.OpenGL.BufferTarget target, IntPtr size, [InAttribute, OutAttribute] T2[,,] data, OpenTK.Graphics.OpenGL.BufferStorageFlags flags)
            where T2 : struct
        ;

        /// <summary>[requires: v4.4 and ARB_buffer_storage|VERSION_4_4]
        /// Creates and initializes a buffer object's immutable data store
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Specifies the size in bytes of the buffer object's new data store.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to data that will be copied into the data store for initialization, or NULL if no data is to be copied.
        /// </para>
        /// </param>
        /// <param name="flags">
        /// <para>
        /// Specifies the intended usage of the buffer's data store. Must be a bitwise combination of the following flags. GL_DYNAMIC_STORAGE_BIT, GL_MAP_READ_BIT GL_MAP_WRITE_BIT, GL_MAP_PERSISTENT_BIT, GL_MAP_COHERENT_BIT, and GL_CLIENT_STORAGE_BIT.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_buffer_storage|VERSION_4_4", Version = "4.4", EntryPoint = "glBufferStorage")]
        public static extern void BufferStorage<T2>(OpenTK.Graphics.OpenGL.BufferTarget target, IntPtr size, [InAttribute, OutAttribute] ref T2 data, OpenTK.Graphics.OpenGL.BufferStorageFlags flags)
            where T2 : struct
        ;

        /// <summary>[requires: v1.5]
        /// Updates a subset of a buffer object's data store
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
        /// </para>
        /// </param>
        /// <param name="offset">
        /// <para>
        /// Specifies the offset into the buffer object's data store where data replacement will begin, measured in bytes.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Specifies the size in bytes of the data store region being replaced.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the new data that will be copied into the data store.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glBufferSubData")]
        public static extern void BufferSubData(OpenTK.Graphics.OpenGL.BufferTarget target, IntPtr offset, IntPtr size, IntPtr data);

        /// <summary>[requires: v1.5]
        /// Updates a subset of a buffer object's data store
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
        /// </para>
        /// </param>
        /// <param name="offset">
        /// <para>
        /// Specifies the offset into the buffer object's data store where data replacement will begin, measured in bytes.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Specifies the size in bytes of the data store region being replaced.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the new data that will be copied into the data store.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glBufferSubData")]
        public static extern void BufferSubData<T3>(OpenTK.Graphics.OpenGL.BufferTarget target, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] T3[] data)
            where T3 : struct
        ;

        /// <summary>[requires: v1.5]
        /// Updates a subset of a buffer object's data store
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
        /// </para>
        /// </param>
        /// <param name="offset">
        /// <para>
        /// Specifies the offset into the buffer object's data store where data replacement will begin, measured in bytes.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Specifies the size in bytes of the data store region being replaced.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the new data that will be copied into the data store.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glBufferSubData")]
        public static extern void BufferSubData<T3>(OpenTK.Graphics.OpenGL.BufferTarget target, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] T3[,] data)
            where T3 : struct
        ;

        /// <summary>[requires: v1.5]
        /// Updates a subset of a buffer object's data store
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
        /// </para>
        /// </param>
        /// <param name="offset">
        /// <para>
        /// Specifies the offset into the buffer object's data store where data replacement will begin, measured in bytes.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Specifies the size in bytes of the data store region being replaced.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the new data that will be copied into the data store.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glBufferSubData")]
        public static extern void BufferSubData<T3>(OpenTK.Graphics.OpenGL.BufferTarget target, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] T3[,,] data)
            where T3 : struct
        ;

        /// <summary>[requires: v1.5]
        /// Updates a subset of a buffer object's data store
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
        /// </para>
        /// </param>
        /// <param name="offset">
        /// <para>
        /// Specifies the offset into the buffer object's data store where data replacement will begin, measured in bytes.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Specifies the size in bytes of the data store region being replaced.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the new data that will be copied into the data store.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glBufferSubData")]
        public static extern void BufferSubData<T3>(OpenTK.Graphics.OpenGL.BufferTarget target, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] ref T3 data)
            where T3 : struct
        ;

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Execute a display list
        /// </summary>
        /// <param name="list">
        /// <para>
        /// Specifies the integer name of the display list to be executed.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glCallList")]
        public static extern void CallList(Int32 list);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Execute a display list
        /// </summary>
        /// <param name="list">
        /// <para>
        /// Specifies the integer name of the display list to be executed.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glCallList")]
        public static extern void CallList(UInt32 list);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Execute a list of display lists
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of display lists to be executed.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of values in lists. Symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, GL_UNSIGNED_INT, GL_FLOAT, GL_2_BYTES, GL_3_BYTES, and GL_4_BYTES are accepted.
        /// </para>
        /// </param>
        /// <param name="lists">
        /// <para>
        /// Specifies the address of an array of name offsets in the display list. The pointer type is void because the offsets can be bytes, shorts, ints, or floats, depending on the value of type.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glCallLists")]
        public static extern void CallLists(Int32 n, OpenTK.Graphics.OpenGL.ListNameType type, IntPtr lists);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Execute a list of display lists
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of display lists to be executed.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of values in lists. Symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, GL_UNSIGNED_INT, GL_FLOAT, GL_2_BYTES, GL_3_BYTES, and GL_4_BYTES are accepted.
        /// </para>
        /// </param>
        /// <param name="lists">
        /// <para>
        /// Specifies the address of an array of name offsets in the display list. The pointer type is void because the offsets can be bytes, shorts, ints, or floats, depending on the value of type.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glCallLists")]
        public static extern void CallLists<T2>(Int32 n, OpenTK.Graphics.OpenGL.ListNameType type, [InAttribute, OutAttribute] T2[] lists)
            where T2 : struct
        ;

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Execute a list of display lists
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of display lists to be executed.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of values in lists. Symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, GL_UNSIGNED_INT, GL_FLOAT, GL_2_BYTES, GL_3_BYTES, and GL_4_BYTES are accepted.
        /// </para>
        /// </param>
        /// <param name="lists">
        /// <para>
        /// Specifies the address of an array of name offsets in the display list. The pointer type is void because the offsets can be bytes, shorts, ints, or floats, depending on the value of type.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glCallLists")]
        public static extern void CallLists<T2>(Int32 n, OpenTK.Graphics.OpenGL.ListNameType type, [InAttribute, OutAttribute] T2[,] lists)
            where T2 : struct
        ;

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Execute a list of display lists
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of display lists to be executed.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of values in lists. Symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, GL_UNSIGNED_INT, GL_FLOAT, GL_2_BYTES, GL_3_BYTES, and GL_4_BYTES are accepted.
        /// </para>
        /// </param>
        /// <param name="lists">
        /// <para>
        /// Specifies the address of an array of name offsets in the display list. The pointer type is void because the offsets can be bytes, shorts, ints, or floats, depending on the value of type.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glCallLists")]
        public static extern void CallLists<T2>(Int32 n, OpenTK.Graphics.OpenGL.ListNameType type, [InAttribute, OutAttribute] T2[,,] lists)
            where T2 : struct
        ;

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Execute a list of display lists
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of display lists to be executed.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of values in lists. Symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, GL_UNSIGNED_INT, GL_FLOAT, GL_2_BYTES, GL_3_BYTES, and GL_4_BYTES are accepted.
        /// </para>
        /// </param>
        /// <param name="lists">
        /// <para>
        /// Specifies the address of an array of name offsets in the display list. The pointer type is void because the offsets can be bytes, shorts, ints, or floats, depending on the value of type.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glCallLists")]
        public static extern void CallLists<T2>(Int32 n, OpenTK.Graphics.OpenGL.ListNameType type, [InAttribute, OutAttribute] ref T2 lists)
            where T2 : struct
        ;

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Check the completeness status of a framebuffer
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the framebuffer completeness check.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glCheckFramebufferStatus")]
        public static extern OpenTK.Graphics.OpenGL.FramebufferErrorCode CheckFramebufferStatus(OpenTK.Graphics.OpenGL.FramebufferTarget target);

        /// <summary>[requires: v3.0]
        /// Specify whether data read via glReadPixels should be clamped
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Target for color clamping. target must be GL_CLAMP_READ_COLOR.
        /// </para>
        /// </param>
        /// <param name="clamp">
        /// <para>
        /// Specifies whether to apply color clamping. clamp must be GL_TRUE or GL_FALSE.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glClampColor")]
        public static extern void ClampColor(OpenTK.Graphics.OpenGL.ClampColorTarget target, OpenTK.Graphics.OpenGL.ClampColorMode clamp);

        /// <summary>[requires: v1.0]
        /// Clear buffers to preset values
        /// </summary>
        /// <param name="mask">
        /// <para>
        /// Bitwise OR of masks that indicate the buffers to be cleared. The three masks are GL_COLOR_BUFFER_BIT, GL_DEPTH_BUFFER_BIT, and GL_STENCIL_BUFFER_BIT.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glClear")]
        public static extern void Clear(OpenTK.Graphics.OpenGL.ClearBufferMask mask);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify clear values for the accumulation buffer
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify the red, green, blue, and alpha values used when the accumulation buffer is cleared. The initial values are all 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glClearAccum")]
        public static extern void ClearAccum(Single red, Single green, Single blue, Single alpha);

        /// <summary>[requires: v4.3 and ARB_clear_buffer_object|VERSION_4_3]
        /// Fill a buffer object's data store with a fixed value
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the operation. target must be one of the global buffer binding targets.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The internal format with which the data will be stored in the buffer object.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// The size, in basic machine units of the range of the data store to fill.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the data in memory addressed by data.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the data in memory addressed by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// The address of a memory location storing the data to be replicated into the buffer's data store.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_clear_buffer_object|VERSION_4_3", Version = "4.3", EntryPoint = "glClearBufferData")]
        public static extern void ClearBufferData(OpenTK.Graphics.OpenGL.BufferTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.All type, IntPtr data);

        /// <summary>[requires: v4.3 and ARB_clear_buffer_object|VERSION_4_3]
        /// Fill a buffer object's data store with a fixed value
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the operation. target must be one of the global buffer binding targets.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The internal format with which the data will be stored in the buffer object.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// The size, in basic machine units of the range of the data store to fill.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the data in memory addressed by data.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the data in memory addressed by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// The address of a memory location storing the data to be replicated into the buffer's data store.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_clear_buffer_object|VERSION_4_3", Version = "4.3", EntryPoint = "glClearBufferData")]
        public static extern void ClearBufferData<T4>(OpenTK.Graphics.OpenGL.BufferTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.All type, [InAttribute, OutAttribute] T4[] data)
            where T4 : struct
        ;

        /// <summary>[requires: v4.3 and ARB_clear_buffer_object|VERSION_4_3]
        /// Fill a buffer object's data store with a fixed value
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the operation. target must be one of the global buffer binding targets.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The internal format with which the data will be stored in the buffer object.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// The size, in basic machine units of the range of the data store to fill.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the data in memory addressed by data.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the data in memory addressed by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// The address of a memory location storing the data to be replicated into the buffer's data store.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_clear_buffer_object|VERSION_4_3", Version = "4.3", EntryPoint = "glClearBufferData")]
        public static extern void ClearBufferData<T4>(OpenTK.Graphics.OpenGL.BufferTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.All type, [InAttribute, OutAttribute] T4[,] data)
            where T4 : struct
        ;

        /// <summary>[requires: v4.3 and ARB_clear_buffer_object|VERSION_4_3]
        /// Fill a buffer object's data store with a fixed value
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the operation. target must be one of the global buffer binding targets.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The internal format with which the data will be stored in the buffer object.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// The size, in basic machine units of the range of the data store to fill.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the data in memory addressed by data.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the data in memory addressed by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// The address of a memory location storing the data to be replicated into the buffer's data store.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_clear_buffer_object|VERSION_4_3", Version = "4.3", EntryPoint = "glClearBufferData")]
        public static extern void ClearBufferData<T4>(OpenTK.Graphics.OpenGL.BufferTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.All type, [InAttribute, OutAttribute] T4[,,] data)
            where T4 : struct
        ;

        /// <summary>[requires: v4.3 and ARB_clear_buffer_object|VERSION_4_3]
        /// Fill a buffer object's data store with a fixed value
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the operation. target must be one of the global buffer binding targets.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The internal format with which the data will be stored in the buffer object.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// The size, in basic machine units of the range of the data store to fill.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the data in memory addressed by data.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the data in memory addressed by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// The address of a memory location storing the data to be replicated into the buffer's data store.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_clear_buffer_object|VERSION_4_3", Version = "4.3", EntryPoint = "glClearBufferData")]
        public static extern void ClearBufferData<T4>(OpenTK.Graphics.OpenGL.BufferTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.All type, [InAttribute, OutAttribute] ref T4 data)
            where T4 : struct
        ;

        /// <summary>[requires: v3.0]
        /// Clear individual buffers of the currently bound draw framebuffer
        /// </summary>
        /// <param name="buffer">
        /// <para>
        /// Specify the buffer to clear.
        /// </para>
        /// </param>
        /// <param name="drawBuffer">
        /// <para>
        /// Specify a particular draw buffer to clear.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For color buffers, a pointer to a four-element vector specifying R, G, B and A values to clear the buffer to. For depth buffers, a pointer to a single depth value to clear the buffer to. For stencil buffers, a pointer to a single stencil value to clear the buffer to.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// The value to clear a depth render buffer to.
        /// </para>
        /// </param>
        /// <param name="stencil">
        /// <para>
        /// The value to clear a stencil render buffer to.
        /// </para>
        /// </param>
        [Obsolete("Use ClearBufferCombined overload instead")]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glClearBufferfi")]
        public static extern void ClearBuffer(OpenTK.Graphics.OpenGL.ClearBuffer buffer, Int32 drawbuffer, Single depth, Int32 stencil);

        /// <summary>[requires: v3.0]
        /// Clear individual buffers of the currently bound draw framebuffer
        /// </summary>
        /// <param name="buffer">
        /// <para>
        /// Specify the buffer to clear.
        /// </para>
        /// </param>
        /// <param name="drawBuffer">
        /// <para>
        /// Specify a particular draw buffer to clear.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For color buffers, a pointer to a four-element vector specifying R, G, B and A values to clear the buffer to. For depth buffers, a pointer to a single depth value to clear the buffer to. For stencil buffers, a pointer to a single stencil value to clear the buffer to.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// The value to clear a depth render buffer to.
        /// </para>
        /// </param>
        /// <param name="stencil">
        /// <para>
        /// The value to clear a stencil render buffer to.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glClearBufferfi")]
        public static extern void ClearBuffer(OpenTK.Graphics.OpenGL.ClearBufferCombined buffer, Int32 drawbuffer, Single depth, Int32 stencil);

        /// <summary>[requires: v3.0]
        /// Clear individual buffers of the currently bound draw framebuffer
        /// </summary>
        /// <param name="buffer">
        /// <para>
        /// Specify the buffer to clear.
        /// </para>
        /// </param>
        /// <param name="drawBuffer">
        /// <para>
        /// Specify a particular draw buffer to clear.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For color buffers, a pointer to a four-element vector specifying R, G, B and A values to clear the buffer to. For depth buffers, a pointer to a single depth value to clear the buffer to. For stencil buffers, a pointer to a single stencil value to clear the buffer to.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// The value to clear a depth render buffer to.
        /// </para>
        /// </param>
        /// <param name="stencil">
        /// <para>
        /// The value to clear a stencil render buffer to.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glClearBufferfv")]
        public static extern void ClearBuffer(OpenTK.Graphics.OpenGL.ClearBuffer buffer, Int32 drawbuffer, Single[] value);

        /// <summary>[requires: v3.0]
        /// Clear individual buffers of the currently bound draw framebuffer
        /// </summary>
        /// <param name="buffer">
        /// <para>
        /// Specify the buffer to clear.
        /// </para>
        /// </param>
        /// <param name="drawBuffer">
        /// <para>
        /// Specify a particular draw buffer to clear.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For color buffers, a pointer to a four-element vector specifying R, G, B and A values to clear the buffer to. For depth buffers, a pointer to a single depth value to clear the buffer to. For stencil buffers, a pointer to a single stencil value to clear the buffer to.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// The value to clear a depth render buffer to.
        /// </para>
        /// </param>
        /// <param name="stencil">
        /// <para>
        /// The value to clear a stencil render buffer to.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glClearBufferfv")]
        public static extern void ClearBuffer(OpenTK.Graphics.OpenGL.ClearBuffer buffer, Int32 drawbuffer, ref Single value);

        /// <summary>[requires: v3.0]
        /// Clear individual buffers of the currently bound draw framebuffer
        /// </summary>
        /// <param name="buffer">
        /// <para>
        /// Specify the buffer to clear.
        /// </para>
        /// </param>
        /// <param name="drawBuffer">
        /// <para>
        /// Specify a particular draw buffer to clear.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For color buffers, a pointer to a four-element vector specifying R, G, B and A values to clear the buffer to. For depth buffers, a pointer to a single depth value to clear the buffer to. For stencil buffers, a pointer to a single stencil value to clear the buffer to.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// The value to clear a depth render buffer to.
        /// </para>
        /// </param>
        /// <param name="stencil">
        /// <para>
        /// The value to clear a stencil render buffer to.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glClearBufferfv")]
        public static extern unsafe void ClearBuffer(OpenTK.Graphics.OpenGL.ClearBuffer buffer, Int32 drawbuffer, Single* value);

        /// <summary>[requires: v3.0]
        /// Clear individual buffers of the currently bound draw framebuffer
        /// </summary>
        /// <param name="buffer">
        /// <para>
        /// Specify the buffer to clear.
        /// </para>
        /// </param>
        /// <param name="drawBuffer">
        /// <para>
        /// Specify a particular draw buffer to clear.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For color buffers, a pointer to a four-element vector specifying R, G, B and A values to clear the buffer to. For depth buffers, a pointer to a single depth value to clear the buffer to. For stencil buffers, a pointer to a single stencil value to clear the buffer to.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// The value to clear a depth render buffer to.
        /// </para>
        /// </param>
        /// <param name="stencil">
        /// <para>
        /// The value to clear a stencil render buffer to.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glClearBufferiv")]
        public static extern void ClearBuffer(OpenTK.Graphics.OpenGL.ClearBuffer buffer, Int32 drawbuffer, Int32[] value);

        /// <summary>[requires: v3.0]
        /// Clear individual buffers of the currently bound draw framebuffer
        /// </summary>
        /// <param name="buffer">
        /// <para>
        /// Specify the buffer to clear.
        /// </para>
        /// </param>
        /// <param name="drawBuffer">
        /// <para>
        /// Specify a particular draw buffer to clear.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For color buffers, a pointer to a four-element vector specifying R, G, B and A values to clear the buffer to. For depth buffers, a pointer to a single depth value to clear the buffer to. For stencil buffers, a pointer to a single stencil value to clear the buffer to.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// The value to clear a depth render buffer to.
        /// </para>
        /// </param>
        /// <param name="stencil">
        /// <para>
        /// The value to clear a stencil render buffer to.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glClearBufferiv")]
        public static extern void ClearBuffer(OpenTK.Graphics.OpenGL.ClearBuffer buffer, Int32 drawbuffer, ref Int32 value);

        /// <summary>[requires: v3.0]
        /// Clear individual buffers of the currently bound draw framebuffer
        /// </summary>
        /// <param name="buffer">
        /// <para>
        /// Specify the buffer to clear.
        /// </para>
        /// </param>
        /// <param name="drawBuffer">
        /// <para>
        /// Specify a particular draw buffer to clear.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For color buffers, a pointer to a four-element vector specifying R, G, B and A values to clear the buffer to. For depth buffers, a pointer to a single depth value to clear the buffer to. For stencil buffers, a pointer to a single stencil value to clear the buffer to.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// The value to clear a depth render buffer to.
        /// </para>
        /// </param>
        /// <param name="stencil">
        /// <para>
        /// The value to clear a stencil render buffer to.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glClearBufferiv")]
        public static extern unsafe void ClearBuffer(OpenTK.Graphics.OpenGL.ClearBuffer buffer, Int32 drawbuffer, Int32* value);

        /// <summary>[requires: v4.3 and ARB_clear_buffer_object|VERSION_4_3]
        /// Fill all or part of buffer object's data store with a fixed value
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the operation. target must be one of the global buffer binding targets.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The internal format with which the data will be stored in the buffer object.
        /// </para>
        /// </param>
        /// <param name="offset">
        /// <para>
        /// The offset, in basic machine units into the buffer object's data store at which to start filling.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// The size, in basic machine units of the range of the data store to fill.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the data in memory addressed by data.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the data in memory addressed by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// The address of a memory location storing the data to be replicated into the buffer's data store.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_clear_buffer_object|VERSION_4_3", Version = "4.3", EntryPoint = "glClearBufferSubData")]
        public static extern void ClearBufferSubData(OpenTK.Graphics.OpenGL.BufferTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, IntPtr offset, IntPtr size, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.All type, IntPtr data);

        /// <summary>[requires: v4.3 and ARB_clear_buffer_object|VERSION_4_3]
        /// Fill all or part of buffer object's data store with a fixed value
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the operation. target must be one of the global buffer binding targets.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The internal format with which the data will be stored in the buffer object.
        /// </para>
        /// </param>
        /// <param name="offset">
        /// <para>
        /// The offset, in basic machine units into the buffer object's data store at which to start filling.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// The size, in basic machine units of the range of the data store to fill.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the data in memory addressed by data.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the data in memory addressed by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// The address of a memory location storing the data to be replicated into the buffer's data store.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_clear_buffer_object|VERSION_4_3", Version = "4.3", EntryPoint = "glClearBufferSubData")]
        public static extern void ClearBufferSubData<T6>(OpenTK.Graphics.OpenGL.BufferTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, IntPtr offset, IntPtr size, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.All type, [InAttribute, OutAttribute] T6[] data)
            where T6 : struct
        ;

        /// <summary>[requires: v4.3 and ARB_clear_buffer_object|VERSION_4_3]
        /// Fill all or part of buffer object's data store with a fixed value
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the operation. target must be one of the global buffer binding targets.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The internal format with which the data will be stored in the buffer object.
        /// </para>
        /// </param>
        /// <param name="offset">
        /// <para>
        /// The offset, in basic machine units into the buffer object's data store at which to start filling.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// The size, in basic machine units of the range of the data store to fill.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the data in memory addressed by data.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the data in memory addressed by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// The address of a memory location storing the data to be replicated into the buffer's data store.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_clear_buffer_object|VERSION_4_3", Version = "4.3", EntryPoint = "glClearBufferSubData")]
        public static extern void ClearBufferSubData<T6>(OpenTK.Graphics.OpenGL.BufferTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, IntPtr offset, IntPtr size, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.All type, [InAttribute, OutAttribute] T6[,] data)
            where T6 : struct
        ;

        /// <summary>[requires: v4.3 and ARB_clear_buffer_object|VERSION_4_3]
        /// Fill all or part of buffer object's data store with a fixed value
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the operation. target must be one of the global buffer binding targets.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The internal format with which the data will be stored in the buffer object.
        /// </para>
        /// </param>
        /// <param name="offset">
        /// <para>
        /// The offset, in basic machine units into the buffer object's data store at which to start filling.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// The size, in basic machine units of the range of the data store to fill.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the data in memory addressed by data.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the data in memory addressed by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// The address of a memory location storing the data to be replicated into the buffer's data store.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_clear_buffer_object|VERSION_4_3", Version = "4.3", EntryPoint = "glClearBufferSubData")]
        public static extern void ClearBufferSubData<T6>(OpenTK.Graphics.OpenGL.BufferTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, IntPtr offset, IntPtr size, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.All type, [InAttribute, OutAttribute] T6[,,] data)
            where T6 : struct
        ;

        /// <summary>[requires: v4.3 and ARB_clear_buffer_object|VERSION_4_3]
        /// Fill all or part of buffer object's data store with a fixed value
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the operation. target must be one of the global buffer binding targets.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The internal format with which the data will be stored in the buffer object.
        /// </para>
        /// </param>
        /// <param name="offset">
        /// <para>
        /// The offset, in basic machine units into the buffer object's data store at which to start filling.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// The size, in basic machine units of the range of the data store to fill.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the data in memory addressed by data.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the data in memory addressed by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// The address of a memory location storing the data to be replicated into the buffer's data store.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_clear_buffer_object|VERSION_4_3", Version = "4.3", EntryPoint = "glClearBufferSubData")]
        public static extern void ClearBufferSubData<T6>(OpenTK.Graphics.OpenGL.BufferTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, IntPtr offset, IntPtr size, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.All type, [InAttribute, OutAttribute] ref T6 data)
            where T6 : struct
        ;

        /// <summary>[requires: v3.0]
        /// Clear individual buffers of the currently bound draw framebuffer
        /// </summary>
        /// <param name="buffer">
        /// <para>
        /// Specify the buffer to clear.
        /// </para>
        /// </param>
        /// <param name="drawBuffer">
        /// <para>
        /// Specify a particular draw buffer to clear.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For color buffers, a pointer to a four-element vector specifying R, G, B and A values to clear the buffer to. For depth buffers, a pointer to a single depth value to clear the buffer to. For stencil buffers, a pointer to a single stencil value to clear the buffer to.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// The value to clear a depth render buffer to.
        /// </para>
        /// </param>
        /// <param name="stencil">
        /// <para>
        /// The value to clear a stencil render buffer to.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glClearBufferuiv")]
        public static extern void ClearBuffer(OpenTK.Graphics.OpenGL.ClearBuffer buffer, Int32 drawbuffer, UInt32[] value);

        /// <summary>[requires: v3.0]
        /// Clear individual buffers of the currently bound draw framebuffer
        /// </summary>
        /// <param name="buffer">
        /// <para>
        /// Specify the buffer to clear.
        /// </para>
        /// </param>
        /// <param name="drawBuffer">
        /// <para>
        /// Specify a particular draw buffer to clear.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For color buffers, a pointer to a four-element vector specifying R, G, B and A values to clear the buffer to. For depth buffers, a pointer to a single depth value to clear the buffer to. For stencil buffers, a pointer to a single stencil value to clear the buffer to.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// The value to clear a depth render buffer to.
        /// </para>
        /// </param>
        /// <param name="stencil">
        /// <para>
        /// The value to clear a stencil render buffer to.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glClearBufferuiv")]
        public static extern void ClearBuffer(OpenTK.Graphics.OpenGL.ClearBuffer buffer, Int32 drawbuffer, ref UInt32 value);

        /// <summary>[requires: v3.0]
        /// Clear individual buffers of the currently bound draw framebuffer
        /// </summary>
        /// <param name="buffer">
        /// <para>
        /// Specify the buffer to clear.
        /// </para>
        /// </param>
        /// <param name="drawBuffer">
        /// <para>
        /// Specify a particular draw buffer to clear.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For color buffers, a pointer to a four-element vector specifying R, G, B and A values to clear the buffer to. For depth buffers, a pointer to a single depth value to clear the buffer to. For stencil buffers, a pointer to a single stencil value to clear the buffer to.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// The value to clear a depth render buffer to.
        /// </para>
        /// </param>
        /// <param name="stencil">
        /// <para>
        /// The value to clear a stencil render buffer to.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glClearBufferuiv")]
        public static extern unsafe void ClearBuffer(OpenTK.Graphics.OpenGL.ClearBuffer buffer, Int32 drawbuffer, UInt32* value);

        /// <summary>[requires: v1.0]
        /// Specify clear values for the color buffers
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify the red, green, blue, and alpha values used when the color buffers are cleared. The initial values are all 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glClearColor")]
        public static extern void ClearColor(Single red, Single green, Single blue, Single alpha);

        /// <summary>[requires: v1.0]
        /// Specify the clear value for the depth buffer
        /// </summary>
        /// <param name="depth">
        /// <para>
        /// Specifies the depth value used when the depth buffer is cleared. The initial value is 1.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glClearDepth")]
        public static extern void ClearDepth(Double depth);

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Specify the clear value for the depth buffer
        /// </summary>
        /// <param name="depth">
        /// <para>
        /// Specifies the depth value used when the depth buffer is cleared. The initial value is 1.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glClearDepthf")]
        public static extern void ClearDepth(Single d);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the clear value for the color index buffers
        /// </summary>
        /// <param name="c">
        /// <para>
        /// Specifies the index used when the color index buffers are cleared. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glClearIndex")]
        public static extern void ClearIndex(Single c);

        /// <summary>[requires: v1.0]
        /// Specify the clear value for the stencil buffer
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specifies the index used when the stencil buffer is cleared. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glClearStencil")]
        public static extern void ClearStencil(Int32 s);

        /// <summary>[requires: v4.4 and ARB_clear_texture|VERSION_4_4]
        /// Fills all a texture image with a constant value
        /// </summary>
        /// <param name="texture">
        /// <para>
        /// The name of an existing texture object containing the image to be cleared.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// The level of texture containing the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// The address in memory of the data to be used to clear the specified region.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_clear_texture|VERSION_4_4", Version = "4.4", EntryPoint = "glClearTexImage")]
        public static extern void ClearTexImage(Int32 texture, Int32 level, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr data);

        /// <summary>[requires: v4.4 and ARB_clear_texture|VERSION_4_4]
        /// Fills all a texture image with a constant value
        /// </summary>
        /// <param name="texture">
        /// <para>
        /// The name of an existing texture object containing the image to be cleared.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// The level of texture containing the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// The address in memory of the data to be used to clear the specified region.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_clear_texture|VERSION_4_4", Version = "4.4", EntryPoint = "glClearTexImage")]
        public static extern void ClearTexImage<T4>(Int32 texture, Int32 level, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T4[] data)
            where T4 : struct
        ;

        /// <summary>[requires: v4.4 and ARB_clear_texture|VERSION_4_4]
        /// Fills all a texture image with a constant value
        /// </summary>
        /// <param name="texture">
        /// <para>
        /// The name of an existing texture object containing the image to be cleared.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// The level of texture containing the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// The address in memory of the data to be used to clear the specified region.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_clear_texture|VERSION_4_4", Version = "4.4", EntryPoint = "glClearTexImage")]
        public static extern void ClearTexImage<T4>(Int32 texture, Int32 level, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T4[,] data)
            where T4 : struct
        ;

        /// <summary>[requires: v4.4 and ARB_clear_texture|VERSION_4_4]
        /// Fills all a texture image with a constant value
        /// </summary>
        /// <param name="texture">
        /// <para>
        /// The name of an existing texture object containing the image to be cleared.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// The level of texture containing the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// The address in memory of the data to be used to clear the specified region.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_clear_texture|VERSION_4_4", Version = "4.4", EntryPoint = "glClearTexImage")]
        public static extern void ClearTexImage<T4>(Int32 texture, Int32 level, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T4[,,] data)
            where T4 : struct
        ;

        /// <summary>[requires: v4.4 and ARB_clear_texture|VERSION_4_4]
        /// Fills all a texture image with a constant value
        /// </summary>
        /// <param name="texture">
        /// <para>
        /// The name of an existing texture object containing the image to be cleared.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// The level of texture containing the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// The address in memory of the data to be used to clear the specified region.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_clear_texture|VERSION_4_4", Version = "4.4", EntryPoint = "glClearTexImage")]
        public static extern void ClearTexImage<T4>(Int32 texture, Int32 level, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T4 data)
            where T4 : struct
        ;

        /// <summary>[requires: v4.4 and ARB_clear_texture|VERSION_4_4]
        /// Fills all a texture image with a constant value
        /// </summary>
        /// <param name="texture">
        /// <para>
        /// The name of an existing texture object containing the image to be cleared.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// The level of texture containing the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// The address in memory of the data to be used to clear the specified region.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_clear_texture|VERSION_4_4", Version = "4.4", EntryPoint = "glClearTexImage")]
        public static extern void ClearTexImage(UInt32 texture, Int32 level, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr data);

        /// <summary>[requires: v4.4 and ARB_clear_texture|VERSION_4_4]
        /// Fills all a texture image with a constant value
        /// </summary>
        /// <param name="texture">
        /// <para>
        /// The name of an existing texture object containing the image to be cleared.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// The level of texture containing the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// The address in memory of the data to be used to clear the specified region.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_clear_texture|VERSION_4_4", Version = "4.4", EntryPoint = "glClearTexImage")]
        public static extern void ClearTexImage<T4>(UInt32 texture, Int32 level, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T4[] data)
            where T4 : struct
        ;

        /// <summary>[requires: v4.4 and ARB_clear_texture|VERSION_4_4]
        /// Fills all a texture image with a constant value
        /// </summary>
        /// <param name="texture">
        /// <para>
        /// The name of an existing texture object containing the image to be cleared.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// The level of texture containing the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// The address in memory of the data to be used to clear the specified region.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_clear_texture|VERSION_4_4", Version = "4.4", EntryPoint = "glClearTexImage")]
        public static extern void ClearTexImage<T4>(UInt32 texture, Int32 level, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T4[,] data)
            where T4 : struct
        ;

        /// <summary>[requires: v4.4 and ARB_clear_texture|VERSION_4_4]
        /// Fills all a texture image with a constant value
        /// </summary>
        /// <param name="texture">
        /// <para>
        /// The name of an existing texture object containing the image to be cleared.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// The level of texture containing the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// The address in memory of the data to be used to clear the specified region.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_clear_texture|VERSION_4_4", Version = "4.4", EntryPoint = "glClearTexImage")]
        public static extern void ClearTexImage<T4>(UInt32 texture, Int32 level, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T4[,,] data)
            where T4 : struct
        ;

        /// <summary>[requires: v4.4 and ARB_clear_texture|VERSION_4_4]
        /// Fills all a texture image with a constant value
        /// </summary>
        /// <param name="texture">
        /// <para>
        /// The name of an existing texture object containing the image to be cleared.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// The level of texture containing the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// The address in memory of the data to be used to clear the specified region.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_clear_texture|VERSION_4_4", Version = "4.4", EntryPoint = "glClearTexImage")]
        public static extern void ClearTexImage<T4>(UInt32 texture, Int32 level, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T4 data)
            where T4 : struct
        ;

        /// <summary>[requires: v4.4 and ARB_clear_texture|VERSION_4_4]
        /// Fills all or part of a texture image with a constant value
        /// </summary>
        /// <param name="texture">
        /// <para>
        /// The name of an existing texture object containing the image to be cleared.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// The level of texture containing the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// The coordinate of the left edge of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="yoffset">
        /// <para>
        /// The coordinate of the lower edge of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="zoffset">
        /// <para>
        /// The coordinate of the front of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The width of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// The height of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// The depth of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// The address in memory of the data to be used to clear the specified region.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_clear_texture|VERSION_4_4", Version = "4.4", EntryPoint = "glClearTexSubImage")]
        public static extern void ClearTexSubImage(Int32 texture, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr data);

        /// <summary>[requires: v4.4 and ARB_clear_texture|VERSION_4_4]
        /// Fills all or part of a texture image with a constant value
        /// </summary>
        /// <param name="texture">
        /// <para>
        /// The name of an existing texture object containing the image to be cleared.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// The level of texture containing the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// The coordinate of the left edge of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="yoffset">
        /// <para>
        /// The coordinate of the lower edge of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="zoffset">
        /// <para>
        /// The coordinate of the front of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The width of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// The height of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// The depth of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// The address in memory of the data to be used to clear the specified region.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_clear_texture|VERSION_4_4", Version = "4.4", EntryPoint = "glClearTexSubImage")]
        public static extern void ClearTexSubImage<T10>(Int32 texture, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T10[] data)
            where T10 : struct
        ;

        /// <summary>[requires: v4.4 and ARB_clear_texture|VERSION_4_4]
        /// Fills all or part of a texture image with a constant value
        /// </summary>
        /// <param name="texture">
        /// <para>
        /// The name of an existing texture object containing the image to be cleared.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// The level of texture containing the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// The coordinate of the left edge of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="yoffset">
        /// <para>
        /// The coordinate of the lower edge of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="zoffset">
        /// <para>
        /// The coordinate of the front of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The width of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// The height of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// The depth of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// The address in memory of the data to be used to clear the specified region.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_clear_texture|VERSION_4_4", Version = "4.4", EntryPoint = "glClearTexSubImage")]
        public static extern void ClearTexSubImage<T10>(Int32 texture, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T10[,] data)
            where T10 : struct
        ;

        /// <summary>[requires: v4.4 and ARB_clear_texture|VERSION_4_4]
        /// Fills all or part of a texture image with a constant value
        /// </summary>
        /// <param name="texture">
        /// <para>
        /// The name of an existing texture object containing the image to be cleared.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// The level of texture containing the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// The coordinate of the left edge of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="yoffset">
        /// <para>
        /// The coordinate of the lower edge of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="zoffset">
        /// <para>
        /// The coordinate of the front of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The width of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// The height of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// The depth of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// The address in memory of the data to be used to clear the specified region.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_clear_texture|VERSION_4_4", Version = "4.4", EntryPoint = "glClearTexSubImage")]
        public static extern void ClearTexSubImage<T10>(Int32 texture, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T10[,,] data)
            where T10 : struct
        ;

        /// <summary>[requires: v4.4 and ARB_clear_texture|VERSION_4_4]
        /// Fills all or part of a texture image with a constant value
        /// </summary>
        /// <param name="texture">
        /// <para>
        /// The name of an existing texture object containing the image to be cleared.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// The level of texture containing the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// The coordinate of the left edge of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="yoffset">
        /// <para>
        /// The coordinate of the lower edge of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="zoffset">
        /// <para>
        /// The coordinate of the front of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The width of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// The height of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// The depth of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// The address in memory of the data to be used to clear the specified region.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_clear_texture|VERSION_4_4", Version = "4.4", EntryPoint = "glClearTexSubImage")]
        public static extern void ClearTexSubImage<T10>(Int32 texture, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T10 data)
            where T10 : struct
        ;

        /// <summary>[requires: v4.4 and ARB_clear_texture|VERSION_4_4]
        /// Fills all or part of a texture image with a constant value
        /// </summary>
        /// <param name="texture">
        /// <para>
        /// The name of an existing texture object containing the image to be cleared.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// The level of texture containing the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// The coordinate of the left edge of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="yoffset">
        /// <para>
        /// The coordinate of the lower edge of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="zoffset">
        /// <para>
        /// The coordinate of the front of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The width of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// The height of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// The depth of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// The address in memory of the data to be used to clear the specified region.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_clear_texture|VERSION_4_4", Version = "4.4", EntryPoint = "glClearTexSubImage")]
        public static extern void ClearTexSubImage(UInt32 texture, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr data);

        /// <summary>[requires: v4.4 and ARB_clear_texture|VERSION_4_4]
        /// Fills all or part of a texture image with a constant value
        /// </summary>
        /// <param name="texture">
        /// <para>
        /// The name of an existing texture object containing the image to be cleared.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// The level of texture containing the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// The coordinate of the left edge of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="yoffset">
        /// <para>
        /// The coordinate of the lower edge of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="zoffset">
        /// <para>
        /// The coordinate of the front of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The width of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// The height of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// The depth of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// The address in memory of the data to be used to clear the specified region.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_clear_texture|VERSION_4_4", Version = "4.4", EntryPoint = "glClearTexSubImage")]
        public static extern void ClearTexSubImage<T10>(UInt32 texture, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T10[] data)
            where T10 : struct
        ;

        /// <summary>[requires: v4.4 and ARB_clear_texture|VERSION_4_4]
        /// Fills all or part of a texture image with a constant value
        /// </summary>
        /// <param name="texture">
        /// <para>
        /// The name of an existing texture object containing the image to be cleared.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// The level of texture containing the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// The coordinate of the left edge of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="yoffset">
        /// <para>
        /// The coordinate of the lower edge of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="zoffset">
        /// <para>
        /// The coordinate of the front of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The width of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// The height of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// The depth of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// The address in memory of the data to be used to clear the specified region.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_clear_texture|VERSION_4_4", Version = "4.4", EntryPoint = "glClearTexSubImage")]
        public static extern void ClearTexSubImage<T10>(UInt32 texture, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T10[,] data)
            where T10 : struct
        ;

        /// <summary>[requires: v4.4 and ARB_clear_texture|VERSION_4_4]
        /// Fills all or part of a texture image with a constant value
        /// </summary>
        /// <param name="texture">
        /// <para>
        /// The name of an existing texture object containing the image to be cleared.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// The level of texture containing the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// The coordinate of the left edge of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="yoffset">
        /// <para>
        /// The coordinate of the lower edge of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="zoffset">
        /// <para>
        /// The coordinate of the front of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The width of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// The height of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// The depth of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// The address in memory of the data to be used to clear the specified region.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_clear_texture|VERSION_4_4", Version = "4.4", EntryPoint = "glClearTexSubImage")]
        public static extern void ClearTexSubImage<T10>(UInt32 texture, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T10[,,] data)
            where T10 : struct
        ;

        /// <summary>[requires: v4.4 and ARB_clear_texture|VERSION_4_4]
        /// Fills all or part of a texture image with a constant value
        /// </summary>
        /// <param name="texture">
        /// <para>
        /// The name of an existing texture object containing the image to be cleared.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// The level of texture containing the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// The coordinate of the left edge of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="yoffset">
        /// <para>
        /// The coordinate of the lower edge of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="zoffset">
        /// <para>
        /// The coordinate of the front of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The width of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// The height of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// The depth of the region to be cleared.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the data whose address in memory is given by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// The address in memory of the data to be used to clear the specified region.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_clear_texture|VERSION_4_4", Version = "4.4", EntryPoint = "glClearTexSubImage")]
        public static extern void ClearTexSubImage<T10>(UInt32 texture, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T10 data)
            where T10 : struct
        ;

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Select active texture unit
        /// </summary>
        /// <param name="texture">
        /// <para>
        /// Specifies which texture unit to make active. The number of texture units is implementation dependent, but must be at least two. texture must be one of GL_TEXTURE, where i ranges from 0 to the value of GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value. The initial value is GL_TEXTURE0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glClientActiveTexture")]
        public static extern void ClientActiveTexture(OpenTK.Graphics.OpenGL.TextureUnit texture);

        /// <summary>[requires: v3.2 and ARB_sync|VERSION_3_2]
        /// Block and wait for a sync object to become signaled
        /// </summary>
        /// <param name="sync">
        /// <para>
        /// The sync object whose status to wait on.
        /// </para>
        /// </param>
        /// <param name="flags">
        /// <para>
        /// A bitfield controlling the command flushing behavior. flags may be GL_SYNC_FLUSH_COMMANDS_BIT.
        /// </para>
        /// </param>
        /// <param name="timeout">
        /// <para>
        /// The timeout, specified in nanoseconds, for which the implementation should wait for sync to become signaled.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_sync|VERSION_3_2", Version = "3.2", EntryPoint = "glClientWaitSync")]
        public static extern OpenTK.Graphics.OpenGL.WaitSyncStatus ClientWaitSync(IntPtr sync, OpenTK.Graphics.OpenGL.ClientWaitSyncFlags flags, Int64 timeout);

        /// <summary>[requires: v3.2 and ARB_sync|VERSION_3_2]
        /// Block and wait for a sync object to become signaled
        /// </summary>
        /// <param name="sync">
        /// <para>
        /// The sync object whose status to wait on.
        /// </para>
        /// </param>
        /// <param name="flags">
        /// <para>
        /// A bitfield controlling the command flushing behavior. flags may be GL_SYNC_FLUSH_COMMANDS_BIT.
        /// </para>
        /// </param>
        /// <param name="timeout">
        /// <para>
        /// The timeout, specified in nanoseconds, for which the implementation should wait for sync to become signaled.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sync|VERSION_3_2", Version = "3.2", EntryPoint = "glClientWaitSync")]
        public static extern OpenTK.Graphics.OpenGL.WaitSyncStatus ClientWaitSync(IntPtr sync, OpenTK.Graphics.OpenGL.ClientWaitSyncFlags flags, UInt64 timeout);

        /// <summary>[requires: v3.2 and ARB_sync|VERSION_3_2]
        /// Block and wait for a sync object to become signaled
        /// </summary>
        /// <param name="sync">
        /// <para>
        /// The sync object whose status to wait on.
        /// </para>
        /// </param>
        /// <param name="flags">
        /// <para>
        /// A bitfield controlling the command flushing behavior. flags may be GL_SYNC_FLUSH_COMMANDS_BIT.
        /// </para>
        /// </param>
        /// <param name="timeout">
        /// <para>
        /// The timeout, specified in nanoseconds, for which the implementation should wait for sync to become signaled.
        /// </para>
        /// </param>
        [Obsolete("Use ClientWaitSyncFlags overload instead")]
        [AutoGenerated(Category = "ARB_sync|VERSION_3_2", Version = "3.2", EntryPoint = "glClientWaitSync")]
        public static extern OpenTK.Graphics.OpenGL.WaitSyncStatus ClientWaitSync(IntPtr sync, Int32 flags, Int64 timeout);

        /// <summary>[requires: v3.2 and ARB_sync|VERSION_3_2]
        /// Block and wait for a sync object to become signaled
        /// </summary>
        /// <param name="sync">
        /// <para>
        /// The sync object whose status to wait on.
        /// </para>
        /// </param>
        /// <param name="flags">
        /// <para>
        /// A bitfield controlling the command flushing behavior. flags may be GL_SYNC_FLUSH_COMMANDS_BIT.
        /// </para>
        /// </param>
        /// <param name="timeout">
        /// <para>
        /// The timeout, specified in nanoseconds, for which the implementation should wait for sync to become signaled.
        /// </para>
        /// </param>
        [Obsolete("Use ClientWaitSyncFlags overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sync|VERSION_3_2", Version = "3.2", EntryPoint = "glClientWaitSync")]
        public static extern OpenTK.Graphics.OpenGL.WaitSyncStatus ClientWaitSync(IntPtr sync, Int32 flags, UInt64 timeout);

        /// <summary>[requires: v3.2 and ARB_sync|VERSION_3_2]
        /// Block and wait for a sync object to become signaled
        /// </summary>
        /// <param name="sync">
        /// <para>
        /// The sync object whose status to wait on.
        /// </para>
        /// </param>
        /// <param name="flags">
        /// <para>
        /// A bitfield controlling the command flushing behavior. flags may be GL_SYNC_FLUSH_COMMANDS_BIT.
        /// </para>
        /// </param>
        /// <param name="timeout">
        /// <para>
        /// The timeout, specified in nanoseconds, for which the implementation should wait for sync to become signaled.
        /// </para>
        /// </param>
        [Obsolete("Use ClientWaitSyncFlags overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sync|VERSION_3_2", Version = "3.2", EntryPoint = "glClientWaitSync")]
        public static extern OpenTK.Graphics.OpenGL.WaitSyncStatus ClientWaitSync(IntPtr sync, UInt32 flags, UInt64 timeout);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a plane against which all geometry is clipped
        /// </summary>
        /// <param name="plane">
        /// <para>
        /// Specifies which clipping plane is being positioned. Symbolic names of the form GL_CLIP_PLANEi, where i is an integer between 0 and GL_MAX_CLIP_PLANES - 1, are accepted.
        /// </para>
        /// </param>
        /// <param name="equation">
        /// <para>
        /// Specifies the address of an array of four double-precision floating-point values. These values are interpreted as a plane equation.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glClipPlane")]
        public static extern void ClipPlane(OpenTK.Graphics.OpenGL.ClipPlaneName plane, Double[] equation);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a plane against which all geometry is clipped
        /// </summary>
        /// <param name="plane">
        /// <para>
        /// Specifies which clipping plane is being positioned. Symbolic names of the form GL_CLIP_PLANEi, where i is an integer between 0 and GL_MAX_CLIP_PLANES - 1, are accepted.
        /// </para>
        /// </param>
        /// <param name="equation">
        /// <para>
        /// Specifies the address of an array of four double-precision floating-point values. These values are interpreted as a plane equation.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glClipPlane")]
        public static extern void ClipPlane(OpenTK.Graphics.OpenGL.ClipPlaneName plane, ref Double equation);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a plane against which all geometry is clipped
        /// </summary>
        /// <param name="plane">
        /// <para>
        /// Specifies which clipping plane is being positioned. Symbolic names of the form GL_CLIP_PLANEi, where i is an integer between 0 and GL_MAX_CLIP_PLANES - 1, are accepted.
        /// </para>
        /// </param>
        /// <param name="equation">
        /// <para>
        /// Specifies the address of an array of four double-precision floating-point values. These values are interpreted as a plane equation.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glClipPlane")]
        public static extern unsafe void ClipPlane(OpenTK.Graphics.OpenGL.ClipPlaneName plane, Double* equation);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor3b")]
        public static extern void Color3(SByte red, SByte green, SByte blue);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor3bv")]
        public static extern void Color3(SByte[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor3bv")]
        public static extern void Color3(ref SByte v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor3bv")]
        public static extern unsafe void Color3(SByte* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor3d")]
        public static extern void Color3(Double red, Double green, Double blue);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor3dv")]
        public static extern void Color3(Double[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor3dv")]
        public static extern void Color3(ref Double v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor3dv")]
        public static extern unsafe void Color3(Double* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor3f")]
        public static extern void Color3(Single red, Single green, Single blue);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor3fv")]
        public static extern void Color3(Single[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor3fv")]
        public static extern void Color3(ref Single v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor3fv")]
        public static extern unsafe void Color3(Single* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor3i")]
        public static extern void Color3(Int32 red, Int32 green, Int32 blue);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor3iv")]
        public static extern void Color3(Int32[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor3iv")]
        public static extern void Color3(ref Int32 v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor3iv")]
        public static extern unsafe void Color3(Int32* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor3s")]
        public static extern void Color3(Int16 red, Int16 green, Int16 blue);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor3sv")]
        public static extern void Color3(Int16[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor3sv")]
        public static extern void Color3(ref Int16 v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor3sv")]
        public static extern unsafe void Color3(Int16* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor3ub")]
        public static extern void Color3(Byte red, Byte green, Byte blue);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor3ubv")]
        public static extern void Color3(Byte[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor3ubv")]
        public static extern void Color3(ref Byte v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor3ubv")]
        public static extern unsafe void Color3(Byte* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor3ui")]
        public static extern void Color3(UInt32 red, UInt32 green, UInt32 blue);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor3uiv")]
        public static extern void Color3(UInt32[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor3uiv")]
        public static extern void Color3(ref UInt32 v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor3uiv")]
        public static extern unsafe void Color3(UInt32* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor3us")]
        public static extern void Color3(UInt16 red, UInt16 green, UInt16 blue);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor3usv")]
        public static extern void Color3(UInt16[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor3usv")]
        public static extern void Color3(ref UInt16 v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor3usv")]
        public static extern unsafe void Color3(UInt16* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor4b")]
        public static extern void Color4(SByte red, SByte green, SByte blue, SByte alpha);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor4bv")]
        public static extern void Color4(SByte[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor4bv")]
        public static extern void Color4(ref SByte v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor4bv")]
        public static extern unsafe void Color4(SByte* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor4d")]
        public static extern void Color4(Double red, Double green, Double blue, Double alpha);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor4dv")]
        public static extern void Color4(Double[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor4dv")]
        public static extern void Color4(ref Double v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor4dv")]
        public static extern unsafe void Color4(Double* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor4f")]
        public static extern void Color4(Single red, Single green, Single blue, Single alpha);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor4fv")]
        public static extern void Color4(Single[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor4fv")]
        public static extern void Color4(ref Single v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor4fv")]
        public static extern unsafe void Color4(Single* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor4i")]
        public static extern void Color4(Int32 red, Int32 green, Int32 blue, Int32 alpha);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor4iv")]
        public static extern void Color4(Int32[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor4iv")]
        public static extern void Color4(ref Int32 v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor4iv")]
        public static extern unsafe void Color4(Int32* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor4s")]
        public static extern void Color4(Int16 red, Int16 green, Int16 blue, Int16 alpha);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor4sv")]
        public static extern void Color4(Int16[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor4sv")]
        public static extern void Color4(ref Int16 v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor4sv")]
        public static extern unsafe void Color4(Int16* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor4ub")]
        public static extern void Color4(Byte red, Byte green, Byte blue, Byte alpha);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor4ubv")]
        public static extern void Color4(Byte[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor4ubv")]
        public static extern void Color4(ref Byte v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor4ubv")]
        public static extern unsafe void Color4(Byte* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor4ui")]
        public static extern void Color4(UInt32 red, UInt32 green, UInt32 blue, UInt32 alpha);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor4uiv")]
        public static extern void Color4(UInt32[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor4uiv")]
        public static extern void Color4(ref UInt32 v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor4uiv")]
        public static extern unsafe void Color4(UInt32* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor4us")]
        public static extern void Color4(UInt16 red, UInt16 green, UInt16 blue, UInt16 alpha);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor4usv")]
        public static extern void Color4(UInt16[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor4usv")]
        public static extern void Color4(ref UInt16 v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current color.
        /// </para>
        /// </param>
        /// <param name="alpha">
        /// <para>
        /// Specifies a new alpha value for the current color. Included only in the four-argument glColor4 commands.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColor4usv")]
        public static extern unsafe void Color4(UInt16* v);

        /// <summary>[requires: v1.0]
        /// Enable and disable writing of frame buffer color components
        /// </summary>
        /// <param name="buf">
        /// <para>
        /// For glColorMaski, specifies the index of the draw buffer whose color mask to set.
        /// </para>
        /// </param>
        /// <param name="red">
        /// <para>
        /// Specify whether red, green, blue, and alpha are to be written into the frame buffer. The initial values are all GL_TRUE, indicating that the color components are written.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColorMask")]
        public static extern void ColorMask(bool red, bool green, bool blue, bool alpha);

        /// <summary>[requires: v3.0]
        /// Enable and disable writing of frame buffer color components
        /// </summary>
        /// <param name="buf">
        /// <para>
        /// For glColorMaski, specifies the index of the draw buffer whose color mask to set.
        /// </para>
        /// </param>
        /// <param name="red">
        /// <para>
        /// Specify whether red, green, blue, and alpha are to be written into the frame buffer. The initial values are all GL_TRUE, indicating that the color components are written.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glColorMaski")]
        public static extern void ColorMask(Int32 index, bool r, bool g, bool b, bool a);

        /// <summary>[requires: v3.0]
        /// Enable and disable writing of frame buffer color components
        /// </summary>
        /// <param name="buf">
        /// <para>
        /// For glColorMaski, specifies the index of the draw buffer whose color mask to set.
        /// </para>
        /// </param>
        /// <param name="red">
        /// <para>
        /// Specify whether red, green, blue, and alpha are to be written into the frame buffer. The initial values are all GL_TRUE, indicating that the color components are written.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glColorMaski")]
        public static extern void ColorMask(UInt32 index, bool r, bool g, bool b, bool a);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Cause a material color to track the current color
        /// </summary>
        /// <param name="face">
        /// <para>
        /// Specifies whether front, back, or both front and back material parameters should track the current color. Accepted values are GL_FRONT, GL_BACK, and GL_FRONT_AND_BACK. The initial value is GL_FRONT_AND_BACK.
        /// </para>
        /// </param>
        /// <param name="mode">
        /// <para>
        /// Specifies which of several material parameters track the current color. Accepted values are GL_EMISSION, GL_AMBIENT, GL_DIFFUSE, GL_SPECULAR, and GL_AMBIENT_AND_DIFFUSE. The initial value is GL_AMBIENT_AND_DIFFUSE.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glColorMaterial")]
        public static extern void ColorMaterial(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.ColorMaterialParameter mode);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glColorP3ui")]
        public static extern void ColorP3(OpenTK.Graphics.OpenGL.PackedPointerType type, Int32 color);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glColorP3ui")]
        public static extern void ColorP3(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32 color);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glColorP3uiv")]
        public static extern unsafe void ColorP3(OpenTK.Graphics.OpenGL.PackedPointerType type, Int32* color);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glColorP3uiv")]
        public static extern unsafe void ColorP3(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32* color);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glColorP4ui")]
        public static extern void ColorP4(OpenTK.Graphics.OpenGL.PackedPointerType type, Int32 color);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glColorP4ui")]
        public static extern void ColorP4(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32 color);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glColorP4uiv")]
        public static extern unsafe void ColorP4(OpenTK.Graphics.OpenGL.PackedPointerType type, Int32* color);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glColorP4uiv")]
        public static extern unsafe void ColorP4(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32* color);

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Define an array of colors
        /// </summary>
        /// <param name="size">
        /// <para>
        /// Specifies the number of components per color. Must be 3 or 4. The initial value is 4.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each color component in the array. Symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, GL_UNSIGNED_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive colors. If stride is 0, the colors are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first component of the first color element in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glColorPointer")]
        public static extern void ColorPointer(Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, IntPtr pointer);

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Define an array of colors
        /// </summary>
        /// <param name="size">
        /// <para>
        /// Specifies the number of components per color. Must be 3 or 4. The initial value is 4.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each color component in the array. Symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, GL_UNSIGNED_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive colors. If stride is 0, the colors are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first component of the first color element in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glColorPointer")]
        public static extern void ColorPointer<T3>(Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, [InAttribute, OutAttribute] T3[] pointer)
            where T3 : struct
        ;

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Define an array of colors
        /// </summary>
        /// <param name="size">
        /// <para>
        /// Specifies the number of components per color. Must be 3 or 4. The initial value is 4.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each color component in the array. Symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, GL_UNSIGNED_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive colors. If stride is 0, the colors are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first component of the first color element in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glColorPointer")]
        public static extern void ColorPointer<T3>(Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, [InAttribute, OutAttribute] T3[,] pointer)
            where T3 : struct
        ;

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Define an array of colors
        /// </summary>
        /// <param name="size">
        /// <para>
        /// Specifies the number of components per color. Must be 3 or 4. The initial value is 4.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each color component in the array. Symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, GL_UNSIGNED_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive colors. If stride is 0, the colors are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first component of the first color element in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glColorPointer")]
        public static extern void ColorPointer<T3>(Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, [InAttribute, OutAttribute] T3[,,] pointer)
            where T3 : struct
        ;

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Define an array of colors
        /// </summary>
        /// <param name="size">
        /// <para>
        /// Specifies the number of components per color. Must be 3 or 4. The initial value is 4.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each color component in the array. Symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, GL_UNSIGNED_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive colors. If stride is 0, the colors are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first component of the first color element in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glColorPointer")]
        public static extern void ColorPointer<T3>(Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, [InAttribute, OutAttribute] ref T3 pointer)
            where T3 : struct
        ;

        /// <summary>
        /// Respecify a portion of a color table
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be one of GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// The starting index of the portion of the color table to be replaced.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// The number of table entries to replace.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the pixel data in data. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the pixel data in data. The allowable values are GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Pointer to a one-dimensional array of pixel data that is processed to replace the specified region of the color table.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glColorSubTable")]
        public static extern void ColorSubTable(OpenTK.Graphics.OpenGL.ColorTableTarget target, Int32 start, Int32 count, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr data);

        /// <summary>
        /// Respecify a portion of a color table
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be one of GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// The starting index of the portion of the color table to be replaced.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// The number of table entries to replace.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the pixel data in data. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the pixel data in data. The allowable values are GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Pointer to a one-dimensional array of pixel data that is processed to replace the specified region of the color table.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glColorSubTable")]
        public static extern void ColorSubTable<T5>(OpenTK.Graphics.OpenGL.ColorTableTarget target, Int32 start, Int32 count, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T5[] data)
            where T5 : struct
        ;

        /// <summary>
        /// Respecify a portion of a color table
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be one of GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// The starting index of the portion of the color table to be replaced.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// The number of table entries to replace.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the pixel data in data. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the pixel data in data. The allowable values are GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Pointer to a one-dimensional array of pixel data that is processed to replace the specified region of the color table.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glColorSubTable")]
        public static extern void ColorSubTable<T5>(OpenTK.Graphics.OpenGL.ColorTableTarget target, Int32 start, Int32 count, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T5[,] data)
            where T5 : struct
        ;

        /// <summary>
        /// Respecify a portion of a color table
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be one of GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// The starting index of the portion of the color table to be replaced.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// The number of table entries to replace.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the pixel data in data. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the pixel data in data. The allowable values are GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Pointer to a one-dimensional array of pixel data that is processed to replace the specified region of the color table.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glColorSubTable")]
        public static extern void ColorSubTable<T5>(OpenTK.Graphics.OpenGL.ColorTableTarget target, Int32 start, Int32 count, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T5[,,] data)
            where T5 : struct
        ;

        /// <summary>
        /// Respecify a portion of a color table
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be one of GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// The starting index of the portion of the color table to be replaced.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// The number of table entries to replace.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the pixel data in data. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the pixel data in data. The allowable values are GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Pointer to a one-dimensional array of pixel data that is processed to replace the specified region of the color table.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glColorSubTable")]
        public static extern void ColorSubTable<T5>(OpenTK.Graphics.OpenGL.ColorTableTarget target, Int32 start, Int32 count, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T5 data)
            where T5 : struct
        ;

        /// <summary>
        /// Define a color lookup table
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be one of GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, GL_POST_COLOR_MATRIX_COLOR_TABLE, GL_PROXY_COLOR_TABLE, GL_PROXY_POST_CONVOLUTION_COLOR_TABLE, or GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The internal format of the color table. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, and GL_RGBA16.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The number of entries in the color lookup table specified by data.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the pixel data in data. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the pixel data in data. The allowable values are GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Pointer to a one-dimensional array of pixel data that is processed to build the color table.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glColorTable")]
        public static extern void ColorTable(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr table);

        /// <summary>
        /// Define a color lookup table
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be one of GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, GL_POST_COLOR_MATRIX_COLOR_TABLE, GL_PROXY_COLOR_TABLE, GL_PROXY_POST_CONVOLUTION_COLOR_TABLE, or GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The internal format of the color table. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, and GL_RGBA16.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The number of entries in the color lookup table specified by data.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the pixel data in data. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the pixel data in data. The allowable values are GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Pointer to a one-dimensional array of pixel data that is processed to build the color table.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glColorTable")]
        public static extern void ColorTable<T5>(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T5[] table)
            where T5 : struct
        ;

        /// <summary>
        /// Define a color lookup table
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be one of GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, GL_POST_COLOR_MATRIX_COLOR_TABLE, GL_PROXY_COLOR_TABLE, GL_PROXY_POST_CONVOLUTION_COLOR_TABLE, or GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The internal format of the color table. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, and GL_RGBA16.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The number of entries in the color lookup table specified by data.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the pixel data in data. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the pixel data in data. The allowable values are GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Pointer to a one-dimensional array of pixel data that is processed to build the color table.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glColorTable")]
        public static extern void ColorTable<T5>(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T5[,] table)
            where T5 : struct
        ;

        /// <summary>
        /// Define a color lookup table
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be one of GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, GL_POST_COLOR_MATRIX_COLOR_TABLE, GL_PROXY_COLOR_TABLE, GL_PROXY_POST_CONVOLUTION_COLOR_TABLE, or GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The internal format of the color table. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, and GL_RGBA16.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The number of entries in the color lookup table specified by data.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the pixel data in data. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the pixel data in data. The allowable values are GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Pointer to a one-dimensional array of pixel data that is processed to build the color table.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glColorTable")]
        public static extern void ColorTable<T5>(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T5[,,] table)
            where T5 : struct
        ;

        /// <summary>
        /// Define a color lookup table
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be one of GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, GL_POST_COLOR_MATRIX_COLOR_TABLE, GL_PROXY_COLOR_TABLE, GL_PROXY_POST_CONVOLUTION_COLOR_TABLE, or GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The internal format of the color table. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, and GL_RGBA16.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The number of entries in the color lookup table specified by data.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the pixel data in data. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the pixel data in data. The allowable values are GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Pointer to a one-dimensional array of pixel data that is processed to build the color table.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glColorTable")]
        public static extern void ColorTable<T5>(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T5 table)
            where T5 : struct
        ;

        /// <summary>
        /// Set color lookup table parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The target color table. Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The symbolic name of a texture color lookup table parameter. Must be one of GL_COLOR_TABLE_SCALE or GL_COLOR_TABLE_BIAS.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// A pointer to an array where the values of the parameters are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glColorTableParameterfv")]
        public static extern void ColorTableParameter(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.ColorTableParameterPName pname, Single[] @params);

        /// <summary>
        /// Set color lookup table parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The target color table. Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The symbolic name of a texture color lookup table parameter. Must be one of GL_COLOR_TABLE_SCALE or GL_COLOR_TABLE_BIAS.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// A pointer to an array where the values of the parameters are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glColorTableParameterfv")]
        public static extern void ColorTableParameter(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.ColorTableParameterPName pname, ref Single @params);

        /// <summary>
        /// Set color lookup table parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The target color table. Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The symbolic name of a texture color lookup table parameter. Must be one of GL_COLOR_TABLE_SCALE or GL_COLOR_TABLE_BIAS.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// A pointer to an array where the values of the parameters are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glColorTableParameterfv")]
        public static extern unsafe void ColorTableParameter(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.ColorTableParameterPName pname, Single* @params);

        /// <summary>
        /// Set color lookup table parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The target color table. Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The symbolic name of a texture color lookup table parameter. Must be one of GL_COLOR_TABLE_SCALE or GL_COLOR_TABLE_BIAS.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// A pointer to an array where the values of the parameters are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glColorTableParameteriv")]
        public static extern void ColorTableParameter(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.ColorTableParameterPName pname, Int32[] @params);

        /// <summary>
        /// Set color lookup table parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The target color table. Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The symbolic name of a texture color lookup table parameter. Must be one of GL_COLOR_TABLE_SCALE or GL_COLOR_TABLE_BIAS.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// A pointer to an array where the values of the parameters are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glColorTableParameteriv")]
        public static extern void ColorTableParameter(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.ColorTableParameterPName pname, ref Int32 @params);

        /// <summary>
        /// Set color lookup table parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The target color table. Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The symbolic name of a texture color lookup table parameter. Must be one of GL_COLOR_TABLE_SCALE or GL_COLOR_TABLE_BIAS.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// A pointer to an array where the values of the parameters are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glColorTableParameteriv")]
        public static extern unsafe void ColorTableParameter(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.ColorTableParameterPName pname, Int32* @params);

        /// <summary>[requires: v2.0]
        /// Compiles a shader object
        /// </summary>
        /// <param name="shader">
        /// <para>
        /// Specifies the shader object to be compiled.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glCompileShader")]
        public static extern void CompileShader(Int32 shader);

        /// <summary>[requires: v2.0]
        /// Compiles a shader object
        /// </summary>
        /// <param name="shader">
        /// <para>
        /// Specifies the shader object to be compiled.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glCompileShader")]
        public static extern void CompileShader(UInt32 shader);

        /// <summary>[requires: v1.3]
        /// Specify a one-dimensional texture image in a compressed format
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_1D or GL_PROXY_TEXTURE_1D.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// Specifies the format of the compressed image data stored at address data.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture image. All implementations support texture images that are at least 64 texels wide. The height of the 1D texture image is 1.
        /// </para>
        /// </param>
        /// <param name="border">
        /// <para>
        /// This value must be 0.
        /// </para>
        /// </param>
        /// <param name="imageSize">
        /// <para>
        /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the compressed image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glCompressedTexImage1D")]
        public static extern void CompressedTexImage1D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 border, Int32 imageSize, IntPtr data);

        /// <summary>[requires: v1.3]
        /// Specify a one-dimensional texture image in a compressed format
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_1D or GL_PROXY_TEXTURE_1D.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// Specifies the format of the compressed image data stored at address data.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture image. All implementations support texture images that are at least 64 texels wide. The height of the 1D texture image is 1.
        /// </para>
        /// </param>
        /// <param name="border">
        /// <para>
        /// This value must be 0.
        /// </para>
        /// </param>
        /// <param name="imageSize">
        /// <para>
        /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the compressed image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glCompressedTexImage1D")]
        public static extern void CompressedTexImage1D<T6>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T6[] data)
            where T6 : struct
        ;

        /// <summary>[requires: v1.3]
        /// Specify a one-dimensional texture image in a compressed format
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_1D or GL_PROXY_TEXTURE_1D.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// Specifies the format of the compressed image data stored at address data.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture image. All implementations support texture images that are at least 64 texels wide. The height of the 1D texture image is 1.
        /// </para>
        /// </param>
        /// <param name="border">
        /// <para>
        /// This value must be 0.
        /// </para>
        /// </param>
        /// <param name="imageSize">
        /// <para>
        /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the compressed image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glCompressedTexImage1D")]
        public static extern void CompressedTexImage1D<T6>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T6[,] data)
            where T6 : struct
        ;

        /// <summary>[requires: v1.3]
        /// Specify a one-dimensional texture image in a compressed format
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_1D or GL_PROXY_TEXTURE_1D.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// Specifies the format of the compressed image data stored at address data.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture image. All implementations support texture images that are at least 64 texels wide. The height of the 1D texture image is 1.
        /// </para>
        /// </param>
        /// <param name="border">
        /// <para>
        /// This value must be 0.
        /// </para>
        /// </param>
        /// <param name="imageSize">
        /// <para>
        /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the compressed image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glCompressedTexImage1D")]
        public static extern void CompressedTexImage1D<T6>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T6[,,] data)
            where T6 : struct
        ;

        /// <summary>[requires: v1.3]
        /// Specify a one-dimensional texture image in a compressed format
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_1D or GL_PROXY_TEXTURE_1D.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// Specifies the format of the compressed image data stored at address data.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture image. All implementations support texture images that are at least 64 texels wide. The height of the 1D texture image is 1.
        /// </para>
        /// </param>
        /// <param name="border">
        /// <para>
        /// This value must be 0.
        /// </para>
        /// </param>
        /// <param name="imageSize">
        /// <para>
        /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the compressed image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glCompressedTexImage1D")]
        public static extern void CompressedTexImage1D<T6>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] ref T6 data)
            where T6 : struct
        ;

        /// <summary>[requires: v1.3]
        /// Specify a two-dimensional texture image in a compressed format
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_PROXY_TEXTURE_2D, GL_TEXTURE_1D_ARRAY, GL_PROXY_TEXTURE_1D_ARRAY, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, or GL_PROXY_TEXTURE_CUBE_MAP.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// Specifies the format of the compressed image data stored at address data.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture image. All implementations support 2D texture and cube map texture images that are at least 16384 texels wide.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture image. All implementations support 2D texture and cube map texture images that are at least 16384 texels high.
        /// </para>
        /// </param>
        /// <param name="border">
        /// <para>
        /// This value must be 0.
        /// </para>
        /// </param>
        /// <param name="imageSize">
        /// <para>
        /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the compressed image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glCompressedTexImage2D")]
        public static extern void CompressedTexImage2D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 border, Int32 imageSize, IntPtr data);

        /// <summary>[requires: v1.3]
        /// Specify a two-dimensional texture image in a compressed format
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_PROXY_TEXTURE_2D, GL_TEXTURE_1D_ARRAY, GL_PROXY_TEXTURE_1D_ARRAY, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, or GL_PROXY_TEXTURE_CUBE_MAP.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// Specifies the format of the compressed image data stored at address data.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture image. All implementations support 2D texture and cube map texture images that are at least 16384 texels wide.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture image. All implementations support 2D texture and cube map texture images that are at least 16384 texels high.
        /// </para>
        /// </param>
        /// <param name="border">
        /// <para>
        /// This value must be 0.
        /// </para>
        /// </param>
        /// <param name="imageSize">
        /// <para>
        /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the compressed image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glCompressedTexImage2D")]
        public static extern void CompressedTexImage2D<T7>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T7[] data)
            where T7 : struct
        ;

        /// <summary>[requires: v1.3]
        /// Specify a two-dimensional texture image in a compressed format
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_PROXY_TEXTURE_2D, GL_TEXTURE_1D_ARRAY, GL_PROXY_TEXTURE_1D_ARRAY, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, or GL_PROXY_TEXTURE_CUBE_MAP.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// Specifies the format of the compressed image data stored at address data.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture image. All implementations support 2D texture and cube map texture images that are at least 16384 texels wide.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture image. All implementations support 2D texture and cube map texture images that are at least 16384 texels high.
        /// </para>
        /// </param>
        /// <param name="border">
        /// <para>
        /// This value must be 0.
        /// </para>
        /// </param>
        /// <param name="imageSize">
        /// <para>
        /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the compressed image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glCompressedTexImage2D")]
        public static extern void CompressedTexImage2D<T7>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T7[,] data)
            where T7 : struct
        ;

        /// <summary>[requires: v1.3]
        /// Specify a two-dimensional texture image in a compressed format
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_PROXY_TEXTURE_2D, GL_TEXTURE_1D_ARRAY, GL_PROXY_TEXTURE_1D_ARRAY, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, or GL_PROXY_TEXTURE_CUBE_MAP.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// Specifies the format of the compressed image data stored at address data.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture image. All implementations support 2D texture and cube map texture images that are at least 16384 texels wide.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture image. All implementations support 2D texture and cube map texture images that are at least 16384 texels high.
        /// </para>
        /// </param>
        /// <param name="border">
        /// <para>
        /// This value must be 0.
        /// </para>
        /// </param>
        /// <param name="imageSize">
        /// <para>
        /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the compressed image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glCompressedTexImage2D")]
        public static extern void CompressedTexImage2D<T7>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T7[,,] data)
            where T7 : struct
        ;

        /// <summary>[requires: v1.3]
        /// Specify a two-dimensional texture image in a compressed format
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_PROXY_TEXTURE_2D, GL_TEXTURE_1D_ARRAY, GL_PROXY_TEXTURE_1D_ARRAY, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, or GL_PROXY_TEXTURE_CUBE_MAP.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// Specifies the format of the compressed image data stored at address data.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture image. All implementations support 2D texture and cube map texture images that are at least 16384 texels wide.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture image. All implementations support 2D texture and cube map texture images that are at least 16384 texels high.
        /// </para>
        /// </param>
        /// <param name="border">
        /// <para>
        /// This value must be 0.
        /// </para>
        /// </param>
        /// <param name="imageSize">
        /// <para>
        /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the compressed image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glCompressedTexImage2D")]
        public static extern void CompressedTexImage2D<T7>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] ref T7 data)
            where T7 : struct
        ;

        /// <summary>[requires: v1.3]
        /// Specify a three-dimensional texture image in a compressed format
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_3D, GL_PROXY_TEXTURE_3D, GL_TEXTURE_2D_ARRAY or GL_PROXY_TEXTURE_2D_ARRAY.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// Specifies the format of the compressed image data stored at address data.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture image. All implementations support 3D texture images that are at least 16 texels wide.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture image. All implementations support 3D texture images that are at least 16 texels high.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// Specifies the depth of the texture image. All implementations support 3D texture images that are at least 16 texels deep.
        /// </para>
        /// </param>
        /// <param name="border">
        /// <para>
        /// This value must be 0.
        /// </para>
        /// </param>
        /// <param name="imageSize">
        /// <para>
        /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the compressed image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glCompressedTexImage3D")]
        public static extern void CompressedTexImage3D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, Int32 imageSize, IntPtr data);

        /// <summary>[requires: v1.3]
        /// Specify a three-dimensional texture image in a compressed format
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_3D, GL_PROXY_TEXTURE_3D, GL_TEXTURE_2D_ARRAY or GL_PROXY_TEXTURE_2D_ARRAY.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// Specifies the format of the compressed image data stored at address data.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture image. All implementations support 3D texture images that are at least 16 texels wide.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture image. All implementations support 3D texture images that are at least 16 texels high.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// Specifies the depth of the texture image. All implementations support 3D texture images that are at least 16 texels deep.
        /// </para>
        /// </param>
        /// <param name="border">
        /// <para>
        /// This value must be 0.
        /// </para>
        /// </param>
        /// <param name="imageSize">
        /// <para>
        /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the compressed image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glCompressedTexImage3D")]
        public static extern void CompressedTexImage3D<T8>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T8[] data)
            where T8 : struct
        ;

        /// <summary>[requires: v1.3]
        /// Specify a three-dimensional texture image in a compressed format
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_3D, GL_PROXY_TEXTURE_3D, GL_TEXTURE_2D_ARRAY or GL_PROXY_TEXTURE_2D_ARRAY.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// Specifies the format of the compressed image data stored at address data.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture image. All implementations support 3D texture images that are at least 16 texels wide.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture image. All implementations support 3D texture images that are at least 16 texels high.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// Specifies the depth of the texture image. All implementations support 3D texture images that are at least 16 texels deep.
        /// </para>
        /// </param>
        /// <param name="border">
        /// <para>
        /// This value must be 0.
        /// </para>
        /// </param>
        /// <param name="imageSize">
        /// <para>
        /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the compressed image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glCompressedTexImage3D")]
        public static extern void CompressedTexImage3D<T8>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T8[,] data)
            where T8 : struct
        ;

        /// <summary>[requires: v1.3]
        /// Specify a three-dimensional texture image in a compressed format
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_3D, GL_PROXY_TEXTURE_3D, GL_TEXTURE_2D_ARRAY or GL_PROXY_TEXTURE_2D_ARRAY.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// Specifies the format of the compressed image data stored at address data.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture image. All implementations support 3D texture images that are at least 16 texels wide.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture image. All implementations support 3D texture images that are at least 16 texels high.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// Specifies the depth of the texture image. All implementations support 3D texture images that are at least 16 texels deep.
        /// </para>
        /// </param>
        /// <param name="border">
        /// <para>
        /// This value must be 0.
        /// </para>
        /// </param>
        /// <param name="imageSize">
        /// <para>
        /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the compressed image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glCompressedTexImage3D")]
        public static extern void CompressedTexImage3D<T8>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T8[,,] data)
            where T8 : struct
        ;

        /// <summary>[requires: v1.3]
        /// Specify a three-dimensional texture image in a compressed format
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_3D, GL_PROXY_TEXTURE_3D, GL_TEXTURE_2D_ARRAY or GL_PROXY_TEXTURE_2D_ARRAY.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// Specifies the format of the compressed image data stored at address data.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture image. All implementations support 3D texture images that are at least 16 texels wide.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture image. All implementations support 3D texture images that are at least 16 texels high.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// Specifies the depth of the texture image. All implementations support 3D texture images that are at least 16 texels deep.
        /// </para>
        /// </param>
        /// <param name="border">
        /// <para>
        /// This value must be 0.
        /// </para>
        /// </param>
        /// <param name="imageSize">
        /// <para>
        /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the compressed image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glCompressedTexImage3D")]
        public static extern void CompressedTexImage3D<T8>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] ref T8 data)
            where T8 : struct
        ;

        /// <summary>[requires: v1.3]
        /// Specify a one-dimensional texture subimage in a compressed format
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_1D.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// Specifies a texel offset in the x direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the compressed image data stored at address data.
        /// </para>
        /// </param>
        /// <param name="imageSize">
        /// <para>
        /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the compressed image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glCompressedTexSubImage1D")]
        public static extern void CompressedTexSubImage1D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, IntPtr data);

        /// <summary>[requires: v1.3]
        /// Specify a one-dimensional texture subimage in a compressed format
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_1D.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// Specifies a texel offset in the x direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the compressed image data stored at address data.
        /// </para>
        /// </param>
        /// <param name="imageSize">
        /// <para>
        /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the compressed image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glCompressedTexSubImage1D")]
        public static extern void CompressedTexSubImage1D<T6>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T6[] data)
            where T6 : struct
        ;

        /// <summary>[requires: v1.3]
        /// Specify a one-dimensional texture subimage in a compressed format
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_1D.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// Specifies a texel offset in the x direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the compressed image data stored at address data.
        /// </para>
        /// </param>
        /// <param name="imageSize">
        /// <para>
        /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the compressed image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glCompressedTexSubImage1D")]
        public static extern void CompressedTexSubImage1D<T6>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T6[,] data)
            where T6 : struct
        ;

        /// <summary>[requires: v1.3]
        /// Specify a one-dimensional texture subimage in a compressed format
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_1D.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// Specifies a texel offset in the x direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the compressed image data stored at address data.
        /// </para>
        /// </param>
        /// <param name="imageSize">
        /// <para>
        /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the compressed image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glCompressedTexSubImage1D")]
        public static extern void CompressedTexSubImage1D<T6>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T6[,,] data)
            where T6 : struct
        ;

        /// <summary>[requires: v1.3]
        /// Specify a one-dimensional texture subimage in a compressed format
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_1D.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// Specifies a texel offset in the x direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the compressed image data stored at address data.
        /// </para>
        /// </param>
        /// <param name="imageSize">
        /// <para>
        /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the compressed image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glCompressedTexSubImage1D")]
        public static extern void CompressedTexSubImage1D<T6>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] ref T6 data)
            where T6 : struct
        ;

        /// <summary>[requires: v1.3]
        /// Specify a two-dimensional texture subimage in a compressed format
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, or GL_TEXTURE_CUBE_MAP_NEGATIVE_Z.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// Specifies a texel offset in the x direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="yoffset">
        /// <para>
        /// Specifies a texel offset in the y direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the compressed image data stored at address data.
        /// </para>
        /// </param>
        /// <param name="imageSize">
        /// <para>
        /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the compressed image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glCompressedTexSubImage2D")]
        public static extern void CompressedTexSubImage2D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, IntPtr data);

        /// <summary>[requires: v1.3]
        /// Specify a two-dimensional texture subimage in a compressed format
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, or GL_TEXTURE_CUBE_MAP_NEGATIVE_Z.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// Specifies a texel offset in the x direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="yoffset">
        /// <para>
        /// Specifies a texel offset in the y direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the compressed image data stored at address data.
        /// </para>
        /// </param>
        /// <param name="imageSize">
        /// <para>
        /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the compressed image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glCompressedTexSubImage2D")]
        public static extern void CompressedTexSubImage2D<T8>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T8[] data)
            where T8 : struct
        ;

        /// <summary>[requires: v1.3]
        /// Specify a two-dimensional texture subimage in a compressed format
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, or GL_TEXTURE_CUBE_MAP_NEGATIVE_Z.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// Specifies a texel offset in the x direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="yoffset">
        /// <para>
        /// Specifies a texel offset in the y direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the compressed image data stored at address data.
        /// </para>
        /// </param>
        /// <param name="imageSize">
        /// <para>
        /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the compressed image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glCompressedTexSubImage2D")]
        public static extern void CompressedTexSubImage2D<T8>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T8[,] data)
            where T8 : struct
        ;

        /// <summary>[requires: v1.3]
        /// Specify a two-dimensional texture subimage in a compressed format
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, or GL_TEXTURE_CUBE_MAP_NEGATIVE_Z.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// Specifies a texel offset in the x direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="yoffset">
        /// <para>
        /// Specifies a texel offset in the y direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the compressed image data stored at address data.
        /// </para>
        /// </param>
        /// <param name="imageSize">
        /// <para>
        /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the compressed image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glCompressedTexSubImage2D")]
        public static extern void CompressedTexSubImage2D<T8>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T8[,,] data)
            where T8 : struct
        ;

        /// <summary>[requires: v1.3]
        /// Specify a two-dimensional texture subimage in a compressed format
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, or GL_TEXTURE_CUBE_MAP_NEGATIVE_Z.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// Specifies a texel offset in the x direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="yoffset">
        /// <para>
        /// Specifies a texel offset in the y direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the compressed image data stored at address data.
        /// </para>
        /// </param>
        /// <param name="imageSize">
        /// <para>
        /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the compressed image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glCompressedTexSubImage2D")]
        public static extern void CompressedTexSubImage2D<T8>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] ref T8 data)
            where T8 : struct
        ;

        /// <summary>[requires: v1.3]
        /// Specify a three-dimensional texture subimage in a compressed format
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_3D.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// Specifies a texel offset in the x direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="yoffset">
        /// <para>
        /// Specifies a texel offset in the y direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// Specifies the depth of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the compressed image data stored at address data.
        /// </para>
        /// </param>
        /// <param name="imageSize">
        /// <para>
        /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the compressed image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glCompressedTexSubImage3D")]
        public static extern void CompressedTexSubImage3D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, IntPtr data);

        /// <summary>[requires: v1.3]
        /// Specify a three-dimensional texture subimage in a compressed format
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_3D.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// Specifies a texel offset in the x direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="yoffset">
        /// <para>
        /// Specifies a texel offset in the y direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// Specifies the depth of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the compressed image data stored at address data.
        /// </para>
        /// </param>
        /// <param name="imageSize">
        /// <para>
        /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the compressed image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glCompressedTexSubImage3D")]
        public static extern void CompressedTexSubImage3D<T10>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T10[] data)
            where T10 : struct
        ;

        /// <summary>[requires: v1.3]
        /// Specify a three-dimensional texture subimage in a compressed format
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_3D.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// Specifies a texel offset in the x direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="yoffset">
        /// <para>
        /// Specifies a texel offset in the y direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// Specifies the depth of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the compressed image data stored at address data.
        /// </para>
        /// </param>
        /// <param name="imageSize">
        /// <para>
        /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the compressed image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glCompressedTexSubImage3D")]
        public static extern void CompressedTexSubImage3D<T10>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T10[,] data)
            where T10 : struct
        ;

        /// <summary>[requires: v1.3]
        /// Specify a three-dimensional texture subimage in a compressed format
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_3D.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// Specifies a texel offset in the x direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="yoffset">
        /// <para>
        /// Specifies a texel offset in the y direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// Specifies the depth of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the compressed image data stored at address data.
        /// </para>
        /// </param>
        /// <param name="imageSize">
        /// <para>
        /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the compressed image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glCompressedTexSubImage3D")]
        public static extern void CompressedTexSubImage3D<T10>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T10[,,] data)
            where T10 : struct
        ;

        /// <summary>[requires: v1.3]
        /// Specify a three-dimensional texture subimage in a compressed format
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_3D.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// Specifies a texel offset in the x direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="yoffset">
        /// <para>
        /// Specifies a texel offset in the y direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// Specifies the depth of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the compressed image data stored at address data.
        /// </para>
        /// </param>
        /// <param name="imageSize">
        /// <para>
        /// Specifies the number of unsigned bytes of image data starting at the address specified by data.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the compressed image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glCompressedTexSubImage3D")]
        public static extern void CompressedTexSubImage3D<T10>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] ref T10 data)
            where T10 : struct
        ;

        /// <summary>
        /// Define a one-dimensional convolution filter
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_CONVOLUTION_1D.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The internal format of the convolution filter kernel. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The width of the pixel array referenced by data.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the pixel data in data. The allowable values are GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_INTENSITY, GL_RGB, and GL_RGBA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the pixel data in data. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Pointer to a one-dimensional array of pixel data that is processed to build the convolution filter kernel.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glConvolutionFilter1D")]
        public static extern void ConvolutionFilter1D(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr image);

        /// <summary>
        /// Define a one-dimensional convolution filter
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_CONVOLUTION_1D.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The internal format of the convolution filter kernel. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The width of the pixel array referenced by data.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the pixel data in data. The allowable values are GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_INTENSITY, GL_RGB, and GL_RGBA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the pixel data in data. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Pointer to a one-dimensional array of pixel data that is processed to build the convolution filter kernel.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glConvolutionFilter1D")]
        public static extern void ConvolutionFilter1D<T5>(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T5[] image)
            where T5 : struct
        ;

        /// <summary>
        /// Define a one-dimensional convolution filter
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_CONVOLUTION_1D.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The internal format of the convolution filter kernel. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The width of the pixel array referenced by data.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the pixel data in data. The allowable values are GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_INTENSITY, GL_RGB, and GL_RGBA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the pixel data in data. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Pointer to a one-dimensional array of pixel data that is processed to build the convolution filter kernel.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glConvolutionFilter1D")]
        public static extern void ConvolutionFilter1D<T5>(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T5[,] image)
            where T5 : struct
        ;

        /// <summary>
        /// Define a one-dimensional convolution filter
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_CONVOLUTION_1D.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The internal format of the convolution filter kernel. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The width of the pixel array referenced by data.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the pixel data in data. The allowable values are GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_INTENSITY, GL_RGB, and GL_RGBA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the pixel data in data. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Pointer to a one-dimensional array of pixel data that is processed to build the convolution filter kernel.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glConvolutionFilter1D")]
        public static extern void ConvolutionFilter1D<T5>(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T5[,,] image)
            where T5 : struct
        ;

        /// <summary>
        /// Define a one-dimensional convolution filter
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_CONVOLUTION_1D.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The internal format of the convolution filter kernel. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The width of the pixel array referenced by data.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the pixel data in data. The allowable values are GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_INTENSITY, GL_RGB, and GL_RGBA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the pixel data in data. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Pointer to a one-dimensional array of pixel data that is processed to build the convolution filter kernel.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glConvolutionFilter1D")]
        public static extern void ConvolutionFilter1D<T5>(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T5 image)
            where T5 : struct
        ;

        /// <summary>
        /// Define a two-dimensional convolution filter
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_CONVOLUTION_2D.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The internal format of the convolution filter kernel. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The width of the pixel array referenced by data.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// The height of the pixel array referenced by data.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the pixel data in data. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, and GL_LUMINANCE_ALPHA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the pixel data in data. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Pointer to a two-dimensional array of pixel data that is processed to build the convolution filter kernel.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glConvolutionFilter2D")]
        public static extern void ConvolutionFilter2D(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr image);

        /// <summary>
        /// Define a two-dimensional convolution filter
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_CONVOLUTION_2D.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The internal format of the convolution filter kernel. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The width of the pixel array referenced by data.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// The height of the pixel array referenced by data.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the pixel data in data. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, and GL_LUMINANCE_ALPHA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the pixel data in data. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Pointer to a two-dimensional array of pixel data that is processed to build the convolution filter kernel.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glConvolutionFilter2D")]
        public static extern void ConvolutionFilter2D<T6>(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T6[] image)
            where T6 : struct
        ;

        /// <summary>
        /// Define a two-dimensional convolution filter
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_CONVOLUTION_2D.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The internal format of the convolution filter kernel. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The width of the pixel array referenced by data.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// The height of the pixel array referenced by data.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the pixel data in data. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, and GL_LUMINANCE_ALPHA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the pixel data in data. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Pointer to a two-dimensional array of pixel data that is processed to build the convolution filter kernel.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glConvolutionFilter2D")]
        public static extern void ConvolutionFilter2D<T6>(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T6[,] image)
            where T6 : struct
        ;

        /// <summary>
        /// Define a two-dimensional convolution filter
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_CONVOLUTION_2D.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The internal format of the convolution filter kernel. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The width of the pixel array referenced by data.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// The height of the pixel array referenced by data.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the pixel data in data. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, and GL_LUMINANCE_ALPHA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the pixel data in data. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Pointer to a two-dimensional array of pixel data that is processed to build the convolution filter kernel.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glConvolutionFilter2D")]
        public static extern void ConvolutionFilter2D<T6>(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T6[,,] image)
            where T6 : struct
        ;

        /// <summary>
        /// Define a two-dimensional convolution filter
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_CONVOLUTION_2D.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The internal format of the convolution filter kernel. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The width of the pixel array referenced by data.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// The height of the pixel array referenced by data.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the pixel data in data. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, and GL_LUMINANCE_ALPHA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the pixel data in data. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Pointer to a two-dimensional array of pixel data that is processed to build the convolution filter kernel.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glConvolutionFilter2D")]
        public static extern void ConvolutionFilter2D<T6>(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T6 image)
            where T6 : struct
        ;

        /// <summary>
        /// Set convolution parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The target for the convolution parameter. Must be one of GL_CONVOLUTION_1D, GL_CONVOLUTION_2D, or GL_SEPARABLE_2D.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The parameter to be set. Must be GL_CONVOLUTION_BORDER_MODE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// The parameter value. Must be one of GL_REDUCE, GL_CONSTANT_BORDER, GL_REPLICATE_BORDER.
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glConvolutionParameterf")]
        public static extern void ConvolutionParameter(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.ConvolutionParameter pname, Single @params);

        /// <summary>
        /// Set convolution parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The target for the convolution parameter. Must be one of GL_CONVOLUTION_1D, GL_CONVOLUTION_2D, or GL_SEPARABLE_2D.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The parameter to be set. Must be GL_CONVOLUTION_BORDER_MODE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// The parameter value. Must be one of GL_REDUCE, GL_CONSTANT_BORDER, GL_REPLICATE_BORDER.
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glConvolutionParameterfv")]
        public static extern void ConvolutionParameter(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.ConvolutionParameter pname, Single[] @params);

        /// <summary>
        /// Set convolution parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The target for the convolution parameter. Must be one of GL_CONVOLUTION_1D, GL_CONVOLUTION_2D, or GL_SEPARABLE_2D.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The parameter to be set. Must be GL_CONVOLUTION_BORDER_MODE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// The parameter value. Must be one of GL_REDUCE, GL_CONSTANT_BORDER, GL_REPLICATE_BORDER.
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glConvolutionParameterfv")]
        public static extern unsafe void ConvolutionParameter(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.ConvolutionParameter pname, Single* @params);

        /// <summary>
        /// Set convolution parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The target for the convolution parameter. Must be one of GL_CONVOLUTION_1D, GL_CONVOLUTION_2D, or GL_SEPARABLE_2D.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The parameter to be set. Must be GL_CONVOLUTION_BORDER_MODE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// The parameter value. Must be one of GL_REDUCE, GL_CONSTANT_BORDER, GL_REPLICATE_BORDER.
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glConvolutionParameteri")]
        public static extern void ConvolutionParameter(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.ConvolutionParameter pname, Int32 @params);

        /// <summary>
        /// Set convolution parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The target for the convolution parameter. Must be one of GL_CONVOLUTION_1D, GL_CONVOLUTION_2D, or GL_SEPARABLE_2D.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The parameter to be set. Must be GL_CONVOLUTION_BORDER_MODE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// The parameter value. Must be one of GL_REDUCE, GL_CONSTANT_BORDER, GL_REPLICATE_BORDER.
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glConvolutionParameteriv")]
        public static extern void ConvolutionParameter(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.ConvolutionParameter pname, Int32[] @params);

        /// <summary>
        /// Set convolution parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The target for the convolution parameter. Must be one of GL_CONVOLUTION_1D, GL_CONVOLUTION_2D, or GL_SEPARABLE_2D.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The parameter to be set. Must be GL_CONVOLUTION_BORDER_MODE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// The parameter value. Must be one of GL_REDUCE, GL_CONSTANT_BORDER, GL_REPLICATE_BORDER.
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glConvolutionParameteriv")]
        public static extern unsafe void ConvolutionParameter(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.ConvolutionParameter pname, Int32* @params);

        /// <summary>[requires: v3.1 and ARB_copy_buffer|VERSION_3_1]
        /// Copy part of the data store of a buffer object to the data store of another buffer object
        /// </summary>
        /// <param name="readtarget">
        /// <para>
        /// Specifies the target from whose data store data should be read.
        /// </para>
        /// </param>
        /// <param name="writetarget">
        /// <para>
        /// Specifies the target to whose data store data should be written.
        /// </para>
        /// </param>
        /// <param name="readoffset">
        /// <para>
        /// Specifies the offset, in basic machine units, within the data store of readtarget from which data should be read.
        /// </para>
        /// </param>
        /// <param name="writeoffset">
        /// <para>
        /// Specifies the offset, in basic machine units, within the data store of writetarget to which data should be written.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Specifies the size, in basic machine units, of the data to be copied from readtarget to writetarget.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_copy_buffer|VERSION_3_1", Version = "3.1", EntryPoint = "glCopyBufferSubData")]
        public static extern void CopyBufferSubData(OpenTK.Graphics.OpenGL.BufferTarget readTarget, OpenTK.Graphics.OpenGL.BufferTarget writeTarget, IntPtr readOffset, IntPtr writeOffset, IntPtr size);

        /// <summary>
        /// Respecify a portion of a color table
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be one of GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// The starting index of the portion of the color table to be replaced.
        /// </para>
        /// </param>
        /// <param name="x">
        /// <para>
        /// The window coordinates of the left corner of the row of pixels to be copied.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The number of table entries to replace.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glCopyColorSubTable")]
        public static extern void CopyColorSubTable(OpenTK.Graphics.OpenGL.ColorTableTarget target, Int32 start, Int32 x, Int32 y, Int32 width);

        /// <summary>
        /// Copy pixels into a color table
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The color table target. Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The internal storage format of the texture image. Must be one of the following symbolic constants: GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
        /// </para>
        /// </param>
        /// <param name="x">
        /// <para>
        /// The x coordinate of the lower-left corner of the pixel rectangle to be transferred to the color table.
        /// </para>
        /// </param>
        /// <param name="y">
        /// <para>
        /// The y coordinate of the lower-left corner of the pixel rectangle to be transferred to the color table.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The width of the pixel rectangle.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glCopyColorTable")]
        public static extern void CopyColorTable(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 x, Int32 y, Int32 width);

        /// <summary>
        /// Copy pixels into a one-dimensional convolution filter
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_CONVOLUTION_1D.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The internal format of the convolution filter kernel. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
        /// </para>
        /// </param>
        /// <param name="x">
        /// <para>
        /// The window space coordinates of the lower-left coordinate of the pixel array to copy.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The width of the pixel array to copy.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glCopyConvolutionFilter1D")]
        public static extern void CopyConvolutionFilter1D(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 x, Int32 y, Int32 width);

        /// <summary>
        /// Copy pixels into a two-dimensional convolution filter
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_CONVOLUTION_2D.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The internal format of the convolution filter kernel. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
        /// </para>
        /// </param>
        /// <param name="x">
        /// <para>
        /// The window space coordinates of the lower-left coordinate of the pixel array to copy.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The width of the pixel array to copy.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// The height of the pixel array to copy.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glCopyConvolutionFilter2D")]
        public static extern void CopyConvolutionFilter2D(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 x, Int32 y, Int32 width, Int32 height);

        /// <summary>[requires: v4.3 and ARB_copy_image|VERSION_4_3]
        /// Perform a raw data copy between two images
        /// </summary>
        /// <param name="srcName">
        /// <para>
        /// The name of a texture or renderbuffer object from which to copy.
        /// </para>
        /// </param>
        /// <param name="srcTarget">
        /// <para>
        /// The target representing the namespace of the source name srcName.
        /// </para>
        /// </param>
        /// <param name="srcLevel">
        /// <para>
        /// The mipmap level to read from the source.
        /// </para>
        /// </param>
        /// <param name="srcX">
        /// <para>
        /// The X coordinate of the left edge of the souce region to copy.
        /// </para>
        /// </param>
        /// <param name="srcY">
        /// <para>
        /// The Y coordinate of the top edge of the souce region to copy.
        /// </para>
        /// </param>
        /// <param name="srcZ">
        /// <para>
        /// The Z coordinate of the near edge of the souce region to copy.
        /// </para>
        /// </param>
        /// <param name="dstName">
        /// <para>
        /// The name of a texture or renderbuffer object to which to copy.
        /// </para>
        /// </param>
        /// <param name="dstTarget">
        /// <para>
        /// The target representing the namespace of the destination name dstName.
        /// </para>
        /// </param>
        /// <param name="dstX">
        /// <para>
        /// The X coordinate of the left edge of the destination region.
        /// </para>
        /// </param>
        /// <param name="dstY">
        /// <para>
        /// The Y coordinate of the top edge of the destination region.
        /// </para>
        /// </param>
        /// <param name="dstZ">
        /// <para>
        /// The Z coordinate of the near edge of the destination region.
        /// </para>
        /// </param>
        /// <param name="srcWidth">
        /// <para>
        /// The width of the region to be copied.
        /// </para>
        /// </param>
        /// <param name="srcHeight">
        /// <para>
        /// The height of the region to be copied.
        /// </para>
        /// </param>
        /// <param name="srcDepth">
        /// <para>
        /// The depth of the region to be copied.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_copy_image|VERSION_4_3", Version = "4.3", EntryPoint = "glCopyImageSubData")]
        public static extern void CopyImageSubData(Int32 srcName, OpenTK.Graphics.OpenGL.ImageTarget srcTarget, Int32 srcLevel, Int32 srcX, Int32 srcY, Int32 srcZ, Int32 dstName, OpenTK.Graphics.OpenGL.ImageTarget dstTarget, Int32 dstLevel, Int32 dstX, Int32 dstY, Int32 dstZ, Int32 srcWidth, Int32 srcHeight, Int32 srcDepth);

        /// <summary>[requires: v4.3 and ARB_copy_image|VERSION_4_3]
        /// Perform a raw data copy between two images
        /// </summary>
        /// <param name="srcName">
        /// <para>
        /// The name of a texture or renderbuffer object from which to copy.
        /// </para>
        /// </param>
        /// <param name="srcTarget">
        /// <para>
        /// The target representing the namespace of the source name srcName.
        /// </para>
        /// </param>
        /// <param name="srcLevel">
        /// <para>
        /// The mipmap level to read from the source.
        /// </para>
        /// </param>
        /// <param name="srcX">
        /// <para>
        /// The X coordinate of the left edge of the souce region to copy.
        /// </para>
        /// </param>
        /// <param name="srcY">
        /// <para>
        /// The Y coordinate of the top edge of the souce region to copy.
        /// </para>
        /// </param>
        /// <param name="srcZ">
        /// <para>
        /// The Z coordinate of the near edge of the souce region to copy.
        /// </para>
        /// </param>
        /// <param name="dstName">
        /// <para>
        /// The name of a texture or renderbuffer object to which to copy.
        /// </para>
        /// </param>
        /// <param name="dstTarget">
        /// <para>
        /// The target representing the namespace of the destination name dstName.
        /// </para>
        /// </param>
        /// <param name="dstX">
        /// <para>
        /// The X coordinate of the left edge of the destination region.
        /// </para>
        /// </param>
        /// <param name="dstY">
        /// <para>
        /// The Y coordinate of the top edge of the destination region.
        /// </para>
        /// </param>
        /// <param name="dstZ">
        /// <para>
        /// The Z coordinate of the near edge of the destination region.
        /// </para>
        /// </param>
        /// <param name="srcWidth">
        /// <para>
        /// The width of the region to be copied.
        /// </para>
        /// </param>
        /// <param name="srcHeight">
        /// <para>
        /// The height of the region to be copied.
        /// </para>
        /// </param>
        /// <param name="srcDepth">
        /// <para>
        /// The depth of the region to be copied.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_copy_image|VERSION_4_3", Version = "4.3", EntryPoint = "glCopyImageSubData")]
        public static extern void CopyImageSubData(UInt32 srcName, OpenTK.Graphics.OpenGL.ImageTarget srcTarget, Int32 srcLevel, Int32 srcX, Int32 srcY, Int32 srcZ, UInt32 dstName, OpenTK.Graphics.OpenGL.ImageTarget dstTarget, Int32 dstLevel, Int32 dstX, Int32 dstY, Int32 dstZ, Int32 srcWidth, Int32 srcHeight, Int32 srcDepth);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Copy pixels in the frame buffer
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the window coordinates of the lower left corner of the rectangular region of pixels to be copied.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specify the dimensions of the rectangular region of pixels to be copied. Both must be nonnegative.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies whether color values, depth values, or stencil values are to be copied. Symbolic constants GL_COLOR, GL_DEPTH, and GL_STENCIL are accepted.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glCopyPixels")]
        public static extern void CopyPixels(Int32 x, Int32 y, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelCopyType type);

        /// <summary>[requires: v1.1]
        /// Copy pixels into a 1D texture image
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_1D.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// Specifies the internal format of the texture. Must be one of the following symbolic constants: GL_COMPRESSED_RED, GL_COMPRESSED_RG, GL_COMPRESSED_RGB, GL_COMPRESSED_RGBA. GL_COMPRESSED_SRGB, GL_COMPRESSED_SRGB_ALPHA. GL_DEPTH_COMPONENT, GL_DEPTH_COMPONENT16, GL_DEPTH_COMPONENT24, GL_DEPTH_COMPONENT32, GL_STENCIL_INDEX8, GL_RED, GL_RG, GL_RGB, GL_R3_G3_B2, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, GL_RGBA16, GL_SRGB, GL_SRGB8, GL_SRGB_ALPHA, or GL_SRGB8_ALPHA8.
        /// </para>
        /// </param>
        /// <param name="x">
        /// <para>
        /// Specify the window coordinates of the left corner of the row of pixels to be copied.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture image. The height of the texture image is 1.
        /// </para>
        /// </param>
        /// <param name="border">
        /// <para>
        /// Must be 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glCopyTexImage1D")]
        public static extern void CopyTexImage1D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 x, Int32 y, Int32 width, Int32 border);

        /// <summary>[requires: v1.1]
        /// Copy pixels into a 2D texture image
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, or GL_TEXTURE_CUBE_MAP_NEGATIVE_Z.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// Specifies the internal format of the texture. Must be one of the following symbolic constants: GL_COMPRESSED_RED, GL_COMPRESSED_RG, GL_COMPRESSED_RGB, GL_COMPRESSED_RGBA. GL_COMPRESSED_SRGB, GL_COMPRESSED_SRGB_ALPHA. GL_DEPTH_COMPONENT, GL_DEPTH_COMPONENT16, GL_DEPTH_COMPONENT24, GL_DEPTH_COMPONENT32, GL_STENCIL_INDEX8, GL_RED, GL_RG, GL_RGB, GL_R3_G3_B2, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, GL_RGBA16, GL_SRGB, GL_SRGB8, GL_SRGB_ALPHA, or GL_SRGB8_ALPHA8.
        /// </para>
        /// </param>
        /// <param name="x">
        /// <para>
        /// Specify the window coordinates of the lower left corner of the rectangular region of pixels to be copied.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture image.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture image.
        /// </para>
        /// </param>
        /// <param name="border">
        /// <para>
        /// Must be 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glCopyTexImage2D")]
        public static extern void CopyTexImage2D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 x, Int32 y, Int32 width, Int32 height, Int32 border);

        /// <summary>[requires: v1.1]
        /// Copy a one-dimensional texture subimage
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_1D.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// Specifies the texel offset within the texture array.
        /// </para>
        /// </param>
        /// <param name="x">
        /// <para>
        /// Specify the window coordinates of the left corner of the row of pixels to be copied.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture subimage.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glCopyTexSubImage1D")]
        public static extern void CopyTexSubImage1D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 x, Int32 y, Int32 width);

        /// <summary>[requires: v1.1]
        /// Copy a two-dimensional texture subimage
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, or GL_TEXTURE_1D_ARRAY.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// Specifies a texel offset in the x direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="yoffset">
        /// <para>
        /// Specifies a texel offset in the y direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="x">
        /// <para>
        /// Specify the window coordinates of the lower left corner of the rectangular region of pixels to be copied.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture subimage.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glCopyTexSubImage2D")]
        public static extern void CopyTexSubImage2D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 x, Int32 y, Int32 width, Int32 height);

        /// <summary>[requires: v1.2]
        /// Copy a three-dimensional texture subimage
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_3D or GL_TEXTURE_2D_ARRAY.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// Specifies a texel offset in the x direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="yoffset">
        /// <para>
        /// Specifies a texel offset in the y direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="zoffset">
        /// <para>
        /// Specifies a texel offset in the z direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="x">
        /// <para>
        /// Specify the window coordinates of the lower left corner of the rectangular region of pixels to be copied.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture subimage.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_2", Version = "1.2", EntryPoint = "glCopyTexSubImage3D")]
        public static extern void CopyTexSubImage3D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 x, Int32 y, Int32 width, Int32 height);

        /// <summary>[requires: v2.0]
        /// Creates a program object
        /// </summary>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glCreateProgram")]
        public static extern Int32 CreateProgram();

        /// <summary>[requires: v2.0]
        /// Creates a shader object
        /// </summary>
        /// <param name="shaderType">
        /// <para>
        /// Specifies the type of shader to be created. Must be one of GL_COMPUTE_SHADER, GL_VERTEX_SHADER, GL_TESS_CONTROL_SHADER, GL_TESS_EVALUATION_SHADER, GL_GEOMETRY_SHADER, or GL_FRAGMENT_SHADER.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glCreateShader")]
        public static extern Int32 CreateShader(OpenTK.Graphics.OpenGL.ShaderType type);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Create a stand-alone program from an array of null-terminated source code strings
        /// </summary>
        /// <param name="type">
        /// <para>
        /// Specifies the type of shader to create.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of source code strings in the array strings.
        /// </para>
        /// </param>
        /// <param name="strings">
        /// <para>
        /// Specifies the address of an array of pointers to source code strings from which to create the program object.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glCreateShaderProgramv")]
        public static extern Int32 CreateShaderProgram(OpenTK.Graphics.OpenGL.ShaderType type, Int32 count, String[] strings);

        /// <summary>[requires: v1.0]
        /// Specify whether front- or back-facing facets can be culled
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies whether front- or back-facing facets are candidates for culling. Symbolic constants GL_FRONT, GL_BACK, and GL_FRONT_AND_BACK are accepted. The initial value is GL_BACK.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glCullFace")]
        public static extern void CullFace(OpenTK.Graphics.OpenGL.CullFaceMode mode);

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Specify a callback to receive debugging messages from the GL
        /// </summary>
        /// <param name="callback">
        /// <para>
        /// The address of a callback function that will be called when a debug message is generated.
        /// </para>
        /// </param>
        /// <param name="userParam">
        /// <para>
        /// A user supplied pointer that will be passed on each invocation of callback.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glDebugMessageCallback")]
        public static extern void DebugMessageCallback(DebugProc callback, IntPtr userParam);

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Specify a callback to receive debugging messages from the GL
        /// </summary>
        /// <param name="callback">
        /// <para>
        /// The address of a callback function that will be called when a debug message is generated.
        /// </para>
        /// </param>
        /// <param name="userParam">
        /// <para>
        /// A user supplied pointer that will be passed on each invocation of callback.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glDebugMessageCallback")]
        public static extern void DebugMessageCallback<T1>(DebugProc callback, [InAttribute, OutAttribute] T1[] userParam)
            where T1 : struct
        ;

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Specify a callback to receive debugging messages from the GL
        /// </summary>
        /// <param name="callback">
        /// <para>
        /// The address of a callback function that will be called when a debug message is generated.
        /// </para>
        /// </param>
        /// <param name="userParam">
        /// <para>
        /// A user supplied pointer that will be passed on each invocation of callback.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glDebugMessageCallback")]
        public static extern void DebugMessageCallback<T1>(DebugProc callback, [InAttribute, OutAttribute] T1[,] userParam)
            where T1 : struct
        ;

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Specify a callback to receive debugging messages from the GL
        /// </summary>
        /// <param name="callback">
        /// <para>
        /// The address of a callback function that will be called when a debug message is generated.
        /// </para>
        /// </param>
        /// <param name="userParam">
        /// <para>
        /// A user supplied pointer that will be passed on each invocation of callback.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glDebugMessageCallback")]
        public static extern void DebugMessageCallback<T1>(DebugProc callback, [InAttribute, OutAttribute] T1[,,] userParam)
            where T1 : struct
        ;

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Specify a callback to receive debugging messages from the GL
        /// </summary>
        /// <param name="callback">
        /// <para>
        /// The address of a callback function that will be called when a debug message is generated.
        /// </para>
        /// </param>
        /// <param name="userParam">
        /// <para>
        /// A user supplied pointer that will be passed on each invocation of callback.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glDebugMessageCallback")]
        public static extern void DebugMessageCallback<T1>(DebugProc callback, [InAttribute, OutAttribute] ref T1 userParam)
            where T1 : struct
        ;

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Control the reporting of debug messages in a debug context
        /// </summary>
        /// <param name="source">
        /// <para>
        /// The source of debug messages to enable or disable.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of debug messages to enable or disable.
        /// </para>
        /// </param>
        /// <param name="severity">
        /// <para>
        /// The severity of debug messages to enable or disable.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// The length of the array ids.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// The address of an array of unsigned integers contianing the ids of the messages to enable or disable.
        /// </para>
        /// </param>
        /// <param name="enabled">
        /// <para>
        /// A Boolean flag determining whether the selected messages should be enabled or disabled.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glDebugMessageControl")]
        public static extern void DebugMessageControl(OpenTK.Graphics.OpenGL.DebugSourceControl source, OpenTK.Graphics.OpenGL.DebugTypeControl type, OpenTK.Graphics.OpenGL.DebugSeverityControl severity, Int32 count, Int32[] ids, bool enabled);

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Control the reporting of debug messages in a debug context
        /// </summary>
        /// <param name="source">
        /// <para>
        /// The source of debug messages to enable or disable.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of debug messages to enable or disable.
        /// </para>
        /// </param>
        /// <param name="severity">
        /// <para>
        /// The severity of debug messages to enable or disable.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// The length of the array ids.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// The address of an array of unsigned integers contianing the ids of the messages to enable or disable.
        /// </para>
        /// </param>
        /// <param name="enabled">
        /// <para>
        /// A Boolean flag determining whether the selected messages should be enabled or disabled.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glDebugMessageControl")]
        public static extern void DebugMessageControl(OpenTK.Graphics.OpenGL.DebugSourceControl source, OpenTK.Graphics.OpenGL.DebugTypeControl type, OpenTK.Graphics.OpenGL.DebugSeverityControl severity, Int32 count, ref Int32 ids, bool enabled);

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Control the reporting of debug messages in a debug context
        /// </summary>
        /// <param name="source">
        /// <para>
        /// The source of debug messages to enable or disable.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of debug messages to enable or disable.
        /// </para>
        /// </param>
        /// <param name="severity">
        /// <para>
        /// The severity of debug messages to enable or disable.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// The length of the array ids.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// The address of an array of unsigned integers contianing the ids of the messages to enable or disable.
        /// </para>
        /// </param>
        /// <param name="enabled">
        /// <para>
        /// A Boolean flag determining whether the selected messages should be enabled or disabled.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glDebugMessageControl")]
        public static extern unsafe void DebugMessageControl(OpenTK.Graphics.OpenGL.DebugSourceControl source, OpenTK.Graphics.OpenGL.DebugTypeControl type, OpenTK.Graphics.OpenGL.DebugSeverityControl severity, Int32 count, Int32* ids, bool enabled);

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Control the reporting of debug messages in a debug context
        /// </summary>
        /// <param name="source">
        /// <para>
        /// The source of debug messages to enable or disable.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of debug messages to enable or disable.
        /// </para>
        /// </param>
        /// <param name="severity">
        /// <para>
        /// The severity of debug messages to enable or disable.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// The length of the array ids.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// The address of an array of unsigned integers contianing the ids of the messages to enable or disable.
        /// </para>
        /// </param>
        /// <param name="enabled">
        /// <para>
        /// A Boolean flag determining whether the selected messages should be enabled or disabled.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glDebugMessageControl")]
        public static extern void DebugMessageControl(OpenTK.Graphics.OpenGL.DebugSourceControl source, OpenTK.Graphics.OpenGL.DebugTypeControl type, OpenTK.Graphics.OpenGL.DebugSeverityControl severity, Int32 count, UInt32[] ids, bool enabled);

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Control the reporting of debug messages in a debug context
        /// </summary>
        /// <param name="source">
        /// <para>
        /// The source of debug messages to enable or disable.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of debug messages to enable or disable.
        /// </para>
        /// </param>
        /// <param name="severity">
        /// <para>
        /// The severity of debug messages to enable or disable.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// The length of the array ids.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// The address of an array of unsigned integers contianing the ids of the messages to enable or disable.
        /// </para>
        /// </param>
        /// <param name="enabled">
        /// <para>
        /// A Boolean flag determining whether the selected messages should be enabled or disabled.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glDebugMessageControl")]
        public static extern void DebugMessageControl(OpenTK.Graphics.OpenGL.DebugSourceControl source, OpenTK.Graphics.OpenGL.DebugTypeControl type, OpenTK.Graphics.OpenGL.DebugSeverityControl severity, Int32 count, ref UInt32 ids, bool enabled);

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Control the reporting of debug messages in a debug context
        /// </summary>
        /// <param name="source">
        /// <para>
        /// The source of debug messages to enable or disable.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of debug messages to enable or disable.
        /// </para>
        /// </param>
        /// <param name="severity">
        /// <para>
        /// The severity of debug messages to enable or disable.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// The length of the array ids.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// The address of an array of unsigned integers contianing the ids of the messages to enable or disable.
        /// </para>
        /// </param>
        /// <param name="enabled">
        /// <para>
        /// A Boolean flag determining whether the selected messages should be enabled or disabled.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glDebugMessageControl")]
        public static extern unsafe void DebugMessageControl(OpenTK.Graphics.OpenGL.DebugSourceControl source, OpenTK.Graphics.OpenGL.DebugTypeControl type, OpenTK.Graphics.OpenGL.DebugSeverityControl severity, Int32 count, UInt32* ids, bool enabled);

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Inject an application-supplied message into the debug message queue
        /// </summary>
        /// <param name="source">
        /// <para>
        /// The source of the debug message to insert.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the debug message insert.
        /// </para>
        /// </param>
        /// <param name="id">
        /// <para>
        /// The user-supplied identifier of the message to insert.
        /// </para>
        /// </param>
        /// <param name="severity">
        /// <para>
        /// The severity of the debug messages to insert.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The length string contained in the character array whose address is given by message.
        /// </para>
        /// </param>
        /// <param name="message">
        /// <para>
        /// The address of a character array containing the message to insert.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glDebugMessageInsert")]
        public static extern void DebugMessageInsert(OpenTK.Graphics.OpenGL.DebugSourceExternal source, OpenTK.Graphics.OpenGL.DebugType type, Int32 id, OpenTK.Graphics.OpenGL.DebugSeverity severity, Int32 length, String buf);

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Inject an application-supplied message into the debug message queue
        /// </summary>
        /// <param name="source">
        /// <para>
        /// The source of the debug message to insert.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the debug message insert.
        /// </para>
        /// </param>
        /// <param name="id">
        /// <para>
        /// The user-supplied identifier of the message to insert.
        /// </para>
        /// </param>
        /// <param name="severity">
        /// <para>
        /// The severity of the debug messages to insert.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The length string contained in the character array whose address is given by message.
        /// </para>
        /// </param>
        /// <param name="message">
        /// <para>
        /// The address of a character array containing the message to insert.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glDebugMessageInsert")]
        public static extern void DebugMessageInsert(OpenTK.Graphics.OpenGL.DebugSourceExternal source, OpenTK.Graphics.OpenGL.DebugType type, UInt32 id, OpenTK.Graphics.OpenGL.DebugSeverity severity, Int32 length, String buf);

        /// <summary>[requires: v1.5]
        /// Delete named buffer objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of buffer objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// Specifies an array of buffer objects to be deleted.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glDeleteBuffers")]
        public static extern void DeleteBuffer(Int32 buffers);

        /// <summary>[requires: v1.5]
        /// Delete named buffer objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of buffer objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// Specifies an array of buffer objects to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glDeleteBuffers")]
        public static extern void DeleteBuffer(UInt32 buffers);

        /// <summary>[requires: v1.5]
        /// Delete named buffer objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of buffer objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// Specifies an array of buffer objects to be deleted.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glDeleteBuffers")]
        public static extern void DeleteBuffers(Int32 n, Int32[] buffers);

        /// <summary>[requires: v1.5]
        /// Delete named buffer objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of buffer objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// Specifies an array of buffer objects to be deleted.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glDeleteBuffers")]
        public static extern void DeleteBuffers(Int32 n, ref Int32 buffers);

        /// <summary>[requires: v1.5]
        /// Delete named buffer objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of buffer objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// Specifies an array of buffer objects to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glDeleteBuffers")]
        public static extern unsafe void DeleteBuffers(Int32 n, Int32* buffers);

        /// <summary>[requires: v1.5]
        /// Delete named buffer objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of buffer objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// Specifies an array of buffer objects to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glDeleteBuffers")]
        public static extern void DeleteBuffers(Int32 n, UInt32[] buffers);

        /// <summary>[requires: v1.5]
        /// Delete named buffer objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of buffer objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// Specifies an array of buffer objects to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glDeleteBuffers")]
        public static extern void DeleteBuffers(Int32 n, ref UInt32 buffers);

        /// <summary>[requires: v1.5]
        /// Delete named buffer objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of buffer objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// Specifies an array of buffer objects to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glDeleteBuffers")]
        public static extern unsafe void DeleteBuffers(Int32 n, UInt32* buffers);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Delete framebuffer objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of framebuffer objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="framebuffers">
        /// <para>
        /// A pointer to an array containing n framebuffer objects to be deleted.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glDeleteFramebuffers")]
        public static extern void DeleteFramebuffer(Int32 framebuffers);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Delete framebuffer objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of framebuffer objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="framebuffers">
        /// <para>
        /// A pointer to an array containing n framebuffer objects to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glDeleteFramebuffers")]
        public static extern void DeleteFramebuffer(UInt32 framebuffers);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Delete framebuffer objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of framebuffer objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="framebuffers">
        /// <para>
        /// A pointer to an array containing n framebuffer objects to be deleted.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glDeleteFramebuffers")]
        public static extern void DeleteFramebuffers(Int32 n, Int32[] framebuffers);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Delete framebuffer objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of framebuffer objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="framebuffers">
        /// <para>
        /// A pointer to an array containing n framebuffer objects to be deleted.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glDeleteFramebuffers")]
        public static extern void DeleteFramebuffers(Int32 n, ref Int32 framebuffers);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Delete framebuffer objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of framebuffer objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="framebuffers">
        /// <para>
        /// A pointer to an array containing n framebuffer objects to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glDeleteFramebuffers")]
        public static extern unsafe void DeleteFramebuffers(Int32 n, Int32* framebuffers);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Delete framebuffer objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of framebuffer objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="framebuffers">
        /// <para>
        /// A pointer to an array containing n framebuffer objects to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glDeleteFramebuffers")]
        public static extern void DeleteFramebuffers(Int32 n, UInt32[] framebuffers);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Delete framebuffer objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of framebuffer objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="framebuffers">
        /// <para>
        /// A pointer to an array containing n framebuffer objects to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glDeleteFramebuffers")]
        public static extern void DeleteFramebuffers(Int32 n, ref UInt32 framebuffers);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Delete framebuffer objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of framebuffer objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="framebuffers">
        /// <para>
        /// A pointer to an array containing n framebuffer objects to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glDeleteFramebuffers")]
        public static extern unsafe void DeleteFramebuffers(Int32 n, UInt32* framebuffers);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Delete a contiguous group of display lists
        /// </summary>
        /// <param name="list">
        /// <para>
        /// Specifies the integer name of the first display list to delete.
        /// </para>
        /// </param>
        /// <param name="range">
        /// <para>
        /// Specifies the number of display lists to delete.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glDeleteLists")]
        public static extern void DeleteLists(Int32 list, Int32 range);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Delete a contiguous group of display lists
        /// </summary>
        /// <param name="list">
        /// <para>
        /// Specifies the integer name of the first display list to delete.
        /// </para>
        /// </param>
        /// <param name="range">
        /// <para>
        /// Specifies the number of display lists to delete.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glDeleteLists")]
        public static extern void DeleteLists(UInt32 list, Int32 range);

        /// <summary>[requires: v2.0]
        /// Deletes a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be deleted.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glDeleteProgram")]
        public static extern void DeleteProgram(Int32 program);

        /// <summary>[requires: v2.0]
        /// Deletes a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glDeleteProgram")]
        public static extern void DeleteProgram(UInt32 program);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Delete program pipeline objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of program pipeline objects to delete.
        /// </para>
        /// </param>
        /// <param name="pipelines">
        /// <para>
        /// Specifies an array of names of program pipeline objects to delete.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glDeleteProgramPipelines")]
        public static extern void DeleteProgramPipeline(Int32 pipelines);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Delete program pipeline objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of program pipeline objects to delete.
        /// </para>
        /// </param>
        /// <param name="pipelines">
        /// <para>
        /// Specifies an array of names of program pipeline objects to delete.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glDeleteProgramPipelines")]
        public static extern void DeleteProgramPipeline(UInt32 pipelines);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Delete program pipeline objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of program pipeline objects to delete.
        /// </para>
        /// </param>
        /// <param name="pipelines">
        /// <para>
        /// Specifies an array of names of program pipeline objects to delete.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glDeleteProgramPipelines")]
        public static extern void DeleteProgramPipelines(Int32 n, Int32[] pipelines);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Delete program pipeline objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of program pipeline objects to delete.
        /// </para>
        /// </param>
        /// <param name="pipelines">
        /// <para>
        /// Specifies an array of names of program pipeline objects to delete.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glDeleteProgramPipelines")]
        public static extern void DeleteProgramPipelines(Int32 n, ref Int32 pipelines);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Delete program pipeline objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of program pipeline objects to delete.
        /// </para>
        /// </param>
        /// <param name="pipelines">
        /// <para>
        /// Specifies an array of names of program pipeline objects to delete.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glDeleteProgramPipelines")]
        public static extern unsafe void DeleteProgramPipelines(Int32 n, Int32* pipelines);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Delete program pipeline objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of program pipeline objects to delete.
        /// </para>
        /// </param>
        /// <param name="pipelines">
        /// <para>
        /// Specifies an array of names of program pipeline objects to delete.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glDeleteProgramPipelines")]
        public static extern void DeleteProgramPipelines(Int32 n, UInt32[] pipelines);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Delete program pipeline objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of program pipeline objects to delete.
        /// </para>
        /// </param>
        /// <param name="pipelines">
        /// <para>
        /// Specifies an array of names of program pipeline objects to delete.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glDeleteProgramPipelines")]
        public static extern void DeleteProgramPipelines(Int32 n, ref UInt32 pipelines);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Delete program pipeline objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of program pipeline objects to delete.
        /// </para>
        /// </param>
        /// <param name="pipelines">
        /// <para>
        /// Specifies an array of names of program pipeline objects to delete.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glDeleteProgramPipelines")]
        public static extern unsafe void DeleteProgramPipelines(Int32 n, UInt32* pipelines);

        /// <summary>[requires: v1.5]
        /// Delete named query objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of query objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array of query objects to be deleted.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glDeleteQueries")]
        public static extern void DeleteQuery(Int32 ids);

        /// <summary>[requires: v1.5]
        /// Delete named query objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of query objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array of query objects to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glDeleteQueries")]
        public static extern void DeleteQuery(UInt32 ids);

        /// <summary>[requires: v1.5]
        /// Delete named query objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of query objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array of query objects to be deleted.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glDeleteQueries")]
        public static extern void DeleteQueries(Int32 n, Int32[] ids);

        /// <summary>[requires: v1.5]
        /// Delete named query objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of query objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array of query objects to be deleted.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glDeleteQueries")]
        public static extern void DeleteQueries(Int32 n, ref Int32 ids);

        /// <summary>[requires: v1.5]
        /// Delete named query objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of query objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array of query objects to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glDeleteQueries")]
        public static extern unsafe void DeleteQueries(Int32 n, Int32* ids);

        /// <summary>[requires: v1.5]
        /// Delete named query objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of query objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array of query objects to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glDeleteQueries")]
        public static extern void DeleteQueries(Int32 n, UInt32[] ids);

        /// <summary>[requires: v1.5]
        /// Delete named query objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of query objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array of query objects to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glDeleteQueries")]
        public static extern void DeleteQueries(Int32 n, ref UInt32 ids);

        /// <summary>[requires: v1.5]
        /// Delete named query objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of query objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array of query objects to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glDeleteQueries")]
        public static extern unsafe void DeleteQueries(Int32 n, UInt32* ids);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Delete renderbuffer objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of renderbuffer objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="renderbuffers">
        /// <para>
        /// A pointer to an array containing n renderbuffer objects to be deleted.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glDeleteRenderbuffers")]
        public static extern void DeleteRenderbuffer(Int32 renderbuffers);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Delete renderbuffer objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of renderbuffer objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="renderbuffers">
        /// <para>
        /// A pointer to an array containing n renderbuffer objects to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glDeleteRenderbuffers")]
        public static extern void DeleteRenderbuffer(UInt32 renderbuffers);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Delete renderbuffer objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of renderbuffer objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="renderbuffers">
        /// <para>
        /// A pointer to an array containing n renderbuffer objects to be deleted.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glDeleteRenderbuffers")]
        public static extern void DeleteRenderbuffers(Int32 n, Int32[] renderbuffers);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Delete renderbuffer objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of renderbuffer objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="renderbuffers">
        /// <para>
        /// A pointer to an array containing n renderbuffer objects to be deleted.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glDeleteRenderbuffers")]
        public static extern void DeleteRenderbuffers(Int32 n, ref Int32 renderbuffers);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Delete renderbuffer objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of renderbuffer objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="renderbuffers">
        /// <para>
        /// A pointer to an array containing n renderbuffer objects to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glDeleteRenderbuffers")]
        public static extern unsafe void DeleteRenderbuffers(Int32 n, Int32* renderbuffers);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Delete renderbuffer objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of renderbuffer objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="renderbuffers">
        /// <para>
        /// A pointer to an array containing n renderbuffer objects to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glDeleteRenderbuffers")]
        public static extern void DeleteRenderbuffers(Int32 n, UInt32[] renderbuffers);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Delete renderbuffer objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of renderbuffer objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="renderbuffers">
        /// <para>
        /// A pointer to an array containing n renderbuffer objects to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glDeleteRenderbuffers")]
        public static extern void DeleteRenderbuffers(Int32 n, ref UInt32 renderbuffers);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Delete renderbuffer objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of renderbuffer objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="renderbuffers">
        /// <para>
        /// A pointer to an array containing n renderbuffer objects to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glDeleteRenderbuffers")]
        public static extern unsafe void DeleteRenderbuffers(Int32 n, UInt32* renderbuffers);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Delete named sampler objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of sampler objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="samplers">
        /// <para>
        /// Specifies an array of sampler objects to be deleted.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glDeleteSamplers")]
        public static extern void DeleteSampler(Int32 samplers);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Delete named sampler objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of sampler objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="samplers">
        /// <para>
        /// Specifies an array of sampler objects to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glDeleteSamplers")]
        public static extern void DeleteSampler(UInt32 samplers);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Delete named sampler objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of sampler objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="samplers">
        /// <para>
        /// Specifies an array of sampler objects to be deleted.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glDeleteSamplers")]
        public static extern void DeleteSamplers(Int32 count, Int32[] samplers);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Delete named sampler objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of sampler objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="samplers">
        /// <para>
        /// Specifies an array of sampler objects to be deleted.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glDeleteSamplers")]
        public static extern void DeleteSamplers(Int32 count, ref Int32 samplers);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Delete named sampler objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of sampler objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="samplers">
        /// <para>
        /// Specifies an array of sampler objects to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glDeleteSamplers")]
        public static extern unsafe void DeleteSamplers(Int32 count, Int32* samplers);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Delete named sampler objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of sampler objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="samplers">
        /// <para>
        /// Specifies an array of sampler objects to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glDeleteSamplers")]
        public static extern void DeleteSamplers(Int32 count, UInt32[] samplers);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Delete named sampler objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of sampler objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="samplers">
        /// <para>
        /// Specifies an array of sampler objects to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glDeleteSamplers")]
        public static extern void DeleteSamplers(Int32 count, ref UInt32 samplers);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Delete named sampler objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of sampler objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="samplers">
        /// <para>
        /// Specifies an array of sampler objects to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glDeleteSamplers")]
        public static extern unsafe void DeleteSamplers(Int32 count, UInt32* samplers);

        /// <summary>[requires: v2.0]
        /// Deletes a shader object
        /// </summary>
        /// <param name="shader">
        /// <para>
        /// Specifies the shader object to be deleted.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glDeleteShader")]
        public static extern void DeleteShader(Int32 shader);

        /// <summary>[requires: v2.0]
        /// Deletes a shader object
        /// </summary>
        /// <param name="shader">
        /// <para>
        /// Specifies the shader object to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glDeleteShader")]
        public static extern void DeleteShader(UInt32 shader);

        /// <summary>[requires: v3.2 and ARB_sync|VERSION_3_2]
        /// Delete a sync object
        /// </summary>
        /// <param name="sync">
        /// <para>
        /// The sync object to be deleted.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_sync|VERSION_3_2", Version = "3.2", EntryPoint = "glDeleteSync")]
        public static extern void DeleteSync(IntPtr sync);

        /// <summary>[requires: v1.1]
        /// Delete named textures
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of textures to be deleted.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies an array of textures to be deleted.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glDeleteTextures")]
        public static extern void DeleteTexture(Int32 textures);

        /// <summary>[requires: v1.1]
        /// Delete named textures
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of textures to be deleted.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies an array of textures to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glDeleteTextures")]
        public static extern void DeleteTexture(UInt32 textures);

        /// <summary>[requires: v1.1]
        /// Delete named textures
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of textures to be deleted.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies an array of textures to be deleted.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glDeleteTextures")]
        public static extern void DeleteTextures(Int32 n, Int32[] textures);

        /// <summary>[requires: v1.1]
        /// Delete named textures
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of textures to be deleted.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies an array of textures to be deleted.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glDeleteTextures")]
        public static extern void DeleteTextures(Int32 n, ref Int32 textures);

        /// <summary>[requires: v1.1]
        /// Delete named textures
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of textures to be deleted.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies an array of textures to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glDeleteTextures")]
        public static extern unsafe void DeleteTextures(Int32 n, Int32* textures);

        /// <summary>[requires: v1.1]
        /// Delete named textures
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of textures to be deleted.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies an array of textures to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glDeleteTextures")]
        public static extern void DeleteTextures(Int32 n, UInt32[] textures);

        /// <summary>[requires: v1.1]
        /// Delete named textures
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of textures to be deleted.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies an array of textures to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glDeleteTextures")]
        public static extern void DeleteTextures(Int32 n, ref UInt32 textures);

        /// <summary>[requires: v1.1]
        /// Delete named textures
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of textures to be deleted.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies an array of textures to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glDeleteTextures")]
        public static extern unsafe void DeleteTextures(Int32 n, UInt32* textures);

        /// <summary>[requires: v4.0 and ARB_transform_feedback2|VERSION_4_0]
        /// Delete transform feedback objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of transform feedback objects to delete.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array of names of transform feedback objects to delete.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_transform_feedback2|VERSION_4_0", Version = "4.0", EntryPoint = "glDeleteTransformFeedbacks")]
        public static extern void DeleteTransformFeedback(Int32 ids);

        /// <summary>[requires: v4.0 and ARB_transform_feedback2|VERSION_4_0]
        /// Delete transform feedback objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of transform feedback objects to delete.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array of names of transform feedback objects to delete.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_transform_feedback2|VERSION_4_0", Version = "4.0", EntryPoint = "glDeleteTransformFeedbacks")]
        public static extern void DeleteTransformFeedback(UInt32 ids);

        /// <summary>[requires: v4.0 and ARB_transform_feedback2|VERSION_4_0]
        /// Delete transform feedback objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of transform feedback objects to delete.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array of names of transform feedback objects to delete.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_transform_feedback2|VERSION_4_0", Version = "4.0", EntryPoint = "glDeleteTransformFeedbacks")]
        public static extern void DeleteTransformFeedbacks(Int32 n, Int32[] ids);

        /// <summary>[requires: v4.0 and ARB_transform_feedback2|VERSION_4_0]
        /// Delete transform feedback objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of transform feedback objects to delete.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array of names of transform feedback objects to delete.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_transform_feedback2|VERSION_4_0", Version = "4.0", EntryPoint = "glDeleteTransformFeedbacks")]
        public static extern void DeleteTransformFeedbacks(Int32 n, ref Int32 ids);

        /// <summary>[requires: v4.0 and ARB_transform_feedback2|VERSION_4_0]
        /// Delete transform feedback objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of transform feedback objects to delete.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array of names of transform feedback objects to delete.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_transform_feedback2|VERSION_4_0", Version = "4.0", EntryPoint = "glDeleteTransformFeedbacks")]
        public static extern unsafe void DeleteTransformFeedbacks(Int32 n, Int32* ids);

        /// <summary>[requires: v4.0 and ARB_transform_feedback2|VERSION_4_0]
        /// Delete transform feedback objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of transform feedback objects to delete.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array of names of transform feedback objects to delete.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_transform_feedback2|VERSION_4_0", Version = "4.0", EntryPoint = "glDeleteTransformFeedbacks")]
        public static extern void DeleteTransformFeedbacks(Int32 n, UInt32[] ids);

        /// <summary>[requires: v4.0 and ARB_transform_feedback2|VERSION_4_0]
        /// Delete transform feedback objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of transform feedback objects to delete.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array of names of transform feedback objects to delete.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_transform_feedback2|VERSION_4_0", Version = "4.0", EntryPoint = "glDeleteTransformFeedbacks")]
        public static extern void DeleteTransformFeedbacks(Int32 n, ref UInt32 ids);

        /// <summary>[requires: v4.0 and ARB_transform_feedback2|VERSION_4_0]
        /// Delete transform feedback objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of transform feedback objects to delete.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array of names of transform feedback objects to delete.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_transform_feedback2|VERSION_4_0", Version = "4.0", EntryPoint = "glDeleteTransformFeedbacks")]
        public static extern unsafe void DeleteTransformFeedbacks(Int32 n, UInt32* ids);

        /// <summary>[requires: v3.0 and ARB_vertex_array_object|VERSION_3_0]
        /// Delete vertex array objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of vertex array objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="arrays">
        /// <para>
        /// Specifies the address of an array containing the n names of the objects to be deleted.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_vertex_array_object|VERSION_3_0", Version = "3.0", EntryPoint = "glDeleteVertexArrays")]
        public static extern void DeleteVertexArray(Int32 arrays);

        /// <summary>[requires: v3.0 and ARB_vertex_array_object|VERSION_3_0]
        /// Delete vertex array objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of vertex array objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="arrays">
        /// <para>
        /// Specifies the address of an array containing the n names of the objects to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_array_object|VERSION_3_0", Version = "3.0", EntryPoint = "glDeleteVertexArrays")]
        public static extern void DeleteVertexArray(UInt32 arrays);

        /// <summary>[requires: v3.0 and ARB_vertex_array_object|VERSION_3_0]
        /// Delete vertex array objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of vertex array objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="arrays">
        /// <para>
        /// Specifies the address of an array containing the n names of the objects to be deleted.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_vertex_array_object|VERSION_3_0", Version = "3.0", EntryPoint = "glDeleteVertexArrays")]
        public static extern void DeleteVertexArrays(Int32 n, Int32[] arrays);

        /// <summary>[requires: v3.0 and ARB_vertex_array_object|VERSION_3_0]
        /// Delete vertex array objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of vertex array objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="arrays">
        /// <para>
        /// Specifies the address of an array containing the n names of the objects to be deleted.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_vertex_array_object|VERSION_3_0", Version = "3.0", EntryPoint = "glDeleteVertexArrays")]
        public static extern void DeleteVertexArrays(Int32 n, ref Int32 arrays);

        /// <summary>[requires: v3.0 and ARB_vertex_array_object|VERSION_3_0]
        /// Delete vertex array objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of vertex array objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="arrays">
        /// <para>
        /// Specifies the address of an array containing the n names of the objects to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_array_object|VERSION_3_0", Version = "3.0", EntryPoint = "glDeleteVertexArrays")]
        public static extern unsafe void DeleteVertexArrays(Int32 n, Int32* arrays);

        /// <summary>[requires: v3.0 and ARB_vertex_array_object|VERSION_3_0]
        /// Delete vertex array objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of vertex array objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="arrays">
        /// <para>
        /// Specifies the address of an array containing the n names of the objects to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_array_object|VERSION_3_0", Version = "3.0", EntryPoint = "glDeleteVertexArrays")]
        public static extern void DeleteVertexArrays(Int32 n, UInt32[] arrays);

        /// <summary>[requires: v3.0 and ARB_vertex_array_object|VERSION_3_0]
        /// Delete vertex array objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of vertex array objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="arrays">
        /// <para>
        /// Specifies the address of an array containing the n names of the objects to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_array_object|VERSION_3_0", Version = "3.0", EntryPoint = "glDeleteVertexArrays")]
        public static extern void DeleteVertexArrays(Int32 n, ref UInt32 arrays);

        /// <summary>[requires: v3.0 and ARB_vertex_array_object|VERSION_3_0]
        /// Delete vertex array objects
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of vertex array objects to be deleted.
        /// </para>
        /// </param>
        /// <param name="arrays">
        /// <para>
        /// Specifies the address of an array containing the n names of the objects to be deleted.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_array_object|VERSION_3_0", Version = "3.0", EntryPoint = "glDeleteVertexArrays")]
        public static extern unsafe void DeleteVertexArrays(Int32 n, UInt32* arrays);

        /// <summary>[requires: v1.0]
        /// Specify the value used for depth buffer comparisons
        /// </summary>
        /// <param name="func">
        /// <para>
        /// Specifies the depth comparison function. Symbolic constants GL_NEVER, GL_LESS, GL_EQUAL, GL_LEQUAL, GL_GREATER, GL_NOTEQUAL, GL_GEQUAL, and GL_ALWAYS are accepted. The initial value is GL_LESS.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glDepthFunc")]
        public static extern void DepthFunc(OpenTK.Graphics.OpenGL.DepthFunction func);

        /// <summary>[requires: v1.0]
        /// Enable or disable writing into the depth buffer
        /// </summary>
        /// <param name="flag">
        /// <para>
        /// Specifies whether the depth buffer is enabled for writing. If flag is GL_FALSE, depth buffer writing is disabled. Otherwise, it is enabled. Initially, depth buffer writing is enabled.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glDepthMask")]
        public static extern void DepthMask(bool flag);

        /// <summary>[requires: v1.0]
        /// Specify mapping of depth values from normalized device coordinates to window coordinates
        /// </summary>
        /// <param name="nearVal">
        /// <para>
        /// Specifies the mapping of the near clipping plane to window coordinates. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="farVal">
        /// <para>
        /// Specifies the mapping of the far clipping plane to window coordinates. The initial value is 1.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glDepthRange")]
        public static extern void DepthRange(Double near, Double far);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Specify mapping of depth values from normalized device coordinates to window coordinates for a specified set of viewports
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the index of the first viewport whose depth range to update.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of viewports whose depth range to update.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Specifies the address of an array containing the near and far values for the depth range of each modified viewport.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glDepthRangeArrayv")]
        public static extern void DepthRangeArray(Int32 first, Int32 count, Double[] v);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Specify mapping of depth values from normalized device coordinates to window coordinates for a specified set of viewports
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the index of the first viewport whose depth range to update.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of viewports whose depth range to update.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Specifies the address of an array containing the near and far values for the depth range of each modified viewport.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glDepthRangeArrayv")]
        public static extern void DepthRangeArray(Int32 first, Int32 count, ref Double v);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Specify mapping of depth values from normalized device coordinates to window coordinates for a specified set of viewports
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the index of the first viewport whose depth range to update.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of viewports whose depth range to update.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Specifies the address of an array containing the near and far values for the depth range of each modified viewport.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glDepthRangeArrayv")]
        public static extern unsafe void DepthRangeArray(Int32 first, Int32 count, Double* v);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Specify mapping of depth values from normalized device coordinates to window coordinates for a specified set of viewports
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the index of the first viewport whose depth range to update.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of viewports whose depth range to update.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Specifies the address of an array containing the near and far values for the depth range of each modified viewport.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glDepthRangeArrayv")]
        public static extern void DepthRangeArray(UInt32 first, Int32 count, Double[] v);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Specify mapping of depth values from normalized device coordinates to window coordinates for a specified set of viewports
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the index of the first viewport whose depth range to update.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of viewports whose depth range to update.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Specifies the address of an array containing the near and far values for the depth range of each modified viewport.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glDepthRangeArrayv")]
        public static extern void DepthRangeArray(UInt32 first, Int32 count, ref Double v);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Specify mapping of depth values from normalized device coordinates to window coordinates for a specified set of viewports
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the index of the first viewport whose depth range to update.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of viewports whose depth range to update.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Specifies the address of an array containing the near and far values for the depth range of each modified viewport.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glDepthRangeArrayv")]
        public static extern unsafe void DepthRangeArray(UInt32 first, Int32 count, Double* v);

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Specify mapping of depth values from normalized device coordinates to window coordinates
        /// </summary>
        /// <param name="nearVal">
        /// <para>
        /// Specifies the mapping of the near clipping plane to window coordinates. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="farVal">
        /// <para>
        /// Specifies the mapping of the far clipping plane to window coordinates. The initial value is 1.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glDepthRangef")]
        public static extern void DepthRange(Single n, Single f);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Specify mapping of depth values from normalized device coordinates to window coordinates for a specified viewport
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the viewport whose depth range to update.
        /// </para>
        /// </param>
        /// <param name="nearVal">
        /// <para>
        /// Specifies the mapping of the near clipping plane to window coordinates. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="farVal">
        /// <para>
        /// Specifies the mapping of the far clipping plane to window coordinates. The initial value is 1.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glDepthRangeIndexed")]
        public static extern void DepthRangeIndexed(Int32 index, Double n, Double f);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Specify mapping of depth values from normalized device coordinates to window coordinates for a specified viewport
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the viewport whose depth range to update.
        /// </para>
        /// </param>
        /// <param name="nearVal">
        /// <para>
        /// Specifies the mapping of the near clipping plane to window coordinates. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="farVal">
        /// <para>
        /// Specifies the mapping of the far clipping plane to window coordinates. The initial value is 1.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glDepthRangeIndexed")]
        public static extern void DepthRangeIndexed(UInt32 index, Double n, Double f);

        /// <summary>[requires: v2.0]
        /// Detaches a shader object from a program object to which it is attached
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object from which to detach the shader object.
        /// </para>
        /// </param>
        /// <param name="shader">
        /// <para>
        /// Specifies the shader object to be detached.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glDetachShader")]
        public static extern void DetachShader(Int32 program, Int32 shader);

        /// <summary>[requires: v2.0]
        /// Detaches a shader object from a program object to which it is attached
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object from which to detach the shader object.
        /// </para>
        /// </param>
        /// <param name="shader">
        /// <para>
        /// Specifies the shader object to be detached.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glDetachShader")]
        public static extern void DetachShader(UInt32 program, UInt32 shader);

        /// <summary>[requires: v1.0]</summary>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glDisable")]
        public static extern void Disable(OpenTK.Graphics.OpenGL.EnableCap cap);

        /// <summary>[requires: v1.1][deprecated: v3.2]</summary>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glDisableClientState")]
        public static extern void DisableClientState(OpenTK.Graphics.OpenGL.ArrayCap array);

        /// <summary>[requires: v3.0]</summary>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glDisablei")]
        public static extern void Disable(OpenTK.Graphics.OpenGL.IndexedEnableCap target, Int32 index);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glDisablei")]
        public static extern void Disable(OpenTK.Graphics.OpenGL.IndexedEnableCap target, UInt32 index);

        /// <summary>[requires: v2.0]</summary>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glDisableVertexAttribArray")]
        public static extern void DisableVertexAttribArray(Int32 index);

        /// <summary>[requires: v2.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glDisableVertexAttribArray")]
        public static extern void DisableVertexAttribArray(UInt32 index);

        /// <summary>[requires: v4.3 and ARB_compute_shader|VERSION_4_3]
        /// Launch one or more compute work groups
        /// </summary>
        /// <param name="num_groups_x">
        /// <para>
        /// The number of work groups to be launched in the X dimension.
        /// </para>
        /// </param>
        /// <param name="num_groups_y">
        /// <para>
        /// The number of work groups to be launched in the Y dimension.
        /// </para>
        /// </param>
        /// <param name="num_groups_z">
        /// <para>
        /// The number of work groups to be launched in the Z dimension.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_compute_shader|VERSION_4_3", Version = "4.3", EntryPoint = "glDispatchCompute")]
        public static extern void DispatchCompute(Int32 num_groups_x, Int32 num_groups_y, Int32 num_groups_z);

        /// <summary>[requires: v4.3 and ARB_compute_shader|VERSION_4_3]
        /// Launch one or more compute work groups
        /// </summary>
        /// <param name="num_groups_x">
        /// <para>
        /// The number of work groups to be launched in the X dimension.
        /// </para>
        /// </param>
        /// <param name="num_groups_y">
        /// <para>
        /// The number of work groups to be launched in the Y dimension.
        /// </para>
        /// </param>
        /// <param name="num_groups_z">
        /// <para>
        /// The number of work groups to be launched in the Z dimension.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_compute_shader|VERSION_4_3", Version = "4.3", EntryPoint = "glDispatchCompute")]
        public static extern void DispatchCompute(UInt32 num_groups_x, UInt32 num_groups_y, UInt32 num_groups_z);

        /// <summary>[requires: v4.3 and ARB_compute_shader|VERSION_4_3]
        /// Launch one or more compute work groups using parameters stored in a buffer
        /// </summary>
        /// <param name="indirect">
        /// <para>
        /// The offset into the buffer object currently bound to the GL_DISPATCH_INDIRECT_BUFFER buffer target at which the dispatch parameters are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_compute_shader|VERSION_4_3", Version = "4.3", EntryPoint = "glDispatchComputeIndirect")]
        public static extern void DispatchComputeIndirect(IntPtr indirect);

        /// <summary>[requires: v1.1]
        /// Render primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="first">
        /// <para>
        /// Specifies the starting index in the enabled arrays.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of indices to be rendered.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glDrawArrays")]
        public static extern void DrawArrays(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 first, Int32 count);

        /// <summary>[requires: v1.1]
        /// Render primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="first">
        /// <para>
        /// Specifies the starting index in the enabled arrays.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of indices to be rendered.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glDrawArrays")]
        public static extern void DrawArrays(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 first, Int32 count);

        /// <summary>[requires: v4.0 and ARB_draw_indirect|VERSION_4_0]
        /// Render primitives from array data, taking parameters from memory
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="indirect">
        /// <para>
        /// Specifies the address of a structure containing the draw parameters.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_draw_indirect|VERSION_4_0", Version = "4.0", EntryPoint = "glDrawArraysIndirect")]
        public static extern void DrawArraysIndirect(OpenTK.Graphics.OpenGL.PrimitiveType mode, IntPtr indirect);

        /// <summary>[requires: v4.0 and ARB_draw_indirect|VERSION_4_0]
        /// Render primitives from array data, taking parameters from memory
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="indirect">
        /// <para>
        /// Specifies the address of a structure containing the draw parameters.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_draw_indirect|VERSION_4_0", Version = "4.0", EntryPoint = "glDrawArraysIndirect")]
        public static extern void DrawArraysIndirect<T1>(OpenTK.Graphics.OpenGL.PrimitiveType mode, [InAttribute, OutAttribute] T1[] indirect)
            where T1 : struct
        ;

        /// <summary>[requires: v4.0 and ARB_draw_indirect|VERSION_4_0]
        /// Render primitives from array data, taking parameters from memory
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="indirect">
        /// <para>
        /// Specifies the address of a structure containing the draw parameters.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_draw_indirect|VERSION_4_0", Version = "4.0", EntryPoint = "glDrawArraysIndirect")]
        public static extern void DrawArraysIndirect<T1>(OpenTK.Graphics.OpenGL.PrimitiveType mode, [InAttribute, OutAttribute] T1[,] indirect)
            where T1 : struct
        ;

        /// <summary>[requires: v4.0 and ARB_draw_indirect|VERSION_4_0]
        /// Render primitives from array data, taking parameters from memory
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="indirect">
        /// <para>
        /// Specifies the address of a structure containing the draw parameters.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_draw_indirect|VERSION_4_0", Version = "4.0", EntryPoint = "glDrawArraysIndirect")]
        public static extern void DrawArraysIndirect<T1>(OpenTK.Graphics.OpenGL.PrimitiveType mode, [InAttribute, OutAttribute] T1[,,] indirect)
            where T1 : struct
        ;

        /// <summary>[requires: v4.0 and ARB_draw_indirect|VERSION_4_0]
        /// Render primitives from array data, taking parameters from memory
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="indirect">
        /// <para>
        /// Specifies the address of a structure containing the draw parameters.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_draw_indirect|VERSION_4_0", Version = "4.0", EntryPoint = "glDrawArraysIndirect")]
        public static extern void DrawArraysIndirect<T1>(OpenTK.Graphics.OpenGL.PrimitiveType mode, [InAttribute, OutAttribute] ref T1 indirect)
            where T1 : struct
        ;

        /// <summary>[requires: v3.1]
        /// Draw multiple instances of a range of elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="first">
        /// <para>
        /// Specifies the starting index in the enabled arrays.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of indices to be rendered.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the specified range of indices to be rendered.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "VERSION_3_1", Version = "3.1", EntryPoint = "glDrawArraysInstanced")]
        public static extern void DrawArraysInstanced(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 first, Int32 count, Int32 instancecount);

        /// <summary>[requires: v3.1]
        /// Draw multiple instances of a range of elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="first">
        /// <para>
        /// Specifies the starting index in the enabled arrays.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of indices to be rendered.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the specified range of indices to be rendered.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_3_1", Version = "3.1", EntryPoint = "glDrawArraysInstanced")]
        public static extern void DrawArraysInstanced(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 first, Int32 count, Int32 instancecount);

        /// <summary>[requires: v4.2 and ARB_base_instance|VERSION_4_2]
        /// Draw multiple instances of a range of elements with offset applied to instanced attributes
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="first">
        /// <para>
        /// Specifies the starting index in the enabled arrays.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of indices to be rendered.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the specified range of indices to be rendered.
        /// </para>
        /// </param>
        /// <param name="baseinstance">
        /// <para>
        /// Specifies the base instance for use in fetching instanced vertex attributes.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_base_instance|VERSION_4_2", Version = "4.2", EntryPoint = "glDrawArraysInstancedBaseInstance")]
        public static extern void DrawArraysInstancedBaseInstance(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 first, Int32 count, Int32 instancecount, Int32 baseinstance);

        /// <summary>[requires: v4.2 and ARB_base_instance|VERSION_4_2]
        /// Draw multiple instances of a range of elements with offset applied to instanced attributes
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="first">
        /// <para>
        /// Specifies the starting index in the enabled arrays.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of indices to be rendered.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the specified range of indices to be rendered.
        /// </para>
        /// </param>
        /// <param name="baseinstance">
        /// <para>
        /// Specifies the base instance for use in fetching instanced vertex attributes.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_base_instance|VERSION_4_2", Version = "4.2", EntryPoint = "glDrawArraysInstancedBaseInstance")]
        public static extern void DrawArraysInstancedBaseInstance(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 first, Int32 count, Int32 instancecount, UInt32 baseinstance);

        /// <summary>[requires: v1.0]
        /// Specify which color buffers are to be drawn into
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies up to four color buffers to be drawn into. Symbolic constants GL_NONE, GL_FRONT_LEFT, GL_FRONT_RIGHT, GL_BACK_LEFT, GL_BACK_RIGHT, GL_FRONT, GL_BACK, GL_LEFT, GL_RIGHT, and GL_FRONT_AND_BACK are accepted. The initial value is GL_FRONT for single-buffered contexts, and GL_BACK for double-buffered contexts.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glDrawBuffer")]
        public static extern void DrawBuffer(OpenTK.Graphics.OpenGL.DrawBufferMode mode);

        /// <summary>[requires: v2.0]
        /// Specifies a list of color buffers to be drawn into
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of buffers in bufs.
        /// </para>
        /// </param>
        /// <param name="bufs">
        /// <para>
        /// Points to an array of symbolic constants specifying the buffers into which fragment colors or data values will be written.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glDrawBuffers")]
        public static extern void DrawBuffers(Int32 n, OpenTK.Graphics.OpenGL.DrawBuffersEnum[] bufs);

        /// <summary>[requires: v2.0]
        /// Specifies a list of color buffers to be drawn into
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of buffers in bufs.
        /// </para>
        /// </param>
        /// <param name="bufs">
        /// <para>
        /// Points to an array of symbolic constants specifying the buffers into which fragment colors or data values will be written.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glDrawBuffers")]
        public static extern void DrawBuffers(Int32 n, ref OpenTK.Graphics.OpenGL.DrawBuffersEnum bufs);

        /// <summary>[requires: v2.0]
        /// Specifies a list of color buffers to be drawn into
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of buffers in bufs.
        /// </para>
        /// </param>
        /// <param name="bufs">
        /// <para>
        /// Points to an array of symbolic constants specifying the buffers into which fragment colors or data values will be written.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glDrawBuffers")]
        public static extern unsafe void DrawBuffers(Int32 n, OpenTK.Graphics.OpenGL.DrawBuffersEnum* bufs);

        /// <summary>[requires: v1.1]
        /// Render primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glDrawElements")]
        public static extern void DrawElements(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, Int32 indices);

        /// <summary>[requires: v1.1]
        /// Render primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glDrawElements")]
        public static extern void DrawElements(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices);

        /// <summary>[requires: v1.1]
        /// Render primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glDrawElements")]
        public static extern void DrawElements<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices)
            where T3 : struct
        ;

        /// <summary>[requires: v1.1]
        /// Render primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glDrawElements")]
        public static extern void DrawElements<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices)
            where T3 : struct
        ;

        /// <summary>[requires: v1.1]
        /// Render primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glDrawElements")]
        public static extern void DrawElements<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices)
            where T3 : struct
        ;

        /// <summary>[requires: v1.1]
        /// Render primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glDrawElements")]
        public static extern void DrawElements<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices)
            where T3 : struct
        ;

        /// <summary>[requires: v1.1]
        /// Render primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glDrawElements")]
        public static extern void DrawElements(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, Int32 indices);

        /// <summary>[requires: v1.1]
        /// Render primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glDrawElements")]
        public static extern void DrawElements(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices);

        /// <summary>[requires: v1.1]
        /// Render primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glDrawElements")]
        public static extern void DrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices)
            where T3 : struct
        ;

        /// <summary>[requires: v1.1]
        /// Render primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glDrawElements")]
        public static extern void DrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices)
            where T3 : struct
        ;

        /// <summary>[requires: v1.1]
        /// Render primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glDrawElements")]
        public static extern void DrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices)
            where T3 : struct
        ;

        /// <summary>[requires: v1.1]
        /// Render primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glDrawElements")]
        public static extern void DrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawElementsBaseVertex")]
        public static extern void DrawElementsBaseVertex(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 basevertex);

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawElementsBaseVertex")]
        public static extern void DrawElementsBaseVertex<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices, Int32 basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawElementsBaseVertex")]
        public static extern void DrawElementsBaseVertex<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices, Int32 basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawElementsBaseVertex")]
        public static extern void DrawElementsBaseVertex<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices, Int32 basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawElementsBaseVertex")]
        public static extern void DrawElementsBaseVertex<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices, Int32 basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawElementsBaseVertex")]
        public static extern void DrawElementsBaseVertex(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 basevertex);

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawElementsBaseVertex")]
        public static extern void DrawElementsBaseVertex<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices, Int32 basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawElementsBaseVertex")]
        public static extern void DrawElementsBaseVertex<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices, Int32 basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawElementsBaseVertex")]
        public static extern void DrawElementsBaseVertex<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices, Int32 basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawElementsBaseVertex")]
        public static extern void DrawElementsBaseVertex<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices, Int32 basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v4.0 and ARB_draw_indirect|VERSION_4_0]
        /// Render indexed primitives from array data, taking parameters from memory
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of data in the buffer bound to the GL_ELEMENT_ARRAY_BUFFER binding.
        /// </para>
        /// </param>
        /// <param name="indirect">
        /// <para>
        /// Specifies the address of a structure containing the draw parameters.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_draw_indirect|VERSION_4_0", Version = "4.0", EntryPoint = "glDrawElementsIndirect")]
        public static extern void DrawElementsIndirect(OpenTK.Graphics.OpenGL.PrimitiveType mode, OpenTK.Graphics.OpenGL.All type, IntPtr indirect);

        /// <summary>[requires: v4.0 and ARB_draw_indirect|VERSION_4_0]
        /// Render indexed primitives from array data, taking parameters from memory
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of data in the buffer bound to the GL_ELEMENT_ARRAY_BUFFER binding.
        /// </para>
        /// </param>
        /// <param name="indirect">
        /// <para>
        /// Specifies the address of a structure containing the draw parameters.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_draw_indirect|VERSION_4_0", Version = "4.0", EntryPoint = "glDrawElementsIndirect")]
        public static extern void DrawElementsIndirect<T2>(OpenTK.Graphics.OpenGL.PrimitiveType mode, OpenTK.Graphics.OpenGL.All type, [InAttribute, OutAttribute] T2[] indirect)
            where T2 : struct
        ;

        /// <summary>[requires: v4.0 and ARB_draw_indirect|VERSION_4_0]
        /// Render indexed primitives from array data, taking parameters from memory
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of data in the buffer bound to the GL_ELEMENT_ARRAY_BUFFER binding.
        /// </para>
        /// </param>
        /// <param name="indirect">
        /// <para>
        /// Specifies the address of a structure containing the draw parameters.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_draw_indirect|VERSION_4_0", Version = "4.0", EntryPoint = "glDrawElementsIndirect")]
        public static extern void DrawElementsIndirect<T2>(OpenTK.Graphics.OpenGL.PrimitiveType mode, OpenTK.Graphics.OpenGL.All type, [InAttribute, OutAttribute] T2[,] indirect)
            where T2 : struct
        ;

        /// <summary>[requires: v4.0 and ARB_draw_indirect|VERSION_4_0]
        /// Render indexed primitives from array data, taking parameters from memory
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of data in the buffer bound to the GL_ELEMENT_ARRAY_BUFFER binding.
        /// </para>
        /// </param>
        /// <param name="indirect">
        /// <para>
        /// Specifies the address of a structure containing the draw parameters.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_draw_indirect|VERSION_4_0", Version = "4.0", EntryPoint = "glDrawElementsIndirect")]
        public static extern void DrawElementsIndirect<T2>(OpenTK.Graphics.OpenGL.PrimitiveType mode, OpenTK.Graphics.OpenGL.All type, [InAttribute, OutAttribute] T2[,,] indirect)
            where T2 : struct
        ;

        /// <summary>[requires: v4.0 and ARB_draw_indirect|VERSION_4_0]
        /// Render indexed primitives from array data, taking parameters from memory
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of data in the buffer bound to the GL_ELEMENT_ARRAY_BUFFER binding.
        /// </para>
        /// </param>
        /// <param name="indirect">
        /// <para>
        /// Specifies the address of a structure containing the draw parameters.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_draw_indirect|VERSION_4_0", Version = "4.0", EntryPoint = "glDrawElementsIndirect")]
        public static extern void DrawElementsIndirect<T2>(OpenTK.Graphics.OpenGL.PrimitiveType mode, OpenTK.Graphics.OpenGL.All type, [InAttribute, OutAttribute] ref T2 indirect)
            where T2 : struct
        ;

        /// <summary>[requires: v3.1]
        /// Draw multiple instances of a set of elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the specified range of indices to be rendered.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "VERSION_3_1", Version = "3.1", EntryPoint = "glDrawElementsInstanced")]
        public static extern void DrawElementsInstanced(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 instancecount);

        /// <summary>[requires: v3.1]
        /// Draw multiple instances of a set of elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the specified range of indices to be rendered.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "VERSION_3_1", Version = "3.1", EntryPoint = "glDrawElementsInstanced")]
        public static extern void DrawElementsInstanced<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices, Int32 instancecount)
            where T3 : struct
        ;

        /// <summary>[requires: v3.1]
        /// Draw multiple instances of a set of elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the specified range of indices to be rendered.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "VERSION_3_1", Version = "3.1", EntryPoint = "glDrawElementsInstanced")]
        public static extern void DrawElementsInstanced<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices, Int32 instancecount)
            where T3 : struct
        ;

        /// <summary>[requires: v3.1]
        /// Draw multiple instances of a set of elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the specified range of indices to be rendered.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "VERSION_3_1", Version = "3.1", EntryPoint = "glDrawElementsInstanced")]
        public static extern void DrawElementsInstanced<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices, Int32 instancecount)
            where T3 : struct
        ;

        /// <summary>[requires: v3.1]
        /// Draw multiple instances of a set of elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the specified range of indices to be rendered.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "VERSION_3_1", Version = "3.1", EntryPoint = "glDrawElementsInstanced")]
        public static extern void DrawElementsInstanced<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices, Int32 instancecount)
            where T3 : struct
        ;

        /// <summary>[requires: v3.1]
        /// Draw multiple instances of a set of elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the specified range of indices to be rendered.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_3_1", Version = "3.1", EntryPoint = "glDrawElementsInstanced")]
        public static extern void DrawElementsInstanced(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 instancecount);

        /// <summary>[requires: v3.1]
        /// Draw multiple instances of a set of elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the specified range of indices to be rendered.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_3_1", Version = "3.1", EntryPoint = "glDrawElementsInstanced")]
        public static extern void DrawElementsInstanced<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices, Int32 instancecount)
            where T3 : struct
        ;

        /// <summary>[requires: v3.1]
        /// Draw multiple instances of a set of elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the specified range of indices to be rendered.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_3_1", Version = "3.1", EntryPoint = "glDrawElementsInstanced")]
        public static extern void DrawElementsInstanced<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices, Int32 instancecount)
            where T3 : struct
        ;

        /// <summary>[requires: v3.1]
        /// Draw multiple instances of a set of elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the specified range of indices to be rendered.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_3_1", Version = "3.1", EntryPoint = "glDrawElementsInstanced")]
        public static extern void DrawElementsInstanced<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices, Int32 instancecount)
            where T3 : struct
        ;

        /// <summary>[requires: v3.1]
        /// Draw multiple instances of a set of elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the specified range of indices to be rendered.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_3_1", Version = "3.1", EntryPoint = "glDrawElementsInstanced")]
        public static extern void DrawElementsInstanced<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices, Int32 instancecount)
            where T3 : struct
        ;

        /// <summary>[requires: v4.2 and ARB_base_instance|VERSION_4_2]
        /// Draw multiple instances of a set of elements with offset applied to instanced attributes
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the specified range of indices to be rendered.
        /// </para>
        /// </param>
        /// <param name="baseinstance">
        /// <para>
        /// Specifies the base instance for use in fetching instanced vertex attributes.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_base_instance|VERSION_4_2", Version = "4.2", EntryPoint = "glDrawElementsInstancedBaseInstance")]
        public static extern void DrawElementsInstancedBaseInstance(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 instancecount, Int32 baseinstance);

        /// <summary>[requires: v4.2 and ARB_base_instance|VERSION_4_2]
        /// Draw multiple instances of a set of elements with offset applied to instanced attributes
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the specified range of indices to be rendered.
        /// </para>
        /// </param>
        /// <param name="baseinstance">
        /// <para>
        /// Specifies the base instance for use in fetching instanced vertex attributes.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_base_instance|VERSION_4_2", Version = "4.2", EntryPoint = "glDrawElementsInstancedBaseInstance")]
        public static extern void DrawElementsInstancedBaseInstance(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 instancecount, UInt32 baseinstance);

        /// <summary>[requires: v4.2 and ARB_base_instance|VERSION_4_2]
        /// Draw multiple instances of a set of elements with offset applied to instanced attributes
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the specified range of indices to be rendered.
        /// </para>
        /// </param>
        /// <param name="baseinstance">
        /// <para>
        /// Specifies the base instance for use in fetching instanced vertex attributes.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_base_instance|VERSION_4_2", Version = "4.2", EntryPoint = "glDrawElementsInstancedBaseInstance")]
        public static extern void DrawElementsInstancedBaseInstance<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices, Int32 instancecount, Int32 baseinstance)
            where T3 : struct
        ;

        /// <summary>[requires: v4.2 and ARB_base_instance|VERSION_4_2]
        /// Draw multiple instances of a set of elements with offset applied to instanced attributes
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the specified range of indices to be rendered.
        /// </para>
        /// </param>
        /// <param name="baseinstance">
        /// <para>
        /// Specifies the base instance for use in fetching instanced vertex attributes.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_base_instance|VERSION_4_2", Version = "4.2", EntryPoint = "glDrawElementsInstancedBaseInstance")]
        public static extern void DrawElementsInstancedBaseInstance<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices, Int32 instancecount, UInt32 baseinstance)
            where T3 : struct
        ;

        /// <summary>[requires: v4.2 and ARB_base_instance|VERSION_4_2]
        /// Draw multiple instances of a set of elements with offset applied to instanced attributes
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the specified range of indices to be rendered.
        /// </para>
        /// </param>
        /// <param name="baseinstance">
        /// <para>
        /// Specifies the base instance for use in fetching instanced vertex attributes.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_base_instance|VERSION_4_2", Version = "4.2", EntryPoint = "glDrawElementsInstancedBaseInstance")]
        public static extern void DrawElementsInstancedBaseInstance<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices, Int32 instancecount, Int32 baseinstance)
            where T3 : struct
        ;

        /// <summary>[requires: v4.2 and ARB_base_instance|VERSION_4_2]
        /// Draw multiple instances of a set of elements with offset applied to instanced attributes
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the specified range of indices to be rendered.
        /// </para>
        /// </param>
        /// <param name="baseinstance">
        /// <para>
        /// Specifies the base instance for use in fetching instanced vertex attributes.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_base_instance|VERSION_4_2", Version = "4.2", EntryPoint = "glDrawElementsInstancedBaseInstance")]
        public static extern void DrawElementsInstancedBaseInstance<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices, Int32 instancecount, UInt32 baseinstance)
            where T3 : struct
        ;

        /// <summary>[requires: v4.2 and ARB_base_instance|VERSION_4_2]
        /// Draw multiple instances of a set of elements with offset applied to instanced attributes
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the specified range of indices to be rendered.
        /// </para>
        /// </param>
        /// <param name="baseinstance">
        /// <para>
        /// Specifies the base instance for use in fetching instanced vertex attributes.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_base_instance|VERSION_4_2", Version = "4.2", EntryPoint = "glDrawElementsInstancedBaseInstance")]
        public static extern void DrawElementsInstancedBaseInstance<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices, Int32 instancecount, Int32 baseinstance)
            where T3 : struct
        ;

        /// <summary>[requires: v4.2 and ARB_base_instance|VERSION_4_2]
        /// Draw multiple instances of a set of elements with offset applied to instanced attributes
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the specified range of indices to be rendered.
        /// </para>
        /// </param>
        /// <param name="baseinstance">
        /// <para>
        /// Specifies the base instance for use in fetching instanced vertex attributes.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_base_instance|VERSION_4_2", Version = "4.2", EntryPoint = "glDrawElementsInstancedBaseInstance")]
        public static extern void DrawElementsInstancedBaseInstance<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices, Int32 instancecount, UInt32 baseinstance)
            where T3 : struct
        ;

        /// <summary>[requires: v4.2 and ARB_base_instance|VERSION_4_2]
        /// Draw multiple instances of a set of elements with offset applied to instanced attributes
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the specified range of indices to be rendered.
        /// </para>
        /// </param>
        /// <param name="baseinstance">
        /// <para>
        /// Specifies the base instance for use in fetching instanced vertex attributes.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_base_instance|VERSION_4_2", Version = "4.2", EntryPoint = "glDrawElementsInstancedBaseInstance")]
        public static extern void DrawElementsInstancedBaseInstance<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices, Int32 instancecount, Int32 baseinstance)
            where T3 : struct
        ;

        /// <summary>[requires: v4.2 and ARB_base_instance|VERSION_4_2]
        /// Draw multiple instances of a set of elements with offset applied to instanced attributes
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the specified range of indices to be rendered.
        /// </para>
        /// </param>
        /// <param name="baseinstance">
        /// <para>
        /// Specifies the base instance for use in fetching instanced vertex attributes.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_base_instance|VERSION_4_2", Version = "4.2", EntryPoint = "glDrawElementsInstancedBaseInstance")]
        public static extern void DrawElementsInstancedBaseInstance<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices, Int32 instancecount, UInt32 baseinstance)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple instances of a set of primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the indexed geometry that should be drawn.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawElementsInstancedBaseVertex")]
        public static extern void DrawElementsInstancedBaseVertex(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 instancecount, Int32 basevertex);

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple instances of a set of primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the indexed geometry that should be drawn.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawElementsInstancedBaseVertex")]
        public static extern void DrawElementsInstancedBaseVertex<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices, Int32 instancecount, Int32 basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple instances of a set of primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the indexed geometry that should be drawn.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawElementsInstancedBaseVertex")]
        public static extern void DrawElementsInstancedBaseVertex<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices, Int32 instancecount, Int32 basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple instances of a set of primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the indexed geometry that should be drawn.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawElementsInstancedBaseVertex")]
        public static extern void DrawElementsInstancedBaseVertex<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices, Int32 instancecount, Int32 basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple instances of a set of primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the indexed geometry that should be drawn.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawElementsInstancedBaseVertex")]
        public static extern void DrawElementsInstancedBaseVertex<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices, Int32 instancecount, Int32 basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple instances of a set of primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the indexed geometry that should be drawn.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawElementsInstancedBaseVertex")]
        public static extern void DrawElementsInstancedBaseVertex(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 instancecount, Int32 basevertex);

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple instances of a set of primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the indexed geometry that should be drawn.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawElementsInstancedBaseVertex")]
        public static extern void DrawElementsInstancedBaseVertex<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices, Int32 instancecount, Int32 basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple instances of a set of primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the indexed geometry that should be drawn.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawElementsInstancedBaseVertex")]
        public static extern void DrawElementsInstancedBaseVertex<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices, Int32 instancecount, Int32 basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple instances of a set of primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the indexed geometry that should be drawn.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawElementsInstancedBaseVertex")]
        public static extern void DrawElementsInstancedBaseVertex<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices, Int32 instancecount, Int32 basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple instances of a set of primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the indexed geometry that should be drawn.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawElementsInstancedBaseVertex")]
        public static extern void DrawElementsInstancedBaseVertex<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices, Int32 instancecount, Int32 basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v4.2 and ARB_base_instance|VERSION_4_2]
        /// Render multiple instances of a set of primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the indexed geometry that should be drawn.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        /// <param name="baseinstance">
        /// <para>
        /// Specifies the base instance for use in fetching instanced vertex attributes.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_base_instance|VERSION_4_2", Version = "4.2", EntryPoint = "glDrawElementsInstancedBaseVertexBaseInstance")]
        public static extern void DrawElementsInstancedBaseVertexBaseInstance(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 instancecount, Int32 basevertex, Int32 baseinstance);

        /// <summary>[requires: v4.2 and ARB_base_instance|VERSION_4_2]
        /// Render multiple instances of a set of primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the indexed geometry that should be drawn.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        /// <param name="baseinstance">
        /// <para>
        /// Specifies the base instance for use in fetching instanced vertex attributes.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_base_instance|VERSION_4_2", Version = "4.2", EntryPoint = "glDrawElementsInstancedBaseVertexBaseInstance")]
        public static extern void DrawElementsInstancedBaseVertexBaseInstance(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 instancecount, Int32 basevertex, UInt32 baseinstance);

        /// <summary>[requires: v4.2 and ARB_base_instance|VERSION_4_2]
        /// Render multiple instances of a set of primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the indexed geometry that should be drawn.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        /// <param name="baseinstance">
        /// <para>
        /// Specifies the base instance for use in fetching instanced vertex attributes.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_base_instance|VERSION_4_2", Version = "4.2", EntryPoint = "glDrawElementsInstancedBaseVertexBaseInstance")]
        public static extern void DrawElementsInstancedBaseVertexBaseInstance<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices, Int32 instancecount, Int32 basevertex, Int32 baseinstance)
            where T3 : struct
        ;

        /// <summary>[requires: v4.2 and ARB_base_instance|VERSION_4_2]
        /// Render multiple instances of a set of primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the indexed geometry that should be drawn.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        /// <param name="baseinstance">
        /// <para>
        /// Specifies the base instance for use in fetching instanced vertex attributes.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_base_instance|VERSION_4_2", Version = "4.2", EntryPoint = "glDrawElementsInstancedBaseVertexBaseInstance")]
        public static extern void DrawElementsInstancedBaseVertexBaseInstance<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices, Int32 instancecount, Int32 basevertex, UInt32 baseinstance)
            where T3 : struct
        ;

        /// <summary>[requires: v4.2 and ARB_base_instance|VERSION_4_2]
        /// Render multiple instances of a set of primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the indexed geometry that should be drawn.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        /// <param name="baseinstance">
        /// <para>
        /// Specifies the base instance for use in fetching instanced vertex attributes.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_base_instance|VERSION_4_2", Version = "4.2", EntryPoint = "glDrawElementsInstancedBaseVertexBaseInstance")]
        public static extern void DrawElementsInstancedBaseVertexBaseInstance<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices, Int32 instancecount, Int32 basevertex, Int32 baseinstance)
            where T3 : struct
        ;

        /// <summary>[requires: v4.2 and ARB_base_instance|VERSION_4_2]
        /// Render multiple instances of a set of primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the indexed geometry that should be drawn.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        /// <param name="baseinstance">
        /// <para>
        /// Specifies the base instance for use in fetching instanced vertex attributes.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_base_instance|VERSION_4_2", Version = "4.2", EntryPoint = "glDrawElementsInstancedBaseVertexBaseInstance")]
        public static extern void DrawElementsInstancedBaseVertexBaseInstance<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices, Int32 instancecount, Int32 basevertex, UInt32 baseinstance)
            where T3 : struct
        ;

        /// <summary>[requires: v4.2 and ARB_base_instance|VERSION_4_2]
        /// Render multiple instances of a set of primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the indexed geometry that should be drawn.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        /// <param name="baseinstance">
        /// <para>
        /// Specifies the base instance for use in fetching instanced vertex attributes.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_base_instance|VERSION_4_2", Version = "4.2", EntryPoint = "glDrawElementsInstancedBaseVertexBaseInstance")]
        public static extern void DrawElementsInstancedBaseVertexBaseInstance<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices, Int32 instancecount, Int32 basevertex, Int32 baseinstance)
            where T3 : struct
        ;

        /// <summary>[requires: v4.2 and ARB_base_instance|VERSION_4_2]
        /// Render multiple instances of a set of primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the indexed geometry that should be drawn.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        /// <param name="baseinstance">
        /// <para>
        /// Specifies the base instance for use in fetching instanced vertex attributes.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_base_instance|VERSION_4_2", Version = "4.2", EntryPoint = "glDrawElementsInstancedBaseVertexBaseInstance")]
        public static extern void DrawElementsInstancedBaseVertexBaseInstance<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices, Int32 instancecount, Int32 basevertex, UInt32 baseinstance)
            where T3 : struct
        ;

        /// <summary>[requires: v4.2 and ARB_base_instance|VERSION_4_2]
        /// Render multiple instances of a set of primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the indexed geometry that should be drawn.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        /// <param name="baseinstance">
        /// <para>
        /// Specifies the base instance for use in fetching instanced vertex attributes.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_base_instance|VERSION_4_2", Version = "4.2", EntryPoint = "glDrawElementsInstancedBaseVertexBaseInstance")]
        public static extern void DrawElementsInstancedBaseVertexBaseInstance<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices, Int32 instancecount, Int32 basevertex, Int32 baseinstance)
            where T3 : struct
        ;

        /// <summary>[requires: v4.2 and ARB_base_instance|VERSION_4_2]
        /// Render multiple instances of a set of primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the indexed geometry that should be drawn.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        /// <param name="baseinstance">
        /// <para>
        /// Specifies the base instance for use in fetching instanced vertex attributes.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_base_instance|VERSION_4_2", Version = "4.2", EntryPoint = "glDrawElementsInstancedBaseVertexBaseInstance")]
        public static extern void DrawElementsInstancedBaseVertexBaseInstance<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices, Int32 instancecount, Int32 basevertex, UInt32 baseinstance)
            where T3 : struct
        ;

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Write a block of pixels to the frame buffer
        /// </summary>
        /// <param name="width">
        /// <para>
        /// Specify the dimensions of the pixel rectangle to be written into the frame buffer.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. Symbolic constants GL_COLOR_INDEX, GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, and GL_LUMINANCE_ALPHA are accepted.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type for data. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the pixel data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glDrawPixels")]
        public static extern void DrawPixels(Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Write a block of pixels to the frame buffer
        /// </summary>
        /// <param name="width">
        /// <para>
        /// Specify the dimensions of the pixel rectangle to be written into the frame buffer.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. Symbolic constants GL_COLOR_INDEX, GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, and GL_LUMINANCE_ALPHA are accepted.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type for data. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the pixel data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glDrawPixels")]
        public static extern void DrawPixels<T4>(Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T4[] pixels)
            where T4 : struct
        ;

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Write a block of pixels to the frame buffer
        /// </summary>
        /// <param name="width">
        /// <para>
        /// Specify the dimensions of the pixel rectangle to be written into the frame buffer.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. Symbolic constants GL_COLOR_INDEX, GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, and GL_LUMINANCE_ALPHA are accepted.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type for data. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the pixel data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glDrawPixels")]
        public static extern void DrawPixels<T4>(Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T4[,] pixels)
            where T4 : struct
        ;

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Write a block of pixels to the frame buffer
        /// </summary>
        /// <param name="width">
        /// <para>
        /// Specify the dimensions of the pixel rectangle to be written into the frame buffer.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. Symbolic constants GL_COLOR_INDEX, GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, and GL_LUMINANCE_ALPHA are accepted.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type for data. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the pixel data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glDrawPixels")]
        public static extern void DrawPixels<T4>(Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T4[,,] pixels)
            where T4 : struct
        ;

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Write a block of pixels to the frame buffer
        /// </summary>
        /// <param name="width">
        /// <para>
        /// Specify the dimensions of the pixel rectangle to be written into the frame buffer.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. Symbolic constants GL_COLOR_INDEX, GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, and GL_LUMINANCE_ALPHA are accepted.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type for data. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the pixel data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glDrawPixels")]
        public static extern void DrawPixels<T4>(Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T4 pixels)
            where T4 : struct
        ;

        /// <summary>[requires: v1.2]
        /// Render primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "VERSION_1_2", Version = "1.2", EntryPoint = "glDrawRangeElements")]
        public static extern void DrawRangeElements(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 start, Int32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices);

        /// <summary>[requires: v1.2]
        /// Render primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "VERSION_1_2", Version = "1.2", EntryPoint = "glDrawRangeElements")]
        public static extern void DrawRangeElements<T5>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 start, Int32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[] indices)
            where T5 : struct
        ;

        /// <summary>[requires: v1.2]
        /// Render primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "VERSION_1_2", Version = "1.2", EntryPoint = "glDrawRangeElements")]
        public static extern void DrawRangeElements<T5>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 start, Int32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[,] indices)
            where T5 : struct
        ;

        /// <summary>[requires: v1.2]
        /// Render primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "VERSION_1_2", Version = "1.2", EntryPoint = "glDrawRangeElements")]
        public static extern void DrawRangeElements<T5>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 start, Int32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[,,] indices)
            where T5 : struct
        ;

        /// <summary>[requires: v1.2]
        /// Render primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "VERSION_1_2", Version = "1.2", EntryPoint = "glDrawRangeElements")]
        public static extern void DrawRangeElements<T5>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 start, Int32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T5 indices)
            where T5 : struct
        ;

        /// <summary>[requires: v1.2]
        /// Render primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_2", Version = "1.2", EntryPoint = "glDrawRangeElements")]
        public static extern void DrawRangeElements(OpenTK.Graphics.OpenGL.BeginMode mode, UInt32 start, UInt32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices);

        /// <summary>[requires: v1.2]
        /// Render primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_2", Version = "1.2", EntryPoint = "glDrawRangeElements")]
        public static extern void DrawRangeElements<T5>(OpenTK.Graphics.OpenGL.BeginMode mode, UInt32 start, UInt32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[] indices)
            where T5 : struct
        ;

        /// <summary>[requires: v1.2]
        /// Render primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_2", Version = "1.2", EntryPoint = "glDrawRangeElements")]
        public static extern void DrawRangeElements<T5>(OpenTK.Graphics.OpenGL.BeginMode mode, UInt32 start, UInt32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[,] indices)
            where T5 : struct
        ;

        /// <summary>[requires: v1.2]
        /// Render primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_2", Version = "1.2", EntryPoint = "glDrawRangeElements")]
        public static extern void DrawRangeElements<T5>(OpenTK.Graphics.OpenGL.BeginMode mode, UInt32 start, UInt32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[,,] indices)
            where T5 : struct
        ;

        /// <summary>[requires: v1.2]
        /// Render primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_2", Version = "1.2", EntryPoint = "glDrawRangeElements")]
        public static extern void DrawRangeElements<T5>(OpenTK.Graphics.OpenGL.BeginMode mode, UInt32 start, UInt32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T5 indices)
            where T5 : struct
        ;

        /// <summary>[requires: v1.2]
        /// Render primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_2", Version = "1.2", EntryPoint = "glDrawRangeElements")]
        public static extern void DrawRangeElements(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 start, Int32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices);

        /// <summary>[requires: v1.2]
        /// Render primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_2", Version = "1.2", EntryPoint = "glDrawRangeElements")]
        public static extern void DrawRangeElements<T5>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 start, Int32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[] indices)
            where T5 : struct
        ;

        /// <summary>[requires: v1.2]
        /// Render primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_2", Version = "1.2", EntryPoint = "glDrawRangeElements")]
        public static extern void DrawRangeElements<T5>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 start, Int32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[,] indices)
            where T5 : struct
        ;

        /// <summary>[requires: v1.2]
        /// Render primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_2", Version = "1.2", EntryPoint = "glDrawRangeElements")]
        public static extern void DrawRangeElements<T5>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 start, Int32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[,,] indices)
            where T5 : struct
        ;

        /// <summary>[requires: v1.2]
        /// Render primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_2", Version = "1.2", EntryPoint = "glDrawRangeElements")]
        public static extern void DrawRangeElements<T5>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 start, Int32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T5 indices)
            where T5 : struct
        ;

        /// <summary>[requires: v1.2]
        /// Render primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_2", Version = "1.2", EntryPoint = "glDrawRangeElements")]
        public static extern void DrawRangeElements(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 start, UInt32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices);

        /// <summary>[requires: v1.2]
        /// Render primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_2", Version = "1.2", EntryPoint = "glDrawRangeElements")]
        public static extern void DrawRangeElements<T5>(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 start, UInt32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[] indices)
            where T5 : struct
        ;

        /// <summary>[requires: v1.2]
        /// Render primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_2", Version = "1.2", EntryPoint = "glDrawRangeElements")]
        public static extern void DrawRangeElements<T5>(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 start, UInt32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[,] indices)
            where T5 : struct
        ;

        /// <summary>[requires: v1.2]
        /// Render primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_2", Version = "1.2", EntryPoint = "glDrawRangeElements")]
        public static extern void DrawRangeElements<T5>(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 start, UInt32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[,,] indices)
            where T5 : struct
        ;

        /// <summary>[requires: v1.2]
        /// Render primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_2", Version = "1.2", EntryPoint = "glDrawRangeElements")]
        public static extern void DrawRangeElements<T5>(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 start, UInt32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T5 indices)
            where T5 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawRangeElementsBaseVertex")]
        public static extern void DrawRangeElementsBaseVertex(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 start, Int32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 basevertex);

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawRangeElementsBaseVertex")]
        public static extern void DrawRangeElementsBaseVertex<T5>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 start, Int32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[] indices, Int32 basevertex)
            where T5 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawRangeElementsBaseVertex")]
        public static extern void DrawRangeElementsBaseVertex<T5>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 start, Int32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[,] indices, Int32 basevertex)
            where T5 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawRangeElementsBaseVertex")]
        public static extern void DrawRangeElementsBaseVertex<T5>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 start, Int32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[,,] indices, Int32 basevertex)
            where T5 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawRangeElementsBaseVertex")]
        public static extern void DrawRangeElementsBaseVertex<T5>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 start, Int32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T5 indices, Int32 basevertex)
            where T5 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawRangeElementsBaseVertex")]
        public static extern void DrawRangeElementsBaseVertex(OpenTK.Graphics.OpenGL.BeginMode mode, UInt32 start, UInt32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 basevertex);

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawRangeElementsBaseVertex")]
        public static extern void DrawRangeElementsBaseVertex<T5>(OpenTK.Graphics.OpenGL.BeginMode mode, UInt32 start, UInt32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[] indices, Int32 basevertex)
            where T5 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawRangeElementsBaseVertex")]
        public static extern void DrawRangeElementsBaseVertex<T5>(OpenTK.Graphics.OpenGL.BeginMode mode, UInt32 start, UInt32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[,] indices, Int32 basevertex)
            where T5 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawRangeElementsBaseVertex")]
        public static extern void DrawRangeElementsBaseVertex<T5>(OpenTK.Graphics.OpenGL.BeginMode mode, UInt32 start, UInt32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[,,] indices, Int32 basevertex)
            where T5 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawRangeElementsBaseVertex")]
        public static extern void DrawRangeElementsBaseVertex<T5>(OpenTK.Graphics.OpenGL.BeginMode mode, UInt32 start, UInt32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T5 indices, Int32 basevertex)
            where T5 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawRangeElementsBaseVertex")]
        public static extern void DrawRangeElementsBaseVertex(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 start, Int32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 basevertex);

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawRangeElementsBaseVertex")]
        public static extern void DrawRangeElementsBaseVertex<T5>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 start, Int32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[] indices, Int32 basevertex)
            where T5 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawRangeElementsBaseVertex")]
        public static extern void DrawRangeElementsBaseVertex<T5>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 start, Int32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[,] indices, Int32 basevertex)
            where T5 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawRangeElementsBaseVertex")]
        public static extern void DrawRangeElementsBaseVertex<T5>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 start, Int32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[,,] indices, Int32 basevertex)
            where T5 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawRangeElementsBaseVertex")]
        public static extern void DrawRangeElementsBaseVertex<T5>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 start, Int32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T5 indices, Int32 basevertex)
            where T5 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawRangeElementsBaseVertex")]
        public static extern void DrawRangeElementsBaseVertex(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 start, UInt32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 basevertex);

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawRangeElementsBaseVertex")]
        public static extern void DrawRangeElementsBaseVertex<T5>(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 start, UInt32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[] indices, Int32 basevertex)
            where T5 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawRangeElementsBaseVertex")]
        public static extern void DrawRangeElementsBaseVertex<T5>(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 start, UInt32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[,] indices, Int32 basevertex)
            where T5 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawRangeElementsBaseVertex")]
        public static extern void DrawRangeElementsBaseVertex<T5>(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 start, UInt32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[,,] indices, Int32 basevertex)
            where T5 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render primitives from array data with a per-element offset
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="start">
        /// <para>
        /// Specifies the minimum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="end">
        /// <para>
        /// Specifies the maximum array index contained in indices.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements to be rendered.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a constant that should be added to each element of indices when chosing elements from the enabled vertex arrays.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glDrawRangeElementsBaseVertex")]
        public static extern void DrawRangeElementsBaseVertex<T5>(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 start, UInt32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T5 indices, Int32 basevertex)
            where T5 : struct
        ;

        /// <summary>[requires: v4.0 and ARB_transform_feedback2|VERSION_4_0]
        /// Render primitives using a count derived from a transform feedback object
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="id">
        /// <para>
        /// Specifies the name of a transform feedback object from which to retrieve a primitive count.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_transform_feedback2|VERSION_4_0", Version = "4.0", EntryPoint = "glDrawTransformFeedback")]
        public static extern void DrawTransformFeedback(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 id);

        /// <summary>[requires: v4.0 and ARB_transform_feedback2|VERSION_4_0]
        /// Render primitives using a count derived from a transform feedback object
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="id">
        /// <para>
        /// Specifies the name of a transform feedback object from which to retrieve a primitive count.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_transform_feedback2|VERSION_4_0", Version = "4.0", EntryPoint = "glDrawTransformFeedback")]
        public static extern void DrawTransformFeedback(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 id);

        /// <summary>[requires: v4.2 and ARB_transform_feedback_instanced|VERSION_4_2]
        /// Render multiple instances of primitives using a count derived from a transform feedback object
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="id">
        /// <para>
        /// Specifies the name of a transform feedback object from which to retrieve a primitive count.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the geometry to render.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_transform_feedback_instanced|VERSION_4_2", Version = "4.2", EntryPoint = "glDrawTransformFeedbackInstanced")]
        public static extern void DrawTransformFeedbackInstanced(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 id, Int32 instancecount);

        /// <summary>[requires: v4.2 and ARB_transform_feedback_instanced|VERSION_4_2]
        /// Render multiple instances of primitives using a count derived from a transform feedback object
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="id">
        /// <para>
        /// Specifies the name of a transform feedback object from which to retrieve a primitive count.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the geometry to render.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_transform_feedback_instanced|VERSION_4_2", Version = "4.2", EntryPoint = "glDrawTransformFeedbackInstanced")]
        public static extern void DrawTransformFeedbackInstanced(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 id, Int32 instancecount);

        /// <summary>[requires: v4.0 and ARB_transform_feedback3|VERSION_4_0]
        /// Render primitives using a count derived from a specifed stream of a transform feedback object
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="id">
        /// <para>
        /// Specifies the name of a transform feedback object from which to retrieve a primitive count.
        /// </para>
        /// </param>
        /// <param name="stream">
        /// <para>
        /// Specifies the index of the transform feedback stream from which to retrieve a primitive count.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_transform_feedback3|VERSION_4_0", Version = "4.0", EntryPoint = "glDrawTransformFeedbackStream")]
        public static extern void DrawTransformFeedbackStream(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 id, Int32 stream);

        /// <summary>[requires: v4.0 and ARB_transform_feedback3|VERSION_4_0]
        /// Render primitives using a count derived from a specifed stream of a transform feedback object
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="id">
        /// <para>
        /// Specifies the name of a transform feedback object from which to retrieve a primitive count.
        /// </para>
        /// </param>
        /// <param name="stream">
        /// <para>
        /// Specifies the index of the transform feedback stream from which to retrieve a primitive count.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_transform_feedback3|VERSION_4_0", Version = "4.0", EntryPoint = "glDrawTransformFeedbackStream")]
        public static extern void DrawTransformFeedbackStream(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 id, UInt32 stream);

        /// <summary>[requires: v4.2 and ARB_transform_feedback_instanced|VERSION_4_2]
        /// Render multiple instances of primitives using a count derived from a specifed stream of a transform feedback object
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="id">
        /// <para>
        /// Specifies the name of a transform feedback object from which to retrieve a primitive count.
        /// </para>
        /// </param>
        /// <param name="stream">
        /// <para>
        /// Specifies the index of the transform feedback stream from which to retrieve a primitive count.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the geometry to render.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_transform_feedback_instanced|VERSION_4_2", Version = "4.2", EntryPoint = "glDrawTransformFeedbackStreamInstanced")]
        public static extern void DrawTransformFeedbackStreamInstanced(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 id, Int32 stream, Int32 instancecount);

        /// <summary>[requires: v4.2 and ARB_transform_feedback_instanced|VERSION_4_2]
        /// Render multiple instances of primitives using a count derived from a specifed stream of a transform feedback object
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="id">
        /// <para>
        /// Specifies the name of a transform feedback object from which to retrieve a primitive count.
        /// </para>
        /// </param>
        /// <param name="stream">
        /// <para>
        /// Specifies the index of the transform feedback stream from which to retrieve a primitive count.
        /// </para>
        /// </param>
        /// <param name="primcount">
        /// <para>
        /// Specifies the number of instances of the geometry to render.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_transform_feedback_instanced|VERSION_4_2", Version = "4.2", EntryPoint = "glDrawTransformFeedbackStreamInstanced")]
        public static extern void DrawTransformFeedbackStreamInstanced(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 id, UInt32 stream, Int32 instancecount);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Flag edges as either boundary or nonboundary
        /// </summary>
        /// <param name="flag">
        /// <para>
        /// Specifies the current edge flag value, either GL_TRUE or GL_FALSE. The initial value is GL_TRUE.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glEdgeFlag")]
        public static extern void EdgeFlag(bool flag);

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Define an array of edge flags
        /// </summary>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive edge flags. If stride is 0, the edge flags are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first edge flag in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glEdgeFlagPointer")]
        public static extern void EdgeFlagPointer(Int32 stride, IntPtr pointer);

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Define an array of edge flags
        /// </summary>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive edge flags. If stride is 0, the edge flags are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first edge flag in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glEdgeFlagPointer")]
        public static extern void EdgeFlagPointer<T1>(Int32 stride, [InAttribute, OutAttribute] T1[] pointer)
            where T1 : struct
        ;

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Define an array of edge flags
        /// </summary>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive edge flags. If stride is 0, the edge flags are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first edge flag in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glEdgeFlagPointer")]
        public static extern void EdgeFlagPointer<T1>(Int32 stride, [InAttribute, OutAttribute] T1[,] pointer)
            where T1 : struct
        ;

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Define an array of edge flags
        /// </summary>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive edge flags. If stride is 0, the edge flags are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first edge flag in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glEdgeFlagPointer")]
        public static extern void EdgeFlagPointer<T1>(Int32 stride, [InAttribute, OutAttribute] T1[,,] pointer)
            where T1 : struct
        ;

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Define an array of edge flags
        /// </summary>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive edge flags. If stride is 0, the edge flags are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first edge flag in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glEdgeFlagPointer")]
        public static extern void EdgeFlagPointer<T1>(Int32 stride, [InAttribute, OutAttribute] ref T1 pointer)
            where T1 : struct
        ;

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Flag edges as either boundary or nonboundary
        /// </summary>
        /// <param name="flag">
        /// <para>
        /// Specifies the current edge flag value, either GL_TRUE or GL_FALSE. The initial value is GL_TRUE.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glEdgeFlagv")]
        public static extern void EdgeFlag(bool[] flag);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Flag edges as either boundary or nonboundary
        /// </summary>
        /// <param name="flag">
        /// <para>
        /// Specifies the current edge flag value, either GL_TRUE or GL_FALSE. The initial value is GL_TRUE.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glEdgeFlagv")]
        public static extern unsafe void EdgeFlag(bool* flag);

        /// <summary>[requires: v1.0]
        /// Enable or disable server-side GL capabilities
        /// </summary>
        /// <param name="cap">
        /// <para>
        /// Specifies a symbolic constant indicating a GL capability.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the switch to disable (for glEnablei and glDisablei only).
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glEnable")]
        public static extern void Enable(OpenTK.Graphics.OpenGL.EnableCap cap);

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Enable or disable client-side capability
        /// </summary>
        /// <param name="cap">
        /// <para>
        /// Specifies the capability to enable. Symbolic constants GL_COLOR_ARRAY, GL_EDGE_FLAG_ARRAY, GL_FOG_COORD_ARRAY, GL_INDEX_ARRAY, GL_NORMAL_ARRAY, GL_SECONDARY_COLOR_ARRAY, GL_TEXTURE_COORD_ARRAY, and GL_VERTEX_ARRAY are accepted.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glEnableClientState")]
        public static extern void EnableClientState(OpenTK.Graphics.OpenGL.ArrayCap array);

        /// <summary>[requires: v3.0]
        /// Enable or disable server-side GL capabilities
        /// </summary>
        /// <param name="cap">
        /// <para>
        /// Specifies a symbolic constant indicating a GL capability.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the switch to disable (for glEnablei and glDisablei only).
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glEnablei")]
        public static extern void Enable(OpenTK.Graphics.OpenGL.IndexedEnableCap target, Int32 index);

        /// <summary>[requires: v3.0]
        /// Enable or disable server-side GL capabilities
        /// </summary>
        /// <param name="cap">
        /// <para>
        /// Specifies a symbolic constant indicating a GL capability.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the switch to disable (for glEnablei and glDisablei only).
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glEnablei")]
        public static extern void Enable(OpenTK.Graphics.OpenGL.IndexedEnableCap target, UInt32 index);

        /// <summary>[requires: v2.0]
        /// Enable or disable a generic vertex attribute array
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be enabled or disabled.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glEnableVertexAttribArray")]
        public static extern void EnableVertexAttribArray(Int32 index);

        /// <summary>[requires: v2.0]
        /// Enable or disable a generic vertex attribute array
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be enabled or disabled.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glEnableVertexAttribArray")]
        public static extern void EnableVertexAttribArray(UInt32 index);

        /// <summary>[requires: v1.0][deprecated: v3.2]</summary>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glEnd")]
        public static extern void End();

        /// <summary>[requires: v3.0]</summary>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glEndConditionalRender")]
        public static extern void EndConditionalRender();

        /// <summary>[requires: v1.0][deprecated: v3.2]</summary>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glEndList")]
        public static extern void EndList();

        /// <summary>[requires: v1.5]</summary>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glEndQuery")]
        public static extern void EndQuery(OpenTK.Graphics.OpenGL.QueryTarget target);

        /// <summary>[requires: v4.0 and ARB_transform_feedback3|VERSION_4_0]</summary>
        [AutoGenerated(Category = "ARB_transform_feedback3|VERSION_4_0", Version = "4.0", EntryPoint = "glEndQueryIndexed")]
        public static extern void EndQueryIndexed(OpenTK.Graphics.OpenGL.QueryTarget target, Int32 index);

        /// <summary>[requires: v4.0 and ARB_transform_feedback3|VERSION_4_0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_transform_feedback3|VERSION_4_0", Version = "4.0", EntryPoint = "glEndQueryIndexed")]
        public static extern void EndQueryIndexed(OpenTK.Graphics.OpenGL.QueryTarget target, UInt32 index);

        /// <summary>[requires: v3.0]</summary>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glEndTransformFeedback")]
        public static extern void EndTransformFeedback();

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Evaluate enabled one- and two-dimensional maps
        /// </summary>
        /// <param name="u">
        /// <para>
        /// Specifies a value that is the domain coordinate to the basis function defined in a previous glMap1 or glMap2 command.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Specifies a value that is the domain coordinate to the basis function defined in a previous glMap2 command. This argument is not present in a glEvalCoord1 command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glEvalCoord1d")]
        public static extern void EvalCoord1(Double u);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Evaluate enabled one- and two-dimensional maps
        /// </summary>
        /// <param name="u">
        /// <para>
        /// Specifies a value that is the domain coordinate to the basis function defined in a previous glMap1 or glMap2 command.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Specifies a value that is the domain coordinate to the basis function defined in a previous glMap2 command. This argument is not present in a glEvalCoord1 command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glEvalCoord1dv")]
        public static extern unsafe void EvalCoord1(Double* u);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Evaluate enabled one- and two-dimensional maps
        /// </summary>
        /// <param name="u">
        /// <para>
        /// Specifies a value that is the domain coordinate to the basis function defined in a previous glMap1 or glMap2 command.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Specifies a value that is the domain coordinate to the basis function defined in a previous glMap2 command. This argument is not present in a glEvalCoord1 command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glEvalCoord1f")]
        public static extern void EvalCoord1(Single u);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Evaluate enabled one- and two-dimensional maps
        /// </summary>
        /// <param name="u">
        /// <para>
        /// Specifies a value that is the domain coordinate to the basis function defined in a previous glMap1 or glMap2 command.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Specifies a value that is the domain coordinate to the basis function defined in a previous glMap2 command. This argument is not present in a glEvalCoord1 command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glEvalCoord1fv")]
        public static extern unsafe void EvalCoord1(Single* u);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Evaluate enabled one- and two-dimensional maps
        /// </summary>
        /// <param name="u">
        /// <para>
        /// Specifies a value that is the domain coordinate to the basis function defined in a previous glMap1 or glMap2 command.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Specifies a value that is the domain coordinate to the basis function defined in a previous glMap2 command. This argument is not present in a glEvalCoord1 command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glEvalCoord2d")]
        public static extern void EvalCoord2(Double u, Double v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Evaluate enabled one- and two-dimensional maps
        /// </summary>
        /// <param name="u">
        /// <para>
        /// Specifies a value that is the domain coordinate to the basis function defined in a previous glMap1 or glMap2 command.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Specifies a value that is the domain coordinate to the basis function defined in a previous glMap2 command. This argument is not present in a glEvalCoord1 command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glEvalCoord2dv")]
        public static extern void EvalCoord2(Double[] u);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Evaluate enabled one- and two-dimensional maps
        /// </summary>
        /// <param name="u">
        /// <para>
        /// Specifies a value that is the domain coordinate to the basis function defined in a previous glMap1 or glMap2 command.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Specifies a value that is the domain coordinate to the basis function defined in a previous glMap2 command. This argument is not present in a glEvalCoord1 command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glEvalCoord2dv")]
        public static extern void EvalCoord2(ref Double u);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Evaluate enabled one- and two-dimensional maps
        /// </summary>
        /// <param name="u">
        /// <para>
        /// Specifies a value that is the domain coordinate to the basis function defined in a previous glMap1 or glMap2 command.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Specifies a value that is the domain coordinate to the basis function defined in a previous glMap2 command. This argument is not present in a glEvalCoord1 command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glEvalCoord2dv")]
        public static extern unsafe void EvalCoord2(Double* u);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Evaluate enabled one- and two-dimensional maps
        /// </summary>
        /// <param name="u">
        /// <para>
        /// Specifies a value that is the domain coordinate to the basis function defined in a previous glMap1 or glMap2 command.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Specifies a value that is the domain coordinate to the basis function defined in a previous glMap2 command. This argument is not present in a glEvalCoord1 command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glEvalCoord2f")]
        public static extern void EvalCoord2(Single u, Single v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Evaluate enabled one- and two-dimensional maps
        /// </summary>
        /// <param name="u">
        /// <para>
        /// Specifies a value that is the domain coordinate to the basis function defined in a previous glMap1 or glMap2 command.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Specifies a value that is the domain coordinate to the basis function defined in a previous glMap2 command. This argument is not present in a glEvalCoord1 command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glEvalCoord2fv")]
        public static extern void EvalCoord2(Single[] u);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Evaluate enabled one- and two-dimensional maps
        /// </summary>
        /// <param name="u">
        /// <para>
        /// Specifies a value that is the domain coordinate to the basis function defined in a previous glMap1 or glMap2 command.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Specifies a value that is the domain coordinate to the basis function defined in a previous glMap2 command. This argument is not present in a glEvalCoord1 command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glEvalCoord2fv")]
        public static extern void EvalCoord2(ref Single u);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Evaluate enabled one- and two-dimensional maps
        /// </summary>
        /// <param name="u">
        /// <para>
        /// Specifies a value that is the domain coordinate to the basis function defined in a previous glMap1 or glMap2 command.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Specifies a value that is the domain coordinate to the basis function defined in a previous glMap2 command. This argument is not present in a glEvalCoord1 command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glEvalCoord2fv")]
        public static extern unsafe void EvalCoord2(Single* u);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Compute a one- or two-dimensional grid of points or lines
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// In glEvalMesh1, specifies whether to compute a one-dimensional mesh of points or lines. Symbolic constants GL_POINT and GL_LINE are accepted.
        /// </para>
        /// </param>
        /// <param name="i1">
        /// <para>
        /// Specify the first and last integer values for grid domain variable .
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glEvalMesh1")]
        public static extern void EvalMesh1(OpenTK.Graphics.OpenGL.MeshMode1 mode, Int32 i1, Int32 i2);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Compute a one- or two-dimensional grid of points or lines
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// In glEvalMesh1, specifies whether to compute a one-dimensional mesh of points or lines. Symbolic constants GL_POINT and GL_LINE are accepted.
        /// </para>
        /// </param>
        /// <param name="i1">
        /// <para>
        /// Specify the first and last integer values for grid domain variable .
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glEvalMesh2")]
        public static extern void EvalMesh2(OpenTK.Graphics.OpenGL.MeshMode2 mode, Int32 i1, Int32 i2, Int32 j1, Int32 j2);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Generate and evaluate a single point in a mesh
        /// </summary>
        /// <param name="i">
        /// <para>
        /// Specifies the integer value for grid domain variable .
        /// </para>
        /// </param>
        /// <param name="j">
        /// <para>
        /// Specifies the integer value for grid domain variable (glEvalPoint2 only).
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glEvalPoint1")]
        public static extern void EvalPoint1(Int32 i);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Generate and evaluate a single point in a mesh
        /// </summary>
        /// <param name="i">
        /// <para>
        /// Specifies the integer value for grid domain variable .
        /// </para>
        /// </param>
        /// <param name="j">
        /// <para>
        /// Specifies the integer value for grid domain variable (glEvalPoint2 only).
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glEvalPoint2")]
        public static extern void EvalPoint2(Int32 i, Int32 j);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Controls feedback mode
        /// </summary>
        /// <param name="size">
        /// <para>
        /// Specifies the maximum number of values that can be written into buffer.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies a symbolic constant that describes the information that will be returned for each vertex. GL_2D, GL_3D, GL_3D_COLOR, GL_3D_COLOR_TEXTURE, and GL_4D_COLOR_TEXTURE are accepted.
        /// </para>
        /// </param>
        /// <param name="buffer">
        /// <para>
        /// Returns the feedback data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glFeedbackBuffer")]
        public static extern void FeedbackBuffer(Int32 size, OpenTK.Graphics.OpenGL.FeedbackType type, [OutAttribute] Single[] buffer);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Controls feedback mode
        /// </summary>
        /// <param name="size">
        /// <para>
        /// Specifies the maximum number of values that can be written into buffer.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies a symbolic constant that describes the information that will be returned for each vertex. GL_2D, GL_3D, GL_3D_COLOR, GL_3D_COLOR_TEXTURE, and GL_4D_COLOR_TEXTURE are accepted.
        /// </para>
        /// </param>
        /// <param name="buffer">
        /// <para>
        /// Returns the feedback data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glFeedbackBuffer")]
        public static extern void FeedbackBuffer(Int32 size, OpenTK.Graphics.OpenGL.FeedbackType type, [OutAttribute] out Single buffer);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Controls feedback mode
        /// </summary>
        /// <param name="size">
        /// <para>
        /// Specifies the maximum number of values that can be written into buffer.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies a symbolic constant that describes the information that will be returned for each vertex. GL_2D, GL_3D, GL_3D_COLOR, GL_3D_COLOR_TEXTURE, and GL_4D_COLOR_TEXTURE are accepted.
        /// </para>
        /// </param>
        /// <param name="buffer">
        /// <para>
        /// Returns the feedback data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glFeedbackBuffer")]
        public static extern unsafe void FeedbackBuffer(Int32 size, OpenTK.Graphics.OpenGL.FeedbackType type, [OutAttribute] Single* buffer);

        /// <summary>[requires: v3.2 and ARB_sync|VERSION_3_2]
        /// Create a new sync object and insert it into the GL command stream
        /// </summary>
        /// <param name="condition">
        /// <para>
        /// Specifies the condition that must be met to set the sync object's state to signaled. condition must be GL_SYNC_GPU_COMMANDS_COMPLETE.
        /// </para>
        /// </param>
        /// <param name="flags">
        /// <para>
        /// Specifies a bitwise combination of flags controlling the behavior of the sync object. No flags are presently defined for this operation and flags must be zero. flags is a placeholder for anticipated future extensions of fence sync object capabilities.
        /// </para>
        /// </param>
        [Obsolete("Use SyncCondition overload instead")]
        [AutoGenerated(Category = "ARB_sync|VERSION_3_2", Version = "3.2", EntryPoint = "glFenceSync")]
        public static extern IntPtr FenceSync(OpenTK.Graphics.OpenGL.ArbSync condition, Int32 flags);

        /// <summary>[requires: v3.2 and ARB_sync|VERSION_3_2]
        /// Create a new sync object and insert it into the GL command stream
        /// </summary>
        /// <param name="condition">
        /// <para>
        /// Specifies the condition that must be met to set the sync object's state to signaled. condition must be GL_SYNC_GPU_COMMANDS_COMPLETE.
        /// </para>
        /// </param>
        /// <param name="flags">
        /// <para>
        /// Specifies a bitwise combination of flags controlling the behavior of the sync object. No flags are presently defined for this operation and flags must be zero. flags is a placeholder for anticipated future extensions of fence sync object capabilities.
        /// </para>
        /// </param>
        [Obsolete("Use SyncCondition overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sync|VERSION_3_2", Version = "3.2", EntryPoint = "glFenceSync")]
        public static extern IntPtr FenceSync(OpenTK.Graphics.OpenGL.ArbSync condition, UInt32 flags);

        /// <summary>[requires: v3.2 and ARB_sync|VERSION_3_2]
        /// Create a new sync object and insert it into the GL command stream
        /// </summary>
        /// <param name="condition">
        /// <para>
        /// Specifies the condition that must be met to set the sync object's state to signaled. condition must be GL_SYNC_GPU_COMMANDS_COMPLETE.
        /// </para>
        /// </param>
        /// <param name="flags">
        /// <para>
        /// Specifies a bitwise combination of flags controlling the behavior of the sync object. No flags are presently defined for this operation and flags must be zero. flags is a placeholder for anticipated future extensions of fence sync object capabilities.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_sync|VERSION_3_2", Version = "3.2", EntryPoint = "glFenceSync")]
        public static extern IntPtr FenceSync(OpenTK.Graphics.OpenGL.SyncCondition condition, OpenTK.Graphics.OpenGL.WaitSyncFlags flags);

        /// <summary>[requires: v1.0]
        /// Block until all GL execution is complete
        /// </summary>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glFinish")]
        public static extern void Finish();

        /// <summary>[requires: v1.0]
        /// Force execution of GL commands in finite time
        /// </summary>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glFlush")]
        public static extern void Flush();

        /// <summary>[requires: v3.0 and ARB_map_buffer_range|VERSION_3_0]
        /// Indicate modifications to a range of a mapped buffer
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target of the flush operation. target must be GL_ARRAY_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
        /// </para>
        /// </param>
        /// <param name="offset">
        /// <para>
        /// Specifies the start of the buffer subrange, in basic machine units.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the length of the buffer subrange, in basic machine units.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_map_buffer_range|VERSION_3_0", Version = "3.0", EntryPoint = "glFlushMappedBufferRange")]
        public static extern void FlushMappedBufferRange(OpenTK.Graphics.OpenGL.BufferTarget target, IntPtr offset, IntPtr length);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current fog coordinates
        /// </summary>
        /// <param name="coord">
        /// <para>
        /// Specify the fog distance.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glFogCoordd")]
        public static extern void FogCoord(Double coord);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current fog coordinates
        /// </summary>
        /// <param name="coord">
        /// <para>
        /// Specify the fog distance.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glFogCoorddv")]
        public static extern unsafe void FogCoord(Double* coord);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current fog coordinates
        /// </summary>
        /// <param name="coord">
        /// <para>
        /// Specify the fog distance.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glFogCoordf")]
        public static extern void FogCoord(Single coord);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current fog coordinates
        /// </summary>
        /// <param name="coord">
        /// <para>
        /// Specify the fog distance.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glFogCoordfv")]
        public static extern unsafe void FogCoord(Single* coord);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Define an array of fog coordinates
        /// </summary>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each fog coordinate. Symbolic constants GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive fog coordinates. If stride is 0, the array elements are understood to be tightly packed. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first coordinate of the first fog coordinate in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glFogCoordPointer")]
        public static extern void FogCoordPointer(OpenTK.Graphics.OpenGL.FogPointerType type, Int32 stride, IntPtr pointer);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Define an array of fog coordinates
        /// </summary>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each fog coordinate. Symbolic constants GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive fog coordinates. If stride is 0, the array elements are understood to be tightly packed. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first coordinate of the first fog coordinate in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glFogCoordPointer")]
        public static extern void FogCoordPointer<T2>(OpenTK.Graphics.OpenGL.FogPointerType type, Int32 stride, [InAttribute, OutAttribute] T2[] pointer)
            where T2 : struct
        ;

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Define an array of fog coordinates
        /// </summary>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each fog coordinate. Symbolic constants GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive fog coordinates. If stride is 0, the array elements are understood to be tightly packed. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first coordinate of the first fog coordinate in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glFogCoordPointer")]
        public static extern void FogCoordPointer<T2>(OpenTK.Graphics.OpenGL.FogPointerType type, Int32 stride, [InAttribute, OutAttribute] T2[,] pointer)
            where T2 : struct
        ;

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Define an array of fog coordinates
        /// </summary>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each fog coordinate. Symbolic constants GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive fog coordinates. If stride is 0, the array elements are understood to be tightly packed. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first coordinate of the first fog coordinate in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glFogCoordPointer")]
        public static extern void FogCoordPointer<T2>(OpenTK.Graphics.OpenGL.FogPointerType type, Int32 stride, [InAttribute, OutAttribute] T2[,,] pointer)
            where T2 : struct
        ;

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Define an array of fog coordinates
        /// </summary>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each fog coordinate. Symbolic constants GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive fog coordinates. If stride is 0, the array elements are understood to be tightly packed. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first coordinate of the first fog coordinate in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glFogCoordPointer")]
        public static extern void FogCoordPointer<T2>(OpenTK.Graphics.OpenGL.FogPointerType type, Int32 stride, [InAttribute, OutAttribute] ref T2 pointer)
            where T2 : struct
        ;

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify fog parameters
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies a single-valued fog parameter. GL_FOG_MODE, GL_FOG_DENSITY, GL_FOG_START, GL_FOG_END, GL_FOG_INDEX, and GL_FOG_COORD_SRC are accepted.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies the value that pname will be set to.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glFogf")]
        public static extern void Fog(OpenTK.Graphics.OpenGL.FogParameter pname, Single param);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify fog parameters
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies a single-valued fog parameter. GL_FOG_MODE, GL_FOG_DENSITY, GL_FOG_START, GL_FOG_END, GL_FOG_INDEX, and GL_FOG_COORD_SRC are accepted.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies the value that pname will be set to.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glFogfv")]
        public static extern void Fog(OpenTK.Graphics.OpenGL.FogParameter pname, Single[] @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify fog parameters
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies a single-valued fog parameter. GL_FOG_MODE, GL_FOG_DENSITY, GL_FOG_START, GL_FOG_END, GL_FOG_INDEX, and GL_FOG_COORD_SRC are accepted.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies the value that pname will be set to.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glFogfv")]
        public static extern unsafe void Fog(OpenTK.Graphics.OpenGL.FogParameter pname, Single* @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify fog parameters
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies a single-valued fog parameter. GL_FOG_MODE, GL_FOG_DENSITY, GL_FOG_START, GL_FOG_END, GL_FOG_INDEX, and GL_FOG_COORD_SRC are accepted.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies the value that pname will be set to.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glFogi")]
        public static extern void Fog(OpenTK.Graphics.OpenGL.FogParameter pname, Int32 param);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify fog parameters
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies a single-valued fog parameter. GL_FOG_MODE, GL_FOG_DENSITY, GL_FOG_START, GL_FOG_END, GL_FOG_INDEX, and GL_FOG_COORD_SRC are accepted.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies the value that pname will be set to.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glFogiv")]
        public static extern void Fog(OpenTK.Graphics.OpenGL.FogParameter pname, Int32[] @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify fog parameters
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies a single-valued fog parameter. GL_FOG_MODE, GL_FOG_DENSITY, GL_FOG_START, GL_FOG_END, GL_FOG_INDEX, and GL_FOG_COORD_SRC are accepted.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies the value that pname will be set to.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glFogiv")]
        public static extern unsafe void Fog(OpenTK.Graphics.OpenGL.FogParameter pname, Int32* @params);

        /// <summary>[requires: v4.3 and ARB_framebuffer_no_attachments|VERSION_4_3]
        /// Set a named parameter of a framebuffer
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The target of the operation, which must be GL_READ_FRAMEBUFFER, GL_DRAW_FRAMEBUFFER or GL_FRAMEBUFFER.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// A token indicating the parameter to be modified.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// The new value for the parameter named pname.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_framebuffer_no_attachments|VERSION_4_3", Version = "4.3", EntryPoint = "glFramebufferParameteri")]
        public static extern void FramebufferParameter(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferDefaultParameter pname, Int32 param);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Attach a renderbuffer as a logical buffer to the currently bound framebuffer object
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the framebuffer target. target must be GL_DRAW_FRAMEBUFFER, GL_READ_FRAMEBUFFER, or GL_FRAMEBUFFER. GL_FRAMEBUFFER is equivalent to GL_DRAW_FRAMEBUFFER.
        /// </para>
        /// </param>
        /// <param name="attachment">
        /// <para>
        /// Specifies the attachment point of the framebuffer.
        /// </para>
        /// </param>
        /// <param name="renderbuffertarget">
        /// <para>
        /// Specifies the renderbuffer target and must be GL_RENDERBUFFER.
        /// </para>
        /// </param>
        /// <param name="renderbuffer">
        /// <para>
        /// Specifies the name of an existing renderbuffer object of type renderbuffertarget to attach.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glFramebufferRenderbuffer")]
        public static extern void FramebufferRenderbuffer(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.RenderbufferTarget renderbuffertarget, Int32 renderbuffer);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Attach a renderbuffer as a logical buffer to the currently bound framebuffer object
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the framebuffer target. target must be GL_DRAW_FRAMEBUFFER, GL_READ_FRAMEBUFFER, or GL_FRAMEBUFFER. GL_FRAMEBUFFER is equivalent to GL_DRAW_FRAMEBUFFER.
        /// </para>
        /// </param>
        /// <param name="attachment">
        /// <para>
        /// Specifies the attachment point of the framebuffer.
        /// </para>
        /// </param>
        /// <param name="renderbuffertarget">
        /// <para>
        /// Specifies the renderbuffer target and must be GL_RENDERBUFFER.
        /// </para>
        /// </param>
        /// <param name="renderbuffer">
        /// <para>
        /// Specifies the name of an existing renderbuffer object of type renderbuffertarget to attach.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glFramebufferRenderbuffer")]
        public static extern void FramebufferRenderbuffer(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.RenderbufferTarget renderbuffertarget, UInt32 renderbuffer);

        /// <summary>[requires: v3.2]
        /// Attach a level of a texture object as a logical buffer to the currently bound framebuffer object
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the framebuffer target. target must be GL_DRAW_FRAMEBUFFER, GL_READ_FRAMEBUFFER, or GL_FRAMEBUFFER. GL_FRAMEBUFFER is equivalent to GL_DRAW_FRAMEBUFFER.
        /// </para>
        /// </param>
        /// <param name="attachment">
        /// <para>
        /// Specifies the attachment point of the framebuffer. attachment must be GL_COLOR_ATTACHMENTi, GL_DEPTH_ATTACHMENT, GL_STENCIL_ATTACHMENT or GL_DEPTH_STENCIL_ATTACHMENT.
        /// </para>
        /// </param>
        /// <param name="textarget">
        /// <para>
        /// For glFramebufferTexture1D, glFramebufferTexture2D and glFramebufferTexture3D, specifies what type of texture is expected in the texture parameter, or for cube map textures, which face is to be attached.
        /// </para>
        /// </param>
        /// <param name="texture">
        /// <para>
        /// Specifies the texture object to attach to the framebuffer attachment point named by attachment.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the mipmap level of texture to attach.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_3_2", Version = "3.2", EntryPoint = "glFramebufferTexture")]
        public static extern void FramebufferTexture(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, Int32 texture, Int32 level);

        /// <summary>[requires: v3.2]
        /// Attach a level of a texture object as a logical buffer to the currently bound framebuffer object
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the framebuffer target. target must be GL_DRAW_FRAMEBUFFER, GL_READ_FRAMEBUFFER, or GL_FRAMEBUFFER. GL_FRAMEBUFFER is equivalent to GL_DRAW_FRAMEBUFFER.
        /// </para>
        /// </param>
        /// <param name="attachment">
        /// <para>
        /// Specifies the attachment point of the framebuffer. attachment must be GL_COLOR_ATTACHMENTi, GL_DEPTH_ATTACHMENT, GL_STENCIL_ATTACHMENT or GL_DEPTH_STENCIL_ATTACHMENT.
        /// </para>
        /// </param>
        /// <param name="textarget">
        /// <para>
        /// For glFramebufferTexture1D, glFramebufferTexture2D and glFramebufferTexture3D, specifies what type of texture is expected in the texture parameter, or for cube map textures, which face is to be attached.
        /// </para>
        /// </param>
        /// <param name="texture">
        /// <para>
        /// Specifies the texture object to attach to the framebuffer attachment point named by attachment.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the mipmap level of texture to attach.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_2", Version = "3.2", EntryPoint = "glFramebufferTexture")]
        public static extern void FramebufferTexture(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, UInt32 texture, Int32 level);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]</summary>
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glFramebufferTexture1D")]
        public static extern void FramebufferTexture1D(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.TextureTarget textarget, Int32 texture, Int32 level);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glFramebufferTexture1D")]
        public static extern void FramebufferTexture1D(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.TextureTarget textarget, UInt32 texture, Int32 level);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]</summary>
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glFramebufferTexture2D")]
        public static extern void FramebufferTexture2D(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.TextureTarget textarget, Int32 texture, Int32 level);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glFramebufferTexture2D")]
        public static extern void FramebufferTexture2D(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.TextureTarget textarget, UInt32 texture, Int32 level);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]</summary>
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glFramebufferTexture3D")]
        public static extern void FramebufferTexture3D(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.TextureTarget textarget, Int32 texture, Int32 level, Int32 zoffset);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glFramebufferTexture3D")]
        public static extern void FramebufferTexture3D(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.TextureTarget textarget, UInt32 texture, Int32 level, Int32 zoffset);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Attach a single layer of a texture to a framebuffer
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the framebuffer target. target must be GL_DRAW_FRAMEBUFFER, GL_READ_FRAMEBUFFER, or GL_FRAMEBUFFER. GL_FRAMEBUFFER is equivalent to GL_DRAW_FRAMEBUFFER.
        /// </para>
        /// </param>
        /// <param name="attachment">
        /// <para>
        /// Specifies the attachment point of the framebuffer. attachment must be GL_COLOR_ATTACHMENTi, GL_DEPTH_ATTACHMENT, GL_STENCIL_ATTACHMENT or GL_DEPTH_STENCIL_ATTACHMENT.
        /// </para>
        /// </param>
        /// <param name="texture">
        /// <para>
        /// Specifies the texture object to attach to the framebuffer attachment point named by attachment.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the mipmap level of texture to attach.
        /// </para>
        /// </param>
        /// <param name="layer">
        /// <para>
        /// Specifies the layer of texture to attach.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glFramebufferTextureLayer")]
        public static extern void FramebufferTextureLayer(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, Int32 texture, Int32 level, Int32 layer);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Attach a single layer of a texture to a framebuffer
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the framebuffer target. target must be GL_DRAW_FRAMEBUFFER, GL_READ_FRAMEBUFFER, or GL_FRAMEBUFFER. GL_FRAMEBUFFER is equivalent to GL_DRAW_FRAMEBUFFER.
        /// </para>
        /// </param>
        /// <param name="attachment">
        /// <para>
        /// Specifies the attachment point of the framebuffer. attachment must be GL_COLOR_ATTACHMENTi, GL_DEPTH_ATTACHMENT, GL_STENCIL_ATTACHMENT or GL_DEPTH_STENCIL_ATTACHMENT.
        /// </para>
        /// </param>
        /// <param name="texture">
        /// <para>
        /// Specifies the texture object to attach to the framebuffer attachment point named by attachment.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the mipmap level of texture to attach.
        /// </para>
        /// </param>
        /// <param name="layer">
        /// <para>
        /// Specifies the layer of texture to attach.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glFramebufferTextureLayer")]
        public static extern void FramebufferTextureLayer(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, UInt32 texture, Int32 level, Int32 layer);

        /// <summary>[requires: v1.0]
        /// Define front- and back-facing polygons
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies the orientation of front-facing polygons. GL_CW and GL_CCW are accepted. The initial value is GL_CCW.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glFrontFace")]
        public static extern void FrontFace(OpenTK.Graphics.OpenGL.FrontFaceDirection mode);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Multiply the current matrix by a perspective matrix
        /// </summary>
        /// <param name="left">
        /// <para>
        /// Specify the coordinates for the left and right vertical clipping planes.
        /// </para>
        /// </param>
        /// <param name="bottom">
        /// <para>
        /// Specify the coordinates for the bottom and top horizontal clipping planes.
        /// </para>
        /// </param>
        /// <param name="nearVal">
        /// <para>
        /// Specify the distances to the near and far depth clipping planes. Both distances must be positive.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glFrustum")]
        public static extern void Frustum(Double left, Double right, Double bottom, Double top, Double zNear, Double zFar);

        /// <summary>[requires: v1.5]
        /// Generate buffer object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of buffer object names to be generated.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// Specifies an array in which the generated buffer object names are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGenBuffers")]
        public static extern Int32 GenBuffer();

        /// <summary>[requires: v1.5]
        /// Generate buffer object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of buffer object names to be generated.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// Specifies an array in which the generated buffer object names are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGenBuffers")]
        public static extern void GenBuffers(Int32 n, [OutAttribute] Int32[] buffers);

        /// <summary>[requires: v1.5]
        /// Generate buffer object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of buffer object names to be generated.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// Specifies an array in which the generated buffer object names are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGenBuffers")]
        public static extern void GenBuffers(Int32 n, [OutAttribute] out Int32 buffers);

        /// <summary>[requires: v1.5]
        /// Generate buffer object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of buffer object names to be generated.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// Specifies an array in which the generated buffer object names are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGenBuffers")]
        public static extern unsafe void GenBuffers(Int32 n, [OutAttribute] Int32* buffers);

        /// <summary>[requires: v1.5]
        /// Generate buffer object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of buffer object names to be generated.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// Specifies an array in which the generated buffer object names are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGenBuffers")]
        public static extern void GenBuffers(Int32 n, [OutAttribute] UInt32[] buffers);

        /// <summary>[requires: v1.5]
        /// Generate buffer object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of buffer object names to be generated.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// Specifies an array in which the generated buffer object names are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGenBuffers")]
        public static extern void GenBuffers(Int32 n, [OutAttribute] out UInt32 buffers);

        /// <summary>[requires: v1.5]
        /// Generate buffer object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of buffer object names to be generated.
        /// </para>
        /// </param>
        /// <param name="buffers">
        /// <para>
        /// Specifies an array in which the generated buffer object names are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGenBuffers")]
        public static extern unsafe void GenBuffers(Int32 n, [OutAttribute] UInt32* buffers);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Generate mipmaps for a specified texture target
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target to which the texture whose mimaps to generate is bound. target must be GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY or GL_TEXTURE_CUBE_MAP.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glGenerateMipmap")]
        public static extern void GenerateMipmap(OpenTK.Graphics.OpenGL.GenerateMipmapTarget target);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Generate framebuffer object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of framebuffer object names to generate.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array in which the generated framebuffer object names are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glGenFramebuffers")]
        public static extern Int32 GenFramebuffer();

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Generate framebuffer object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of framebuffer object names to generate.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array in which the generated framebuffer object names are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glGenFramebuffers")]
        public static extern void GenFramebuffers(Int32 n, [OutAttribute] Int32[] framebuffers);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Generate framebuffer object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of framebuffer object names to generate.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array in which the generated framebuffer object names are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glGenFramebuffers")]
        public static extern void GenFramebuffers(Int32 n, [OutAttribute] out Int32 framebuffers);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Generate framebuffer object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of framebuffer object names to generate.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array in which the generated framebuffer object names are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glGenFramebuffers")]
        public static extern unsafe void GenFramebuffers(Int32 n, [OutAttribute] Int32* framebuffers);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Generate framebuffer object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of framebuffer object names to generate.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array in which the generated framebuffer object names are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glGenFramebuffers")]
        public static extern void GenFramebuffers(Int32 n, [OutAttribute] UInt32[] framebuffers);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Generate framebuffer object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of framebuffer object names to generate.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array in which the generated framebuffer object names are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glGenFramebuffers")]
        public static extern void GenFramebuffers(Int32 n, [OutAttribute] out UInt32 framebuffers);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Generate framebuffer object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of framebuffer object names to generate.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array in which the generated framebuffer object names are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glGenFramebuffers")]
        public static extern unsafe void GenFramebuffers(Int32 n, [OutAttribute] UInt32* framebuffers);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Generate a contiguous set of empty display lists
        /// </summary>
        /// <param name="range">
        /// <para>
        /// Specifies the number of contiguous empty display lists to be generated.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGenLists")]
        public static extern Int32 GenLists(Int32 range);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Reserve program pipeline object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of program pipeline object names to reserve.
        /// </para>
        /// </param>
        /// <param name="pipelines">
        /// <para>
        /// Specifies an array of into which the reserved names will be written.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glGenProgramPipelines")]
        public static extern Int32 GenProgramPipeline();

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Reserve program pipeline object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of program pipeline object names to reserve.
        /// </para>
        /// </param>
        /// <param name="pipelines">
        /// <para>
        /// Specifies an array of into which the reserved names will be written.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glGenProgramPipelines")]
        public static extern void GenProgramPipelines(Int32 n, [OutAttribute] Int32[] pipelines);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Reserve program pipeline object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of program pipeline object names to reserve.
        /// </para>
        /// </param>
        /// <param name="pipelines">
        /// <para>
        /// Specifies an array of into which the reserved names will be written.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glGenProgramPipelines")]
        public static extern void GenProgramPipelines(Int32 n, [OutAttribute] out Int32 pipelines);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Reserve program pipeline object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of program pipeline object names to reserve.
        /// </para>
        /// </param>
        /// <param name="pipelines">
        /// <para>
        /// Specifies an array of into which the reserved names will be written.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glGenProgramPipelines")]
        public static extern unsafe void GenProgramPipelines(Int32 n, [OutAttribute] Int32* pipelines);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Reserve program pipeline object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of program pipeline object names to reserve.
        /// </para>
        /// </param>
        /// <param name="pipelines">
        /// <para>
        /// Specifies an array of into which the reserved names will be written.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glGenProgramPipelines")]
        public static extern void GenProgramPipelines(Int32 n, [OutAttribute] UInt32[] pipelines);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Reserve program pipeline object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of program pipeline object names to reserve.
        /// </para>
        /// </param>
        /// <param name="pipelines">
        /// <para>
        /// Specifies an array of into which the reserved names will be written.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glGenProgramPipelines")]
        public static extern void GenProgramPipelines(Int32 n, [OutAttribute] out UInt32 pipelines);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Reserve program pipeline object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of program pipeline object names to reserve.
        /// </para>
        /// </param>
        /// <param name="pipelines">
        /// <para>
        /// Specifies an array of into which the reserved names will be written.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glGenProgramPipelines")]
        public static extern unsafe void GenProgramPipelines(Int32 n, [OutAttribute] UInt32* pipelines);

        /// <summary>[requires: v1.5]
        /// Generate query object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of query object names to be generated.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array in which the generated query object names are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGenQueries")]
        public static extern Int32 GenQuery();

        /// <summary>[requires: v1.5]
        /// Generate query object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of query object names to be generated.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array in which the generated query object names are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGenQueries")]
        public static extern void GenQueries(Int32 n, [OutAttribute] Int32[] ids);

        /// <summary>[requires: v1.5]
        /// Generate query object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of query object names to be generated.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array in which the generated query object names are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGenQueries")]
        public static extern void GenQueries(Int32 n, [OutAttribute] out Int32 ids);

        /// <summary>[requires: v1.5]
        /// Generate query object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of query object names to be generated.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array in which the generated query object names are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGenQueries")]
        public static extern unsafe void GenQueries(Int32 n, [OutAttribute] Int32* ids);

        /// <summary>[requires: v1.5]
        /// Generate query object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of query object names to be generated.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array in which the generated query object names are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGenQueries")]
        public static extern void GenQueries(Int32 n, [OutAttribute] UInt32[] ids);

        /// <summary>[requires: v1.5]
        /// Generate query object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of query object names to be generated.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array in which the generated query object names are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGenQueries")]
        public static extern void GenQueries(Int32 n, [OutAttribute] out UInt32 ids);

        /// <summary>[requires: v1.5]
        /// Generate query object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of query object names to be generated.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array in which the generated query object names are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGenQueries")]
        public static extern unsafe void GenQueries(Int32 n, [OutAttribute] UInt32* ids);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Generate renderbuffer object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of renderbuffer object names to generate.
        /// </para>
        /// </param>
        /// <param name="renderbuffers">
        /// <para>
        /// Specifies an array in which the generated renderbuffer object names are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glGenRenderbuffers")]
        public static extern Int32 GenRenderbuffer();

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Generate renderbuffer object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of renderbuffer object names to generate.
        /// </para>
        /// </param>
        /// <param name="renderbuffers">
        /// <para>
        /// Specifies an array in which the generated renderbuffer object names are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glGenRenderbuffers")]
        public static extern void GenRenderbuffers(Int32 n, [OutAttribute] Int32[] renderbuffers);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Generate renderbuffer object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of renderbuffer object names to generate.
        /// </para>
        /// </param>
        /// <param name="renderbuffers">
        /// <para>
        /// Specifies an array in which the generated renderbuffer object names are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glGenRenderbuffers")]
        public static extern void GenRenderbuffers(Int32 n, [OutAttribute] out Int32 renderbuffers);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Generate renderbuffer object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of renderbuffer object names to generate.
        /// </para>
        /// </param>
        /// <param name="renderbuffers">
        /// <para>
        /// Specifies an array in which the generated renderbuffer object names are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glGenRenderbuffers")]
        public static extern unsafe void GenRenderbuffers(Int32 n, [OutAttribute] Int32* renderbuffers);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Generate renderbuffer object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of renderbuffer object names to generate.
        /// </para>
        /// </param>
        /// <param name="renderbuffers">
        /// <para>
        /// Specifies an array in which the generated renderbuffer object names are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glGenRenderbuffers")]
        public static extern void GenRenderbuffers(Int32 n, [OutAttribute] UInt32[] renderbuffers);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Generate renderbuffer object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of renderbuffer object names to generate.
        /// </para>
        /// </param>
        /// <param name="renderbuffers">
        /// <para>
        /// Specifies an array in which the generated renderbuffer object names are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glGenRenderbuffers")]
        public static extern void GenRenderbuffers(Int32 n, [OutAttribute] out UInt32 renderbuffers);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Generate renderbuffer object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of renderbuffer object names to generate.
        /// </para>
        /// </param>
        /// <param name="renderbuffers">
        /// <para>
        /// Specifies an array in which the generated renderbuffer object names are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glGenRenderbuffers")]
        public static extern unsafe void GenRenderbuffers(Int32 n, [OutAttribute] UInt32* renderbuffers);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Generate sampler object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of sampler object names to generate.
        /// </para>
        /// </param>
        /// <param name="samplers">
        /// <para>
        /// Specifies an array in which the generated sampler object names are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glGenSamplers")]
        public static extern Int32 GenSampler();

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Generate sampler object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of sampler object names to generate.
        /// </para>
        /// </param>
        /// <param name="samplers">
        /// <para>
        /// Specifies an array in which the generated sampler object names are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glGenSamplers")]
        public static extern void GenSamplers(Int32 count, [OutAttribute] Int32[] samplers);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Generate sampler object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of sampler object names to generate.
        /// </para>
        /// </param>
        /// <param name="samplers">
        /// <para>
        /// Specifies an array in which the generated sampler object names are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glGenSamplers")]
        public static extern void GenSamplers(Int32 count, [OutAttribute] out Int32 samplers);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Generate sampler object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of sampler object names to generate.
        /// </para>
        /// </param>
        /// <param name="samplers">
        /// <para>
        /// Specifies an array in which the generated sampler object names are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glGenSamplers")]
        public static extern unsafe void GenSamplers(Int32 count, [OutAttribute] Int32* samplers);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Generate sampler object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of sampler object names to generate.
        /// </para>
        /// </param>
        /// <param name="samplers">
        /// <para>
        /// Specifies an array in which the generated sampler object names are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glGenSamplers")]
        public static extern void GenSamplers(Int32 count, [OutAttribute] UInt32[] samplers);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Generate sampler object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of sampler object names to generate.
        /// </para>
        /// </param>
        /// <param name="samplers">
        /// <para>
        /// Specifies an array in which the generated sampler object names are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glGenSamplers")]
        public static extern void GenSamplers(Int32 count, [OutAttribute] out UInt32 samplers);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Generate sampler object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of sampler object names to generate.
        /// </para>
        /// </param>
        /// <param name="samplers">
        /// <para>
        /// Specifies an array in which the generated sampler object names are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glGenSamplers")]
        public static extern unsafe void GenSamplers(Int32 count, [OutAttribute] UInt32* samplers);

        /// <summary>[requires: v1.1]
        /// Generate texture names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of texture names to be generated.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies an array in which the generated texture names are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glGenTextures")]
        public static extern Int32 GenTexture();

        /// <summary>[requires: v1.1]
        /// Generate texture names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of texture names to be generated.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies an array in which the generated texture names are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glGenTextures")]
        public static extern void GenTextures(Int32 n, [OutAttribute] Int32[] textures);

        /// <summary>[requires: v1.1]
        /// Generate texture names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of texture names to be generated.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies an array in which the generated texture names are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glGenTextures")]
        public static extern void GenTextures(Int32 n, [OutAttribute] out Int32 textures);

        /// <summary>[requires: v1.1]
        /// Generate texture names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of texture names to be generated.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies an array in which the generated texture names are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glGenTextures")]
        public static extern unsafe void GenTextures(Int32 n, [OutAttribute] Int32* textures);

        /// <summary>[requires: v1.1]
        /// Generate texture names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of texture names to be generated.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies an array in which the generated texture names are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glGenTextures")]
        public static extern void GenTextures(Int32 n, [OutAttribute] UInt32[] textures);

        /// <summary>[requires: v1.1]
        /// Generate texture names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of texture names to be generated.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies an array in which the generated texture names are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glGenTextures")]
        public static extern void GenTextures(Int32 n, [OutAttribute] out UInt32 textures);

        /// <summary>[requires: v1.1]
        /// Generate texture names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of texture names to be generated.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies an array in which the generated texture names are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glGenTextures")]
        public static extern unsafe void GenTextures(Int32 n, [OutAttribute] UInt32* textures);

        /// <summary>[requires: v4.0 and ARB_transform_feedback2|VERSION_4_0]
        /// Reserve transform feedback object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of transform feedback object names to reserve.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array of into which the reserved names will be written.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_transform_feedback2|VERSION_4_0", Version = "4.0", EntryPoint = "glGenTransformFeedbacks")]
        public static extern Int32 GenTransformFeedback();

        /// <summary>[requires: v4.0 and ARB_transform_feedback2|VERSION_4_0]
        /// Reserve transform feedback object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of transform feedback object names to reserve.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array of into which the reserved names will be written.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_transform_feedback2|VERSION_4_0", Version = "4.0", EntryPoint = "glGenTransformFeedbacks")]
        public static extern void GenTransformFeedbacks(Int32 n, [OutAttribute] Int32[] ids);

        /// <summary>[requires: v4.0 and ARB_transform_feedback2|VERSION_4_0]
        /// Reserve transform feedback object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of transform feedback object names to reserve.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array of into which the reserved names will be written.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_transform_feedback2|VERSION_4_0", Version = "4.0", EntryPoint = "glGenTransformFeedbacks")]
        public static extern void GenTransformFeedbacks(Int32 n, [OutAttribute] out Int32 ids);

        /// <summary>[requires: v4.0 and ARB_transform_feedback2|VERSION_4_0]
        /// Reserve transform feedback object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of transform feedback object names to reserve.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array of into which the reserved names will be written.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_transform_feedback2|VERSION_4_0", Version = "4.0", EntryPoint = "glGenTransformFeedbacks")]
        public static extern unsafe void GenTransformFeedbacks(Int32 n, [OutAttribute] Int32* ids);

        /// <summary>[requires: v4.0 and ARB_transform_feedback2|VERSION_4_0]
        /// Reserve transform feedback object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of transform feedback object names to reserve.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array of into which the reserved names will be written.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_transform_feedback2|VERSION_4_0", Version = "4.0", EntryPoint = "glGenTransformFeedbacks")]
        public static extern void GenTransformFeedbacks(Int32 n, [OutAttribute] UInt32[] ids);

        /// <summary>[requires: v4.0 and ARB_transform_feedback2|VERSION_4_0]
        /// Reserve transform feedback object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of transform feedback object names to reserve.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array of into which the reserved names will be written.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_transform_feedback2|VERSION_4_0", Version = "4.0", EntryPoint = "glGenTransformFeedbacks")]
        public static extern void GenTransformFeedbacks(Int32 n, [OutAttribute] out UInt32 ids);

        /// <summary>[requires: v4.0 and ARB_transform_feedback2|VERSION_4_0]
        /// Reserve transform feedback object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of transform feedback object names to reserve.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// Specifies an array of into which the reserved names will be written.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_transform_feedback2|VERSION_4_0", Version = "4.0", EntryPoint = "glGenTransformFeedbacks")]
        public static extern unsafe void GenTransformFeedbacks(Int32 n, [OutAttribute] UInt32* ids);

        /// <summary>[requires: v3.0 and ARB_vertex_array_object|VERSION_3_0]
        /// Generate vertex array object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of vertex array object names to generate.
        /// </para>
        /// </param>
        /// <param name="arrays">
        /// <para>
        /// Specifies an array in which the generated vertex array object names are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_vertex_array_object|VERSION_3_0", Version = "3.0", EntryPoint = "glGenVertexArrays")]
        public static extern Int32 GenVertexArray();

        /// <summary>[requires: v3.0 and ARB_vertex_array_object|VERSION_3_0]
        /// Generate vertex array object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of vertex array object names to generate.
        /// </para>
        /// </param>
        /// <param name="arrays">
        /// <para>
        /// Specifies an array in which the generated vertex array object names are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_vertex_array_object|VERSION_3_0", Version = "3.0", EntryPoint = "glGenVertexArrays")]
        public static extern void GenVertexArrays(Int32 n, [OutAttribute] Int32[] arrays);

        /// <summary>[requires: v3.0 and ARB_vertex_array_object|VERSION_3_0]
        /// Generate vertex array object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of vertex array object names to generate.
        /// </para>
        /// </param>
        /// <param name="arrays">
        /// <para>
        /// Specifies an array in which the generated vertex array object names are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_vertex_array_object|VERSION_3_0", Version = "3.0", EntryPoint = "glGenVertexArrays")]
        public static extern void GenVertexArrays(Int32 n, [OutAttribute] out Int32 arrays);

        /// <summary>[requires: v3.0 and ARB_vertex_array_object|VERSION_3_0]
        /// Generate vertex array object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of vertex array object names to generate.
        /// </para>
        /// </param>
        /// <param name="arrays">
        /// <para>
        /// Specifies an array in which the generated vertex array object names are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_array_object|VERSION_3_0", Version = "3.0", EntryPoint = "glGenVertexArrays")]
        public static extern unsafe void GenVertexArrays(Int32 n, [OutAttribute] Int32* arrays);

        /// <summary>[requires: v3.0 and ARB_vertex_array_object|VERSION_3_0]
        /// Generate vertex array object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of vertex array object names to generate.
        /// </para>
        /// </param>
        /// <param name="arrays">
        /// <para>
        /// Specifies an array in which the generated vertex array object names are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_array_object|VERSION_3_0", Version = "3.0", EntryPoint = "glGenVertexArrays")]
        public static extern void GenVertexArrays(Int32 n, [OutAttribute] UInt32[] arrays);

        /// <summary>[requires: v3.0 and ARB_vertex_array_object|VERSION_3_0]
        /// Generate vertex array object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of vertex array object names to generate.
        /// </para>
        /// </param>
        /// <param name="arrays">
        /// <para>
        /// Specifies an array in which the generated vertex array object names are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_array_object|VERSION_3_0", Version = "3.0", EntryPoint = "glGenVertexArrays")]
        public static extern void GenVertexArrays(Int32 n, [OutAttribute] out UInt32 arrays);

        /// <summary>[requires: v3.0 and ARB_vertex_array_object|VERSION_3_0]
        /// Generate vertex array object names
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of vertex array object names to generate.
        /// </para>
        /// </param>
        /// <param name="arrays">
        /// <para>
        /// Specifies an array in which the generated vertex array object names are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_array_object|VERSION_3_0", Version = "3.0", EntryPoint = "glGenVertexArrays")]
        public static extern unsafe void GenVertexArrays(Int32 n, [OutAttribute] UInt32* arrays);

        /// <summary>[requires: v4.2 and ARB_shader_atomic_counters|VERSION_4_2]
        /// Retrieve information about the set of active atomic counter buffers for a program
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of a program object from which to retrieve information.
        /// </para>
        /// </param>
        /// <param name="bufferIndex">
        /// <para>
        /// Specifies index of an active atomic counter buffer.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies which parameter of the atomic counter buffer to retrieve.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Specifies the address of a variable into which to write the retrieved information.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_shader_atomic_counters|VERSION_4_2", Version = "4.2", EntryPoint = "glGetActiveAtomicCounterBufferiv")]
        public static extern void GetActiveAtomicCounterBuffer(Int32 program, Int32 bufferIndex, OpenTK.Graphics.OpenGL.AtomicCounterBufferParameter pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v4.2 and ARB_shader_atomic_counters|VERSION_4_2]
        /// Retrieve information about the set of active atomic counter buffers for a program
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of a program object from which to retrieve information.
        /// </para>
        /// </param>
        /// <param name="bufferIndex">
        /// <para>
        /// Specifies index of an active atomic counter buffer.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies which parameter of the atomic counter buffer to retrieve.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Specifies the address of a variable into which to write the retrieved information.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_shader_atomic_counters|VERSION_4_2", Version = "4.2", EntryPoint = "glGetActiveAtomicCounterBufferiv")]
        public static extern void GetActiveAtomicCounterBuffer(Int32 program, Int32 bufferIndex, OpenTK.Graphics.OpenGL.AtomicCounterBufferParameter pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v4.2 and ARB_shader_atomic_counters|VERSION_4_2]
        /// Retrieve information about the set of active atomic counter buffers for a program
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of a program object from which to retrieve information.
        /// </para>
        /// </param>
        /// <param name="bufferIndex">
        /// <para>
        /// Specifies index of an active atomic counter buffer.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies which parameter of the atomic counter buffer to retrieve.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Specifies the address of a variable into which to write the retrieved information.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_shader_atomic_counters|VERSION_4_2", Version = "4.2", EntryPoint = "glGetActiveAtomicCounterBufferiv")]
        public static extern unsafe void GetActiveAtomicCounterBuffer(Int32 program, Int32 bufferIndex, OpenTK.Graphics.OpenGL.AtomicCounterBufferParameter pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v4.2 and ARB_shader_atomic_counters|VERSION_4_2]
        /// Retrieve information about the set of active atomic counter buffers for a program
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of a program object from which to retrieve information.
        /// </para>
        /// </param>
        /// <param name="bufferIndex">
        /// <para>
        /// Specifies index of an active atomic counter buffer.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies which parameter of the atomic counter buffer to retrieve.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Specifies the address of a variable into which to write the retrieved information.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_shader_atomic_counters|VERSION_4_2", Version = "4.2", EntryPoint = "glGetActiveAtomicCounterBufferiv")]
        public static extern void GetActiveAtomicCounterBuffer(UInt32 program, UInt32 bufferIndex, OpenTK.Graphics.OpenGL.AtomicCounterBufferParameter pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v4.2 and ARB_shader_atomic_counters|VERSION_4_2]
        /// Retrieve information about the set of active atomic counter buffers for a program
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of a program object from which to retrieve information.
        /// </para>
        /// </param>
        /// <param name="bufferIndex">
        /// <para>
        /// Specifies index of an active atomic counter buffer.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies which parameter of the atomic counter buffer to retrieve.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Specifies the address of a variable into which to write the retrieved information.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_shader_atomic_counters|VERSION_4_2", Version = "4.2", EntryPoint = "glGetActiveAtomicCounterBufferiv")]
        public static extern void GetActiveAtomicCounterBuffer(UInt32 program, UInt32 bufferIndex, OpenTK.Graphics.OpenGL.AtomicCounterBufferParameter pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v4.2 and ARB_shader_atomic_counters|VERSION_4_2]
        /// Retrieve information about the set of active atomic counter buffers for a program
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of a program object from which to retrieve information.
        /// </para>
        /// </param>
        /// <param name="bufferIndex">
        /// <para>
        /// Specifies index of an active atomic counter buffer.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies which parameter of the atomic counter buffer to retrieve.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Specifies the address of a variable into which to write the retrieved information.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_shader_atomic_counters|VERSION_4_2", Version = "4.2", EntryPoint = "glGetActiveAtomicCounterBufferiv")]
        public static extern unsafe void GetActiveAtomicCounterBuffer(UInt32 program, UInt32 bufferIndex, OpenTK.Graphics.OpenGL.AtomicCounterBufferParameter pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v2.0]
        /// Returns information about an active attribute variable for the specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the attribute variable to be queried.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the maximum number of characters OpenGL is allowed to write in the character buffer indicated by name.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Returns the number of characters actually written by OpenGL in the string indicated by name (excluding the null terminator) if a value other than NULL is passed.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Returns the size of the attribute variable.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Returns the data type of the attribute variable.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// Returns a null terminated string containing the name of the attribute variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetActiveAttrib")]
        public static extern void GetActiveAttrib(Int32 program, Int32 index, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] out Int32 size, [OutAttribute] out OpenTK.Graphics.OpenGL.ActiveAttribType type, [OutAttribute] StringBuilder name);

        /// <summary>[requires: v2.0]
        /// Returns information about an active attribute variable for the specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the attribute variable to be queried.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the maximum number of characters OpenGL is allowed to write in the character buffer indicated by name.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Returns the number of characters actually written by OpenGL in the string indicated by name (excluding the null terminator) if a value other than NULL is passed.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Returns the size of the attribute variable.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Returns the data type of the attribute variable.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// Returns a null terminated string containing the name of the attribute variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetActiveAttrib")]
        public static extern unsafe void GetActiveAttrib(Int32 program, Int32 index, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] Int32* size, [OutAttribute] OpenTK.Graphics.OpenGL.ActiveAttribType* type, [OutAttribute] StringBuilder name);

        /// <summary>[requires: v2.0]
        /// Returns information about an active attribute variable for the specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the attribute variable to be queried.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the maximum number of characters OpenGL is allowed to write in the character buffer indicated by name.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Returns the number of characters actually written by OpenGL in the string indicated by name (excluding the null terminator) if a value other than NULL is passed.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Returns the size of the attribute variable.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Returns the data type of the attribute variable.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// Returns a null terminated string containing the name of the attribute variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetActiveAttrib")]
        public static extern void GetActiveAttrib(UInt32 program, UInt32 index, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] out Int32 size, [OutAttribute] out OpenTK.Graphics.OpenGL.ActiveAttribType type, [OutAttribute] StringBuilder name);

        /// <summary>[requires: v2.0]
        /// Returns information about an active attribute variable for the specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the attribute variable to be queried.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the maximum number of characters OpenGL is allowed to write in the character buffer indicated by name.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Returns the number of characters actually written by OpenGL in the string indicated by name (excluding the null terminator) if a value other than NULL is passed.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Returns the size of the attribute variable.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Returns the data type of the attribute variable.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// Returns a null terminated string containing the name of the attribute variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetActiveAttrib")]
        public static extern unsafe void GetActiveAttrib(UInt32 program, UInt32 index, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] Int32* size, [OutAttribute] OpenTK.Graphics.OpenGL.ActiveAttribType* type, [OutAttribute] StringBuilder name);

        /// <summary>[requires: v4.0 and ARB_shader_subroutine|VERSION_4_0]
        /// Query the name of an active shader subroutine
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of the program containing the subroutine.
        /// </para>
        /// </param>
        /// <param name="shadertype">
        /// <para>
        /// Specifies the shader stage from which to query the subroutine name.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the shader subroutine uniform.
        /// </para>
        /// </param>
        /// <param name="bufsize">
        /// <para>
        /// Specifies the size of the buffer whose address is given in name.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable which is to receive the length of the shader subroutine uniform name.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// Specifies the address of an array into which the name of the shader subroutine uniform will be written.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_shader_subroutine|VERSION_4_0", Version = "4.0", EntryPoint = "glGetActiveSubroutineName")]
        public static extern void GetActiveSubroutineName(Int32 program, OpenTK.Graphics.OpenGL.ShaderType shadertype, Int32 index, Int32 bufsize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder name);

        /// <summary>[requires: v4.0 and ARB_shader_subroutine|VERSION_4_0]
        /// Query the name of an active shader subroutine
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of the program containing the subroutine.
        /// </para>
        /// </param>
        /// <param name="shadertype">
        /// <para>
        /// Specifies the shader stage from which to query the subroutine name.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the shader subroutine uniform.
        /// </para>
        /// </param>
        /// <param name="bufsize">
        /// <para>
        /// Specifies the size of the buffer whose address is given in name.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable which is to receive the length of the shader subroutine uniform name.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// Specifies the address of an array into which the name of the shader subroutine uniform will be written.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_shader_subroutine|VERSION_4_0", Version = "4.0", EntryPoint = "glGetActiveSubroutineName")]
        public static extern unsafe void GetActiveSubroutineName(Int32 program, OpenTK.Graphics.OpenGL.ShaderType shadertype, Int32 index, Int32 bufsize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder name);

        /// <summary>[requires: v4.0 and ARB_shader_subroutine|VERSION_4_0]
        /// Query the name of an active shader subroutine
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of the program containing the subroutine.
        /// </para>
        /// </param>
        /// <param name="shadertype">
        /// <para>
        /// Specifies the shader stage from which to query the subroutine name.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the shader subroutine uniform.
        /// </para>
        /// </param>
        /// <param name="bufsize">
        /// <para>
        /// Specifies the size of the buffer whose address is given in name.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable which is to receive the length of the shader subroutine uniform name.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// Specifies the address of an array into which the name of the shader subroutine uniform will be written.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_shader_subroutine|VERSION_4_0", Version = "4.0", EntryPoint = "glGetActiveSubroutineName")]
        public static extern void GetActiveSubroutineName(UInt32 program, OpenTK.Graphics.OpenGL.ShaderType shadertype, UInt32 index, Int32 bufsize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder name);

        /// <summary>[requires: v4.0 and ARB_shader_subroutine|VERSION_4_0]
        /// Query the name of an active shader subroutine
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of the program containing the subroutine.
        /// </para>
        /// </param>
        /// <param name="shadertype">
        /// <para>
        /// Specifies the shader stage from which to query the subroutine name.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the shader subroutine uniform.
        /// </para>
        /// </param>
        /// <param name="bufsize">
        /// <para>
        /// Specifies the size of the buffer whose address is given in name.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable which is to receive the length of the shader subroutine uniform name.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// Specifies the address of an array into which the name of the shader subroutine uniform will be written.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_shader_subroutine|VERSION_4_0", Version = "4.0", EntryPoint = "glGetActiveSubroutineName")]
        public static extern unsafe void GetActiveSubroutineName(UInt32 program, OpenTK.Graphics.OpenGL.ShaderType shadertype, UInt32 index, Int32 bufsize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder name);

        /// <summary>[requires: v4.0 and ARB_shader_subroutine|VERSION_4_0]
        /// Query a property of an active shader subroutine uniform
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of the program containing the subroutine.
        /// </para>
        /// </param>
        /// <param name="shadertype">
        /// <para>
        /// Specifies the shader stage from which to query for the subroutine parameter. shadertype must be one of GL_VERTEX_SHADER, GL_TESS_CONTROL_SHADER, GL_TESS_EVALUATION_SHADER, GL_GEOMETRY_SHADER or GL_FRAGMENT_SHADER.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the shader subroutine uniform.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the parameter of the shader subroutine uniform to query. pname must be GL_NUM_COMPATIBLE_SUBROUTINES, GL_COMPATIBLE_SUBROUTINES, GL_UNIFORM_SIZE or GL_UNIFORM_NAME_LENGTH.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies the address of a into which the queried value or values will be placed.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_shader_subroutine|VERSION_4_0", Version = "4.0", EntryPoint = "glGetActiveSubroutineUniformiv")]
        public static extern void GetActiveSubroutineUniform(Int32 program, OpenTK.Graphics.OpenGL.ShaderType shadertype, Int32 index, OpenTK.Graphics.OpenGL.ActiveSubroutineUniformParameter pname, [OutAttribute] Int32[] values);

        /// <summary>[requires: v4.0 and ARB_shader_subroutine|VERSION_4_0]
        /// Query a property of an active shader subroutine uniform
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of the program containing the subroutine.
        /// </para>
        /// </param>
        /// <param name="shadertype">
        /// <para>
        /// Specifies the shader stage from which to query for the subroutine parameter. shadertype must be one of GL_VERTEX_SHADER, GL_TESS_CONTROL_SHADER, GL_TESS_EVALUATION_SHADER, GL_GEOMETRY_SHADER or GL_FRAGMENT_SHADER.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the shader subroutine uniform.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the parameter of the shader subroutine uniform to query. pname must be GL_NUM_COMPATIBLE_SUBROUTINES, GL_COMPATIBLE_SUBROUTINES, GL_UNIFORM_SIZE or GL_UNIFORM_NAME_LENGTH.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies the address of a into which the queried value or values will be placed.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_shader_subroutine|VERSION_4_0", Version = "4.0", EntryPoint = "glGetActiveSubroutineUniformiv")]
        public static extern void GetActiveSubroutineUniform(Int32 program, OpenTK.Graphics.OpenGL.ShaderType shadertype, Int32 index, OpenTK.Graphics.OpenGL.ActiveSubroutineUniformParameter pname, [OutAttribute] out Int32 values);

        /// <summary>[requires: v4.0 and ARB_shader_subroutine|VERSION_4_0]
        /// Query a property of an active shader subroutine uniform
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of the program containing the subroutine.
        /// </para>
        /// </param>
        /// <param name="shadertype">
        /// <para>
        /// Specifies the shader stage from which to query for the subroutine parameter. shadertype must be one of GL_VERTEX_SHADER, GL_TESS_CONTROL_SHADER, GL_TESS_EVALUATION_SHADER, GL_GEOMETRY_SHADER or GL_FRAGMENT_SHADER.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the shader subroutine uniform.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the parameter of the shader subroutine uniform to query. pname must be GL_NUM_COMPATIBLE_SUBROUTINES, GL_COMPATIBLE_SUBROUTINES, GL_UNIFORM_SIZE or GL_UNIFORM_NAME_LENGTH.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies the address of a into which the queried value or values will be placed.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_shader_subroutine|VERSION_4_0", Version = "4.0", EntryPoint = "glGetActiveSubroutineUniformiv")]
        public static extern unsafe void GetActiveSubroutineUniform(Int32 program, OpenTK.Graphics.OpenGL.ShaderType shadertype, Int32 index, OpenTK.Graphics.OpenGL.ActiveSubroutineUniformParameter pname, [OutAttribute] Int32* values);

        /// <summary>[requires: v4.0 and ARB_shader_subroutine|VERSION_4_0]
        /// Query a property of an active shader subroutine uniform
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of the program containing the subroutine.
        /// </para>
        /// </param>
        /// <param name="shadertype">
        /// <para>
        /// Specifies the shader stage from which to query for the subroutine parameter. shadertype must be one of GL_VERTEX_SHADER, GL_TESS_CONTROL_SHADER, GL_TESS_EVALUATION_SHADER, GL_GEOMETRY_SHADER or GL_FRAGMENT_SHADER.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the shader subroutine uniform.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the parameter of the shader subroutine uniform to query. pname must be GL_NUM_COMPATIBLE_SUBROUTINES, GL_COMPATIBLE_SUBROUTINES, GL_UNIFORM_SIZE or GL_UNIFORM_NAME_LENGTH.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies the address of a into which the queried value or values will be placed.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_shader_subroutine|VERSION_4_0", Version = "4.0", EntryPoint = "glGetActiveSubroutineUniformiv")]
        public static extern void GetActiveSubroutineUniform(UInt32 program, OpenTK.Graphics.OpenGL.ShaderType shadertype, UInt32 index, OpenTK.Graphics.OpenGL.ActiveSubroutineUniformParameter pname, [OutAttribute] Int32[] values);

        /// <summary>[requires: v4.0 and ARB_shader_subroutine|VERSION_4_0]
        /// Query a property of an active shader subroutine uniform
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of the program containing the subroutine.
        /// </para>
        /// </param>
        /// <param name="shadertype">
        /// <para>
        /// Specifies the shader stage from which to query for the subroutine parameter. shadertype must be one of GL_VERTEX_SHADER, GL_TESS_CONTROL_SHADER, GL_TESS_EVALUATION_SHADER, GL_GEOMETRY_SHADER or GL_FRAGMENT_SHADER.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the shader subroutine uniform.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the parameter of the shader subroutine uniform to query. pname must be GL_NUM_COMPATIBLE_SUBROUTINES, GL_COMPATIBLE_SUBROUTINES, GL_UNIFORM_SIZE or GL_UNIFORM_NAME_LENGTH.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies the address of a into which the queried value or values will be placed.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_shader_subroutine|VERSION_4_0", Version = "4.0", EntryPoint = "glGetActiveSubroutineUniformiv")]
        public static extern void GetActiveSubroutineUniform(UInt32 program, OpenTK.Graphics.OpenGL.ShaderType shadertype, UInt32 index, OpenTK.Graphics.OpenGL.ActiveSubroutineUniformParameter pname, [OutAttribute] out Int32 values);

        /// <summary>[requires: v4.0 and ARB_shader_subroutine|VERSION_4_0]
        /// Query a property of an active shader subroutine uniform
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of the program containing the subroutine.
        /// </para>
        /// </param>
        /// <param name="shadertype">
        /// <para>
        /// Specifies the shader stage from which to query for the subroutine parameter. shadertype must be one of GL_VERTEX_SHADER, GL_TESS_CONTROL_SHADER, GL_TESS_EVALUATION_SHADER, GL_GEOMETRY_SHADER or GL_FRAGMENT_SHADER.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the shader subroutine uniform.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the parameter of the shader subroutine uniform to query. pname must be GL_NUM_COMPATIBLE_SUBROUTINES, GL_COMPATIBLE_SUBROUTINES, GL_UNIFORM_SIZE or GL_UNIFORM_NAME_LENGTH.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies the address of a into which the queried value or values will be placed.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_shader_subroutine|VERSION_4_0", Version = "4.0", EntryPoint = "glGetActiveSubroutineUniformiv")]
        public static extern unsafe void GetActiveSubroutineUniform(UInt32 program, OpenTK.Graphics.OpenGL.ShaderType shadertype, UInt32 index, OpenTK.Graphics.OpenGL.ActiveSubroutineUniformParameter pname, [OutAttribute] Int32* values);

        /// <summary>[requires: v4.0 and ARB_shader_subroutine|VERSION_4_0]
        /// Query the name of an active shader subroutine uniform
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of the program containing the subroutine.
        /// </para>
        /// </param>
        /// <param name="shadertype">
        /// <para>
        /// Specifies the shader stage from which to query for the subroutine parameter. shadertype must be one of GL_VERTEX_SHADER, GL_TESS_CONTROL_SHADER, GL_TESS_EVALUATION_SHADER, GL_GEOMETRY_SHADER or GL_FRAGMENT_SHADER.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the shader subroutine uniform.
        /// </para>
        /// </param>
        /// <param name="bufsize">
        /// <para>
        /// Specifies the size of the buffer whose address is given in name.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable into which is written the number of characters copied into name.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// Specifies the address of a buffer that will receive the name of the specified shader subroutine uniform.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_shader_subroutine|VERSION_4_0", Version = "4.0", EntryPoint = "glGetActiveSubroutineUniformName")]
        public static extern void GetActiveSubroutineUniformName(Int32 program, OpenTK.Graphics.OpenGL.ShaderType shadertype, Int32 index, Int32 bufsize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder name);

        /// <summary>[requires: v4.0 and ARB_shader_subroutine|VERSION_4_0]
        /// Query the name of an active shader subroutine uniform
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of the program containing the subroutine.
        /// </para>
        /// </param>
        /// <param name="shadertype">
        /// <para>
        /// Specifies the shader stage from which to query for the subroutine parameter. shadertype must be one of GL_VERTEX_SHADER, GL_TESS_CONTROL_SHADER, GL_TESS_EVALUATION_SHADER, GL_GEOMETRY_SHADER or GL_FRAGMENT_SHADER.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the shader subroutine uniform.
        /// </para>
        /// </param>
        /// <param name="bufsize">
        /// <para>
        /// Specifies the size of the buffer whose address is given in name.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable into which is written the number of characters copied into name.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// Specifies the address of a buffer that will receive the name of the specified shader subroutine uniform.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_shader_subroutine|VERSION_4_0", Version = "4.0", EntryPoint = "glGetActiveSubroutineUniformName")]
        public static extern unsafe void GetActiveSubroutineUniformName(Int32 program, OpenTK.Graphics.OpenGL.ShaderType shadertype, Int32 index, Int32 bufsize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder name);

        /// <summary>[requires: v4.0 and ARB_shader_subroutine|VERSION_4_0]
        /// Query the name of an active shader subroutine uniform
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of the program containing the subroutine.
        /// </para>
        /// </param>
        /// <param name="shadertype">
        /// <para>
        /// Specifies the shader stage from which to query for the subroutine parameter. shadertype must be one of GL_VERTEX_SHADER, GL_TESS_CONTROL_SHADER, GL_TESS_EVALUATION_SHADER, GL_GEOMETRY_SHADER or GL_FRAGMENT_SHADER.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the shader subroutine uniform.
        /// </para>
        /// </param>
        /// <param name="bufsize">
        /// <para>
        /// Specifies the size of the buffer whose address is given in name.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable into which is written the number of characters copied into name.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// Specifies the address of a buffer that will receive the name of the specified shader subroutine uniform.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_shader_subroutine|VERSION_4_0", Version = "4.0", EntryPoint = "glGetActiveSubroutineUniformName")]
        public static extern void GetActiveSubroutineUniformName(UInt32 program, OpenTK.Graphics.OpenGL.ShaderType shadertype, UInt32 index, Int32 bufsize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder name);

        /// <summary>[requires: v4.0 and ARB_shader_subroutine|VERSION_4_0]
        /// Query the name of an active shader subroutine uniform
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of the program containing the subroutine.
        /// </para>
        /// </param>
        /// <param name="shadertype">
        /// <para>
        /// Specifies the shader stage from which to query for the subroutine parameter. shadertype must be one of GL_VERTEX_SHADER, GL_TESS_CONTROL_SHADER, GL_TESS_EVALUATION_SHADER, GL_GEOMETRY_SHADER or GL_FRAGMENT_SHADER.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the shader subroutine uniform.
        /// </para>
        /// </param>
        /// <param name="bufsize">
        /// <para>
        /// Specifies the size of the buffer whose address is given in name.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable into which is written the number of characters copied into name.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// Specifies the address of a buffer that will receive the name of the specified shader subroutine uniform.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_shader_subroutine|VERSION_4_0", Version = "4.0", EntryPoint = "glGetActiveSubroutineUniformName")]
        public static extern unsafe void GetActiveSubroutineUniformName(UInt32 program, OpenTK.Graphics.OpenGL.ShaderType shadertype, UInt32 index, Int32 bufsize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder name);

        /// <summary>[requires: v2.0]
        /// Returns information about an active uniform variable for the specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the uniform variable to be queried.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the maximum number of characters OpenGL is allowed to write in the character buffer indicated by name.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Returns the number of characters actually written by OpenGL in the string indicated by name (excluding the null terminator) if a value other than NULL is passed.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Returns the size of the uniform variable.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Returns the data type of the uniform variable.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// Returns a null terminated string containing the name of the uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetActiveUniform")]
        public static extern void GetActiveUniform(Int32 program, Int32 index, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] out Int32 size, [OutAttribute] out OpenTK.Graphics.OpenGL.ActiveUniformType type, [OutAttribute] StringBuilder name);

        /// <summary>[requires: v2.0]
        /// Returns information about an active uniform variable for the specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the uniform variable to be queried.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the maximum number of characters OpenGL is allowed to write in the character buffer indicated by name.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Returns the number of characters actually written by OpenGL in the string indicated by name (excluding the null terminator) if a value other than NULL is passed.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Returns the size of the uniform variable.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Returns the data type of the uniform variable.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// Returns a null terminated string containing the name of the uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetActiveUniform")]
        public static extern unsafe void GetActiveUniform(Int32 program, Int32 index, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] Int32* size, [OutAttribute] OpenTK.Graphics.OpenGL.ActiveUniformType* type, [OutAttribute] StringBuilder name);

        /// <summary>[requires: v2.0]
        /// Returns information about an active uniform variable for the specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the uniform variable to be queried.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the maximum number of characters OpenGL is allowed to write in the character buffer indicated by name.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Returns the number of characters actually written by OpenGL in the string indicated by name (excluding the null terminator) if a value other than NULL is passed.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Returns the size of the uniform variable.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Returns the data type of the uniform variable.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// Returns a null terminated string containing the name of the uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetActiveUniform")]
        public static extern void GetActiveUniform(UInt32 program, UInt32 index, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] out Int32 size, [OutAttribute] out OpenTK.Graphics.OpenGL.ActiveUniformType type, [OutAttribute] StringBuilder name);

        /// <summary>[requires: v2.0]
        /// Returns information about an active uniform variable for the specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the uniform variable to be queried.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the maximum number of characters OpenGL is allowed to write in the character buffer indicated by name.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Returns the number of characters actually written by OpenGL in the string indicated by name (excluding the null terminator) if a value other than NULL is passed.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Returns the size of the uniform variable.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Returns the data type of the uniform variable.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// Returns a null terminated string containing the name of the uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetActiveUniform")]
        public static extern unsafe void GetActiveUniform(UInt32 program, UInt32 index, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] Int32* size, [OutAttribute] OpenTK.Graphics.OpenGL.ActiveUniformType* type, [OutAttribute] StringBuilder name);

        /// <summary>[requires: v3.1 and ARB_uniform_buffer_object|VERSION_3_1]
        /// Query information about an active uniform block
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program containing the uniform block.
        /// </para>
        /// </param>
        /// <param name="uniformBlockIndex">
        /// <para>
        /// Specifies the index of the uniform block within program.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the name of the parameter to query.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Specifies the address of a variable to receive the result of the query.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_uniform_buffer_object|VERSION_3_1", Version = "3.1", EntryPoint = "glGetActiveUniformBlockiv")]
        public static extern void GetActiveUniformBlock(Int32 program, Int32 uniformBlockIndex, OpenTK.Graphics.OpenGL.ActiveUniformBlockParameter pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v3.1 and ARB_uniform_buffer_object|VERSION_3_1]
        /// Query information about an active uniform block
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program containing the uniform block.
        /// </para>
        /// </param>
        /// <param name="uniformBlockIndex">
        /// <para>
        /// Specifies the index of the uniform block within program.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the name of the parameter to query.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Specifies the address of a variable to receive the result of the query.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_uniform_buffer_object|VERSION_3_1", Version = "3.1", EntryPoint = "glGetActiveUniformBlockiv")]
        public static extern void GetActiveUniformBlock(Int32 program, Int32 uniformBlockIndex, OpenTK.Graphics.OpenGL.ActiveUniformBlockParameter pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v3.1 and ARB_uniform_buffer_object|VERSION_3_1]
        /// Query information about an active uniform block
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program containing the uniform block.
        /// </para>
        /// </param>
        /// <param name="uniformBlockIndex">
        /// <para>
        /// Specifies the index of the uniform block within program.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the name of the parameter to query.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Specifies the address of a variable to receive the result of the query.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_uniform_buffer_object|VERSION_3_1", Version = "3.1", EntryPoint = "glGetActiveUniformBlockiv")]
        public static extern unsafe void GetActiveUniformBlock(Int32 program, Int32 uniformBlockIndex, OpenTK.Graphics.OpenGL.ActiveUniformBlockParameter pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v3.1 and ARB_uniform_buffer_object|VERSION_3_1]
        /// Query information about an active uniform block
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program containing the uniform block.
        /// </para>
        /// </param>
        /// <param name="uniformBlockIndex">
        /// <para>
        /// Specifies the index of the uniform block within program.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the name of the parameter to query.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Specifies the address of a variable to receive the result of the query.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_uniform_buffer_object|VERSION_3_1", Version = "3.1", EntryPoint = "glGetActiveUniformBlockiv")]
        public static extern void GetActiveUniformBlock(UInt32 program, UInt32 uniformBlockIndex, OpenTK.Graphics.OpenGL.ActiveUniformBlockParameter pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v3.1 and ARB_uniform_buffer_object|VERSION_3_1]
        /// Query information about an active uniform block
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program containing the uniform block.
        /// </para>
        /// </param>
        /// <param name="uniformBlockIndex">
        /// <para>
        /// Specifies the index of the uniform block within program.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the name of the parameter to query.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Specifies the address of a variable to receive the result of the query.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_uniform_buffer_object|VERSION_3_1", Version = "3.1", EntryPoint = "glGetActiveUniformBlockiv")]
        public static extern void GetActiveUniformBlock(UInt32 program, UInt32 uniformBlockIndex, OpenTK.Graphics.OpenGL.ActiveUniformBlockParameter pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v3.1 and ARB_uniform_buffer_object|VERSION_3_1]
        /// Query information about an active uniform block
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program containing the uniform block.
        /// </para>
        /// </param>
        /// <param name="uniformBlockIndex">
        /// <para>
        /// Specifies the index of the uniform block within program.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the name of the parameter to query.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Specifies the address of a variable to receive the result of the query.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_uniform_buffer_object|VERSION_3_1", Version = "3.1", EntryPoint = "glGetActiveUniformBlockiv")]
        public static extern unsafe void GetActiveUniformBlock(UInt32 program, UInt32 uniformBlockIndex, OpenTK.Graphics.OpenGL.ActiveUniformBlockParameter pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v3.1 and ARB_uniform_buffer_object|VERSION_3_1]
        /// Retrieve the name of an active uniform block
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program containing the uniform block.
        /// </para>
        /// </param>
        /// <param name="uniformBlockIndex">
        /// <para>
        /// Specifies the index of the uniform block within program.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the buffer addressed by uniformBlockName.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable to receive the number of characters that were written to uniformBlockName.
        /// </para>
        /// </param>
        /// <param name="uniformBlockName">
        /// <para>
        /// Specifies the address an array of characters to receive the name of the uniform block at uniformBlockIndex.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_uniform_buffer_object|VERSION_3_1", Version = "3.1", EntryPoint = "glGetActiveUniformBlockName")]
        public static extern void GetActiveUniformBlockName(Int32 program, Int32 uniformBlockIndex, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder uniformBlockName);

        /// <summary>[requires: v3.1 and ARB_uniform_buffer_object|VERSION_3_1]
        /// Retrieve the name of an active uniform block
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program containing the uniform block.
        /// </para>
        /// </param>
        /// <param name="uniformBlockIndex">
        /// <para>
        /// Specifies the index of the uniform block within program.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the buffer addressed by uniformBlockName.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable to receive the number of characters that were written to uniformBlockName.
        /// </para>
        /// </param>
        /// <param name="uniformBlockName">
        /// <para>
        /// Specifies the address an array of characters to receive the name of the uniform block at uniformBlockIndex.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_uniform_buffer_object|VERSION_3_1", Version = "3.1", EntryPoint = "glGetActiveUniformBlockName")]
        public static extern unsafe void GetActiveUniformBlockName(Int32 program, Int32 uniformBlockIndex, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder uniformBlockName);

        /// <summary>[requires: v3.1 and ARB_uniform_buffer_object|VERSION_3_1]
        /// Retrieve the name of an active uniform block
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program containing the uniform block.
        /// </para>
        /// </param>
        /// <param name="uniformBlockIndex">
        /// <para>
        /// Specifies the index of the uniform block within program.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the buffer addressed by uniformBlockName.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable to receive the number of characters that were written to uniformBlockName.
        /// </para>
        /// </param>
        /// <param name="uniformBlockName">
        /// <para>
        /// Specifies the address an array of characters to receive the name of the uniform block at uniformBlockIndex.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_uniform_buffer_object|VERSION_3_1", Version = "3.1", EntryPoint = "glGetActiveUniformBlockName")]
        public static extern void GetActiveUniformBlockName(UInt32 program, UInt32 uniformBlockIndex, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder uniformBlockName);

        /// <summary>[requires: v3.1 and ARB_uniform_buffer_object|VERSION_3_1]
        /// Retrieve the name of an active uniform block
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program containing the uniform block.
        /// </para>
        /// </param>
        /// <param name="uniformBlockIndex">
        /// <para>
        /// Specifies the index of the uniform block within program.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the buffer addressed by uniformBlockName.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable to receive the number of characters that were written to uniformBlockName.
        /// </para>
        /// </param>
        /// <param name="uniformBlockName">
        /// <para>
        /// Specifies the address an array of characters to receive the name of the uniform block at uniformBlockIndex.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_uniform_buffer_object|VERSION_3_1", Version = "3.1", EntryPoint = "glGetActiveUniformBlockName")]
        public static extern unsafe void GetActiveUniformBlockName(UInt32 program, UInt32 uniformBlockIndex, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder uniformBlockName);

        /// <summary>[requires: v3.1 and ARB_uniform_buffer_object|VERSION_3_1]
        /// Query the name of an active uniform
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program containing the active uniform index uniformIndex.
        /// </para>
        /// </param>
        /// <param name="uniformIndex">
        /// <para>
        /// Specifies the index of the active uniform whose name to query.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the buffer, in units of GLchar, of the buffer whose address is specified in uniformName.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable that will receive the number of characters that were or would have been written to the buffer addressed by uniformName.
        /// </para>
        /// </param>
        /// <param name="uniformName">
        /// <para>
        /// Specifies the address of a buffer into which the GL will place the name of the active uniform at uniformIndex within program.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_uniform_buffer_object|VERSION_3_1", Version = "3.1", EntryPoint = "glGetActiveUniformName")]
        public static extern void GetActiveUniformName(Int32 program, Int32 uniformIndex, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder uniformName);

        /// <summary>[requires: v3.1 and ARB_uniform_buffer_object|VERSION_3_1]
        /// Query the name of an active uniform
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program containing the active uniform index uniformIndex.
        /// </para>
        /// </param>
        /// <param name="uniformIndex">
        /// <para>
        /// Specifies the index of the active uniform whose name to query.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the buffer, in units of GLchar, of the buffer whose address is specified in uniformName.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable that will receive the number of characters that were or would have been written to the buffer addressed by uniformName.
        /// </para>
        /// </param>
        /// <param name="uniformName">
        /// <para>
        /// Specifies the address of a buffer into which the GL will place the name of the active uniform at uniformIndex within program.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_uniform_buffer_object|VERSION_3_1", Version = "3.1", EntryPoint = "glGetActiveUniformName")]
        public static extern unsafe void GetActiveUniformName(Int32 program, Int32 uniformIndex, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder uniformName);

        /// <summary>[requires: v3.1 and ARB_uniform_buffer_object|VERSION_3_1]
        /// Query the name of an active uniform
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program containing the active uniform index uniformIndex.
        /// </para>
        /// </param>
        /// <param name="uniformIndex">
        /// <para>
        /// Specifies the index of the active uniform whose name to query.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the buffer, in units of GLchar, of the buffer whose address is specified in uniformName.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable that will receive the number of characters that were or would have been written to the buffer addressed by uniformName.
        /// </para>
        /// </param>
        /// <param name="uniformName">
        /// <para>
        /// Specifies the address of a buffer into which the GL will place the name of the active uniform at uniformIndex within program.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_uniform_buffer_object|VERSION_3_1", Version = "3.1", EntryPoint = "glGetActiveUniformName")]
        public static extern void GetActiveUniformName(UInt32 program, UInt32 uniformIndex, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder uniformName);

        /// <summary>[requires: v3.1 and ARB_uniform_buffer_object|VERSION_3_1]
        /// Query the name of an active uniform
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program containing the active uniform index uniformIndex.
        /// </para>
        /// </param>
        /// <param name="uniformIndex">
        /// <para>
        /// Specifies the index of the active uniform whose name to query.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the buffer, in units of GLchar, of the buffer whose address is specified in uniformName.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable that will receive the number of characters that were or would have been written to the buffer addressed by uniformName.
        /// </para>
        /// </param>
        /// <param name="uniformName">
        /// <para>
        /// Specifies the address of a buffer into which the GL will place the name of the active uniform at uniformIndex within program.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_uniform_buffer_object|VERSION_3_1", Version = "3.1", EntryPoint = "glGetActiveUniformName")]
        public static extern unsafe void GetActiveUniformName(UInt32 program, UInt32 uniformIndex, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder uniformName);

        /// <summary>[requires: v3.1 and ARB_uniform_buffer_object|VERSION_3_1]
        /// Returns information about several active uniform variables for the specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="uniformCount">
        /// <para>
        /// Specifies both the number of elements in the array of indices uniformIndices and the number of parameters written to params upon successful return.
        /// </para>
        /// </param>
        /// <param name="uniformIndices">
        /// <para>
        /// Specifies the address of an array of uniformCount integers containing the indices of uniforms within program whose parameter pname should be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the property of each uniform in uniformIndices that should be written into the corresponding element of params.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Specifies the address of an array of uniformCount integers which are to receive the value of pname for each uniform in uniformIndices.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_uniform_buffer_object|VERSION_3_1", Version = "3.1", EntryPoint = "glGetActiveUniformsiv")]
        public static extern void GetActiveUniforms(Int32 program, Int32 uniformCount, Int32[] uniformIndices, OpenTK.Graphics.OpenGL.ActiveUniformParameter pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v3.1 and ARB_uniform_buffer_object|VERSION_3_1]
        /// Returns information about several active uniform variables for the specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="uniformCount">
        /// <para>
        /// Specifies both the number of elements in the array of indices uniformIndices and the number of parameters written to params upon successful return.
        /// </para>
        /// </param>
        /// <param name="uniformIndices">
        /// <para>
        /// Specifies the address of an array of uniformCount integers containing the indices of uniforms within program whose parameter pname should be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the property of each uniform in uniformIndices that should be written into the corresponding element of params.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Specifies the address of an array of uniformCount integers which are to receive the value of pname for each uniform in uniformIndices.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_uniform_buffer_object|VERSION_3_1", Version = "3.1", EntryPoint = "glGetActiveUniformsiv")]
        public static extern void GetActiveUniforms(Int32 program, Int32 uniformCount, ref Int32 uniformIndices, OpenTK.Graphics.OpenGL.ActiveUniformParameter pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v3.1 and ARB_uniform_buffer_object|VERSION_3_1]
        /// Returns information about several active uniform variables for the specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="uniformCount">
        /// <para>
        /// Specifies both the number of elements in the array of indices uniformIndices and the number of parameters written to params upon successful return.
        /// </para>
        /// </param>
        /// <param name="uniformIndices">
        /// <para>
        /// Specifies the address of an array of uniformCount integers containing the indices of uniforms within program whose parameter pname should be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the property of each uniform in uniformIndices that should be written into the corresponding element of params.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Specifies the address of an array of uniformCount integers which are to receive the value of pname for each uniform in uniformIndices.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_uniform_buffer_object|VERSION_3_1", Version = "3.1", EntryPoint = "glGetActiveUniformsiv")]
        public static extern unsafe void GetActiveUniforms(Int32 program, Int32 uniformCount, Int32* uniformIndices, OpenTK.Graphics.OpenGL.ActiveUniformParameter pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v3.1 and ARB_uniform_buffer_object|VERSION_3_1]
        /// Returns information about several active uniform variables for the specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="uniformCount">
        /// <para>
        /// Specifies both the number of elements in the array of indices uniformIndices and the number of parameters written to params upon successful return.
        /// </para>
        /// </param>
        /// <param name="uniformIndices">
        /// <para>
        /// Specifies the address of an array of uniformCount integers containing the indices of uniforms within program whose parameter pname should be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the property of each uniform in uniformIndices that should be written into the corresponding element of params.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Specifies the address of an array of uniformCount integers which are to receive the value of pname for each uniform in uniformIndices.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_uniform_buffer_object|VERSION_3_1", Version = "3.1", EntryPoint = "glGetActiveUniformsiv")]
        public static extern void GetActiveUniforms(UInt32 program, Int32 uniformCount, UInt32[] uniformIndices, OpenTK.Graphics.OpenGL.ActiveUniformParameter pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v3.1 and ARB_uniform_buffer_object|VERSION_3_1]
        /// Returns information about several active uniform variables for the specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="uniformCount">
        /// <para>
        /// Specifies both the number of elements in the array of indices uniformIndices and the number of parameters written to params upon successful return.
        /// </para>
        /// </param>
        /// <param name="uniformIndices">
        /// <para>
        /// Specifies the address of an array of uniformCount integers containing the indices of uniforms within program whose parameter pname should be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the property of each uniform in uniformIndices that should be written into the corresponding element of params.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Specifies the address of an array of uniformCount integers which are to receive the value of pname for each uniform in uniformIndices.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_uniform_buffer_object|VERSION_3_1", Version = "3.1", EntryPoint = "glGetActiveUniformsiv")]
        public static extern void GetActiveUniforms(UInt32 program, Int32 uniformCount, ref UInt32 uniformIndices, OpenTK.Graphics.OpenGL.ActiveUniformParameter pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v3.1 and ARB_uniform_buffer_object|VERSION_3_1]
        /// Returns information about several active uniform variables for the specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="uniformCount">
        /// <para>
        /// Specifies both the number of elements in the array of indices uniformIndices and the number of parameters written to params upon successful return.
        /// </para>
        /// </param>
        /// <param name="uniformIndices">
        /// <para>
        /// Specifies the address of an array of uniformCount integers containing the indices of uniforms within program whose parameter pname should be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the property of each uniform in uniformIndices that should be written into the corresponding element of params.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Specifies the address of an array of uniformCount integers which are to receive the value of pname for each uniform in uniformIndices.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_uniform_buffer_object|VERSION_3_1", Version = "3.1", EntryPoint = "glGetActiveUniformsiv")]
        public static extern unsafe void GetActiveUniforms(UInt32 program, Int32 uniformCount, UInt32* uniformIndices, OpenTK.Graphics.OpenGL.ActiveUniformParameter pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v2.0]
        /// Returns the handles of the shader objects attached to a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="maxCount">
        /// <para>
        /// Specifies the size of the array for storing the returned object names.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Returns the number of names actually returned in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies an array that is used to return the names of attached shader objects.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetAttachedShaders")]
        public static extern void GetAttachedShaders(Int32 program, Int32 maxCount, [OutAttribute] out Int32 count, [OutAttribute] Int32[] shaders);

        /// <summary>[requires: v2.0]
        /// Returns the handles of the shader objects attached to a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="maxCount">
        /// <para>
        /// Specifies the size of the array for storing the returned object names.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Returns the number of names actually returned in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies an array that is used to return the names of attached shader objects.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetAttachedShaders")]
        public static extern void GetAttachedShaders(Int32 program, Int32 maxCount, [OutAttribute] out Int32 count, [OutAttribute] out Int32 shaders);

        /// <summary>[requires: v2.0]
        /// Returns the handles of the shader objects attached to a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="maxCount">
        /// <para>
        /// Specifies the size of the array for storing the returned object names.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Returns the number of names actually returned in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies an array that is used to return the names of attached shader objects.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetAttachedShaders")]
        public static extern unsafe void GetAttachedShaders(Int32 program, Int32 maxCount, [OutAttribute] Int32* count, [OutAttribute] Int32* shaders);

        /// <summary>[requires: v2.0]
        /// Returns the handles of the shader objects attached to a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="maxCount">
        /// <para>
        /// Specifies the size of the array for storing the returned object names.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Returns the number of names actually returned in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies an array that is used to return the names of attached shader objects.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetAttachedShaders")]
        public static extern void GetAttachedShaders(UInt32 program, Int32 maxCount, [OutAttribute] out Int32 count, [OutAttribute] UInt32[] shaders);

        /// <summary>[requires: v2.0]
        /// Returns the handles of the shader objects attached to a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="maxCount">
        /// <para>
        /// Specifies the size of the array for storing the returned object names.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Returns the number of names actually returned in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies an array that is used to return the names of attached shader objects.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetAttachedShaders")]
        public static extern void GetAttachedShaders(UInt32 program, Int32 maxCount, [OutAttribute] out Int32 count, [OutAttribute] out UInt32 shaders);

        /// <summary>[requires: v2.0]
        /// Returns the handles of the shader objects attached to a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="maxCount">
        /// <para>
        /// Specifies the size of the array for storing the returned object names.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Returns the number of names actually returned in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies an array that is used to return the names of attached shader objects.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetAttachedShaders")]
        public static extern unsafe void GetAttachedShaders(UInt32 program, Int32 maxCount, [OutAttribute] Int32* count, [OutAttribute] UInt32* shaders);

        /// <summary>[requires: v2.0]
        /// Returns the location of an attribute variable
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// Points to a null terminated string containing the name of the attribute variable whose location is to be queried.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetAttribLocation")]
        public static extern Int32 GetAttribLocation(Int32 program, String name);

        /// <summary>[requires: v2.0]
        /// Returns the location of an attribute variable
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// Points to a null terminated string containing the name of the attribute variable whose location is to be queried.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetAttribLocation")]
        public static extern Int32 GetAttribLocation(UInt32 program, String name);

        /// <summary>[requires: v3.0]</summary>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetBooleani_v")]
        public static extern void GetBoolean(OpenTK.Graphics.OpenGL.GetIndexedPName target, Int32 index, [OutAttribute] bool[] data);

        /// <summary>[requires: v3.0]</summary>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetBooleani_v")]
        public static extern void GetBoolean(OpenTK.Graphics.OpenGL.GetIndexedPName target, Int32 index, [OutAttribute] out bool data);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetBooleani_v")]
        public static extern unsafe void GetBoolean(OpenTK.Graphics.OpenGL.GetIndexedPName target, Int32 index, [OutAttribute] bool* data);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetBooleani_v")]
        public static extern void GetBoolean(OpenTK.Graphics.OpenGL.GetIndexedPName target, UInt32 index, [OutAttribute] bool[] data);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetBooleani_v")]
        public static extern void GetBoolean(OpenTK.Graphics.OpenGL.GetIndexedPName target, UInt32 index, [OutAttribute] out bool data);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetBooleani_v")]
        public static extern unsafe void GetBoolean(OpenTK.Graphics.OpenGL.GetIndexedPName target, UInt32 index, [OutAttribute] bool* data);

        /// <summary>[requires: v1.0]</summary>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetBooleanv")]
        public static extern bool GetBoolean(OpenTK.Graphics.OpenGL.GetPName pname);

        /// <summary>[requires: v1.0]</summary>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetBooleanv")]
        public static extern void GetBoolean(OpenTK.Graphics.OpenGL.GetPName pname, [OutAttribute] bool[] data);

        /// <summary>[requires: v1.0]</summary>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetBooleanv")]
        public static extern void GetBoolean(OpenTK.Graphics.OpenGL.GetPName pname, [OutAttribute] out bool data);

        /// <summary>[requires: v1.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetBooleanv")]
        public static extern unsafe void GetBoolean(OpenTK.Graphics.OpenGL.GetPName pname, [OutAttribute] bool* data);

        /// <summary>[requires: v3.2]
        /// Return parameters of a buffer object
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// Specifies the symbolic name of a buffer object parameter. Accepted values are GL_BUFFER_ACCESS, GL_BUFFER_MAPPED, GL_BUFFER_SIZE, or GL_BUFFER_USAGE.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Returns the requested parameter.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_3_2", Version = "3.2", EntryPoint = "glGetBufferParameteri64v")]
        public static extern void GetBufferParameter(OpenTK.Graphics.OpenGL.BufferTarget target, OpenTK.Graphics.OpenGL.BufferParameterName pname, [OutAttribute] Int64[] @params);

        /// <summary>[requires: v3.2]
        /// Return parameters of a buffer object
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// Specifies the symbolic name of a buffer object parameter. Accepted values are GL_BUFFER_ACCESS, GL_BUFFER_MAPPED, GL_BUFFER_SIZE, or GL_BUFFER_USAGE.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Returns the requested parameter.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_3_2", Version = "3.2", EntryPoint = "glGetBufferParameteri64v")]
        public static extern void GetBufferParameter(OpenTK.Graphics.OpenGL.BufferTarget target, OpenTK.Graphics.OpenGL.BufferParameterName pname, [OutAttribute] out Int64 @params);

        /// <summary>[requires: v3.2]
        /// Return parameters of a buffer object
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// Specifies the symbolic name of a buffer object parameter. Accepted values are GL_BUFFER_ACCESS, GL_BUFFER_MAPPED, GL_BUFFER_SIZE, or GL_BUFFER_USAGE.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Returns the requested parameter.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_2", Version = "3.2", EntryPoint = "glGetBufferParameteri64v")]
        public static extern unsafe void GetBufferParameter(OpenTK.Graphics.OpenGL.BufferTarget target, OpenTK.Graphics.OpenGL.BufferParameterName pname, [OutAttribute] Int64* @params);

        /// <summary>[requires: v1.5]
        /// Return parameters of a buffer object
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, or GL_PIXEL_UNPACK_BUFFER.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// Specifies the symbolic name of a buffer object parameter. Accepted values are GL_BUFFER_ACCESS, GL_BUFFER_MAPPED, GL_BUFFER_SIZE, or GL_BUFFER_USAGE.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Returns the requested parameter.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGetBufferParameteriv")]
        public static extern void GetBufferParameter(OpenTK.Graphics.OpenGL.BufferTarget target, OpenTK.Graphics.OpenGL.BufferParameterName pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v1.5]
        /// Return parameters of a buffer object
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, or GL_PIXEL_UNPACK_BUFFER.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// Specifies the symbolic name of a buffer object parameter. Accepted values are GL_BUFFER_ACCESS, GL_BUFFER_MAPPED, GL_BUFFER_SIZE, or GL_BUFFER_USAGE.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Returns the requested parameter.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGetBufferParameteriv")]
        public static extern void GetBufferParameter(OpenTK.Graphics.OpenGL.BufferTarget target, OpenTK.Graphics.OpenGL.BufferParameterName pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v1.5]
        /// Return parameters of a buffer object
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, or GL_PIXEL_UNPACK_BUFFER.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// Specifies the symbolic name of a buffer object parameter. Accepted values are GL_BUFFER_ACCESS, GL_BUFFER_MAPPED, GL_BUFFER_SIZE, or GL_BUFFER_USAGE.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Returns the requested parameter.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGetBufferParameteriv")]
        public static extern unsafe void GetBufferParameter(OpenTK.Graphics.OpenGL.BufferTarget target, OpenTK.Graphics.OpenGL.BufferParameterName pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v1.5]
        /// Return the pointer to a mapped buffer object's data store
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the pointer to be returned. The symbolic constant must be GL_BUFFER_MAP_POINTER.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the pointer value specified by pname.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGetBufferPointerv")]
        public static extern void GetBufferPointer(OpenTK.Graphics.OpenGL.BufferTarget target, OpenTK.Graphics.OpenGL.BufferPointer pname, [OutAttribute] IntPtr @params);

        /// <summary>[requires: v1.5]
        /// Return the pointer to a mapped buffer object's data store
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the pointer to be returned. The symbolic constant must be GL_BUFFER_MAP_POINTER.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the pointer value specified by pname.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGetBufferPointerv")]
        public static extern void GetBufferPointer<T2>(OpenTK.Graphics.OpenGL.BufferTarget target, OpenTK.Graphics.OpenGL.BufferPointer pname, [InAttribute, OutAttribute] T2[] @params)
            where T2 : struct
        ;

        /// <summary>[requires: v1.5]
        /// Return the pointer to a mapped buffer object's data store
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the pointer to be returned. The symbolic constant must be GL_BUFFER_MAP_POINTER.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the pointer value specified by pname.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGetBufferPointerv")]
        public static extern void GetBufferPointer<T2>(OpenTK.Graphics.OpenGL.BufferTarget target, OpenTK.Graphics.OpenGL.BufferPointer pname, [InAttribute, OutAttribute] T2[,] @params)
            where T2 : struct
        ;

        /// <summary>[requires: v1.5]
        /// Return the pointer to a mapped buffer object's data store
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the pointer to be returned. The symbolic constant must be GL_BUFFER_MAP_POINTER.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the pointer value specified by pname.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGetBufferPointerv")]
        public static extern void GetBufferPointer<T2>(OpenTK.Graphics.OpenGL.BufferTarget target, OpenTK.Graphics.OpenGL.BufferPointer pname, [InAttribute, OutAttribute] T2[,,] @params)
            where T2 : struct
        ;

        /// <summary>[requires: v1.5]
        /// Return the pointer to a mapped buffer object's data store
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the pointer to be returned. The symbolic constant must be GL_BUFFER_MAP_POINTER.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the pointer value specified by pname.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGetBufferPointerv")]
        public static extern void GetBufferPointer<T2>(OpenTK.Graphics.OpenGL.BufferTarget target, OpenTK.Graphics.OpenGL.BufferPointer pname, [InAttribute, OutAttribute] ref T2 @params)
            where T2 : struct
        ;

        /// <summary>[requires: v1.5]
        /// Returns a subset of a buffer object's data store
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_RESULT_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
        /// </para>
        /// </param>
        /// <param name="offset">
        /// <para>
        /// Specifies the offset into the buffer object's data store from which data will be returned, measured in bytes.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Specifies the size in bytes of the data store region being returned.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the location where buffer object data is returned.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGetBufferSubData")]
        public static extern void GetBufferSubData(OpenTK.Graphics.OpenGL.BufferTarget target, IntPtr offset, IntPtr size, [OutAttribute] IntPtr data);

        /// <summary>[requires: v1.5]
        /// Returns a subset of a buffer object's data store
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_RESULT_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
        /// </para>
        /// </param>
        /// <param name="offset">
        /// <para>
        /// Specifies the offset into the buffer object's data store from which data will be returned, measured in bytes.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Specifies the size in bytes of the data store region being returned.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the location where buffer object data is returned.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGetBufferSubData")]
        public static extern void GetBufferSubData<T3>(OpenTK.Graphics.OpenGL.BufferTarget target, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] T3[] data)
            where T3 : struct
        ;

        /// <summary>[requires: v1.5]
        /// Returns a subset of a buffer object's data store
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_RESULT_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
        /// </para>
        /// </param>
        /// <param name="offset">
        /// <para>
        /// Specifies the offset into the buffer object's data store from which data will be returned, measured in bytes.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Specifies the size in bytes of the data store region being returned.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the location where buffer object data is returned.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGetBufferSubData")]
        public static extern void GetBufferSubData<T3>(OpenTK.Graphics.OpenGL.BufferTarget target, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] T3[,] data)
            where T3 : struct
        ;

        /// <summary>[requires: v1.5]
        /// Returns a subset of a buffer object's data store
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_RESULT_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
        /// </para>
        /// </param>
        /// <param name="offset">
        /// <para>
        /// Specifies the offset into the buffer object's data store from which data will be returned, measured in bytes.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Specifies the size in bytes of the data store region being returned.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the location where buffer object data is returned.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGetBufferSubData")]
        public static extern void GetBufferSubData<T3>(OpenTK.Graphics.OpenGL.BufferTarget target, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] T3[,,] data)
            where T3 : struct
        ;

        /// <summary>[requires: v1.5]
        /// Returns a subset of a buffer object's data store
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_RESULT_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
        /// </para>
        /// </param>
        /// <param name="offset">
        /// <para>
        /// Specifies the offset into the buffer object's data store from which data will be returned, measured in bytes.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Specifies the size in bytes of the data store region being returned.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the location where buffer object data is returned.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGetBufferSubData")]
        public static extern void GetBufferSubData<T3>(OpenTK.Graphics.OpenGL.BufferTarget target, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] ref T3 data)
            where T3 : struct
        ;

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return the coefficients of the specified clipping plane
        /// </summary>
        /// <param name="plane">
        /// <para>
        /// Specifies a clipping plane. The number of clipping planes depends on the implementation, but at least six clipping planes are supported. They are identified by symbolic names of the form GL_CLIP_PLANE where i ranges from 0 to the value of GL_MAX_CLIP_PLANES - 1.
        /// </para>
        /// </param>
        /// <param name="equation">
        /// <para>
        /// Returns four double-precision values that are the coefficients of the plane equation of plane in eye coordinates. The initial value is (0, 0, 0, 0).
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetClipPlane")]
        public static extern void GetClipPlane(OpenTK.Graphics.OpenGL.ClipPlaneName plane, [OutAttribute] Double[] equation);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return the coefficients of the specified clipping plane
        /// </summary>
        /// <param name="plane">
        /// <para>
        /// Specifies a clipping plane. The number of clipping planes depends on the implementation, but at least six clipping planes are supported. They are identified by symbolic names of the form GL_CLIP_PLANE where i ranges from 0 to the value of GL_MAX_CLIP_PLANES - 1.
        /// </para>
        /// </param>
        /// <param name="equation">
        /// <para>
        /// Returns four double-precision values that are the coefficients of the plane equation of plane in eye coordinates. The initial value is (0, 0, 0, 0).
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetClipPlane")]
        public static extern void GetClipPlane(OpenTK.Graphics.OpenGL.ClipPlaneName plane, [OutAttribute] out Double equation);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return the coefficients of the specified clipping plane
        /// </summary>
        /// <param name="plane">
        /// <para>
        /// Specifies a clipping plane. The number of clipping planes depends on the implementation, but at least six clipping planes are supported. They are identified by symbolic names of the form GL_CLIP_PLANE where i ranges from 0 to the value of GL_MAX_CLIP_PLANES - 1.
        /// </para>
        /// </param>
        /// <param name="equation">
        /// <para>
        /// Returns four double-precision values that are the coefficients of the plane equation of plane in eye coordinates. The initial value is (0, 0, 0, 0).
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetClipPlane")]
        public static extern unsafe void GetClipPlane(OpenTK.Graphics.OpenGL.ClipPlaneName plane, [OutAttribute] Double* equation);

        /// <summary>
        /// Retrieve contents of a color lookup table
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the pixel data in table. The possible values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the pixel data in table. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="table">
        /// <para>
        /// Pointer to a one-dimensional array of pixel data containing the contents of the color table.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetColorTable")]
        public static extern void GetColorTable(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [OutAttribute] IntPtr table);

        /// <summary>
        /// Retrieve contents of a color lookup table
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the pixel data in table. The possible values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the pixel data in table. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="table">
        /// <para>
        /// Pointer to a one-dimensional array of pixel data containing the contents of the color table.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetColorTable")]
        public static extern void GetColorTable<T3>(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T3[] table)
            where T3 : struct
        ;

        /// <summary>
        /// Retrieve contents of a color lookup table
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the pixel data in table. The possible values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the pixel data in table. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="table">
        /// <para>
        /// Pointer to a one-dimensional array of pixel data containing the contents of the color table.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetColorTable")]
        public static extern void GetColorTable<T3>(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T3[,] table)
            where T3 : struct
        ;

        /// <summary>
        /// Retrieve contents of a color lookup table
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the pixel data in table. The possible values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the pixel data in table. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="table">
        /// <para>
        /// Pointer to a one-dimensional array of pixel data containing the contents of the color table.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetColorTable")]
        public static extern void GetColorTable<T3>(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T3[,,] table)
            where T3 : struct
        ;

        /// <summary>
        /// Retrieve contents of a color lookup table
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the pixel data in table. The possible values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the pixel data in table. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="table">
        /// <para>
        /// Pointer to a one-dimensional array of pixel data containing the contents of the color table.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetColorTable")]
        public static extern void GetColorTable<T3>(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T3 table)
            where T3 : struct
        ;

        /// <summary>
        /// Get color lookup table parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The target color table. Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, GL_POST_COLOR_MATRIX_COLOR_TABLE, GL_PROXY_COLOR_TABLE, GL_PROXY_POST_CONVOLUTION_COLOR_TABLE, or GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The symbolic name of a color lookup table parameter. Must be one of GL_COLOR_TABLE_BIAS, GL_COLOR_TABLE_SCALE, GL_COLOR_TABLE_FORMAT, GL_COLOR_TABLE_WIDTH, GL_COLOR_TABLE_RED_SIZE, GL_COLOR_TABLE_GREEN_SIZE, GL_COLOR_TABLE_BLUE_SIZE, GL_COLOR_TABLE_ALPHA_SIZE, GL_COLOR_TABLE_LUMINANCE_SIZE, or GL_COLOR_TABLE_INTENSITY_SIZE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// A pointer to an array where the values of the parameter will be stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetColorTableParameterfv")]
        public static extern void GetColorTableParameter(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.GetColorTableParameterPName pname, [OutAttribute] Single[] @params);

        /// <summary>
        /// Get color lookup table parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The target color table. Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, GL_POST_COLOR_MATRIX_COLOR_TABLE, GL_PROXY_COLOR_TABLE, GL_PROXY_POST_CONVOLUTION_COLOR_TABLE, or GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The symbolic name of a color lookup table parameter. Must be one of GL_COLOR_TABLE_BIAS, GL_COLOR_TABLE_SCALE, GL_COLOR_TABLE_FORMAT, GL_COLOR_TABLE_WIDTH, GL_COLOR_TABLE_RED_SIZE, GL_COLOR_TABLE_GREEN_SIZE, GL_COLOR_TABLE_BLUE_SIZE, GL_COLOR_TABLE_ALPHA_SIZE, GL_COLOR_TABLE_LUMINANCE_SIZE, or GL_COLOR_TABLE_INTENSITY_SIZE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// A pointer to an array where the values of the parameter will be stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetColorTableParameterfv")]
        public static extern void GetColorTableParameter(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.GetColorTableParameterPName pname, [OutAttribute] out Single @params);

        /// <summary>
        /// Get color lookup table parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The target color table. Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, GL_POST_COLOR_MATRIX_COLOR_TABLE, GL_PROXY_COLOR_TABLE, GL_PROXY_POST_CONVOLUTION_COLOR_TABLE, or GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The symbolic name of a color lookup table parameter. Must be one of GL_COLOR_TABLE_BIAS, GL_COLOR_TABLE_SCALE, GL_COLOR_TABLE_FORMAT, GL_COLOR_TABLE_WIDTH, GL_COLOR_TABLE_RED_SIZE, GL_COLOR_TABLE_GREEN_SIZE, GL_COLOR_TABLE_BLUE_SIZE, GL_COLOR_TABLE_ALPHA_SIZE, GL_COLOR_TABLE_LUMINANCE_SIZE, or GL_COLOR_TABLE_INTENSITY_SIZE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// A pointer to an array where the values of the parameter will be stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetColorTableParameterfv")]
        public static extern unsafe void GetColorTableParameter(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.GetColorTableParameterPName pname, [OutAttribute] Single* @params);

        /// <summary>
        /// Get color lookup table parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The target color table. Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, GL_POST_COLOR_MATRIX_COLOR_TABLE, GL_PROXY_COLOR_TABLE, GL_PROXY_POST_CONVOLUTION_COLOR_TABLE, or GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The symbolic name of a color lookup table parameter. Must be one of GL_COLOR_TABLE_BIAS, GL_COLOR_TABLE_SCALE, GL_COLOR_TABLE_FORMAT, GL_COLOR_TABLE_WIDTH, GL_COLOR_TABLE_RED_SIZE, GL_COLOR_TABLE_GREEN_SIZE, GL_COLOR_TABLE_BLUE_SIZE, GL_COLOR_TABLE_ALPHA_SIZE, GL_COLOR_TABLE_LUMINANCE_SIZE, or GL_COLOR_TABLE_INTENSITY_SIZE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// A pointer to an array where the values of the parameter will be stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetColorTableParameteriv")]
        public static extern void GetColorTableParameter(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.GetColorTableParameterPName pname, [OutAttribute] Int32[] @params);

        /// <summary>
        /// Get color lookup table parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The target color table. Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, GL_POST_COLOR_MATRIX_COLOR_TABLE, GL_PROXY_COLOR_TABLE, GL_PROXY_POST_CONVOLUTION_COLOR_TABLE, or GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The symbolic name of a color lookup table parameter. Must be one of GL_COLOR_TABLE_BIAS, GL_COLOR_TABLE_SCALE, GL_COLOR_TABLE_FORMAT, GL_COLOR_TABLE_WIDTH, GL_COLOR_TABLE_RED_SIZE, GL_COLOR_TABLE_GREEN_SIZE, GL_COLOR_TABLE_BLUE_SIZE, GL_COLOR_TABLE_ALPHA_SIZE, GL_COLOR_TABLE_LUMINANCE_SIZE, or GL_COLOR_TABLE_INTENSITY_SIZE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// A pointer to an array where the values of the parameter will be stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetColorTableParameteriv")]
        public static extern void GetColorTableParameter(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.GetColorTableParameterPName pname, [OutAttribute] out Int32 @params);

        /// <summary>
        /// Get color lookup table parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The target color table. Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, GL_POST_COLOR_MATRIX_COLOR_TABLE, GL_PROXY_COLOR_TABLE, GL_PROXY_POST_CONVOLUTION_COLOR_TABLE, or GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The symbolic name of a color lookup table parameter. Must be one of GL_COLOR_TABLE_BIAS, GL_COLOR_TABLE_SCALE, GL_COLOR_TABLE_FORMAT, GL_COLOR_TABLE_WIDTH, GL_COLOR_TABLE_RED_SIZE, GL_COLOR_TABLE_GREEN_SIZE, GL_COLOR_TABLE_BLUE_SIZE, GL_COLOR_TABLE_ALPHA_SIZE, GL_COLOR_TABLE_LUMINANCE_SIZE, or GL_COLOR_TABLE_INTENSITY_SIZE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// A pointer to an array where the values of the parameter will be stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetColorTableParameteriv")]
        public static extern unsafe void GetColorTableParameter(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.GetColorTableParameterPName pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v1.3]
        /// Return a compressed texture image
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies which texture is to be obtained. GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, and GL_TEXTURE_CUBE_MAP_NEGATIVE_Z are accepted.
        /// </para>
        /// </param>
        /// <param name="lod">
        /// <para>
        /// Specifies the level-of-detail number of the desired image. Level 0 is the base image level. Level is the th mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="img">
        /// <para>
        /// Returns the compressed texture image.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glGetCompressedTexImage")]
        public static extern void GetCompressedTexImage(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, [OutAttribute] IntPtr img);

        /// <summary>[requires: v1.3]
        /// Return a compressed texture image
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies which texture is to be obtained. GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, and GL_TEXTURE_CUBE_MAP_NEGATIVE_Z are accepted.
        /// </para>
        /// </param>
        /// <param name="lod">
        /// <para>
        /// Specifies the level-of-detail number of the desired image. Level 0 is the base image level. Level is the th mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="img">
        /// <para>
        /// Returns the compressed texture image.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glGetCompressedTexImage")]
        public static extern void GetCompressedTexImage<T2>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, [InAttribute, OutAttribute] T2[] img)
            where T2 : struct
        ;

        /// <summary>[requires: v1.3]
        /// Return a compressed texture image
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies which texture is to be obtained. GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, and GL_TEXTURE_CUBE_MAP_NEGATIVE_Z are accepted.
        /// </para>
        /// </param>
        /// <param name="lod">
        /// <para>
        /// Specifies the level-of-detail number of the desired image. Level 0 is the base image level. Level is the th mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="img">
        /// <para>
        /// Returns the compressed texture image.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glGetCompressedTexImage")]
        public static extern void GetCompressedTexImage<T2>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, [InAttribute, OutAttribute] T2[,] img)
            where T2 : struct
        ;

        /// <summary>[requires: v1.3]
        /// Return a compressed texture image
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies which texture is to be obtained. GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, and GL_TEXTURE_CUBE_MAP_NEGATIVE_Z are accepted.
        /// </para>
        /// </param>
        /// <param name="lod">
        /// <para>
        /// Specifies the level-of-detail number of the desired image. Level 0 is the base image level. Level is the th mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="img">
        /// <para>
        /// Returns the compressed texture image.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glGetCompressedTexImage")]
        public static extern void GetCompressedTexImage<T2>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, [InAttribute, OutAttribute] T2[,,] img)
            where T2 : struct
        ;

        /// <summary>[requires: v1.3]
        /// Return a compressed texture image
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies which texture is to be obtained. GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, and GL_TEXTURE_CUBE_MAP_NEGATIVE_Z are accepted.
        /// </para>
        /// </param>
        /// <param name="lod">
        /// <para>
        /// Specifies the level-of-detail number of the desired image. Level 0 is the base image level. Level is the th mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="img">
        /// <para>
        /// Returns the compressed texture image.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glGetCompressedTexImage")]
        public static extern void GetCompressedTexImage<T2>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, [InAttribute, OutAttribute] ref T2 img)
            where T2 : struct
        ;

        /// <summary>
        /// Get current 1D or 2D convolution filter kernel
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The filter to be retrieved. Must be one of GL_CONVOLUTION_1D or GL_CONVOLUTION_2D.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Format of the output image. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Data type of components in the output image. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="image">
        /// <para>
        /// Pointer to storage for the output image.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetConvolutionFilter")]
        public static extern void GetConvolutionFilter(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [OutAttribute] IntPtr image);

        /// <summary>
        /// Get current 1D or 2D convolution filter kernel
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The filter to be retrieved. Must be one of GL_CONVOLUTION_1D or GL_CONVOLUTION_2D.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Format of the output image. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Data type of components in the output image. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="image">
        /// <para>
        /// Pointer to storage for the output image.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetConvolutionFilter")]
        public static extern void GetConvolutionFilter<T3>(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T3[] image)
            where T3 : struct
        ;

        /// <summary>
        /// Get current 1D or 2D convolution filter kernel
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The filter to be retrieved. Must be one of GL_CONVOLUTION_1D or GL_CONVOLUTION_2D.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Format of the output image. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Data type of components in the output image. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="image">
        /// <para>
        /// Pointer to storage for the output image.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetConvolutionFilter")]
        public static extern void GetConvolutionFilter<T3>(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T3[,] image)
            where T3 : struct
        ;

        /// <summary>
        /// Get current 1D or 2D convolution filter kernel
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The filter to be retrieved. Must be one of GL_CONVOLUTION_1D or GL_CONVOLUTION_2D.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Format of the output image. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Data type of components in the output image. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="image">
        /// <para>
        /// Pointer to storage for the output image.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetConvolutionFilter")]
        public static extern void GetConvolutionFilter<T3>(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T3[,,] image)
            where T3 : struct
        ;

        /// <summary>
        /// Get current 1D or 2D convolution filter kernel
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The filter to be retrieved. Must be one of GL_CONVOLUTION_1D or GL_CONVOLUTION_2D.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Format of the output image. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Data type of components in the output image. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="image">
        /// <para>
        /// Pointer to storage for the output image.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetConvolutionFilter")]
        public static extern void GetConvolutionFilter<T3>(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T3 image)
            where T3 : struct
        ;

        /// <summary>
        /// Get convolution parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The filter whose parameters are to be retrieved. Must be one of GL_CONVOLUTION_1D, GL_CONVOLUTION_2D, or GL_SEPARABLE_2D.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The parameter to be retrieved. Must be one of GL_CONVOLUTION_BORDER_MODE, GL_CONVOLUTION_BORDER_COLOR, GL_CONVOLUTION_FILTER_SCALE, GL_CONVOLUTION_FILTER_BIAS, GL_CONVOLUTION_FORMAT, GL_CONVOLUTION_WIDTH, GL_CONVOLUTION_HEIGHT, GL_MAX_CONVOLUTION_WIDTH, or GL_MAX_CONVOLUTION_HEIGHT.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Pointer to storage for the parameters to be retrieved.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetConvolutionParameterfv")]
        public static extern void GetConvolutionParameter(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.GetConvolutionParameterPName pname, [OutAttribute] Single[] @params);

        /// <summary>
        /// Get convolution parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The filter whose parameters are to be retrieved. Must be one of GL_CONVOLUTION_1D, GL_CONVOLUTION_2D, or GL_SEPARABLE_2D.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The parameter to be retrieved. Must be one of GL_CONVOLUTION_BORDER_MODE, GL_CONVOLUTION_BORDER_COLOR, GL_CONVOLUTION_FILTER_SCALE, GL_CONVOLUTION_FILTER_BIAS, GL_CONVOLUTION_FORMAT, GL_CONVOLUTION_WIDTH, GL_CONVOLUTION_HEIGHT, GL_MAX_CONVOLUTION_WIDTH, or GL_MAX_CONVOLUTION_HEIGHT.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Pointer to storage for the parameters to be retrieved.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetConvolutionParameterfv")]
        public static extern void GetConvolutionParameter(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.GetConvolutionParameterPName pname, [OutAttribute] out Single @params);

        /// <summary>
        /// Get convolution parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The filter whose parameters are to be retrieved. Must be one of GL_CONVOLUTION_1D, GL_CONVOLUTION_2D, or GL_SEPARABLE_2D.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The parameter to be retrieved. Must be one of GL_CONVOLUTION_BORDER_MODE, GL_CONVOLUTION_BORDER_COLOR, GL_CONVOLUTION_FILTER_SCALE, GL_CONVOLUTION_FILTER_BIAS, GL_CONVOLUTION_FORMAT, GL_CONVOLUTION_WIDTH, GL_CONVOLUTION_HEIGHT, GL_MAX_CONVOLUTION_WIDTH, or GL_MAX_CONVOLUTION_HEIGHT.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Pointer to storage for the parameters to be retrieved.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetConvolutionParameterfv")]
        public static extern unsafe void GetConvolutionParameter(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.GetConvolutionParameterPName pname, [OutAttribute] Single* @params);

        /// <summary>
        /// Get convolution parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The filter whose parameters are to be retrieved. Must be one of GL_CONVOLUTION_1D, GL_CONVOLUTION_2D, or GL_SEPARABLE_2D.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The parameter to be retrieved. Must be one of GL_CONVOLUTION_BORDER_MODE, GL_CONVOLUTION_BORDER_COLOR, GL_CONVOLUTION_FILTER_SCALE, GL_CONVOLUTION_FILTER_BIAS, GL_CONVOLUTION_FORMAT, GL_CONVOLUTION_WIDTH, GL_CONVOLUTION_HEIGHT, GL_MAX_CONVOLUTION_WIDTH, or GL_MAX_CONVOLUTION_HEIGHT.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Pointer to storage for the parameters to be retrieved.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetConvolutionParameteriv")]
        public static extern void GetConvolutionParameter(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.GetConvolutionParameterPName pname, [OutAttribute] Int32[] @params);

        /// <summary>
        /// Get convolution parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The filter whose parameters are to be retrieved. Must be one of GL_CONVOLUTION_1D, GL_CONVOLUTION_2D, or GL_SEPARABLE_2D.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The parameter to be retrieved. Must be one of GL_CONVOLUTION_BORDER_MODE, GL_CONVOLUTION_BORDER_COLOR, GL_CONVOLUTION_FILTER_SCALE, GL_CONVOLUTION_FILTER_BIAS, GL_CONVOLUTION_FORMAT, GL_CONVOLUTION_WIDTH, GL_CONVOLUTION_HEIGHT, GL_MAX_CONVOLUTION_WIDTH, or GL_MAX_CONVOLUTION_HEIGHT.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Pointer to storage for the parameters to be retrieved.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetConvolutionParameteriv")]
        public static extern void GetConvolutionParameter(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.GetConvolutionParameterPName pname, [OutAttribute] out Int32 @params);

        /// <summary>
        /// Get convolution parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The filter whose parameters are to be retrieved. Must be one of GL_CONVOLUTION_1D, GL_CONVOLUTION_2D, or GL_SEPARABLE_2D.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The parameter to be retrieved. Must be one of GL_CONVOLUTION_BORDER_MODE, GL_CONVOLUTION_BORDER_COLOR, GL_CONVOLUTION_FILTER_SCALE, GL_CONVOLUTION_FILTER_BIAS, GL_CONVOLUTION_FORMAT, GL_CONVOLUTION_WIDTH, GL_CONVOLUTION_HEIGHT, GL_MAX_CONVOLUTION_WIDTH, or GL_MAX_CONVOLUTION_HEIGHT.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Pointer to storage for the parameters to be retrieved.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetConvolutionParameteriv")]
        public static extern unsafe void GetConvolutionParameter(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.GetConvolutionParameterPName pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Retrieve messages from the debug message log
        /// </summary>
        /// <param name="count">
        /// <para>
        /// The number of debug messages to retrieve from the log.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The size of the buffer whose address is given by messageLog.
        /// </para>
        /// </param>
        /// <param name="sources">
        /// <para>
        /// The address of an array of variables to receive the sources of the retrieved messages.
        /// </para>
        /// </param>
        /// <param name="types">
        /// <para>
        /// The address of an array of variables to receive the types of the retrieved messages.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// The address of an array of unsigned integers to receive the ids of the retrieved messages.
        /// </para>
        /// </param>
        /// <param name="severities">
        /// <para>
        /// The address of an array of variables to receive the severites of the retrieved messages.
        /// </para>
        /// </param>
        /// <param name="lengths">
        /// <para>
        /// The address of an array of variables to receive the lengths of the received messages.
        /// </para>
        /// </param>
        /// <param name="messageLog">
        /// <para>
        /// The address of an array of characters that will receive the messages.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glGetDebugMessageLog")]
        public static extern Int32 GetDebugMessageLog(Int32 count, Int32 bufSize, [OutAttribute] OpenTK.Graphics.OpenGL.DebugSource[] sources, [OutAttribute] OpenTK.Graphics.OpenGL.DebugType[] types, [OutAttribute] Int32[] ids, [OutAttribute] OpenTK.Graphics.OpenGL.DebugSeverity[] severities, [OutAttribute] Int32[] lengths, [OutAttribute] StringBuilder messageLog);

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Retrieve messages from the debug message log
        /// </summary>
        /// <param name="count">
        /// <para>
        /// The number of debug messages to retrieve from the log.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The size of the buffer whose address is given by messageLog.
        /// </para>
        /// </param>
        /// <param name="sources">
        /// <para>
        /// The address of an array of variables to receive the sources of the retrieved messages.
        /// </para>
        /// </param>
        /// <param name="types">
        /// <para>
        /// The address of an array of variables to receive the types of the retrieved messages.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// The address of an array of unsigned integers to receive the ids of the retrieved messages.
        /// </para>
        /// </param>
        /// <param name="severities">
        /// <para>
        /// The address of an array of variables to receive the severites of the retrieved messages.
        /// </para>
        /// </param>
        /// <param name="lengths">
        /// <para>
        /// The address of an array of variables to receive the lengths of the received messages.
        /// </para>
        /// </param>
        /// <param name="messageLog">
        /// <para>
        /// The address of an array of characters that will receive the messages.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glGetDebugMessageLog")]
        public static extern Int32 GetDebugMessageLog(Int32 count, Int32 bufSize, [OutAttribute] out OpenTK.Graphics.OpenGL.DebugSource sources, [OutAttribute] out OpenTK.Graphics.OpenGL.DebugType types, [OutAttribute] out Int32 ids, [OutAttribute] out OpenTK.Graphics.OpenGL.DebugSeverity severities, [OutAttribute] out Int32 lengths, [OutAttribute] StringBuilder messageLog);

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Retrieve messages from the debug message log
        /// </summary>
        /// <param name="count">
        /// <para>
        /// The number of debug messages to retrieve from the log.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The size of the buffer whose address is given by messageLog.
        /// </para>
        /// </param>
        /// <param name="sources">
        /// <para>
        /// The address of an array of variables to receive the sources of the retrieved messages.
        /// </para>
        /// </param>
        /// <param name="types">
        /// <para>
        /// The address of an array of variables to receive the types of the retrieved messages.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// The address of an array of unsigned integers to receive the ids of the retrieved messages.
        /// </para>
        /// </param>
        /// <param name="severities">
        /// <para>
        /// The address of an array of variables to receive the severites of the retrieved messages.
        /// </para>
        /// </param>
        /// <param name="lengths">
        /// <para>
        /// The address of an array of variables to receive the lengths of the received messages.
        /// </para>
        /// </param>
        /// <param name="messageLog">
        /// <para>
        /// The address of an array of characters that will receive the messages.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glGetDebugMessageLog")]
        public static extern unsafe Int32 GetDebugMessageLog(Int32 count, Int32 bufSize, [OutAttribute] OpenTK.Graphics.OpenGL.DebugSource* sources, [OutAttribute] OpenTK.Graphics.OpenGL.DebugType* types, [OutAttribute] Int32* ids, [OutAttribute] OpenTK.Graphics.OpenGL.DebugSeverity* severities, [OutAttribute] Int32* lengths, [OutAttribute] StringBuilder messageLog);

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Retrieve messages from the debug message log
        /// </summary>
        /// <param name="count">
        /// <para>
        /// The number of debug messages to retrieve from the log.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The size of the buffer whose address is given by messageLog.
        /// </para>
        /// </param>
        /// <param name="sources">
        /// <para>
        /// The address of an array of variables to receive the sources of the retrieved messages.
        /// </para>
        /// </param>
        /// <param name="types">
        /// <para>
        /// The address of an array of variables to receive the types of the retrieved messages.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// The address of an array of unsigned integers to receive the ids of the retrieved messages.
        /// </para>
        /// </param>
        /// <param name="severities">
        /// <para>
        /// The address of an array of variables to receive the severites of the retrieved messages.
        /// </para>
        /// </param>
        /// <param name="lengths">
        /// <para>
        /// The address of an array of variables to receive the lengths of the received messages.
        /// </para>
        /// </param>
        /// <param name="messageLog">
        /// <para>
        /// The address of an array of characters that will receive the messages.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glGetDebugMessageLog")]
        public static extern Int32 GetDebugMessageLog(UInt32 count, Int32 bufSize, [OutAttribute] OpenTK.Graphics.OpenGL.DebugSource[] sources, [OutAttribute] OpenTK.Graphics.OpenGL.DebugType[] types, [OutAttribute] UInt32[] ids, [OutAttribute] OpenTK.Graphics.OpenGL.DebugSeverity[] severities, [OutAttribute] Int32[] lengths, [OutAttribute] StringBuilder messageLog);

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Retrieve messages from the debug message log
        /// </summary>
        /// <param name="count">
        /// <para>
        /// The number of debug messages to retrieve from the log.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The size of the buffer whose address is given by messageLog.
        /// </para>
        /// </param>
        /// <param name="sources">
        /// <para>
        /// The address of an array of variables to receive the sources of the retrieved messages.
        /// </para>
        /// </param>
        /// <param name="types">
        /// <para>
        /// The address of an array of variables to receive the types of the retrieved messages.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// The address of an array of unsigned integers to receive the ids of the retrieved messages.
        /// </para>
        /// </param>
        /// <param name="severities">
        /// <para>
        /// The address of an array of variables to receive the severites of the retrieved messages.
        /// </para>
        /// </param>
        /// <param name="lengths">
        /// <para>
        /// The address of an array of variables to receive the lengths of the received messages.
        /// </para>
        /// </param>
        /// <param name="messageLog">
        /// <para>
        /// The address of an array of characters that will receive the messages.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glGetDebugMessageLog")]
        public static extern Int32 GetDebugMessageLog(UInt32 count, Int32 bufSize, [OutAttribute] out OpenTK.Graphics.OpenGL.DebugSource sources, [OutAttribute] out OpenTK.Graphics.OpenGL.DebugType types, [OutAttribute] out UInt32 ids, [OutAttribute] out OpenTK.Graphics.OpenGL.DebugSeverity severities, [OutAttribute] out Int32 lengths, [OutAttribute] StringBuilder messageLog);

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Retrieve messages from the debug message log
        /// </summary>
        /// <param name="count">
        /// <para>
        /// The number of debug messages to retrieve from the log.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The size of the buffer whose address is given by messageLog.
        /// </para>
        /// </param>
        /// <param name="sources">
        /// <para>
        /// The address of an array of variables to receive the sources of the retrieved messages.
        /// </para>
        /// </param>
        /// <param name="types">
        /// <para>
        /// The address of an array of variables to receive the types of the retrieved messages.
        /// </para>
        /// </param>
        /// <param name="ids">
        /// <para>
        /// The address of an array of unsigned integers to receive the ids of the retrieved messages.
        /// </para>
        /// </param>
        /// <param name="severities">
        /// <para>
        /// The address of an array of variables to receive the severites of the retrieved messages.
        /// </para>
        /// </param>
        /// <param name="lengths">
        /// <para>
        /// The address of an array of variables to receive the lengths of the received messages.
        /// </para>
        /// </param>
        /// <param name="messageLog">
        /// <para>
        /// The address of an array of characters that will receive the messages.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glGetDebugMessageLog")]
        public static extern unsafe Int32 GetDebugMessageLog(UInt32 count, Int32 bufSize, [OutAttribute] OpenTK.Graphics.OpenGL.DebugSource* sources, [OutAttribute] OpenTK.Graphics.OpenGL.DebugType* types, [OutAttribute] UInt32* ids, [OutAttribute] OpenTK.Graphics.OpenGL.DebugSeverity* severities, [OutAttribute] Int32* lengths, [OutAttribute] StringBuilder messageLog);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glGetDoublei_v")]
        public static extern void GetDouble(OpenTK.Graphics.OpenGL.GetIndexedPName target, Int32 index, [OutAttribute] Double[] data);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glGetDoublei_v")]
        public static extern void GetDouble(OpenTK.Graphics.OpenGL.GetIndexedPName target, Int32 index, [OutAttribute] out Double data);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glGetDoublei_v")]
        public static extern unsafe void GetDouble(OpenTK.Graphics.OpenGL.GetIndexedPName target, Int32 index, [OutAttribute] Double* data);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glGetDoublei_v")]
        public static extern void GetDouble(OpenTK.Graphics.OpenGL.GetIndexedPName target, UInt32 index, [OutAttribute] Double[] data);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glGetDoublei_v")]
        public static extern void GetDouble(OpenTK.Graphics.OpenGL.GetIndexedPName target, UInt32 index, [OutAttribute] out Double data);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glGetDoublei_v")]
        public static extern unsafe void GetDouble(OpenTK.Graphics.OpenGL.GetIndexedPName target, UInt32 index, [OutAttribute] Double* data);

        /// <summary>[requires: v1.0]</summary>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetDoublev")]
        public static extern Double GetDouble(OpenTK.Graphics.OpenGL.GetPName pname);

        /// <summary>[requires: v1.0]</summary>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetDoublev")]
        public static extern void GetDouble(OpenTK.Graphics.OpenGL.GetPName pname, [OutAttribute] Double[] data);

        /// <summary>[requires: v1.0]</summary>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetDoublev")]
        public static extern void GetDouble(OpenTK.Graphics.OpenGL.GetPName pname, [OutAttribute] out Double data);

        /// <summary>[requires: v1.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetDoublev")]
        public static extern unsafe void GetDouble(OpenTK.Graphics.OpenGL.GetPName pname, [OutAttribute] Double* data);

        /// <summary>[requires: v1.0]
        /// Return error information
        /// </summary>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetError")]
        public static extern OpenTK.Graphics.OpenGL.ErrorCode GetError();

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glGetFloati_v")]
        public static extern void GetFloat(OpenTK.Graphics.OpenGL.GetIndexedPName target, Int32 index, [OutAttribute] Single[] data);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glGetFloati_v")]
        public static extern void GetFloat(OpenTK.Graphics.OpenGL.GetIndexedPName target, Int32 index, [OutAttribute] out Single data);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glGetFloati_v")]
        public static extern unsafe void GetFloat(OpenTK.Graphics.OpenGL.GetIndexedPName target, Int32 index, [OutAttribute] Single* data);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glGetFloati_v")]
        public static extern void GetFloat(OpenTK.Graphics.OpenGL.GetIndexedPName target, UInt32 index, [OutAttribute] Single[] data);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glGetFloati_v")]
        public static extern void GetFloat(OpenTK.Graphics.OpenGL.GetIndexedPName target, UInt32 index, [OutAttribute] out Single data);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glGetFloati_v")]
        public static extern unsafe void GetFloat(OpenTK.Graphics.OpenGL.GetIndexedPName target, UInt32 index, [OutAttribute] Single* data);

        /// <summary>[requires: v1.0]</summary>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetFloatv")]
        public static extern Single GetFloat(OpenTK.Graphics.OpenGL.GetPName pname);

        /// <summary>[requires: v1.0]</summary>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetFloatv")]
        public static extern void GetFloat(OpenTK.Graphics.OpenGL.GetPName pname, [OutAttribute] Single[] data);

        /// <summary>[requires: v1.0]</summary>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetFloatv")]
        public static extern void GetFloat(OpenTK.Graphics.OpenGL.GetPName pname, [OutAttribute] out Single data);

        /// <summary>[requires: v1.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetFloatv")]
        public static extern unsafe void GetFloat(OpenTK.Graphics.OpenGL.GetPName pname, [OutAttribute] Single* data);

        /// <summary>[requires: v3.3 and ARB_blend_func_extended|VERSION_3_3]
        /// Query the bindings of color indices to user-defined varying out variables
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of the program containing varying out variable whose binding to query
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The name of the user-defined varying out variable whose index to query
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_blend_func_extended|VERSION_3_3", Version = "3.3", EntryPoint = "glGetFragDataIndex")]
        public static extern Int32 GetFragDataIndex(Int32 program, String name);

        /// <summary>[requires: v3.3 and ARB_blend_func_extended|VERSION_3_3]
        /// Query the bindings of color indices to user-defined varying out variables
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of the program containing varying out variable whose binding to query
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The name of the user-defined varying out variable whose index to query
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_blend_func_extended|VERSION_3_3", Version = "3.3", EntryPoint = "glGetFragDataIndex")]
        public static extern Int32 GetFragDataIndex(UInt32 program, String name);

        /// <summary>[requires: v3.0]
        /// Query the bindings of color numbers to user-defined varying out variables
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of the program containing varying out variable whose binding to query
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The name of the user-defined varying out variable whose binding to query
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetFragDataLocation")]
        public static extern Int32 GetFragDataLocation(Int32 program, String name);

        /// <summary>[requires: v3.0]
        /// Query the bindings of color numbers to user-defined varying out variables
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of the program containing varying out variable whose binding to query
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The name of the user-defined varying out variable whose binding to query
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetFragDataLocation")]
        public static extern Int32 GetFragDataLocation(UInt32 program, String name);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Retrieve information about attachments of a bound framebuffer object
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target of the query operation.
        /// </para>
        /// </param>
        /// <param name="attachment">
        /// <para>
        /// Specifies the attachment within target
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the parameter of attachment to query.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Specifies the address of a variable receive the value of pname for attachment.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glGetFramebufferAttachmentParameteriv")]
        public static extern void GetFramebufferAttachmentParameter(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.FramebufferParameterName pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Retrieve information about attachments of a bound framebuffer object
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target of the query operation.
        /// </para>
        /// </param>
        /// <param name="attachment">
        /// <para>
        /// Specifies the attachment within target
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the parameter of attachment to query.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Specifies the address of a variable receive the value of pname for attachment.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glGetFramebufferAttachmentParameteriv")]
        public static extern void GetFramebufferAttachmentParameter(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.FramebufferParameterName pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Retrieve information about attachments of a bound framebuffer object
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target of the query operation.
        /// </para>
        /// </param>
        /// <param name="attachment">
        /// <para>
        /// Specifies the attachment within target
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the parameter of attachment to query.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Specifies the address of a variable receive the value of pname for attachment.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glGetFramebufferAttachmentParameteriv")]
        public static extern unsafe void GetFramebufferAttachmentParameter(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.FramebufferParameterName pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v4.3 and ARB_framebuffer_no_attachments|VERSION_4_3]
        /// Retrieve a named parameter from a framebuffer
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The target of the operation, which must be GL_READ_FRAMEBUFFER, GL_DRAW_FRAMEBUFFER or GL_FRAMEBUFFER.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// A token indicating the parameter to be retrieved.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// The address of a variable to receive the value of the parameter named pname.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_framebuffer_no_attachments|VERSION_4_3", Version = "4.3", EntryPoint = "glGetFramebufferParameteriv")]
        public static extern void GetFramebufferParameter(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferDefaultParameter pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v4.3 and ARB_framebuffer_no_attachments|VERSION_4_3]
        /// Retrieve a named parameter from a framebuffer
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The target of the operation, which must be GL_READ_FRAMEBUFFER, GL_DRAW_FRAMEBUFFER or GL_FRAMEBUFFER.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// A token indicating the parameter to be retrieved.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// The address of a variable to receive the value of the parameter named pname.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_framebuffer_no_attachments|VERSION_4_3", Version = "4.3", EntryPoint = "glGetFramebufferParameteriv")]
        public static extern void GetFramebufferParameter(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferDefaultParameter pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v4.3 and ARB_framebuffer_no_attachments|VERSION_4_3]
        /// Retrieve a named parameter from a framebuffer
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The target of the operation, which must be GL_READ_FRAMEBUFFER, GL_DRAW_FRAMEBUFFER or GL_FRAMEBUFFER.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// A token indicating the parameter to be retrieved.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// The address of a variable to receive the value of the parameter named pname.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_framebuffer_no_attachments|VERSION_4_3", Version = "4.3", EntryPoint = "glGetFramebufferParameteriv")]
        public static extern unsafe void GetFramebufferParameter(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferDefaultParameter pname, [OutAttribute] Int32* @params);

        /// <summary>
        /// Get histogram table
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_HISTOGRAM.
        /// </para>
        /// </param>
        /// <param name="reset">
        /// <para>
        /// If GL_TRUE, each component counter that is actually returned is reset to zero. (Other counters are unaffected.) If GL_FALSE, none of the counters in the histogram table is modified.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of values to be returned in values. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of values to be returned in values. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// A pointer to storage for the returned histogram table.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetHistogram")]
        public static extern void GetHistogram(OpenTK.Graphics.OpenGL.HistogramTarget target, bool reset, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [OutAttribute] IntPtr values);

        /// <summary>
        /// Get histogram table
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_HISTOGRAM.
        /// </para>
        /// </param>
        /// <param name="reset">
        /// <para>
        /// If GL_TRUE, each component counter that is actually returned is reset to zero. (Other counters are unaffected.) If GL_FALSE, none of the counters in the histogram table is modified.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of values to be returned in values. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of values to be returned in values. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// A pointer to storage for the returned histogram table.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetHistogram")]
        public static extern void GetHistogram<T4>(OpenTK.Graphics.OpenGL.HistogramTarget target, bool reset, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T4[] values)
            where T4 : struct
        ;

        /// <summary>
        /// Get histogram table
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_HISTOGRAM.
        /// </para>
        /// </param>
        /// <param name="reset">
        /// <para>
        /// If GL_TRUE, each component counter that is actually returned is reset to zero. (Other counters are unaffected.) If GL_FALSE, none of the counters in the histogram table is modified.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of values to be returned in values. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of values to be returned in values. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// A pointer to storage for the returned histogram table.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetHistogram")]
        public static extern void GetHistogram<T4>(OpenTK.Graphics.OpenGL.HistogramTarget target, bool reset, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T4[,] values)
            where T4 : struct
        ;

        /// <summary>
        /// Get histogram table
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_HISTOGRAM.
        /// </para>
        /// </param>
        /// <param name="reset">
        /// <para>
        /// If GL_TRUE, each component counter that is actually returned is reset to zero. (Other counters are unaffected.) If GL_FALSE, none of the counters in the histogram table is modified.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of values to be returned in values. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of values to be returned in values. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// A pointer to storage for the returned histogram table.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetHistogram")]
        public static extern void GetHistogram<T4>(OpenTK.Graphics.OpenGL.HistogramTarget target, bool reset, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T4[,,] values)
            where T4 : struct
        ;

        /// <summary>
        /// Get histogram table
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_HISTOGRAM.
        /// </para>
        /// </param>
        /// <param name="reset">
        /// <para>
        /// If GL_TRUE, each component counter that is actually returned is reset to zero. (Other counters are unaffected.) If GL_FALSE, none of the counters in the histogram table is modified.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of values to be returned in values. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of values to be returned in values. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// A pointer to storage for the returned histogram table.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetHistogram")]
        public static extern void GetHistogram<T4>(OpenTK.Graphics.OpenGL.HistogramTarget target, bool reset, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T4 values)
            where T4 : struct
        ;

        /// <summary>
        /// Get histogram parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be one of GL_HISTOGRAM or GL_PROXY_HISTOGRAM.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The name of the parameter to be retrieved. Must be one of GL_HISTOGRAM_WIDTH, GL_HISTOGRAM_FORMAT, GL_HISTOGRAM_RED_SIZE, GL_HISTOGRAM_GREEN_SIZE, GL_HISTOGRAM_BLUE_SIZE, GL_HISTOGRAM_ALPHA_SIZE, GL_HISTOGRAM_LUMINANCE_SIZE, or GL_HISTOGRAM_SINK.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Pointer to storage for the returned values.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetHistogramParameterfv")]
        public static extern void GetHistogramParameter(OpenTK.Graphics.OpenGL.HistogramTarget target, OpenTK.Graphics.OpenGL.GetHistogramParameterPName pname, [OutAttribute] Single[] @params);

        /// <summary>
        /// Get histogram parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be one of GL_HISTOGRAM or GL_PROXY_HISTOGRAM.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The name of the parameter to be retrieved. Must be one of GL_HISTOGRAM_WIDTH, GL_HISTOGRAM_FORMAT, GL_HISTOGRAM_RED_SIZE, GL_HISTOGRAM_GREEN_SIZE, GL_HISTOGRAM_BLUE_SIZE, GL_HISTOGRAM_ALPHA_SIZE, GL_HISTOGRAM_LUMINANCE_SIZE, or GL_HISTOGRAM_SINK.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Pointer to storage for the returned values.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetHistogramParameterfv")]
        public static extern void GetHistogramParameter(OpenTK.Graphics.OpenGL.HistogramTarget target, OpenTK.Graphics.OpenGL.GetHistogramParameterPName pname, [OutAttribute] out Single @params);

        /// <summary>
        /// Get histogram parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be one of GL_HISTOGRAM or GL_PROXY_HISTOGRAM.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The name of the parameter to be retrieved. Must be one of GL_HISTOGRAM_WIDTH, GL_HISTOGRAM_FORMAT, GL_HISTOGRAM_RED_SIZE, GL_HISTOGRAM_GREEN_SIZE, GL_HISTOGRAM_BLUE_SIZE, GL_HISTOGRAM_ALPHA_SIZE, GL_HISTOGRAM_LUMINANCE_SIZE, or GL_HISTOGRAM_SINK.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Pointer to storage for the returned values.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetHistogramParameterfv")]
        public static extern unsafe void GetHistogramParameter(OpenTK.Graphics.OpenGL.HistogramTarget target, OpenTK.Graphics.OpenGL.GetHistogramParameterPName pname, [OutAttribute] Single* @params);

        /// <summary>
        /// Get histogram parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be one of GL_HISTOGRAM or GL_PROXY_HISTOGRAM.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The name of the parameter to be retrieved. Must be one of GL_HISTOGRAM_WIDTH, GL_HISTOGRAM_FORMAT, GL_HISTOGRAM_RED_SIZE, GL_HISTOGRAM_GREEN_SIZE, GL_HISTOGRAM_BLUE_SIZE, GL_HISTOGRAM_ALPHA_SIZE, GL_HISTOGRAM_LUMINANCE_SIZE, or GL_HISTOGRAM_SINK.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Pointer to storage for the returned values.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetHistogramParameteriv")]
        public static extern void GetHistogramParameter(OpenTK.Graphics.OpenGL.HistogramTarget target, OpenTK.Graphics.OpenGL.GetHistogramParameterPName pname, [OutAttribute] Int32[] @params);

        /// <summary>
        /// Get histogram parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be one of GL_HISTOGRAM or GL_PROXY_HISTOGRAM.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The name of the parameter to be retrieved. Must be one of GL_HISTOGRAM_WIDTH, GL_HISTOGRAM_FORMAT, GL_HISTOGRAM_RED_SIZE, GL_HISTOGRAM_GREEN_SIZE, GL_HISTOGRAM_BLUE_SIZE, GL_HISTOGRAM_ALPHA_SIZE, GL_HISTOGRAM_LUMINANCE_SIZE, or GL_HISTOGRAM_SINK.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Pointer to storage for the returned values.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetHistogramParameteriv")]
        public static extern void GetHistogramParameter(OpenTK.Graphics.OpenGL.HistogramTarget target, OpenTK.Graphics.OpenGL.GetHistogramParameterPName pname, [OutAttribute] out Int32 @params);

        /// <summary>
        /// Get histogram parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be one of GL_HISTOGRAM or GL_PROXY_HISTOGRAM.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The name of the parameter to be retrieved. Must be one of GL_HISTOGRAM_WIDTH, GL_HISTOGRAM_FORMAT, GL_HISTOGRAM_RED_SIZE, GL_HISTOGRAM_GREEN_SIZE, GL_HISTOGRAM_BLUE_SIZE, GL_HISTOGRAM_ALPHA_SIZE, GL_HISTOGRAM_LUMINANCE_SIZE, or GL_HISTOGRAM_SINK.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Pointer to storage for the returned values.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetHistogramParameteriv")]
        public static extern unsafe void GetHistogramParameter(OpenTK.Graphics.OpenGL.HistogramTarget target, OpenTK.Graphics.OpenGL.GetHistogramParameterPName pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v3.2]</summary>
        [AutoGenerated(Category = "VERSION_3_2", Version = "3.2", EntryPoint = "glGetInteger64i_v")]
        public static extern void GetInteger64(OpenTK.Graphics.OpenGL.GetIndexedPName target, Int32 index, [OutAttribute] Int64[] data);

        /// <summary>[requires: v3.2]</summary>
        [AutoGenerated(Category = "VERSION_3_2", Version = "3.2", EntryPoint = "glGetInteger64i_v")]
        public static extern void GetInteger64(OpenTK.Graphics.OpenGL.GetIndexedPName target, Int32 index, [OutAttribute] out Int64 data);

        /// <summary>[requires: v3.2]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_2", Version = "3.2", EntryPoint = "glGetInteger64i_v")]
        public static extern unsafe void GetInteger64(OpenTK.Graphics.OpenGL.GetIndexedPName target, Int32 index, [OutAttribute] Int64* data);

        /// <summary>[requires: v3.2]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_2", Version = "3.2", EntryPoint = "glGetInteger64i_v")]
        public static extern void GetInteger64(OpenTK.Graphics.OpenGL.GetIndexedPName target, UInt32 index, [OutAttribute] Int64[] data);

        /// <summary>[requires: v3.2]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_2", Version = "3.2", EntryPoint = "glGetInteger64i_v")]
        public static extern void GetInteger64(OpenTK.Graphics.OpenGL.GetIndexedPName target, UInt32 index, [OutAttribute] out Int64 data);

        /// <summary>[requires: v3.2]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_2", Version = "3.2", EntryPoint = "glGetInteger64i_v")]
        public static extern unsafe void GetInteger64(OpenTK.Graphics.OpenGL.GetIndexedPName target, UInt32 index, [OutAttribute] Int64* data);

        /// <summary>[requires: v3.2]</summary>
        [Obsolete("Use GetIndexedPName overload instead")]
        [AutoGenerated(Category = "VERSION_3_2", Version = "3.2", EntryPoint = "glGetInteger64i_v")]
        public static extern void GetInteger64(OpenTK.Graphics.OpenGL.Version32 target, Int32 index, [OutAttribute] Int64[] data);

        /// <summary>[requires: v3.2]</summary>
        [Obsolete("Use GetIndexedPName overload instead")]
        [AutoGenerated(Category = "VERSION_3_2", Version = "3.2", EntryPoint = "glGetInteger64i_v")]
        public static extern void GetInteger64(OpenTK.Graphics.OpenGL.Version32 target, Int32 index, [OutAttribute] out Int64 data);

        /// <summary>[requires: v3.2]</summary>
        [Obsolete("Use GetIndexedPName overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_2", Version = "3.2", EntryPoint = "glGetInteger64i_v")]
        public static extern unsafe void GetInteger64(OpenTK.Graphics.OpenGL.Version32 target, Int32 index, [OutAttribute] Int64* data);

        /// <summary>[requires: v3.2]</summary>
        [Obsolete("Use GetIndexedPName overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_2", Version = "3.2", EntryPoint = "glGetInteger64i_v")]
        public static extern void GetInteger64(OpenTK.Graphics.OpenGL.Version32 target, UInt32 index, [OutAttribute] Int64[] data);

        /// <summary>[requires: v3.2]</summary>
        [Obsolete("Use GetIndexedPName overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_2", Version = "3.2", EntryPoint = "glGetInteger64i_v")]
        public static extern void GetInteger64(OpenTK.Graphics.OpenGL.Version32 target, UInt32 index, [OutAttribute] out Int64 data);

        /// <summary>[requires: v3.2]</summary>
        [Obsolete("Use GetIndexedPName overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_2", Version = "3.2", EntryPoint = "glGetInteger64i_v")]
        public static extern unsafe void GetInteger64(OpenTK.Graphics.OpenGL.Version32 target, UInt32 index, [OutAttribute] Int64* data);

        /// <summary>[requires: v3.2 and ARB_sync|VERSION_3_2]</summary>
        [AutoGenerated(Category = "ARB_sync|VERSION_3_2", Version = "3.2", EntryPoint = "glGetInteger64v")]
        public static extern Int64 GetInteger64(OpenTK.Graphics.OpenGL.GetPName pname);

        /// <summary>[requires: v3.2 and ARB_sync|VERSION_3_2]</summary>
        [Obsolete("Use GetPName overload instead")]
        [AutoGenerated(Category = "ARB_sync|VERSION_3_2", Version = "3.2", EntryPoint = "glGetInteger64v")]
        public static extern void GetInteger64(OpenTK.Graphics.OpenGL.ArbSync pname, [OutAttribute] Int64[] data);

        /// <summary>[requires: v3.2 and ARB_sync|VERSION_3_2]</summary>
        [Obsolete("Use GetPName overload instead")]
        [AutoGenerated(Category = "ARB_sync|VERSION_3_2", Version = "3.2", EntryPoint = "glGetInteger64v")]
        public static extern void GetInteger64(OpenTK.Graphics.OpenGL.ArbSync pname, [OutAttribute] out Int64 data);

        /// <summary>[requires: v3.2 and ARB_sync|VERSION_3_2]</summary>
        [Obsolete("Use GetPName overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sync|VERSION_3_2", Version = "3.2", EntryPoint = "glGetInteger64v")]
        public static extern unsafe void GetInteger64(OpenTK.Graphics.OpenGL.ArbSync pname, [OutAttribute] Int64* data);

        /// <summary>[requires: v3.2 and ARB_sync|VERSION_3_2]</summary>
        [AutoGenerated(Category = "ARB_sync|VERSION_3_2", Version = "3.2", EntryPoint = "glGetInteger64v")]
        public static extern void GetInteger64(OpenTK.Graphics.OpenGL.GetPName pname, [OutAttribute] Int64[] data);

        /// <summary>[requires: v3.2 and ARB_sync|VERSION_3_2]</summary>
        [AutoGenerated(Category = "ARB_sync|VERSION_3_2", Version = "3.2", EntryPoint = "glGetInteger64v")]
        public static extern void GetInteger64(OpenTK.Graphics.OpenGL.GetPName pname, [OutAttribute] out Int64 data);

        /// <summary>[requires: v3.2 and ARB_sync|VERSION_3_2]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sync|VERSION_3_2", Version = "3.2", EntryPoint = "glGetInteger64v")]
        public static extern unsafe void GetInteger64(OpenTK.Graphics.OpenGL.GetPName pname, [OutAttribute] Int64* data);

        /// <summary>[requires: v3.0]</summary>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetIntegeri_v")]
        public static extern void GetInteger(OpenTK.Graphics.OpenGL.GetIndexedPName target, Int32 index, [OutAttribute] Int32[] data);

        /// <summary>[requires: v3.0]</summary>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetIntegeri_v")]
        public static extern void GetInteger(OpenTK.Graphics.OpenGL.GetIndexedPName target, Int32 index, [OutAttribute] out Int32 data);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetIntegeri_v")]
        public static extern unsafe void GetInteger(OpenTK.Graphics.OpenGL.GetIndexedPName target, Int32 index, [OutAttribute] Int32* data);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetIntegeri_v")]
        public static extern void GetInteger(OpenTK.Graphics.OpenGL.GetIndexedPName target, UInt32 index, [OutAttribute] Int32[] data);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetIntegeri_v")]
        public static extern void GetInteger(OpenTK.Graphics.OpenGL.GetIndexedPName target, UInt32 index, [OutAttribute] out Int32 data);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetIntegeri_v")]
        public static extern unsafe void GetInteger(OpenTK.Graphics.OpenGL.GetIndexedPName target, UInt32 index, [OutAttribute] Int32* data);

        /// <summary>[requires: v1.0]</summary>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetIntegerv")]
        public static extern Int32 GetInteger(OpenTK.Graphics.OpenGL.GetPName pname);

        /// <summary>[requires: v1.0]</summary>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetIntegerv")]
        public static extern void GetInteger(OpenTK.Graphics.OpenGL.GetPName pname, [OutAttribute] Int32[] data);

        /// <summary>[requires: v1.0]</summary>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetIntegerv")]
        public static extern void GetInteger(OpenTK.Graphics.OpenGL.GetPName pname, [OutAttribute] out Int32 data);

        /// <summary>[requires: v1.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetIntegerv")]
        public static extern unsafe void GetInteger(OpenTK.Graphics.OpenGL.GetPName pname, [OutAttribute] Int32* data);

        /// <summary>[requires: v4.3 and ARB_internalformat_query2|VERSION_4_3]</summary>
        [AutoGenerated(Category = "ARB_internalformat_query2|VERSION_4_3", Version = "4.3", EntryPoint = "glGetInternalformati64v")]
        public static extern void GetInternalformat(OpenTK.Graphics.OpenGL.ImageTarget target, OpenTK.Graphics.OpenGL.SizedInternalFormat internalformat, OpenTK.Graphics.OpenGL.InternalFormatParameter pname, Int32 bufSize, [OutAttribute] Int64[] @params);

        /// <summary>[requires: v4.3 and ARB_internalformat_query2|VERSION_4_3]</summary>
        [AutoGenerated(Category = "ARB_internalformat_query2|VERSION_4_3", Version = "4.3", EntryPoint = "glGetInternalformati64v")]
        public static extern void GetInternalformat(OpenTK.Graphics.OpenGL.ImageTarget target, OpenTK.Graphics.OpenGL.SizedInternalFormat internalformat, OpenTK.Graphics.OpenGL.InternalFormatParameter pname, Int32 bufSize, [OutAttribute] out Int64 @params);

        /// <summary>[requires: v4.3 and ARB_internalformat_query2|VERSION_4_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_internalformat_query2|VERSION_4_3", Version = "4.3", EntryPoint = "glGetInternalformati64v")]
        public static extern unsafe void GetInternalformat(OpenTK.Graphics.OpenGL.ImageTarget target, OpenTK.Graphics.OpenGL.SizedInternalFormat internalformat, OpenTK.Graphics.OpenGL.InternalFormatParameter pname, Int32 bufSize, [OutAttribute] Int64* @params);

        /// <summary>[requires: v4.2 and ARB_internalformat_query|VERSION_4_2]
        /// Retrieve information about implementation-dependent support for internal formats
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Indicates the usage of the internal format. target must be GL_TEXTURE_1D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_3D, GL_TEXTURE_CUBE_MAP, GL_TEXTURE_CUBE_MAP_ARRAY, GL_TEXTURE_RECTANGLE, GL_TEXTURE_BUFFER, GL_RENDERBUFFER, GL_TEXTURE_2D_MULTISAMPLE or GL_TEXTURE_2D_MULTISAMPLE_ARRAY.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// Specifies the internal format about which to retrieve information.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the type of information to query.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the maximum number of basic machine units that may be written to params by the function.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Specifies the address of a variable into which to write the retrieved information.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_internalformat_query|VERSION_4_2", Version = "4.2", EntryPoint = "glGetInternalformativ")]
        public static extern void GetInternalformat(OpenTK.Graphics.OpenGL.ImageTarget target, OpenTK.Graphics.OpenGL.SizedInternalFormat internalformat, OpenTK.Graphics.OpenGL.InternalFormatParameter pname, Int32 bufSize, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v4.2 and ARB_internalformat_query|VERSION_4_2]
        /// Retrieve information about implementation-dependent support for internal formats
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Indicates the usage of the internal format. target must be GL_TEXTURE_1D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_3D, GL_TEXTURE_CUBE_MAP, GL_TEXTURE_CUBE_MAP_ARRAY, GL_TEXTURE_RECTANGLE, GL_TEXTURE_BUFFER, GL_RENDERBUFFER, GL_TEXTURE_2D_MULTISAMPLE or GL_TEXTURE_2D_MULTISAMPLE_ARRAY.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// Specifies the internal format about which to retrieve information.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the type of information to query.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the maximum number of basic machine units that may be written to params by the function.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Specifies the address of a variable into which to write the retrieved information.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_internalformat_query|VERSION_4_2", Version = "4.2", EntryPoint = "glGetInternalformativ")]
        public static extern void GetInternalformat(OpenTK.Graphics.OpenGL.ImageTarget target, OpenTK.Graphics.OpenGL.SizedInternalFormat internalformat, OpenTK.Graphics.OpenGL.InternalFormatParameter pname, Int32 bufSize, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v4.2 and ARB_internalformat_query|VERSION_4_2]
        /// Retrieve information about implementation-dependent support for internal formats
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Indicates the usage of the internal format. target must be GL_TEXTURE_1D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_3D, GL_TEXTURE_CUBE_MAP, GL_TEXTURE_CUBE_MAP_ARRAY, GL_TEXTURE_RECTANGLE, GL_TEXTURE_BUFFER, GL_RENDERBUFFER, GL_TEXTURE_2D_MULTISAMPLE or GL_TEXTURE_2D_MULTISAMPLE_ARRAY.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// Specifies the internal format about which to retrieve information.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the type of information to query.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the maximum number of basic machine units that may be written to params by the function.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Specifies the address of a variable into which to write the retrieved information.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_internalformat_query|VERSION_4_2", Version = "4.2", EntryPoint = "glGetInternalformativ")]
        public static extern unsafe void GetInternalformat(OpenTK.Graphics.OpenGL.ImageTarget target, OpenTK.Graphics.OpenGL.SizedInternalFormat internalformat, OpenTK.Graphics.OpenGL.InternalFormatParameter pname, Int32 bufSize, [OutAttribute] Int32* @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return light source parameter values
        /// </summary>
        /// <param name="light">
        /// <para>
        /// Specifies a light source. The number of possible lights depends on the implementation, but at least eight lights are supported. They are identified by symbolic names of the form GL_LIGHT where ranges from 0 to the value of GL_MAX_LIGHTS - 1.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies a light source parameter for light. Accepted symbolic names are GL_AMBIENT, GL_DIFFUSE, GL_SPECULAR, GL_POSITION, GL_SPOT_DIRECTION, GL_SPOT_EXPONENT, GL_SPOT_CUTOFF, GL_CONSTANT_ATTENUATION, GL_LINEAR_ATTENUATION, and GL_QUADRATIC_ATTENUATION.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetLightfv")]
        public static extern void GetLight(OpenTK.Graphics.OpenGL.LightName light, OpenTK.Graphics.OpenGL.LightParameter pname, [OutAttribute] Single[] @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return light source parameter values
        /// </summary>
        /// <param name="light">
        /// <para>
        /// Specifies a light source. The number of possible lights depends on the implementation, but at least eight lights are supported. They are identified by symbolic names of the form GL_LIGHT where ranges from 0 to the value of GL_MAX_LIGHTS - 1.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies a light source parameter for light. Accepted symbolic names are GL_AMBIENT, GL_DIFFUSE, GL_SPECULAR, GL_POSITION, GL_SPOT_DIRECTION, GL_SPOT_EXPONENT, GL_SPOT_CUTOFF, GL_CONSTANT_ATTENUATION, GL_LINEAR_ATTENUATION, and GL_QUADRATIC_ATTENUATION.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetLightfv")]
        public static extern void GetLight(OpenTK.Graphics.OpenGL.LightName light, OpenTK.Graphics.OpenGL.LightParameter pname, [OutAttribute] out Single @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return light source parameter values
        /// </summary>
        /// <param name="light">
        /// <para>
        /// Specifies a light source. The number of possible lights depends on the implementation, but at least eight lights are supported. They are identified by symbolic names of the form GL_LIGHT where ranges from 0 to the value of GL_MAX_LIGHTS - 1.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies a light source parameter for light. Accepted symbolic names are GL_AMBIENT, GL_DIFFUSE, GL_SPECULAR, GL_POSITION, GL_SPOT_DIRECTION, GL_SPOT_EXPONENT, GL_SPOT_CUTOFF, GL_CONSTANT_ATTENUATION, GL_LINEAR_ATTENUATION, and GL_QUADRATIC_ATTENUATION.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetLightfv")]
        public static extern unsafe void GetLight(OpenTK.Graphics.OpenGL.LightName light, OpenTK.Graphics.OpenGL.LightParameter pname, [OutAttribute] Single* @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return light source parameter values
        /// </summary>
        /// <param name="light">
        /// <para>
        /// Specifies a light source. The number of possible lights depends on the implementation, but at least eight lights are supported. They are identified by symbolic names of the form GL_LIGHT where ranges from 0 to the value of GL_MAX_LIGHTS - 1.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies a light source parameter for light. Accepted symbolic names are GL_AMBIENT, GL_DIFFUSE, GL_SPECULAR, GL_POSITION, GL_SPOT_DIRECTION, GL_SPOT_EXPONENT, GL_SPOT_CUTOFF, GL_CONSTANT_ATTENUATION, GL_LINEAR_ATTENUATION, and GL_QUADRATIC_ATTENUATION.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetLightiv")]
        public static extern void GetLight(OpenTK.Graphics.OpenGL.LightName light, OpenTK.Graphics.OpenGL.LightParameter pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return light source parameter values
        /// </summary>
        /// <param name="light">
        /// <para>
        /// Specifies a light source. The number of possible lights depends on the implementation, but at least eight lights are supported. They are identified by symbolic names of the form GL_LIGHT where ranges from 0 to the value of GL_MAX_LIGHTS - 1.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies a light source parameter for light. Accepted symbolic names are GL_AMBIENT, GL_DIFFUSE, GL_SPECULAR, GL_POSITION, GL_SPOT_DIRECTION, GL_SPOT_EXPONENT, GL_SPOT_CUTOFF, GL_CONSTANT_ATTENUATION, GL_LINEAR_ATTENUATION, and GL_QUADRATIC_ATTENUATION.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetLightiv")]
        public static extern void GetLight(OpenTK.Graphics.OpenGL.LightName light, OpenTK.Graphics.OpenGL.LightParameter pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return light source parameter values
        /// </summary>
        /// <param name="light">
        /// <para>
        /// Specifies a light source. The number of possible lights depends on the implementation, but at least eight lights are supported. They are identified by symbolic names of the form GL_LIGHT where ranges from 0 to the value of GL_MAX_LIGHTS - 1.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies a light source parameter for light. Accepted symbolic names are GL_AMBIENT, GL_DIFFUSE, GL_SPECULAR, GL_POSITION, GL_SPOT_DIRECTION, GL_SPOT_EXPONENT, GL_SPOT_CUTOFF, GL_CONSTANT_ATTENUATION, GL_LINEAR_ATTENUATION, and GL_QUADRATIC_ATTENUATION.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetLightiv")]
        public static extern unsafe void GetLight(OpenTK.Graphics.OpenGL.LightName light, OpenTK.Graphics.OpenGL.LightParameter pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return evaluator parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the symbolic name of a map. Accepted values are GL_MAP1_COLOR_4, GL_MAP1_INDEX, GL_MAP1_NORMAL, GL_MAP1_TEXTURE_COORD_1, GL_MAP1_TEXTURE_COORD_2, GL_MAP1_TEXTURE_COORD_3, GL_MAP1_TEXTURE_COORD_4, GL_MAP1_VERTEX_3, GL_MAP1_VERTEX_4, GL_MAP2_COLOR_4, GL_MAP2_INDEX, GL_MAP2_NORMAL, GL_MAP2_TEXTURE_COORD_1, GL_MAP2_TEXTURE_COORD_2, GL_MAP2_TEXTURE_COORD_3, GL_MAP2_TEXTURE_COORD_4, GL_MAP2_VERTEX_3, and GL_MAP2_VERTEX_4.
        /// </para>
        /// </param>
        /// <param name="query">
        /// <para>
        /// Specifies which parameter to return. Symbolic names GL_COEFF, GL_ORDER, and GL_DOMAIN are accepted.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetMapdv")]
        public static extern void GetMap(OpenTK.Graphics.OpenGL.MapTarget target, OpenTK.Graphics.OpenGL.GetMapQuery query, [OutAttribute] Double[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return evaluator parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the symbolic name of a map. Accepted values are GL_MAP1_COLOR_4, GL_MAP1_INDEX, GL_MAP1_NORMAL, GL_MAP1_TEXTURE_COORD_1, GL_MAP1_TEXTURE_COORD_2, GL_MAP1_TEXTURE_COORD_3, GL_MAP1_TEXTURE_COORD_4, GL_MAP1_VERTEX_3, GL_MAP1_VERTEX_4, GL_MAP2_COLOR_4, GL_MAP2_INDEX, GL_MAP2_NORMAL, GL_MAP2_TEXTURE_COORD_1, GL_MAP2_TEXTURE_COORD_2, GL_MAP2_TEXTURE_COORD_3, GL_MAP2_TEXTURE_COORD_4, GL_MAP2_VERTEX_3, and GL_MAP2_VERTEX_4.
        /// </para>
        /// </param>
        /// <param name="query">
        /// <para>
        /// Specifies which parameter to return. Symbolic names GL_COEFF, GL_ORDER, and GL_DOMAIN are accepted.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetMapdv")]
        public static extern void GetMap(OpenTK.Graphics.OpenGL.MapTarget target, OpenTK.Graphics.OpenGL.GetMapQuery query, [OutAttribute] out Double v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return evaluator parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the symbolic name of a map. Accepted values are GL_MAP1_COLOR_4, GL_MAP1_INDEX, GL_MAP1_NORMAL, GL_MAP1_TEXTURE_COORD_1, GL_MAP1_TEXTURE_COORD_2, GL_MAP1_TEXTURE_COORD_3, GL_MAP1_TEXTURE_COORD_4, GL_MAP1_VERTEX_3, GL_MAP1_VERTEX_4, GL_MAP2_COLOR_4, GL_MAP2_INDEX, GL_MAP2_NORMAL, GL_MAP2_TEXTURE_COORD_1, GL_MAP2_TEXTURE_COORD_2, GL_MAP2_TEXTURE_COORD_3, GL_MAP2_TEXTURE_COORD_4, GL_MAP2_VERTEX_3, and GL_MAP2_VERTEX_4.
        /// </para>
        /// </param>
        /// <param name="query">
        /// <para>
        /// Specifies which parameter to return. Symbolic names GL_COEFF, GL_ORDER, and GL_DOMAIN are accepted.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetMapdv")]
        public static extern unsafe void GetMap(OpenTK.Graphics.OpenGL.MapTarget target, OpenTK.Graphics.OpenGL.GetMapQuery query, [OutAttribute] Double* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return evaluator parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the symbolic name of a map. Accepted values are GL_MAP1_COLOR_4, GL_MAP1_INDEX, GL_MAP1_NORMAL, GL_MAP1_TEXTURE_COORD_1, GL_MAP1_TEXTURE_COORD_2, GL_MAP1_TEXTURE_COORD_3, GL_MAP1_TEXTURE_COORD_4, GL_MAP1_VERTEX_3, GL_MAP1_VERTEX_4, GL_MAP2_COLOR_4, GL_MAP2_INDEX, GL_MAP2_NORMAL, GL_MAP2_TEXTURE_COORD_1, GL_MAP2_TEXTURE_COORD_2, GL_MAP2_TEXTURE_COORD_3, GL_MAP2_TEXTURE_COORD_4, GL_MAP2_VERTEX_3, and GL_MAP2_VERTEX_4.
        /// </para>
        /// </param>
        /// <param name="query">
        /// <para>
        /// Specifies which parameter to return. Symbolic names GL_COEFF, GL_ORDER, and GL_DOMAIN are accepted.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetMapfv")]
        public static extern void GetMap(OpenTK.Graphics.OpenGL.MapTarget target, OpenTK.Graphics.OpenGL.GetMapQuery query, [OutAttribute] Single[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return evaluator parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the symbolic name of a map. Accepted values are GL_MAP1_COLOR_4, GL_MAP1_INDEX, GL_MAP1_NORMAL, GL_MAP1_TEXTURE_COORD_1, GL_MAP1_TEXTURE_COORD_2, GL_MAP1_TEXTURE_COORD_3, GL_MAP1_TEXTURE_COORD_4, GL_MAP1_VERTEX_3, GL_MAP1_VERTEX_4, GL_MAP2_COLOR_4, GL_MAP2_INDEX, GL_MAP2_NORMAL, GL_MAP2_TEXTURE_COORD_1, GL_MAP2_TEXTURE_COORD_2, GL_MAP2_TEXTURE_COORD_3, GL_MAP2_TEXTURE_COORD_4, GL_MAP2_VERTEX_3, and GL_MAP2_VERTEX_4.
        /// </para>
        /// </param>
        /// <param name="query">
        /// <para>
        /// Specifies which parameter to return. Symbolic names GL_COEFF, GL_ORDER, and GL_DOMAIN are accepted.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetMapfv")]
        public static extern void GetMap(OpenTK.Graphics.OpenGL.MapTarget target, OpenTK.Graphics.OpenGL.GetMapQuery query, [OutAttribute] out Single v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return evaluator parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the symbolic name of a map. Accepted values are GL_MAP1_COLOR_4, GL_MAP1_INDEX, GL_MAP1_NORMAL, GL_MAP1_TEXTURE_COORD_1, GL_MAP1_TEXTURE_COORD_2, GL_MAP1_TEXTURE_COORD_3, GL_MAP1_TEXTURE_COORD_4, GL_MAP1_VERTEX_3, GL_MAP1_VERTEX_4, GL_MAP2_COLOR_4, GL_MAP2_INDEX, GL_MAP2_NORMAL, GL_MAP2_TEXTURE_COORD_1, GL_MAP2_TEXTURE_COORD_2, GL_MAP2_TEXTURE_COORD_3, GL_MAP2_TEXTURE_COORD_4, GL_MAP2_VERTEX_3, and GL_MAP2_VERTEX_4.
        /// </para>
        /// </param>
        /// <param name="query">
        /// <para>
        /// Specifies which parameter to return. Symbolic names GL_COEFF, GL_ORDER, and GL_DOMAIN are accepted.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetMapfv")]
        public static extern unsafe void GetMap(OpenTK.Graphics.OpenGL.MapTarget target, OpenTK.Graphics.OpenGL.GetMapQuery query, [OutAttribute] Single* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return evaluator parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the symbolic name of a map. Accepted values are GL_MAP1_COLOR_4, GL_MAP1_INDEX, GL_MAP1_NORMAL, GL_MAP1_TEXTURE_COORD_1, GL_MAP1_TEXTURE_COORD_2, GL_MAP1_TEXTURE_COORD_3, GL_MAP1_TEXTURE_COORD_4, GL_MAP1_VERTEX_3, GL_MAP1_VERTEX_4, GL_MAP2_COLOR_4, GL_MAP2_INDEX, GL_MAP2_NORMAL, GL_MAP2_TEXTURE_COORD_1, GL_MAP2_TEXTURE_COORD_2, GL_MAP2_TEXTURE_COORD_3, GL_MAP2_TEXTURE_COORD_4, GL_MAP2_VERTEX_3, and GL_MAP2_VERTEX_4.
        /// </para>
        /// </param>
        /// <param name="query">
        /// <para>
        /// Specifies which parameter to return. Symbolic names GL_COEFF, GL_ORDER, and GL_DOMAIN are accepted.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetMapiv")]
        public static extern void GetMap(OpenTK.Graphics.OpenGL.MapTarget target, OpenTK.Graphics.OpenGL.GetMapQuery query, [OutAttribute] Int32[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return evaluator parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the symbolic name of a map. Accepted values are GL_MAP1_COLOR_4, GL_MAP1_INDEX, GL_MAP1_NORMAL, GL_MAP1_TEXTURE_COORD_1, GL_MAP1_TEXTURE_COORD_2, GL_MAP1_TEXTURE_COORD_3, GL_MAP1_TEXTURE_COORD_4, GL_MAP1_VERTEX_3, GL_MAP1_VERTEX_4, GL_MAP2_COLOR_4, GL_MAP2_INDEX, GL_MAP2_NORMAL, GL_MAP2_TEXTURE_COORD_1, GL_MAP2_TEXTURE_COORD_2, GL_MAP2_TEXTURE_COORD_3, GL_MAP2_TEXTURE_COORD_4, GL_MAP2_VERTEX_3, and GL_MAP2_VERTEX_4.
        /// </para>
        /// </param>
        /// <param name="query">
        /// <para>
        /// Specifies which parameter to return. Symbolic names GL_COEFF, GL_ORDER, and GL_DOMAIN are accepted.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetMapiv")]
        public static extern void GetMap(OpenTK.Graphics.OpenGL.MapTarget target, OpenTK.Graphics.OpenGL.GetMapQuery query, [OutAttribute] out Int32 v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return evaluator parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the symbolic name of a map. Accepted values are GL_MAP1_COLOR_4, GL_MAP1_INDEX, GL_MAP1_NORMAL, GL_MAP1_TEXTURE_COORD_1, GL_MAP1_TEXTURE_COORD_2, GL_MAP1_TEXTURE_COORD_3, GL_MAP1_TEXTURE_COORD_4, GL_MAP1_VERTEX_3, GL_MAP1_VERTEX_4, GL_MAP2_COLOR_4, GL_MAP2_INDEX, GL_MAP2_NORMAL, GL_MAP2_TEXTURE_COORD_1, GL_MAP2_TEXTURE_COORD_2, GL_MAP2_TEXTURE_COORD_3, GL_MAP2_TEXTURE_COORD_4, GL_MAP2_VERTEX_3, and GL_MAP2_VERTEX_4.
        /// </para>
        /// </param>
        /// <param name="query">
        /// <para>
        /// Specifies which parameter to return. Symbolic names GL_COEFF, GL_ORDER, and GL_DOMAIN are accepted.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetMapiv")]
        public static extern unsafe void GetMap(OpenTK.Graphics.OpenGL.MapTarget target, OpenTK.Graphics.OpenGL.GetMapQuery query, [OutAttribute] Int32* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return material parameters
        /// </summary>
        /// <param name="face">
        /// <para>
        /// Specifies which of the two materials is being queried. GL_FRONT or GL_BACK are accepted, representing the front and back materials, respectively.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the material parameter to return. GL_AMBIENT, GL_DIFFUSE, GL_SPECULAR, GL_EMISSION, GL_SHININESS, and GL_COLOR_INDEXES are accepted.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetMaterialfv")]
        public static extern void GetMaterial(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, [OutAttribute] Single[] @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return material parameters
        /// </summary>
        /// <param name="face">
        /// <para>
        /// Specifies which of the two materials is being queried. GL_FRONT or GL_BACK are accepted, representing the front and back materials, respectively.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the material parameter to return. GL_AMBIENT, GL_DIFFUSE, GL_SPECULAR, GL_EMISSION, GL_SHININESS, and GL_COLOR_INDEXES are accepted.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetMaterialfv")]
        public static extern void GetMaterial(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, [OutAttribute] out Single @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return material parameters
        /// </summary>
        /// <param name="face">
        /// <para>
        /// Specifies which of the two materials is being queried. GL_FRONT or GL_BACK are accepted, representing the front and back materials, respectively.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the material parameter to return. GL_AMBIENT, GL_DIFFUSE, GL_SPECULAR, GL_EMISSION, GL_SHININESS, and GL_COLOR_INDEXES are accepted.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetMaterialfv")]
        public static extern unsafe void GetMaterial(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, [OutAttribute] Single* @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return material parameters
        /// </summary>
        /// <param name="face">
        /// <para>
        /// Specifies which of the two materials is being queried. GL_FRONT or GL_BACK are accepted, representing the front and back materials, respectively.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the material parameter to return. GL_AMBIENT, GL_DIFFUSE, GL_SPECULAR, GL_EMISSION, GL_SHININESS, and GL_COLOR_INDEXES are accepted.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetMaterialiv")]
        public static extern void GetMaterial(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return material parameters
        /// </summary>
        /// <param name="face">
        /// <para>
        /// Specifies which of the two materials is being queried. GL_FRONT or GL_BACK are accepted, representing the front and back materials, respectively.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the material parameter to return. GL_AMBIENT, GL_DIFFUSE, GL_SPECULAR, GL_EMISSION, GL_SHININESS, and GL_COLOR_INDEXES are accepted.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetMaterialiv")]
        public static extern void GetMaterial(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return material parameters
        /// </summary>
        /// <param name="face">
        /// <para>
        /// Specifies which of the two materials is being queried. GL_FRONT or GL_BACK are accepted, representing the front and back materials, respectively.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the material parameter to return. GL_AMBIENT, GL_DIFFUSE, GL_SPECULAR, GL_EMISSION, GL_SHININESS, and GL_COLOR_INDEXES are accepted.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetMaterialiv")]
        public static extern unsafe void GetMaterial(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, [OutAttribute] Int32* @params);

        /// <summary>
        /// Get minimum and maximum pixel values
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_MINMAX.
        /// </para>
        /// </param>
        /// <param name="reset">
        /// <para>
        /// If GL_TRUE, all entries in the minmax table that are actually returned are reset to their initial values. (Other entries are unaltered.) If GL_FALSE, the minmax table is unaltered.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the data to be returned in values. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
        /// </para>
        /// </param>
        /// <param name="types">
        /// <para>
        /// The type of the data to be returned in values. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// A pointer to storage for the returned values.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetMinmax")]
        public static extern void GetMinmax(OpenTK.Graphics.OpenGL.MinmaxTarget target, bool reset, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [OutAttribute] IntPtr values);

        /// <summary>
        /// Get minimum and maximum pixel values
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_MINMAX.
        /// </para>
        /// </param>
        /// <param name="reset">
        /// <para>
        /// If GL_TRUE, all entries in the minmax table that are actually returned are reset to their initial values. (Other entries are unaltered.) If GL_FALSE, the minmax table is unaltered.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the data to be returned in values. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
        /// </para>
        /// </param>
        /// <param name="types">
        /// <para>
        /// The type of the data to be returned in values. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// A pointer to storage for the returned values.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetMinmax")]
        public static extern void GetMinmax<T4>(OpenTK.Graphics.OpenGL.MinmaxTarget target, bool reset, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T4[] values)
            where T4 : struct
        ;

        /// <summary>
        /// Get minimum and maximum pixel values
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_MINMAX.
        /// </para>
        /// </param>
        /// <param name="reset">
        /// <para>
        /// If GL_TRUE, all entries in the minmax table that are actually returned are reset to their initial values. (Other entries are unaltered.) If GL_FALSE, the minmax table is unaltered.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the data to be returned in values. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
        /// </para>
        /// </param>
        /// <param name="types">
        /// <para>
        /// The type of the data to be returned in values. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// A pointer to storage for the returned values.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetMinmax")]
        public static extern void GetMinmax<T4>(OpenTK.Graphics.OpenGL.MinmaxTarget target, bool reset, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T4[,] values)
            where T4 : struct
        ;

        /// <summary>
        /// Get minimum and maximum pixel values
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_MINMAX.
        /// </para>
        /// </param>
        /// <param name="reset">
        /// <para>
        /// If GL_TRUE, all entries in the minmax table that are actually returned are reset to their initial values. (Other entries are unaltered.) If GL_FALSE, the minmax table is unaltered.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the data to be returned in values. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
        /// </para>
        /// </param>
        /// <param name="types">
        /// <para>
        /// The type of the data to be returned in values. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// A pointer to storage for the returned values.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetMinmax")]
        public static extern void GetMinmax<T4>(OpenTK.Graphics.OpenGL.MinmaxTarget target, bool reset, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T4[,,] values)
            where T4 : struct
        ;

        /// <summary>
        /// Get minimum and maximum pixel values
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_MINMAX.
        /// </para>
        /// </param>
        /// <param name="reset">
        /// <para>
        /// If GL_TRUE, all entries in the minmax table that are actually returned are reset to their initial values. (Other entries are unaltered.) If GL_FALSE, the minmax table is unaltered.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the data to be returned in values. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
        /// </para>
        /// </param>
        /// <param name="types">
        /// <para>
        /// The type of the data to be returned in values. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// A pointer to storage for the returned values.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetMinmax")]
        public static extern void GetMinmax<T4>(OpenTK.Graphics.OpenGL.MinmaxTarget target, bool reset, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T4 values)
            where T4 : struct
        ;

        /// <summary>
        /// Get minmax parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_MINMAX.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The parameter to be retrieved. Must be one of GL_MINMAX_FORMAT or GL_MINMAX_SINK.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// A pointer to storage for the retrieved parameters.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetMinmaxParameterfv")]
        public static extern void GetMinmaxParameter(OpenTK.Graphics.OpenGL.MinmaxTarget target, OpenTK.Graphics.OpenGL.GetMinmaxParameterPName pname, [OutAttribute] Single[] @params);

        /// <summary>
        /// Get minmax parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_MINMAX.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The parameter to be retrieved. Must be one of GL_MINMAX_FORMAT or GL_MINMAX_SINK.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// A pointer to storage for the retrieved parameters.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetMinmaxParameterfv")]
        public static extern void GetMinmaxParameter(OpenTK.Graphics.OpenGL.MinmaxTarget target, OpenTK.Graphics.OpenGL.GetMinmaxParameterPName pname, [OutAttribute] out Single @params);

        /// <summary>
        /// Get minmax parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_MINMAX.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The parameter to be retrieved. Must be one of GL_MINMAX_FORMAT or GL_MINMAX_SINK.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// A pointer to storage for the retrieved parameters.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetMinmaxParameterfv")]
        public static extern unsafe void GetMinmaxParameter(OpenTK.Graphics.OpenGL.MinmaxTarget target, OpenTK.Graphics.OpenGL.GetMinmaxParameterPName pname, [OutAttribute] Single* @params);

        /// <summary>
        /// Get minmax parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_MINMAX.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The parameter to be retrieved. Must be one of GL_MINMAX_FORMAT or GL_MINMAX_SINK.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// A pointer to storage for the retrieved parameters.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetMinmaxParameteriv")]
        public static extern void GetMinmaxParameter(OpenTK.Graphics.OpenGL.MinmaxTarget target, OpenTK.Graphics.OpenGL.GetMinmaxParameterPName pname, [OutAttribute] Int32[] @params);

        /// <summary>
        /// Get minmax parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_MINMAX.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The parameter to be retrieved. Must be one of GL_MINMAX_FORMAT or GL_MINMAX_SINK.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// A pointer to storage for the retrieved parameters.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetMinmaxParameteriv")]
        public static extern void GetMinmaxParameter(OpenTK.Graphics.OpenGL.MinmaxTarget target, OpenTK.Graphics.OpenGL.GetMinmaxParameterPName pname, [OutAttribute] out Int32 @params);

        /// <summary>
        /// Get minmax parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_MINMAX.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The parameter to be retrieved. Must be one of GL_MINMAX_FORMAT or GL_MINMAX_SINK.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// A pointer to storage for the retrieved parameters.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetMinmaxParameteriv")]
        public static extern unsafe void GetMinmaxParameter(OpenTK.Graphics.OpenGL.MinmaxTarget target, OpenTK.Graphics.OpenGL.GetMinmaxParameterPName pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v3.2 and ARB_texture_multisample|VERSION_3_2]
        /// Retrieve the location of a sample
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies the sample parameter name. pname must be GL_SAMPLE_POSITION.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the sample whose position to query.
        /// </para>
        /// </param>
        /// <param name="val">
        /// <para>
        /// Specifies the address of an array to receive the position of the sample.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_texture_multisample|VERSION_3_2", Version = "3.2", EntryPoint = "glGetMultisamplefv")]
        public static extern void GetMultisample(OpenTK.Graphics.OpenGL.GetMultisamplePName pname, Int32 index, [OutAttribute] Single[] val);

        /// <summary>[requires: v3.2 and ARB_texture_multisample|VERSION_3_2]
        /// Retrieve the location of a sample
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies the sample parameter name. pname must be GL_SAMPLE_POSITION.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the sample whose position to query.
        /// </para>
        /// </param>
        /// <param name="val">
        /// <para>
        /// Specifies the address of an array to receive the position of the sample.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_texture_multisample|VERSION_3_2", Version = "3.2", EntryPoint = "glGetMultisamplefv")]
        public static extern void GetMultisample(OpenTK.Graphics.OpenGL.GetMultisamplePName pname, Int32 index, [OutAttribute] out Single val);

        /// <summary>[requires: v3.2 and ARB_texture_multisample|VERSION_3_2]
        /// Retrieve the location of a sample
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies the sample parameter name. pname must be GL_SAMPLE_POSITION.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the sample whose position to query.
        /// </para>
        /// </param>
        /// <param name="val">
        /// <para>
        /// Specifies the address of an array to receive the position of the sample.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_texture_multisample|VERSION_3_2", Version = "3.2", EntryPoint = "glGetMultisamplefv")]
        public static extern unsafe void GetMultisample(OpenTK.Graphics.OpenGL.GetMultisamplePName pname, Int32 index, [OutAttribute] Single* val);

        /// <summary>[requires: v3.2 and ARB_texture_multisample|VERSION_3_2]
        /// Retrieve the location of a sample
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies the sample parameter name. pname must be GL_SAMPLE_POSITION.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the sample whose position to query.
        /// </para>
        /// </param>
        /// <param name="val">
        /// <para>
        /// Specifies the address of an array to receive the position of the sample.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_texture_multisample|VERSION_3_2", Version = "3.2", EntryPoint = "glGetMultisamplefv")]
        public static extern void GetMultisample(OpenTK.Graphics.OpenGL.GetMultisamplePName pname, UInt32 index, [OutAttribute] Single[] val);

        /// <summary>[requires: v3.2 and ARB_texture_multisample|VERSION_3_2]
        /// Retrieve the location of a sample
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies the sample parameter name. pname must be GL_SAMPLE_POSITION.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the sample whose position to query.
        /// </para>
        /// </param>
        /// <param name="val">
        /// <para>
        /// Specifies the address of an array to receive the position of the sample.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_texture_multisample|VERSION_3_2", Version = "3.2", EntryPoint = "glGetMultisamplefv")]
        public static extern void GetMultisample(OpenTK.Graphics.OpenGL.GetMultisamplePName pname, UInt32 index, [OutAttribute] out Single val);

        /// <summary>[requires: v3.2 and ARB_texture_multisample|VERSION_3_2]
        /// Retrieve the location of a sample
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies the sample parameter name. pname must be GL_SAMPLE_POSITION.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the sample whose position to query.
        /// </para>
        /// </param>
        /// <param name="val">
        /// <para>
        /// Specifies the address of an array to receive the position of the sample.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_texture_multisample|VERSION_3_2", Version = "3.2", EntryPoint = "glGetMultisamplefv")]
        public static extern unsafe void GetMultisample(OpenTK.Graphics.OpenGL.GetMultisamplePName pname, UInt32 index, [OutAttribute] Single* val);

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Retrieve the label of a named object identified within a namespace
        /// </summary>
        /// <param name="identifier">
        /// <para>
        /// The namespace from which the name of the object is allocated.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The name of the object whose label to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The length of the buffer whose address is in label.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The address of a variable to receive the length of the object label.
        /// </para>
        /// </param>
        /// <param name="label">
        /// <para>
        /// The address of a string that will receive the object label.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glGetObjectLabel")]
        public static extern void GetObjectLabel(OpenTK.Graphics.OpenGL.ObjectLabelIdentifier identifier, Int32 name, Int32 bufSize, [OutAttribute] Int32[] length, [OutAttribute] StringBuilder label);

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Retrieve the label of a named object identified within a namespace
        /// </summary>
        /// <param name="identifier">
        /// <para>
        /// The namespace from which the name of the object is allocated.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The name of the object whose label to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The length of the buffer whose address is in label.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The address of a variable to receive the length of the object label.
        /// </para>
        /// </param>
        /// <param name="label">
        /// <para>
        /// The address of a string that will receive the object label.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glGetObjectLabel")]
        public static extern void GetObjectLabel(OpenTK.Graphics.OpenGL.ObjectLabelIdentifier identifier, Int32 name, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder label);

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Retrieve the label of a named object identified within a namespace
        /// </summary>
        /// <param name="identifier">
        /// <para>
        /// The namespace from which the name of the object is allocated.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The name of the object whose label to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The length of the buffer whose address is in label.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The address of a variable to receive the length of the object label.
        /// </para>
        /// </param>
        /// <param name="label">
        /// <para>
        /// The address of a string that will receive the object label.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glGetObjectLabel")]
        public static extern unsafe void GetObjectLabel(OpenTK.Graphics.OpenGL.ObjectLabelIdentifier identifier, Int32 name, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder label);

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Retrieve the label of a named object identified within a namespace
        /// </summary>
        /// <param name="identifier">
        /// <para>
        /// The namespace from which the name of the object is allocated.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The name of the object whose label to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The length of the buffer whose address is in label.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The address of a variable to receive the length of the object label.
        /// </para>
        /// </param>
        /// <param name="label">
        /// <para>
        /// The address of a string that will receive the object label.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glGetObjectLabel")]
        public static extern void GetObjectLabel(OpenTK.Graphics.OpenGL.ObjectLabelIdentifier identifier, UInt32 name, Int32 bufSize, [OutAttribute] Int32[] length, [OutAttribute] StringBuilder label);

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Retrieve the label of a named object identified within a namespace
        /// </summary>
        /// <param name="identifier">
        /// <para>
        /// The namespace from which the name of the object is allocated.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The name of the object whose label to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The length of the buffer whose address is in label.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The address of a variable to receive the length of the object label.
        /// </para>
        /// </param>
        /// <param name="label">
        /// <para>
        /// The address of a string that will receive the object label.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glGetObjectLabel")]
        public static extern void GetObjectLabel(OpenTK.Graphics.OpenGL.ObjectLabelIdentifier identifier, UInt32 name, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder label);

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Retrieve the label of a named object identified within a namespace
        /// </summary>
        /// <param name="identifier">
        /// <para>
        /// The namespace from which the name of the object is allocated.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The name of the object whose label to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The length of the buffer whose address is in label.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The address of a variable to receive the length of the object label.
        /// </para>
        /// </param>
        /// <param name="label">
        /// <para>
        /// The address of a string that will receive the object label.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glGetObjectLabel")]
        public static extern unsafe void GetObjectLabel(OpenTK.Graphics.OpenGL.ObjectLabelIdentifier identifier, UInt32 name, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder label);

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Retrieve the label of a sync object identified by a pointer
        /// </summary>
        /// <param name="ptr">
        /// <para>
        /// The name of the sync object whose label to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The length of the buffer whose address is in label.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The address of a variable to receive the length of the object label.
        /// </para>
        /// </param>
        /// <param name="label">
        /// <para>
        /// The address of a string that will receive the object label.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glGetObjectPtrLabel")]
        public static extern void GetObjectPtrLabel(IntPtr ptr, Int32 bufSize, [OutAttribute] Int32[] length, [OutAttribute] StringBuilder label);

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Retrieve the label of a sync object identified by a pointer
        /// </summary>
        /// <param name="ptr">
        /// <para>
        /// The name of the sync object whose label to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The length of the buffer whose address is in label.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The address of a variable to receive the length of the object label.
        /// </para>
        /// </param>
        /// <param name="label">
        /// <para>
        /// The address of a string that will receive the object label.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glGetObjectPtrLabel")]
        public static extern void GetObjectPtrLabel(IntPtr ptr, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder label);

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Retrieve the label of a sync object identified by a pointer
        /// </summary>
        /// <param name="ptr">
        /// <para>
        /// The name of the sync object whose label to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The length of the buffer whose address is in label.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The address of a variable to receive the length of the object label.
        /// </para>
        /// </param>
        /// <param name="label">
        /// <para>
        /// The address of a string that will receive the object label.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glGetObjectPtrLabel")]
        public static extern unsafe void GetObjectPtrLabel(IntPtr ptr, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder label);

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Retrieve the label of a sync object identified by a pointer
        /// </summary>
        /// <param name="ptr">
        /// <para>
        /// The name of the sync object whose label to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The length of the buffer whose address is in label.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The address of a variable to receive the length of the object label.
        /// </para>
        /// </param>
        /// <param name="label">
        /// <para>
        /// The address of a string that will receive the object label.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glGetObjectPtrLabel")]
        public static extern void GetObjectPtrLabel<T0>([InAttribute, OutAttribute] T0[] ptr, Int32 bufSize, [OutAttribute] Int32[] length, [OutAttribute] StringBuilder label)
            where T0 : struct
        ;

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Retrieve the label of a sync object identified by a pointer
        /// </summary>
        /// <param name="ptr">
        /// <para>
        /// The name of the sync object whose label to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The length of the buffer whose address is in label.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The address of a variable to receive the length of the object label.
        /// </para>
        /// </param>
        /// <param name="label">
        /// <para>
        /// The address of a string that will receive the object label.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glGetObjectPtrLabel")]
        public static extern void GetObjectPtrLabel<T0>([InAttribute, OutAttribute] T0[] ptr, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder label)
            where T0 : struct
        ;

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Retrieve the label of a sync object identified by a pointer
        /// </summary>
        /// <param name="ptr">
        /// <para>
        /// The name of the sync object whose label to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The length of the buffer whose address is in label.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The address of a variable to receive the length of the object label.
        /// </para>
        /// </param>
        /// <param name="label">
        /// <para>
        /// The address of a string that will receive the object label.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glGetObjectPtrLabel")]
        public static extern unsafe void GetObjectPtrLabel<T0>([InAttribute, OutAttribute] T0[] ptr, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder label)
            where T0 : struct
        ;

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Retrieve the label of a sync object identified by a pointer
        /// </summary>
        /// <param name="ptr">
        /// <para>
        /// The name of the sync object whose label to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The length of the buffer whose address is in label.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The address of a variable to receive the length of the object label.
        /// </para>
        /// </param>
        /// <param name="label">
        /// <para>
        /// The address of a string that will receive the object label.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glGetObjectPtrLabel")]
        public static extern void GetObjectPtrLabel<T0>([InAttribute, OutAttribute] T0[,] ptr, Int32 bufSize, [OutAttribute] Int32[] length, [OutAttribute] StringBuilder label)
            where T0 : struct
        ;

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Retrieve the label of a sync object identified by a pointer
        /// </summary>
        /// <param name="ptr">
        /// <para>
        /// The name of the sync object whose label to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The length of the buffer whose address is in label.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The address of a variable to receive the length of the object label.
        /// </para>
        /// </param>
        /// <param name="label">
        /// <para>
        /// The address of a string that will receive the object label.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glGetObjectPtrLabel")]
        public static extern void GetObjectPtrLabel<T0>([InAttribute, OutAttribute] T0[,] ptr, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder label)
            where T0 : struct
        ;

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Retrieve the label of a sync object identified by a pointer
        /// </summary>
        /// <param name="ptr">
        /// <para>
        /// The name of the sync object whose label to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The length of the buffer whose address is in label.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The address of a variable to receive the length of the object label.
        /// </para>
        /// </param>
        /// <param name="label">
        /// <para>
        /// The address of a string that will receive the object label.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glGetObjectPtrLabel")]
        public static extern unsafe void GetObjectPtrLabel<T0>([InAttribute, OutAttribute] T0[,] ptr, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder label)
            where T0 : struct
        ;

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Retrieve the label of a sync object identified by a pointer
        /// </summary>
        /// <param name="ptr">
        /// <para>
        /// The name of the sync object whose label to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The length of the buffer whose address is in label.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The address of a variable to receive the length of the object label.
        /// </para>
        /// </param>
        /// <param name="label">
        /// <para>
        /// The address of a string that will receive the object label.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glGetObjectPtrLabel")]
        public static extern void GetObjectPtrLabel<T0>([InAttribute, OutAttribute] T0[,,] ptr, Int32 bufSize, [OutAttribute] Int32[] length, [OutAttribute] StringBuilder label)
            where T0 : struct
        ;

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Retrieve the label of a sync object identified by a pointer
        /// </summary>
        /// <param name="ptr">
        /// <para>
        /// The name of the sync object whose label to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The length of the buffer whose address is in label.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The address of a variable to receive the length of the object label.
        /// </para>
        /// </param>
        /// <param name="label">
        /// <para>
        /// The address of a string that will receive the object label.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glGetObjectPtrLabel")]
        public static extern void GetObjectPtrLabel<T0>([InAttribute, OutAttribute] T0[,,] ptr, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder label)
            where T0 : struct
        ;

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Retrieve the label of a sync object identified by a pointer
        /// </summary>
        /// <param name="ptr">
        /// <para>
        /// The name of the sync object whose label to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The length of the buffer whose address is in label.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The address of a variable to receive the length of the object label.
        /// </para>
        /// </param>
        /// <param name="label">
        /// <para>
        /// The address of a string that will receive the object label.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glGetObjectPtrLabel")]
        public static extern unsafe void GetObjectPtrLabel<T0>([InAttribute, OutAttribute] T0[,,] ptr, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder label)
            where T0 : struct
        ;

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Retrieve the label of a sync object identified by a pointer
        /// </summary>
        /// <param name="ptr">
        /// <para>
        /// The name of the sync object whose label to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The length of the buffer whose address is in label.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The address of a variable to receive the length of the object label.
        /// </para>
        /// </param>
        /// <param name="label">
        /// <para>
        /// The address of a string that will receive the object label.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glGetObjectPtrLabel")]
        public static extern void GetObjectPtrLabel<T0>([InAttribute, OutAttribute] ref T0 ptr, Int32 bufSize, [OutAttribute] Int32[] length, [OutAttribute] StringBuilder label)
            where T0 : struct
        ;

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Retrieve the label of a sync object identified by a pointer
        /// </summary>
        /// <param name="ptr">
        /// <para>
        /// The name of the sync object whose label to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The length of the buffer whose address is in label.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The address of a variable to receive the length of the object label.
        /// </para>
        /// </param>
        /// <param name="label">
        /// <para>
        /// The address of a string that will receive the object label.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glGetObjectPtrLabel")]
        public static extern void GetObjectPtrLabel<T0>([InAttribute, OutAttribute] ref T0 ptr, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder label)
            where T0 : struct
        ;

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Retrieve the label of a sync object identified by a pointer
        /// </summary>
        /// <param name="ptr">
        /// <para>
        /// The name of the sync object whose label to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The length of the buffer whose address is in label.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The address of a variable to receive the length of the object label.
        /// </para>
        /// </param>
        /// <param name="label">
        /// <para>
        /// The address of a string that will receive the object label.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glGetObjectPtrLabel")]
        public static extern unsafe void GetObjectPtrLabel<T0>([InAttribute, OutAttribute] ref T0 ptr, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder label)
            where T0 : struct
        ;

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return the specified pixel map
        /// </summary>
        /// <param name="map">
        /// <para>
        /// Specifies the name of the pixel map to return. Accepted values are GL_PIXEL_MAP_I_TO_I, GL_PIXEL_MAP_S_TO_S, GL_PIXEL_MAP_I_TO_R, GL_PIXEL_MAP_I_TO_G, GL_PIXEL_MAP_I_TO_B, GL_PIXEL_MAP_I_TO_A, GL_PIXEL_MAP_R_TO_R, GL_PIXEL_MAP_G_TO_G, GL_PIXEL_MAP_B_TO_B, and GL_PIXEL_MAP_A_TO_A.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Returns the pixel map contents.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetPixelMapfv")]
        public static extern Single GetPixelMap(OpenTK.Graphics.OpenGL.PixelMap map);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return the specified pixel map
        /// </summary>
        /// <param name="map">
        /// <para>
        /// Specifies the name of the pixel map to return. Accepted values are GL_PIXEL_MAP_I_TO_I, GL_PIXEL_MAP_S_TO_S, GL_PIXEL_MAP_I_TO_R, GL_PIXEL_MAP_I_TO_G, GL_PIXEL_MAP_I_TO_B, GL_PIXEL_MAP_I_TO_A, GL_PIXEL_MAP_R_TO_R, GL_PIXEL_MAP_G_TO_G, GL_PIXEL_MAP_B_TO_B, and GL_PIXEL_MAP_A_TO_A.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Returns the pixel map contents.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetPixelMapfv")]
        public static extern void GetPixelMap(OpenTK.Graphics.OpenGL.PixelMap map, [OutAttribute] Single[] values);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return the specified pixel map
        /// </summary>
        /// <param name="map">
        /// <para>
        /// Specifies the name of the pixel map to return. Accepted values are GL_PIXEL_MAP_I_TO_I, GL_PIXEL_MAP_S_TO_S, GL_PIXEL_MAP_I_TO_R, GL_PIXEL_MAP_I_TO_G, GL_PIXEL_MAP_I_TO_B, GL_PIXEL_MAP_I_TO_A, GL_PIXEL_MAP_R_TO_R, GL_PIXEL_MAP_G_TO_G, GL_PIXEL_MAP_B_TO_B, and GL_PIXEL_MAP_A_TO_A.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Returns the pixel map contents.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetPixelMapfv")]
        public static extern void GetPixelMap(OpenTK.Graphics.OpenGL.PixelMap map, [OutAttribute] out Single values);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return the specified pixel map
        /// </summary>
        /// <param name="map">
        /// <para>
        /// Specifies the name of the pixel map to return. Accepted values are GL_PIXEL_MAP_I_TO_I, GL_PIXEL_MAP_S_TO_S, GL_PIXEL_MAP_I_TO_R, GL_PIXEL_MAP_I_TO_G, GL_PIXEL_MAP_I_TO_B, GL_PIXEL_MAP_I_TO_A, GL_PIXEL_MAP_R_TO_R, GL_PIXEL_MAP_G_TO_G, GL_PIXEL_MAP_B_TO_B, and GL_PIXEL_MAP_A_TO_A.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Returns the pixel map contents.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetPixelMapfv")]
        public static extern unsafe void GetPixelMap(OpenTK.Graphics.OpenGL.PixelMap map, [OutAttribute] Single* values);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return the specified pixel map
        /// </summary>
        /// <param name="map">
        /// <para>
        /// Specifies the name of the pixel map to return. Accepted values are GL_PIXEL_MAP_I_TO_I, GL_PIXEL_MAP_S_TO_S, GL_PIXEL_MAP_I_TO_R, GL_PIXEL_MAP_I_TO_G, GL_PIXEL_MAP_I_TO_B, GL_PIXEL_MAP_I_TO_A, GL_PIXEL_MAP_R_TO_R, GL_PIXEL_MAP_G_TO_G, GL_PIXEL_MAP_B_TO_B, and GL_PIXEL_MAP_A_TO_A.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Returns the pixel map contents.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetPixelMapuiv")]
        public static extern void GetPixelMap(OpenTK.Graphics.OpenGL.PixelMap map, [OutAttribute] Int32[] values);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return the specified pixel map
        /// </summary>
        /// <param name="map">
        /// <para>
        /// Specifies the name of the pixel map to return. Accepted values are GL_PIXEL_MAP_I_TO_I, GL_PIXEL_MAP_S_TO_S, GL_PIXEL_MAP_I_TO_R, GL_PIXEL_MAP_I_TO_G, GL_PIXEL_MAP_I_TO_B, GL_PIXEL_MAP_I_TO_A, GL_PIXEL_MAP_R_TO_R, GL_PIXEL_MAP_G_TO_G, GL_PIXEL_MAP_B_TO_B, and GL_PIXEL_MAP_A_TO_A.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Returns the pixel map contents.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetPixelMapuiv")]
        public static extern void GetPixelMap(OpenTK.Graphics.OpenGL.PixelMap map, [OutAttribute] out Int32 values);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return the specified pixel map
        /// </summary>
        /// <param name="map">
        /// <para>
        /// Specifies the name of the pixel map to return. Accepted values are GL_PIXEL_MAP_I_TO_I, GL_PIXEL_MAP_S_TO_S, GL_PIXEL_MAP_I_TO_R, GL_PIXEL_MAP_I_TO_G, GL_PIXEL_MAP_I_TO_B, GL_PIXEL_MAP_I_TO_A, GL_PIXEL_MAP_R_TO_R, GL_PIXEL_MAP_G_TO_G, GL_PIXEL_MAP_B_TO_B, and GL_PIXEL_MAP_A_TO_A.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Returns the pixel map contents.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetPixelMapuiv")]
        public static extern unsafe void GetPixelMap(OpenTK.Graphics.OpenGL.PixelMap map, [OutAttribute] Int32* values);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return the specified pixel map
        /// </summary>
        /// <param name="map">
        /// <para>
        /// Specifies the name of the pixel map to return. Accepted values are GL_PIXEL_MAP_I_TO_I, GL_PIXEL_MAP_S_TO_S, GL_PIXEL_MAP_I_TO_R, GL_PIXEL_MAP_I_TO_G, GL_PIXEL_MAP_I_TO_B, GL_PIXEL_MAP_I_TO_A, GL_PIXEL_MAP_R_TO_R, GL_PIXEL_MAP_G_TO_G, GL_PIXEL_MAP_B_TO_B, and GL_PIXEL_MAP_A_TO_A.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Returns the pixel map contents.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetPixelMapuiv")]
        public static extern void GetPixelMap(OpenTK.Graphics.OpenGL.PixelMap map, [OutAttribute] UInt32[] values);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return the specified pixel map
        /// </summary>
        /// <param name="map">
        /// <para>
        /// Specifies the name of the pixel map to return. Accepted values are GL_PIXEL_MAP_I_TO_I, GL_PIXEL_MAP_S_TO_S, GL_PIXEL_MAP_I_TO_R, GL_PIXEL_MAP_I_TO_G, GL_PIXEL_MAP_I_TO_B, GL_PIXEL_MAP_I_TO_A, GL_PIXEL_MAP_R_TO_R, GL_PIXEL_MAP_G_TO_G, GL_PIXEL_MAP_B_TO_B, and GL_PIXEL_MAP_A_TO_A.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Returns the pixel map contents.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetPixelMapuiv")]
        public static extern void GetPixelMap(OpenTK.Graphics.OpenGL.PixelMap map, [OutAttribute] out UInt32 values);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return the specified pixel map
        /// </summary>
        /// <param name="map">
        /// <para>
        /// Specifies the name of the pixel map to return. Accepted values are GL_PIXEL_MAP_I_TO_I, GL_PIXEL_MAP_S_TO_S, GL_PIXEL_MAP_I_TO_R, GL_PIXEL_MAP_I_TO_G, GL_PIXEL_MAP_I_TO_B, GL_PIXEL_MAP_I_TO_A, GL_PIXEL_MAP_R_TO_R, GL_PIXEL_MAP_G_TO_G, GL_PIXEL_MAP_B_TO_B, and GL_PIXEL_MAP_A_TO_A.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Returns the pixel map contents.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetPixelMapuiv")]
        public static extern unsafe void GetPixelMap(OpenTK.Graphics.OpenGL.PixelMap map, [OutAttribute] UInt32* values);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return the specified pixel map
        /// </summary>
        /// <param name="map">
        /// <para>
        /// Specifies the name of the pixel map to return. Accepted values are GL_PIXEL_MAP_I_TO_I, GL_PIXEL_MAP_S_TO_S, GL_PIXEL_MAP_I_TO_R, GL_PIXEL_MAP_I_TO_G, GL_PIXEL_MAP_I_TO_B, GL_PIXEL_MAP_I_TO_A, GL_PIXEL_MAP_R_TO_R, GL_PIXEL_MAP_G_TO_G, GL_PIXEL_MAP_B_TO_B, and GL_PIXEL_MAP_A_TO_A.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Returns the pixel map contents.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetPixelMapusv")]
        public static extern void GetPixelMap(OpenTK.Graphics.OpenGL.PixelMap map, [OutAttribute] Int16[] values);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return the specified pixel map
        /// </summary>
        /// <param name="map">
        /// <para>
        /// Specifies the name of the pixel map to return. Accepted values are GL_PIXEL_MAP_I_TO_I, GL_PIXEL_MAP_S_TO_S, GL_PIXEL_MAP_I_TO_R, GL_PIXEL_MAP_I_TO_G, GL_PIXEL_MAP_I_TO_B, GL_PIXEL_MAP_I_TO_A, GL_PIXEL_MAP_R_TO_R, GL_PIXEL_MAP_G_TO_G, GL_PIXEL_MAP_B_TO_B, and GL_PIXEL_MAP_A_TO_A.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Returns the pixel map contents.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetPixelMapusv")]
        public static extern void GetPixelMap(OpenTK.Graphics.OpenGL.PixelMap map, [OutAttribute] out Int16 values);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return the specified pixel map
        /// </summary>
        /// <param name="map">
        /// <para>
        /// Specifies the name of the pixel map to return. Accepted values are GL_PIXEL_MAP_I_TO_I, GL_PIXEL_MAP_S_TO_S, GL_PIXEL_MAP_I_TO_R, GL_PIXEL_MAP_I_TO_G, GL_PIXEL_MAP_I_TO_B, GL_PIXEL_MAP_I_TO_A, GL_PIXEL_MAP_R_TO_R, GL_PIXEL_MAP_G_TO_G, GL_PIXEL_MAP_B_TO_B, and GL_PIXEL_MAP_A_TO_A.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Returns the pixel map contents.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetPixelMapusv")]
        public static extern unsafe void GetPixelMap(OpenTK.Graphics.OpenGL.PixelMap map, [OutAttribute] Int16* values);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return the specified pixel map
        /// </summary>
        /// <param name="map">
        /// <para>
        /// Specifies the name of the pixel map to return. Accepted values are GL_PIXEL_MAP_I_TO_I, GL_PIXEL_MAP_S_TO_S, GL_PIXEL_MAP_I_TO_R, GL_PIXEL_MAP_I_TO_G, GL_PIXEL_MAP_I_TO_B, GL_PIXEL_MAP_I_TO_A, GL_PIXEL_MAP_R_TO_R, GL_PIXEL_MAP_G_TO_G, GL_PIXEL_MAP_B_TO_B, and GL_PIXEL_MAP_A_TO_A.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Returns the pixel map contents.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetPixelMapusv")]
        public static extern void GetPixelMap(OpenTK.Graphics.OpenGL.PixelMap map, [OutAttribute] UInt16[] values);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return the specified pixel map
        /// </summary>
        /// <param name="map">
        /// <para>
        /// Specifies the name of the pixel map to return. Accepted values are GL_PIXEL_MAP_I_TO_I, GL_PIXEL_MAP_S_TO_S, GL_PIXEL_MAP_I_TO_R, GL_PIXEL_MAP_I_TO_G, GL_PIXEL_MAP_I_TO_B, GL_PIXEL_MAP_I_TO_A, GL_PIXEL_MAP_R_TO_R, GL_PIXEL_MAP_G_TO_G, GL_PIXEL_MAP_B_TO_B, and GL_PIXEL_MAP_A_TO_A.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Returns the pixel map contents.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetPixelMapusv")]
        public static extern void GetPixelMap(OpenTK.Graphics.OpenGL.PixelMap map, [OutAttribute] out UInt16 values);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return the specified pixel map
        /// </summary>
        /// <param name="map">
        /// <para>
        /// Specifies the name of the pixel map to return. Accepted values are GL_PIXEL_MAP_I_TO_I, GL_PIXEL_MAP_S_TO_S, GL_PIXEL_MAP_I_TO_R, GL_PIXEL_MAP_I_TO_G, GL_PIXEL_MAP_I_TO_B, GL_PIXEL_MAP_I_TO_A, GL_PIXEL_MAP_R_TO_R, GL_PIXEL_MAP_G_TO_G, GL_PIXEL_MAP_B_TO_B, and GL_PIXEL_MAP_A_TO_A.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Returns the pixel map contents.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetPixelMapusv")]
        public static extern unsafe void GetPixelMap(OpenTK.Graphics.OpenGL.PixelMap map, [OutAttribute] UInt16* values);

        /// <summary></summary>
        [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetPixelMapxv")]
        public static extern void GetPixelMapx(OpenTK.Graphics.OpenGL.OesFixedPoint map, Int32 size, [OutAttribute] int[] values);

        /// <summary></summary>
        [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetPixelMapxv")]
        public static extern void GetPixelMapx(OpenTK.Graphics.OpenGL.OesFixedPoint map, Int32 size, [OutAttribute] out int values);

        /// <summary></summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetPixelMapxv")]
        public static extern unsafe void GetPixelMapx(OpenTK.Graphics.OpenGL.OesFixedPoint map, Int32 size, [OutAttribute] int* values);

        /// <summary>[requires: v1.1 and KHR_debug|VERSION_1_1|VERSION_4_3|VERSION_4_3]
        /// Return the address of the specified pointer
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies the array or buffer pointer to be returned. Symbolic constants GL_COLOR_ARRAY_POINTER, GL_EDGE_FLAG_ARRAY_POINTER, GL_FOG_COORD_ARRAY_POINTER, GL_FEEDBACK_BUFFER_POINTER, GL_INDEX_ARRAY_POINTER, GL_NORMAL_ARRAY_POINTER, GL_SECONDARY_COLOR_ARRAY_POINTER, GL_SELECTION_BUFFER_POINTER, GL_TEXTURE_COORD_ARRAY_POINTER, or GL_VERTEX_ARRAY_POINTER are accepted.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the pointer value specified by pname.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "KHR_debug|VERSION_1_1|VERSION_4_3|VERSION_4_3", Version = "1.1", EntryPoint = "glGetPointerv")]
        public static extern void GetPointer(OpenTK.Graphics.OpenGL.GetPointervPName pname, [OutAttribute] IntPtr @params);

        /// <summary>[requires: v1.1 and KHR_debug|VERSION_1_1|VERSION_4_3|VERSION_4_3]
        /// Return the address of the specified pointer
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies the array or buffer pointer to be returned. Symbolic constants GL_COLOR_ARRAY_POINTER, GL_EDGE_FLAG_ARRAY_POINTER, GL_FOG_COORD_ARRAY_POINTER, GL_FEEDBACK_BUFFER_POINTER, GL_INDEX_ARRAY_POINTER, GL_NORMAL_ARRAY_POINTER, GL_SECONDARY_COLOR_ARRAY_POINTER, GL_SELECTION_BUFFER_POINTER, GL_TEXTURE_COORD_ARRAY_POINTER, or GL_VERTEX_ARRAY_POINTER are accepted.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the pointer value specified by pname.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "KHR_debug|VERSION_1_1|VERSION_4_3|VERSION_4_3", Version = "1.1", EntryPoint = "glGetPointerv")]
        public static extern void GetPointer<T1>(OpenTK.Graphics.OpenGL.GetPointervPName pname, [InAttribute, OutAttribute] T1[] @params)
            where T1 : struct
        ;

        /// <summary>[requires: v1.1 and KHR_debug|VERSION_1_1|VERSION_4_3|VERSION_4_3]
        /// Return the address of the specified pointer
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies the array or buffer pointer to be returned. Symbolic constants GL_COLOR_ARRAY_POINTER, GL_EDGE_FLAG_ARRAY_POINTER, GL_FOG_COORD_ARRAY_POINTER, GL_FEEDBACK_BUFFER_POINTER, GL_INDEX_ARRAY_POINTER, GL_NORMAL_ARRAY_POINTER, GL_SECONDARY_COLOR_ARRAY_POINTER, GL_SELECTION_BUFFER_POINTER, GL_TEXTURE_COORD_ARRAY_POINTER, or GL_VERTEX_ARRAY_POINTER are accepted.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the pointer value specified by pname.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "KHR_debug|VERSION_1_1|VERSION_4_3|VERSION_4_3", Version = "1.1", EntryPoint = "glGetPointerv")]
        public static extern void GetPointer<T1>(OpenTK.Graphics.OpenGL.GetPointervPName pname, [InAttribute, OutAttribute] T1[,] @params)
            where T1 : struct
        ;

        /// <summary>[requires: v1.1 and KHR_debug|VERSION_1_1|VERSION_4_3|VERSION_4_3]
        /// Return the address of the specified pointer
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies the array or buffer pointer to be returned. Symbolic constants GL_COLOR_ARRAY_POINTER, GL_EDGE_FLAG_ARRAY_POINTER, GL_FOG_COORD_ARRAY_POINTER, GL_FEEDBACK_BUFFER_POINTER, GL_INDEX_ARRAY_POINTER, GL_NORMAL_ARRAY_POINTER, GL_SECONDARY_COLOR_ARRAY_POINTER, GL_SELECTION_BUFFER_POINTER, GL_TEXTURE_COORD_ARRAY_POINTER, or GL_VERTEX_ARRAY_POINTER are accepted.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the pointer value specified by pname.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "KHR_debug|VERSION_1_1|VERSION_4_3|VERSION_4_3", Version = "1.1", EntryPoint = "glGetPointerv")]
        public static extern void GetPointer<T1>(OpenTK.Graphics.OpenGL.GetPointervPName pname, [InAttribute, OutAttribute] T1[,,] @params)
            where T1 : struct
        ;

        /// <summary>[requires: v1.1 and KHR_debug|VERSION_1_1|VERSION_4_3|VERSION_4_3]
        /// Return the address of the specified pointer
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies the array or buffer pointer to be returned. Symbolic constants GL_COLOR_ARRAY_POINTER, GL_EDGE_FLAG_ARRAY_POINTER, GL_FOG_COORD_ARRAY_POINTER, GL_FEEDBACK_BUFFER_POINTER, GL_INDEX_ARRAY_POINTER, GL_NORMAL_ARRAY_POINTER, GL_SECONDARY_COLOR_ARRAY_POINTER, GL_SELECTION_BUFFER_POINTER, GL_TEXTURE_COORD_ARRAY_POINTER, or GL_VERTEX_ARRAY_POINTER are accepted.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the pointer value specified by pname.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "KHR_debug|VERSION_1_1|VERSION_4_3|VERSION_4_3", Version = "1.1", EntryPoint = "glGetPointerv")]
        public static extern void GetPointer<T1>(OpenTK.Graphics.OpenGL.GetPointervPName pname, [InAttribute, OutAttribute] ref T1 @params)
            where T1 : struct
        ;

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return the polygon stipple pattern
        /// </summary>
        /// <param name="pattern">
        /// <para>
        /// Returns the stipple pattern. The initial value is all 1's.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetPolygonStipple")]
        public static extern Byte GetPolygonStipple();

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return the polygon stipple pattern
        /// </summary>
        /// <param name="pattern">
        /// <para>
        /// Returns the stipple pattern. The initial value is all 1's.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetPolygonStipple")]
        public static extern void GetPolygonStipple([OutAttribute] Byte[] mask);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return the polygon stipple pattern
        /// </summary>
        /// <param name="pattern">
        /// <para>
        /// Returns the stipple pattern. The initial value is all 1's.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetPolygonStipple")]
        public static extern void GetPolygonStipple([OutAttribute] out Byte mask);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return the polygon stipple pattern
        /// </summary>
        /// <param name="pattern">
        /// <para>
        /// Returns the stipple pattern. The initial value is all 1's.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetPolygonStipple")]
        public static extern unsafe void GetPolygonStipple([OutAttribute] Byte* mask);

        /// <summary>[requires: v4.1 and ARB_get_program_binary|VERSION_4_1]
        /// Return a binary representation of a program object's compiled and linked executable source
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program object whose binary representation to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the buffer whose address is given by binary.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable to receive the number of bytes written into binary.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the address of a variable to receive a token indicating the format of the binary data returned by the GL.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address an array into which the GL will return program's binary representation.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_get_program_binary|VERSION_4_1", Version = "4.1", EntryPoint = "glGetProgramBinary")]
        public static extern void GetProgramBinary(Int32 program, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] out OpenTK.Graphics.OpenGL.BinaryFormat binaryFormat, [OutAttribute] IntPtr binary);

        /// <summary>[requires: v4.1 and ARB_get_program_binary|VERSION_4_1]
        /// Return a binary representation of a program object's compiled and linked executable source
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program object whose binary representation to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the buffer whose address is given by binary.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable to receive the number of bytes written into binary.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the address of a variable to receive a token indicating the format of the binary data returned by the GL.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address an array into which the GL will return program's binary representation.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_get_program_binary|VERSION_4_1", Version = "4.1", EntryPoint = "glGetProgramBinary")]
        public static extern void GetProgramBinary<T4>(Int32 program, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] out OpenTK.Graphics.OpenGL.BinaryFormat binaryFormat, [InAttribute, OutAttribute] T4[] binary)
            where T4 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_get_program_binary|VERSION_4_1]
        /// Return a binary representation of a program object's compiled and linked executable source
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program object whose binary representation to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the buffer whose address is given by binary.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable to receive the number of bytes written into binary.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the address of a variable to receive a token indicating the format of the binary data returned by the GL.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address an array into which the GL will return program's binary representation.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_get_program_binary|VERSION_4_1", Version = "4.1", EntryPoint = "glGetProgramBinary")]
        public static extern void GetProgramBinary<T4>(Int32 program, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] out OpenTK.Graphics.OpenGL.BinaryFormat binaryFormat, [InAttribute, OutAttribute] T4[,] binary)
            where T4 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_get_program_binary|VERSION_4_1]
        /// Return a binary representation of a program object's compiled and linked executable source
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program object whose binary representation to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the buffer whose address is given by binary.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable to receive the number of bytes written into binary.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the address of a variable to receive a token indicating the format of the binary data returned by the GL.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address an array into which the GL will return program's binary representation.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_get_program_binary|VERSION_4_1", Version = "4.1", EntryPoint = "glGetProgramBinary")]
        public static extern void GetProgramBinary<T4>(Int32 program, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] out OpenTK.Graphics.OpenGL.BinaryFormat binaryFormat, [InAttribute, OutAttribute] T4[,,] binary)
            where T4 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_get_program_binary|VERSION_4_1]
        /// Return a binary representation of a program object's compiled and linked executable source
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program object whose binary representation to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the buffer whose address is given by binary.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable to receive the number of bytes written into binary.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the address of a variable to receive a token indicating the format of the binary data returned by the GL.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address an array into which the GL will return program's binary representation.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_get_program_binary|VERSION_4_1", Version = "4.1", EntryPoint = "glGetProgramBinary")]
        public static extern void GetProgramBinary<T4>(Int32 program, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] out OpenTK.Graphics.OpenGL.BinaryFormat binaryFormat, [InAttribute, OutAttribute] ref T4 binary)
            where T4 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_get_program_binary|VERSION_4_1]
        /// Return a binary representation of a program object's compiled and linked executable source
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program object whose binary representation to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the buffer whose address is given by binary.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable to receive the number of bytes written into binary.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the address of a variable to receive a token indicating the format of the binary data returned by the GL.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address an array into which the GL will return program's binary representation.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_get_program_binary|VERSION_4_1", Version = "4.1", EntryPoint = "glGetProgramBinary")]
        public static extern unsafe void GetProgramBinary(Int32 program, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] OpenTK.Graphics.OpenGL.BinaryFormat* binaryFormat, [OutAttribute] IntPtr binary);

        /// <summary>[requires: v4.1 and ARB_get_program_binary|VERSION_4_1]
        /// Return a binary representation of a program object's compiled and linked executable source
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program object whose binary representation to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the buffer whose address is given by binary.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable to receive the number of bytes written into binary.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the address of a variable to receive a token indicating the format of the binary data returned by the GL.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address an array into which the GL will return program's binary representation.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_get_program_binary|VERSION_4_1", Version = "4.1", EntryPoint = "glGetProgramBinary")]
        public static extern unsafe void GetProgramBinary<T4>(Int32 program, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] OpenTK.Graphics.OpenGL.BinaryFormat* binaryFormat, [InAttribute, OutAttribute] T4[] binary)
            where T4 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_get_program_binary|VERSION_4_1]
        /// Return a binary representation of a program object's compiled and linked executable source
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program object whose binary representation to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the buffer whose address is given by binary.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable to receive the number of bytes written into binary.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the address of a variable to receive a token indicating the format of the binary data returned by the GL.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address an array into which the GL will return program's binary representation.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_get_program_binary|VERSION_4_1", Version = "4.1", EntryPoint = "glGetProgramBinary")]
        public static extern unsafe void GetProgramBinary<T4>(Int32 program, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] OpenTK.Graphics.OpenGL.BinaryFormat* binaryFormat, [InAttribute, OutAttribute] T4[,] binary)
            where T4 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_get_program_binary|VERSION_4_1]
        /// Return a binary representation of a program object's compiled and linked executable source
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program object whose binary representation to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the buffer whose address is given by binary.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable to receive the number of bytes written into binary.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the address of a variable to receive a token indicating the format of the binary data returned by the GL.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address an array into which the GL will return program's binary representation.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_get_program_binary|VERSION_4_1", Version = "4.1", EntryPoint = "glGetProgramBinary")]
        public static extern unsafe void GetProgramBinary<T4>(Int32 program, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] OpenTK.Graphics.OpenGL.BinaryFormat* binaryFormat, [InAttribute, OutAttribute] T4[,,] binary)
            where T4 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_get_program_binary|VERSION_4_1]
        /// Return a binary representation of a program object's compiled and linked executable source
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program object whose binary representation to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the buffer whose address is given by binary.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable to receive the number of bytes written into binary.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the address of a variable to receive a token indicating the format of the binary data returned by the GL.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address an array into which the GL will return program's binary representation.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_get_program_binary|VERSION_4_1", Version = "4.1", EntryPoint = "glGetProgramBinary")]
        public static extern unsafe void GetProgramBinary<T4>(Int32 program, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] OpenTK.Graphics.OpenGL.BinaryFormat* binaryFormat, [InAttribute, OutAttribute] ref T4 binary)
            where T4 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_get_program_binary|VERSION_4_1]
        /// Return a binary representation of a program object's compiled and linked executable source
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program object whose binary representation to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the buffer whose address is given by binary.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable to receive the number of bytes written into binary.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the address of a variable to receive a token indicating the format of the binary data returned by the GL.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address an array into which the GL will return program's binary representation.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_get_program_binary|VERSION_4_1", Version = "4.1", EntryPoint = "glGetProgramBinary")]
        public static extern void GetProgramBinary(UInt32 program, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] out OpenTK.Graphics.OpenGL.BinaryFormat binaryFormat, [OutAttribute] IntPtr binary);

        /// <summary>[requires: v4.1 and ARB_get_program_binary|VERSION_4_1]
        /// Return a binary representation of a program object's compiled and linked executable source
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program object whose binary representation to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the buffer whose address is given by binary.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable to receive the number of bytes written into binary.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the address of a variable to receive a token indicating the format of the binary data returned by the GL.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address an array into which the GL will return program's binary representation.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_get_program_binary|VERSION_4_1", Version = "4.1", EntryPoint = "glGetProgramBinary")]
        public static extern void GetProgramBinary<T4>(UInt32 program, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] out OpenTK.Graphics.OpenGL.BinaryFormat binaryFormat, [InAttribute, OutAttribute] T4[] binary)
            where T4 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_get_program_binary|VERSION_4_1]
        /// Return a binary representation of a program object's compiled and linked executable source
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program object whose binary representation to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the buffer whose address is given by binary.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable to receive the number of bytes written into binary.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the address of a variable to receive a token indicating the format of the binary data returned by the GL.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address an array into which the GL will return program's binary representation.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_get_program_binary|VERSION_4_1", Version = "4.1", EntryPoint = "glGetProgramBinary")]
        public static extern void GetProgramBinary<T4>(UInt32 program, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] out OpenTK.Graphics.OpenGL.BinaryFormat binaryFormat, [InAttribute, OutAttribute] T4[,] binary)
            where T4 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_get_program_binary|VERSION_4_1]
        /// Return a binary representation of a program object's compiled and linked executable source
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program object whose binary representation to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the buffer whose address is given by binary.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable to receive the number of bytes written into binary.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the address of a variable to receive a token indicating the format of the binary data returned by the GL.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address an array into which the GL will return program's binary representation.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_get_program_binary|VERSION_4_1", Version = "4.1", EntryPoint = "glGetProgramBinary")]
        public static extern void GetProgramBinary<T4>(UInt32 program, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] out OpenTK.Graphics.OpenGL.BinaryFormat binaryFormat, [InAttribute, OutAttribute] T4[,,] binary)
            where T4 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_get_program_binary|VERSION_4_1]
        /// Return a binary representation of a program object's compiled and linked executable source
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program object whose binary representation to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the buffer whose address is given by binary.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable to receive the number of bytes written into binary.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the address of a variable to receive a token indicating the format of the binary data returned by the GL.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address an array into which the GL will return program's binary representation.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_get_program_binary|VERSION_4_1", Version = "4.1", EntryPoint = "glGetProgramBinary")]
        public static extern void GetProgramBinary<T4>(UInt32 program, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] out OpenTK.Graphics.OpenGL.BinaryFormat binaryFormat, [InAttribute, OutAttribute] ref T4 binary)
            where T4 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_get_program_binary|VERSION_4_1]
        /// Return a binary representation of a program object's compiled and linked executable source
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program object whose binary representation to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the buffer whose address is given by binary.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable to receive the number of bytes written into binary.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the address of a variable to receive a token indicating the format of the binary data returned by the GL.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address an array into which the GL will return program's binary representation.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_get_program_binary|VERSION_4_1", Version = "4.1", EntryPoint = "glGetProgramBinary")]
        public static extern unsafe void GetProgramBinary(UInt32 program, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] OpenTK.Graphics.OpenGL.BinaryFormat* binaryFormat, [OutAttribute] IntPtr binary);

        /// <summary>[requires: v4.1 and ARB_get_program_binary|VERSION_4_1]
        /// Return a binary representation of a program object's compiled and linked executable source
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program object whose binary representation to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the buffer whose address is given by binary.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable to receive the number of bytes written into binary.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the address of a variable to receive a token indicating the format of the binary data returned by the GL.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address an array into which the GL will return program's binary representation.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_get_program_binary|VERSION_4_1", Version = "4.1", EntryPoint = "glGetProgramBinary")]
        public static extern unsafe void GetProgramBinary<T4>(UInt32 program, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] OpenTK.Graphics.OpenGL.BinaryFormat* binaryFormat, [InAttribute, OutAttribute] T4[] binary)
            where T4 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_get_program_binary|VERSION_4_1]
        /// Return a binary representation of a program object's compiled and linked executable source
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program object whose binary representation to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the buffer whose address is given by binary.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable to receive the number of bytes written into binary.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the address of a variable to receive a token indicating the format of the binary data returned by the GL.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address an array into which the GL will return program's binary representation.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_get_program_binary|VERSION_4_1", Version = "4.1", EntryPoint = "glGetProgramBinary")]
        public static extern unsafe void GetProgramBinary<T4>(UInt32 program, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] OpenTK.Graphics.OpenGL.BinaryFormat* binaryFormat, [InAttribute, OutAttribute] T4[,] binary)
            where T4 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_get_program_binary|VERSION_4_1]
        /// Return a binary representation of a program object's compiled and linked executable source
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program object whose binary representation to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the buffer whose address is given by binary.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable to receive the number of bytes written into binary.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the address of a variable to receive a token indicating the format of the binary data returned by the GL.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address an array into which the GL will return program's binary representation.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_get_program_binary|VERSION_4_1", Version = "4.1", EntryPoint = "glGetProgramBinary")]
        public static extern unsafe void GetProgramBinary<T4>(UInt32 program, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] OpenTK.Graphics.OpenGL.BinaryFormat* binaryFormat, [InAttribute, OutAttribute] T4[,,] binary)
            where T4 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_get_program_binary|VERSION_4_1]
        /// Return a binary representation of a program object's compiled and linked executable source
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program object whose binary representation to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the buffer whose address is given by binary.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable to receive the number of bytes written into binary.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the address of a variable to receive a token indicating the format of the binary data returned by the GL.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address an array into which the GL will return program's binary representation.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_get_program_binary|VERSION_4_1", Version = "4.1", EntryPoint = "glGetProgramBinary")]
        public static extern unsafe void GetProgramBinary<T4>(UInt32 program, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] OpenTK.Graphics.OpenGL.BinaryFormat* binaryFormat, [InAttribute, OutAttribute] ref T4 binary)
            where T4 : struct
        ;

        /// <summary>[requires: v2.0]
        /// Returns the information log for a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object whose information log is to be queried.
        /// </para>
        /// </param>
        /// <param name="maxLength">
        /// <para>
        /// Specifies the size of the character buffer for storing the returned information log.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Returns the length of the string returned in infoLog (excluding the null terminator).
        /// </para>
        /// </param>
        /// <param name="infoLog">
        /// <para>
        /// Specifies an array of characters that is used to return the information log.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetProgramInfoLog")]
        public static extern void GetProgramInfoLog(Int32 program, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder infoLog);

        /// <summary>[requires: v2.0]
        /// Returns the information log for a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object whose information log is to be queried.
        /// </para>
        /// </param>
        /// <param name="maxLength">
        /// <para>
        /// Specifies the size of the character buffer for storing the returned information log.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Returns the length of the string returned in infoLog (excluding the null terminator).
        /// </para>
        /// </param>
        /// <param name="infoLog">
        /// <para>
        /// Specifies an array of characters that is used to return the information log.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetProgramInfoLog")]
        public static extern unsafe void GetProgramInfoLog(Int32 program, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder infoLog);

        /// <summary>[requires: v2.0]
        /// Returns the information log for a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object whose information log is to be queried.
        /// </para>
        /// </param>
        /// <param name="maxLength">
        /// <para>
        /// Specifies the size of the character buffer for storing the returned information log.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Returns the length of the string returned in infoLog (excluding the null terminator).
        /// </para>
        /// </param>
        /// <param name="infoLog">
        /// <para>
        /// Specifies an array of characters that is used to return the information log.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetProgramInfoLog")]
        public static extern void GetProgramInfoLog(UInt32 program, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder infoLog);

        /// <summary>[requires: v2.0]
        /// Returns the information log for a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object whose information log is to be queried.
        /// </para>
        /// </param>
        /// <param name="maxLength">
        /// <para>
        /// Specifies the size of the character buffer for storing the returned information log.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Returns the length of the string returned in infoLog (excluding the null terminator).
        /// </para>
        /// </param>
        /// <param name="infoLog">
        /// <para>
        /// Specifies an array of characters that is used to return the information log.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetProgramInfoLog")]
        public static extern unsafe void GetProgramInfoLog(UInt32 program, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder infoLog);

        /// <summary>[requires: v4.3 and ARB_program_interface_query|VERSION_4_3]
        /// Query a property of an interface in a program
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of a program object whose interface to query.
        /// </para>
        /// </param>
        /// <param name="programInterface">
        /// <para>
        /// A token identifying the interface within program to query.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The name of the parameter within programInterface to query.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// The address of a variable to retrieve the value of pname for the program interface.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_program_interface_query|VERSION_4_3", Version = "4.3", EntryPoint = "glGetProgramInterfaceiv")]
        public static extern void GetProgramInterface(Int32 program, OpenTK.Graphics.OpenGL.ProgramInterface programInterface, OpenTK.Graphics.OpenGL.ProgramInterfaceParameter pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v4.3 and ARB_program_interface_query|VERSION_4_3]
        /// Query a property of an interface in a program
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of a program object whose interface to query.
        /// </para>
        /// </param>
        /// <param name="programInterface">
        /// <para>
        /// A token identifying the interface within program to query.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The name of the parameter within programInterface to query.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// The address of a variable to retrieve the value of pname for the program interface.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_program_interface_query|VERSION_4_3", Version = "4.3", EntryPoint = "glGetProgramInterfaceiv")]
        public static extern void GetProgramInterface(Int32 program, OpenTK.Graphics.OpenGL.ProgramInterface programInterface, OpenTK.Graphics.OpenGL.ProgramInterfaceParameter pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v4.3 and ARB_program_interface_query|VERSION_4_3]
        /// Query a property of an interface in a program
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of a program object whose interface to query.
        /// </para>
        /// </param>
        /// <param name="programInterface">
        /// <para>
        /// A token identifying the interface within program to query.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The name of the parameter within programInterface to query.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// The address of a variable to retrieve the value of pname for the program interface.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_program_interface_query|VERSION_4_3", Version = "4.3", EntryPoint = "glGetProgramInterfaceiv")]
        public static extern unsafe void GetProgramInterface(Int32 program, OpenTK.Graphics.OpenGL.ProgramInterface programInterface, OpenTK.Graphics.OpenGL.ProgramInterfaceParameter pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v4.3 and ARB_program_interface_query|VERSION_4_3]
        /// Query a property of an interface in a program
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of a program object whose interface to query.
        /// </para>
        /// </param>
        /// <param name="programInterface">
        /// <para>
        /// A token identifying the interface within program to query.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The name of the parameter within programInterface to query.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// The address of a variable to retrieve the value of pname for the program interface.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_program_interface_query|VERSION_4_3", Version = "4.3", EntryPoint = "glGetProgramInterfaceiv")]
        public static extern void GetProgramInterface(UInt32 program, OpenTK.Graphics.OpenGL.ProgramInterface programInterface, OpenTK.Graphics.OpenGL.ProgramInterfaceParameter pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v4.3 and ARB_program_interface_query|VERSION_4_3]
        /// Query a property of an interface in a program
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of a program object whose interface to query.
        /// </para>
        /// </param>
        /// <param name="programInterface">
        /// <para>
        /// A token identifying the interface within program to query.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The name of the parameter within programInterface to query.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// The address of a variable to retrieve the value of pname for the program interface.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_program_interface_query|VERSION_4_3", Version = "4.3", EntryPoint = "glGetProgramInterfaceiv")]
        public static extern void GetProgramInterface(UInt32 program, OpenTK.Graphics.OpenGL.ProgramInterface programInterface, OpenTK.Graphics.OpenGL.ProgramInterfaceParameter pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v4.3 and ARB_program_interface_query|VERSION_4_3]
        /// Query a property of an interface in a program
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of a program object whose interface to query.
        /// </para>
        /// </param>
        /// <param name="programInterface">
        /// <para>
        /// A token identifying the interface within program to query.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// The name of the parameter within programInterface to query.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// The address of a variable to retrieve the value of pname for the program interface.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_program_interface_query|VERSION_4_3", Version = "4.3", EntryPoint = "glGetProgramInterfaceiv")]
        public static extern unsafe void GetProgramInterface(UInt32 program, OpenTK.Graphics.OpenGL.ProgramInterface programInterface, OpenTK.Graphics.OpenGL.ProgramInterfaceParameter pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v2.0]
        /// Returns a parameter from a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the object parameter. Accepted symbolic names are GL_DELETE_STATUS, GL_LINK_STATUS, GL_VALIDATE_STATUS, GL_INFO_LOG_LENGTH, GL_ATTACHED_SHADERS, GL_ACTIVE_ATOMIC_COUNTER_BUFFERS, GL_ACTIVE_ATTRIBUTES, GL_ACTIVE_ATTRIBUTE_MAX_LENGTH, GL_ACTIVE_UNIFORMS, GL_ACTIVE_UNIFORM_BLOCKS, GL_ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH, GL_ACTIVE_UNIFORM_MAX_LENGTH, GL_COMPUTE_WORK_GROUP_SIZE GL_PROGRAM_BINARY_LENGTH, GL_TRANSFORM_FEEDBACK_BUFFER_MODE, GL_TRANSFORM_FEEDBACK_VARYINGS, GL_TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH, GL_GEOMETRY_VERTICES_OUT, GL_GEOMETRY_INPUT_TYPE, and GL_GEOMETRY_OUTPUT_TYPE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested object parameter.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetProgramiv")]
        public static extern void GetProgram(Int32 program, OpenTK.Graphics.OpenGL.GetProgramParameterName pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v2.0]
        /// Returns a parameter from a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the object parameter. Accepted symbolic names are GL_DELETE_STATUS, GL_LINK_STATUS, GL_VALIDATE_STATUS, GL_INFO_LOG_LENGTH, GL_ATTACHED_SHADERS, GL_ACTIVE_ATOMIC_COUNTER_BUFFERS, GL_ACTIVE_ATTRIBUTES, GL_ACTIVE_ATTRIBUTE_MAX_LENGTH, GL_ACTIVE_UNIFORMS, GL_ACTIVE_UNIFORM_BLOCKS, GL_ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH, GL_ACTIVE_UNIFORM_MAX_LENGTH, GL_COMPUTE_WORK_GROUP_SIZE GL_PROGRAM_BINARY_LENGTH, GL_TRANSFORM_FEEDBACK_BUFFER_MODE, GL_TRANSFORM_FEEDBACK_VARYINGS, GL_TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH, GL_GEOMETRY_VERTICES_OUT, GL_GEOMETRY_INPUT_TYPE, and GL_GEOMETRY_OUTPUT_TYPE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested object parameter.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetProgramiv")]
        public static extern void GetProgram(Int32 program, OpenTK.Graphics.OpenGL.GetProgramParameterName pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v2.0]
        /// Returns a parameter from a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the object parameter. Accepted symbolic names are GL_DELETE_STATUS, GL_LINK_STATUS, GL_VALIDATE_STATUS, GL_INFO_LOG_LENGTH, GL_ATTACHED_SHADERS, GL_ACTIVE_ATOMIC_COUNTER_BUFFERS, GL_ACTIVE_ATTRIBUTES, GL_ACTIVE_ATTRIBUTE_MAX_LENGTH, GL_ACTIVE_UNIFORMS, GL_ACTIVE_UNIFORM_BLOCKS, GL_ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH, GL_ACTIVE_UNIFORM_MAX_LENGTH, GL_COMPUTE_WORK_GROUP_SIZE GL_PROGRAM_BINARY_LENGTH, GL_TRANSFORM_FEEDBACK_BUFFER_MODE, GL_TRANSFORM_FEEDBACK_VARYINGS, GL_TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH, GL_GEOMETRY_VERTICES_OUT, GL_GEOMETRY_INPUT_TYPE, and GL_GEOMETRY_OUTPUT_TYPE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested object parameter.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetProgramiv")]
        public static extern unsafe void GetProgram(Int32 program, OpenTK.Graphics.OpenGL.GetProgramParameterName pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v2.0]
        /// Returns a parameter from a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the object parameter. Accepted symbolic names are GL_DELETE_STATUS, GL_LINK_STATUS, GL_VALIDATE_STATUS, GL_INFO_LOG_LENGTH, GL_ATTACHED_SHADERS, GL_ACTIVE_ATOMIC_COUNTER_BUFFERS, GL_ACTIVE_ATTRIBUTES, GL_ACTIVE_ATTRIBUTE_MAX_LENGTH, GL_ACTIVE_UNIFORMS, GL_ACTIVE_UNIFORM_BLOCKS, GL_ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH, GL_ACTIVE_UNIFORM_MAX_LENGTH, GL_COMPUTE_WORK_GROUP_SIZE GL_PROGRAM_BINARY_LENGTH, GL_TRANSFORM_FEEDBACK_BUFFER_MODE, GL_TRANSFORM_FEEDBACK_VARYINGS, GL_TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH, GL_GEOMETRY_VERTICES_OUT, GL_GEOMETRY_INPUT_TYPE, and GL_GEOMETRY_OUTPUT_TYPE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested object parameter.
        /// </para>
        /// </param>
        [Obsolete("Use GetProgramParameterName overload instead")]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetProgramiv")]
        public static extern void GetProgram(Int32 program, OpenTK.Graphics.OpenGL.ProgramParameter pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v2.0]
        /// Returns a parameter from a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the object parameter. Accepted symbolic names are GL_DELETE_STATUS, GL_LINK_STATUS, GL_VALIDATE_STATUS, GL_INFO_LOG_LENGTH, GL_ATTACHED_SHADERS, GL_ACTIVE_ATOMIC_COUNTER_BUFFERS, GL_ACTIVE_ATTRIBUTES, GL_ACTIVE_ATTRIBUTE_MAX_LENGTH, GL_ACTIVE_UNIFORMS, GL_ACTIVE_UNIFORM_BLOCKS, GL_ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH, GL_ACTIVE_UNIFORM_MAX_LENGTH, GL_COMPUTE_WORK_GROUP_SIZE GL_PROGRAM_BINARY_LENGTH, GL_TRANSFORM_FEEDBACK_BUFFER_MODE, GL_TRANSFORM_FEEDBACK_VARYINGS, GL_TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH, GL_GEOMETRY_VERTICES_OUT, GL_GEOMETRY_INPUT_TYPE, and GL_GEOMETRY_OUTPUT_TYPE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested object parameter.
        /// </para>
        /// </param>
        [Obsolete("Use GetProgramParameterName overload instead")]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetProgramiv")]
        public static extern void GetProgram(Int32 program, OpenTK.Graphics.OpenGL.ProgramParameter pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v2.0]
        /// Returns a parameter from a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the object parameter. Accepted symbolic names are GL_DELETE_STATUS, GL_LINK_STATUS, GL_VALIDATE_STATUS, GL_INFO_LOG_LENGTH, GL_ATTACHED_SHADERS, GL_ACTIVE_ATOMIC_COUNTER_BUFFERS, GL_ACTIVE_ATTRIBUTES, GL_ACTIVE_ATTRIBUTE_MAX_LENGTH, GL_ACTIVE_UNIFORMS, GL_ACTIVE_UNIFORM_BLOCKS, GL_ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH, GL_ACTIVE_UNIFORM_MAX_LENGTH, GL_COMPUTE_WORK_GROUP_SIZE GL_PROGRAM_BINARY_LENGTH, GL_TRANSFORM_FEEDBACK_BUFFER_MODE, GL_TRANSFORM_FEEDBACK_VARYINGS, GL_TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH, GL_GEOMETRY_VERTICES_OUT, GL_GEOMETRY_INPUT_TYPE, and GL_GEOMETRY_OUTPUT_TYPE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested object parameter.
        /// </para>
        /// </param>
        [Obsolete("Use GetProgramParameterName overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetProgramiv")]
        public static extern unsafe void GetProgram(Int32 program, OpenTK.Graphics.OpenGL.ProgramParameter pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v2.0]
        /// Returns a parameter from a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the object parameter. Accepted symbolic names are GL_DELETE_STATUS, GL_LINK_STATUS, GL_VALIDATE_STATUS, GL_INFO_LOG_LENGTH, GL_ATTACHED_SHADERS, GL_ACTIVE_ATOMIC_COUNTER_BUFFERS, GL_ACTIVE_ATTRIBUTES, GL_ACTIVE_ATTRIBUTE_MAX_LENGTH, GL_ACTIVE_UNIFORMS, GL_ACTIVE_UNIFORM_BLOCKS, GL_ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH, GL_ACTIVE_UNIFORM_MAX_LENGTH, GL_COMPUTE_WORK_GROUP_SIZE GL_PROGRAM_BINARY_LENGTH, GL_TRANSFORM_FEEDBACK_BUFFER_MODE, GL_TRANSFORM_FEEDBACK_VARYINGS, GL_TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH, GL_GEOMETRY_VERTICES_OUT, GL_GEOMETRY_INPUT_TYPE, and GL_GEOMETRY_OUTPUT_TYPE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested object parameter.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetProgramiv")]
        public static extern void GetProgram(UInt32 program, OpenTK.Graphics.OpenGL.GetProgramParameterName pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v2.0]
        /// Returns a parameter from a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the object parameter. Accepted symbolic names are GL_DELETE_STATUS, GL_LINK_STATUS, GL_VALIDATE_STATUS, GL_INFO_LOG_LENGTH, GL_ATTACHED_SHADERS, GL_ACTIVE_ATOMIC_COUNTER_BUFFERS, GL_ACTIVE_ATTRIBUTES, GL_ACTIVE_ATTRIBUTE_MAX_LENGTH, GL_ACTIVE_UNIFORMS, GL_ACTIVE_UNIFORM_BLOCKS, GL_ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH, GL_ACTIVE_UNIFORM_MAX_LENGTH, GL_COMPUTE_WORK_GROUP_SIZE GL_PROGRAM_BINARY_LENGTH, GL_TRANSFORM_FEEDBACK_BUFFER_MODE, GL_TRANSFORM_FEEDBACK_VARYINGS, GL_TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH, GL_GEOMETRY_VERTICES_OUT, GL_GEOMETRY_INPUT_TYPE, and GL_GEOMETRY_OUTPUT_TYPE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested object parameter.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetProgramiv")]
        public static extern void GetProgram(UInt32 program, OpenTK.Graphics.OpenGL.GetProgramParameterName pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v2.0]
        /// Returns a parameter from a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the object parameter. Accepted symbolic names are GL_DELETE_STATUS, GL_LINK_STATUS, GL_VALIDATE_STATUS, GL_INFO_LOG_LENGTH, GL_ATTACHED_SHADERS, GL_ACTIVE_ATOMIC_COUNTER_BUFFERS, GL_ACTIVE_ATTRIBUTES, GL_ACTIVE_ATTRIBUTE_MAX_LENGTH, GL_ACTIVE_UNIFORMS, GL_ACTIVE_UNIFORM_BLOCKS, GL_ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH, GL_ACTIVE_UNIFORM_MAX_LENGTH, GL_COMPUTE_WORK_GROUP_SIZE GL_PROGRAM_BINARY_LENGTH, GL_TRANSFORM_FEEDBACK_BUFFER_MODE, GL_TRANSFORM_FEEDBACK_VARYINGS, GL_TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH, GL_GEOMETRY_VERTICES_OUT, GL_GEOMETRY_INPUT_TYPE, and GL_GEOMETRY_OUTPUT_TYPE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested object parameter.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetProgramiv")]
        public static extern unsafe void GetProgram(UInt32 program, OpenTK.Graphics.OpenGL.GetProgramParameterName pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v2.0]
        /// Returns a parameter from a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the object parameter. Accepted symbolic names are GL_DELETE_STATUS, GL_LINK_STATUS, GL_VALIDATE_STATUS, GL_INFO_LOG_LENGTH, GL_ATTACHED_SHADERS, GL_ACTIVE_ATOMIC_COUNTER_BUFFERS, GL_ACTIVE_ATTRIBUTES, GL_ACTIVE_ATTRIBUTE_MAX_LENGTH, GL_ACTIVE_UNIFORMS, GL_ACTIVE_UNIFORM_BLOCKS, GL_ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH, GL_ACTIVE_UNIFORM_MAX_LENGTH, GL_COMPUTE_WORK_GROUP_SIZE GL_PROGRAM_BINARY_LENGTH, GL_TRANSFORM_FEEDBACK_BUFFER_MODE, GL_TRANSFORM_FEEDBACK_VARYINGS, GL_TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH, GL_GEOMETRY_VERTICES_OUT, GL_GEOMETRY_INPUT_TYPE, and GL_GEOMETRY_OUTPUT_TYPE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested object parameter.
        /// </para>
        /// </param>
        [Obsolete("Use GetProgramParameterName overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetProgramiv")]
        public static extern void GetProgram(UInt32 program, OpenTK.Graphics.OpenGL.ProgramParameter pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v2.0]
        /// Returns a parameter from a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the object parameter. Accepted symbolic names are GL_DELETE_STATUS, GL_LINK_STATUS, GL_VALIDATE_STATUS, GL_INFO_LOG_LENGTH, GL_ATTACHED_SHADERS, GL_ACTIVE_ATOMIC_COUNTER_BUFFERS, GL_ACTIVE_ATTRIBUTES, GL_ACTIVE_ATTRIBUTE_MAX_LENGTH, GL_ACTIVE_UNIFORMS, GL_ACTIVE_UNIFORM_BLOCKS, GL_ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH, GL_ACTIVE_UNIFORM_MAX_LENGTH, GL_COMPUTE_WORK_GROUP_SIZE GL_PROGRAM_BINARY_LENGTH, GL_TRANSFORM_FEEDBACK_BUFFER_MODE, GL_TRANSFORM_FEEDBACK_VARYINGS, GL_TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH, GL_GEOMETRY_VERTICES_OUT, GL_GEOMETRY_INPUT_TYPE, and GL_GEOMETRY_OUTPUT_TYPE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested object parameter.
        /// </para>
        /// </param>
        [Obsolete("Use GetProgramParameterName overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetProgramiv")]
        public static extern void GetProgram(UInt32 program, OpenTK.Graphics.OpenGL.ProgramParameter pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v2.0]
        /// Returns a parameter from a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the object parameter. Accepted symbolic names are GL_DELETE_STATUS, GL_LINK_STATUS, GL_VALIDATE_STATUS, GL_INFO_LOG_LENGTH, GL_ATTACHED_SHADERS, GL_ACTIVE_ATOMIC_COUNTER_BUFFERS, GL_ACTIVE_ATTRIBUTES, GL_ACTIVE_ATTRIBUTE_MAX_LENGTH, GL_ACTIVE_UNIFORMS, GL_ACTIVE_UNIFORM_BLOCKS, GL_ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH, GL_ACTIVE_UNIFORM_MAX_LENGTH, GL_COMPUTE_WORK_GROUP_SIZE GL_PROGRAM_BINARY_LENGTH, GL_TRANSFORM_FEEDBACK_BUFFER_MODE, GL_TRANSFORM_FEEDBACK_VARYINGS, GL_TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH, GL_GEOMETRY_VERTICES_OUT, GL_GEOMETRY_INPUT_TYPE, and GL_GEOMETRY_OUTPUT_TYPE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested object parameter.
        /// </para>
        /// </param>
        [Obsolete("Use GetProgramParameterName overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetProgramiv")]
        public static extern unsafe void GetProgram(UInt32 program, OpenTK.Graphics.OpenGL.ProgramParameter pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Retrieve the info log string from a program pipeline object
        /// </summary>
        /// <param name="pipeline">
        /// <para>
        /// Specifies the name of a program pipeline object from which to retrieve the info log.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the maximum number of characters, including the null terminator, that may be written into infoLog.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable into which will be written the number of characters written into infoLog.
        /// </para>
        /// </param>
        /// <param name="infoLog">
        /// <para>
        /// Specifies the address of an array of characters into which will be written the info log for pipeline.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glGetProgramPipelineInfoLog")]
        public static extern void GetProgramPipelineInfoLog(Int32 pipeline, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder infoLog);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Retrieve the info log string from a program pipeline object
        /// </summary>
        /// <param name="pipeline">
        /// <para>
        /// Specifies the name of a program pipeline object from which to retrieve the info log.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the maximum number of characters, including the null terminator, that may be written into infoLog.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable into which will be written the number of characters written into infoLog.
        /// </para>
        /// </param>
        /// <param name="infoLog">
        /// <para>
        /// Specifies the address of an array of characters into which will be written the info log for pipeline.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glGetProgramPipelineInfoLog")]
        public static extern unsafe void GetProgramPipelineInfoLog(Int32 pipeline, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder infoLog);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Retrieve the info log string from a program pipeline object
        /// </summary>
        /// <param name="pipeline">
        /// <para>
        /// Specifies the name of a program pipeline object from which to retrieve the info log.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the maximum number of characters, including the null terminator, that may be written into infoLog.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable into which will be written the number of characters written into infoLog.
        /// </para>
        /// </param>
        /// <param name="infoLog">
        /// <para>
        /// Specifies the address of an array of characters into which will be written the info log for pipeline.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glGetProgramPipelineInfoLog")]
        public static extern void GetProgramPipelineInfoLog(UInt32 pipeline, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder infoLog);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Retrieve the info log string from a program pipeline object
        /// </summary>
        /// <param name="pipeline">
        /// <para>
        /// Specifies the name of a program pipeline object from which to retrieve the info log.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the maximum number of characters, including the null terminator, that may be written into infoLog.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of a variable into which will be written the number of characters written into infoLog.
        /// </para>
        /// </param>
        /// <param name="infoLog">
        /// <para>
        /// Specifies the address of an array of characters into which will be written the info log for pipeline.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glGetProgramPipelineInfoLog")]
        public static extern unsafe void GetProgramPipelineInfoLog(UInt32 pipeline, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder infoLog);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Retrieve properties of a program pipeline object
        /// </summary>
        /// <param name="pipeline">
        /// <para>
        /// Specifies the name of a program pipeline object whose parameter retrieve.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the name of the parameter to retrieve.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Specifies the address of a variable into which will be written the value or values of pname for pipeline.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glGetProgramPipelineiv")]
        public static extern void GetProgramPipeline(Int32 pipeline, OpenTK.Graphics.OpenGL.ProgramPipelineParameter pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Retrieve properties of a program pipeline object
        /// </summary>
        /// <param name="pipeline">
        /// <para>
        /// Specifies the name of a program pipeline object whose parameter retrieve.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the name of the parameter to retrieve.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Specifies the address of a variable into which will be written the value or values of pname for pipeline.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glGetProgramPipelineiv")]
        public static extern void GetProgramPipeline(Int32 pipeline, OpenTK.Graphics.OpenGL.ProgramPipelineParameter pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Retrieve properties of a program pipeline object
        /// </summary>
        /// <param name="pipeline">
        /// <para>
        /// Specifies the name of a program pipeline object whose parameter retrieve.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the name of the parameter to retrieve.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Specifies the address of a variable into which will be written the value or values of pname for pipeline.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glGetProgramPipelineiv")]
        public static extern unsafe void GetProgramPipeline(Int32 pipeline, OpenTK.Graphics.OpenGL.ProgramPipelineParameter pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Retrieve properties of a program pipeline object
        /// </summary>
        /// <param name="pipeline">
        /// <para>
        /// Specifies the name of a program pipeline object whose parameter retrieve.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the name of the parameter to retrieve.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Specifies the address of a variable into which will be written the value or values of pname for pipeline.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glGetProgramPipelineiv")]
        public static extern void GetProgramPipeline(UInt32 pipeline, OpenTK.Graphics.OpenGL.ProgramPipelineParameter pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Retrieve properties of a program pipeline object
        /// </summary>
        /// <param name="pipeline">
        /// <para>
        /// Specifies the name of a program pipeline object whose parameter retrieve.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the name of the parameter to retrieve.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Specifies the address of a variable into which will be written the value or values of pname for pipeline.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glGetProgramPipelineiv")]
        public static extern void GetProgramPipeline(UInt32 pipeline, OpenTK.Graphics.OpenGL.ProgramPipelineParameter pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Retrieve properties of a program pipeline object
        /// </summary>
        /// <param name="pipeline">
        /// <para>
        /// Specifies the name of a program pipeline object whose parameter retrieve.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the name of the parameter to retrieve.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Specifies the address of a variable into which will be written the value or values of pname for pipeline.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glGetProgramPipelineiv")]
        public static extern unsafe void GetProgramPipeline(UInt32 pipeline, OpenTK.Graphics.OpenGL.ProgramPipelineParameter pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v4.3 and ARB_program_interface_query|VERSION_4_3]
        /// Query the index of a named resource within a program
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of a program object whose resources to query.
        /// </para>
        /// </param>
        /// <param name="programInterface">
        /// <para>
        /// A token identifying the interface within program containing the resource named name.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The name of the resource to query the index of.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_program_interface_query|VERSION_4_3", Version = "4.3", EntryPoint = "glGetProgramResourceIndex")]
        public static extern Int32 GetProgramResourceIndex(Int32 program, OpenTK.Graphics.OpenGL.ProgramInterface programInterface, String name);

        /// <summary>[requires: v4.3 and ARB_program_interface_query|VERSION_4_3]
        /// Query the index of a named resource within a program
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of a program object whose resources to query.
        /// </para>
        /// </param>
        /// <param name="programInterface">
        /// <para>
        /// A token identifying the interface within program containing the resource named name.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The name of the resource to query the index of.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_program_interface_query|VERSION_4_3", Version = "4.3", EntryPoint = "glGetProgramResourceIndex")]
        public static extern Int32 GetProgramResourceIndex(UInt32 program, OpenTK.Graphics.OpenGL.ProgramInterface programInterface, String name);

        /// <summary>[requires: v4.3 and ARB_program_interface_query|VERSION_4_3]
        /// Retrieve values for multiple properties of a single active resource within a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of a program object whose resources to query.
        /// </para>
        /// </param>
        /// <param name="programInterface">
        /// <para>
        /// A token identifying the interface within program containing the resource named name.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_program_interface_query|VERSION_4_3", Version = "4.3", EntryPoint = "glGetProgramResourceiv")]
        public static extern void GetProgramResource(Int32 program, OpenTK.Graphics.OpenGL.ProgramInterface programInterface, Int32 index, Int32 propCount, OpenTK.Graphics.OpenGL.ProgramProperty[] props, Int32 bufSize, [OutAttribute] Int32[] length, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v4.3 and ARB_program_interface_query|VERSION_4_3]
        /// Retrieve values for multiple properties of a single active resource within a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of a program object whose resources to query.
        /// </para>
        /// </param>
        /// <param name="programInterface">
        /// <para>
        /// A token identifying the interface within program containing the resource named name.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_program_interface_query|VERSION_4_3", Version = "4.3", EntryPoint = "glGetProgramResourceiv")]
        public static extern void GetProgramResource(Int32 program, OpenTK.Graphics.OpenGL.ProgramInterface programInterface, Int32 index, Int32 propCount, ref OpenTK.Graphics.OpenGL.ProgramProperty props, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v4.3 and ARB_program_interface_query|VERSION_4_3]
        /// Retrieve values for multiple properties of a single active resource within a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of a program object whose resources to query.
        /// </para>
        /// </param>
        /// <param name="programInterface">
        /// <para>
        /// A token identifying the interface within program containing the resource named name.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_program_interface_query|VERSION_4_3", Version = "4.3", EntryPoint = "glGetProgramResourceiv")]
        public static extern unsafe void GetProgramResource(Int32 program, OpenTK.Graphics.OpenGL.ProgramInterface programInterface, Int32 index, Int32 propCount, OpenTK.Graphics.OpenGL.ProgramProperty* props, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] Int32* @params);

        /// <summary>[requires: v4.3 and ARB_program_interface_query|VERSION_4_3]
        /// Retrieve values for multiple properties of a single active resource within a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of a program object whose resources to query.
        /// </para>
        /// </param>
        /// <param name="programInterface">
        /// <para>
        /// A token identifying the interface within program containing the resource named name.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_program_interface_query|VERSION_4_3", Version = "4.3", EntryPoint = "glGetProgramResourceiv")]
        public static extern void GetProgramResource(UInt32 program, OpenTK.Graphics.OpenGL.ProgramInterface programInterface, UInt32 index, Int32 propCount, OpenTK.Graphics.OpenGL.ProgramProperty[] props, Int32 bufSize, [OutAttribute] Int32[] length, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v4.3 and ARB_program_interface_query|VERSION_4_3]
        /// Retrieve values for multiple properties of a single active resource within a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of a program object whose resources to query.
        /// </para>
        /// </param>
        /// <param name="programInterface">
        /// <para>
        /// A token identifying the interface within program containing the resource named name.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_program_interface_query|VERSION_4_3", Version = "4.3", EntryPoint = "glGetProgramResourceiv")]
        public static extern void GetProgramResource(UInt32 program, OpenTK.Graphics.OpenGL.ProgramInterface programInterface, UInt32 index, Int32 propCount, ref OpenTK.Graphics.OpenGL.ProgramProperty props, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v4.3 and ARB_program_interface_query|VERSION_4_3]
        /// Retrieve values for multiple properties of a single active resource within a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of a program object whose resources to query.
        /// </para>
        /// </param>
        /// <param name="programInterface">
        /// <para>
        /// A token identifying the interface within program containing the resource named name.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_program_interface_query|VERSION_4_3", Version = "4.3", EntryPoint = "glGetProgramResourceiv")]
        public static extern unsafe void GetProgramResource(UInt32 program, OpenTK.Graphics.OpenGL.ProgramInterface programInterface, UInt32 index, Int32 propCount, OpenTK.Graphics.OpenGL.ProgramProperty* props, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] Int32* @params);

        /// <summary>[requires: v4.3 and ARB_program_interface_query|VERSION_4_3]
        /// Query the location of a named resource within a program
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of a program object whose resources to query.
        /// </para>
        /// </param>
        /// <param name="programInterface">
        /// <para>
        /// A token identifying the interface within program containing the resource named name.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The name of the resource to query the location of.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_program_interface_query|VERSION_4_3", Version = "4.3", EntryPoint = "glGetProgramResourceLocation")]
        public static extern Int32 GetProgramResourceLocation(Int32 program, OpenTK.Graphics.OpenGL.ProgramInterface programInterface, String name);

        /// <summary>[requires: v4.3 and ARB_program_interface_query|VERSION_4_3]
        /// Query the location of a named resource within a program
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of a program object whose resources to query.
        /// </para>
        /// </param>
        /// <param name="programInterface">
        /// <para>
        /// A token identifying the interface within program containing the resource named name.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The name of the resource to query the location of.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_program_interface_query|VERSION_4_3", Version = "4.3", EntryPoint = "glGetProgramResourceLocation")]
        public static extern Int32 GetProgramResourceLocation(UInt32 program, OpenTK.Graphics.OpenGL.ProgramInterface programInterface, String name);

        /// <summary>[requires: v4.3 and ARB_program_interface_query|VERSION_4_3]
        /// Query the fragment color index of a named variable within a program
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of a program object whose resources to query.
        /// </para>
        /// </param>
        /// <param name="programInterface">
        /// <para>
        /// A token identifying the interface within program containing the resource named name.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The name of the resource to query the location of.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_program_interface_query|VERSION_4_3", Version = "4.3", EntryPoint = "glGetProgramResourceLocationIndex")]
        public static extern Int32 GetProgramResourceLocationIndex(Int32 program, OpenTK.Graphics.OpenGL.ProgramInterface programInterface, String name);

        /// <summary>[requires: v4.3 and ARB_program_interface_query|VERSION_4_3]
        /// Query the fragment color index of a named variable within a program
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of a program object whose resources to query.
        /// </para>
        /// </param>
        /// <param name="programInterface">
        /// <para>
        /// A token identifying the interface within program containing the resource named name.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The name of the resource to query the location of.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_program_interface_query|VERSION_4_3", Version = "4.3", EntryPoint = "glGetProgramResourceLocationIndex")]
        public static extern Int32 GetProgramResourceLocationIndex(UInt32 program, OpenTK.Graphics.OpenGL.ProgramInterface programInterface, String name);

        /// <summary>[requires: v4.3 and ARB_program_interface_query|VERSION_4_3]
        /// Query the name of an indexed resource within a program
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of a program object whose resources to query.
        /// </para>
        /// </param>
        /// <param name="programInterface">
        /// <para>
        /// A token identifying the interface within program containing the indexed resource.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// The index of the resource within programInterface of program.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The size of the character array whose address is given by name.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The address of a variable which will receive the length of the resource name.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The address of a character array into which will be written the name of the resource.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_program_interface_query|VERSION_4_3", Version = "4.3", EntryPoint = "glGetProgramResourceName")]
        public static extern void GetProgramResourceName(Int32 program, OpenTK.Graphics.OpenGL.ProgramInterface programInterface, Int32 index, Int32 bufSize, [OutAttribute] Int32[] length, [OutAttribute] StringBuilder name);

        /// <summary>[requires: v4.3 and ARB_program_interface_query|VERSION_4_3]
        /// Query the name of an indexed resource within a program
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of a program object whose resources to query.
        /// </para>
        /// </param>
        /// <param name="programInterface">
        /// <para>
        /// A token identifying the interface within program containing the indexed resource.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// The index of the resource within programInterface of program.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The size of the character array whose address is given by name.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The address of a variable which will receive the length of the resource name.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The address of a character array into which will be written the name of the resource.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_program_interface_query|VERSION_4_3", Version = "4.3", EntryPoint = "glGetProgramResourceName")]
        public static extern void GetProgramResourceName(Int32 program, OpenTK.Graphics.OpenGL.ProgramInterface programInterface, Int32 index, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder name);

        /// <summary>[requires: v4.3 and ARB_program_interface_query|VERSION_4_3]
        /// Query the name of an indexed resource within a program
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of a program object whose resources to query.
        /// </para>
        /// </param>
        /// <param name="programInterface">
        /// <para>
        /// A token identifying the interface within program containing the indexed resource.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// The index of the resource within programInterface of program.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The size of the character array whose address is given by name.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The address of a variable which will receive the length of the resource name.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The address of a character array into which will be written the name of the resource.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_program_interface_query|VERSION_4_3", Version = "4.3", EntryPoint = "glGetProgramResourceName")]
        public static extern unsafe void GetProgramResourceName(Int32 program, OpenTK.Graphics.OpenGL.ProgramInterface programInterface, Int32 index, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder name);

        /// <summary>[requires: v4.3 and ARB_program_interface_query|VERSION_4_3]
        /// Query the name of an indexed resource within a program
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of a program object whose resources to query.
        /// </para>
        /// </param>
        /// <param name="programInterface">
        /// <para>
        /// A token identifying the interface within program containing the indexed resource.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// The index of the resource within programInterface of program.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The size of the character array whose address is given by name.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The address of a variable which will receive the length of the resource name.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The address of a character array into which will be written the name of the resource.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_program_interface_query|VERSION_4_3", Version = "4.3", EntryPoint = "glGetProgramResourceName")]
        public static extern void GetProgramResourceName(UInt32 program, OpenTK.Graphics.OpenGL.ProgramInterface programInterface, UInt32 index, Int32 bufSize, [OutAttribute] Int32[] length, [OutAttribute] StringBuilder name);

        /// <summary>[requires: v4.3 and ARB_program_interface_query|VERSION_4_3]
        /// Query the name of an indexed resource within a program
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of a program object whose resources to query.
        /// </para>
        /// </param>
        /// <param name="programInterface">
        /// <para>
        /// A token identifying the interface within program containing the indexed resource.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// The index of the resource within programInterface of program.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The size of the character array whose address is given by name.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The address of a variable which will receive the length of the resource name.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The address of a character array into which will be written the name of the resource.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_program_interface_query|VERSION_4_3", Version = "4.3", EntryPoint = "glGetProgramResourceName")]
        public static extern void GetProgramResourceName(UInt32 program, OpenTK.Graphics.OpenGL.ProgramInterface programInterface, UInt32 index, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder name);

        /// <summary>[requires: v4.3 and ARB_program_interface_query|VERSION_4_3]
        /// Query the name of an indexed resource within a program
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of a program object whose resources to query.
        /// </para>
        /// </param>
        /// <param name="programInterface">
        /// <para>
        /// A token identifying the interface within program containing the indexed resource.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// The index of the resource within programInterface of program.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The size of the character array whose address is given by name.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The address of a variable which will receive the length of the resource name.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The address of a character array into which will be written the name of the resource.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_program_interface_query|VERSION_4_3", Version = "4.3", EntryPoint = "glGetProgramResourceName")]
        public static extern unsafe void GetProgramResourceName(UInt32 program, OpenTK.Graphics.OpenGL.ProgramInterface programInterface, UInt32 index, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder name);

        /// <summary>[requires: v4.0 and ARB_shader_subroutine|VERSION_4_0]
        /// Retrieve properties of a program object corresponding to a specified shader stage
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of the program containing shader stage.
        /// </para>
        /// </param>
        /// <param name="shadertype">
        /// <para>
        /// Specifies the shader stage from which to query for the subroutine parameter. shadertype must be one of GL_VERTEX_SHADER, GL_TESS_CONTROL_SHADER, GL_TESS_EVALUATION_SHADER, GL_GEOMETRY_SHADER or GL_FRAGMENT_SHADER.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the parameter of the shader to query. pname must be GL_ACTIVE_SUBROUTINE_UNIFORMS, GL_ACTIVE_SUBROUTINE_UNIFORM_LOCATIONS, GL_ACTIVE_SUBROUTINES, GL_ACTIVE_SUBROUTINE_UNIFORM_MAX_LENGTH, or GL_ACTIVE_SUBROUTINE_MAX_LENGTH.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies the address of a variable into which the queried value or values will be placed.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_shader_subroutine|VERSION_4_0", Version = "4.0", EntryPoint = "glGetProgramStageiv")]
        public static extern void GetProgramStage(Int32 program, OpenTK.Graphics.OpenGL.ShaderType shadertype, OpenTK.Graphics.OpenGL.ProgramStageParameter pname, [OutAttribute] out Int32 values);

        /// <summary>[requires: v4.0 and ARB_shader_subroutine|VERSION_4_0]
        /// Retrieve properties of a program object corresponding to a specified shader stage
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of the program containing shader stage.
        /// </para>
        /// </param>
        /// <param name="shadertype">
        /// <para>
        /// Specifies the shader stage from which to query for the subroutine parameter. shadertype must be one of GL_VERTEX_SHADER, GL_TESS_CONTROL_SHADER, GL_TESS_EVALUATION_SHADER, GL_GEOMETRY_SHADER or GL_FRAGMENT_SHADER.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the parameter of the shader to query. pname must be GL_ACTIVE_SUBROUTINE_UNIFORMS, GL_ACTIVE_SUBROUTINE_UNIFORM_LOCATIONS, GL_ACTIVE_SUBROUTINES, GL_ACTIVE_SUBROUTINE_UNIFORM_MAX_LENGTH, or GL_ACTIVE_SUBROUTINE_MAX_LENGTH.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies the address of a variable into which the queried value or values will be placed.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_shader_subroutine|VERSION_4_0", Version = "4.0", EntryPoint = "glGetProgramStageiv")]
        public static extern unsafe void GetProgramStage(Int32 program, OpenTK.Graphics.OpenGL.ShaderType shadertype, OpenTK.Graphics.OpenGL.ProgramStageParameter pname, [OutAttribute] Int32* values);

        /// <summary>[requires: v4.0 and ARB_shader_subroutine|VERSION_4_0]
        /// Retrieve properties of a program object corresponding to a specified shader stage
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of the program containing shader stage.
        /// </para>
        /// </param>
        /// <param name="shadertype">
        /// <para>
        /// Specifies the shader stage from which to query for the subroutine parameter. shadertype must be one of GL_VERTEX_SHADER, GL_TESS_CONTROL_SHADER, GL_TESS_EVALUATION_SHADER, GL_GEOMETRY_SHADER or GL_FRAGMENT_SHADER.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the parameter of the shader to query. pname must be GL_ACTIVE_SUBROUTINE_UNIFORMS, GL_ACTIVE_SUBROUTINE_UNIFORM_LOCATIONS, GL_ACTIVE_SUBROUTINES, GL_ACTIVE_SUBROUTINE_UNIFORM_MAX_LENGTH, or GL_ACTIVE_SUBROUTINE_MAX_LENGTH.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies the address of a variable into which the queried value or values will be placed.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_shader_subroutine|VERSION_4_0", Version = "4.0", EntryPoint = "glGetProgramStageiv")]
        public static extern void GetProgramStage(UInt32 program, OpenTK.Graphics.OpenGL.ShaderType shadertype, OpenTK.Graphics.OpenGL.ProgramStageParameter pname, [OutAttribute] out Int32 values);

        /// <summary>[requires: v4.0 and ARB_shader_subroutine|VERSION_4_0]
        /// Retrieve properties of a program object corresponding to a specified shader stage
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of the program containing shader stage.
        /// </para>
        /// </param>
        /// <param name="shadertype">
        /// <para>
        /// Specifies the shader stage from which to query for the subroutine parameter. shadertype must be one of GL_VERTEX_SHADER, GL_TESS_CONTROL_SHADER, GL_TESS_EVALUATION_SHADER, GL_GEOMETRY_SHADER or GL_FRAGMENT_SHADER.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the parameter of the shader to query. pname must be GL_ACTIVE_SUBROUTINE_UNIFORMS, GL_ACTIVE_SUBROUTINE_UNIFORM_LOCATIONS, GL_ACTIVE_SUBROUTINES, GL_ACTIVE_SUBROUTINE_UNIFORM_MAX_LENGTH, or GL_ACTIVE_SUBROUTINE_MAX_LENGTH.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies the address of a variable into which the queried value or values will be placed.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_shader_subroutine|VERSION_4_0", Version = "4.0", EntryPoint = "glGetProgramStageiv")]
        public static extern unsafe void GetProgramStage(UInt32 program, OpenTK.Graphics.OpenGL.ShaderType shadertype, OpenTK.Graphics.OpenGL.ProgramStageParameter pname, [OutAttribute] Int32* values);

        /// <summary>[requires: v4.0 and ARB_transform_feedback3|VERSION_4_0]
        /// Return parameters of an indexed query object target
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies a query object target. Must be GL_SAMPLES_PASSED, GL_ANY_SAMPLES_PASSED, GL_ANY_SAMPLES_PASSED_CONSERVATIVE GL_PRIMITIVES_GENERATED, GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN, GL_TIME_ELAPSED, or GL_TIMESTAMP.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the query object target.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a query object target parameter. Accepted values are GL_CURRENT_QUERY or GL_QUERY_COUNTER_BITS.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_transform_feedback3|VERSION_4_0", Version = "4.0", EntryPoint = "glGetQueryIndexediv")]
        public static extern void GetQueryIndexed(OpenTK.Graphics.OpenGL.QueryTarget target, Int32 index, OpenTK.Graphics.OpenGL.GetQueryParam pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v4.0 and ARB_transform_feedback3|VERSION_4_0]
        /// Return parameters of an indexed query object target
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies a query object target. Must be GL_SAMPLES_PASSED, GL_ANY_SAMPLES_PASSED, GL_ANY_SAMPLES_PASSED_CONSERVATIVE GL_PRIMITIVES_GENERATED, GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN, GL_TIME_ELAPSED, or GL_TIMESTAMP.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the query object target.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a query object target parameter. Accepted values are GL_CURRENT_QUERY or GL_QUERY_COUNTER_BITS.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_transform_feedback3|VERSION_4_0", Version = "4.0", EntryPoint = "glGetQueryIndexediv")]
        public static extern void GetQueryIndexed(OpenTK.Graphics.OpenGL.QueryTarget target, Int32 index, OpenTK.Graphics.OpenGL.GetQueryParam pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v4.0 and ARB_transform_feedback3|VERSION_4_0]
        /// Return parameters of an indexed query object target
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies a query object target. Must be GL_SAMPLES_PASSED, GL_ANY_SAMPLES_PASSED, GL_ANY_SAMPLES_PASSED_CONSERVATIVE GL_PRIMITIVES_GENERATED, GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN, GL_TIME_ELAPSED, or GL_TIMESTAMP.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the query object target.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a query object target parameter. Accepted values are GL_CURRENT_QUERY or GL_QUERY_COUNTER_BITS.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_transform_feedback3|VERSION_4_0", Version = "4.0", EntryPoint = "glGetQueryIndexediv")]
        public static extern unsafe void GetQueryIndexed(OpenTK.Graphics.OpenGL.QueryTarget target, Int32 index, OpenTK.Graphics.OpenGL.GetQueryParam pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v4.0 and ARB_transform_feedback3|VERSION_4_0]
        /// Return parameters of an indexed query object target
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies a query object target. Must be GL_SAMPLES_PASSED, GL_ANY_SAMPLES_PASSED, GL_ANY_SAMPLES_PASSED_CONSERVATIVE GL_PRIMITIVES_GENERATED, GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN, GL_TIME_ELAPSED, or GL_TIMESTAMP.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the query object target.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a query object target parameter. Accepted values are GL_CURRENT_QUERY or GL_QUERY_COUNTER_BITS.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_transform_feedback3|VERSION_4_0", Version = "4.0", EntryPoint = "glGetQueryIndexediv")]
        public static extern void GetQueryIndexed(OpenTK.Graphics.OpenGL.QueryTarget target, UInt32 index, OpenTK.Graphics.OpenGL.GetQueryParam pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v4.0 and ARB_transform_feedback3|VERSION_4_0]
        /// Return parameters of an indexed query object target
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies a query object target. Must be GL_SAMPLES_PASSED, GL_ANY_SAMPLES_PASSED, GL_ANY_SAMPLES_PASSED_CONSERVATIVE GL_PRIMITIVES_GENERATED, GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN, GL_TIME_ELAPSED, or GL_TIMESTAMP.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the query object target.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a query object target parameter. Accepted values are GL_CURRENT_QUERY or GL_QUERY_COUNTER_BITS.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_transform_feedback3|VERSION_4_0", Version = "4.0", EntryPoint = "glGetQueryIndexediv")]
        public static extern void GetQueryIndexed(OpenTK.Graphics.OpenGL.QueryTarget target, UInt32 index, OpenTK.Graphics.OpenGL.GetQueryParam pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v4.0 and ARB_transform_feedback3|VERSION_4_0]
        /// Return parameters of an indexed query object target
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies a query object target. Must be GL_SAMPLES_PASSED, GL_ANY_SAMPLES_PASSED, GL_ANY_SAMPLES_PASSED_CONSERVATIVE GL_PRIMITIVES_GENERATED, GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN, GL_TIME_ELAPSED, or GL_TIMESTAMP.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the query object target.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a query object target parameter. Accepted values are GL_CURRENT_QUERY or GL_QUERY_COUNTER_BITS.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_transform_feedback3|VERSION_4_0", Version = "4.0", EntryPoint = "glGetQueryIndexediv")]
        public static extern unsafe void GetQueryIndexed(OpenTK.Graphics.OpenGL.QueryTarget target, UInt32 index, OpenTK.Graphics.OpenGL.GetQueryParam pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v1.5]
        /// Return parameters of a query object target
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies a query object target. Must be GL_SAMPLES_PASSED, GL_ANY_SAMPLES_PASSED, GL_ANY_SAMPLES_PASSED_CONSERVATIVE GL_PRIMITIVES_GENERATED, GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN, GL_TIME_ELAPSED, or GL_TIMESTAMP.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a query object target parameter. Accepted values are GL_CURRENT_QUERY or GL_QUERY_COUNTER_BITS.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGetQueryiv")]
        public static extern void GetQuery(OpenTK.Graphics.OpenGL.QueryTarget target, OpenTK.Graphics.OpenGL.GetQueryParam pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v1.5]
        /// Return parameters of a query object target
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies a query object target. Must be GL_SAMPLES_PASSED, GL_ANY_SAMPLES_PASSED, GL_ANY_SAMPLES_PASSED_CONSERVATIVE GL_PRIMITIVES_GENERATED, GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN, GL_TIME_ELAPSED, or GL_TIMESTAMP.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a query object target parameter. Accepted values are GL_CURRENT_QUERY or GL_QUERY_COUNTER_BITS.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGetQueryiv")]
        public static extern void GetQuery(OpenTK.Graphics.OpenGL.QueryTarget target, OpenTK.Graphics.OpenGL.GetQueryParam pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v1.5]
        /// Return parameters of a query object target
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies a query object target. Must be GL_SAMPLES_PASSED, GL_ANY_SAMPLES_PASSED, GL_ANY_SAMPLES_PASSED_CONSERVATIVE GL_PRIMITIVES_GENERATED, GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN, GL_TIME_ELAPSED, or GL_TIMESTAMP.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a query object target parameter. Accepted values are GL_CURRENT_QUERY or GL_QUERY_COUNTER_BITS.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGetQueryiv")]
        public static extern unsafe void GetQuery(OpenTK.Graphics.OpenGL.QueryTarget target, OpenTK.Graphics.OpenGL.GetQueryParam pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v3.3 and ARB_timer_query|VERSION_3_3]
        /// Return parameters of a query object
        /// </summary>
        /// <param name="id">
        /// <para>
        /// Specifies the name of a query object.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_timer_query|VERSION_3_3", Version = "3.3", EntryPoint = "glGetQueryObjecti64v")]
        public static extern void GetQueryObject(Int32 id, OpenTK.Graphics.OpenGL.GetQueryObjectParam pname, [OutAttribute] Int64[] @params);

        /// <summary>[requires: v3.3 and ARB_timer_query|VERSION_3_3]
        /// Return parameters of a query object
        /// </summary>
        /// <param name="id">
        /// <para>
        /// Specifies the name of a query object.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_timer_query|VERSION_3_3", Version = "3.3", EntryPoint = "glGetQueryObjecti64v")]
        public static extern void GetQueryObject(Int32 id, OpenTK.Graphics.OpenGL.GetQueryObjectParam pname, [OutAttribute] out Int64 @params);

        /// <summary>[requires: v3.3 and ARB_timer_query|VERSION_3_3]
        /// Return parameters of a query object
        /// </summary>
        /// <param name="id">
        /// <para>
        /// Specifies the name of a query object.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_timer_query|VERSION_3_3", Version = "3.3", EntryPoint = "glGetQueryObjecti64v")]
        public static extern unsafe void GetQueryObject(Int32 id, OpenTK.Graphics.OpenGL.GetQueryObjectParam pname, [OutAttribute] Int64* @params);

        /// <summary>[requires: v3.3 and ARB_timer_query|VERSION_3_3]
        /// Return parameters of a query object
        /// </summary>
        /// <param name="id">
        /// <para>
        /// Specifies the name of a query object.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_timer_query|VERSION_3_3", Version = "3.3", EntryPoint = "glGetQueryObjecti64v")]
        public static extern void GetQueryObject(UInt32 id, OpenTK.Graphics.OpenGL.GetQueryObjectParam pname, [OutAttribute] Int64[] @params);

        /// <summary>[requires: v3.3 and ARB_timer_query|VERSION_3_3]
        /// Return parameters of a query object
        /// </summary>
        /// <param name="id">
        /// <para>
        /// Specifies the name of a query object.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_timer_query|VERSION_3_3", Version = "3.3", EntryPoint = "glGetQueryObjecti64v")]
        public static extern void GetQueryObject(UInt32 id, OpenTK.Graphics.OpenGL.GetQueryObjectParam pname, [OutAttribute] out Int64 @params);

        /// <summary>[requires: v3.3 and ARB_timer_query|VERSION_3_3]
        /// Return parameters of a query object
        /// </summary>
        /// <param name="id">
        /// <para>
        /// Specifies the name of a query object.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_timer_query|VERSION_3_3", Version = "3.3", EntryPoint = "glGetQueryObjecti64v")]
        public static extern unsafe void GetQueryObject(UInt32 id, OpenTK.Graphics.OpenGL.GetQueryObjectParam pname, [OutAttribute] Int64* @params);

        /// <summary>[requires: v1.5]
        /// Return parameters of a query object
        /// </summary>
        /// <param name="id">
        /// <para>
        /// Specifies the name of a query object.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGetQueryObjectiv")]
        public static extern void GetQueryObject(Int32 id, OpenTK.Graphics.OpenGL.GetQueryObjectParam pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v1.5]
        /// Return parameters of a query object
        /// </summary>
        /// <param name="id">
        /// <para>
        /// Specifies the name of a query object.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGetQueryObjectiv")]
        public static extern void GetQueryObject(Int32 id, OpenTK.Graphics.OpenGL.GetQueryObjectParam pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v1.5]
        /// Return parameters of a query object
        /// </summary>
        /// <param name="id">
        /// <para>
        /// Specifies the name of a query object.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGetQueryObjectiv")]
        public static extern unsafe void GetQueryObject(Int32 id, OpenTK.Graphics.OpenGL.GetQueryObjectParam pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v1.5]
        /// Return parameters of a query object
        /// </summary>
        /// <param name="id">
        /// <para>
        /// Specifies the name of a query object.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGetQueryObjectiv")]
        public static extern void GetQueryObject(UInt32 id, OpenTK.Graphics.OpenGL.GetQueryObjectParam pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v1.5]
        /// Return parameters of a query object
        /// </summary>
        /// <param name="id">
        /// <para>
        /// Specifies the name of a query object.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGetQueryObjectiv")]
        public static extern void GetQueryObject(UInt32 id, OpenTK.Graphics.OpenGL.GetQueryObjectParam pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v1.5]
        /// Return parameters of a query object
        /// </summary>
        /// <param name="id">
        /// <para>
        /// Specifies the name of a query object.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGetQueryObjectiv")]
        public static extern unsafe void GetQueryObject(UInt32 id, OpenTK.Graphics.OpenGL.GetQueryObjectParam pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v3.3 and ARB_timer_query|VERSION_3_3]
        /// Return parameters of a query object
        /// </summary>
        /// <param name="id">
        /// <para>
        /// Specifies the name of a query object.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_timer_query|VERSION_3_3", Version = "3.3", EntryPoint = "glGetQueryObjectui64v")]
        public static extern void GetQueryObject(UInt32 id, OpenTK.Graphics.OpenGL.GetQueryObjectParam pname, [OutAttribute] UInt64[] @params);

        /// <summary>[requires: v3.3 and ARB_timer_query|VERSION_3_3]
        /// Return parameters of a query object
        /// </summary>
        /// <param name="id">
        /// <para>
        /// Specifies the name of a query object.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_timer_query|VERSION_3_3", Version = "3.3", EntryPoint = "glGetQueryObjectui64v")]
        public static extern void GetQueryObject(UInt32 id, OpenTK.Graphics.OpenGL.GetQueryObjectParam pname, [OutAttribute] out UInt64 @params);

        /// <summary>[requires: v3.3 and ARB_timer_query|VERSION_3_3]
        /// Return parameters of a query object
        /// </summary>
        /// <param name="id">
        /// <para>
        /// Specifies the name of a query object.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_timer_query|VERSION_3_3", Version = "3.3", EntryPoint = "glGetQueryObjectui64v")]
        public static extern unsafe void GetQueryObject(UInt32 id, OpenTK.Graphics.OpenGL.GetQueryObjectParam pname, [OutAttribute] UInt64* @params);

        /// <summary>[requires: v1.5]
        /// Return parameters of a query object
        /// </summary>
        /// <param name="id">
        /// <para>
        /// Specifies the name of a query object.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGetQueryObjectuiv")]
        public static extern void GetQueryObject(UInt32 id, OpenTK.Graphics.OpenGL.GetQueryObjectParam pname, [OutAttribute] UInt32[] @params);

        /// <summary>[requires: v1.5]
        /// Return parameters of a query object
        /// </summary>
        /// <param name="id">
        /// <para>
        /// Specifies the name of a query object.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGetQueryObjectuiv")]
        public static extern void GetQueryObject(UInt32 id, OpenTK.Graphics.OpenGL.GetQueryObjectParam pname, [OutAttribute] out UInt32 @params);

        /// <summary>[requires: v1.5]
        /// Return parameters of a query object
        /// </summary>
        /// <param name="id">
        /// <para>
        /// Specifies the name of a query object.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glGetQueryObjectuiv")]
        public static extern unsafe void GetQueryObject(UInt32 id, OpenTK.Graphics.OpenGL.GetQueryObjectParam pname, [OutAttribute] UInt32* @params);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Retrieve information about a bound renderbuffer object
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target of the query operation. target must be GL_RENDERBUFFER.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the parameter whose value to retrieve from the renderbuffer bound to target.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Specifies the address of an array to receive the value of the queried parameter.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glGetRenderbufferParameteriv")]
        public static extern void GetRenderbufferParameter(OpenTK.Graphics.OpenGL.RenderbufferTarget target, OpenTK.Graphics.OpenGL.RenderbufferParameterName pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Retrieve information about a bound renderbuffer object
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target of the query operation. target must be GL_RENDERBUFFER.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the parameter whose value to retrieve from the renderbuffer bound to target.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Specifies the address of an array to receive the value of the queried parameter.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glGetRenderbufferParameteriv")]
        public static extern void GetRenderbufferParameter(OpenTK.Graphics.OpenGL.RenderbufferTarget target, OpenTK.Graphics.OpenGL.RenderbufferParameterName pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Retrieve information about a bound renderbuffer object
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target of the query operation. target must be GL_RENDERBUFFER.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the parameter whose value to retrieve from the renderbuffer bound to target.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Specifies the address of an array to receive the value of the queried parameter.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glGetRenderbufferParameteriv")]
        public static extern unsafe void GetRenderbufferParameter(OpenTK.Graphics.OpenGL.RenderbufferTarget target, OpenTK.Graphics.OpenGL.RenderbufferParameterName pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Return sampler parameter values
        /// </summary>
        /// <param name="sampler">
        /// <para>
        /// Specifies name of the sampler object from which to retrieve parameters.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a sampler parameter. GL_TEXTURE_MAG_FILTER, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, GL_TEXTURE_WRAP_R, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_COMPARE_MODE, and GL_TEXTURE_COMPARE_FUNC are accepted.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the sampler parameters.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glGetSamplerParameterfv")]
        public static extern void GetSamplerParameter(Int32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, [OutAttribute] Single[] @params);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Return sampler parameter values
        /// </summary>
        /// <param name="sampler">
        /// <para>
        /// Specifies name of the sampler object from which to retrieve parameters.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a sampler parameter. GL_TEXTURE_MAG_FILTER, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, GL_TEXTURE_WRAP_R, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_COMPARE_MODE, and GL_TEXTURE_COMPARE_FUNC are accepted.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the sampler parameters.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glGetSamplerParameterfv")]
        public static extern void GetSamplerParameter(Int32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, [OutAttribute] out Single @params);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Return sampler parameter values
        /// </summary>
        /// <param name="sampler">
        /// <para>
        /// Specifies name of the sampler object from which to retrieve parameters.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a sampler parameter. GL_TEXTURE_MAG_FILTER, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, GL_TEXTURE_WRAP_R, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_COMPARE_MODE, and GL_TEXTURE_COMPARE_FUNC are accepted.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the sampler parameters.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glGetSamplerParameterfv")]
        public static extern unsafe void GetSamplerParameter(Int32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, [OutAttribute] Single* @params);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Return sampler parameter values
        /// </summary>
        /// <param name="sampler">
        /// <para>
        /// Specifies name of the sampler object from which to retrieve parameters.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a sampler parameter. GL_TEXTURE_MAG_FILTER, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, GL_TEXTURE_WRAP_R, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_COMPARE_MODE, and GL_TEXTURE_COMPARE_FUNC are accepted.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the sampler parameters.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glGetSamplerParameterfv")]
        public static extern void GetSamplerParameter(UInt32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, [OutAttribute] Single[] @params);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Return sampler parameter values
        /// </summary>
        /// <param name="sampler">
        /// <para>
        /// Specifies name of the sampler object from which to retrieve parameters.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a sampler parameter. GL_TEXTURE_MAG_FILTER, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, GL_TEXTURE_WRAP_R, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_COMPARE_MODE, and GL_TEXTURE_COMPARE_FUNC are accepted.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the sampler parameters.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glGetSamplerParameterfv")]
        public static extern void GetSamplerParameter(UInt32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, [OutAttribute] out Single @params);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Return sampler parameter values
        /// </summary>
        /// <param name="sampler">
        /// <para>
        /// Specifies name of the sampler object from which to retrieve parameters.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a sampler parameter. GL_TEXTURE_MAG_FILTER, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, GL_TEXTURE_WRAP_R, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_COMPARE_MODE, and GL_TEXTURE_COMPARE_FUNC are accepted.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the sampler parameters.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glGetSamplerParameterfv")]
        public static extern unsafe void GetSamplerParameter(UInt32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, [OutAttribute] Single* @params);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]</summary>
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glGetSamplerParameterIiv")]
        public static extern void GetSamplerParameterI(Int32 sampler, OpenTK.Graphics.OpenGL.All pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]</summary>
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glGetSamplerParameterIiv")]
        public static extern void GetSamplerParameterI(Int32 sampler, OpenTK.Graphics.OpenGL.All pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glGetSamplerParameterIiv")]
        public static extern unsafe void GetSamplerParameterI(Int32 sampler, OpenTK.Graphics.OpenGL.All pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glGetSamplerParameterIiv")]
        public static extern void GetSamplerParameterI(UInt32 sampler, OpenTK.Graphics.OpenGL.All pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glGetSamplerParameterIiv")]
        public static extern void GetSamplerParameterI(UInt32 sampler, OpenTK.Graphics.OpenGL.All pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glGetSamplerParameterIiv")]
        public static extern unsafe void GetSamplerParameterI(UInt32 sampler, OpenTK.Graphics.OpenGL.All pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glGetSamplerParameterIuiv")]
        public static extern void GetSamplerParameterI(UInt32 sampler, OpenTK.Graphics.OpenGL.All pname, [OutAttribute] UInt32[] @params);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glGetSamplerParameterIuiv")]
        public static extern void GetSamplerParameterI(UInt32 sampler, OpenTK.Graphics.OpenGL.All pname, [OutAttribute] out UInt32 @params);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glGetSamplerParameterIuiv")]
        public static extern unsafe void GetSamplerParameterI(UInt32 sampler, OpenTK.Graphics.OpenGL.All pname, [OutAttribute] UInt32* @params);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Return sampler parameter values
        /// </summary>
        /// <param name="sampler">
        /// <para>
        /// Specifies name of the sampler object from which to retrieve parameters.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a sampler parameter. GL_TEXTURE_MAG_FILTER, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, GL_TEXTURE_WRAP_R, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_COMPARE_MODE, and GL_TEXTURE_COMPARE_FUNC are accepted.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the sampler parameters.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glGetSamplerParameteriv")]
        public static extern void GetSamplerParameter(Int32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Return sampler parameter values
        /// </summary>
        /// <param name="sampler">
        /// <para>
        /// Specifies name of the sampler object from which to retrieve parameters.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a sampler parameter. GL_TEXTURE_MAG_FILTER, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, GL_TEXTURE_WRAP_R, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_COMPARE_MODE, and GL_TEXTURE_COMPARE_FUNC are accepted.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the sampler parameters.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glGetSamplerParameteriv")]
        public static extern void GetSamplerParameter(Int32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Return sampler parameter values
        /// </summary>
        /// <param name="sampler">
        /// <para>
        /// Specifies name of the sampler object from which to retrieve parameters.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a sampler parameter. GL_TEXTURE_MAG_FILTER, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, GL_TEXTURE_WRAP_R, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_COMPARE_MODE, and GL_TEXTURE_COMPARE_FUNC are accepted.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the sampler parameters.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glGetSamplerParameteriv")]
        public static extern unsafe void GetSamplerParameter(Int32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Return sampler parameter values
        /// </summary>
        /// <param name="sampler">
        /// <para>
        /// Specifies name of the sampler object from which to retrieve parameters.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a sampler parameter. GL_TEXTURE_MAG_FILTER, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, GL_TEXTURE_WRAP_R, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_COMPARE_MODE, and GL_TEXTURE_COMPARE_FUNC are accepted.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the sampler parameters.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glGetSamplerParameteriv")]
        public static extern void GetSamplerParameter(UInt32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Return sampler parameter values
        /// </summary>
        /// <param name="sampler">
        /// <para>
        /// Specifies name of the sampler object from which to retrieve parameters.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a sampler parameter. GL_TEXTURE_MAG_FILTER, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, GL_TEXTURE_WRAP_R, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_COMPARE_MODE, and GL_TEXTURE_COMPARE_FUNC are accepted.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the sampler parameters.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glGetSamplerParameteriv")]
        public static extern void GetSamplerParameter(UInt32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Return sampler parameter values
        /// </summary>
        /// <param name="sampler">
        /// <para>
        /// Specifies name of the sampler object from which to retrieve parameters.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a sampler parameter. GL_TEXTURE_MAG_FILTER, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, GL_TEXTURE_WRAP_R, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_COMPARE_MODE, and GL_TEXTURE_COMPARE_FUNC are accepted.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the sampler parameters.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glGetSamplerParameteriv")]
        public static extern unsafe void GetSamplerParameter(UInt32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, [OutAttribute] Int32* @params);

        /// <summary>
        /// Get separable convolution filter kernel images
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The separable filter to be retrieved. Must be GL_SEPARABLE_2D.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Format of the output images. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Data type of components in the output images. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="row">
        /// <para>
        /// Pointer to storage for the row filter image.
        /// </para>
        /// </param>
        /// <param name="column">
        /// <para>
        /// Pointer to storage for the column filter image.
        /// </para>
        /// </param>
        /// <param name="span">
        /// <para>
        /// Pointer to storage for the span filter image (currently unused).
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetSeparableFilter")]
        public static extern void GetSeparableFilter(OpenTK.Graphics.OpenGL.SeparableTarget target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [OutAttribute] IntPtr row, [OutAttribute] IntPtr column, [OutAttribute] IntPtr span);

        /// <summary>
        /// Get separable convolution filter kernel images
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The separable filter to be retrieved. Must be GL_SEPARABLE_2D.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Format of the output images. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Data type of components in the output images. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="row">
        /// <para>
        /// Pointer to storage for the row filter image.
        /// </para>
        /// </param>
        /// <param name="column">
        /// <para>
        /// Pointer to storage for the column filter image.
        /// </para>
        /// </param>
        /// <param name="span">
        /// <para>
        /// Pointer to storage for the span filter image (currently unused).
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetSeparableFilter")]
        public static extern void GetSeparableFilter<T3,T4,T5>(OpenTK.Graphics.OpenGL.SeparableTarget target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T3[] row, [InAttribute, OutAttribute] T4[] column, [InAttribute, OutAttribute] T5[] span)
            where T3 : struct
            where T4 : struct
            where T5 : struct
        ;

        /// <summary>
        /// Get separable convolution filter kernel images
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The separable filter to be retrieved. Must be GL_SEPARABLE_2D.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Format of the output images. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Data type of components in the output images. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="row">
        /// <para>
        /// Pointer to storage for the row filter image.
        /// </para>
        /// </param>
        /// <param name="column">
        /// <para>
        /// Pointer to storage for the column filter image.
        /// </para>
        /// </param>
        /// <param name="span">
        /// <para>
        /// Pointer to storage for the span filter image (currently unused).
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetSeparableFilter")]
        public static extern void GetSeparableFilter<T3,T4,T5>(OpenTK.Graphics.OpenGL.SeparableTarget target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T3[,] row, [InAttribute, OutAttribute] T4[,] column, [InAttribute, OutAttribute] T5[,] span)
            where T3 : struct
            where T4 : struct
            where T5 : struct
        ;

        /// <summary>
        /// Get separable convolution filter kernel images
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The separable filter to be retrieved. Must be GL_SEPARABLE_2D.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Format of the output images. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Data type of components in the output images. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="row">
        /// <para>
        /// Pointer to storage for the row filter image.
        /// </para>
        /// </param>
        /// <param name="column">
        /// <para>
        /// Pointer to storage for the column filter image.
        /// </para>
        /// </param>
        /// <param name="span">
        /// <para>
        /// Pointer to storage for the span filter image (currently unused).
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetSeparableFilter")]
        public static extern void GetSeparableFilter<T3,T4,T5>(OpenTK.Graphics.OpenGL.SeparableTarget target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T3[,,] row, [InAttribute, OutAttribute] T4[,,] column, [InAttribute, OutAttribute] T5[,,] span)
            where T3 : struct
            where T4 : struct
            where T5 : struct
        ;

        /// <summary>
        /// Get separable convolution filter kernel images
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The separable filter to be retrieved. Must be GL_SEPARABLE_2D.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Format of the output images. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Data type of components in the output images. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="row">
        /// <para>
        /// Pointer to storage for the row filter image.
        /// </para>
        /// </param>
        /// <param name="column">
        /// <para>
        /// Pointer to storage for the column filter image.
        /// </para>
        /// </param>
        /// <param name="span">
        /// <para>
        /// Pointer to storage for the span filter image (currently unused).
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glGetSeparableFilter")]
        public static extern void GetSeparableFilter<T3,T4,T5>(OpenTK.Graphics.OpenGL.SeparableTarget target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T3 row, [InAttribute, OutAttribute] ref T4 column, [InAttribute, OutAttribute] ref T5 span)
            where T3 : struct
            where T4 : struct
            where T5 : struct
        ;

        /// <summary>[requires: v2.0]
        /// Returns the information log for a shader object
        /// </summary>
        /// <param name="shader">
        /// <para>
        /// Specifies the shader object whose information log is to be queried.
        /// </para>
        /// </param>
        /// <param name="maxLength">
        /// <para>
        /// Specifies the size of the character buffer for storing the returned information log.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Returns the length of the string returned in infoLog (excluding the null terminator).
        /// </para>
        /// </param>
        /// <param name="infoLog">
        /// <para>
        /// Specifies an array of characters that is used to return the information log.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetShaderInfoLog")]
        public static extern void GetShaderInfoLog(Int32 shader, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder infoLog);

        /// <summary>[requires: v2.0]
        /// Returns the information log for a shader object
        /// </summary>
        /// <param name="shader">
        /// <para>
        /// Specifies the shader object whose information log is to be queried.
        /// </para>
        /// </param>
        /// <param name="maxLength">
        /// <para>
        /// Specifies the size of the character buffer for storing the returned information log.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Returns the length of the string returned in infoLog (excluding the null terminator).
        /// </para>
        /// </param>
        /// <param name="infoLog">
        /// <para>
        /// Specifies an array of characters that is used to return the information log.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetShaderInfoLog")]
        public static extern unsafe void GetShaderInfoLog(Int32 shader, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder infoLog);

        /// <summary>[requires: v2.0]
        /// Returns the information log for a shader object
        /// </summary>
        /// <param name="shader">
        /// <para>
        /// Specifies the shader object whose information log is to be queried.
        /// </para>
        /// </param>
        /// <param name="maxLength">
        /// <para>
        /// Specifies the size of the character buffer for storing the returned information log.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Returns the length of the string returned in infoLog (excluding the null terminator).
        /// </para>
        /// </param>
        /// <param name="infoLog">
        /// <para>
        /// Specifies an array of characters that is used to return the information log.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetShaderInfoLog")]
        public static extern void GetShaderInfoLog(UInt32 shader, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder infoLog);

        /// <summary>[requires: v2.0]
        /// Returns the information log for a shader object
        /// </summary>
        /// <param name="shader">
        /// <para>
        /// Specifies the shader object whose information log is to be queried.
        /// </para>
        /// </param>
        /// <param name="maxLength">
        /// <para>
        /// Specifies the size of the character buffer for storing the returned information log.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Returns the length of the string returned in infoLog (excluding the null terminator).
        /// </para>
        /// </param>
        /// <param name="infoLog">
        /// <para>
        /// Specifies an array of characters that is used to return the information log.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetShaderInfoLog")]
        public static extern unsafe void GetShaderInfoLog(UInt32 shader, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder infoLog);

        /// <summary>[requires: v2.0]
        /// Returns a parameter from a shader object
        /// </summary>
        /// <param name="shader">
        /// <para>
        /// Specifies the shader object to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the object parameter. Accepted symbolic names are GL_SHADER_TYPE, GL_DELETE_STATUS, GL_COMPILE_STATUS, GL_INFO_LOG_LENGTH, GL_SHADER_SOURCE_LENGTH.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested object parameter.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetShaderiv")]
        public static extern void GetShader(Int32 shader, OpenTK.Graphics.OpenGL.ShaderParameter pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v2.0]
        /// Returns a parameter from a shader object
        /// </summary>
        /// <param name="shader">
        /// <para>
        /// Specifies the shader object to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the object parameter. Accepted symbolic names are GL_SHADER_TYPE, GL_DELETE_STATUS, GL_COMPILE_STATUS, GL_INFO_LOG_LENGTH, GL_SHADER_SOURCE_LENGTH.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested object parameter.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetShaderiv")]
        public static extern void GetShader(Int32 shader, OpenTK.Graphics.OpenGL.ShaderParameter pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v2.0]
        /// Returns a parameter from a shader object
        /// </summary>
        /// <param name="shader">
        /// <para>
        /// Specifies the shader object to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the object parameter. Accepted symbolic names are GL_SHADER_TYPE, GL_DELETE_STATUS, GL_COMPILE_STATUS, GL_INFO_LOG_LENGTH, GL_SHADER_SOURCE_LENGTH.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested object parameter.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetShaderiv")]
        public static extern unsafe void GetShader(Int32 shader, OpenTK.Graphics.OpenGL.ShaderParameter pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v2.0]
        /// Returns a parameter from a shader object
        /// </summary>
        /// <param name="shader">
        /// <para>
        /// Specifies the shader object to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the object parameter. Accepted symbolic names are GL_SHADER_TYPE, GL_DELETE_STATUS, GL_COMPILE_STATUS, GL_INFO_LOG_LENGTH, GL_SHADER_SOURCE_LENGTH.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested object parameter.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetShaderiv")]
        public static extern void GetShader(UInt32 shader, OpenTK.Graphics.OpenGL.ShaderParameter pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v2.0]
        /// Returns a parameter from a shader object
        /// </summary>
        /// <param name="shader">
        /// <para>
        /// Specifies the shader object to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the object parameter. Accepted symbolic names are GL_SHADER_TYPE, GL_DELETE_STATUS, GL_COMPILE_STATUS, GL_INFO_LOG_LENGTH, GL_SHADER_SOURCE_LENGTH.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested object parameter.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetShaderiv")]
        public static extern void GetShader(UInt32 shader, OpenTK.Graphics.OpenGL.ShaderParameter pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v2.0]
        /// Returns a parameter from a shader object
        /// </summary>
        /// <param name="shader">
        /// <para>
        /// Specifies the shader object to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the object parameter. Accepted symbolic names are GL_SHADER_TYPE, GL_DELETE_STATUS, GL_COMPILE_STATUS, GL_INFO_LOG_LENGTH, GL_SHADER_SOURCE_LENGTH.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested object parameter.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetShaderiv")]
        public static extern unsafe void GetShader(UInt32 shader, OpenTK.Graphics.OpenGL.ShaderParameter pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Retrieve the range and precision for numeric formats supported by the shader compiler
        /// </summary>
        /// <param name="shaderType">
        /// <para>
        /// Specifies the type of shader whose precision to query. shaderType must be GL_VERTEX_SHADER or GL_FRAGMENT_SHADER.
        /// </para>
        /// </param>
        /// <param name="precisionType">
        /// <para>
        /// Specifies the numeric format whose precision and range to query.
        /// </para>
        /// </param>
        /// <param name="range">
        /// <para>
        /// Specifies the address of array of two integers into which encodings of the implementation's numeric range are returned.
        /// </para>
        /// </param>
        /// <param name="precision">
        /// <para>
        /// Specifies the address of an integer into which the numeric precision of the implementation is written.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glGetShaderPrecisionFormat")]
        public static extern void GetShaderPrecisionFormat(OpenTK.Graphics.OpenGL.ShaderType shadertype, OpenTK.Graphics.OpenGL.ShaderPrecision precisiontype, [OutAttribute] Int32[] range, [OutAttribute] Int32[] precision);

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Retrieve the range and precision for numeric formats supported by the shader compiler
        /// </summary>
        /// <param name="shaderType">
        /// <para>
        /// Specifies the type of shader whose precision to query. shaderType must be GL_VERTEX_SHADER or GL_FRAGMENT_SHADER.
        /// </para>
        /// </param>
        /// <param name="precisionType">
        /// <para>
        /// Specifies the numeric format whose precision and range to query.
        /// </para>
        /// </param>
        /// <param name="range">
        /// <para>
        /// Specifies the address of array of two integers into which encodings of the implementation's numeric range are returned.
        /// </para>
        /// </param>
        /// <param name="precision">
        /// <para>
        /// Specifies the address of an integer into which the numeric precision of the implementation is written.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glGetShaderPrecisionFormat")]
        public static extern void GetShaderPrecisionFormat(OpenTK.Graphics.OpenGL.ShaderType shadertype, OpenTK.Graphics.OpenGL.ShaderPrecision precisiontype, [OutAttribute] out Int32 range, [OutAttribute] out Int32 precision);

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Retrieve the range and precision for numeric formats supported by the shader compiler
        /// </summary>
        /// <param name="shaderType">
        /// <para>
        /// Specifies the type of shader whose precision to query. shaderType must be GL_VERTEX_SHADER or GL_FRAGMENT_SHADER.
        /// </para>
        /// </param>
        /// <param name="precisionType">
        /// <para>
        /// Specifies the numeric format whose precision and range to query.
        /// </para>
        /// </param>
        /// <param name="range">
        /// <para>
        /// Specifies the address of array of two integers into which encodings of the implementation's numeric range are returned.
        /// </para>
        /// </param>
        /// <param name="precision">
        /// <para>
        /// Specifies the address of an integer into which the numeric precision of the implementation is written.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glGetShaderPrecisionFormat")]
        public static extern unsafe void GetShaderPrecisionFormat(OpenTK.Graphics.OpenGL.ShaderType shadertype, OpenTK.Graphics.OpenGL.ShaderPrecision precisiontype, [OutAttribute] Int32* range, [OutAttribute] Int32* precision);

        /// <summary>[requires: v2.0]
        /// Returns the source code string from a shader object
        /// </summary>
        /// <param name="shader">
        /// <para>
        /// Specifies the shader object to be queried.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the character buffer for storing the returned source code string.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Returns the length of the string returned in source (excluding the null terminator).
        /// </para>
        /// </param>
        /// <param name="source">
        /// <para>
        /// Specifies an array of characters that is used to return the source code string.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetShaderSource")]
        public static extern void GetShaderSource(Int32 shader, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder source);

        /// <summary>[requires: v2.0]
        /// Returns the source code string from a shader object
        /// </summary>
        /// <param name="shader">
        /// <para>
        /// Specifies the shader object to be queried.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the character buffer for storing the returned source code string.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Returns the length of the string returned in source (excluding the null terminator).
        /// </para>
        /// </param>
        /// <param name="source">
        /// <para>
        /// Specifies an array of characters that is used to return the source code string.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetShaderSource")]
        public static extern unsafe void GetShaderSource(Int32 shader, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder source);

        /// <summary>[requires: v2.0]
        /// Returns the source code string from a shader object
        /// </summary>
        /// <param name="shader">
        /// <para>
        /// Specifies the shader object to be queried.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the character buffer for storing the returned source code string.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Returns the length of the string returned in source (excluding the null terminator).
        /// </para>
        /// </param>
        /// <param name="source">
        /// <para>
        /// Specifies an array of characters that is used to return the source code string.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetShaderSource")]
        public static extern void GetShaderSource(UInt32 shader, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder source);

        /// <summary>[requires: v2.0]
        /// Returns the source code string from a shader object
        /// </summary>
        /// <param name="shader">
        /// <para>
        /// Specifies the shader object to be queried.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the character buffer for storing the returned source code string.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Returns the length of the string returned in source (excluding the null terminator).
        /// </para>
        /// </param>
        /// <param name="source">
        /// <para>
        /// Specifies an array of characters that is used to return the source code string.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetShaderSource")]
        public static extern unsafe void GetShaderSource(UInt32 shader, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder source);

        /// <summary>[requires: v1.0]
        /// Return a string describing the current GL connection
        /// </summary>
        /// <param name="name">
        /// <para>
        /// Specifies a symbolic constant, one of GL_VENDOR, GL_RENDERER, GL_VERSION, or GL_SHADING_LANGUAGE_VERSION. Additionally, glGetStringi accepts the GL_EXTENSIONS token.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// For glGetStringi, specifies the index of the string to return.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetString")]
        public static extern String GetString(OpenTK.Graphics.OpenGL.StringName name);

        /// <summary>[requires: v3.0]
        /// Return a string describing the current GL connection
        /// </summary>
        /// <param name="name">
        /// <para>
        /// Specifies a symbolic constant, one of GL_VENDOR, GL_RENDERER, GL_VERSION, or GL_SHADING_LANGUAGE_VERSION. Additionally, glGetStringi accepts the GL_EXTENSIONS token.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// For glGetStringi, specifies the index of the string to return.
        /// </para>
        /// </param>
        [Obsolete("Use StringNameIndexed overload instead")]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetStringi")]
        public static extern String GetString(OpenTK.Graphics.OpenGL.StringName name, Int32 index);

        /// <summary>[requires: v3.0]
        /// Return a string describing the current GL connection
        /// </summary>
        /// <param name="name">
        /// <para>
        /// Specifies a symbolic constant, one of GL_VENDOR, GL_RENDERER, GL_VERSION, or GL_SHADING_LANGUAGE_VERSION. Additionally, glGetStringi accepts the GL_EXTENSIONS token.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// For glGetStringi, specifies the index of the string to return.
        /// </para>
        /// </param>
        [Obsolete("Use StringNameIndexed overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetStringi")]
        public static extern String GetString(OpenTK.Graphics.OpenGL.StringName name, UInt32 index);

        /// <summary>[requires: v3.0]
        /// Return a string describing the current GL connection
        /// </summary>
        /// <param name="name">
        /// <para>
        /// Specifies a symbolic constant, one of GL_VENDOR, GL_RENDERER, GL_VERSION, or GL_SHADING_LANGUAGE_VERSION. Additionally, glGetStringi accepts the GL_EXTENSIONS token.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// For glGetStringi, specifies the index of the string to return.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetStringi")]
        public static extern String GetString(OpenTK.Graphics.OpenGL.StringNameIndexed name, Int32 index);

        /// <summary>[requires: v3.0]
        /// Return a string describing the current GL connection
        /// </summary>
        /// <param name="name">
        /// <para>
        /// Specifies a symbolic constant, one of GL_VENDOR, GL_RENDERER, GL_VERSION, or GL_SHADING_LANGUAGE_VERSION. Additionally, glGetStringi accepts the GL_EXTENSIONS token.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// For glGetStringi, specifies the index of the string to return.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetStringi")]
        public static extern String GetString(OpenTK.Graphics.OpenGL.StringNameIndexed name, UInt32 index);

        /// <summary>[requires: v4.0 and ARB_shader_subroutine|VERSION_4_0]
        /// Retrieve the index of a subroutine uniform of a given shader stage within a program
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of the program containing shader stage.
        /// </para>
        /// </param>
        /// <param name="shadertype">
        /// <para>
        /// Specifies the shader stage from which to query for subroutine uniform index. shadertype must be one of GL_VERTEX_SHADER, GL_TESS_CONTROL_SHADER, GL_TESS_EVALUATION_SHADER, GL_GEOMETRY_SHADER or GL_FRAGMENT_SHADER.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// Specifies the name of the subroutine uniform whose index to query.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_shader_subroutine|VERSION_4_0", Version = "4.0", EntryPoint = "glGetSubroutineIndex")]
        public static extern Int32 GetSubroutineIndex(Int32 program, OpenTK.Graphics.OpenGL.ShaderType shadertype, String name);

        /// <summary>[requires: v4.0 and ARB_shader_subroutine|VERSION_4_0]
        /// Retrieve the index of a subroutine uniform of a given shader stage within a program
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of the program containing shader stage.
        /// </para>
        /// </param>
        /// <param name="shadertype">
        /// <para>
        /// Specifies the shader stage from which to query for subroutine uniform index. shadertype must be one of GL_VERTEX_SHADER, GL_TESS_CONTROL_SHADER, GL_TESS_EVALUATION_SHADER, GL_GEOMETRY_SHADER or GL_FRAGMENT_SHADER.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// Specifies the name of the subroutine uniform whose index to query.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_shader_subroutine|VERSION_4_0", Version = "4.0", EntryPoint = "glGetSubroutineIndex")]
        public static extern Int32 GetSubroutineIndex(UInt32 program, OpenTK.Graphics.OpenGL.ShaderType shadertype, String name);

        /// <summary>[requires: v4.0 and ARB_shader_subroutine|VERSION_4_0]
        /// Retrieve the location of a subroutine uniform of a given shader stage within a program
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of the program containing shader stage.
        /// </para>
        /// </param>
        /// <param name="shadertype">
        /// <para>
        /// Specifies the shader stage from which to query for subroutine uniform index. shadertype must be one of GL_VERTEX_SHADER, GL_TESS_CONTROL_SHADER, GL_TESS_EVALUATION_SHADER, GL_GEOMETRY_SHADER or GL_FRAGMENT_SHADER.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// Specifies the name of the subroutine uniform whose index to query.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_shader_subroutine|VERSION_4_0", Version = "4.0", EntryPoint = "glGetSubroutineUniformLocation")]
        public static extern Int32 GetSubroutineUniformLocation(Int32 program, OpenTK.Graphics.OpenGL.ShaderType shadertype, String name);

        /// <summary>[requires: v4.0 and ARB_shader_subroutine|VERSION_4_0]
        /// Retrieve the location of a subroutine uniform of a given shader stage within a program
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of the program containing shader stage.
        /// </para>
        /// </param>
        /// <param name="shadertype">
        /// <para>
        /// Specifies the shader stage from which to query for subroutine uniform index. shadertype must be one of GL_VERTEX_SHADER, GL_TESS_CONTROL_SHADER, GL_TESS_EVALUATION_SHADER, GL_GEOMETRY_SHADER or GL_FRAGMENT_SHADER.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// Specifies the name of the subroutine uniform whose index to query.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_shader_subroutine|VERSION_4_0", Version = "4.0", EntryPoint = "glGetSubroutineUniformLocation")]
        public static extern Int32 GetSubroutineUniformLocation(UInt32 program, OpenTK.Graphics.OpenGL.ShaderType shadertype, String name);

        /// <summary>[requires: v3.2 and ARB_sync|VERSION_3_2]
        /// Query the properties of a sync object
        /// </summary>
        /// <param name="sync">
        /// <para>
        /// Specifies the sync object whose properties to query.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the parameter whose value to retrieve from the sync object specified in sync.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the buffer whose address is given in values.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of an variable to receive the number of integers placed in values.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies the address of an array to receive the values of the queried parameter.
        /// </para>
        /// </param>
        [Obsolete("Use SyncParameterName overload instead")]
        [AutoGenerated(Category = "ARB_sync|VERSION_3_2", Version = "3.2", EntryPoint = "glGetSynciv")]
        public static extern void GetSync(IntPtr sync, OpenTK.Graphics.OpenGL.ArbSync pname, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] Int32[] values);

        /// <summary>[requires: v3.2 and ARB_sync|VERSION_3_2]
        /// Query the properties of a sync object
        /// </summary>
        /// <param name="sync">
        /// <para>
        /// Specifies the sync object whose properties to query.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the parameter whose value to retrieve from the sync object specified in sync.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the buffer whose address is given in values.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of an variable to receive the number of integers placed in values.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies the address of an array to receive the values of the queried parameter.
        /// </para>
        /// </param>
        [Obsolete("Use SyncParameterName overload instead")]
        [AutoGenerated(Category = "ARB_sync|VERSION_3_2", Version = "3.2", EntryPoint = "glGetSynciv")]
        public static extern void GetSync(IntPtr sync, OpenTK.Graphics.OpenGL.ArbSync pname, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] out Int32 values);

        /// <summary>[requires: v3.2 and ARB_sync|VERSION_3_2]
        /// Query the properties of a sync object
        /// </summary>
        /// <param name="sync">
        /// <para>
        /// Specifies the sync object whose properties to query.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the parameter whose value to retrieve from the sync object specified in sync.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the buffer whose address is given in values.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of an variable to receive the number of integers placed in values.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies the address of an array to receive the values of the queried parameter.
        /// </para>
        /// </param>
        [Obsolete("Use SyncParameterName overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sync|VERSION_3_2", Version = "3.2", EntryPoint = "glGetSynciv")]
        public static extern unsafe void GetSync(IntPtr sync, OpenTK.Graphics.OpenGL.ArbSync pname, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] Int32* values);

        /// <summary>[requires: v3.2 and ARB_sync|VERSION_3_2]
        /// Query the properties of a sync object
        /// </summary>
        /// <param name="sync">
        /// <para>
        /// Specifies the sync object whose properties to query.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the parameter whose value to retrieve from the sync object specified in sync.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the buffer whose address is given in values.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of an variable to receive the number of integers placed in values.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies the address of an array to receive the values of the queried parameter.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_sync|VERSION_3_2", Version = "3.2", EntryPoint = "glGetSynciv")]
        public static extern void GetSync(IntPtr sync, OpenTK.Graphics.OpenGL.SyncParameterName pname, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] Int32[] values);

        /// <summary>[requires: v3.2 and ARB_sync|VERSION_3_2]
        /// Query the properties of a sync object
        /// </summary>
        /// <param name="sync">
        /// <para>
        /// Specifies the sync object whose properties to query.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the parameter whose value to retrieve from the sync object specified in sync.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the buffer whose address is given in values.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of an variable to receive the number of integers placed in values.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies the address of an array to receive the values of the queried parameter.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_sync|VERSION_3_2", Version = "3.2", EntryPoint = "glGetSynciv")]
        public static extern void GetSync(IntPtr sync, OpenTK.Graphics.OpenGL.SyncParameterName pname, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] out Int32 values);

        /// <summary>[requires: v3.2 and ARB_sync|VERSION_3_2]
        /// Query the properties of a sync object
        /// </summary>
        /// <param name="sync">
        /// <para>
        /// Specifies the sync object whose properties to query.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the parameter whose value to retrieve from the sync object specified in sync.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// Specifies the size of the buffer whose address is given in values.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the address of an variable to receive the number of integers placed in values.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies the address of an array to receive the values of the queried parameter.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sync|VERSION_3_2", Version = "3.2", EntryPoint = "glGetSynciv")]
        public static extern unsafe void GetSync(IntPtr sync, OpenTK.Graphics.OpenGL.SyncParameterName pname, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] Int32* values);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return texture environment parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies a texture environment. May be GL_TEXTURE_ENV, GL_TEXTURE_FILTER_CONTROL, or GL_POINT_SPRITE.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a texture environment parameter. Accepted values are GL_TEXTURE_ENV_MODE, GL_TEXTURE_ENV_COLOR, GL_TEXTURE_LOD_BIAS, GL_COMBINE_RGB, GL_COMBINE_ALPHA, GL_SRC0_RGB, GL_SRC1_RGB, GL_SRC2_RGB, GL_SRC0_ALPHA, GL_SRC1_ALPHA, GL_SRC2_ALPHA, GL_OPERAND0_RGB, GL_OPERAND1_RGB, GL_OPERAND2_RGB, GL_OPERAND0_ALPHA, GL_OPERAND1_ALPHA, GL_OPERAND2_ALPHA, GL_RGB_SCALE, GL_ALPHA_SCALE, or GL_COORD_REPLACE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetTexEnvfv")]
        public static extern void GetTexEnv(OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, [OutAttribute] Single[] @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return texture environment parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies a texture environment. May be GL_TEXTURE_ENV, GL_TEXTURE_FILTER_CONTROL, or GL_POINT_SPRITE.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a texture environment parameter. Accepted values are GL_TEXTURE_ENV_MODE, GL_TEXTURE_ENV_COLOR, GL_TEXTURE_LOD_BIAS, GL_COMBINE_RGB, GL_COMBINE_ALPHA, GL_SRC0_RGB, GL_SRC1_RGB, GL_SRC2_RGB, GL_SRC0_ALPHA, GL_SRC1_ALPHA, GL_SRC2_ALPHA, GL_OPERAND0_RGB, GL_OPERAND1_RGB, GL_OPERAND2_RGB, GL_OPERAND0_ALPHA, GL_OPERAND1_ALPHA, GL_OPERAND2_ALPHA, GL_RGB_SCALE, GL_ALPHA_SCALE, or GL_COORD_REPLACE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetTexEnvfv")]
        public static extern void GetTexEnv(OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, [OutAttribute] out Single @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return texture environment parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies a texture environment. May be GL_TEXTURE_ENV, GL_TEXTURE_FILTER_CONTROL, or GL_POINT_SPRITE.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a texture environment parameter. Accepted values are GL_TEXTURE_ENV_MODE, GL_TEXTURE_ENV_COLOR, GL_TEXTURE_LOD_BIAS, GL_COMBINE_RGB, GL_COMBINE_ALPHA, GL_SRC0_RGB, GL_SRC1_RGB, GL_SRC2_RGB, GL_SRC0_ALPHA, GL_SRC1_ALPHA, GL_SRC2_ALPHA, GL_OPERAND0_RGB, GL_OPERAND1_RGB, GL_OPERAND2_RGB, GL_OPERAND0_ALPHA, GL_OPERAND1_ALPHA, GL_OPERAND2_ALPHA, GL_RGB_SCALE, GL_ALPHA_SCALE, or GL_COORD_REPLACE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetTexEnvfv")]
        public static extern unsafe void GetTexEnv(OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, [OutAttribute] Single* @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return texture environment parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies a texture environment. May be GL_TEXTURE_ENV, GL_TEXTURE_FILTER_CONTROL, or GL_POINT_SPRITE.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a texture environment parameter. Accepted values are GL_TEXTURE_ENV_MODE, GL_TEXTURE_ENV_COLOR, GL_TEXTURE_LOD_BIAS, GL_COMBINE_RGB, GL_COMBINE_ALPHA, GL_SRC0_RGB, GL_SRC1_RGB, GL_SRC2_RGB, GL_SRC0_ALPHA, GL_SRC1_ALPHA, GL_SRC2_ALPHA, GL_OPERAND0_RGB, GL_OPERAND1_RGB, GL_OPERAND2_RGB, GL_OPERAND0_ALPHA, GL_OPERAND1_ALPHA, GL_OPERAND2_ALPHA, GL_RGB_SCALE, GL_ALPHA_SCALE, or GL_COORD_REPLACE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetTexEnviv")]
        public static extern void GetTexEnv(OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return texture environment parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies a texture environment. May be GL_TEXTURE_ENV, GL_TEXTURE_FILTER_CONTROL, or GL_POINT_SPRITE.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a texture environment parameter. Accepted values are GL_TEXTURE_ENV_MODE, GL_TEXTURE_ENV_COLOR, GL_TEXTURE_LOD_BIAS, GL_COMBINE_RGB, GL_COMBINE_ALPHA, GL_SRC0_RGB, GL_SRC1_RGB, GL_SRC2_RGB, GL_SRC0_ALPHA, GL_SRC1_ALPHA, GL_SRC2_ALPHA, GL_OPERAND0_RGB, GL_OPERAND1_RGB, GL_OPERAND2_RGB, GL_OPERAND0_ALPHA, GL_OPERAND1_ALPHA, GL_OPERAND2_ALPHA, GL_RGB_SCALE, GL_ALPHA_SCALE, or GL_COORD_REPLACE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetTexEnviv")]
        public static extern void GetTexEnv(OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return texture environment parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies a texture environment. May be GL_TEXTURE_ENV, GL_TEXTURE_FILTER_CONTROL, or GL_POINT_SPRITE.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a texture environment parameter. Accepted values are GL_TEXTURE_ENV_MODE, GL_TEXTURE_ENV_COLOR, GL_TEXTURE_LOD_BIAS, GL_COMBINE_RGB, GL_COMBINE_ALPHA, GL_SRC0_RGB, GL_SRC1_RGB, GL_SRC2_RGB, GL_SRC0_ALPHA, GL_SRC1_ALPHA, GL_SRC2_ALPHA, GL_OPERAND0_RGB, GL_OPERAND1_RGB, GL_OPERAND2_RGB, GL_OPERAND0_ALPHA, GL_OPERAND1_ALPHA, GL_OPERAND2_ALPHA, GL_RGB_SCALE, GL_ALPHA_SCALE, or GL_COORD_REPLACE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetTexEnviv")]
        public static extern unsafe void GetTexEnv(OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return texture coordinate generation parameters
        /// </summary>
        /// <param name="coord">
        /// <para>
        /// Specifies a texture coordinate. Must be GL_S, GL_T, GL_R, or GL_Q.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the value(s) to be returned. Must be either GL_TEXTURE_GEN_MODE or the name of one of the texture generation plane equations: GL_OBJECT_PLANE or GL_EYE_PLANE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetTexGendv")]
        public static extern void GetTexGen(OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, [OutAttribute] Double[] @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return texture coordinate generation parameters
        /// </summary>
        /// <param name="coord">
        /// <para>
        /// Specifies a texture coordinate. Must be GL_S, GL_T, GL_R, or GL_Q.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the value(s) to be returned. Must be either GL_TEXTURE_GEN_MODE or the name of one of the texture generation plane equations: GL_OBJECT_PLANE or GL_EYE_PLANE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetTexGendv")]
        public static extern void GetTexGen(OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, [OutAttribute] out Double @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return texture coordinate generation parameters
        /// </summary>
        /// <param name="coord">
        /// <para>
        /// Specifies a texture coordinate. Must be GL_S, GL_T, GL_R, or GL_Q.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the value(s) to be returned. Must be either GL_TEXTURE_GEN_MODE or the name of one of the texture generation plane equations: GL_OBJECT_PLANE or GL_EYE_PLANE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetTexGendv")]
        public static extern unsafe void GetTexGen(OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, [OutAttribute] Double* @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return texture coordinate generation parameters
        /// </summary>
        /// <param name="coord">
        /// <para>
        /// Specifies a texture coordinate. Must be GL_S, GL_T, GL_R, or GL_Q.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the value(s) to be returned. Must be either GL_TEXTURE_GEN_MODE or the name of one of the texture generation plane equations: GL_OBJECT_PLANE or GL_EYE_PLANE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetTexGenfv")]
        public static extern void GetTexGen(OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, [OutAttribute] Single[] @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return texture coordinate generation parameters
        /// </summary>
        /// <param name="coord">
        /// <para>
        /// Specifies a texture coordinate. Must be GL_S, GL_T, GL_R, or GL_Q.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the value(s) to be returned. Must be either GL_TEXTURE_GEN_MODE or the name of one of the texture generation plane equations: GL_OBJECT_PLANE or GL_EYE_PLANE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetTexGenfv")]
        public static extern void GetTexGen(OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, [OutAttribute] out Single @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return texture coordinate generation parameters
        /// </summary>
        /// <param name="coord">
        /// <para>
        /// Specifies a texture coordinate. Must be GL_S, GL_T, GL_R, or GL_Q.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the value(s) to be returned. Must be either GL_TEXTURE_GEN_MODE or the name of one of the texture generation plane equations: GL_OBJECT_PLANE or GL_EYE_PLANE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetTexGenfv")]
        public static extern unsafe void GetTexGen(OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, [OutAttribute] Single* @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return texture coordinate generation parameters
        /// </summary>
        /// <param name="coord">
        /// <para>
        /// Specifies a texture coordinate. Must be GL_S, GL_T, GL_R, or GL_Q.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the value(s) to be returned. Must be either GL_TEXTURE_GEN_MODE or the name of one of the texture generation plane equations: GL_OBJECT_PLANE or GL_EYE_PLANE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetTexGeniv")]
        public static extern void GetTexGen(OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return texture coordinate generation parameters
        /// </summary>
        /// <param name="coord">
        /// <para>
        /// Specifies a texture coordinate. Must be GL_S, GL_T, GL_R, or GL_Q.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the value(s) to be returned. Must be either GL_TEXTURE_GEN_MODE or the name of one of the texture generation plane equations: GL_OBJECT_PLANE or GL_EYE_PLANE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetTexGeniv")]
        public static extern void GetTexGen(OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Return texture coordinate generation parameters
        /// </summary>
        /// <param name="coord">
        /// <para>
        /// Specifies a texture coordinate. Must be GL_S, GL_T, GL_R, or GL_Q.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the value(s) to be returned. Must be either GL_TEXTURE_GEN_MODE or the name of one of the texture generation plane equations: GL_OBJECT_PLANE or GL_EYE_PLANE.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetTexGeniv")]
        public static extern unsafe void GetTexGen(OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v1.0]
        /// Return a texture image
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies which texture is to be obtained. GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_RECTANGLE, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, and GL_TEXTURE_CUBE_MAP_NEGATIVE_Z are accepted.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number of the desired image. Level 0 is the base image level. Level is the th mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies a pixel format for the returned data. The supported formats are GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_DEPTH_STENCIL, GL_RED, GL_GREEN, GL_BLUE, GL_RG, GL_RGB, GL_RGBA, GL_BGR, GL_BGRA, GL_RED_INTEGER, GL_GREEN_INTEGER, GL_BLUE_INTEGER, GL_RG_INTEGER, GL_RGB_INTEGER, GL_RGBA_INTEGER, GL_BGR_INTEGER, GL_BGRA_INTEGER.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies a pixel type for the returned data. The supported types are GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_HALF_FLOAT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, GL_UNSIGNED_INT_2_10_10_10_REV, GL_UNSIGNED_INT_24_8, GL_UNSIGNED_INT_10F_11F_11F_REV, GL_UNSIGNED_INT_5_9_9_9_REV, and GL_FLOAT_32_UNSIGNED_INT_24_8_REV.
        /// </para>
        /// </param>
        /// <param name="img">
        /// <para>
        /// Returns the texture image. Should be a pointer to an array of the type specified by type.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetTexImage")]
        public static extern void GetTexImage(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [OutAttribute] IntPtr pixels);

        /// <summary>[requires: v1.0]
        /// Return a texture image
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies which texture is to be obtained. GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_RECTANGLE, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, and GL_TEXTURE_CUBE_MAP_NEGATIVE_Z are accepted.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number of the desired image. Level 0 is the base image level. Level is the th mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies a pixel format for the returned data. The supported formats are GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_DEPTH_STENCIL, GL_RED, GL_GREEN, GL_BLUE, GL_RG, GL_RGB, GL_RGBA, GL_BGR, GL_BGRA, GL_RED_INTEGER, GL_GREEN_INTEGER, GL_BLUE_INTEGER, GL_RG_INTEGER, GL_RGB_INTEGER, GL_RGBA_INTEGER, GL_BGR_INTEGER, GL_BGRA_INTEGER.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies a pixel type for the returned data. The supported types are GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_HALF_FLOAT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, GL_UNSIGNED_INT_2_10_10_10_REV, GL_UNSIGNED_INT_24_8, GL_UNSIGNED_INT_10F_11F_11F_REV, GL_UNSIGNED_INT_5_9_9_9_REV, and GL_FLOAT_32_UNSIGNED_INT_24_8_REV.
        /// </para>
        /// </param>
        /// <param name="img">
        /// <para>
        /// Returns the texture image. Should be a pointer to an array of the type specified by type.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetTexImage")]
        public static extern void GetTexImage<T4>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T4[] pixels)
            where T4 : struct
        ;

        /// <summary>[requires: v1.0]
        /// Return a texture image
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies which texture is to be obtained. GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_RECTANGLE, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, and GL_TEXTURE_CUBE_MAP_NEGATIVE_Z are accepted.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number of the desired image. Level 0 is the base image level. Level is the th mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies a pixel format for the returned data. The supported formats are GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_DEPTH_STENCIL, GL_RED, GL_GREEN, GL_BLUE, GL_RG, GL_RGB, GL_RGBA, GL_BGR, GL_BGRA, GL_RED_INTEGER, GL_GREEN_INTEGER, GL_BLUE_INTEGER, GL_RG_INTEGER, GL_RGB_INTEGER, GL_RGBA_INTEGER, GL_BGR_INTEGER, GL_BGRA_INTEGER.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies a pixel type for the returned data. The supported types are GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_HALF_FLOAT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, GL_UNSIGNED_INT_2_10_10_10_REV, GL_UNSIGNED_INT_24_8, GL_UNSIGNED_INT_10F_11F_11F_REV, GL_UNSIGNED_INT_5_9_9_9_REV, and GL_FLOAT_32_UNSIGNED_INT_24_8_REV.
        /// </para>
        /// </param>
        /// <param name="img">
        /// <para>
        /// Returns the texture image. Should be a pointer to an array of the type specified by type.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetTexImage")]
        public static extern void GetTexImage<T4>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T4[,] pixels)
            where T4 : struct
        ;

        /// <summary>[requires: v1.0]
        /// Return a texture image
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies which texture is to be obtained. GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_RECTANGLE, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, and GL_TEXTURE_CUBE_MAP_NEGATIVE_Z are accepted.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number of the desired image. Level 0 is the base image level. Level is the th mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies a pixel format for the returned data. The supported formats are GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_DEPTH_STENCIL, GL_RED, GL_GREEN, GL_BLUE, GL_RG, GL_RGB, GL_RGBA, GL_BGR, GL_BGRA, GL_RED_INTEGER, GL_GREEN_INTEGER, GL_BLUE_INTEGER, GL_RG_INTEGER, GL_RGB_INTEGER, GL_RGBA_INTEGER, GL_BGR_INTEGER, GL_BGRA_INTEGER.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies a pixel type for the returned data. The supported types are GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_HALF_FLOAT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, GL_UNSIGNED_INT_2_10_10_10_REV, GL_UNSIGNED_INT_24_8, GL_UNSIGNED_INT_10F_11F_11F_REV, GL_UNSIGNED_INT_5_9_9_9_REV, and GL_FLOAT_32_UNSIGNED_INT_24_8_REV.
        /// </para>
        /// </param>
        /// <param name="img">
        /// <para>
        /// Returns the texture image. Should be a pointer to an array of the type specified by type.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetTexImage")]
        public static extern void GetTexImage<T4>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T4[,,] pixels)
            where T4 : struct
        ;

        /// <summary>[requires: v1.0]
        /// Return a texture image
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies which texture is to be obtained. GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_RECTANGLE, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, and GL_TEXTURE_CUBE_MAP_NEGATIVE_Z are accepted.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number of the desired image. Level 0 is the base image level. Level is the th mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies a pixel format for the returned data. The supported formats are GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_DEPTH_STENCIL, GL_RED, GL_GREEN, GL_BLUE, GL_RG, GL_RGB, GL_RGBA, GL_BGR, GL_BGRA, GL_RED_INTEGER, GL_GREEN_INTEGER, GL_BLUE_INTEGER, GL_RG_INTEGER, GL_RGB_INTEGER, GL_RGBA_INTEGER, GL_BGR_INTEGER, GL_BGRA_INTEGER.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies a pixel type for the returned data. The supported types are GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_HALF_FLOAT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, GL_UNSIGNED_INT_2_10_10_10_REV, GL_UNSIGNED_INT_24_8, GL_UNSIGNED_INT_10F_11F_11F_REV, GL_UNSIGNED_INT_5_9_9_9_REV, and GL_FLOAT_32_UNSIGNED_INT_24_8_REV.
        /// </para>
        /// </param>
        /// <param name="img">
        /// <para>
        /// Returns the texture image. Should be a pointer to an array of the type specified by type.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetTexImage")]
        public static extern void GetTexImage<T4>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T4 pixels)
            where T4 : struct
        ;

        /// <summary>[requires: v1.0]
        /// Return texture parameter values for a specific level of detail
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the symbolic name of the target texture, one of GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_RECTANGLE, GL_TEXTURE_2D_MULTISAMPLE, GL_TEXTURE_2D_MULTISAMPLE_ARRAY, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, GL_PROXY_TEXTURE_1D, GL_PROXY_TEXTURE_2D, GL_PROXY_TEXTURE_3D, GL_PROXY_TEXTURE_1D_ARRAY, GL_PROXY_TEXTURE_2D_ARRAY, GL_PROXY_TEXTURE_RECTANGLE, GL_PROXY_TEXTURE_2D_MULTISAMPLE, GL_PROXY_TEXTURE_2D_MULTISAMPLE_ARRAY, GL_PROXY_TEXTURE_CUBE_MAP, or GL_TEXTURE_BUFFER.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number of the desired image. Level 0 is the base image level. Level is the th mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a texture parameter. GL_TEXTURE_WIDTH, GL_TEXTURE_HEIGHT, GL_TEXTURE_DEPTH, GL_TEXTURE_INTERNAL_FORMAT, GL_TEXTURE_RED_SIZE, GL_TEXTURE_GREEN_SIZE, GL_TEXTURE_BLUE_SIZE, GL_TEXTURE_ALPHA_SIZE, GL_TEXTURE_DEPTH_SIZE, GL_TEXTURE_COMPRESSED, GL_TEXTURE_COMPRESSED_IMAGE_SIZE, and GL_TEXTURE_BUFFER_OFFSET are accepted.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetTexLevelParameterfv")]
        public static extern void GetTexLevelParameter(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Single[] @params);

        /// <summary>[requires: v1.0]
        /// Return texture parameter values for a specific level of detail
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the symbolic name of the target texture, one of GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_RECTANGLE, GL_TEXTURE_2D_MULTISAMPLE, GL_TEXTURE_2D_MULTISAMPLE_ARRAY, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, GL_PROXY_TEXTURE_1D, GL_PROXY_TEXTURE_2D, GL_PROXY_TEXTURE_3D, GL_PROXY_TEXTURE_1D_ARRAY, GL_PROXY_TEXTURE_2D_ARRAY, GL_PROXY_TEXTURE_RECTANGLE, GL_PROXY_TEXTURE_2D_MULTISAMPLE, GL_PROXY_TEXTURE_2D_MULTISAMPLE_ARRAY, GL_PROXY_TEXTURE_CUBE_MAP, or GL_TEXTURE_BUFFER.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number of the desired image. Level 0 is the base image level. Level is the th mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a texture parameter. GL_TEXTURE_WIDTH, GL_TEXTURE_HEIGHT, GL_TEXTURE_DEPTH, GL_TEXTURE_INTERNAL_FORMAT, GL_TEXTURE_RED_SIZE, GL_TEXTURE_GREEN_SIZE, GL_TEXTURE_BLUE_SIZE, GL_TEXTURE_ALPHA_SIZE, GL_TEXTURE_DEPTH_SIZE, GL_TEXTURE_COMPRESSED, GL_TEXTURE_COMPRESSED_IMAGE_SIZE, and GL_TEXTURE_BUFFER_OFFSET are accepted.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetTexLevelParameterfv")]
        public static extern void GetTexLevelParameter(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] out Single @params);

        /// <summary>[requires: v1.0]
        /// Return texture parameter values for a specific level of detail
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the symbolic name of the target texture, one of GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_RECTANGLE, GL_TEXTURE_2D_MULTISAMPLE, GL_TEXTURE_2D_MULTISAMPLE_ARRAY, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, GL_PROXY_TEXTURE_1D, GL_PROXY_TEXTURE_2D, GL_PROXY_TEXTURE_3D, GL_PROXY_TEXTURE_1D_ARRAY, GL_PROXY_TEXTURE_2D_ARRAY, GL_PROXY_TEXTURE_RECTANGLE, GL_PROXY_TEXTURE_2D_MULTISAMPLE, GL_PROXY_TEXTURE_2D_MULTISAMPLE_ARRAY, GL_PROXY_TEXTURE_CUBE_MAP, or GL_TEXTURE_BUFFER.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number of the desired image. Level 0 is the base image level. Level is the th mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a texture parameter. GL_TEXTURE_WIDTH, GL_TEXTURE_HEIGHT, GL_TEXTURE_DEPTH, GL_TEXTURE_INTERNAL_FORMAT, GL_TEXTURE_RED_SIZE, GL_TEXTURE_GREEN_SIZE, GL_TEXTURE_BLUE_SIZE, GL_TEXTURE_ALPHA_SIZE, GL_TEXTURE_DEPTH_SIZE, GL_TEXTURE_COMPRESSED, GL_TEXTURE_COMPRESSED_IMAGE_SIZE, and GL_TEXTURE_BUFFER_OFFSET are accepted.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetTexLevelParameterfv")]
        public static extern unsafe void GetTexLevelParameter(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Single* @params);

        /// <summary>[requires: v1.0]
        /// Return texture parameter values for a specific level of detail
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the symbolic name of the target texture, one of GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_RECTANGLE, GL_TEXTURE_2D_MULTISAMPLE, GL_TEXTURE_2D_MULTISAMPLE_ARRAY, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, GL_PROXY_TEXTURE_1D, GL_PROXY_TEXTURE_2D, GL_PROXY_TEXTURE_3D, GL_PROXY_TEXTURE_1D_ARRAY, GL_PROXY_TEXTURE_2D_ARRAY, GL_PROXY_TEXTURE_RECTANGLE, GL_PROXY_TEXTURE_2D_MULTISAMPLE, GL_PROXY_TEXTURE_2D_MULTISAMPLE_ARRAY, GL_PROXY_TEXTURE_CUBE_MAP, or GL_TEXTURE_BUFFER.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number of the desired image. Level 0 is the base image level. Level is the th mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a texture parameter. GL_TEXTURE_WIDTH, GL_TEXTURE_HEIGHT, GL_TEXTURE_DEPTH, GL_TEXTURE_INTERNAL_FORMAT, GL_TEXTURE_RED_SIZE, GL_TEXTURE_GREEN_SIZE, GL_TEXTURE_BLUE_SIZE, GL_TEXTURE_ALPHA_SIZE, GL_TEXTURE_DEPTH_SIZE, GL_TEXTURE_COMPRESSED, GL_TEXTURE_COMPRESSED_IMAGE_SIZE, and GL_TEXTURE_BUFFER_OFFSET are accepted.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetTexLevelParameteriv")]
        public static extern void GetTexLevelParameter(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v1.0]
        /// Return texture parameter values for a specific level of detail
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the symbolic name of the target texture, one of GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_RECTANGLE, GL_TEXTURE_2D_MULTISAMPLE, GL_TEXTURE_2D_MULTISAMPLE_ARRAY, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, GL_PROXY_TEXTURE_1D, GL_PROXY_TEXTURE_2D, GL_PROXY_TEXTURE_3D, GL_PROXY_TEXTURE_1D_ARRAY, GL_PROXY_TEXTURE_2D_ARRAY, GL_PROXY_TEXTURE_RECTANGLE, GL_PROXY_TEXTURE_2D_MULTISAMPLE, GL_PROXY_TEXTURE_2D_MULTISAMPLE_ARRAY, GL_PROXY_TEXTURE_CUBE_MAP, or GL_TEXTURE_BUFFER.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number of the desired image. Level 0 is the base image level. Level is the th mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a texture parameter. GL_TEXTURE_WIDTH, GL_TEXTURE_HEIGHT, GL_TEXTURE_DEPTH, GL_TEXTURE_INTERNAL_FORMAT, GL_TEXTURE_RED_SIZE, GL_TEXTURE_GREEN_SIZE, GL_TEXTURE_BLUE_SIZE, GL_TEXTURE_ALPHA_SIZE, GL_TEXTURE_DEPTH_SIZE, GL_TEXTURE_COMPRESSED, GL_TEXTURE_COMPRESSED_IMAGE_SIZE, and GL_TEXTURE_BUFFER_OFFSET are accepted.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetTexLevelParameteriv")]
        public static extern void GetTexLevelParameter(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v1.0]
        /// Return texture parameter values for a specific level of detail
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the symbolic name of the target texture, one of GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_RECTANGLE, GL_TEXTURE_2D_MULTISAMPLE, GL_TEXTURE_2D_MULTISAMPLE_ARRAY, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, GL_PROXY_TEXTURE_1D, GL_PROXY_TEXTURE_2D, GL_PROXY_TEXTURE_3D, GL_PROXY_TEXTURE_1D_ARRAY, GL_PROXY_TEXTURE_2D_ARRAY, GL_PROXY_TEXTURE_RECTANGLE, GL_PROXY_TEXTURE_2D_MULTISAMPLE, GL_PROXY_TEXTURE_2D_MULTISAMPLE_ARRAY, GL_PROXY_TEXTURE_CUBE_MAP, or GL_TEXTURE_BUFFER.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number of the desired image. Level 0 is the base image level. Level is the th mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a texture parameter. GL_TEXTURE_WIDTH, GL_TEXTURE_HEIGHT, GL_TEXTURE_DEPTH, GL_TEXTURE_INTERNAL_FORMAT, GL_TEXTURE_RED_SIZE, GL_TEXTURE_GREEN_SIZE, GL_TEXTURE_BLUE_SIZE, GL_TEXTURE_ALPHA_SIZE, GL_TEXTURE_DEPTH_SIZE, GL_TEXTURE_COMPRESSED, GL_TEXTURE_COMPRESSED_IMAGE_SIZE, and GL_TEXTURE_BUFFER_OFFSET are accepted.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetTexLevelParameteriv")]
        public static extern unsafe void GetTexLevelParameter(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v1.0]
        /// Return texture parameter values
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the symbolic name of the target texture. GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_3D, GL_TEXTURE_RECTANGLE, GL_TEXTURE_CUBE_MAP, and GL_TEXTURE_CUBE_MAP_ARRAY are accepted.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a texture parameter. GL_DEPTH_STENCIL_TEXTURE_MODE, GL_TEXTURE_BASE_LEVEL, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_COMPARE_MODE, GL_TEXTURE_COMPARE_FUNC, GL_TEXTURE_IMMUTABLE_FORMAT, GL_TEXTURE_IMMUTABLE_LEVELS, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_MAG_FILTER, GL_TEXTURE_MAX_LEVEL, GL_TEXTURE_MAX_LOD, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MIN_LOD, GL_TEXTURE_SWIZZLE_R, GL_TEXTURE_SWIZZLE_G, GL_TEXTURE_SWIZZLE_B, GL_TEXTURE_SWIZZLE_A, GL_TEXTURE_SWIZZLE_RGBA, GL_TEXTURE_VIEW_MIN_LAYER, GL_TEXTURE_VIEW_MIN_LEVEL, GL_TEXTURE_VIEW_NUM_LAYERS, GL_TEXTURE_VIEW_NUM_LEVELS, GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, and GL_TEXTURE_WRAP_R are accepted.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the texture parameters.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetTexParameterfv")]
        public static extern void GetTexParameter(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Single[] @params);

        /// <summary>[requires: v1.0]
        /// Return texture parameter values
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the symbolic name of the target texture. GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_3D, GL_TEXTURE_RECTANGLE, GL_TEXTURE_CUBE_MAP, and GL_TEXTURE_CUBE_MAP_ARRAY are accepted.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a texture parameter. GL_DEPTH_STENCIL_TEXTURE_MODE, GL_TEXTURE_BASE_LEVEL, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_COMPARE_MODE, GL_TEXTURE_COMPARE_FUNC, GL_TEXTURE_IMMUTABLE_FORMAT, GL_TEXTURE_IMMUTABLE_LEVELS, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_MAG_FILTER, GL_TEXTURE_MAX_LEVEL, GL_TEXTURE_MAX_LOD, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MIN_LOD, GL_TEXTURE_SWIZZLE_R, GL_TEXTURE_SWIZZLE_G, GL_TEXTURE_SWIZZLE_B, GL_TEXTURE_SWIZZLE_A, GL_TEXTURE_SWIZZLE_RGBA, GL_TEXTURE_VIEW_MIN_LAYER, GL_TEXTURE_VIEW_MIN_LEVEL, GL_TEXTURE_VIEW_NUM_LAYERS, GL_TEXTURE_VIEW_NUM_LEVELS, GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, and GL_TEXTURE_WRAP_R are accepted.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the texture parameters.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetTexParameterfv")]
        public static extern void GetTexParameter(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] out Single @params);

        /// <summary>[requires: v1.0]
        /// Return texture parameter values
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the symbolic name of the target texture. GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_3D, GL_TEXTURE_RECTANGLE, GL_TEXTURE_CUBE_MAP, and GL_TEXTURE_CUBE_MAP_ARRAY are accepted.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a texture parameter. GL_DEPTH_STENCIL_TEXTURE_MODE, GL_TEXTURE_BASE_LEVEL, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_COMPARE_MODE, GL_TEXTURE_COMPARE_FUNC, GL_TEXTURE_IMMUTABLE_FORMAT, GL_TEXTURE_IMMUTABLE_LEVELS, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_MAG_FILTER, GL_TEXTURE_MAX_LEVEL, GL_TEXTURE_MAX_LOD, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MIN_LOD, GL_TEXTURE_SWIZZLE_R, GL_TEXTURE_SWIZZLE_G, GL_TEXTURE_SWIZZLE_B, GL_TEXTURE_SWIZZLE_A, GL_TEXTURE_SWIZZLE_RGBA, GL_TEXTURE_VIEW_MIN_LAYER, GL_TEXTURE_VIEW_MIN_LEVEL, GL_TEXTURE_VIEW_NUM_LAYERS, GL_TEXTURE_VIEW_NUM_LEVELS, GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, and GL_TEXTURE_WRAP_R are accepted.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the texture parameters.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetTexParameterfv")]
        public static extern unsafe void GetTexParameter(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Single* @params);

        /// <summary>[requires: v3.0]</summary>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetTexParameterIiv")]
        public static extern void GetTexParameterI(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v3.0]</summary>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetTexParameterIiv")]
        public static extern void GetTexParameterI(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetTexParameterIiv")]
        public static extern unsafe void GetTexParameterI(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetTexParameterIuiv")]
        public static extern void GetTexParameterI(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] UInt32[] @params);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetTexParameterIuiv")]
        public static extern void GetTexParameterI(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] out UInt32 @params);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetTexParameterIuiv")]
        public static extern unsafe void GetTexParameterI(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] UInt32* @params);

        /// <summary>[requires: v1.0]
        /// Return texture parameter values
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the symbolic name of the target texture. GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_3D, GL_TEXTURE_RECTANGLE, GL_TEXTURE_CUBE_MAP, and GL_TEXTURE_CUBE_MAP_ARRAY are accepted.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a texture parameter. GL_DEPTH_STENCIL_TEXTURE_MODE, GL_TEXTURE_BASE_LEVEL, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_COMPARE_MODE, GL_TEXTURE_COMPARE_FUNC, GL_TEXTURE_IMMUTABLE_FORMAT, GL_TEXTURE_IMMUTABLE_LEVELS, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_MAG_FILTER, GL_TEXTURE_MAX_LEVEL, GL_TEXTURE_MAX_LOD, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MIN_LOD, GL_TEXTURE_SWIZZLE_R, GL_TEXTURE_SWIZZLE_G, GL_TEXTURE_SWIZZLE_B, GL_TEXTURE_SWIZZLE_A, GL_TEXTURE_SWIZZLE_RGBA, GL_TEXTURE_VIEW_MIN_LAYER, GL_TEXTURE_VIEW_MIN_LEVEL, GL_TEXTURE_VIEW_NUM_LAYERS, GL_TEXTURE_VIEW_NUM_LEVELS, GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, and GL_TEXTURE_WRAP_R are accepted.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the texture parameters.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetTexParameteriv")]
        public static extern void GetTexParameter(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v1.0]
        /// Return texture parameter values
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the symbolic name of the target texture. GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_3D, GL_TEXTURE_RECTANGLE, GL_TEXTURE_CUBE_MAP, and GL_TEXTURE_CUBE_MAP_ARRAY are accepted.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a texture parameter. GL_DEPTH_STENCIL_TEXTURE_MODE, GL_TEXTURE_BASE_LEVEL, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_COMPARE_MODE, GL_TEXTURE_COMPARE_FUNC, GL_TEXTURE_IMMUTABLE_FORMAT, GL_TEXTURE_IMMUTABLE_LEVELS, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_MAG_FILTER, GL_TEXTURE_MAX_LEVEL, GL_TEXTURE_MAX_LOD, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MIN_LOD, GL_TEXTURE_SWIZZLE_R, GL_TEXTURE_SWIZZLE_G, GL_TEXTURE_SWIZZLE_B, GL_TEXTURE_SWIZZLE_A, GL_TEXTURE_SWIZZLE_RGBA, GL_TEXTURE_VIEW_MIN_LAYER, GL_TEXTURE_VIEW_MIN_LEVEL, GL_TEXTURE_VIEW_NUM_LAYERS, GL_TEXTURE_VIEW_NUM_LEVELS, GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, and GL_TEXTURE_WRAP_R are accepted.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the texture parameters.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetTexParameteriv")]
        public static extern void GetTexParameter(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v1.0]
        /// Return texture parameter values
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the symbolic name of the target texture. GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_3D, GL_TEXTURE_RECTANGLE, GL_TEXTURE_CUBE_MAP, and GL_TEXTURE_CUBE_MAP_ARRAY are accepted.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a texture parameter. GL_DEPTH_STENCIL_TEXTURE_MODE, GL_TEXTURE_BASE_LEVEL, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_COMPARE_MODE, GL_TEXTURE_COMPARE_FUNC, GL_TEXTURE_IMMUTABLE_FORMAT, GL_TEXTURE_IMMUTABLE_LEVELS, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_MAG_FILTER, GL_TEXTURE_MAX_LEVEL, GL_TEXTURE_MAX_LOD, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MIN_LOD, GL_TEXTURE_SWIZZLE_R, GL_TEXTURE_SWIZZLE_G, GL_TEXTURE_SWIZZLE_B, GL_TEXTURE_SWIZZLE_A, GL_TEXTURE_SWIZZLE_RGBA, GL_TEXTURE_VIEW_MIN_LAYER, GL_TEXTURE_VIEW_MIN_LEVEL, GL_TEXTURE_VIEW_NUM_LAYERS, GL_TEXTURE_VIEW_NUM_LEVELS, GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, and GL_TEXTURE_WRAP_R are accepted.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the texture parameters.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glGetTexParameteriv")]
        public static extern unsafe void GetTexParameter(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v3.0]
        /// Retrieve information about varying variables selected for transform feedback
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of the target program object.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// The index of the varying variable whose information to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The maximum number of characters, including the null terminator, that may be written into name.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The address of a variable which will receive the number of characters written into name, excluding the null-terminator. If length is NULL no length is returned.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// The address of a variable that will receive the size of the varying.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The address of a variable that will recieve the type of the varying.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The address of a buffer into which will be written the name of the varying.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetTransformFeedbackVarying")]
        public static extern void GetTransformFeedbackVarying(Int32 program, Int32 index, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] out Int32 size, [OutAttribute] out OpenTK.Graphics.OpenGL.ActiveAttribType type, [OutAttribute] StringBuilder name);

        /// <summary>[requires: v3.0]
        /// Retrieve information about varying variables selected for transform feedback
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of the target program object.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// The index of the varying variable whose information to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The maximum number of characters, including the null terminator, that may be written into name.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The address of a variable which will receive the number of characters written into name, excluding the null-terminator. If length is NULL no length is returned.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// The address of a variable that will receive the size of the varying.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The address of a variable that will recieve the type of the varying.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The address of a buffer into which will be written the name of the varying.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetTransformFeedbackVarying")]
        public static extern void GetTransformFeedbackVarying(Int32 program, Int32 index, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] out Int32 size, [OutAttribute] out OpenTK.Graphics.OpenGL.TransformFeedbackType type, [OutAttribute] StringBuilder name);

        /// <summary>[requires: v3.0]
        /// Retrieve information about varying variables selected for transform feedback
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of the target program object.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// The index of the varying variable whose information to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The maximum number of characters, including the null terminator, that may be written into name.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The address of a variable which will receive the number of characters written into name, excluding the null-terminator. If length is NULL no length is returned.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// The address of a variable that will receive the size of the varying.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The address of a variable that will recieve the type of the varying.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The address of a buffer into which will be written the name of the varying.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetTransformFeedbackVarying")]
        public static extern unsafe void GetTransformFeedbackVarying(Int32 program, Int32 index, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] Int32* size, [OutAttribute] OpenTK.Graphics.OpenGL.ActiveAttribType* type, [OutAttribute] StringBuilder name);

        /// <summary>[requires: v3.0]
        /// Retrieve information about varying variables selected for transform feedback
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of the target program object.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// The index of the varying variable whose information to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The maximum number of characters, including the null terminator, that may be written into name.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The address of a variable which will receive the number of characters written into name, excluding the null-terminator. If length is NULL no length is returned.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// The address of a variable that will receive the size of the varying.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The address of a variable that will recieve the type of the varying.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The address of a buffer into which will be written the name of the varying.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetTransformFeedbackVarying")]
        public static extern unsafe void GetTransformFeedbackVarying(Int32 program, Int32 index, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] Int32* size, [OutAttribute] OpenTK.Graphics.OpenGL.TransformFeedbackType* type, [OutAttribute] StringBuilder name);

        /// <summary>[requires: v3.0]
        /// Retrieve information about varying variables selected for transform feedback
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of the target program object.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// The index of the varying variable whose information to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The maximum number of characters, including the null terminator, that may be written into name.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The address of a variable which will receive the number of characters written into name, excluding the null-terminator. If length is NULL no length is returned.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// The address of a variable that will receive the size of the varying.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The address of a variable that will recieve the type of the varying.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The address of a buffer into which will be written the name of the varying.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetTransformFeedbackVarying")]
        public static extern void GetTransformFeedbackVarying(UInt32 program, UInt32 index, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] out Int32 size, [OutAttribute] out OpenTK.Graphics.OpenGL.ActiveAttribType type, [OutAttribute] StringBuilder name);

        /// <summary>[requires: v3.0]
        /// Retrieve information about varying variables selected for transform feedback
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of the target program object.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// The index of the varying variable whose information to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The maximum number of characters, including the null terminator, that may be written into name.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The address of a variable which will receive the number of characters written into name, excluding the null-terminator. If length is NULL no length is returned.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// The address of a variable that will receive the size of the varying.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The address of a variable that will recieve the type of the varying.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The address of a buffer into which will be written the name of the varying.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetTransformFeedbackVarying")]
        public static extern void GetTransformFeedbackVarying(UInt32 program, UInt32 index, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] out Int32 size, [OutAttribute] out OpenTK.Graphics.OpenGL.TransformFeedbackType type, [OutAttribute] StringBuilder name);

        /// <summary>[requires: v3.0]
        /// Retrieve information about varying variables selected for transform feedback
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of the target program object.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// The index of the varying variable whose information to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The maximum number of characters, including the null terminator, that may be written into name.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The address of a variable which will receive the number of characters written into name, excluding the null-terminator. If length is NULL no length is returned.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// The address of a variable that will receive the size of the varying.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The address of a variable that will recieve the type of the varying.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The address of a buffer into which will be written the name of the varying.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetTransformFeedbackVarying")]
        public static extern unsafe void GetTransformFeedbackVarying(UInt32 program, UInt32 index, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] Int32* size, [OutAttribute] OpenTK.Graphics.OpenGL.ActiveAttribType* type, [OutAttribute] StringBuilder name);

        /// <summary>[requires: v3.0]
        /// Retrieve information about varying variables selected for transform feedback
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of the target program object.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// The index of the varying variable whose information to retrieve.
        /// </para>
        /// </param>
        /// <param name="bufSize">
        /// <para>
        /// The maximum number of characters, including the null terminator, that may be written into name.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The address of a variable which will receive the number of characters written into name, excluding the null-terminator. If length is NULL no length is returned.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// The address of a variable that will receive the size of the varying.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The address of a variable that will recieve the type of the varying.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The address of a buffer into which will be written the name of the varying.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetTransformFeedbackVarying")]
        public static extern unsafe void GetTransformFeedbackVarying(UInt32 program, UInt32 index, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] Int32* size, [OutAttribute] OpenTK.Graphics.OpenGL.TransformFeedbackType* type, [OutAttribute] StringBuilder name);

        /// <summary>[requires: v3.1 and ARB_uniform_buffer_object|VERSION_3_1]
        /// Retrieve the index of a named uniform block
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program containing the uniform block.
        /// </para>
        /// </param>
        /// <param name="uniformBlockName">
        /// <para>
        /// Specifies the address an array of characters to containing the name of the uniform block whose index to retrieve.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_uniform_buffer_object|VERSION_3_1", Version = "3.1", EntryPoint = "glGetUniformBlockIndex")]
        public static extern Int32 GetUniformBlockIndex(Int32 program, String uniformBlockName);

        /// <summary>[requires: v3.1 and ARB_uniform_buffer_object|VERSION_3_1]
        /// Retrieve the index of a named uniform block
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program containing the uniform block.
        /// </para>
        /// </param>
        /// <param name="uniformBlockName">
        /// <para>
        /// Specifies the address an array of characters to containing the name of the uniform block whose index to retrieve.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_uniform_buffer_object|VERSION_3_1", Version = "3.1", EntryPoint = "glGetUniformBlockIndex")]
        public static extern Int32 GetUniformBlockIndex(UInt32 program, String uniformBlockName);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]
        /// Returns the value of a uniform variable
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be queried.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the value of the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glGetUniformdv")]
        public static extern void GetUniform(Int32 program, Int32 location, [OutAttribute] Double[] @params);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]
        /// Returns the value of a uniform variable
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be queried.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the value of the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glGetUniformdv")]
        public static extern void GetUniform(Int32 program, Int32 location, [OutAttribute] out Double @params);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]
        /// Returns the value of a uniform variable
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be queried.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the value of the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glGetUniformdv")]
        public static extern unsafe void GetUniform(Int32 program, Int32 location, [OutAttribute] Double* @params);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]
        /// Returns the value of a uniform variable
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be queried.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the value of the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glGetUniformdv")]
        public static extern void GetUniform(UInt32 program, Int32 location, [OutAttribute] Double[] @params);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]
        /// Returns the value of a uniform variable
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be queried.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the value of the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glGetUniformdv")]
        public static extern void GetUniform(UInt32 program, Int32 location, [OutAttribute] out Double @params);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]
        /// Returns the value of a uniform variable
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be queried.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the value of the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glGetUniformdv")]
        public static extern unsafe void GetUniform(UInt32 program, Int32 location, [OutAttribute] Double* @params);

        /// <summary>[requires: v2.0]
        /// Returns the value of a uniform variable
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be queried.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the value of the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetUniformfv")]
        public static extern void GetUniform(Int32 program, Int32 location, [OutAttribute] Single[] @params);

        /// <summary>[requires: v2.0]
        /// Returns the value of a uniform variable
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be queried.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the value of the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetUniformfv")]
        public static extern void GetUniform(Int32 program, Int32 location, [OutAttribute] out Single @params);

        /// <summary>[requires: v2.0]
        /// Returns the value of a uniform variable
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be queried.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the value of the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetUniformfv")]
        public static extern unsafe void GetUniform(Int32 program, Int32 location, [OutAttribute] Single* @params);

        /// <summary>[requires: v2.0]
        /// Returns the value of a uniform variable
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be queried.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the value of the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetUniformfv")]
        public static extern void GetUniform(UInt32 program, Int32 location, [OutAttribute] Single[] @params);

        /// <summary>[requires: v2.0]
        /// Returns the value of a uniform variable
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be queried.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the value of the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetUniformfv")]
        public static extern void GetUniform(UInt32 program, Int32 location, [OutAttribute] out Single @params);

        /// <summary>[requires: v2.0]
        /// Returns the value of a uniform variable
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be queried.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the value of the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetUniformfv")]
        public static extern unsafe void GetUniform(UInt32 program, Int32 location, [OutAttribute] Single* @params);

        /// <summary>[requires: v3.1 and ARB_uniform_buffer_object|VERSION_3_1]
        /// Retrieve the index of a named uniform block
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program containing uniforms whose indices to query.
        /// </para>
        /// </param>
        /// <param name="uniformCount">
        /// <para>
        /// Specifies the number of uniforms whose indices to query.
        /// </para>
        /// </param>
        /// <param name="uniformNames">
        /// <para>
        /// Specifies the address of an array of pointers to buffers containing the names of the queried uniforms.
        /// </para>
        /// </param>
        /// <param name="uniformIndices">
        /// <para>
        /// Specifies the address of an array that will receive the indices of the uniforms.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_uniform_buffer_object|VERSION_3_1", Version = "3.1", EntryPoint = "glGetUniformIndices")]
        public static extern void GetUniformIndices(Int32 program, Int32 uniformCount, String[] uniformNames, [OutAttribute] Int32[] uniformIndices);

        /// <summary>[requires: v3.1 and ARB_uniform_buffer_object|VERSION_3_1]
        /// Retrieve the index of a named uniform block
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program containing uniforms whose indices to query.
        /// </para>
        /// </param>
        /// <param name="uniformCount">
        /// <para>
        /// Specifies the number of uniforms whose indices to query.
        /// </para>
        /// </param>
        /// <param name="uniformNames">
        /// <para>
        /// Specifies the address of an array of pointers to buffers containing the names of the queried uniforms.
        /// </para>
        /// </param>
        /// <param name="uniformIndices">
        /// <para>
        /// Specifies the address of an array that will receive the indices of the uniforms.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_uniform_buffer_object|VERSION_3_1", Version = "3.1", EntryPoint = "glGetUniformIndices")]
        public static extern void GetUniformIndices(Int32 program, Int32 uniformCount, String[] uniformNames, [OutAttribute] out Int32 uniformIndices);

        /// <summary>[requires: v3.1 and ARB_uniform_buffer_object|VERSION_3_1]
        /// Retrieve the index of a named uniform block
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program containing uniforms whose indices to query.
        /// </para>
        /// </param>
        /// <param name="uniformCount">
        /// <para>
        /// Specifies the number of uniforms whose indices to query.
        /// </para>
        /// </param>
        /// <param name="uniformNames">
        /// <para>
        /// Specifies the address of an array of pointers to buffers containing the names of the queried uniforms.
        /// </para>
        /// </param>
        /// <param name="uniformIndices">
        /// <para>
        /// Specifies the address of an array that will receive the indices of the uniforms.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_uniform_buffer_object|VERSION_3_1", Version = "3.1", EntryPoint = "glGetUniformIndices")]
        public static extern unsafe void GetUniformIndices(Int32 program, Int32 uniformCount, String[] uniformNames, [OutAttribute] Int32* uniformIndices);

        /// <summary>[requires: v3.1 and ARB_uniform_buffer_object|VERSION_3_1]
        /// Retrieve the index of a named uniform block
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program containing uniforms whose indices to query.
        /// </para>
        /// </param>
        /// <param name="uniformCount">
        /// <para>
        /// Specifies the number of uniforms whose indices to query.
        /// </para>
        /// </param>
        /// <param name="uniformNames">
        /// <para>
        /// Specifies the address of an array of pointers to buffers containing the names of the queried uniforms.
        /// </para>
        /// </param>
        /// <param name="uniformIndices">
        /// <para>
        /// Specifies the address of an array that will receive the indices of the uniforms.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_uniform_buffer_object|VERSION_3_1", Version = "3.1", EntryPoint = "glGetUniformIndices")]
        public static extern void GetUniformIndices(UInt32 program, Int32 uniformCount, String[] uniformNames, [OutAttribute] UInt32[] uniformIndices);

        /// <summary>[requires: v3.1 and ARB_uniform_buffer_object|VERSION_3_1]
        /// Retrieve the index of a named uniform block
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program containing uniforms whose indices to query.
        /// </para>
        /// </param>
        /// <param name="uniformCount">
        /// <para>
        /// Specifies the number of uniforms whose indices to query.
        /// </para>
        /// </param>
        /// <param name="uniformNames">
        /// <para>
        /// Specifies the address of an array of pointers to buffers containing the names of the queried uniforms.
        /// </para>
        /// </param>
        /// <param name="uniformIndices">
        /// <para>
        /// Specifies the address of an array that will receive the indices of the uniforms.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_uniform_buffer_object|VERSION_3_1", Version = "3.1", EntryPoint = "glGetUniformIndices")]
        public static extern void GetUniformIndices(UInt32 program, Int32 uniformCount, String[] uniformNames, [OutAttribute] out UInt32 uniformIndices);

        /// <summary>[requires: v3.1 and ARB_uniform_buffer_object|VERSION_3_1]
        /// Retrieve the index of a named uniform block
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program containing uniforms whose indices to query.
        /// </para>
        /// </param>
        /// <param name="uniformCount">
        /// <para>
        /// Specifies the number of uniforms whose indices to query.
        /// </para>
        /// </param>
        /// <param name="uniformNames">
        /// <para>
        /// Specifies the address of an array of pointers to buffers containing the names of the queried uniforms.
        /// </para>
        /// </param>
        /// <param name="uniformIndices">
        /// <para>
        /// Specifies the address of an array that will receive the indices of the uniforms.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_uniform_buffer_object|VERSION_3_1", Version = "3.1", EntryPoint = "glGetUniformIndices")]
        public static extern unsafe void GetUniformIndices(UInt32 program, Int32 uniformCount, String[] uniformNames, [OutAttribute] UInt32* uniformIndices);

        /// <summary>[requires: v2.0]
        /// Returns the value of a uniform variable
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be queried.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the value of the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetUniformiv")]
        public static extern void GetUniform(Int32 program, Int32 location, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v2.0]
        /// Returns the value of a uniform variable
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be queried.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the value of the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetUniformiv")]
        public static extern void GetUniform(Int32 program, Int32 location, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v2.0]
        /// Returns the value of a uniform variable
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be queried.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the value of the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetUniformiv")]
        public static extern unsafe void GetUniform(Int32 program, Int32 location, [OutAttribute] Int32* @params);

        /// <summary>[requires: v2.0]
        /// Returns the value of a uniform variable
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be queried.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the value of the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetUniformiv")]
        public static extern void GetUniform(UInt32 program, Int32 location, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v2.0]
        /// Returns the value of a uniform variable
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be queried.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the value of the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetUniformiv")]
        public static extern void GetUniform(UInt32 program, Int32 location, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v2.0]
        /// Returns the value of a uniform variable
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be queried.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the value of the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetUniformiv")]
        public static extern unsafe void GetUniform(UInt32 program, Int32 location, [OutAttribute] Int32* @params);

        /// <summary>[requires: v2.0]
        /// Returns the location of a uniform variable
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// Points to a null terminated string containing the name of the uniform variable whose location is to be queried.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetUniformLocation")]
        public static extern Int32 GetUniformLocation(Int32 program, String name);

        /// <summary>[requires: v2.0]
        /// Returns the location of a uniform variable
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// Points to a null terminated string containing the name of the uniform variable whose location is to be queried.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetUniformLocation")]
        public static extern Int32 GetUniformLocation(UInt32 program, String name);

        /// <summary>[requires: v4.0 and ARB_shader_subroutine|VERSION_4_0]
        /// Retrieve the value of a subroutine uniform of a given shader stage of the current program
        /// </summary>
        /// <param name="shadertype">
        /// <para>
        /// Specifies the shader stage from which to query for subroutine uniform index. shadertype must be one of GL_VERTEX_SHADER, GL_TESS_CONTROL_SHADER, GL_TESS_EVALUATION_SHADER, GL_GEOMETRY_SHADER or GL_FRAGMENT_SHADER.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the subroutine uniform.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies the address of a variable to receive the value or values of the subroutine uniform.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_shader_subroutine|VERSION_4_0", Version = "4.0", EntryPoint = "glGetUniformSubroutineuiv")]
        public static extern void GetUniformSubroutine(OpenTK.Graphics.OpenGL.ShaderType shadertype, Int32 location, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v4.0 and ARB_shader_subroutine|VERSION_4_0]
        /// Retrieve the value of a subroutine uniform of a given shader stage of the current program
        /// </summary>
        /// <param name="shadertype">
        /// <para>
        /// Specifies the shader stage from which to query for subroutine uniform index. shadertype must be one of GL_VERTEX_SHADER, GL_TESS_CONTROL_SHADER, GL_TESS_EVALUATION_SHADER, GL_GEOMETRY_SHADER or GL_FRAGMENT_SHADER.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the subroutine uniform.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies the address of a variable to receive the value or values of the subroutine uniform.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_shader_subroutine|VERSION_4_0", Version = "4.0", EntryPoint = "glGetUniformSubroutineuiv")]
        public static extern unsafe void GetUniformSubroutine(OpenTK.Graphics.OpenGL.ShaderType shadertype, Int32 location, [OutAttribute] Int32* @params);

        /// <summary>[requires: v4.0 and ARB_shader_subroutine|VERSION_4_0]
        /// Retrieve the value of a subroutine uniform of a given shader stage of the current program
        /// </summary>
        /// <param name="shadertype">
        /// <para>
        /// Specifies the shader stage from which to query for subroutine uniform index. shadertype must be one of GL_VERTEX_SHADER, GL_TESS_CONTROL_SHADER, GL_TESS_EVALUATION_SHADER, GL_GEOMETRY_SHADER or GL_FRAGMENT_SHADER.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the subroutine uniform.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies the address of a variable to receive the value or values of the subroutine uniform.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_shader_subroutine|VERSION_4_0", Version = "4.0", EntryPoint = "glGetUniformSubroutineuiv")]
        public static extern void GetUniformSubroutine(OpenTK.Graphics.OpenGL.ShaderType shadertype, Int32 location, [OutAttribute] out UInt32 @params);

        /// <summary>[requires: v4.0 and ARB_shader_subroutine|VERSION_4_0]
        /// Retrieve the value of a subroutine uniform of a given shader stage of the current program
        /// </summary>
        /// <param name="shadertype">
        /// <para>
        /// Specifies the shader stage from which to query for subroutine uniform index. shadertype must be one of GL_VERTEX_SHADER, GL_TESS_CONTROL_SHADER, GL_TESS_EVALUATION_SHADER, GL_GEOMETRY_SHADER or GL_FRAGMENT_SHADER.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the subroutine uniform.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies the address of a variable to receive the value or values of the subroutine uniform.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_shader_subroutine|VERSION_4_0", Version = "4.0", EntryPoint = "glGetUniformSubroutineuiv")]
        public static extern unsafe void GetUniformSubroutine(OpenTK.Graphics.OpenGL.ShaderType shadertype, Int32 location, [OutAttribute] UInt32* @params);

        /// <summary>[requires: v3.0]
        /// Returns the value of a uniform variable
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be queried.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the value of the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetUniformuiv")]
        public static extern void GetUniform(UInt32 program, Int32 location, [OutAttribute] UInt32[] @params);

        /// <summary>[requires: v3.0]
        /// Returns the value of a uniform variable
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be queried.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the value of the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetUniformuiv")]
        public static extern void GetUniform(UInt32 program, Int32 location, [OutAttribute] out UInt32 @params);

        /// <summary>[requires: v3.0]
        /// Returns the value of a uniform variable
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the program object to be queried.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be queried.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the value of the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetUniformuiv")]
        public static extern unsafe void GetUniform(UInt32 program, Int32 location, [OutAttribute] UInt32* @params);

        /// <summary>[requires: v2.0]
        /// Return a generic vertex attribute parameter
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the generic vertex attribute parameter to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetVertexAttribdv")]
        public static extern void GetVertexAttrib(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] Double[] @params);

        /// <summary>[requires: v2.0]
        /// Return a generic vertex attribute parameter
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the generic vertex attribute parameter to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetVertexAttribdv")]
        public static extern void GetVertexAttrib(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] out Double @params);

        /// <summary>[requires: v2.0]
        /// Return a generic vertex attribute parameter
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the generic vertex attribute parameter to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetVertexAttribdv")]
        public static extern unsafe void GetVertexAttrib(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] Double* @params);

        /// <summary>[requires: v2.0]
        /// Return a generic vertex attribute parameter
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the generic vertex attribute parameter to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetVertexAttribdv")]
        public static extern void GetVertexAttrib(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] Double[] @params);

        /// <summary>[requires: v2.0]
        /// Return a generic vertex attribute parameter
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the generic vertex attribute parameter to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetVertexAttribdv")]
        public static extern void GetVertexAttrib(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] out Double @params);

        /// <summary>[requires: v2.0]
        /// Return a generic vertex attribute parameter
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the generic vertex attribute parameter to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetVertexAttribdv")]
        public static extern unsafe void GetVertexAttrib(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] Double* @params);

        /// <summary>[requires: v2.0]
        /// Return a generic vertex attribute parameter
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the generic vertex attribute parameter to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetVertexAttribfv")]
        public static extern void GetVertexAttrib(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] Single[] @params);

        /// <summary>[requires: v2.0]
        /// Return a generic vertex attribute parameter
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the generic vertex attribute parameter to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetVertexAttribfv")]
        public static extern void GetVertexAttrib(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] out Single @params);

        /// <summary>[requires: v2.0]
        /// Return a generic vertex attribute parameter
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the generic vertex attribute parameter to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetVertexAttribfv")]
        public static extern unsafe void GetVertexAttrib(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] Single* @params);

        /// <summary>[requires: v2.0]
        /// Return a generic vertex attribute parameter
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the generic vertex attribute parameter to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetVertexAttribfv")]
        public static extern void GetVertexAttrib(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] Single[] @params);

        /// <summary>[requires: v2.0]
        /// Return a generic vertex attribute parameter
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the generic vertex attribute parameter to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetVertexAttribfv")]
        public static extern void GetVertexAttrib(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] out Single @params);

        /// <summary>[requires: v2.0]
        /// Return a generic vertex attribute parameter
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the generic vertex attribute parameter to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetVertexAttribfv")]
        public static extern unsafe void GetVertexAttrib(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] Single* @params);

        /// <summary>[requires: v3.0]</summary>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetVertexAttribIiv")]
        public static extern void GetVertexAttribI(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetVertexAttribIiv")]
        public static extern unsafe void GetVertexAttribI(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetVertexAttribIiv")]
        public static extern void GetVertexAttribI(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetVertexAttribIiv")]
        public static extern unsafe void GetVertexAttribI(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetVertexAttribIuiv")]
        public static extern void GetVertexAttribI(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] out UInt32 @params);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glGetVertexAttribIuiv")]
        public static extern unsafe void GetVertexAttribI(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] UInt32* @params);

        /// <summary>[requires: v2.0]
        /// Return a generic vertex attribute parameter
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the generic vertex attribute parameter to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetVertexAttribiv")]
        public static extern void GetVertexAttrib(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v2.0]
        /// Return a generic vertex attribute parameter
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the generic vertex attribute parameter to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetVertexAttribiv")]
        public static extern void GetVertexAttrib(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v2.0]
        /// Return a generic vertex attribute parameter
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the generic vertex attribute parameter to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetVertexAttribiv")]
        public static extern unsafe void GetVertexAttrib(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v2.0]
        /// Return a generic vertex attribute parameter
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the generic vertex attribute parameter to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetVertexAttribiv")]
        public static extern void GetVertexAttrib(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] Int32[] @params);

        /// <summary>[requires: v2.0]
        /// Return a generic vertex attribute parameter
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the generic vertex attribute parameter to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetVertexAttribiv")]
        public static extern void GetVertexAttrib(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] out Int32 @params);

        /// <summary>[requires: v2.0]
        /// Return a generic vertex attribute parameter
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the generic vertex attribute parameter to be queried.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// Returns the requested data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetVertexAttribiv")]
        public static extern unsafe void GetVertexAttrib(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] Int32* @params);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glGetVertexAttribLdv")]
        public static extern void GetVertexAttribL(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] Double[] @params);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glGetVertexAttribLdv")]
        public static extern void GetVertexAttribL(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] out Double @params);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glGetVertexAttribLdv")]
        public static extern unsafe void GetVertexAttribL(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] Double* @params);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glGetVertexAttribLdv")]
        public static extern void GetVertexAttribL(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] Double[] @params);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glGetVertexAttribLdv")]
        public static extern void GetVertexAttribL(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] out Double @params);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glGetVertexAttribLdv")]
        public static extern unsafe void GetVertexAttribL(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] Double* @params);

        /// <summary>[requires: v2.0]
        /// Return the address of the specified generic vertex attribute pointer
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the generic vertex attribute parameter to be returned.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the generic vertex attribute parameter to be returned. Must be GL_VERTEX_ATTRIB_ARRAY_POINTER.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Returns the pointer value.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetVertexAttribPointerv")]
        public static extern void GetVertexAttribPointer(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribPointerParameter pname, [OutAttribute] IntPtr pointer);

        /// <summary>[requires: v2.0]
        /// Return the address of the specified generic vertex attribute pointer
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the generic vertex attribute parameter to be returned.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the generic vertex attribute parameter to be returned. Must be GL_VERTEX_ATTRIB_ARRAY_POINTER.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Returns the pointer value.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetVertexAttribPointerv")]
        public static extern void GetVertexAttribPointer<T2>(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribPointerParameter pname, [InAttribute, OutAttribute] T2[] pointer)
            where T2 : struct
        ;

        /// <summary>[requires: v2.0]
        /// Return the address of the specified generic vertex attribute pointer
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the generic vertex attribute parameter to be returned.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the generic vertex attribute parameter to be returned. Must be GL_VERTEX_ATTRIB_ARRAY_POINTER.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Returns the pointer value.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetVertexAttribPointerv")]
        public static extern void GetVertexAttribPointer<T2>(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribPointerParameter pname, [InAttribute, OutAttribute] T2[,] pointer)
            where T2 : struct
        ;

        /// <summary>[requires: v2.0]
        /// Return the address of the specified generic vertex attribute pointer
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the generic vertex attribute parameter to be returned.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the generic vertex attribute parameter to be returned. Must be GL_VERTEX_ATTRIB_ARRAY_POINTER.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Returns the pointer value.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetVertexAttribPointerv")]
        public static extern void GetVertexAttribPointer<T2>(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribPointerParameter pname, [InAttribute, OutAttribute] T2[,,] pointer)
            where T2 : struct
        ;

        /// <summary>[requires: v2.0]
        /// Return the address of the specified generic vertex attribute pointer
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the generic vertex attribute parameter to be returned.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the generic vertex attribute parameter to be returned. Must be GL_VERTEX_ATTRIB_ARRAY_POINTER.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Returns the pointer value.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetVertexAttribPointerv")]
        public static extern void GetVertexAttribPointer<T2>(Int32 index, OpenTK.Graphics.OpenGL.VertexAttribPointerParameter pname, [InAttribute, OutAttribute] ref T2 pointer)
            where T2 : struct
        ;

        /// <summary>[requires: v2.0]
        /// Return the address of the specified generic vertex attribute pointer
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the generic vertex attribute parameter to be returned.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the generic vertex attribute parameter to be returned. Must be GL_VERTEX_ATTRIB_ARRAY_POINTER.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Returns the pointer value.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetVertexAttribPointerv")]
        public static extern void GetVertexAttribPointer(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribPointerParameter pname, [OutAttribute] IntPtr pointer);

        /// <summary>[requires: v2.0]
        /// Return the address of the specified generic vertex attribute pointer
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the generic vertex attribute parameter to be returned.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the generic vertex attribute parameter to be returned. Must be GL_VERTEX_ATTRIB_ARRAY_POINTER.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Returns the pointer value.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetVertexAttribPointerv")]
        public static extern void GetVertexAttribPointer<T2>(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribPointerParameter pname, [InAttribute, OutAttribute] T2[] pointer)
            where T2 : struct
        ;

        /// <summary>[requires: v2.0]
        /// Return the address of the specified generic vertex attribute pointer
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the generic vertex attribute parameter to be returned.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the generic vertex attribute parameter to be returned. Must be GL_VERTEX_ATTRIB_ARRAY_POINTER.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Returns the pointer value.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetVertexAttribPointerv")]
        public static extern void GetVertexAttribPointer<T2>(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribPointerParameter pname, [InAttribute, OutAttribute] T2[,] pointer)
            where T2 : struct
        ;

        /// <summary>[requires: v2.0]
        /// Return the address of the specified generic vertex attribute pointer
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the generic vertex attribute parameter to be returned.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the generic vertex attribute parameter to be returned. Must be GL_VERTEX_ATTRIB_ARRAY_POINTER.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Returns the pointer value.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetVertexAttribPointerv")]
        public static extern void GetVertexAttribPointer<T2>(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribPointerParameter pname, [InAttribute, OutAttribute] T2[,,] pointer)
            where T2 : struct
        ;

        /// <summary>[requires: v2.0]
        /// Return the address of the specified generic vertex attribute pointer
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the generic vertex attribute parameter to be returned.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the generic vertex attribute parameter to be returned. Must be GL_VERTEX_ATTRIB_ARRAY_POINTER.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Returns the pointer value.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glGetVertexAttribPointerv")]
        public static extern void GetVertexAttribPointer<T2>(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribPointerParameter pname, [InAttribute, OutAttribute] ref T2 pointer)
            where T2 : struct
        ;

        /// <summary>[requires: v1.0]
        /// Specify implementation-specific hints
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies a symbolic constant indicating the behavior to be controlled. GL_LINE_SMOOTH_HINT, GL_POLYGON_SMOOTH_HINT, GL_TEXTURE_COMPRESSION_HINT, and GL_FRAGMENT_SHADER_DERIVATIVE_HINT are accepted.
        /// </para>
        /// </param>
        /// <param name="mode">
        /// <para>
        /// Specifies a symbolic constant indicating the desired behavior. GL_FASTEST, GL_NICEST, and GL_DONT_CARE are accepted.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glHint")]
        public static extern void Hint(OpenTK.Graphics.OpenGL.HintTarget target, OpenTK.Graphics.OpenGL.HintMode mode);

        /// <summary>
        /// Define histogram table
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The histogram whose parameters are to be set. Must be one of GL_HISTOGRAM or GL_PROXY_HISTOGRAM.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The number of entries in the histogram table. Must be a power of 2.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The format of entries in the histogram table. Must be one of GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
        /// </para>
        /// </param>
        /// <param name="sink">
        /// <para>
        /// If GL_TRUE, pixels will be consumed by the histogramming process and no drawing or texture loading will take place. If GL_FALSE, pixels will proceed to the minmax process after histogramming.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glHistogram")]
        public static extern void Histogram(OpenTK.Graphics.OpenGL.HistogramTarget target, Int32 width, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, bool sink);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color index
        /// </summary>
        /// <param name="c">
        /// <para>
        /// Specifies the new value for the current color index.
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glIndexd")]
        public static extern void Index(Double c);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color index
        /// </summary>
        /// <param name="c">
        /// <para>
        /// Specifies the new value for the current color index.
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glIndexdv")]
        public static extern unsafe void Index(Double* c);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color index
        /// </summary>
        /// <param name="c">
        /// <para>
        /// Specifies the new value for the current color index.
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glIndexf")]
        public static extern void Index(Single c);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color index
        /// </summary>
        /// <param name="c">
        /// <para>
        /// Specifies the new value for the current color index.
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glIndexfv")]
        public static extern unsafe void Index(Single* c);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color index
        /// </summary>
        /// <param name="c">
        /// <para>
        /// Specifies the new value for the current color index.
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glIndexi")]
        public static extern void Index(Int32 c);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color index
        /// </summary>
        /// <param name="c">
        /// <para>
        /// Specifies the new value for the current color index.
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glIndexiv")]
        public static extern unsafe void Index(Int32* c);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Control the writing of individual bits in the color index buffers
        /// </summary>
        /// <param name="mask">
        /// <para>
        /// Specifies a bit mask to enable and disable the writing of individual bits in the color index buffers. Initially, the mask is all 1's.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glIndexMask")]
        public static extern void IndexMask(Int32 mask);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Control the writing of individual bits in the color index buffers
        /// </summary>
        /// <param name="mask">
        /// <para>
        /// Specifies a bit mask to enable and disable the writing of individual bits in the color index buffers. Initially, the mask is all 1's.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glIndexMask")]
        public static extern void IndexMask(UInt32 mask);

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Define an array of color indexes
        /// </summary>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each color index in the array. Symbolic constants GL_UNSIGNED_BYTE, GL_SHORT, GL_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive color indexes. If stride is 0, the color indexes are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first index in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glIndexPointer")]
        public static extern void IndexPointer(OpenTK.Graphics.OpenGL.IndexPointerType type, Int32 stride, IntPtr pointer);

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Define an array of color indexes
        /// </summary>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each color index in the array. Symbolic constants GL_UNSIGNED_BYTE, GL_SHORT, GL_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive color indexes. If stride is 0, the color indexes are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first index in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glIndexPointer")]
        public static extern void IndexPointer<T2>(OpenTK.Graphics.OpenGL.IndexPointerType type, Int32 stride, [InAttribute, OutAttribute] T2[] pointer)
            where T2 : struct
        ;

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Define an array of color indexes
        /// </summary>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each color index in the array. Symbolic constants GL_UNSIGNED_BYTE, GL_SHORT, GL_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive color indexes. If stride is 0, the color indexes are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first index in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glIndexPointer")]
        public static extern void IndexPointer<T2>(OpenTK.Graphics.OpenGL.IndexPointerType type, Int32 stride, [InAttribute, OutAttribute] T2[,] pointer)
            where T2 : struct
        ;

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Define an array of color indexes
        /// </summary>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each color index in the array. Symbolic constants GL_UNSIGNED_BYTE, GL_SHORT, GL_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive color indexes. If stride is 0, the color indexes are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first index in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glIndexPointer")]
        public static extern void IndexPointer<T2>(OpenTK.Graphics.OpenGL.IndexPointerType type, Int32 stride, [InAttribute, OutAttribute] T2[,,] pointer)
            where T2 : struct
        ;

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Define an array of color indexes
        /// </summary>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each color index in the array. Symbolic constants GL_UNSIGNED_BYTE, GL_SHORT, GL_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive color indexes. If stride is 0, the color indexes are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first index in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glIndexPointer")]
        public static extern void IndexPointer<T2>(OpenTK.Graphics.OpenGL.IndexPointerType type, Int32 stride, [InAttribute, OutAttribute] ref T2 pointer)
            where T2 : struct
        ;

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color index
        /// </summary>
        /// <param name="c">
        /// <para>
        /// Specifies the new value for the current color index.
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glIndexs")]
        public static extern void Index(Int16 c);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current color index
        /// </summary>
        /// <param name="c">
        /// <para>
        /// Specifies the new value for the current color index.
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glIndexsv")]
        public static extern unsafe void Index(Int16* c);

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Set the current color index
        /// </summary>
        /// <param name="c">
        /// <para>
        /// Specifies the new value for the current color index.
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glIndexub")]
        public static extern void Index(Byte c);

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Set the current color index
        /// </summary>
        /// <param name="c">
        /// <para>
        /// Specifies the new value for the current color index.
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glIndexubv")]
        public static extern unsafe void Index(Byte* c);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Initialize the name stack
        /// </summary>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glInitNames")]
        public static extern void InitNames();

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Simultaneously specify and enable several interleaved arrays
        /// </summary>
        /// <param name="format">
        /// <para>
        /// Specifies the type of array to enable. Symbolic constants GL_V2F, GL_V3F, GL_C4UB_V2F, GL_C4UB_V3F, GL_C3F_V3F, GL_N3F_V3F, GL_C4F_N3F_V3F, GL_T2F_V3F, GL_T4F_V4F, GL_T2F_C4UB_V3F, GL_T2F_C3F_V3F, GL_T2F_N3F_V3F, GL_T2F_C4F_N3F_V3F, and GL_T4F_C4F_N3F_V4F are accepted.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the offset in bytes between each aggregate array element.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glInterleavedArrays")]
        public static extern void InterleavedArrays(OpenTK.Graphics.OpenGL.InterleavedArrayFormat format, Int32 stride, IntPtr pointer);

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Simultaneously specify and enable several interleaved arrays
        /// </summary>
        /// <param name="format">
        /// <para>
        /// Specifies the type of array to enable. Symbolic constants GL_V2F, GL_V3F, GL_C4UB_V2F, GL_C4UB_V3F, GL_C3F_V3F, GL_N3F_V3F, GL_C4F_N3F_V3F, GL_T2F_V3F, GL_T4F_V4F, GL_T2F_C4UB_V3F, GL_T2F_C3F_V3F, GL_T2F_N3F_V3F, GL_T2F_C4F_N3F_V3F, and GL_T4F_C4F_N3F_V4F are accepted.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the offset in bytes between each aggregate array element.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glInterleavedArrays")]
        public static extern void InterleavedArrays<T2>(OpenTK.Graphics.OpenGL.InterleavedArrayFormat format, Int32 stride, [InAttribute, OutAttribute] T2[] pointer)
            where T2 : struct
        ;

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Simultaneously specify and enable several interleaved arrays
        /// </summary>
        /// <param name="format">
        /// <para>
        /// Specifies the type of array to enable. Symbolic constants GL_V2F, GL_V3F, GL_C4UB_V2F, GL_C4UB_V3F, GL_C3F_V3F, GL_N3F_V3F, GL_C4F_N3F_V3F, GL_T2F_V3F, GL_T4F_V4F, GL_T2F_C4UB_V3F, GL_T2F_C3F_V3F, GL_T2F_N3F_V3F, GL_T2F_C4F_N3F_V3F, and GL_T4F_C4F_N3F_V4F are accepted.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the offset in bytes between each aggregate array element.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glInterleavedArrays")]
        public static extern void InterleavedArrays<T2>(OpenTK.Graphics.OpenGL.InterleavedArrayFormat format, Int32 stride, [InAttribute, OutAttribute] T2[,] pointer)
            where T2 : struct
        ;

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Simultaneously specify and enable several interleaved arrays
        /// </summary>
        /// <param name="format">
        /// <para>
        /// Specifies the type of array to enable. Symbolic constants GL_V2F, GL_V3F, GL_C4UB_V2F, GL_C4UB_V3F, GL_C3F_V3F, GL_N3F_V3F, GL_C4F_N3F_V3F, GL_T2F_V3F, GL_T4F_V4F, GL_T2F_C4UB_V3F, GL_T2F_C3F_V3F, GL_T2F_N3F_V3F, GL_T2F_C4F_N3F_V3F, and GL_T4F_C4F_N3F_V4F are accepted.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the offset in bytes between each aggregate array element.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glInterleavedArrays")]
        public static extern void InterleavedArrays<T2>(OpenTK.Graphics.OpenGL.InterleavedArrayFormat format, Int32 stride, [InAttribute, OutAttribute] T2[,,] pointer)
            where T2 : struct
        ;

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Simultaneously specify and enable several interleaved arrays
        /// </summary>
        /// <param name="format">
        /// <para>
        /// Specifies the type of array to enable. Symbolic constants GL_V2F, GL_V3F, GL_C4UB_V2F, GL_C4UB_V3F, GL_C3F_V3F, GL_N3F_V3F, GL_C4F_N3F_V3F, GL_T2F_V3F, GL_T4F_V4F, GL_T2F_C4UB_V3F, GL_T2F_C3F_V3F, GL_T2F_N3F_V3F, GL_T2F_C4F_N3F_V3F, and GL_T4F_C4F_N3F_V4F are accepted.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the offset in bytes between each aggregate array element.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glInterleavedArrays")]
        public static extern void InterleavedArrays<T2>(OpenTK.Graphics.OpenGL.InterleavedArrayFormat format, Int32 stride, [InAttribute, OutAttribute] ref T2 pointer)
            where T2 : struct
        ;

        /// <summary>[requires: v4.3 and ARB_invalidate_subdata|VERSION_4_3]
        /// Invalidate the content of a buffer object's data store
        /// </summary>
        /// <param name="buffer">
        /// <para>
        /// The name of a buffer object whose data store to invalidate.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_invalidate_subdata|VERSION_4_3", Version = "4.3", EntryPoint = "glInvalidateBufferData")]
        public static extern void InvalidateBufferData(Int32 buffer);

        /// <summary>[requires: v4.3 and ARB_invalidate_subdata|VERSION_4_3]
        /// Invalidate the content of a buffer object's data store
        /// </summary>
        /// <param name="buffer">
        /// <para>
        /// The name of a buffer object whose data store to invalidate.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_invalidate_subdata|VERSION_4_3", Version = "4.3", EntryPoint = "glInvalidateBufferData")]
        public static extern void InvalidateBufferData(UInt32 buffer);

        /// <summary>[requires: v4.3 and ARB_invalidate_subdata|VERSION_4_3]
        /// Invalidate a region of a buffer object's data store
        /// </summary>
        /// <param name="buffer">
        /// <para>
        /// The name of a buffer object, a subrange of whose data store to invalidate.
        /// </para>
        /// </param>
        /// <param name="offset">
        /// <para>
        /// The offset within the buffer's data store of the start of the range to be invalidated.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The length of the range within the buffer's data store to be invalidated.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_invalidate_subdata|VERSION_4_3", Version = "4.3", EntryPoint = "glInvalidateBufferSubData")]
        public static extern void InvalidateBufferSubData(Int32 buffer, IntPtr offset, IntPtr length);

        /// <summary>[requires: v4.3 and ARB_invalidate_subdata|VERSION_4_3]
        /// Invalidate a region of a buffer object's data store
        /// </summary>
        /// <param name="buffer">
        /// <para>
        /// The name of a buffer object, a subrange of whose data store to invalidate.
        /// </para>
        /// </param>
        /// <param name="offset">
        /// <para>
        /// The offset within the buffer's data store of the start of the range to be invalidated.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The length of the range within the buffer's data store to be invalidated.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_invalidate_subdata|VERSION_4_3", Version = "4.3", EntryPoint = "glInvalidateBufferSubData")]
        public static extern void InvalidateBufferSubData(UInt32 buffer, IntPtr offset, IntPtr length);

        /// <summary>[requires: v4.3 and ARB_invalidate_subdata|VERSION_4_3]
        /// Invalidate the content some or all of a framebuffer object's attachments
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The target to which the framebuffer is attached. target must be GL_FRAMEBUFFER, GL_DRAW_FRAMEBUFFER, or GL_READ_FRAMEBUFFER.
        /// </para>
        /// </param>
        /// <param name="numAttachments">
        /// <para>
        /// The number of entries in the attachments array.
        /// </para>
        /// </param>
        /// <param name="attachments">
        /// <para>
        /// The address of an array identifying the attachments to be invalidated.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_invalidate_subdata|VERSION_4_3", Version = "4.3", EntryPoint = "glInvalidateFramebuffer")]
        public static extern void InvalidateFramebuffer(OpenTK.Graphics.OpenGL.FramebufferTarget target, Int32 numAttachments, OpenTK.Graphics.OpenGL.FramebufferAttachment[] attachments);

        /// <summary>[requires: v4.3 and ARB_invalidate_subdata|VERSION_4_3]
        /// Invalidate the content some or all of a framebuffer object's attachments
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The target to which the framebuffer is attached. target must be GL_FRAMEBUFFER, GL_DRAW_FRAMEBUFFER, or GL_READ_FRAMEBUFFER.
        /// </para>
        /// </param>
        /// <param name="numAttachments">
        /// <para>
        /// The number of entries in the attachments array.
        /// </para>
        /// </param>
        /// <param name="attachments">
        /// <para>
        /// The address of an array identifying the attachments to be invalidated.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_invalidate_subdata|VERSION_4_3", Version = "4.3", EntryPoint = "glInvalidateFramebuffer")]
        public static extern void InvalidateFramebuffer(OpenTK.Graphics.OpenGL.FramebufferTarget target, Int32 numAttachments, ref OpenTK.Graphics.OpenGL.FramebufferAttachment attachments);

        /// <summary>[requires: v4.3 and ARB_invalidate_subdata|VERSION_4_3]
        /// Invalidate the content some or all of a framebuffer object's attachments
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The target to which the framebuffer is attached. target must be GL_FRAMEBUFFER, GL_DRAW_FRAMEBUFFER, or GL_READ_FRAMEBUFFER.
        /// </para>
        /// </param>
        /// <param name="numAttachments">
        /// <para>
        /// The number of entries in the attachments array.
        /// </para>
        /// </param>
        /// <param name="attachments">
        /// <para>
        /// The address of an array identifying the attachments to be invalidated.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_invalidate_subdata|VERSION_4_3", Version = "4.3", EntryPoint = "glInvalidateFramebuffer")]
        public static extern unsafe void InvalidateFramebuffer(OpenTK.Graphics.OpenGL.FramebufferTarget target, Int32 numAttachments, OpenTK.Graphics.OpenGL.FramebufferAttachment* attachments);

        /// <summary>[requires: v4.3 and ARB_invalidate_subdata|VERSION_4_3]
        /// Invalidate the content of a region of some or all of a framebuffer object's attachments
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The target to which the framebuffer is attached. target must be GL_FRAMEBUFFER, GL_DRAW_FRAMEBUFFER, or GL_READ_FRAMEBUFFER.
        /// </para>
        /// </param>
        /// <param name="numAttachments">
        /// <para>
        /// The number of entries in the attachments array.
        /// </para>
        /// </param>
        /// <param name="attachments">
        /// <para>
        /// The address of an array identifying the attachments to be invalidated.
        /// </para>
        /// </param>
        /// <param name="x">
        /// <para>
        /// The X offset of the region to be invalidated.
        /// </para>
        /// </param>
        /// <param name="y">
        /// <para>
        /// The Y offset of the region to be invalidated.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The width of the region to be invalidated.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// The height of the region to be invalidated.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_invalidate_subdata|VERSION_4_3", Version = "4.3", EntryPoint = "glInvalidateSubFramebuffer")]
        public static extern void InvalidateSubFramebuffer(OpenTK.Graphics.OpenGL.FramebufferTarget target, Int32 numAttachments, OpenTK.Graphics.OpenGL.FramebufferAttachment[] attachments, Int32 x, Int32 y, Int32 width, Int32 height);

        /// <summary>[requires: v4.3 and ARB_invalidate_subdata|VERSION_4_3]
        /// Invalidate the content of a region of some or all of a framebuffer object's attachments
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The target to which the framebuffer is attached. target must be GL_FRAMEBUFFER, GL_DRAW_FRAMEBUFFER, or GL_READ_FRAMEBUFFER.
        /// </para>
        /// </param>
        /// <param name="numAttachments">
        /// <para>
        /// The number of entries in the attachments array.
        /// </para>
        /// </param>
        /// <param name="attachments">
        /// <para>
        /// The address of an array identifying the attachments to be invalidated.
        /// </para>
        /// </param>
        /// <param name="x">
        /// <para>
        /// The X offset of the region to be invalidated.
        /// </para>
        /// </param>
        /// <param name="y">
        /// <para>
        /// The Y offset of the region to be invalidated.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The width of the region to be invalidated.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// The height of the region to be invalidated.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_invalidate_subdata|VERSION_4_3", Version = "4.3", EntryPoint = "glInvalidateSubFramebuffer")]
        public static extern void InvalidateSubFramebuffer(OpenTK.Graphics.OpenGL.FramebufferTarget target, Int32 numAttachments, ref OpenTK.Graphics.OpenGL.FramebufferAttachment attachments, Int32 x, Int32 y, Int32 width, Int32 height);

        /// <summary>[requires: v4.3 and ARB_invalidate_subdata|VERSION_4_3]
        /// Invalidate the content of a region of some or all of a framebuffer object's attachments
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The target to which the framebuffer is attached. target must be GL_FRAMEBUFFER, GL_DRAW_FRAMEBUFFER, or GL_READ_FRAMEBUFFER.
        /// </para>
        /// </param>
        /// <param name="numAttachments">
        /// <para>
        /// The number of entries in the attachments array.
        /// </para>
        /// </param>
        /// <param name="attachments">
        /// <para>
        /// The address of an array identifying the attachments to be invalidated.
        /// </para>
        /// </param>
        /// <param name="x">
        /// <para>
        /// The X offset of the region to be invalidated.
        /// </para>
        /// </param>
        /// <param name="y">
        /// <para>
        /// The Y offset of the region to be invalidated.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The width of the region to be invalidated.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// The height of the region to be invalidated.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_invalidate_subdata|VERSION_4_3", Version = "4.3", EntryPoint = "glInvalidateSubFramebuffer")]
        public static extern unsafe void InvalidateSubFramebuffer(OpenTK.Graphics.OpenGL.FramebufferTarget target, Int32 numAttachments, OpenTK.Graphics.OpenGL.FramebufferAttachment* attachments, Int32 x, Int32 y, Int32 width, Int32 height);

        /// <summary>[requires: v4.3 and ARB_invalidate_subdata|VERSION_4_3]
        /// Invalidate the entirety a texture image
        /// </summary>
        /// <param name="texture">
        /// <para>
        /// The name of a texture object to invalidate.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// The level of detail of the texture object to invalidate.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_invalidate_subdata|VERSION_4_3", Version = "4.3", EntryPoint = "glInvalidateTexImage")]
        public static extern void InvalidateTexImage(Int32 texture, Int32 level);

        /// <summary>[requires: v4.3 and ARB_invalidate_subdata|VERSION_4_3]
        /// Invalidate the entirety a texture image
        /// </summary>
        /// <param name="texture">
        /// <para>
        /// The name of a texture object to invalidate.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// The level of detail of the texture object to invalidate.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_invalidate_subdata|VERSION_4_3", Version = "4.3", EntryPoint = "glInvalidateTexImage")]
        public static extern void InvalidateTexImage(UInt32 texture, Int32 level);

        /// <summary>[requires: v4.3 and ARB_invalidate_subdata|VERSION_4_3]
        /// Invalidate a region of a texture image
        /// </summary>
        /// <param name="texture">
        /// <para>
        /// The name of a texture object a subregion of which to invalidate.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// The level of detail of the texture object within which the region resides.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// The X offset of the region to be invalidated.
        /// </para>
        /// </param>
        /// <param name="yoffset">
        /// <para>
        /// The Y offset of the region to be invalidated.
        /// </para>
        /// </param>
        /// <param name="zoffset">
        /// <para>
        /// The Z offset of the region to be invalidated.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The width of the region to be invalidated.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// The height of the region to be invalidated.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// The depth of the region to be invalidated.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_invalidate_subdata|VERSION_4_3", Version = "4.3", EntryPoint = "glInvalidateTexSubImage")]
        public static extern void InvalidateTexSubImage(Int32 texture, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth);

        /// <summary>[requires: v4.3 and ARB_invalidate_subdata|VERSION_4_3]
        /// Invalidate a region of a texture image
        /// </summary>
        /// <param name="texture">
        /// <para>
        /// The name of a texture object a subregion of which to invalidate.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// The level of detail of the texture object within which the region resides.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// The X offset of the region to be invalidated.
        /// </para>
        /// </param>
        /// <param name="yoffset">
        /// <para>
        /// The Y offset of the region to be invalidated.
        /// </para>
        /// </param>
        /// <param name="zoffset">
        /// <para>
        /// The Z offset of the region to be invalidated.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The width of the region to be invalidated.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// The height of the region to be invalidated.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// The depth of the region to be invalidated.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_invalidate_subdata|VERSION_4_3", Version = "4.3", EntryPoint = "glInvalidateTexSubImage")]
        public static extern void InvalidateTexSubImage(UInt32 texture, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth);

        /// <summary>[requires: v1.5]
        /// Determine if a name corresponds to a buffer object
        /// </summary>
        /// <param name="buffer">
        /// <para>
        /// Specifies a value that may be the name of a buffer object.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glIsBuffer")]
        public static extern bool IsBuffer(Int32 buffer);

        /// <summary>[requires: v1.5]
        /// Determine if a name corresponds to a buffer object
        /// </summary>
        /// <param name="buffer">
        /// <para>
        /// Specifies a value that may be the name of a buffer object.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glIsBuffer")]
        public static extern bool IsBuffer(UInt32 buffer);

        /// <summary>[requires: v1.0]
        /// Test whether a capability is enabled
        /// </summary>
        /// <param name="cap">
        /// <para>
        /// Specifies a symbolic constant indicating a GL capability.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the capability.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glIsEnabled")]
        public static extern bool IsEnabled(OpenTK.Graphics.OpenGL.EnableCap cap);

        /// <summary>[requires: v3.0]
        /// Test whether a capability is enabled
        /// </summary>
        /// <param name="cap">
        /// <para>
        /// Specifies a symbolic constant indicating a GL capability.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the capability.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glIsEnabledi")]
        public static extern bool IsEnabled(OpenTK.Graphics.OpenGL.IndexedEnableCap target, Int32 index);

        /// <summary>[requires: v3.0]
        /// Test whether a capability is enabled
        /// </summary>
        /// <param name="cap">
        /// <para>
        /// Specifies a symbolic constant indicating a GL capability.
        /// </para>
        /// </param>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the capability.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glIsEnabledi")]
        public static extern bool IsEnabled(OpenTK.Graphics.OpenGL.IndexedEnableCap target, UInt32 index);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Determine if a name corresponds to a framebuffer object
        /// </summary>
        /// <param name="framebuffer">
        /// <para>
        /// Specifies a value that may be the name of a framebuffer object.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glIsFramebuffer")]
        public static extern bool IsFramebuffer(Int32 framebuffer);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Determine if a name corresponds to a framebuffer object
        /// </summary>
        /// <param name="framebuffer">
        /// <para>
        /// Specifies a value that may be the name of a framebuffer object.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glIsFramebuffer")]
        public static extern bool IsFramebuffer(UInt32 framebuffer);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Determine if a name corresponds to a display list
        /// </summary>
        /// <param name="list">
        /// <para>
        /// Specifies a potential display list name.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glIsList")]
        public static extern bool IsList(Int32 list);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Determine if a name corresponds to a display list
        /// </summary>
        /// <param name="list">
        /// <para>
        /// Specifies a potential display list name.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glIsList")]
        public static extern bool IsList(UInt32 list);

        /// <summary>[requires: v2.0]
        /// Determines if a name corresponds to a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies a potential program object.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glIsProgram")]
        public static extern bool IsProgram(Int32 program);

        /// <summary>[requires: v2.0]
        /// Determines if a name corresponds to a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies a potential program object.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glIsProgram")]
        public static extern bool IsProgram(UInt32 program);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Determine if a name corresponds to a program pipeline object
        /// </summary>
        /// <param name="pipeline">
        /// <para>
        /// Specifies a value that may be the name of a program pipeline object.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glIsProgramPipeline")]
        public static extern bool IsProgramPipeline(Int32 pipeline);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Determine if a name corresponds to a program pipeline object
        /// </summary>
        /// <param name="pipeline">
        /// <para>
        /// Specifies a value that may be the name of a program pipeline object.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glIsProgramPipeline")]
        public static extern bool IsProgramPipeline(UInt32 pipeline);

        /// <summary>[requires: v1.5]
        /// Determine if a name corresponds to a query object
        /// </summary>
        /// <param name="id">
        /// <para>
        /// Specifies a value that may be the name of a query object.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glIsQuery")]
        public static extern bool IsQuery(Int32 id);

        /// <summary>[requires: v1.5]
        /// Determine if a name corresponds to a query object
        /// </summary>
        /// <param name="id">
        /// <para>
        /// Specifies a value that may be the name of a query object.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glIsQuery")]
        public static extern bool IsQuery(UInt32 id);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Determine if a name corresponds to a renderbuffer object
        /// </summary>
        /// <param name="renderbuffer">
        /// <para>
        /// Specifies a value that may be the name of a renderbuffer object.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glIsRenderbuffer")]
        public static extern bool IsRenderbuffer(Int32 renderbuffer);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Determine if a name corresponds to a renderbuffer object
        /// </summary>
        /// <param name="renderbuffer">
        /// <para>
        /// Specifies a value that may be the name of a renderbuffer object.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glIsRenderbuffer")]
        public static extern bool IsRenderbuffer(UInt32 renderbuffer);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Determine if a name corresponds to a sampler object
        /// </summary>
        /// <param name="id">
        /// <para>
        /// Specifies a value that may be the name of a sampler object.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glIsSampler")]
        public static extern bool IsSampler(Int32 sampler);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Determine if a name corresponds to a sampler object
        /// </summary>
        /// <param name="id">
        /// <para>
        /// Specifies a value that may be the name of a sampler object.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glIsSampler")]
        public static extern bool IsSampler(UInt32 sampler);

        /// <summary>[requires: v2.0]
        /// Determines if a name corresponds to a shader object
        /// </summary>
        /// <param name="shader">
        /// <para>
        /// Specifies a potential shader object.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glIsShader")]
        public static extern bool IsShader(Int32 shader);

        /// <summary>[requires: v2.0]
        /// Determines if a name corresponds to a shader object
        /// </summary>
        /// <param name="shader">
        /// <para>
        /// Specifies a potential shader object.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glIsShader")]
        public static extern bool IsShader(UInt32 shader);

        /// <summary>[requires: v3.2 and ARB_sync|VERSION_3_2]
        /// Determine if a name corresponds to a sync object
        /// </summary>
        /// <param name="sync">
        /// <para>
        /// Specifies a value that may be the name of a sync object.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_sync|VERSION_3_2", Version = "3.2", EntryPoint = "glIsSync")]
        public static extern bool IsSync(IntPtr sync);

        /// <summary>[requires: v1.1]
        /// Determine if a name corresponds to a texture
        /// </summary>
        /// <param name="texture">
        /// <para>
        /// Specifies a value that may be the name of a texture.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glIsTexture")]
        public static extern bool IsTexture(Int32 texture);

        /// <summary>[requires: v1.1]
        /// Determine if a name corresponds to a texture
        /// </summary>
        /// <param name="texture">
        /// <para>
        /// Specifies a value that may be the name of a texture.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glIsTexture")]
        public static extern bool IsTexture(UInt32 texture);

        /// <summary>[requires: v4.0 and ARB_transform_feedback2|VERSION_4_0]
        /// Determine if a name corresponds to a transform feedback object
        /// </summary>
        /// <param name="id">
        /// <para>
        /// Specifies a value that may be the name of a transform feedback object.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_transform_feedback2|VERSION_4_0", Version = "4.0", EntryPoint = "glIsTransformFeedback")]
        public static extern bool IsTransformFeedback(Int32 id);

        /// <summary>[requires: v4.0 and ARB_transform_feedback2|VERSION_4_0]
        /// Determine if a name corresponds to a transform feedback object
        /// </summary>
        /// <param name="id">
        /// <para>
        /// Specifies a value that may be the name of a transform feedback object.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_transform_feedback2|VERSION_4_0", Version = "4.0", EntryPoint = "glIsTransformFeedback")]
        public static extern bool IsTransformFeedback(UInt32 id);

        /// <summary>[requires: v3.0 and ARB_vertex_array_object|VERSION_3_0]
        /// Determine if a name corresponds to a vertex array object
        /// </summary>
        /// <param name="array">
        /// <para>
        /// Specifies a value that may be the name of a vertex array object.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_vertex_array_object|VERSION_3_0", Version = "3.0", EntryPoint = "glIsVertexArray")]
        public static extern bool IsVertexArray(Int32 array);

        /// <summary>[requires: v3.0 and ARB_vertex_array_object|VERSION_3_0]
        /// Determine if a name corresponds to a vertex array object
        /// </summary>
        /// <param name="array">
        /// <para>
        /// Specifies a value that may be the name of a vertex array object.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_array_object|VERSION_3_0", Version = "3.0", EntryPoint = "glIsVertexArray")]
        public static extern bool IsVertexArray(UInt32 array);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set light source parameters
        /// </summary>
        /// <param name="light">
        /// <para>
        /// Specifies a light. The number of lights depends on the implementation, but at least eight lights are supported. They are identified by symbolic names of the form GL_LIGHT , where i ranges from 0 to the value of GL_MAX_LIGHTS - 1.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies a single-valued light source parameter for light. GL_SPOT_EXPONENT, GL_SPOT_CUTOFF, GL_CONSTANT_ATTENUATION, GL_LINEAR_ATTENUATION, and GL_QUADRATIC_ATTENUATION are accepted.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies the value that parameter pname of light source light will be set to.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glLightf")]
        public static extern void Light(OpenTK.Graphics.OpenGL.LightName light, OpenTK.Graphics.OpenGL.LightParameter pname, Single param);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set light source parameters
        /// </summary>
        /// <param name="light">
        /// <para>
        /// Specifies a light. The number of lights depends on the implementation, but at least eight lights are supported. They are identified by symbolic names of the form GL_LIGHT , where i ranges from 0 to the value of GL_MAX_LIGHTS - 1.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies a single-valued light source parameter for light. GL_SPOT_EXPONENT, GL_SPOT_CUTOFF, GL_CONSTANT_ATTENUATION, GL_LINEAR_ATTENUATION, and GL_QUADRATIC_ATTENUATION are accepted.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies the value that parameter pname of light source light will be set to.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glLightfv")]
        public static extern void Light(OpenTK.Graphics.OpenGL.LightName light, OpenTK.Graphics.OpenGL.LightParameter pname, Single[] @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set light source parameters
        /// </summary>
        /// <param name="light">
        /// <para>
        /// Specifies a light. The number of lights depends on the implementation, but at least eight lights are supported. They are identified by symbolic names of the form GL_LIGHT , where i ranges from 0 to the value of GL_MAX_LIGHTS - 1.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies a single-valued light source parameter for light. GL_SPOT_EXPONENT, GL_SPOT_CUTOFF, GL_CONSTANT_ATTENUATION, GL_LINEAR_ATTENUATION, and GL_QUADRATIC_ATTENUATION are accepted.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies the value that parameter pname of light source light will be set to.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glLightfv")]
        public static extern unsafe void Light(OpenTK.Graphics.OpenGL.LightName light, OpenTK.Graphics.OpenGL.LightParameter pname, Single* @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set light source parameters
        /// </summary>
        /// <param name="light">
        /// <para>
        /// Specifies a light. The number of lights depends on the implementation, but at least eight lights are supported. They are identified by symbolic names of the form GL_LIGHT , where i ranges from 0 to the value of GL_MAX_LIGHTS - 1.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies a single-valued light source parameter for light. GL_SPOT_EXPONENT, GL_SPOT_CUTOFF, GL_CONSTANT_ATTENUATION, GL_LINEAR_ATTENUATION, and GL_QUADRATIC_ATTENUATION are accepted.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies the value that parameter pname of light source light will be set to.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glLighti")]
        public static extern void Light(OpenTK.Graphics.OpenGL.LightName light, OpenTK.Graphics.OpenGL.LightParameter pname, Int32 param);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set light source parameters
        /// </summary>
        /// <param name="light">
        /// <para>
        /// Specifies a light. The number of lights depends on the implementation, but at least eight lights are supported. They are identified by symbolic names of the form GL_LIGHT , where i ranges from 0 to the value of GL_MAX_LIGHTS - 1.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies a single-valued light source parameter for light. GL_SPOT_EXPONENT, GL_SPOT_CUTOFF, GL_CONSTANT_ATTENUATION, GL_LINEAR_ATTENUATION, and GL_QUADRATIC_ATTENUATION are accepted.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies the value that parameter pname of light source light will be set to.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glLightiv")]
        public static extern void Light(OpenTK.Graphics.OpenGL.LightName light, OpenTK.Graphics.OpenGL.LightParameter pname, Int32[] @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set light source parameters
        /// </summary>
        /// <param name="light">
        /// <para>
        /// Specifies a light. The number of lights depends on the implementation, but at least eight lights are supported. They are identified by symbolic names of the form GL_LIGHT , where i ranges from 0 to the value of GL_MAX_LIGHTS - 1.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies a single-valued light source parameter for light. GL_SPOT_EXPONENT, GL_SPOT_CUTOFF, GL_CONSTANT_ATTENUATION, GL_LINEAR_ATTENUATION, and GL_QUADRATIC_ATTENUATION are accepted.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies the value that parameter pname of light source light will be set to.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glLightiv")]
        public static extern unsafe void Light(OpenTK.Graphics.OpenGL.LightName light, OpenTK.Graphics.OpenGL.LightParameter pname, Int32* @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the lighting model parameters
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies a single-valued lighting model parameter. GL_LIGHT_MODEL_LOCAL_VIEWER, GL_LIGHT_MODEL_COLOR_CONTROL, and GL_LIGHT_MODEL_TWO_SIDE are accepted.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies the value that param will be set to.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glLightModelf")]
        public static extern void LightModel(OpenTK.Graphics.OpenGL.LightModelParameter pname, Single param);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the lighting model parameters
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies a single-valued lighting model parameter. GL_LIGHT_MODEL_LOCAL_VIEWER, GL_LIGHT_MODEL_COLOR_CONTROL, and GL_LIGHT_MODEL_TWO_SIDE are accepted.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies the value that param will be set to.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glLightModelfv")]
        public static extern void LightModel(OpenTK.Graphics.OpenGL.LightModelParameter pname, Single[] @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the lighting model parameters
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies a single-valued lighting model parameter. GL_LIGHT_MODEL_LOCAL_VIEWER, GL_LIGHT_MODEL_COLOR_CONTROL, and GL_LIGHT_MODEL_TWO_SIDE are accepted.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies the value that param will be set to.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glLightModelfv")]
        public static extern unsafe void LightModel(OpenTK.Graphics.OpenGL.LightModelParameter pname, Single* @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the lighting model parameters
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies a single-valued lighting model parameter. GL_LIGHT_MODEL_LOCAL_VIEWER, GL_LIGHT_MODEL_COLOR_CONTROL, and GL_LIGHT_MODEL_TWO_SIDE are accepted.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies the value that param will be set to.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glLightModeli")]
        public static extern void LightModel(OpenTK.Graphics.OpenGL.LightModelParameter pname, Int32 param);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the lighting model parameters
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies a single-valued lighting model parameter. GL_LIGHT_MODEL_LOCAL_VIEWER, GL_LIGHT_MODEL_COLOR_CONTROL, and GL_LIGHT_MODEL_TWO_SIDE are accepted.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies the value that param will be set to.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glLightModeliv")]
        public static extern void LightModel(OpenTK.Graphics.OpenGL.LightModelParameter pname, Int32[] @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the lighting model parameters
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies a single-valued lighting model parameter. GL_LIGHT_MODEL_LOCAL_VIEWER, GL_LIGHT_MODEL_COLOR_CONTROL, and GL_LIGHT_MODEL_TWO_SIDE are accepted.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies the value that param will be set to.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glLightModeliv")]
        public static extern unsafe void LightModel(OpenTK.Graphics.OpenGL.LightModelParameter pname, Int32* @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the line stipple pattern
        /// </summary>
        /// <param name="factor">
        /// <para>
        /// Specifies a multiplier for each bit in the line stipple pattern. If factor is 3, for example, each bit in the pattern is used three times before the next bit in the pattern is used. factor is clamped to the range [1, 256] and defaults to 1.
        /// </para>
        /// </param>
        /// <param name="pattern">
        /// <para>
        /// Specifies a 16-bit integer whose bit pattern determines which fragments of a line will be drawn when the line is rasterized. Bit zero is used first; the default pattern is all 1's.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glLineStipple")]
        public static extern void LineStipple(Int32 factor, Int16 pattern);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the line stipple pattern
        /// </summary>
        /// <param name="factor">
        /// <para>
        /// Specifies a multiplier for each bit in the line stipple pattern. If factor is 3, for example, each bit in the pattern is used three times before the next bit in the pattern is used. factor is clamped to the range [1, 256] and defaults to 1.
        /// </para>
        /// </param>
        /// <param name="pattern">
        /// <para>
        /// Specifies a 16-bit integer whose bit pattern determines which fragments of a line will be drawn when the line is rasterized. Bit zero is used first; the default pattern is all 1's.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glLineStipple")]
        public static extern void LineStipple(Int32 factor, UInt16 pattern);

        /// <summary>[requires: v1.0]
        /// Specify the width of rasterized lines
        /// </summary>
        /// <param name="width">
        /// <para>
        /// Specifies the width of rasterized lines. The initial value is 1.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glLineWidth")]
        public static extern void LineWidth(Single width);

        /// <summary>[requires: v2.0]
        /// Links a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program object to be linked.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glLinkProgram")]
        public static extern void LinkProgram(Int32 program);

        /// <summary>[requires: v2.0]
        /// Links a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program object to be linked.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glLinkProgram")]
        public static extern void LinkProgram(UInt32 program);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the display-list base for glCallLists
        /// </summary>
        /// <param name="base">
        /// <para>
        /// Specifies an integer offset that will be added to glCallLists offsets to generate display-list names. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glListBase")]
        public static extern void ListBase(Int32 @base);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the display-list base for glCallLists
        /// </summary>
        /// <param name="base">
        /// <para>
        /// Specifies an integer offset that will be added to glCallLists offsets to generate display-list names. The initial value is 0.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glListBase")]
        public static extern void ListBase(UInt32 @base);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Replace the current matrix with the identity matrix
        /// </summary>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glLoadIdentity")]
        public static extern void LoadIdentity();

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Replace the current matrix with the specified matrix
        /// </summary>
        /// <param name="m">
        /// <para>
        /// Specifies a pointer to 16 consecutive values, which are used as the elements of a 4 times 4 column-major matrix.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glLoadMatrixd")]
        public static extern void LoadMatrix(Double[] m);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Replace the current matrix with the specified matrix
        /// </summary>
        /// <param name="m">
        /// <para>
        /// Specifies a pointer to 16 consecutive values, which are used as the elements of a 4 times 4 column-major matrix.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glLoadMatrixd")]
        public static extern void LoadMatrix(ref Double m);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Replace the current matrix with the specified matrix
        /// </summary>
        /// <param name="m">
        /// <para>
        /// Specifies a pointer to 16 consecutive values, which are used as the elements of a 4 times 4 column-major matrix.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glLoadMatrixd")]
        public static extern unsafe void LoadMatrix(Double* m);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Replace the current matrix with the specified matrix
        /// </summary>
        /// <param name="m">
        /// <para>
        /// Specifies a pointer to 16 consecutive values, which are used as the elements of a 4 times 4 column-major matrix.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glLoadMatrixf")]
        public static extern void LoadMatrix(Single[] m);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Replace the current matrix with the specified matrix
        /// </summary>
        /// <param name="m">
        /// <para>
        /// Specifies a pointer to 16 consecutive values, which are used as the elements of a 4 times 4 column-major matrix.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glLoadMatrixf")]
        public static extern void LoadMatrix(ref Single m);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Replace the current matrix with the specified matrix
        /// </summary>
        /// <param name="m">
        /// <para>
        /// Specifies a pointer to 16 consecutive values, which are used as the elements of a 4 times 4 column-major matrix.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glLoadMatrixf")]
        public static extern unsafe void LoadMatrix(Single* m);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Load a name onto the name stack
        /// </summary>
        /// <param name="name">
        /// <para>
        /// Specifies a name that will replace the top value on the name stack.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glLoadName")]
        public static extern void LoadName(Int32 name);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Load a name onto the name stack
        /// </summary>
        /// <param name="name">
        /// <para>
        /// Specifies a name that will replace the top value on the name stack.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glLoadName")]
        public static extern void LoadName(UInt32 name);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Replace the current matrix with the specified row-major ordered matrix
        /// </summary>
        /// <param name="m">
        /// <para>
        /// Specifies a pointer to 16 consecutive values, which are used as the elements of a 4 times 4 row-major matrix.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glLoadTransposeMatrixd")]
        public static extern void LoadTransposeMatrix(Double[] m);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Replace the current matrix with the specified row-major ordered matrix
        /// </summary>
        /// <param name="m">
        /// <para>
        /// Specifies a pointer to 16 consecutive values, which are used as the elements of a 4 times 4 row-major matrix.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glLoadTransposeMatrixd")]
        public static extern void LoadTransposeMatrix(ref Double m);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Replace the current matrix with the specified row-major ordered matrix
        /// </summary>
        /// <param name="m">
        /// <para>
        /// Specifies a pointer to 16 consecutive values, which are used as the elements of a 4 times 4 row-major matrix.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glLoadTransposeMatrixd")]
        public static extern unsafe void LoadTransposeMatrix(Double* m);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Replace the current matrix with the specified row-major ordered matrix
        /// </summary>
        /// <param name="m">
        /// <para>
        /// Specifies a pointer to 16 consecutive values, which are used as the elements of a 4 times 4 row-major matrix.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glLoadTransposeMatrixf")]
        public static extern void LoadTransposeMatrix(Single[] m);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Replace the current matrix with the specified row-major ordered matrix
        /// </summary>
        /// <param name="m">
        /// <para>
        /// Specifies a pointer to 16 consecutive values, which are used as the elements of a 4 times 4 row-major matrix.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glLoadTransposeMatrixf")]
        public static extern void LoadTransposeMatrix(ref Single m);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Replace the current matrix with the specified row-major ordered matrix
        /// </summary>
        /// <param name="m">
        /// <para>
        /// Specifies a pointer to 16 consecutive values, which are used as the elements of a 4 times 4 row-major matrix.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glLoadTransposeMatrixf")]
        public static extern unsafe void LoadTransposeMatrix(Single* m);

        /// <summary>[requires: v1.0]
        /// Specify a logical pixel operation for rendering
        /// </summary>
        /// <param name="opcode">
        /// <para>
        /// Specifies a symbolic constant that selects a logical operation. The following symbols are accepted: GL_CLEAR, GL_SET, GL_COPY, GL_COPY_INVERTED, GL_NOOP, GL_INVERT, GL_AND, GL_NAND, GL_OR, GL_NOR, GL_XOR, GL_EQUIV, GL_AND_REVERSE, GL_AND_INVERTED, GL_OR_REVERSE, and GL_OR_INVERTED. The initial value is GL_COPY.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glLogicOp")]
        public static extern void LogicOp(OpenTK.Graphics.OpenGL.LogicOp opcode);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Define a one-dimensional evaluator
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the kind of values that are generated by the evaluator. Symbolic constants GL_MAP1_VERTEX_3, GL_MAP1_VERTEX_4, GL_MAP1_INDEX, GL_MAP1_COLOR_4, GL_MAP1_NORMAL, GL_MAP1_TEXTURE_COORD_1, GL_MAP1_TEXTURE_COORD_2, GL_MAP1_TEXTURE_COORD_3, and GL_MAP1_TEXTURE_COORD_4 are accepted.
        /// </para>
        /// </param>
        /// <param name="u1">
        /// <para>
        /// Specify a linear mapping of , as presented to glEvalCoord1, to u hat, the variable that is evaluated by the equations specified by this command.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the number of floats or doubles between the beginning of one control point and the beginning of the next one in the data structure referenced in points. This allows control points to be embedded in arbitrary data structures. The only constraint is that the values for a particular control point must occupy contiguous memory locations.
        /// </para>
        /// </param>
        /// <param name="order">
        /// <para>
        /// Specifies the number of control points. Must be positive.
        /// </para>
        /// </param>
        /// <param name="points">
        /// <para>
        /// Specifies a pointer to the array of control points.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glMap1d")]
        public static extern void Map1(OpenTK.Graphics.OpenGL.MapTarget target, Double u1, Double u2, Int32 stride, Int32 order, Double[] points);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Define a one-dimensional evaluator
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the kind of values that are generated by the evaluator. Symbolic constants GL_MAP1_VERTEX_3, GL_MAP1_VERTEX_4, GL_MAP1_INDEX, GL_MAP1_COLOR_4, GL_MAP1_NORMAL, GL_MAP1_TEXTURE_COORD_1, GL_MAP1_TEXTURE_COORD_2, GL_MAP1_TEXTURE_COORD_3, and GL_MAP1_TEXTURE_COORD_4 are accepted.
        /// </para>
        /// </param>
        /// <param name="u1">
        /// <para>
        /// Specify a linear mapping of , as presented to glEvalCoord1, to u hat, the variable that is evaluated by the equations specified by this command.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the number of floats or doubles between the beginning of one control point and the beginning of the next one in the data structure referenced in points. This allows control points to be embedded in arbitrary data structures. The only constraint is that the values for a particular control point must occupy contiguous memory locations.
        /// </para>
        /// </param>
        /// <param name="order">
        /// <para>
        /// Specifies the number of control points. Must be positive.
        /// </para>
        /// </param>
        /// <param name="points">
        /// <para>
        /// Specifies a pointer to the array of control points.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glMap1d")]
        public static extern void Map1(OpenTK.Graphics.OpenGL.MapTarget target, Double u1, Double u2, Int32 stride, Int32 order, ref Double points);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Define a one-dimensional evaluator
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the kind of values that are generated by the evaluator. Symbolic constants GL_MAP1_VERTEX_3, GL_MAP1_VERTEX_4, GL_MAP1_INDEX, GL_MAP1_COLOR_4, GL_MAP1_NORMAL, GL_MAP1_TEXTURE_COORD_1, GL_MAP1_TEXTURE_COORD_2, GL_MAP1_TEXTURE_COORD_3, and GL_MAP1_TEXTURE_COORD_4 are accepted.
        /// </para>
        /// </param>
        /// <param name="u1">
        /// <para>
        /// Specify a linear mapping of , as presented to glEvalCoord1, to u hat, the variable that is evaluated by the equations specified by this command.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the number of floats or doubles between the beginning of one control point and the beginning of the next one in the data structure referenced in points. This allows control points to be embedded in arbitrary data structures. The only constraint is that the values for a particular control point must occupy contiguous memory locations.
        /// </para>
        /// </param>
        /// <param name="order">
        /// <para>
        /// Specifies the number of control points. Must be positive.
        /// </para>
        /// </param>
        /// <param name="points">
        /// <para>
        /// Specifies a pointer to the array of control points.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glMap1d")]
        public static extern unsafe void Map1(OpenTK.Graphics.OpenGL.MapTarget target, Double u1, Double u2, Int32 stride, Int32 order, Double* points);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Define a one-dimensional evaluator
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the kind of values that are generated by the evaluator. Symbolic constants GL_MAP1_VERTEX_3, GL_MAP1_VERTEX_4, GL_MAP1_INDEX, GL_MAP1_COLOR_4, GL_MAP1_NORMAL, GL_MAP1_TEXTURE_COORD_1, GL_MAP1_TEXTURE_COORD_2, GL_MAP1_TEXTURE_COORD_3, and GL_MAP1_TEXTURE_COORD_4 are accepted.
        /// </para>
        /// </param>
        /// <param name="u1">
        /// <para>
        /// Specify a linear mapping of , as presented to glEvalCoord1, to u hat, the variable that is evaluated by the equations specified by this command.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the number of floats or doubles between the beginning of one control point and the beginning of the next one in the data structure referenced in points. This allows control points to be embedded in arbitrary data structures. The only constraint is that the values for a particular control point must occupy contiguous memory locations.
        /// </para>
        /// </param>
        /// <param name="order">
        /// <para>
        /// Specifies the number of control points. Must be positive.
        /// </para>
        /// </param>
        /// <param name="points">
        /// <para>
        /// Specifies a pointer to the array of control points.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glMap1f")]
        public static extern void Map1(OpenTK.Graphics.OpenGL.MapTarget target, Single u1, Single u2, Int32 stride, Int32 order, Single[] points);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Define a one-dimensional evaluator
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the kind of values that are generated by the evaluator. Symbolic constants GL_MAP1_VERTEX_3, GL_MAP1_VERTEX_4, GL_MAP1_INDEX, GL_MAP1_COLOR_4, GL_MAP1_NORMAL, GL_MAP1_TEXTURE_COORD_1, GL_MAP1_TEXTURE_COORD_2, GL_MAP1_TEXTURE_COORD_3, and GL_MAP1_TEXTURE_COORD_4 are accepted.
        /// </para>
        /// </param>
        /// <param name="u1">
        /// <para>
        /// Specify a linear mapping of , as presented to glEvalCoord1, to u hat, the variable that is evaluated by the equations specified by this command.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the number of floats or doubles between the beginning of one control point and the beginning of the next one in the data structure referenced in points. This allows control points to be embedded in arbitrary data structures. The only constraint is that the values for a particular control point must occupy contiguous memory locations.
        /// </para>
        /// </param>
        /// <param name="order">
        /// <para>
        /// Specifies the number of control points. Must be positive.
        /// </para>
        /// </param>
        /// <param name="points">
        /// <para>
        /// Specifies a pointer to the array of control points.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glMap1f")]
        public static extern void Map1(OpenTK.Graphics.OpenGL.MapTarget target, Single u1, Single u2, Int32 stride, Int32 order, ref Single points);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Define a one-dimensional evaluator
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the kind of values that are generated by the evaluator. Symbolic constants GL_MAP1_VERTEX_3, GL_MAP1_VERTEX_4, GL_MAP1_INDEX, GL_MAP1_COLOR_4, GL_MAP1_NORMAL, GL_MAP1_TEXTURE_COORD_1, GL_MAP1_TEXTURE_COORD_2, GL_MAP1_TEXTURE_COORD_3, and GL_MAP1_TEXTURE_COORD_4 are accepted.
        /// </para>
        /// </param>
        /// <param name="u1">
        /// <para>
        /// Specify a linear mapping of , as presented to glEvalCoord1, to u hat, the variable that is evaluated by the equations specified by this command.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the number of floats or doubles between the beginning of one control point and the beginning of the next one in the data structure referenced in points. This allows control points to be embedded in arbitrary data structures. The only constraint is that the values for a particular control point must occupy contiguous memory locations.
        /// </para>
        /// </param>
        /// <param name="order">
        /// <para>
        /// Specifies the number of control points. Must be positive.
        /// </para>
        /// </param>
        /// <param name="points">
        /// <para>
        /// Specifies a pointer to the array of control points.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glMap1f")]
        public static extern unsafe void Map1(OpenTK.Graphics.OpenGL.MapTarget target, Single u1, Single u2, Int32 stride, Int32 order, Single* points);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Define a two-dimensional evaluator
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the kind of values that are generated by the evaluator. Symbolic constants GL_MAP2_VERTEX_3, GL_MAP2_VERTEX_4, GL_MAP2_INDEX, GL_MAP2_COLOR_4, GL_MAP2_NORMAL, GL_MAP2_TEXTURE_COORD_1, GL_MAP2_TEXTURE_COORD_2, GL_MAP2_TEXTURE_COORD_3, and GL_MAP2_TEXTURE_COORD_4 are accepted.
        /// </para>
        /// </param>
        /// <param name="u1">
        /// <para>
        /// Specify a linear mapping of , as presented to glEvalCoord2, to u hat, one of the two variables that are evaluated by the equations specified by this command. Initially, u1 is 0 and u2 is 1.
        /// </para>
        /// </param>
        /// <param name="ustride">
        /// <para>
        /// Specifies the number of floats or doubles between the beginning of control point R sub ij and the beginning of control point R sub { (i+1) j }, where and are the and control point indices, respectively. This allows control points to be embedded in arbitrary data structures. The only constraint is that the values for a particular control point must occupy contiguous memory locations. The initial value of ustride is 0.
        /// </para>
        /// </param>
        /// <param name="uorder">
        /// <para>
        /// Specifies the dimension of the control point array in the axis. Must be positive. The initial value is 1.
        /// </para>
        /// </param>
        /// <param name="v1">
        /// <para>
        /// Specify a linear mapping of , as presented to glEvalCoord2, to v hat, one of the two variables that are evaluated by the equations specified by this command. Initially, v1 is 0 and v2 is 1.
        /// </para>
        /// </param>
        /// <param name="vstride">
        /// <para>
        /// Specifies the number of floats or doubles between the beginning of control point R sub ij and the beginning of control point R sub { i (j+1) }, where and are the and control point indices, respectively. This allows control points to be embedded in arbitrary data structures. The only constraint is that the values for a particular control point must occupy contiguous memory locations. The initial value of vstride is 0.
        /// </para>
        /// </param>
        /// <param name="vorder">
        /// <para>
        /// Specifies the dimension of the control point array in the axis. Must be positive. The initial value is 1.
        /// </para>
        /// </param>
        /// <param name="points">
        /// <para>
        /// Specifies a pointer to the array of control points.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glMap2d")]
        public static extern void Map2(OpenTK.Graphics.OpenGL.MapTarget target, Double u1, Double u2, Int32 ustride, Int32 uorder, Double v1, Double v2, Int32 vstride, Int32 vorder, Double[] points);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Define a two-dimensional evaluator
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the kind of values that are generated by the evaluator. Symbolic constants GL_MAP2_VERTEX_3, GL_MAP2_VERTEX_4, GL_MAP2_INDEX, GL_MAP2_COLOR_4, GL_MAP2_NORMAL, GL_MAP2_TEXTURE_COORD_1, GL_MAP2_TEXTURE_COORD_2, GL_MAP2_TEXTURE_COORD_3, and GL_MAP2_TEXTURE_COORD_4 are accepted.
        /// </para>
        /// </param>
        /// <param name="u1">
        /// <para>
        /// Specify a linear mapping of , as presented to glEvalCoord2, to u hat, one of the two variables that are evaluated by the equations specified by this command. Initially, u1 is 0 and u2 is 1.
        /// </para>
        /// </param>
        /// <param name="ustride">
        /// <para>
        /// Specifies the number of floats or doubles between the beginning of control point R sub ij and the beginning of control point R sub { (i+1) j }, where and are the and control point indices, respectively. This allows control points to be embedded in arbitrary data structures. The only constraint is that the values for a particular control point must occupy contiguous memory locations. The initial value of ustride is 0.
        /// </para>
        /// </param>
        /// <param name="uorder">
        /// <para>
        /// Specifies the dimension of the control point array in the axis. Must be positive. The initial value is 1.
        /// </para>
        /// </param>
        /// <param name="v1">
        /// <para>
        /// Specify a linear mapping of , as presented to glEvalCoord2, to v hat, one of the two variables that are evaluated by the equations specified by this command. Initially, v1 is 0 and v2 is 1.
        /// </para>
        /// </param>
        /// <param name="vstride">
        /// <para>
        /// Specifies the number of floats or doubles between the beginning of control point R sub ij and the beginning of control point R sub { i (j+1) }, where and are the and control point indices, respectively. This allows control points to be embedded in arbitrary data structures. The only constraint is that the values for a particular control point must occupy contiguous memory locations. The initial value of vstride is 0.
        /// </para>
        /// </param>
        /// <param name="vorder">
        /// <para>
        /// Specifies the dimension of the control point array in the axis. Must be positive. The initial value is 1.
        /// </para>
        /// </param>
        /// <param name="points">
        /// <para>
        /// Specifies a pointer to the array of control points.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glMap2d")]
        public static extern void Map2(OpenTK.Graphics.OpenGL.MapTarget target, Double u1, Double u2, Int32 ustride, Int32 uorder, Double v1, Double v2, Int32 vstride, Int32 vorder, ref Double points);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Define a two-dimensional evaluator
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the kind of values that are generated by the evaluator. Symbolic constants GL_MAP2_VERTEX_3, GL_MAP2_VERTEX_4, GL_MAP2_INDEX, GL_MAP2_COLOR_4, GL_MAP2_NORMAL, GL_MAP2_TEXTURE_COORD_1, GL_MAP2_TEXTURE_COORD_2, GL_MAP2_TEXTURE_COORD_3, and GL_MAP2_TEXTURE_COORD_4 are accepted.
        /// </para>
        /// </param>
        /// <param name="u1">
        /// <para>
        /// Specify a linear mapping of , as presented to glEvalCoord2, to u hat, one of the two variables that are evaluated by the equations specified by this command. Initially, u1 is 0 and u2 is 1.
        /// </para>
        /// </param>
        /// <param name="ustride">
        /// <para>
        /// Specifies the number of floats or doubles between the beginning of control point R sub ij and the beginning of control point R sub { (i+1) j }, where and are the and control point indices, respectively. This allows control points to be embedded in arbitrary data structures. The only constraint is that the values for a particular control point must occupy contiguous memory locations. The initial value of ustride is 0.
        /// </para>
        /// </param>
        /// <param name="uorder">
        /// <para>
        /// Specifies the dimension of the control point array in the axis. Must be positive. The initial value is 1.
        /// </para>
        /// </param>
        /// <param name="v1">
        /// <para>
        /// Specify a linear mapping of , as presented to glEvalCoord2, to v hat, one of the two variables that are evaluated by the equations specified by this command. Initially, v1 is 0 and v2 is 1.
        /// </para>
        /// </param>
        /// <param name="vstride">
        /// <para>
        /// Specifies the number of floats or doubles between the beginning of control point R sub ij and the beginning of control point R sub { i (j+1) }, where and are the and control point indices, respectively. This allows control points to be embedded in arbitrary data structures. The only constraint is that the values for a particular control point must occupy contiguous memory locations. The initial value of vstride is 0.
        /// </para>
        /// </param>
        /// <param name="vorder">
        /// <para>
        /// Specifies the dimension of the control point array in the axis. Must be positive. The initial value is 1.
        /// </para>
        /// </param>
        /// <param name="points">
        /// <para>
        /// Specifies a pointer to the array of control points.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glMap2d")]
        public static extern unsafe void Map2(OpenTK.Graphics.OpenGL.MapTarget target, Double u1, Double u2, Int32 ustride, Int32 uorder, Double v1, Double v2, Int32 vstride, Int32 vorder, Double* points);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Define a two-dimensional evaluator
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the kind of values that are generated by the evaluator. Symbolic constants GL_MAP2_VERTEX_3, GL_MAP2_VERTEX_4, GL_MAP2_INDEX, GL_MAP2_COLOR_4, GL_MAP2_NORMAL, GL_MAP2_TEXTURE_COORD_1, GL_MAP2_TEXTURE_COORD_2, GL_MAP2_TEXTURE_COORD_3, and GL_MAP2_TEXTURE_COORD_4 are accepted.
        /// </para>
        /// </param>
        /// <param name="u1">
        /// <para>
        /// Specify a linear mapping of , as presented to glEvalCoord2, to u hat, one of the two variables that are evaluated by the equations specified by this command. Initially, u1 is 0 and u2 is 1.
        /// </para>
        /// </param>
        /// <param name="ustride">
        /// <para>
        /// Specifies the number of floats or doubles between the beginning of control point R sub ij and the beginning of control point R sub { (i+1) j }, where and are the and control point indices, respectively. This allows control points to be embedded in arbitrary data structures. The only constraint is that the values for a particular control point must occupy contiguous memory locations. The initial value of ustride is 0.
        /// </para>
        /// </param>
        /// <param name="uorder">
        /// <para>
        /// Specifies the dimension of the control point array in the axis. Must be positive. The initial value is 1.
        /// </para>
        /// </param>
        /// <param name="v1">
        /// <para>
        /// Specify a linear mapping of , as presented to glEvalCoord2, to v hat, one of the two variables that are evaluated by the equations specified by this command. Initially, v1 is 0 and v2 is 1.
        /// </para>
        /// </param>
        /// <param name="vstride">
        /// <para>
        /// Specifies the number of floats or doubles between the beginning of control point R sub ij and the beginning of control point R sub { i (j+1) }, where and are the and control point indices, respectively. This allows control points to be embedded in arbitrary data structures. The only constraint is that the values for a particular control point must occupy contiguous memory locations. The initial value of vstride is 0.
        /// </para>
        /// </param>
        /// <param name="vorder">
        /// <para>
        /// Specifies the dimension of the control point array in the axis. Must be positive. The initial value is 1.
        /// </para>
        /// </param>
        /// <param name="points">
        /// <para>
        /// Specifies a pointer to the array of control points.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glMap2f")]
        public static extern void Map2(OpenTK.Graphics.OpenGL.MapTarget target, Single u1, Single u2, Int32 ustride, Int32 uorder, Single v1, Single v2, Int32 vstride, Int32 vorder, Single[] points);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Define a two-dimensional evaluator
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the kind of values that are generated by the evaluator. Symbolic constants GL_MAP2_VERTEX_3, GL_MAP2_VERTEX_4, GL_MAP2_INDEX, GL_MAP2_COLOR_4, GL_MAP2_NORMAL, GL_MAP2_TEXTURE_COORD_1, GL_MAP2_TEXTURE_COORD_2, GL_MAP2_TEXTURE_COORD_3, and GL_MAP2_TEXTURE_COORD_4 are accepted.
        /// </para>
        /// </param>
        /// <param name="u1">
        /// <para>
        /// Specify a linear mapping of , as presented to glEvalCoord2, to u hat, one of the two variables that are evaluated by the equations specified by this command. Initially, u1 is 0 and u2 is 1.
        /// </para>
        /// </param>
        /// <param name="ustride">
        /// <para>
        /// Specifies the number of floats or doubles between the beginning of control point R sub ij and the beginning of control point R sub { (i+1) j }, where and are the and control point indices, respectively. This allows control points to be embedded in arbitrary data structures. The only constraint is that the values for a particular control point must occupy contiguous memory locations. The initial value of ustride is 0.
        /// </para>
        /// </param>
        /// <param name="uorder">
        /// <para>
        /// Specifies the dimension of the control point array in the axis. Must be positive. The initial value is 1.
        /// </para>
        /// </param>
        /// <param name="v1">
        /// <para>
        /// Specify a linear mapping of , as presented to glEvalCoord2, to v hat, one of the two variables that are evaluated by the equations specified by this command. Initially, v1 is 0 and v2 is 1.
        /// </para>
        /// </param>
        /// <param name="vstride">
        /// <para>
        /// Specifies the number of floats or doubles between the beginning of control point R sub ij and the beginning of control point R sub { i (j+1) }, where and are the and control point indices, respectively. This allows control points to be embedded in arbitrary data structures. The only constraint is that the values for a particular control point must occupy contiguous memory locations. The initial value of vstride is 0.
        /// </para>
        /// </param>
        /// <param name="vorder">
        /// <para>
        /// Specifies the dimension of the control point array in the axis. Must be positive. The initial value is 1.
        /// </para>
        /// </param>
        /// <param name="points">
        /// <para>
        /// Specifies a pointer to the array of control points.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glMap2f")]
        public static extern void Map2(OpenTK.Graphics.OpenGL.MapTarget target, Single u1, Single u2, Int32 ustride, Int32 uorder, Single v1, Single v2, Int32 vstride, Int32 vorder, ref Single points);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Define a two-dimensional evaluator
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the kind of values that are generated by the evaluator. Symbolic constants GL_MAP2_VERTEX_3, GL_MAP2_VERTEX_4, GL_MAP2_INDEX, GL_MAP2_COLOR_4, GL_MAP2_NORMAL, GL_MAP2_TEXTURE_COORD_1, GL_MAP2_TEXTURE_COORD_2, GL_MAP2_TEXTURE_COORD_3, and GL_MAP2_TEXTURE_COORD_4 are accepted.
        /// </para>
        /// </param>
        /// <param name="u1">
        /// <para>
        /// Specify a linear mapping of , as presented to glEvalCoord2, to u hat, one of the two variables that are evaluated by the equations specified by this command. Initially, u1 is 0 and u2 is 1.
        /// </para>
        /// </param>
        /// <param name="ustride">
        /// <para>
        /// Specifies the number of floats or doubles between the beginning of control point R sub ij and the beginning of control point R sub { (i+1) j }, where and are the and control point indices, respectively. This allows control points to be embedded in arbitrary data structures. The only constraint is that the values for a particular control point must occupy contiguous memory locations. The initial value of ustride is 0.
        /// </para>
        /// </param>
        /// <param name="uorder">
        /// <para>
        /// Specifies the dimension of the control point array in the axis. Must be positive. The initial value is 1.
        /// </para>
        /// </param>
        /// <param name="v1">
        /// <para>
        /// Specify a linear mapping of , as presented to glEvalCoord2, to v hat, one of the two variables that are evaluated by the equations specified by this command. Initially, v1 is 0 and v2 is 1.
        /// </para>
        /// </param>
        /// <param name="vstride">
        /// <para>
        /// Specifies the number of floats or doubles between the beginning of control point R sub ij and the beginning of control point R sub { i (j+1) }, where and are the and control point indices, respectively. This allows control points to be embedded in arbitrary data structures. The only constraint is that the values for a particular control point must occupy contiguous memory locations. The initial value of vstride is 0.
        /// </para>
        /// </param>
        /// <param name="vorder">
        /// <para>
        /// Specifies the dimension of the control point array in the axis. Must be positive. The initial value is 1.
        /// </para>
        /// </param>
        /// <param name="points">
        /// <para>
        /// Specifies a pointer to the array of control points.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glMap2f")]
        public static extern unsafe void Map2(OpenTK.Graphics.OpenGL.MapTarget target, Single u1, Single u2, Int32 ustride, Int32 uorder, Single v1, Single v2, Int32 vstride, Int32 vorder, Single* points);

        /// <summary>[requires: v1.5]
        /// Map a buffer object's data store
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target buffer object being mapped. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER or GL_UNIFORM_BUFFER.
        /// </para>
        /// </param>
        /// <param name="access">
        /// <para>
        /// For glMapBuffer only, specifies the access policy, indicating whether it will be possible to read from, write to, or both read from and write to the buffer object's mapped data store. The symbolic constant must be GL_READ_ONLY, GL_WRITE_ONLY, or GL_READ_WRITE.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glMapBuffer")]
        public static extern IntPtr MapBuffer(OpenTK.Graphics.OpenGL.BufferTarget target, OpenTK.Graphics.OpenGL.BufferAccess access);

        /// <summary>[requires: v3.0 and ARB_map_buffer_range|VERSION_3_0]
        /// Map a section of a buffer object's data store
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies a binding to which the target buffer is bound.
        /// </para>
        /// </param>
        /// <param name="offset">
        /// <para>
        /// Specifies a the starting offset within the buffer of the range to be mapped.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies a length of the range to be mapped.
        /// </para>
        /// </param>
        /// <param name="access">
        /// <para>
        /// Specifies a combination of access flags indicating the desired access to the range.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_map_buffer_range|VERSION_3_0", Version = "3.0", EntryPoint = "glMapBufferRange")]
        public static extern IntPtr MapBufferRange(OpenTK.Graphics.OpenGL.BufferTarget target, IntPtr offset, IntPtr length, OpenTK.Graphics.OpenGL.BufferAccessMask access);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Define a one- or two-dimensional mesh
        /// </summary>
        /// <param name="un">
        /// <para>
        /// Specifies the number of partitions in the grid range interval [u1, u2]. Must be positive.
        /// </para>
        /// </param>
        /// <param name="u1">
        /// <para>
        /// Specify the mappings for integer grid domain values i = 0 and i = un.
        /// </para>
        /// </param>
        /// <param name="vn">
        /// <para>
        /// Specifies the number of partitions in the grid range interval [v1, v2] (glMapGrid2 only).
        /// </para>
        /// </param>
        /// <param name="v1">
        /// <para>
        /// Specify the mappings for integer grid domain values j = 0 and j = vn (glMapGrid2 only).
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glMapGrid1d")]
        public static extern void MapGrid1(Int32 un, Double u1, Double u2);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Define a one- or two-dimensional mesh
        /// </summary>
        /// <param name="un">
        /// <para>
        /// Specifies the number of partitions in the grid range interval [u1, u2]. Must be positive.
        /// </para>
        /// </param>
        /// <param name="u1">
        /// <para>
        /// Specify the mappings for integer grid domain values i = 0 and i = un.
        /// </para>
        /// </param>
        /// <param name="vn">
        /// <para>
        /// Specifies the number of partitions in the grid range interval [v1, v2] (glMapGrid2 only).
        /// </para>
        /// </param>
        /// <param name="v1">
        /// <para>
        /// Specify the mappings for integer grid domain values j = 0 and j = vn (glMapGrid2 only).
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glMapGrid1f")]
        public static extern void MapGrid1(Int32 un, Single u1, Single u2);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Define a one- or two-dimensional mesh
        /// </summary>
        /// <param name="un">
        /// <para>
        /// Specifies the number of partitions in the grid range interval [u1, u2]. Must be positive.
        /// </para>
        /// </param>
        /// <param name="u1">
        /// <para>
        /// Specify the mappings for integer grid domain values i = 0 and i = un.
        /// </para>
        /// </param>
        /// <param name="vn">
        /// <para>
        /// Specifies the number of partitions in the grid range interval [v1, v2] (glMapGrid2 only).
        /// </para>
        /// </param>
        /// <param name="v1">
        /// <para>
        /// Specify the mappings for integer grid domain values j = 0 and j = vn (glMapGrid2 only).
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glMapGrid2d")]
        public static extern void MapGrid2(Int32 un, Double u1, Double u2, Int32 vn, Double v1, Double v2);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Define a one- or two-dimensional mesh
        /// </summary>
        /// <param name="un">
        /// <para>
        /// Specifies the number of partitions in the grid range interval [u1, u2]. Must be positive.
        /// </para>
        /// </param>
        /// <param name="u1">
        /// <para>
        /// Specify the mappings for integer grid domain values i = 0 and i = un.
        /// </para>
        /// </param>
        /// <param name="vn">
        /// <para>
        /// Specifies the number of partitions in the grid range interval [v1, v2] (glMapGrid2 only).
        /// </para>
        /// </param>
        /// <param name="v1">
        /// <para>
        /// Specify the mappings for integer grid domain values j = 0 and j = vn (glMapGrid2 only).
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glMapGrid2f")]
        public static extern void MapGrid2(Int32 un, Single u1, Single u2, Int32 vn, Single v1, Single v2);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify material parameters for the lighting model
        /// </summary>
        /// <param name="face">
        /// <para>
        /// Specifies which face or faces are being updated. Must be one of GL_FRONT, GL_BACK, or GL_FRONT_AND_BACK.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the single-valued material parameter of the face or faces that is being updated. Must be GL_SHININESS.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies the value that parameter GL_SHININESS will be set to.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glMaterialf")]
        public static extern void Material(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, Single param);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify material parameters for the lighting model
        /// </summary>
        /// <param name="face">
        /// <para>
        /// Specifies which face or faces are being updated. Must be one of GL_FRONT, GL_BACK, or GL_FRONT_AND_BACK.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the single-valued material parameter of the face or faces that is being updated. Must be GL_SHININESS.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies the value that parameter GL_SHININESS will be set to.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glMaterialfv")]
        public static extern void Material(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, Single[] @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify material parameters for the lighting model
        /// </summary>
        /// <param name="face">
        /// <para>
        /// Specifies which face or faces are being updated. Must be one of GL_FRONT, GL_BACK, or GL_FRONT_AND_BACK.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the single-valued material parameter of the face or faces that is being updated. Must be GL_SHININESS.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies the value that parameter GL_SHININESS will be set to.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glMaterialfv")]
        public static extern unsafe void Material(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, Single* @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify material parameters for the lighting model
        /// </summary>
        /// <param name="face">
        /// <para>
        /// Specifies which face or faces are being updated. Must be one of GL_FRONT, GL_BACK, or GL_FRONT_AND_BACK.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the single-valued material parameter of the face or faces that is being updated. Must be GL_SHININESS.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies the value that parameter GL_SHININESS will be set to.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glMateriali")]
        public static extern void Material(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, Int32 param);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify material parameters for the lighting model
        /// </summary>
        /// <param name="face">
        /// <para>
        /// Specifies which face or faces are being updated. Must be one of GL_FRONT, GL_BACK, or GL_FRONT_AND_BACK.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the single-valued material parameter of the face or faces that is being updated. Must be GL_SHININESS.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies the value that parameter GL_SHININESS will be set to.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glMaterialiv")]
        public static extern void Material(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, Int32[] @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify material parameters for the lighting model
        /// </summary>
        /// <param name="face">
        /// <para>
        /// Specifies which face or faces are being updated. Must be one of GL_FRONT, GL_BACK, or GL_FRONT_AND_BACK.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the single-valued material parameter of the face or faces that is being updated. Must be GL_SHININESS.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies the value that parameter GL_SHININESS will be set to.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glMaterialiv")]
        public static extern unsafe void Material(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, Int32* @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify which matrix is the current matrix
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies which matrix stack is the target for subsequent matrix operations. Three values are accepted: GL_MODELVIEW, GL_PROJECTION, and GL_TEXTURE. The initial value is GL_MODELVIEW. Additionally, if the ARB_imaging extension is supported, GL_COLOR is also accepted.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glMatrixMode")]
        public static extern void MatrixMode(OpenTK.Graphics.OpenGL.MatrixMode mode);

        /// <summary>[requires: v4.2 and ARB_shader_image_load_store|VERSION_4_2]
        /// Defines a barrier ordering memory transactions
        /// </summary>
        /// <param name="barriers">
        /// <para>
        /// Specifies the barriers to insert. Must be a bitwise combination of GL_VERTEX_ATTRIB_ARRAY_BARRIER_BIT, GL_ELEMENT_ARRAY_BARRIER_BIT, GL_UNIFORM_BARRIER_BIT, GL_TEXTURE_FETCH_BARRIER_BIT, GL_SHADER_IMAGE_ACCESS_BARRIER_BIT, GL_COMMAND_BARRIER_BIT, GL_PIXEL_BUFFER_BARRIER_BIT, GL_TEXTURE_UPDATE_BARRIER_BIT, GL_BUFFER_UPDATE_BARRIER_BIT, GL_FRAMEBUFFER_BARRIER_BIT, GL_TRANSFORM_FEEDBACK_BARRIER_BIT, GL_ATOMIC_COUNTER_BARRIER_BIT, or GL_SHADER_STORAGE_BARRIER_BIT. If the special value GL_ALL_BARRIER_BITS is specified, all supported barriers will be inserted.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_shader_image_load_store|VERSION_4_2", Version = "4.2", EntryPoint = "glMemoryBarrier")]
        public static extern void MemoryBarrier(OpenTK.Graphics.OpenGL.MemoryBarrierFlags barriers);

        /// <summary>
        /// Define minmax table
        /// </summary>
        /// <param name="target">
        /// <para>
        /// The minmax table whose parameters are to be set. Must be GL_MINMAX.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The format of entries in the minmax table. Must be one of GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
        /// </para>
        /// </param>
        /// <param name="sink">
        /// <para>
        /// If GL_TRUE, pixels will be consumed by the minmax process and no drawing or texture loading will take place. If GL_FALSE, pixels will proceed to the final conversion process after minmax.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glMinmax")]
        public static extern void Minmax(OpenTK.Graphics.OpenGL.MinmaxTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, bool sink);

        /// <summary>[requires: v4.0]
        /// Specifies minimum rate at which sample shaing takes place
        /// </summary>
        /// <param name="value">
        /// <para>
        /// Specifies the rate at which samples are shaded within each covered pixel.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_4_0", Version = "4.0", EntryPoint = "glMinSampleShading")]
        public static extern void MinSampleShading(Single value);

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="first">
        /// <para>
        /// Points to an array of starting indices in the enabled arrays.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the number of indices to be rendered.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the first and count
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawArrays")]
        public static extern void MultiDrawArrays(OpenTK.Graphics.OpenGL.BeginMode mode, Int32[] first, Int32[] count, Int32 drawcount);

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="first">
        /// <para>
        /// Points to an array of starting indices in the enabled arrays.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the number of indices to be rendered.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the first and count
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawArrays")]
        public static extern void MultiDrawArrays(OpenTK.Graphics.OpenGL.BeginMode mode, ref Int32 first, ref Int32 count, Int32 drawcount);

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="first">
        /// <para>
        /// Points to an array of starting indices in the enabled arrays.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the number of indices to be rendered.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the first and count
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawArrays")]
        public static extern unsafe void MultiDrawArrays(OpenTK.Graphics.OpenGL.BeginMode mode, Int32* first, Int32* count, Int32 drawcount);

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="first">
        /// <para>
        /// Points to an array of starting indices in the enabled arrays.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the number of indices to be rendered.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the first and count
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawArrays")]
        public static extern void MultiDrawArrays(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32[] first, Int32[] count, Int32 drawcount);

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="first">
        /// <para>
        /// Points to an array of starting indices in the enabled arrays.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the number of indices to be rendered.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the first and count
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawArrays")]
        public static extern void MultiDrawArrays(OpenTK.Graphics.OpenGL.PrimitiveType mode, ref Int32 first, ref Int32 count, Int32 drawcount);

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives from array data
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="first">
        /// <para>
        /// Points to an array of starting indices in the enabled arrays.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the number of indices to be rendered.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the first and count
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawArrays")]
        public static extern unsafe void MultiDrawArrays(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32* first, Int32* count, Int32 drawcount);

        /// <summary>[requires: v4.3 and ARB_multi_draw_indirect|VERSION_4_3]
        /// Render multiple sets of primitives from array data, taking parameters from memory
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="indirect">
        /// <para>
        /// Specifies the address of an array of structures containing the draw parameters.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the the number of elements in the array of draw parameter structures.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the distance in basic machine units between elements of the draw parameter array.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_multi_draw_indirect|VERSION_4_3", Version = "4.3", EntryPoint = "glMultiDrawArraysIndirect")]
        public static extern void MultiDrawArraysIndirect(OpenTK.Graphics.OpenGL.PrimitiveType mode, IntPtr indirect, Int32 drawcount, Int32 stride);

        /// <summary>[requires: v4.3 and ARB_multi_draw_indirect|VERSION_4_3]
        /// Render multiple sets of primitives from array data, taking parameters from memory
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="indirect">
        /// <para>
        /// Specifies the address of an array of structures containing the draw parameters.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the the number of elements in the array of draw parameter structures.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the distance in basic machine units between elements of the draw parameter array.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_multi_draw_indirect|VERSION_4_3", Version = "4.3", EntryPoint = "glMultiDrawArraysIndirect")]
        public static extern void MultiDrawArraysIndirect<T1>(OpenTK.Graphics.OpenGL.PrimitiveType mode, [InAttribute, OutAttribute] T1[] indirect, Int32 drawcount, Int32 stride)
            where T1 : struct
        ;

        /// <summary>[requires: v4.3 and ARB_multi_draw_indirect|VERSION_4_3]
        /// Render multiple sets of primitives from array data, taking parameters from memory
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="indirect">
        /// <para>
        /// Specifies the address of an array of structures containing the draw parameters.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the the number of elements in the array of draw parameter structures.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the distance in basic machine units between elements of the draw parameter array.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_multi_draw_indirect|VERSION_4_3", Version = "4.3", EntryPoint = "glMultiDrawArraysIndirect")]
        public static extern void MultiDrawArraysIndirect<T1>(OpenTK.Graphics.OpenGL.PrimitiveType mode, [InAttribute, OutAttribute] T1[,] indirect, Int32 drawcount, Int32 stride)
            where T1 : struct
        ;

        /// <summary>[requires: v4.3 and ARB_multi_draw_indirect|VERSION_4_3]
        /// Render multiple sets of primitives from array data, taking parameters from memory
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="indirect">
        /// <para>
        /// Specifies the address of an array of structures containing the draw parameters.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the the number of elements in the array of draw parameter structures.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the distance in basic machine units between elements of the draw parameter array.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_multi_draw_indirect|VERSION_4_3", Version = "4.3", EntryPoint = "glMultiDrawArraysIndirect")]
        public static extern void MultiDrawArraysIndirect<T1>(OpenTK.Graphics.OpenGL.PrimitiveType mode, [InAttribute, OutAttribute] T1[,,] indirect, Int32 drawcount, Int32 stride)
            where T1 : struct
        ;

        /// <summary>[requires: v4.3 and ARB_multi_draw_indirect|VERSION_4_3]
        /// Render multiple sets of primitives from array data, taking parameters from memory
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="indirect">
        /// <para>
        /// Specifies the address of an array of structures containing the draw parameters.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the the number of elements in the array of draw parameter structures.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the distance in basic machine units between elements of the draw parameter array.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_multi_draw_indirect|VERSION_4_3", Version = "4.3", EntryPoint = "glMultiDrawArraysIndirect")]
        public static extern void MultiDrawArraysIndirect<T1>(OpenTK.Graphics.OpenGL.PrimitiveType mode, [InAttribute, OutAttribute] ref T1 indirect, Int32 drawcount, Int32 stride)
            where T1 : struct
        ;

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives by specifying indices of array data elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count and indices arrays.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawElements")]
        public static extern void MultiDrawElements(OpenTK.Graphics.OpenGL.BeginMode mode, Int32[] count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 drawcount);

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives by specifying indices of array data elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count and indices arrays.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawElements")]
        public static extern void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32[] count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices, Int32 drawcount)
            where T3 : struct
        ;

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives by specifying indices of array data elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count and indices arrays.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawElements")]
        public static extern void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32[] count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices, Int32 drawcount)
            where T3 : struct
        ;

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives by specifying indices of array data elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count and indices arrays.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawElements")]
        public static extern void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32[] count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices, Int32 drawcount)
            where T3 : struct
        ;

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives by specifying indices of array data elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count and indices arrays.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawElements")]
        public static extern void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32[] count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices, Int32 drawcount)
            where T3 : struct
        ;

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives by specifying indices of array data elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count and indices arrays.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawElements")]
        public static extern void MultiDrawElements(OpenTK.Graphics.OpenGL.BeginMode mode, ref Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 drawcount);

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives by specifying indices of array data elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count and indices arrays.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawElements")]
        public static extern void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, ref Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices, Int32 drawcount)
            where T3 : struct
        ;

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives by specifying indices of array data elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count and indices arrays.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawElements")]
        public static extern void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, ref Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices, Int32 drawcount)
            where T3 : struct
        ;

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives by specifying indices of array data elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count and indices arrays.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawElements")]
        public static extern void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, ref Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices, Int32 drawcount)
            where T3 : struct
        ;

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives by specifying indices of array data elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count and indices arrays.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawElements")]
        public static extern void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, ref Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices, Int32 drawcount)
            where T3 : struct
        ;

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives by specifying indices of array data elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count and indices arrays.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawElements")]
        public static extern unsafe void MultiDrawElements(OpenTK.Graphics.OpenGL.BeginMode mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 drawcount);

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives by specifying indices of array data elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count and indices arrays.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawElements")]
        public static extern unsafe void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices, Int32 drawcount)
            where T3 : struct
        ;

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives by specifying indices of array data elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count and indices arrays.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawElements")]
        public static extern unsafe void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices, Int32 drawcount)
            where T3 : struct
        ;

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives by specifying indices of array data elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count and indices arrays.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawElements")]
        public static extern unsafe void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices, Int32 drawcount)
            where T3 : struct
        ;

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives by specifying indices of array data elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count and indices arrays.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawElements")]
        public static extern unsafe void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices, Int32 drawcount)
            where T3 : struct
        ;

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives by specifying indices of array data elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count and indices arrays.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawElements")]
        public static extern void MultiDrawElements(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32[] count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 drawcount);

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives by specifying indices of array data elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count and indices arrays.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawElements")]
        public static extern void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32[] count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices, Int32 drawcount)
            where T3 : struct
        ;

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives by specifying indices of array data elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count and indices arrays.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawElements")]
        public static extern void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32[] count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices, Int32 drawcount)
            where T3 : struct
        ;

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives by specifying indices of array data elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count and indices arrays.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawElements")]
        public static extern void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32[] count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices, Int32 drawcount)
            where T3 : struct
        ;

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives by specifying indices of array data elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count and indices arrays.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawElements")]
        public static extern void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32[] count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices, Int32 drawcount)
            where T3 : struct
        ;

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives by specifying indices of array data elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count and indices arrays.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawElements")]
        public static extern void MultiDrawElements(OpenTK.Graphics.OpenGL.PrimitiveType mode, ref Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 drawcount);

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives by specifying indices of array data elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count and indices arrays.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawElements")]
        public static extern void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, ref Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices, Int32 drawcount)
            where T3 : struct
        ;

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives by specifying indices of array data elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count and indices arrays.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawElements")]
        public static extern void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, ref Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices, Int32 drawcount)
            where T3 : struct
        ;

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives by specifying indices of array data elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count and indices arrays.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawElements")]
        public static extern void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, ref Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices, Int32 drawcount)
            where T3 : struct
        ;

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives by specifying indices of array data elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count and indices arrays.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawElements")]
        public static extern void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, ref Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices, Int32 drawcount)
            where T3 : struct
        ;

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives by specifying indices of array data elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count and indices arrays.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawElements")]
        public static extern unsafe void MultiDrawElements(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 drawcount);

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives by specifying indices of array data elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count and indices arrays.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawElements")]
        public static extern unsafe void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices, Int32 drawcount)
            where T3 : struct
        ;

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives by specifying indices of array data elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count and indices arrays.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawElements")]
        public static extern unsafe void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices, Int32 drawcount)
            where T3 : struct
        ;

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives by specifying indices of array data elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count and indices arrays.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawElements")]
        public static extern unsafe void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices, Int32 drawcount)
            where T3 : struct
        ;

        /// <summary>[requires: v1.4]
        /// Render multiple sets of primitives by specifying indices of array data elements
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count and indices arrays.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glMultiDrawElements")]
        public static extern unsafe void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices, Int32 drawcount)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple sets of primitives by specifying indices of array data elements and an index to apply to each index
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count, indices and basevertex arrays.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a pointer to the location where the base vertices are stored.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glMultiDrawElementsBaseVertex")]
        public static extern void MultiDrawElementsBaseVertex(OpenTK.Graphics.OpenGL.BeginMode mode, Int32[] count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 drawcount, Int32[] basevertex);

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple sets of primitives by specifying indices of array data elements and an index to apply to each index
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count, indices and basevertex arrays.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a pointer to the location where the base vertices are stored.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glMultiDrawElementsBaseVertex")]
        public static extern void MultiDrawElementsBaseVertex<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32[] count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices, Int32 drawcount, Int32[] basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple sets of primitives by specifying indices of array data elements and an index to apply to each index
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count, indices and basevertex arrays.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a pointer to the location where the base vertices are stored.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glMultiDrawElementsBaseVertex")]
        public static extern void MultiDrawElementsBaseVertex<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32[] count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices, Int32 drawcount, Int32[] basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple sets of primitives by specifying indices of array data elements and an index to apply to each index
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count, indices and basevertex arrays.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a pointer to the location where the base vertices are stored.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glMultiDrawElementsBaseVertex")]
        public static extern void MultiDrawElementsBaseVertex<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32[] count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices, Int32 drawcount, Int32[] basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple sets of primitives by specifying indices of array data elements and an index to apply to each index
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count, indices and basevertex arrays.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a pointer to the location where the base vertices are stored.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glMultiDrawElementsBaseVertex")]
        public static extern void MultiDrawElementsBaseVertex<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32[] count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices, Int32 drawcount, Int32[] basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple sets of primitives by specifying indices of array data elements and an index to apply to each index
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count, indices and basevertex arrays.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a pointer to the location where the base vertices are stored.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glMultiDrawElementsBaseVertex")]
        public static extern void MultiDrawElementsBaseVertex(OpenTK.Graphics.OpenGL.BeginMode mode, ref Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 drawcount, ref Int32 basevertex);

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple sets of primitives by specifying indices of array data elements and an index to apply to each index
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count, indices and basevertex arrays.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a pointer to the location where the base vertices are stored.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glMultiDrawElementsBaseVertex")]
        public static extern void MultiDrawElementsBaseVertex<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, ref Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices, Int32 drawcount, ref Int32 basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple sets of primitives by specifying indices of array data elements and an index to apply to each index
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count, indices and basevertex arrays.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a pointer to the location where the base vertices are stored.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glMultiDrawElementsBaseVertex")]
        public static extern void MultiDrawElementsBaseVertex<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, ref Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices, Int32 drawcount, ref Int32 basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple sets of primitives by specifying indices of array data elements and an index to apply to each index
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count, indices and basevertex arrays.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a pointer to the location where the base vertices are stored.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glMultiDrawElementsBaseVertex")]
        public static extern void MultiDrawElementsBaseVertex<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, ref Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices, Int32 drawcount, ref Int32 basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple sets of primitives by specifying indices of array data elements and an index to apply to each index
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count, indices and basevertex arrays.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a pointer to the location where the base vertices are stored.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glMultiDrawElementsBaseVertex")]
        public static extern void MultiDrawElementsBaseVertex<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, ref Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices, Int32 drawcount, ref Int32 basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple sets of primitives by specifying indices of array data elements and an index to apply to each index
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count, indices and basevertex arrays.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a pointer to the location where the base vertices are stored.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glMultiDrawElementsBaseVertex")]
        public static extern unsafe void MultiDrawElementsBaseVertex(OpenTK.Graphics.OpenGL.BeginMode mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 drawcount, Int32* basevertex);

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple sets of primitives by specifying indices of array data elements and an index to apply to each index
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count, indices and basevertex arrays.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a pointer to the location where the base vertices are stored.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glMultiDrawElementsBaseVertex")]
        public static extern unsafe void MultiDrawElementsBaseVertex<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices, Int32 drawcount, Int32* basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple sets of primitives by specifying indices of array data elements and an index to apply to each index
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count, indices and basevertex arrays.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a pointer to the location where the base vertices are stored.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glMultiDrawElementsBaseVertex")]
        public static extern unsafe void MultiDrawElementsBaseVertex<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices, Int32 drawcount, Int32* basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple sets of primitives by specifying indices of array data elements and an index to apply to each index
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count, indices and basevertex arrays.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a pointer to the location where the base vertices are stored.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glMultiDrawElementsBaseVertex")]
        public static extern unsafe void MultiDrawElementsBaseVertex<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices, Int32 drawcount, Int32* basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple sets of primitives by specifying indices of array data elements and an index to apply to each index
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count, indices and basevertex arrays.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a pointer to the location where the base vertices are stored.
        /// </para>
        /// </param>
        [Obsolete("Use PrimitiveType overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glMultiDrawElementsBaseVertex")]
        public static extern unsafe void MultiDrawElementsBaseVertex<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices, Int32 drawcount, Int32* basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple sets of primitives by specifying indices of array data elements and an index to apply to each index
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count, indices and basevertex arrays.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a pointer to the location where the base vertices are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glMultiDrawElementsBaseVertex")]
        public static extern void MultiDrawElementsBaseVertex(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32[] count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 drawcount, Int32[] basevertex);

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple sets of primitives by specifying indices of array data elements and an index to apply to each index
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count, indices and basevertex arrays.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a pointer to the location where the base vertices are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glMultiDrawElementsBaseVertex")]
        public static extern void MultiDrawElementsBaseVertex<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32[] count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices, Int32 drawcount, Int32[] basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple sets of primitives by specifying indices of array data elements and an index to apply to each index
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count, indices and basevertex arrays.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a pointer to the location where the base vertices are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glMultiDrawElementsBaseVertex")]
        public static extern void MultiDrawElementsBaseVertex<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32[] count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices, Int32 drawcount, Int32[] basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple sets of primitives by specifying indices of array data elements and an index to apply to each index
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count, indices and basevertex arrays.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a pointer to the location where the base vertices are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glMultiDrawElementsBaseVertex")]
        public static extern void MultiDrawElementsBaseVertex<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32[] count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices, Int32 drawcount, Int32[] basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple sets of primitives by specifying indices of array data elements and an index to apply to each index
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count, indices and basevertex arrays.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a pointer to the location where the base vertices are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glMultiDrawElementsBaseVertex")]
        public static extern void MultiDrawElementsBaseVertex<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32[] count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices, Int32 drawcount, Int32[] basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple sets of primitives by specifying indices of array data elements and an index to apply to each index
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count, indices and basevertex arrays.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a pointer to the location where the base vertices are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glMultiDrawElementsBaseVertex")]
        public static extern void MultiDrawElementsBaseVertex(OpenTK.Graphics.OpenGL.PrimitiveType mode, ref Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 drawcount, ref Int32 basevertex);

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple sets of primitives by specifying indices of array data elements and an index to apply to each index
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count, indices and basevertex arrays.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a pointer to the location where the base vertices are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glMultiDrawElementsBaseVertex")]
        public static extern void MultiDrawElementsBaseVertex<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, ref Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices, Int32 drawcount, ref Int32 basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple sets of primitives by specifying indices of array data elements and an index to apply to each index
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count, indices and basevertex arrays.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a pointer to the location where the base vertices are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glMultiDrawElementsBaseVertex")]
        public static extern void MultiDrawElementsBaseVertex<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, ref Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices, Int32 drawcount, ref Int32 basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple sets of primitives by specifying indices of array data elements and an index to apply to each index
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count, indices and basevertex arrays.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a pointer to the location where the base vertices are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glMultiDrawElementsBaseVertex")]
        public static extern void MultiDrawElementsBaseVertex<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, ref Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices, Int32 drawcount, ref Int32 basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple sets of primitives by specifying indices of array data elements and an index to apply to each index
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count, indices and basevertex arrays.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a pointer to the location where the base vertices are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glMultiDrawElementsBaseVertex")]
        public static extern void MultiDrawElementsBaseVertex<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, ref Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices, Int32 drawcount, ref Int32 basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple sets of primitives by specifying indices of array data elements and an index to apply to each index
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count, indices and basevertex arrays.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a pointer to the location where the base vertices are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glMultiDrawElementsBaseVertex")]
        public static extern unsafe void MultiDrawElementsBaseVertex(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 drawcount, Int32* basevertex);

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple sets of primitives by specifying indices of array data elements and an index to apply to each index
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count, indices and basevertex arrays.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a pointer to the location where the base vertices are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glMultiDrawElementsBaseVertex")]
        public static extern unsafe void MultiDrawElementsBaseVertex<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices, Int32 drawcount, Int32* basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple sets of primitives by specifying indices of array data elements and an index to apply to each index
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count, indices and basevertex arrays.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a pointer to the location where the base vertices are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glMultiDrawElementsBaseVertex")]
        public static extern unsafe void MultiDrawElementsBaseVertex<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices, Int32 drawcount, Int32* basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple sets of primitives by specifying indices of array data elements and an index to apply to each index
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count, indices and basevertex arrays.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a pointer to the location where the base vertices are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glMultiDrawElementsBaseVertex")]
        public static extern unsafe void MultiDrawElementsBaseVertex<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices, Int32 drawcount, Int32* basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_draw_elements_base_vertex|VERSION_3_2]
        /// Render multiple sets of primitives by specifying indices of array data elements and an index to apply to each index
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Points to an array of the elements counts.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies a pointer to the location where the indices are stored.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the size of the count, indices and basevertex arrays.
        /// </para>
        /// </param>
        /// <param name="basevertex">
        /// <para>
        /// Specifies a pointer to the location where the base vertices are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_draw_elements_base_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glMultiDrawElementsBaseVertex")]
        public static extern unsafe void MultiDrawElementsBaseVertex<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices, Int32 drawcount, Int32* basevertex)
            where T3 : struct
        ;

        /// <summary>[requires: v4.3 and ARB_multi_draw_indirect|VERSION_4_3]
        /// Render indexed primitives from array data, taking parameters from memory
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of data in the buffer bound to the GL_ELEMENT_ARRAY_BUFFER binding.
        /// </para>
        /// </param>
        /// <param name="indirect">
        /// <para>
        /// Specifies the address of a structure containing an array of draw parameters.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the number of elements in the array addressed by indirect.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the distance in basic machine units between elements of the draw parameter array.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_multi_draw_indirect|VERSION_4_3", Version = "4.3", EntryPoint = "glMultiDrawElementsIndirect")]
        public static extern void MultiDrawElementsIndirect(OpenTK.Graphics.OpenGL.All mode, OpenTK.Graphics.OpenGL.All type, IntPtr indirect, Int32 drawcount, Int32 stride);

        /// <summary>[requires: v4.3 and ARB_multi_draw_indirect|VERSION_4_3]
        /// Render indexed primitives from array data, taking parameters from memory
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of data in the buffer bound to the GL_ELEMENT_ARRAY_BUFFER binding.
        /// </para>
        /// </param>
        /// <param name="indirect">
        /// <para>
        /// Specifies the address of a structure containing an array of draw parameters.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the number of elements in the array addressed by indirect.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the distance in basic machine units between elements of the draw parameter array.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_multi_draw_indirect|VERSION_4_3", Version = "4.3", EntryPoint = "glMultiDrawElementsIndirect")]
        public static extern void MultiDrawElementsIndirect<T2>(OpenTK.Graphics.OpenGL.All mode, OpenTK.Graphics.OpenGL.All type, [InAttribute, OutAttribute] T2[] indirect, Int32 drawcount, Int32 stride)
            where T2 : struct
        ;

        /// <summary>[requires: v4.3 and ARB_multi_draw_indirect|VERSION_4_3]
        /// Render indexed primitives from array data, taking parameters from memory
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of data in the buffer bound to the GL_ELEMENT_ARRAY_BUFFER binding.
        /// </para>
        /// </param>
        /// <param name="indirect">
        /// <para>
        /// Specifies the address of a structure containing an array of draw parameters.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the number of elements in the array addressed by indirect.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the distance in basic machine units between elements of the draw parameter array.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_multi_draw_indirect|VERSION_4_3", Version = "4.3", EntryPoint = "glMultiDrawElementsIndirect")]
        public static extern void MultiDrawElementsIndirect<T2>(OpenTK.Graphics.OpenGL.All mode, OpenTK.Graphics.OpenGL.All type, [InAttribute, OutAttribute] T2[,] indirect, Int32 drawcount, Int32 stride)
            where T2 : struct
        ;

        /// <summary>[requires: v4.3 and ARB_multi_draw_indirect|VERSION_4_3]
        /// Render indexed primitives from array data, taking parameters from memory
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of data in the buffer bound to the GL_ELEMENT_ARRAY_BUFFER binding.
        /// </para>
        /// </param>
        /// <param name="indirect">
        /// <para>
        /// Specifies the address of a structure containing an array of draw parameters.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the number of elements in the array addressed by indirect.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the distance in basic machine units between elements of the draw parameter array.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_multi_draw_indirect|VERSION_4_3", Version = "4.3", EntryPoint = "glMultiDrawElementsIndirect")]
        public static extern void MultiDrawElementsIndirect<T2>(OpenTK.Graphics.OpenGL.All mode, OpenTK.Graphics.OpenGL.All type, [InAttribute, OutAttribute] T2[,,] indirect, Int32 drawcount, Int32 stride)
            where T2 : struct
        ;

        /// <summary>[requires: v4.3 and ARB_multi_draw_indirect|VERSION_4_3]
        /// Render indexed primitives from array data, taking parameters from memory
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the type of data in the buffer bound to the GL_ELEMENT_ARRAY_BUFFER binding.
        /// </para>
        /// </param>
        /// <param name="indirect">
        /// <para>
        /// Specifies the address of a structure containing an array of draw parameters.
        /// </para>
        /// </param>
        /// <param name="drawcount">
        /// <para>
        /// Specifies the number of elements in the array addressed by indirect.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the distance in basic machine units between elements of the draw parameter array.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_multi_draw_indirect|VERSION_4_3", Version = "4.3", EntryPoint = "glMultiDrawElementsIndirect")]
        public static extern void MultiDrawElementsIndirect<T2>(OpenTK.Graphics.OpenGL.All mode, OpenTK.Graphics.OpenGL.All type, [InAttribute, OutAttribute] ref T2 indirect, Int32 drawcount, Int32 stride)
            where T2 : struct
        ;

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord1d")]
        public static extern void MultiTexCoord1(OpenTK.Graphics.OpenGL.TextureUnit target, Double s);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord1dv")]
        public static extern unsafe void MultiTexCoord1(OpenTK.Graphics.OpenGL.TextureUnit target, Double* v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord1f")]
        public static extern void MultiTexCoord1(OpenTK.Graphics.OpenGL.TextureUnit target, Single s);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord1fv")]
        public static extern unsafe void MultiTexCoord1(OpenTK.Graphics.OpenGL.TextureUnit target, Single* v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord1i")]
        public static extern void MultiTexCoord1(OpenTK.Graphics.OpenGL.TextureUnit target, Int32 s);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord1iv")]
        public static extern unsafe void MultiTexCoord1(OpenTK.Graphics.OpenGL.TextureUnit target, Int32* v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord1s")]
        public static extern void MultiTexCoord1(OpenTK.Graphics.OpenGL.TextureUnit target, Int16 s);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord1sv")]
        public static extern unsafe void MultiTexCoord1(OpenTK.Graphics.OpenGL.TextureUnit target, Int16* v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord2d")]
        public static extern void MultiTexCoord2(OpenTK.Graphics.OpenGL.TextureUnit target, Double s, Double t);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord2dv")]
        public static extern void MultiTexCoord2(OpenTK.Graphics.OpenGL.TextureUnit target, Double[] v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord2dv")]
        public static extern void MultiTexCoord2(OpenTK.Graphics.OpenGL.TextureUnit target, ref Double v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord2dv")]
        public static extern unsafe void MultiTexCoord2(OpenTK.Graphics.OpenGL.TextureUnit target, Double* v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord2f")]
        public static extern void MultiTexCoord2(OpenTK.Graphics.OpenGL.TextureUnit target, Single s, Single t);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord2fv")]
        public static extern void MultiTexCoord2(OpenTK.Graphics.OpenGL.TextureUnit target, Single[] v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord2fv")]
        public static extern void MultiTexCoord2(OpenTK.Graphics.OpenGL.TextureUnit target, ref Single v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord2fv")]
        public static extern unsafe void MultiTexCoord2(OpenTK.Graphics.OpenGL.TextureUnit target, Single* v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord2i")]
        public static extern void MultiTexCoord2(OpenTK.Graphics.OpenGL.TextureUnit target, Int32 s, Int32 t);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord2iv")]
        public static extern void MultiTexCoord2(OpenTK.Graphics.OpenGL.TextureUnit target, Int32[] v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord2iv")]
        public static extern void MultiTexCoord2(OpenTK.Graphics.OpenGL.TextureUnit target, ref Int32 v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord2iv")]
        public static extern unsafe void MultiTexCoord2(OpenTK.Graphics.OpenGL.TextureUnit target, Int32* v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord2s")]
        public static extern void MultiTexCoord2(OpenTK.Graphics.OpenGL.TextureUnit target, Int16 s, Int16 t);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord2sv")]
        public static extern void MultiTexCoord2(OpenTK.Graphics.OpenGL.TextureUnit target, Int16[] v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord2sv")]
        public static extern void MultiTexCoord2(OpenTK.Graphics.OpenGL.TextureUnit target, ref Int16 v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord2sv")]
        public static extern unsafe void MultiTexCoord2(OpenTK.Graphics.OpenGL.TextureUnit target, Int16* v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord3d")]
        public static extern void MultiTexCoord3(OpenTK.Graphics.OpenGL.TextureUnit target, Double s, Double t, Double r);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord3dv")]
        public static extern void MultiTexCoord3(OpenTK.Graphics.OpenGL.TextureUnit target, Double[] v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord3dv")]
        public static extern void MultiTexCoord3(OpenTK.Graphics.OpenGL.TextureUnit target, ref Double v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord3dv")]
        public static extern unsafe void MultiTexCoord3(OpenTK.Graphics.OpenGL.TextureUnit target, Double* v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord3f")]
        public static extern void MultiTexCoord3(OpenTK.Graphics.OpenGL.TextureUnit target, Single s, Single t, Single r);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord3fv")]
        public static extern void MultiTexCoord3(OpenTK.Graphics.OpenGL.TextureUnit target, Single[] v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord3fv")]
        public static extern void MultiTexCoord3(OpenTK.Graphics.OpenGL.TextureUnit target, ref Single v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord3fv")]
        public static extern unsafe void MultiTexCoord3(OpenTK.Graphics.OpenGL.TextureUnit target, Single* v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord3i")]
        public static extern void MultiTexCoord3(OpenTK.Graphics.OpenGL.TextureUnit target, Int32 s, Int32 t, Int32 r);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord3iv")]
        public static extern void MultiTexCoord3(OpenTK.Graphics.OpenGL.TextureUnit target, Int32[] v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord3iv")]
        public static extern void MultiTexCoord3(OpenTK.Graphics.OpenGL.TextureUnit target, ref Int32 v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord3iv")]
        public static extern unsafe void MultiTexCoord3(OpenTK.Graphics.OpenGL.TextureUnit target, Int32* v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord3s")]
        public static extern void MultiTexCoord3(OpenTK.Graphics.OpenGL.TextureUnit target, Int16 s, Int16 t, Int16 r);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord3sv")]
        public static extern void MultiTexCoord3(OpenTK.Graphics.OpenGL.TextureUnit target, Int16[] v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord3sv")]
        public static extern void MultiTexCoord3(OpenTK.Graphics.OpenGL.TextureUnit target, ref Int16 v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord3sv")]
        public static extern unsafe void MultiTexCoord3(OpenTK.Graphics.OpenGL.TextureUnit target, Int16* v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord4d")]
        public static extern void MultiTexCoord4(OpenTK.Graphics.OpenGL.TextureUnit target, Double s, Double t, Double r, Double q);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord4dv")]
        public static extern void MultiTexCoord4(OpenTK.Graphics.OpenGL.TextureUnit target, Double[] v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord4dv")]
        public static extern void MultiTexCoord4(OpenTK.Graphics.OpenGL.TextureUnit target, ref Double v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord4dv")]
        public static extern unsafe void MultiTexCoord4(OpenTK.Graphics.OpenGL.TextureUnit target, Double* v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord4f")]
        public static extern void MultiTexCoord4(OpenTK.Graphics.OpenGL.TextureUnit target, Single s, Single t, Single r, Single q);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord4fv")]
        public static extern void MultiTexCoord4(OpenTK.Graphics.OpenGL.TextureUnit target, Single[] v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord4fv")]
        public static extern void MultiTexCoord4(OpenTK.Graphics.OpenGL.TextureUnit target, ref Single v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord4fv")]
        public static extern unsafe void MultiTexCoord4(OpenTK.Graphics.OpenGL.TextureUnit target, Single* v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord4i")]
        public static extern void MultiTexCoord4(OpenTK.Graphics.OpenGL.TextureUnit target, Int32 s, Int32 t, Int32 r, Int32 q);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord4iv")]
        public static extern void MultiTexCoord4(OpenTK.Graphics.OpenGL.TextureUnit target, Int32[] v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord4iv")]
        public static extern void MultiTexCoord4(OpenTK.Graphics.OpenGL.TextureUnit target, ref Int32 v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord4iv")]
        public static extern unsafe void MultiTexCoord4(OpenTK.Graphics.OpenGL.TextureUnit target, Int32* v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord4s")]
        public static extern void MultiTexCoord4(OpenTK.Graphics.OpenGL.TextureUnit target, Int16 s, Int16 t, Int16 r, Int16 q);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord4sv")]
        public static extern void MultiTexCoord4(OpenTK.Graphics.OpenGL.TextureUnit target, Int16[] v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord4sv")]
        public static extern void MultiTexCoord4(OpenTK.Graphics.OpenGL.TextureUnit target, ref Int16 v);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
        /// </para>
        /// </param>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultiTexCoord4sv")]
        public static extern unsafe void MultiTexCoord4(OpenTK.Graphics.OpenGL.TextureUnit target, Int16* v);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glMultiTexCoordP1ui")]
        public static extern void MultiTexCoordP1(OpenTK.Graphics.OpenGL.TextureUnit texture, OpenTK.Graphics.OpenGL.PackedPointerType type, Int32 coords);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glMultiTexCoordP1ui")]
        public static extern void MultiTexCoordP1(OpenTK.Graphics.OpenGL.TextureUnit texture, OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32 coords);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glMultiTexCoordP1uiv")]
        public static extern unsafe void MultiTexCoordP1(OpenTK.Graphics.OpenGL.TextureUnit texture, OpenTK.Graphics.OpenGL.PackedPointerType type, Int32* coords);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glMultiTexCoordP1uiv")]
        public static extern unsafe void MultiTexCoordP1(OpenTK.Graphics.OpenGL.TextureUnit texture, OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32* coords);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glMultiTexCoordP2ui")]
        public static extern void MultiTexCoordP2(OpenTK.Graphics.OpenGL.TextureUnit texture, OpenTK.Graphics.OpenGL.PackedPointerType type, Int32 coords);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glMultiTexCoordP2ui")]
        public static extern void MultiTexCoordP2(OpenTK.Graphics.OpenGL.TextureUnit texture, OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32 coords);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glMultiTexCoordP2uiv")]
        public static extern unsafe void MultiTexCoordP2(OpenTK.Graphics.OpenGL.TextureUnit texture, OpenTK.Graphics.OpenGL.PackedPointerType type, Int32* coords);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glMultiTexCoordP2uiv")]
        public static extern unsafe void MultiTexCoordP2(OpenTK.Graphics.OpenGL.TextureUnit texture, OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32* coords);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glMultiTexCoordP3ui")]
        public static extern void MultiTexCoordP3(OpenTK.Graphics.OpenGL.TextureUnit texture, OpenTK.Graphics.OpenGL.PackedPointerType type, Int32 coords);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glMultiTexCoordP3ui")]
        public static extern void MultiTexCoordP3(OpenTK.Graphics.OpenGL.TextureUnit texture, OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32 coords);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glMultiTexCoordP3uiv")]
        public static extern unsafe void MultiTexCoordP3(OpenTK.Graphics.OpenGL.TextureUnit texture, OpenTK.Graphics.OpenGL.PackedPointerType type, Int32* coords);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glMultiTexCoordP3uiv")]
        public static extern unsafe void MultiTexCoordP3(OpenTK.Graphics.OpenGL.TextureUnit texture, OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32* coords);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glMultiTexCoordP4ui")]
        public static extern void MultiTexCoordP4(OpenTK.Graphics.OpenGL.TextureUnit texture, OpenTK.Graphics.OpenGL.PackedPointerType type, Int32 coords);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glMultiTexCoordP4ui")]
        public static extern void MultiTexCoordP4(OpenTK.Graphics.OpenGL.TextureUnit texture, OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32 coords);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glMultiTexCoordP4uiv")]
        public static extern unsafe void MultiTexCoordP4(OpenTK.Graphics.OpenGL.TextureUnit texture, OpenTK.Graphics.OpenGL.PackedPointerType type, Int32* coords);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glMultiTexCoordP4uiv")]
        public static extern unsafe void MultiTexCoordP4(OpenTK.Graphics.OpenGL.TextureUnit texture, OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32* coords);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Multiply the current matrix with the specified matrix
        /// </summary>
        /// <param name="m">
        /// <para>
        /// Points to 16 consecutive values that are used as the elements of a 4 times 4 column-major matrix.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glMultMatrixd")]
        public static extern void MultMatrix(Double[] m);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Multiply the current matrix with the specified matrix
        /// </summary>
        /// <param name="m">
        /// <para>
        /// Points to 16 consecutive values that are used as the elements of a 4 times 4 column-major matrix.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glMultMatrixd")]
        public static extern void MultMatrix(ref Double m);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Multiply the current matrix with the specified matrix
        /// </summary>
        /// <param name="m">
        /// <para>
        /// Points to 16 consecutive values that are used as the elements of a 4 times 4 column-major matrix.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glMultMatrixd")]
        public static extern unsafe void MultMatrix(Double* m);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Multiply the current matrix with the specified matrix
        /// </summary>
        /// <param name="m">
        /// <para>
        /// Points to 16 consecutive values that are used as the elements of a 4 times 4 column-major matrix.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glMultMatrixf")]
        public static extern void MultMatrix(Single[] m);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Multiply the current matrix with the specified matrix
        /// </summary>
        /// <param name="m">
        /// <para>
        /// Points to 16 consecutive values that are used as the elements of a 4 times 4 column-major matrix.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glMultMatrixf")]
        public static extern void MultMatrix(ref Single m);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Multiply the current matrix with the specified matrix
        /// </summary>
        /// <param name="m">
        /// <para>
        /// Points to 16 consecutive values that are used as the elements of a 4 times 4 column-major matrix.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glMultMatrixf")]
        public static extern unsafe void MultMatrix(Single* m);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Multiply the current matrix with the specified row-major ordered matrix
        /// </summary>
        /// <param name="m">
        /// <para>
        /// Points to 16 consecutive values that are used as the elements of a 4 times 4 row-major matrix.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultTransposeMatrixd")]
        public static extern void MultTransposeMatrix(Double[] m);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Multiply the current matrix with the specified row-major ordered matrix
        /// </summary>
        /// <param name="m">
        /// <para>
        /// Points to 16 consecutive values that are used as the elements of a 4 times 4 row-major matrix.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultTransposeMatrixd")]
        public static extern void MultTransposeMatrix(ref Double m);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Multiply the current matrix with the specified row-major ordered matrix
        /// </summary>
        /// <param name="m">
        /// <para>
        /// Points to 16 consecutive values that are used as the elements of a 4 times 4 row-major matrix.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultTransposeMatrixd")]
        public static extern unsafe void MultTransposeMatrix(Double* m);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Multiply the current matrix with the specified row-major ordered matrix
        /// </summary>
        /// <param name="m">
        /// <para>
        /// Points to 16 consecutive values that are used as the elements of a 4 times 4 row-major matrix.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultTransposeMatrixf")]
        public static extern void MultTransposeMatrix(Single[] m);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Multiply the current matrix with the specified row-major ordered matrix
        /// </summary>
        /// <param name="m">
        /// <para>
        /// Points to 16 consecutive values that are used as the elements of a 4 times 4 row-major matrix.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultTransposeMatrixf")]
        public static extern void MultTransposeMatrix(ref Single m);

        /// <summary>[requires: v1.3][deprecated: v3.2]
        /// Multiply the current matrix with the specified row-major ordered matrix
        /// </summary>
        /// <param name="m">
        /// <para>
        /// Points to 16 consecutive values that are used as the elements of a 4 times 4 row-major matrix.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glMultTransposeMatrixf")]
        public static extern unsafe void MultTransposeMatrix(Single* m);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Create or replace a display list
        /// </summary>
        /// <param name="list">
        /// <para>
        /// Specifies the display-list name.
        /// </para>
        /// </param>
        /// <param name="mode">
        /// <para>
        /// Specifies the compilation mode, which can be GL_COMPILE or GL_COMPILE_AND_EXECUTE.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glNewList")]
        public static extern void NewList(Int32 list, OpenTK.Graphics.OpenGL.ListMode mode);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Create or replace a display list
        /// </summary>
        /// <param name="list">
        /// <para>
        /// Specifies the display-list name.
        /// </para>
        /// </param>
        /// <param name="mode">
        /// <para>
        /// Specifies the compilation mode, which can be GL_COMPILE or GL_COMPILE_AND_EXECUTE.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glNewList")]
        public static extern void NewList(UInt32 list, OpenTK.Graphics.OpenGL.ListMode mode);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current normal vector
        /// </summary>
        /// <param name="nx">
        /// <para>
        /// Specify the , , and coordinates of the new current normal. The initial value of the current normal is the unit vector, (0, 0, 1).
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glNormal3b")]
        public static extern void Normal3(Byte nx, Byte ny, Byte nz);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current normal vector
        /// </summary>
        /// <param name="nx">
        /// <para>
        /// Specify the , , and coordinates of the new current normal. The initial value of the current normal is the unit vector, (0, 0, 1).
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glNormal3b")]
        public static extern void Normal3(SByte nx, SByte ny, SByte nz);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current normal vector
        /// </summary>
        /// <param name="nx">
        /// <para>
        /// Specify the , , and coordinates of the new current normal. The initial value of the current normal is the unit vector, (0, 0, 1).
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glNormal3bv")]
        public static extern void Normal3(Byte[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current normal vector
        /// </summary>
        /// <param name="nx">
        /// <para>
        /// Specify the , , and coordinates of the new current normal. The initial value of the current normal is the unit vector, (0, 0, 1).
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glNormal3bv")]
        public static extern void Normal3(ref Byte v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current normal vector
        /// </summary>
        /// <param name="nx">
        /// <para>
        /// Specify the , , and coordinates of the new current normal. The initial value of the current normal is the unit vector, (0, 0, 1).
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glNormal3bv")]
        public static extern unsafe void Normal3(Byte* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current normal vector
        /// </summary>
        /// <param name="nx">
        /// <para>
        /// Specify the , , and coordinates of the new current normal. The initial value of the current normal is the unit vector, (0, 0, 1).
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glNormal3bv")]
        public static extern void Normal3(SByte[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current normal vector
        /// </summary>
        /// <param name="nx">
        /// <para>
        /// Specify the , , and coordinates of the new current normal. The initial value of the current normal is the unit vector, (0, 0, 1).
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glNormal3bv")]
        public static extern void Normal3(ref SByte v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current normal vector
        /// </summary>
        /// <param name="nx">
        /// <para>
        /// Specify the , , and coordinates of the new current normal. The initial value of the current normal is the unit vector, (0, 0, 1).
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glNormal3bv")]
        public static extern unsafe void Normal3(SByte* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current normal vector
        /// </summary>
        /// <param name="nx">
        /// <para>
        /// Specify the , , and coordinates of the new current normal. The initial value of the current normal is the unit vector, (0, 0, 1).
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glNormal3d")]
        public static extern void Normal3(Double nx, Double ny, Double nz);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current normal vector
        /// </summary>
        /// <param name="nx">
        /// <para>
        /// Specify the , , and coordinates of the new current normal. The initial value of the current normal is the unit vector, (0, 0, 1).
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glNormal3dv")]
        public static extern void Normal3(Double[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current normal vector
        /// </summary>
        /// <param name="nx">
        /// <para>
        /// Specify the , , and coordinates of the new current normal. The initial value of the current normal is the unit vector, (0, 0, 1).
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glNormal3dv")]
        public static extern void Normal3(ref Double v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current normal vector
        /// </summary>
        /// <param name="nx">
        /// <para>
        /// Specify the , , and coordinates of the new current normal. The initial value of the current normal is the unit vector, (0, 0, 1).
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glNormal3dv")]
        public static extern unsafe void Normal3(Double* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current normal vector
        /// </summary>
        /// <param name="nx">
        /// <para>
        /// Specify the , , and coordinates of the new current normal. The initial value of the current normal is the unit vector, (0, 0, 1).
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glNormal3f")]
        public static extern void Normal3(Single nx, Single ny, Single nz);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current normal vector
        /// </summary>
        /// <param name="nx">
        /// <para>
        /// Specify the , , and coordinates of the new current normal. The initial value of the current normal is the unit vector, (0, 0, 1).
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glNormal3fv")]
        public static extern void Normal3(Single[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current normal vector
        /// </summary>
        /// <param name="nx">
        /// <para>
        /// Specify the , , and coordinates of the new current normal. The initial value of the current normal is the unit vector, (0, 0, 1).
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glNormal3fv")]
        public static extern void Normal3(ref Single v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current normal vector
        /// </summary>
        /// <param name="nx">
        /// <para>
        /// Specify the , , and coordinates of the new current normal. The initial value of the current normal is the unit vector, (0, 0, 1).
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glNormal3fv")]
        public static extern unsafe void Normal3(Single* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current normal vector
        /// </summary>
        /// <param name="nx">
        /// <para>
        /// Specify the , , and coordinates of the new current normal. The initial value of the current normal is the unit vector, (0, 0, 1).
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glNormal3i")]
        public static extern void Normal3(Int32 nx, Int32 ny, Int32 nz);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current normal vector
        /// </summary>
        /// <param name="nx">
        /// <para>
        /// Specify the , , and coordinates of the new current normal. The initial value of the current normal is the unit vector, (0, 0, 1).
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glNormal3iv")]
        public static extern void Normal3(Int32[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current normal vector
        /// </summary>
        /// <param name="nx">
        /// <para>
        /// Specify the , , and coordinates of the new current normal. The initial value of the current normal is the unit vector, (0, 0, 1).
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glNormal3iv")]
        public static extern void Normal3(ref Int32 v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current normal vector
        /// </summary>
        /// <param name="nx">
        /// <para>
        /// Specify the , , and coordinates of the new current normal. The initial value of the current normal is the unit vector, (0, 0, 1).
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glNormal3iv")]
        public static extern unsafe void Normal3(Int32* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current normal vector
        /// </summary>
        /// <param name="nx">
        /// <para>
        /// Specify the , , and coordinates of the new current normal. The initial value of the current normal is the unit vector, (0, 0, 1).
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glNormal3s")]
        public static extern void Normal3(Int16 nx, Int16 ny, Int16 nz);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current normal vector
        /// </summary>
        /// <param name="nx">
        /// <para>
        /// Specify the , , and coordinates of the new current normal. The initial value of the current normal is the unit vector, (0, 0, 1).
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glNormal3sv")]
        public static extern void Normal3(Int16[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current normal vector
        /// </summary>
        /// <param name="nx">
        /// <para>
        /// Specify the , , and coordinates of the new current normal. The initial value of the current normal is the unit vector, (0, 0, 1).
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glNormal3sv")]
        public static extern void Normal3(ref Int16 v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current normal vector
        /// </summary>
        /// <param name="nx">
        /// <para>
        /// Specify the , , and coordinates of the new current normal. The initial value of the current normal is the unit vector, (0, 0, 1).
        /// </para>
        /// <para>
        ///
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glNormal3sv")]
        public static extern unsafe void Normal3(Int16* v);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glNormalP3ui")]
        public static extern void NormalP3(OpenTK.Graphics.OpenGL.PackedPointerType type, Int32 coords);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glNormalP3ui")]
        public static extern void NormalP3(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32 coords);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glNormalP3uiv")]
        public static extern unsafe void NormalP3(OpenTK.Graphics.OpenGL.PackedPointerType type, Int32* coords);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glNormalP3uiv")]
        public static extern unsafe void NormalP3(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32* coords);

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Define an array of normals
        /// </summary>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each coordinate in the array. Symbolic constants GL_BYTE, GL_SHORT, GL_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive normals. If stride is 0, the normals are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first coordinate of the first normal in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glNormalPointer")]
        public static extern void NormalPointer(OpenTK.Graphics.OpenGL.NormalPointerType type, Int32 stride, IntPtr pointer);

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Define an array of normals
        /// </summary>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each coordinate in the array. Symbolic constants GL_BYTE, GL_SHORT, GL_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive normals. If stride is 0, the normals are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first coordinate of the first normal in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glNormalPointer")]
        public static extern void NormalPointer<T2>(OpenTK.Graphics.OpenGL.NormalPointerType type, Int32 stride, [InAttribute, OutAttribute] T2[] pointer)
            where T2 : struct
        ;

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Define an array of normals
        /// </summary>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each coordinate in the array. Symbolic constants GL_BYTE, GL_SHORT, GL_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive normals. If stride is 0, the normals are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first coordinate of the first normal in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glNormalPointer")]
        public static extern void NormalPointer<T2>(OpenTK.Graphics.OpenGL.NormalPointerType type, Int32 stride, [InAttribute, OutAttribute] T2[,] pointer)
            where T2 : struct
        ;

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Define an array of normals
        /// </summary>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each coordinate in the array. Symbolic constants GL_BYTE, GL_SHORT, GL_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive normals. If stride is 0, the normals are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first coordinate of the first normal in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glNormalPointer")]
        public static extern void NormalPointer<T2>(OpenTK.Graphics.OpenGL.NormalPointerType type, Int32 stride, [InAttribute, OutAttribute] T2[,,] pointer)
            where T2 : struct
        ;

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Define an array of normals
        /// </summary>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each coordinate in the array. Symbolic constants GL_BYTE, GL_SHORT, GL_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive normals. If stride is 0, the normals are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first coordinate of the first normal in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glNormalPointer")]
        public static extern void NormalPointer<T2>(OpenTK.Graphics.OpenGL.NormalPointerType type, Int32 stride, [InAttribute, OutAttribute] ref T2 pointer)
            where T2 : struct
        ;

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Label a named object identified within a namespace
        /// </summary>
        /// <param name="identifier">
        /// <para>
        /// The namespace from which the name of the object is allocated.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The name of the object to label.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The length of the label to be used for the object.
        /// </para>
        /// </param>
        /// <param name="label">
        /// <para>
        /// The address of a string containing the label to assign to the object.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glObjectLabel")]
        public static extern void ObjectLabel(OpenTK.Graphics.OpenGL.ObjectLabelIdentifier identifier, Int32 name, Int32 length, String label);

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Label a named object identified within a namespace
        /// </summary>
        /// <param name="identifier">
        /// <para>
        /// The namespace from which the name of the object is allocated.
        /// </para>
        /// </param>
        /// <param name="name">
        /// <para>
        /// The name of the object to label.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The length of the label to be used for the object.
        /// </para>
        /// </param>
        /// <param name="label">
        /// <para>
        /// The address of a string containing the label to assign to the object.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glObjectLabel")]
        public static extern void ObjectLabel(OpenTK.Graphics.OpenGL.ObjectLabelIdentifier identifier, UInt32 name, Int32 length, String label);

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Label a a sync object identified by a pointer
        /// </summary>
        /// <param name="ptr">
        /// <para>
        /// A pointer identifying a sync object.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The length of the label to be used for the object.
        /// </para>
        /// </param>
        /// <param name="label">
        /// <para>
        /// The address of a string containing the label to assign to the object.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glObjectPtrLabel")]
        public static extern void ObjectPtrLabel(IntPtr ptr, Int32 length, String label);

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Label a a sync object identified by a pointer
        /// </summary>
        /// <param name="ptr">
        /// <para>
        /// A pointer identifying a sync object.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The length of the label to be used for the object.
        /// </para>
        /// </param>
        /// <param name="label">
        /// <para>
        /// The address of a string containing the label to assign to the object.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glObjectPtrLabel")]
        public static extern void ObjectPtrLabel<T0>([InAttribute, OutAttribute] T0[] ptr, Int32 length, String label)
            where T0 : struct
        ;

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Label a a sync object identified by a pointer
        /// </summary>
        /// <param name="ptr">
        /// <para>
        /// A pointer identifying a sync object.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The length of the label to be used for the object.
        /// </para>
        /// </param>
        /// <param name="label">
        /// <para>
        /// The address of a string containing the label to assign to the object.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glObjectPtrLabel")]
        public static extern void ObjectPtrLabel<T0>([InAttribute, OutAttribute] T0[,] ptr, Int32 length, String label)
            where T0 : struct
        ;

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Label a a sync object identified by a pointer
        /// </summary>
        /// <param name="ptr">
        /// <para>
        /// A pointer identifying a sync object.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The length of the label to be used for the object.
        /// </para>
        /// </param>
        /// <param name="label">
        /// <para>
        /// The address of a string containing the label to assign to the object.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glObjectPtrLabel")]
        public static extern void ObjectPtrLabel<T0>([InAttribute, OutAttribute] T0[,,] ptr, Int32 length, String label)
            where T0 : struct
        ;

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Label a a sync object identified by a pointer
        /// </summary>
        /// <param name="ptr">
        /// <para>
        /// A pointer identifying a sync object.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The length of the label to be used for the object.
        /// </para>
        /// </param>
        /// <param name="label">
        /// <para>
        /// The address of a string containing the label to assign to the object.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glObjectPtrLabel")]
        public static extern void ObjectPtrLabel<T0>([InAttribute, OutAttribute] ref T0 ptr, Int32 length, String label)
            where T0 : struct
        ;

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Multiply the current matrix with an orthographic matrix
        /// </summary>
        /// <param name="left">
        /// <para>
        /// Specify the coordinates for the left and right vertical clipping planes.
        /// </para>
        /// </param>
        /// <param name="bottom">
        /// <para>
        /// Specify the coordinates for the bottom and top horizontal clipping planes.
        /// </para>
        /// </param>
        /// <param name="nearVal">
        /// <para>
        /// Specify the distances to the nearer and farther depth clipping planes. These values are negative if the plane is to be behind the viewer.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glOrtho")]
        public static extern void Ortho(Double left, Double right, Double bottom, Double top, Double zNear, Double zFar);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Place a marker in the feedback buffer
        /// </summary>
        /// <param name="token">
        /// <para>
        /// Specifies a marker value to be placed in the feedback buffer following a GL_PASS_THROUGH_TOKEN.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glPassThrough")]
        public static extern void PassThrough(Single token);

        /// <summary>[requires: v4.0 and ARB_tessellation_shader|VERSION_4_0]
        /// Specifies the parameters for patch primitives
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies the name of the parameter to set. The symbolc constants GL_PATCH_VERTICES, GL_PATCH_DEFAULT_OUTER_LEVEL, and GL_PATCH_DEFAULT_INNER_LEVEL are accepted.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// Specifies the new value for the parameter given by pname.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies the address of an array containing the new values for the parameter given by pname.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_tessellation_shader|VERSION_4_0", Version = "4.0", EntryPoint = "glPatchParameterfv")]
        public static extern void PatchParameter(OpenTK.Graphics.OpenGL.PatchParameterFloat pname, Single[] values);

        /// <summary>[requires: v4.0 and ARB_tessellation_shader|VERSION_4_0]
        /// Specifies the parameters for patch primitives
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies the name of the parameter to set. The symbolc constants GL_PATCH_VERTICES, GL_PATCH_DEFAULT_OUTER_LEVEL, and GL_PATCH_DEFAULT_INNER_LEVEL are accepted.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// Specifies the new value for the parameter given by pname.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies the address of an array containing the new values for the parameter given by pname.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_tessellation_shader|VERSION_4_0", Version = "4.0", EntryPoint = "glPatchParameterfv")]
        public static extern void PatchParameter(OpenTK.Graphics.OpenGL.PatchParameterFloat pname, ref Single values);

        /// <summary>[requires: v4.0 and ARB_tessellation_shader|VERSION_4_0]
        /// Specifies the parameters for patch primitives
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies the name of the parameter to set. The symbolc constants GL_PATCH_VERTICES, GL_PATCH_DEFAULT_OUTER_LEVEL, and GL_PATCH_DEFAULT_INNER_LEVEL are accepted.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// Specifies the new value for the parameter given by pname.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies the address of an array containing the new values for the parameter given by pname.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_tessellation_shader|VERSION_4_0", Version = "4.0", EntryPoint = "glPatchParameterfv")]
        public static extern unsafe void PatchParameter(OpenTK.Graphics.OpenGL.PatchParameterFloat pname, Single* values);

        /// <summary>[requires: v4.0 and ARB_tessellation_shader|VERSION_4_0]
        /// Specifies the parameters for patch primitives
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies the name of the parameter to set. The symbolc constants GL_PATCH_VERTICES, GL_PATCH_DEFAULT_OUTER_LEVEL, and GL_PATCH_DEFAULT_INNER_LEVEL are accepted.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// Specifies the new value for the parameter given by pname.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies the address of an array containing the new values for the parameter given by pname.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_tessellation_shader|VERSION_4_0", Version = "4.0", EntryPoint = "glPatchParameteri")]
        public static extern void PatchParameter(OpenTK.Graphics.OpenGL.PatchParameterInt pname, Int32 value);

        /// <summary>[requires: v4.0 and ARB_transform_feedback2|VERSION_4_0]
        /// Pause transform feedback operations
        /// </summary>
        [AutoGenerated(Category = "ARB_transform_feedback2|VERSION_4_0", Version = "4.0", EntryPoint = "glPauseTransformFeedback")]
        public static extern void PauseTransformFeedback();

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set up pixel transfer maps
        /// </summary>
        /// <param name="map">
        /// <para>
        /// Specifies a symbolic map name. Must be one of the following: GL_PIXEL_MAP_I_TO_I, GL_PIXEL_MAP_S_TO_S, GL_PIXEL_MAP_I_TO_R, GL_PIXEL_MAP_I_TO_G, GL_PIXEL_MAP_I_TO_B, GL_PIXEL_MAP_I_TO_A, GL_PIXEL_MAP_R_TO_R, GL_PIXEL_MAP_G_TO_G, GL_PIXEL_MAP_B_TO_B, or GL_PIXEL_MAP_A_TO_A.
        /// </para>
        /// </param>
        /// <param name="mapsize">
        /// <para>
        /// Specifies the size of the map being defined.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies an array of mapsize values.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glPixelMapfv")]
        public static extern void PixelMap(OpenTK.Graphics.OpenGL.PixelMap map, Int32 mapsize, Single[] values);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set up pixel transfer maps
        /// </summary>
        /// <param name="map">
        /// <para>
        /// Specifies a symbolic map name. Must be one of the following: GL_PIXEL_MAP_I_TO_I, GL_PIXEL_MAP_S_TO_S, GL_PIXEL_MAP_I_TO_R, GL_PIXEL_MAP_I_TO_G, GL_PIXEL_MAP_I_TO_B, GL_PIXEL_MAP_I_TO_A, GL_PIXEL_MAP_R_TO_R, GL_PIXEL_MAP_G_TO_G, GL_PIXEL_MAP_B_TO_B, or GL_PIXEL_MAP_A_TO_A.
        /// </para>
        /// </param>
        /// <param name="mapsize">
        /// <para>
        /// Specifies the size of the map being defined.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies an array of mapsize values.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glPixelMapfv")]
        public static extern void PixelMap(OpenTK.Graphics.OpenGL.PixelMap map, Int32 mapsize, ref Single values);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set up pixel transfer maps
        /// </summary>
        /// <param name="map">
        /// <para>
        /// Specifies a symbolic map name. Must be one of the following: GL_PIXEL_MAP_I_TO_I, GL_PIXEL_MAP_S_TO_S, GL_PIXEL_MAP_I_TO_R, GL_PIXEL_MAP_I_TO_G, GL_PIXEL_MAP_I_TO_B, GL_PIXEL_MAP_I_TO_A, GL_PIXEL_MAP_R_TO_R, GL_PIXEL_MAP_G_TO_G, GL_PIXEL_MAP_B_TO_B, or GL_PIXEL_MAP_A_TO_A.
        /// </para>
        /// </param>
        /// <param name="mapsize">
        /// <para>
        /// Specifies the size of the map being defined.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies an array of mapsize values.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glPixelMapfv")]
        public static extern unsafe void PixelMap(OpenTK.Graphics.OpenGL.PixelMap map, Int32 mapsize, Single* values);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set up pixel transfer maps
        /// </summary>
        /// <param name="map">
        /// <para>
        /// Specifies a symbolic map name. Must be one of the following: GL_PIXEL_MAP_I_TO_I, GL_PIXEL_MAP_S_TO_S, GL_PIXEL_MAP_I_TO_R, GL_PIXEL_MAP_I_TO_G, GL_PIXEL_MAP_I_TO_B, GL_PIXEL_MAP_I_TO_A, GL_PIXEL_MAP_R_TO_R, GL_PIXEL_MAP_G_TO_G, GL_PIXEL_MAP_B_TO_B, or GL_PIXEL_MAP_A_TO_A.
        /// </para>
        /// </param>
        /// <param name="mapsize">
        /// <para>
        /// Specifies the size of the map being defined.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies an array of mapsize values.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glPixelMapuiv")]
        public static extern void PixelMap(OpenTK.Graphics.OpenGL.PixelMap map, Int32 mapsize, Int32[] values);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set up pixel transfer maps
        /// </summary>
        /// <param name="map">
        /// <para>
        /// Specifies a symbolic map name. Must be one of the following: GL_PIXEL_MAP_I_TO_I, GL_PIXEL_MAP_S_TO_S, GL_PIXEL_MAP_I_TO_R, GL_PIXEL_MAP_I_TO_G, GL_PIXEL_MAP_I_TO_B, GL_PIXEL_MAP_I_TO_A, GL_PIXEL_MAP_R_TO_R, GL_PIXEL_MAP_G_TO_G, GL_PIXEL_MAP_B_TO_B, or GL_PIXEL_MAP_A_TO_A.
        /// </para>
        /// </param>
        /// <param name="mapsize">
        /// <para>
        /// Specifies the size of the map being defined.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies an array of mapsize values.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glPixelMapuiv")]
        public static extern void PixelMap(OpenTK.Graphics.OpenGL.PixelMap map, Int32 mapsize, ref Int32 values);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set up pixel transfer maps
        /// </summary>
        /// <param name="map">
        /// <para>
        /// Specifies a symbolic map name. Must be one of the following: GL_PIXEL_MAP_I_TO_I, GL_PIXEL_MAP_S_TO_S, GL_PIXEL_MAP_I_TO_R, GL_PIXEL_MAP_I_TO_G, GL_PIXEL_MAP_I_TO_B, GL_PIXEL_MAP_I_TO_A, GL_PIXEL_MAP_R_TO_R, GL_PIXEL_MAP_G_TO_G, GL_PIXEL_MAP_B_TO_B, or GL_PIXEL_MAP_A_TO_A.
        /// </para>
        /// </param>
        /// <param name="mapsize">
        /// <para>
        /// Specifies the size of the map being defined.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies an array of mapsize values.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glPixelMapuiv")]
        public static extern unsafe void PixelMap(OpenTK.Graphics.OpenGL.PixelMap map, Int32 mapsize, Int32* values);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set up pixel transfer maps
        /// </summary>
        /// <param name="map">
        /// <para>
        /// Specifies a symbolic map name. Must be one of the following: GL_PIXEL_MAP_I_TO_I, GL_PIXEL_MAP_S_TO_S, GL_PIXEL_MAP_I_TO_R, GL_PIXEL_MAP_I_TO_G, GL_PIXEL_MAP_I_TO_B, GL_PIXEL_MAP_I_TO_A, GL_PIXEL_MAP_R_TO_R, GL_PIXEL_MAP_G_TO_G, GL_PIXEL_MAP_B_TO_B, or GL_PIXEL_MAP_A_TO_A.
        /// </para>
        /// </param>
        /// <param name="mapsize">
        /// <para>
        /// Specifies the size of the map being defined.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies an array of mapsize values.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glPixelMapuiv")]
        public static extern void PixelMap(OpenTK.Graphics.OpenGL.PixelMap map, Int32 mapsize, UInt32[] values);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set up pixel transfer maps
        /// </summary>
        /// <param name="map">
        /// <para>
        /// Specifies a symbolic map name. Must be one of the following: GL_PIXEL_MAP_I_TO_I, GL_PIXEL_MAP_S_TO_S, GL_PIXEL_MAP_I_TO_R, GL_PIXEL_MAP_I_TO_G, GL_PIXEL_MAP_I_TO_B, GL_PIXEL_MAP_I_TO_A, GL_PIXEL_MAP_R_TO_R, GL_PIXEL_MAP_G_TO_G, GL_PIXEL_MAP_B_TO_B, or GL_PIXEL_MAP_A_TO_A.
        /// </para>
        /// </param>
        /// <param name="mapsize">
        /// <para>
        /// Specifies the size of the map being defined.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies an array of mapsize values.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glPixelMapuiv")]
        public static extern void PixelMap(OpenTK.Graphics.OpenGL.PixelMap map, Int32 mapsize, ref UInt32 values);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set up pixel transfer maps
        /// </summary>
        /// <param name="map">
        /// <para>
        /// Specifies a symbolic map name. Must be one of the following: GL_PIXEL_MAP_I_TO_I, GL_PIXEL_MAP_S_TO_S, GL_PIXEL_MAP_I_TO_R, GL_PIXEL_MAP_I_TO_G, GL_PIXEL_MAP_I_TO_B, GL_PIXEL_MAP_I_TO_A, GL_PIXEL_MAP_R_TO_R, GL_PIXEL_MAP_G_TO_G, GL_PIXEL_MAP_B_TO_B, or GL_PIXEL_MAP_A_TO_A.
        /// </para>
        /// </param>
        /// <param name="mapsize">
        /// <para>
        /// Specifies the size of the map being defined.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies an array of mapsize values.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glPixelMapuiv")]
        public static extern unsafe void PixelMap(OpenTK.Graphics.OpenGL.PixelMap map, Int32 mapsize, UInt32* values);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set up pixel transfer maps
        /// </summary>
        /// <param name="map">
        /// <para>
        /// Specifies a symbolic map name. Must be one of the following: GL_PIXEL_MAP_I_TO_I, GL_PIXEL_MAP_S_TO_S, GL_PIXEL_MAP_I_TO_R, GL_PIXEL_MAP_I_TO_G, GL_PIXEL_MAP_I_TO_B, GL_PIXEL_MAP_I_TO_A, GL_PIXEL_MAP_R_TO_R, GL_PIXEL_MAP_G_TO_G, GL_PIXEL_MAP_B_TO_B, or GL_PIXEL_MAP_A_TO_A.
        /// </para>
        /// </param>
        /// <param name="mapsize">
        /// <para>
        /// Specifies the size of the map being defined.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies an array of mapsize values.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glPixelMapusv")]
        public static extern void PixelMap(OpenTK.Graphics.OpenGL.PixelMap map, Int32 mapsize, Int16[] values);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set up pixel transfer maps
        /// </summary>
        /// <param name="map">
        /// <para>
        /// Specifies a symbolic map name. Must be one of the following: GL_PIXEL_MAP_I_TO_I, GL_PIXEL_MAP_S_TO_S, GL_PIXEL_MAP_I_TO_R, GL_PIXEL_MAP_I_TO_G, GL_PIXEL_MAP_I_TO_B, GL_PIXEL_MAP_I_TO_A, GL_PIXEL_MAP_R_TO_R, GL_PIXEL_MAP_G_TO_G, GL_PIXEL_MAP_B_TO_B, or GL_PIXEL_MAP_A_TO_A.
        /// </para>
        /// </param>
        /// <param name="mapsize">
        /// <para>
        /// Specifies the size of the map being defined.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies an array of mapsize values.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glPixelMapusv")]
        public static extern void PixelMap(OpenTK.Graphics.OpenGL.PixelMap map, Int32 mapsize, ref Int16 values);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set up pixel transfer maps
        /// </summary>
        /// <param name="map">
        /// <para>
        /// Specifies a symbolic map name. Must be one of the following: GL_PIXEL_MAP_I_TO_I, GL_PIXEL_MAP_S_TO_S, GL_PIXEL_MAP_I_TO_R, GL_PIXEL_MAP_I_TO_G, GL_PIXEL_MAP_I_TO_B, GL_PIXEL_MAP_I_TO_A, GL_PIXEL_MAP_R_TO_R, GL_PIXEL_MAP_G_TO_G, GL_PIXEL_MAP_B_TO_B, or GL_PIXEL_MAP_A_TO_A.
        /// </para>
        /// </param>
        /// <param name="mapsize">
        /// <para>
        /// Specifies the size of the map being defined.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies an array of mapsize values.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glPixelMapusv")]
        public static extern unsafe void PixelMap(OpenTK.Graphics.OpenGL.PixelMap map, Int32 mapsize, Int16* values);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set up pixel transfer maps
        /// </summary>
        /// <param name="map">
        /// <para>
        /// Specifies a symbolic map name. Must be one of the following: GL_PIXEL_MAP_I_TO_I, GL_PIXEL_MAP_S_TO_S, GL_PIXEL_MAP_I_TO_R, GL_PIXEL_MAP_I_TO_G, GL_PIXEL_MAP_I_TO_B, GL_PIXEL_MAP_I_TO_A, GL_PIXEL_MAP_R_TO_R, GL_PIXEL_MAP_G_TO_G, GL_PIXEL_MAP_B_TO_B, or GL_PIXEL_MAP_A_TO_A.
        /// </para>
        /// </param>
        /// <param name="mapsize">
        /// <para>
        /// Specifies the size of the map being defined.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies an array of mapsize values.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glPixelMapusv")]
        public static extern void PixelMap(OpenTK.Graphics.OpenGL.PixelMap map, Int32 mapsize, UInt16[] values);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set up pixel transfer maps
        /// </summary>
        /// <param name="map">
        /// <para>
        /// Specifies a symbolic map name. Must be one of the following: GL_PIXEL_MAP_I_TO_I, GL_PIXEL_MAP_S_TO_S, GL_PIXEL_MAP_I_TO_R, GL_PIXEL_MAP_I_TO_G, GL_PIXEL_MAP_I_TO_B, GL_PIXEL_MAP_I_TO_A, GL_PIXEL_MAP_R_TO_R, GL_PIXEL_MAP_G_TO_G, GL_PIXEL_MAP_B_TO_B, or GL_PIXEL_MAP_A_TO_A.
        /// </para>
        /// </param>
        /// <param name="mapsize">
        /// <para>
        /// Specifies the size of the map being defined.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies an array of mapsize values.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glPixelMapusv")]
        public static extern void PixelMap(OpenTK.Graphics.OpenGL.PixelMap map, Int32 mapsize, ref UInt16 values);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set up pixel transfer maps
        /// </summary>
        /// <param name="map">
        /// <para>
        /// Specifies a symbolic map name. Must be one of the following: GL_PIXEL_MAP_I_TO_I, GL_PIXEL_MAP_S_TO_S, GL_PIXEL_MAP_I_TO_R, GL_PIXEL_MAP_I_TO_G, GL_PIXEL_MAP_I_TO_B, GL_PIXEL_MAP_I_TO_A, GL_PIXEL_MAP_R_TO_R, GL_PIXEL_MAP_G_TO_G, GL_PIXEL_MAP_B_TO_B, or GL_PIXEL_MAP_A_TO_A.
        /// </para>
        /// </param>
        /// <param name="mapsize">
        /// <para>
        /// Specifies the size of the map being defined.
        /// </para>
        /// </param>
        /// <param name="values">
        /// <para>
        /// Specifies an array of mapsize values.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glPixelMapusv")]
        public static extern unsafe void PixelMap(OpenTK.Graphics.OpenGL.PixelMap map, Int32 mapsize, UInt16* values);

        /// <summary></summary>
        [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glPixelMapx")]
        public static extern void PixelMapx(OpenTK.Graphics.OpenGL.OesFixedPoint map, Int32 size, int[] values);

        /// <summary></summary>
        [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glPixelMapx")]
        public static extern void PixelMapx(OpenTK.Graphics.OpenGL.OesFixedPoint map, Int32 size, ref int values);

        /// <summary></summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glPixelMapx")]
        public static extern unsafe void PixelMapx(OpenTK.Graphics.OpenGL.OesFixedPoint map, Int32 size, int* values);

        /// <summary>[requires: v1.0]
        /// Set pixel storage modes
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the parameter to be set. Six values affect the packing of pixel data into memory: GL_PACK_SWAP_BYTES, GL_PACK_LSB_FIRST, GL_PACK_ROW_LENGTH, GL_PACK_IMAGE_HEIGHT, GL_PACK_SKIP_PIXELS, GL_PACK_SKIP_ROWS, GL_PACK_SKIP_IMAGES, and GL_PACK_ALIGNMENT. Six more affect the unpacking of pixel data from memory: GL_UNPACK_SWAP_BYTES, GL_UNPACK_LSB_FIRST, GL_UNPACK_ROW_LENGTH, GL_UNPACK_IMAGE_HEIGHT, GL_UNPACK_SKIP_PIXELS, GL_UNPACK_SKIP_ROWS, GL_UNPACK_SKIP_IMAGES, and GL_UNPACK_ALIGNMENT.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies the value that pname is set to.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glPixelStoref")]
        public static extern void PixelStore(OpenTK.Graphics.OpenGL.PixelStoreParameter pname, Single param);

        /// <summary>[requires: v1.0]
        /// Set pixel storage modes
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the parameter to be set. Six values affect the packing of pixel data into memory: GL_PACK_SWAP_BYTES, GL_PACK_LSB_FIRST, GL_PACK_ROW_LENGTH, GL_PACK_IMAGE_HEIGHT, GL_PACK_SKIP_PIXELS, GL_PACK_SKIP_ROWS, GL_PACK_SKIP_IMAGES, and GL_PACK_ALIGNMENT. Six more affect the unpacking of pixel data from memory: GL_UNPACK_SWAP_BYTES, GL_UNPACK_LSB_FIRST, GL_UNPACK_ROW_LENGTH, GL_UNPACK_IMAGE_HEIGHT, GL_UNPACK_SKIP_PIXELS, GL_UNPACK_SKIP_ROWS, GL_UNPACK_SKIP_IMAGES, and GL_UNPACK_ALIGNMENT.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies the value that pname is set to.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glPixelStorei")]
        public static extern void PixelStore(OpenTK.Graphics.OpenGL.PixelStoreParameter pname, Int32 param);

        /// <summary></summary>
        [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glPixelStorex")]
        public static extern void PixelStorex(OpenTK.Graphics.OpenGL.OesFixedPoint pname, int param);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set pixel transfer modes
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the pixel transfer parameter to be set. Must be one of the following: GL_MAP_COLOR, GL_MAP_STENCIL, GL_INDEX_SHIFT, GL_INDEX_OFFSET, GL_RED_SCALE, GL_RED_BIAS, GL_GREEN_SCALE, GL_GREEN_BIAS, GL_BLUE_SCALE, GL_BLUE_BIAS, GL_ALPHA_SCALE, GL_ALPHA_BIAS, GL_DEPTH_SCALE, or GL_DEPTH_BIAS.
        /// </para>
        /// <para>
        /// Additionally, if the ARB_imaging extension is supported, the following symbolic names are accepted: GL_POST_COLOR_MATRIX_RED_SCALE, GL_POST_COLOR_MATRIX_GREEN_SCALE, GL_POST_COLOR_MATRIX_BLUE_SCALE, GL_POST_COLOR_MATRIX_ALPHA_SCALE, GL_POST_COLOR_MATRIX_RED_BIAS, GL_POST_COLOR_MATRIX_GREEN_BIAS, GL_POST_COLOR_MATRIX_BLUE_BIAS, GL_POST_COLOR_MATRIX_ALPHA_BIAS, GL_POST_CONVOLUTION_RED_SCALE, GL_POST_CONVOLUTION_GREEN_SCALE, GL_POST_CONVOLUTION_BLUE_SCALE, GL_POST_CONVOLUTION_ALPHA_SCALE, GL_POST_CONVOLUTION_RED_BIAS, GL_POST_CONVOLUTION_GREEN_BIAS, GL_POST_CONVOLUTION_BLUE_BIAS, and GL_POST_CONVOLUTION_ALPHA_BIAS.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies the value that pname is set to.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glPixelTransferf")]
        public static extern void PixelTransfer(OpenTK.Graphics.OpenGL.PixelTransferParameter pname, Single param);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set pixel transfer modes
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the pixel transfer parameter to be set. Must be one of the following: GL_MAP_COLOR, GL_MAP_STENCIL, GL_INDEX_SHIFT, GL_INDEX_OFFSET, GL_RED_SCALE, GL_RED_BIAS, GL_GREEN_SCALE, GL_GREEN_BIAS, GL_BLUE_SCALE, GL_BLUE_BIAS, GL_ALPHA_SCALE, GL_ALPHA_BIAS, GL_DEPTH_SCALE, or GL_DEPTH_BIAS.
        /// </para>
        /// <para>
        /// Additionally, if the ARB_imaging extension is supported, the following symbolic names are accepted: GL_POST_COLOR_MATRIX_RED_SCALE, GL_POST_COLOR_MATRIX_GREEN_SCALE, GL_POST_COLOR_MATRIX_BLUE_SCALE, GL_POST_COLOR_MATRIX_ALPHA_SCALE, GL_POST_COLOR_MATRIX_RED_BIAS, GL_POST_COLOR_MATRIX_GREEN_BIAS, GL_POST_COLOR_MATRIX_BLUE_BIAS, GL_POST_COLOR_MATRIX_ALPHA_BIAS, GL_POST_CONVOLUTION_RED_SCALE, GL_POST_CONVOLUTION_GREEN_SCALE, GL_POST_CONVOLUTION_BLUE_SCALE, GL_POST_CONVOLUTION_ALPHA_SCALE, GL_POST_CONVOLUTION_RED_BIAS, GL_POST_CONVOLUTION_GREEN_BIAS, GL_POST_CONVOLUTION_BLUE_BIAS, and GL_POST_CONVOLUTION_ALPHA_BIAS.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies the value that pname is set to.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glPixelTransferi")]
        public static extern void PixelTransfer(OpenTK.Graphics.OpenGL.PixelTransferParameter pname, Int32 param);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the pixel zoom factors
        /// </summary>
        /// <param name="xfactor">
        /// <para>
        /// Specify the and zoom factors for pixel write operations.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glPixelZoom")]
        public static extern void PixelZoom(Single xfactor, Single yfactor);

        /// <summary>[requires: v1.4]
        /// Specify point parameters
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies a single-valued point parameter. GL_POINT_FADE_THRESHOLD_SIZE, and GL_POINT_SPRITE_COORD_ORIGIN are accepted.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// For glPointParameterf and glPointParameteri, specifies the value that pname will be set to.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// For glPointParameterfv and glPointParameteriv, specifies a pointer to an array where the value or values to be assigned to pname are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glPointParameterf")]
        public static extern void PointParameter(OpenTK.Graphics.OpenGL.PointParameterName pname, Single param);

        /// <summary>[requires: v1.4]
        /// Specify point parameters
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies a single-valued point parameter. GL_POINT_FADE_THRESHOLD_SIZE, and GL_POINT_SPRITE_COORD_ORIGIN are accepted.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// For glPointParameterf and glPointParameteri, specifies the value that pname will be set to.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// For glPointParameterfv and glPointParameteriv, specifies a pointer to an array where the value or values to be assigned to pname are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glPointParameterfv")]
        public static extern void PointParameter(OpenTK.Graphics.OpenGL.PointParameterName pname, Single[] @params);

        /// <summary>[requires: v1.4]
        /// Specify point parameters
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies a single-valued point parameter. GL_POINT_FADE_THRESHOLD_SIZE, and GL_POINT_SPRITE_COORD_ORIGIN are accepted.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// For glPointParameterf and glPointParameteri, specifies the value that pname will be set to.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// For glPointParameterfv and glPointParameteriv, specifies a pointer to an array where the value or values to be assigned to pname are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glPointParameterfv")]
        public static extern unsafe void PointParameter(OpenTK.Graphics.OpenGL.PointParameterName pname, Single* @params);

        /// <summary>[requires: v1.4]
        /// Specify point parameters
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies a single-valued point parameter. GL_POINT_FADE_THRESHOLD_SIZE, and GL_POINT_SPRITE_COORD_ORIGIN are accepted.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// For glPointParameterf and glPointParameteri, specifies the value that pname will be set to.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// For glPointParameterfv and glPointParameteriv, specifies a pointer to an array where the value or values to be assigned to pname are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glPointParameteri")]
        public static extern void PointParameter(OpenTK.Graphics.OpenGL.PointParameterName pname, Int32 param);

        /// <summary>[requires: v1.4]
        /// Specify point parameters
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies a single-valued point parameter. GL_POINT_FADE_THRESHOLD_SIZE, and GL_POINT_SPRITE_COORD_ORIGIN are accepted.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// For glPointParameterf and glPointParameteri, specifies the value that pname will be set to.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// For glPointParameterfv and glPointParameteriv, specifies a pointer to an array where the value or values to be assigned to pname are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glPointParameteriv")]
        public static extern void PointParameter(OpenTK.Graphics.OpenGL.PointParameterName pname, Int32[] @params);

        /// <summary>[requires: v1.4]
        /// Specify point parameters
        /// </summary>
        /// <param name="pname">
        /// <para>
        /// Specifies a single-valued point parameter. GL_POINT_FADE_THRESHOLD_SIZE, and GL_POINT_SPRITE_COORD_ORIGIN are accepted.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// For glPointParameterf and glPointParameteri, specifies the value that pname will be set to.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// For glPointParameterfv and glPointParameteriv, specifies a pointer to an array where the value or values to be assigned to pname are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glPointParameteriv")]
        public static extern unsafe void PointParameter(OpenTK.Graphics.OpenGL.PointParameterName pname, Int32* @params);

        /// <summary>[requires: v1.0]
        /// Specify the diameter of rasterized points
        /// </summary>
        /// <param name="size">
        /// <para>
        /// Specifies the diameter of rasterized points. The initial value is 1.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glPointSize")]
        public static extern void PointSize(Single size);

        /// <summary>[requires: v1.0]
        /// Select a polygon rasterization mode
        /// </summary>
        /// <param name="face">
        /// <para>
        /// Specifies the polygons that mode applies to. Must be GL_FRONT_AND_BACK for front- and back-facing polygons.
        /// </para>
        /// </param>
        /// <param name="mode">
        /// <para>
        /// Specifies how polygons will be rasterized. Accepted values are GL_POINT, GL_LINE, and GL_FILL. The initial value is GL_FILL for both front- and back-facing polygons.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glPolygonMode")]
        public static extern void PolygonMode(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.PolygonMode mode);

        /// <summary>[requires: v1.1]
        /// Set the scale and units used to calculate depth values
        /// </summary>
        /// <param name="factor">
        /// <para>
        /// Specifies a scale factor that is used to create a variable depth offset for each polygon. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="units">
        /// <para>
        /// Is multiplied by an implementation-specific value to create a constant depth offset. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glPolygonOffset")]
        public static extern void PolygonOffset(Single factor, Single units);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the polygon stippling pattern
        /// </summary>
        /// <param name="pattern">
        /// <para>
        /// Specifies a pointer to a 32 times 32 stipple pattern that will be unpacked from memory in the same way that glDrawPixels unpacks pixels.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glPolygonStipple")]
        public static extern void PolygonStipple(Byte[] mask);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the polygon stippling pattern
        /// </summary>
        /// <param name="pattern">
        /// <para>
        /// Specifies a pointer to a 32 times 32 stipple pattern that will be unpacked from memory in the same way that glDrawPixels unpacks pixels.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glPolygonStipple")]
        public static extern void PolygonStipple(ref Byte mask);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the polygon stippling pattern
        /// </summary>
        /// <param name="pattern">
        /// <para>
        /// Specifies a pointer to a 32 times 32 stipple pattern that will be unpacked from memory in the same way that glDrawPixels unpacks pixels.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glPolygonStipple")]
        public static extern unsafe void PolygonStipple(Byte* mask);

        /// <summary>[requires: v1.0][deprecated: v3.2]</summary>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glPopAttrib")]
        public static extern void PopAttrib();

        /// <summary>[requires: v1.1][deprecated: v3.2]</summary>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glPopClientAttrib")]
        public static extern void PopClientAttrib();

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Pop the active debug group
        /// </summary>
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glPopDebugGroup")]
        public static extern void PopDebugGroup();

        /// <summary>[requires: v1.0][deprecated: v3.2]</summary>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glPopMatrix")]
        public static extern void PopMatrix();

        /// <summary>[requires: v1.0][deprecated: v3.2]</summary>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glPopName")]
        public static extern void PopName();

        /// <summary>[requires: v3.1]
        /// Specify the primitive restart index
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the value to be interpreted as the primitive restart index.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_3_1", Version = "3.1", EntryPoint = "glPrimitiveRestartIndex")]
        public static extern void PrimitiveRestartIndex(Int32 index);

        /// <summary>[requires: v3.1]
        /// Specify the primitive restart index
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the value to be interpreted as the primitive restart index.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_1", Version = "3.1", EntryPoint = "glPrimitiveRestartIndex")]
        public static extern void PrimitiveRestartIndex(UInt32 index);

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Set texture residence priority
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of textures to be prioritized.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies an array containing the names of the textures to be prioritized.
        /// </para>
        /// </param>
        /// <param name="priorities">
        /// <para>
        /// Specifies an array containing the texture priorities. A priority given in an element of priorities applies to the texture named by the corresponding element of textures.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glPrioritizeTextures")]
        public static extern void PrioritizeTextures(Int32 n, Int32[] textures, Single[] priorities);

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Set texture residence priority
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of textures to be prioritized.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies an array containing the names of the textures to be prioritized.
        /// </para>
        /// </param>
        /// <param name="priorities">
        /// <para>
        /// Specifies an array containing the texture priorities. A priority given in an element of priorities applies to the texture named by the corresponding element of textures.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glPrioritizeTextures")]
        public static extern void PrioritizeTextures(Int32 n, ref Int32 textures, ref Single priorities);

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Set texture residence priority
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of textures to be prioritized.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies an array containing the names of the textures to be prioritized.
        /// </para>
        /// </param>
        /// <param name="priorities">
        /// <para>
        /// Specifies an array containing the texture priorities. A priority given in an element of priorities applies to the texture named by the corresponding element of textures.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glPrioritizeTextures")]
        public static extern unsafe void PrioritizeTextures(Int32 n, Int32* textures, Single* priorities);

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Set texture residence priority
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of textures to be prioritized.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies an array containing the names of the textures to be prioritized.
        /// </para>
        /// </param>
        /// <param name="priorities">
        /// <para>
        /// Specifies an array containing the texture priorities. A priority given in an element of priorities applies to the texture named by the corresponding element of textures.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glPrioritizeTextures")]
        public static extern void PrioritizeTextures(Int32 n, UInt32[] textures, Single[] priorities);

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Set texture residence priority
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of textures to be prioritized.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies an array containing the names of the textures to be prioritized.
        /// </para>
        /// </param>
        /// <param name="priorities">
        /// <para>
        /// Specifies an array containing the texture priorities. A priority given in an element of priorities applies to the texture named by the corresponding element of textures.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glPrioritizeTextures")]
        public static extern void PrioritizeTextures(Int32 n, ref UInt32 textures, ref Single priorities);

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Set texture residence priority
        /// </summary>
        /// <param name="n">
        /// <para>
        /// Specifies the number of textures to be prioritized.
        /// </para>
        /// </param>
        /// <param name="textures">
        /// <para>
        /// Specifies an array containing the names of the textures to be prioritized.
        /// </para>
        /// </param>
        /// <param name="priorities">
        /// <para>
        /// Specifies an array containing the texture priorities. A priority given in an element of priorities applies to the texture named by the corresponding element of textures.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glPrioritizeTextures")]
        public static extern unsafe void PrioritizeTextures(Int32 n, UInt32* textures, Single* priorities);

        /// <summary>[requires: v4.1 and ARB_get_program_binary|VERSION_4_1]
        /// Load a program object with a program binary
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program object into which to load a program binary.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the binary data in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address an array containing the binary to be loaded into program.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the number of bytes contained in binary.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_get_program_binary|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramBinary")]
        public static extern void ProgramBinary(Int32 program, OpenTK.Graphics.OpenGL.BinaryFormat binaryFormat, IntPtr binary, Int32 length);

        /// <summary>[requires: v4.1 and ARB_get_program_binary|VERSION_4_1]
        /// Load a program object with a program binary
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program object into which to load a program binary.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the binary data in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address an array containing the binary to be loaded into program.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the number of bytes contained in binary.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_get_program_binary|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramBinary")]
        public static extern void ProgramBinary<T2>(Int32 program, OpenTK.Graphics.OpenGL.BinaryFormat binaryFormat, [InAttribute, OutAttribute] T2[] binary, Int32 length)
            where T2 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_get_program_binary|VERSION_4_1]
        /// Load a program object with a program binary
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program object into which to load a program binary.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the binary data in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address an array containing the binary to be loaded into program.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the number of bytes contained in binary.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_get_program_binary|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramBinary")]
        public static extern void ProgramBinary<T2>(Int32 program, OpenTK.Graphics.OpenGL.BinaryFormat binaryFormat, [InAttribute, OutAttribute] T2[,] binary, Int32 length)
            where T2 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_get_program_binary|VERSION_4_1]
        /// Load a program object with a program binary
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program object into which to load a program binary.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the binary data in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address an array containing the binary to be loaded into program.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the number of bytes contained in binary.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_get_program_binary|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramBinary")]
        public static extern void ProgramBinary<T2>(Int32 program, OpenTK.Graphics.OpenGL.BinaryFormat binaryFormat, [InAttribute, OutAttribute] T2[,,] binary, Int32 length)
            where T2 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_get_program_binary|VERSION_4_1]
        /// Load a program object with a program binary
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program object into which to load a program binary.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the binary data in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address an array containing the binary to be loaded into program.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the number of bytes contained in binary.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_get_program_binary|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramBinary")]
        public static extern void ProgramBinary<T2>(Int32 program, OpenTK.Graphics.OpenGL.BinaryFormat binaryFormat, [InAttribute, OutAttribute] ref T2 binary, Int32 length)
            where T2 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_get_program_binary|VERSION_4_1]
        /// Load a program object with a program binary
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program object into which to load a program binary.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the binary data in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address an array containing the binary to be loaded into program.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the number of bytes contained in binary.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_get_program_binary|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramBinary")]
        public static extern void ProgramBinary(UInt32 program, OpenTK.Graphics.OpenGL.BinaryFormat binaryFormat, IntPtr binary, Int32 length);

        /// <summary>[requires: v4.1 and ARB_get_program_binary|VERSION_4_1]
        /// Load a program object with a program binary
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program object into which to load a program binary.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the binary data in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address an array containing the binary to be loaded into program.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the number of bytes contained in binary.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_get_program_binary|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramBinary")]
        public static extern void ProgramBinary<T2>(UInt32 program, OpenTK.Graphics.OpenGL.BinaryFormat binaryFormat, [InAttribute, OutAttribute] T2[] binary, Int32 length)
            where T2 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_get_program_binary|VERSION_4_1]
        /// Load a program object with a program binary
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program object into which to load a program binary.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the binary data in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address an array containing the binary to be loaded into program.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the number of bytes contained in binary.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_get_program_binary|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramBinary")]
        public static extern void ProgramBinary<T2>(UInt32 program, OpenTK.Graphics.OpenGL.BinaryFormat binaryFormat, [InAttribute, OutAttribute] T2[,] binary, Int32 length)
            where T2 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_get_program_binary|VERSION_4_1]
        /// Load a program object with a program binary
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program object into which to load a program binary.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the binary data in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address an array containing the binary to be loaded into program.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the number of bytes contained in binary.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_get_program_binary|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramBinary")]
        public static extern void ProgramBinary<T2>(UInt32 program, OpenTK.Graphics.OpenGL.BinaryFormat binaryFormat, [InAttribute, OutAttribute] T2[,,] binary, Int32 length)
            where T2 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_get_program_binary|VERSION_4_1]
        /// Load a program object with a program binary
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program object into which to load a program binary.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the binary data in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address an array containing the binary to be loaded into program.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the number of bytes contained in binary.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_get_program_binary|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramBinary")]
        public static extern void ProgramBinary<T2>(UInt32 program, OpenTK.Graphics.OpenGL.BinaryFormat binaryFormat, [InAttribute, OutAttribute] ref T2 binary, Int32 length)
            where T2 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_get_program_binary|VERSION_4_1]
        /// Specify a parameter for a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program object whose parameter to modify.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the name of the parameter to modify.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// Specifies the new value of the parameter specified by pname for program.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_get_program_binary|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramParameteri")]
        public static extern void ProgramParameter(Int32 program, OpenTK.Graphics.OpenGL.ProgramParameterName pname, Int32 value);

        /// <summary>[requires: v4.1 and ARB_get_program_binary|VERSION_4_1]
        /// Specify a parameter for a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program object whose parameter to modify.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the name of the parameter to modify.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// Specifies the new value of the parameter specified by pname for program.
        /// </para>
        /// </param>
        [Obsolete("Use ProgramParameterName overload instead")]
        [AutoGenerated(Category = "ARB_get_program_binary|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramParameteri")]
        public static extern void ProgramParameter(Int32 program, OpenTK.Graphics.OpenGL.Version32 pname, Int32 value);

        /// <summary>[requires: v4.1 and ARB_get_program_binary|VERSION_4_1]
        /// Specify a parameter for a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program object whose parameter to modify.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the name of the parameter to modify.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// Specifies the new value of the parameter specified by pname for program.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_get_program_binary|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramParameteri")]
        public static extern void ProgramParameter(UInt32 program, OpenTK.Graphics.OpenGL.ProgramParameterName pname, Int32 value);

        /// <summary>[requires: v4.1 and ARB_get_program_binary|VERSION_4_1]
        /// Specify a parameter for a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the name of a program object whose parameter to modify.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the name of the parameter to modify.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// Specifies the new value of the parameter specified by pname for program.
        /// </para>
        /// </param>
        [Obsolete("Use ProgramParameterName overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_get_program_binary|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramParameteri")]
        public static extern void ProgramParameter(UInt32 program, OpenTK.Graphics.OpenGL.Version32 pname, Int32 value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform1d")]
        public static extern void ProgramUniform1(Int32 program, Int32 location, Double v0);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform1d")]
        public static extern void ProgramUniform1(UInt32 program, Int32 location, Double v0);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform1dv")]
        public static extern void ProgramUniform1(Int32 program, Int32 location, Int32 count, ref Double value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform1dv")]
        public static extern unsafe void ProgramUniform1(Int32 program, Int32 location, Int32 count, Double* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform1dv")]
        public static extern void ProgramUniform1(UInt32 program, Int32 location, Int32 count, ref Double value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform1dv")]
        public static extern unsafe void ProgramUniform1(UInt32 program, Int32 location, Int32 count, Double* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform1f")]
        public static extern void ProgramUniform1(Int32 program, Int32 location, Single v0);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform1f")]
        public static extern void ProgramUniform1(UInt32 program, Int32 location, Single v0);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform1fv")]
        public static extern void ProgramUniform1(Int32 program, Int32 location, Int32 count, ref Single value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform1fv")]
        public static extern unsafe void ProgramUniform1(Int32 program, Int32 location, Int32 count, Single* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform1fv")]
        public static extern void ProgramUniform1(UInt32 program, Int32 location, Int32 count, ref Single value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform1fv")]
        public static extern unsafe void ProgramUniform1(UInt32 program, Int32 location, Int32 count, Single* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform1i")]
        public static extern void ProgramUniform1(Int32 program, Int32 location, Int32 v0);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform1i")]
        public static extern void ProgramUniform1(UInt32 program, Int32 location, Int32 v0);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform1iv")]
        public static extern void ProgramUniform1(Int32 program, Int32 location, Int32 count, ref Int32 value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform1iv")]
        public static extern unsafe void ProgramUniform1(Int32 program, Int32 location, Int32 count, Int32* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform1iv")]
        public static extern void ProgramUniform1(UInt32 program, Int32 location, Int32 count, ref Int32 value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform1iv")]
        public static extern unsafe void ProgramUniform1(UInt32 program, Int32 location, Int32 count, Int32* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform1ui")]
        public static extern void ProgramUniform1(UInt32 program, Int32 location, UInt32 v0);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform1uiv")]
        public static extern void ProgramUniform1(UInt32 program, Int32 location, Int32 count, ref UInt32 value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform1uiv")]
        public static extern unsafe void ProgramUniform1(UInt32 program, Int32 location, Int32 count, UInt32* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform2d")]
        public static extern void ProgramUniform2(Int32 program, Int32 location, Double v0, Double v1);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform2d")]
        public static extern void ProgramUniform2(UInt32 program, Int32 location, Double v0, Double v1);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform2dv")]
        public static extern void ProgramUniform2(Int32 program, Int32 location, Int32 count, Double[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform2dv")]
        public static extern void ProgramUniform2(Int32 program, Int32 location, Int32 count, ref Double value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform2dv")]
        public static extern unsafe void ProgramUniform2(Int32 program, Int32 location, Int32 count, Double* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform2dv")]
        public static extern void ProgramUniform2(UInt32 program, Int32 location, Int32 count, Double[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform2dv")]
        public static extern void ProgramUniform2(UInt32 program, Int32 location, Int32 count, ref Double value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform2dv")]
        public static extern unsafe void ProgramUniform2(UInt32 program, Int32 location, Int32 count, Double* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform2f")]
        public static extern void ProgramUniform2(Int32 program, Int32 location, Single v0, Single v1);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform2f")]
        public static extern void ProgramUniform2(UInt32 program, Int32 location, Single v0, Single v1);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform2fv")]
        public static extern void ProgramUniform2(Int32 program, Int32 location, Int32 count, Single[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform2fv")]
        public static extern void ProgramUniform2(Int32 program, Int32 location, Int32 count, ref Single value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform2fv")]
        public static extern unsafe void ProgramUniform2(Int32 program, Int32 location, Int32 count, Single* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform2fv")]
        public static extern void ProgramUniform2(UInt32 program, Int32 location, Int32 count, Single[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform2fv")]
        public static extern void ProgramUniform2(UInt32 program, Int32 location, Int32 count, ref Single value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform2fv")]
        public static extern unsafe void ProgramUniform2(UInt32 program, Int32 location, Int32 count, Single* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform2i")]
        public static extern void ProgramUniform2(Int32 program, Int32 location, Int32 v0, Int32 v1);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform2i")]
        public static extern void ProgramUniform2(UInt32 program, Int32 location, Int32 v0, Int32 v1);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform2iv")]
        public static extern void ProgramUniform2(Int32 program, Int32 location, Int32 count, Int32[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform2iv")]
        public static extern unsafe void ProgramUniform2(Int32 program, Int32 location, Int32 count, Int32* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform2iv")]
        public static extern void ProgramUniform2(UInt32 program, Int32 location, Int32 count, Int32[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform2iv")]
        public static extern unsafe void ProgramUniform2(UInt32 program, Int32 location, Int32 count, Int32* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform2ui")]
        public static extern void ProgramUniform2(UInt32 program, Int32 location, UInt32 v0, UInt32 v1);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform2uiv")]
        public static extern void ProgramUniform2(UInt32 program, Int32 location, Int32 count, UInt32[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform2uiv")]
        public static extern void ProgramUniform2(UInt32 program, Int32 location, Int32 count, ref UInt32 value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform2uiv")]
        public static extern unsafe void ProgramUniform2(UInt32 program, Int32 location, Int32 count, UInt32* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform3d")]
        public static extern void ProgramUniform3(Int32 program, Int32 location, Double v0, Double v1, Double v2);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform3d")]
        public static extern void ProgramUniform3(UInt32 program, Int32 location, Double v0, Double v1, Double v2);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform3dv")]
        public static extern void ProgramUniform3(Int32 program, Int32 location, Int32 count, Double[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform3dv")]
        public static extern void ProgramUniform3(Int32 program, Int32 location, Int32 count, ref Double value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform3dv")]
        public static extern unsafe void ProgramUniform3(Int32 program, Int32 location, Int32 count, Double* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform3dv")]
        public static extern void ProgramUniform3(UInt32 program, Int32 location, Int32 count, Double[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform3dv")]
        public static extern void ProgramUniform3(UInt32 program, Int32 location, Int32 count, ref Double value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform3dv")]
        public static extern unsafe void ProgramUniform3(UInt32 program, Int32 location, Int32 count, Double* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform3f")]
        public static extern void ProgramUniform3(Int32 program, Int32 location, Single v0, Single v1, Single v2);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform3f")]
        public static extern void ProgramUniform3(UInt32 program, Int32 location, Single v0, Single v1, Single v2);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform3fv")]
        public static extern void ProgramUniform3(Int32 program, Int32 location, Int32 count, Single[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform3fv")]
        public static extern void ProgramUniform3(Int32 program, Int32 location, Int32 count, ref Single value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform3fv")]
        public static extern unsafe void ProgramUniform3(Int32 program, Int32 location, Int32 count, Single* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform3fv")]
        public static extern void ProgramUniform3(UInt32 program, Int32 location, Int32 count, Single[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform3fv")]
        public static extern void ProgramUniform3(UInt32 program, Int32 location, Int32 count, ref Single value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform3fv")]
        public static extern unsafe void ProgramUniform3(UInt32 program, Int32 location, Int32 count, Single* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform3i")]
        public static extern void ProgramUniform3(Int32 program, Int32 location, Int32 v0, Int32 v1, Int32 v2);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform3i")]
        public static extern void ProgramUniform3(UInt32 program, Int32 location, Int32 v0, Int32 v1, Int32 v2);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform3iv")]
        public static extern void ProgramUniform3(Int32 program, Int32 location, Int32 count, Int32[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform3iv")]
        public static extern void ProgramUniform3(Int32 program, Int32 location, Int32 count, ref Int32 value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform3iv")]
        public static extern unsafe void ProgramUniform3(Int32 program, Int32 location, Int32 count, Int32* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform3iv")]
        public static extern void ProgramUniform3(UInt32 program, Int32 location, Int32 count, Int32[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform3iv")]
        public static extern void ProgramUniform3(UInt32 program, Int32 location, Int32 count, ref Int32 value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform3iv")]
        public static extern unsafe void ProgramUniform3(UInt32 program, Int32 location, Int32 count, Int32* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform3ui")]
        public static extern void ProgramUniform3(UInt32 program, Int32 location, UInt32 v0, UInt32 v1, UInt32 v2);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform3uiv")]
        public static extern void ProgramUniform3(UInt32 program, Int32 location, Int32 count, UInt32[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform3uiv")]
        public static extern void ProgramUniform3(UInt32 program, Int32 location, Int32 count, ref UInt32 value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform3uiv")]
        public static extern unsafe void ProgramUniform3(UInt32 program, Int32 location, Int32 count, UInt32* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform4d")]
        public static extern void ProgramUniform4(Int32 program, Int32 location, Double v0, Double v1, Double v2, Double v3);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform4d")]
        public static extern void ProgramUniform4(UInt32 program, Int32 location, Double v0, Double v1, Double v2, Double v3);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform4dv")]
        public static extern void ProgramUniform4(Int32 program, Int32 location, Int32 count, Double[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform4dv")]
        public static extern void ProgramUniform4(Int32 program, Int32 location, Int32 count, ref Double value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform4dv")]
        public static extern unsafe void ProgramUniform4(Int32 program, Int32 location, Int32 count, Double* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform4dv")]
        public static extern void ProgramUniform4(UInt32 program, Int32 location, Int32 count, Double[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform4dv")]
        public static extern void ProgramUniform4(UInt32 program, Int32 location, Int32 count, ref Double value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform4dv")]
        public static extern unsafe void ProgramUniform4(UInt32 program, Int32 location, Int32 count, Double* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform4f")]
        public static extern void ProgramUniform4(Int32 program, Int32 location, Single v0, Single v1, Single v2, Single v3);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform4f")]
        public static extern void ProgramUniform4(UInt32 program, Int32 location, Single v0, Single v1, Single v2, Single v3);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform4fv")]
        public static extern void ProgramUniform4(Int32 program, Int32 location, Int32 count, Single[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform4fv")]
        public static extern void ProgramUniform4(Int32 program, Int32 location, Int32 count, ref Single value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform4fv")]
        public static extern unsafe void ProgramUniform4(Int32 program, Int32 location, Int32 count, Single* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform4fv")]
        public static extern void ProgramUniform4(UInt32 program, Int32 location, Int32 count, Single[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform4fv")]
        public static extern void ProgramUniform4(UInt32 program, Int32 location, Int32 count, ref Single value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform4fv")]
        public static extern unsafe void ProgramUniform4(UInt32 program, Int32 location, Int32 count, Single* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform4i")]
        public static extern void ProgramUniform4(Int32 program, Int32 location, Int32 v0, Int32 v1, Int32 v2, Int32 v3);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform4i")]
        public static extern void ProgramUniform4(UInt32 program, Int32 location, Int32 v0, Int32 v1, Int32 v2, Int32 v3);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform4iv")]
        public static extern void ProgramUniform4(Int32 program, Int32 location, Int32 count, Int32[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform4iv")]
        public static extern void ProgramUniform4(Int32 program, Int32 location, Int32 count, ref Int32 value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform4iv")]
        public static extern unsafe void ProgramUniform4(Int32 program, Int32 location, Int32 count, Int32* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform4iv")]
        public static extern void ProgramUniform4(UInt32 program, Int32 location, Int32 count, Int32[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform4iv")]
        public static extern void ProgramUniform4(UInt32 program, Int32 location, Int32 count, ref Int32 value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform4iv")]
        public static extern unsafe void ProgramUniform4(UInt32 program, Int32 location, Int32 count, Int32* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform4ui")]
        public static extern void ProgramUniform4(UInt32 program, Int32 location, UInt32 v0, UInt32 v1, UInt32 v2, UInt32 v3);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform4uiv")]
        public static extern void ProgramUniform4(UInt32 program, Int32 location, Int32 count, UInt32[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform4uiv")]
        public static extern void ProgramUniform4(UInt32 program, Int32 location, Int32 count, ref UInt32 value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Specify the value of a uniform variable for a specified program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program containing the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniform4uiv")]
        public static extern unsafe void ProgramUniform4(UInt32 program, Int32 location, Int32 count, UInt32* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2dv")]
        public static extern void ProgramUniformMatrix2(Int32 program, Int32 location, Int32 count, bool transpose, Double[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2dv")]
        public static extern void ProgramUniformMatrix2(Int32 program, Int32 location, Int32 count, bool transpose, ref Double value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2dv")]
        public static extern unsafe void ProgramUniformMatrix2(Int32 program, Int32 location, Int32 count, bool transpose, Double* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2dv")]
        public static extern void ProgramUniformMatrix2(UInt32 program, Int32 location, Int32 count, bool transpose, Double[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2dv")]
        public static extern void ProgramUniformMatrix2(UInt32 program, Int32 location, Int32 count, bool transpose, ref Double value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2dv")]
        public static extern unsafe void ProgramUniformMatrix2(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2fv")]
        public static extern void ProgramUniformMatrix2(Int32 program, Int32 location, Int32 count, bool transpose, Single[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2fv")]
        public static extern void ProgramUniformMatrix2(Int32 program, Int32 location, Int32 count, bool transpose, ref Single value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2fv")]
        public static extern unsafe void ProgramUniformMatrix2(Int32 program, Int32 location, Int32 count, bool transpose, Single* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2fv")]
        public static extern void ProgramUniformMatrix2(UInt32 program, Int32 location, Int32 count, bool transpose, Single[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2fv")]
        public static extern void ProgramUniformMatrix2(UInt32 program, Int32 location, Int32 count, bool transpose, ref Single value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2fv")]
        public static extern unsafe void ProgramUniformMatrix2(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2x3dv")]
        public static extern void ProgramUniformMatrix2x3(Int32 program, Int32 location, Int32 count, bool transpose, Double[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2x3dv")]
        public static extern void ProgramUniformMatrix2x3(Int32 program, Int32 location, Int32 count, bool transpose, ref Double value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2x3dv")]
        public static extern unsafe void ProgramUniformMatrix2x3(Int32 program, Int32 location, Int32 count, bool transpose, Double* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2x3dv")]
        public static extern void ProgramUniformMatrix2x3(UInt32 program, Int32 location, Int32 count, bool transpose, Double[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2x3dv")]
        public static extern void ProgramUniformMatrix2x3(UInt32 program, Int32 location, Int32 count, bool transpose, ref Double value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2x3dv")]
        public static extern unsafe void ProgramUniformMatrix2x3(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2x3fv")]
        public static extern void ProgramUniformMatrix2x3(Int32 program, Int32 location, Int32 count, bool transpose, Single[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2x3fv")]
        public static extern void ProgramUniformMatrix2x3(Int32 program, Int32 location, Int32 count, bool transpose, ref Single value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2x3fv")]
        public static extern unsafe void ProgramUniformMatrix2x3(Int32 program, Int32 location, Int32 count, bool transpose, Single* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2x3fv")]
        public static extern void ProgramUniformMatrix2x3(UInt32 program, Int32 location, Int32 count, bool transpose, Single[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2x3fv")]
        public static extern void ProgramUniformMatrix2x3(UInt32 program, Int32 location, Int32 count, bool transpose, ref Single value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2x3fv")]
        public static extern unsafe void ProgramUniformMatrix2x3(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2x4dv")]
        public static extern void ProgramUniformMatrix2x4(Int32 program, Int32 location, Int32 count, bool transpose, Double[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2x4dv")]
        public static extern void ProgramUniformMatrix2x4(Int32 program, Int32 location, Int32 count, bool transpose, ref Double value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2x4dv")]
        public static extern unsafe void ProgramUniformMatrix2x4(Int32 program, Int32 location, Int32 count, bool transpose, Double* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2x4dv")]
        public static extern void ProgramUniformMatrix2x4(UInt32 program, Int32 location, Int32 count, bool transpose, Double[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2x4dv")]
        public static extern void ProgramUniformMatrix2x4(UInt32 program, Int32 location, Int32 count, bool transpose, ref Double value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2x4dv")]
        public static extern unsafe void ProgramUniformMatrix2x4(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2x4fv")]
        public static extern void ProgramUniformMatrix2x4(Int32 program, Int32 location, Int32 count, bool transpose, Single[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2x4fv")]
        public static extern void ProgramUniformMatrix2x4(Int32 program, Int32 location, Int32 count, bool transpose, ref Single value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2x4fv")]
        public static extern unsafe void ProgramUniformMatrix2x4(Int32 program, Int32 location, Int32 count, bool transpose, Single* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2x4fv")]
        public static extern void ProgramUniformMatrix2x4(UInt32 program, Int32 location, Int32 count, bool transpose, Single[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2x4fv")]
        public static extern void ProgramUniformMatrix2x4(UInt32 program, Int32 location, Int32 count, bool transpose, ref Single value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix2x4fv")]
        public static extern unsafe void ProgramUniformMatrix2x4(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3dv")]
        public static extern void ProgramUniformMatrix3(Int32 program, Int32 location, Int32 count, bool transpose, Double[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3dv")]
        public static extern void ProgramUniformMatrix3(Int32 program, Int32 location, Int32 count, bool transpose, ref Double value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3dv")]
        public static extern unsafe void ProgramUniformMatrix3(Int32 program, Int32 location, Int32 count, bool transpose, Double* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3dv")]
        public static extern void ProgramUniformMatrix3(UInt32 program, Int32 location, Int32 count, bool transpose, Double[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3dv")]
        public static extern void ProgramUniformMatrix3(UInt32 program, Int32 location, Int32 count, bool transpose, ref Double value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3dv")]
        public static extern unsafe void ProgramUniformMatrix3(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3fv")]
        public static extern void ProgramUniformMatrix3(Int32 program, Int32 location, Int32 count, bool transpose, Single[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3fv")]
        public static extern void ProgramUniformMatrix3(Int32 program, Int32 location, Int32 count, bool transpose, ref Single value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3fv")]
        public static extern unsafe void ProgramUniformMatrix3(Int32 program, Int32 location, Int32 count, bool transpose, Single* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3fv")]
        public static extern void ProgramUniformMatrix3(UInt32 program, Int32 location, Int32 count, bool transpose, Single[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3fv")]
        public static extern void ProgramUniformMatrix3(UInt32 program, Int32 location, Int32 count, bool transpose, ref Single value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3fv")]
        public static extern unsafe void ProgramUniformMatrix3(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3x2dv")]
        public static extern void ProgramUniformMatrix3x2(Int32 program, Int32 location, Int32 count, bool transpose, Double[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3x2dv")]
        public static extern void ProgramUniformMatrix3x2(Int32 program, Int32 location, Int32 count, bool transpose, ref Double value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3x2dv")]
        public static extern unsafe void ProgramUniformMatrix3x2(Int32 program, Int32 location, Int32 count, bool transpose, Double* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3x2dv")]
        public static extern void ProgramUniformMatrix3x2(UInt32 program, Int32 location, Int32 count, bool transpose, Double[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3x2dv")]
        public static extern void ProgramUniformMatrix3x2(UInt32 program, Int32 location, Int32 count, bool transpose, ref Double value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3x2dv")]
        public static extern unsafe void ProgramUniformMatrix3x2(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3x2fv")]
        public static extern void ProgramUniformMatrix3x2(Int32 program, Int32 location, Int32 count, bool transpose, Single[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3x2fv")]
        public static extern void ProgramUniformMatrix3x2(Int32 program, Int32 location, Int32 count, bool transpose, ref Single value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3x2fv")]
        public static extern unsafe void ProgramUniformMatrix3x2(Int32 program, Int32 location, Int32 count, bool transpose, Single* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3x2fv")]
        public static extern void ProgramUniformMatrix3x2(UInt32 program, Int32 location, Int32 count, bool transpose, Single[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3x2fv")]
        public static extern void ProgramUniformMatrix3x2(UInt32 program, Int32 location, Int32 count, bool transpose, ref Single value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3x2fv")]
        public static extern unsafe void ProgramUniformMatrix3x2(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3x4dv")]
        public static extern void ProgramUniformMatrix3x4(Int32 program, Int32 location, Int32 count, bool transpose, Double[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3x4dv")]
        public static extern void ProgramUniformMatrix3x4(Int32 program, Int32 location, Int32 count, bool transpose, ref Double value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3x4dv")]
        public static extern unsafe void ProgramUniformMatrix3x4(Int32 program, Int32 location, Int32 count, bool transpose, Double* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3x4dv")]
        public static extern void ProgramUniformMatrix3x4(UInt32 program, Int32 location, Int32 count, bool transpose, Double[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3x4dv")]
        public static extern void ProgramUniformMatrix3x4(UInt32 program, Int32 location, Int32 count, bool transpose, ref Double value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3x4dv")]
        public static extern unsafe void ProgramUniformMatrix3x4(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3x4fv")]
        public static extern void ProgramUniformMatrix3x4(Int32 program, Int32 location, Int32 count, bool transpose, Single[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3x4fv")]
        public static extern void ProgramUniformMatrix3x4(Int32 program, Int32 location, Int32 count, bool transpose, ref Single value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3x4fv")]
        public static extern unsafe void ProgramUniformMatrix3x4(Int32 program, Int32 location, Int32 count, bool transpose, Single* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3x4fv")]
        public static extern void ProgramUniformMatrix3x4(UInt32 program, Int32 location, Int32 count, bool transpose, Single[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3x4fv")]
        public static extern void ProgramUniformMatrix3x4(UInt32 program, Int32 location, Int32 count, bool transpose, ref Single value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix3x4fv")]
        public static extern unsafe void ProgramUniformMatrix3x4(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4dv")]
        public static extern void ProgramUniformMatrix4(Int32 program, Int32 location, Int32 count, bool transpose, Double[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4dv")]
        public static extern void ProgramUniformMatrix4(Int32 program, Int32 location, Int32 count, bool transpose, ref Double value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4dv")]
        public static extern unsafe void ProgramUniformMatrix4(Int32 program, Int32 location, Int32 count, bool transpose, Double* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4dv")]
        public static extern void ProgramUniformMatrix4(UInt32 program, Int32 location, Int32 count, bool transpose, Double[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4dv")]
        public static extern void ProgramUniformMatrix4(UInt32 program, Int32 location, Int32 count, bool transpose, ref Double value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4dv")]
        public static extern unsafe void ProgramUniformMatrix4(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4fv")]
        public static extern void ProgramUniformMatrix4(Int32 program, Int32 location, Int32 count, bool transpose, Single[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4fv")]
        public static extern void ProgramUniformMatrix4(Int32 program, Int32 location, Int32 count, bool transpose, ref Single value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4fv")]
        public static extern unsafe void ProgramUniformMatrix4(Int32 program, Int32 location, Int32 count, bool transpose, Single* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4fv")]
        public static extern void ProgramUniformMatrix4(UInt32 program, Int32 location, Int32 count, bool transpose, Single[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4fv")]
        public static extern void ProgramUniformMatrix4(UInt32 program, Int32 location, Int32 count, bool transpose, ref Single value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4fv")]
        public static extern unsafe void ProgramUniformMatrix4(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4x2dv")]
        public static extern void ProgramUniformMatrix4x2(Int32 program, Int32 location, Int32 count, bool transpose, Double[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4x2dv")]
        public static extern void ProgramUniformMatrix4x2(Int32 program, Int32 location, Int32 count, bool transpose, ref Double value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4x2dv")]
        public static extern unsafe void ProgramUniformMatrix4x2(Int32 program, Int32 location, Int32 count, bool transpose, Double* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4x2dv")]
        public static extern void ProgramUniformMatrix4x2(UInt32 program, Int32 location, Int32 count, bool transpose, Double[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4x2dv")]
        public static extern void ProgramUniformMatrix4x2(UInt32 program, Int32 location, Int32 count, bool transpose, ref Double value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4x2dv")]
        public static extern unsafe void ProgramUniformMatrix4x2(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4x2fv")]
        public static extern void ProgramUniformMatrix4x2(Int32 program, Int32 location, Int32 count, bool transpose, Single[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4x2fv")]
        public static extern void ProgramUniformMatrix4x2(Int32 program, Int32 location, Int32 count, bool transpose, ref Single value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4x2fv")]
        public static extern unsafe void ProgramUniformMatrix4x2(Int32 program, Int32 location, Int32 count, bool transpose, Single* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4x2fv")]
        public static extern void ProgramUniformMatrix4x2(UInt32 program, Int32 location, Int32 count, bool transpose, Single[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4x2fv")]
        public static extern void ProgramUniformMatrix4x2(UInt32 program, Int32 location, Int32 count, bool transpose, ref Single value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4x2fv")]
        public static extern unsafe void ProgramUniformMatrix4x2(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4x3dv")]
        public static extern void ProgramUniformMatrix4x3(Int32 program, Int32 location, Int32 count, bool transpose, Double[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4x3dv")]
        public static extern void ProgramUniformMatrix4x3(Int32 program, Int32 location, Int32 count, bool transpose, ref Double value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4x3dv")]
        public static extern unsafe void ProgramUniformMatrix4x3(Int32 program, Int32 location, Int32 count, bool transpose, Double* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4x3dv")]
        public static extern void ProgramUniformMatrix4x3(UInt32 program, Int32 location, Int32 count, bool transpose, Double[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4x3dv")]
        public static extern void ProgramUniformMatrix4x3(UInt32 program, Int32 location, Int32 count, bool transpose, ref Double value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4x3dv")]
        public static extern unsafe void ProgramUniformMatrix4x3(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4x3fv")]
        public static extern void ProgramUniformMatrix4x3(Int32 program, Int32 location, Int32 count, bool transpose, Single[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4x3fv")]
        public static extern void ProgramUniformMatrix4x3(Int32 program, Int32 location, Int32 count, bool transpose, ref Single value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4x3fv")]
        public static extern unsafe void ProgramUniformMatrix4x3(Int32 program, Int32 location, Int32 count, bool transpose, Single* value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4x3fv")]
        public static extern void ProgramUniformMatrix4x3(UInt32 program, Int32 location, Int32 count, bool transpose, Single[] value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4x3fv")]
        public static extern void ProgramUniformMatrix4x3(UInt32 program, Int32 location, Int32 count, bool transpose, ref Single value);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glProgramUniformMatrix4x3fv")]
        public static extern unsafe void ProgramUniformMatrix4x3(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);

        /// <summary>[requires: v3.2 and ARB_provoking_vertex|VERSION_3_2]
        /// Specifiy the vertex to be used as the source of data for flat shaded varyings
        /// </summary>
        /// <param name="provokeMode">
        /// <para>
        /// Specifies the vertex to be used as the source of data for flat shaded varyings.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_provoking_vertex|VERSION_3_2", Version = "3.2", EntryPoint = "glProvokingVertex")]
        public static extern void ProvokingVertex(OpenTK.Graphics.OpenGL.ProvokingVertexMode mode);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Push and pop the server attribute stack
        /// </summary>
        /// <param name="mask">
        /// <para>
        /// Specifies a mask that indicates which attributes to save. Values for mask are listed below.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glPushAttrib")]
        public static extern void PushAttrib(OpenTK.Graphics.OpenGL.AttribMask mask);

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Push and pop the client attribute stack
        /// </summary>
        /// <param name="mask">
        /// <para>
        /// Specifies a mask that indicates which attributes to save. Values for mask are listed below.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glPushClientAttrib")]
        public static extern void PushClientAttrib(OpenTK.Graphics.OpenGL.ClientAttribMask mask);

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Push a named debug group into the command stream
        /// </summary>
        /// <param name="source">
        /// <para>
        /// The source of the debug message.
        /// </para>
        /// </param>
        /// <param name="id">
        /// <para>
        /// The identifier of the message.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The length of the message to be sent to the debug output stream.
        /// </para>
        /// </param>
        /// <param name="message">
        /// <para>
        /// The a string containing the message to be sent to the debug output stream.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glPushDebugGroup")]
        public static extern void PushDebugGroup(OpenTK.Graphics.OpenGL.DebugSourceExternal source, Int32 id, Int32 length, String message);

        /// <summary>[requires: v4.3 and KHR_debug|VERSION_4_3]
        /// Push a named debug group into the command stream
        /// </summary>
        /// <param name="source">
        /// <para>
        /// The source of the debug message.
        /// </para>
        /// </param>
        /// <param name="id">
        /// <para>
        /// The identifier of the message.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// The length of the message to be sent to the debug output stream.
        /// </para>
        /// </param>
        /// <param name="message">
        /// <para>
        /// The a string containing the message to be sent to the debug output stream.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "KHR_debug|VERSION_4_3", Version = "4.3", EntryPoint = "glPushDebugGroup")]
        public static extern void PushDebugGroup(OpenTK.Graphics.OpenGL.DebugSourceExternal source, UInt32 id, Int32 length, String message);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Push and pop the current matrix stack
        /// </summary>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glPushMatrix")]
        public static extern void PushMatrix();

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Push and pop the name stack
        /// </summary>
        /// <param name="name">
        /// <para>
        /// Specifies a name that will be pushed onto the name stack.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glPushName")]
        public static extern void PushName(Int32 name);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Push and pop the name stack
        /// </summary>
        /// <param name="name">
        /// <para>
        /// Specifies a name that will be pushed onto the name stack.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glPushName")]
        public static extern void PushName(UInt32 name);

        /// <summary>[requires: v3.3 and ARB_timer_query|VERSION_3_3]
        /// Record the GL time into a query object after all previous commands have reached the GL server but have not yet necessarily executed.
        /// </summary>
        /// <param name="id">
        /// <para>
        /// Specify the name of a query object into which to record the GL time.
        /// </para>
        /// </param>
        /// <param name="target">
        /// <para>
        /// Specify the counter to query. target must be GL_TIMESTAMP.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_timer_query|VERSION_3_3", Version = "3.3", EntryPoint = "glQueryCounter")]
        public static extern void QueryCounter(Int32 id, OpenTK.Graphics.OpenGL.QueryCounterTarget target);

        /// <summary>[requires: v3.3 and ARB_timer_query|VERSION_3_3]
        /// Record the GL time into a query object after all previous commands have reached the GL server but have not yet necessarily executed.
        /// </summary>
        /// <param name="id">
        /// <para>
        /// Specify the name of a query object into which to record the GL time.
        /// </para>
        /// </param>
        /// <param name="target">
        /// <para>
        /// Specify the counter to query. target must be GL_TIMESTAMP.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_timer_query|VERSION_3_3", Version = "3.3", EntryPoint = "glQueryCounter")]
        public static extern void QueryCounter(UInt32 id, OpenTK.Graphics.OpenGL.QueryCounterTarget target);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos2d")]
        public static extern void RasterPos2(Double x, Double y);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos2dv")]
        public static extern void RasterPos2(Double[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos2dv")]
        public static extern void RasterPos2(ref Double v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos2dv")]
        public static extern unsafe void RasterPos2(Double* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos2f")]
        public static extern void RasterPos2(Single x, Single y);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos2fv")]
        public static extern void RasterPos2(Single[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos2fv")]
        public static extern void RasterPos2(ref Single v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos2fv")]
        public static extern unsafe void RasterPos2(Single* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos2i")]
        public static extern void RasterPos2(Int32 x, Int32 y);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos2iv")]
        public static extern void RasterPos2(Int32[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos2iv")]
        public static extern void RasterPos2(ref Int32 v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos2iv")]
        public static extern unsafe void RasterPos2(Int32* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos2s")]
        public static extern void RasterPos2(Int16 x, Int16 y);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos2sv")]
        public static extern void RasterPos2(Int16[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos2sv")]
        public static extern void RasterPos2(ref Int16 v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos2sv")]
        public static extern unsafe void RasterPos2(Int16* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos3d")]
        public static extern void RasterPos3(Double x, Double y, Double z);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos3dv")]
        public static extern void RasterPos3(Double[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos3dv")]
        public static extern void RasterPos3(ref Double v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos3dv")]
        public static extern unsafe void RasterPos3(Double* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos3f")]
        public static extern void RasterPos3(Single x, Single y, Single z);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos3fv")]
        public static extern void RasterPos3(Single[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos3fv")]
        public static extern void RasterPos3(ref Single v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos3fv")]
        public static extern unsafe void RasterPos3(Single* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos3i")]
        public static extern void RasterPos3(Int32 x, Int32 y, Int32 z);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos3iv")]
        public static extern void RasterPos3(Int32[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos3iv")]
        public static extern void RasterPos3(ref Int32 v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos3iv")]
        public static extern unsafe void RasterPos3(Int32* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos3s")]
        public static extern void RasterPos3(Int16 x, Int16 y, Int16 z);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos3sv")]
        public static extern void RasterPos3(Int16[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos3sv")]
        public static extern void RasterPos3(ref Int16 v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos3sv")]
        public static extern unsafe void RasterPos3(Int16* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos4d")]
        public static extern void RasterPos4(Double x, Double y, Double z, Double w);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos4dv")]
        public static extern void RasterPos4(Double[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos4dv")]
        public static extern void RasterPos4(ref Double v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos4dv")]
        public static extern unsafe void RasterPos4(Double* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos4f")]
        public static extern void RasterPos4(Single x, Single y, Single z, Single w);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos4fv")]
        public static extern void RasterPos4(Single[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos4fv")]
        public static extern void RasterPos4(ref Single v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos4fv")]
        public static extern unsafe void RasterPos4(Single* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos4i")]
        public static extern void RasterPos4(Int32 x, Int32 y, Int32 z, Int32 w);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos4iv")]
        public static extern void RasterPos4(Int32[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos4iv")]
        public static extern void RasterPos4(ref Int32 v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos4iv")]
        public static extern unsafe void RasterPos4(Int32* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos4s")]
        public static extern void RasterPos4(Int16 x, Int16 y, Int16 z, Int16 w);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos4sv")]
        public static extern void RasterPos4(Int16[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos4sv")]
        public static extern void RasterPos4(ref Int16 v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify the raster position for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , , and object coordinates (if present) for the raster position.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRasterPos4sv")]
        public static extern unsafe void RasterPos4(Int16* v);

        /// <summary>[requires: v1.0]
        /// Select a color buffer source for pixels
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies a color buffer. Accepted values are GL_FRONT_LEFT, GL_FRONT_RIGHT, GL_BACK_LEFT, GL_BACK_RIGHT, GL_FRONT, GL_BACK, GL_LEFT, GL_RIGHT, and the constants GL_COLOR_ATTACHMENTi.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glReadBuffer")]
        public static extern void ReadBuffer(OpenTK.Graphics.OpenGL.ReadBufferMode mode);

        /// <summary>[requires: v1.0]
        /// Read a block of pixels from the frame buffer
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the window coordinates of the first pixel that is read from the frame buffer. This location is the lower left corner of a rectangular block of pixels.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specify the dimensions of the pixel rectangle. width and height of one correspond to a single pixel.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_DEPTH_STENCIL, GL_RED, GL_GREEN, GL_BLUE, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of the pixel data. Must be one of GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_HALF_FLOAT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, GL_UNSIGNED_INT_2_10_10_10_REV, GL_UNSIGNED_INT_24_8, GL_UNSIGNED_INT_10F_11F_11F_REV, GL_UNSIGNED_INT_5_9_9_9_REV, or GL_FLOAT_32_UNSIGNED_INT_24_8_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Returns the pixel data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glReadPixels")]
        public static extern void ReadPixels(Int32 x, Int32 y, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [OutAttribute] IntPtr pixels);

        /// <summary>[requires: v1.0]
        /// Read a block of pixels from the frame buffer
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the window coordinates of the first pixel that is read from the frame buffer. This location is the lower left corner of a rectangular block of pixels.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specify the dimensions of the pixel rectangle. width and height of one correspond to a single pixel.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_DEPTH_STENCIL, GL_RED, GL_GREEN, GL_BLUE, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of the pixel data. Must be one of GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_HALF_FLOAT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, GL_UNSIGNED_INT_2_10_10_10_REV, GL_UNSIGNED_INT_24_8, GL_UNSIGNED_INT_10F_11F_11F_REV, GL_UNSIGNED_INT_5_9_9_9_REV, or GL_FLOAT_32_UNSIGNED_INT_24_8_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Returns the pixel data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glReadPixels")]
        public static extern void ReadPixels<T6>(Int32 x, Int32 y, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T6[] pixels)
            where T6 : struct
        ;

        /// <summary>[requires: v1.0]
        /// Read a block of pixels from the frame buffer
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the window coordinates of the first pixel that is read from the frame buffer. This location is the lower left corner of a rectangular block of pixels.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specify the dimensions of the pixel rectangle. width and height of one correspond to a single pixel.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_DEPTH_STENCIL, GL_RED, GL_GREEN, GL_BLUE, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of the pixel data. Must be one of GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_HALF_FLOAT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, GL_UNSIGNED_INT_2_10_10_10_REV, GL_UNSIGNED_INT_24_8, GL_UNSIGNED_INT_10F_11F_11F_REV, GL_UNSIGNED_INT_5_9_9_9_REV, or GL_FLOAT_32_UNSIGNED_INT_24_8_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Returns the pixel data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glReadPixels")]
        public static extern void ReadPixels<T6>(Int32 x, Int32 y, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T6[,] pixels)
            where T6 : struct
        ;

        /// <summary>[requires: v1.0]
        /// Read a block of pixels from the frame buffer
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the window coordinates of the first pixel that is read from the frame buffer. This location is the lower left corner of a rectangular block of pixels.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specify the dimensions of the pixel rectangle. width and height of one correspond to a single pixel.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_DEPTH_STENCIL, GL_RED, GL_GREEN, GL_BLUE, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of the pixel data. Must be one of GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_HALF_FLOAT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, GL_UNSIGNED_INT_2_10_10_10_REV, GL_UNSIGNED_INT_24_8, GL_UNSIGNED_INT_10F_11F_11F_REV, GL_UNSIGNED_INT_5_9_9_9_REV, or GL_FLOAT_32_UNSIGNED_INT_24_8_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Returns the pixel data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glReadPixels")]
        public static extern void ReadPixels<T6>(Int32 x, Int32 y, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T6[,,] pixels)
            where T6 : struct
        ;

        /// <summary>[requires: v1.0]
        /// Read a block of pixels from the frame buffer
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the window coordinates of the first pixel that is read from the frame buffer. This location is the lower left corner of a rectangular block of pixels.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specify the dimensions of the pixel rectangle. width and height of one correspond to a single pixel.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_DEPTH_STENCIL, GL_RED, GL_GREEN, GL_BLUE, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of the pixel data. Must be one of GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_HALF_FLOAT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, GL_UNSIGNED_INT_2_10_10_10_REV, GL_UNSIGNED_INT_24_8, GL_UNSIGNED_INT_10F_11F_11F_REV, GL_UNSIGNED_INT_5_9_9_9_REV, or GL_FLOAT_32_UNSIGNED_INT_24_8_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Returns the pixel data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glReadPixels")]
        public static extern void ReadPixels<T6>(Int32 x, Int32 y, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T6 pixels)
            where T6 : struct
        ;

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Draw a rectangle
        /// </summary>
        /// <param name="x1">
        /// <para>
        /// Specify one vertex of a rectangle.
        /// </para>
        /// </param>
        /// <param name="x2">
        /// <para>
        /// Specify the opposite vertex of the rectangle.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRectd")]
        public static extern void Rect(Double x1, Double y1, Double x2, Double y2);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Draw a rectangle
        /// </summary>
        /// <param name="x1">
        /// <para>
        /// Specify one vertex of a rectangle.
        /// </para>
        /// </param>
        /// <param name="x2">
        /// <para>
        /// Specify the opposite vertex of the rectangle.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRectdv")]
        public static extern void Rect(Double[] v1, Double[] v2);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Draw a rectangle
        /// </summary>
        /// <param name="x1">
        /// <para>
        /// Specify one vertex of a rectangle.
        /// </para>
        /// </param>
        /// <param name="x2">
        /// <para>
        /// Specify the opposite vertex of the rectangle.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRectdv")]
        public static extern void Rect(ref Double v1, ref Double v2);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Draw a rectangle
        /// </summary>
        /// <param name="x1">
        /// <para>
        /// Specify one vertex of a rectangle.
        /// </para>
        /// </param>
        /// <param name="x2">
        /// <para>
        /// Specify the opposite vertex of the rectangle.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRectdv")]
        public static extern unsafe void Rect(Double* v1, Double* v2);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Draw a rectangle
        /// </summary>
        /// <param name="x1">
        /// <para>
        /// Specify one vertex of a rectangle.
        /// </para>
        /// </param>
        /// <param name="x2">
        /// <para>
        /// Specify the opposite vertex of the rectangle.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRectf")]
        public static extern void Rect(Single x1, Single y1, Single x2, Single y2);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Draw a rectangle
        /// </summary>
        /// <param name="x1">
        /// <para>
        /// Specify one vertex of a rectangle.
        /// </para>
        /// </param>
        /// <param name="x2">
        /// <para>
        /// Specify the opposite vertex of the rectangle.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRectfv")]
        public static extern void Rect(Single[] v1, Single[] v2);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Draw a rectangle
        /// </summary>
        /// <param name="x1">
        /// <para>
        /// Specify one vertex of a rectangle.
        /// </para>
        /// </param>
        /// <param name="x2">
        /// <para>
        /// Specify the opposite vertex of the rectangle.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRectfv")]
        public static extern void Rect(ref Single v1, ref Single v2);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Draw a rectangle
        /// </summary>
        /// <param name="x1">
        /// <para>
        /// Specify one vertex of a rectangle.
        /// </para>
        /// </param>
        /// <param name="x2">
        /// <para>
        /// Specify the opposite vertex of the rectangle.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRectfv")]
        public static extern unsafe void Rect(Single* v1, Single* v2);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Draw a rectangle
        /// </summary>
        /// <param name="x1">
        /// <para>
        /// Specify one vertex of a rectangle.
        /// </para>
        /// </param>
        /// <param name="x2">
        /// <para>
        /// Specify the opposite vertex of the rectangle.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRecti")]
        public static extern void Rect(Int32 x1, Int32 y1, Int32 x2, Int32 y2);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Draw a rectangle
        /// </summary>
        /// <param name="x1">
        /// <para>
        /// Specify one vertex of a rectangle.
        /// </para>
        /// </param>
        /// <param name="x2">
        /// <para>
        /// Specify the opposite vertex of the rectangle.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRectiv")]
        public static extern void Rect(Int32[] v1, Int32[] v2);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Draw a rectangle
        /// </summary>
        /// <param name="x1">
        /// <para>
        /// Specify one vertex of a rectangle.
        /// </para>
        /// </param>
        /// <param name="x2">
        /// <para>
        /// Specify the opposite vertex of the rectangle.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRectiv")]
        public static extern void Rect(ref Int32 v1, ref Int32 v2);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Draw a rectangle
        /// </summary>
        /// <param name="x1">
        /// <para>
        /// Specify one vertex of a rectangle.
        /// </para>
        /// </param>
        /// <param name="x2">
        /// <para>
        /// Specify the opposite vertex of the rectangle.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRectiv")]
        public static extern unsafe void Rect(Int32* v1, Int32* v2);

        /// <summary>[requires: v1.0][deprecated: v3.2]</summary>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRects")]
        public static extern void Rects(Int16 x1, Int16 y1, Int16 x2, Int16 y2);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Draw a rectangle
        /// </summary>
        /// <param name="x1">
        /// <para>
        /// Specify one vertex of a rectangle.
        /// </para>
        /// </param>
        /// <param name="x2">
        /// <para>
        /// Specify the opposite vertex of the rectangle.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRectsv")]
        public static extern void Rect(Int16[] v1, Int16[] v2);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Draw a rectangle
        /// </summary>
        /// <param name="x1">
        /// <para>
        /// Specify one vertex of a rectangle.
        /// </para>
        /// </param>
        /// <param name="x2">
        /// <para>
        /// Specify the opposite vertex of the rectangle.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRectsv")]
        public static extern void Rect(ref Int16 v1, ref Int16 v2);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Draw a rectangle
        /// </summary>
        /// <param name="x1">
        /// <para>
        /// Specify one vertex of a rectangle.
        /// </para>
        /// </param>
        /// <param name="x2">
        /// <para>
        /// Specify the opposite vertex of the rectangle.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRectsv")]
        public static extern unsafe void Rect(Int16* v1, Int16* v2);

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Release resources consumed by the implementation's shader compiler
        /// </summary>
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glReleaseShaderCompiler")]
        public static extern void ReleaseShaderCompiler();

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Establish data storage, format and dimensions of a renderbuffer object's image
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies a binding to which the target of the allocation and must be GL_RENDERBUFFER.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// Specifies the internal format to use for the renderbuffer object's image.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the renderbuffer, in pixels.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the renderbuffer, in pixels.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glRenderbufferStorage")]
        public static extern void RenderbufferStorage(OpenTK.Graphics.OpenGL.RenderbufferTarget target, OpenTK.Graphics.OpenGL.RenderbufferStorage internalformat, Int32 width, Int32 height);

        /// <summary>[requires: v3.0 and ARB_framebuffer_object|VERSION_3_0]
        /// Establish data storage, format, dimensions and sample count of a renderbuffer object's image
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies a binding to which the target of the allocation and must be GL_RENDERBUFFER.
        /// </para>
        /// </param>
        /// <param name="samples">
        /// <para>
        /// Specifies the number of samples to be used for the renderbuffer object's storage.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// Specifies the internal format to use for the renderbuffer object's image.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the renderbuffer, in pixels.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the renderbuffer, in pixels.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_framebuffer_object|VERSION_3_0", Version = "3.0", EntryPoint = "glRenderbufferStorageMultisample")]
        public static extern void RenderbufferStorageMultisample(OpenTK.Graphics.OpenGL.RenderbufferTarget target, Int32 samples, OpenTK.Graphics.OpenGL.RenderbufferStorage internalformat, Int32 width, Int32 height);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set rasterization mode
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies the rasterization mode. Three values are accepted: GL_RENDER, GL_SELECT, and GL_FEEDBACK. The initial value is GL_RENDER.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRenderMode")]
        public static extern Int32 RenderMode(OpenTK.Graphics.OpenGL.RenderingMode mode);

        /// <summary>
        /// Reset histogram table entries to zero
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_HISTOGRAM.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glResetHistogram")]
        public static extern void ResetHistogram(OpenTK.Graphics.OpenGL.HistogramTarget target);

        /// <summary>
        /// Reset minmax table entries to initial values
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_MINMAX.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glResetMinmax")]
        public static extern void ResetMinmax(OpenTK.Graphics.OpenGL.MinmaxTarget target);

        /// <summary>[requires: v4.0 and ARB_transform_feedback2|VERSION_4_0]
        /// Resume transform feedback operations
        /// </summary>
        [AutoGenerated(Category = "ARB_transform_feedback2|VERSION_4_0", Version = "4.0", EntryPoint = "glResumeTransformFeedback")]
        public static extern void ResumeTransformFeedback();

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Multiply the current matrix by a rotation matrix
        /// </summary>
        /// <param name="angle">
        /// <para>
        /// Specifies the angle of rotation, in degrees.
        /// </para>
        /// </param>
        /// <param name="x">
        /// <para>
        /// Specify the x, y, and z coordinates of a vector, respectively.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRotated")]
        public static extern void Rotate(Double angle, Double x, Double y, Double z);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Multiply the current matrix by a rotation matrix
        /// </summary>
        /// <param name="angle">
        /// <para>
        /// Specifies the angle of rotation, in degrees.
        /// </para>
        /// </param>
        /// <param name="x">
        /// <para>
        /// Specify the x, y, and z coordinates of a vector, respectively.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glRotatef")]
        public static extern void Rotate(Single angle, Single x, Single y, Single z);

        /// <summary>[requires: v1.3]
        /// Specify multisample coverage parameters
        /// </summary>
        /// <param name="value">
        /// <para>
        /// Specify a single floating-point sample coverage value. The value is clamped to the range [0 ,1]. The initial value is 1.0.
        /// </para>
        /// </param>
        /// <param name="invert">
        /// <para>
        /// Specify a single boolean value representing if the coverage masks should be inverted. GL_TRUE and GL_FALSE are accepted. The initial value is GL_FALSE.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_3", Version = "1.3", EntryPoint = "glSampleCoverage")]
        public static extern void SampleCoverage(Single value, bool invert);

        /// <summary>[requires: v3.2 and ARB_texture_multisample|VERSION_3_2]
        /// Set the value of a sub-word of the sample mask
        /// </summary>
        /// <param name="maskNumber">
        /// <para>
        /// Specifies which 32-bit sub-word of the sample mask to update.
        /// </para>
        /// </param>
        /// <param name="mask">
        /// <para>
        /// Specifies the new value of the mask sub-word.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_texture_multisample|VERSION_3_2", Version = "3.2", EntryPoint = "glSampleMaski")]
        public static extern void SampleMask(Int32 index, Int32 mask);

        /// <summary>[requires: v3.2 and ARB_texture_multisample|VERSION_3_2]
        /// Set the value of a sub-word of the sample mask
        /// </summary>
        /// <param name="maskNumber">
        /// <para>
        /// Specifies which 32-bit sub-word of the sample mask to update.
        /// </para>
        /// </param>
        /// <param name="mask">
        /// <para>
        /// Specifies the new value of the mask sub-word.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_texture_multisample|VERSION_3_2", Version = "3.2", EntryPoint = "glSampleMaski")]
        public static extern void SampleMask(UInt32 index, UInt32 mask);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Set sampler parameters
        /// </summary>
        /// <param name="sampler">
        /// <para>
        /// Specifies the sampler object whose parameter to modify.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a sampler parameter. pname can be one of the following: GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, GL_TEXTURE_WRAP_R, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MAG_FILTER, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_LOD_BIAS GL_TEXTURE_COMPARE_MODE, or GL_TEXTURE_COMPARE_FUNC.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// For the scalar commands, specifies the value of pname.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// For the vector commands (glSamplerParameter*v), specifies a pointer to an array where the value or values of pname are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glSamplerParameterf")]
        public static extern void SamplerParameter(Int32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, Single param);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Set sampler parameters
        /// </summary>
        /// <param name="sampler">
        /// <para>
        /// Specifies the sampler object whose parameter to modify.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a sampler parameter. pname can be one of the following: GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, GL_TEXTURE_WRAP_R, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MAG_FILTER, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_LOD_BIAS GL_TEXTURE_COMPARE_MODE, or GL_TEXTURE_COMPARE_FUNC.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// For the scalar commands, specifies the value of pname.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// For the vector commands (glSamplerParameter*v), specifies a pointer to an array where the value or values of pname are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glSamplerParameterf")]
        public static extern void SamplerParameter(UInt32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, Single param);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Set sampler parameters
        /// </summary>
        /// <param name="sampler">
        /// <para>
        /// Specifies the sampler object whose parameter to modify.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a sampler parameter. pname can be one of the following: GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, GL_TEXTURE_WRAP_R, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MAG_FILTER, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_LOD_BIAS GL_TEXTURE_COMPARE_MODE, or GL_TEXTURE_COMPARE_FUNC.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// For the scalar commands, specifies the value of pname.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// For the vector commands (glSamplerParameter*v), specifies a pointer to an array where the value or values of pname are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glSamplerParameterfv")]
        public static extern void SamplerParameter(Int32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, Single[] param);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Set sampler parameters
        /// </summary>
        /// <param name="sampler">
        /// <para>
        /// Specifies the sampler object whose parameter to modify.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a sampler parameter. pname can be one of the following: GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, GL_TEXTURE_WRAP_R, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MAG_FILTER, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_LOD_BIAS GL_TEXTURE_COMPARE_MODE, or GL_TEXTURE_COMPARE_FUNC.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// For the scalar commands, specifies the value of pname.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// For the vector commands (glSamplerParameter*v), specifies a pointer to an array where the value or values of pname are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glSamplerParameterfv")]
        public static extern unsafe void SamplerParameter(Int32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, Single* param);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Set sampler parameters
        /// </summary>
        /// <param name="sampler">
        /// <para>
        /// Specifies the sampler object whose parameter to modify.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a sampler parameter. pname can be one of the following: GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, GL_TEXTURE_WRAP_R, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MAG_FILTER, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_LOD_BIAS GL_TEXTURE_COMPARE_MODE, or GL_TEXTURE_COMPARE_FUNC.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// For the scalar commands, specifies the value of pname.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// For the vector commands (glSamplerParameter*v), specifies a pointer to an array where the value or values of pname are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glSamplerParameterfv")]
        public static extern void SamplerParameter(UInt32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, Single[] param);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Set sampler parameters
        /// </summary>
        /// <param name="sampler">
        /// <para>
        /// Specifies the sampler object whose parameter to modify.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a sampler parameter. pname can be one of the following: GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, GL_TEXTURE_WRAP_R, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MAG_FILTER, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_LOD_BIAS GL_TEXTURE_COMPARE_MODE, or GL_TEXTURE_COMPARE_FUNC.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// For the scalar commands, specifies the value of pname.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// For the vector commands (glSamplerParameter*v), specifies a pointer to an array where the value or values of pname are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glSamplerParameterfv")]
        public static extern unsafe void SamplerParameter(UInt32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, Single* param);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Set sampler parameters
        /// </summary>
        /// <param name="sampler">
        /// <para>
        /// Specifies the sampler object whose parameter to modify.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a sampler parameter. pname can be one of the following: GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, GL_TEXTURE_WRAP_R, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MAG_FILTER, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_LOD_BIAS GL_TEXTURE_COMPARE_MODE, or GL_TEXTURE_COMPARE_FUNC.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// For the scalar commands, specifies the value of pname.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// For the vector commands (glSamplerParameter*v), specifies a pointer to an array where the value or values of pname are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glSamplerParameteri")]
        public static extern void SamplerParameter(Int32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, Int32 param);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Set sampler parameters
        /// </summary>
        /// <param name="sampler">
        /// <para>
        /// Specifies the sampler object whose parameter to modify.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a sampler parameter. pname can be one of the following: GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, GL_TEXTURE_WRAP_R, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MAG_FILTER, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_LOD_BIAS GL_TEXTURE_COMPARE_MODE, or GL_TEXTURE_COMPARE_FUNC.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// For the scalar commands, specifies the value of pname.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// For the vector commands (glSamplerParameter*v), specifies a pointer to an array where the value or values of pname are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glSamplerParameteri")]
        public static extern void SamplerParameter(UInt32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, Int32 param);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]</summary>
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glSamplerParameterIiv")]
        public static extern void SamplerParameterI(Int32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, Int32[] param);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]</summary>
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glSamplerParameterIiv")]
        public static extern void SamplerParameterI(Int32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, ref Int32 param);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glSamplerParameterIiv")]
        public static extern unsafe void SamplerParameterI(Int32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, Int32* param);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glSamplerParameterIiv")]
        public static extern void SamplerParameterI(UInt32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, Int32[] param);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glSamplerParameterIiv")]
        public static extern void SamplerParameterI(UInt32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, ref Int32 param);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glSamplerParameterIiv")]
        public static extern unsafe void SamplerParameterI(UInt32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, Int32* param);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glSamplerParameterIuiv")]
        public static extern void SamplerParameterI(UInt32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, UInt32[] param);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glSamplerParameterIuiv")]
        public static extern void SamplerParameterI(UInt32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, ref UInt32 param);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glSamplerParameterIuiv")]
        public static extern unsafe void SamplerParameterI(UInt32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, UInt32* param);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Set sampler parameters
        /// </summary>
        /// <param name="sampler">
        /// <para>
        /// Specifies the sampler object whose parameter to modify.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a sampler parameter. pname can be one of the following: GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, GL_TEXTURE_WRAP_R, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MAG_FILTER, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_LOD_BIAS GL_TEXTURE_COMPARE_MODE, or GL_TEXTURE_COMPARE_FUNC.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// For the scalar commands, specifies the value of pname.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// For the vector commands (glSamplerParameter*v), specifies a pointer to an array where the value or values of pname are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glSamplerParameteriv")]
        public static extern void SamplerParameter(Int32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, Int32[] param);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Set sampler parameters
        /// </summary>
        /// <param name="sampler">
        /// <para>
        /// Specifies the sampler object whose parameter to modify.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a sampler parameter. pname can be one of the following: GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, GL_TEXTURE_WRAP_R, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MAG_FILTER, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_LOD_BIAS GL_TEXTURE_COMPARE_MODE, or GL_TEXTURE_COMPARE_FUNC.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// For the scalar commands, specifies the value of pname.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// For the vector commands (glSamplerParameter*v), specifies a pointer to an array where the value or values of pname are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glSamplerParameteriv")]
        public static extern unsafe void SamplerParameter(Int32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, Int32* param);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Set sampler parameters
        /// </summary>
        /// <param name="sampler">
        /// <para>
        /// Specifies the sampler object whose parameter to modify.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a sampler parameter. pname can be one of the following: GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, GL_TEXTURE_WRAP_R, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MAG_FILTER, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_LOD_BIAS GL_TEXTURE_COMPARE_MODE, or GL_TEXTURE_COMPARE_FUNC.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// For the scalar commands, specifies the value of pname.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// For the vector commands (glSamplerParameter*v), specifies a pointer to an array where the value or values of pname are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glSamplerParameteriv")]
        public static extern void SamplerParameter(UInt32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, Int32[] param);

        /// <summary>[requires: v3.3 and ARB_sampler_objects|VERSION_3_3]
        /// Set sampler parameters
        /// </summary>
        /// <param name="sampler">
        /// <para>
        /// Specifies the sampler object whose parameter to modify.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a sampler parameter. pname can be one of the following: GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, GL_TEXTURE_WRAP_R, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MAG_FILTER, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_LOD_BIAS GL_TEXTURE_COMPARE_MODE, or GL_TEXTURE_COMPARE_FUNC.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// For the scalar commands, specifies the value of pname.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// For the vector commands (glSamplerParameter*v), specifies a pointer to an array where the value or values of pname are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sampler_objects|VERSION_3_3", Version = "3.3", EntryPoint = "glSamplerParameteriv")]
        public static extern unsafe void SamplerParameter(UInt32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, Int32* param);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Multiply the current matrix by a general scaling matrix
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify scale factors along the x, y, and z axes, respectively.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glScaled")]
        public static extern void Scale(Double x, Double y, Double z);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Multiply the current matrix by a general scaling matrix
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify scale factors along the x, y, and z axes, respectively.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glScalef")]
        public static extern void Scale(Single x, Single y, Single z);

        /// <summary>[requires: v1.0]
        /// Define the scissor box
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the lower left corner of the scissor box. Initially (0, 0).
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specify the width and height of the scissor box. When a GL context is first attached to a window, width and height are set to the dimensions of that window.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glScissor")]
        public static extern void Scissor(Int32 x, Int32 y, Int32 width, Int32 height);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Define the scissor box for multiple viewports
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the index of the first viewport whose scissor box to modify.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of scissor boxes to modify.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Specifies the address of an array containing the left, bottom, width and height of each scissor box, in that order.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glScissorArrayv")]
        public static extern void ScissorArray(Int32 first, Int32 count, Int32[] v);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Define the scissor box for multiple viewports
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the index of the first viewport whose scissor box to modify.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of scissor boxes to modify.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Specifies the address of an array containing the left, bottom, width and height of each scissor box, in that order.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glScissorArrayv")]
        public static extern void ScissorArray(Int32 first, Int32 count, ref Int32 v);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Define the scissor box for multiple viewports
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the index of the first viewport whose scissor box to modify.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of scissor boxes to modify.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Specifies the address of an array containing the left, bottom, width and height of each scissor box, in that order.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glScissorArrayv")]
        public static extern unsafe void ScissorArray(Int32 first, Int32 count, Int32* v);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Define the scissor box for multiple viewports
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the index of the first viewport whose scissor box to modify.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of scissor boxes to modify.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Specifies the address of an array containing the left, bottom, width and height of each scissor box, in that order.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glScissorArrayv")]
        public static extern void ScissorArray(UInt32 first, Int32 count, Int32[] v);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Define the scissor box for multiple viewports
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the index of the first viewport whose scissor box to modify.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of scissor boxes to modify.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Specifies the address of an array containing the left, bottom, width and height of each scissor box, in that order.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glScissorArrayv")]
        public static extern void ScissorArray(UInt32 first, Int32 count, ref Int32 v);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Define the scissor box for multiple viewports
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specifies the index of the first viewport whose scissor box to modify.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of scissor boxes to modify.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Specifies the address of an array containing the left, bottom, width and height of each scissor box, in that order.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glScissorArrayv")]
        public static extern unsafe void ScissorArray(UInt32 first, Int32 count, Int32* v);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Define the scissor box for a specific viewport
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the viewport whose scissor box to modify.
        /// </para>
        /// </param>
        /// <param name="left">
        /// <para>
        /// Specify the coordinate of the bottom left corner of the scissor box, in pixels.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specify ths dimensions of the scissor box, in pixels.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For glScissorIndexedv, specifies the address of an array containing the left, bottom, width and height of each scissor box, in that order.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glScissorIndexed")]
        public static extern void ScissorIndexed(Int32 index, Int32 left, Int32 bottom, Int32 width, Int32 height);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Define the scissor box for a specific viewport
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the viewport whose scissor box to modify.
        /// </para>
        /// </param>
        /// <param name="left">
        /// <para>
        /// Specify the coordinate of the bottom left corner of the scissor box, in pixels.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specify ths dimensions of the scissor box, in pixels.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For glScissorIndexedv, specifies the address of an array containing the left, bottom, width and height of each scissor box, in that order.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glScissorIndexed")]
        public static extern void ScissorIndexed(UInt32 index, Int32 left, Int32 bottom, Int32 width, Int32 height);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Define the scissor box for a specific viewport
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the viewport whose scissor box to modify.
        /// </para>
        /// </param>
        /// <param name="left">
        /// <para>
        /// Specify the coordinate of the bottom left corner of the scissor box, in pixels.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specify ths dimensions of the scissor box, in pixels.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For glScissorIndexedv, specifies the address of an array containing the left, bottom, width and height of each scissor box, in that order.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glScissorIndexedv")]
        public static extern void ScissorIndexed(Int32 index, Int32[] v);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Define the scissor box for a specific viewport
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the viewport whose scissor box to modify.
        /// </para>
        /// </param>
        /// <param name="left">
        /// <para>
        /// Specify the coordinate of the bottom left corner of the scissor box, in pixels.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specify ths dimensions of the scissor box, in pixels.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For glScissorIndexedv, specifies the address of an array containing the left, bottom, width and height of each scissor box, in that order.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glScissorIndexedv")]
        public static extern void ScissorIndexed(Int32 index, ref Int32 v);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Define the scissor box for a specific viewport
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the viewport whose scissor box to modify.
        /// </para>
        /// </param>
        /// <param name="left">
        /// <para>
        /// Specify the coordinate of the bottom left corner of the scissor box, in pixels.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specify ths dimensions of the scissor box, in pixels.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For glScissorIndexedv, specifies the address of an array containing the left, bottom, width and height of each scissor box, in that order.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glScissorIndexedv")]
        public static extern unsafe void ScissorIndexed(Int32 index, Int32* v);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Define the scissor box for a specific viewport
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the viewport whose scissor box to modify.
        /// </para>
        /// </param>
        /// <param name="left">
        /// <para>
        /// Specify the coordinate of the bottom left corner of the scissor box, in pixels.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specify ths dimensions of the scissor box, in pixels.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For glScissorIndexedv, specifies the address of an array containing the left, bottom, width and height of each scissor box, in that order.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glScissorIndexedv")]
        public static extern void ScissorIndexed(UInt32 index, Int32[] v);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Define the scissor box for a specific viewport
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the viewport whose scissor box to modify.
        /// </para>
        /// </param>
        /// <param name="left">
        /// <para>
        /// Specify the coordinate of the bottom left corner of the scissor box, in pixels.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specify ths dimensions of the scissor box, in pixels.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For glScissorIndexedv, specifies the address of an array containing the left, bottom, width and height of each scissor box, in that order.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glScissorIndexedv")]
        public static extern void ScissorIndexed(UInt32 index, ref Int32 v);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Define the scissor box for a specific viewport
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the viewport whose scissor box to modify.
        /// </para>
        /// </param>
        /// <param name="left">
        /// <para>
        /// Specify the coordinate of the bottom left corner of the scissor box, in pixels.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specify ths dimensions of the scissor box, in pixels.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For glScissorIndexedv, specifies the address of an array containing the left, bottom, width and height of each scissor box, in that order.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glScissorIndexedv")]
        public static extern unsafe void ScissorIndexed(UInt32 index, Int32* v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current secondary color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current secondary color.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColor3b")]
        public static extern void SecondaryColor3(SByte red, SByte green, SByte blue);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current secondary color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current secondary color.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColor3bv")]
        public static extern void SecondaryColor3(SByte[] v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current secondary color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current secondary color.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColor3bv")]
        public static extern void SecondaryColor3(ref SByte v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current secondary color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current secondary color.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColor3bv")]
        public static extern unsafe void SecondaryColor3(SByte* v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current secondary color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current secondary color.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColor3d")]
        public static extern void SecondaryColor3(Double red, Double green, Double blue);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current secondary color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current secondary color.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColor3dv")]
        public static extern void SecondaryColor3(Double[] v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current secondary color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current secondary color.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColor3dv")]
        public static extern void SecondaryColor3(ref Double v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current secondary color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current secondary color.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColor3dv")]
        public static extern unsafe void SecondaryColor3(Double* v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current secondary color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current secondary color.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColor3f")]
        public static extern void SecondaryColor3(Single red, Single green, Single blue);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current secondary color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current secondary color.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColor3fv")]
        public static extern void SecondaryColor3(Single[] v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current secondary color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current secondary color.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColor3fv")]
        public static extern void SecondaryColor3(ref Single v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current secondary color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current secondary color.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColor3fv")]
        public static extern unsafe void SecondaryColor3(Single* v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current secondary color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current secondary color.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColor3i")]
        public static extern void SecondaryColor3(Int32 red, Int32 green, Int32 blue);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current secondary color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current secondary color.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColor3iv")]
        public static extern void SecondaryColor3(Int32[] v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current secondary color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current secondary color.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColor3iv")]
        public static extern void SecondaryColor3(ref Int32 v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current secondary color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current secondary color.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColor3iv")]
        public static extern unsafe void SecondaryColor3(Int32* v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current secondary color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current secondary color.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColor3s")]
        public static extern void SecondaryColor3(Int16 red, Int16 green, Int16 blue);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current secondary color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current secondary color.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColor3sv")]
        public static extern void SecondaryColor3(Int16[] v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current secondary color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current secondary color.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColor3sv")]
        public static extern void SecondaryColor3(ref Int16 v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current secondary color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current secondary color.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColor3sv")]
        public static extern unsafe void SecondaryColor3(Int16* v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current secondary color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current secondary color.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColor3ub")]
        public static extern void SecondaryColor3(Byte red, Byte green, Byte blue);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current secondary color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current secondary color.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColor3ubv")]
        public static extern void SecondaryColor3(Byte[] v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current secondary color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current secondary color.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColor3ubv")]
        public static extern void SecondaryColor3(ref Byte v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current secondary color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current secondary color.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColor3ubv")]
        public static extern unsafe void SecondaryColor3(Byte* v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current secondary color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current secondary color.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColor3ui")]
        public static extern void SecondaryColor3(UInt32 red, UInt32 green, UInt32 blue);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current secondary color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current secondary color.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColor3uiv")]
        public static extern void SecondaryColor3(UInt32[] v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current secondary color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current secondary color.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColor3uiv")]
        public static extern void SecondaryColor3(ref UInt32 v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current secondary color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current secondary color.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColor3uiv")]
        public static extern unsafe void SecondaryColor3(UInt32* v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current secondary color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current secondary color.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColor3us")]
        public static extern void SecondaryColor3(UInt16 red, UInt16 green, UInt16 blue);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current secondary color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current secondary color.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColor3usv")]
        public static extern void SecondaryColor3(UInt16[] v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current secondary color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current secondary color.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColor3usv")]
        public static extern void SecondaryColor3(ref UInt16 v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Set the current secondary color
        /// </summary>
        /// <param name="red">
        /// <para>
        /// Specify new red, green, and blue values for the current secondary color.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColor3usv")]
        public static extern unsafe void SecondaryColor3(UInt16* v);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glSecondaryColorP3ui")]
        public static extern void SecondaryColorP3(OpenTK.Graphics.OpenGL.PackedPointerType type, Int32 color);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glSecondaryColorP3ui")]
        public static extern void SecondaryColorP3(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32 color);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glSecondaryColorP3uiv")]
        public static extern unsafe void SecondaryColorP3(OpenTK.Graphics.OpenGL.PackedPointerType type, Int32* color);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glSecondaryColorP3uiv")]
        public static extern unsafe void SecondaryColorP3(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32* color);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Define an array of secondary colors
        /// </summary>
        /// <param name="size">
        /// <para>
        /// Specifies the number of components per color. Must be 3.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each color component in the array. Symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, GL_UNSIGNED_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive colors. If stride is 0, the colors are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first component of the first color element in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColorPointer")]
        public static extern void SecondaryColorPointer(Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, IntPtr pointer);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Define an array of secondary colors
        /// </summary>
        /// <param name="size">
        /// <para>
        /// Specifies the number of components per color. Must be 3.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each color component in the array. Symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, GL_UNSIGNED_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive colors. If stride is 0, the colors are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first component of the first color element in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColorPointer")]
        public static extern void SecondaryColorPointer<T3>(Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, [InAttribute, OutAttribute] T3[] pointer)
            where T3 : struct
        ;

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Define an array of secondary colors
        /// </summary>
        /// <param name="size">
        /// <para>
        /// Specifies the number of components per color. Must be 3.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each color component in the array. Symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, GL_UNSIGNED_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive colors. If stride is 0, the colors are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first component of the first color element in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColorPointer")]
        public static extern void SecondaryColorPointer<T3>(Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, [InAttribute, OutAttribute] T3[,] pointer)
            where T3 : struct
        ;

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Define an array of secondary colors
        /// </summary>
        /// <param name="size">
        /// <para>
        /// Specifies the number of components per color. Must be 3.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each color component in the array. Symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, GL_UNSIGNED_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive colors. If stride is 0, the colors are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first component of the first color element in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColorPointer")]
        public static extern void SecondaryColorPointer<T3>(Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, [InAttribute, OutAttribute] T3[,,] pointer)
            where T3 : struct
        ;

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Define an array of secondary colors
        /// </summary>
        /// <param name="size">
        /// <para>
        /// Specifies the number of components per color. Must be 3.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each color component in the array. Symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, GL_UNSIGNED_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive colors. If stride is 0, the colors are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first component of the first color element in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glSecondaryColorPointer")]
        public static extern void SecondaryColorPointer<T3>(Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, [InAttribute, OutAttribute] ref T3 pointer)
            where T3 : struct
        ;

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Establish a buffer for selection mode values
        /// </summary>
        /// <param name="size">
        /// <para>
        /// Specifies the size of buffer.
        /// </para>
        /// </param>
        /// <param name="buffer">
        /// <para>
        /// Returns the selection data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glSelectBuffer")]
        public static extern void SelectBuffer(Int32 size, [OutAttribute] Int32[] buffer);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Establish a buffer for selection mode values
        /// </summary>
        /// <param name="size">
        /// <para>
        /// Specifies the size of buffer.
        /// </para>
        /// </param>
        /// <param name="buffer">
        /// <para>
        /// Returns the selection data.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glSelectBuffer")]
        public static extern void SelectBuffer(Int32 size, [OutAttribute] out Int32 buffer);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Establish a buffer for selection mode values
        /// </summary>
        /// <param name="size">
        /// <para>
        /// Specifies the size of buffer.
        /// </para>
        /// </param>
        /// <param name="buffer">
        /// <para>
        /// Returns the selection data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glSelectBuffer")]
        public static extern unsafe void SelectBuffer(Int32 size, [OutAttribute] Int32* buffer);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Establish a buffer for selection mode values
        /// </summary>
        /// <param name="size">
        /// <para>
        /// Specifies the size of buffer.
        /// </para>
        /// </param>
        /// <param name="buffer">
        /// <para>
        /// Returns the selection data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glSelectBuffer")]
        public static extern void SelectBuffer(Int32 size, [OutAttribute] UInt32[] buffer);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Establish a buffer for selection mode values
        /// </summary>
        /// <param name="size">
        /// <para>
        /// Specifies the size of buffer.
        /// </para>
        /// </param>
        /// <param name="buffer">
        /// <para>
        /// Returns the selection data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glSelectBuffer")]
        public static extern void SelectBuffer(Int32 size, [OutAttribute] out UInt32 buffer);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Establish a buffer for selection mode values
        /// </summary>
        /// <param name="size">
        /// <para>
        /// Specifies the size of buffer.
        /// </para>
        /// </param>
        /// <param name="buffer">
        /// <para>
        /// Returns the selection data.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glSelectBuffer")]
        public static extern unsafe void SelectBuffer(Int32 size, [OutAttribute] UInt32* buffer);

        /// <summary>
        /// Define a separable two-dimensional convolution filter
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_SEPARABLE_2D.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The internal format of the convolution filter kernel. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The number of elements in the pixel array referenced by row. (This is the width of the separable filter kernel.)
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// The number of elements in the pixel array referenced by column. (This is the height of the separable filter kernel.)
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the pixel data in row and column. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_INTENSITY, GL_LUMINANCE, and GL_LUMINANCE_ALPHA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the pixel data in row and column. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="row">
        /// <para>
        /// Pointer to a one-dimensional array of pixel data that is processed to build the row filter kernel.
        /// </para>
        /// </param>
        /// <param name="column">
        /// <para>
        /// Pointer to a one-dimensional array of pixel data that is processed to build the column filter kernel.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glSeparableFilter2D")]
        public static extern void SeparableFilter2D(OpenTK.Graphics.OpenGL.SeparableTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr row, IntPtr column);

        /// <summary>
        /// Define a separable two-dimensional convolution filter
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_SEPARABLE_2D.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The internal format of the convolution filter kernel. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The number of elements in the pixel array referenced by row. (This is the width of the separable filter kernel.)
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// The number of elements in the pixel array referenced by column. (This is the height of the separable filter kernel.)
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the pixel data in row and column. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_INTENSITY, GL_LUMINANCE, and GL_LUMINANCE_ALPHA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the pixel data in row and column. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="row">
        /// <para>
        /// Pointer to a one-dimensional array of pixel data that is processed to build the row filter kernel.
        /// </para>
        /// </param>
        /// <param name="column">
        /// <para>
        /// Pointer to a one-dimensional array of pixel data that is processed to build the column filter kernel.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glSeparableFilter2D")]
        public static extern void SeparableFilter2D<T6,T7>(OpenTK.Graphics.OpenGL.SeparableTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T6[] row, [InAttribute, OutAttribute] T7[] column)
            where T6 : struct
            where T7 : struct
        ;

        /// <summary>
        /// Define a separable two-dimensional convolution filter
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_SEPARABLE_2D.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The internal format of the convolution filter kernel. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The number of elements in the pixel array referenced by row. (This is the width of the separable filter kernel.)
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// The number of elements in the pixel array referenced by column. (This is the height of the separable filter kernel.)
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the pixel data in row and column. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_INTENSITY, GL_LUMINANCE, and GL_LUMINANCE_ALPHA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the pixel data in row and column. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="row">
        /// <para>
        /// Pointer to a one-dimensional array of pixel data that is processed to build the row filter kernel.
        /// </para>
        /// </param>
        /// <param name="column">
        /// <para>
        /// Pointer to a one-dimensional array of pixel data that is processed to build the column filter kernel.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glSeparableFilter2D")]
        public static extern void SeparableFilter2D<T6,T7>(OpenTK.Graphics.OpenGL.SeparableTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T6[,] row, [InAttribute, OutAttribute] T7[,] column)
            where T6 : struct
            where T7 : struct
        ;

        /// <summary>
        /// Define a separable two-dimensional convolution filter
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_SEPARABLE_2D.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The internal format of the convolution filter kernel. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The number of elements in the pixel array referenced by row. (This is the width of the separable filter kernel.)
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// The number of elements in the pixel array referenced by column. (This is the height of the separable filter kernel.)
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the pixel data in row and column. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_INTENSITY, GL_LUMINANCE, and GL_LUMINANCE_ALPHA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the pixel data in row and column. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="row">
        /// <para>
        /// Pointer to a one-dimensional array of pixel data that is processed to build the row filter kernel.
        /// </para>
        /// </param>
        /// <param name="column">
        /// <para>
        /// Pointer to a one-dimensional array of pixel data that is processed to build the column filter kernel.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glSeparableFilter2D")]
        public static extern void SeparableFilter2D<T6,T7>(OpenTK.Graphics.OpenGL.SeparableTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T6[,,] row, [InAttribute, OutAttribute] T7[,,] column)
            where T6 : struct
            where T7 : struct
        ;

        /// <summary>
        /// Define a separable two-dimensional convolution filter
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Must be GL_SEPARABLE_2D.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The internal format of the convolution filter kernel. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The number of elements in the pixel array referenced by row. (This is the width of the separable filter kernel.)
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// The number of elements in the pixel array referenced by column. (This is the height of the separable filter kernel.)
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// The format of the pixel data in row and column. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_INTENSITY, GL_LUMINANCE, and GL_LUMINANCE_ALPHA.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the pixel data in row and column. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
        /// </para>
        /// </param>
        /// <param name="row">
        /// <para>
        /// Pointer to a one-dimensional array of pixel data that is processed to build the row filter kernel.
        /// </para>
        /// </param>
        /// <param name="column">
        /// <para>
        /// Pointer to a one-dimensional array of pixel data that is processed to build the column filter kernel.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_imaging", Version = "", EntryPoint = "glSeparableFilter2D")]
        public static extern void SeparableFilter2D<T6,T7>(OpenTK.Graphics.OpenGL.SeparableTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T6 row, [InAttribute, OutAttribute] ref T7 column)
            where T6 : struct
            where T7 : struct
        ;

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Select flat or smooth shading
        /// </summary>
        /// <param name="mode">
        /// <para>
        /// Specifies a symbolic value representing a shading technique. Accepted values are GL_FLAT and GL_SMOOTH. The initial value is GL_SMOOTH.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glShadeModel")]
        public static extern void ShadeModel(OpenTK.Graphics.OpenGL.ShadingModel mode);

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Load pre-compiled shader binaries
        /// </summary>
        /// <param name="count">
        /// <para>
        /// Specifies the number of shader object handles contained in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies the address of an array of shader handles into which to load pre-compiled shader binaries.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the shader binaries contained in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address of an array of bytes containing pre-compiled binary shader code.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the length of the array whose address is given in binary.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glShaderBinary")]
        public static extern void ShaderBinary(Int32 count, Int32[] shaders, OpenTK.Graphics.OpenGL.BinaryFormat binaryformat, IntPtr binary, Int32 length);

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Load pre-compiled shader binaries
        /// </summary>
        /// <param name="count">
        /// <para>
        /// Specifies the number of shader object handles contained in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies the address of an array of shader handles into which to load pre-compiled shader binaries.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the shader binaries contained in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address of an array of bytes containing pre-compiled binary shader code.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the length of the array whose address is given in binary.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glShaderBinary")]
        public static extern void ShaderBinary<T3>(Int32 count, Int32[] shaders, OpenTK.Graphics.OpenGL.BinaryFormat binaryformat, [InAttribute, OutAttribute] T3[] binary, Int32 length)
            where T3 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Load pre-compiled shader binaries
        /// </summary>
        /// <param name="count">
        /// <para>
        /// Specifies the number of shader object handles contained in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies the address of an array of shader handles into which to load pre-compiled shader binaries.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the shader binaries contained in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address of an array of bytes containing pre-compiled binary shader code.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the length of the array whose address is given in binary.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glShaderBinary")]
        public static extern void ShaderBinary<T3>(Int32 count, Int32[] shaders, OpenTK.Graphics.OpenGL.BinaryFormat binaryformat, [InAttribute, OutAttribute] T3[,] binary, Int32 length)
            where T3 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Load pre-compiled shader binaries
        /// </summary>
        /// <param name="count">
        /// <para>
        /// Specifies the number of shader object handles contained in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies the address of an array of shader handles into which to load pre-compiled shader binaries.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the shader binaries contained in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address of an array of bytes containing pre-compiled binary shader code.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the length of the array whose address is given in binary.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glShaderBinary")]
        public static extern void ShaderBinary<T3>(Int32 count, Int32[] shaders, OpenTK.Graphics.OpenGL.BinaryFormat binaryformat, [InAttribute, OutAttribute] T3[,,] binary, Int32 length)
            where T3 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Load pre-compiled shader binaries
        /// </summary>
        /// <param name="count">
        /// <para>
        /// Specifies the number of shader object handles contained in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies the address of an array of shader handles into which to load pre-compiled shader binaries.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the shader binaries contained in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address of an array of bytes containing pre-compiled binary shader code.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the length of the array whose address is given in binary.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glShaderBinary")]
        public static extern void ShaderBinary<T3>(Int32 count, Int32[] shaders, OpenTK.Graphics.OpenGL.BinaryFormat binaryformat, [InAttribute, OutAttribute] ref T3 binary, Int32 length)
            where T3 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Load pre-compiled shader binaries
        /// </summary>
        /// <param name="count">
        /// <para>
        /// Specifies the number of shader object handles contained in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies the address of an array of shader handles into which to load pre-compiled shader binaries.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the shader binaries contained in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address of an array of bytes containing pre-compiled binary shader code.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the length of the array whose address is given in binary.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glShaderBinary")]
        public static extern void ShaderBinary(Int32 count, ref Int32 shaders, OpenTK.Graphics.OpenGL.BinaryFormat binaryformat, IntPtr binary, Int32 length);

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Load pre-compiled shader binaries
        /// </summary>
        /// <param name="count">
        /// <para>
        /// Specifies the number of shader object handles contained in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies the address of an array of shader handles into which to load pre-compiled shader binaries.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the shader binaries contained in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address of an array of bytes containing pre-compiled binary shader code.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the length of the array whose address is given in binary.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glShaderBinary")]
        public static extern void ShaderBinary<T3>(Int32 count, ref Int32 shaders, OpenTK.Graphics.OpenGL.BinaryFormat binaryformat, [InAttribute, OutAttribute] T3[] binary, Int32 length)
            where T3 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Load pre-compiled shader binaries
        /// </summary>
        /// <param name="count">
        /// <para>
        /// Specifies the number of shader object handles contained in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies the address of an array of shader handles into which to load pre-compiled shader binaries.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the shader binaries contained in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address of an array of bytes containing pre-compiled binary shader code.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the length of the array whose address is given in binary.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glShaderBinary")]
        public static extern void ShaderBinary<T3>(Int32 count, ref Int32 shaders, OpenTK.Graphics.OpenGL.BinaryFormat binaryformat, [InAttribute, OutAttribute] T3[,] binary, Int32 length)
            where T3 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Load pre-compiled shader binaries
        /// </summary>
        /// <param name="count">
        /// <para>
        /// Specifies the number of shader object handles contained in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies the address of an array of shader handles into which to load pre-compiled shader binaries.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the shader binaries contained in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address of an array of bytes containing pre-compiled binary shader code.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the length of the array whose address is given in binary.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glShaderBinary")]
        public static extern void ShaderBinary<T3>(Int32 count, ref Int32 shaders, OpenTK.Graphics.OpenGL.BinaryFormat binaryformat, [InAttribute, OutAttribute] T3[,,] binary, Int32 length)
            where T3 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Load pre-compiled shader binaries
        /// </summary>
        /// <param name="count">
        /// <para>
        /// Specifies the number of shader object handles contained in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies the address of an array of shader handles into which to load pre-compiled shader binaries.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the shader binaries contained in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address of an array of bytes containing pre-compiled binary shader code.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the length of the array whose address is given in binary.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glShaderBinary")]
        public static extern void ShaderBinary<T3>(Int32 count, ref Int32 shaders, OpenTK.Graphics.OpenGL.BinaryFormat binaryformat, [InAttribute, OutAttribute] ref T3 binary, Int32 length)
            where T3 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Load pre-compiled shader binaries
        /// </summary>
        /// <param name="count">
        /// <para>
        /// Specifies the number of shader object handles contained in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies the address of an array of shader handles into which to load pre-compiled shader binaries.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the shader binaries contained in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address of an array of bytes containing pre-compiled binary shader code.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the length of the array whose address is given in binary.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glShaderBinary")]
        public static extern unsafe void ShaderBinary(Int32 count, Int32* shaders, OpenTK.Graphics.OpenGL.BinaryFormat binaryformat, IntPtr binary, Int32 length);

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Load pre-compiled shader binaries
        /// </summary>
        /// <param name="count">
        /// <para>
        /// Specifies the number of shader object handles contained in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies the address of an array of shader handles into which to load pre-compiled shader binaries.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the shader binaries contained in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address of an array of bytes containing pre-compiled binary shader code.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the length of the array whose address is given in binary.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glShaderBinary")]
        public static extern unsafe void ShaderBinary<T3>(Int32 count, Int32* shaders, OpenTK.Graphics.OpenGL.BinaryFormat binaryformat, [InAttribute, OutAttribute] T3[] binary, Int32 length)
            where T3 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Load pre-compiled shader binaries
        /// </summary>
        /// <param name="count">
        /// <para>
        /// Specifies the number of shader object handles contained in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies the address of an array of shader handles into which to load pre-compiled shader binaries.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the shader binaries contained in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address of an array of bytes containing pre-compiled binary shader code.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the length of the array whose address is given in binary.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glShaderBinary")]
        public static extern unsafe void ShaderBinary<T3>(Int32 count, Int32* shaders, OpenTK.Graphics.OpenGL.BinaryFormat binaryformat, [InAttribute, OutAttribute] T3[,] binary, Int32 length)
            where T3 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Load pre-compiled shader binaries
        /// </summary>
        /// <param name="count">
        /// <para>
        /// Specifies the number of shader object handles contained in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies the address of an array of shader handles into which to load pre-compiled shader binaries.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the shader binaries contained in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address of an array of bytes containing pre-compiled binary shader code.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the length of the array whose address is given in binary.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glShaderBinary")]
        public static extern unsafe void ShaderBinary<T3>(Int32 count, Int32* shaders, OpenTK.Graphics.OpenGL.BinaryFormat binaryformat, [InAttribute, OutAttribute] T3[,,] binary, Int32 length)
            where T3 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Load pre-compiled shader binaries
        /// </summary>
        /// <param name="count">
        /// <para>
        /// Specifies the number of shader object handles contained in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies the address of an array of shader handles into which to load pre-compiled shader binaries.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the shader binaries contained in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address of an array of bytes containing pre-compiled binary shader code.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the length of the array whose address is given in binary.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glShaderBinary")]
        public static extern unsafe void ShaderBinary<T3>(Int32 count, Int32* shaders, OpenTK.Graphics.OpenGL.BinaryFormat binaryformat, [InAttribute, OutAttribute] ref T3 binary, Int32 length)
            where T3 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Load pre-compiled shader binaries
        /// </summary>
        /// <param name="count">
        /// <para>
        /// Specifies the number of shader object handles contained in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies the address of an array of shader handles into which to load pre-compiled shader binaries.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the shader binaries contained in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address of an array of bytes containing pre-compiled binary shader code.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the length of the array whose address is given in binary.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glShaderBinary")]
        public static extern void ShaderBinary(Int32 count, UInt32[] shaders, OpenTK.Graphics.OpenGL.BinaryFormat binaryformat, IntPtr binary, Int32 length);

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Load pre-compiled shader binaries
        /// </summary>
        /// <param name="count">
        /// <para>
        /// Specifies the number of shader object handles contained in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies the address of an array of shader handles into which to load pre-compiled shader binaries.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the shader binaries contained in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address of an array of bytes containing pre-compiled binary shader code.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the length of the array whose address is given in binary.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glShaderBinary")]
        public static extern void ShaderBinary<T3>(Int32 count, UInt32[] shaders, OpenTK.Graphics.OpenGL.BinaryFormat binaryformat, [InAttribute, OutAttribute] T3[] binary, Int32 length)
            where T3 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Load pre-compiled shader binaries
        /// </summary>
        /// <param name="count">
        /// <para>
        /// Specifies the number of shader object handles contained in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies the address of an array of shader handles into which to load pre-compiled shader binaries.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the shader binaries contained in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address of an array of bytes containing pre-compiled binary shader code.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the length of the array whose address is given in binary.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glShaderBinary")]
        public static extern void ShaderBinary<T3>(Int32 count, UInt32[] shaders, OpenTK.Graphics.OpenGL.BinaryFormat binaryformat, [InAttribute, OutAttribute] T3[,] binary, Int32 length)
            where T3 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Load pre-compiled shader binaries
        /// </summary>
        /// <param name="count">
        /// <para>
        /// Specifies the number of shader object handles contained in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies the address of an array of shader handles into which to load pre-compiled shader binaries.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the shader binaries contained in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address of an array of bytes containing pre-compiled binary shader code.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the length of the array whose address is given in binary.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glShaderBinary")]
        public static extern void ShaderBinary<T3>(Int32 count, UInt32[] shaders, OpenTK.Graphics.OpenGL.BinaryFormat binaryformat, [InAttribute, OutAttribute] T3[,,] binary, Int32 length)
            where T3 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Load pre-compiled shader binaries
        /// </summary>
        /// <param name="count">
        /// <para>
        /// Specifies the number of shader object handles contained in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies the address of an array of shader handles into which to load pre-compiled shader binaries.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the shader binaries contained in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address of an array of bytes containing pre-compiled binary shader code.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the length of the array whose address is given in binary.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glShaderBinary")]
        public static extern void ShaderBinary<T3>(Int32 count, UInt32[] shaders, OpenTK.Graphics.OpenGL.BinaryFormat binaryformat, [InAttribute, OutAttribute] ref T3 binary, Int32 length)
            where T3 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Load pre-compiled shader binaries
        /// </summary>
        /// <param name="count">
        /// <para>
        /// Specifies the number of shader object handles contained in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies the address of an array of shader handles into which to load pre-compiled shader binaries.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the shader binaries contained in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address of an array of bytes containing pre-compiled binary shader code.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the length of the array whose address is given in binary.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glShaderBinary")]
        public static extern void ShaderBinary(Int32 count, ref UInt32 shaders, OpenTK.Graphics.OpenGL.BinaryFormat binaryformat, IntPtr binary, Int32 length);

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Load pre-compiled shader binaries
        /// </summary>
        /// <param name="count">
        /// <para>
        /// Specifies the number of shader object handles contained in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies the address of an array of shader handles into which to load pre-compiled shader binaries.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the shader binaries contained in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address of an array of bytes containing pre-compiled binary shader code.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the length of the array whose address is given in binary.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glShaderBinary")]
        public static extern void ShaderBinary<T3>(Int32 count, ref UInt32 shaders, OpenTK.Graphics.OpenGL.BinaryFormat binaryformat, [InAttribute, OutAttribute] T3[] binary, Int32 length)
            where T3 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Load pre-compiled shader binaries
        /// </summary>
        /// <param name="count">
        /// <para>
        /// Specifies the number of shader object handles contained in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies the address of an array of shader handles into which to load pre-compiled shader binaries.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the shader binaries contained in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address of an array of bytes containing pre-compiled binary shader code.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the length of the array whose address is given in binary.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glShaderBinary")]
        public static extern void ShaderBinary<T3>(Int32 count, ref UInt32 shaders, OpenTK.Graphics.OpenGL.BinaryFormat binaryformat, [InAttribute, OutAttribute] T3[,] binary, Int32 length)
            where T3 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Load pre-compiled shader binaries
        /// </summary>
        /// <param name="count">
        /// <para>
        /// Specifies the number of shader object handles contained in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies the address of an array of shader handles into which to load pre-compiled shader binaries.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the shader binaries contained in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address of an array of bytes containing pre-compiled binary shader code.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the length of the array whose address is given in binary.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glShaderBinary")]
        public static extern void ShaderBinary<T3>(Int32 count, ref UInt32 shaders, OpenTK.Graphics.OpenGL.BinaryFormat binaryformat, [InAttribute, OutAttribute] T3[,,] binary, Int32 length)
            where T3 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Load pre-compiled shader binaries
        /// </summary>
        /// <param name="count">
        /// <para>
        /// Specifies the number of shader object handles contained in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies the address of an array of shader handles into which to load pre-compiled shader binaries.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the shader binaries contained in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address of an array of bytes containing pre-compiled binary shader code.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the length of the array whose address is given in binary.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glShaderBinary")]
        public static extern void ShaderBinary<T3>(Int32 count, ref UInt32 shaders, OpenTK.Graphics.OpenGL.BinaryFormat binaryformat, [InAttribute, OutAttribute] ref T3 binary, Int32 length)
            where T3 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Load pre-compiled shader binaries
        /// </summary>
        /// <param name="count">
        /// <para>
        /// Specifies the number of shader object handles contained in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies the address of an array of shader handles into which to load pre-compiled shader binaries.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the shader binaries contained in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address of an array of bytes containing pre-compiled binary shader code.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the length of the array whose address is given in binary.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glShaderBinary")]
        public static extern unsafe void ShaderBinary(Int32 count, UInt32* shaders, OpenTK.Graphics.OpenGL.BinaryFormat binaryformat, IntPtr binary, Int32 length);

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Load pre-compiled shader binaries
        /// </summary>
        /// <param name="count">
        /// <para>
        /// Specifies the number of shader object handles contained in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies the address of an array of shader handles into which to load pre-compiled shader binaries.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the shader binaries contained in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address of an array of bytes containing pre-compiled binary shader code.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the length of the array whose address is given in binary.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glShaderBinary")]
        public static extern unsafe void ShaderBinary<T3>(Int32 count, UInt32* shaders, OpenTK.Graphics.OpenGL.BinaryFormat binaryformat, [InAttribute, OutAttribute] T3[] binary, Int32 length)
            where T3 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Load pre-compiled shader binaries
        /// </summary>
        /// <param name="count">
        /// <para>
        /// Specifies the number of shader object handles contained in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies the address of an array of shader handles into which to load pre-compiled shader binaries.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the shader binaries contained in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address of an array of bytes containing pre-compiled binary shader code.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the length of the array whose address is given in binary.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glShaderBinary")]
        public static extern unsafe void ShaderBinary<T3>(Int32 count, UInt32* shaders, OpenTK.Graphics.OpenGL.BinaryFormat binaryformat, [InAttribute, OutAttribute] T3[,] binary, Int32 length)
            where T3 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Load pre-compiled shader binaries
        /// </summary>
        /// <param name="count">
        /// <para>
        /// Specifies the number of shader object handles contained in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies the address of an array of shader handles into which to load pre-compiled shader binaries.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the shader binaries contained in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address of an array of bytes containing pre-compiled binary shader code.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the length of the array whose address is given in binary.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glShaderBinary")]
        public static extern unsafe void ShaderBinary<T3>(Int32 count, UInt32* shaders, OpenTK.Graphics.OpenGL.BinaryFormat binaryformat, [InAttribute, OutAttribute] T3[,,] binary, Int32 length)
            where T3 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_ES2_compatibility|VERSION_4_1]
        /// Load pre-compiled shader binaries
        /// </summary>
        /// <param name="count">
        /// <para>
        /// Specifies the number of shader object handles contained in shaders.
        /// </para>
        /// </param>
        /// <param name="shaders">
        /// <para>
        /// Specifies the address of an array of shader handles into which to load pre-compiled shader binaries.
        /// </para>
        /// </param>
        /// <param name="binaryFormat">
        /// <para>
        /// Specifies the format of the shader binaries contained in binary.
        /// </para>
        /// </param>
        /// <param name="binary">
        /// <para>
        /// Specifies the address of an array of bytes containing pre-compiled binary shader code.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies the length of the array whose address is given in binary.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_ES2_compatibility|VERSION_4_1", Version = "4.1", EntryPoint = "glShaderBinary")]
        public static extern unsafe void ShaderBinary<T3>(Int32 count, UInt32* shaders, OpenTK.Graphics.OpenGL.BinaryFormat binaryformat, [InAttribute, OutAttribute] ref T3 binary, Int32 length)
            where T3 : struct
        ;

        /// <summary>[requires: v2.0]
        /// Replaces the source code in a shader object
        /// </summary>
        /// <param name="shader">
        /// <para>
        /// Specifies the handle of the shader object whose source code is to be replaced.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements in the string and length arrays.
        /// </para>
        /// </param>
        /// <param name="string">
        /// <para>
        /// Specifies an array of pointers to strings containing the source code to be loaded into the shader.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies an array of string lengths.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glShaderSource")]
        public static extern void ShaderSource(Int32 shader, Int32 count, String[] @string, Int32[] length);

        /// <summary>[requires: v2.0]
        /// Replaces the source code in a shader object
        /// </summary>
        /// <param name="shader">
        /// <para>
        /// Specifies the handle of the shader object whose source code is to be replaced.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements in the string and length arrays.
        /// </para>
        /// </param>
        /// <param name="string">
        /// <para>
        /// Specifies an array of pointers to strings containing the source code to be loaded into the shader.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies an array of string lengths.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glShaderSource")]
        public static extern void ShaderSource(Int32 shader, Int32 count, String[] @string, ref Int32 length);

        /// <summary>[requires: v2.0]
        /// Replaces the source code in a shader object
        /// </summary>
        /// <param name="shader">
        /// <para>
        /// Specifies the handle of the shader object whose source code is to be replaced.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements in the string and length arrays.
        /// </para>
        /// </param>
        /// <param name="string">
        /// <para>
        /// Specifies an array of pointers to strings containing the source code to be loaded into the shader.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies an array of string lengths.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glShaderSource")]
        public static extern unsafe void ShaderSource(Int32 shader, Int32 count, String[] @string, Int32* length);

        /// <summary>[requires: v2.0]
        /// Replaces the source code in a shader object
        /// </summary>
        /// <param name="shader">
        /// <para>
        /// Specifies the handle of the shader object whose source code is to be replaced.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements in the string and length arrays.
        /// </para>
        /// </param>
        /// <param name="string">
        /// <para>
        /// Specifies an array of pointers to strings containing the source code to be loaded into the shader.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies an array of string lengths.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glShaderSource")]
        public static extern void ShaderSource(UInt32 shader, Int32 count, String[] @string, Int32[] length);

        /// <summary>[requires: v2.0]
        /// Replaces the source code in a shader object
        /// </summary>
        /// <param name="shader">
        /// <para>
        /// Specifies the handle of the shader object whose source code is to be replaced.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements in the string and length arrays.
        /// </para>
        /// </param>
        /// <param name="string">
        /// <para>
        /// Specifies an array of pointers to strings containing the source code to be loaded into the shader.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies an array of string lengths.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glShaderSource")]
        public static extern void ShaderSource(UInt32 shader, Int32 count, String[] @string, ref Int32 length);

        /// <summary>[requires: v2.0]
        /// Replaces the source code in a shader object
        /// </summary>
        /// <param name="shader">
        /// <para>
        /// Specifies the handle of the shader object whose source code is to be replaced.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of elements in the string and length arrays.
        /// </para>
        /// </param>
        /// <param name="string">
        /// <para>
        /// Specifies an array of pointers to strings containing the source code to be loaded into the shader.
        /// </para>
        /// </param>
        /// <param name="length">
        /// <para>
        /// Specifies an array of string lengths.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glShaderSource")]
        public static extern unsafe void ShaderSource(UInt32 shader, Int32 count, String[] @string, Int32* length);

        /// <summary>[requires: v4.3 and ARB_shader_storage_buffer_object|VERSION_4_3]
        /// Change an active shader storage block binding
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of the program containing the block whose binding to change.
        /// </para>
        /// </param>
        /// <param name="storageBlockIndex">
        /// <para>
        /// The index storage block within the program.
        /// </para>
        /// </param>
        /// <param name="storageBlockBinding">
        /// <para>
        /// The index storage block binding to associate with the specified storage block.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_shader_storage_buffer_object|VERSION_4_3", Version = "4.3", EntryPoint = "glShaderStorageBlockBinding")]
        public static extern void ShaderStorageBlockBinding(Int32 program, Int32 storageBlockIndex, Int32 storageBlockBinding);

        /// <summary>[requires: v4.3 and ARB_shader_storage_buffer_object|VERSION_4_3]
        /// Change an active shader storage block binding
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of the program containing the block whose binding to change.
        /// </para>
        /// </param>
        /// <param name="storageBlockIndex">
        /// <para>
        /// The index storage block within the program.
        /// </para>
        /// </param>
        /// <param name="storageBlockBinding">
        /// <para>
        /// The index storage block binding to associate with the specified storage block.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_shader_storage_buffer_object|VERSION_4_3", Version = "4.3", EntryPoint = "glShaderStorageBlockBinding")]
        public static extern void ShaderStorageBlockBinding(UInt32 program, UInt32 storageBlockIndex, UInt32 storageBlockBinding);

        /// <summary>[requires: v1.0]
        /// Set front and back function and reference value for stencil testing
        /// </summary>
        /// <param name="func">
        /// <para>
        /// Specifies the test function. Eight symbolic constants are valid: GL_NEVER, GL_LESS, GL_LEQUAL, GL_GREATER, GL_GEQUAL, GL_EQUAL, GL_NOTEQUAL, and GL_ALWAYS. The initial value is GL_ALWAYS.
        /// </para>
        /// </param>
        /// <param name="ref">
        /// <para>
        /// Specifies the reference value for the stencil test. ref is clamped to the range [0, 2 sup n - 1], where is the number of bitplanes in the stencil buffer. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="mask">
        /// <para>
        /// Specifies a mask that is ANDed with both the reference value and the stored stencil value when the test is done. The initial value is all 1's.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glStencilFunc")]
        public static extern void StencilFunc(OpenTK.Graphics.OpenGL.StencilFunction func, Int32 @ref, Int32 mask);

        /// <summary>[requires: v1.0]
        /// Set front and back function and reference value for stencil testing
        /// </summary>
        /// <param name="func">
        /// <para>
        /// Specifies the test function. Eight symbolic constants are valid: GL_NEVER, GL_LESS, GL_LEQUAL, GL_GREATER, GL_GEQUAL, GL_EQUAL, GL_NOTEQUAL, and GL_ALWAYS. The initial value is GL_ALWAYS.
        /// </para>
        /// </param>
        /// <param name="ref">
        /// <para>
        /// Specifies the reference value for the stencil test. ref is clamped to the range [0, 2 sup n - 1], where is the number of bitplanes in the stencil buffer. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="mask">
        /// <para>
        /// Specifies a mask that is ANDed with both the reference value and the stored stencil value when the test is done. The initial value is all 1's.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glStencilFunc")]
        public static extern void StencilFunc(OpenTK.Graphics.OpenGL.StencilFunction func, Int32 @ref, UInt32 mask);

        /// <summary>[requires: v2.0]
        /// Set front and/or back function and reference value for stencil testing
        /// </summary>
        /// <param name="face">
        /// <para>
        /// Specifies whether front and/or back stencil state is updated. Three symbolic constants are valid: GL_FRONT, GL_BACK, and GL_FRONT_AND_BACK.
        /// </para>
        /// </param>
        /// <param name="func">
        /// <para>
        /// Specifies the test function. Eight symbolic constants are valid: GL_NEVER, GL_LESS, GL_LEQUAL, GL_GREATER, GL_GEQUAL, GL_EQUAL, GL_NOTEQUAL, and GL_ALWAYS. The initial value is GL_ALWAYS.
        /// </para>
        /// </param>
        /// <param name="ref">
        /// <para>
        /// Specifies the reference value for the stencil test. ref is clamped to the range [0, 2 sup n - 1], where is the number of bitplanes in the stencil buffer. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="mask">
        /// <para>
        /// Specifies a mask that is ANDed with both the reference value and the stored stencil value when the test is done. The initial value is all 1's.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glStencilFuncSeparate")]
        public static extern void StencilFuncSeparate(OpenTK.Graphics.OpenGL.StencilFace face, OpenTK.Graphics.OpenGL.StencilFunction func, Int32 @ref, Int32 mask);

        /// <summary>[requires: v2.0]
        /// Set front and/or back function and reference value for stencil testing
        /// </summary>
        /// <param name="face">
        /// <para>
        /// Specifies whether front and/or back stencil state is updated. Three symbolic constants are valid: GL_FRONT, GL_BACK, and GL_FRONT_AND_BACK.
        /// </para>
        /// </param>
        /// <param name="func">
        /// <para>
        /// Specifies the test function. Eight symbolic constants are valid: GL_NEVER, GL_LESS, GL_LEQUAL, GL_GREATER, GL_GEQUAL, GL_EQUAL, GL_NOTEQUAL, and GL_ALWAYS. The initial value is GL_ALWAYS.
        /// </para>
        /// </param>
        /// <param name="ref">
        /// <para>
        /// Specifies the reference value for the stencil test. ref is clamped to the range [0, 2 sup n - 1], where is the number of bitplanes in the stencil buffer. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="mask">
        /// <para>
        /// Specifies a mask that is ANDed with both the reference value and the stored stencil value when the test is done. The initial value is all 1's.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glStencilFuncSeparate")]
        public static extern void StencilFuncSeparate(OpenTK.Graphics.OpenGL.StencilFace face, OpenTK.Graphics.OpenGL.StencilFunction func, Int32 @ref, UInt32 mask);

        /// <summary>[requires: v1.0]
        /// Control the front and back writing of individual bits in the stencil planes
        /// </summary>
        /// <param name="mask">
        /// <para>
        /// Specifies a bit mask to enable and disable writing of individual bits in the stencil planes. Initially, the mask is all 1's.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glStencilMask")]
        public static extern void StencilMask(Int32 mask);

        /// <summary>[requires: v1.0]
        /// Control the front and back writing of individual bits in the stencil planes
        /// </summary>
        /// <param name="mask">
        /// <para>
        /// Specifies a bit mask to enable and disable writing of individual bits in the stencil planes. Initially, the mask is all 1's.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glStencilMask")]
        public static extern void StencilMask(UInt32 mask);

        /// <summary>[requires: v2.0]
        /// Control the front and/or back writing of individual bits in the stencil planes
        /// </summary>
        /// <param name="face">
        /// <para>
        /// Specifies whether the front and/or back stencil writemask is updated. Three symbolic constants are valid: GL_FRONT, GL_BACK, and GL_FRONT_AND_BACK.
        /// </para>
        /// </param>
        /// <param name="mask">
        /// <para>
        /// Specifies a bit mask to enable and disable writing of individual bits in the stencil planes. Initially, the mask is all 1's.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glStencilMaskSeparate")]
        public static extern void StencilMaskSeparate(OpenTK.Graphics.OpenGL.StencilFace face, Int32 mask);

        /// <summary>[requires: v2.0]
        /// Control the front and/or back writing of individual bits in the stencil planes
        /// </summary>
        /// <param name="face">
        /// <para>
        /// Specifies whether the front and/or back stencil writemask is updated. Three symbolic constants are valid: GL_FRONT, GL_BACK, and GL_FRONT_AND_BACK.
        /// </para>
        /// </param>
        /// <param name="mask">
        /// <para>
        /// Specifies a bit mask to enable and disable writing of individual bits in the stencil planes. Initially, the mask is all 1's.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glStencilMaskSeparate")]
        public static extern void StencilMaskSeparate(OpenTK.Graphics.OpenGL.StencilFace face, UInt32 mask);

        /// <summary>[requires: v1.0]
        /// Set front and back stencil test actions
        /// </summary>
        /// <param name="sfail">
        /// <para>
        /// Specifies the action to take when the stencil test fails. Eight symbolic constants are accepted: GL_KEEP, GL_ZERO, GL_REPLACE, GL_INCR, GL_INCR_WRAP, GL_DECR, GL_DECR_WRAP, and GL_INVERT. The initial value is GL_KEEP.
        /// </para>
        /// </param>
        /// <param name="dpfail">
        /// <para>
        /// Specifies the stencil action when the stencil test passes, but the depth test fails. dpfail accepts the same symbolic constants as sfail. The initial value is GL_KEEP.
        /// </para>
        /// </param>
        /// <param name="dppass">
        /// <para>
        /// Specifies the stencil action when both the stencil test and the depth test pass, or when the stencil test passes and either there is no depth buffer or depth testing is not enabled. dppass accepts the same symbolic constants as sfail. The initial value is GL_KEEP.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glStencilOp")]
        public static extern void StencilOp(OpenTK.Graphics.OpenGL.StencilOp fail, OpenTK.Graphics.OpenGL.StencilOp zfail, OpenTK.Graphics.OpenGL.StencilOp zpass);

        /// <summary>[requires: v2.0]
        /// Set front and/or back stencil test actions
        /// </summary>
        /// <param name="face">
        /// <para>
        /// Specifies whether front and/or back stencil state is updated. Three symbolic constants are valid: GL_FRONT, GL_BACK, and GL_FRONT_AND_BACK.
        /// </para>
        /// </param>
        /// <param name="sfail">
        /// <para>
        /// Specifies the action to take when the stencil test fails. Eight symbolic constants are accepted: GL_KEEP, GL_ZERO, GL_REPLACE, GL_INCR, GL_INCR_WRAP, GL_DECR, GL_DECR_WRAP, and GL_INVERT. The initial value is GL_KEEP.
        /// </para>
        /// </param>
        /// <param name="dpfail">
        /// <para>
        /// Specifies the stencil action when the stencil test passes, but the depth test fails. dpfail accepts the same symbolic constants as sfail. The initial value is GL_KEEP.
        /// </para>
        /// </param>
        /// <param name="dppass">
        /// <para>
        /// Specifies the stencil action when both the stencil test and the depth test pass, or when the stencil test passes and either there is no depth buffer or depth testing is not enabled. dppass accepts the same symbolic constants as sfail. The initial value is GL_KEEP.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glStencilOpSeparate")]
        public static extern void StencilOpSeparate(OpenTK.Graphics.OpenGL.StencilFace face, OpenTK.Graphics.OpenGL.StencilOp sfail, OpenTK.Graphics.OpenGL.StencilOp dpfail, OpenTK.Graphics.OpenGL.StencilOp dppass);

        /// <summary>[requires: v3.1]
        /// Attach the storage for a buffer object to the active buffer texture
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target of the operation and must be GL_TEXTURE_BUFFER.
        /// </para>
        /// </param>
        /// <param name="internalFormat">
        /// <para>
        /// Specifies the internal format of the data in the store belonging to buffer.
        /// </para>
        /// </param>
        /// <param name="buffer">
        /// <para>
        /// Specifies the name of the buffer object whose storage to attach to the active buffer texture.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_3_1", Version = "3.1", EntryPoint = "glTexBuffer")]
        public static extern void TexBuffer(OpenTK.Graphics.OpenGL.TextureBufferTarget target, OpenTK.Graphics.OpenGL.SizedInternalFormat internalformat, Int32 buffer);

        /// <summary>[requires: v3.1]
        /// Attach the storage for a buffer object to the active buffer texture
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target of the operation and must be GL_TEXTURE_BUFFER.
        /// </para>
        /// </param>
        /// <param name="internalFormat">
        /// <para>
        /// Specifies the internal format of the data in the store belonging to buffer.
        /// </para>
        /// </param>
        /// <param name="buffer">
        /// <para>
        /// Specifies the name of the buffer object whose storage to attach to the active buffer texture.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_1", Version = "3.1", EntryPoint = "glTexBuffer")]
        public static extern void TexBuffer(OpenTK.Graphics.OpenGL.TextureBufferTarget target, OpenTK.Graphics.OpenGL.SizedInternalFormat internalformat, UInt32 buffer);

        /// <summary>[requires: v4.3 and ARB_texture_buffer_range|VERSION_4_3]
        /// Bind a range of a buffer's data store to a buffer texture
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target of the operation and must be GL_TEXTURE_BUFFER.
        /// </para>
        /// </param>
        /// <param name="internalFormat">
        /// <para>
        /// Specifies the internal format of the data in the store belonging to buffer.
        /// </para>
        /// </param>
        /// <param name="buffer">
        /// <para>
        /// Specifies the name of the buffer object whose storage to attach to the active buffer texture.
        /// </para>
        /// </param>
        /// <param name="offset">
        /// <para>
        /// Specifies the offset of the start of the range of the buffer's data store to attach.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Specifies the size of the range of the buffer's data store to attach.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_texture_buffer_range|VERSION_4_3", Version = "4.3", EntryPoint = "glTexBufferRange")]
        public static extern void TexBufferRange(OpenTK.Graphics.OpenGL.TextureBufferTarget target, OpenTK.Graphics.OpenGL.SizedInternalFormat internalformat, Int32 buffer, IntPtr offset, IntPtr size);

        /// <summary>[requires: v4.3 and ARB_texture_buffer_range|VERSION_4_3]
        /// Bind a range of a buffer's data store to a buffer texture
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target of the operation and must be GL_TEXTURE_BUFFER.
        /// </para>
        /// </param>
        /// <param name="internalFormat">
        /// <para>
        /// Specifies the internal format of the data in the store belonging to buffer.
        /// </para>
        /// </param>
        /// <param name="buffer">
        /// <para>
        /// Specifies the name of the buffer object whose storage to attach to the active buffer texture.
        /// </para>
        /// </param>
        /// <param name="offset">
        /// <para>
        /// Specifies the offset of the start of the range of the buffer's data store to attach.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Specifies the size of the range of the buffer's data store to attach.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_texture_buffer_range|VERSION_4_3", Version = "4.3", EntryPoint = "glTexBufferRange")]
        public static extern void TexBufferRange(OpenTK.Graphics.OpenGL.TextureBufferTarget target, OpenTK.Graphics.OpenGL.SizedInternalFormat internalformat, UInt32 buffer, IntPtr offset, IntPtr size);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord1d")]
        public static extern void TexCoord1(Double s);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord1dv")]
        public static extern unsafe void TexCoord1(Double* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord1f")]
        public static extern void TexCoord1(Single s);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord1fv")]
        public static extern unsafe void TexCoord1(Single* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord1i")]
        public static extern void TexCoord1(Int32 s);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord1iv")]
        public static extern unsafe void TexCoord1(Int32* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord1s")]
        public static extern void TexCoord1(Int16 s);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord1sv")]
        public static extern unsafe void TexCoord1(Int16* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord2d")]
        public static extern void TexCoord2(Double s, Double t);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord2dv")]
        public static extern void TexCoord2(Double[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord2dv")]
        public static extern void TexCoord2(ref Double v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord2dv")]
        public static extern unsafe void TexCoord2(Double* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord2f")]
        public static extern void TexCoord2(Single s, Single t);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord2fv")]
        public static extern void TexCoord2(Single[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord2fv")]
        public static extern void TexCoord2(ref Single v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord2fv")]
        public static extern unsafe void TexCoord2(Single* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord2i")]
        public static extern void TexCoord2(Int32 s, Int32 t);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord2iv")]
        public static extern void TexCoord2(Int32[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord2iv")]
        public static extern void TexCoord2(ref Int32 v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord2iv")]
        public static extern unsafe void TexCoord2(Int32* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord2s")]
        public static extern void TexCoord2(Int16 s, Int16 t);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord2sv")]
        public static extern void TexCoord2(Int16[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord2sv")]
        public static extern void TexCoord2(ref Int16 v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord2sv")]
        public static extern unsafe void TexCoord2(Int16* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord3d")]
        public static extern void TexCoord3(Double s, Double t, Double r);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord3dv")]
        public static extern void TexCoord3(Double[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord3dv")]
        public static extern void TexCoord3(ref Double v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord3dv")]
        public static extern unsafe void TexCoord3(Double* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord3f")]
        public static extern void TexCoord3(Single s, Single t, Single r);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord3fv")]
        public static extern void TexCoord3(Single[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord3fv")]
        public static extern void TexCoord3(ref Single v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord3fv")]
        public static extern unsafe void TexCoord3(Single* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord3i")]
        public static extern void TexCoord3(Int32 s, Int32 t, Int32 r);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord3iv")]
        public static extern void TexCoord3(Int32[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord3iv")]
        public static extern void TexCoord3(ref Int32 v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord3iv")]
        public static extern unsafe void TexCoord3(Int32* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord3s")]
        public static extern void TexCoord3(Int16 s, Int16 t, Int16 r);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord3sv")]
        public static extern void TexCoord3(Int16[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord3sv")]
        public static extern void TexCoord3(ref Int16 v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord3sv")]
        public static extern unsafe void TexCoord3(Int16* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord4d")]
        public static extern void TexCoord4(Double s, Double t, Double r, Double q);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord4dv")]
        public static extern void TexCoord4(Double[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord4dv")]
        public static extern void TexCoord4(ref Double v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord4dv")]
        public static extern unsafe void TexCoord4(Double* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord4f")]
        public static extern void TexCoord4(Single s, Single t, Single r, Single q);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord4fv")]
        public static extern void TexCoord4(Single[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord4fv")]
        public static extern void TexCoord4(ref Single v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord4fv")]
        public static extern unsafe void TexCoord4(Single* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord4i")]
        public static extern void TexCoord4(Int32 s, Int32 t, Int32 r, Int32 q);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord4iv")]
        public static extern void TexCoord4(Int32[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord4iv")]
        public static extern void TexCoord4(ref Int32 v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord4iv")]
        public static extern unsafe void TexCoord4(Int32* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord4s")]
        public static extern void TexCoord4(Int16 s, Int16 t, Int16 r, Int16 q);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord4sv")]
        public static extern void TexCoord4(Int16[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord4sv")]
        public static extern void TexCoord4(ref Int16 v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set the current texture coordinates
        /// </summary>
        /// <param name="s">
        /// <para>
        /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexCoord4sv")]
        public static extern unsafe void TexCoord4(Int16* v);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glTexCoordP1ui")]
        public static extern void TexCoordP1(OpenTK.Graphics.OpenGL.PackedPointerType type, Int32 coords);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glTexCoordP1ui")]
        public static extern void TexCoordP1(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32 coords);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glTexCoordP1uiv")]
        public static extern unsafe void TexCoordP1(OpenTK.Graphics.OpenGL.PackedPointerType type, Int32* coords);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glTexCoordP1uiv")]
        public static extern unsafe void TexCoordP1(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32* coords);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glTexCoordP2ui")]
        public static extern void TexCoordP2(OpenTK.Graphics.OpenGL.PackedPointerType type, Int32 coords);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glTexCoordP2ui")]
        public static extern void TexCoordP2(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32 coords);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glTexCoordP2uiv")]
        public static extern unsafe void TexCoordP2(OpenTK.Graphics.OpenGL.PackedPointerType type, Int32* coords);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glTexCoordP2uiv")]
        public static extern unsafe void TexCoordP2(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32* coords);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glTexCoordP3ui")]
        public static extern void TexCoordP3(OpenTK.Graphics.OpenGL.PackedPointerType type, Int32 coords);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glTexCoordP3ui")]
        public static extern void TexCoordP3(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32 coords);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glTexCoordP3uiv")]
        public static extern unsafe void TexCoordP3(OpenTK.Graphics.OpenGL.PackedPointerType type, Int32* coords);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glTexCoordP3uiv")]
        public static extern unsafe void TexCoordP3(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32* coords);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glTexCoordP4ui")]
        public static extern void TexCoordP4(OpenTK.Graphics.OpenGL.PackedPointerType type, Int32 coords);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glTexCoordP4ui")]
        public static extern void TexCoordP4(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32 coords);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glTexCoordP4uiv")]
        public static extern unsafe void TexCoordP4(OpenTK.Graphics.OpenGL.PackedPointerType type, Int32* coords);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glTexCoordP4uiv")]
        public static extern unsafe void TexCoordP4(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32* coords);

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Define an array of texture coordinates
        /// </summary>
        /// <param name="size">
        /// <para>
        /// Specifies the number of coordinates per array element. Must be 1, 2, 3, or 4. The initial value is 4.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each texture coordinate. Symbolic constants GL_SHORT, GL_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive texture coordinate sets. If stride is 0, the array elements are understood to be tightly packed. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first coordinate of the first texture coordinate set in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glTexCoordPointer")]
        public static extern void TexCoordPointer(Int32 size, OpenTK.Graphics.OpenGL.TexCoordPointerType type, Int32 stride, IntPtr pointer);

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Define an array of texture coordinates
        /// </summary>
        /// <param name="size">
        /// <para>
        /// Specifies the number of coordinates per array element. Must be 1, 2, 3, or 4. The initial value is 4.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each texture coordinate. Symbolic constants GL_SHORT, GL_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive texture coordinate sets. If stride is 0, the array elements are understood to be tightly packed. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first coordinate of the first texture coordinate set in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glTexCoordPointer")]
        public static extern void TexCoordPointer<T3>(Int32 size, OpenTK.Graphics.OpenGL.TexCoordPointerType type, Int32 stride, [InAttribute, OutAttribute] T3[] pointer)
            where T3 : struct
        ;

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Define an array of texture coordinates
        /// </summary>
        /// <param name="size">
        /// <para>
        /// Specifies the number of coordinates per array element. Must be 1, 2, 3, or 4. The initial value is 4.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each texture coordinate. Symbolic constants GL_SHORT, GL_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive texture coordinate sets. If stride is 0, the array elements are understood to be tightly packed. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first coordinate of the first texture coordinate set in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glTexCoordPointer")]
        public static extern void TexCoordPointer<T3>(Int32 size, OpenTK.Graphics.OpenGL.TexCoordPointerType type, Int32 stride, [InAttribute, OutAttribute] T3[,] pointer)
            where T3 : struct
        ;

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Define an array of texture coordinates
        /// </summary>
        /// <param name="size">
        /// <para>
        /// Specifies the number of coordinates per array element. Must be 1, 2, 3, or 4. The initial value is 4.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each texture coordinate. Symbolic constants GL_SHORT, GL_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive texture coordinate sets. If stride is 0, the array elements are understood to be tightly packed. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first coordinate of the first texture coordinate set in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glTexCoordPointer")]
        public static extern void TexCoordPointer<T3>(Int32 size, OpenTK.Graphics.OpenGL.TexCoordPointerType type, Int32 stride, [InAttribute, OutAttribute] T3[,,] pointer)
            where T3 : struct
        ;

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Define an array of texture coordinates
        /// </summary>
        /// <param name="size">
        /// <para>
        /// Specifies the number of coordinates per array element. Must be 1, 2, 3, or 4. The initial value is 4.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each texture coordinate. Symbolic constants GL_SHORT, GL_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive texture coordinate sets. If stride is 0, the array elements are understood to be tightly packed. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first coordinate of the first texture coordinate set in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glTexCoordPointer")]
        public static extern void TexCoordPointer<T3>(Int32 size, OpenTK.Graphics.OpenGL.TexCoordPointerType type, Int32 stride, [InAttribute, OutAttribute] ref T3 pointer)
            where T3 : struct
        ;

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set texture environment parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies a texture environment. May be GL_TEXTURE_ENV, GL_TEXTURE_FILTER_CONTROL or GL_POINT_SPRITE.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a single-valued texture environment parameter. May be either GL_TEXTURE_ENV_MODE, GL_TEXTURE_LOD_BIAS, GL_COMBINE_RGB, GL_COMBINE_ALPHA, GL_SRC0_RGB, GL_SRC1_RGB, GL_SRC2_RGB, GL_SRC0_ALPHA, GL_SRC1_ALPHA, GL_SRC2_ALPHA, GL_OPERAND0_RGB, GL_OPERAND1_RGB, GL_OPERAND2_RGB, GL_OPERAND0_ALPHA, GL_OPERAND1_ALPHA, GL_OPERAND2_ALPHA, GL_RGB_SCALE, GL_ALPHA_SCALE, or GL_COORD_REPLACE.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies a single symbolic constant, one of GL_ADD, GL_ADD_SIGNED, GL_INTERPOLATE, GL_MODULATE, GL_DECAL, GL_BLEND, GL_REPLACE, GL_SUBTRACT, GL_COMBINE, GL_TEXTURE, GL_CONSTANT, GL_PRIMARY_COLOR, GL_PREVIOUS, GL_SRC_COLOR, GL_ONE_MINUS_SRC_COLOR, GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA, a single boolean value for the point sprite texture coordinate replacement, a single floating-point value for the texture level-of-detail bias, or 1.0, 2.0, or 4.0 when specifying the GL_RGB_SCALE or GL_ALPHA_SCALE.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexEnvf")]
        public static extern void TexEnv(OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, Single param);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set texture environment parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies a texture environment. May be GL_TEXTURE_ENV, GL_TEXTURE_FILTER_CONTROL or GL_POINT_SPRITE.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a single-valued texture environment parameter. May be either GL_TEXTURE_ENV_MODE, GL_TEXTURE_LOD_BIAS, GL_COMBINE_RGB, GL_COMBINE_ALPHA, GL_SRC0_RGB, GL_SRC1_RGB, GL_SRC2_RGB, GL_SRC0_ALPHA, GL_SRC1_ALPHA, GL_SRC2_ALPHA, GL_OPERAND0_RGB, GL_OPERAND1_RGB, GL_OPERAND2_RGB, GL_OPERAND0_ALPHA, GL_OPERAND1_ALPHA, GL_OPERAND2_ALPHA, GL_RGB_SCALE, GL_ALPHA_SCALE, or GL_COORD_REPLACE.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies a single symbolic constant, one of GL_ADD, GL_ADD_SIGNED, GL_INTERPOLATE, GL_MODULATE, GL_DECAL, GL_BLEND, GL_REPLACE, GL_SUBTRACT, GL_COMBINE, GL_TEXTURE, GL_CONSTANT, GL_PRIMARY_COLOR, GL_PREVIOUS, GL_SRC_COLOR, GL_ONE_MINUS_SRC_COLOR, GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA, a single boolean value for the point sprite texture coordinate replacement, a single floating-point value for the texture level-of-detail bias, or 1.0, 2.0, or 4.0 when specifying the GL_RGB_SCALE or GL_ALPHA_SCALE.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexEnvfv")]
        public static extern void TexEnv(OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, Single[] @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set texture environment parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies a texture environment. May be GL_TEXTURE_ENV, GL_TEXTURE_FILTER_CONTROL or GL_POINT_SPRITE.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a single-valued texture environment parameter. May be either GL_TEXTURE_ENV_MODE, GL_TEXTURE_LOD_BIAS, GL_COMBINE_RGB, GL_COMBINE_ALPHA, GL_SRC0_RGB, GL_SRC1_RGB, GL_SRC2_RGB, GL_SRC0_ALPHA, GL_SRC1_ALPHA, GL_SRC2_ALPHA, GL_OPERAND0_RGB, GL_OPERAND1_RGB, GL_OPERAND2_RGB, GL_OPERAND0_ALPHA, GL_OPERAND1_ALPHA, GL_OPERAND2_ALPHA, GL_RGB_SCALE, GL_ALPHA_SCALE, or GL_COORD_REPLACE.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies a single symbolic constant, one of GL_ADD, GL_ADD_SIGNED, GL_INTERPOLATE, GL_MODULATE, GL_DECAL, GL_BLEND, GL_REPLACE, GL_SUBTRACT, GL_COMBINE, GL_TEXTURE, GL_CONSTANT, GL_PRIMARY_COLOR, GL_PREVIOUS, GL_SRC_COLOR, GL_ONE_MINUS_SRC_COLOR, GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA, a single boolean value for the point sprite texture coordinate replacement, a single floating-point value for the texture level-of-detail bias, or 1.0, 2.0, or 4.0 when specifying the GL_RGB_SCALE or GL_ALPHA_SCALE.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexEnvfv")]
        public static extern unsafe void TexEnv(OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, Single* @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set texture environment parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies a texture environment. May be GL_TEXTURE_ENV, GL_TEXTURE_FILTER_CONTROL or GL_POINT_SPRITE.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a single-valued texture environment parameter. May be either GL_TEXTURE_ENV_MODE, GL_TEXTURE_LOD_BIAS, GL_COMBINE_RGB, GL_COMBINE_ALPHA, GL_SRC0_RGB, GL_SRC1_RGB, GL_SRC2_RGB, GL_SRC0_ALPHA, GL_SRC1_ALPHA, GL_SRC2_ALPHA, GL_OPERAND0_RGB, GL_OPERAND1_RGB, GL_OPERAND2_RGB, GL_OPERAND0_ALPHA, GL_OPERAND1_ALPHA, GL_OPERAND2_ALPHA, GL_RGB_SCALE, GL_ALPHA_SCALE, or GL_COORD_REPLACE.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies a single symbolic constant, one of GL_ADD, GL_ADD_SIGNED, GL_INTERPOLATE, GL_MODULATE, GL_DECAL, GL_BLEND, GL_REPLACE, GL_SUBTRACT, GL_COMBINE, GL_TEXTURE, GL_CONSTANT, GL_PRIMARY_COLOR, GL_PREVIOUS, GL_SRC_COLOR, GL_ONE_MINUS_SRC_COLOR, GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA, a single boolean value for the point sprite texture coordinate replacement, a single floating-point value for the texture level-of-detail bias, or 1.0, 2.0, or 4.0 when specifying the GL_RGB_SCALE or GL_ALPHA_SCALE.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexEnvi")]
        public static extern void TexEnv(OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, Int32 param);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set texture environment parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies a texture environment. May be GL_TEXTURE_ENV, GL_TEXTURE_FILTER_CONTROL or GL_POINT_SPRITE.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a single-valued texture environment parameter. May be either GL_TEXTURE_ENV_MODE, GL_TEXTURE_LOD_BIAS, GL_COMBINE_RGB, GL_COMBINE_ALPHA, GL_SRC0_RGB, GL_SRC1_RGB, GL_SRC2_RGB, GL_SRC0_ALPHA, GL_SRC1_ALPHA, GL_SRC2_ALPHA, GL_OPERAND0_RGB, GL_OPERAND1_RGB, GL_OPERAND2_RGB, GL_OPERAND0_ALPHA, GL_OPERAND1_ALPHA, GL_OPERAND2_ALPHA, GL_RGB_SCALE, GL_ALPHA_SCALE, or GL_COORD_REPLACE.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies a single symbolic constant, one of GL_ADD, GL_ADD_SIGNED, GL_INTERPOLATE, GL_MODULATE, GL_DECAL, GL_BLEND, GL_REPLACE, GL_SUBTRACT, GL_COMBINE, GL_TEXTURE, GL_CONSTANT, GL_PRIMARY_COLOR, GL_PREVIOUS, GL_SRC_COLOR, GL_ONE_MINUS_SRC_COLOR, GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA, a single boolean value for the point sprite texture coordinate replacement, a single floating-point value for the texture level-of-detail bias, or 1.0, 2.0, or 4.0 when specifying the GL_RGB_SCALE or GL_ALPHA_SCALE.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexEnviv")]
        public static extern void TexEnv(OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, Int32[] @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Set texture environment parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies a texture environment. May be GL_TEXTURE_ENV, GL_TEXTURE_FILTER_CONTROL or GL_POINT_SPRITE.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a single-valued texture environment parameter. May be either GL_TEXTURE_ENV_MODE, GL_TEXTURE_LOD_BIAS, GL_COMBINE_RGB, GL_COMBINE_ALPHA, GL_SRC0_RGB, GL_SRC1_RGB, GL_SRC2_RGB, GL_SRC0_ALPHA, GL_SRC1_ALPHA, GL_SRC2_ALPHA, GL_OPERAND0_RGB, GL_OPERAND1_RGB, GL_OPERAND2_RGB, GL_OPERAND0_ALPHA, GL_OPERAND1_ALPHA, GL_OPERAND2_ALPHA, GL_RGB_SCALE, GL_ALPHA_SCALE, or GL_COORD_REPLACE.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies a single symbolic constant, one of GL_ADD, GL_ADD_SIGNED, GL_INTERPOLATE, GL_MODULATE, GL_DECAL, GL_BLEND, GL_REPLACE, GL_SUBTRACT, GL_COMBINE, GL_TEXTURE, GL_CONSTANT, GL_PRIMARY_COLOR, GL_PREVIOUS, GL_SRC_COLOR, GL_ONE_MINUS_SRC_COLOR, GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA, a single boolean value for the point sprite texture coordinate replacement, a single floating-point value for the texture level-of-detail bias, or 1.0, 2.0, or 4.0 when specifying the GL_RGB_SCALE or GL_ALPHA_SCALE.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexEnviv")]
        public static extern unsafe void TexEnv(OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, Int32* @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]</summary>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexGend")]
        public static extern void TexGend(OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, Double param);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Control the generation of texture coordinates
        /// </summary>
        /// <param name="coord">
        /// <para>
        /// Specifies a texture coordinate. Must be one of GL_S, GL_T, GL_R, or GL_Q.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the texture-coordinate generation function. Must be GL_TEXTURE_GEN_MODE.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies a single-valued texture generation parameter, one of GL_OBJECT_LINEAR, GL_EYE_LINEAR, GL_SPHERE_MAP, GL_NORMAL_MAP, or GL_REFLECTION_MAP.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexGendv")]
        public static extern void TexGen(OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, Double[] @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Control the generation of texture coordinates
        /// </summary>
        /// <param name="coord">
        /// <para>
        /// Specifies a texture coordinate. Must be one of GL_S, GL_T, GL_R, or GL_Q.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the texture-coordinate generation function. Must be GL_TEXTURE_GEN_MODE.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies a single-valued texture generation parameter, one of GL_OBJECT_LINEAR, GL_EYE_LINEAR, GL_SPHERE_MAP, GL_NORMAL_MAP, or GL_REFLECTION_MAP.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexGendv")]
        public static extern void TexGen(OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, ref Double @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Control the generation of texture coordinates
        /// </summary>
        /// <param name="coord">
        /// <para>
        /// Specifies a texture coordinate. Must be one of GL_S, GL_T, GL_R, or GL_Q.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the texture-coordinate generation function. Must be GL_TEXTURE_GEN_MODE.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies a single-valued texture generation parameter, one of GL_OBJECT_LINEAR, GL_EYE_LINEAR, GL_SPHERE_MAP, GL_NORMAL_MAP, or GL_REFLECTION_MAP.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexGendv")]
        public static extern unsafe void TexGen(OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, Double* @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Control the generation of texture coordinates
        /// </summary>
        /// <param name="coord">
        /// <para>
        /// Specifies a texture coordinate. Must be one of GL_S, GL_T, GL_R, or GL_Q.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the texture-coordinate generation function. Must be GL_TEXTURE_GEN_MODE.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies a single-valued texture generation parameter, one of GL_OBJECT_LINEAR, GL_EYE_LINEAR, GL_SPHERE_MAP, GL_NORMAL_MAP, or GL_REFLECTION_MAP.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexGenf")]
        public static extern void TexGen(OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, Single param);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Control the generation of texture coordinates
        /// </summary>
        /// <param name="coord">
        /// <para>
        /// Specifies a texture coordinate. Must be one of GL_S, GL_T, GL_R, or GL_Q.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the texture-coordinate generation function. Must be GL_TEXTURE_GEN_MODE.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies a single-valued texture generation parameter, one of GL_OBJECT_LINEAR, GL_EYE_LINEAR, GL_SPHERE_MAP, GL_NORMAL_MAP, or GL_REFLECTION_MAP.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexGenfv")]
        public static extern void TexGen(OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, Single[] @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Control the generation of texture coordinates
        /// </summary>
        /// <param name="coord">
        /// <para>
        /// Specifies a texture coordinate. Must be one of GL_S, GL_T, GL_R, or GL_Q.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the texture-coordinate generation function. Must be GL_TEXTURE_GEN_MODE.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies a single-valued texture generation parameter, one of GL_OBJECT_LINEAR, GL_EYE_LINEAR, GL_SPHERE_MAP, GL_NORMAL_MAP, or GL_REFLECTION_MAP.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexGenfv")]
        public static extern unsafe void TexGen(OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, Single* @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Control the generation of texture coordinates
        /// </summary>
        /// <param name="coord">
        /// <para>
        /// Specifies a texture coordinate. Must be one of GL_S, GL_T, GL_R, or GL_Q.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the texture-coordinate generation function. Must be GL_TEXTURE_GEN_MODE.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies a single-valued texture generation parameter, one of GL_OBJECT_LINEAR, GL_EYE_LINEAR, GL_SPHERE_MAP, GL_NORMAL_MAP, or GL_REFLECTION_MAP.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexGeni")]
        public static extern void TexGen(OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, Int32 param);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Control the generation of texture coordinates
        /// </summary>
        /// <param name="coord">
        /// <para>
        /// Specifies a texture coordinate. Must be one of GL_S, GL_T, GL_R, or GL_Q.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the texture-coordinate generation function. Must be GL_TEXTURE_GEN_MODE.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies a single-valued texture generation parameter, one of GL_OBJECT_LINEAR, GL_EYE_LINEAR, GL_SPHERE_MAP, GL_NORMAL_MAP, or GL_REFLECTION_MAP.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexGeniv")]
        public static extern void TexGen(OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, Int32[] @params);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Control the generation of texture coordinates
        /// </summary>
        /// <param name="coord">
        /// <para>
        /// Specifies a texture coordinate. Must be one of GL_S, GL_T, GL_R, or GL_Q.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of the texture-coordinate generation function. Must be GL_TEXTURE_GEN_MODE.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// Specifies a single-valued texture generation parameter, one of GL_OBJECT_LINEAR, GL_EYE_LINEAR, GL_SPHERE_MAP, GL_NORMAL_MAP, or GL_REFLECTION_MAP.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexGeniv")]
        public static extern unsafe void TexGen(OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, Int32* @params);

        /// <summary>[requires: v1.0]
        /// Specify a one-dimensional texture image
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_1D or GL_PROXY_TEXTURE_1D.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="internalFormat">
        /// <para>
        /// Specifies the number of color components in the texture. Must be one of base internal formats given in Table 1, one of the sized internal formats given in Table 2, or one of the compressed internal formats given in Table 3, below.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture image. All implementations support texture images that are at least 1024 texels wide. The height of the 1D texture image is 1.
        /// </para>
        /// </param>
        /// <param name="border">
        /// <para>
        /// This value must be 0.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_RED_INTEGER, GL_RG_INTEGER, GL_RGB_INTEGER, GL_BGR_INTEGER, GL_RGBA_INTEGER, GL_BGRA_INTEGER, GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_DEPTH_STENCIL.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexImage1D")]
        public static extern void TexImage1D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

        /// <summary>[requires: v1.0]
        /// Specify a one-dimensional texture image
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_1D or GL_PROXY_TEXTURE_1D.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="internalFormat">
        /// <para>
        /// Specifies the number of color components in the texture. Must be one of base internal formats given in Table 1, one of the sized internal formats given in Table 2, or one of the compressed internal formats given in Table 3, below.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture image. All implementations support texture images that are at least 1024 texels wide. The height of the 1D texture image is 1.
        /// </para>
        /// </param>
        /// <param name="border">
        /// <para>
        /// This value must be 0.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_RED_INTEGER, GL_RG_INTEGER, GL_RGB_INTEGER, GL_BGR_INTEGER, GL_RGBA_INTEGER, GL_BGRA_INTEGER, GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_DEPTH_STENCIL.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexImage1D")]
        public static extern void TexImage1D<T7>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T7[] pixels)
            where T7 : struct
        ;

        /// <summary>[requires: v1.0]
        /// Specify a one-dimensional texture image
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_1D or GL_PROXY_TEXTURE_1D.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="internalFormat">
        /// <para>
        /// Specifies the number of color components in the texture. Must be one of base internal formats given in Table 1, one of the sized internal formats given in Table 2, or one of the compressed internal formats given in Table 3, below.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture image. All implementations support texture images that are at least 1024 texels wide. The height of the 1D texture image is 1.
        /// </para>
        /// </param>
        /// <param name="border">
        /// <para>
        /// This value must be 0.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_RED_INTEGER, GL_RG_INTEGER, GL_RGB_INTEGER, GL_BGR_INTEGER, GL_RGBA_INTEGER, GL_BGRA_INTEGER, GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_DEPTH_STENCIL.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexImage1D")]
        public static extern void TexImage1D<T7>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T7[,] pixels)
            where T7 : struct
        ;

        /// <summary>[requires: v1.0]
        /// Specify a one-dimensional texture image
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_1D or GL_PROXY_TEXTURE_1D.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="internalFormat">
        /// <para>
        /// Specifies the number of color components in the texture. Must be one of base internal formats given in Table 1, one of the sized internal formats given in Table 2, or one of the compressed internal formats given in Table 3, below.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture image. All implementations support texture images that are at least 1024 texels wide. The height of the 1D texture image is 1.
        /// </para>
        /// </param>
        /// <param name="border">
        /// <para>
        /// This value must be 0.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_RED_INTEGER, GL_RG_INTEGER, GL_RGB_INTEGER, GL_BGR_INTEGER, GL_RGBA_INTEGER, GL_BGRA_INTEGER, GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_DEPTH_STENCIL.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexImage1D")]
        public static extern void TexImage1D<T7>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T7[,,] pixels)
            where T7 : struct
        ;

        /// <summary>[requires: v1.0]
        /// Specify a one-dimensional texture image
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_1D or GL_PROXY_TEXTURE_1D.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="internalFormat">
        /// <para>
        /// Specifies the number of color components in the texture. Must be one of base internal formats given in Table 1, one of the sized internal formats given in Table 2, or one of the compressed internal formats given in Table 3, below.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture image. All implementations support texture images that are at least 1024 texels wide. The height of the 1D texture image is 1.
        /// </para>
        /// </param>
        /// <param name="border">
        /// <para>
        /// This value must be 0.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_RED_INTEGER, GL_RG_INTEGER, GL_RGB_INTEGER, GL_BGR_INTEGER, GL_RGBA_INTEGER, GL_BGRA_INTEGER, GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_DEPTH_STENCIL.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexImage1D")]
        public static extern void TexImage1D<T7>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T7 pixels)
            where T7 : struct
        ;

        /// <summary>[requires: v1.0]
        /// Specify a two-dimensional texture image
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_PROXY_TEXTURE_2D, GL_TEXTURE_1D_ARRAY, GL_PROXY_TEXTURE_1D_ARRAY, GL_TEXTURE_RECTANGLE, GL_PROXY_TEXTURE_RECTANGLE, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, or GL_PROXY_TEXTURE_CUBE_MAP.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image. If target is GL_TEXTURE_RECTANGLE or GL_PROXY_TEXTURE_RECTANGLE, level must be 0.
        /// </para>
        /// </param>
        /// <param name="internalFormat">
        /// <para>
        /// Specifies the number of color components in the texture. Must be one of base internal formats given in Table 1, one of the sized internal formats given in Table 2, or one of the compressed internal formats given in Table 3, below.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture image. All implementations support texture images that are at least 1024 texels wide.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture image, or the number of layers in a texture array, in the case of the GL_TEXTURE_1D_ARRAY and GL_PROXY_TEXTURE_1D_ARRAY targets. All implementations support 2D texture images that are at least 1024 texels high, and texture arrays that are at least 256 layers deep.
        /// </para>
        /// </param>
        /// <param name="border">
        /// <para>
        /// This value must be 0.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_RED_INTEGER, GL_RG_INTEGER, GL_RGB_INTEGER, GL_BGR_INTEGER, GL_RGBA_INTEGER, GL_BGRA_INTEGER, GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_DEPTH_STENCIL.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexImage2D")]
        public static extern void TexImage2D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

        /// <summary>[requires: v1.0]
        /// Specify a two-dimensional texture image
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_PROXY_TEXTURE_2D, GL_TEXTURE_1D_ARRAY, GL_PROXY_TEXTURE_1D_ARRAY, GL_TEXTURE_RECTANGLE, GL_PROXY_TEXTURE_RECTANGLE, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, or GL_PROXY_TEXTURE_CUBE_MAP.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image. If target is GL_TEXTURE_RECTANGLE or GL_PROXY_TEXTURE_RECTANGLE, level must be 0.
        /// </para>
        /// </param>
        /// <param name="internalFormat">
        /// <para>
        /// Specifies the number of color components in the texture. Must be one of base internal formats given in Table 1, one of the sized internal formats given in Table 2, or one of the compressed internal formats given in Table 3, below.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture image. All implementations support texture images that are at least 1024 texels wide.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture image, or the number of layers in a texture array, in the case of the GL_TEXTURE_1D_ARRAY and GL_PROXY_TEXTURE_1D_ARRAY targets. All implementations support 2D texture images that are at least 1024 texels high, and texture arrays that are at least 256 layers deep.
        /// </para>
        /// </param>
        /// <param name="border">
        /// <para>
        /// This value must be 0.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_RED_INTEGER, GL_RG_INTEGER, GL_RGB_INTEGER, GL_BGR_INTEGER, GL_RGBA_INTEGER, GL_BGRA_INTEGER, GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_DEPTH_STENCIL.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexImage2D")]
        public static extern void TexImage2D<T8>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T8[] pixels)
            where T8 : struct
        ;

        /// <summary>[requires: v1.0]
        /// Specify a two-dimensional texture image
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_PROXY_TEXTURE_2D, GL_TEXTURE_1D_ARRAY, GL_PROXY_TEXTURE_1D_ARRAY, GL_TEXTURE_RECTANGLE, GL_PROXY_TEXTURE_RECTANGLE, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, or GL_PROXY_TEXTURE_CUBE_MAP.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image. If target is GL_TEXTURE_RECTANGLE or GL_PROXY_TEXTURE_RECTANGLE, level must be 0.
        /// </para>
        /// </param>
        /// <param name="internalFormat">
        /// <para>
        /// Specifies the number of color components in the texture. Must be one of base internal formats given in Table 1, one of the sized internal formats given in Table 2, or one of the compressed internal formats given in Table 3, below.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture image. All implementations support texture images that are at least 1024 texels wide.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture image, or the number of layers in a texture array, in the case of the GL_TEXTURE_1D_ARRAY and GL_PROXY_TEXTURE_1D_ARRAY targets. All implementations support 2D texture images that are at least 1024 texels high, and texture arrays that are at least 256 layers deep.
        /// </para>
        /// </param>
        /// <param name="border">
        /// <para>
        /// This value must be 0.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_RED_INTEGER, GL_RG_INTEGER, GL_RGB_INTEGER, GL_BGR_INTEGER, GL_RGBA_INTEGER, GL_BGRA_INTEGER, GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_DEPTH_STENCIL.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexImage2D")]
        public static extern void TexImage2D<T8>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T8[,] pixels)
            where T8 : struct
        ;

        /// <summary>[requires: v1.0]
        /// Specify a two-dimensional texture image
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_PROXY_TEXTURE_2D, GL_TEXTURE_1D_ARRAY, GL_PROXY_TEXTURE_1D_ARRAY, GL_TEXTURE_RECTANGLE, GL_PROXY_TEXTURE_RECTANGLE, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, or GL_PROXY_TEXTURE_CUBE_MAP.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image. If target is GL_TEXTURE_RECTANGLE or GL_PROXY_TEXTURE_RECTANGLE, level must be 0.
        /// </para>
        /// </param>
        /// <param name="internalFormat">
        /// <para>
        /// Specifies the number of color components in the texture. Must be one of base internal formats given in Table 1, one of the sized internal formats given in Table 2, or one of the compressed internal formats given in Table 3, below.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture image. All implementations support texture images that are at least 1024 texels wide.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture image, or the number of layers in a texture array, in the case of the GL_TEXTURE_1D_ARRAY and GL_PROXY_TEXTURE_1D_ARRAY targets. All implementations support 2D texture images that are at least 1024 texels high, and texture arrays that are at least 256 layers deep.
        /// </para>
        /// </param>
        /// <param name="border">
        /// <para>
        /// This value must be 0.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_RED_INTEGER, GL_RG_INTEGER, GL_RGB_INTEGER, GL_BGR_INTEGER, GL_RGBA_INTEGER, GL_BGRA_INTEGER, GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_DEPTH_STENCIL.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexImage2D")]
        public static extern void TexImage2D<T8>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T8[,,] pixels)
            where T8 : struct
        ;

        /// <summary>[requires: v1.0]
        /// Specify a two-dimensional texture image
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_PROXY_TEXTURE_2D, GL_TEXTURE_1D_ARRAY, GL_PROXY_TEXTURE_1D_ARRAY, GL_TEXTURE_RECTANGLE, GL_PROXY_TEXTURE_RECTANGLE, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, or GL_PROXY_TEXTURE_CUBE_MAP.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image. If target is GL_TEXTURE_RECTANGLE or GL_PROXY_TEXTURE_RECTANGLE, level must be 0.
        /// </para>
        /// </param>
        /// <param name="internalFormat">
        /// <para>
        /// Specifies the number of color components in the texture. Must be one of base internal formats given in Table 1, one of the sized internal formats given in Table 2, or one of the compressed internal formats given in Table 3, below.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture image. All implementations support texture images that are at least 1024 texels wide.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture image, or the number of layers in a texture array, in the case of the GL_TEXTURE_1D_ARRAY and GL_PROXY_TEXTURE_1D_ARRAY targets. All implementations support 2D texture images that are at least 1024 texels high, and texture arrays that are at least 256 layers deep.
        /// </para>
        /// </param>
        /// <param name="border">
        /// <para>
        /// This value must be 0.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_RED_INTEGER, GL_RG_INTEGER, GL_RGB_INTEGER, GL_BGR_INTEGER, GL_RGBA_INTEGER, GL_BGRA_INTEGER, GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_DEPTH_STENCIL.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexImage2D")]
        public static extern void TexImage2D<T8>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T8 pixels)
            where T8 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_texture_multisample|VERSION_3_2]
        /// Establish the data storage, format, dimensions, and number of samples of a multisample texture's image
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target of the operation. target must be GL_TEXTURE_2D_MULTISAMPLE or GL_PROXY_TEXTURE_2D_MULTISAMPLE.
        /// </para>
        /// </param>
        /// <param name="samples">
        /// <para>
        /// The number of samples in the multisample texture's image.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The internal format to be used to store the multisample texture's image. internalformat must specify a color-renderable, depth-renderable, or stencil-renderable format.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The width of the multisample texture's image, in texels.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// The height of the multisample texture's image, in texels.
        /// </para>
        /// </param>
        /// <param name="fixedsamplelocations">
        /// <para>
        /// Specifies whether the image will use identical sample locations and the same number of samples for all texels in the image, and the sample locations will not depend on the internal format or size of the image.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_texture_multisample|VERSION_3_2", Version = "3.2", EntryPoint = "glTexImage2DMultisample")]
        public static extern void TexImage2DMultisample(OpenTK.Graphics.OpenGL.TextureTargetMultisample target, Int32 samples, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, bool fixedsamplelocations);

        /// <summary>[requires: v1.2]
        /// Specify a three-dimensional texture image
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be one of GL_TEXTURE_3D, GL_PROXY_TEXTURE_3D, GL_TEXTURE_2D_ARRAY or GL_PROXY_TEXTURE_2D_ARRAY.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level is the n sup th mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="internalFormat">
        /// <para>
        /// Specifies the number of color components in the texture. Must be one of base internal formats given in Table 1, one of the sized internal formats given in Table 2, or one of the compressed internal formats given in Table 3, below.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture image. All implementations support 3D texture images that are at least 16 texels wide.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture image. All implementations support 3D texture images that are at least 256 texels high.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// Specifies the depth of the texture image, or the number of layers in a texture array. All implementations support 3D texture images that are at least 256 texels deep, and texture arrays that are at least 256 layers deep.
        /// </para>
        /// </param>
        /// <param name="border">
        /// <para>
        /// This value must be 0.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_RED_INTEGER, GL_RG_INTEGER, GL_RGB_INTEGER, GL_BGR_INTEGER, GL_RGBA_INTEGER, GL_BGRA_INTEGER, GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_DEPTH_STENCIL.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_2", Version = "1.2", EntryPoint = "glTexImage3D")]
        public static extern void TexImage3D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

        /// <summary>[requires: v1.2]
        /// Specify a three-dimensional texture image
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be one of GL_TEXTURE_3D, GL_PROXY_TEXTURE_3D, GL_TEXTURE_2D_ARRAY or GL_PROXY_TEXTURE_2D_ARRAY.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level is the n sup th mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="internalFormat">
        /// <para>
        /// Specifies the number of color components in the texture. Must be one of base internal formats given in Table 1, one of the sized internal formats given in Table 2, or one of the compressed internal formats given in Table 3, below.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture image. All implementations support 3D texture images that are at least 16 texels wide.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture image. All implementations support 3D texture images that are at least 256 texels high.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// Specifies the depth of the texture image, or the number of layers in a texture array. All implementations support 3D texture images that are at least 256 texels deep, and texture arrays that are at least 256 layers deep.
        /// </para>
        /// </param>
        /// <param name="border">
        /// <para>
        /// This value must be 0.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_RED_INTEGER, GL_RG_INTEGER, GL_RGB_INTEGER, GL_BGR_INTEGER, GL_RGBA_INTEGER, GL_BGRA_INTEGER, GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_DEPTH_STENCIL.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_2", Version = "1.2", EntryPoint = "glTexImage3D")]
        public static extern void TexImage3D<T9>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T9[] pixels)
            where T9 : struct
        ;

        /// <summary>[requires: v1.2]
        /// Specify a three-dimensional texture image
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be one of GL_TEXTURE_3D, GL_PROXY_TEXTURE_3D, GL_TEXTURE_2D_ARRAY or GL_PROXY_TEXTURE_2D_ARRAY.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level is the n sup th mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="internalFormat">
        /// <para>
        /// Specifies the number of color components in the texture. Must be one of base internal formats given in Table 1, one of the sized internal formats given in Table 2, or one of the compressed internal formats given in Table 3, below.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture image. All implementations support 3D texture images that are at least 16 texels wide.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture image. All implementations support 3D texture images that are at least 256 texels high.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// Specifies the depth of the texture image, or the number of layers in a texture array. All implementations support 3D texture images that are at least 256 texels deep, and texture arrays that are at least 256 layers deep.
        /// </para>
        /// </param>
        /// <param name="border">
        /// <para>
        /// This value must be 0.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_RED_INTEGER, GL_RG_INTEGER, GL_RGB_INTEGER, GL_BGR_INTEGER, GL_RGBA_INTEGER, GL_BGRA_INTEGER, GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_DEPTH_STENCIL.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_2", Version = "1.2", EntryPoint = "glTexImage3D")]
        public static extern void TexImage3D<T9>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T9[,] pixels)
            where T9 : struct
        ;

        /// <summary>[requires: v1.2]
        /// Specify a three-dimensional texture image
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be one of GL_TEXTURE_3D, GL_PROXY_TEXTURE_3D, GL_TEXTURE_2D_ARRAY or GL_PROXY_TEXTURE_2D_ARRAY.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level is the n sup th mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="internalFormat">
        /// <para>
        /// Specifies the number of color components in the texture. Must be one of base internal formats given in Table 1, one of the sized internal formats given in Table 2, or one of the compressed internal formats given in Table 3, below.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture image. All implementations support 3D texture images that are at least 16 texels wide.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture image. All implementations support 3D texture images that are at least 256 texels high.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// Specifies the depth of the texture image, or the number of layers in a texture array. All implementations support 3D texture images that are at least 256 texels deep, and texture arrays that are at least 256 layers deep.
        /// </para>
        /// </param>
        /// <param name="border">
        /// <para>
        /// This value must be 0.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_RED_INTEGER, GL_RG_INTEGER, GL_RGB_INTEGER, GL_BGR_INTEGER, GL_RGBA_INTEGER, GL_BGRA_INTEGER, GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_DEPTH_STENCIL.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_2", Version = "1.2", EntryPoint = "glTexImage3D")]
        public static extern void TexImage3D<T9>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T9[,,] pixels)
            where T9 : struct
        ;

        /// <summary>[requires: v1.2]
        /// Specify a three-dimensional texture image
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be one of GL_TEXTURE_3D, GL_PROXY_TEXTURE_3D, GL_TEXTURE_2D_ARRAY or GL_PROXY_TEXTURE_2D_ARRAY.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level is the n sup th mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="internalFormat">
        /// <para>
        /// Specifies the number of color components in the texture. Must be one of base internal formats given in Table 1, one of the sized internal formats given in Table 2, or one of the compressed internal formats given in Table 3, below.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture image. All implementations support 3D texture images that are at least 16 texels wide.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture image. All implementations support 3D texture images that are at least 256 texels high.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// Specifies the depth of the texture image, or the number of layers in a texture array. All implementations support 3D texture images that are at least 256 texels deep, and texture arrays that are at least 256 layers deep.
        /// </para>
        /// </param>
        /// <param name="border">
        /// <para>
        /// This value must be 0.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_RED_INTEGER, GL_RG_INTEGER, GL_RGB_INTEGER, GL_BGR_INTEGER, GL_RGBA_INTEGER, GL_BGRA_INTEGER, GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_DEPTH_STENCIL.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_2", Version = "1.2", EntryPoint = "glTexImage3D")]
        public static extern void TexImage3D<T9>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T9 pixels)
            where T9 : struct
        ;

        /// <summary>[requires: v3.2 and ARB_texture_multisample|VERSION_3_2]
        /// Establish the data storage, format, dimensions, and number of samples of a multisample texture's image
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target of the operation. target must be GL_TEXTURE_2D_MULTISAMPLE_ARRAY or GL_PROXY_TEXTURE_2D_MULTISAMPLE_ARRAY.
        /// </para>
        /// </param>
        /// <param name="samples">
        /// <para>
        /// The number of samples in the multisample texture's image.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// The internal format to be used to store the multisample texture's image. internalformat must specify a color-renderable, depth-renderable, or stencil-renderable format.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// The width of the multisample texture's image, in texels.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// The height of the multisample texture's image, in texels.
        /// </para>
        /// </param>
        /// <param name="fixedsamplelocations">
        /// <para>
        /// Specifies whether the image will use identical sample locations and the same number of samples for all texels in the image, and the sample locations will not depend on the internal format or size of the image.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_texture_multisample|VERSION_3_2", Version = "3.2", EntryPoint = "glTexImage3DMultisample")]
        public static extern void TexImage3DMultisample(OpenTK.Graphics.OpenGL.TextureTargetMultisample target, Int32 samples, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 depth, bool fixedsamplelocations);

        /// <summary>[requires: v1.0]
        /// Set texture parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture, which must be either GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_RECTANGLE, or GL_TEXTURE_CUBE_MAP.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a single-valued texture parameter. pname can be one of the following: GL_DEPTH_STENCIL_TEXTURE_MODE, GL_TEXTURE_BASE_LEVEL, GL_TEXTURE_COMPARE_FUNC, GL_TEXTURE_COMPARE_MODE, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MAG_FILTER, GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_MAX_LEVEL, GL_TEXTURE_SWIZZLE_R, GL_TEXTURE_SWIZZLE_G, GL_TEXTURE_SWIZZLE_B, GL_TEXTURE_SWIZZLE_A, GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, or GL_TEXTURE_WRAP_R.
        /// </para>
        /// <para>
        /// For the vector commands (glTexParameter*v), pname can also be one of GL_TEXTURE_BORDER_COLOR or GL_TEXTURE_SWIZZLE_RGBA.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// For the scalar commands, specifies the value of pname.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// For the vector commands, specifies a pointer to an array where the value or values of pname are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexParameterf")]
        public static extern void TexParameter(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Single param);

        /// <summary>[requires: v1.0]
        /// Set texture parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture, which must be either GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_RECTANGLE, or GL_TEXTURE_CUBE_MAP.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a single-valued texture parameter. pname can be one of the following: GL_DEPTH_STENCIL_TEXTURE_MODE, GL_TEXTURE_BASE_LEVEL, GL_TEXTURE_COMPARE_FUNC, GL_TEXTURE_COMPARE_MODE, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MAG_FILTER, GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_MAX_LEVEL, GL_TEXTURE_SWIZZLE_R, GL_TEXTURE_SWIZZLE_G, GL_TEXTURE_SWIZZLE_B, GL_TEXTURE_SWIZZLE_A, GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, or GL_TEXTURE_WRAP_R.
        /// </para>
        /// <para>
        /// For the vector commands (glTexParameter*v), pname can also be one of GL_TEXTURE_BORDER_COLOR or GL_TEXTURE_SWIZZLE_RGBA.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// For the scalar commands, specifies the value of pname.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// For the vector commands, specifies a pointer to an array where the value or values of pname are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexParameterfv")]
        public static extern void TexParameter(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Single[] @params);

        /// <summary>[requires: v1.0]
        /// Set texture parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture, which must be either GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_RECTANGLE, or GL_TEXTURE_CUBE_MAP.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a single-valued texture parameter. pname can be one of the following: GL_DEPTH_STENCIL_TEXTURE_MODE, GL_TEXTURE_BASE_LEVEL, GL_TEXTURE_COMPARE_FUNC, GL_TEXTURE_COMPARE_MODE, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MAG_FILTER, GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_MAX_LEVEL, GL_TEXTURE_SWIZZLE_R, GL_TEXTURE_SWIZZLE_G, GL_TEXTURE_SWIZZLE_B, GL_TEXTURE_SWIZZLE_A, GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, or GL_TEXTURE_WRAP_R.
        /// </para>
        /// <para>
        /// For the vector commands (glTexParameter*v), pname can also be one of GL_TEXTURE_BORDER_COLOR or GL_TEXTURE_SWIZZLE_RGBA.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// For the scalar commands, specifies the value of pname.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// For the vector commands, specifies a pointer to an array where the value or values of pname are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexParameterfv")]
        public static extern unsafe void TexParameter(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Single* @params);

        /// <summary>[requires: v1.0]
        /// Set texture parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture, which must be either GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_RECTANGLE, or GL_TEXTURE_CUBE_MAP.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a single-valued texture parameter. pname can be one of the following: GL_DEPTH_STENCIL_TEXTURE_MODE, GL_TEXTURE_BASE_LEVEL, GL_TEXTURE_COMPARE_FUNC, GL_TEXTURE_COMPARE_MODE, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MAG_FILTER, GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_MAX_LEVEL, GL_TEXTURE_SWIZZLE_R, GL_TEXTURE_SWIZZLE_G, GL_TEXTURE_SWIZZLE_B, GL_TEXTURE_SWIZZLE_A, GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, or GL_TEXTURE_WRAP_R.
        /// </para>
        /// <para>
        /// For the vector commands (glTexParameter*v), pname can also be one of GL_TEXTURE_BORDER_COLOR or GL_TEXTURE_SWIZZLE_RGBA.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// For the scalar commands, specifies the value of pname.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// For the vector commands, specifies a pointer to an array where the value or values of pname are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexParameteri")]
        public static extern void TexParameter(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Int32 param);

        /// <summary>[requires: v3.0]</summary>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glTexParameterIiv")]
        public static extern void TexParameterI(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Int32[] @params);

        /// <summary>[requires: v3.0]</summary>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glTexParameterIiv")]
        public static extern void TexParameterI(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, ref Int32 @params);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glTexParameterIiv")]
        public static extern unsafe void TexParameterI(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Int32* @params);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glTexParameterIuiv")]
        public static extern void TexParameterI(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, UInt32[] @params);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glTexParameterIuiv")]
        public static extern void TexParameterI(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, ref UInt32 @params);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glTexParameterIuiv")]
        public static extern unsafe void TexParameterI(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, UInt32* @params);

        /// <summary>[requires: v1.0]
        /// Set texture parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture, which must be either GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_RECTANGLE, or GL_TEXTURE_CUBE_MAP.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a single-valued texture parameter. pname can be one of the following: GL_DEPTH_STENCIL_TEXTURE_MODE, GL_TEXTURE_BASE_LEVEL, GL_TEXTURE_COMPARE_FUNC, GL_TEXTURE_COMPARE_MODE, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MAG_FILTER, GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_MAX_LEVEL, GL_TEXTURE_SWIZZLE_R, GL_TEXTURE_SWIZZLE_G, GL_TEXTURE_SWIZZLE_B, GL_TEXTURE_SWIZZLE_A, GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, or GL_TEXTURE_WRAP_R.
        /// </para>
        /// <para>
        /// For the vector commands (glTexParameter*v), pname can also be one of GL_TEXTURE_BORDER_COLOR or GL_TEXTURE_SWIZZLE_RGBA.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// For the scalar commands, specifies the value of pname.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// For the vector commands, specifies a pointer to an array where the value or values of pname are stored.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexParameteriv")]
        public static extern void TexParameter(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Int32[] @params);

        /// <summary>[requires: v1.0]
        /// Set texture parameters
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture, which must be either GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_RECTANGLE, or GL_TEXTURE_CUBE_MAP.
        /// </para>
        /// </param>
        /// <param name="pname">
        /// <para>
        /// Specifies the symbolic name of a single-valued texture parameter. pname can be one of the following: GL_DEPTH_STENCIL_TEXTURE_MODE, GL_TEXTURE_BASE_LEVEL, GL_TEXTURE_COMPARE_FUNC, GL_TEXTURE_COMPARE_MODE, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MAG_FILTER, GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_MAX_LEVEL, GL_TEXTURE_SWIZZLE_R, GL_TEXTURE_SWIZZLE_G, GL_TEXTURE_SWIZZLE_B, GL_TEXTURE_SWIZZLE_A, GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, or GL_TEXTURE_WRAP_R.
        /// </para>
        /// <para>
        /// For the vector commands (glTexParameter*v), pname can also be one of GL_TEXTURE_BORDER_COLOR or GL_TEXTURE_SWIZZLE_RGBA.
        /// </para>
        /// </param>
        /// <param name="param">
        /// <para>
        /// For the scalar commands, specifies the value of pname.
        /// </para>
        /// </param>
        /// <param name="params">
        /// <para>
        /// For the vector commands, specifies a pointer to an array where the value or values of pname are stored.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTexParameteriv")]
        public static extern unsafe void TexParameter(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Int32* @params);

        /// <summary>[requires: v4.2 and ARB_texture_storage|VERSION_4_2]
        /// Simultaneously specify storage for all levels of a one-dimensional texture
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the operation. target must be either GL_TEXTURE_1D or GL_PROXY_TEXTURE_1D.
        /// </para>
        /// </param>
        /// <param name="levels">
        /// <para>
        /// Specify the number of texture levels.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// Specifies the sized internal format to be used to store texture image data.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture, in texels.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_texture_storage|VERSION_4_2", Version = "4.2", EntryPoint = "glTexStorage1D")]
        public static extern void TexStorage1D(OpenTK.Graphics.OpenGL.TextureTarget1d target, Int32 levels, OpenTK.Graphics.OpenGL.SizedInternalFormat internalformat, Int32 width);

        /// <summary>[requires: v4.2 and ARB_texture_storage|VERSION_4_2]
        /// Simultaneously specify storage for all levels of a two-dimensional or one-dimensional array texture
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the operation. target must be one of GL_TEXTURE_2D, GL_PROXY_TEXTURE_2D, GL_TEXTURE_1D_ARRAY, GL_PROXY_TEXTURE_1D_ARRAY, GL_TEXTURE_RECTANGLE, GL_PROXY_TEXTURE_RECTANGLE, or GL_PROXY_TEXTURE_CUBE_MAP.
        /// </para>
        /// </param>
        /// <param name="levels">
        /// <para>
        /// Specify the number of texture levels.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// Specifies the sized internal format to be used to store texture image data.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture, in texels.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture, in texels.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_texture_storage|VERSION_4_2", Version = "4.2", EntryPoint = "glTexStorage2D")]
        public static extern void TexStorage2D(OpenTK.Graphics.OpenGL.TextureTarget2d target, Int32 levels, OpenTK.Graphics.OpenGL.SizedInternalFormat internalformat, Int32 width, Int32 height);

        /// <summary>[requires: v4.3 and ARB_texture_storage_multisample|VERSION_4_3]
        /// Specify storage for a two-dimensional multisample texture
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the operation. target must be GL_TEXTURE_2D_MULTISAMPLE or GL_PROXY_TEXTURE_2D_MULTISAMPLE.
        /// </para>
        /// </param>
        /// <param name="samples">
        /// <para>
        /// Specify the number of samples in the texture.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// Specifies the sized internal format to be used to store texture image data.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture, in texels.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture, in texels.
        /// </para>
        /// </param>
        /// <param name="fixedsamplelocations">
        /// <para>
        /// Specifies whether the image will use identical sample locations and the same number of samples for all texels in the image, and the sample locations will not depend on the internal format or size of the image.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_texture_storage_multisample|VERSION_4_3", Version = "4.3", EntryPoint = "glTexStorage2DMultisample")]
        public static extern void TexStorage2DMultisample(OpenTK.Graphics.OpenGL.TextureTargetMultisample2d target, Int32 samples, OpenTK.Graphics.OpenGL.SizedInternalFormat internalformat, Int32 width, Int32 height, bool fixedsamplelocations);

        /// <summary>[requires: v4.2 and ARB_texture_storage|VERSION_4_2]
        /// Simultaneously specify storage for all levels of a three-dimensional, two-dimensional array or cube-map array texture
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the operation. target must be one of GL_TEXTURE_3D, GL_PROXY_TEXTURE_3D, GL_TEXTURE_2D_ARRAY, GL_PROXY_TEXTURE_2D_ARRAY, GL_TEXTURE_CUBE_ARRAY, or GL_PROXY_TEXTURE_CUBE_ARRAY.
        /// </para>
        /// </param>
        /// <param name="levels">
        /// <para>
        /// Specify the number of texture levels.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// Specifies the sized internal format to be used to store texture image data.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture, in texels.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture, in texels.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// Specifies the depth of the texture, in texels.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_texture_storage|VERSION_4_2", Version = "4.2", EntryPoint = "glTexStorage3D")]
        public static extern void TexStorage3D(OpenTK.Graphics.OpenGL.TextureTarget3d target, Int32 levels, OpenTK.Graphics.OpenGL.SizedInternalFormat internalformat, Int32 width, Int32 height, Int32 depth);

        /// <summary>[requires: v4.3 and ARB_texture_storage_multisample|VERSION_4_3]
        /// Specify storage for a two-dimensional multisample array texture
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specify the target of the operation. target must be GL_TEXTURE_2D_MULTISAMPLE_ARRAY or GL_PROXY_TEXTURE_2D_MULTISAMPLE_MULTISAMPLE.
        /// </para>
        /// </param>
        /// <param name="samples">
        /// <para>
        /// Specify the number of samples in the texture.
        /// </para>
        /// </param>
        /// <param name="internalformat">
        /// <para>
        /// Specifies the sized internal format to be used to store texture image data.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture, in texels.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture, in texels.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// Specifies the depth of the texture, in layers.
        /// </para>
        /// </param>
        /// <param name="fixedsamplelocations">
        /// <para>
        /// Specifies whether the image will use identical sample locations and the same number of samples for all texels in the image, and the sample locations will not depend on the internal format or size of the image.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_texture_storage_multisample|VERSION_4_3", Version = "4.3", EntryPoint = "glTexStorage3DMultisample")]
        public static extern void TexStorage3DMultisample(OpenTK.Graphics.OpenGL.TextureTargetMultisample3d target, Int32 samples, OpenTK.Graphics.OpenGL.SizedInternalFormat internalformat, Int32 width, Int32 height, Int32 depth, bool fixedsamplelocations);

        /// <summary>[requires: v1.1]
        /// Specify a one-dimensional texture subimage
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_1D.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// Specifies a texel offset in the x direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_DEPTH_COMPONENT, and GL_STENCIL_INDEX.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glTexSubImage1D")]
        public static extern void TexSubImage1D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

        /// <summary>[requires: v1.1]
        /// Specify a one-dimensional texture subimage
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_1D.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// Specifies a texel offset in the x direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_DEPTH_COMPONENT, and GL_STENCIL_INDEX.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glTexSubImage1D")]
        public static extern void TexSubImage1D<T6>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T6[] pixels)
            where T6 : struct
        ;

        /// <summary>[requires: v1.1]
        /// Specify a one-dimensional texture subimage
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_1D.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// Specifies a texel offset in the x direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_DEPTH_COMPONENT, and GL_STENCIL_INDEX.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glTexSubImage1D")]
        public static extern void TexSubImage1D<T6>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T6[,] pixels)
            where T6 : struct
        ;

        /// <summary>[requires: v1.1]
        /// Specify a one-dimensional texture subimage
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_1D.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// Specifies a texel offset in the x direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_DEPTH_COMPONENT, and GL_STENCIL_INDEX.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glTexSubImage1D")]
        public static extern void TexSubImage1D<T6>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T6[,,] pixels)
            where T6 : struct
        ;

        /// <summary>[requires: v1.1]
        /// Specify a one-dimensional texture subimage
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_1D.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// Specifies a texel offset in the x direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_DEPTH_COMPONENT, and GL_STENCIL_INDEX.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glTexSubImage1D")]
        public static extern void TexSubImage1D<T6>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T6 pixels)
            where T6 : struct
        ;

        /// <summary>[requires: v1.1]
        /// Specify a two-dimensional texture subimage
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, or GL_TEXTURE_1D_ARRAY.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// Specifies a texel offset in the x direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="yoffset">
        /// <para>
        /// Specifies a texel offset in the y direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_DEPTH_COMPONENT, and GL_STENCIL_INDEX.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glTexSubImage2D")]
        public static extern void TexSubImage2D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

        /// <summary>[requires: v1.1]
        /// Specify a two-dimensional texture subimage
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, or GL_TEXTURE_1D_ARRAY.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// Specifies a texel offset in the x direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="yoffset">
        /// <para>
        /// Specifies a texel offset in the y direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_DEPTH_COMPONENT, and GL_STENCIL_INDEX.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glTexSubImage2D")]
        public static extern void TexSubImage2D<T8>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T8[] pixels)
            where T8 : struct
        ;

        /// <summary>[requires: v1.1]
        /// Specify a two-dimensional texture subimage
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, or GL_TEXTURE_1D_ARRAY.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// Specifies a texel offset in the x direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="yoffset">
        /// <para>
        /// Specifies a texel offset in the y direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_DEPTH_COMPONENT, and GL_STENCIL_INDEX.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glTexSubImage2D")]
        public static extern void TexSubImage2D<T8>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T8[,] pixels)
            where T8 : struct
        ;

        /// <summary>[requires: v1.1]
        /// Specify a two-dimensional texture subimage
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, or GL_TEXTURE_1D_ARRAY.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// Specifies a texel offset in the x direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="yoffset">
        /// <para>
        /// Specifies a texel offset in the y direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_DEPTH_COMPONENT, and GL_STENCIL_INDEX.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glTexSubImage2D")]
        public static extern void TexSubImage2D<T8>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T8[,,] pixels)
            where T8 : struct
        ;

        /// <summary>[requires: v1.1]
        /// Specify a two-dimensional texture subimage
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, or GL_TEXTURE_1D_ARRAY.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// Specifies a texel offset in the x direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="yoffset">
        /// <para>
        /// Specifies a texel offset in the y direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_DEPTH_COMPONENT, and GL_STENCIL_INDEX.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glTexSubImage2D")]
        public static extern void TexSubImage2D<T8>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T8 pixels)
            where T8 : struct
        ;

        /// <summary>[requires: v1.2]
        /// Specify a three-dimensional texture subimage
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_3D or GL_TEXTURE_2D_ARRAY.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// Specifies a texel offset in the x direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="yoffset">
        /// <para>
        /// Specifies a texel offset in the y direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="zoffset">
        /// <para>
        /// Specifies a texel offset in the z direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// Specifies the depth of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_DEPTH_COMPONENT, and GL_STENCIL_INDEX.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_2", Version = "1.2", EntryPoint = "glTexSubImage3D")]
        public static extern void TexSubImage3D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

        /// <summary>[requires: v1.2]
        /// Specify a three-dimensional texture subimage
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_3D or GL_TEXTURE_2D_ARRAY.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// Specifies a texel offset in the x direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="yoffset">
        /// <para>
        /// Specifies a texel offset in the y direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="zoffset">
        /// <para>
        /// Specifies a texel offset in the z direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// Specifies the depth of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_DEPTH_COMPONENT, and GL_STENCIL_INDEX.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_2", Version = "1.2", EntryPoint = "glTexSubImage3D")]
        public static extern void TexSubImage3D<T10>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T10[] pixels)
            where T10 : struct
        ;

        /// <summary>[requires: v1.2]
        /// Specify a three-dimensional texture subimage
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_3D or GL_TEXTURE_2D_ARRAY.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// Specifies a texel offset in the x direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="yoffset">
        /// <para>
        /// Specifies a texel offset in the y direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="zoffset">
        /// <para>
        /// Specifies a texel offset in the z direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// Specifies the depth of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_DEPTH_COMPONENT, and GL_STENCIL_INDEX.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_2", Version = "1.2", EntryPoint = "glTexSubImage3D")]
        public static extern void TexSubImage3D<T10>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T10[,] pixels)
            where T10 : struct
        ;

        /// <summary>[requires: v1.2]
        /// Specify a three-dimensional texture subimage
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_3D or GL_TEXTURE_2D_ARRAY.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// Specifies a texel offset in the x direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="yoffset">
        /// <para>
        /// Specifies a texel offset in the y direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="zoffset">
        /// <para>
        /// Specifies a texel offset in the z direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// Specifies the depth of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_DEPTH_COMPONENT, and GL_STENCIL_INDEX.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_2", Version = "1.2", EntryPoint = "glTexSubImage3D")]
        public static extern void TexSubImage3D<T10>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T10[,,] pixels)
            where T10 : struct
        ;

        /// <summary>[requires: v1.2]
        /// Specify a three-dimensional texture subimage
        /// </summary>
        /// <param name="target">
        /// <para>
        /// Specifies the target texture. Must be GL_TEXTURE_3D or GL_TEXTURE_2D_ARRAY.
        /// </para>
        /// </param>
        /// <param name="level">
        /// <para>
        /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
        /// </para>
        /// </param>
        /// <param name="xoffset">
        /// <para>
        /// Specifies a texel offset in the x direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="yoffset">
        /// <para>
        /// Specifies a texel offset in the y direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="zoffset">
        /// <para>
        /// Specifies a texel offset in the z direction within the texture array.
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specifies the width of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="height">
        /// <para>
        /// Specifies the height of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="depth">
        /// <para>
        /// Specifies the depth of the texture subimage.
        /// </para>
        /// </param>
        /// <param name="format">
        /// <para>
        /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_DEPTH_COMPONENT, and GL_STENCIL_INDEX.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
        /// </para>
        /// </param>
        /// <param name="data">
        /// <para>
        /// Specifies a pointer to the image data in memory.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_2", Version = "1.2", EntryPoint = "glTexSubImage3D")]
        public static extern void TexSubImage3D<T10>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T10 pixels)
            where T10 : struct
        ;

        /// <summary>[requires: v4.3 and ARB_texture_view|VERSION_4_3]
        /// Initialize a texture as a data alias of another texture's data store
        /// </summary>
        /// <param name="texture">
        /// <para>
        /// Specifies the texture object to be initialized as a view.
        /// </para>
        /// </param>
        /// <param name="target">
        /// <para>
        /// Specifies the target to be used for the newly initialized texture.
        /// </para>
        /// </param>
        /// <param name="origtexture">
        /// <para>
        /// Specifies the name of a texture object of which to make a view.
        /// </para>
        /// </param>
        /// <param name="internalFormat">
        /// <para>
        /// Specifies the internal format for the newly created view.
        /// </para>
        /// </param>
        /// <param name="minlevel">
        /// <para>
        /// Specifies lowest level of detail of the view.
        /// </para>
        /// </param>
        /// <param name="numlevels">
        /// <para>
        /// Specifies the number of levels of detail to include in the view.
        /// </para>
        /// </param>
        /// <param name="minlayer">
        /// <para>
        /// Specifies the index of the first layer to include in the view.
        /// </para>
        /// </param>
        /// <param name="numlayers">
        /// <para>
        /// Specifies the number of layers to include in the view.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_texture_view|VERSION_4_3", Version = "4.3", EntryPoint = "glTextureView")]
        public static extern void TextureView(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 origtexture, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 minlevel, Int32 numlevels, Int32 minlayer, Int32 numlayers);

        /// <summary>[requires: v4.3 and ARB_texture_view|VERSION_4_3]
        /// Initialize a texture as a data alias of another texture's data store
        /// </summary>
        /// <param name="texture">
        /// <para>
        /// Specifies the texture object to be initialized as a view.
        /// </para>
        /// </param>
        /// <param name="target">
        /// <para>
        /// Specifies the target to be used for the newly initialized texture.
        /// </para>
        /// </param>
        /// <param name="origtexture">
        /// <para>
        /// Specifies the name of a texture object of which to make a view.
        /// </para>
        /// </param>
        /// <param name="internalFormat">
        /// <para>
        /// Specifies the internal format for the newly created view.
        /// </para>
        /// </param>
        /// <param name="minlevel">
        /// <para>
        /// Specifies lowest level of detail of the view.
        /// </para>
        /// </param>
        /// <param name="numlevels">
        /// <para>
        /// Specifies the number of levels of detail to include in the view.
        /// </para>
        /// </param>
        /// <param name="minlayer">
        /// <para>
        /// Specifies the index of the first layer to include in the view.
        /// </para>
        /// </param>
        /// <param name="numlayers">
        /// <para>
        /// Specifies the number of layers to include in the view.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_texture_view|VERSION_4_3", Version = "4.3", EntryPoint = "glTextureView")]
        public static extern void TextureView(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, UInt32 origtexture, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, UInt32 minlevel, UInt32 numlevels, UInt32 minlayer, UInt32 numlayers);

        /// <summary>[requires: v3.0]
        /// Specify values to record in transform feedback buffers
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of the target program object.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// The number of varying variables used for transform feedback.
        /// </para>
        /// </param>
        /// <param name="varyings">
        /// <para>
        /// An array of count zero-terminated strings specifying the names of the varying variables to use for transform feedback.
        /// </para>
        /// </param>
        /// <param name="bufferMode">
        /// <para>
        /// Identifies the mode used to capture the varying variables when transform feedback is active. bufferMode must be GL_INTERLEAVED_ATTRIBS or GL_SEPARATE_ATTRIBS.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glTransformFeedbackVaryings")]
        public static extern void TransformFeedbackVaryings(Int32 program, Int32 count, String[] varyings, OpenTK.Graphics.OpenGL.TransformFeedbackMode bufferMode);

        /// <summary>[requires: v3.0]
        /// Specify values to record in transform feedback buffers
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of the target program object.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// The number of varying variables used for transform feedback.
        /// </para>
        /// </param>
        /// <param name="varyings">
        /// <para>
        /// An array of count zero-terminated strings specifying the names of the varying variables to use for transform feedback.
        /// </para>
        /// </param>
        /// <param name="bufferMode">
        /// <para>
        /// Identifies the mode used to capture the varying variables when transform feedback is active. bufferMode must be GL_INTERLEAVED_ATTRIBS or GL_SEPARATE_ATTRIBS.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glTransformFeedbackVaryings")]
        public static extern void TransformFeedbackVaryings(UInt32 program, Int32 count, String[] varyings, OpenTK.Graphics.OpenGL.TransformFeedbackMode bufferMode);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Multiply the current matrix by a translation matrix
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the x, y, and z coordinates of a translation vector.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTranslated")]
        public static extern void Translate(Double x, Double y, Double z);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Multiply the current matrix by a translation matrix
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the x, y, and z coordinates of a translation vector.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glTranslatef")]
        public static extern void Translate(Single x, Single y, Single z);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniform1d")]
        public static extern void Uniform1(Int32 location, Double x);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniform1dv")]
        public static extern void Uniform1(Int32 location, Int32 count, Double[] value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniform1dv")]
        public static extern void Uniform1(Int32 location, Int32 count, ref Double value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniform1dv")]
        public static extern unsafe void Uniform1(Int32 location, Int32 count, Double* value);

        /// <summary>[requires: v2.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniform1f")]
        public static extern void Uniform1(Int32 location, Single v0);

        /// <summary>[requires: v2.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniform1fv")]
        public static extern void Uniform1(Int32 location, Int32 count, Single[] value);

        /// <summary>[requires: v2.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniform1fv")]
        public static extern void Uniform1(Int32 location, Int32 count, ref Single value);

        /// <summary>[requires: v2.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniform1fv")]
        public static extern unsafe void Uniform1(Int32 location, Int32 count, Single* value);

        /// <summary>[requires: v2.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniform1i")]
        public static extern void Uniform1(Int32 location, Int32 v0);

        /// <summary>[requires: v2.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniform1iv")]
        public static extern void Uniform1(Int32 location, Int32 count, Int32[] value);

        /// <summary>[requires: v2.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniform1iv")]
        public static extern void Uniform1(Int32 location, Int32 count, ref Int32 value);

        /// <summary>[requires: v2.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniform1iv")]
        public static extern unsafe void Uniform1(Int32 location, Int32 count, Int32* value);

        /// <summary>[requires: v3.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glUniform1ui")]
        public static extern void Uniform1(Int32 location, UInt32 v0);

        /// <summary>[requires: v3.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glUniform1uiv")]
        public static extern void Uniform1(Int32 location, Int32 count, UInt32[] value);

        /// <summary>[requires: v3.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glUniform1uiv")]
        public static extern void Uniform1(Int32 location, Int32 count, ref UInt32 value);

        /// <summary>[requires: v3.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glUniform1uiv")]
        public static extern unsafe void Uniform1(Int32 location, Int32 count, UInt32* value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniform2d")]
        public static extern void Uniform2(Int32 location, Double x, Double y);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniform2dv")]
        public static extern void Uniform2(Int32 location, Int32 count, Double[] value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniform2dv")]
        public static extern void Uniform2(Int32 location, Int32 count, ref Double value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniform2dv")]
        public static extern unsafe void Uniform2(Int32 location, Int32 count, Double* value);

        /// <summary>[requires: v2.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniform2f")]
        public static extern void Uniform2(Int32 location, Single v0, Single v1);

        /// <summary>[requires: v2.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniform2fv")]
        public static extern void Uniform2(Int32 location, Int32 count, Single[] value);

        /// <summary>[requires: v2.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniform2fv")]
        public static extern void Uniform2(Int32 location, Int32 count, ref Single value);

        /// <summary>[requires: v2.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniform2fv")]
        public static extern unsafe void Uniform2(Int32 location, Int32 count, Single* value);

        /// <summary>[requires: v2.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniform2i")]
        public static extern void Uniform2(Int32 location, Int32 v0, Int32 v1);

        /// <summary>[requires: v2.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniform2iv")]
        public static extern void Uniform2(Int32 location, Int32 count, Int32[] value);

        /// <summary>[requires: v2.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniform2iv")]
        public static extern unsafe void Uniform2(Int32 location, Int32 count, Int32* value);

        /// <summary>[requires: v3.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glUniform2ui")]
        public static extern void Uniform2(Int32 location, UInt32 v0, UInt32 v1);

        /// <summary>[requires: v3.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glUniform2uiv")]
        public static extern void Uniform2(Int32 location, Int32 count, UInt32[] value);

        /// <summary>[requires: v3.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glUniform2uiv")]
        public static extern void Uniform2(Int32 location, Int32 count, ref UInt32 value);

        /// <summary>[requires: v3.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glUniform2uiv")]
        public static extern unsafe void Uniform2(Int32 location, Int32 count, UInt32* value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniform3d")]
        public static extern void Uniform3(Int32 location, Double x, Double y, Double z);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniform3dv")]
        public static extern void Uniform3(Int32 location, Int32 count, Double[] value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniform3dv")]
        public static extern void Uniform3(Int32 location, Int32 count, ref Double value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniform3dv")]
        public static extern unsafe void Uniform3(Int32 location, Int32 count, Double* value);

        /// <summary>[requires: v2.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniform3f")]
        public static extern void Uniform3(Int32 location, Single v0, Single v1, Single v2);

        /// <summary>[requires: v2.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniform3fv")]
        public static extern void Uniform3(Int32 location, Int32 count, Single[] value);

        /// <summary>[requires: v2.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniform3fv")]
        public static extern void Uniform3(Int32 location, Int32 count, ref Single value);

        /// <summary>[requires: v2.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniform3fv")]
        public static extern unsafe void Uniform3(Int32 location, Int32 count, Single* value);

        /// <summary>[requires: v2.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniform3i")]
        public static extern void Uniform3(Int32 location, Int32 v0, Int32 v1, Int32 v2);

        /// <summary>[requires: v2.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniform3iv")]
        public static extern void Uniform3(Int32 location, Int32 count, Int32[] value);

        /// <summary>[requires: v2.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniform3iv")]
        public static extern void Uniform3(Int32 location, Int32 count, ref Int32 value);

        /// <summary>[requires: v2.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniform3iv")]
        public static extern unsafe void Uniform3(Int32 location, Int32 count, Int32* value);

        /// <summary>[requires: v3.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glUniform3ui")]
        public static extern void Uniform3(Int32 location, UInt32 v0, UInt32 v1, UInt32 v2);

        /// <summary>[requires: v3.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glUniform3uiv")]
        public static extern void Uniform3(Int32 location, Int32 count, UInt32[] value);

        /// <summary>[requires: v3.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glUniform3uiv")]
        public static extern void Uniform3(Int32 location, Int32 count, ref UInt32 value);

        /// <summary>[requires: v3.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glUniform3uiv")]
        public static extern unsafe void Uniform3(Int32 location, Int32 count, UInt32* value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniform4d")]
        public static extern void Uniform4(Int32 location, Double x, Double y, Double z, Double w);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniform4dv")]
        public static extern void Uniform4(Int32 location, Int32 count, Double[] value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniform4dv")]
        public static extern void Uniform4(Int32 location, Int32 count, ref Double value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniform4dv")]
        public static extern unsafe void Uniform4(Int32 location, Int32 count, Double* value);

        /// <summary>[requires: v2.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniform4f")]
        public static extern void Uniform4(Int32 location, Single v0, Single v1, Single v2, Single v3);

        /// <summary>[requires: v2.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniform4fv")]
        public static extern void Uniform4(Int32 location, Int32 count, Single[] value);

        /// <summary>[requires: v2.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniform4fv")]
        public static extern void Uniform4(Int32 location, Int32 count, ref Single value);

        /// <summary>[requires: v2.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniform4fv")]
        public static extern unsafe void Uniform4(Int32 location, Int32 count, Single* value);

        /// <summary>[requires: v2.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniform4i")]
        public static extern void Uniform4(Int32 location, Int32 v0, Int32 v1, Int32 v2, Int32 v3);

        /// <summary>[requires: v2.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniform4iv")]
        public static extern void Uniform4(Int32 location, Int32 count, Int32[] value);

        /// <summary>[requires: v2.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniform4iv")]
        public static extern void Uniform4(Int32 location, Int32 count, ref Int32 value);

        /// <summary>[requires: v2.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniform4iv")]
        public static extern unsafe void Uniform4(Int32 location, Int32 count, Int32* value);

        /// <summary>[requires: v3.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glUniform4ui")]
        public static extern void Uniform4(Int32 location, UInt32 v0, UInt32 v1, UInt32 v2, UInt32 v3);

        /// <summary>[requires: v3.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glUniform4uiv")]
        public static extern void Uniform4(Int32 location, Int32 count, UInt32[] value);

        /// <summary>[requires: v3.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glUniform4uiv")]
        public static extern void Uniform4(Int32 location, Int32 count, ref UInt32 value);

        /// <summary>[requires: v3.0]
        /// Specify the value of a uniform variable for the current program object
        /// </summary>
        /// <param name="location">
        /// <para>
        /// Specifies the location of the uniform variable to be modified.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
        /// </para>
        /// <para>
        /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
        /// </para>
        /// </param>
        /// <param name="transpose">
        /// <para>
        /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glUniform4uiv")]
        public static extern unsafe void Uniform4(Int32 location, Int32 count, UInt32* value);

        /// <summary>[requires: v3.1 and ARB_uniform_buffer_object|VERSION_3_1]
        /// Assign a binding point to an active uniform block
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of a program object containing the active uniform block whose binding to assign.
        /// </para>
        /// </param>
        /// <param name="uniformBlockIndex">
        /// <para>
        /// The index of the active uniform block within program whose binding to assign.
        /// </para>
        /// </param>
        /// <param name="uniformBlockBinding">
        /// <para>
        /// Specifies the binding point to which to bind the uniform block with index uniformBlockIndex within program.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_uniform_buffer_object|VERSION_3_1", Version = "3.1", EntryPoint = "glUniformBlockBinding")]
        public static extern void UniformBlockBinding(Int32 program, Int32 uniformBlockIndex, Int32 uniformBlockBinding);

        /// <summary>[requires: v3.1 and ARB_uniform_buffer_object|VERSION_3_1]
        /// Assign a binding point to an active uniform block
        /// </summary>
        /// <param name="program">
        /// <para>
        /// The name of a program object containing the active uniform block whose binding to assign.
        /// </para>
        /// </param>
        /// <param name="uniformBlockIndex">
        /// <para>
        /// The index of the active uniform block within program whose binding to assign.
        /// </para>
        /// </param>
        /// <param name="uniformBlockBinding">
        /// <para>
        /// Specifies the binding point to which to bind the uniform block with index uniformBlockIndex within program.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_uniform_buffer_object|VERSION_3_1", Version = "3.1", EntryPoint = "glUniformBlockBinding")]
        public static extern void UniformBlockBinding(UInt32 program, UInt32 uniformBlockIndex, UInt32 uniformBlockBinding);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]</summary>
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniformMatrix2dv")]
        public static extern void UniformMatrix2(Int32 location, Int32 count, bool transpose, Double[] value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]</summary>
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniformMatrix2dv")]
        public static extern void UniformMatrix2(Int32 location, Int32 count, bool transpose, ref Double value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniformMatrix2dv")]
        public static extern unsafe void UniformMatrix2(Int32 location, Int32 count, bool transpose, Double* value);

        /// <summary>[requires: v2.0]</summary>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniformMatrix2fv")]
        public static extern void UniformMatrix2(Int32 location, Int32 count, bool transpose, Single[] value);

        /// <summary>[requires: v2.0]</summary>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniformMatrix2fv")]
        public static extern void UniformMatrix2(Int32 location, Int32 count, bool transpose, ref Single value);

        /// <summary>[requires: v2.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniformMatrix2fv")]
        public static extern unsafe void UniformMatrix2(Int32 location, Int32 count, bool transpose, Single* value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]</summary>
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniformMatrix2x3dv")]
        public static extern void UniformMatrix2x3(Int32 location, Int32 count, bool transpose, Double[] value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]</summary>
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniformMatrix2x3dv")]
        public static extern void UniformMatrix2x3(Int32 location, Int32 count, bool transpose, ref Double value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniformMatrix2x3dv")]
        public static extern unsafe void UniformMatrix2x3(Int32 location, Int32 count, bool transpose, Double* value);

        /// <summary>[requires: v2.1]</summary>
        [AutoGenerated(Category = "VERSION_2_1", Version = "2.1", EntryPoint = "glUniformMatrix2x3fv")]
        public static extern void UniformMatrix2x3(Int32 location, Int32 count, bool transpose, Single[] value);

        /// <summary>[requires: v2.1]</summary>
        [AutoGenerated(Category = "VERSION_2_1", Version = "2.1", EntryPoint = "glUniformMatrix2x3fv")]
        public static extern void UniformMatrix2x3(Int32 location, Int32 count, bool transpose, ref Single value);

        /// <summary>[requires: v2.1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_1", Version = "2.1", EntryPoint = "glUniformMatrix2x3fv")]
        public static extern unsafe void UniformMatrix2x3(Int32 location, Int32 count, bool transpose, Single* value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]</summary>
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniformMatrix2x4dv")]
        public static extern void UniformMatrix2x4(Int32 location, Int32 count, bool transpose, Double[] value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]</summary>
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniformMatrix2x4dv")]
        public static extern void UniformMatrix2x4(Int32 location, Int32 count, bool transpose, ref Double value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniformMatrix2x4dv")]
        public static extern unsafe void UniformMatrix2x4(Int32 location, Int32 count, bool transpose, Double* value);

        /// <summary>[requires: v2.1]</summary>
        [AutoGenerated(Category = "VERSION_2_1", Version = "2.1", EntryPoint = "glUniformMatrix2x4fv")]
        public static extern void UniformMatrix2x4(Int32 location, Int32 count, bool transpose, Single[] value);

        /// <summary>[requires: v2.1]</summary>
        [AutoGenerated(Category = "VERSION_2_1", Version = "2.1", EntryPoint = "glUniformMatrix2x4fv")]
        public static extern void UniformMatrix2x4(Int32 location, Int32 count, bool transpose, ref Single value);

        /// <summary>[requires: v2.1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_1", Version = "2.1", EntryPoint = "glUniformMatrix2x4fv")]
        public static extern unsafe void UniformMatrix2x4(Int32 location, Int32 count, bool transpose, Single* value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]</summary>
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniformMatrix3dv")]
        public static extern void UniformMatrix3(Int32 location, Int32 count, bool transpose, Double[] value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]</summary>
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniformMatrix3dv")]
        public static extern void UniformMatrix3(Int32 location, Int32 count, bool transpose, ref Double value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniformMatrix3dv")]
        public static extern unsafe void UniformMatrix3(Int32 location, Int32 count, bool transpose, Double* value);

        /// <summary>[requires: v2.0]</summary>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniformMatrix3fv")]
        public static extern void UniformMatrix3(Int32 location, Int32 count, bool transpose, Single[] value);

        /// <summary>[requires: v2.0]</summary>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniformMatrix3fv")]
        public static extern void UniformMatrix3(Int32 location, Int32 count, bool transpose, ref Single value);

        /// <summary>[requires: v2.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniformMatrix3fv")]
        public static extern unsafe void UniformMatrix3(Int32 location, Int32 count, bool transpose, Single* value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]</summary>
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniformMatrix3x2dv")]
        public static extern void UniformMatrix3x2(Int32 location, Int32 count, bool transpose, Double[] value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]</summary>
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniformMatrix3x2dv")]
        public static extern void UniformMatrix3x2(Int32 location, Int32 count, bool transpose, ref Double value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniformMatrix3x2dv")]
        public static extern unsafe void UniformMatrix3x2(Int32 location, Int32 count, bool transpose, Double* value);

        /// <summary>[requires: v2.1]</summary>
        [AutoGenerated(Category = "VERSION_2_1", Version = "2.1", EntryPoint = "glUniformMatrix3x2fv")]
        public static extern void UniformMatrix3x2(Int32 location, Int32 count, bool transpose, Single[] value);

        /// <summary>[requires: v2.1]</summary>
        [AutoGenerated(Category = "VERSION_2_1", Version = "2.1", EntryPoint = "glUniformMatrix3x2fv")]
        public static extern void UniformMatrix3x2(Int32 location, Int32 count, bool transpose, ref Single value);

        /// <summary>[requires: v2.1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_1", Version = "2.1", EntryPoint = "glUniformMatrix3x2fv")]
        public static extern unsafe void UniformMatrix3x2(Int32 location, Int32 count, bool transpose, Single* value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]</summary>
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniformMatrix3x4dv")]
        public static extern void UniformMatrix3x4(Int32 location, Int32 count, bool transpose, Double[] value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]</summary>
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniformMatrix3x4dv")]
        public static extern void UniformMatrix3x4(Int32 location, Int32 count, bool transpose, ref Double value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniformMatrix3x4dv")]
        public static extern unsafe void UniformMatrix3x4(Int32 location, Int32 count, bool transpose, Double* value);

        /// <summary>[requires: v2.1]</summary>
        [AutoGenerated(Category = "VERSION_2_1", Version = "2.1", EntryPoint = "glUniformMatrix3x4fv")]
        public static extern void UniformMatrix3x4(Int32 location, Int32 count, bool transpose, Single[] value);

        /// <summary>[requires: v2.1]</summary>
        [AutoGenerated(Category = "VERSION_2_1", Version = "2.1", EntryPoint = "glUniformMatrix3x4fv")]
        public static extern void UniformMatrix3x4(Int32 location, Int32 count, bool transpose, ref Single value);

        /// <summary>[requires: v2.1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_1", Version = "2.1", EntryPoint = "glUniformMatrix3x4fv")]
        public static extern unsafe void UniformMatrix3x4(Int32 location, Int32 count, bool transpose, Single* value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]</summary>
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniformMatrix4dv")]
        public static extern void UniformMatrix4(Int32 location, Int32 count, bool transpose, Double[] value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]</summary>
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniformMatrix4dv")]
        public static extern void UniformMatrix4(Int32 location, Int32 count, bool transpose, ref Double value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniformMatrix4dv")]
        public static extern unsafe void UniformMatrix4(Int32 location, Int32 count, bool transpose, Double* value);

        /// <summary>[requires: v2.0]</summary>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniformMatrix4fv")]
        public static extern void UniformMatrix4(Int32 location, Int32 count, bool transpose, Single[] value);

        /// <summary>[requires: v2.0]</summary>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniformMatrix4fv")]
        public static extern void UniformMatrix4(Int32 location, Int32 count, bool transpose, ref Single value);

        /// <summary>[requires: v2.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUniformMatrix4fv")]
        public static extern unsafe void UniformMatrix4(Int32 location, Int32 count, bool transpose, Single* value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]</summary>
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniformMatrix4x2dv")]
        public static extern void UniformMatrix4x2(Int32 location, Int32 count, bool transpose, Double[] value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]</summary>
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniformMatrix4x2dv")]
        public static extern void UniformMatrix4x2(Int32 location, Int32 count, bool transpose, ref Double value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniformMatrix4x2dv")]
        public static extern unsafe void UniformMatrix4x2(Int32 location, Int32 count, bool transpose, Double* value);

        /// <summary>[requires: v2.1]</summary>
        [AutoGenerated(Category = "VERSION_2_1", Version = "2.1", EntryPoint = "glUniformMatrix4x2fv")]
        public static extern void UniformMatrix4x2(Int32 location, Int32 count, bool transpose, Single[] value);

        /// <summary>[requires: v2.1]</summary>
        [AutoGenerated(Category = "VERSION_2_1", Version = "2.1", EntryPoint = "glUniformMatrix4x2fv")]
        public static extern void UniformMatrix4x2(Int32 location, Int32 count, bool transpose, ref Single value);

        /// <summary>[requires: v2.1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_1", Version = "2.1", EntryPoint = "glUniformMatrix4x2fv")]
        public static extern unsafe void UniformMatrix4x2(Int32 location, Int32 count, bool transpose, Single* value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]</summary>
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniformMatrix4x3dv")]
        public static extern void UniformMatrix4x3(Int32 location, Int32 count, bool transpose, Double[] value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]</summary>
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniformMatrix4x3dv")]
        public static extern void UniformMatrix4x3(Int32 location, Int32 count, bool transpose, ref Double value);

        /// <summary>[requires: v4.0 and ARB_gpu_shader_fp64|VERSION_4_0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_gpu_shader_fp64|VERSION_4_0", Version = "4.0", EntryPoint = "glUniformMatrix4x3dv")]
        public static extern unsafe void UniformMatrix4x3(Int32 location, Int32 count, bool transpose, Double* value);

        /// <summary>[requires: v2.1]</summary>
        [AutoGenerated(Category = "VERSION_2_1", Version = "2.1", EntryPoint = "glUniformMatrix4x3fv")]
        public static extern void UniformMatrix4x3(Int32 location, Int32 count, bool transpose, Single[] value);

        /// <summary>[requires: v2.1]</summary>
        [AutoGenerated(Category = "VERSION_2_1", Version = "2.1", EntryPoint = "glUniformMatrix4x3fv")]
        public static extern void UniformMatrix4x3(Int32 location, Int32 count, bool transpose, ref Single value);

        /// <summary>[requires: v2.1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_1", Version = "2.1", EntryPoint = "glUniformMatrix4x3fv")]
        public static extern unsafe void UniformMatrix4x3(Int32 location, Int32 count, bool transpose, Single* value);

        /// <summary>[requires: v4.0 and ARB_shader_subroutine|VERSION_4_0]
        /// Load active subroutine uniforms
        /// </summary>
        /// <param name="shadertype">
        /// <para>
        /// Specifies the shader stage from which to query for subroutine uniform index. shadertype must be one of GL_VERTEX_SHADER, GL_TESS_CONTROL_SHADER, GL_TESS_EVALUATION_SHADER, GL_GEOMETRY_SHADER or GL_FRAGMENT_SHADER.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of uniform indices stored in indices.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies the address of an array holding the indices to load into the shader subroutine variables.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_shader_subroutine|VERSION_4_0", Version = "4.0", EntryPoint = "glUniformSubroutinesuiv")]
        public static extern void UniformSubroutines(OpenTK.Graphics.OpenGL.ShaderType shadertype, Int32 count, Int32[] indices);

        /// <summary>[requires: v4.0 and ARB_shader_subroutine|VERSION_4_0]
        /// Load active subroutine uniforms
        /// </summary>
        /// <param name="shadertype">
        /// <para>
        /// Specifies the shader stage from which to query for subroutine uniform index. shadertype must be one of GL_VERTEX_SHADER, GL_TESS_CONTROL_SHADER, GL_TESS_EVALUATION_SHADER, GL_GEOMETRY_SHADER or GL_FRAGMENT_SHADER.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of uniform indices stored in indices.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies the address of an array holding the indices to load into the shader subroutine variables.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_shader_subroutine|VERSION_4_0", Version = "4.0", EntryPoint = "glUniformSubroutinesuiv")]
        public static extern void UniformSubroutines(OpenTK.Graphics.OpenGL.ShaderType shadertype, Int32 count, ref Int32 indices);

        /// <summary>[requires: v4.0 and ARB_shader_subroutine|VERSION_4_0]
        /// Load active subroutine uniforms
        /// </summary>
        /// <param name="shadertype">
        /// <para>
        /// Specifies the shader stage from which to query for subroutine uniform index. shadertype must be one of GL_VERTEX_SHADER, GL_TESS_CONTROL_SHADER, GL_TESS_EVALUATION_SHADER, GL_GEOMETRY_SHADER or GL_FRAGMENT_SHADER.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of uniform indices stored in indices.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies the address of an array holding the indices to load into the shader subroutine variables.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_shader_subroutine|VERSION_4_0", Version = "4.0", EntryPoint = "glUniformSubroutinesuiv")]
        public static extern unsafe void UniformSubroutines(OpenTK.Graphics.OpenGL.ShaderType shadertype, Int32 count, Int32* indices);

        /// <summary>[requires: v4.0 and ARB_shader_subroutine|VERSION_4_0]
        /// Load active subroutine uniforms
        /// </summary>
        /// <param name="shadertype">
        /// <para>
        /// Specifies the shader stage from which to query for subroutine uniform index. shadertype must be one of GL_VERTEX_SHADER, GL_TESS_CONTROL_SHADER, GL_TESS_EVALUATION_SHADER, GL_GEOMETRY_SHADER or GL_FRAGMENT_SHADER.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of uniform indices stored in indices.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies the address of an array holding the indices to load into the shader subroutine variables.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_shader_subroutine|VERSION_4_0", Version = "4.0", EntryPoint = "glUniformSubroutinesuiv")]
        public static extern void UniformSubroutines(OpenTK.Graphics.OpenGL.ShaderType shadertype, Int32 count, UInt32[] indices);

        /// <summary>[requires: v4.0 and ARB_shader_subroutine|VERSION_4_0]
        /// Load active subroutine uniforms
        /// </summary>
        /// <param name="shadertype">
        /// <para>
        /// Specifies the shader stage from which to query for subroutine uniform index. shadertype must be one of GL_VERTEX_SHADER, GL_TESS_CONTROL_SHADER, GL_TESS_EVALUATION_SHADER, GL_GEOMETRY_SHADER or GL_FRAGMENT_SHADER.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of uniform indices stored in indices.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies the address of an array holding the indices to load into the shader subroutine variables.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_shader_subroutine|VERSION_4_0", Version = "4.0", EntryPoint = "glUniformSubroutinesuiv")]
        public static extern void UniformSubroutines(OpenTK.Graphics.OpenGL.ShaderType shadertype, Int32 count, ref UInt32 indices);

        /// <summary>[requires: v4.0 and ARB_shader_subroutine|VERSION_4_0]
        /// Load active subroutine uniforms
        /// </summary>
        /// <param name="shadertype">
        /// <para>
        /// Specifies the shader stage from which to query for subroutine uniform index. shadertype must be one of GL_VERTEX_SHADER, GL_TESS_CONTROL_SHADER, GL_TESS_EVALUATION_SHADER, GL_GEOMETRY_SHADER or GL_FRAGMENT_SHADER.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specifies the number of uniform indices stored in indices.
        /// </para>
        /// </param>
        /// <param name="indices">
        /// <para>
        /// Specifies the address of an array holding the indices to load into the shader subroutine variables.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_shader_subroutine|VERSION_4_0", Version = "4.0", EntryPoint = "glUniformSubroutinesuiv")]
        public static extern unsafe void UniformSubroutines(OpenTK.Graphics.OpenGL.ShaderType shadertype, Int32 count, UInt32* indices);

        /// <summary>[requires: v1.5]</summary>
        [AutoGenerated(Category = "VERSION_1_5", Version = "1.5", EntryPoint = "glUnmapBuffer")]
        public static extern bool UnmapBuffer(OpenTK.Graphics.OpenGL.BufferTarget target);

        /// <summary>[requires: v2.0]
        /// Installs a program object as part of current rendering state
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program object whose executables are to be used as part of current rendering state.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUseProgram")]
        public static extern void UseProgram(Int32 program);

        /// <summary>[requires: v2.0]
        /// Installs a program object as part of current rendering state
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program object whose executables are to be used as part of current rendering state.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glUseProgram")]
        public static extern void UseProgram(UInt32 program);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Bind stages of a program object to a program pipeline
        /// </summary>
        /// <param name="pipeline">
        /// <para>
        /// Specifies the program pipeline object to which to bind stages from program.
        /// </para>
        /// </param>
        /// <param name="stages">
        /// <para>
        /// Specifies a set of program stages to bind to the program pipeline object.
        /// </para>
        /// </param>
        /// <param name="program">
        /// <para>
        /// Specifies the program object containing the shader executables to use in pipeline.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glUseProgramStages")]
        public static extern void UseProgramStages(Int32 pipeline, OpenTK.Graphics.OpenGL.ProgramStageMask stages, Int32 program);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Bind stages of a program object to a program pipeline
        /// </summary>
        /// <param name="pipeline">
        /// <para>
        /// Specifies the program pipeline object to which to bind stages from program.
        /// </para>
        /// </param>
        /// <param name="stages">
        /// <para>
        /// Specifies a set of program stages to bind to the program pipeline object.
        /// </para>
        /// </param>
        /// <param name="program">
        /// <para>
        /// Specifies the program object containing the shader executables to use in pipeline.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glUseProgramStages")]
        public static extern void UseProgramStages(UInt32 pipeline, OpenTK.Graphics.OpenGL.ProgramStageMask stages, UInt32 program);

        /// <summary>[requires: v2.0]
        /// Validates a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program object to be validated.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glValidateProgram")]
        public static extern void ValidateProgram(Int32 program);

        /// <summary>[requires: v2.0]
        /// Validates a program object
        /// </summary>
        /// <param name="program">
        /// <para>
        /// Specifies the handle of the program object to be validated.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glValidateProgram")]
        public static extern void ValidateProgram(UInt32 program);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Validate a program pipeline object against current GL state
        /// </summary>
        /// <param name="pipeline">
        /// <para>
        /// Specifies the name of a program pipeline object to validate.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glValidateProgramPipeline")]
        public static extern void ValidateProgramPipeline(Int32 pipeline);

        /// <summary>[requires: v4.1 and ARB_separate_shader_objects|VERSION_4_1]
        /// Validate a program pipeline object against current GL state
        /// </summary>
        /// <param name="pipeline">
        /// <para>
        /// Specifies the name of a program pipeline object to validate.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_separate_shader_objects|VERSION_4_1", Version = "4.1", EntryPoint = "glValidateProgramPipeline")]
        public static extern void ValidateProgramPipeline(UInt32 pipeline);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex2d")]
        public static extern void Vertex2(Double x, Double y);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex2dv")]
        public static extern void Vertex2(Double[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex2dv")]
        public static extern void Vertex2(ref Double v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex2dv")]
        public static extern unsafe void Vertex2(Double* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex2f")]
        public static extern void Vertex2(Single x, Single y);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex2fv")]
        public static extern void Vertex2(Single[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex2fv")]
        public static extern void Vertex2(ref Single v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex2fv")]
        public static extern unsafe void Vertex2(Single* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex2i")]
        public static extern void Vertex2(Int32 x, Int32 y);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex2iv")]
        public static extern void Vertex2(Int32[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex2iv")]
        public static extern void Vertex2(ref Int32 v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex2iv")]
        public static extern unsafe void Vertex2(Int32* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex2s")]
        public static extern void Vertex2(Int16 x, Int16 y);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex2sv")]
        public static extern void Vertex2(Int16[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex2sv")]
        public static extern void Vertex2(ref Int16 v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex2sv")]
        public static extern unsafe void Vertex2(Int16* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex3d")]
        public static extern void Vertex3(Double x, Double y, Double z);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex3dv")]
        public static extern void Vertex3(Double[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex3dv")]
        public static extern void Vertex3(ref Double v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex3dv")]
        public static extern unsafe void Vertex3(Double* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex3f")]
        public static extern void Vertex3(Single x, Single y, Single z);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex3fv")]
        public static extern void Vertex3(Single[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex3fv")]
        public static extern void Vertex3(ref Single v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex3fv")]
        public static extern unsafe void Vertex3(Single* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex3i")]
        public static extern void Vertex3(Int32 x, Int32 y, Int32 z);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex3iv")]
        public static extern void Vertex3(Int32[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex3iv")]
        public static extern void Vertex3(ref Int32 v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex3iv")]
        public static extern unsafe void Vertex3(Int32* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex3s")]
        public static extern void Vertex3(Int16 x, Int16 y, Int16 z);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex3sv")]
        public static extern void Vertex3(Int16[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex3sv")]
        public static extern void Vertex3(ref Int16 v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex3sv")]
        public static extern unsafe void Vertex3(Int16* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex4d")]
        public static extern void Vertex4(Double x, Double y, Double z, Double w);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex4dv")]
        public static extern void Vertex4(Double[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex4dv")]
        public static extern void Vertex4(ref Double v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex4dv")]
        public static extern unsafe void Vertex4(Double* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex4f")]
        public static extern void Vertex4(Single x, Single y, Single z, Single w);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex4fv")]
        public static extern void Vertex4(Single[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex4fv")]
        public static extern void Vertex4(ref Single v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex4fv")]
        public static extern unsafe void Vertex4(Single* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex4i")]
        public static extern void Vertex4(Int32 x, Int32 y, Int32 z, Int32 w);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex4iv")]
        public static extern void Vertex4(Int32[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex4iv")]
        public static extern void Vertex4(ref Int32 v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex4iv")]
        public static extern unsafe void Vertex4(Int32* v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex4s")]
        public static extern void Vertex4(Int16 x, Int16 y, Int16 z, Int16 w);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex4sv")]
        public static extern void Vertex4(Int16[] v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex4sv")]
        public static extern void Vertex4(ref Int16 v);

        /// <summary>[requires: v1.0][deprecated: v3.2]
        /// Specify a vertex
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glVertex4sv")]
        public static extern unsafe void Vertex4(Int16* v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib1d")]
        public static extern void VertexAttrib1(Int32 index, Double x);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib1d")]
        public static extern void VertexAttrib1(UInt32 index, Double x);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib1dv")]
        public static extern unsafe void VertexAttrib1(Int32 index, Double* v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib1dv")]
        public static extern unsafe void VertexAttrib1(UInt32 index, Double* v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib1f")]
        public static extern void VertexAttrib1(Int32 index, Single x);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib1f")]
        public static extern void VertexAttrib1(UInt32 index, Single x);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib1fv")]
        public static extern unsafe void VertexAttrib1(Int32 index, Single* v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib1fv")]
        public static extern unsafe void VertexAttrib1(UInt32 index, Single* v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib1s")]
        public static extern void VertexAttrib1(Int32 index, Int16 x);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib1s")]
        public static extern void VertexAttrib1(UInt32 index, Int16 x);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib1sv")]
        public static extern unsafe void VertexAttrib1(Int32 index, Int16* v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib1sv")]
        public static extern unsafe void VertexAttrib1(UInt32 index, Int16* v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib2d")]
        public static extern void VertexAttrib2(Int32 index, Double x, Double y);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib2d")]
        public static extern void VertexAttrib2(UInt32 index, Double x, Double y);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib2dv")]
        public static extern void VertexAttrib2(Int32 index, Double[] v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib2dv")]
        public static extern void VertexAttrib2(Int32 index, ref Double v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib2dv")]
        public static extern unsafe void VertexAttrib2(Int32 index, Double* v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib2dv")]
        public static extern void VertexAttrib2(UInt32 index, Double[] v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib2dv")]
        public static extern void VertexAttrib2(UInt32 index, ref Double v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib2dv")]
        public static extern unsafe void VertexAttrib2(UInt32 index, Double* v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib2f")]
        public static extern void VertexAttrib2(Int32 index, Single x, Single y);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib2f")]
        public static extern void VertexAttrib2(UInt32 index, Single x, Single y);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib2fv")]
        public static extern void VertexAttrib2(Int32 index, Single[] v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib2fv")]
        public static extern void VertexAttrib2(Int32 index, ref Single v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib2fv")]
        public static extern unsafe void VertexAttrib2(Int32 index, Single* v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib2fv")]
        public static extern void VertexAttrib2(UInt32 index, Single[] v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib2fv")]
        public static extern void VertexAttrib2(UInt32 index, ref Single v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib2fv")]
        public static extern unsafe void VertexAttrib2(UInt32 index, Single* v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib2s")]
        public static extern void VertexAttrib2(Int32 index, Int16 x, Int16 y);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib2s")]
        public static extern void VertexAttrib2(UInt32 index, Int16 x, Int16 y);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib2sv")]
        public static extern void VertexAttrib2(Int32 index, Int16[] v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib2sv")]
        public static extern void VertexAttrib2(Int32 index, ref Int16 v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib2sv")]
        public static extern unsafe void VertexAttrib2(Int32 index, Int16* v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib2sv")]
        public static extern void VertexAttrib2(UInt32 index, Int16[] v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib2sv")]
        public static extern void VertexAttrib2(UInt32 index, ref Int16 v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib2sv")]
        public static extern unsafe void VertexAttrib2(UInt32 index, Int16* v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib3d")]
        public static extern void VertexAttrib3(Int32 index, Double x, Double y, Double z);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib3d")]
        public static extern void VertexAttrib3(UInt32 index, Double x, Double y, Double z);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib3dv")]
        public static extern void VertexAttrib3(Int32 index, Double[] v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib3dv")]
        public static extern void VertexAttrib3(Int32 index, ref Double v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib3dv")]
        public static extern unsafe void VertexAttrib3(Int32 index, Double* v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib3dv")]
        public static extern void VertexAttrib3(UInt32 index, Double[] v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib3dv")]
        public static extern void VertexAttrib3(UInt32 index, ref Double v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib3dv")]
        public static extern unsafe void VertexAttrib3(UInt32 index, Double* v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib3f")]
        public static extern void VertexAttrib3(Int32 index, Single x, Single y, Single z);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib3f")]
        public static extern void VertexAttrib3(UInt32 index, Single x, Single y, Single z);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib3fv")]
        public static extern void VertexAttrib3(Int32 index, Single[] v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib3fv")]
        public static extern void VertexAttrib3(Int32 index, ref Single v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib3fv")]
        public static extern unsafe void VertexAttrib3(Int32 index, Single* v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib3fv")]
        public static extern void VertexAttrib3(UInt32 index, Single[] v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib3fv")]
        public static extern void VertexAttrib3(UInt32 index, ref Single v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib3fv")]
        public static extern unsafe void VertexAttrib3(UInt32 index, Single* v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib3s")]
        public static extern void VertexAttrib3(Int32 index, Int16 x, Int16 y, Int16 z);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib3s")]
        public static extern void VertexAttrib3(UInt32 index, Int16 x, Int16 y, Int16 z);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib3sv")]
        public static extern void VertexAttrib3(Int32 index, Int16[] v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib3sv")]
        public static extern void VertexAttrib3(Int32 index, ref Int16 v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib3sv")]
        public static extern unsafe void VertexAttrib3(Int32 index, Int16* v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib3sv")]
        public static extern void VertexAttrib3(UInt32 index, Int16[] v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib3sv")]
        public static extern void VertexAttrib3(UInt32 index, ref Int16 v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib3sv")]
        public static extern unsafe void VertexAttrib3(UInt32 index, Int16* v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4bv")]
        public static extern void VertexAttrib4(UInt32 index, SByte[] v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4bv")]
        public static extern void VertexAttrib4(UInt32 index, ref SByte v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4bv")]
        public static extern unsafe void VertexAttrib4(UInt32 index, SByte* v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4d")]
        public static extern void VertexAttrib4(Int32 index, Double x, Double y, Double z, Double w);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4d")]
        public static extern void VertexAttrib4(UInt32 index, Double x, Double y, Double z, Double w);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4dv")]
        public static extern void VertexAttrib4(Int32 index, Double[] v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4dv")]
        public static extern void VertexAttrib4(Int32 index, ref Double v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4dv")]
        public static extern unsafe void VertexAttrib4(Int32 index, Double* v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4dv")]
        public static extern void VertexAttrib4(UInt32 index, Double[] v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4dv")]
        public static extern void VertexAttrib4(UInt32 index, ref Double v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4dv")]
        public static extern unsafe void VertexAttrib4(UInt32 index, Double* v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4f")]
        public static extern void VertexAttrib4(Int32 index, Single x, Single y, Single z, Single w);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4f")]
        public static extern void VertexAttrib4(UInt32 index, Single x, Single y, Single z, Single w);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4fv")]
        public static extern void VertexAttrib4(Int32 index, Single[] v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4fv")]
        public static extern void VertexAttrib4(Int32 index, ref Single v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4fv")]
        public static extern unsafe void VertexAttrib4(Int32 index, Single* v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4fv")]
        public static extern void VertexAttrib4(UInt32 index, Single[] v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4fv")]
        public static extern void VertexAttrib4(UInt32 index, ref Single v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4fv")]
        public static extern unsafe void VertexAttrib4(UInt32 index, Single* v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4iv")]
        public static extern void VertexAttrib4(Int32 index, Int32[] v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4iv")]
        public static extern void VertexAttrib4(Int32 index, ref Int32 v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4iv")]
        public static extern unsafe void VertexAttrib4(Int32 index, Int32* v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4iv")]
        public static extern void VertexAttrib4(UInt32 index, Int32[] v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4iv")]
        public static extern void VertexAttrib4(UInt32 index, ref Int32 v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4iv")]
        public static extern unsafe void VertexAttrib4(UInt32 index, Int32* v);

        /// <summary>[requires: v2.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4Nbv")]
        public static extern void VertexAttrib4N(UInt32 index, SByte[] v);

        /// <summary>[requires: v2.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4Nbv")]
        public static extern void VertexAttrib4N(UInt32 index, ref SByte v);

        /// <summary>[requires: v2.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4Nbv")]
        public static extern unsafe void VertexAttrib4N(UInt32 index, SByte* v);

        /// <summary>[requires: v2.0]</summary>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4Niv")]
        public static extern void VertexAttrib4N(Int32 index, Int32[] v);

        /// <summary>[requires: v2.0]</summary>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4Niv")]
        public static extern void VertexAttrib4N(Int32 index, ref Int32 v);

        /// <summary>[requires: v2.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4Niv")]
        public static extern unsafe void VertexAttrib4N(Int32 index, Int32* v);

        /// <summary>[requires: v2.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4Niv")]
        public static extern void VertexAttrib4N(UInt32 index, Int32[] v);

        /// <summary>[requires: v2.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4Niv")]
        public static extern void VertexAttrib4N(UInt32 index, ref Int32 v);

        /// <summary>[requires: v2.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4Niv")]
        public static extern unsafe void VertexAttrib4N(UInt32 index, Int32* v);

        /// <summary>[requires: v2.0]</summary>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4Nsv")]
        public static extern void VertexAttrib4N(Int32 index, Int16[] v);

        /// <summary>[requires: v2.0]</summary>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4Nsv")]
        public static extern void VertexAttrib4N(Int32 index, ref Int16 v);

        /// <summary>[requires: v2.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4Nsv")]
        public static extern unsafe void VertexAttrib4N(Int32 index, Int16* v);

        /// <summary>[requires: v2.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4Nsv")]
        public static extern void VertexAttrib4N(UInt32 index, Int16[] v);

        /// <summary>[requires: v2.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4Nsv")]
        public static extern void VertexAttrib4N(UInt32 index, ref Int16 v);

        /// <summary>[requires: v2.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4Nsv")]
        public static extern unsafe void VertexAttrib4N(UInt32 index, Int16* v);

        /// <summary>[requires: v2.0]</summary>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4Nub")]
        public static extern void VertexAttrib4N(Int32 index, Byte x, Byte y, Byte z, Byte w);

        /// <summary>[requires: v2.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4Nub")]
        public static extern void VertexAttrib4N(UInt32 index, Byte x, Byte y, Byte z, Byte w);

        /// <summary>[requires: v2.0]</summary>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4Nubv")]
        public static extern void VertexAttrib4N(Int32 index, Byte[] v);

        /// <summary>[requires: v2.0]</summary>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4Nubv")]
        public static extern void VertexAttrib4N(Int32 index, ref Byte v);

        /// <summary>[requires: v2.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4Nubv")]
        public static extern unsafe void VertexAttrib4N(Int32 index, Byte* v);

        /// <summary>[requires: v2.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4Nubv")]
        public static extern void VertexAttrib4N(UInt32 index, Byte[] v);

        /// <summary>[requires: v2.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4Nubv")]
        public static extern void VertexAttrib4N(UInt32 index, ref Byte v);

        /// <summary>[requires: v2.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4Nubv")]
        public static extern unsafe void VertexAttrib4N(UInt32 index, Byte* v);

        /// <summary>[requires: v2.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4Nuiv")]
        public static extern void VertexAttrib4N(UInt32 index, UInt32[] v);

        /// <summary>[requires: v2.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4Nuiv")]
        public static extern void VertexAttrib4N(UInt32 index, ref UInt32 v);

        /// <summary>[requires: v2.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4Nuiv")]
        public static extern unsafe void VertexAttrib4N(UInt32 index, UInt32* v);

        /// <summary>[requires: v2.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4Nusv")]
        public static extern void VertexAttrib4N(UInt32 index, UInt16[] v);

        /// <summary>[requires: v2.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4Nusv")]
        public static extern void VertexAttrib4N(UInt32 index, ref UInt16 v);

        /// <summary>[requires: v2.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4Nusv")]
        public static extern unsafe void VertexAttrib4N(UInt32 index, UInt16* v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4s")]
        public static extern void VertexAttrib4(Int32 index, Int16 x, Int16 y, Int16 z, Int16 w);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4s")]
        public static extern void VertexAttrib4(UInt32 index, Int16 x, Int16 y, Int16 z, Int16 w);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4sv")]
        public static extern void VertexAttrib4(Int32 index, Int16[] v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4sv")]
        public static extern void VertexAttrib4(Int32 index, ref Int16 v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4sv")]
        public static extern unsafe void VertexAttrib4(Int32 index, Int16* v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4sv")]
        public static extern void VertexAttrib4(UInt32 index, Int16[] v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4sv")]
        public static extern void VertexAttrib4(UInt32 index, ref Int16 v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4sv")]
        public static extern unsafe void VertexAttrib4(UInt32 index, Int16* v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4ubv")]
        public static extern void VertexAttrib4(Int32 index, Byte[] v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4ubv")]
        public static extern void VertexAttrib4(Int32 index, ref Byte v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4ubv")]
        public static extern unsafe void VertexAttrib4(Int32 index, Byte* v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4ubv")]
        public static extern void VertexAttrib4(UInt32 index, Byte[] v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4ubv")]
        public static extern void VertexAttrib4(UInt32 index, ref Byte v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4ubv")]
        public static extern unsafe void VertexAttrib4(UInt32 index, Byte* v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4uiv")]
        public static extern void VertexAttrib4(UInt32 index, UInt32[] v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4uiv")]
        public static extern void VertexAttrib4(UInt32 index, ref UInt32 v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4uiv")]
        public static extern unsafe void VertexAttrib4(UInt32 index, UInt32* v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4usv")]
        public static extern void VertexAttrib4(UInt32 index, UInt16[] v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4usv")]
        public static extern void VertexAttrib4(UInt32 index, ref UInt16 v);

        /// <summary>[requires: v2.0]
        /// Specifies the value of a generic vertex attribute
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="v0">
        /// <para>
        /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
        /// </para>
        /// </param>
        /// <param name="value">
        /// <para>
        /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttrib4usv")]
        public static extern unsafe void VertexAttrib4(UInt32 index, UInt16* v);

        /// <summary>[requires: v4.3 and ARB_vertex_attrib_binding|VERSION_4_3]
        /// Associate a vertex attribute and a vertex buffer binding
        /// </summary>
        /// <param name="attribindex">
        /// <para>
        /// The index of the attribute to associate with a vertex buffer binding.
        /// </para>
        /// </param>
        /// <param name="bindingindex">
        /// <para>
        /// The index of the vertex buffer binding with which to associate the generic vertex attribute.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_vertex_attrib_binding|VERSION_4_3", Version = "4.3", EntryPoint = "glVertexAttribBinding")]
        public static extern void VertexAttribBinding(Int32 attribindex, Int32 bindingindex);

        /// <summary>[requires: v4.3 and ARB_vertex_attrib_binding|VERSION_4_3]
        /// Associate a vertex attribute and a vertex buffer binding
        /// </summary>
        /// <param name="attribindex">
        /// <para>
        /// The index of the attribute to associate with a vertex buffer binding.
        /// </para>
        /// </param>
        /// <param name="bindingindex">
        /// <para>
        /// The index of the vertex buffer binding with which to associate the generic vertex attribute.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_attrib_binding|VERSION_4_3", Version = "4.3", EntryPoint = "glVertexAttribBinding")]
        public static extern void VertexAttribBinding(UInt32 attribindex, UInt32 bindingindex);

        /// <summary>[requires: v3.3]
        /// Modify the rate at which generic vertex attributes advance during instanced rendering
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specify the index of the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="divisor">
        /// <para>
        /// Specify the number of instances that will pass between updates of the generic attribute at slot index.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_3_3", Version = "3.3", EntryPoint = "glVertexAttribDivisor")]
        public static extern void VertexAttribDivisor(Int32 index, Int32 divisor);

        /// <summary>[requires: v3.3]
        /// Modify the rate at which generic vertex attributes advance during instanced rendering
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specify the index of the generic vertex attribute.
        /// </para>
        /// </param>
        /// <param name="divisor">
        /// <para>
        /// Specify the number of instances that will pass between updates of the generic attribute at slot index.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_3", Version = "3.3", EntryPoint = "glVertexAttribDivisor")]
        public static extern void VertexAttribDivisor(UInt32 index, UInt32 divisor);

        /// <summary>[requires: v4.3 and ARB_vertex_attrib_binding|VERSION_4_3]
        /// Specify the organization of vertex arrays
        /// </summary>
        /// <param name="attribindex">
        /// <para>
        /// The generic vertex attribute array being described.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// The number of values per vertex that are stored in the array.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the data stored in the array.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// The distance between elements within the buffer.
        /// </para>
        /// </param>
        /// <param name="relativeoffset">
        /// <para>
        /// The distance between elements within the buffer.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_vertex_attrib_binding|VERSION_4_3", Version = "4.3", EntryPoint = "glVertexAttribFormat")]
        public static extern void VertexAttribFormat(Int32 attribindex, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribType type, bool normalized, Int32 relativeoffset);

        /// <summary>[requires: v4.3 and ARB_vertex_attrib_binding|VERSION_4_3]
        /// Specify the organization of vertex arrays
        /// </summary>
        /// <param name="attribindex">
        /// <para>
        /// The generic vertex attribute array being described.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// The number of values per vertex that are stored in the array.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// The type of the data stored in the array.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// The distance between elements within the buffer.
        /// </para>
        /// </param>
        /// <param name="relativeoffset">
        /// <para>
        /// The distance between elements within the buffer.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_attrib_binding|VERSION_4_3", Version = "4.3", EntryPoint = "glVertexAttribFormat")]
        public static extern void VertexAttribFormat(UInt32 attribindex, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribType type, bool normalized, UInt32 relativeoffset);

        /// <summary>[requires: v3.0]</summary>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI1i")]
        public static extern void VertexAttribI1(Int32 index, Int32 x);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI1i")]
        public static extern void VertexAttribI1(UInt32 index, Int32 x);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI1iv")]
        public static extern unsafe void VertexAttribI1(Int32 index, Int32* v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI1iv")]
        public static extern unsafe void VertexAttribI1(UInt32 index, Int32* v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI1ui")]
        public static extern void VertexAttribI1(UInt32 index, UInt32 x);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI1uiv")]
        public static extern unsafe void VertexAttribI1(UInt32 index, UInt32* v);

        /// <summary>[requires: v3.0]</summary>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI2i")]
        public static extern void VertexAttribI2(Int32 index, Int32 x, Int32 y);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI2i")]
        public static extern void VertexAttribI2(UInt32 index, Int32 x, Int32 y);

        /// <summary>[requires: v3.0]</summary>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI2iv")]
        public static extern void VertexAttribI2(Int32 index, Int32[] v);

        /// <summary>[requires: v3.0]</summary>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI2iv")]
        public static extern void VertexAttribI2(Int32 index, ref Int32 v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI2iv")]
        public static extern unsafe void VertexAttribI2(Int32 index, Int32* v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI2iv")]
        public static extern void VertexAttribI2(UInt32 index, Int32[] v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI2iv")]
        public static extern void VertexAttribI2(UInt32 index, ref Int32 v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI2iv")]
        public static extern unsafe void VertexAttribI2(UInt32 index, Int32* v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI2ui")]
        public static extern void VertexAttribI2(UInt32 index, UInt32 x, UInt32 y);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI2uiv")]
        public static extern void VertexAttribI2(UInt32 index, UInt32[] v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI2uiv")]
        public static extern void VertexAttribI2(UInt32 index, ref UInt32 v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI2uiv")]
        public static extern unsafe void VertexAttribI2(UInt32 index, UInt32* v);

        /// <summary>[requires: v3.0]</summary>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI3i")]
        public static extern void VertexAttribI3(Int32 index, Int32 x, Int32 y, Int32 z);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI3i")]
        public static extern void VertexAttribI3(UInt32 index, Int32 x, Int32 y, Int32 z);

        /// <summary>[requires: v3.0]</summary>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI3iv")]
        public static extern void VertexAttribI3(Int32 index, Int32[] v);

        /// <summary>[requires: v3.0]</summary>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI3iv")]
        public static extern void VertexAttribI3(Int32 index, ref Int32 v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI3iv")]
        public static extern unsafe void VertexAttribI3(Int32 index, Int32* v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI3iv")]
        public static extern void VertexAttribI3(UInt32 index, Int32[] v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI3iv")]
        public static extern void VertexAttribI3(UInt32 index, ref Int32 v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI3iv")]
        public static extern unsafe void VertexAttribI3(UInt32 index, Int32* v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI3ui")]
        public static extern void VertexAttribI3(UInt32 index, UInt32 x, UInt32 y, UInt32 z);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI3uiv")]
        public static extern void VertexAttribI3(UInt32 index, UInt32[] v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI3uiv")]
        public static extern void VertexAttribI3(UInt32 index, ref UInt32 v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI3uiv")]
        public static extern unsafe void VertexAttribI3(UInt32 index, UInt32* v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI4bv")]
        public static extern void VertexAttribI4(UInt32 index, SByte[] v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI4bv")]
        public static extern void VertexAttribI4(UInt32 index, ref SByte v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI4bv")]
        public static extern unsafe void VertexAttribI4(UInt32 index, SByte* v);

        /// <summary>[requires: v3.0]</summary>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI4i")]
        public static extern void VertexAttribI4(Int32 index, Int32 x, Int32 y, Int32 z, Int32 w);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI4i")]
        public static extern void VertexAttribI4(UInt32 index, Int32 x, Int32 y, Int32 z, Int32 w);

        /// <summary>[requires: v3.0]</summary>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI4iv")]
        public static extern void VertexAttribI4(Int32 index, Int32[] v);

        /// <summary>[requires: v3.0]</summary>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI4iv")]
        public static extern void VertexAttribI4(Int32 index, ref Int32 v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI4iv")]
        public static extern unsafe void VertexAttribI4(Int32 index, Int32* v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI4iv")]
        public static extern void VertexAttribI4(UInt32 index, Int32[] v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI4iv")]
        public static extern void VertexAttribI4(UInt32 index, ref Int32 v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI4iv")]
        public static extern unsafe void VertexAttribI4(UInt32 index, Int32* v);

        /// <summary>[requires: v3.0]</summary>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI4sv")]
        public static extern void VertexAttribI4(Int32 index, Int16[] v);

        /// <summary>[requires: v3.0]</summary>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI4sv")]
        public static extern void VertexAttribI4(Int32 index, ref Int16 v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI4sv")]
        public static extern unsafe void VertexAttribI4(Int32 index, Int16* v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI4sv")]
        public static extern void VertexAttribI4(UInt32 index, Int16[] v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI4sv")]
        public static extern void VertexAttribI4(UInt32 index, ref Int16 v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI4sv")]
        public static extern unsafe void VertexAttribI4(UInt32 index, Int16* v);

        /// <summary>[requires: v3.0]</summary>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI4ubv")]
        public static extern void VertexAttribI4(Int32 index, Byte[] v);

        /// <summary>[requires: v3.0]</summary>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI4ubv")]
        public static extern void VertexAttribI4(Int32 index, ref Byte v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI4ubv")]
        public static extern unsafe void VertexAttribI4(Int32 index, Byte* v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI4ubv")]
        public static extern void VertexAttribI4(UInt32 index, Byte[] v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI4ubv")]
        public static extern void VertexAttribI4(UInt32 index, ref Byte v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI4ubv")]
        public static extern unsafe void VertexAttribI4(UInt32 index, Byte* v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI4ui")]
        public static extern void VertexAttribI4(UInt32 index, UInt32 x, UInt32 y, UInt32 z, UInt32 w);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI4uiv")]
        public static extern void VertexAttribI4(UInt32 index, UInt32[] v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI4uiv")]
        public static extern void VertexAttribI4(UInt32 index, ref UInt32 v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI4uiv")]
        public static extern unsafe void VertexAttribI4(UInt32 index, UInt32* v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI4usv")]
        public static extern void VertexAttribI4(UInt32 index, UInt16[] v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI4usv")]
        public static extern void VertexAttribI4(UInt32 index, ref UInt16 v);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribI4usv")]
        public static extern unsafe void VertexAttribI4(UInt32 index, UInt16* v);

        /// <summary>[requires: v4.3 and ARB_vertex_attrib_binding|VERSION_4_3]</summary>
        [AutoGenerated(Category = "ARB_vertex_attrib_binding|VERSION_4_3", Version = "4.3", EntryPoint = "glVertexAttribIFormat")]
        public static extern void VertexAttribIFormat(Int32 attribindex, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribIntegerType type, Int32 relativeoffset);

        /// <summary>[requires: v4.3 and ARB_vertex_attrib_binding|VERSION_4_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_attrib_binding|VERSION_4_3", Version = "4.3", EntryPoint = "glVertexAttribIFormat")]
        public static extern void VertexAttribIFormat(UInt32 attribindex, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribIntegerType type, UInt32 relativeoffset);

        /// <summary>[requires: v3.0]</summary>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribIPointer")]
        public static extern void VertexAttribIPointer(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribIntegerType type, Int32 stride, IntPtr pointer);

        /// <summary>[requires: v3.0]</summary>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribIPointer")]
        public static extern void VertexAttribIPointer<T4>(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribIntegerType type, Int32 stride, [InAttribute, OutAttribute] T4[] pointer)
            where T4 : struct
        ;

        /// <summary>[requires: v3.0]</summary>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribIPointer")]
        public static extern void VertexAttribIPointer<T4>(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribIntegerType type, Int32 stride, [InAttribute, OutAttribute] T4[,] pointer)
            where T4 : struct
        ;

        /// <summary>[requires: v3.0]</summary>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribIPointer")]
        public static extern void VertexAttribIPointer<T4>(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribIntegerType type, Int32 stride, [InAttribute, OutAttribute] T4[,,] pointer)
            where T4 : struct
        ;

        /// <summary>[requires: v3.0]</summary>
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribIPointer")]
        public static extern void VertexAttribIPointer<T4>(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribIntegerType type, Int32 stride, [InAttribute, OutAttribute] ref T4 pointer)
            where T4 : struct
        ;

        /// <summary>[requires: v3.0]</summary>
        [Obsolete("Use VertexAttribIntegerType overload instead")]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribIPointer")]
        public static extern void VertexAttribIPointer(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribIPointerType type, Int32 stride, IntPtr pointer);

        /// <summary>[requires: v3.0]</summary>
        [Obsolete("Use VertexAttribIntegerType overload instead")]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribIPointer")]
        public static extern void VertexAttribIPointer<T4>(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribIPointerType type, Int32 stride, [InAttribute, OutAttribute] T4[] pointer)
            where T4 : struct
        ;

        /// <summary>[requires: v3.0]</summary>
        [Obsolete("Use VertexAttribIntegerType overload instead")]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribIPointer")]
        public static extern void VertexAttribIPointer<T4>(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribIPointerType type, Int32 stride, [InAttribute, OutAttribute] T4[,] pointer)
            where T4 : struct
        ;

        /// <summary>[requires: v3.0]</summary>
        [Obsolete("Use VertexAttribIntegerType overload instead")]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribIPointer")]
        public static extern void VertexAttribIPointer<T4>(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribIPointerType type, Int32 stride, [InAttribute, OutAttribute] T4[,,] pointer)
            where T4 : struct
        ;

        /// <summary>[requires: v3.0]</summary>
        [Obsolete("Use VertexAttribIntegerType overload instead")]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribIPointer")]
        public static extern void VertexAttribIPointer<T4>(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribIPointerType type, Int32 stride, [InAttribute, OutAttribute] ref T4 pointer)
            where T4 : struct
        ;

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribIPointer")]
        public static extern void VertexAttribIPointer(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribIntegerType type, Int32 stride, IntPtr pointer);

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribIPointer")]
        public static extern void VertexAttribIPointer<T4>(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribIntegerType type, Int32 stride, [InAttribute, OutAttribute] T4[] pointer)
            where T4 : struct
        ;

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribIPointer")]
        public static extern void VertexAttribIPointer<T4>(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribIntegerType type, Int32 stride, [InAttribute, OutAttribute] T4[,] pointer)
            where T4 : struct
        ;

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribIPointer")]
        public static extern void VertexAttribIPointer<T4>(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribIntegerType type, Int32 stride, [InAttribute, OutAttribute] T4[,,] pointer)
            where T4 : struct
        ;

        /// <summary>[requires: v3.0]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribIPointer")]
        public static extern void VertexAttribIPointer<T4>(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribIntegerType type, Int32 stride, [InAttribute, OutAttribute] ref T4 pointer)
            where T4 : struct
        ;

        /// <summary>[requires: v3.0]</summary>
        [Obsolete("Use VertexAttribIntegerType overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribIPointer")]
        public static extern void VertexAttribIPointer(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribIPointerType type, Int32 stride, IntPtr pointer);

        /// <summary>[requires: v3.0]</summary>
        [Obsolete("Use VertexAttribIntegerType overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribIPointer")]
        public static extern void VertexAttribIPointer<T4>(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribIPointerType type, Int32 stride, [InAttribute, OutAttribute] T4[] pointer)
            where T4 : struct
        ;

        /// <summary>[requires: v3.0]</summary>
        [Obsolete("Use VertexAttribIntegerType overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribIPointer")]
        public static extern void VertexAttribIPointer<T4>(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribIPointerType type, Int32 stride, [InAttribute, OutAttribute] T4[,] pointer)
            where T4 : struct
        ;

        /// <summary>[requires: v3.0]</summary>
        [Obsolete("Use VertexAttribIntegerType overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribIPointer")]
        public static extern void VertexAttribIPointer<T4>(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribIPointerType type, Int32 stride, [InAttribute, OutAttribute] T4[,,] pointer)
            where T4 : struct
        ;

        /// <summary>[requires: v3.0]</summary>
        [Obsolete("Use VertexAttribIntegerType overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_3_0", Version = "3.0", EntryPoint = "glVertexAttribIPointer")]
        public static extern void VertexAttribIPointer<T4>(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribIPointerType type, Int32 stride, [InAttribute, OutAttribute] ref T4 pointer)
            where T4 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribL1d")]
        public static extern void VertexAttribL1(Int32 index, Double x);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribL1d")]
        public static extern void VertexAttribL1(UInt32 index, Double x);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribL1dv")]
        public static extern unsafe void VertexAttribL1(Int32 index, Double* v);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribL1dv")]
        public static extern unsafe void VertexAttribL1(UInt32 index, Double* v);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribL2d")]
        public static extern void VertexAttribL2(Int32 index, Double x, Double y);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribL2d")]
        public static extern void VertexAttribL2(UInt32 index, Double x, Double y);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribL2dv")]
        public static extern void VertexAttribL2(Int32 index, Double[] v);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribL2dv")]
        public static extern void VertexAttribL2(Int32 index, ref Double v);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribL2dv")]
        public static extern unsafe void VertexAttribL2(Int32 index, Double* v);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribL2dv")]
        public static extern void VertexAttribL2(UInt32 index, Double[] v);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribL2dv")]
        public static extern void VertexAttribL2(UInt32 index, ref Double v);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribL2dv")]
        public static extern unsafe void VertexAttribL2(UInt32 index, Double* v);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribL3d")]
        public static extern void VertexAttribL3(Int32 index, Double x, Double y, Double z);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribL3d")]
        public static extern void VertexAttribL3(UInt32 index, Double x, Double y, Double z);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribL3dv")]
        public static extern void VertexAttribL3(Int32 index, Double[] v);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribL3dv")]
        public static extern void VertexAttribL3(Int32 index, ref Double v);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribL3dv")]
        public static extern unsafe void VertexAttribL3(Int32 index, Double* v);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribL3dv")]
        public static extern void VertexAttribL3(UInt32 index, Double[] v);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribL3dv")]
        public static extern void VertexAttribL3(UInt32 index, ref Double v);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribL3dv")]
        public static extern unsafe void VertexAttribL3(UInt32 index, Double* v);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribL4d")]
        public static extern void VertexAttribL4(Int32 index, Double x, Double y, Double z, Double w);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribL4d")]
        public static extern void VertexAttribL4(UInt32 index, Double x, Double y, Double z, Double w);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribL4dv")]
        public static extern void VertexAttribL4(Int32 index, Double[] v);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribL4dv")]
        public static extern void VertexAttribL4(Int32 index, ref Double v);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribL4dv")]
        public static extern unsafe void VertexAttribL4(Int32 index, Double* v);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribL4dv")]
        public static extern void VertexAttribL4(UInt32 index, Double[] v);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribL4dv")]
        public static extern void VertexAttribL4(UInt32 index, ref Double v);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribL4dv")]
        public static extern unsafe void VertexAttribL4(UInt32 index, Double* v);

        /// <summary>[requires: v4.3 and ARB_vertex_attrib_binding|VERSION_4_3]</summary>
        [AutoGenerated(Category = "ARB_vertex_attrib_binding|VERSION_4_3", Version = "4.3", EntryPoint = "glVertexAttribLFormat")]
        public static extern void VertexAttribLFormat(Int32 attribindex, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribDoubleType type, Int32 relativeoffset);

        /// <summary>[requires: v4.3 and ARB_vertex_attrib_binding|VERSION_4_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_attrib_binding|VERSION_4_3", Version = "4.3", EntryPoint = "glVertexAttribLFormat")]
        public static extern void VertexAttribLFormat(UInt32 attribindex, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribDoubleType type, UInt32 relativeoffset);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribLPointer")]
        public static extern void VertexAttribLPointer(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribDoubleType type, Int32 stride, IntPtr pointer);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribLPointer")]
        public static extern void VertexAttribLPointer<T4>(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribDoubleType type, Int32 stride, [InAttribute, OutAttribute] T4[] pointer)
            where T4 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribLPointer")]
        public static extern void VertexAttribLPointer<T4>(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribDoubleType type, Int32 stride, [InAttribute, OutAttribute] T4[,] pointer)
            where T4 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribLPointer")]
        public static extern void VertexAttribLPointer<T4>(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribDoubleType type, Int32 stride, [InAttribute, OutAttribute] T4[,,] pointer)
            where T4 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribLPointer")]
        public static extern void VertexAttribLPointer<T4>(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribDoubleType type, Int32 stride, [InAttribute, OutAttribute] ref T4 pointer)
            where T4 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribLPointer")]
        public static extern void VertexAttribLPointer(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribDoubleType type, Int32 stride, IntPtr pointer);

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribLPointer")]
        public static extern void VertexAttribLPointer<T4>(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribDoubleType type, Int32 stride, [InAttribute, OutAttribute] T4[] pointer)
            where T4 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribLPointer")]
        public static extern void VertexAttribLPointer<T4>(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribDoubleType type, Int32 stride, [InAttribute, OutAttribute] T4[,] pointer)
            where T4 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribLPointer")]
        public static extern void VertexAttribLPointer<T4>(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribDoubleType type, Int32 stride, [InAttribute, OutAttribute] T4[,,] pointer)
            where T4 : struct
        ;

        /// <summary>[requires: v4.1 and ARB_vertex_attrib_64bit|VERSION_4_1]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_attrib_64bit|VERSION_4_1", Version = "4.1", EntryPoint = "glVertexAttribLPointer")]
        public static extern void VertexAttribLPointer<T4>(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribDoubleType type, Int32 stride, [InAttribute, OutAttribute] ref T4 pointer)
            where T4 : struct
        ;

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glVertexAttribP1ui")]
        public static extern void VertexAttribP1(Int32 index, OpenTK.Graphics.OpenGL.PackedPointerType type, bool normalized, Int32 value);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glVertexAttribP1ui")]
        public static extern void VertexAttribP1(UInt32 index, OpenTK.Graphics.OpenGL.PackedPointerType type, bool normalized, UInt32 value);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glVertexAttribP1uiv")]
        public static extern unsafe void VertexAttribP1(Int32 index, OpenTK.Graphics.OpenGL.PackedPointerType type, bool normalized, Int32* value);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glVertexAttribP1uiv")]
        public static extern unsafe void VertexAttribP1(UInt32 index, OpenTK.Graphics.OpenGL.PackedPointerType type, bool normalized, UInt32* value);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glVertexAttribP2ui")]
        public static extern void VertexAttribP2(Int32 index, OpenTK.Graphics.OpenGL.PackedPointerType type, bool normalized, Int32 value);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glVertexAttribP2ui")]
        public static extern void VertexAttribP2(UInt32 index, OpenTK.Graphics.OpenGL.PackedPointerType type, bool normalized, UInt32 value);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glVertexAttribP2uiv")]
        public static extern unsafe void VertexAttribP2(Int32 index, OpenTK.Graphics.OpenGL.PackedPointerType type, bool normalized, Int32* value);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glVertexAttribP2uiv")]
        public static extern unsafe void VertexAttribP2(UInt32 index, OpenTK.Graphics.OpenGL.PackedPointerType type, bool normalized, UInt32* value);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glVertexAttribP3ui")]
        public static extern void VertexAttribP3(Int32 index, OpenTK.Graphics.OpenGL.PackedPointerType type, bool normalized, Int32 value);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glVertexAttribP3ui")]
        public static extern void VertexAttribP3(UInt32 index, OpenTK.Graphics.OpenGL.PackedPointerType type, bool normalized, UInt32 value);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glVertexAttribP3uiv")]
        public static extern unsafe void VertexAttribP3(Int32 index, OpenTK.Graphics.OpenGL.PackedPointerType type, bool normalized, Int32* value);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glVertexAttribP3uiv")]
        public static extern unsafe void VertexAttribP3(UInt32 index, OpenTK.Graphics.OpenGL.PackedPointerType type, bool normalized, UInt32* value);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glVertexAttribP4ui")]
        public static extern void VertexAttribP4(Int32 index, OpenTK.Graphics.OpenGL.PackedPointerType type, bool normalized, Int32 value);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glVertexAttribP4ui")]
        public static extern void VertexAttribP4(UInt32 index, OpenTK.Graphics.OpenGL.PackedPointerType type, bool normalized, UInt32 value);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glVertexAttribP4uiv")]
        public static extern unsafe void VertexAttribP4(Int32 index, OpenTK.Graphics.OpenGL.PackedPointerType type, bool normalized, Int32* value);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glVertexAttribP4uiv")]
        public static extern unsafe void VertexAttribP4(UInt32 index, OpenTK.Graphics.OpenGL.PackedPointerType type, bool normalized, UInt32* value);

        /// <summary>[requires: v2.0]
        /// Define an array of generic vertex attribute data
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Specifies the number of components per generic vertex attribute. Must be 1, 2, 3, 4. Additionally, the symbolic constant GL_BGRA is accepted by glVertexAttribPointer. The initial value is 4.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each component in the array. The symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, and GL_UNSIGNED_INT are accepted by glVertexAttribPointer and glVertexAttribIPointer. Additionally GL_HALF_FLOAT, GL_FLOAT, GL_DOUBLE, GL_FIXED, GL_INT_2_10_10_10_REV, GL_UNSIGNED_INT_2_10_10_10_REV and GL_UNSIGNED_INT_10F_11F_11F_REV are accepted by glVertexAttribPointer. GL_DOUBLE is also accepted by glVertexAttribLPointer and is the only token accepted by the type parameter for that function. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For glVertexAttribPointer, specifies whether fixed-point data values should be normalized (GL_TRUE) or converted directly as fixed-point values (GL_FALSE) when they are accessed.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive generic vertex attributes. If stride is 0, the generic vertex attributes are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a offset of the first component of the first generic vertex attribute in the array in the data store of the buffer currently bound to the GL_ARRAY_BUFFER target. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttribPointer")]
        public static extern void VertexAttribPointer(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribPointerType type, bool normalized, Int32 stride, IntPtr pointer);

        /// <summary>[requires: v2.0]
        /// Define an array of generic vertex attribute data
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Specifies the number of components per generic vertex attribute. Must be 1, 2, 3, 4. Additionally, the symbolic constant GL_BGRA is accepted by glVertexAttribPointer. The initial value is 4.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each component in the array. The symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, and GL_UNSIGNED_INT are accepted by glVertexAttribPointer and glVertexAttribIPointer. Additionally GL_HALF_FLOAT, GL_FLOAT, GL_DOUBLE, GL_FIXED, GL_INT_2_10_10_10_REV, GL_UNSIGNED_INT_2_10_10_10_REV and GL_UNSIGNED_INT_10F_11F_11F_REV are accepted by glVertexAttribPointer. GL_DOUBLE is also accepted by glVertexAttribLPointer and is the only token accepted by the type parameter for that function. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For glVertexAttribPointer, specifies whether fixed-point data values should be normalized (GL_TRUE) or converted directly as fixed-point values (GL_FALSE) when they are accessed.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive generic vertex attributes. If stride is 0, the generic vertex attributes are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a offset of the first component of the first generic vertex attribute in the array in the data store of the buffer currently bound to the GL_ARRAY_BUFFER target. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttribPointer")]
        public static extern void VertexAttribPointer<T5>(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribPointerType type, bool normalized, Int32 stride, [InAttribute, OutAttribute] T5[] pointer)
            where T5 : struct
        ;

        /// <summary>[requires: v2.0]
        /// Define an array of generic vertex attribute data
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Specifies the number of components per generic vertex attribute. Must be 1, 2, 3, 4. Additionally, the symbolic constant GL_BGRA is accepted by glVertexAttribPointer. The initial value is 4.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each component in the array. The symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, and GL_UNSIGNED_INT are accepted by glVertexAttribPointer and glVertexAttribIPointer. Additionally GL_HALF_FLOAT, GL_FLOAT, GL_DOUBLE, GL_FIXED, GL_INT_2_10_10_10_REV, GL_UNSIGNED_INT_2_10_10_10_REV and GL_UNSIGNED_INT_10F_11F_11F_REV are accepted by glVertexAttribPointer. GL_DOUBLE is also accepted by glVertexAttribLPointer and is the only token accepted by the type parameter for that function. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For glVertexAttribPointer, specifies whether fixed-point data values should be normalized (GL_TRUE) or converted directly as fixed-point values (GL_FALSE) when they are accessed.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive generic vertex attributes. If stride is 0, the generic vertex attributes are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a offset of the first component of the first generic vertex attribute in the array in the data store of the buffer currently bound to the GL_ARRAY_BUFFER target. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttribPointer")]
        public static extern void VertexAttribPointer<T5>(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribPointerType type, bool normalized, Int32 stride, [InAttribute, OutAttribute] T5[,] pointer)
            where T5 : struct
        ;

        /// <summary>[requires: v2.0]
        /// Define an array of generic vertex attribute data
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Specifies the number of components per generic vertex attribute. Must be 1, 2, 3, 4. Additionally, the symbolic constant GL_BGRA is accepted by glVertexAttribPointer. The initial value is 4.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each component in the array. The symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, and GL_UNSIGNED_INT are accepted by glVertexAttribPointer and glVertexAttribIPointer. Additionally GL_HALF_FLOAT, GL_FLOAT, GL_DOUBLE, GL_FIXED, GL_INT_2_10_10_10_REV, GL_UNSIGNED_INT_2_10_10_10_REV and GL_UNSIGNED_INT_10F_11F_11F_REV are accepted by glVertexAttribPointer. GL_DOUBLE is also accepted by glVertexAttribLPointer and is the only token accepted by the type parameter for that function. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For glVertexAttribPointer, specifies whether fixed-point data values should be normalized (GL_TRUE) or converted directly as fixed-point values (GL_FALSE) when they are accessed.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive generic vertex attributes. If stride is 0, the generic vertex attributes are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a offset of the first component of the first generic vertex attribute in the array in the data store of the buffer currently bound to the GL_ARRAY_BUFFER target. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttribPointer")]
        public static extern void VertexAttribPointer<T5>(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribPointerType type, bool normalized, Int32 stride, [InAttribute, OutAttribute] T5[,,] pointer)
            where T5 : struct
        ;

        /// <summary>[requires: v2.0]
        /// Define an array of generic vertex attribute data
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Specifies the number of components per generic vertex attribute. Must be 1, 2, 3, 4. Additionally, the symbolic constant GL_BGRA is accepted by glVertexAttribPointer. The initial value is 4.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each component in the array. The symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, and GL_UNSIGNED_INT are accepted by glVertexAttribPointer and glVertexAttribIPointer. Additionally GL_HALF_FLOAT, GL_FLOAT, GL_DOUBLE, GL_FIXED, GL_INT_2_10_10_10_REV, GL_UNSIGNED_INT_2_10_10_10_REV and GL_UNSIGNED_INT_10F_11F_11F_REV are accepted by glVertexAttribPointer. GL_DOUBLE is also accepted by glVertexAttribLPointer and is the only token accepted by the type parameter for that function. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For glVertexAttribPointer, specifies whether fixed-point data values should be normalized (GL_TRUE) or converted directly as fixed-point values (GL_FALSE) when they are accessed.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive generic vertex attributes. If stride is 0, the generic vertex attributes are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a offset of the first component of the first generic vertex attribute in the array in the data store of the buffer currently bound to the GL_ARRAY_BUFFER target. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttribPointer")]
        public static extern void VertexAttribPointer<T5>(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribPointerType type, bool normalized, Int32 stride, [InAttribute, OutAttribute] ref T5 pointer)
            where T5 : struct
        ;

        /// <summary>[requires: v2.0]
        /// Define an array of generic vertex attribute data
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Specifies the number of components per generic vertex attribute. Must be 1, 2, 3, 4. Additionally, the symbolic constant GL_BGRA is accepted by glVertexAttribPointer. The initial value is 4.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each component in the array. The symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, and GL_UNSIGNED_INT are accepted by glVertexAttribPointer and glVertexAttribIPointer. Additionally GL_HALF_FLOAT, GL_FLOAT, GL_DOUBLE, GL_FIXED, GL_INT_2_10_10_10_REV, GL_UNSIGNED_INT_2_10_10_10_REV and GL_UNSIGNED_INT_10F_11F_11F_REV are accepted by glVertexAttribPointer. GL_DOUBLE is also accepted by glVertexAttribLPointer and is the only token accepted by the type parameter for that function. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For glVertexAttribPointer, specifies whether fixed-point data values should be normalized (GL_TRUE) or converted directly as fixed-point values (GL_FALSE) when they are accessed.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive generic vertex attributes. If stride is 0, the generic vertex attributes are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a offset of the first component of the first generic vertex attribute in the array in the data store of the buffer currently bound to the GL_ARRAY_BUFFER target. The initial value is 0.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttribPointer")]
        public static extern void VertexAttribPointer(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribPointerType type, bool normalized, Int32 stride, IntPtr pointer);

        /// <summary>[requires: v2.0]
        /// Define an array of generic vertex attribute data
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Specifies the number of components per generic vertex attribute. Must be 1, 2, 3, 4. Additionally, the symbolic constant GL_BGRA is accepted by glVertexAttribPointer. The initial value is 4.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each component in the array. The symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, and GL_UNSIGNED_INT are accepted by glVertexAttribPointer and glVertexAttribIPointer. Additionally GL_HALF_FLOAT, GL_FLOAT, GL_DOUBLE, GL_FIXED, GL_INT_2_10_10_10_REV, GL_UNSIGNED_INT_2_10_10_10_REV and GL_UNSIGNED_INT_10F_11F_11F_REV are accepted by glVertexAttribPointer. GL_DOUBLE is also accepted by glVertexAttribLPointer and is the only token accepted by the type parameter for that function. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For glVertexAttribPointer, specifies whether fixed-point data values should be normalized (GL_TRUE) or converted directly as fixed-point values (GL_FALSE) when they are accessed.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive generic vertex attributes. If stride is 0, the generic vertex attributes are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a offset of the first component of the first generic vertex attribute in the array in the data store of the buffer currently bound to the GL_ARRAY_BUFFER target. The initial value is 0.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttribPointer")]
        public static extern void VertexAttribPointer<T5>(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribPointerType type, bool normalized, Int32 stride, [InAttribute, OutAttribute] T5[] pointer)
            where T5 : struct
        ;

        /// <summary>[requires: v2.0]
        /// Define an array of generic vertex attribute data
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Specifies the number of components per generic vertex attribute. Must be 1, 2, 3, 4. Additionally, the symbolic constant GL_BGRA is accepted by glVertexAttribPointer. The initial value is 4.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each component in the array. The symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, and GL_UNSIGNED_INT are accepted by glVertexAttribPointer and glVertexAttribIPointer. Additionally GL_HALF_FLOAT, GL_FLOAT, GL_DOUBLE, GL_FIXED, GL_INT_2_10_10_10_REV, GL_UNSIGNED_INT_2_10_10_10_REV and GL_UNSIGNED_INT_10F_11F_11F_REV are accepted by glVertexAttribPointer. GL_DOUBLE is also accepted by glVertexAttribLPointer and is the only token accepted by the type parameter for that function. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For glVertexAttribPointer, specifies whether fixed-point data values should be normalized (GL_TRUE) or converted directly as fixed-point values (GL_FALSE) when they are accessed.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive generic vertex attributes. If stride is 0, the generic vertex attributes are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a offset of the first component of the first generic vertex attribute in the array in the data store of the buffer currently bound to the GL_ARRAY_BUFFER target. The initial value is 0.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttribPointer")]
        public static extern void VertexAttribPointer<T5>(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribPointerType type, bool normalized, Int32 stride, [InAttribute, OutAttribute] T5[,] pointer)
            where T5 : struct
        ;

        /// <summary>[requires: v2.0]
        /// Define an array of generic vertex attribute data
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Specifies the number of components per generic vertex attribute. Must be 1, 2, 3, 4. Additionally, the symbolic constant GL_BGRA is accepted by glVertexAttribPointer. The initial value is 4.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each component in the array. The symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, and GL_UNSIGNED_INT are accepted by glVertexAttribPointer and glVertexAttribIPointer. Additionally GL_HALF_FLOAT, GL_FLOAT, GL_DOUBLE, GL_FIXED, GL_INT_2_10_10_10_REV, GL_UNSIGNED_INT_2_10_10_10_REV and GL_UNSIGNED_INT_10F_11F_11F_REV are accepted by glVertexAttribPointer. GL_DOUBLE is also accepted by glVertexAttribLPointer and is the only token accepted by the type parameter for that function. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For glVertexAttribPointer, specifies whether fixed-point data values should be normalized (GL_TRUE) or converted directly as fixed-point values (GL_FALSE) when they are accessed.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive generic vertex attributes. If stride is 0, the generic vertex attributes are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a offset of the first component of the first generic vertex attribute in the array in the data store of the buffer currently bound to the GL_ARRAY_BUFFER target. The initial value is 0.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttribPointer")]
        public static extern void VertexAttribPointer<T5>(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribPointerType type, bool normalized, Int32 stride, [InAttribute, OutAttribute] T5[,,] pointer)
            where T5 : struct
        ;

        /// <summary>[requires: v2.0]
        /// Define an array of generic vertex attribute data
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specifies the index of the generic vertex attribute to be modified.
        /// </para>
        /// </param>
        /// <param name="size">
        /// <para>
        /// Specifies the number of components per generic vertex attribute. Must be 1, 2, 3, 4. Additionally, the symbolic constant GL_BGRA is accepted by glVertexAttribPointer. The initial value is 4.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each component in the array. The symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, and GL_UNSIGNED_INT are accepted by glVertexAttribPointer and glVertexAttribIPointer. Additionally GL_HALF_FLOAT, GL_FLOAT, GL_DOUBLE, GL_FIXED, GL_INT_2_10_10_10_REV, GL_UNSIGNED_INT_2_10_10_10_REV and GL_UNSIGNED_INT_10F_11F_11F_REV are accepted by glVertexAttribPointer. GL_DOUBLE is also accepted by glVertexAttribLPointer and is the only token accepted by the type parameter for that function. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="normalized">
        /// <para>
        /// For glVertexAttribPointer, specifies whether fixed-point data values should be normalized (GL_TRUE) or converted directly as fixed-point values (GL_FALSE) when they are accessed.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive generic vertex attributes. If stride is 0, the generic vertex attributes are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a offset of the first component of the first generic vertex attribute in the array in the data store of the buffer currently bound to the GL_ARRAY_BUFFER target. The initial value is 0.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_2_0", Version = "2.0", EntryPoint = "glVertexAttribPointer")]
        public static extern void VertexAttribPointer<T5>(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribPointerType type, bool normalized, Int32 stride, [InAttribute, OutAttribute] ref T5 pointer)
            where T5 : struct
        ;

        /// <summary>[requires: v4.3 and ARB_vertex_attrib_binding|VERSION_4_3]
        /// Modify the rate at which generic vertex attributes advance
        /// </summary>
        /// <param name="bindingindex">
        /// <para>
        /// The index of the binding whose divisor to modify.
        /// </para>
        /// </param>
        /// <param name="divisor">
        /// <para>
        /// The new value for the instance step rate to apply.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_vertex_attrib_binding|VERSION_4_3", Version = "4.3", EntryPoint = "glVertexBindingDivisor")]
        public static extern void VertexBindingDivisor(Int32 bindingindex, Int32 divisor);

        /// <summary>[requires: v4.3 and ARB_vertex_attrib_binding|VERSION_4_3]
        /// Modify the rate at which generic vertex attributes advance
        /// </summary>
        /// <param name="bindingindex">
        /// <para>
        /// The index of the binding whose divisor to modify.
        /// </para>
        /// </param>
        /// <param name="divisor">
        /// <para>
        /// The new value for the instance step rate to apply.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_attrib_binding|VERSION_4_3", Version = "4.3", EntryPoint = "glVertexBindingDivisor")]
        public static extern void VertexBindingDivisor(UInt32 bindingindex, UInt32 divisor);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glVertexP2ui")]
        public static extern void VertexP2(OpenTK.Graphics.OpenGL.PackedPointerType type, Int32 value);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glVertexP2ui")]
        public static extern void VertexP2(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32 value);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glVertexP2uiv")]
        public static extern unsafe void VertexP2(OpenTK.Graphics.OpenGL.PackedPointerType type, Int32* value);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glVertexP2uiv")]
        public static extern unsafe void VertexP2(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32* value);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glVertexP3ui")]
        public static extern void VertexP3(OpenTK.Graphics.OpenGL.PackedPointerType type, Int32 value);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glVertexP3ui")]
        public static extern void VertexP3(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32 value);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glVertexP3uiv")]
        public static extern unsafe void VertexP3(OpenTK.Graphics.OpenGL.PackedPointerType type, Int32* value);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glVertexP3uiv")]
        public static extern unsafe void VertexP3(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32* value);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glVertexP4ui")]
        public static extern void VertexP4(OpenTK.Graphics.OpenGL.PackedPointerType type, Int32 value);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glVertexP4ui")]
        public static extern void VertexP4(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32 value);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glVertexP4uiv")]
        public static extern unsafe void VertexP4(OpenTK.Graphics.OpenGL.PackedPointerType type, Int32* value);

        /// <summary>[requires: v3.3 and ARB_vertex_type_2_10_10_10_rev|VERSION_3_3]</summary>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_vertex_type_2_10_10_10_rev|VERSION_3_3", Version = "3.3", EntryPoint = "glVertexP4uiv")]
        public static extern unsafe void VertexP4(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32* value);

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Define an array of vertex data
        /// </summary>
        /// <param name="size">
        /// <para>
        /// Specifies the number of coordinates per vertex. Must be 2, 3, or 4. The initial value is 4.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each coordinate in the array. Symbolic constants GL_SHORT, GL_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive vertices. If stride is 0, the vertices are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first coordinate of the first vertex in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glVertexPointer")]
        public static extern void VertexPointer(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, Int32 stride, IntPtr pointer);

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Define an array of vertex data
        /// </summary>
        /// <param name="size">
        /// <para>
        /// Specifies the number of coordinates per vertex. Must be 2, 3, or 4. The initial value is 4.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each coordinate in the array. Symbolic constants GL_SHORT, GL_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive vertices. If stride is 0, the vertices are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first coordinate of the first vertex in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glVertexPointer")]
        public static extern void VertexPointer<T3>(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, Int32 stride, [InAttribute, OutAttribute] T3[] pointer)
            where T3 : struct
        ;

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Define an array of vertex data
        /// </summary>
        /// <param name="size">
        /// <para>
        /// Specifies the number of coordinates per vertex. Must be 2, 3, or 4. The initial value is 4.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each coordinate in the array. Symbolic constants GL_SHORT, GL_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive vertices. If stride is 0, the vertices are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first coordinate of the first vertex in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glVertexPointer")]
        public static extern void VertexPointer<T3>(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, Int32 stride, [InAttribute, OutAttribute] T3[,] pointer)
            where T3 : struct
        ;

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Define an array of vertex data
        /// </summary>
        /// <param name="size">
        /// <para>
        /// Specifies the number of coordinates per vertex. Must be 2, 3, or 4. The initial value is 4.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each coordinate in the array. Symbolic constants GL_SHORT, GL_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive vertices. If stride is 0, the vertices are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first coordinate of the first vertex in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glVertexPointer")]
        public static extern void VertexPointer<T3>(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, Int32 stride, [InAttribute, OutAttribute] T3[,,] pointer)
            where T3 : struct
        ;

        /// <summary>[requires: v1.1][deprecated: v3.2]
        /// Define an array of vertex data
        /// </summary>
        /// <param name="size">
        /// <para>
        /// Specifies the number of coordinates per vertex. Must be 2, 3, or 4. The initial value is 4.
        /// </para>
        /// </param>
        /// <param name="type">
        /// <para>
        /// Specifies the data type of each coordinate in the array. Symbolic constants GL_SHORT, GL_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
        /// </para>
        /// </param>
        /// <param name="stride">
        /// <para>
        /// Specifies the byte offset between consecutive vertices. If stride is 0, the vertices are understood to be tightly packed in the array. The initial value is 0.
        /// </para>
        /// </param>
        /// <param name="pointer">
        /// <para>
        /// Specifies a pointer to the first coordinate of the first vertex in the array. The initial value is 0.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_1", Version = "1.1", EntryPoint = "glVertexPointer")]
        public static extern void VertexPointer<T3>(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, Int32 stride, [InAttribute, OutAttribute] ref T3 pointer)
            where T3 : struct
        ;

        /// <summary>[requires: v1.0]
        /// Set the viewport
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the lower left corner of the viewport rectangle, in pixels. The initial value is (0,0).
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// Specify the width and height of the viewport. When a GL context is first attached to a window, width and height are set to the dimensions of that window.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_0", Version = "1.0", EntryPoint = "glViewport")]
        public static extern void Viewport(Int32 x, Int32 y, Int32 width, Int32 height);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Set multiple viewports
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specify the first viewport to set.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specify the number of viewports to set.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Specify the address of an array containing the viewport parameters.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glViewportArrayv")]
        public static extern void ViewportArray(Int32 first, Int32 count, Single[] v);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Set multiple viewports
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specify the first viewport to set.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specify the number of viewports to set.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Specify the address of an array containing the viewport parameters.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glViewportArrayv")]
        public static extern void ViewportArray(Int32 first, Int32 count, ref Single v);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Set multiple viewports
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specify the first viewport to set.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specify the number of viewports to set.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Specify the address of an array containing the viewport parameters.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glViewportArrayv")]
        public static extern unsafe void ViewportArray(Int32 first, Int32 count, Single* v);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Set multiple viewports
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specify the first viewport to set.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specify the number of viewports to set.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Specify the address of an array containing the viewport parameters.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glViewportArrayv")]
        public static extern void ViewportArray(UInt32 first, Int32 count, Single[] v);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Set multiple viewports
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specify the first viewport to set.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specify the number of viewports to set.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Specify the address of an array containing the viewport parameters.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glViewportArrayv")]
        public static extern void ViewportArray(UInt32 first, Int32 count, ref Single v);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Set multiple viewports
        /// </summary>
        /// <param name="first">
        /// <para>
        /// Specify the first viewport to set.
        /// </para>
        /// </param>
        /// <param name="count">
        /// <para>
        /// Specify the number of viewports to set.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// Specify the address of an array containing the viewport parameters.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glViewportArrayv")]
        public static extern unsafe void ViewportArray(UInt32 first, Int32 count, Single* v);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Set a specified viewport
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specify the first viewport to set.
        /// </para>
        /// </param>
        /// <param name="x">
        /// <para>
        /// For glViewportIndexedf, specifies the lower left corner of the viewport rectangle, in pixels. The initial value is (0,0).
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// For glViewportIndexedf, specifies the width and height of the viewport. When a GL context is first attached to a window, width and height are set to the dimensions of that window.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For glViewportIndexedfv, specifies the address of an array containing the viewport parameters.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glViewportIndexedf")]
        public static extern void ViewportIndexed(Int32 index, Single x, Single y, Single w, Single h);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Set a specified viewport
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specify the first viewport to set.
        /// </para>
        /// </param>
        /// <param name="x">
        /// <para>
        /// For glViewportIndexedf, specifies the lower left corner of the viewport rectangle, in pixels. The initial value is (0,0).
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// For glViewportIndexedf, specifies the width and height of the viewport. When a GL context is first attached to a window, width and height are set to the dimensions of that window.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For glViewportIndexedfv, specifies the address of an array containing the viewport parameters.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glViewportIndexedf")]
        public static extern void ViewportIndexed(UInt32 index, Single x, Single y, Single w, Single h);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Set a specified viewport
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specify the first viewport to set.
        /// </para>
        /// </param>
        /// <param name="x">
        /// <para>
        /// For glViewportIndexedf, specifies the lower left corner of the viewport rectangle, in pixels. The initial value is (0,0).
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// For glViewportIndexedf, specifies the width and height of the viewport. When a GL context is first attached to a window, width and height are set to the dimensions of that window.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For glViewportIndexedfv, specifies the address of an array containing the viewport parameters.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glViewportIndexedfv")]
        public static extern void ViewportIndexed(Int32 index, Single[] v);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Set a specified viewport
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specify the first viewport to set.
        /// </para>
        /// </param>
        /// <param name="x">
        /// <para>
        /// For glViewportIndexedf, specifies the lower left corner of the viewport rectangle, in pixels. The initial value is (0,0).
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// For glViewportIndexedf, specifies the width and height of the viewport. When a GL context is first attached to a window, width and height are set to the dimensions of that window.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For glViewportIndexedfv, specifies the address of an array containing the viewport parameters.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glViewportIndexedfv")]
        public static extern void ViewportIndexed(Int32 index, ref Single v);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Set a specified viewport
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specify the first viewport to set.
        /// </para>
        /// </param>
        /// <param name="x">
        /// <para>
        /// For glViewportIndexedf, specifies the lower left corner of the viewport rectangle, in pixels. The initial value is (0,0).
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// For glViewportIndexedf, specifies the width and height of the viewport. When a GL context is first attached to a window, width and height are set to the dimensions of that window.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For glViewportIndexedfv, specifies the address of an array containing the viewport parameters.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glViewportIndexedfv")]
        public static extern unsafe void ViewportIndexed(Int32 index, Single* v);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Set a specified viewport
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specify the first viewport to set.
        /// </para>
        /// </param>
        /// <param name="x">
        /// <para>
        /// For glViewportIndexedf, specifies the lower left corner of the viewport rectangle, in pixels. The initial value is (0,0).
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// For glViewportIndexedf, specifies the width and height of the viewport. When a GL context is first attached to a window, width and height are set to the dimensions of that window.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For glViewportIndexedfv, specifies the address of an array containing the viewport parameters.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glViewportIndexedfv")]
        public static extern void ViewportIndexed(UInt32 index, Single[] v);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Set a specified viewport
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specify the first viewport to set.
        /// </para>
        /// </param>
        /// <param name="x">
        /// <para>
        /// For glViewportIndexedf, specifies the lower left corner of the viewport rectangle, in pixels. The initial value is (0,0).
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// For glViewportIndexedf, specifies the width and height of the viewport. When a GL context is first attached to a window, width and height are set to the dimensions of that window.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For glViewportIndexedfv, specifies the address of an array containing the viewport parameters.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glViewportIndexedfv")]
        public static extern void ViewportIndexed(UInt32 index, ref Single v);

        /// <summary>[requires: v4.1 and ARB_viewport_array|VERSION_4_1]
        /// Set a specified viewport
        /// </summary>
        /// <param name="index">
        /// <para>
        /// Specify the first viewport to set.
        /// </para>
        /// </param>
        /// <param name="x">
        /// <para>
        /// For glViewportIndexedf, specifies the lower left corner of the viewport rectangle, in pixels. The initial value is (0,0).
        /// </para>
        /// </param>
        /// <param name="width">
        /// <para>
        /// For glViewportIndexedf, specifies the width and height of the viewport. When a GL context is first attached to a window, width and height are set to the dimensions of that window.
        /// </para>
        /// </param>
        /// <param name="v">
        /// <para>
        /// For glViewportIndexedfv, specifies the address of an array containing the viewport parameters.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_viewport_array|VERSION_4_1", Version = "4.1", EntryPoint = "glViewportIndexedfv")]
        public static extern unsafe void ViewportIndexed(UInt32 index, Single* v);

        /// <summary>[requires: v3.2 and ARB_sync|VERSION_3_2]
        /// Instruct the GL server to block until the specified sync object becomes signaled
        /// </summary>
        /// <param name="sync">
        /// <para>
        /// Specifies the sync object whose status to wait on.
        /// </para>
        /// </param>
        /// <param name="flags">
        /// <para>
        /// A bitfield controlling the command flushing behavior. flags may be zero.
        /// </para>
        /// </param>
        /// <param name="timeout">
        /// <para>
        /// Specifies the timeout that the server should wait before continuing. timeout must be GL_TIMEOUT_IGNORED.
        /// </para>
        /// </param>
        [Obsolete("Use WaitSyncFlags overload instead")]
        [AutoGenerated(Category = "ARB_sync|VERSION_3_2", Version = "3.2", EntryPoint = "glWaitSync")]
        public static extern OpenTK.Graphics.OpenGL.WaitSyncStatus WaitSync(IntPtr sync, Int32 flags, Int64 timeout);

        /// <summary>[requires: v3.2 and ARB_sync|VERSION_3_2]
        /// Instruct the GL server to block until the specified sync object becomes signaled
        /// </summary>
        /// <param name="sync">
        /// <para>
        /// Specifies the sync object whose status to wait on.
        /// </para>
        /// </param>
        /// <param name="flags">
        /// <para>
        /// A bitfield controlling the command flushing behavior. flags may be zero.
        /// </para>
        /// </param>
        /// <param name="timeout">
        /// <para>
        /// Specifies the timeout that the server should wait before continuing. timeout must be GL_TIMEOUT_IGNORED.
        /// </para>
        /// </param>
        [Obsolete("Use WaitSyncFlags overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sync|VERSION_3_2", Version = "3.2", EntryPoint = "glWaitSync")]
        public static extern OpenTK.Graphics.OpenGL.WaitSyncStatus WaitSync(IntPtr sync, Int32 flags, UInt64 timeout);

        /// <summary>[requires: v3.2 and ARB_sync|VERSION_3_2]
        /// Instruct the GL server to block until the specified sync object becomes signaled
        /// </summary>
        /// <param name="sync">
        /// <para>
        /// Specifies the sync object whose status to wait on.
        /// </para>
        /// </param>
        /// <param name="flags">
        /// <para>
        /// A bitfield controlling the command flushing behavior. flags may be zero.
        /// </para>
        /// </param>
        /// <param name="timeout">
        /// <para>
        /// Specifies the timeout that the server should wait before continuing. timeout must be GL_TIMEOUT_IGNORED.
        /// </para>
        /// </param>
        [Obsolete("Use WaitSyncFlags overload instead")]
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sync|VERSION_3_2", Version = "3.2", EntryPoint = "glWaitSync")]
        public static extern OpenTK.Graphics.OpenGL.WaitSyncStatus WaitSync(IntPtr sync, UInt32 flags, UInt64 timeout);

        /// <summary>[requires: v3.2 and ARB_sync|VERSION_3_2]
        /// Instruct the GL server to block until the specified sync object becomes signaled
        /// </summary>
        /// <param name="sync">
        /// <para>
        /// Specifies the sync object whose status to wait on.
        /// </para>
        /// </param>
        /// <param name="flags">
        /// <para>
        /// A bitfield controlling the command flushing behavior. flags may be zero.
        /// </para>
        /// </param>
        /// <param name="timeout">
        /// <para>
        /// Specifies the timeout that the server should wait before continuing. timeout must be GL_TIMEOUT_IGNORED.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "ARB_sync|VERSION_3_2", Version = "3.2", EntryPoint = "glWaitSync")]
        public static extern OpenTK.Graphics.OpenGL.WaitSyncStatus WaitSync(IntPtr sync, OpenTK.Graphics.OpenGL.WaitSyncFlags flags, Int64 timeout);

        /// <summary>[requires: v3.2 and ARB_sync|VERSION_3_2]
        /// Instruct the GL server to block until the specified sync object becomes signaled
        /// </summary>
        /// <param name="sync">
        /// <para>
        /// Specifies the sync object whose status to wait on.
        /// </para>
        /// </param>
        /// <param name="flags">
        /// <para>
        /// A bitfield controlling the command flushing behavior. flags may be zero.
        /// </para>
        /// </param>
        /// <param name="timeout">
        /// <para>
        /// Specifies the timeout that the server should wait before continuing. timeout must be GL_TIMEOUT_IGNORED.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "ARB_sync|VERSION_3_2", Version = "3.2", EntryPoint = "glWaitSync")]
        public static extern OpenTK.Graphics.OpenGL.WaitSyncStatus WaitSync(IntPtr sync, OpenTK.Graphics.OpenGL.WaitSyncFlags flags, UInt64 timeout);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Specify the raster position in window coordinates for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , coordinates for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glWindowPos2d")]
        public static extern void WindowPos2(Double x, Double y);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Specify the raster position in window coordinates for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , coordinates for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glWindowPos2dv")]
        public static extern void WindowPos2(Double[] v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Specify the raster position in window coordinates for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , coordinates for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glWindowPos2dv")]
        public static extern void WindowPos2(ref Double v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Specify the raster position in window coordinates for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , coordinates for the raster position.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glWindowPos2dv")]
        public static extern unsafe void WindowPos2(Double* v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Specify the raster position in window coordinates for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , coordinates for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glWindowPos2f")]
        public static extern void WindowPos2(Single x, Single y);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Specify the raster position in window coordinates for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , coordinates for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glWindowPos2fv")]
        public static extern void WindowPos2(Single[] v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Specify the raster position in window coordinates for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , coordinates for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glWindowPos2fv")]
        public static extern void WindowPos2(ref Single v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Specify the raster position in window coordinates for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , coordinates for the raster position.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glWindowPos2fv")]
        public static extern unsafe void WindowPos2(Single* v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Specify the raster position in window coordinates for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , coordinates for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glWindowPos2i")]
        public static extern void WindowPos2(Int32 x, Int32 y);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Specify the raster position in window coordinates for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , coordinates for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glWindowPos2iv")]
        public static extern void WindowPos2(Int32[] v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Specify the raster position in window coordinates for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , coordinates for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glWindowPos2iv")]
        public static extern void WindowPos2(ref Int32 v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Specify the raster position in window coordinates for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , coordinates for the raster position.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glWindowPos2iv")]
        public static extern unsafe void WindowPos2(Int32* v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Specify the raster position in window coordinates for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , coordinates for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glWindowPos2s")]
        public static extern void WindowPos2(Int16 x, Int16 y);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Specify the raster position in window coordinates for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , coordinates for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glWindowPos2sv")]
        public static extern void WindowPos2(Int16[] v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Specify the raster position in window coordinates for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , coordinates for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glWindowPos2sv")]
        public static extern void WindowPos2(ref Int16 v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Specify the raster position in window coordinates for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , coordinates for the raster position.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glWindowPos2sv")]
        public static extern unsafe void WindowPos2(Int16* v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Specify the raster position in window coordinates for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , coordinates for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glWindowPos3d")]
        public static extern void WindowPos3(Double x, Double y, Double z);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Specify the raster position in window coordinates for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , coordinates for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glWindowPos3dv")]
        public static extern void WindowPos3(Double[] v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Specify the raster position in window coordinates for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , coordinates for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glWindowPos3dv")]
        public static extern void WindowPos3(ref Double v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Specify the raster position in window coordinates for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , coordinates for the raster position.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glWindowPos3dv")]
        public static extern unsafe void WindowPos3(Double* v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Specify the raster position in window coordinates for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , coordinates for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glWindowPos3f")]
        public static extern void WindowPos3(Single x, Single y, Single z);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Specify the raster position in window coordinates for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , coordinates for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glWindowPos3fv")]
        public static extern void WindowPos3(Single[] v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Specify the raster position in window coordinates for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , coordinates for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glWindowPos3fv")]
        public static extern void WindowPos3(ref Single v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Specify the raster position in window coordinates for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , coordinates for the raster position.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glWindowPos3fv")]
        public static extern unsafe void WindowPos3(Single* v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Specify the raster position in window coordinates for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , coordinates for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glWindowPos3i")]
        public static extern void WindowPos3(Int32 x, Int32 y, Int32 z);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Specify the raster position in window coordinates for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , coordinates for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glWindowPos3iv")]
        public static extern void WindowPos3(Int32[] v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Specify the raster position in window coordinates for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , coordinates for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glWindowPos3iv")]
        public static extern void WindowPos3(ref Int32 v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Specify the raster position in window coordinates for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , coordinates for the raster position.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glWindowPos3iv")]
        public static extern unsafe void WindowPos3(Int32* v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Specify the raster position in window coordinates for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , coordinates for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glWindowPos3s")]
        public static extern void WindowPos3(Int16 x, Int16 y, Int16 z);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Specify the raster position in window coordinates for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , coordinates for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glWindowPos3sv")]
        public static extern void WindowPos3(Int16[] v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Specify the raster position in window coordinates for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , coordinates for the raster position.
        /// </para>
        /// </param>
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glWindowPos3sv")]
        public static extern void WindowPos3(ref Int16 v);

        /// <summary>[requires: v1.4][deprecated: v3.2]
        /// Specify the raster position in window coordinates for pixel operations
        /// </summary>
        /// <param name="x">
        /// <para>
        /// Specify the , , coordinates for the raster position.
        /// </para>
        /// </param>
        [System.CLSCompliant(false)]
        [AutoGenerated(Category = "VERSION_1_4", Version = "1.4", EntryPoint = "glWindowPos3sv")]
        public static extern unsafe void WindowPos3(Int16* v);

        public static partial class Ext
        {
            /// <summary>[requires: EXT_separate_shader_objects]</summary>
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glActiveProgramEXT")]
            public static extern void ActiveProgram(Int32 program);

            /// <summary>[requires: EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glActiveProgramEXT")]
            public static extern void ActiveProgram(UInt32 program);

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Set the active program object for a program pipeline object
            /// </summary>
            /// <param name="pipeline">
            /// <para>
            /// Specifies the program pipeline object to set the active program object for.
            /// </para>
            /// </param>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to set as the active program pipeline object pipeline.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glActiveShaderProgramEXT")]
            public static extern void ActiveShaderProgram(Int32 pipeline, Int32 program);

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Set the active program object for a program pipeline object
            /// </summary>
            /// <param name="pipeline">
            /// <para>
            /// Specifies the program pipeline object to set the active program object for.
            /// </para>
            /// </param>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to set as the active program pipeline object pipeline.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glActiveShaderProgramEXT")]
            public static extern void ActiveShaderProgram(UInt32 pipeline, UInt32 program);

            /// <summary>[requires: EXT_stencil_two_side]</summary>
            [AutoGenerated(Category = "EXT_stencil_two_side", Version = "", EntryPoint = "glActiveStencilFaceEXT")]
            public static extern void ActiveStencilFace(OpenTK.Graphics.OpenGL.ExtStencilTwoSide face);

            /// <summary>[requires: EXT_light_texture]</summary>
            [AutoGenerated(Category = "EXT_light_texture", Version = "", EntryPoint = "glApplyTextureEXT")]
            public static extern void ApplyTexture(OpenTK.Graphics.OpenGL.ExtLightTexture mode);

            /// <summary>[requires: EXT_texture_object]
            /// Determine if textures are loaded in texture memory
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of textures to be queried.
            /// </para>
            /// </param>
            /// <param name="textures">
            /// <para>
            /// Specifies an array containing the names of the textures to be queried.
            /// </para>
            /// </param>
            /// <param name="residences">
            /// <para>
            /// Specifies an array in which the texture residence status is returned. The residence status of a texture named by an element of textures is returned in the corresponding element of residences.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_texture_object", Version = "", EntryPoint = "glAreTexturesResidentEXT")]
            public static extern bool AreTexturesResident(Int32 n, Int32[] textures, [OutAttribute] bool[] residences);

            /// <summary>[requires: EXT_texture_object]
            /// Determine if textures are loaded in texture memory
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of textures to be queried.
            /// </para>
            /// </param>
            /// <param name="textures">
            /// <para>
            /// Specifies an array containing the names of the textures to be queried.
            /// </para>
            /// </param>
            /// <param name="residences">
            /// <para>
            /// Specifies an array in which the texture residence status is returned. The residence status of a texture named by an element of textures is returned in the corresponding element of residences.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_texture_object", Version = "", EntryPoint = "glAreTexturesResidentEXT")]
            public static extern bool AreTexturesResident(Int32 n, ref Int32 textures, [OutAttribute] out bool residences);

            /// <summary>[requires: EXT_texture_object]
            /// Determine if textures are loaded in texture memory
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of textures to be queried.
            /// </para>
            /// </param>
            /// <param name="textures">
            /// <para>
            /// Specifies an array containing the names of the textures to be queried.
            /// </para>
            /// </param>
            /// <param name="residences">
            /// <para>
            /// Specifies an array in which the texture residence status is returned. The residence status of a texture named by an element of textures is returned in the corresponding element of residences.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_texture_object", Version = "", EntryPoint = "glAreTexturesResidentEXT")]
            public static extern unsafe bool AreTexturesResident(Int32 n, Int32* textures, [OutAttribute] bool* residences);

            /// <summary>[requires: EXT_texture_object]
            /// Determine if textures are loaded in texture memory
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of textures to be queried.
            /// </para>
            /// </param>
            /// <param name="textures">
            /// <para>
            /// Specifies an array containing the names of the textures to be queried.
            /// </para>
            /// </param>
            /// <param name="residences">
            /// <para>
            /// Specifies an array in which the texture residence status is returned. The residence status of a texture named by an element of textures is returned in the corresponding element of residences.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_texture_object", Version = "", EntryPoint = "glAreTexturesResidentEXT")]
            public static extern bool AreTexturesResident(Int32 n, UInt32[] textures, [OutAttribute] bool[] residences);

            /// <summary>[requires: EXT_texture_object]
            /// Determine if textures are loaded in texture memory
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of textures to be queried.
            /// </para>
            /// </param>
            /// <param name="textures">
            /// <para>
            /// Specifies an array containing the names of the textures to be queried.
            /// </para>
            /// </param>
            /// <param name="residences">
            /// <para>
            /// Specifies an array in which the texture residence status is returned. The residence status of a texture named by an element of textures is returned in the corresponding element of residences.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_texture_object", Version = "", EntryPoint = "glAreTexturesResidentEXT")]
            public static extern bool AreTexturesResident(Int32 n, ref UInt32 textures, [OutAttribute] out bool residences);

            /// <summary>[requires: EXT_texture_object]
            /// Determine if textures are loaded in texture memory
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of textures to be queried.
            /// </para>
            /// </param>
            /// <param name="textures">
            /// <para>
            /// Specifies an array containing the names of the textures to be queried.
            /// </para>
            /// </param>
            /// <param name="residences">
            /// <para>
            /// Specifies an array in which the texture residence status is returned. The residence status of a texture named by an element of textures is returned in the corresponding element of residences.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_texture_object", Version = "", EntryPoint = "glAreTexturesResidentEXT")]
            public static extern unsafe bool AreTexturesResident(Int32 n, UInt32* textures, [OutAttribute] bool* residences);

            /// <summary>[requires: EXT_vertex_array]
            /// Render a vertex using the specified vertex array element
            /// </summary>
            /// <param name="i">
            /// <para>
            /// Specifies an index into the enabled vertex data arrays.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glArrayElementEXT")]
            public static extern void ArrayElement(Int32 i);

            /// <summary>[requires: EXT_transform_feedback]
            /// Start transform feedback operation
            /// </summary>
            /// <param name="primitiveMode">
            /// <para>
            /// Specify the output type of the primitives that will be recorded into the buffer objects that are bound for transform feedback.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_transform_feedback", Version = "", EntryPoint = "glBeginTransformFeedbackEXT")]
            public static extern void BeginTransformFeedback(OpenTK.Graphics.OpenGL.ExtTransformFeedback primitiveMode);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glBeginVertexShaderEXT")]
            public static extern void BeginVertexShader();

            /// <summary>[requires: EXT_transform_feedback]
            /// Bind a buffer object to an indexed buffer target
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specify the target of the bind operation. target must be one of GL_ATOMIC_COUNTER_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, GL_UNIFORM_BUFFER or GL_SHADER_STORAGE_BUFFER.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// Specify the index of the binding point within the array specified by target.
            /// </para>
            /// </param>
            /// <param name="buffer">
            /// <para>
            /// The name of a buffer object to bind to the specified binding point.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_transform_feedback", Version = "", EntryPoint = "glBindBufferBaseEXT")]
            public static extern void BindBufferBase(OpenTK.Graphics.OpenGL.ExtTransformFeedback target, Int32 index, Int32 buffer);

            /// <summary>[requires: EXT_transform_feedback]
            /// Bind a buffer object to an indexed buffer target
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specify the target of the bind operation. target must be one of GL_ATOMIC_COUNTER_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, GL_UNIFORM_BUFFER or GL_SHADER_STORAGE_BUFFER.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// Specify the index of the binding point within the array specified by target.
            /// </para>
            /// </param>
            /// <param name="buffer">
            /// <para>
            /// The name of a buffer object to bind to the specified binding point.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_transform_feedback", Version = "", EntryPoint = "glBindBufferBaseEXT")]
            public static extern void BindBufferBase(OpenTK.Graphics.OpenGL.ExtTransformFeedback target, UInt32 index, UInt32 buffer);

            /// <summary>[requires: EXT_transform_feedback]</summary>
            [AutoGenerated(Category = "EXT_transform_feedback", Version = "", EntryPoint = "glBindBufferOffsetEXT")]
            public static extern void BindBufferOffset(OpenTK.Graphics.OpenGL.ExtTransformFeedback target, Int32 index, Int32 buffer, IntPtr offset);

            /// <summary>[requires: EXT_transform_feedback]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_transform_feedback", Version = "", EntryPoint = "glBindBufferOffsetEXT")]
            public static extern void BindBufferOffset(OpenTK.Graphics.OpenGL.ExtTransformFeedback target, UInt32 index, UInt32 buffer, IntPtr offset);

            /// <summary>[requires: EXT_transform_feedback]
            /// Bind a range within a buffer object to an indexed buffer target
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specify the target of the bind operation. target must be one of GL_ATOMIC_COUNTER_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, GL_UNIFORM_BUFFER, or GL_SHADER_STORAGE_BUFFER.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// Specify the index of the binding point within the array specified by target.
            /// </para>
            /// </param>
            /// <param name="buffer">
            /// <para>
            /// The name of a buffer object to bind to the specified binding point.
            /// </para>
            /// </param>
            /// <param name="offset">
            /// <para>
            /// The starting offset in basic machine units into the buffer object buffer.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// The amount of data in machine units that can be read from the buffet object while used as an indexed target.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_transform_feedback", Version = "", EntryPoint = "glBindBufferRangeEXT")]
            public static extern void BindBufferRange(OpenTK.Graphics.OpenGL.ExtTransformFeedback target, Int32 index, Int32 buffer, IntPtr offset, IntPtr size);

            /// <summary>[requires: EXT_transform_feedback]
            /// Bind a range within a buffer object to an indexed buffer target
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specify the target of the bind operation. target must be one of GL_ATOMIC_COUNTER_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, GL_UNIFORM_BUFFER, or GL_SHADER_STORAGE_BUFFER.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// Specify the index of the binding point within the array specified by target.
            /// </para>
            /// </param>
            /// <param name="buffer">
            /// <para>
            /// The name of a buffer object to bind to the specified binding point.
            /// </para>
            /// </param>
            /// <param name="offset">
            /// <para>
            /// The starting offset in basic machine units into the buffer object buffer.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// The amount of data in machine units that can be read from the buffet object while used as an indexed target.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_transform_feedback", Version = "", EntryPoint = "glBindBufferRangeEXT")]
            public static extern void BindBufferRange(OpenTK.Graphics.OpenGL.ExtTransformFeedback target, UInt32 index, UInt32 buffer, IntPtr offset, IntPtr size);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Bind a user-defined varying out variable to a fragment shader color number
            /// </summary>
            /// <param name="program">
            /// <para>
            /// The name of the program containing varying out variable whose binding to modify
            /// </para>
            /// </param>
            /// <param name="colorNumber">
            /// <para>
            /// The color number to bind the user-defined varying out variable to
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// The name of the user-defined varying out variable whose binding to modify
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glBindFragDataLocationEXT")]
            public static extern void BindFragDataLocation(Int32 program, Int32 color, String name);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Bind a user-defined varying out variable to a fragment shader color number
            /// </summary>
            /// <param name="program">
            /// <para>
            /// The name of the program containing varying out variable whose binding to modify
            /// </para>
            /// </param>
            /// <param name="colorNumber">
            /// <para>
            /// The color number to bind the user-defined varying out variable to
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// The name of the user-defined varying out variable whose binding to modify
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glBindFragDataLocationEXT")]
            public static extern void BindFragDataLocation(UInt32 program, UInt32 color, String name);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Bind a framebuffer to a framebuffer target
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the framebuffer target of the binding operation.
            /// </para>
            /// </param>
            /// <param name="framebuffer">
            /// <para>
            /// Specifies the name of the framebuffer object to bind.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glBindFramebufferEXT")]
            public static extern void BindFramebuffer(OpenTK.Graphics.OpenGL.FramebufferTarget target, Int32 framebuffer);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Bind a framebuffer to a framebuffer target
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the framebuffer target of the binding operation.
            /// </para>
            /// </param>
            /// <param name="framebuffer">
            /// <para>
            /// Specifies the name of the framebuffer object to bind.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glBindFramebufferEXT")]
            public static extern void BindFramebuffer(OpenTK.Graphics.OpenGL.FramebufferTarget target, UInt32 framebuffer);

            /// <summary>[requires: EXT_shader_image_load_store]
            /// Bind a level of a texture to an image unit
            /// </summary>
            /// <param name="unit">
            /// <para>
            /// Specifies the index of the image unit to which to bind the texture
            /// </para>
            /// </param>
            /// <param name="texture">
            /// <para>
            /// Specifies the name of the texture to bind to the image unit.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level of the texture that is to be bound.
            /// </para>
            /// </param>
            /// <param name="layered">
            /// <para>
            /// Specifies whether a layered texture binding is to be established.
            /// </para>
            /// </param>
            /// <param name="layer">
            /// <para>
            /// If layered is GL_FALSE, specifies the layer of texture to be bound to the image unit. Ignored otherwise.
            /// </para>
            /// </param>
            /// <param name="access">
            /// <para>
            /// Specifies a token indicating the type of access that will be performed on the image.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format that the elements of the image will be treated as for the purposes of formatted stores.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_shader_image_load_store", Version = "", EntryPoint = "glBindImageTextureEXT")]
            public static extern void BindImageTexture(Int32 index, Int32 texture, Int32 level, bool layered, Int32 layer, OpenTK.Graphics.OpenGL.ExtShaderImageLoadStore access, Int32 format);

            /// <summary>[requires: EXT_shader_image_load_store]
            /// Bind a level of a texture to an image unit
            /// </summary>
            /// <param name="unit">
            /// <para>
            /// Specifies the index of the image unit to which to bind the texture
            /// </para>
            /// </param>
            /// <param name="texture">
            /// <para>
            /// Specifies the name of the texture to bind to the image unit.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level of the texture that is to be bound.
            /// </para>
            /// </param>
            /// <param name="layered">
            /// <para>
            /// Specifies whether a layered texture binding is to be established.
            /// </para>
            /// </param>
            /// <param name="layer">
            /// <para>
            /// If layered is GL_FALSE, specifies the layer of texture to be bound to the image unit. Ignored otherwise.
            /// </para>
            /// </param>
            /// <param name="access">
            /// <para>
            /// Specifies a token indicating the type of access that will be performed on the image.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format that the elements of the image will be treated as for the purposes of formatted stores.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_shader_image_load_store", Version = "", EntryPoint = "glBindImageTextureEXT")]
            public static extern void BindImageTexture(UInt32 index, UInt32 texture, Int32 level, bool layered, Int32 layer, OpenTK.Graphics.OpenGL.ExtShaderImageLoadStore access, Int32 format);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glBindLightParameterEXT")]
            public static extern Int32 BindLightParameter(OpenTK.Graphics.OpenGL.LightName light, OpenTK.Graphics.OpenGL.LightParameter value);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glBindMaterialParameterEXT")]
            public static extern Int32 BindMaterialParameter(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glBindMultiTextureEXT")]
            public static extern void BindMultiTexture(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 texture);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glBindMultiTextureEXT")]
            public static extern void BindMultiTexture(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, UInt32 texture);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glBindParameterEXT")]
            public static extern Int32 BindParameter(OpenTK.Graphics.OpenGL.ExtVertexShader value);

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Bind a program pipeline to the current context
            /// </summary>
            /// <param name="pipeline">
            /// <para>
            /// Specifies the name of the pipeline object to bind to the context.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glBindProgramPipelineEXT")]
            public static extern void BindProgramPipeline(Int32 pipeline);

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Bind a program pipeline to the current context
            /// </summary>
            /// <param name="pipeline">
            /// <para>
            /// Specifies the name of the pipeline object to bind to the context.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glBindProgramPipelineEXT")]
            public static extern void BindProgramPipeline(UInt32 pipeline);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Bind a renderbuffer to a renderbuffer target
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the renderbuffer target of the binding operation. target must be GL_RENDERBUFFER.
            /// </para>
            /// </param>
            /// <param name="renderbuffer">
            /// <para>
            /// Specifies the name of the renderbuffer object to bind.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glBindRenderbufferEXT")]
            public static extern void BindRenderbuffer(OpenTK.Graphics.OpenGL.RenderbufferTarget target, Int32 renderbuffer);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Bind a renderbuffer to a renderbuffer target
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the renderbuffer target of the binding operation. target must be GL_RENDERBUFFER.
            /// </para>
            /// </param>
            /// <param name="renderbuffer">
            /// <para>
            /// Specifies the name of the renderbuffer object to bind.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glBindRenderbufferEXT")]
            public static extern void BindRenderbuffer(OpenTK.Graphics.OpenGL.RenderbufferTarget target, UInt32 renderbuffer);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glBindTexGenParameterEXT")]
            public static extern Int32 BindTexGenParameter(OpenTK.Graphics.OpenGL.TextureUnit unit, OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter value);

            /// <summary>[requires: EXT_texture_object]
            /// Bind a named texture to a texturing target
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target to which the texture is bound. Must be one of GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_RECTANGLE, GL_TEXTURE_CUBE_MAP, GL_TEXTURE_CUBE_MAP_ARRAY, GL_TEXTURE_BUFFER, GL_TEXTURE_2D_MULTISAMPLE or GL_TEXTURE_2D_MULTISAMPLE_ARRAY.
            /// </para>
            /// </param>
            /// <param name="texture">
            /// <para>
            /// Specifies the name of a texture.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_texture_object", Version = "", EntryPoint = "glBindTextureEXT")]
            public static extern void BindTexture(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 texture);

            /// <summary>[requires: EXT_texture_object]
            /// Bind a named texture to a texturing target
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target to which the texture is bound. Must be one of GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_RECTANGLE, GL_TEXTURE_CUBE_MAP, GL_TEXTURE_CUBE_MAP_ARRAY, GL_TEXTURE_BUFFER, GL_TEXTURE_2D_MULTISAMPLE or GL_TEXTURE_2D_MULTISAMPLE_ARRAY.
            /// </para>
            /// </param>
            /// <param name="texture">
            /// <para>
            /// Specifies the name of a texture.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_texture_object", Version = "", EntryPoint = "glBindTextureEXT")]
            public static extern void BindTexture(OpenTK.Graphics.OpenGL.TextureTarget target, UInt32 texture);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glBindTextureUnitParameterEXT")]
            public static extern Int32 BindTextureUnitParameter(OpenTK.Graphics.OpenGL.TextureUnit unit, OpenTK.Graphics.OpenGL.ExtVertexShader value);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glBindVertexShaderEXT")]
            public static extern void BindVertexShader(Int32 id);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glBindVertexShaderEXT")]
            public static extern void BindVertexShader(UInt32 id);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glBinormal3bEXT")]
            public static extern void Binormal3(Byte bx, Byte by, Byte bz);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glBinormal3bEXT")]
            public static extern void Binormal3(SByte bx, SByte by, SByte bz);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glBinormal3bvEXT")]
            public static extern void Binormal3(Byte[] v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glBinormal3bvEXT")]
            public static extern void Binormal3(ref Byte v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glBinormal3bvEXT")]
            public static extern unsafe void Binormal3(Byte* v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glBinormal3bvEXT")]
            public static extern void Binormal3(SByte[] v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glBinormal3bvEXT")]
            public static extern void Binormal3(ref SByte v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glBinormal3bvEXT")]
            public static extern unsafe void Binormal3(SByte* v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glBinormal3dEXT")]
            public static extern void Binormal3(Double bx, Double by, Double bz);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glBinormal3dvEXT")]
            public static extern void Binormal3(Double[] v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glBinormal3dvEXT")]
            public static extern void Binormal3(ref Double v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glBinormal3dvEXT")]
            public static extern unsafe void Binormal3(Double* v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glBinormal3fEXT")]
            public static extern void Binormal3(Single bx, Single by, Single bz);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glBinormal3fvEXT")]
            public static extern void Binormal3(Single[] v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glBinormal3fvEXT")]
            public static extern void Binormal3(ref Single v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glBinormal3fvEXT")]
            public static extern unsafe void Binormal3(Single* v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glBinormal3iEXT")]
            public static extern void Binormal3(Int32 bx, Int32 by, Int32 bz);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glBinormal3ivEXT")]
            public static extern void Binormal3(Int32[] v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glBinormal3ivEXT")]
            public static extern void Binormal3(ref Int32 v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glBinormal3ivEXT")]
            public static extern unsafe void Binormal3(Int32* v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glBinormal3sEXT")]
            public static extern void Binormal3(Int16 bx, Int16 by, Int16 bz);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glBinormal3svEXT")]
            public static extern void Binormal3(Int16[] v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glBinormal3svEXT")]
            public static extern void Binormal3(ref Int16 v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glBinormal3svEXT")]
            public static extern unsafe void Binormal3(Int16* v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glBinormalPointerEXT")]
            public static extern void BinormalPointer(OpenTK.Graphics.OpenGL.NormalPointerType type, Int32 stride, IntPtr pointer);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glBinormalPointerEXT")]
            public static extern void BinormalPointer<T2>(OpenTK.Graphics.OpenGL.NormalPointerType type, Int32 stride, [InAttribute, OutAttribute] T2[] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glBinormalPointerEXT")]
            public static extern void BinormalPointer<T2>(OpenTK.Graphics.OpenGL.NormalPointerType type, Int32 stride, [InAttribute, OutAttribute] T2[,] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glBinormalPointerEXT")]
            public static extern void BinormalPointer<T2>(OpenTK.Graphics.OpenGL.NormalPointerType type, Int32 stride, [InAttribute, OutAttribute] T2[,,] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glBinormalPointerEXT")]
            public static extern void BinormalPointer<T2>(OpenTK.Graphics.OpenGL.NormalPointerType type, Int32 stride, [InAttribute, OutAttribute] ref T2 pointer)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_blend_color]
            /// Set the blend color
            /// </summary>
            /// <param name="red">
            /// <para>
            /// specify the components of GL_BLEND_COLOR
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_blend_color", Version = "", EntryPoint = "glBlendColorEXT")]
            public static extern void BlendColor(Single red, Single green, Single blue, Single alpha);

            /// <summary>[requires: EXT_blend_minmax]
            /// Specify the equation used for both the RGB blend equation and the Alpha blend equation
            /// </summary>
            /// <param name="buf">
            /// <para>
            /// for glBlendEquationi, specifies the index of the draw buffer for which to set the blend equation.
            /// </para>
            /// </param>
            /// <param name="mode">
            /// <para>
            /// specifies how source and destination colors are combined. It must be GL_FUNC_ADD, GL_FUNC_SUBTRACT, GL_FUNC_REVERSE_SUBTRACT, GL_MIN, GL_MAX.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_blend_minmax", Version = "", EntryPoint = "glBlendEquationEXT")]
            public static extern void BlendEquation(OpenTK.Graphics.OpenGL.BlendEquationMode mode);

            /// <summary>[requires: EXT_blend_minmax]
            /// Specify the equation used for both the RGB blend equation and the Alpha blend equation
            /// </summary>
            /// <param name="buf">
            /// <para>
            /// for glBlendEquationi, specifies the index of the draw buffer for which to set the blend equation.
            /// </para>
            /// </param>
            /// <param name="mode">
            /// <para>
            /// specifies how source and destination colors are combined. It must be GL_FUNC_ADD, GL_FUNC_SUBTRACT, GL_FUNC_REVERSE_SUBTRACT, GL_MIN, GL_MAX.
            /// </para>
            /// </param>
            [Obsolete("Use BlendEquationMode overload instead")]
            [AutoGenerated(Category = "EXT_blend_minmax", Version = "", EntryPoint = "glBlendEquationEXT")]
            public static extern void BlendEquation(OpenTK.Graphics.OpenGL.ExtBlendMinmax mode);

            /// <summary>[requires: EXT_blend_equation_separate]
            /// Set the RGB blend equation and the alpha blend equation separately
            /// </summary>
            /// <param name="buf">
            /// <para>
            /// for glBlendEquationSeparatei, specifies the index of the draw buffer for which to set the blend equations.
            /// </para>
            /// </param>
            /// <param name="modeRGB">
            /// <para>
            /// specifies the RGB blend equation, how the red, green, and blue components of the source and destination colors are combined. It must be GL_FUNC_ADD, GL_FUNC_SUBTRACT, GL_FUNC_REVERSE_SUBTRACT, GL_MIN, GL_MAX.
            /// </para>
            /// </param>
            /// <param name="modeAlpha">
            /// <para>
            /// specifies the alpha blend equation, how the alpha component of the source and destination colors are combined. It must be GL_FUNC_ADD, GL_FUNC_SUBTRACT, GL_FUNC_REVERSE_SUBTRACT, GL_MIN, GL_MAX.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_blend_equation_separate", Version = "", EntryPoint = "glBlendEquationSeparateEXT")]
            public static extern void BlendEquationSeparate(OpenTK.Graphics.OpenGL.ExtBlendEquationSeparate modeRGB, OpenTK.Graphics.OpenGL.ExtBlendEquationSeparate modeAlpha);

            /// <summary>[requires: EXT_blend_func_separate]
            /// Specify pixel arithmetic for RGB and alpha components separately
            /// </summary>
            /// <param name="buf">
            /// <para>
            /// For glBlendFuncSeparatei, specifies the index of the draw buffer for which to set the blend functions.
            /// </para>
            /// </param>
            /// <param name="srcRGB">
            /// <para>
            /// Specifies how the red, green, and blue blending factors are computed. The initial value is GL_ONE.
            /// </para>
            /// </param>
            /// <param name="dstRGB">
            /// <para>
            /// Specifies how the red, green, and blue destination blending factors are computed. The initial value is GL_ZERO.
            /// </para>
            /// </param>
            /// <param name="srcAlpha">
            /// <para>
            /// Specified how the alpha source blending factor is computed. The initial value is GL_ONE.
            /// </para>
            /// </param>
            /// <param name="dstAlpha">
            /// <para>
            /// Specified how the alpha destination blending factor is computed. The initial value is GL_ZERO.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_blend_func_separate", Version = "", EntryPoint = "glBlendFuncSeparateEXT")]
            public static extern void BlendFuncSeparate(OpenTK.Graphics.OpenGL.ExtBlendFuncSeparate sfactorRGB, OpenTK.Graphics.OpenGL.ExtBlendFuncSeparate dfactorRGB, OpenTK.Graphics.OpenGL.ExtBlendFuncSeparate sfactorAlpha, OpenTK.Graphics.OpenGL.ExtBlendFuncSeparate dfactorAlpha);

            /// <summary>[requires: EXT_framebuffer_blit]
            /// Copy a block of pixels from the read framebuffer to the draw framebuffer
            /// </summary>
            /// <param name="srcX0">
            /// <para>
            /// Specify the bounds of the source rectangle within the read buffer of the read framebuffer.
            /// </para>
            /// </param>
            /// <param name="dstX0">
            /// <para>
            /// Specify the bounds of the destination rectangle within the write buffer of the write framebuffer.
            /// </para>
            /// </param>
            /// <param name="mask">
            /// <para>
            /// The bitwise OR of the flags indicating which buffers are to be copied. The allowed flags are GL_COLOR_BUFFER_BIT, GL_DEPTH_BUFFER_BIT and GL_STENCIL_BUFFER_BIT.
            /// </para>
            /// </param>
            /// <param name="filter">
            /// <para>
            /// Specifies the interpolation to be applied if the image is stretched. Must be GL_NEAREST or GL_LINEAR.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_framebuffer_blit", Version = "", EntryPoint = "glBlitFramebufferEXT")]
            public static extern void BlitFramebuffer(Int32 srcX0, Int32 srcY0, Int32 srcX1, Int32 srcY1, Int32 dstX0, Int32 dstY0, Int32 dstX1, Int32 dstY1, OpenTK.Graphics.OpenGL.ClearBufferMask mask, OpenTK.Graphics.OpenGL.BlitFramebufferFilter filter);

            /// <summary>[requires: EXT_framebuffer_blit]
            /// Copy a block of pixels from the read framebuffer to the draw framebuffer
            /// </summary>
            /// <param name="srcX0">
            /// <para>
            /// Specify the bounds of the source rectangle within the read buffer of the read framebuffer.
            /// </para>
            /// </param>
            /// <param name="dstX0">
            /// <para>
            /// Specify the bounds of the destination rectangle within the write buffer of the write framebuffer.
            /// </para>
            /// </param>
            /// <param name="mask">
            /// <para>
            /// The bitwise OR of the flags indicating which buffers are to be copied. The allowed flags are GL_COLOR_BUFFER_BIT, GL_DEPTH_BUFFER_BIT and GL_STENCIL_BUFFER_BIT.
            /// </para>
            /// </param>
            /// <param name="filter">
            /// <para>
            /// Specifies the interpolation to be applied if the image is stretched. Must be GL_NEAREST or GL_LINEAR.
            /// </para>
            /// </param>
            [Obsolete("Use BlitFramebufferFilter overload instead")]
            [AutoGenerated(Category = "EXT_framebuffer_blit", Version = "", EntryPoint = "glBlitFramebufferEXT")]
            public static extern void BlitFramebuffer(Int32 srcX0, Int32 srcY0, Int32 srcX1, Int32 srcY1, Int32 dstX0, Int32 dstY0, Int32 dstX1, Int32 dstY1, OpenTK.Graphics.OpenGL.ClearBufferMask mask, OpenTK.Graphics.OpenGL.ExtFramebufferBlit filter);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Check the completeness status of a framebuffer
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specify the target of the framebuffer completeness check.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glCheckFramebufferStatusEXT")]
            public static extern OpenTK.Graphics.OpenGL.FramebufferErrorCode CheckFramebufferStatus(OpenTK.Graphics.OpenGL.FramebufferTarget target);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCheckNamedFramebufferStatusEXT")]
            public static extern OpenTK.Graphics.OpenGL.ExtDirectStateAccess CheckNamedFramebufferStatus(Int32 framebuffer, OpenTK.Graphics.OpenGL.FramebufferTarget target);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCheckNamedFramebufferStatusEXT")]
            public static extern OpenTK.Graphics.OpenGL.ExtDirectStateAccess CheckNamedFramebufferStatus(UInt32 framebuffer, OpenTK.Graphics.OpenGL.FramebufferTarget target);

            /// <summary>[requires: EXT_texture_integer]</summary>
            [AutoGenerated(Category = "EXT_texture_integer", Version = "", EntryPoint = "glClearColorIiEXT")]
            public static extern void ClearColorI(Int32 red, Int32 green, Int32 blue, Int32 alpha);

            /// <summary>[requires: EXT_texture_integer]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_texture_integer", Version = "", EntryPoint = "glClearColorIuiEXT")]
            public static extern void ClearColorI(UInt32 red, UInt32 green, UInt32 blue, UInt32 alpha);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glClearNamedBufferDataEXT")]
            public static extern void ClearNamedBufferData(Int32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr data);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glClearNamedBufferDataEXT")]
            public static extern void ClearNamedBufferData<T4>(Int32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T4[] data)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glClearNamedBufferDataEXT")]
            public static extern void ClearNamedBufferData<T4>(Int32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T4[,] data)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glClearNamedBufferDataEXT")]
            public static extern void ClearNamedBufferData<T4>(Int32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T4[,,] data)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glClearNamedBufferDataEXT")]
            public static extern void ClearNamedBufferData<T4>(Int32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T4 data)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glClearNamedBufferDataEXT")]
            public static extern void ClearNamedBufferData(UInt32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr data);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glClearNamedBufferDataEXT")]
            public static extern void ClearNamedBufferData<T4>(UInt32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T4[] data)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glClearNamedBufferDataEXT")]
            public static extern void ClearNamedBufferData<T4>(UInt32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T4[,] data)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glClearNamedBufferDataEXT")]
            public static extern void ClearNamedBufferData<T4>(UInt32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T4[,,] data)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glClearNamedBufferDataEXT")]
            public static extern void ClearNamedBufferData<T4>(UInt32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T4 data)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glClearNamedBufferSubDataEXT")]
            public static extern void ClearNamedBufferSubData(Int32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr offset, IntPtr size, IntPtr data);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glClearNamedBufferSubDataEXT")]
            public static extern void ClearNamedBufferSubData<T6>(Int32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] T6[] data)
                where T6 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glClearNamedBufferSubDataEXT")]
            public static extern void ClearNamedBufferSubData<T6>(Int32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] T6[,] data)
                where T6 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glClearNamedBufferSubDataEXT")]
            public static extern void ClearNamedBufferSubData<T6>(Int32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] T6[,,] data)
                where T6 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glClearNamedBufferSubDataEXT")]
            public static extern void ClearNamedBufferSubData<T6>(Int32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] ref T6 data)
                where T6 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glClearNamedBufferSubDataEXT")]
            public static extern void ClearNamedBufferSubData(UInt32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr offset, IntPtr size, IntPtr data);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glClearNamedBufferSubDataEXT")]
            public static extern void ClearNamedBufferSubData<T6>(UInt32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] T6[] data)
                where T6 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glClearNamedBufferSubDataEXT")]
            public static extern void ClearNamedBufferSubData<T6>(UInt32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] T6[,] data)
                where T6 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glClearNamedBufferSubDataEXT")]
            public static extern void ClearNamedBufferSubData<T6>(UInt32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] T6[,,] data)
                where T6 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glClearNamedBufferSubDataEXT")]
            public static extern void ClearNamedBufferSubData<T6>(UInt32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] ref T6 data)
                where T6 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glClientAttribDefaultEXT")]
            public static extern void ClientAttribDefault(OpenTK.Graphics.OpenGL.ClientAttribMask mask);

            /// <summary>[requires: EXT_draw_buffers2]</summary>
            [AutoGenerated(Category = "EXT_draw_buffers2", Version = "", EntryPoint = "glColorMaskIndexedEXT")]
            public static extern void ColorMaskIndexed(Int32 index, bool r, bool g, bool b, bool a);

            /// <summary>[requires: EXT_draw_buffers2]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_draw_buffers2", Version = "", EntryPoint = "glColorMaskIndexedEXT")]
            public static extern void ColorMaskIndexed(UInt32 index, bool r, bool g, bool b, bool a);

            /// <summary>[requires: EXT_vertex_array]
            /// Define an array of colors
            /// </summary>
            /// <param name="size">
            /// <para>
            /// Specifies the number of components per color. Must be 3 or 4. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each color component in the array. Symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, GL_UNSIGNED_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive colors. If stride is 0, the colors are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first component of the first color element in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glColorPointerEXT")]
            public static extern void ColorPointer(Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, Int32 count, IntPtr pointer);

            /// <summary>[requires: EXT_vertex_array]
            /// Define an array of colors
            /// </summary>
            /// <param name="size">
            /// <para>
            /// Specifies the number of components per color. Must be 3 or 4. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each color component in the array. Symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, GL_UNSIGNED_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive colors. If stride is 0, the colors are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first component of the first color element in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glColorPointerEXT")]
            public static extern void ColorPointer<T4>(Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, Int32 count, [InAttribute, OutAttribute] T4[] pointer)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_vertex_array]
            /// Define an array of colors
            /// </summary>
            /// <param name="size">
            /// <para>
            /// Specifies the number of components per color. Must be 3 or 4. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each color component in the array. Symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, GL_UNSIGNED_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive colors. If stride is 0, the colors are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first component of the first color element in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glColorPointerEXT")]
            public static extern void ColorPointer<T4>(Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, Int32 count, [InAttribute, OutAttribute] T4[,] pointer)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_vertex_array]
            /// Define an array of colors
            /// </summary>
            /// <param name="size">
            /// <para>
            /// Specifies the number of components per color. Must be 3 or 4. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each color component in the array. Symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, GL_UNSIGNED_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive colors. If stride is 0, the colors are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first component of the first color element in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glColorPointerEXT")]
            public static extern void ColorPointer<T4>(Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, Int32 count, [InAttribute, OutAttribute] T4[,,] pointer)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_vertex_array]
            /// Define an array of colors
            /// </summary>
            /// <param name="size">
            /// <para>
            /// Specifies the number of components per color. Must be 3 or 4. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each color component in the array. Symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, GL_UNSIGNED_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive colors. If stride is 0, the colors are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first component of the first color element in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glColorPointerEXT")]
            public static extern void ColorPointer<T4>(Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, Int32 count, [InAttribute, OutAttribute] ref T4 pointer)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_color_subtable]
            /// Respecify a portion of a color table
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be one of GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="start">
            /// <para>
            /// The starting index of the portion of the color table to be replaced.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// The number of table entries to replace.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in data. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in data. The allowable values are GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data that is processed to replace the specified region of the color table.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_color_subtable", Version = "", EntryPoint = "glColorSubTableEXT")]
            public static extern void ColorSubTable(OpenTK.Graphics.OpenGL.ColorTableTarget target, Int32 start, Int32 count, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr data);

            /// <summary>[requires: EXT_color_subtable]
            /// Respecify a portion of a color table
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be one of GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="start">
            /// <para>
            /// The starting index of the portion of the color table to be replaced.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// The number of table entries to replace.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in data. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in data. The allowable values are GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data that is processed to replace the specified region of the color table.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_color_subtable", Version = "", EntryPoint = "glColorSubTableEXT")]
            public static extern void ColorSubTable<T5>(OpenTK.Graphics.OpenGL.ColorTableTarget target, Int32 start, Int32 count, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T5[] data)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_color_subtable]
            /// Respecify a portion of a color table
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be one of GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="start">
            /// <para>
            /// The starting index of the portion of the color table to be replaced.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// The number of table entries to replace.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in data. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in data. The allowable values are GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data that is processed to replace the specified region of the color table.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_color_subtable", Version = "", EntryPoint = "glColorSubTableEXT")]
            public static extern void ColorSubTable<T5>(OpenTK.Graphics.OpenGL.ColorTableTarget target, Int32 start, Int32 count, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T5[,] data)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_color_subtable]
            /// Respecify a portion of a color table
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be one of GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="start">
            /// <para>
            /// The starting index of the portion of the color table to be replaced.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// The number of table entries to replace.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in data. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in data. The allowable values are GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data that is processed to replace the specified region of the color table.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_color_subtable", Version = "", EntryPoint = "glColorSubTableEXT")]
            public static extern void ColorSubTable<T5>(OpenTK.Graphics.OpenGL.ColorTableTarget target, Int32 start, Int32 count, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T5[,,] data)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_color_subtable]
            /// Respecify a portion of a color table
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be one of GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="start">
            /// <para>
            /// The starting index of the portion of the color table to be replaced.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// The number of table entries to replace.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in data. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in data. The allowable values are GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data that is processed to replace the specified region of the color table.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_color_subtable", Version = "", EntryPoint = "glColorSubTableEXT")]
            public static extern void ColorSubTable<T5>(OpenTK.Graphics.OpenGL.ColorTableTarget target, Int32 start, Int32 count, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T5 data)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_paletted_texture]
            /// Define a color lookup table
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be one of GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, GL_POST_COLOR_MATRIX_COLOR_TABLE, GL_PROXY_COLOR_TABLE, GL_PROXY_POST_CONVOLUTION_COLOR_TABLE, or GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// The internal format of the color table. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, and GL_RGBA16.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// The number of entries in the color lookup table specified by data.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in data. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in data. The allowable values are GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data that is processed to build the color table.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_paletted_texture", Version = "", EntryPoint = "glColorTableEXT")]
            public static extern void ColorTable(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalFormat, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr table);

            /// <summary>[requires: EXT_paletted_texture]
            /// Define a color lookup table
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be one of GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, GL_POST_COLOR_MATRIX_COLOR_TABLE, GL_PROXY_COLOR_TABLE, GL_PROXY_POST_CONVOLUTION_COLOR_TABLE, or GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// The internal format of the color table. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, and GL_RGBA16.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// The number of entries in the color lookup table specified by data.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in data. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in data. The allowable values are GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data that is processed to build the color table.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_paletted_texture", Version = "", EntryPoint = "glColorTableEXT")]
            public static extern void ColorTable<T5>(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalFormat, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T5[] table)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_paletted_texture]
            /// Define a color lookup table
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be one of GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, GL_POST_COLOR_MATRIX_COLOR_TABLE, GL_PROXY_COLOR_TABLE, GL_PROXY_POST_CONVOLUTION_COLOR_TABLE, or GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// The internal format of the color table. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, and GL_RGBA16.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// The number of entries in the color lookup table specified by data.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in data. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in data. The allowable values are GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data that is processed to build the color table.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_paletted_texture", Version = "", EntryPoint = "glColorTableEXT")]
            public static extern void ColorTable<T5>(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalFormat, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T5[,] table)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_paletted_texture]
            /// Define a color lookup table
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be one of GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, GL_POST_COLOR_MATRIX_COLOR_TABLE, GL_PROXY_COLOR_TABLE, GL_PROXY_POST_CONVOLUTION_COLOR_TABLE, or GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// The internal format of the color table. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, and GL_RGBA16.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// The number of entries in the color lookup table specified by data.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in data. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in data. The allowable values are GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data that is processed to build the color table.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_paletted_texture", Version = "", EntryPoint = "glColorTableEXT")]
            public static extern void ColorTable<T5>(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalFormat, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T5[,,] table)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_paletted_texture]
            /// Define a color lookup table
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be one of GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, GL_POST_COLOR_MATRIX_COLOR_TABLE, GL_PROXY_COLOR_TABLE, GL_PROXY_POST_CONVOLUTION_COLOR_TABLE, or GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// The internal format of the color table. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, and GL_RGBA16.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// The number of entries in the color lookup table specified by data.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in data. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in data. The allowable values are GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data that is processed to build the color table.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_paletted_texture", Version = "", EntryPoint = "glColorTableEXT")]
            public static extern void ColorTable<T5>(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalFormat, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T5 table)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedMultiTexImage1DEXT")]
            public static extern void CompressedMultiTexImage1D(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 border, Int32 imageSize, IntPtr bits);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedMultiTexImage1DEXT")]
            public static extern void CompressedMultiTexImage1D<T7>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T7[] bits)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedMultiTexImage1DEXT")]
            public static extern void CompressedMultiTexImage1D<T7>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T7[,] bits)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedMultiTexImage1DEXT")]
            public static extern void CompressedMultiTexImage1D<T7>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T7[,,] bits)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedMultiTexImage1DEXT")]
            public static extern void CompressedMultiTexImage1D<T7>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] ref T7 bits)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedMultiTexImage2DEXT")]
            public static extern void CompressedMultiTexImage2D(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 border, Int32 imageSize, IntPtr bits);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedMultiTexImage2DEXT")]
            public static extern void CompressedMultiTexImage2D<T8>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T8[] bits)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedMultiTexImage2DEXT")]
            public static extern void CompressedMultiTexImage2D<T8>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T8[,] bits)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedMultiTexImage2DEXT")]
            public static extern void CompressedMultiTexImage2D<T8>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T8[,,] bits)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedMultiTexImage2DEXT")]
            public static extern void CompressedMultiTexImage2D<T8>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] ref T8 bits)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedMultiTexImage3DEXT")]
            public static extern void CompressedMultiTexImage3D(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, Int32 imageSize, IntPtr bits);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedMultiTexImage3DEXT")]
            public static extern void CompressedMultiTexImage3D<T9>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T9[] bits)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedMultiTexImage3DEXT")]
            public static extern void CompressedMultiTexImage3D<T9>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T9[,] bits)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedMultiTexImage3DEXT")]
            public static extern void CompressedMultiTexImage3D<T9>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T9[,,] bits)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedMultiTexImage3DEXT")]
            public static extern void CompressedMultiTexImage3D<T9>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] ref T9 bits)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedMultiTexSubImage1DEXT")]
            public static extern void CompressedMultiTexSubImage1D(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, IntPtr bits);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedMultiTexSubImage1DEXT")]
            public static extern void CompressedMultiTexSubImage1D<T7>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T7[] bits)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedMultiTexSubImage1DEXT")]
            public static extern void CompressedMultiTexSubImage1D<T7>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T7[,] bits)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedMultiTexSubImage1DEXT")]
            public static extern void CompressedMultiTexSubImage1D<T7>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T7[,,] bits)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedMultiTexSubImage1DEXT")]
            public static extern void CompressedMultiTexSubImage1D<T7>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] ref T7 bits)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedMultiTexSubImage2DEXT")]
            public static extern void CompressedMultiTexSubImage2D(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, IntPtr bits);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedMultiTexSubImage2DEXT")]
            public static extern void CompressedMultiTexSubImage2D<T9>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T9[] bits)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedMultiTexSubImage2DEXT")]
            public static extern void CompressedMultiTexSubImage2D<T9>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T9[,] bits)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedMultiTexSubImage2DEXT")]
            public static extern void CompressedMultiTexSubImage2D<T9>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T9[,,] bits)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedMultiTexSubImage2DEXT")]
            public static extern void CompressedMultiTexSubImage2D<T9>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] ref T9 bits)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedMultiTexSubImage3DEXT")]
            public static extern void CompressedMultiTexSubImage3D(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, IntPtr bits);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedMultiTexSubImage3DEXT")]
            public static extern void CompressedMultiTexSubImage3D<T11>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T11[] bits)
                where T11 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedMultiTexSubImage3DEXT")]
            public static extern void CompressedMultiTexSubImage3D<T11>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T11[,] bits)
                where T11 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedMultiTexSubImage3DEXT")]
            public static extern void CompressedMultiTexSubImage3D<T11>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T11[,,] bits)
                where T11 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedMultiTexSubImage3DEXT")]
            public static extern void CompressedMultiTexSubImage3D<T11>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] ref T11 bits)
                where T11 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureImage1DEXT")]
            public static extern void CompressedTextureImage1D(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 border, Int32 imageSize, IntPtr bits);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureImage1DEXT")]
            public static extern void CompressedTextureImage1D<T7>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T7[] bits)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureImage1DEXT")]
            public static extern void CompressedTextureImage1D<T7>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T7[,] bits)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureImage1DEXT")]
            public static extern void CompressedTextureImage1D<T7>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T7[,,] bits)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureImage1DEXT")]
            public static extern void CompressedTextureImage1D<T7>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] ref T7 bits)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureImage1DEXT")]
            public static extern void CompressedTextureImage1D(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 border, Int32 imageSize, IntPtr bits);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureImage1DEXT")]
            public static extern void CompressedTextureImage1D<T7>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T7[] bits)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureImage1DEXT")]
            public static extern void CompressedTextureImage1D<T7>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T7[,] bits)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureImage1DEXT")]
            public static extern void CompressedTextureImage1D<T7>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T7[,,] bits)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureImage1DEXT")]
            public static extern void CompressedTextureImage1D<T7>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] ref T7 bits)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureImage2DEXT")]
            public static extern void CompressedTextureImage2D(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 border, Int32 imageSize, IntPtr bits);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureImage2DEXT")]
            public static extern void CompressedTextureImage2D<T8>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T8[] bits)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureImage2DEXT")]
            public static extern void CompressedTextureImage2D<T8>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T8[,] bits)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureImage2DEXT")]
            public static extern void CompressedTextureImage2D<T8>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T8[,,] bits)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureImage2DEXT")]
            public static extern void CompressedTextureImage2D<T8>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] ref T8 bits)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureImage2DEXT")]
            public static extern void CompressedTextureImage2D(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 border, Int32 imageSize, IntPtr bits);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureImage2DEXT")]
            public static extern void CompressedTextureImage2D<T8>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T8[] bits)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureImage2DEXT")]
            public static extern void CompressedTextureImage2D<T8>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T8[,] bits)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureImage2DEXT")]
            public static extern void CompressedTextureImage2D<T8>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T8[,,] bits)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureImage2DEXT")]
            public static extern void CompressedTextureImage2D<T8>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] ref T8 bits)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureImage3DEXT")]
            public static extern void CompressedTextureImage3D(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, Int32 imageSize, IntPtr bits);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureImage3DEXT")]
            public static extern void CompressedTextureImage3D<T9>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T9[] bits)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureImage3DEXT")]
            public static extern void CompressedTextureImage3D<T9>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T9[,] bits)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureImage3DEXT")]
            public static extern void CompressedTextureImage3D<T9>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T9[,,] bits)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureImage3DEXT")]
            public static extern void CompressedTextureImage3D<T9>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] ref T9 bits)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureImage3DEXT")]
            public static extern void CompressedTextureImage3D(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, Int32 imageSize, IntPtr bits);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureImage3DEXT")]
            public static extern void CompressedTextureImage3D<T9>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T9[] bits)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureImage3DEXT")]
            public static extern void CompressedTextureImage3D<T9>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T9[,] bits)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureImage3DEXT")]
            public static extern void CompressedTextureImage3D<T9>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] T9[,,] bits)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureImage3DEXT")]
            public static extern void CompressedTextureImage3D<T9>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, Int32 imageSize, [InAttribute, OutAttribute] ref T9 bits)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureSubImage1DEXT")]
            public static extern void CompressedTextureSubImage1D(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, IntPtr bits);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureSubImage1DEXT")]
            public static extern void CompressedTextureSubImage1D<T7>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T7[] bits)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureSubImage1DEXT")]
            public static extern void CompressedTextureSubImage1D<T7>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T7[,] bits)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureSubImage1DEXT")]
            public static extern void CompressedTextureSubImage1D<T7>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T7[,,] bits)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureSubImage1DEXT")]
            public static extern void CompressedTextureSubImage1D<T7>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] ref T7 bits)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureSubImage1DEXT")]
            public static extern void CompressedTextureSubImage1D(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, IntPtr bits);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureSubImage1DEXT")]
            public static extern void CompressedTextureSubImage1D<T7>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T7[] bits)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureSubImage1DEXT")]
            public static extern void CompressedTextureSubImage1D<T7>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T7[,] bits)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureSubImage1DEXT")]
            public static extern void CompressedTextureSubImage1D<T7>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T7[,,] bits)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureSubImage1DEXT")]
            public static extern void CompressedTextureSubImage1D<T7>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] ref T7 bits)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureSubImage2DEXT")]
            public static extern void CompressedTextureSubImage2D(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, IntPtr bits);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureSubImage2DEXT")]
            public static extern void CompressedTextureSubImage2D<T9>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T9[] bits)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureSubImage2DEXT")]
            public static extern void CompressedTextureSubImage2D<T9>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T9[,] bits)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureSubImage2DEXT")]
            public static extern void CompressedTextureSubImage2D<T9>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T9[,,] bits)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureSubImage2DEXT")]
            public static extern void CompressedTextureSubImage2D<T9>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] ref T9 bits)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureSubImage2DEXT")]
            public static extern void CompressedTextureSubImage2D(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, IntPtr bits);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureSubImage2DEXT")]
            public static extern void CompressedTextureSubImage2D<T9>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T9[] bits)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureSubImage2DEXT")]
            public static extern void CompressedTextureSubImage2D<T9>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T9[,] bits)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureSubImage2DEXT")]
            public static extern void CompressedTextureSubImage2D<T9>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T9[,,] bits)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureSubImage2DEXT")]
            public static extern void CompressedTextureSubImage2D<T9>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] ref T9 bits)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureSubImage3DEXT")]
            public static extern void CompressedTextureSubImage3D(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, IntPtr bits);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureSubImage3DEXT")]
            public static extern void CompressedTextureSubImage3D<T11>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T11[] bits)
                where T11 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureSubImage3DEXT")]
            public static extern void CompressedTextureSubImage3D<T11>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T11[,] bits)
                where T11 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureSubImage3DEXT")]
            public static extern void CompressedTextureSubImage3D<T11>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T11[,,] bits)
                where T11 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureSubImage3DEXT")]
            public static extern void CompressedTextureSubImage3D<T11>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] ref T11 bits)
                where T11 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureSubImage3DEXT")]
            public static extern void CompressedTextureSubImage3D(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, IntPtr bits);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureSubImage3DEXT")]
            public static extern void CompressedTextureSubImage3D<T11>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T11[] bits)
                where T11 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureSubImage3DEXT")]
            public static extern void CompressedTextureSubImage3D<T11>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T11[,] bits)
                where T11 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureSubImage3DEXT")]
            public static extern void CompressedTextureSubImage3D<T11>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] T11[,,] bits)
                where T11 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCompressedTextureSubImage3DEXT")]
            public static extern void CompressedTextureSubImage3D<T11>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, [InAttribute, OutAttribute] ref T11 bits)
                where T11 : struct
            ;

            /// <summary>[requires: EXT_convolution]
            /// Define a one-dimensional convolution filter
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_CONVOLUTION_1D.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// The internal format of the convolution filter kernel. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// The width of the pixel array referenced by data.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in data. The allowable values are GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_INTENSITY, GL_RGB, and GL_RGBA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in data. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data that is processed to build the convolution filter kernel.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glConvolutionFilter1DEXT")]
            public static extern void ConvolutionFilter1D(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr image);

            /// <summary>[requires: EXT_convolution]
            /// Define a one-dimensional convolution filter
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_CONVOLUTION_1D.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// The internal format of the convolution filter kernel. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// The width of the pixel array referenced by data.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in data. The allowable values are GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_INTENSITY, GL_RGB, and GL_RGBA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in data. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data that is processed to build the convolution filter kernel.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glConvolutionFilter1DEXT")]
            public static extern void ConvolutionFilter1D<T5>(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T5[] image)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_convolution]
            /// Define a one-dimensional convolution filter
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_CONVOLUTION_1D.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// The internal format of the convolution filter kernel. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// The width of the pixel array referenced by data.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in data. The allowable values are GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_INTENSITY, GL_RGB, and GL_RGBA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in data. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data that is processed to build the convolution filter kernel.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glConvolutionFilter1DEXT")]
            public static extern void ConvolutionFilter1D<T5>(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T5[,] image)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_convolution]
            /// Define a one-dimensional convolution filter
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_CONVOLUTION_1D.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// The internal format of the convolution filter kernel. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// The width of the pixel array referenced by data.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in data. The allowable values are GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_INTENSITY, GL_RGB, and GL_RGBA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in data. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data that is processed to build the convolution filter kernel.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glConvolutionFilter1DEXT")]
            public static extern void ConvolutionFilter1D<T5>(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T5[,,] image)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_convolution]
            /// Define a one-dimensional convolution filter
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_CONVOLUTION_1D.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// The internal format of the convolution filter kernel. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// The width of the pixel array referenced by data.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in data. The allowable values are GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_INTENSITY, GL_RGB, and GL_RGBA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in data. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data that is processed to build the convolution filter kernel.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glConvolutionFilter1DEXT")]
            public static extern void ConvolutionFilter1D<T5>(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T5 image)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_convolution]
            /// Define a two-dimensional convolution filter
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_CONVOLUTION_2D.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// The internal format of the convolution filter kernel. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// The width of the pixel array referenced by data.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// The height of the pixel array referenced by data.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in data. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, and GL_LUMINANCE_ALPHA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in data. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Pointer to a two-dimensional array of pixel data that is processed to build the convolution filter kernel.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glConvolutionFilter2DEXT")]
            public static extern void ConvolutionFilter2D(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr image);

            /// <summary>[requires: EXT_convolution]
            /// Define a two-dimensional convolution filter
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_CONVOLUTION_2D.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// The internal format of the convolution filter kernel. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// The width of the pixel array referenced by data.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// The height of the pixel array referenced by data.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in data. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, and GL_LUMINANCE_ALPHA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in data. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Pointer to a two-dimensional array of pixel data that is processed to build the convolution filter kernel.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glConvolutionFilter2DEXT")]
            public static extern void ConvolutionFilter2D<T6>(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T6[] image)
                where T6 : struct
            ;

            /// <summary>[requires: EXT_convolution]
            /// Define a two-dimensional convolution filter
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_CONVOLUTION_2D.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// The internal format of the convolution filter kernel. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// The width of the pixel array referenced by data.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// The height of the pixel array referenced by data.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in data. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, and GL_LUMINANCE_ALPHA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in data. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Pointer to a two-dimensional array of pixel data that is processed to build the convolution filter kernel.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glConvolutionFilter2DEXT")]
            public static extern void ConvolutionFilter2D<T6>(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T6[,] image)
                where T6 : struct
            ;

            /// <summary>[requires: EXT_convolution]
            /// Define a two-dimensional convolution filter
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_CONVOLUTION_2D.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// The internal format of the convolution filter kernel. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// The width of the pixel array referenced by data.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// The height of the pixel array referenced by data.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in data. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, and GL_LUMINANCE_ALPHA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in data. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Pointer to a two-dimensional array of pixel data that is processed to build the convolution filter kernel.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glConvolutionFilter2DEXT")]
            public static extern void ConvolutionFilter2D<T6>(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T6[,,] image)
                where T6 : struct
            ;

            /// <summary>[requires: EXT_convolution]
            /// Define a two-dimensional convolution filter
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_CONVOLUTION_2D.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// The internal format of the convolution filter kernel. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// The width of the pixel array referenced by data.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// The height of the pixel array referenced by data.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in data. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, and GL_LUMINANCE_ALPHA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in data. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Pointer to a two-dimensional array of pixel data that is processed to build the convolution filter kernel.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glConvolutionFilter2DEXT")]
            public static extern void ConvolutionFilter2D<T6>(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T6 image)
                where T6 : struct
            ;

            /// <summary>[requires: EXT_convolution]
            /// Set convolution parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The target for the convolution parameter. Must be one of GL_CONVOLUTION_1D, GL_CONVOLUTION_2D, or GL_SEPARABLE_2D.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The parameter to be set. Must be GL_CONVOLUTION_BORDER_MODE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// The parameter value. Must be one of GL_REDUCE, GL_CONSTANT_BORDER, GL_REPLICATE_BORDER.
            /// </para>
            /// <para>
            ///
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glConvolutionParameterfEXT")]
            public static extern void ConvolutionParameter(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.ExtConvolution pname, Single @params);

            /// <summary>[requires: EXT_convolution]
            /// Set convolution parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The target for the convolution parameter. Must be one of GL_CONVOLUTION_1D, GL_CONVOLUTION_2D, or GL_SEPARABLE_2D.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The parameter to be set. Must be GL_CONVOLUTION_BORDER_MODE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// The parameter value. Must be one of GL_REDUCE, GL_CONSTANT_BORDER, GL_REPLICATE_BORDER.
            /// </para>
            /// <para>
            ///
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glConvolutionParameterfvEXT")]
            public static extern void ConvolutionParameter(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.ExtConvolution pname, Single[] @params);

            /// <summary>[requires: EXT_convolution]
            /// Set convolution parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The target for the convolution parameter. Must be one of GL_CONVOLUTION_1D, GL_CONVOLUTION_2D, or GL_SEPARABLE_2D.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The parameter to be set. Must be GL_CONVOLUTION_BORDER_MODE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// The parameter value. Must be one of GL_REDUCE, GL_CONSTANT_BORDER, GL_REPLICATE_BORDER.
            /// </para>
            /// <para>
            ///
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glConvolutionParameterfvEXT")]
            public static extern unsafe void ConvolutionParameter(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.ExtConvolution pname, Single* @params);

            /// <summary>[requires: EXT_convolution]
            /// Set convolution parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The target for the convolution parameter. Must be one of GL_CONVOLUTION_1D, GL_CONVOLUTION_2D, or GL_SEPARABLE_2D.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The parameter to be set. Must be GL_CONVOLUTION_BORDER_MODE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// The parameter value. Must be one of GL_REDUCE, GL_CONSTANT_BORDER, GL_REPLICATE_BORDER.
            /// </para>
            /// <para>
            ///
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glConvolutionParameteriEXT")]
            public static extern void ConvolutionParameter(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.ExtConvolution pname, Int32 @params);

            /// <summary>[requires: EXT_convolution]
            /// Set convolution parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The target for the convolution parameter. Must be one of GL_CONVOLUTION_1D, GL_CONVOLUTION_2D, or GL_SEPARABLE_2D.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The parameter to be set. Must be GL_CONVOLUTION_BORDER_MODE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// The parameter value. Must be one of GL_REDUCE, GL_CONSTANT_BORDER, GL_REPLICATE_BORDER.
            /// </para>
            /// <para>
            ///
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glConvolutionParameterivEXT")]
            public static extern void ConvolutionParameter(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.ExtConvolution pname, Int32[] @params);

            /// <summary>[requires: EXT_convolution]
            /// Set convolution parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The target for the convolution parameter. Must be one of GL_CONVOLUTION_1D, GL_CONVOLUTION_2D, or GL_SEPARABLE_2D.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The parameter to be set. Must be GL_CONVOLUTION_BORDER_MODE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// The parameter value. Must be one of GL_REDUCE, GL_CONSTANT_BORDER, GL_REPLICATE_BORDER.
            /// </para>
            /// <para>
            ///
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glConvolutionParameterivEXT")]
            public static extern unsafe void ConvolutionParameter(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.ExtConvolution pname, Int32* @params);

            /// <summary>[requires: EXT_color_subtable]
            /// Respecify a portion of a color table
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be one of GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="start">
            /// <para>
            /// The starting index of the portion of the color table to be replaced.
            /// </para>
            /// </param>
            /// <param name="x">
            /// <para>
            /// The window coordinates of the left corner of the row of pixels to be copied.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// The number of table entries to replace.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_color_subtable", Version = "", EntryPoint = "glCopyColorSubTableEXT")]
            public static extern void CopyColorSubTable(OpenTK.Graphics.OpenGL.ColorTableTarget target, Int32 start, Int32 x, Int32 y, Int32 width);

            /// <summary>[requires: EXT_convolution]
            /// Copy pixels into a one-dimensional convolution filter
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_CONVOLUTION_1D.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// The internal format of the convolution filter kernel. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
            /// </para>
            /// </param>
            /// <param name="x">
            /// <para>
            /// The window space coordinates of the lower-left coordinate of the pixel array to copy.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// The width of the pixel array to copy.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glCopyConvolutionFilter1DEXT")]
            public static extern void CopyConvolutionFilter1D(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 x, Int32 y, Int32 width);

            /// <summary>[requires: EXT_convolution]
            /// Copy pixels into a two-dimensional convolution filter
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_CONVOLUTION_2D.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// The internal format of the convolution filter kernel. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
            /// </para>
            /// </param>
            /// <param name="x">
            /// <para>
            /// The window space coordinates of the lower-left coordinate of the pixel array to copy.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// The width of the pixel array to copy.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// The height of the pixel array to copy.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glCopyConvolutionFilter2DEXT")]
            public static extern void CopyConvolutionFilter2D(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 x, Int32 y, Int32 width, Int32 height);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCopyMultiTexImage1DEXT")]
            public static extern void CopyMultiTexImage1D(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 x, Int32 y, Int32 width, Int32 border);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCopyMultiTexImage2DEXT")]
            public static extern void CopyMultiTexImage2D(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 x, Int32 y, Int32 width, Int32 height, Int32 border);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCopyMultiTexSubImage1DEXT")]
            public static extern void CopyMultiTexSubImage1D(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 x, Int32 y, Int32 width);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCopyMultiTexSubImage2DEXT")]
            public static extern void CopyMultiTexSubImage2D(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 x, Int32 y, Int32 width, Int32 height);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCopyMultiTexSubImage3DEXT")]
            public static extern void CopyMultiTexSubImage3D(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 x, Int32 y, Int32 width, Int32 height);

            /// <summary>[requires: EXT_copy_texture]
            /// Copy pixels into a 1D texture image
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_1D.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// Specifies the internal format of the texture. Must be one of the following symbolic constants: GL_COMPRESSED_RED, GL_COMPRESSED_RG, GL_COMPRESSED_RGB, GL_COMPRESSED_RGBA. GL_COMPRESSED_SRGB, GL_COMPRESSED_SRGB_ALPHA. GL_DEPTH_COMPONENT, GL_DEPTH_COMPONENT16, GL_DEPTH_COMPONENT24, GL_DEPTH_COMPONENT32, GL_STENCIL_INDEX8, GL_RED, GL_RG, GL_RGB, GL_R3_G3_B2, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, GL_RGBA16, GL_SRGB, GL_SRGB8, GL_SRGB_ALPHA, or GL_SRGB8_ALPHA8.
            /// </para>
            /// </param>
            /// <param name="x">
            /// <para>
            /// Specify the window coordinates of the left corner of the row of pixels to be copied.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture image. The height of the texture image is 1.
            /// </para>
            /// </param>
            /// <param name="border">
            /// <para>
            /// Must be 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_copy_texture", Version = "", EntryPoint = "glCopyTexImage1DEXT")]
            public static extern void CopyTexImage1D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 x, Int32 y, Int32 width, Int32 border);

            /// <summary>[requires: EXT_copy_texture]
            /// Copy pixels into a 2D texture image
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, or GL_TEXTURE_CUBE_MAP_NEGATIVE_Z.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// Specifies the internal format of the texture. Must be one of the following symbolic constants: GL_COMPRESSED_RED, GL_COMPRESSED_RG, GL_COMPRESSED_RGB, GL_COMPRESSED_RGBA. GL_COMPRESSED_SRGB, GL_COMPRESSED_SRGB_ALPHA. GL_DEPTH_COMPONENT, GL_DEPTH_COMPONENT16, GL_DEPTH_COMPONENT24, GL_DEPTH_COMPONENT32, GL_STENCIL_INDEX8, GL_RED, GL_RG, GL_RGB, GL_R3_G3_B2, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, GL_RGBA16, GL_SRGB, GL_SRGB8, GL_SRGB_ALPHA, or GL_SRGB8_ALPHA8.
            /// </para>
            /// </param>
            /// <param name="x">
            /// <para>
            /// Specify the window coordinates of the lower left corner of the rectangular region of pixels to be copied.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture image.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture image.
            /// </para>
            /// </param>
            /// <param name="border">
            /// <para>
            /// Must be 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_copy_texture", Version = "", EntryPoint = "glCopyTexImage2DEXT")]
            public static extern void CopyTexImage2D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 x, Int32 y, Int32 width, Int32 height, Int32 border);

            /// <summary>[requires: EXT_copy_texture]
            /// Copy a one-dimensional texture subimage
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_1D.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="xoffset">
            /// <para>
            /// Specifies the texel offset within the texture array.
            /// </para>
            /// </param>
            /// <param name="x">
            /// <para>
            /// Specify the window coordinates of the left corner of the row of pixels to be copied.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture subimage.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_copy_texture", Version = "", EntryPoint = "glCopyTexSubImage1DEXT")]
            public static extern void CopyTexSubImage1D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 x, Int32 y, Int32 width);

            /// <summary>[requires: EXT_copy_texture]
            /// Copy a two-dimensional texture subimage
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, or GL_TEXTURE_1D_ARRAY.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="xoffset">
            /// <para>
            /// Specifies a texel offset in the x direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="yoffset">
            /// <para>
            /// Specifies a texel offset in the y direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="x">
            /// <para>
            /// Specify the window coordinates of the lower left corner of the rectangular region of pixels to be copied.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture subimage.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_copy_texture", Version = "", EntryPoint = "glCopyTexSubImage2DEXT")]
            public static extern void CopyTexSubImage2D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 x, Int32 y, Int32 width, Int32 height);

            /// <summary>[requires: EXT_copy_texture]
            /// Copy a three-dimensional texture subimage
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_3D or GL_TEXTURE_2D_ARRAY.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="xoffset">
            /// <para>
            /// Specifies a texel offset in the x direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="yoffset">
            /// <para>
            /// Specifies a texel offset in the y direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="zoffset">
            /// <para>
            /// Specifies a texel offset in the z direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="x">
            /// <para>
            /// Specify the window coordinates of the lower left corner of the rectangular region of pixels to be copied.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture subimage.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_copy_texture", Version = "", EntryPoint = "glCopyTexSubImage3DEXT")]
            public static extern void CopyTexSubImage3D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 x, Int32 y, Int32 width, Int32 height);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCopyTextureImage1DEXT")]
            public static extern void CopyTextureImage1D(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 x, Int32 y, Int32 width, Int32 border);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCopyTextureImage1DEXT")]
            public static extern void CopyTextureImage1D(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 x, Int32 y, Int32 width, Int32 border);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCopyTextureImage2DEXT")]
            public static extern void CopyTextureImage2D(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 x, Int32 y, Int32 width, Int32 height, Int32 border);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCopyTextureImage2DEXT")]
            public static extern void CopyTextureImage2D(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 x, Int32 y, Int32 width, Int32 height, Int32 border);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCopyTextureSubImage1DEXT")]
            public static extern void CopyTextureSubImage1D(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 x, Int32 y, Int32 width);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCopyTextureSubImage1DEXT")]
            public static extern void CopyTextureSubImage1D(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 x, Int32 y, Int32 width);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCopyTextureSubImage2DEXT")]
            public static extern void CopyTextureSubImage2D(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 x, Int32 y, Int32 width, Int32 height);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCopyTextureSubImage2DEXT")]
            public static extern void CopyTextureSubImage2D(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 x, Int32 y, Int32 width, Int32 height);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCopyTextureSubImage3DEXT")]
            public static extern void CopyTextureSubImage3D(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 x, Int32 y, Int32 width, Int32 height);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glCopyTextureSubImage3DEXT")]
            public static extern void CopyTextureSubImage3D(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 x, Int32 y, Int32 width, Int32 height);

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Create a stand-alone program from an array of null-terminated source code strings
            /// </summary>
            /// <param name="type">
            /// <para>
            /// Specifies the type of shader to create.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of source code strings in the array strings.
            /// </para>
            /// </param>
            /// <param name="strings">
            /// <para>
            /// Specifies the address of an array of pointers to source code strings from which to create the program object.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glCreateShaderProgramEXT")]
            public static extern Int32 CreateShaderProgram(OpenTK.Graphics.OpenGL.ExtSeparateShaderObjects type, String @string);

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Create a stand-alone program from an array of null-terminated source code strings
            /// </summary>
            /// <param name="type">
            /// <para>
            /// Specifies the type of shader to create.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of source code strings in the array strings.
            /// </para>
            /// </param>
            /// <param name="strings">
            /// <para>
            /// Specifies the address of an array of pointers to source code strings from which to create the program object.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glCreateShaderProgramvEXT")]
            public static extern Int32 CreateShaderProgram(OpenTK.Graphics.OpenGL.ExtSeparateShaderObjects type, Int32 count, String[] strings);

            /// <summary>[requires: EXT_cull_vertex]</summary>
            [AutoGenerated(Category = "EXT_cull_vertex", Version = "", EntryPoint = "glCullParameterdvEXT")]
            public static extern void CullParameter(OpenTK.Graphics.OpenGL.ExtCullVertex pname, [OutAttribute] Double[] @params);

            /// <summary>[requires: EXT_cull_vertex]</summary>
            [AutoGenerated(Category = "EXT_cull_vertex", Version = "", EntryPoint = "glCullParameterdvEXT")]
            public static extern void CullParameter(OpenTK.Graphics.OpenGL.ExtCullVertex pname, [OutAttribute] out Double @params);

            /// <summary>[requires: EXT_cull_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_cull_vertex", Version = "", EntryPoint = "glCullParameterdvEXT")]
            public static extern unsafe void CullParameter(OpenTK.Graphics.OpenGL.ExtCullVertex pname, [OutAttribute] Double* @params);

            /// <summary>[requires: EXT_cull_vertex]</summary>
            [AutoGenerated(Category = "EXT_cull_vertex", Version = "", EntryPoint = "glCullParameterfvEXT")]
            public static extern void CullParameter(OpenTK.Graphics.OpenGL.ExtCullVertex pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: EXT_cull_vertex]</summary>
            [AutoGenerated(Category = "EXT_cull_vertex", Version = "", EntryPoint = "glCullParameterfvEXT")]
            public static extern void CullParameter(OpenTK.Graphics.OpenGL.ExtCullVertex pname, [OutAttribute] out Single @params);

            /// <summary>[requires: EXT_cull_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_cull_vertex", Version = "", EntryPoint = "glCullParameterfvEXT")]
            public static extern unsafe void CullParameter(OpenTK.Graphics.OpenGL.ExtCullVertex pname, [OutAttribute] Single* @params);

            /// <summary>[requires: EXT_framebuffer_object]</summary>
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glDeleteFramebuffersEXT")]
            public static extern void DeleteFramebuffer(Int32 framebuffers);

            /// <summary>[requires: EXT_framebuffer_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glDeleteFramebuffersEXT")]
            public static extern void DeleteFramebuffer(UInt32 framebuffers);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Delete framebuffer objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of framebuffer objects to be deleted.
            /// </para>
            /// </param>
            /// <param name="framebuffers">
            /// <para>
            /// A pointer to an array containing n framebuffer objects to be deleted.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glDeleteFramebuffersEXT")]
            public static extern void DeleteFramebuffers(Int32 n, Int32[] framebuffers);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Delete framebuffer objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of framebuffer objects to be deleted.
            /// </para>
            /// </param>
            /// <param name="framebuffers">
            /// <para>
            /// A pointer to an array containing n framebuffer objects to be deleted.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glDeleteFramebuffersEXT")]
            public static extern void DeleteFramebuffers(Int32 n, ref Int32 framebuffers);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Delete framebuffer objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of framebuffer objects to be deleted.
            /// </para>
            /// </param>
            /// <param name="framebuffers">
            /// <para>
            /// A pointer to an array containing n framebuffer objects to be deleted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glDeleteFramebuffersEXT")]
            public static extern unsafe void DeleteFramebuffers(Int32 n, Int32* framebuffers);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Delete framebuffer objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of framebuffer objects to be deleted.
            /// </para>
            /// </param>
            /// <param name="framebuffers">
            /// <para>
            /// A pointer to an array containing n framebuffer objects to be deleted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glDeleteFramebuffersEXT")]
            public static extern void DeleteFramebuffers(Int32 n, UInt32[] framebuffers);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Delete framebuffer objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of framebuffer objects to be deleted.
            /// </para>
            /// </param>
            /// <param name="framebuffers">
            /// <para>
            /// A pointer to an array containing n framebuffer objects to be deleted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glDeleteFramebuffersEXT")]
            public static extern void DeleteFramebuffers(Int32 n, ref UInt32 framebuffers);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Delete framebuffer objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of framebuffer objects to be deleted.
            /// </para>
            /// </param>
            /// <param name="framebuffers">
            /// <para>
            /// A pointer to an array containing n framebuffer objects to be deleted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glDeleteFramebuffersEXT")]
            public static extern unsafe void DeleteFramebuffers(Int32 n, UInt32* framebuffers);

            /// <summary>[requires: EXT_separate_shader_objects]</summary>
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glDeleteProgramPipelinesEXT")]
            public static extern void DeleteProgramPipeline(Int32 pipelines);

            /// <summary>[requires: EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glDeleteProgramPipelinesEXT")]
            public static extern void DeleteProgramPipeline(UInt32 pipelines);

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Delete program pipeline objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of program pipeline objects to delete.
            /// </para>
            /// </param>
            /// <param name="pipelines">
            /// <para>
            /// Specifies an array of names of program pipeline objects to delete.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glDeleteProgramPipelinesEXT")]
            public static extern void DeleteProgramPipelines(Int32 n, Int32[] pipelines);

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Delete program pipeline objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of program pipeline objects to delete.
            /// </para>
            /// </param>
            /// <param name="pipelines">
            /// <para>
            /// Specifies an array of names of program pipeline objects to delete.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glDeleteProgramPipelinesEXT")]
            public static extern void DeleteProgramPipelines(Int32 n, ref Int32 pipelines);

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Delete program pipeline objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of program pipeline objects to delete.
            /// </para>
            /// </param>
            /// <param name="pipelines">
            /// <para>
            /// Specifies an array of names of program pipeline objects to delete.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glDeleteProgramPipelinesEXT")]
            public static extern unsafe void DeleteProgramPipelines(Int32 n, Int32* pipelines);

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Delete program pipeline objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of program pipeline objects to delete.
            /// </para>
            /// </param>
            /// <param name="pipelines">
            /// <para>
            /// Specifies an array of names of program pipeline objects to delete.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glDeleteProgramPipelinesEXT")]
            public static extern void DeleteProgramPipelines(Int32 n, UInt32[] pipelines);

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Delete program pipeline objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of program pipeline objects to delete.
            /// </para>
            /// </param>
            /// <param name="pipelines">
            /// <para>
            /// Specifies an array of names of program pipeline objects to delete.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glDeleteProgramPipelinesEXT")]
            public static extern void DeleteProgramPipelines(Int32 n, ref UInt32 pipelines);

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Delete program pipeline objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of program pipeline objects to delete.
            /// </para>
            /// </param>
            /// <param name="pipelines">
            /// <para>
            /// Specifies an array of names of program pipeline objects to delete.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glDeleteProgramPipelinesEXT")]
            public static extern unsafe void DeleteProgramPipelines(Int32 n, UInt32* pipelines);

            /// <summary>[requires: EXT_framebuffer_object]</summary>
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glDeleteRenderbuffersEXT")]
            public static extern void DeleteRenderbuffer(Int32 renderbuffers);

            /// <summary>[requires: EXT_framebuffer_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glDeleteRenderbuffersEXT")]
            public static extern void DeleteRenderbuffer(UInt32 renderbuffers);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Delete renderbuffer objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of renderbuffer objects to be deleted.
            /// </para>
            /// </param>
            /// <param name="renderbuffers">
            /// <para>
            /// A pointer to an array containing n renderbuffer objects to be deleted.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glDeleteRenderbuffersEXT")]
            public static extern void DeleteRenderbuffers(Int32 n, Int32[] renderbuffers);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Delete renderbuffer objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of renderbuffer objects to be deleted.
            /// </para>
            /// </param>
            /// <param name="renderbuffers">
            /// <para>
            /// A pointer to an array containing n renderbuffer objects to be deleted.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glDeleteRenderbuffersEXT")]
            public static extern void DeleteRenderbuffers(Int32 n, ref Int32 renderbuffers);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Delete renderbuffer objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of renderbuffer objects to be deleted.
            /// </para>
            /// </param>
            /// <param name="renderbuffers">
            /// <para>
            /// A pointer to an array containing n renderbuffer objects to be deleted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glDeleteRenderbuffersEXT")]
            public static extern unsafe void DeleteRenderbuffers(Int32 n, Int32* renderbuffers);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Delete renderbuffer objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of renderbuffer objects to be deleted.
            /// </para>
            /// </param>
            /// <param name="renderbuffers">
            /// <para>
            /// A pointer to an array containing n renderbuffer objects to be deleted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glDeleteRenderbuffersEXT")]
            public static extern void DeleteRenderbuffers(Int32 n, UInt32[] renderbuffers);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Delete renderbuffer objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of renderbuffer objects to be deleted.
            /// </para>
            /// </param>
            /// <param name="renderbuffers">
            /// <para>
            /// A pointer to an array containing n renderbuffer objects to be deleted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glDeleteRenderbuffersEXT")]
            public static extern void DeleteRenderbuffers(Int32 n, ref UInt32 renderbuffers);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Delete renderbuffer objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of renderbuffer objects to be deleted.
            /// </para>
            /// </param>
            /// <param name="renderbuffers">
            /// <para>
            /// A pointer to an array containing n renderbuffer objects to be deleted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glDeleteRenderbuffersEXT")]
            public static extern unsafe void DeleteRenderbuffers(Int32 n, UInt32* renderbuffers);

            /// <summary>[requires: EXT_texture_object]</summary>
            [AutoGenerated(Category = "EXT_texture_object", Version = "", EntryPoint = "glDeleteTexturesEXT")]
            public static extern void DeleteTexture(Int32 textures);

            /// <summary>[requires: EXT_texture_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_texture_object", Version = "", EntryPoint = "glDeleteTexturesEXT")]
            public static extern void DeleteTexture(UInt32 textures);

            /// <summary>[requires: EXT_texture_object]
            /// Delete named textures
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of textures to be deleted.
            /// </para>
            /// </param>
            /// <param name="textures">
            /// <para>
            /// Specifies an array of textures to be deleted.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_texture_object", Version = "", EntryPoint = "glDeleteTexturesEXT")]
            public static extern void DeleteTextures(Int32 n, Int32[] textures);

            /// <summary>[requires: EXT_texture_object]
            /// Delete named textures
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of textures to be deleted.
            /// </para>
            /// </param>
            /// <param name="textures">
            /// <para>
            /// Specifies an array of textures to be deleted.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_texture_object", Version = "", EntryPoint = "glDeleteTexturesEXT")]
            public static extern void DeleteTextures(Int32 n, ref Int32 textures);

            /// <summary>[requires: EXT_texture_object]
            /// Delete named textures
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of textures to be deleted.
            /// </para>
            /// </param>
            /// <param name="textures">
            /// <para>
            /// Specifies an array of textures to be deleted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_texture_object", Version = "", EntryPoint = "glDeleteTexturesEXT")]
            public static extern unsafe void DeleteTextures(Int32 n, Int32* textures);

            /// <summary>[requires: EXT_texture_object]
            /// Delete named textures
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of textures to be deleted.
            /// </para>
            /// </param>
            /// <param name="textures">
            /// <para>
            /// Specifies an array of textures to be deleted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_texture_object", Version = "", EntryPoint = "glDeleteTexturesEXT")]
            public static extern void DeleteTextures(Int32 n, UInt32[] textures);

            /// <summary>[requires: EXT_texture_object]
            /// Delete named textures
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of textures to be deleted.
            /// </para>
            /// </param>
            /// <param name="textures">
            /// <para>
            /// Specifies an array of textures to be deleted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_texture_object", Version = "", EntryPoint = "glDeleteTexturesEXT")]
            public static extern void DeleteTextures(Int32 n, ref UInt32 textures);

            /// <summary>[requires: EXT_texture_object]
            /// Delete named textures
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of textures to be deleted.
            /// </para>
            /// </param>
            /// <param name="textures">
            /// <para>
            /// Specifies an array of textures to be deleted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_texture_object", Version = "", EntryPoint = "glDeleteTexturesEXT")]
            public static extern unsafe void DeleteTextures(Int32 n, UInt32* textures);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glDeleteVertexShaderEXT")]
            public static extern void DeleteVertexShader(Int32 id);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glDeleteVertexShaderEXT")]
            public static extern void DeleteVertexShader(UInt32 id);

            /// <summary>[requires: EXT_depth_bounds_test]</summary>
            [AutoGenerated(Category = "EXT_depth_bounds_test", Version = "", EntryPoint = "glDepthBoundsEXT")]
            public static extern void DepthBounds(Double zmin, Double zmax);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glDisableClientStateiEXT")]
            public static extern void DisableClientState(OpenTK.Graphics.OpenGL.ArrayCap array, Int32 index);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glDisableClientStateiEXT")]
            public static extern void DisableClientState(OpenTK.Graphics.OpenGL.ArrayCap array, UInt32 index);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glDisableClientStateIndexedEXT")]
            public static extern void DisableClientStateIndexed(OpenTK.Graphics.OpenGL.ArrayCap array, Int32 index);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glDisableClientStateIndexedEXT")]
            public static extern void DisableClientStateIndexed(OpenTK.Graphics.OpenGL.ArrayCap array, UInt32 index);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use ArrayCap overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glDisableClientStateIndexedEXT")]
            public static extern void DisableClientStateIndexed(OpenTK.Graphics.OpenGL.EnableCap array, Int32 index);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use ArrayCap overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glDisableClientStateIndexedEXT")]
            public static extern void DisableClientStateIndexed(OpenTK.Graphics.OpenGL.EnableCap array, UInt32 index);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [Obsolete("Use IndexedEnableCap overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glDisableIndexedEXT")]
            public static extern void DisableIndexed(OpenTK.Graphics.OpenGL.ExtDrawBuffers2 target, Int32 index);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [Obsolete("Use IndexedEnableCap overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glDisableIndexedEXT")]
            public static extern void DisableIndexed(OpenTK.Graphics.OpenGL.ExtDrawBuffers2 target, UInt32 index);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glDisableIndexedEXT")]
            public static extern void DisableIndexed(OpenTK.Graphics.OpenGL.IndexedEnableCap target, Int32 index);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glDisableIndexedEXT")]
            public static extern void DisableIndexed(OpenTK.Graphics.OpenGL.IndexedEnableCap target, UInt32 index);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glDisableVariantClientStateEXT")]
            public static extern void DisableVariantClientState(Int32 id);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glDisableVariantClientStateEXT")]
            public static extern void DisableVariantClientState(UInt32 id);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glDisableVertexArrayAttribEXT")]
            public static extern void DisableVertexArrayAttrib(Int32 vaobj, Int32 index);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glDisableVertexArrayAttribEXT")]
            public static extern void DisableVertexArrayAttrib(UInt32 vaobj, UInt32 index);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glDisableVertexArrayEXT")]
            public static extern void DisableVertexArray(Int32 vaobj, OpenTK.Graphics.OpenGL.EnableCap array);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glDisableVertexArrayEXT")]
            public static extern void DisableVertexArray(UInt32 vaobj, OpenTK.Graphics.OpenGL.EnableCap array);

            /// <summary>[requires: EXT_vertex_array]
            /// Render primitives from array data
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="first">
            /// <para>
            /// Specifies the starting index in the enabled arrays.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of indices to be rendered.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glDrawArraysEXT")]
            public static extern void DrawArrays(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 first, Int32 count);

            /// <summary>[requires: EXT_vertex_array]
            /// Render primitives from array data
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="first">
            /// <para>
            /// Specifies the starting index in the enabled arrays.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of indices to be rendered.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glDrawArraysEXT")]
            public static extern void DrawArrays(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 first, Int32 count);

            /// <summary>[requires: EXT_draw_instanced]
            /// Draw multiple instances of a range of elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="first">
            /// <para>
            /// Specifies the starting index in the enabled arrays.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of indices to be rendered.
            /// </para>
            /// </param>
            /// <param name="primcount">
            /// <para>
            /// Specifies the number of instances of the specified range of indices to be rendered.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "EXT_draw_instanced", Version = "", EntryPoint = "glDrawArraysInstancedEXT")]
            public static extern void DrawArraysInstanced(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 start, Int32 count, Int32 primcount);

            /// <summary>[requires: EXT_draw_instanced]
            /// Draw multiple instances of a range of elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES GL_LINES_ADJACENCY, GL_LINE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, GL_TRIANGLE_STRIP_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="first">
            /// <para>
            /// Specifies the starting index in the enabled arrays.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of indices to be rendered.
            /// </para>
            /// </param>
            /// <param name="primcount">
            /// <para>
            /// Specifies the number of instances of the specified range of indices to be rendered.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_draw_instanced", Version = "", EntryPoint = "glDrawArraysInstancedEXT")]
            public static extern void DrawArraysInstanced(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 start, Int32 count, Int32 primcount);

            /// <summary>[requires: EXT_draw_instanced]
            /// Draw multiple instances of a set of elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="primcount">
            /// <para>
            /// Specifies the number of instances of the specified range of indices to be rendered.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "EXT_draw_instanced", Version = "", EntryPoint = "glDrawElementsInstancedEXT")]
            public static extern void DrawElementsInstanced(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 primcount);

            /// <summary>[requires: EXT_draw_instanced]
            /// Draw multiple instances of a set of elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="primcount">
            /// <para>
            /// Specifies the number of instances of the specified range of indices to be rendered.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "EXT_draw_instanced", Version = "", EntryPoint = "glDrawElementsInstancedEXT")]
            public static extern void DrawElementsInstanced<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_draw_instanced]
            /// Draw multiple instances of a set of elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="primcount">
            /// <para>
            /// Specifies the number of instances of the specified range of indices to be rendered.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "EXT_draw_instanced", Version = "", EntryPoint = "glDrawElementsInstancedEXT")]
            public static extern void DrawElementsInstanced<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_draw_instanced]
            /// Draw multiple instances of a set of elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="primcount">
            /// <para>
            /// Specifies the number of instances of the specified range of indices to be rendered.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "EXT_draw_instanced", Version = "", EntryPoint = "glDrawElementsInstancedEXT")]
            public static extern void DrawElementsInstanced<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_draw_instanced]
            /// Draw multiple instances of a set of elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="primcount">
            /// <para>
            /// Specifies the number of instances of the specified range of indices to be rendered.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "EXT_draw_instanced", Version = "", EntryPoint = "glDrawElementsInstancedEXT")]
            public static extern void DrawElementsInstanced<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_draw_instanced]
            /// Draw multiple instances of a set of elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="primcount">
            /// <para>
            /// Specifies the number of instances of the specified range of indices to be rendered.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_draw_instanced", Version = "", EntryPoint = "glDrawElementsInstancedEXT")]
            public static extern void DrawElementsInstanced(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 primcount);

            /// <summary>[requires: EXT_draw_instanced]
            /// Draw multiple instances of a set of elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="primcount">
            /// <para>
            /// Specifies the number of instances of the specified range of indices to be rendered.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_draw_instanced", Version = "", EntryPoint = "glDrawElementsInstancedEXT")]
            public static extern void DrawElementsInstanced<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_draw_instanced]
            /// Draw multiple instances of a set of elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="primcount">
            /// <para>
            /// Specifies the number of instances of the specified range of indices to be rendered.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_draw_instanced", Version = "", EntryPoint = "glDrawElementsInstancedEXT")]
            public static extern void DrawElementsInstanced<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_draw_instanced]
            /// Draw multiple instances of a set of elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="primcount">
            /// <para>
            /// Specifies the number of instances of the specified range of indices to be rendered.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_draw_instanced", Version = "", EntryPoint = "glDrawElementsInstancedEXT")]
            public static extern void DrawElementsInstanced<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_draw_instanced]
            /// Draw multiple instances of a set of elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="primcount">
            /// <para>
            /// Specifies the number of instances of the specified range of indices to be rendered.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_draw_instanced", Version = "", EntryPoint = "glDrawElementsInstancedEXT")]
            public static extern void DrawElementsInstanced<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_draw_range_elements]
            /// Render primitives from array data
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="start">
            /// <para>
            /// Specifies the minimum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="end">
            /// <para>
            /// Specifies the maximum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "EXT_draw_range_elements", Version = "", EntryPoint = "glDrawRangeElementsEXT")]
            public static extern void DrawRangeElements(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 start, Int32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices);

            /// <summary>[requires: EXT_draw_range_elements]
            /// Render primitives from array data
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="start">
            /// <para>
            /// Specifies the minimum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="end">
            /// <para>
            /// Specifies the maximum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "EXT_draw_range_elements", Version = "", EntryPoint = "glDrawRangeElementsEXT")]
            public static extern void DrawRangeElements<T5>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 start, Int32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[] indices)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_draw_range_elements]
            /// Render primitives from array data
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="start">
            /// <para>
            /// Specifies the minimum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="end">
            /// <para>
            /// Specifies the maximum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "EXT_draw_range_elements", Version = "", EntryPoint = "glDrawRangeElementsEXT")]
            public static extern void DrawRangeElements<T5>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 start, Int32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[,] indices)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_draw_range_elements]
            /// Render primitives from array data
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="start">
            /// <para>
            /// Specifies the minimum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="end">
            /// <para>
            /// Specifies the maximum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "EXT_draw_range_elements", Version = "", EntryPoint = "glDrawRangeElementsEXT")]
            public static extern void DrawRangeElements<T5>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 start, Int32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[,,] indices)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_draw_range_elements]
            /// Render primitives from array data
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="start">
            /// <para>
            /// Specifies the minimum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="end">
            /// <para>
            /// Specifies the maximum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "EXT_draw_range_elements", Version = "", EntryPoint = "glDrawRangeElementsEXT")]
            public static extern void DrawRangeElements<T5>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 start, Int32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T5 indices)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_draw_range_elements]
            /// Render primitives from array data
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="start">
            /// <para>
            /// Specifies the minimum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="end">
            /// <para>
            /// Specifies the maximum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_draw_range_elements", Version = "", EntryPoint = "glDrawRangeElementsEXT")]
            public static extern void DrawRangeElements(OpenTK.Graphics.OpenGL.BeginMode mode, UInt32 start, UInt32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices);

            /// <summary>[requires: EXT_draw_range_elements]
            /// Render primitives from array data
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="start">
            /// <para>
            /// Specifies the minimum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="end">
            /// <para>
            /// Specifies the maximum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_draw_range_elements", Version = "", EntryPoint = "glDrawRangeElementsEXT")]
            public static extern void DrawRangeElements<T5>(OpenTK.Graphics.OpenGL.BeginMode mode, UInt32 start, UInt32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[] indices)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_draw_range_elements]
            /// Render primitives from array data
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="start">
            /// <para>
            /// Specifies the minimum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="end">
            /// <para>
            /// Specifies the maximum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_draw_range_elements", Version = "", EntryPoint = "glDrawRangeElementsEXT")]
            public static extern void DrawRangeElements<T5>(OpenTK.Graphics.OpenGL.BeginMode mode, UInt32 start, UInt32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[,] indices)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_draw_range_elements]
            /// Render primitives from array data
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="start">
            /// <para>
            /// Specifies the minimum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="end">
            /// <para>
            /// Specifies the maximum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_draw_range_elements", Version = "", EntryPoint = "glDrawRangeElementsEXT")]
            public static extern void DrawRangeElements<T5>(OpenTK.Graphics.OpenGL.BeginMode mode, UInt32 start, UInt32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[,,] indices)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_draw_range_elements]
            /// Render primitives from array data
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="start">
            /// <para>
            /// Specifies the minimum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="end">
            /// <para>
            /// Specifies the maximum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_draw_range_elements", Version = "", EntryPoint = "glDrawRangeElementsEXT")]
            public static extern void DrawRangeElements<T5>(OpenTK.Graphics.OpenGL.BeginMode mode, UInt32 start, UInt32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T5 indices)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_draw_range_elements]
            /// Render primitives from array data
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="start">
            /// <para>
            /// Specifies the minimum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="end">
            /// <para>
            /// Specifies the maximum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_draw_range_elements", Version = "", EntryPoint = "glDrawRangeElementsEXT")]
            public static extern void DrawRangeElements(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 start, Int32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices);

            /// <summary>[requires: EXT_draw_range_elements]
            /// Render primitives from array data
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="start">
            /// <para>
            /// Specifies the minimum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="end">
            /// <para>
            /// Specifies the maximum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_draw_range_elements", Version = "", EntryPoint = "glDrawRangeElementsEXT")]
            public static extern void DrawRangeElements<T5>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 start, Int32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[] indices)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_draw_range_elements]
            /// Render primitives from array data
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="start">
            /// <para>
            /// Specifies the minimum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="end">
            /// <para>
            /// Specifies the maximum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_draw_range_elements", Version = "", EntryPoint = "glDrawRangeElementsEXT")]
            public static extern void DrawRangeElements<T5>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 start, Int32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[,] indices)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_draw_range_elements]
            /// Render primitives from array data
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="start">
            /// <para>
            /// Specifies the minimum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="end">
            /// <para>
            /// Specifies the maximum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_draw_range_elements", Version = "", EntryPoint = "glDrawRangeElementsEXT")]
            public static extern void DrawRangeElements<T5>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 start, Int32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[,,] indices)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_draw_range_elements]
            /// Render primitives from array data
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="start">
            /// <para>
            /// Specifies the minimum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="end">
            /// <para>
            /// Specifies the maximum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_draw_range_elements", Version = "", EntryPoint = "glDrawRangeElementsEXT")]
            public static extern void DrawRangeElements<T5>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 start, Int32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T5 indices)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_draw_range_elements]
            /// Render primitives from array data
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="start">
            /// <para>
            /// Specifies the minimum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="end">
            /// <para>
            /// Specifies the maximum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_draw_range_elements", Version = "", EntryPoint = "glDrawRangeElementsEXT")]
            public static extern void DrawRangeElements(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 start, UInt32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices);

            /// <summary>[requires: EXT_draw_range_elements]
            /// Render primitives from array data
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="start">
            /// <para>
            /// Specifies the minimum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="end">
            /// <para>
            /// Specifies the maximum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_draw_range_elements", Version = "", EntryPoint = "glDrawRangeElementsEXT")]
            public static extern void DrawRangeElements<T5>(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 start, UInt32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[] indices)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_draw_range_elements]
            /// Render primitives from array data
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="start">
            /// <para>
            /// Specifies the minimum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="end">
            /// <para>
            /// Specifies the maximum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_draw_range_elements", Version = "", EntryPoint = "glDrawRangeElementsEXT")]
            public static extern void DrawRangeElements<T5>(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 start, UInt32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[,] indices)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_draw_range_elements]
            /// Render primitives from array data
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="start">
            /// <para>
            /// Specifies the minimum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="end">
            /// <para>
            /// Specifies the maximum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_draw_range_elements", Version = "", EntryPoint = "glDrawRangeElementsEXT")]
            public static extern void DrawRangeElements<T5>(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 start, UInt32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T5[,,] indices)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_draw_range_elements]
            /// Render primitives from array data
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="start">
            /// <para>
            /// Specifies the minimum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="end">
            /// <para>
            /// Specifies the maximum array index contained in indices.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Specifies the number of elements to be rendered.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_draw_range_elements", Version = "", EntryPoint = "glDrawRangeElementsEXT")]
            public static extern void DrawRangeElements<T5>(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 start, UInt32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T5 indices)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_vertex_array]
            /// Define an array of edge flags
            /// </summary>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive edge flags. If stride is 0, the edge flags are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first edge flag in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glEdgeFlagPointerEXT")]
            public static extern void EdgeFlagPointer(Int32 stride, Int32 count, bool[] pointer);

            /// <summary>[requires: EXT_vertex_array]
            /// Define an array of edge flags
            /// </summary>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive edge flags. If stride is 0, the edge flags are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first edge flag in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glEdgeFlagPointerEXT")]
            public static extern void EdgeFlagPointer(Int32 stride, Int32 count, ref bool pointer);

            /// <summary>[requires: EXT_vertex_array]
            /// Define an array of edge flags
            /// </summary>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive edge flags. If stride is 0, the edge flags are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first edge flag in the array. The initial value is 0.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glEdgeFlagPointerEXT")]
            public static extern unsafe void EdgeFlagPointer(Int32 stride, Int32 count, bool* pointer);

            /// <summary>[requires: EXT_direct_state_access]
            /// Enable or disable client-side capability
            /// </summary>
            /// <param name="cap">
            /// <para>
            /// Specifies the capability to enable. Symbolic constants GL_COLOR_ARRAY, GL_EDGE_FLAG_ARRAY, GL_FOG_COORD_ARRAY, GL_INDEX_ARRAY, GL_NORMAL_ARRAY, GL_SECONDARY_COLOR_ARRAY, GL_TEXTURE_COORD_ARRAY, and GL_VERTEX_ARRAY are accepted.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glEnableClientStateiEXT")]
            public static extern void EnableClientState(OpenTK.Graphics.OpenGL.ArrayCap array, Int32 index);

            /// <summary>[requires: EXT_direct_state_access]
            /// Enable or disable client-side capability
            /// </summary>
            /// <param name="cap">
            /// <para>
            /// Specifies the capability to enable. Symbolic constants GL_COLOR_ARRAY, GL_EDGE_FLAG_ARRAY, GL_FOG_COORD_ARRAY, GL_INDEX_ARRAY, GL_NORMAL_ARRAY, GL_SECONDARY_COLOR_ARRAY, GL_TEXTURE_COORD_ARRAY, and GL_VERTEX_ARRAY are accepted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glEnableClientStateiEXT")]
            public static extern void EnableClientState(OpenTK.Graphics.OpenGL.ArrayCap array, UInt32 index);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glEnableClientStateIndexedEXT")]
            public static extern void EnableClientStateIndexed(OpenTK.Graphics.OpenGL.ArrayCap array, Int32 index);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glEnableClientStateIndexedEXT")]
            public static extern void EnableClientStateIndexed(OpenTK.Graphics.OpenGL.ArrayCap array, UInt32 index);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use ArrayCap overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glEnableClientStateIndexedEXT")]
            public static extern void EnableClientStateIndexed(OpenTK.Graphics.OpenGL.EnableCap array, Int32 index);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use ArrayCap overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glEnableClientStateIndexedEXT")]
            public static extern void EnableClientStateIndexed(OpenTK.Graphics.OpenGL.EnableCap array, UInt32 index);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [Obsolete("Use IndexedEnableCap overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glEnableIndexedEXT")]
            public static extern void EnableIndexed(OpenTK.Graphics.OpenGL.ExtDrawBuffers2 target, Int32 index);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [Obsolete("Use IndexedEnableCap overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glEnableIndexedEXT")]
            public static extern void EnableIndexed(OpenTK.Graphics.OpenGL.ExtDrawBuffers2 target, UInt32 index);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glEnableIndexedEXT")]
            public static extern void EnableIndexed(OpenTK.Graphics.OpenGL.IndexedEnableCap target, Int32 index);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glEnableIndexedEXT")]
            public static extern void EnableIndexed(OpenTK.Graphics.OpenGL.IndexedEnableCap target, UInt32 index);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glEnableVariantClientStateEXT")]
            public static extern void EnableVariantClientState(Int32 id);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glEnableVariantClientStateEXT")]
            public static extern void EnableVariantClientState(UInt32 id);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glEnableVertexArrayAttribEXT")]
            public static extern void EnableVertexArrayAttrib(Int32 vaobj, Int32 index);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glEnableVertexArrayAttribEXT")]
            public static extern void EnableVertexArrayAttrib(UInt32 vaobj, UInt32 index);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glEnableVertexArrayEXT")]
            public static extern void EnableVertexArray(Int32 vaobj, OpenTK.Graphics.OpenGL.EnableCap array);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glEnableVertexArrayEXT")]
            public static extern void EnableVertexArray(UInt32 vaobj, OpenTK.Graphics.OpenGL.EnableCap array);

            /// <summary>[requires: EXT_transform_feedback]</summary>
            [AutoGenerated(Category = "EXT_transform_feedback", Version = "", EntryPoint = "glEndTransformFeedbackEXT")]
            public static extern void EndTransformFeedback();

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glEndVertexShaderEXT")]
            public static extern void EndVertexShader();

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glExtractComponentEXT")]
            public static extern void ExtractComponent(Int32 res, Int32 src, Int32 num);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glExtractComponentEXT")]
            public static extern void ExtractComponent(UInt32 res, UInt32 src, UInt32 num);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glFlushMappedNamedBufferRangeEXT")]
            public static extern void FlushMappedNamedBufferRange(Int32 buffer, IntPtr offset, IntPtr length);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glFlushMappedNamedBufferRangeEXT")]
            public static extern void FlushMappedNamedBufferRange(UInt32 buffer, IntPtr offset, IntPtr length);

            /// <summary>[requires: EXT_fog_coord]
            /// Set the current fog coordinates
            /// </summary>
            /// <param name="coord">
            /// <para>
            /// Specify the fog distance.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_fog_coord", Version = "", EntryPoint = "glFogCoorddEXT")]
            public static extern void FogCoord(Double coord);

            /// <summary>[requires: EXT_fog_coord]
            /// Set the current fog coordinates
            /// </summary>
            /// <param name="coord">
            /// <para>
            /// Specify the fog distance.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_fog_coord", Version = "", EntryPoint = "glFogCoorddvEXT")]
            public static extern unsafe void FogCoord(Double* coord);

            /// <summary>[requires: EXT_fog_coord]
            /// Set the current fog coordinates
            /// </summary>
            /// <param name="coord">
            /// <para>
            /// Specify the fog distance.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_fog_coord", Version = "", EntryPoint = "glFogCoordfEXT")]
            public static extern void FogCoord(Single coord);

            /// <summary>[requires: EXT_fog_coord]
            /// Set the current fog coordinates
            /// </summary>
            /// <param name="coord">
            /// <para>
            /// Specify the fog distance.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_fog_coord", Version = "", EntryPoint = "glFogCoordfvEXT")]
            public static extern unsafe void FogCoord(Single* coord);

            /// <summary>[requires: EXT_fog_coord]
            /// Define an array of fog coordinates
            /// </summary>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each fog coordinate. Symbolic constants GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive fog coordinates. If stride is 0, the array elements are understood to be tightly packed. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first coordinate of the first fog coordinate in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_fog_coord", Version = "", EntryPoint = "glFogCoordPointerEXT")]
            public static extern void FogCoordPointer(OpenTK.Graphics.OpenGL.ExtFogCoord type, Int32 stride, IntPtr pointer);

            /// <summary>[requires: EXT_fog_coord]
            /// Define an array of fog coordinates
            /// </summary>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each fog coordinate. Symbolic constants GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive fog coordinates. If stride is 0, the array elements are understood to be tightly packed. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first coordinate of the first fog coordinate in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_fog_coord", Version = "", EntryPoint = "glFogCoordPointerEXT")]
            public static extern void FogCoordPointer<T2>(OpenTK.Graphics.OpenGL.ExtFogCoord type, Int32 stride, [InAttribute, OutAttribute] T2[] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_fog_coord]
            /// Define an array of fog coordinates
            /// </summary>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each fog coordinate. Symbolic constants GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive fog coordinates. If stride is 0, the array elements are understood to be tightly packed. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first coordinate of the first fog coordinate in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_fog_coord", Version = "", EntryPoint = "glFogCoordPointerEXT")]
            public static extern void FogCoordPointer<T2>(OpenTK.Graphics.OpenGL.ExtFogCoord type, Int32 stride, [InAttribute, OutAttribute] T2[,] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_fog_coord]
            /// Define an array of fog coordinates
            /// </summary>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each fog coordinate. Symbolic constants GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive fog coordinates. If stride is 0, the array elements are understood to be tightly packed. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first coordinate of the first fog coordinate in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_fog_coord", Version = "", EntryPoint = "glFogCoordPointerEXT")]
            public static extern void FogCoordPointer<T2>(OpenTK.Graphics.OpenGL.ExtFogCoord type, Int32 stride, [InAttribute, OutAttribute] T2[,,] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_fog_coord]
            /// Define an array of fog coordinates
            /// </summary>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each fog coordinate. Symbolic constants GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive fog coordinates. If stride is 0, the array elements are understood to be tightly packed. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first coordinate of the first fog coordinate in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_fog_coord", Version = "", EntryPoint = "glFogCoordPointerEXT")]
            public static extern void FogCoordPointer<T2>(OpenTK.Graphics.OpenGL.ExtFogCoord type, Int32 stride, [InAttribute, OutAttribute] ref T2 pointer)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glFramebufferDrawBufferEXT")]
            public static extern void FramebufferDrawBuffer(Int32 framebuffer, OpenTK.Graphics.OpenGL.DrawBufferMode mode);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glFramebufferDrawBufferEXT")]
            public static extern void FramebufferDrawBuffer(UInt32 framebuffer, OpenTK.Graphics.OpenGL.DrawBufferMode mode);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glFramebufferDrawBuffersEXT")]
            public static extern void FramebufferDrawBuffers(Int32 framebuffer, Int32 n, OpenTK.Graphics.OpenGL.DrawBufferMode[] bufs);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glFramebufferDrawBuffersEXT")]
            public static extern void FramebufferDrawBuffers(Int32 framebuffer, Int32 n, ref OpenTK.Graphics.OpenGL.DrawBufferMode bufs);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glFramebufferDrawBuffersEXT")]
            public static extern unsafe void FramebufferDrawBuffers(Int32 framebuffer, Int32 n, OpenTK.Graphics.OpenGL.DrawBufferMode* bufs);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glFramebufferDrawBuffersEXT")]
            public static extern void FramebufferDrawBuffers(UInt32 framebuffer, Int32 n, OpenTK.Graphics.OpenGL.DrawBufferMode[] bufs);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glFramebufferDrawBuffersEXT")]
            public static extern void FramebufferDrawBuffers(UInt32 framebuffer, Int32 n, ref OpenTK.Graphics.OpenGL.DrawBufferMode bufs);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glFramebufferDrawBuffersEXT")]
            public static extern unsafe void FramebufferDrawBuffers(UInt32 framebuffer, Int32 n, OpenTK.Graphics.OpenGL.DrawBufferMode* bufs);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glFramebufferReadBufferEXT")]
            public static extern void FramebufferReadBuffer(Int32 framebuffer, OpenTK.Graphics.OpenGL.ReadBufferMode mode);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glFramebufferReadBufferEXT")]
            public static extern void FramebufferReadBuffer(UInt32 framebuffer, OpenTK.Graphics.OpenGL.ReadBufferMode mode);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Attach a renderbuffer as a logical buffer to the currently bound framebuffer object
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the framebuffer target. target must be GL_DRAW_FRAMEBUFFER, GL_READ_FRAMEBUFFER, or GL_FRAMEBUFFER. GL_FRAMEBUFFER is equivalent to GL_DRAW_FRAMEBUFFER.
            /// </para>
            /// </param>
            /// <param name="attachment">
            /// <para>
            /// Specifies the attachment point of the framebuffer.
            /// </para>
            /// </param>
            /// <param name="renderbuffertarget">
            /// <para>
            /// Specifies the renderbuffer target and must be GL_RENDERBUFFER.
            /// </para>
            /// </param>
            /// <param name="renderbuffer">
            /// <para>
            /// Specifies the name of an existing renderbuffer object of type renderbuffertarget to attach.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glFramebufferRenderbufferEXT")]
            public static extern void FramebufferRenderbuffer(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.RenderbufferTarget renderbuffertarget, Int32 renderbuffer);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Attach a renderbuffer as a logical buffer to the currently bound framebuffer object
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the framebuffer target. target must be GL_DRAW_FRAMEBUFFER, GL_READ_FRAMEBUFFER, or GL_FRAMEBUFFER. GL_FRAMEBUFFER is equivalent to GL_DRAW_FRAMEBUFFER.
            /// </para>
            /// </param>
            /// <param name="attachment">
            /// <para>
            /// Specifies the attachment point of the framebuffer.
            /// </para>
            /// </param>
            /// <param name="renderbuffertarget">
            /// <para>
            /// Specifies the renderbuffer target and must be GL_RENDERBUFFER.
            /// </para>
            /// </param>
            /// <param name="renderbuffer">
            /// <para>
            /// Specifies the name of an existing renderbuffer object of type renderbuffertarget to attach.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glFramebufferRenderbufferEXT")]
            public static extern void FramebufferRenderbuffer(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.RenderbufferTarget renderbuffertarget, UInt32 renderbuffer);

            /// <summary>[requires: EXT_framebuffer_object]</summary>
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glFramebufferTexture1DEXT")]
            public static extern void FramebufferTexture1D(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.TextureTarget textarget, Int32 texture, Int32 level);

            /// <summary>[requires: EXT_framebuffer_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glFramebufferTexture1DEXT")]
            public static extern void FramebufferTexture1D(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.TextureTarget textarget, UInt32 texture, Int32 level);

            /// <summary>[requires: EXT_framebuffer_object]</summary>
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glFramebufferTexture2DEXT")]
            public static extern void FramebufferTexture2D(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.TextureTarget textarget, Int32 texture, Int32 level);

            /// <summary>[requires: EXT_framebuffer_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glFramebufferTexture2DEXT")]
            public static extern void FramebufferTexture2D(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.TextureTarget textarget, UInt32 texture, Int32 level);

            /// <summary>[requires: EXT_framebuffer_object]</summary>
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glFramebufferTexture3DEXT")]
            public static extern void FramebufferTexture3D(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.TextureTarget textarget, Int32 texture, Int32 level, Int32 zoffset);

            /// <summary>[requires: EXT_framebuffer_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glFramebufferTexture3DEXT")]
            public static extern void FramebufferTexture3D(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.TextureTarget textarget, UInt32 texture, Int32 level, Int32 zoffset);

            /// <summary>[requires: NV_geometry_program4]
            /// Attach a level of a texture object as a logical buffer to the currently bound framebuffer object
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the framebuffer target. target must be GL_DRAW_FRAMEBUFFER, GL_READ_FRAMEBUFFER, or GL_FRAMEBUFFER. GL_FRAMEBUFFER is equivalent to GL_DRAW_FRAMEBUFFER.
            /// </para>
            /// </param>
            /// <param name="attachment">
            /// <para>
            /// Specifies the attachment point of the framebuffer. attachment must be GL_COLOR_ATTACHMENTi, GL_DEPTH_ATTACHMENT, GL_STENCIL_ATTACHMENT or GL_DEPTH_STENCIL_ATTACHMENT.
            /// </para>
            /// </param>
            /// <param name="textarget">
            /// <para>
            /// For glFramebufferTexture1D, glFramebufferTexture2D and glFramebufferTexture3D, specifies what type of texture is expected in the texture parameter, or for cube map textures, which face is to be attached.
            /// </para>
            /// </param>
            /// <param name="texture">
            /// <para>
            /// Specifies the texture object to attach to the framebuffer attachment point named by attachment.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the mipmap level of texture to attach.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_geometry_program4", Version = "", EntryPoint = "glFramebufferTextureEXT")]
            public static extern void FramebufferTexture(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, Int32 texture, Int32 level);

            /// <summary>[requires: NV_geometry_program4]
            /// Attach a level of a texture object as a logical buffer to the currently bound framebuffer object
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the framebuffer target. target must be GL_DRAW_FRAMEBUFFER, GL_READ_FRAMEBUFFER, or GL_FRAMEBUFFER. GL_FRAMEBUFFER is equivalent to GL_DRAW_FRAMEBUFFER.
            /// </para>
            /// </param>
            /// <param name="attachment">
            /// <para>
            /// Specifies the attachment point of the framebuffer. attachment must be GL_COLOR_ATTACHMENTi, GL_DEPTH_ATTACHMENT, GL_STENCIL_ATTACHMENT or GL_DEPTH_STENCIL_ATTACHMENT.
            /// </para>
            /// </param>
            /// <param name="textarget">
            /// <para>
            /// For glFramebufferTexture1D, glFramebufferTexture2D and glFramebufferTexture3D, specifies what type of texture is expected in the texture parameter, or for cube map textures, which face is to be attached.
            /// </para>
            /// </param>
            /// <param name="texture">
            /// <para>
            /// Specifies the texture object to attach to the framebuffer attachment point named by attachment.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the mipmap level of texture to attach.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_geometry_program4", Version = "", EntryPoint = "glFramebufferTextureEXT")]
            public static extern void FramebufferTexture(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, UInt32 texture, Int32 level);

            /// <summary>[requires: NV_geometry_program4]
            /// Attach a face of a cube map texture as a logical buffer to the currently bound framebuffer
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the framebuffer target. target must be GL_DRAW_FRAMEBUFFER, GL_READ_FRAMEBUFFER, or GL_FRAMEBUFFER. GL_FRAMEBUFFER is equivalent to GL_DRAW_FRAMEBUFFER.
            /// </para>
            /// </param>
            /// <param name="attachment">
            /// <para>
            /// Specifies the attachment point of the framebuffer. attachment must be GL_COLOR_ATTACHMENTi, GL_DEPTH_ATTACHMENT, GL_STENCIL_ATTACHMENT or GL_DEPTH_STENCIL_ATTACHMMENT.
            /// </para>
            /// </param>
            /// <param name="texture">
            /// <para>
            /// Specifies the texture object to attach to the framebuffer attachment point named by attachment. texture must be the name of an existing cube-map texture.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the mipmap level of texture to attach.
            /// </para>
            /// </param>
            /// <param name="face">
            /// <para>
            /// Specifies the face of texture to attach.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_geometry_program4", Version = "", EntryPoint = "glFramebufferTextureFaceEXT")]
            public static extern void FramebufferTextureFace(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, Int32 texture, Int32 level, OpenTK.Graphics.OpenGL.TextureTarget face);

            /// <summary>[requires: NV_geometry_program4]
            /// Attach a face of a cube map texture as a logical buffer to the currently bound framebuffer
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the framebuffer target. target must be GL_DRAW_FRAMEBUFFER, GL_READ_FRAMEBUFFER, or GL_FRAMEBUFFER. GL_FRAMEBUFFER is equivalent to GL_DRAW_FRAMEBUFFER.
            /// </para>
            /// </param>
            /// <param name="attachment">
            /// <para>
            /// Specifies the attachment point of the framebuffer. attachment must be GL_COLOR_ATTACHMENTi, GL_DEPTH_ATTACHMENT, GL_STENCIL_ATTACHMENT or GL_DEPTH_STENCIL_ATTACHMMENT.
            /// </para>
            /// </param>
            /// <param name="texture">
            /// <para>
            /// Specifies the texture object to attach to the framebuffer attachment point named by attachment. texture must be the name of an existing cube-map texture.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the mipmap level of texture to attach.
            /// </para>
            /// </param>
            /// <param name="face">
            /// <para>
            /// Specifies the face of texture to attach.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_geometry_program4", Version = "", EntryPoint = "glFramebufferTextureFaceEXT")]
            public static extern void FramebufferTextureFace(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, UInt32 texture, Int32 level, OpenTK.Graphics.OpenGL.TextureTarget face);

            /// <summary>[requires: NV_geometry_program4]
            /// Attach a single layer of a texture to a framebuffer
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the framebuffer target. target must be GL_DRAW_FRAMEBUFFER, GL_READ_FRAMEBUFFER, or GL_FRAMEBUFFER. GL_FRAMEBUFFER is equivalent to GL_DRAW_FRAMEBUFFER.
            /// </para>
            /// </param>
            /// <param name="attachment">
            /// <para>
            /// Specifies the attachment point of the framebuffer. attachment must be GL_COLOR_ATTACHMENTi, GL_DEPTH_ATTACHMENT, GL_STENCIL_ATTACHMENT or GL_DEPTH_STENCIL_ATTACHMENT.
            /// </para>
            /// </param>
            /// <param name="texture">
            /// <para>
            /// Specifies the texture object to attach to the framebuffer attachment point named by attachment.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the mipmap level of texture to attach.
            /// </para>
            /// </param>
            /// <param name="layer">
            /// <para>
            /// Specifies the layer of texture to attach.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_geometry_program4", Version = "", EntryPoint = "glFramebufferTextureLayerEXT")]
            public static extern void FramebufferTextureLayer(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, Int32 texture, Int32 level, Int32 layer);

            /// <summary>[requires: NV_geometry_program4]
            /// Attach a single layer of a texture to a framebuffer
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the framebuffer target. target must be GL_DRAW_FRAMEBUFFER, GL_READ_FRAMEBUFFER, or GL_FRAMEBUFFER. GL_FRAMEBUFFER is equivalent to GL_DRAW_FRAMEBUFFER.
            /// </para>
            /// </param>
            /// <param name="attachment">
            /// <para>
            /// Specifies the attachment point of the framebuffer. attachment must be GL_COLOR_ATTACHMENTi, GL_DEPTH_ATTACHMENT, GL_STENCIL_ATTACHMENT or GL_DEPTH_STENCIL_ATTACHMENT.
            /// </para>
            /// </param>
            /// <param name="texture">
            /// <para>
            /// Specifies the texture object to attach to the framebuffer attachment point named by attachment.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the mipmap level of texture to attach.
            /// </para>
            /// </param>
            /// <param name="layer">
            /// <para>
            /// Specifies the layer of texture to attach.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_geometry_program4", Version = "", EntryPoint = "glFramebufferTextureLayerEXT")]
            public static extern void FramebufferTextureLayer(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, UInt32 texture, Int32 level, Int32 layer);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Generate mipmaps for a specified texture target
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target to which the texture whose mimaps to generate is bound. target must be GL_TEXTURE_1D, GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY or GL_TEXTURE_CUBE_MAP.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glGenerateMipmapEXT")]
            public static extern void GenerateMipmap(OpenTK.Graphics.OpenGL.GenerateMipmapTarget target);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGenerateMultiTexMipmapEXT")]
            public static extern void GenerateMultiTexMipmap(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGenerateTextureMipmapEXT")]
            public static extern void GenerateTextureMipmap(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGenerateTextureMipmapEXT")]
            public static extern void GenerateTextureMipmap(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target);

            /// <summary>[requires: EXT_framebuffer_object]</summary>
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glGenFramebuffersEXT")]
            public static extern Int32 GenFramebuffer();

            /// <summary>[requires: EXT_framebuffer_object]
            /// Generate framebuffer object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of framebuffer object names to generate.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// Specifies an array in which the generated framebuffer object names are stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glGenFramebuffersEXT")]
            public static extern void GenFramebuffers(Int32 n, [OutAttribute] Int32[] framebuffers);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Generate framebuffer object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of framebuffer object names to generate.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// Specifies an array in which the generated framebuffer object names are stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glGenFramebuffersEXT")]
            public static extern void GenFramebuffers(Int32 n, [OutAttribute] out Int32 framebuffers);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Generate framebuffer object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of framebuffer object names to generate.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// Specifies an array in which the generated framebuffer object names are stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glGenFramebuffersEXT")]
            public static extern unsafe void GenFramebuffers(Int32 n, [OutAttribute] Int32* framebuffers);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Generate framebuffer object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of framebuffer object names to generate.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// Specifies an array in which the generated framebuffer object names are stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glGenFramebuffersEXT")]
            public static extern void GenFramebuffers(Int32 n, [OutAttribute] UInt32[] framebuffers);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Generate framebuffer object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of framebuffer object names to generate.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// Specifies an array in which the generated framebuffer object names are stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glGenFramebuffersEXT")]
            public static extern void GenFramebuffers(Int32 n, [OutAttribute] out UInt32 framebuffers);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Generate framebuffer object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of framebuffer object names to generate.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// Specifies an array in which the generated framebuffer object names are stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glGenFramebuffersEXT")]
            public static extern unsafe void GenFramebuffers(Int32 n, [OutAttribute] UInt32* framebuffers);

            /// <summary>[requires: EXT_separate_shader_objects]</summary>
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glGenProgramPipelinesEXT")]
            public static extern Int32 GenProgramPipeline();

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Reserve program pipeline object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of program pipeline object names to reserve.
            /// </para>
            /// </param>
            /// <param name="pipelines">
            /// <para>
            /// Specifies an array of into which the reserved names will be written.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glGenProgramPipelinesEXT")]
            public static extern void GenProgramPipelines(Int32 n, [OutAttribute] Int32[] pipelines);

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Reserve program pipeline object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of program pipeline object names to reserve.
            /// </para>
            /// </param>
            /// <param name="pipelines">
            /// <para>
            /// Specifies an array of into which the reserved names will be written.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glGenProgramPipelinesEXT")]
            public static extern void GenProgramPipelines(Int32 n, [OutAttribute] out Int32 pipelines);

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Reserve program pipeline object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of program pipeline object names to reserve.
            /// </para>
            /// </param>
            /// <param name="pipelines">
            /// <para>
            /// Specifies an array of into which the reserved names will be written.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glGenProgramPipelinesEXT")]
            public static extern unsafe void GenProgramPipelines(Int32 n, [OutAttribute] Int32* pipelines);

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Reserve program pipeline object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of program pipeline object names to reserve.
            /// </para>
            /// </param>
            /// <param name="pipelines">
            /// <para>
            /// Specifies an array of into which the reserved names will be written.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glGenProgramPipelinesEXT")]
            public static extern void GenProgramPipelines(Int32 n, [OutAttribute] UInt32[] pipelines);

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Reserve program pipeline object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of program pipeline object names to reserve.
            /// </para>
            /// </param>
            /// <param name="pipelines">
            /// <para>
            /// Specifies an array of into which the reserved names will be written.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glGenProgramPipelinesEXT")]
            public static extern void GenProgramPipelines(Int32 n, [OutAttribute] out UInt32 pipelines);

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Reserve program pipeline object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of program pipeline object names to reserve.
            /// </para>
            /// </param>
            /// <param name="pipelines">
            /// <para>
            /// Specifies an array of into which the reserved names will be written.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glGenProgramPipelinesEXT")]
            public static extern unsafe void GenProgramPipelines(Int32 n, [OutAttribute] UInt32* pipelines);

            /// <summary>[requires: EXT_framebuffer_object]</summary>
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glGenRenderbuffersEXT")]
            public static extern Int32 GenRenderbuffer();

            /// <summary>[requires: EXT_framebuffer_object]
            /// Generate renderbuffer object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of renderbuffer object names to generate.
            /// </para>
            /// </param>
            /// <param name="renderbuffers">
            /// <para>
            /// Specifies an array in which the generated renderbuffer object names are stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glGenRenderbuffersEXT")]
            public static extern void GenRenderbuffers(Int32 n, [OutAttribute] Int32[] renderbuffers);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Generate renderbuffer object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of renderbuffer object names to generate.
            /// </para>
            /// </param>
            /// <param name="renderbuffers">
            /// <para>
            /// Specifies an array in which the generated renderbuffer object names are stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glGenRenderbuffersEXT")]
            public static extern void GenRenderbuffers(Int32 n, [OutAttribute] out Int32 renderbuffers);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Generate renderbuffer object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of renderbuffer object names to generate.
            /// </para>
            /// </param>
            /// <param name="renderbuffers">
            /// <para>
            /// Specifies an array in which the generated renderbuffer object names are stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glGenRenderbuffersEXT")]
            public static extern unsafe void GenRenderbuffers(Int32 n, [OutAttribute] Int32* renderbuffers);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Generate renderbuffer object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of renderbuffer object names to generate.
            /// </para>
            /// </param>
            /// <param name="renderbuffers">
            /// <para>
            /// Specifies an array in which the generated renderbuffer object names are stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glGenRenderbuffersEXT")]
            public static extern void GenRenderbuffers(Int32 n, [OutAttribute] UInt32[] renderbuffers);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Generate renderbuffer object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of renderbuffer object names to generate.
            /// </para>
            /// </param>
            /// <param name="renderbuffers">
            /// <para>
            /// Specifies an array in which the generated renderbuffer object names are stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glGenRenderbuffersEXT")]
            public static extern void GenRenderbuffers(Int32 n, [OutAttribute] out UInt32 renderbuffers);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Generate renderbuffer object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of renderbuffer object names to generate.
            /// </para>
            /// </param>
            /// <param name="renderbuffers">
            /// <para>
            /// Specifies an array in which the generated renderbuffer object names are stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glGenRenderbuffersEXT")]
            public static extern unsafe void GenRenderbuffers(Int32 n, [OutAttribute] UInt32* renderbuffers);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGenSymbolsEXT")]
            public static extern Int32 GenSymbol(OpenTK.Graphics.OpenGL.ExtVertexShader datatype, OpenTK.Graphics.OpenGL.ExtVertexShader storagetype, OpenTK.Graphics.OpenGL.ExtVertexShader range, Int32 components);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGenSymbolsEXT")]
            public static extern Int32 GenSymbol(OpenTK.Graphics.OpenGL.ExtVertexShader datatype, OpenTK.Graphics.OpenGL.ExtVertexShader storagetype, OpenTK.Graphics.OpenGL.ExtVertexShader range, UInt32 components);

            /// <summary>[requires: EXT_texture_object]</summary>
            [AutoGenerated(Category = "EXT_texture_object", Version = "", EntryPoint = "glGenTexturesEXT")]
            public static extern Int32 GenTexture();

            /// <summary>[requires: EXT_texture_object]
            /// Generate texture names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of texture names to be generated.
            /// </para>
            /// </param>
            /// <param name="textures">
            /// <para>
            /// Specifies an array in which the generated texture names are stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_texture_object", Version = "", EntryPoint = "glGenTexturesEXT")]
            public static extern void GenTextures(Int32 n, [OutAttribute] Int32[] textures);

            /// <summary>[requires: EXT_texture_object]
            /// Generate texture names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of texture names to be generated.
            /// </para>
            /// </param>
            /// <param name="textures">
            /// <para>
            /// Specifies an array in which the generated texture names are stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_texture_object", Version = "", EntryPoint = "glGenTexturesEXT")]
            public static extern void GenTextures(Int32 n, [OutAttribute] out Int32 textures);

            /// <summary>[requires: EXT_texture_object]
            /// Generate texture names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of texture names to be generated.
            /// </para>
            /// </param>
            /// <param name="textures">
            /// <para>
            /// Specifies an array in which the generated texture names are stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_texture_object", Version = "", EntryPoint = "glGenTexturesEXT")]
            public static extern unsafe void GenTextures(Int32 n, [OutAttribute] Int32* textures);

            /// <summary>[requires: EXT_texture_object]
            /// Generate texture names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of texture names to be generated.
            /// </para>
            /// </param>
            /// <param name="textures">
            /// <para>
            /// Specifies an array in which the generated texture names are stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_texture_object", Version = "", EntryPoint = "glGenTexturesEXT")]
            public static extern void GenTextures(Int32 n, [OutAttribute] UInt32[] textures);

            /// <summary>[requires: EXT_texture_object]
            /// Generate texture names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of texture names to be generated.
            /// </para>
            /// </param>
            /// <param name="textures">
            /// <para>
            /// Specifies an array in which the generated texture names are stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_texture_object", Version = "", EntryPoint = "glGenTexturesEXT")]
            public static extern void GenTextures(Int32 n, [OutAttribute] out UInt32 textures);

            /// <summary>[requires: EXT_texture_object]
            /// Generate texture names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of texture names to be generated.
            /// </para>
            /// </param>
            /// <param name="textures">
            /// <para>
            /// Specifies an array in which the generated texture names are stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_texture_object", Version = "", EntryPoint = "glGenTexturesEXT")]
            public static extern unsafe void GenTextures(Int32 n, [OutAttribute] UInt32* textures);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGenVertexShadersEXT")]
            public static extern Int32 GenVertexShaders(Int32 range);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGenVertexShadersEXT")]
            public static extern Int32 GenVertexShaders(UInt32 range);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glGetBooleanIndexedvEXT")]
            public static extern void GetBooleanIndexed(OpenTK.Graphics.OpenGL.All target, Int32 index, [OutAttribute] bool[] data);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glGetBooleanIndexedvEXT")]
            public static extern void GetBooleanIndexed(OpenTK.Graphics.OpenGL.All target, Int32 index, [OutAttribute] out bool data);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glGetBooleanIndexedvEXT")]
            public static extern unsafe void GetBooleanIndexed(OpenTK.Graphics.OpenGL.All target, Int32 index, [OutAttribute] bool* data);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glGetBooleanIndexedvEXT")]
            public static extern void GetBooleanIndexed(OpenTK.Graphics.OpenGL.All target, UInt32 index, [OutAttribute] bool[] data);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glGetBooleanIndexedvEXT")]
            public static extern void GetBooleanIndexed(OpenTK.Graphics.OpenGL.All target, UInt32 index, [OutAttribute] out bool data);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glGetBooleanIndexedvEXT")]
            public static extern unsafe void GetBooleanIndexed(OpenTK.Graphics.OpenGL.All target, UInt32 index, [OutAttribute] bool* data);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [Obsolete("Use All overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glGetBooleanIndexedvEXT")]
            public static extern void GetBooleanIndexed(OpenTK.Graphics.OpenGL.ExtDrawBuffers2 target, Int32 index, [OutAttribute] bool[] data);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [Obsolete("Use All overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glGetBooleanIndexedvEXT")]
            public static extern void GetBooleanIndexed(OpenTK.Graphics.OpenGL.ExtDrawBuffers2 target, Int32 index, [OutAttribute] out bool data);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [Obsolete("Use All overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glGetBooleanIndexedvEXT")]
            public static extern unsafe void GetBooleanIndexed(OpenTK.Graphics.OpenGL.ExtDrawBuffers2 target, Int32 index, [OutAttribute] bool* data);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [Obsolete("Use All overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glGetBooleanIndexedvEXT")]
            public static extern void GetBooleanIndexed(OpenTK.Graphics.OpenGL.ExtDrawBuffers2 target, UInt32 index, [OutAttribute] bool[] data);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [Obsolete("Use All overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glGetBooleanIndexedvEXT")]
            public static extern void GetBooleanIndexed(OpenTK.Graphics.OpenGL.ExtDrawBuffers2 target, UInt32 index, [OutAttribute] out bool data);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [Obsolete("Use All overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glGetBooleanIndexedvEXT")]
            public static extern unsafe void GetBooleanIndexed(OpenTK.Graphics.OpenGL.ExtDrawBuffers2 target, UInt32 index, [OutAttribute] bool* data);

            /// <summary>[requires: EXT_paletted_texture]
            /// Retrieve contents of a color lookup table
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in table. The possible values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in table. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="table">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data containing the contents of the color table.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_paletted_texture", Version = "", EntryPoint = "glGetColorTableEXT")]
            public static extern void GetColorTable(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [OutAttribute] IntPtr data);

            /// <summary>[requires: EXT_paletted_texture]
            /// Retrieve contents of a color lookup table
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in table. The possible values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in table. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="table">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data containing the contents of the color table.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_paletted_texture", Version = "", EntryPoint = "glGetColorTableEXT")]
            public static extern void GetColorTable<T3>(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T3[] data)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_paletted_texture]
            /// Retrieve contents of a color lookup table
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in table. The possible values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in table. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="table">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data containing the contents of the color table.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_paletted_texture", Version = "", EntryPoint = "glGetColorTableEXT")]
            public static extern void GetColorTable<T3>(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T3[,] data)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_paletted_texture]
            /// Retrieve contents of a color lookup table
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in table. The possible values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in table. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="table">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data containing the contents of the color table.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_paletted_texture", Version = "", EntryPoint = "glGetColorTableEXT")]
            public static extern void GetColorTable<T3>(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T3[,,] data)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_paletted_texture]
            /// Retrieve contents of a color lookup table
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in table. The possible values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in table. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="table">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data containing the contents of the color table.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_paletted_texture", Version = "", EntryPoint = "glGetColorTableEXT")]
            public static extern void GetColorTable<T3>(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T3 data)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_paletted_texture]
            /// Get color lookup table parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The target color table. Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, GL_POST_COLOR_MATRIX_COLOR_TABLE, GL_PROXY_COLOR_TABLE, GL_PROXY_POST_CONVOLUTION_COLOR_TABLE, or GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The symbolic name of a color lookup table parameter. Must be one of GL_COLOR_TABLE_BIAS, GL_COLOR_TABLE_SCALE, GL_COLOR_TABLE_FORMAT, GL_COLOR_TABLE_WIDTH, GL_COLOR_TABLE_RED_SIZE, GL_COLOR_TABLE_GREEN_SIZE, GL_COLOR_TABLE_BLUE_SIZE, GL_COLOR_TABLE_ALPHA_SIZE, GL_COLOR_TABLE_LUMINANCE_SIZE, or GL_COLOR_TABLE_INTENSITY_SIZE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// A pointer to an array where the values of the parameter will be stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_paletted_texture", Version = "", EntryPoint = "glGetColorTableParameterfvEXT")]
            public static extern void GetColorTableParameter(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.GetColorTableParameterPName pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: EXT_paletted_texture]
            /// Get color lookup table parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The target color table. Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, GL_POST_COLOR_MATRIX_COLOR_TABLE, GL_PROXY_COLOR_TABLE, GL_PROXY_POST_CONVOLUTION_COLOR_TABLE, or GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The symbolic name of a color lookup table parameter. Must be one of GL_COLOR_TABLE_BIAS, GL_COLOR_TABLE_SCALE, GL_COLOR_TABLE_FORMAT, GL_COLOR_TABLE_WIDTH, GL_COLOR_TABLE_RED_SIZE, GL_COLOR_TABLE_GREEN_SIZE, GL_COLOR_TABLE_BLUE_SIZE, GL_COLOR_TABLE_ALPHA_SIZE, GL_COLOR_TABLE_LUMINANCE_SIZE, or GL_COLOR_TABLE_INTENSITY_SIZE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// A pointer to an array where the values of the parameter will be stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_paletted_texture", Version = "", EntryPoint = "glGetColorTableParameterfvEXT")]
            public static extern void GetColorTableParameter(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.GetColorTableParameterPName pname, [OutAttribute] out Single @params);

            /// <summary>[requires: EXT_paletted_texture]
            /// Get color lookup table parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The target color table. Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, GL_POST_COLOR_MATRIX_COLOR_TABLE, GL_PROXY_COLOR_TABLE, GL_PROXY_POST_CONVOLUTION_COLOR_TABLE, or GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The symbolic name of a color lookup table parameter. Must be one of GL_COLOR_TABLE_BIAS, GL_COLOR_TABLE_SCALE, GL_COLOR_TABLE_FORMAT, GL_COLOR_TABLE_WIDTH, GL_COLOR_TABLE_RED_SIZE, GL_COLOR_TABLE_GREEN_SIZE, GL_COLOR_TABLE_BLUE_SIZE, GL_COLOR_TABLE_ALPHA_SIZE, GL_COLOR_TABLE_LUMINANCE_SIZE, or GL_COLOR_TABLE_INTENSITY_SIZE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// A pointer to an array where the values of the parameter will be stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_paletted_texture", Version = "", EntryPoint = "glGetColorTableParameterfvEXT")]
            public static extern unsafe void GetColorTableParameter(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.GetColorTableParameterPName pname, [OutAttribute] Single* @params);

            /// <summary>[requires: EXT_paletted_texture]
            /// Get color lookup table parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The target color table. Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, GL_POST_COLOR_MATRIX_COLOR_TABLE, GL_PROXY_COLOR_TABLE, GL_PROXY_POST_CONVOLUTION_COLOR_TABLE, or GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The symbolic name of a color lookup table parameter. Must be one of GL_COLOR_TABLE_BIAS, GL_COLOR_TABLE_SCALE, GL_COLOR_TABLE_FORMAT, GL_COLOR_TABLE_WIDTH, GL_COLOR_TABLE_RED_SIZE, GL_COLOR_TABLE_GREEN_SIZE, GL_COLOR_TABLE_BLUE_SIZE, GL_COLOR_TABLE_ALPHA_SIZE, GL_COLOR_TABLE_LUMINANCE_SIZE, or GL_COLOR_TABLE_INTENSITY_SIZE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// A pointer to an array where the values of the parameter will be stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_paletted_texture", Version = "", EntryPoint = "glGetColorTableParameterivEXT")]
            public static extern void GetColorTableParameter(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.GetColorTableParameterPName pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: EXT_paletted_texture]
            /// Get color lookup table parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The target color table. Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, GL_POST_COLOR_MATRIX_COLOR_TABLE, GL_PROXY_COLOR_TABLE, GL_PROXY_POST_CONVOLUTION_COLOR_TABLE, or GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The symbolic name of a color lookup table parameter. Must be one of GL_COLOR_TABLE_BIAS, GL_COLOR_TABLE_SCALE, GL_COLOR_TABLE_FORMAT, GL_COLOR_TABLE_WIDTH, GL_COLOR_TABLE_RED_SIZE, GL_COLOR_TABLE_GREEN_SIZE, GL_COLOR_TABLE_BLUE_SIZE, GL_COLOR_TABLE_ALPHA_SIZE, GL_COLOR_TABLE_LUMINANCE_SIZE, or GL_COLOR_TABLE_INTENSITY_SIZE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// A pointer to an array where the values of the parameter will be stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_paletted_texture", Version = "", EntryPoint = "glGetColorTableParameterivEXT")]
            public static extern void GetColorTableParameter(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.GetColorTableParameterPName pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_paletted_texture]
            /// Get color lookup table parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The target color table. Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, GL_POST_COLOR_MATRIX_COLOR_TABLE, GL_PROXY_COLOR_TABLE, GL_PROXY_POST_CONVOLUTION_COLOR_TABLE, or GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The symbolic name of a color lookup table parameter. Must be one of GL_COLOR_TABLE_BIAS, GL_COLOR_TABLE_SCALE, GL_COLOR_TABLE_FORMAT, GL_COLOR_TABLE_WIDTH, GL_COLOR_TABLE_RED_SIZE, GL_COLOR_TABLE_GREEN_SIZE, GL_COLOR_TABLE_BLUE_SIZE, GL_COLOR_TABLE_ALPHA_SIZE, GL_COLOR_TABLE_LUMINANCE_SIZE, or GL_COLOR_TABLE_INTENSITY_SIZE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// A pointer to an array where the values of the parameter will be stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_paletted_texture", Version = "", EntryPoint = "glGetColorTableParameterivEXT")]
            public static extern unsafe void GetColorTableParameter(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.GetColorTableParameterPName pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetCompressedMultiTexImageEXT")]
            public static extern void GetCompressedMultiTexImage(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 lod, [OutAttribute] IntPtr img);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetCompressedMultiTexImageEXT")]
            public static extern void GetCompressedMultiTexImage<T3>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 lod, [InAttribute, OutAttribute] T3[] img)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetCompressedMultiTexImageEXT")]
            public static extern void GetCompressedMultiTexImage<T3>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 lod, [InAttribute, OutAttribute] T3[,] img)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetCompressedMultiTexImageEXT")]
            public static extern void GetCompressedMultiTexImage<T3>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 lod, [InAttribute, OutAttribute] T3[,,] img)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetCompressedMultiTexImageEXT")]
            public static extern void GetCompressedMultiTexImage<T3>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 lod, [InAttribute, OutAttribute] ref T3 img)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetCompressedTextureImageEXT")]
            public static extern void GetCompressedTextureImage(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 lod, [OutAttribute] IntPtr img);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetCompressedTextureImageEXT")]
            public static extern void GetCompressedTextureImage<T3>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 lod, [InAttribute, OutAttribute] T3[] img)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetCompressedTextureImageEXT")]
            public static extern void GetCompressedTextureImage<T3>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 lod, [InAttribute, OutAttribute] T3[,] img)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetCompressedTextureImageEXT")]
            public static extern void GetCompressedTextureImage<T3>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 lod, [InAttribute, OutAttribute] T3[,,] img)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetCompressedTextureImageEXT")]
            public static extern void GetCompressedTextureImage<T3>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 lod, [InAttribute, OutAttribute] ref T3 img)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetCompressedTextureImageEXT")]
            public static extern void GetCompressedTextureImage(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 lod, [OutAttribute] IntPtr img);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetCompressedTextureImageEXT")]
            public static extern void GetCompressedTextureImage<T3>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 lod, [InAttribute, OutAttribute] T3[] img)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetCompressedTextureImageEXT")]
            public static extern void GetCompressedTextureImage<T3>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 lod, [InAttribute, OutAttribute] T3[,] img)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetCompressedTextureImageEXT")]
            public static extern void GetCompressedTextureImage<T3>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 lod, [InAttribute, OutAttribute] T3[,,] img)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetCompressedTextureImageEXT")]
            public static extern void GetCompressedTextureImage<T3>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 lod, [InAttribute, OutAttribute] ref T3 img)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_convolution]
            /// Get current 1D or 2D convolution filter kernel
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The filter to be retrieved. Must be one of GL_CONVOLUTION_1D or GL_CONVOLUTION_2D.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Format of the output image. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Data type of components in the output image. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="image">
            /// <para>
            /// Pointer to storage for the output image.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glGetConvolutionFilterEXT")]
            public static extern void GetConvolutionFilter(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [OutAttribute] IntPtr image);

            /// <summary>[requires: EXT_convolution]
            /// Get current 1D or 2D convolution filter kernel
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The filter to be retrieved. Must be one of GL_CONVOLUTION_1D or GL_CONVOLUTION_2D.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Format of the output image. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Data type of components in the output image. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="image">
            /// <para>
            /// Pointer to storage for the output image.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glGetConvolutionFilterEXT")]
            public static extern void GetConvolutionFilter<T3>(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T3[] image)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_convolution]
            /// Get current 1D or 2D convolution filter kernel
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The filter to be retrieved. Must be one of GL_CONVOLUTION_1D or GL_CONVOLUTION_2D.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Format of the output image. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Data type of components in the output image. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="image">
            /// <para>
            /// Pointer to storage for the output image.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glGetConvolutionFilterEXT")]
            public static extern void GetConvolutionFilter<T3>(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T3[,] image)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_convolution]
            /// Get current 1D or 2D convolution filter kernel
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The filter to be retrieved. Must be one of GL_CONVOLUTION_1D or GL_CONVOLUTION_2D.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Format of the output image. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Data type of components in the output image. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="image">
            /// <para>
            /// Pointer to storage for the output image.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glGetConvolutionFilterEXT")]
            public static extern void GetConvolutionFilter<T3>(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T3[,,] image)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_convolution]
            /// Get current 1D or 2D convolution filter kernel
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The filter to be retrieved. Must be one of GL_CONVOLUTION_1D or GL_CONVOLUTION_2D.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Format of the output image. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Data type of components in the output image. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="image">
            /// <para>
            /// Pointer to storage for the output image.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glGetConvolutionFilterEXT")]
            public static extern void GetConvolutionFilter<T3>(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T3 image)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_convolution]
            /// Get convolution parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The filter whose parameters are to be retrieved. Must be one of GL_CONVOLUTION_1D, GL_CONVOLUTION_2D, or GL_SEPARABLE_2D.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The parameter to be retrieved. Must be one of GL_CONVOLUTION_BORDER_MODE, GL_CONVOLUTION_BORDER_COLOR, GL_CONVOLUTION_FILTER_SCALE, GL_CONVOLUTION_FILTER_BIAS, GL_CONVOLUTION_FORMAT, GL_CONVOLUTION_WIDTH, GL_CONVOLUTION_HEIGHT, GL_MAX_CONVOLUTION_WIDTH, or GL_MAX_CONVOLUTION_HEIGHT.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Pointer to storage for the parameters to be retrieved.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glGetConvolutionParameterfvEXT")]
            public static extern void GetConvolutionParameter(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.ExtConvolution pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: EXT_convolution]
            /// Get convolution parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The filter whose parameters are to be retrieved. Must be one of GL_CONVOLUTION_1D, GL_CONVOLUTION_2D, or GL_SEPARABLE_2D.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The parameter to be retrieved. Must be one of GL_CONVOLUTION_BORDER_MODE, GL_CONVOLUTION_BORDER_COLOR, GL_CONVOLUTION_FILTER_SCALE, GL_CONVOLUTION_FILTER_BIAS, GL_CONVOLUTION_FORMAT, GL_CONVOLUTION_WIDTH, GL_CONVOLUTION_HEIGHT, GL_MAX_CONVOLUTION_WIDTH, or GL_MAX_CONVOLUTION_HEIGHT.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Pointer to storage for the parameters to be retrieved.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glGetConvolutionParameterfvEXT")]
            public static extern void GetConvolutionParameter(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.ExtConvolution pname, [OutAttribute] out Single @params);

            /// <summary>[requires: EXT_convolution]
            /// Get convolution parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The filter whose parameters are to be retrieved. Must be one of GL_CONVOLUTION_1D, GL_CONVOLUTION_2D, or GL_SEPARABLE_2D.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The parameter to be retrieved. Must be one of GL_CONVOLUTION_BORDER_MODE, GL_CONVOLUTION_BORDER_COLOR, GL_CONVOLUTION_FILTER_SCALE, GL_CONVOLUTION_FILTER_BIAS, GL_CONVOLUTION_FORMAT, GL_CONVOLUTION_WIDTH, GL_CONVOLUTION_HEIGHT, GL_MAX_CONVOLUTION_WIDTH, or GL_MAX_CONVOLUTION_HEIGHT.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Pointer to storage for the parameters to be retrieved.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glGetConvolutionParameterfvEXT")]
            public static extern unsafe void GetConvolutionParameter(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.ExtConvolution pname, [OutAttribute] Single* @params);

            /// <summary>[requires: EXT_convolution]
            /// Get convolution parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The filter whose parameters are to be retrieved. Must be one of GL_CONVOLUTION_1D, GL_CONVOLUTION_2D, or GL_SEPARABLE_2D.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The parameter to be retrieved. Must be one of GL_CONVOLUTION_BORDER_MODE, GL_CONVOLUTION_BORDER_COLOR, GL_CONVOLUTION_FILTER_SCALE, GL_CONVOLUTION_FILTER_BIAS, GL_CONVOLUTION_FORMAT, GL_CONVOLUTION_WIDTH, GL_CONVOLUTION_HEIGHT, GL_MAX_CONVOLUTION_WIDTH, or GL_MAX_CONVOLUTION_HEIGHT.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Pointer to storage for the parameters to be retrieved.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glGetConvolutionParameterivEXT")]
            public static extern void GetConvolutionParameter(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.ExtConvolution pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: EXT_convolution]
            /// Get convolution parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The filter whose parameters are to be retrieved. Must be one of GL_CONVOLUTION_1D, GL_CONVOLUTION_2D, or GL_SEPARABLE_2D.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The parameter to be retrieved. Must be one of GL_CONVOLUTION_BORDER_MODE, GL_CONVOLUTION_BORDER_COLOR, GL_CONVOLUTION_FILTER_SCALE, GL_CONVOLUTION_FILTER_BIAS, GL_CONVOLUTION_FORMAT, GL_CONVOLUTION_WIDTH, GL_CONVOLUTION_HEIGHT, GL_MAX_CONVOLUTION_WIDTH, or GL_MAX_CONVOLUTION_HEIGHT.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Pointer to storage for the parameters to be retrieved.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glGetConvolutionParameterivEXT")]
            public static extern void GetConvolutionParameter(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.ExtConvolution pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_convolution]
            /// Get convolution parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The filter whose parameters are to be retrieved. Must be one of GL_CONVOLUTION_1D, GL_CONVOLUTION_2D, or GL_SEPARABLE_2D.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The parameter to be retrieved. Must be one of GL_CONVOLUTION_BORDER_MODE, GL_CONVOLUTION_BORDER_COLOR, GL_CONVOLUTION_FILTER_SCALE, GL_CONVOLUTION_FILTER_BIAS, GL_CONVOLUTION_FORMAT, GL_CONVOLUTION_WIDTH, GL_CONVOLUTION_HEIGHT, GL_MAX_CONVOLUTION_WIDTH, or GL_MAX_CONVOLUTION_HEIGHT.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Pointer to storage for the parameters to be retrieved.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glGetConvolutionParameterivEXT")]
            public static extern unsafe void GetConvolutionParameter(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.ExtConvolution pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetDoublei_vEXT")]
            public static extern void GetDouble(OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, Int32 index, [OutAttribute] Double[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetDoublei_vEXT")]
            public static extern void GetDouble(OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, Int32 index, [OutAttribute] out Double @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetDoublei_vEXT")]
            public static extern unsafe void GetDouble(OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, Int32 index, [OutAttribute] Double* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetDoublei_vEXT")]
            public static extern void GetDouble(OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, UInt32 index, [OutAttribute] Double[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetDoublei_vEXT")]
            public static extern void GetDouble(OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, UInt32 index, [OutAttribute] out Double @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetDoublei_vEXT")]
            public static extern unsafe void GetDouble(OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, UInt32 index, [OutAttribute] Double* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetDoubleIndexedvEXT")]
            public static extern void GetDoubleIndexed(OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, [OutAttribute] Double[] data);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetDoubleIndexedvEXT")]
            public static extern void GetDoubleIndexed(OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, [OutAttribute] out Double data);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetDoubleIndexedvEXT")]
            public static extern unsafe void GetDoubleIndexed(OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, [OutAttribute] Double* data);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetDoubleIndexedvEXT")]
            public static extern void GetDoubleIndexed(OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, [OutAttribute] Double[] data);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetDoubleIndexedvEXT")]
            public static extern void GetDoubleIndexed(OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, [OutAttribute] out Double data);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetDoubleIndexedvEXT")]
            public static extern unsafe void GetDoubleIndexed(OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, [OutAttribute] Double* data);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetFloati_vEXT")]
            public static extern void GetFloat(OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, Int32 index, [OutAttribute] Single[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetFloati_vEXT")]
            public static extern void GetFloat(OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, Int32 index, [OutAttribute] out Single @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetFloati_vEXT")]
            public static extern unsafe void GetFloat(OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, Int32 index, [OutAttribute] Single* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetFloati_vEXT")]
            public static extern void GetFloat(OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, UInt32 index, [OutAttribute] Single[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetFloati_vEXT")]
            public static extern void GetFloat(OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, UInt32 index, [OutAttribute] out Single @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetFloati_vEXT")]
            public static extern unsafe void GetFloat(OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, UInt32 index, [OutAttribute] Single* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetFloatIndexedvEXT")]
            public static extern void GetFloatIndexed(OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, [OutAttribute] Single[] data);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetFloatIndexedvEXT")]
            public static extern void GetFloatIndexed(OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, [OutAttribute] out Single data);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetFloatIndexedvEXT")]
            public static extern unsafe void GetFloatIndexed(OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, [OutAttribute] Single* data);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetFloatIndexedvEXT")]
            public static extern void GetFloatIndexed(OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, [OutAttribute] Single[] data);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetFloatIndexedvEXT")]
            public static extern void GetFloatIndexed(OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, [OutAttribute] out Single data);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetFloatIndexedvEXT")]
            public static extern unsafe void GetFloatIndexed(OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, [OutAttribute] Single* data);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Query the bindings of color numbers to user-defined varying out variables
            /// </summary>
            /// <param name="program">
            /// <para>
            /// The name of the program containing varying out variable whose binding to query
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// The name of the user-defined varying out variable whose binding to query
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glGetFragDataLocationEXT")]
            public static extern Int32 GetFragDataLocation(Int32 program, String name);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Query the bindings of color numbers to user-defined varying out variables
            /// </summary>
            /// <param name="program">
            /// <para>
            /// The name of the program containing varying out variable whose binding to query
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// The name of the user-defined varying out variable whose binding to query
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glGetFragDataLocationEXT")]
            public static extern Int32 GetFragDataLocation(UInt32 program, String name);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Retrieve information about attachments of a bound framebuffer object
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target of the query operation.
            /// </para>
            /// </param>
            /// <param name="attachment">
            /// <para>
            /// Specifies the attachment within target
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the parameter of attachment to query.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Specifies the address of a variable receive the value of pname for attachment.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glGetFramebufferAttachmentParameterivEXT")]
            public static extern void GetFramebufferAttachmentParameter(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.FramebufferParameterName pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Retrieve information about attachments of a bound framebuffer object
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target of the query operation.
            /// </para>
            /// </param>
            /// <param name="attachment">
            /// <para>
            /// Specifies the attachment within target
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the parameter of attachment to query.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Specifies the address of a variable receive the value of pname for attachment.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glGetFramebufferAttachmentParameterivEXT")]
            public static extern void GetFramebufferAttachmentParameter(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.FramebufferParameterName pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Retrieve information about attachments of a bound framebuffer object
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target of the query operation.
            /// </para>
            /// </param>
            /// <param name="attachment">
            /// <para>
            /// Specifies the attachment within target
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the parameter of attachment to query.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Specifies the address of a variable receive the value of pname for attachment.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glGetFramebufferAttachmentParameterivEXT")]
            public static extern unsafe void GetFramebufferAttachmentParameter(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.FramebufferParameterName pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]
            /// Retrieve a named parameter from a framebuffer
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The target of the operation, which must be GL_READ_FRAMEBUFFER, GL_DRAW_FRAMEBUFFER or GL_FRAMEBUFFER.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// A token indicating the parameter to be retrieved.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// The address of a variable to receive the value of the parameter named pname.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetFramebufferParameterivEXT")]
            public static extern void GetFramebufferParameter(Int32 framebuffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: EXT_direct_state_access]
            /// Retrieve a named parameter from a framebuffer
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The target of the operation, which must be GL_READ_FRAMEBUFFER, GL_DRAW_FRAMEBUFFER or GL_FRAMEBUFFER.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// A token indicating the parameter to be retrieved.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// The address of a variable to receive the value of the parameter named pname.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetFramebufferParameterivEXT")]
            public static extern void GetFramebufferParameter(Int32 framebuffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_direct_state_access]
            /// Retrieve a named parameter from a framebuffer
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The target of the operation, which must be GL_READ_FRAMEBUFFER, GL_DRAW_FRAMEBUFFER or GL_FRAMEBUFFER.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// A token indicating the parameter to be retrieved.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// The address of a variable to receive the value of the parameter named pname.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetFramebufferParameterivEXT")]
            public static extern unsafe void GetFramebufferParameter(Int32 framebuffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]
            /// Retrieve a named parameter from a framebuffer
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The target of the operation, which must be GL_READ_FRAMEBUFFER, GL_DRAW_FRAMEBUFFER or GL_FRAMEBUFFER.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// A token indicating the parameter to be retrieved.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// The address of a variable to receive the value of the parameter named pname.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetFramebufferParameterivEXT")]
            public static extern void GetFramebufferParameter(UInt32 framebuffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: EXT_direct_state_access]
            /// Retrieve a named parameter from a framebuffer
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The target of the operation, which must be GL_READ_FRAMEBUFFER, GL_DRAW_FRAMEBUFFER or GL_FRAMEBUFFER.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// A token indicating the parameter to be retrieved.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// The address of a variable to receive the value of the parameter named pname.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetFramebufferParameterivEXT")]
            public static extern void GetFramebufferParameter(UInt32 framebuffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_direct_state_access]
            /// Retrieve a named parameter from a framebuffer
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The target of the operation, which must be GL_READ_FRAMEBUFFER, GL_DRAW_FRAMEBUFFER or GL_FRAMEBUFFER.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// A token indicating the parameter to be retrieved.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// The address of a variable to receive the value of the parameter named pname.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetFramebufferParameterivEXT")]
            public static extern unsafe void GetFramebufferParameter(UInt32 framebuffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_histogram]
            /// Get histogram table
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_HISTOGRAM.
            /// </para>
            /// </param>
            /// <param name="reset">
            /// <para>
            /// If GL_TRUE, each component counter that is actually returned is reset to zero. (Other counters are unaffected.) If GL_FALSE, none of the counters in the histogram table is modified.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of values to be returned in values. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of values to be returned in values. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="values">
            /// <para>
            /// A pointer to storage for the returned histogram table.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_histogram", Version = "", EntryPoint = "glGetHistogramEXT")]
            public static extern void GetHistogram(OpenTK.Graphics.OpenGL.ExtHistogram target, bool reset, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [OutAttribute] IntPtr values);

            /// <summary>[requires: EXT_histogram]
            /// Get histogram table
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_HISTOGRAM.
            /// </para>
            /// </param>
            /// <param name="reset">
            /// <para>
            /// If GL_TRUE, each component counter that is actually returned is reset to zero. (Other counters are unaffected.) If GL_FALSE, none of the counters in the histogram table is modified.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of values to be returned in values. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of values to be returned in values. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="values">
            /// <para>
            /// A pointer to storage for the returned histogram table.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_histogram", Version = "", EntryPoint = "glGetHistogramEXT")]
            public static extern void GetHistogram<T4>(OpenTK.Graphics.OpenGL.ExtHistogram target, bool reset, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T4[] values)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_histogram]
            /// Get histogram table
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_HISTOGRAM.
            /// </para>
            /// </param>
            /// <param name="reset">
            /// <para>
            /// If GL_TRUE, each component counter that is actually returned is reset to zero. (Other counters are unaffected.) If GL_FALSE, none of the counters in the histogram table is modified.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of values to be returned in values. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of values to be returned in values. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="values">
            /// <para>
            /// A pointer to storage for the returned histogram table.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_histogram", Version = "", EntryPoint = "glGetHistogramEXT")]
            public static extern void GetHistogram<T4>(OpenTK.Graphics.OpenGL.ExtHistogram target, bool reset, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T4[,] values)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_histogram]
            /// Get histogram table
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_HISTOGRAM.
            /// </para>
            /// </param>
            /// <param name="reset">
            /// <para>
            /// If GL_TRUE, each component counter that is actually returned is reset to zero. (Other counters are unaffected.) If GL_FALSE, none of the counters in the histogram table is modified.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of values to be returned in values. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of values to be returned in values. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="values">
            /// <para>
            /// A pointer to storage for the returned histogram table.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_histogram", Version = "", EntryPoint = "glGetHistogramEXT")]
            public static extern void GetHistogram<T4>(OpenTK.Graphics.OpenGL.ExtHistogram target, bool reset, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T4[,,] values)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_histogram]
            /// Get histogram table
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_HISTOGRAM.
            /// </para>
            /// </param>
            /// <param name="reset">
            /// <para>
            /// If GL_TRUE, each component counter that is actually returned is reset to zero. (Other counters are unaffected.) If GL_FALSE, none of the counters in the histogram table is modified.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of values to be returned in values. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of values to be returned in values. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="values">
            /// <para>
            /// A pointer to storage for the returned histogram table.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_histogram", Version = "", EntryPoint = "glGetHistogramEXT")]
            public static extern void GetHistogram<T4>(OpenTK.Graphics.OpenGL.ExtHistogram target, bool reset, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T4 values)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_histogram]
            /// Get histogram parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be one of GL_HISTOGRAM or GL_PROXY_HISTOGRAM.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The name of the parameter to be retrieved. Must be one of GL_HISTOGRAM_WIDTH, GL_HISTOGRAM_FORMAT, GL_HISTOGRAM_RED_SIZE, GL_HISTOGRAM_GREEN_SIZE, GL_HISTOGRAM_BLUE_SIZE, GL_HISTOGRAM_ALPHA_SIZE, GL_HISTOGRAM_LUMINANCE_SIZE, or GL_HISTOGRAM_SINK.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Pointer to storage for the returned values.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_histogram", Version = "", EntryPoint = "glGetHistogramParameterfvEXT")]
            public static extern void GetHistogramParameter(OpenTK.Graphics.OpenGL.ExtHistogram target, OpenTK.Graphics.OpenGL.ExtHistogram pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: EXT_histogram]
            /// Get histogram parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be one of GL_HISTOGRAM or GL_PROXY_HISTOGRAM.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The name of the parameter to be retrieved. Must be one of GL_HISTOGRAM_WIDTH, GL_HISTOGRAM_FORMAT, GL_HISTOGRAM_RED_SIZE, GL_HISTOGRAM_GREEN_SIZE, GL_HISTOGRAM_BLUE_SIZE, GL_HISTOGRAM_ALPHA_SIZE, GL_HISTOGRAM_LUMINANCE_SIZE, or GL_HISTOGRAM_SINK.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Pointer to storage for the returned values.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_histogram", Version = "", EntryPoint = "glGetHistogramParameterfvEXT")]
            public static extern void GetHistogramParameter(OpenTK.Graphics.OpenGL.ExtHistogram target, OpenTK.Graphics.OpenGL.ExtHistogram pname, [OutAttribute] out Single @params);

            /// <summary>[requires: EXT_histogram]
            /// Get histogram parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be one of GL_HISTOGRAM or GL_PROXY_HISTOGRAM.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The name of the parameter to be retrieved. Must be one of GL_HISTOGRAM_WIDTH, GL_HISTOGRAM_FORMAT, GL_HISTOGRAM_RED_SIZE, GL_HISTOGRAM_GREEN_SIZE, GL_HISTOGRAM_BLUE_SIZE, GL_HISTOGRAM_ALPHA_SIZE, GL_HISTOGRAM_LUMINANCE_SIZE, or GL_HISTOGRAM_SINK.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Pointer to storage for the returned values.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_histogram", Version = "", EntryPoint = "glGetHistogramParameterfvEXT")]
            public static extern unsafe void GetHistogramParameter(OpenTK.Graphics.OpenGL.ExtHistogram target, OpenTK.Graphics.OpenGL.ExtHistogram pname, [OutAttribute] Single* @params);

            /// <summary>[requires: EXT_histogram]
            /// Get histogram parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be one of GL_HISTOGRAM or GL_PROXY_HISTOGRAM.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The name of the parameter to be retrieved. Must be one of GL_HISTOGRAM_WIDTH, GL_HISTOGRAM_FORMAT, GL_HISTOGRAM_RED_SIZE, GL_HISTOGRAM_GREEN_SIZE, GL_HISTOGRAM_BLUE_SIZE, GL_HISTOGRAM_ALPHA_SIZE, GL_HISTOGRAM_LUMINANCE_SIZE, or GL_HISTOGRAM_SINK.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Pointer to storage for the returned values.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_histogram", Version = "", EntryPoint = "glGetHistogramParameterivEXT")]
            public static extern void GetHistogramParameter(OpenTK.Graphics.OpenGL.ExtHistogram target, OpenTK.Graphics.OpenGL.ExtHistogram pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: EXT_histogram]
            /// Get histogram parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be one of GL_HISTOGRAM or GL_PROXY_HISTOGRAM.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The name of the parameter to be retrieved. Must be one of GL_HISTOGRAM_WIDTH, GL_HISTOGRAM_FORMAT, GL_HISTOGRAM_RED_SIZE, GL_HISTOGRAM_GREEN_SIZE, GL_HISTOGRAM_BLUE_SIZE, GL_HISTOGRAM_ALPHA_SIZE, GL_HISTOGRAM_LUMINANCE_SIZE, or GL_HISTOGRAM_SINK.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Pointer to storage for the returned values.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_histogram", Version = "", EntryPoint = "glGetHistogramParameterivEXT")]
            public static extern void GetHistogramParameter(OpenTK.Graphics.OpenGL.ExtHistogram target, OpenTK.Graphics.OpenGL.ExtHistogram pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_histogram]
            /// Get histogram parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be one of GL_HISTOGRAM or GL_PROXY_HISTOGRAM.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The name of the parameter to be retrieved. Must be one of GL_HISTOGRAM_WIDTH, GL_HISTOGRAM_FORMAT, GL_HISTOGRAM_RED_SIZE, GL_HISTOGRAM_GREEN_SIZE, GL_HISTOGRAM_BLUE_SIZE, GL_HISTOGRAM_ALPHA_SIZE, GL_HISTOGRAM_LUMINANCE_SIZE, or GL_HISTOGRAM_SINK.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Pointer to storage for the returned values.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_histogram", Version = "", EntryPoint = "glGetHistogramParameterivEXT")]
            public static extern unsafe void GetHistogramParameter(OpenTK.Graphics.OpenGL.ExtHistogram target, OpenTK.Graphics.OpenGL.ExtHistogram pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [Obsolete("Use GetIndexedPName overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glGetIntegerIndexedvEXT")]
            public static extern void GetIntegerIndexed(OpenTK.Graphics.OpenGL.ExtDrawBuffers2 target, Int32 index, [OutAttribute] Int32[] data);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [Obsolete("Use GetIndexedPName overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glGetIntegerIndexedvEXT")]
            public static extern void GetIntegerIndexed(OpenTK.Graphics.OpenGL.ExtDrawBuffers2 target, Int32 index, [OutAttribute] out Int32 data);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [Obsolete("Use GetIndexedPName overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glGetIntegerIndexedvEXT")]
            public static extern unsafe void GetIntegerIndexed(OpenTK.Graphics.OpenGL.ExtDrawBuffers2 target, Int32 index, [OutAttribute] Int32* data);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [Obsolete("Use GetIndexedPName overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glGetIntegerIndexedvEXT")]
            public static extern void GetIntegerIndexed(OpenTK.Graphics.OpenGL.ExtDrawBuffers2 target, UInt32 index, [OutAttribute] Int32[] data);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [Obsolete("Use GetIndexedPName overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glGetIntegerIndexedvEXT")]
            public static extern void GetIntegerIndexed(OpenTK.Graphics.OpenGL.ExtDrawBuffers2 target, UInt32 index, [OutAttribute] out Int32 data);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [Obsolete("Use GetIndexedPName overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glGetIntegerIndexedvEXT")]
            public static extern unsafe void GetIntegerIndexed(OpenTK.Graphics.OpenGL.ExtDrawBuffers2 target, UInt32 index, [OutAttribute] Int32* data);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glGetIntegerIndexedvEXT")]
            public static extern void GetIntegerIndexed(OpenTK.Graphics.OpenGL.GetIndexedPName target, Int32 index, [OutAttribute] Int32[] data);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glGetIntegerIndexedvEXT")]
            public static extern void GetIntegerIndexed(OpenTK.Graphics.OpenGL.GetIndexedPName target, Int32 index, [OutAttribute] out Int32 data);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glGetIntegerIndexedvEXT")]
            public static extern unsafe void GetIntegerIndexed(OpenTK.Graphics.OpenGL.GetIndexedPName target, Int32 index, [OutAttribute] Int32* data);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glGetIntegerIndexedvEXT")]
            public static extern void GetIntegerIndexed(OpenTK.Graphics.OpenGL.GetIndexedPName target, UInt32 index, [OutAttribute] Int32[] data);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glGetIntegerIndexedvEXT")]
            public static extern void GetIntegerIndexed(OpenTK.Graphics.OpenGL.GetIndexedPName target, UInt32 index, [OutAttribute] out Int32 data);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glGetIntegerIndexedvEXT")]
            public static extern unsafe void GetIntegerIndexed(OpenTK.Graphics.OpenGL.GetIndexedPName target, UInt32 index, [OutAttribute] Int32* data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetInvariantBooleanvEXT")]
            public static extern void GetInvariantBoolean(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] bool[] data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetInvariantBooleanvEXT")]
            public static extern void GetInvariantBoolean(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] out bool data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetInvariantBooleanvEXT")]
            public static extern unsafe void GetInvariantBoolean(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] bool* data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetInvariantBooleanvEXT")]
            public static extern void GetInvariantBoolean(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] bool[] data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetInvariantBooleanvEXT")]
            public static extern void GetInvariantBoolean(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] out bool data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetInvariantBooleanvEXT")]
            public static extern unsafe void GetInvariantBoolean(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] bool* data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetInvariantFloatvEXT")]
            public static extern void GetInvariantFloat(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] Single[] data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetInvariantFloatvEXT")]
            public static extern void GetInvariantFloat(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] out Single data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetInvariantFloatvEXT")]
            public static extern unsafe void GetInvariantFloat(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] Single* data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetInvariantFloatvEXT")]
            public static extern void GetInvariantFloat(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] Single[] data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetInvariantFloatvEXT")]
            public static extern void GetInvariantFloat(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] out Single data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetInvariantFloatvEXT")]
            public static extern unsafe void GetInvariantFloat(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] Single* data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetInvariantIntegervEXT")]
            public static extern void GetInvariantInteger(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] Int32[] data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetInvariantIntegervEXT")]
            public static extern void GetInvariantInteger(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] out Int32 data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetInvariantIntegervEXT")]
            public static extern unsafe void GetInvariantInteger(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] Int32* data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetInvariantIntegervEXT")]
            public static extern void GetInvariantInteger(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] Int32[] data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetInvariantIntegervEXT")]
            public static extern void GetInvariantInteger(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] out Int32 data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetInvariantIntegervEXT")]
            public static extern unsafe void GetInvariantInteger(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] Int32* data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetLocalConstantBooleanvEXT")]
            public static extern void GetLocalConstantBoolean(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] bool[] data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetLocalConstantBooleanvEXT")]
            public static extern void GetLocalConstantBoolean(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] out bool data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetLocalConstantBooleanvEXT")]
            public static extern unsafe void GetLocalConstantBoolean(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] bool* data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetLocalConstantBooleanvEXT")]
            public static extern void GetLocalConstantBoolean(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] bool[] data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetLocalConstantBooleanvEXT")]
            public static extern void GetLocalConstantBoolean(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] out bool data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetLocalConstantBooleanvEXT")]
            public static extern unsafe void GetLocalConstantBoolean(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] bool* data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetLocalConstantFloatvEXT")]
            public static extern void GetLocalConstantFloat(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] Single[] data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetLocalConstantFloatvEXT")]
            public static extern void GetLocalConstantFloat(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] out Single data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetLocalConstantFloatvEXT")]
            public static extern unsafe void GetLocalConstantFloat(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] Single* data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetLocalConstantFloatvEXT")]
            public static extern void GetLocalConstantFloat(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] Single[] data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetLocalConstantFloatvEXT")]
            public static extern void GetLocalConstantFloat(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] out Single data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetLocalConstantFloatvEXT")]
            public static extern unsafe void GetLocalConstantFloat(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] Single* data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetLocalConstantIntegervEXT")]
            public static extern void GetLocalConstantInteger(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] Int32[] data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetLocalConstantIntegervEXT")]
            public static extern void GetLocalConstantInteger(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] out Int32 data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetLocalConstantIntegervEXT")]
            public static extern unsafe void GetLocalConstantInteger(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] Int32* data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetLocalConstantIntegervEXT")]
            public static extern void GetLocalConstantInteger(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] Int32[] data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetLocalConstantIntegervEXT")]
            public static extern void GetLocalConstantInteger(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] out Int32 data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetLocalConstantIntegervEXT")]
            public static extern unsafe void GetLocalConstantInteger(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] Int32* data);

            /// <summary>[requires: EXT_histogram]
            /// Get minimum and maximum pixel values
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_MINMAX.
            /// </para>
            /// </param>
            /// <param name="reset">
            /// <para>
            /// If GL_TRUE, all entries in the minmax table that are actually returned are reset to their initial values. (Other entries are unaltered.) If GL_FALSE, the minmax table is unaltered.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the data to be returned in values. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
            /// </para>
            /// </param>
            /// <param name="types">
            /// <para>
            /// The type of the data to be returned in values. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="values">
            /// <para>
            /// A pointer to storage for the returned values.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_histogram", Version = "", EntryPoint = "glGetMinmaxEXT")]
            public static extern void GetMinmax(OpenTK.Graphics.OpenGL.ExtHistogram target, bool reset, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [OutAttribute] IntPtr values);

            /// <summary>[requires: EXT_histogram]
            /// Get minimum and maximum pixel values
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_MINMAX.
            /// </para>
            /// </param>
            /// <param name="reset">
            /// <para>
            /// If GL_TRUE, all entries in the minmax table that are actually returned are reset to their initial values. (Other entries are unaltered.) If GL_FALSE, the minmax table is unaltered.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the data to be returned in values. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
            /// </para>
            /// </param>
            /// <param name="types">
            /// <para>
            /// The type of the data to be returned in values. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="values">
            /// <para>
            /// A pointer to storage for the returned values.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_histogram", Version = "", EntryPoint = "glGetMinmaxEXT")]
            public static extern void GetMinmax<T4>(OpenTK.Graphics.OpenGL.ExtHistogram target, bool reset, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T4[] values)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_histogram]
            /// Get minimum and maximum pixel values
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_MINMAX.
            /// </para>
            /// </param>
            /// <param name="reset">
            /// <para>
            /// If GL_TRUE, all entries in the minmax table that are actually returned are reset to their initial values. (Other entries are unaltered.) If GL_FALSE, the minmax table is unaltered.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the data to be returned in values. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
            /// </para>
            /// </param>
            /// <param name="types">
            /// <para>
            /// The type of the data to be returned in values. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="values">
            /// <para>
            /// A pointer to storage for the returned values.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_histogram", Version = "", EntryPoint = "glGetMinmaxEXT")]
            public static extern void GetMinmax<T4>(OpenTK.Graphics.OpenGL.ExtHistogram target, bool reset, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T4[,] values)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_histogram]
            /// Get minimum and maximum pixel values
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_MINMAX.
            /// </para>
            /// </param>
            /// <param name="reset">
            /// <para>
            /// If GL_TRUE, all entries in the minmax table that are actually returned are reset to their initial values. (Other entries are unaltered.) If GL_FALSE, the minmax table is unaltered.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the data to be returned in values. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
            /// </para>
            /// </param>
            /// <param name="types">
            /// <para>
            /// The type of the data to be returned in values. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="values">
            /// <para>
            /// A pointer to storage for the returned values.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_histogram", Version = "", EntryPoint = "glGetMinmaxEXT")]
            public static extern void GetMinmax<T4>(OpenTK.Graphics.OpenGL.ExtHistogram target, bool reset, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T4[,,] values)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_histogram]
            /// Get minimum and maximum pixel values
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_MINMAX.
            /// </para>
            /// </param>
            /// <param name="reset">
            /// <para>
            /// If GL_TRUE, all entries in the minmax table that are actually returned are reset to their initial values. (Other entries are unaltered.) If GL_FALSE, the minmax table is unaltered.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the data to be returned in values. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
            /// </para>
            /// </param>
            /// <param name="types">
            /// <para>
            /// The type of the data to be returned in values. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="values">
            /// <para>
            /// A pointer to storage for the returned values.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_histogram", Version = "", EntryPoint = "glGetMinmaxEXT")]
            public static extern void GetMinmax<T4>(OpenTK.Graphics.OpenGL.ExtHistogram target, bool reset, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T4 values)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_histogram]
            /// Get minmax parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_MINMAX.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The parameter to be retrieved. Must be one of GL_MINMAX_FORMAT or GL_MINMAX_SINK.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// A pointer to storage for the retrieved parameters.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_histogram", Version = "", EntryPoint = "glGetMinmaxParameterfvEXT")]
            public static extern void GetMinmaxParameter(OpenTK.Graphics.OpenGL.ExtHistogram target, OpenTK.Graphics.OpenGL.ExtHistogram pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: EXT_histogram]
            /// Get minmax parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_MINMAX.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The parameter to be retrieved. Must be one of GL_MINMAX_FORMAT or GL_MINMAX_SINK.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// A pointer to storage for the retrieved parameters.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_histogram", Version = "", EntryPoint = "glGetMinmaxParameterfvEXT")]
            public static extern void GetMinmaxParameter(OpenTK.Graphics.OpenGL.ExtHistogram target, OpenTK.Graphics.OpenGL.ExtHistogram pname, [OutAttribute] out Single @params);

            /// <summary>[requires: EXT_histogram]
            /// Get minmax parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_MINMAX.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The parameter to be retrieved. Must be one of GL_MINMAX_FORMAT or GL_MINMAX_SINK.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// A pointer to storage for the retrieved parameters.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_histogram", Version = "", EntryPoint = "glGetMinmaxParameterfvEXT")]
            public static extern unsafe void GetMinmaxParameter(OpenTK.Graphics.OpenGL.ExtHistogram target, OpenTK.Graphics.OpenGL.ExtHistogram pname, [OutAttribute] Single* @params);

            /// <summary>[requires: EXT_histogram]
            /// Get minmax parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_MINMAX.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The parameter to be retrieved. Must be one of GL_MINMAX_FORMAT or GL_MINMAX_SINK.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// A pointer to storage for the retrieved parameters.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_histogram", Version = "", EntryPoint = "glGetMinmaxParameterivEXT")]
            public static extern void GetMinmaxParameter(OpenTK.Graphics.OpenGL.ExtHistogram target, OpenTK.Graphics.OpenGL.ExtHistogram pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: EXT_histogram]
            /// Get minmax parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_MINMAX.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The parameter to be retrieved. Must be one of GL_MINMAX_FORMAT or GL_MINMAX_SINK.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// A pointer to storage for the retrieved parameters.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_histogram", Version = "", EntryPoint = "glGetMinmaxParameterivEXT")]
            public static extern void GetMinmaxParameter(OpenTK.Graphics.OpenGL.ExtHistogram target, OpenTK.Graphics.OpenGL.ExtHistogram pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_histogram]
            /// Get minmax parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_MINMAX.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The parameter to be retrieved. Must be one of GL_MINMAX_FORMAT or GL_MINMAX_SINK.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// A pointer to storage for the retrieved parameters.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_histogram", Version = "", EntryPoint = "glGetMinmaxParameterivEXT")]
            public static extern unsafe void GetMinmaxParameter(OpenTK.Graphics.OpenGL.ExtHistogram target, OpenTK.Graphics.OpenGL.ExtHistogram pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexEnvfvEXT")]
            public static extern void GetMultiTexEnv(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexEnvfvEXT")]
            public static extern void GetMultiTexEnv(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, [OutAttribute] out Single @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexEnvfvEXT")]
            public static extern unsafe void GetMultiTexEnv(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, [OutAttribute] Single* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexEnvivEXT")]
            public static extern void GetMultiTexEnv(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexEnvivEXT")]
            public static extern void GetMultiTexEnv(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexEnvivEXT")]
            public static extern unsafe void GetMultiTexEnv(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexGendvEXT")]
            public static extern void GetMultiTexGen(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, [OutAttribute] Double[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexGendvEXT")]
            public static extern void GetMultiTexGen(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, [OutAttribute] out Double @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexGendvEXT")]
            public static extern unsafe void GetMultiTexGen(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, [OutAttribute] Double* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexGenfvEXT")]
            public static extern void GetMultiTexGen(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexGenfvEXT")]
            public static extern void GetMultiTexGen(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, [OutAttribute] out Single @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexGenfvEXT")]
            public static extern unsafe void GetMultiTexGen(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, [OutAttribute] Single* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexGenivEXT")]
            public static extern void GetMultiTexGen(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexGenivEXT")]
            public static extern void GetMultiTexGen(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexGenivEXT")]
            public static extern unsafe void GetMultiTexGen(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexImageEXT")]
            public static extern void GetMultiTexImage(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [OutAttribute] IntPtr pixels);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexImageEXT")]
            public static extern void GetMultiTexImage<T5>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T5[] pixels)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexImageEXT")]
            public static extern void GetMultiTexImage<T5>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T5[,] pixels)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexImageEXT")]
            public static extern void GetMultiTexImage<T5>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T5[,,] pixels)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexImageEXT")]
            public static extern void GetMultiTexImage<T5>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T5 pixels)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexLevelParameterfvEXT")]
            public static extern void GetMultiTexLevelParameter(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexLevelParameterfvEXT")]
            public static extern void GetMultiTexLevelParameter(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] out Single @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexLevelParameterfvEXT")]
            public static extern unsafe void GetMultiTexLevelParameter(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Single* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexLevelParameterivEXT")]
            public static extern void GetMultiTexLevelParameter(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexLevelParameterivEXT")]
            public static extern void GetMultiTexLevelParameter(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexLevelParameterivEXT")]
            public static extern unsafe void GetMultiTexLevelParameter(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexParameterfvEXT")]
            public static extern void GetMultiTexParameter(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexParameterfvEXT")]
            public static extern void GetMultiTexParameter(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] out Single @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexParameterfvEXT")]
            public static extern unsafe void GetMultiTexParameter(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Single* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexParameterIivEXT")]
            public static extern void GetMultiTexParameterI(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexParameterIivEXT")]
            public static extern void GetMultiTexParameterI(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexParameterIivEXT")]
            public static extern unsafe void GetMultiTexParameterI(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexParameterIuivEXT")]
            public static extern void GetMultiTexParameterI(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] UInt32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexParameterIuivEXT")]
            public static extern void GetMultiTexParameterI(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] out UInt32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexParameterIuivEXT")]
            public static extern unsafe void GetMultiTexParameterI(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] UInt32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexParameterivEXT")]
            public static extern void GetMultiTexParameter(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexParameterivEXT")]
            public static extern void GetMultiTexParameter(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetMultiTexParameterivEXT")]
            public static extern unsafe void GetMultiTexParameter(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedBufferParameterivEXT")]
            public static extern void GetNamedBufferParameter(Int32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedBufferParameterivEXT")]
            public static extern void GetNamedBufferParameter(Int32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedBufferParameterivEXT")]
            public static extern unsafe void GetNamedBufferParameter(Int32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedBufferParameterivEXT")]
            public static extern void GetNamedBufferParameter(UInt32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedBufferParameterivEXT")]
            public static extern void GetNamedBufferParameter(UInt32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedBufferParameterivEXT")]
            public static extern unsafe void GetNamedBufferParameter(UInt32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedBufferPointervEXT")]
            public static extern void GetNamedBufferPointer(Int32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] IntPtr @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedBufferPointervEXT")]
            public static extern void GetNamedBufferPointer<T2>(Int32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [InAttribute, OutAttribute] T2[] @params)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedBufferPointervEXT")]
            public static extern void GetNamedBufferPointer<T2>(Int32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [InAttribute, OutAttribute] T2[,] @params)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedBufferPointervEXT")]
            public static extern void GetNamedBufferPointer<T2>(Int32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [InAttribute, OutAttribute] T2[,,] @params)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedBufferPointervEXT")]
            public static extern void GetNamedBufferPointer<T2>(Int32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [InAttribute, OutAttribute] ref T2 @params)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedBufferPointervEXT")]
            public static extern void GetNamedBufferPointer(UInt32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] IntPtr @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedBufferPointervEXT")]
            public static extern void GetNamedBufferPointer<T2>(UInt32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [InAttribute, OutAttribute] T2[] @params)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedBufferPointervEXT")]
            public static extern void GetNamedBufferPointer<T2>(UInt32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [InAttribute, OutAttribute] T2[,] @params)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedBufferPointervEXT")]
            public static extern void GetNamedBufferPointer<T2>(UInt32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [InAttribute, OutAttribute] T2[,,] @params)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedBufferPointervEXT")]
            public static extern void GetNamedBufferPointer<T2>(UInt32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [InAttribute, OutAttribute] ref T2 @params)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedBufferSubDataEXT")]
            public static extern void GetNamedBufferSubData(Int32 buffer, IntPtr offset, IntPtr size, [OutAttribute] IntPtr data);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedBufferSubDataEXT")]
            public static extern void GetNamedBufferSubData<T3>(Int32 buffer, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] T3[] data)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedBufferSubDataEXT")]
            public static extern void GetNamedBufferSubData<T3>(Int32 buffer, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] T3[,] data)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedBufferSubDataEXT")]
            public static extern void GetNamedBufferSubData<T3>(Int32 buffer, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] T3[,,] data)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedBufferSubDataEXT")]
            public static extern void GetNamedBufferSubData<T3>(Int32 buffer, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] ref T3 data)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedBufferSubDataEXT")]
            public static extern void GetNamedBufferSubData(UInt32 buffer, IntPtr offset, IntPtr size, [OutAttribute] IntPtr data);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedBufferSubDataEXT")]
            public static extern void GetNamedBufferSubData<T3>(UInt32 buffer, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] T3[] data)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedBufferSubDataEXT")]
            public static extern void GetNamedBufferSubData<T3>(UInt32 buffer, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] T3[,] data)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedBufferSubDataEXT")]
            public static extern void GetNamedBufferSubData<T3>(UInt32 buffer, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] T3[,,] data)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedBufferSubDataEXT")]
            public static extern void GetNamedBufferSubData<T3>(UInt32 buffer, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] ref T3 data)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedFramebufferAttachmentParameterivEXT")]
            public static extern void GetNamedFramebufferAttachmentParameter(Int32 framebuffer, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedFramebufferAttachmentParameterivEXT")]
            public static extern void GetNamedFramebufferAttachmentParameter(Int32 framebuffer, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedFramebufferAttachmentParameterivEXT")]
            public static extern unsafe void GetNamedFramebufferAttachmentParameter(Int32 framebuffer, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedFramebufferAttachmentParameterivEXT")]
            public static extern void GetNamedFramebufferAttachmentParameter(UInt32 framebuffer, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedFramebufferAttachmentParameterivEXT")]
            public static extern void GetNamedFramebufferAttachmentParameter(UInt32 framebuffer, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedFramebufferAttachmentParameterivEXT")]
            public static extern unsafe void GetNamedFramebufferAttachmentParameter(UInt32 framebuffer, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedFramebufferParameterivEXT")]
            public static extern void GetNamedFramebufferParameter(Int32 framebuffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedFramebufferParameterivEXT")]
            public static extern void GetNamedFramebufferParameter(Int32 framebuffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedFramebufferParameterivEXT")]
            public static extern unsafe void GetNamedFramebufferParameter(Int32 framebuffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedFramebufferParameterivEXT")]
            public static extern void GetNamedFramebufferParameter(UInt32 framebuffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedFramebufferParameterivEXT")]
            public static extern void GetNamedFramebufferParameter(UInt32 framebuffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedFramebufferParameterivEXT")]
            public static extern unsafe void GetNamedFramebufferParameter(UInt32 framebuffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use ProgramProperty overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramivEXT")]
            public static extern void GetNamedProgram(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use ProgramProperty overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramivEXT")]
            public static extern unsafe void GetNamedProgram(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramivEXT")]
            public static extern void GetNamedProgram(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, OpenTK.Graphics.OpenGL.ProgramProperty pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramivEXT")]
            public static extern unsafe void GetNamedProgram(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, OpenTK.Graphics.OpenGL.ProgramProperty pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use ProgramProperty overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramivEXT")]
            public static extern void GetNamedProgram(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use ProgramProperty overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramivEXT")]
            public static extern unsafe void GetNamedProgram(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramivEXT")]
            public static extern void GetNamedProgram(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, OpenTK.Graphics.OpenGL.ProgramProperty pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramivEXT")]
            public static extern unsafe void GetNamedProgram(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, OpenTK.Graphics.OpenGL.ProgramProperty pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramLocalParameterdvEXT")]
            public static extern void GetNamedProgramLocalParameter(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, [OutAttribute] Double[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramLocalParameterdvEXT")]
            public static extern void GetNamedProgramLocalParameter(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, [OutAttribute] out Double @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramLocalParameterdvEXT")]
            public static extern unsafe void GetNamedProgramLocalParameter(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, [OutAttribute] Double* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramLocalParameterdvEXT")]
            public static extern void GetNamedProgramLocalParameter(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, [OutAttribute] Double[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramLocalParameterdvEXT")]
            public static extern void GetNamedProgramLocalParameter(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, [OutAttribute] out Double @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramLocalParameterdvEXT")]
            public static extern unsafe void GetNamedProgramLocalParameter(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, [OutAttribute] Double* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramLocalParameterfvEXT")]
            public static extern void GetNamedProgramLocalParameter(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, [OutAttribute] Single[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramLocalParameterfvEXT")]
            public static extern void GetNamedProgramLocalParameter(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, [OutAttribute] out Single @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramLocalParameterfvEXT")]
            public static extern unsafe void GetNamedProgramLocalParameter(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, [OutAttribute] Single* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramLocalParameterfvEXT")]
            public static extern void GetNamedProgramLocalParameter(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, [OutAttribute] Single[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramLocalParameterfvEXT")]
            public static extern void GetNamedProgramLocalParameter(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, [OutAttribute] out Single @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramLocalParameterfvEXT")]
            public static extern unsafe void GetNamedProgramLocalParameter(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, [OutAttribute] Single* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramLocalParameterIivEXT")]
            public static extern void GetNamedProgramLocalParameterI(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, [OutAttribute] Int32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramLocalParameterIivEXT")]
            public static extern void GetNamedProgramLocalParameterI(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramLocalParameterIivEXT")]
            public static extern unsafe void GetNamedProgramLocalParameterI(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramLocalParameterIivEXT")]
            public static extern void GetNamedProgramLocalParameterI(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, [OutAttribute] Int32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramLocalParameterIivEXT")]
            public static extern void GetNamedProgramLocalParameterI(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramLocalParameterIivEXT")]
            public static extern unsafe void GetNamedProgramLocalParameterI(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramLocalParameterIuivEXT")]
            public static extern void GetNamedProgramLocalParameterI(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, [OutAttribute] UInt32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramLocalParameterIuivEXT")]
            public static extern void GetNamedProgramLocalParameterI(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, [OutAttribute] out UInt32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramLocalParameterIuivEXT")]
            public static extern unsafe void GetNamedProgramLocalParameterI(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, [OutAttribute] UInt32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramStringEXT")]
            public static extern void GetNamedProgramString(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] IntPtr @string);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramStringEXT")]
            public static extern void GetNamedProgramString<T3>(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [InAttribute, OutAttribute] T3[] @string)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramStringEXT")]
            public static extern void GetNamedProgramString<T3>(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [InAttribute, OutAttribute] T3[,] @string)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramStringEXT")]
            public static extern void GetNamedProgramString<T3>(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [InAttribute, OutAttribute] T3[,,] @string)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramStringEXT")]
            public static extern void GetNamedProgramString<T3>(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [InAttribute, OutAttribute] ref T3 @string)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramStringEXT")]
            public static extern void GetNamedProgramString(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] IntPtr @string);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramStringEXT")]
            public static extern void GetNamedProgramString<T3>(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [InAttribute, OutAttribute] T3[] @string)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramStringEXT")]
            public static extern void GetNamedProgramString<T3>(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [InAttribute, OutAttribute] T3[,] @string)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramStringEXT")]
            public static extern void GetNamedProgramString<T3>(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [InAttribute, OutAttribute] T3[,,] @string)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedProgramStringEXT")]
            public static extern void GetNamedProgramString<T3>(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [InAttribute, OutAttribute] ref T3 @string)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedRenderbufferParameterivEXT")]
            public static extern void GetNamedRenderbufferParameter(Int32 renderbuffer, OpenTK.Graphics.OpenGL.RenderbufferParameterName pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedRenderbufferParameterivEXT")]
            public static extern void GetNamedRenderbufferParameter(Int32 renderbuffer, OpenTK.Graphics.OpenGL.RenderbufferParameterName pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedRenderbufferParameterivEXT")]
            public static extern unsafe void GetNamedRenderbufferParameter(Int32 renderbuffer, OpenTK.Graphics.OpenGL.RenderbufferParameterName pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedRenderbufferParameterivEXT")]
            public static extern void GetNamedRenderbufferParameter(UInt32 renderbuffer, OpenTK.Graphics.OpenGL.RenderbufferParameterName pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedRenderbufferParameterivEXT")]
            public static extern void GetNamedRenderbufferParameter(UInt32 renderbuffer, OpenTK.Graphics.OpenGL.RenderbufferParameterName pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetNamedRenderbufferParameterivEXT")]
            public static extern unsafe void GetNamedRenderbufferParameter(UInt32 renderbuffer, OpenTK.Graphics.OpenGL.RenderbufferParameterName pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_debug_label]
            /// Retrieve the label of a named object identified within a namespace
            /// </summary>
            /// <param name="identifier">
            /// <para>
            /// The namespace from which the name of the object is allocated.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// The name of the object whose label to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The length of the buffer whose address is in label.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable to receive the length of the object label.
            /// </para>
            /// </param>
            /// <param name="label">
            /// <para>
            /// The address of a string that will receive the object label.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_debug_label", Version = "", EntryPoint = "glGetObjectLabelEXT")]
            public static extern void GetObjectLabel(OpenTK.Graphics.OpenGL.ExtDebugLabel type, Int32 @object, Int32 bufSize, [OutAttribute] Int32[] length, [OutAttribute] StringBuilder label);

            /// <summary>[requires: EXT_debug_label]
            /// Retrieve the label of a named object identified within a namespace
            /// </summary>
            /// <param name="identifier">
            /// <para>
            /// The namespace from which the name of the object is allocated.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// The name of the object whose label to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The length of the buffer whose address is in label.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable to receive the length of the object label.
            /// </para>
            /// </param>
            /// <param name="label">
            /// <para>
            /// The address of a string that will receive the object label.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_debug_label", Version = "", EntryPoint = "glGetObjectLabelEXT")]
            public static extern void GetObjectLabel(OpenTK.Graphics.OpenGL.ExtDebugLabel type, Int32 @object, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder label);

            /// <summary>[requires: EXT_debug_label]
            /// Retrieve the label of a named object identified within a namespace
            /// </summary>
            /// <param name="identifier">
            /// <para>
            /// The namespace from which the name of the object is allocated.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// The name of the object whose label to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The length of the buffer whose address is in label.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable to receive the length of the object label.
            /// </para>
            /// </param>
            /// <param name="label">
            /// <para>
            /// The address of a string that will receive the object label.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_debug_label", Version = "", EntryPoint = "glGetObjectLabelEXT")]
            public static extern unsafe void GetObjectLabel(OpenTK.Graphics.OpenGL.ExtDebugLabel type, Int32 @object, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder label);

            /// <summary>[requires: EXT_debug_label]
            /// Retrieve the label of a named object identified within a namespace
            /// </summary>
            /// <param name="identifier">
            /// <para>
            /// The namespace from which the name of the object is allocated.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// The name of the object whose label to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The length of the buffer whose address is in label.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable to receive the length of the object label.
            /// </para>
            /// </param>
            /// <param name="label">
            /// <para>
            /// The address of a string that will receive the object label.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_debug_label", Version = "", EntryPoint = "glGetObjectLabelEXT")]
            public static extern void GetObjectLabel(OpenTK.Graphics.OpenGL.ExtDebugLabel type, UInt32 @object, Int32 bufSize, [OutAttribute] Int32[] length, [OutAttribute] StringBuilder label);

            /// <summary>[requires: EXT_debug_label]
            /// Retrieve the label of a named object identified within a namespace
            /// </summary>
            /// <param name="identifier">
            /// <para>
            /// The namespace from which the name of the object is allocated.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// The name of the object whose label to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The length of the buffer whose address is in label.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable to receive the length of the object label.
            /// </para>
            /// </param>
            /// <param name="label">
            /// <para>
            /// The address of a string that will receive the object label.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_debug_label", Version = "", EntryPoint = "glGetObjectLabelEXT")]
            public static extern void GetObjectLabel(OpenTK.Graphics.OpenGL.ExtDebugLabel type, UInt32 @object, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder label);

            /// <summary>[requires: EXT_debug_label]
            /// Retrieve the label of a named object identified within a namespace
            /// </summary>
            /// <param name="identifier">
            /// <para>
            /// The namespace from which the name of the object is allocated.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// The name of the object whose label to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The length of the buffer whose address is in label.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable to receive the length of the object label.
            /// </para>
            /// </param>
            /// <param name="label">
            /// <para>
            /// The address of a string that will receive the object label.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_debug_label", Version = "", EntryPoint = "glGetObjectLabelEXT")]
            public static extern unsafe void GetObjectLabel(OpenTK.Graphics.OpenGL.ExtDebugLabel type, UInt32 @object, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder label);

            /// <summary>[requires: EXT_pixel_transform]</summary>
            [AutoGenerated(Category = "EXT_pixel_transform", Version = "", EntryPoint = "glGetPixelTransformParameterfvEXT")]
            public static extern void GetPixelTransformParameter(OpenTK.Graphics.OpenGL.ExtPixelTransform target, OpenTK.Graphics.OpenGL.ExtPixelTransform pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: EXT_pixel_transform]</summary>
            [AutoGenerated(Category = "EXT_pixel_transform", Version = "", EntryPoint = "glGetPixelTransformParameterfvEXT")]
            public static extern void GetPixelTransformParameter(OpenTK.Graphics.OpenGL.ExtPixelTransform target, OpenTK.Graphics.OpenGL.ExtPixelTransform pname, [OutAttribute] out Single @params);

            /// <summary>[requires: EXT_pixel_transform]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_pixel_transform", Version = "", EntryPoint = "glGetPixelTransformParameterfvEXT")]
            public static extern unsafe void GetPixelTransformParameter(OpenTK.Graphics.OpenGL.ExtPixelTransform target, OpenTK.Graphics.OpenGL.ExtPixelTransform pname, [OutAttribute] Single* @params);

            /// <summary>[requires: EXT_pixel_transform]</summary>
            [AutoGenerated(Category = "EXT_pixel_transform", Version = "", EntryPoint = "glGetPixelTransformParameterivEXT")]
            public static extern void GetPixelTransformParameter(OpenTK.Graphics.OpenGL.ExtPixelTransform target, OpenTK.Graphics.OpenGL.ExtPixelTransform pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: EXT_pixel_transform]</summary>
            [AutoGenerated(Category = "EXT_pixel_transform", Version = "", EntryPoint = "glGetPixelTransformParameterivEXT")]
            public static extern void GetPixelTransformParameter(OpenTK.Graphics.OpenGL.ExtPixelTransform target, OpenTK.Graphics.OpenGL.ExtPixelTransform pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_pixel_transform]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_pixel_transform", Version = "", EntryPoint = "glGetPixelTransformParameterivEXT")]
            public static extern unsafe void GetPixelTransformParameter(OpenTK.Graphics.OpenGL.ExtPixelTransform target, OpenTK.Graphics.OpenGL.ExtPixelTransform pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetPointeri_vEXT")]
            public static extern void GetPointer(OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, Int32 index, [OutAttribute] IntPtr @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetPointeri_vEXT")]
            public static extern void GetPointer<T2>(OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, Int32 index, [InAttribute, OutAttribute] T2[] @params)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetPointeri_vEXT")]
            public static extern void GetPointer<T2>(OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, Int32 index, [InAttribute, OutAttribute] T2[,] @params)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetPointeri_vEXT")]
            public static extern void GetPointer<T2>(OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, Int32 index, [InAttribute, OutAttribute] T2[,,] @params)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetPointeri_vEXT")]
            public static extern void GetPointer<T2>(OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, Int32 index, [InAttribute, OutAttribute] ref T2 @params)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetPointeri_vEXT")]
            public static extern void GetPointer(OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, UInt32 index, [OutAttribute] IntPtr @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetPointeri_vEXT")]
            public static extern void GetPointer<T2>(OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, UInt32 index, [InAttribute, OutAttribute] T2[] @params)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetPointeri_vEXT")]
            public static extern void GetPointer<T2>(OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, UInt32 index, [InAttribute, OutAttribute] T2[,] @params)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetPointeri_vEXT")]
            public static extern void GetPointer<T2>(OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, UInt32 index, [InAttribute, OutAttribute] T2[,,] @params)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetPointeri_vEXT")]
            public static extern void GetPointer<T2>(OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, UInt32 index, [InAttribute, OutAttribute] ref T2 @params)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetPointerIndexedvEXT")]
            public static extern void GetPointerIndexed(OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, [OutAttribute] IntPtr data);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetPointerIndexedvEXT")]
            public static extern void GetPointerIndexed<T2>(OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, [InAttribute, OutAttribute] T2[] data)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetPointerIndexedvEXT")]
            public static extern void GetPointerIndexed<T2>(OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, [InAttribute, OutAttribute] T2[,] data)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetPointerIndexedvEXT")]
            public static extern void GetPointerIndexed<T2>(OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, [InAttribute, OutAttribute] T2[,,] data)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetPointerIndexedvEXT")]
            public static extern void GetPointerIndexed<T2>(OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, [InAttribute, OutAttribute] ref T2 data)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetPointerIndexedvEXT")]
            public static extern void GetPointerIndexed(OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, [OutAttribute] IntPtr data);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetPointerIndexedvEXT")]
            public static extern void GetPointerIndexed<T2>(OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, [InAttribute, OutAttribute] T2[] data)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetPointerIndexedvEXT")]
            public static extern void GetPointerIndexed<T2>(OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, [InAttribute, OutAttribute] T2[,] data)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetPointerIndexedvEXT")]
            public static extern void GetPointerIndexed<T2>(OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, [InAttribute, OutAttribute] T2[,,] data)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetPointerIndexedvEXT")]
            public static extern void GetPointerIndexed<T2>(OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, [InAttribute, OutAttribute] ref T2 data)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_vertex_array]</summary>
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glGetPointervEXT")]
            public static extern void GetPointer(OpenTK.Graphics.OpenGL.GetPointervPName pname, [OutAttribute] IntPtr @params);

            /// <summary>[requires: EXT_vertex_array]</summary>
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glGetPointervEXT")]
            public static extern void GetPointer<T1>(OpenTK.Graphics.OpenGL.GetPointervPName pname, [InAttribute, OutAttribute] T1[] @params)
                where T1 : struct
            ;

            /// <summary>[requires: EXT_vertex_array]</summary>
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glGetPointervEXT")]
            public static extern void GetPointer<T1>(OpenTK.Graphics.OpenGL.GetPointervPName pname, [InAttribute, OutAttribute] T1[,] @params)
                where T1 : struct
            ;

            /// <summary>[requires: EXT_vertex_array]</summary>
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glGetPointervEXT")]
            public static extern void GetPointer<T1>(OpenTK.Graphics.OpenGL.GetPointervPName pname, [InAttribute, OutAttribute] T1[,,] @params)
                where T1 : struct
            ;

            /// <summary>[requires: EXT_vertex_array]</summary>
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glGetPointervEXT")]
            public static extern void GetPointer<T1>(OpenTK.Graphics.OpenGL.GetPointervPName pname, [InAttribute, OutAttribute] ref T1 @params)
                where T1 : struct
            ;

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Retrieve the info log string from a program pipeline object
            /// </summary>
            /// <param name="pipeline">
            /// <para>
            /// Specifies the name of a program pipeline object from which to retrieve the info log.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// Specifies the maximum number of characters, including the null terminator, that may be written into infoLog.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// Specifies the address of a variable into which will be written the number of characters written into infoLog.
            /// </para>
            /// </param>
            /// <param name="infoLog">
            /// <para>
            /// Specifies the address of an array of characters into which will be written the info log for pipeline.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glGetProgramPipelineInfoLogEXT")]
            public static extern void GetProgramPipelineInfoLog(Int32 pipeline, Int32 bufSize, [OutAttribute] Int32[] length, [OutAttribute] StringBuilder infoLog);

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Retrieve the info log string from a program pipeline object
            /// </summary>
            /// <param name="pipeline">
            /// <para>
            /// Specifies the name of a program pipeline object from which to retrieve the info log.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// Specifies the maximum number of characters, including the null terminator, that may be written into infoLog.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// Specifies the address of a variable into which will be written the number of characters written into infoLog.
            /// </para>
            /// </param>
            /// <param name="infoLog">
            /// <para>
            /// Specifies the address of an array of characters into which will be written the info log for pipeline.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glGetProgramPipelineInfoLogEXT")]
            public static extern void GetProgramPipelineInfoLog(Int32 pipeline, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder infoLog);

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Retrieve the info log string from a program pipeline object
            /// </summary>
            /// <param name="pipeline">
            /// <para>
            /// Specifies the name of a program pipeline object from which to retrieve the info log.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// Specifies the maximum number of characters, including the null terminator, that may be written into infoLog.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// Specifies the address of a variable into which will be written the number of characters written into infoLog.
            /// </para>
            /// </param>
            /// <param name="infoLog">
            /// <para>
            /// Specifies the address of an array of characters into which will be written the info log for pipeline.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glGetProgramPipelineInfoLogEXT")]
            public static extern unsafe void GetProgramPipelineInfoLog(Int32 pipeline, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder infoLog);

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Retrieve the info log string from a program pipeline object
            /// </summary>
            /// <param name="pipeline">
            /// <para>
            /// Specifies the name of a program pipeline object from which to retrieve the info log.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// Specifies the maximum number of characters, including the null terminator, that may be written into infoLog.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// Specifies the address of a variable into which will be written the number of characters written into infoLog.
            /// </para>
            /// </param>
            /// <param name="infoLog">
            /// <para>
            /// Specifies the address of an array of characters into which will be written the info log for pipeline.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glGetProgramPipelineInfoLogEXT")]
            public static extern void GetProgramPipelineInfoLog(UInt32 pipeline, Int32 bufSize, [OutAttribute] Int32[] length, [OutAttribute] StringBuilder infoLog);

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Retrieve the info log string from a program pipeline object
            /// </summary>
            /// <param name="pipeline">
            /// <para>
            /// Specifies the name of a program pipeline object from which to retrieve the info log.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// Specifies the maximum number of characters, including the null terminator, that may be written into infoLog.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// Specifies the address of a variable into which will be written the number of characters written into infoLog.
            /// </para>
            /// </param>
            /// <param name="infoLog">
            /// <para>
            /// Specifies the address of an array of characters into which will be written the info log for pipeline.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glGetProgramPipelineInfoLogEXT")]
            public static extern void GetProgramPipelineInfoLog(UInt32 pipeline, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder infoLog);

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Retrieve the info log string from a program pipeline object
            /// </summary>
            /// <param name="pipeline">
            /// <para>
            /// Specifies the name of a program pipeline object from which to retrieve the info log.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// Specifies the maximum number of characters, including the null terminator, that may be written into infoLog.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// Specifies the address of a variable into which will be written the number of characters written into infoLog.
            /// </para>
            /// </param>
            /// <param name="infoLog">
            /// <para>
            /// Specifies the address of an array of characters into which will be written the info log for pipeline.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glGetProgramPipelineInfoLogEXT")]
            public static extern unsafe void GetProgramPipelineInfoLog(UInt32 pipeline, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder infoLog);

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Retrieve properties of a program pipeline object
            /// </summary>
            /// <param name="pipeline">
            /// <para>
            /// Specifies the name of a program pipeline object whose parameter retrieve.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the name of the parameter to retrieve.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Specifies the address of a variable into which will be written the value or values of pname for pipeline.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glGetProgramPipelineivEXT")]
            public static extern void GetProgramPipeline(Int32 pipeline, OpenTK.Graphics.OpenGL.ExtSeparateShaderObjects pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Retrieve properties of a program pipeline object
            /// </summary>
            /// <param name="pipeline">
            /// <para>
            /// Specifies the name of a program pipeline object whose parameter retrieve.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the name of the parameter to retrieve.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Specifies the address of a variable into which will be written the value or values of pname for pipeline.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glGetProgramPipelineivEXT")]
            public static extern void GetProgramPipeline(Int32 pipeline, OpenTK.Graphics.OpenGL.ExtSeparateShaderObjects pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Retrieve properties of a program pipeline object
            /// </summary>
            /// <param name="pipeline">
            /// <para>
            /// Specifies the name of a program pipeline object whose parameter retrieve.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the name of the parameter to retrieve.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Specifies the address of a variable into which will be written the value or values of pname for pipeline.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glGetProgramPipelineivEXT")]
            public static extern unsafe void GetProgramPipeline(Int32 pipeline, OpenTK.Graphics.OpenGL.ExtSeparateShaderObjects pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Retrieve properties of a program pipeline object
            /// </summary>
            /// <param name="pipeline">
            /// <para>
            /// Specifies the name of a program pipeline object whose parameter retrieve.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the name of the parameter to retrieve.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Specifies the address of a variable into which will be written the value or values of pname for pipeline.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glGetProgramPipelineivEXT")]
            public static extern void GetProgramPipeline(UInt32 pipeline, OpenTK.Graphics.OpenGL.ExtSeparateShaderObjects pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Retrieve properties of a program pipeline object
            /// </summary>
            /// <param name="pipeline">
            /// <para>
            /// Specifies the name of a program pipeline object whose parameter retrieve.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the name of the parameter to retrieve.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Specifies the address of a variable into which will be written the value or values of pname for pipeline.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glGetProgramPipelineivEXT")]
            public static extern void GetProgramPipeline(UInt32 pipeline, OpenTK.Graphics.OpenGL.ExtSeparateShaderObjects pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Retrieve properties of a program pipeline object
            /// </summary>
            /// <param name="pipeline">
            /// <para>
            /// Specifies the name of a program pipeline object whose parameter retrieve.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the name of the parameter to retrieve.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Specifies the address of a variable into which will be written the value or values of pname for pipeline.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glGetProgramPipelineivEXT")]
            public static extern unsafe void GetProgramPipeline(UInt32 pipeline, OpenTK.Graphics.OpenGL.ExtSeparateShaderObjects pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_timer_query]
            /// Return parameters of a query object
            /// </summary>
            /// <param name="id">
            /// <para>
            /// Specifies the name of a query object.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_timer_query", Version = "", EntryPoint = "glGetQueryObjecti64vEXT")]
            public static extern void GetQueryObject(Int32 id, OpenTK.Graphics.OpenGL.ExtTimerQuery pname, [OutAttribute] Int64[] @params);

            /// <summary>[requires: EXT_timer_query]
            /// Return parameters of a query object
            /// </summary>
            /// <param name="id">
            /// <para>
            /// Specifies the name of a query object.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_timer_query", Version = "", EntryPoint = "glGetQueryObjecti64vEXT")]
            public static extern void GetQueryObject(Int32 id, OpenTK.Graphics.OpenGL.ExtTimerQuery pname, [OutAttribute] out Int64 @params);

            /// <summary>[requires: EXT_timer_query]
            /// Return parameters of a query object
            /// </summary>
            /// <param name="id">
            /// <para>
            /// Specifies the name of a query object.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_timer_query", Version = "", EntryPoint = "glGetQueryObjecti64vEXT")]
            public static extern unsafe void GetQueryObject(Int32 id, OpenTK.Graphics.OpenGL.ExtTimerQuery pname, [OutAttribute] Int64* @params);

            /// <summary>[requires: EXT_timer_query]
            /// Return parameters of a query object
            /// </summary>
            /// <param name="id">
            /// <para>
            /// Specifies the name of a query object.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_timer_query", Version = "", EntryPoint = "glGetQueryObjecti64vEXT")]
            public static extern void GetQueryObject(UInt32 id, OpenTK.Graphics.OpenGL.ExtTimerQuery pname, [OutAttribute] Int64[] @params);

            /// <summary>[requires: EXT_timer_query]
            /// Return parameters of a query object
            /// </summary>
            /// <param name="id">
            /// <para>
            /// Specifies the name of a query object.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_timer_query", Version = "", EntryPoint = "glGetQueryObjecti64vEXT")]
            public static extern void GetQueryObject(UInt32 id, OpenTK.Graphics.OpenGL.ExtTimerQuery pname, [OutAttribute] out Int64 @params);

            /// <summary>[requires: EXT_timer_query]
            /// Return parameters of a query object
            /// </summary>
            /// <param name="id">
            /// <para>
            /// Specifies the name of a query object.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_timer_query", Version = "", EntryPoint = "glGetQueryObjecti64vEXT")]
            public static extern unsafe void GetQueryObject(UInt32 id, OpenTK.Graphics.OpenGL.ExtTimerQuery pname, [OutAttribute] Int64* @params);

            /// <summary>[requires: EXT_timer_query]
            /// Return parameters of a query object
            /// </summary>
            /// <param name="id">
            /// <para>
            /// Specifies the name of a query object.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_timer_query", Version = "", EntryPoint = "glGetQueryObjectui64vEXT")]
            public static extern void GetQueryObject(UInt32 id, OpenTK.Graphics.OpenGL.ExtTimerQuery pname, [OutAttribute] UInt64[] @params);

            /// <summary>[requires: EXT_timer_query]
            /// Return parameters of a query object
            /// </summary>
            /// <param name="id">
            /// <para>
            /// Specifies the name of a query object.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_timer_query", Version = "", EntryPoint = "glGetQueryObjectui64vEXT")]
            public static extern void GetQueryObject(UInt32 id, OpenTK.Graphics.OpenGL.ExtTimerQuery pname, [OutAttribute] out UInt64 @params);

            /// <summary>[requires: EXT_timer_query]
            /// Return parameters of a query object
            /// </summary>
            /// <param name="id">
            /// <para>
            /// Specifies the name of a query object.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of a query object parameter. Accepted values are GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// If a buffer is bound to the GL_QUERY_RESULT_BUFFER target, then params is treated as an offset to a location within that buffer's data store to receive the result of the query. If no buffer is bound to GL_QUERY_RESULT_BUFFER, then params is treated as an address in client memory of a variable to receive the resulting data.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_timer_query", Version = "", EntryPoint = "glGetQueryObjectui64vEXT")]
            public static extern unsafe void GetQueryObject(UInt32 id, OpenTK.Graphics.OpenGL.ExtTimerQuery pname, [OutAttribute] UInt64* @params);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Retrieve information about a bound renderbuffer object
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target of the query operation. target must be GL_RENDERBUFFER.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the parameter whose value to retrieve from the renderbuffer bound to target.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Specifies the address of an array to receive the value of the queried parameter.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glGetRenderbufferParameterivEXT")]
            public static extern void GetRenderbufferParameter(OpenTK.Graphics.OpenGL.RenderbufferTarget target, OpenTK.Graphics.OpenGL.RenderbufferParameterName pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Retrieve information about a bound renderbuffer object
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target of the query operation. target must be GL_RENDERBUFFER.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the parameter whose value to retrieve from the renderbuffer bound to target.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Specifies the address of an array to receive the value of the queried parameter.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glGetRenderbufferParameterivEXT")]
            public static extern void GetRenderbufferParameter(OpenTK.Graphics.OpenGL.RenderbufferTarget target, OpenTK.Graphics.OpenGL.RenderbufferParameterName pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Retrieve information about a bound renderbuffer object
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target of the query operation. target must be GL_RENDERBUFFER.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the parameter whose value to retrieve from the renderbuffer bound to target.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Specifies the address of an array to receive the value of the queried parameter.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glGetRenderbufferParameterivEXT")]
            public static extern unsafe void GetRenderbufferParameter(OpenTK.Graphics.OpenGL.RenderbufferTarget target, OpenTK.Graphics.OpenGL.RenderbufferParameterName pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_convolution]
            /// Get separable convolution filter kernel images
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The separable filter to be retrieved. Must be GL_SEPARABLE_2D.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Format of the output images. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Data type of components in the output images. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="row">
            /// <para>
            /// Pointer to storage for the row filter image.
            /// </para>
            /// </param>
            /// <param name="column">
            /// <para>
            /// Pointer to storage for the column filter image.
            /// </para>
            /// </param>
            /// <param name="span">
            /// <para>
            /// Pointer to storage for the span filter image (currently unused).
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glGetSeparableFilterEXT")]
            public static extern void GetSeparableFilter(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [OutAttribute] IntPtr row, [OutAttribute] IntPtr column, [OutAttribute] IntPtr span);

            /// <summary>[requires: EXT_convolution]
            /// Get separable convolution filter kernel images
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The separable filter to be retrieved. Must be GL_SEPARABLE_2D.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Format of the output images. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Data type of components in the output images. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="row">
            /// <para>
            /// Pointer to storage for the row filter image.
            /// </para>
            /// </param>
            /// <param name="column">
            /// <para>
            /// Pointer to storage for the column filter image.
            /// </para>
            /// </param>
            /// <param name="span">
            /// <para>
            /// Pointer to storage for the span filter image (currently unused).
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glGetSeparableFilterEXT")]
            public static extern void GetSeparableFilter<T3,T4,T5>(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T3[] row, [InAttribute, OutAttribute] T4[] column, [InAttribute, OutAttribute] T5[] span)
                where T3 : struct
                where T4 : struct
                where T5 : struct
            ;

            /// <summary>[requires: EXT_convolution]
            /// Get separable convolution filter kernel images
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The separable filter to be retrieved. Must be GL_SEPARABLE_2D.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Format of the output images. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Data type of components in the output images. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="row">
            /// <para>
            /// Pointer to storage for the row filter image.
            /// </para>
            /// </param>
            /// <param name="column">
            /// <para>
            /// Pointer to storage for the column filter image.
            /// </para>
            /// </param>
            /// <param name="span">
            /// <para>
            /// Pointer to storage for the span filter image (currently unused).
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glGetSeparableFilterEXT")]
            public static extern void GetSeparableFilter<T3,T4,T5>(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T3[,] row, [InAttribute, OutAttribute] T4[,] column, [InAttribute, OutAttribute] T5[,] span)
                where T3 : struct
                where T4 : struct
                where T5 : struct
            ;

            /// <summary>[requires: EXT_convolution]
            /// Get separable convolution filter kernel images
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The separable filter to be retrieved. Must be GL_SEPARABLE_2D.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Format of the output images. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Data type of components in the output images. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="row">
            /// <para>
            /// Pointer to storage for the row filter image.
            /// </para>
            /// </param>
            /// <param name="column">
            /// <para>
            /// Pointer to storage for the column filter image.
            /// </para>
            /// </param>
            /// <param name="span">
            /// <para>
            /// Pointer to storage for the span filter image (currently unused).
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glGetSeparableFilterEXT")]
            public static extern void GetSeparableFilter<T3,T4,T5>(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T3[,,] row, [InAttribute, OutAttribute] T4[,,] column, [InAttribute, OutAttribute] T5[,,] span)
                where T3 : struct
                where T4 : struct
                where T5 : struct
            ;

            /// <summary>[requires: EXT_convolution]
            /// Get separable convolution filter kernel images
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The separable filter to be retrieved. Must be GL_SEPARABLE_2D.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Format of the output images. Must be one of GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR GL_RGBA, GL_BGRA, GL_LUMINANCE, or GL_LUMINANCE_ALPHA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Data type of components in the output images. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="row">
            /// <para>
            /// Pointer to storage for the row filter image.
            /// </para>
            /// </param>
            /// <param name="column">
            /// <para>
            /// Pointer to storage for the column filter image.
            /// </para>
            /// </param>
            /// <param name="span">
            /// <para>
            /// Pointer to storage for the span filter image (currently unused).
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glGetSeparableFilterEXT")]
            public static extern void GetSeparableFilter<T3,T4,T5>(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T3 row, [InAttribute, OutAttribute] ref T4 column, [InAttribute, OutAttribute] ref T5 span)
                where T3 : struct
                where T4 : struct
                where T5 : struct
            ;

            /// <summary>[requires: EXT_texture_integer]</summary>
            [AutoGenerated(Category = "EXT_texture_integer", Version = "", EntryPoint = "glGetTexParameterIivEXT")]
            public static extern void GetTexParameterI(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: EXT_texture_integer]</summary>
            [AutoGenerated(Category = "EXT_texture_integer", Version = "", EntryPoint = "glGetTexParameterIivEXT")]
            public static extern void GetTexParameterI(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_texture_integer]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_texture_integer", Version = "", EntryPoint = "glGetTexParameterIivEXT")]
            public static extern unsafe void GetTexParameterI(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_texture_integer]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_texture_integer", Version = "", EntryPoint = "glGetTexParameterIuivEXT")]
            public static extern void GetTexParameterI(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] UInt32[] @params);

            /// <summary>[requires: EXT_texture_integer]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_texture_integer", Version = "", EntryPoint = "glGetTexParameterIuivEXT")]
            public static extern void GetTexParameterI(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] out UInt32 @params);

            /// <summary>[requires: EXT_texture_integer]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_texture_integer", Version = "", EntryPoint = "glGetTexParameterIuivEXT")]
            public static extern unsafe void GetTexParameterI(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] UInt32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureImageEXT")]
            public static extern void GetTextureImage(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [OutAttribute] IntPtr pixels);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureImageEXT")]
            public static extern void GetTextureImage<T5>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T5[] pixels)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureImageEXT")]
            public static extern void GetTextureImage<T5>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T5[,] pixels)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureImageEXT")]
            public static extern void GetTextureImage<T5>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T5[,,] pixels)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureImageEXT")]
            public static extern void GetTextureImage<T5>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T5 pixels)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureImageEXT")]
            public static extern void GetTextureImage(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [OutAttribute] IntPtr pixels);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureImageEXT")]
            public static extern void GetTextureImage<T5>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T5[] pixels)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureImageEXT")]
            public static extern void GetTextureImage<T5>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T5[,] pixels)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureImageEXT")]
            public static extern void GetTextureImage<T5>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T5[,,] pixels)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureImageEXT")]
            public static extern void GetTextureImage<T5>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T5 pixels)
                where T5 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureLevelParameterfvEXT")]
            public static extern void GetTextureLevelParameter(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureLevelParameterfvEXT")]
            public static extern void GetTextureLevelParameter(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] out Single @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureLevelParameterfvEXT")]
            public static extern unsafe void GetTextureLevelParameter(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Single* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureLevelParameterfvEXT")]
            public static extern void GetTextureLevelParameter(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureLevelParameterfvEXT")]
            public static extern void GetTextureLevelParameter(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] out Single @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureLevelParameterfvEXT")]
            public static extern unsafe void GetTextureLevelParameter(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Single* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureLevelParameterivEXT")]
            public static extern void GetTextureLevelParameter(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureLevelParameterivEXT")]
            public static extern void GetTextureLevelParameter(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureLevelParameterivEXT")]
            public static extern unsafe void GetTextureLevelParameter(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureLevelParameterivEXT")]
            public static extern void GetTextureLevelParameter(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureLevelParameterivEXT")]
            public static extern void GetTextureLevelParameter(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureLevelParameterivEXT")]
            public static extern unsafe void GetTextureLevelParameter(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureParameterfvEXT")]
            public static extern void GetTextureParameter(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureParameterfvEXT")]
            public static extern void GetTextureParameter(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] out Single @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureParameterfvEXT")]
            public static extern unsafe void GetTextureParameter(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Single* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureParameterfvEXT")]
            public static extern void GetTextureParameter(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureParameterfvEXT")]
            public static extern void GetTextureParameter(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] out Single @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureParameterfvEXT")]
            public static extern unsafe void GetTextureParameter(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Single* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureParameterIivEXT")]
            public static extern void GetTextureParameterI(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureParameterIivEXT")]
            public static extern void GetTextureParameterI(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureParameterIivEXT")]
            public static extern unsafe void GetTextureParameterI(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureParameterIivEXT")]
            public static extern void GetTextureParameterI(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureParameterIivEXT")]
            public static extern void GetTextureParameterI(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureParameterIivEXT")]
            public static extern unsafe void GetTextureParameterI(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureParameterIuivEXT")]
            public static extern void GetTextureParameterI(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] UInt32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureParameterIuivEXT")]
            public static extern void GetTextureParameterI(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] out UInt32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureParameterIuivEXT")]
            public static extern unsafe void GetTextureParameterI(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] UInt32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureParameterivEXT")]
            public static extern void GetTextureParameter(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureParameterivEXT")]
            public static extern void GetTextureParameter(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureParameterivEXT")]
            public static extern unsafe void GetTextureParameter(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureParameterivEXT")]
            public static extern void GetTextureParameter(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureParameterivEXT")]
            public static extern void GetTextureParameter(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetTextureParameterivEXT")]
            public static extern unsafe void GetTextureParameter(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_transform_feedback]
            /// Retrieve information about varying variables selected for transform feedback
            /// </summary>
            /// <param name="program">
            /// <para>
            /// The name of the target program object.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// The index of the varying variable whose information to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The maximum number of characters, including the null terminator, that may be written into name.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable which will receive the number of characters written into name, excluding the null-terminator. If length is NULL no length is returned.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// The address of a variable that will receive the size of the varying.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The address of a variable that will recieve the type of the varying.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// The address of a buffer into which will be written the name of the varying.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_transform_feedback", Version = "", EntryPoint = "glGetTransformFeedbackVaryingEXT")]
            public static extern void GetTransformFeedbackVarying(Int32 program, Int32 index, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] out Int32 size, [OutAttribute] out OpenTK.Graphics.OpenGL.ActiveAttribType type, [OutAttribute] StringBuilder name);

            /// <summary>[requires: EXT_transform_feedback]
            /// Retrieve information about varying variables selected for transform feedback
            /// </summary>
            /// <param name="program">
            /// <para>
            /// The name of the target program object.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// The index of the varying variable whose information to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The maximum number of characters, including the null terminator, that may be written into name.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable which will receive the number of characters written into name, excluding the null-terminator. If length is NULL no length is returned.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// The address of a variable that will receive the size of the varying.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The address of a variable that will recieve the type of the varying.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// The address of a buffer into which will be written the name of the varying.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_transform_feedback", Version = "", EntryPoint = "glGetTransformFeedbackVaryingEXT")]
            public static extern void GetTransformFeedbackVarying(Int32 program, Int32 index, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] out Int32 size, [OutAttribute] out OpenTK.Graphics.OpenGL.ExtTransformFeedback type, [OutAttribute] StringBuilder name);

            /// <summary>[requires: EXT_transform_feedback]
            /// Retrieve information about varying variables selected for transform feedback
            /// </summary>
            /// <param name="program">
            /// <para>
            /// The name of the target program object.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// The index of the varying variable whose information to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The maximum number of characters, including the null terminator, that may be written into name.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable which will receive the number of characters written into name, excluding the null-terminator. If length is NULL no length is returned.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// The address of a variable that will receive the size of the varying.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The address of a variable that will recieve the type of the varying.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// The address of a buffer into which will be written the name of the varying.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_transform_feedback", Version = "", EntryPoint = "glGetTransformFeedbackVaryingEXT")]
            public static extern unsafe void GetTransformFeedbackVarying(Int32 program, Int32 index, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] Int32* size, [OutAttribute] OpenTK.Graphics.OpenGL.ActiveAttribType* type, [OutAttribute] StringBuilder name);

            /// <summary>[requires: EXT_transform_feedback]
            /// Retrieve information about varying variables selected for transform feedback
            /// </summary>
            /// <param name="program">
            /// <para>
            /// The name of the target program object.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// The index of the varying variable whose information to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The maximum number of characters, including the null terminator, that may be written into name.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable which will receive the number of characters written into name, excluding the null-terminator. If length is NULL no length is returned.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// The address of a variable that will receive the size of the varying.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The address of a variable that will recieve the type of the varying.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// The address of a buffer into which will be written the name of the varying.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_transform_feedback", Version = "", EntryPoint = "glGetTransformFeedbackVaryingEXT")]
            public static extern unsafe void GetTransformFeedbackVarying(Int32 program, Int32 index, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] Int32* size, [OutAttribute] OpenTK.Graphics.OpenGL.ExtTransformFeedback* type, [OutAttribute] StringBuilder name);

            /// <summary>[requires: EXT_transform_feedback]
            /// Retrieve information about varying variables selected for transform feedback
            /// </summary>
            /// <param name="program">
            /// <para>
            /// The name of the target program object.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// The index of the varying variable whose information to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The maximum number of characters, including the null terminator, that may be written into name.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable which will receive the number of characters written into name, excluding the null-terminator. If length is NULL no length is returned.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// The address of a variable that will receive the size of the varying.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The address of a variable that will recieve the type of the varying.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// The address of a buffer into which will be written the name of the varying.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_transform_feedback", Version = "", EntryPoint = "glGetTransformFeedbackVaryingEXT")]
            public static extern void GetTransformFeedbackVarying(UInt32 program, UInt32 index, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] out Int32 size, [OutAttribute] out OpenTK.Graphics.OpenGL.ActiveAttribType type, [OutAttribute] StringBuilder name);

            /// <summary>[requires: EXT_transform_feedback]
            /// Retrieve information about varying variables selected for transform feedback
            /// </summary>
            /// <param name="program">
            /// <para>
            /// The name of the target program object.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// The index of the varying variable whose information to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The maximum number of characters, including the null terminator, that may be written into name.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable which will receive the number of characters written into name, excluding the null-terminator. If length is NULL no length is returned.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// The address of a variable that will receive the size of the varying.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The address of a variable that will recieve the type of the varying.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// The address of a buffer into which will be written the name of the varying.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_transform_feedback", Version = "", EntryPoint = "glGetTransformFeedbackVaryingEXT")]
            public static extern void GetTransformFeedbackVarying(UInt32 program, UInt32 index, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] out Int32 size, [OutAttribute] out OpenTK.Graphics.OpenGL.ExtTransformFeedback type, [OutAttribute] StringBuilder name);

            /// <summary>[requires: EXT_transform_feedback]
            /// Retrieve information about varying variables selected for transform feedback
            /// </summary>
            /// <param name="program">
            /// <para>
            /// The name of the target program object.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// The index of the varying variable whose information to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The maximum number of characters, including the null terminator, that may be written into name.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable which will receive the number of characters written into name, excluding the null-terminator. If length is NULL no length is returned.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// The address of a variable that will receive the size of the varying.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The address of a variable that will recieve the type of the varying.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// The address of a buffer into which will be written the name of the varying.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_transform_feedback", Version = "", EntryPoint = "glGetTransformFeedbackVaryingEXT")]
            public static extern unsafe void GetTransformFeedbackVarying(UInt32 program, UInt32 index, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] Int32* size, [OutAttribute] OpenTK.Graphics.OpenGL.ActiveAttribType* type, [OutAttribute] StringBuilder name);

            /// <summary>[requires: EXT_transform_feedback]
            /// Retrieve information about varying variables selected for transform feedback
            /// </summary>
            /// <param name="program">
            /// <para>
            /// The name of the target program object.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// The index of the varying variable whose information to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The maximum number of characters, including the null terminator, that may be written into name.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable which will receive the number of characters written into name, excluding the null-terminator. If length is NULL no length is returned.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// The address of a variable that will receive the size of the varying.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The address of a variable that will recieve the type of the varying.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// The address of a buffer into which will be written the name of the varying.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_transform_feedback", Version = "", EntryPoint = "glGetTransformFeedbackVaryingEXT")]
            public static extern unsafe void GetTransformFeedbackVarying(UInt32 program, UInt32 index, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] Int32* size, [OutAttribute] OpenTK.Graphics.OpenGL.ExtTransformFeedback* type, [OutAttribute] StringBuilder name);

            /// <summary>[requires: EXT_bindable_uniform]</summary>
            [AutoGenerated(Category = "EXT_bindable_uniform", Version = "", EntryPoint = "glGetUniformBufferSizeEXT")]
            public static extern Int32 GetUniformBufferSize(Int32 program, Int32 location);

            /// <summary>[requires: EXT_bindable_uniform]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_bindable_uniform", Version = "", EntryPoint = "glGetUniformBufferSizeEXT")]
            public static extern Int32 GetUniformBufferSize(UInt32 program, Int32 location);

            /// <summary>[requires: EXT_bindable_uniform]</summary>
            [AutoGenerated(Category = "EXT_bindable_uniform", Version = "", EntryPoint = "glGetUniformOffsetEXT")]
            public static extern IntPtr GetUniformOffset(Int32 program, Int32 location);

            /// <summary>[requires: EXT_bindable_uniform]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_bindable_uniform", Version = "", EntryPoint = "glGetUniformOffsetEXT")]
            public static extern IntPtr GetUniformOffset(UInt32 program, Int32 location);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Returns the value of a uniform variable
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be queried.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the value of the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glGetUniformuivEXT")]
            public static extern void GetUniform(Int32 program, Int32 location, [OutAttribute] Int32[] @params);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Returns the value of a uniform variable
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be queried.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the value of the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glGetUniformuivEXT")]
            public static extern void GetUniform(Int32 program, Int32 location, [OutAttribute] out Int32 @params);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Returns the value of a uniform variable
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be queried.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the value of the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glGetUniformuivEXT")]
            public static extern unsafe void GetUniform(Int32 program, Int32 location, [OutAttribute] Int32* @params);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Returns the value of a uniform variable
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be queried.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the value of the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glGetUniformuivEXT")]
            public static extern void GetUniform(UInt32 program, Int32 location, [OutAttribute] UInt32[] @params);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Returns the value of a uniform variable
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be queried.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the value of the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glGetUniformuivEXT")]
            public static extern void GetUniform(UInt32 program, Int32 location, [OutAttribute] out UInt32 @params);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Returns the value of a uniform variable
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be queried.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the value of the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glGetUniformuivEXT")]
            public static extern unsafe void GetUniform(UInt32 program, Int32 location, [OutAttribute] UInt32* @params);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetVariantBooleanvEXT")]
            public static extern void GetVariantBoolean(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] bool[] data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetVariantBooleanvEXT")]
            public static extern void GetVariantBoolean(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] out bool data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetVariantBooleanvEXT")]
            public static extern unsafe void GetVariantBoolean(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] bool* data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetVariantBooleanvEXT")]
            public static extern void GetVariantBoolean(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] bool[] data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetVariantBooleanvEXT")]
            public static extern void GetVariantBoolean(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] out bool data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetVariantBooleanvEXT")]
            public static extern unsafe void GetVariantBoolean(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] bool* data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetVariantFloatvEXT")]
            public static extern void GetVariantFloat(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] Single[] data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetVariantFloatvEXT")]
            public static extern void GetVariantFloat(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] out Single data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetVariantFloatvEXT")]
            public static extern unsafe void GetVariantFloat(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] Single* data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetVariantFloatvEXT")]
            public static extern void GetVariantFloat(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] Single[] data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetVariantFloatvEXT")]
            public static extern void GetVariantFloat(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] out Single data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetVariantFloatvEXT")]
            public static extern unsafe void GetVariantFloat(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] Single* data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetVariantIntegervEXT")]
            public static extern void GetVariantInteger(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] Int32[] data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetVariantIntegervEXT")]
            public static extern void GetVariantInteger(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] out Int32 data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetVariantIntegervEXT")]
            public static extern unsafe void GetVariantInteger(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] Int32* data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetVariantIntegervEXT")]
            public static extern void GetVariantInteger(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] Int32[] data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetVariantIntegervEXT")]
            public static extern void GetVariantInteger(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] out Int32 data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetVariantIntegervEXT")]
            public static extern unsafe void GetVariantInteger(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] Int32* data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetVariantPointervEXT")]
            public static extern void GetVariantPointer(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] IntPtr data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetVariantPointervEXT")]
            public static extern void GetVariantPointer<T2>(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [InAttribute, OutAttribute] T2[] data)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetVariantPointervEXT")]
            public static extern void GetVariantPointer<T2>(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [InAttribute, OutAttribute] T2[,] data)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetVariantPointervEXT")]
            public static extern void GetVariantPointer<T2>(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [InAttribute, OutAttribute] T2[,,] data)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetVariantPointervEXT")]
            public static extern void GetVariantPointer<T2>(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [InAttribute, OutAttribute] ref T2 data)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetVariantPointervEXT")]
            public static extern void GetVariantPointer(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] IntPtr data);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetVariantPointervEXT")]
            public static extern void GetVariantPointer<T2>(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [InAttribute, OutAttribute] T2[] data)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetVariantPointervEXT")]
            public static extern void GetVariantPointer<T2>(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [InAttribute, OutAttribute] T2[,] data)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetVariantPointervEXT")]
            public static extern void GetVariantPointer<T2>(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [InAttribute, OutAttribute] T2[,,] data)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glGetVariantPointervEXT")]
            public static extern void GetVariantPointer<T2>(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [InAttribute, OutAttribute] ref T2 data)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetVertexArrayIntegeri_vEXT")]
            public static extern void GetVertexArrayInteger(Int32 vaobj, Int32 index, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] Int32[] param);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetVertexArrayIntegeri_vEXT")]
            public static extern void GetVertexArrayInteger(Int32 vaobj, Int32 index, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] out Int32 param);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetVertexArrayIntegeri_vEXT")]
            public static extern unsafe void GetVertexArrayInteger(Int32 vaobj, Int32 index, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] Int32* param);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetVertexArrayIntegeri_vEXT")]
            public static extern void GetVertexArrayInteger(UInt32 vaobj, UInt32 index, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] Int32[] param);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetVertexArrayIntegeri_vEXT")]
            public static extern void GetVertexArrayInteger(UInt32 vaobj, UInt32 index, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] out Int32 param);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetVertexArrayIntegeri_vEXT")]
            public static extern unsafe void GetVertexArrayInteger(UInt32 vaobj, UInt32 index, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] Int32* param);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetVertexArrayIntegervEXT")]
            public static extern void GetVertexArrayInteger(Int32 vaobj, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] Int32[] param);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetVertexArrayIntegervEXT")]
            public static extern void GetVertexArrayInteger(Int32 vaobj, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] out Int32 param);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetVertexArrayIntegervEXT")]
            public static extern unsafe void GetVertexArrayInteger(Int32 vaobj, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] Int32* param);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetVertexArrayIntegervEXT")]
            public static extern void GetVertexArrayInteger(UInt32 vaobj, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] Int32[] param);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetVertexArrayIntegervEXT")]
            public static extern void GetVertexArrayInteger(UInt32 vaobj, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] out Int32 param);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetVertexArrayIntegervEXT")]
            public static extern unsafe void GetVertexArrayInteger(UInt32 vaobj, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] Int32* param);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetVertexArrayPointeri_vEXT")]
            public static extern void GetVertexArrayPointer(Int32 vaobj, Int32 index, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] IntPtr param);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetVertexArrayPointeri_vEXT")]
            public static extern void GetVertexArrayPointer<T3>(Int32 vaobj, Int32 index, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [InAttribute, OutAttribute] T3[] param)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetVertexArrayPointeri_vEXT")]
            public static extern void GetVertexArrayPointer<T3>(Int32 vaobj, Int32 index, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [InAttribute, OutAttribute] T3[,] param)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetVertexArrayPointeri_vEXT")]
            public static extern void GetVertexArrayPointer<T3>(Int32 vaobj, Int32 index, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [InAttribute, OutAttribute] T3[,,] param)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetVertexArrayPointeri_vEXT")]
            public static extern void GetVertexArrayPointer<T3>(Int32 vaobj, Int32 index, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [InAttribute, OutAttribute] ref T3 param)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetVertexArrayPointeri_vEXT")]
            public static extern void GetVertexArrayPointer(UInt32 vaobj, UInt32 index, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] IntPtr param);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetVertexArrayPointeri_vEXT")]
            public static extern void GetVertexArrayPointer<T3>(UInt32 vaobj, UInt32 index, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [InAttribute, OutAttribute] T3[] param)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetVertexArrayPointeri_vEXT")]
            public static extern void GetVertexArrayPointer<T3>(UInt32 vaobj, UInt32 index, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [InAttribute, OutAttribute] T3[,] param)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetVertexArrayPointeri_vEXT")]
            public static extern void GetVertexArrayPointer<T3>(UInt32 vaobj, UInt32 index, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [InAttribute, OutAttribute] T3[,,] param)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetVertexArrayPointeri_vEXT")]
            public static extern void GetVertexArrayPointer<T3>(UInt32 vaobj, UInt32 index, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [InAttribute, OutAttribute] ref T3 param)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetVertexArrayPointervEXT")]
            public static extern void GetVertexArrayPointer(Int32 vaobj, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] IntPtr param);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetVertexArrayPointervEXT")]
            public static extern void GetVertexArrayPointer<T2>(Int32 vaobj, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [InAttribute, OutAttribute] T2[] param)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetVertexArrayPointervEXT")]
            public static extern void GetVertexArrayPointer<T2>(Int32 vaobj, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [InAttribute, OutAttribute] T2[,] param)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetVertexArrayPointervEXT")]
            public static extern void GetVertexArrayPointer<T2>(Int32 vaobj, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [InAttribute, OutAttribute] T2[,,] param)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetVertexArrayPointervEXT")]
            public static extern void GetVertexArrayPointer<T2>(Int32 vaobj, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [InAttribute, OutAttribute] ref T2 param)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetVertexArrayPointervEXT")]
            public static extern void GetVertexArrayPointer(UInt32 vaobj, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] IntPtr param);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetVertexArrayPointervEXT")]
            public static extern void GetVertexArrayPointer<T2>(UInt32 vaobj, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [InAttribute, OutAttribute] T2[] param)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetVertexArrayPointervEXT")]
            public static extern void GetVertexArrayPointer<T2>(UInt32 vaobj, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [InAttribute, OutAttribute] T2[,] param)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetVertexArrayPointervEXT")]
            public static extern void GetVertexArrayPointer<T2>(UInt32 vaobj, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [InAttribute, OutAttribute] T2[,,] param)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glGetVertexArrayPointervEXT")]
            public static extern void GetVertexArrayPointer<T2>(UInt32 vaobj, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [InAttribute, OutAttribute] ref T2 param)
                where T2 : struct
            ;

            /// <summary>[requires: NV_vertex_program4]</summary>
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glGetVertexAttribIivEXT")]
            public static extern void GetVertexAttribI(Int32 index, OpenTK.Graphics.OpenGL.NvVertexProgram4 pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glGetVertexAttribIivEXT")]
            public static extern unsafe void GetVertexAttribI(Int32 index, OpenTK.Graphics.OpenGL.NvVertexProgram4 pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glGetVertexAttribIivEXT")]
            public static extern void GetVertexAttribI(UInt32 index, OpenTK.Graphics.OpenGL.NvVertexProgram4 pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glGetVertexAttribIivEXT")]
            public static extern unsafe void GetVertexAttribI(UInt32 index, OpenTK.Graphics.OpenGL.NvVertexProgram4 pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glGetVertexAttribIuivEXT")]
            public static extern void GetVertexAttribI(UInt32 index, OpenTK.Graphics.OpenGL.NvVertexProgram4 pname, [OutAttribute] out UInt32 @params);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glGetVertexAttribIuivEXT")]
            public static extern unsafe void GetVertexAttribI(UInt32 index, OpenTK.Graphics.OpenGL.NvVertexProgram4 pname, [OutAttribute] UInt32* @params);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glGetVertexAttribLdvEXT")]
            public static extern void GetVertexAttribL(Int32 index, OpenTK.Graphics.OpenGL.ExtVertexAttrib64bit pname, [OutAttribute] Double[] @params);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glGetVertexAttribLdvEXT")]
            public static extern void GetVertexAttribL(Int32 index, OpenTK.Graphics.OpenGL.ExtVertexAttrib64bit pname, [OutAttribute] out Double @params);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glGetVertexAttribLdvEXT")]
            public static extern unsafe void GetVertexAttribL(Int32 index, OpenTK.Graphics.OpenGL.ExtVertexAttrib64bit pname, [OutAttribute] Double* @params);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glGetVertexAttribLdvEXT")]
            public static extern void GetVertexAttribL(UInt32 index, OpenTK.Graphics.OpenGL.ExtVertexAttrib64bit pname, [OutAttribute] Double[] @params);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glGetVertexAttribLdvEXT")]
            public static extern void GetVertexAttribL(UInt32 index, OpenTK.Graphics.OpenGL.ExtVertexAttrib64bit pname, [OutAttribute] out Double @params);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glGetVertexAttribLdvEXT")]
            public static extern unsafe void GetVertexAttribL(UInt32 index, OpenTK.Graphics.OpenGL.ExtVertexAttrib64bit pname, [OutAttribute] Double* @params);

            /// <summary>[requires: EXT_histogram]
            /// Define histogram table
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The histogram whose parameters are to be set. Must be one of GL_HISTOGRAM or GL_PROXY_HISTOGRAM.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// The number of entries in the histogram table. Must be a power of 2.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// The format of entries in the histogram table. Must be one of GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
            /// </para>
            /// </param>
            /// <param name="sink">
            /// <para>
            /// If GL_TRUE, pixels will be consumed by the histogramming process and no drawing or texture loading will take place. If GL_FALSE, pixels will proceed to the minmax process after histogramming.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_histogram", Version = "", EntryPoint = "glHistogramEXT")]
            public static extern void Histogram(OpenTK.Graphics.OpenGL.ExtHistogram target, Int32 width, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, bool sink);

            /// <summary>[requires: EXT_x11_sync_object]</summary>
            [AutoGenerated(Category = "EXT_x11_sync_object", Version = "", EntryPoint = "glImportSyncEXT")]
            public static extern IntPtr ImportSync(OpenTK.Graphics.OpenGL.ExtX11SyncObject external_sync_type, IntPtr external_sync, Int32 flags);

            /// <summary>[requires: EXT_x11_sync_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_x11_sync_object", Version = "", EntryPoint = "glImportSyncEXT")]
            public static extern IntPtr ImportSync(OpenTK.Graphics.OpenGL.ExtX11SyncObject external_sync_type, IntPtr external_sync, UInt32 flags);

            /// <summary>[requires: EXT_index_func]</summary>
            [AutoGenerated(Category = "EXT_index_func", Version = "", EntryPoint = "glIndexFuncEXT")]
            public static extern void IndexFunc(OpenTK.Graphics.OpenGL.ExtIndexFunc func, Single @ref);

            /// <summary>[requires: EXT_index_material]</summary>
            [AutoGenerated(Category = "EXT_index_material", Version = "", EntryPoint = "glIndexMaterialEXT")]
            public static extern void IndexMaterial(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.ExtIndexMaterial mode);

            /// <summary>[requires: EXT_vertex_array]
            /// Define an array of color indexes
            /// </summary>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each color index in the array. Symbolic constants GL_UNSIGNED_BYTE, GL_SHORT, GL_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive color indexes. If stride is 0, the color indexes are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first index in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glIndexPointerEXT")]
            public static extern void IndexPointer(OpenTK.Graphics.OpenGL.IndexPointerType type, Int32 stride, Int32 count, IntPtr pointer);

            /// <summary>[requires: EXT_vertex_array]
            /// Define an array of color indexes
            /// </summary>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each color index in the array. Symbolic constants GL_UNSIGNED_BYTE, GL_SHORT, GL_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive color indexes. If stride is 0, the color indexes are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first index in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glIndexPointerEXT")]
            public static extern void IndexPointer<T3>(OpenTK.Graphics.OpenGL.IndexPointerType type, Int32 stride, Int32 count, [InAttribute, OutAttribute] T3[] pointer)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_vertex_array]
            /// Define an array of color indexes
            /// </summary>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each color index in the array. Symbolic constants GL_UNSIGNED_BYTE, GL_SHORT, GL_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive color indexes. If stride is 0, the color indexes are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first index in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glIndexPointerEXT")]
            public static extern void IndexPointer<T3>(OpenTK.Graphics.OpenGL.IndexPointerType type, Int32 stride, Int32 count, [InAttribute, OutAttribute] T3[,] pointer)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_vertex_array]
            /// Define an array of color indexes
            /// </summary>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each color index in the array. Symbolic constants GL_UNSIGNED_BYTE, GL_SHORT, GL_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive color indexes. If stride is 0, the color indexes are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first index in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glIndexPointerEXT")]
            public static extern void IndexPointer<T3>(OpenTK.Graphics.OpenGL.IndexPointerType type, Int32 stride, Int32 count, [InAttribute, OutAttribute] T3[,,] pointer)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_vertex_array]
            /// Define an array of color indexes
            /// </summary>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each color index in the array. Symbolic constants GL_UNSIGNED_BYTE, GL_SHORT, GL_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive color indexes. If stride is 0, the color indexes are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first index in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glIndexPointerEXT")]
            public static extern void IndexPointer<T3>(OpenTK.Graphics.OpenGL.IndexPointerType type, Int32 stride, Int32 count, [InAttribute, OutAttribute] ref T3 pointer)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glInsertComponentEXT")]
            public static extern void InsertComponent(Int32 res, Int32 src, Int32 num);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glInsertComponentEXT")]
            public static extern void InsertComponent(UInt32 res, UInt32 src, UInt32 num);

            /// <summary>[requires: EXT_debug_marker]</summary>
            [AutoGenerated(Category = "EXT_debug_marker", Version = "", EntryPoint = "glInsertEventMarkerEXT")]
            public static extern void InsertEventMarker(Int32 length, String marker);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [Obsolete("Use IndexedEnableCap overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glIsEnabledIndexedEXT")]
            public static extern bool IsEnabledIndexed(OpenTK.Graphics.OpenGL.ExtDrawBuffers2 target, Int32 index);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [Obsolete("Use IndexedEnableCap overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glIsEnabledIndexedEXT")]
            public static extern bool IsEnabledIndexed(OpenTK.Graphics.OpenGL.ExtDrawBuffers2 target, UInt32 index);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glIsEnabledIndexedEXT")]
            public static extern bool IsEnabledIndexed(OpenTK.Graphics.OpenGL.IndexedEnableCap target, Int32 index);

            /// <summary>[requires: EXT_direct_state_access|EXT_draw_buffers2]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_draw_buffers2", Version = "", EntryPoint = "glIsEnabledIndexedEXT")]
            public static extern bool IsEnabledIndexed(OpenTK.Graphics.OpenGL.IndexedEnableCap target, UInt32 index);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Determine if a name corresponds to a framebuffer object
            /// </summary>
            /// <param name="framebuffer">
            /// <para>
            /// Specifies a value that may be the name of a framebuffer object.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glIsFramebufferEXT")]
            public static extern bool IsFramebuffer(Int32 framebuffer);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Determine if a name corresponds to a framebuffer object
            /// </summary>
            /// <param name="framebuffer">
            /// <para>
            /// Specifies a value that may be the name of a framebuffer object.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glIsFramebufferEXT")]
            public static extern bool IsFramebuffer(UInt32 framebuffer);

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Determine if a name corresponds to a program pipeline object
            /// </summary>
            /// <param name="pipeline">
            /// <para>
            /// Specifies a value that may be the name of a program pipeline object.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glIsProgramPipelineEXT")]
            public static extern bool IsProgramPipeline(Int32 pipeline);

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Determine if a name corresponds to a program pipeline object
            /// </summary>
            /// <param name="pipeline">
            /// <para>
            /// Specifies a value that may be the name of a program pipeline object.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glIsProgramPipelineEXT")]
            public static extern bool IsProgramPipeline(UInt32 pipeline);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Determine if a name corresponds to a renderbuffer object
            /// </summary>
            /// <param name="renderbuffer">
            /// <para>
            /// Specifies a value that may be the name of a renderbuffer object.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glIsRenderbufferEXT")]
            public static extern bool IsRenderbuffer(Int32 renderbuffer);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Determine if a name corresponds to a renderbuffer object
            /// </summary>
            /// <param name="renderbuffer">
            /// <para>
            /// Specifies a value that may be the name of a renderbuffer object.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glIsRenderbufferEXT")]
            public static extern bool IsRenderbuffer(UInt32 renderbuffer);

            /// <summary>[requires: EXT_texture_object]
            /// Determine if a name corresponds to a texture
            /// </summary>
            /// <param name="texture">
            /// <para>
            /// Specifies a value that may be the name of a texture.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_texture_object", Version = "", EntryPoint = "glIsTextureEXT")]
            public static extern bool IsTexture(Int32 texture);

            /// <summary>[requires: EXT_texture_object]
            /// Determine if a name corresponds to a texture
            /// </summary>
            /// <param name="texture">
            /// <para>
            /// Specifies a value that may be the name of a texture.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_texture_object", Version = "", EntryPoint = "glIsTextureEXT")]
            public static extern bool IsTexture(UInt32 texture);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glIsVariantEnabledEXT")]
            public static extern bool IsVariantEnabled(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader cap);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glIsVariantEnabledEXT")]
            public static extern bool IsVariantEnabled(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader cap);

            /// <summary>[requires: EXT_debug_label]</summary>
            [AutoGenerated(Category = "EXT_debug_label", Version = "", EntryPoint = "glLabelObjectEXT")]
            public static extern void LabelObject(OpenTK.Graphics.OpenGL.ExtDebugLabel type, Int32 @object, Int32 length, String label);

            /// <summary>[requires: EXT_debug_label]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_debug_label", Version = "", EntryPoint = "glLabelObjectEXT")]
            public static extern void LabelObject(OpenTK.Graphics.OpenGL.ExtDebugLabel type, UInt32 @object, Int32 length, String label);

            /// <summary>[requires: EXT_compiled_vertex_array]</summary>
            [AutoGenerated(Category = "EXT_compiled_vertex_array", Version = "", EntryPoint = "glLockArraysEXT")]
            public static extern void LockArrays(Int32 first, Int32 count);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMapNamedBufferEXT")]
            public static extern IntPtr MapNamedBuffer(Int32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess access);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMapNamedBufferEXT")]
            public static extern IntPtr MapNamedBuffer(UInt32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess access);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMapNamedBufferRangeEXT")]
            public static extern IntPtr MapNamedBufferRange(Int32 buffer, IntPtr offset, IntPtr length, OpenTK.Graphics.OpenGL.BufferAccessMask access);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMapNamedBufferRangeEXT")]
            public static extern IntPtr MapNamedBufferRange(UInt32 buffer, IntPtr offset, IntPtr length, OpenTK.Graphics.OpenGL.BufferAccessMask access);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMatrixFrustumEXT")]
            public static extern void MatrixFrustum(OpenTK.Graphics.OpenGL.MatrixMode mode, Double left, Double right, Double bottom, Double top, Double zNear, Double zFar);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMatrixLoaddEXT")]
            public static extern void MatrixLoad(OpenTK.Graphics.OpenGL.MatrixMode mode, Double[] m);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMatrixLoaddEXT")]
            public static extern void MatrixLoad(OpenTK.Graphics.OpenGL.MatrixMode mode, ref Double m);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMatrixLoaddEXT")]
            public static extern unsafe void MatrixLoad(OpenTK.Graphics.OpenGL.MatrixMode mode, Double* m);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMatrixLoadfEXT")]
            public static extern void MatrixLoad(OpenTK.Graphics.OpenGL.MatrixMode mode, Single[] m);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMatrixLoadfEXT")]
            public static extern void MatrixLoad(OpenTK.Graphics.OpenGL.MatrixMode mode, ref Single m);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMatrixLoadfEXT")]
            public static extern unsafe void MatrixLoad(OpenTK.Graphics.OpenGL.MatrixMode mode, Single* m);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMatrixLoadIdentityEXT")]
            public static extern void MatrixLoadIdentity(OpenTK.Graphics.OpenGL.MatrixMode mode);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMatrixLoadTransposedEXT")]
            public static extern void MatrixLoadTranspose(OpenTK.Graphics.OpenGL.MatrixMode mode, Double[] m);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMatrixLoadTransposedEXT")]
            public static extern void MatrixLoadTranspose(OpenTK.Graphics.OpenGL.MatrixMode mode, ref Double m);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMatrixLoadTransposedEXT")]
            public static extern unsafe void MatrixLoadTranspose(OpenTK.Graphics.OpenGL.MatrixMode mode, Double* m);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMatrixLoadTransposefEXT")]
            public static extern void MatrixLoadTranspose(OpenTK.Graphics.OpenGL.MatrixMode mode, Single[] m);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMatrixLoadTransposefEXT")]
            public static extern void MatrixLoadTranspose(OpenTK.Graphics.OpenGL.MatrixMode mode, ref Single m);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMatrixLoadTransposefEXT")]
            public static extern unsafe void MatrixLoadTranspose(OpenTK.Graphics.OpenGL.MatrixMode mode, Single* m);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMatrixMultdEXT")]
            public static extern void MatrixMult(OpenTK.Graphics.OpenGL.MatrixMode mode, Double[] m);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMatrixMultdEXT")]
            public static extern void MatrixMult(OpenTK.Graphics.OpenGL.MatrixMode mode, ref Double m);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMatrixMultdEXT")]
            public static extern unsafe void MatrixMult(OpenTK.Graphics.OpenGL.MatrixMode mode, Double* m);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMatrixMultfEXT")]
            public static extern void MatrixMult(OpenTK.Graphics.OpenGL.MatrixMode mode, Single[] m);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMatrixMultfEXT")]
            public static extern void MatrixMult(OpenTK.Graphics.OpenGL.MatrixMode mode, ref Single m);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMatrixMultfEXT")]
            public static extern unsafe void MatrixMult(OpenTK.Graphics.OpenGL.MatrixMode mode, Single* m);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMatrixMultTransposedEXT")]
            public static extern void MatrixMultTranspose(OpenTK.Graphics.OpenGL.MatrixMode mode, Double[] m);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMatrixMultTransposedEXT")]
            public static extern void MatrixMultTranspose(OpenTK.Graphics.OpenGL.MatrixMode mode, ref Double m);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMatrixMultTransposedEXT")]
            public static extern unsafe void MatrixMultTranspose(OpenTK.Graphics.OpenGL.MatrixMode mode, Double* m);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMatrixMultTransposefEXT")]
            public static extern void MatrixMultTranspose(OpenTK.Graphics.OpenGL.MatrixMode mode, Single[] m);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMatrixMultTransposefEXT")]
            public static extern void MatrixMultTranspose(OpenTK.Graphics.OpenGL.MatrixMode mode, ref Single m);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMatrixMultTransposefEXT")]
            public static extern unsafe void MatrixMultTranspose(OpenTK.Graphics.OpenGL.MatrixMode mode, Single* m);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMatrixOrthoEXT")]
            public static extern void MatrixOrtho(OpenTK.Graphics.OpenGL.MatrixMode mode, Double left, Double right, Double bottom, Double top, Double zNear, Double zFar);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMatrixPopEXT")]
            public static extern void MatrixPop(OpenTK.Graphics.OpenGL.MatrixMode mode);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMatrixPushEXT")]
            public static extern void MatrixPush(OpenTK.Graphics.OpenGL.MatrixMode mode);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMatrixRotatedEXT")]
            public static extern void MatrixRotate(OpenTK.Graphics.OpenGL.MatrixMode mode, Double angle, Double x, Double y, Double z);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMatrixRotatefEXT")]
            public static extern void MatrixRotate(OpenTK.Graphics.OpenGL.MatrixMode mode, Single angle, Single x, Single y, Single z);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMatrixScaledEXT")]
            public static extern void MatrixScale(OpenTK.Graphics.OpenGL.MatrixMode mode, Double x, Double y, Double z);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMatrixScalefEXT")]
            public static extern void MatrixScale(OpenTK.Graphics.OpenGL.MatrixMode mode, Single x, Single y, Single z);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMatrixTranslatedEXT")]
            public static extern void MatrixTranslate(OpenTK.Graphics.OpenGL.MatrixMode mode, Double x, Double y, Double z);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMatrixTranslatefEXT")]
            public static extern void MatrixTranslate(OpenTK.Graphics.OpenGL.MatrixMode mode, Single x, Single y, Single z);

            /// <summary>[requires: EXT_shader_image_load_store]
            /// Defines a barrier ordering memory transactions
            /// </summary>
            /// <param name="barriers">
            /// <para>
            /// Specifies the barriers to insert. Must be a bitwise combination of GL_VERTEX_ATTRIB_ARRAY_BARRIER_BIT, GL_ELEMENT_ARRAY_BARRIER_BIT, GL_UNIFORM_BARRIER_BIT, GL_TEXTURE_FETCH_BARRIER_BIT, GL_SHADER_IMAGE_ACCESS_BARRIER_BIT, GL_COMMAND_BARRIER_BIT, GL_PIXEL_BUFFER_BARRIER_BIT, GL_TEXTURE_UPDATE_BARRIER_BIT, GL_BUFFER_UPDATE_BARRIER_BIT, GL_FRAMEBUFFER_BARRIER_BIT, GL_TRANSFORM_FEEDBACK_BARRIER_BIT, GL_ATOMIC_COUNTER_BARRIER_BIT, or GL_SHADER_STORAGE_BARRIER_BIT. If the special value GL_ALL_BARRIER_BITS is specified, all supported barriers will be inserted.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_shader_image_load_store", Version = "", EntryPoint = "glMemoryBarrierEXT")]
            public static extern void MemoryBarrier(Int32 barriers);

            /// <summary>[requires: EXT_shader_image_load_store]
            /// Defines a barrier ordering memory transactions
            /// </summary>
            /// <param name="barriers">
            /// <para>
            /// Specifies the barriers to insert. Must be a bitwise combination of GL_VERTEX_ATTRIB_ARRAY_BARRIER_BIT, GL_ELEMENT_ARRAY_BARRIER_BIT, GL_UNIFORM_BARRIER_BIT, GL_TEXTURE_FETCH_BARRIER_BIT, GL_SHADER_IMAGE_ACCESS_BARRIER_BIT, GL_COMMAND_BARRIER_BIT, GL_PIXEL_BUFFER_BARRIER_BIT, GL_TEXTURE_UPDATE_BARRIER_BIT, GL_BUFFER_UPDATE_BARRIER_BIT, GL_FRAMEBUFFER_BARRIER_BIT, GL_TRANSFORM_FEEDBACK_BARRIER_BIT, GL_ATOMIC_COUNTER_BARRIER_BIT, or GL_SHADER_STORAGE_BARRIER_BIT. If the special value GL_ALL_BARRIER_BITS is specified, all supported barriers will be inserted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_shader_image_load_store", Version = "", EntryPoint = "glMemoryBarrierEXT")]
            public static extern void MemoryBarrier(UInt32 barriers);

            /// <summary>[requires: EXT_histogram]
            /// Define minmax table
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The minmax table whose parameters are to be set. Must be GL_MINMAX.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// The format of entries in the minmax table. Must be one of GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
            /// </para>
            /// </param>
            /// <param name="sink">
            /// <para>
            /// If GL_TRUE, pixels will be consumed by the minmax process and no drawing or texture loading will take place. If GL_FALSE, pixels will proceed to the final conversion process after minmax.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_histogram", Version = "", EntryPoint = "glMinmaxEXT")]
            public static extern void Minmax(OpenTK.Graphics.OpenGL.ExtHistogram target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, bool sink);

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives from array data
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="first">
            /// <para>
            /// Points to an array of starting indices in the enabled arrays.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the number of indices to be rendered.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the first and count
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawArraysEXT")]
            public static extern void MultiDrawArrays(OpenTK.Graphics.OpenGL.BeginMode mode, Int32[] first, Int32[] count, Int32 primcount);

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives from array data
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="first">
            /// <para>
            /// Points to an array of starting indices in the enabled arrays.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the number of indices to be rendered.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the first and count
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawArraysEXT")]
            public static extern void MultiDrawArrays(OpenTK.Graphics.OpenGL.BeginMode mode, ref Int32 first, ref Int32 count, Int32 primcount);

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives from array data
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="first">
            /// <para>
            /// Points to an array of starting indices in the enabled arrays.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the number of indices to be rendered.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the first and count
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawArraysEXT")]
            public static extern unsafe void MultiDrawArrays(OpenTK.Graphics.OpenGL.BeginMode mode, Int32* first, Int32* count, Int32 primcount);

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives from array data
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="first">
            /// <para>
            /// Points to an array of starting indices in the enabled arrays.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the number of indices to be rendered.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the first and count
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawArraysEXT")]
            public static extern void MultiDrawArrays(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32[] first, Int32[] count, Int32 primcount);

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives from array data
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="first">
            /// <para>
            /// Points to an array of starting indices in the enabled arrays.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the number of indices to be rendered.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the first and count
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawArraysEXT")]
            public static extern void MultiDrawArrays(OpenTK.Graphics.OpenGL.PrimitiveType mode, ref Int32 first, ref Int32 count, Int32 primcount);

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives from array data
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="first">
            /// <para>
            /// Points to an array of starting indices in the enabled arrays.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the number of indices to be rendered.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the first and count
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawArraysEXT")]
            public static extern unsafe void MultiDrawArrays(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32* first, Int32* count, Int32 primcount);

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives by specifying indices of array data elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the elements counts.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the count and indices arrays.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawElementsEXT")]
            public static extern void MultiDrawElements(OpenTK.Graphics.OpenGL.BeginMode mode, Int32[] count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 primcount);

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives by specifying indices of array data elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the elements counts.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the count and indices arrays.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawElementsEXT")]
            public static extern void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32[] count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives by specifying indices of array data elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the elements counts.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the count and indices arrays.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawElementsEXT")]
            public static extern void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32[] count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives by specifying indices of array data elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the elements counts.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the count and indices arrays.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawElementsEXT")]
            public static extern void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32[] count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives by specifying indices of array data elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the elements counts.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the count and indices arrays.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawElementsEXT")]
            public static extern void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32[] count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives by specifying indices of array data elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the elements counts.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the count and indices arrays.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawElementsEXT")]
            public static extern void MultiDrawElements(OpenTK.Graphics.OpenGL.BeginMode mode, ref Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 primcount);

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives by specifying indices of array data elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the elements counts.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the count and indices arrays.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawElementsEXT")]
            public static extern void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, ref Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives by specifying indices of array data elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the elements counts.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the count and indices arrays.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawElementsEXT")]
            public static extern void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, ref Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives by specifying indices of array data elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the elements counts.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the count and indices arrays.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawElementsEXT")]
            public static extern void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, ref Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives by specifying indices of array data elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the elements counts.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the count and indices arrays.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawElementsEXT")]
            public static extern void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, ref Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives by specifying indices of array data elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the elements counts.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the count and indices arrays.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawElementsEXT")]
            public static extern unsafe void MultiDrawElements(OpenTK.Graphics.OpenGL.BeginMode mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 primcount);

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives by specifying indices of array data elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the elements counts.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the count and indices arrays.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawElementsEXT")]
            public static extern unsafe void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives by specifying indices of array data elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the elements counts.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the count and indices arrays.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawElementsEXT")]
            public static extern unsafe void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives by specifying indices of array data elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the elements counts.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the count and indices arrays.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawElementsEXT")]
            public static extern unsafe void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives by specifying indices of array data elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the elements counts.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the count and indices arrays.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawElementsEXT")]
            public static extern unsafe void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.BeginMode mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives by specifying indices of array data elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the elements counts.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the count and indices arrays.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawElementsEXT")]
            public static extern void MultiDrawElements(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32[] count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 primcount);

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives by specifying indices of array data elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the elements counts.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the count and indices arrays.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawElementsEXT")]
            public static extern void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32[] count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives by specifying indices of array data elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the elements counts.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the count and indices arrays.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawElementsEXT")]
            public static extern void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32[] count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives by specifying indices of array data elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the elements counts.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the count and indices arrays.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawElementsEXT")]
            public static extern void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32[] count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives by specifying indices of array data elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the elements counts.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the count and indices arrays.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawElementsEXT")]
            public static extern void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32[] count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives by specifying indices of array data elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the elements counts.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the count and indices arrays.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawElementsEXT")]
            public static extern void MultiDrawElements(OpenTK.Graphics.OpenGL.PrimitiveType mode, ref Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 primcount);

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives by specifying indices of array data elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the elements counts.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the count and indices arrays.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawElementsEXT")]
            public static extern void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, ref Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives by specifying indices of array data elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the elements counts.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the count and indices arrays.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawElementsEXT")]
            public static extern void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, ref Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives by specifying indices of array data elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the elements counts.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the count and indices arrays.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawElementsEXT")]
            public static extern void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, ref Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives by specifying indices of array data elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the elements counts.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the count and indices arrays.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawElementsEXT")]
            public static extern void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, ref Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives by specifying indices of array data elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the elements counts.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the count and indices arrays.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawElementsEXT")]
            public static extern unsafe void MultiDrawElements(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 primcount);

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives by specifying indices of array data elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the elements counts.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the count and indices arrays.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawElementsEXT")]
            public static extern unsafe void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives by specifying indices of array data elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the elements counts.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the count and indices arrays.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawElementsEXT")]
            public static extern unsafe void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives by specifying indices of array data elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the elements counts.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the count and indices arrays.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawElementsEXT")]
            public static extern unsafe void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_multi_draw_arrays]
            /// Render multiple sets of primitives by specifying indices of array data elements
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// Points to an array of the elements counts.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the type of the values in indices. Must be one of GL_UNSIGNED_BYTE, GL_UNSIGNED_SHORT, or GL_UNSIGNED_INT.
            /// </para>
            /// </param>
            /// <param name="indices">
            /// <para>
            /// Specifies a pointer to the location where the indices are stored.
            /// </para>
            /// </param>
            /// <param name="drawcount">
            /// <para>
            /// Specifies the size of the count and indices arrays.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_multi_draw_arrays", Version = "", EntryPoint = "glMultiDrawElementsEXT")]
            public static extern unsafe void MultiDrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices, Int32 primcount)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexBufferEXT")]
            public static extern void MultiTexBuffer(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 buffer);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexBufferEXT")]
            public static extern void MultiTexBuffer(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, UInt32 buffer);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexCoordPointerEXT")]
            public static extern void MultiTexCoordPointer(OpenTK.Graphics.OpenGL.TextureUnit texunit, Int32 size, OpenTK.Graphics.OpenGL.TexCoordPointerType type, Int32 stride, IntPtr pointer);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexCoordPointerEXT")]
            public static extern void MultiTexCoordPointer<T4>(OpenTK.Graphics.OpenGL.TextureUnit texunit, Int32 size, OpenTK.Graphics.OpenGL.TexCoordPointerType type, Int32 stride, [InAttribute, OutAttribute] T4[] pointer)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexCoordPointerEXT")]
            public static extern void MultiTexCoordPointer<T4>(OpenTK.Graphics.OpenGL.TextureUnit texunit, Int32 size, OpenTK.Graphics.OpenGL.TexCoordPointerType type, Int32 stride, [InAttribute, OutAttribute] T4[,] pointer)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexCoordPointerEXT")]
            public static extern void MultiTexCoordPointer<T4>(OpenTK.Graphics.OpenGL.TextureUnit texunit, Int32 size, OpenTK.Graphics.OpenGL.TexCoordPointerType type, Int32 stride, [InAttribute, OutAttribute] T4[,,] pointer)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexCoordPointerEXT")]
            public static extern void MultiTexCoordPointer<T4>(OpenTK.Graphics.OpenGL.TextureUnit texunit, Int32 size, OpenTK.Graphics.OpenGL.TexCoordPointerType type, Int32 stride, [InAttribute, OutAttribute] ref T4 pointer)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexEnvfEXT")]
            public static extern void MultiTexEnv(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, Single param);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexEnvfvEXT")]
            public static extern void MultiTexEnv(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, Single[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexEnvfvEXT")]
            public static extern unsafe void MultiTexEnv(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, Single* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexEnviEXT")]
            public static extern void MultiTexEnv(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, Int32 param);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexEnvivEXT")]
            public static extern void MultiTexEnv(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, Int32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexEnvivEXT")]
            public static extern unsafe void MultiTexEnv(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexGendEXT")]
            public static extern void MultiTexGend(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, Double param);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexGendvEXT")]
            public static extern void MultiTexGen(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, Double[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexGendvEXT")]
            public static extern void MultiTexGen(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, ref Double @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexGendvEXT")]
            public static extern unsafe void MultiTexGen(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, Double* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexGenfEXT")]
            public static extern void MultiTexGen(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, Single param);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexGenfvEXT")]
            public static extern void MultiTexGen(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, Single[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexGenfvEXT")]
            public static extern unsafe void MultiTexGen(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, Single* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexGeniEXT")]
            public static extern void MultiTexGen(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, Int32 param);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexGenivEXT")]
            public static extern void MultiTexGen(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, Int32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexGenivEXT")]
            public static extern unsafe void MultiTexGen(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexImage1DEXT")]
            public static extern void MultiTexImage1D(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexImage1DEXT")]
            public static extern void MultiTexImage1D<T8>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T8[] pixels)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexImage1DEXT")]
            public static extern void MultiTexImage1D<T8>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T8[,] pixels)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexImage1DEXT")]
            public static extern void MultiTexImage1D<T8>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T8[,,] pixels)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexImage1DEXT")]
            public static extern void MultiTexImage1D<T8>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T8 pixels)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexImage1DEXT")]
            public static extern void MultiTexImage1D(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexImage1DEXT")]
            public static extern void MultiTexImage1D<T8>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T8[] pixels)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexImage1DEXT")]
            public static extern void MultiTexImage1D<T8>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T8[,] pixels)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexImage1DEXT")]
            public static extern void MultiTexImage1D<T8>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T8[,,] pixels)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexImage1DEXT")]
            public static extern void MultiTexImage1D<T8>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T8 pixels)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexImage2DEXT")]
            public static extern void MultiTexImage2D(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexImage2DEXT")]
            public static extern void MultiTexImage2D<T9>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T9[] pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexImage2DEXT")]
            public static extern void MultiTexImage2D<T9>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T9[,] pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexImage2DEXT")]
            public static extern void MultiTexImage2D<T9>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T9[,,] pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexImage2DEXT")]
            public static extern void MultiTexImage2D<T9>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T9 pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexImage2DEXT")]
            public static extern void MultiTexImage2D(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexImage2DEXT")]
            public static extern void MultiTexImage2D<T9>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T9[] pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexImage2DEXT")]
            public static extern void MultiTexImage2D<T9>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T9[,] pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexImage2DEXT")]
            public static extern void MultiTexImage2D<T9>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T9[,,] pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexImage2DEXT")]
            public static extern void MultiTexImage2D<T9>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T9 pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexImage3DEXT")]
            public static extern void MultiTexImage3D(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexImage3DEXT")]
            public static extern void MultiTexImage3D<T10>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T10[] pixels)
                where T10 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexImage3DEXT")]
            public static extern void MultiTexImage3D<T10>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T10[,] pixels)
                where T10 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexImage3DEXT")]
            public static extern void MultiTexImage3D<T10>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T10[,,] pixels)
                where T10 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexImage3DEXT")]
            public static extern void MultiTexImage3D<T10>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T10 pixels)
                where T10 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexImage3DEXT")]
            public static extern void MultiTexImage3D(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexImage3DEXT")]
            public static extern void MultiTexImage3D<T10>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T10[] pixels)
                where T10 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexImage3DEXT")]
            public static extern void MultiTexImage3D<T10>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T10[,] pixels)
                where T10 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexImage3DEXT")]
            public static extern void MultiTexImage3D<T10>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T10[,,] pixels)
                where T10 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexImage3DEXT")]
            public static extern void MultiTexImage3D<T10>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T10 pixels)
                where T10 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexParameterfEXT")]
            public static extern void MultiTexParameter(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Single param);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexParameterfvEXT")]
            public static extern void MultiTexParameter(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Single[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexParameterfvEXT")]
            public static extern unsafe void MultiTexParameter(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Single* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexParameteriEXT")]
            public static extern void MultiTexParameter(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Int32 param);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexParameterIivEXT")]
            public static extern void MultiTexParameterI(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Int32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexParameterIivEXT")]
            public static extern void MultiTexParameterI(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, ref Int32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexParameterIivEXT")]
            public static extern unsafe void MultiTexParameterI(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexParameterIuivEXT")]
            public static extern void MultiTexParameterI(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, UInt32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexParameterIuivEXT")]
            public static extern void MultiTexParameterI(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, ref UInt32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexParameterIuivEXT")]
            public static extern unsafe void MultiTexParameterI(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, UInt32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexParameterivEXT")]
            public static extern void MultiTexParameter(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Int32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexParameterivEXT")]
            public static extern unsafe void MultiTexParameter(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexRenderbufferEXT")]
            public static extern void MultiTexRenderbuffer(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 renderbuffer);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexRenderbufferEXT")]
            public static extern void MultiTexRenderbuffer(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, UInt32 renderbuffer);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexSubImage1DEXT")]
            public static extern void MultiTexSubImage1D(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexSubImage1DEXT")]
            public static extern void MultiTexSubImage1D<T7>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T7[] pixels)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexSubImage1DEXT")]
            public static extern void MultiTexSubImage1D<T7>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T7[,] pixels)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexSubImage1DEXT")]
            public static extern void MultiTexSubImage1D<T7>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T7[,,] pixels)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexSubImage1DEXT")]
            public static extern void MultiTexSubImage1D<T7>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T7 pixels)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexSubImage2DEXT")]
            public static extern void MultiTexSubImage2D(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexSubImage2DEXT")]
            public static extern void MultiTexSubImage2D<T9>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T9[] pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexSubImage2DEXT")]
            public static extern void MultiTexSubImage2D<T9>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T9[,] pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexSubImage2DEXT")]
            public static extern void MultiTexSubImage2D<T9>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T9[,,] pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexSubImage2DEXT")]
            public static extern void MultiTexSubImage2D<T9>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T9 pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexSubImage3DEXT")]
            public static extern void MultiTexSubImage3D(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexSubImage3DEXT")]
            public static extern void MultiTexSubImage3D<T11>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T11[] pixels)
                where T11 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexSubImage3DEXT")]
            public static extern void MultiTexSubImage3D<T11>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T11[,] pixels)
                where T11 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexSubImage3DEXT")]
            public static extern void MultiTexSubImage3D<T11>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T11[,,] pixels)
                where T11 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glMultiTexSubImage3DEXT")]
            public static extern void MultiTexSubImage3D<T11>(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T11 pixels)
                where T11 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedBufferDataEXT")]
            public static extern void NamedBufferData(Int32 buffer, IntPtr size, IntPtr data, OpenTK.Graphics.OpenGL.ExtDirectStateAccess usage);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedBufferDataEXT")]
            public static extern void NamedBufferData<T2>(Int32 buffer, IntPtr size, [InAttribute, OutAttribute] T2[] data, OpenTK.Graphics.OpenGL.ExtDirectStateAccess usage)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedBufferDataEXT")]
            public static extern void NamedBufferData<T2>(Int32 buffer, IntPtr size, [InAttribute, OutAttribute] T2[,] data, OpenTK.Graphics.OpenGL.ExtDirectStateAccess usage)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedBufferDataEXT")]
            public static extern void NamedBufferData<T2>(Int32 buffer, IntPtr size, [InAttribute, OutAttribute] T2[,,] data, OpenTK.Graphics.OpenGL.ExtDirectStateAccess usage)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedBufferDataEXT")]
            public static extern void NamedBufferData<T2>(Int32 buffer, IntPtr size, [InAttribute, OutAttribute] ref T2 data, OpenTK.Graphics.OpenGL.ExtDirectStateAccess usage)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedBufferDataEXT")]
            public static extern void NamedBufferData(UInt32 buffer, IntPtr size, IntPtr data, OpenTK.Graphics.OpenGL.ExtDirectStateAccess usage);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedBufferDataEXT")]
            public static extern void NamedBufferData<T2>(UInt32 buffer, IntPtr size, [InAttribute, OutAttribute] T2[] data, OpenTK.Graphics.OpenGL.ExtDirectStateAccess usage)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedBufferDataEXT")]
            public static extern void NamedBufferData<T2>(UInt32 buffer, IntPtr size, [InAttribute, OutAttribute] T2[,] data, OpenTK.Graphics.OpenGL.ExtDirectStateAccess usage)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedBufferDataEXT")]
            public static extern void NamedBufferData<T2>(UInt32 buffer, IntPtr size, [InAttribute, OutAttribute] T2[,,] data, OpenTK.Graphics.OpenGL.ExtDirectStateAccess usage)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedBufferDataEXT")]
            public static extern void NamedBufferData<T2>(UInt32 buffer, IntPtr size, [InAttribute, OutAttribute] ref T2 data, OpenTK.Graphics.OpenGL.ExtDirectStateAccess usage)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedBufferStorageEXT")]
            public static extern void NamedBufferStorage(Int32 buffer, IntPtr size, IntPtr data, Int32 flags);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedBufferStorageEXT")]
            public static extern void NamedBufferStorage<T2>(Int32 buffer, IntPtr size, [InAttribute, OutAttribute] T2[] data, Int32 flags)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedBufferStorageEXT")]
            public static extern void NamedBufferStorage<T2>(Int32 buffer, IntPtr size, [InAttribute, OutAttribute] T2[,] data, Int32 flags)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedBufferStorageEXT")]
            public static extern void NamedBufferStorage<T2>(Int32 buffer, IntPtr size, [InAttribute, OutAttribute] T2[,,] data, Int32 flags)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedBufferStorageEXT")]
            public static extern void NamedBufferStorage<T2>(Int32 buffer, IntPtr size, [InAttribute, OutAttribute] ref T2 data, Int32 flags)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedBufferStorageEXT")]
            public static extern void NamedBufferStorage(UInt32 buffer, IntPtr size, IntPtr data, UInt32 flags);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedBufferStorageEXT")]
            public static extern void NamedBufferStorage<T2>(UInt32 buffer, IntPtr size, [InAttribute, OutAttribute] T2[] data, UInt32 flags)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedBufferStorageEXT")]
            public static extern void NamedBufferStorage<T2>(UInt32 buffer, IntPtr size, [InAttribute, OutAttribute] T2[,] data, UInt32 flags)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedBufferStorageEXT")]
            public static extern void NamedBufferStorage<T2>(UInt32 buffer, IntPtr size, [InAttribute, OutAttribute] T2[,,] data, UInt32 flags)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedBufferStorageEXT")]
            public static extern void NamedBufferStorage<T2>(UInt32 buffer, IntPtr size, [InAttribute, OutAttribute] ref T2 data, UInt32 flags)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedBufferSubDataEXT")]
            public static extern void NamedBufferSubData(Int32 buffer, IntPtr offset, IntPtr size, IntPtr data);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedBufferSubDataEXT")]
            public static extern void NamedBufferSubData<T3>(Int32 buffer, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] T3[] data)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedBufferSubDataEXT")]
            public static extern void NamedBufferSubData<T3>(Int32 buffer, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] T3[,] data)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedBufferSubDataEXT")]
            public static extern void NamedBufferSubData<T3>(Int32 buffer, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] T3[,,] data)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedBufferSubDataEXT")]
            public static extern void NamedBufferSubData<T3>(Int32 buffer, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] ref T3 data)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedBufferSubDataEXT")]
            public static extern void NamedBufferSubData(UInt32 buffer, IntPtr offset, IntPtr size, IntPtr data);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedBufferSubDataEXT")]
            public static extern void NamedBufferSubData<T3>(UInt32 buffer, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] T3[] data)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedBufferSubDataEXT")]
            public static extern void NamedBufferSubData<T3>(UInt32 buffer, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] T3[,] data)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedBufferSubDataEXT")]
            public static extern void NamedBufferSubData<T3>(UInt32 buffer, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] T3[,,] data)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedBufferSubDataEXT")]
            public static extern void NamedBufferSubData<T3>(UInt32 buffer, IntPtr offset, IntPtr size, [InAttribute, OutAttribute] ref T3 data)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedCopyBufferSubDataEXT")]
            public static extern void NamedCopyBufferSubData(Int32 readBuffer, Int32 writeBuffer, IntPtr readOffset, IntPtr writeOffset, IntPtr size);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedCopyBufferSubDataEXT")]
            public static extern void NamedCopyBufferSubData(UInt32 readBuffer, UInt32 writeBuffer, IntPtr readOffset, IntPtr writeOffset, IntPtr size);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedFramebufferParameteriEXT")]
            public static extern void NamedFramebufferParameter(Int32 framebuffer, OpenTK.Graphics.OpenGL.FramebufferParameterName pname, Int32 param);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedFramebufferParameteriEXT")]
            public static extern void NamedFramebufferParameter(UInt32 framebuffer, OpenTK.Graphics.OpenGL.FramebufferParameterName pname, Int32 param);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedFramebufferRenderbufferEXT")]
            public static extern void NamedFramebufferRenderbuffer(Int32 framebuffer, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.RenderbufferTarget renderbuffertarget, Int32 renderbuffer);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedFramebufferRenderbufferEXT")]
            public static extern void NamedFramebufferRenderbuffer(UInt32 framebuffer, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.RenderbufferTarget renderbuffertarget, UInt32 renderbuffer);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedFramebufferTexture1DEXT")]
            public static extern void NamedFramebufferTexture1D(Int32 framebuffer, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.TextureTarget textarget, Int32 texture, Int32 level);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedFramebufferTexture1DEXT")]
            public static extern void NamedFramebufferTexture1D(UInt32 framebuffer, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.TextureTarget textarget, UInt32 texture, Int32 level);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedFramebufferTexture2DEXT")]
            public static extern void NamedFramebufferTexture2D(Int32 framebuffer, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.TextureTarget textarget, Int32 texture, Int32 level);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedFramebufferTexture2DEXT")]
            public static extern void NamedFramebufferTexture2D(UInt32 framebuffer, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.TextureTarget textarget, UInt32 texture, Int32 level);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedFramebufferTexture3DEXT")]
            public static extern void NamedFramebufferTexture3D(Int32 framebuffer, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.TextureTarget textarget, Int32 texture, Int32 level, Int32 zoffset);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedFramebufferTexture3DEXT")]
            public static extern void NamedFramebufferTexture3D(UInt32 framebuffer, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.TextureTarget textarget, UInt32 texture, Int32 level, Int32 zoffset);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedFramebufferTextureEXT")]
            public static extern void NamedFramebufferTexture(Int32 framebuffer, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, Int32 texture, Int32 level);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedFramebufferTextureEXT")]
            public static extern void NamedFramebufferTexture(UInt32 framebuffer, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, UInt32 texture, Int32 level);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedFramebufferTextureFaceEXT")]
            public static extern void NamedFramebufferTextureFace(Int32 framebuffer, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, Int32 texture, Int32 level, OpenTK.Graphics.OpenGL.TextureTarget face);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedFramebufferTextureFaceEXT")]
            public static extern void NamedFramebufferTextureFace(UInt32 framebuffer, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, UInt32 texture, Int32 level, OpenTK.Graphics.OpenGL.TextureTarget face);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedFramebufferTextureLayerEXT")]
            public static extern void NamedFramebufferTextureLayer(Int32 framebuffer, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, Int32 texture, Int32 level, Int32 layer);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedFramebufferTextureLayerEXT")]
            public static extern void NamedFramebufferTextureLayer(UInt32 framebuffer, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, UInt32 texture, Int32 level, Int32 layer);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParameter4dEXT")]
            public static extern void NamedProgramLocalParameter4(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, Double x, Double y, Double z, Double w);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParameter4dEXT")]
            public static extern void NamedProgramLocalParameter4(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, Double x, Double y, Double z, Double w);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParameter4dvEXT")]
            public static extern void NamedProgramLocalParameter4(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, Double[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParameter4dvEXT")]
            public static extern void NamedProgramLocalParameter4(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, ref Double @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParameter4dvEXT")]
            public static extern unsafe void NamedProgramLocalParameter4(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, Double* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParameter4dvEXT")]
            public static extern void NamedProgramLocalParameter4(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, Double[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParameter4dvEXT")]
            public static extern void NamedProgramLocalParameter4(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, ref Double @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParameter4dvEXT")]
            public static extern unsafe void NamedProgramLocalParameter4(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, Double* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParameter4fEXT")]
            public static extern void NamedProgramLocalParameter4(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, Single x, Single y, Single z, Single w);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParameter4fEXT")]
            public static extern void NamedProgramLocalParameter4(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, Single x, Single y, Single z, Single w);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParameter4fvEXT")]
            public static extern void NamedProgramLocalParameter4(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, Single[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParameter4fvEXT")]
            public static extern void NamedProgramLocalParameter4(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, ref Single @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParameter4fvEXT")]
            public static extern unsafe void NamedProgramLocalParameter4(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, Single* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParameter4fvEXT")]
            public static extern void NamedProgramLocalParameter4(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, Single[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParameter4fvEXT")]
            public static extern void NamedProgramLocalParameter4(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, ref Single @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParameter4fvEXT")]
            public static extern unsafe void NamedProgramLocalParameter4(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, Single* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParameterI4iEXT")]
            public static extern void NamedProgramLocalParameterI4(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, Int32 x, Int32 y, Int32 z, Int32 w);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParameterI4iEXT")]
            public static extern void NamedProgramLocalParameterI4(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, Int32 x, Int32 y, Int32 z, Int32 w);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParameterI4ivEXT")]
            public static extern void NamedProgramLocalParameterI4(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, Int32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParameterI4ivEXT")]
            public static extern void NamedProgramLocalParameterI4(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, ref Int32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParameterI4ivEXT")]
            public static extern unsafe void NamedProgramLocalParameterI4(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParameterI4ivEXT")]
            public static extern void NamedProgramLocalParameterI4(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, Int32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParameterI4ivEXT")]
            public static extern void NamedProgramLocalParameterI4(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, ref Int32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParameterI4ivEXT")]
            public static extern unsafe void NamedProgramLocalParameterI4(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParameterI4uiEXT")]
            public static extern void NamedProgramLocalParameterI4(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, UInt32 x, UInt32 y, UInt32 z, UInt32 w);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParameterI4uivEXT")]
            public static extern void NamedProgramLocalParameterI4(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, UInt32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParameterI4uivEXT")]
            public static extern void NamedProgramLocalParameterI4(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, ref UInt32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParameterI4uivEXT")]
            public static extern unsafe void NamedProgramLocalParameterI4(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, UInt32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParameters4fvEXT")]
            public static extern void NamedProgramLocalParameters4(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, Int32 count, Single[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParameters4fvEXT")]
            public static extern void NamedProgramLocalParameters4(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, Int32 count, ref Single @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParameters4fvEXT")]
            public static extern unsafe void NamedProgramLocalParameters4(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, Int32 count, Single* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParameters4fvEXT")]
            public static extern void NamedProgramLocalParameters4(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, Int32 count, Single[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParameters4fvEXT")]
            public static extern void NamedProgramLocalParameters4(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, Int32 count, ref Single @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParameters4fvEXT")]
            public static extern unsafe void NamedProgramLocalParameters4(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, Int32 count, Single* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParametersI4ivEXT")]
            public static extern void NamedProgramLocalParametersI4(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, Int32 count, Int32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParametersI4ivEXT")]
            public static extern void NamedProgramLocalParametersI4(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, Int32 count, ref Int32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParametersI4ivEXT")]
            public static extern unsafe void NamedProgramLocalParametersI4(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 index, Int32 count, Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParametersI4ivEXT")]
            public static extern void NamedProgramLocalParametersI4(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, Int32 count, Int32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParametersI4ivEXT")]
            public static extern void NamedProgramLocalParametersI4(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, Int32 count, ref Int32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParametersI4ivEXT")]
            public static extern unsafe void NamedProgramLocalParametersI4(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, Int32 count, Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParametersI4uivEXT")]
            public static extern void NamedProgramLocalParametersI4(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, Int32 count, UInt32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParametersI4uivEXT")]
            public static extern void NamedProgramLocalParametersI4(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, Int32 count, ref UInt32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramLocalParametersI4uivEXT")]
            public static extern unsafe void NamedProgramLocalParametersI4(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, Int32 count, UInt32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramStringEXT")]
            public static extern void NamedProgramString(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, OpenTK.Graphics.OpenGL.ExtDirectStateAccess format, Int32 len, IntPtr @string);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramStringEXT")]
            public static extern void NamedProgramString<T4>(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, OpenTK.Graphics.OpenGL.ExtDirectStateAccess format, Int32 len, [InAttribute, OutAttribute] T4[] @string)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramStringEXT")]
            public static extern void NamedProgramString<T4>(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, OpenTK.Graphics.OpenGL.ExtDirectStateAccess format, Int32 len, [InAttribute, OutAttribute] T4[,] @string)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramStringEXT")]
            public static extern void NamedProgramString<T4>(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, OpenTK.Graphics.OpenGL.ExtDirectStateAccess format, Int32 len, [InAttribute, OutAttribute] T4[,,] @string)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramStringEXT")]
            public static extern void NamedProgramString<T4>(Int32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, OpenTK.Graphics.OpenGL.ExtDirectStateAccess format, Int32 len, [InAttribute, OutAttribute] ref T4 @string)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramStringEXT")]
            public static extern void NamedProgramString(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, OpenTK.Graphics.OpenGL.ExtDirectStateAccess format, Int32 len, IntPtr @string);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramStringEXT")]
            public static extern void NamedProgramString<T4>(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, OpenTK.Graphics.OpenGL.ExtDirectStateAccess format, Int32 len, [InAttribute, OutAttribute] T4[] @string)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramStringEXT")]
            public static extern void NamedProgramString<T4>(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, OpenTK.Graphics.OpenGL.ExtDirectStateAccess format, Int32 len, [InAttribute, OutAttribute] T4[,] @string)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramStringEXT")]
            public static extern void NamedProgramString<T4>(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, OpenTK.Graphics.OpenGL.ExtDirectStateAccess format, Int32 len, [InAttribute, OutAttribute] T4[,,] @string)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedProgramStringEXT")]
            public static extern void NamedProgramString<T4>(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, OpenTK.Graphics.OpenGL.ExtDirectStateAccess format, Int32 len, [InAttribute, OutAttribute] ref T4 @string)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedRenderbufferStorageEXT")]
            public static extern void NamedRenderbufferStorage(Int32 renderbuffer, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedRenderbufferStorageEXT")]
            public static extern void NamedRenderbufferStorage(UInt32 renderbuffer, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedRenderbufferStorageMultisampleCoverageEXT")]
            public static extern void NamedRenderbufferStorageMultisampleCoverage(Int32 renderbuffer, Int32 coverageSamples, Int32 colorSamples, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedRenderbufferStorageMultisampleCoverageEXT")]
            public static extern void NamedRenderbufferStorageMultisampleCoverage(UInt32 renderbuffer, Int32 coverageSamples, Int32 colorSamples, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedRenderbufferStorageMultisampleEXT")]
            public static extern void NamedRenderbufferStorageMultisample(Int32 renderbuffer, Int32 samples, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glNamedRenderbufferStorageMultisampleEXT")]
            public static extern void NamedRenderbufferStorageMultisample(UInt32 renderbuffer, Int32 samples, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height);

            /// <summary>[requires: EXT_vertex_array]
            /// Define an array of normals
            /// </summary>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each coordinate in the array. Symbolic constants GL_BYTE, GL_SHORT, GL_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive normals. If stride is 0, the normals are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first coordinate of the first normal in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glNormalPointerEXT")]
            public static extern void NormalPointer(OpenTK.Graphics.OpenGL.NormalPointerType type, Int32 stride, Int32 count, IntPtr pointer);

            /// <summary>[requires: EXT_vertex_array]
            /// Define an array of normals
            /// </summary>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each coordinate in the array. Symbolic constants GL_BYTE, GL_SHORT, GL_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive normals. If stride is 0, the normals are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first coordinate of the first normal in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glNormalPointerEXT")]
            public static extern void NormalPointer<T3>(OpenTK.Graphics.OpenGL.NormalPointerType type, Int32 stride, Int32 count, [InAttribute, OutAttribute] T3[] pointer)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_vertex_array]
            /// Define an array of normals
            /// </summary>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each coordinate in the array. Symbolic constants GL_BYTE, GL_SHORT, GL_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive normals. If stride is 0, the normals are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first coordinate of the first normal in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glNormalPointerEXT")]
            public static extern void NormalPointer<T3>(OpenTK.Graphics.OpenGL.NormalPointerType type, Int32 stride, Int32 count, [InAttribute, OutAttribute] T3[,] pointer)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_vertex_array]
            /// Define an array of normals
            /// </summary>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each coordinate in the array. Symbolic constants GL_BYTE, GL_SHORT, GL_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive normals. If stride is 0, the normals are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first coordinate of the first normal in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glNormalPointerEXT")]
            public static extern void NormalPointer<T3>(OpenTK.Graphics.OpenGL.NormalPointerType type, Int32 stride, Int32 count, [InAttribute, OutAttribute] T3[,,] pointer)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_vertex_array]
            /// Define an array of normals
            /// </summary>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each coordinate in the array. Symbolic constants GL_BYTE, GL_SHORT, GL_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive normals. If stride is 0, the normals are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first coordinate of the first normal in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glNormalPointerEXT")]
            public static extern void NormalPointer<T3>(OpenTK.Graphics.OpenGL.NormalPointerType type, Int32 stride, Int32 count, [InAttribute, OutAttribute] ref T3 pointer)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_pixel_transform]</summary>
            [AutoGenerated(Category = "EXT_pixel_transform", Version = "", EntryPoint = "glPixelTransformParameterfEXT")]
            public static extern void PixelTransformParameter(OpenTK.Graphics.OpenGL.ExtPixelTransform target, OpenTK.Graphics.OpenGL.ExtPixelTransform pname, Single param);

            /// <summary>[requires: EXT_pixel_transform]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_pixel_transform", Version = "", EntryPoint = "glPixelTransformParameterfvEXT")]
            public static extern unsafe void PixelTransformParameter(OpenTK.Graphics.OpenGL.ExtPixelTransform target, OpenTK.Graphics.OpenGL.ExtPixelTransform pname, Single* @params);

            /// <summary>[requires: EXT_pixel_transform]</summary>
            [AutoGenerated(Category = "EXT_pixel_transform", Version = "", EntryPoint = "glPixelTransformParameteriEXT")]
            public static extern void PixelTransformParameter(OpenTK.Graphics.OpenGL.ExtPixelTransform target, OpenTK.Graphics.OpenGL.ExtPixelTransform pname, Int32 param);

            /// <summary>[requires: EXT_pixel_transform]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_pixel_transform", Version = "", EntryPoint = "glPixelTransformParameterivEXT")]
            public static extern unsafe void PixelTransformParameter(OpenTK.Graphics.OpenGL.ExtPixelTransform target, OpenTK.Graphics.OpenGL.ExtPixelTransform pname, Int32* @params);

            /// <summary>[requires: EXT_point_parameters]
            /// Specify point parameters
            /// </summary>
            /// <param name="pname">
            /// <para>
            /// Specifies a single-valued point parameter. GL_POINT_FADE_THRESHOLD_SIZE, and GL_POINT_SPRITE_COORD_ORIGIN are accepted.
            /// </para>
            /// </param>
            /// <param name="param">
            /// <para>
            /// For glPointParameterf and glPointParameteri, specifies the value that pname will be set to.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// For glPointParameterfv and glPointParameteriv, specifies a pointer to an array where the value or values to be assigned to pname are stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_point_parameters", Version = "", EntryPoint = "glPointParameterfEXT")]
            public static extern void PointParameter(OpenTK.Graphics.OpenGL.ExtPointParameters pname, Single param);

            /// <summary>[requires: EXT_point_parameters]
            /// Specify point parameters
            /// </summary>
            /// <param name="pname">
            /// <para>
            /// Specifies a single-valued point parameter. GL_POINT_FADE_THRESHOLD_SIZE, and GL_POINT_SPRITE_COORD_ORIGIN are accepted.
            /// </para>
            /// </param>
            /// <param name="param">
            /// <para>
            /// For glPointParameterf and glPointParameteri, specifies the value that pname will be set to.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// For glPointParameterfv and glPointParameteriv, specifies a pointer to an array where the value or values to be assigned to pname are stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_point_parameters", Version = "", EntryPoint = "glPointParameterfvEXT")]
            public static extern void PointParameter(OpenTK.Graphics.OpenGL.ExtPointParameters pname, Single[] @params);

            /// <summary>[requires: EXT_point_parameters]
            /// Specify point parameters
            /// </summary>
            /// <param name="pname">
            /// <para>
            /// Specifies a single-valued point parameter. GL_POINT_FADE_THRESHOLD_SIZE, and GL_POINT_SPRITE_COORD_ORIGIN are accepted.
            /// </para>
            /// </param>
            /// <param name="param">
            /// <para>
            /// For glPointParameterf and glPointParameteri, specifies the value that pname will be set to.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// For glPointParameterfv and glPointParameteriv, specifies a pointer to an array where the value or values to be assigned to pname are stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_point_parameters", Version = "", EntryPoint = "glPointParameterfvEXT")]
            public static extern unsafe void PointParameter(OpenTK.Graphics.OpenGL.ExtPointParameters pname, Single* @params);

            /// <summary>[requires: EXT_polygon_offset]
            /// Set the scale and units used to calculate depth values
            /// </summary>
            /// <param name="factor">
            /// <para>
            /// Specifies a scale factor that is used to create a variable depth offset for each polygon. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="units">
            /// <para>
            /// Is multiplied by an implementation-specific value to create a constant depth offset. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_polygon_offset", Version = "", EntryPoint = "glPolygonOffsetEXT")]
            public static extern void PolygonOffset(Single factor, Single bias);

            /// <summary>[requires: EXT_debug_marker]</summary>
            [AutoGenerated(Category = "EXT_debug_marker", Version = "", EntryPoint = "glPopGroupMarkerEXT")]
            public static extern void PopGroupMarker();

            /// <summary>[requires: EXT_texture_object]
            /// Set texture residence priority
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of textures to be prioritized.
            /// </para>
            /// </param>
            /// <param name="textures">
            /// <para>
            /// Specifies an array containing the names of the textures to be prioritized.
            /// </para>
            /// </param>
            /// <param name="priorities">
            /// <para>
            /// Specifies an array containing the texture priorities. A priority given in an element of priorities applies to the texture named by the corresponding element of textures.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_texture_object", Version = "", EntryPoint = "glPrioritizeTexturesEXT")]
            public static extern void PrioritizeTextures(Int32 n, Int32[] textures, Single[] priorities);

            /// <summary>[requires: EXT_texture_object]
            /// Set texture residence priority
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of textures to be prioritized.
            /// </para>
            /// </param>
            /// <param name="textures">
            /// <para>
            /// Specifies an array containing the names of the textures to be prioritized.
            /// </para>
            /// </param>
            /// <param name="priorities">
            /// <para>
            /// Specifies an array containing the texture priorities. A priority given in an element of priorities applies to the texture named by the corresponding element of textures.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_texture_object", Version = "", EntryPoint = "glPrioritizeTexturesEXT")]
            public static extern void PrioritizeTextures(Int32 n, ref Int32 textures, ref Single priorities);

            /// <summary>[requires: EXT_texture_object]
            /// Set texture residence priority
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of textures to be prioritized.
            /// </para>
            /// </param>
            /// <param name="textures">
            /// <para>
            /// Specifies an array containing the names of the textures to be prioritized.
            /// </para>
            /// </param>
            /// <param name="priorities">
            /// <para>
            /// Specifies an array containing the texture priorities. A priority given in an element of priorities applies to the texture named by the corresponding element of textures.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_texture_object", Version = "", EntryPoint = "glPrioritizeTexturesEXT")]
            public static extern unsafe void PrioritizeTextures(Int32 n, Int32* textures, Single* priorities);

            /// <summary>[requires: EXT_texture_object]
            /// Set texture residence priority
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of textures to be prioritized.
            /// </para>
            /// </param>
            /// <param name="textures">
            /// <para>
            /// Specifies an array containing the names of the textures to be prioritized.
            /// </para>
            /// </param>
            /// <param name="priorities">
            /// <para>
            /// Specifies an array containing the texture priorities. A priority given in an element of priorities applies to the texture named by the corresponding element of textures.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_texture_object", Version = "", EntryPoint = "glPrioritizeTexturesEXT")]
            public static extern void PrioritizeTextures(Int32 n, UInt32[] textures, Single[] priorities);

            /// <summary>[requires: EXT_texture_object]
            /// Set texture residence priority
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of textures to be prioritized.
            /// </para>
            /// </param>
            /// <param name="textures">
            /// <para>
            /// Specifies an array containing the names of the textures to be prioritized.
            /// </para>
            /// </param>
            /// <param name="priorities">
            /// <para>
            /// Specifies an array containing the texture priorities. A priority given in an element of priorities applies to the texture named by the corresponding element of textures.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_texture_object", Version = "", EntryPoint = "glPrioritizeTexturesEXT")]
            public static extern void PrioritizeTextures(Int32 n, ref UInt32 textures, ref Single priorities);

            /// <summary>[requires: EXT_texture_object]
            /// Set texture residence priority
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of textures to be prioritized.
            /// </para>
            /// </param>
            /// <param name="textures">
            /// <para>
            /// Specifies an array containing the names of the textures to be prioritized.
            /// </para>
            /// </param>
            /// <param name="priorities">
            /// <para>
            /// Specifies an array containing the texture priorities. A priority given in an element of priorities applies to the texture named by the corresponding element of textures.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_texture_object", Version = "", EntryPoint = "glPrioritizeTexturesEXT")]
            public static extern unsafe void PrioritizeTextures(Int32 n, UInt32* textures, Single* priorities);

            /// <summary>[requires: EXT_gpu_program_parameters]</summary>
            [AutoGenerated(Category = "EXT_gpu_program_parameters", Version = "", EntryPoint = "glProgramEnvParameters4fvEXT")]
            public static extern void ProgramEnvParameters4(OpenTK.Graphics.OpenGL.ExtGpuProgramParameters target, Int32 index, Int32 count, Single[] @params);

            /// <summary>[requires: EXT_gpu_program_parameters]</summary>
            [AutoGenerated(Category = "EXT_gpu_program_parameters", Version = "", EntryPoint = "glProgramEnvParameters4fvEXT")]
            public static extern void ProgramEnvParameters4(OpenTK.Graphics.OpenGL.ExtGpuProgramParameters target, Int32 index, Int32 count, ref Single @params);

            /// <summary>[requires: EXT_gpu_program_parameters]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_gpu_program_parameters", Version = "", EntryPoint = "glProgramEnvParameters4fvEXT")]
            public static extern unsafe void ProgramEnvParameters4(OpenTK.Graphics.OpenGL.ExtGpuProgramParameters target, Int32 index, Int32 count, Single* @params);

            /// <summary>[requires: EXT_gpu_program_parameters]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_gpu_program_parameters", Version = "", EntryPoint = "glProgramEnvParameters4fvEXT")]
            public static extern void ProgramEnvParameters4(OpenTK.Graphics.OpenGL.ExtGpuProgramParameters target, UInt32 index, Int32 count, Single[] @params);

            /// <summary>[requires: EXT_gpu_program_parameters]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_gpu_program_parameters", Version = "", EntryPoint = "glProgramEnvParameters4fvEXT")]
            public static extern void ProgramEnvParameters4(OpenTK.Graphics.OpenGL.ExtGpuProgramParameters target, UInt32 index, Int32 count, ref Single @params);

            /// <summary>[requires: EXT_gpu_program_parameters]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_gpu_program_parameters", Version = "", EntryPoint = "glProgramEnvParameters4fvEXT")]
            public static extern unsafe void ProgramEnvParameters4(OpenTK.Graphics.OpenGL.ExtGpuProgramParameters target, UInt32 index, Int32 count, Single* @params);

            /// <summary>[requires: EXT_gpu_program_parameters]</summary>
            [AutoGenerated(Category = "EXT_gpu_program_parameters", Version = "", EntryPoint = "glProgramLocalParameters4fvEXT")]
            public static extern void ProgramLocalParameters4(OpenTK.Graphics.OpenGL.ExtGpuProgramParameters target, Int32 index, Int32 count, Single[] @params);

            /// <summary>[requires: EXT_gpu_program_parameters]</summary>
            [AutoGenerated(Category = "EXT_gpu_program_parameters", Version = "", EntryPoint = "glProgramLocalParameters4fvEXT")]
            public static extern void ProgramLocalParameters4(OpenTK.Graphics.OpenGL.ExtGpuProgramParameters target, Int32 index, Int32 count, ref Single @params);

            /// <summary>[requires: EXT_gpu_program_parameters]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_gpu_program_parameters", Version = "", EntryPoint = "glProgramLocalParameters4fvEXT")]
            public static extern unsafe void ProgramLocalParameters4(OpenTK.Graphics.OpenGL.ExtGpuProgramParameters target, Int32 index, Int32 count, Single* @params);

            /// <summary>[requires: EXT_gpu_program_parameters]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_gpu_program_parameters", Version = "", EntryPoint = "glProgramLocalParameters4fvEXT")]
            public static extern void ProgramLocalParameters4(OpenTK.Graphics.OpenGL.ExtGpuProgramParameters target, UInt32 index, Int32 count, Single[] @params);

            /// <summary>[requires: EXT_gpu_program_parameters]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_gpu_program_parameters", Version = "", EntryPoint = "glProgramLocalParameters4fvEXT")]
            public static extern void ProgramLocalParameters4(OpenTK.Graphics.OpenGL.ExtGpuProgramParameters target, UInt32 index, Int32 count, ref Single @params);

            /// <summary>[requires: EXT_gpu_program_parameters]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_gpu_program_parameters", Version = "", EntryPoint = "glProgramLocalParameters4fvEXT")]
            public static extern unsafe void ProgramLocalParameters4(OpenTK.Graphics.OpenGL.ExtGpuProgramParameters target, UInt32 index, Int32 count, Single* @params);

            /// <summary>[requires: EXT_geometry_shader4|EXT_separate_shader_objects]
            /// Specify a parameter for a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the name of a program object whose parameter to modify.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the name of the parameter to modify.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// Specifies the new value of the parameter specified by pname for program.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_geometry_shader4|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramParameteriEXT")]
            public static extern void ProgramParameter(Int32 program, OpenTK.Graphics.OpenGL.AssemblyProgramParameterArb pname, Int32 value);

            /// <summary>[requires: EXT_geometry_shader4|EXT_separate_shader_objects]
            /// Specify a parameter for a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the name of a program object whose parameter to modify.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the name of the parameter to modify.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// Specifies the new value of the parameter specified by pname for program.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_geometry_shader4|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramParameteriEXT")]
            public static extern void ProgramParameter(UInt32 program, OpenTK.Graphics.OpenGL.AssemblyProgramParameterArb pname, Int32 value);

            /// <summary>[requires: EXT_direct_state_access]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniform1dEXT")]
            public static extern void ProgramUniform1(Int32 program, Int32 location, Double x);

            /// <summary>[requires: EXT_direct_state_access]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniform1dEXT")]
            public static extern void ProgramUniform1(UInt32 program, Int32 location, Double x);

            /// <summary>[requires: EXT_direct_state_access]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniform1dvEXT")]
            public static extern void ProgramUniform1(Int32 program, Int32 location, Int32 count, Double[] value);

            /// <summary>[requires: EXT_direct_state_access]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniform1dvEXT")]
            public static extern void ProgramUniform1(Int32 program, Int32 location, Int32 count, ref Double value);

            /// <summary>[requires: EXT_direct_state_access]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniform1dvEXT")]
            public static extern unsafe void ProgramUniform1(Int32 program, Int32 location, Int32 count, Double* value);

            /// <summary>[requires: EXT_direct_state_access]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniform1dvEXT")]
            public static extern void ProgramUniform1(UInt32 program, Int32 location, Int32 count, Double[] value);

            /// <summary>[requires: EXT_direct_state_access]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniform1dvEXT")]
            public static extern void ProgramUniform1(UInt32 program, Int32 location, Int32 count, ref Double value);

            /// <summary>[requires: EXT_direct_state_access]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniform1dvEXT")]
            public static extern unsafe void ProgramUniform1(UInt32 program, Int32 location, Int32 count, Double* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform1fEXT")]
            public static extern void ProgramUniform1(Int32 program, Int32 location, Single v0);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform1fEXT")]
            public static extern void ProgramUniform1(UInt32 program, Int32 location, Single v0);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform1fvEXT")]
            public static extern void ProgramUniform1(Int32 program, Int32 location, Int32 count, Single[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform1fvEXT")]
            public static extern void ProgramUniform1(Int32 program, Int32 location, Int32 count, ref Single value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform1fvEXT")]
            public static extern unsafe void ProgramUniform1(Int32 program, Int32 location, Int32 count, Single* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform1fvEXT")]
            public static extern void ProgramUniform1(UInt32 program, Int32 location, Int32 count, Single[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform1fvEXT")]
            public static extern void ProgramUniform1(UInt32 program, Int32 location, Int32 count, ref Single value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform1fvEXT")]
            public static extern unsafe void ProgramUniform1(UInt32 program, Int32 location, Int32 count, Single* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform1iEXT")]
            public static extern void ProgramUniform1(Int32 program, Int32 location, Int32 v0);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform1iEXT")]
            public static extern void ProgramUniform1(UInt32 program, Int32 location, Int32 v0);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform1ivEXT")]
            public static extern void ProgramUniform1(Int32 program, Int32 location, Int32 count, Int32[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform1ivEXT")]
            public static extern void ProgramUniform1(Int32 program, Int32 location, Int32 count, ref Int32 value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform1ivEXT")]
            public static extern unsafe void ProgramUniform1(Int32 program, Int32 location, Int32 count, Int32* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform1ivEXT")]
            public static extern void ProgramUniform1(UInt32 program, Int32 location, Int32 count, Int32[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform1ivEXT")]
            public static extern void ProgramUniform1(UInt32 program, Int32 location, Int32 count, ref Int32 value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform1ivEXT")]
            public static extern unsafe void ProgramUniform1(UInt32 program, Int32 location, Int32 count, Int32* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform1uiEXT")]
            public static extern void ProgramUniform1(UInt32 program, Int32 location, UInt32 v0);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform1uivEXT")]
            public static extern void ProgramUniform1(UInt32 program, Int32 location, Int32 count, UInt32[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform1uivEXT")]
            public static extern void ProgramUniform1(UInt32 program, Int32 location, Int32 count, ref UInt32 value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform1uivEXT")]
            public static extern unsafe void ProgramUniform1(UInt32 program, Int32 location, Int32 count, UInt32* value);

            /// <summary>[requires: EXT_direct_state_access]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniform2dEXT")]
            public static extern void ProgramUniform2(Int32 program, Int32 location, Double x, Double y);

            /// <summary>[requires: EXT_direct_state_access]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniform2dEXT")]
            public static extern void ProgramUniform2(UInt32 program, Int32 location, Double x, Double y);

            /// <summary>[requires: EXT_direct_state_access]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniform2dvEXT")]
            public static extern void ProgramUniform2(Int32 program, Int32 location, Int32 count, Double[] value);

            /// <summary>[requires: EXT_direct_state_access]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniform2dvEXT")]
            public static extern void ProgramUniform2(Int32 program, Int32 location, Int32 count, ref Double value);

            /// <summary>[requires: EXT_direct_state_access]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniform2dvEXT")]
            public static extern unsafe void ProgramUniform2(Int32 program, Int32 location, Int32 count, Double* value);

            /// <summary>[requires: EXT_direct_state_access]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniform2dvEXT")]
            public static extern void ProgramUniform2(UInt32 program, Int32 location, Int32 count, Double[] value);

            /// <summary>[requires: EXT_direct_state_access]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniform2dvEXT")]
            public static extern void ProgramUniform2(UInt32 program, Int32 location, Int32 count, ref Double value);

            /// <summary>[requires: EXT_direct_state_access]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniform2dvEXT")]
            public static extern unsafe void ProgramUniform2(UInt32 program, Int32 location, Int32 count, Double* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform2fEXT")]
            public static extern void ProgramUniform2(Int32 program, Int32 location, Single v0, Single v1);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform2fEXT")]
            public static extern void ProgramUniform2(UInt32 program, Int32 location, Single v0, Single v1);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform2fvEXT")]
            public static extern void ProgramUniform2(Int32 program, Int32 location, Int32 count, Single[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform2fvEXT")]
            public static extern void ProgramUniform2(Int32 program, Int32 location, Int32 count, ref Single value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform2fvEXT")]
            public static extern unsafe void ProgramUniform2(Int32 program, Int32 location, Int32 count, Single* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform2fvEXT")]
            public static extern void ProgramUniform2(UInt32 program, Int32 location, Int32 count, Single[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform2fvEXT")]
            public static extern void ProgramUniform2(UInt32 program, Int32 location, Int32 count, ref Single value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform2fvEXT")]
            public static extern unsafe void ProgramUniform2(UInt32 program, Int32 location, Int32 count, Single* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform2iEXT")]
            public static extern void ProgramUniform2(Int32 program, Int32 location, Int32 v0, Int32 v1);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform2iEXT")]
            public static extern void ProgramUniform2(UInt32 program, Int32 location, Int32 v0, Int32 v1);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform2ivEXT")]
            public static extern void ProgramUniform2(Int32 program, Int32 location, Int32 count, Int32[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform2ivEXT")]
            public static extern unsafe void ProgramUniform2(Int32 program, Int32 location, Int32 count, Int32* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform2ivEXT")]
            public static extern void ProgramUniform2(UInt32 program, Int32 location, Int32 count, Int32[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform2ivEXT")]
            public static extern unsafe void ProgramUniform2(UInt32 program, Int32 location, Int32 count, Int32* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform2uiEXT")]
            public static extern void ProgramUniform2(UInt32 program, Int32 location, UInt32 v0, UInt32 v1);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform2uivEXT")]
            public static extern void ProgramUniform2(UInt32 program, Int32 location, Int32 count, UInt32[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform2uivEXT")]
            public static extern void ProgramUniform2(UInt32 program, Int32 location, Int32 count, ref UInt32 value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform2uivEXT")]
            public static extern unsafe void ProgramUniform2(UInt32 program, Int32 location, Int32 count, UInt32* value);

            /// <summary>[requires: EXT_direct_state_access]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniform3dEXT")]
            public static extern void ProgramUniform3(Int32 program, Int32 location, Double x, Double y, Double z);

            /// <summary>[requires: EXT_direct_state_access]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniform3dEXT")]
            public static extern void ProgramUniform3(UInt32 program, Int32 location, Double x, Double y, Double z);

            /// <summary>[requires: EXT_direct_state_access]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniform3dvEXT")]
            public static extern void ProgramUniform3(Int32 program, Int32 location, Int32 count, Double[] value);

            /// <summary>[requires: EXT_direct_state_access]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniform3dvEXT")]
            public static extern void ProgramUniform3(Int32 program, Int32 location, Int32 count, ref Double value);

            /// <summary>[requires: EXT_direct_state_access]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniform3dvEXT")]
            public static extern unsafe void ProgramUniform3(Int32 program, Int32 location, Int32 count, Double* value);

            /// <summary>[requires: EXT_direct_state_access]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniform3dvEXT")]
            public static extern void ProgramUniform3(UInt32 program, Int32 location, Int32 count, Double[] value);

            /// <summary>[requires: EXT_direct_state_access]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniform3dvEXT")]
            public static extern void ProgramUniform3(UInt32 program, Int32 location, Int32 count, ref Double value);

            /// <summary>[requires: EXT_direct_state_access]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniform3dvEXT")]
            public static extern unsafe void ProgramUniform3(UInt32 program, Int32 location, Int32 count, Double* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform3fEXT")]
            public static extern void ProgramUniform3(Int32 program, Int32 location, Single v0, Single v1, Single v2);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform3fEXT")]
            public static extern void ProgramUniform3(UInt32 program, Int32 location, Single v0, Single v1, Single v2);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform3fvEXT")]
            public static extern void ProgramUniform3(Int32 program, Int32 location, Int32 count, Single[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform3fvEXT")]
            public static extern void ProgramUniform3(Int32 program, Int32 location, Int32 count, ref Single value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform3fvEXT")]
            public static extern unsafe void ProgramUniform3(Int32 program, Int32 location, Int32 count, Single* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform3fvEXT")]
            public static extern void ProgramUniform3(UInt32 program, Int32 location, Int32 count, Single[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform3fvEXT")]
            public static extern void ProgramUniform3(UInt32 program, Int32 location, Int32 count, ref Single value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform3fvEXT")]
            public static extern unsafe void ProgramUniform3(UInt32 program, Int32 location, Int32 count, Single* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform3iEXT")]
            public static extern void ProgramUniform3(Int32 program, Int32 location, Int32 v0, Int32 v1, Int32 v2);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform3iEXT")]
            public static extern void ProgramUniform3(UInt32 program, Int32 location, Int32 v0, Int32 v1, Int32 v2);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform3ivEXT")]
            public static extern void ProgramUniform3(Int32 program, Int32 location, Int32 count, Int32[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform3ivEXT")]
            public static extern void ProgramUniform3(Int32 program, Int32 location, Int32 count, ref Int32 value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform3ivEXT")]
            public static extern unsafe void ProgramUniform3(Int32 program, Int32 location, Int32 count, Int32* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform3ivEXT")]
            public static extern void ProgramUniform3(UInt32 program, Int32 location, Int32 count, Int32[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform3ivEXT")]
            public static extern void ProgramUniform3(UInt32 program, Int32 location, Int32 count, ref Int32 value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform3ivEXT")]
            public static extern unsafe void ProgramUniform3(UInt32 program, Int32 location, Int32 count, Int32* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform3uiEXT")]
            public static extern void ProgramUniform3(UInt32 program, Int32 location, UInt32 v0, UInt32 v1, UInt32 v2);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform3uivEXT")]
            public static extern void ProgramUniform3(UInt32 program, Int32 location, Int32 count, UInt32[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform3uivEXT")]
            public static extern void ProgramUniform3(UInt32 program, Int32 location, Int32 count, ref UInt32 value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform3uivEXT")]
            public static extern unsafe void ProgramUniform3(UInt32 program, Int32 location, Int32 count, UInt32* value);

            /// <summary>[requires: EXT_direct_state_access]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniform4dEXT")]
            public static extern void ProgramUniform4(Int32 program, Int32 location, Double x, Double y, Double z, Double w);

            /// <summary>[requires: EXT_direct_state_access]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniform4dEXT")]
            public static extern void ProgramUniform4(UInt32 program, Int32 location, Double x, Double y, Double z, Double w);

            /// <summary>[requires: EXT_direct_state_access]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniform4dvEXT")]
            public static extern void ProgramUniform4(Int32 program, Int32 location, Int32 count, Double[] value);

            /// <summary>[requires: EXT_direct_state_access]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniform4dvEXT")]
            public static extern void ProgramUniform4(Int32 program, Int32 location, Int32 count, ref Double value);

            /// <summary>[requires: EXT_direct_state_access]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniform4dvEXT")]
            public static extern unsafe void ProgramUniform4(Int32 program, Int32 location, Int32 count, Double* value);

            /// <summary>[requires: EXT_direct_state_access]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniform4dvEXT")]
            public static extern void ProgramUniform4(UInt32 program, Int32 location, Int32 count, Double[] value);

            /// <summary>[requires: EXT_direct_state_access]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniform4dvEXT")]
            public static extern void ProgramUniform4(UInt32 program, Int32 location, Int32 count, ref Double value);

            /// <summary>[requires: EXT_direct_state_access]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniform4dvEXT")]
            public static extern unsafe void ProgramUniform4(UInt32 program, Int32 location, Int32 count, Double* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform4fEXT")]
            public static extern void ProgramUniform4(Int32 program, Int32 location, Single v0, Single v1, Single v2, Single v3);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform4fEXT")]
            public static extern void ProgramUniform4(UInt32 program, Int32 location, Single v0, Single v1, Single v2, Single v3);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform4fvEXT")]
            public static extern void ProgramUniform4(Int32 program, Int32 location, Int32 count, Single[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform4fvEXT")]
            public static extern void ProgramUniform4(Int32 program, Int32 location, Int32 count, ref Single value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform4fvEXT")]
            public static extern unsafe void ProgramUniform4(Int32 program, Int32 location, Int32 count, Single* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform4fvEXT")]
            public static extern void ProgramUniform4(UInt32 program, Int32 location, Int32 count, Single[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform4fvEXT")]
            public static extern void ProgramUniform4(UInt32 program, Int32 location, Int32 count, ref Single value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform4fvEXT")]
            public static extern unsafe void ProgramUniform4(UInt32 program, Int32 location, Int32 count, Single* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform4iEXT")]
            public static extern void ProgramUniform4(Int32 program, Int32 location, Int32 v0, Int32 v1, Int32 v2, Int32 v3);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform4iEXT")]
            public static extern void ProgramUniform4(UInt32 program, Int32 location, Int32 v0, Int32 v1, Int32 v2, Int32 v3);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform4ivEXT")]
            public static extern void ProgramUniform4(Int32 program, Int32 location, Int32 count, Int32[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform4ivEXT")]
            public static extern void ProgramUniform4(Int32 program, Int32 location, Int32 count, ref Int32 value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform4ivEXT")]
            public static extern unsafe void ProgramUniform4(Int32 program, Int32 location, Int32 count, Int32* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform4ivEXT")]
            public static extern void ProgramUniform4(UInt32 program, Int32 location, Int32 count, Int32[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform4ivEXT")]
            public static extern void ProgramUniform4(UInt32 program, Int32 location, Int32 count, ref Int32 value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform4ivEXT")]
            public static extern unsafe void ProgramUniform4(UInt32 program, Int32 location, Int32 count, Int32* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform4uiEXT")]
            public static extern void ProgramUniform4(UInt32 program, Int32 location, UInt32 v0, UInt32 v1, UInt32 v2, UInt32 v3);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform4uivEXT")]
            public static extern void ProgramUniform4(UInt32 program, Int32 location, Int32 count, UInt32[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform4uivEXT")]
            public static extern void ProgramUniform4(UInt32 program, Int32 location, Int32 count, ref UInt32 value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniform4uivEXT")]
            public static extern unsafe void ProgramUniform4(UInt32 program, Int32 location, Int32 count, UInt32* value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix2dvEXT")]
            public static extern void ProgramUniformMatrix2(Int32 program, Int32 location, Int32 count, bool transpose, Double[] value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix2dvEXT")]
            public static extern void ProgramUniformMatrix2(Int32 program, Int32 location, Int32 count, bool transpose, ref Double value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix2dvEXT")]
            public static extern unsafe void ProgramUniformMatrix2(Int32 program, Int32 location, Int32 count, bool transpose, Double* value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix2dvEXT")]
            public static extern void ProgramUniformMatrix2(UInt32 program, Int32 location, Int32 count, bool transpose, Double[] value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix2dvEXT")]
            public static extern void ProgramUniformMatrix2(UInt32 program, Int32 location, Int32 count, bool transpose, ref Double value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix2dvEXT")]
            public static extern unsafe void ProgramUniformMatrix2(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix2fvEXT")]
            public static extern void ProgramUniformMatrix2(Int32 program, Int32 location, Int32 count, bool transpose, Single[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix2fvEXT")]
            public static extern void ProgramUniformMatrix2(Int32 program, Int32 location, Int32 count, bool transpose, ref Single value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix2fvEXT")]
            public static extern unsafe void ProgramUniformMatrix2(Int32 program, Int32 location, Int32 count, bool transpose, Single* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix2fvEXT")]
            public static extern void ProgramUniformMatrix2(UInt32 program, Int32 location, Int32 count, bool transpose, Single[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix2fvEXT")]
            public static extern void ProgramUniformMatrix2(UInt32 program, Int32 location, Int32 count, bool transpose, ref Single value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix2fvEXT")]
            public static extern unsafe void ProgramUniformMatrix2(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix2x3dvEXT")]
            public static extern void ProgramUniformMatrix2x3(Int32 program, Int32 location, Int32 count, bool transpose, Double[] value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix2x3dvEXT")]
            public static extern void ProgramUniformMatrix2x3(Int32 program, Int32 location, Int32 count, bool transpose, ref Double value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix2x3dvEXT")]
            public static extern unsafe void ProgramUniformMatrix2x3(Int32 program, Int32 location, Int32 count, bool transpose, Double* value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix2x3dvEXT")]
            public static extern void ProgramUniformMatrix2x3(UInt32 program, Int32 location, Int32 count, bool transpose, Double[] value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix2x3dvEXT")]
            public static extern void ProgramUniformMatrix2x3(UInt32 program, Int32 location, Int32 count, bool transpose, ref Double value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix2x3dvEXT")]
            public static extern unsafe void ProgramUniformMatrix2x3(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix2x3fvEXT")]
            public static extern void ProgramUniformMatrix2x3(Int32 program, Int32 location, Int32 count, bool transpose, Single[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix2x3fvEXT")]
            public static extern void ProgramUniformMatrix2x3(Int32 program, Int32 location, Int32 count, bool transpose, ref Single value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix2x3fvEXT")]
            public static extern unsafe void ProgramUniformMatrix2x3(Int32 program, Int32 location, Int32 count, bool transpose, Single* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix2x3fvEXT")]
            public static extern void ProgramUniformMatrix2x3(UInt32 program, Int32 location, Int32 count, bool transpose, Single[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix2x3fvEXT")]
            public static extern void ProgramUniformMatrix2x3(UInt32 program, Int32 location, Int32 count, bool transpose, ref Single value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix2x3fvEXT")]
            public static extern unsafe void ProgramUniformMatrix2x3(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix2x4dvEXT")]
            public static extern void ProgramUniformMatrix2x4(Int32 program, Int32 location, Int32 count, bool transpose, Double[] value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix2x4dvEXT")]
            public static extern void ProgramUniformMatrix2x4(Int32 program, Int32 location, Int32 count, bool transpose, ref Double value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix2x4dvEXT")]
            public static extern unsafe void ProgramUniformMatrix2x4(Int32 program, Int32 location, Int32 count, bool transpose, Double* value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix2x4dvEXT")]
            public static extern void ProgramUniformMatrix2x4(UInt32 program, Int32 location, Int32 count, bool transpose, Double[] value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix2x4dvEXT")]
            public static extern void ProgramUniformMatrix2x4(UInt32 program, Int32 location, Int32 count, bool transpose, ref Double value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix2x4dvEXT")]
            public static extern unsafe void ProgramUniformMatrix2x4(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix2x4fvEXT")]
            public static extern void ProgramUniformMatrix2x4(Int32 program, Int32 location, Int32 count, bool transpose, Single[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix2x4fvEXT")]
            public static extern void ProgramUniformMatrix2x4(Int32 program, Int32 location, Int32 count, bool transpose, ref Single value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix2x4fvEXT")]
            public static extern unsafe void ProgramUniformMatrix2x4(Int32 program, Int32 location, Int32 count, bool transpose, Single* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix2x4fvEXT")]
            public static extern void ProgramUniformMatrix2x4(UInt32 program, Int32 location, Int32 count, bool transpose, Single[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix2x4fvEXT")]
            public static extern void ProgramUniformMatrix2x4(UInt32 program, Int32 location, Int32 count, bool transpose, ref Single value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix2x4fvEXT")]
            public static extern unsafe void ProgramUniformMatrix2x4(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix3dvEXT")]
            public static extern void ProgramUniformMatrix3(Int32 program, Int32 location, Int32 count, bool transpose, Double[] value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix3dvEXT")]
            public static extern void ProgramUniformMatrix3(Int32 program, Int32 location, Int32 count, bool transpose, ref Double value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix3dvEXT")]
            public static extern unsafe void ProgramUniformMatrix3(Int32 program, Int32 location, Int32 count, bool transpose, Double* value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix3dvEXT")]
            public static extern void ProgramUniformMatrix3(UInt32 program, Int32 location, Int32 count, bool transpose, Double[] value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix3dvEXT")]
            public static extern void ProgramUniformMatrix3(UInt32 program, Int32 location, Int32 count, bool transpose, ref Double value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix3dvEXT")]
            public static extern unsafe void ProgramUniformMatrix3(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix3fvEXT")]
            public static extern void ProgramUniformMatrix3(Int32 program, Int32 location, Int32 count, bool transpose, Single[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix3fvEXT")]
            public static extern void ProgramUniformMatrix3(Int32 program, Int32 location, Int32 count, bool transpose, ref Single value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix3fvEXT")]
            public static extern unsafe void ProgramUniformMatrix3(Int32 program, Int32 location, Int32 count, bool transpose, Single* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix3fvEXT")]
            public static extern void ProgramUniformMatrix3(UInt32 program, Int32 location, Int32 count, bool transpose, Single[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix3fvEXT")]
            public static extern void ProgramUniformMatrix3(UInt32 program, Int32 location, Int32 count, bool transpose, ref Single value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix3fvEXT")]
            public static extern unsafe void ProgramUniformMatrix3(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix3x2dvEXT")]
            public static extern void ProgramUniformMatrix3x2(Int32 program, Int32 location, Int32 count, bool transpose, Double[] value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix3x2dvEXT")]
            public static extern void ProgramUniformMatrix3x2(Int32 program, Int32 location, Int32 count, bool transpose, ref Double value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix3x2dvEXT")]
            public static extern unsafe void ProgramUniformMatrix3x2(Int32 program, Int32 location, Int32 count, bool transpose, Double* value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix3x2dvEXT")]
            public static extern void ProgramUniformMatrix3x2(UInt32 program, Int32 location, Int32 count, bool transpose, Double[] value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix3x2dvEXT")]
            public static extern void ProgramUniformMatrix3x2(UInt32 program, Int32 location, Int32 count, bool transpose, ref Double value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix3x2dvEXT")]
            public static extern unsafe void ProgramUniformMatrix3x2(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix3x2fvEXT")]
            public static extern void ProgramUniformMatrix3x2(Int32 program, Int32 location, Int32 count, bool transpose, Single[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix3x2fvEXT")]
            public static extern void ProgramUniformMatrix3x2(Int32 program, Int32 location, Int32 count, bool transpose, ref Single value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix3x2fvEXT")]
            public static extern unsafe void ProgramUniformMatrix3x2(Int32 program, Int32 location, Int32 count, bool transpose, Single* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix3x2fvEXT")]
            public static extern void ProgramUniformMatrix3x2(UInt32 program, Int32 location, Int32 count, bool transpose, Single[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix3x2fvEXT")]
            public static extern void ProgramUniformMatrix3x2(UInt32 program, Int32 location, Int32 count, bool transpose, ref Single value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix3x2fvEXT")]
            public static extern unsafe void ProgramUniformMatrix3x2(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix3x4dvEXT")]
            public static extern void ProgramUniformMatrix3x4(Int32 program, Int32 location, Int32 count, bool transpose, Double[] value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix3x4dvEXT")]
            public static extern void ProgramUniformMatrix3x4(Int32 program, Int32 location, Int32 count, bool transpose, ref Double value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix3x4dvEXT")]
            public static extern unsafe void ProgramUniformMatrix3x4(Int32 program, Int32 location, Int32 count, bool transpose, Double* value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix3x4dvEXT")]
            public static extern void ProgramUniformMatrix3x4(UInt32 program, Int32 location, Int32 count, bool transpose, Double[] value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix3x4dvEXT")]
            public static extern void ProgramUniformMatrix3x4(UInt32 program, Int32 location, Int32 count, bool transpose, ref Double value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix3x4dvEXT")]
            public static extern unsafe void ProgramUniformMatrix3x4(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix3x4fvEXT")]
            public static extern void ProgramUniformMatrix3x4(Int32 program, Int32 location, Int32 count, bool transpose, Single[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix3x4fvEXT")]
            public static extern void ProgramUniformMatrix3x4(Int32 program, Int32 location, Int32 count, bool transpose, ref Single value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix3x4fvEXT")]
            public static extern unsafe void ProgramUniformMatrix3x4(Int32 program, Int32 location, Int32 count, bool transpose, Single* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix3x4fvEXT")]
            public static extern void ProgramUniformMatrix3x4(UInt32 program, Int32 location, Int32 count, bool transpose, Single[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix3x4fvEXT")]
            public static extern void ProgramUniformMatrix3x4(UInt32 program, Int32 location, Int32 count, bool transpose, ref Single value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix3x4fvEXT")]
            public static extern unsafe void ProgramUniformMatrix3x4(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix4dvEXT")]
            public static extern void ProgramUniformMatrix4(Int32 program, Int32 location, Int32 count, bool transpose, Double[] value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix4dvEXT")]
            public static extern void ProgramUniformMatrix4(Int32 program, Int32 location, Int32 count, bool transpose, ref Double value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix4dvEXT")]
            public static extern unsafe void ProgramUniformMatrix4(Int32 program, Int32 location, Int32 count, bool transpose, Double* value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix4dvEXT")]
            public static extern void ProgramUniformMatrix4(UInt32 program, Int32 location, Int32 count, bool transpose, Double[] value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix4dvEXT")]
            public static extern void ProgramUniformMatrix4(UInt32 program, Int32 location, Int32 count, bool transpose, ref Double value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix4dvEXT")]
            public static extern unsafe void ProgramUniformMatrix4(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects|EXT_separate_shader_objects]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix4fvEXT")]
            public static extern void ProgramUniformMatrix4(Int32 program, Int32 location, Int32 count, bool transpose, Single[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects|EXT_separate_shader_objects]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix4fvEXT")]
            public static extern void ProgramUniformMatrix4(Int32 program, Int32 location, Int32 count, bool transpose, ref Single value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix4fvEXT")]
            public static extern unsafe void ProgramUniformMatrix4(Int32 program, Int32 location, Int32 count, bool transpose, Single* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix4fvEXT")]
            public static extern void ProgramUniformMatrix4(UInt32 program, Int32 location, Int32 count, bool transpose, Single[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix4fvEXT")]
            public static extern void ProgramUniformMatrix4(UInt32 program, Int32 location, Int32 count, bool transpose, ref Single value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix4fvEXT")]
            public static extern unsafe void ProgramUniformMatrix4(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix4x2dvEXT")]
            public static extern void ProgramUniformMatrix4x2(Int32 program, Int32 location, Int32 count, bool transpose, Double[] value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix4x2dvEXT")]
            public static extern void ProgramUniformMatrix4x2(Int32 program, Int32 location, Int32 count, bool transpose, ref Double value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix4x2dvEXT")]
            public static extern unsafe void ProgramUniformMatrix4x2(Int32 program, Int32 location, Int32 count, bool transpose, Double* value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix4x2dvEXT")]
            public static extern void ProgramUniformMatrix4x2(UInt32 program, Int32 location, Int32 count, bool transpose, Double[] value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix4x2dvEXT")]
            public static extern void ProgramUniformMatrix4x2(UInt32 program, Int32 location, Int32 count, bool transpose, ref Double value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix4x2dvEXT")]
            public static extern unsafe void ProgramUniformMatrix4x2(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix4x2fvEXT")]
            public static extern void ProgramUniformMatrix4x2(Int32 program, Int32 location, Int32 count, bool transpose, Single[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix4x2fvEXT")]
            public static extern void ProgramUniformMatrix4x2(Int32 program, Int32 location, Int32 count, bool transpose, ref Single value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix4x2fvEXT")]
            public static extern unsafe void ProgramUniformMatrix4x2(Int32 program, Int32 location, Int32 count, bool transpose, Single* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix4x2fvEXT")]
            public static extern void ProgramUniformMatrix4x2(UInt32 program, Int32 location, Int32 count, bool transpose, Single[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix4x2fvEXT")]
            public static extern void ProgramUniformMatrix4x2(UInt32 program, Int32 location, Int32 count, bool transpose, ref Single value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix4x2fvEXT")]
            public static extern unsafe void ProgramUniformMatrix4x2(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix4x3dvEXT")]
            public static extern void ProgramUniformMatrix4x3(Int32 program, Int32 location, Int32 count, bool transpose, Double[] value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix4x3dvEXT")]
            public static extern void ProgramUniformMatrix4x3(Int32 program, Int32 location, Int32 count, bool transpose, ref Double value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix4x3dvEXT")]
            public static extern unsafe void ProgramUniformMatrix4x3(Int32 program, Int32 location, Int32 count, bool transpose, Double* value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix4x3dvEXT")]
            public static extern void ProgramUniformMatrix4x3(UInt32 program, Int32 location, Int32 count, bool transpose, Double[] value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix4x3dvEXT")]
            public static extern void ProgramUniformMatrix4x3(UInt32 program, Int32 location, Int32 count, bool transpose, ref Double value);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glProgramUniformMatrix4x3dvEXT")]
            public static extern unsafe void ProgramUniformMatrix4x3(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix4x3fvEXT")]
            public static extern void ProgramUniformMatrix4x3(Int32 program, Int32 location, Int32 count, bool transpose, Single[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix4x3fvEXT")]
            public static extern void ProgramUniformMatrix4x3(Int32 program, Int32 location, Int32 count, bool transpose, ref Single value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix4x3fvEXT")]
            public static extern unsafe void ProgramUniformMatrix4x3(Int32 program, Int32 location, Int32 count, bool transpose, Single* value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix4x3fvEXT")]
            public static extern void ProgramUniformMatrix4x3(UInt32 program, Int32 location, Int32 count, bool transpose, Single[] value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix4x3fvEXT")]
            public static extern void ProgramUniformMatrix4x3(UInt32 program, Int32 location, Int32 count, bool transpose, ref Single value);

            /// <summary>[requires: EXT_direct_state_access|EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access|EXT_separate_shader_objects", Version = "", EntryPoint = "glProgramUniformMatrix4x3fvEXT")]
            public static extern unsafe void ProgramUniformMatrix4x3(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);

            /// <summary>[requires: EXT_provoking_vertex]
            /// Specifiy the vertex to be used as the source of data for flat shaded varyings
            /// </summary>
            /// <param name="provokeMode">
            /// <para>
            /// Specifies the vertex to be used as the source of data for flat shaded varyings.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_provoking_vertex", Version = "", EntryPoint = "glProvokingVertexEXT")]
            public static extern void ProvokingVertex(OpenTK.Graphics.OpenGL.ExtProvokingVertex mode);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glPushClientAttribDefaultEXT")]
            public static extern void PushClientAttribDefault(OpenTK.Graphics.OpenGL.ClientAttribMask mask);

            /// <summary>[requires: EXT_debug_marker]</summary>
            [AutoGenerated(Category = "EXT_debug_marker", Version = "", EntryPoint = "glPushGroupMarkerEXT")]
            public static extern void PushGroupMarker(Int32 length, String marker);

            /// <summary>[requires: EXT_framebuffer_object]
            /// Establish data storage, format and dimensions of a renderbuffer object's image
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies a binding to which the target of the allocation and must be GL_RENDERBUFFER.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// Specifies the internal format to use for the renderbuffer object's image.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the renderbuffer, in pixels.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the renderbuffer, in pixels.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_framebuffer_object", Version = "", EntryPoint = "glRenderbufferStorageEXT")]
            public static extern void RenderbufferStorage(OpenTK.Graphics.OpenGL.RenderbufferTarget target, OpenTK.Graphics.OpenGL.RenderbufferStorage internalformat, Int32 width, Int32 height);

            /// <summary>[requires: EXT_framebuffer_multisample]
            /// Establish data storage, format, dimensions and sample count of a renderbuffer object's image
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies a binding to which the target of the allocation and must be GL_RENDERBUFFER.
            /// </para>
            /// </param>
            /// <param name="samples">
            /// <para>
            /// Specifies the number of samples to be used for the renderbuffer object's storage.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// Specifies the internal format to use for the renderbuffer object's image.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the renderbuffer, in pixels.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the renderbuffer, in pixels.
            /// </para>
            /// </param>
            [Obsolete("Use RenderbufferTarget overload instead")]
            [AutoGenerated(Category = "EXT_framebuffer_multisample", Version = "", EntryPoint = "glRenderbufferStorageMultisampleEXT")]
            public static extern void RenderbufferStorageMultisample(OpenTK.Graphics.OpenGL.ExtFramebufferMultisample target, Int32 samples, OpenTK.Graphics.OpenGL.ExtFramebufferMultisample internalformat, Int32 width, Int32 height);

            /// <summary>[requires: EXT_framebuffer_multisample]
            /// Establish data storage, format, dimensions and sample count of a renderbuffer object's image
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies a binding to which the target of the allocation and must be GL_RENDERBUFFER.
            /// </para>
            /// </param>
            /// <param name="samples">
            /// <para>
            /// Specifies the number of samples to be used for the renderbuffer object's storage.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// Specifies the internal format to use for the renderbuffer object's image.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the renderbuffer, in pixels.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the renderbuffer, in pixels.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_framebuffer_multisample", Version = "", EntryPoint = "glRenderbufferStorageMultisampleEXT")]
            public static extern void RenderbufferStorageMultisample(OpenTK.Graphics.OpenGL.RenderbufferTarget target, Int32 samples, OpenTK.Graphics.OpenGL.RenderbufferStorage internalformat, Int32 width, Int32 height);

            /// <summary>[requires: EXT_histogram]
            /// Reset histogram table entries to zero
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_HISTOGRAM.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_histogram", Version = "", EntryPoint = "glResetHistogramEXT")]
            public static extern void ResetHistogram(OpenTK.Graphics.OpenGL.ExtHistogram target);

            /// <summary>[requires: EXT_histogram]
            /// Reset minmax table entries to initial values
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_MINMAX.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_histogram", Version = "", EntryPoint = "glResetMinmaxEXT")]
            public static extern void ResetMinmax(OpenTK.Graphics.OpenGL.ExtHistogram target);

            /// <summary>[requires: EXT_multisample]</summary>
            [AutoGenerated(Category = "EXT_multisample", Version = "", EntryPoint = "glSampleMaskEXT")]
            public static extern void SampleMask(Single value, bool invert);

            /// <summary>[requires: EXT_multisample]</summary>
            [AutoGenerated(Category = "EXT_multisample", Version = "", EntryPoint = "glSamplePatternEXT")]
            public static extern void SamplePattern(OpenTK.Graphics.OpenGL.ExtMultisample pattern);

            /// <summary>[requires: EXT_secondary_color]
            /// Set the current secondary color
            /// </summary>
            /// <param name="red">
            /// <para>
            /// Specify new red, green, and blue values for the current secondary color.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColor3bEXT")]
            public static extern void SecondaryColor3(SByte red, SByte green, SByte blue);

            /// <summary>[requires: EXT_secondary_color]
            /// Set the current secondary color
            /// </summary>
            /// <param name="red">
            /// <para>
            /// Specify new red, green, and blue values for the current secondary color.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColor3bvEXT")]
            public static extern void SecondaryColor3(SByte[] v);

            /// <summary>[requires: EXT_secondary_color]
            /// Set the current secondary color
            /// </summary>
            /// <param name="red">
            /// <para>
            /// Specify new red, green, and blue values for the current secondary color.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColor3bvEXT")]
            public static extern void SecondaryColor3(ref SByte v);

            /// <summary>[requires: EXT_secondary_color]
            /// Set the current secondary color
            /// </summary>
            /// <param name="red">
            /// <para>
            /// Specify new red, green, and blue values for the current secondary color.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColor3bvEXT")]
            public static extern unsafe void SecondaryColor3(SByte* v);

            /// <summary>[requires: EXT_secondary_color]
            /// Set the current secondary color
            /// </summary>
            /// <param name="red">
            /// <para>
            /// Specify new red, green, and blue values for the current secondary color.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColor3dEXT")]
            public static extern void SecondaryColor3(Double red, Double green, Double blue);

            /// <summary>[requires: EXT_secondary_color]
            /// Set the current secondary color
            /// </summary>
            /// <param name="red">
            /// <para>
            /// Specify new red, green, and blue values for the current secondary color.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColor3dvEXT")]
            public static extern void SecondaryColor3(Double[] v);

            /// <summary>[requires: EXT_secondary_color]
            /// Set the current secondary color
            /// </summary>
            /// <param name="red">
            /// <para>
            /// Specify new red, green, and blue values for the current secondary color.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColor3dvEXT")]
            public static extern void SecondaryColor3(ref Double v);

            /// <summary>[requires: EXT_secondary_color]
            /// Set the current secondary color
            /// </summary>
            /// <param name="red">
            /// <para>
            /// Specify new red, green, and blue values for the current secondary color.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColor3dvEXT")]
            public static extern unsafe void SecondaryColor3(Double* v);

            /// <summary>[requires: EXT_secondary_color]
            /// Set the current secondary color
            /// </summary>
            /// <param name="red">
            /// <para>
            /// Specify new red, green, and blue values for the current secondary color.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColor3fEXT")]
            public static extern void SecondaryColor3(Single red, Single green, Single blue);

            /// <summary>[requires: EXT_secondary_color]
            /// Set the current secondary color
            /// </summary>
            /// <param name="red">
            /// <para>
            /// Specify new red, green, and blue values for the current secondary color.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColor3fvEXT")]
            public static extern void SecondaryColor3(Single[] v);

            /// <summary>[requires: EXT_secondary_color]
            /// Set the current secondary color
            /// </summary>
            /// <param name="red">
            /// <para>
            /// Specify new red, green, and blue values for the current secondary color.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColor3fvEXT")]
            public static extern void SecondaryColor3(ref Single v);

            /// <summary>[requires: EXT_secondary_color]
            /// Set the current secondary color
            /// </summary>
            /// <param name="red">
            /// <para>
            /// Specify new red, green, and blue values for the current secondary color.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColor3fvEXT")]
            public static extern unsafe void SecondaryColor3(Single* v);

            /// <summary>[requires: EXT_secondary_color]
            /// Set the current secondary color
            /// </summary>
            /// <param name="red">
            /// <para>
            /// Specify new red, green, and blue values for the current secondary color.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColor3iEXT")]
            public static extern void SecondaryColor3(Int32 red, Int32 green, Int32 blue);

            /// <summary>[requires: EXT_secondary_color]
            /// Set the current secondary color
            /// </summary>
            /// <param name="red">
            /// <para>
            /// Specify new red, green, and blue values for the current secondary color.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColor3ivEXT")]
            public static extern void SecondaryColor3(Int32[] v);

            /// <summary>[requires: EXT_secondary_color]
            /// Set the current secondary color
            /// </summary>
            /// <param name="red">
            /// <para>
            /// Specify new red, green, and blue values for the current secondary color.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColor3ivEXT")]
            public static extern void SecondaryColor3(ref Int32 v);

            /// <summary>[requires: EXT_secondary_color]
            /// Set the current secondary color
            /// </summary>
            /// <param name="red">
            /// <para>
            /// Specify new red, green, and blue values for the current secondary color.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColor3ivEXT")]
            public static extern unsafe void SecondaryColor3(Int32* v);

            /// <summary>[requires: EXT_secondary_color]
            /// Set the current secondary color
            /// </summary>
            /// <param name="red">
            /// <para>
            /// Specify new red, green, and blue values for the current secondary color.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColor3sEXT")]
            public static extern void SecondaryColor3(Int16 red, Int16 green, Int16 blue);

            /// <summary>[requires: EXT_secondary_color]
            /// Set the current secondary color
            /// </summary>
            /// <param name="red">
            /// <para>
            /// Specify new red, green, and blue values for the current secondary color.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColor3svEXT")]
            public static extern void SecondaryColor3(Int16[] v);

            /// <summary>[requires: EXT_secondary_color]
            /// Set the current secondary color
            /// </summary>
            /// <param name="red">
            /// <para>
            /// Specify new red, green, and blue values for the current secondary color.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColor3svEXT")]
            public static extern void SecondaryColor3(ref Int16 v);

            /// <summary>[requires: EXT_secondary_color]
            /// Set the current secondary color
            /// </summary>
            /// <param name="red">
            /// <para>
            /// Specify new red, green, and blue values for the current secondary color.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColor3svEXT")]
            public static extern unsafe void SecondaryColor3(Int16* v);

            /// <summary>[requires: EXT_secondary_color]
            /// Set the current secondary color
            /// </summary>
            /// <param name="red">
            /// <para>
            /// Specify new red, green, and blue values for the current secondary color.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColor3ubEXT")]
            public static extern void SecondaryColor3(Byte red, Byte green, Byte blue);

            /// <summary>[requires: EXT_secondary_color]
            /// Set the current secondary color
            /// </summary>
            /// <param name="red">
            /// <para>
            /// Specify new red, green, and blue values for the current secondary color.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColor3ubvEXT")]
            public static extern void SecondaryColor3(Byte[] v);

            /// <summary>[requires: EXT_secondary_color]
            /// Set the current secondary color
            /// </summary>
            /// <param name="red">
            /// <para>
            /// Specify new red, green, and blue values for the current secondary color.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColor3ubvEXT")]
            public static extern void SecondaryColor3(ref Byte v);

            /// <summary>[requires: EXT_secondary_color]
            /// Set the current secondary color
            /// </summary>
            /// <param name="red">
            /// <para>
            /// Specify new red, green, and blue values for the current secondary color.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColor3ubvEXT")]
            public static extern unsafe void SecondaryColor3(Byte* v);

            /// <summary>[requires: EXT_secondary_color]
            /// Set the current secondary color
            /// </summary>
            /// <param name="red">
            /// <para>
            /// Specify new red, green, and blue values for the current secondary color.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColor3uiEXT")]
            public static extern void SecondaryColor3(UInt32 red, UInt32 green, UInt32 blue);

            /// <summary>[requires: EXT_secondary_color]
            /// Set the current secondary color
            /// </summary>
            /// <param name="red">
            /// <para>
            /// Specify new red, green, and blue values for the current secondary color.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColor3uivEXT")]
            public static extern void SecondaryColor3(UInt32[] v);

            /// <summary>[requires: EXT_secondary_color]
            /// Set the current secondary color
            /// </summary>
            /// <param name="red">
            /// <para>
            /// Specify new red, green, and blue values for the current secondary color.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColor3uivEXT")]
            public static extern void SecondaryColor3(ref UInt32 v);

            /// <summary>[requires: EXT_secondary_color]
            /// Set the current secondary color
            /// </summary>
            /// <param name="red">
            /// <para>
            /// Specify new red, green, and blue values for the current secondary color.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColor3uivEXT")]
            public static extern unsafe void SecondaryColor3(UInt32* v);

            /// <summary>[requires: EXT_secondary_color]
            /// Set the current secondary color
            /// </summary>
            /// <param name="red">
            /// <para>
            /// Specify new red, green, and blue values for the current secondary color.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColor3usEXT")]
            public static extern void SecondaryColor3(UInt16 red, UInt16 green, UInt16 blue);

            /// <summary>[requires: EXT_secondary_color]
            /// Set the current secondary color
            /// </summary>
            /// <param name="red">
            /// <para>
            /// Specify new red, green, and blue values for the current secondary color.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColor3usvEXT")]
            public static extern void SecondaryColor3(UInt16[] v);

            /// <summary>[requires: EXT_secondary_color]
            /// Set the current secondary color
            /// </summary>
            /// <param name="red">
            /// <para>
            /// Specify new red, green, and blue values for the current secondary color.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColor3usvEXT")]
            public static extern void SecondaryColor3(ref UInt16 v);

            /// <summary>[requires: EXT_secondary_color]
            /// Set the current secondary color
            /// </summary>
            /// <param name="red">
            /// <para>
            /// Specify new red, green, and blue values for the current secondary color.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColor3usvEXT")]
            public static extern unsafe void SecondaryColor3(UInt16* v);

            /// <summary>[requires: EXT_secondary_color]
            /// Define an array of secondary colors
            /// </summary>
            /// <param name="size">
            /// <para>
            /// Specifies the number of components per color. Must be 3.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each color component in the array. Symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, GL_UNSIGNED_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive colors. If stride is 0, the colors are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first component of the first color element in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColorPointerEXT")]
            public static extern void SecondaryColorPointer(Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, IntPtr pointer);

            /// <summary>[requires: EXT_secondary_color]
            /// Define an array of secondary colors
            /// </summary>
            /// <param name="size">
            /// <para>
            /// Specifies the number of components per color. Must be 3.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each color component in the array. Symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, GL_UNSIGNED_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive colors. If stride is 0, the colors are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first component of the first color element in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColorPointerEXT")]
            public static extern void SecondaryColorPointer<T3>(Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, [InAttribute, OutAttribute] T3[] pointer)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_secondary_color]
            /// Define an array of secondary colors
            /// </summary>
            /// <param name="size">
            /// <para>
            /// Specifies the number of components per color. Must be 3.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each color component in the array. Symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, GL_UNSIGNED_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive colors. If stride is 0, the colors are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first component of the first color element in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColorPointerEXT")]
            public static extern void SecondaryColorPointer<T3>(Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, [InAttribute, OutAttribute] T3[,] pointer)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_secondary_color]
            /// Define an array of secondary colors
            /// </summary>
            /// <param name="size">
            /// <para>
            /// Specifies the number of components per color. Must be 3.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each color component in the array. Symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, GL_UNSIGNED_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive colors. If stride is 0, the colors are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first component of the first color element in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColorPointerEXT")]
            public static extern void SecondaryColorPointer<T3>(Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, [InAttribute, OutAttribute] T3[,,] pointer)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_secondary_color]
            /// Define an array of secondary colors
            /// </summary>
            /// <param name="size">
            /// <para>
            /// Specifies the number of components per color. Must be 3.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each color component in the array. Symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, GL_UNSIGNED_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive colors. If stride is 0, the colors are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first component of the first color element in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_secondary_color", Version = "", EntryPoint = "glSecondaryColorPointerEXT")]
            public static extern void SecondaryColorPointer<T3>(Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, [InAttribute, OutAttribute] ref T3 pointer)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_convolution]
            /// Define a separable two-dimensional convolution filter
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_SEPARABLE_2D.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// The internal format of the convolution filter kernel. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// The number of elements in the pixel array referenced by row. (This is the width of the separable filter kernel.)
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// The number of elements in the pixel array referenced by column. (This is the height of the separable filter kernel.)
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in row and column. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_INTENSITY, GL_LUMINANCE, and GL_LUMINANCE_ALPHA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in row and column. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="row">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data that is processed to build the row filter kernel.
            /// </para>
            /// </param>
            /// <param name="column">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data that is processed to build the column filter kernel.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glSeparableFilter2DEXT")]
            public static extern void SeparableFilter2D(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr row, IntPtr column);

            /// <summary>[requires: EXT_convolution]
            /// Define a separable two-dimensional convolution filter
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_SEPARABLE_2D.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// The internal format of the convolution filter kernel. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// The number of elements in the pixel array referenced by row. (This is the width of the separable filter kernel.)
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// The number of elements in the pixel array referenced by column. (This is the height of the separable filter kernel.)
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in row and column. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_INTENSITY, GL_LUMINANCE, and GL_LUMINANCE_ALPHA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in row and column. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="row">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data that is processed to build the row filter kernel.
            /// </para>
            /// </param>
            /// <param name="column">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data that is processed to build the column filter kernel.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glSeparableFilter2DEXT")]
            public static extern void SeparableFilter2D<T6,T7>(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T6[] row, [InAttribute, OutAttribute] T7[] column)
                where T6 : struct
                where T7 : struct
            ;

            /// <summary>[requires: EXT_convolution]
            /// Define a separable two-dimensional convolution filter
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_SEPARABLE_2D.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// The internal format of the convolution filter kernel. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// The number of elements in the pixel array referenced by row. (This is the width of the separable filter kernel.)
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// The number of elements in the pixel array referenced by column. (This is the height of the separable filter kernel.)
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in row and column. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_INTENSITY, GL_LUMINANCE, and GL_LUMINANCE_ALPHA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in row and column. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="row">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data that is processed to build the row filter kernel.
            /// </para>
            /// </param>
            /// <param name="column">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data that is processed to build the column filter kernel.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glSeparableFilter2DEXT")]
            public static extern void SeparableFilter2D<T6,T7>(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T6[,] row, [InAttribute, OutAttribute] T7[,] column)
                where T6 : struct
                where T7 : struct
            ;

            /// <summary>[requires: EXT_convolution]
            /// Define a separable two-dimensional convolution filter
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_SEPARABLE_2D.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// The internal format of the convolution filter kernel. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// The number of elements in the pixel array referenced by row. (This is the width of the separable filter kernel.)
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// The number of elements in the pixel array referenced by column. (This is the height of the separable filter kernel.)
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in row and column. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_INTENSITY, GL_LUMINANCE, and GL_LUMINANCE_ALPHA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in row and column. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="row">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data that is processed to build the row filter kernel.
            /// </para>
            /// </param>
            /// <param name="column">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data that is processed to build the column filter kernel.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glSeparableFilter2DEXT")]
            public static extern void SeparableFilter2D<T6,T7>(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T6[,,] row, [InAttribute, OutAttribute] T7[,,] column)
                where T6 : struct
                where T7 : struct
            ;

            /// <summary>[requires: EXT_convolution]
            /// Define a separable two-dimensional convolution filter
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_SEPARABLE_2D.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// The internal format of the convolution filter kernel. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// The number of elements in the pixel array referenced by row. (This is the width of the separable filter kernel.)
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// The number of elements in the pixel array referenced by column. (This is the height of the separable filter kernel.)
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in row and column. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_INTENSITY, GL_LUMINANCE, and GL_LUMINANCE_ALPHA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in row and column. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="row">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data that is processed to build the row filter kernel.
            /// </para>
            /// </param>
            /// <param name="column">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data that is processed to build the column filter kernel.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_convolution", Version = "", EntryPoint = "glSeparableFilter2DEXT")]
            public static extern void SeparableFilter2D<T6,T7>(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T6 row, [InAttribute, OutAttribute] ref T7 column)
                where T6 : struct
                where T7 : struct
            ;

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glSetInvariantEXT")]
            public static extern void SetInvariant(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader type, IntPtr addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glSetInvariantEXT")]
            public static extern void SetInvariant<T2>(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader type, [InAttribute, OutAttribute] T2[] addr)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glSetInvariantEXT")]
            public static extern void SetInvariant<T2>(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader type, [InAttribute, OutAttribute] T2[,] addr)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glSetInvariantEXT")]
            public static extern void SetInvariant<T2>(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader type, [InAttribute, OutAttribute] T2[,,] addr)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glSetInvariantEXT")]
            public static extern void SetInvariant<T2>(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader type, [InAttribute, OutAttribute] ref T2 addr)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glSetInvariantEXT")]
            public static extern void SetInvariant(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader type, IntPtr addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glSetInvariantEXT")]
            public static extern void SetInvariant<T2>(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader type, [InAttribute, OutAttribute] T2[] addr)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glSetInvariantEXT")]
            public static extern void SetInvariant<T2>(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader type, [InAttribute, OutAttribute] T2[,] addr)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glSetInvariantEXT")]
            public static extern void SetInvariant<T2>(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader type, [InAttribute, OutAttribute] T2[,,] addr)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glSetInvariantEXT")]
            public static extern void SetInvariant<T2>(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader type, [InAttribute, OutAttribute] ref T2 addr)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glSetLocalConstantEXT")]
            public static extern void SetLocalConstant(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader type, IntPtr addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glSetLocalConstantEXT")]
            public static extern void SetLocalConstant<T2>(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader type, [InAttribute, OutAttribute] T2[] addr)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glSetLocalConstantEXT")]
            public static extern void SetLocalConstant<T2>(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader type, [InAttribute, OutAttribute] T2[,] addr)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glSetLocalConstantEXT")]
            public static extern void SetLocalConstant<T2>(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader type, [InAttribute, OutAttribute] T2[,,] addr)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glSetLocalConstantEXT")]
            public static extern void SetLocalConstant<T2>(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader type, [InAttribute, OutAttribute] ref T2 addr)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glSetLocalConstantEXT")]
            public static extern void SetLocalConstant(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader type, IntPtr addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glSetLocalConstantEXT")]
            public static extern void SetLocalConstant<T2>(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader type, [InAttribute, OutAttribute] T2[] addr)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glSetLocalConstantEXT")]
            public static extern void SetLocalConstant<T2>(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader type, [InAttribute, OutAttribute] T2[,] addr)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glSetLocalConstantEXT")]
            public static extern void SetLocalConstant<T2>(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader type, [InAttribute, OutAttribute] T2[,,] addr)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glSetLocalConstantEXT")]
            public static extern void SetLocalConstant<T2>(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader type, [InAttribute, OutAttribute] ref T2 addr)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glShaderOp1EXT")]
            public static extern void ShaderOp1(OpenTK.Graphics.OpenGL.ExtVertexShader op, Int32 res, Int32 arg1);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glShaderOp1EXT")]
            public static extern void ShaderOp1(OpenTK.Graphics.OpenGL.ExtVertexShader op, UInt32 res, UInt32 arg1);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glShaderOp2EXT")]
            public static extern void ShaderOp2(OpenTK.Graphics.OpenGL.ExtVertexShader op, Int32 res, Int32 arg1, Int32 arg2);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glShaderOp2EXT")]
            public static extern void ShaderOp2(OpenTK.Graphics.OpenGL.ExtVertexShader op, UInt32 res, UInt32 arg1, UInt32 arg2);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glShaderOp3EXT")]
            public static extern void ShaderOp3(OpenTK.Graphics.OpenGL.ExtVertexShader op, Int32 res, Int32 arg1, Int32 arg2, Int32 arg3);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glShaderOp3EXT")]
            public static extern void ShaderOp3(OpenTK.Graphics.OpenGL.ExtVertexShader op, UInt32 res, UInt32 arg1, UInt32 arg2, UInt32 arg3);

            /// <summary>[requires: EXT_stencil_clear_tag]</summary>
            [AutoGenerated(Category = "EXT_stencil_clear_tag", Version = "", EntryPoint = "glStencilClearTagEXT")]
            public static extern void StencilClearTag(Int32 stencilTagBits, Int32 stencilClearTag);

            /// <summary>[requires: EXT_stencil_clear_tag]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_stencil_clear_tag", Version = "", EntryPoint = "glStencilClearTagEXT")]
            public static extern void StencilClearTag(Int32 stencilTagBits, UInt32 stencilClearTag);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glSwizzleEXT")]
            public static extern void Swizzle(Int32 res, Int32 @in, OpenTK.Graphics.OpenGL.ExtVertexShader outX, OpenTK.Graphics.OpenGL.ExtVertexShader outY, OpenTK.Graphics.OpenGL.ExtVertexShader outZ, OpenTK.Graphics.OpenGL.ExtVertexShader outW);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glSwizzleEXT")]
            public static extern void Swizzle(UInt32 res, UInt32 @in, OpenTK.Graphics.OpenGL.ExtVertexShader outX, OpenTK.Graphics.OpenGL.ExtVertexShader outY, OpenTK.Graphics.OpenGL.ExtVertexShader outZ, OpenTK.Graphics.OpenGL.ExtVertexShader outW);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glTangent3bEXT")]
            public static extern void Tangent3(Byte tx, Byte ty, Byte tz);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glTangent3bEXT")]
            public static extern void Tangent3(SByte tx, SByte ty, SByte tz);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glTangent3bvEXT")]
            public static extern void Tangent3(Byte[] v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glTangent3bvEXT")]
            public static extern void Tangent3(ref Byte v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glTangent3bvEXT")]
            public static extern unsafe void Tangent3(Byte* v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glTangent3bvEXT")]
            public static extern void Tangent3(SByte[] v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glTangent3bvEXT")]
            public static extern void Tangent3(ref SByte v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glTangent3bvEXT")]
            public static extern unsafe void Tangent3(SByte* v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glTangent3dEXT")]
            public static extern void Tangent3(Double tx, Double ty, Double tz);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glTangent3dvEXT")]
            public static extern void Tangent3(Double[] v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glTangent3dvEXT")]
            public static extern void Tangent3(ref Double v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glTangent3dvEXT")]
            public static extern unsafe void Tangent3(Double* v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glTangent3fEXT")]
            public static extern void Tangent3(Single tx, Single ty, Single tz);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glTangent3fvEXT")]
            public static extern void Tangent3(Single[] v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glTangent3fvEXT")]
            public static extern void Tangent3(ref Single v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glTangent3fvEXT")]
            public static extern unsafe void Tangent3(Single* v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glTangent3iEXT")]
            public static extern void Tangent3(Int32 tx, Int32 ty, Int32 tz);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glTangent3ivEXT")]
            public static extern void Tangent3(Int32[] v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glTangent3ivEXT")]
            public static extern void Tangent3(ref Int32 v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glTangent3ivEXT")]
            public static extern unsafe void Tangent3(Int32* v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glTangent3sEXT")]
            public static extern void Tangent3(Int16 tx, Int16 ty, Int16 tz);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glTangent3svEXT")]
            public static extern void Tangent3(Int16[] v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glTangent3svEXT")]
            public static extern void Tangent3(ref Int16 v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glTangent3svEXT")]
            public static extern unsafe void Tangent3(Int16* v);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glTangentPointerEXT")]
            public static extern void TangentPointer(OpenTK.Graphics.OpenGL.NormalPointerType type, Int32 stride, IntPtr pointer);

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glTangentPointerEXT")]
            public static extern void TangentPointer<T2>(OpenTK.Graphics.OpenGL.NormalPointerType type, Int32 stride, [InAttribute, OutAttribute] T2[] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glTangentPointerEXT")]
            public static extern void TangentPointer<T2>(OpenTK.Graphics.OpenGL.NormalPointerType type, Int32 stride, [InAttribute, OutAttribute] T2[,] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glTangentPointerEXT")]
            public static extern void TangentPointer<T2>(OpenTK.Graphics.OpenGL.NormalPointerType type, Int32 stride, [InAttribute, OutAttribute] T2[,,] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_coordinate_frame]</summary>
            [AutoGenerated(Category = "EXT_coordinate_frame", Version = "", EntryPoint = "glTangentPointerEXT")]
            public static extern void TangentPointer<T2>(OpenTK.Graphics.OpenGL.NormalPointerType type, Int32 stride, [InAttribute, OutAttribute] ref T2 pointer)
                where T2 : struct
            ;

            /// <summary>[requires: EXT_texture_buffer_object]
            /// Attach the storage for a buffer object to the active buffer texture
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target of the operation and must be GL_TEXTURE_BUFFER.
            /// </para>
            /// </param>
            /// <param name="internalFormat">
            /// <para>
            /// Specifies the internal format of the data in the store belonging to buffer.
            /// </para>
            /// </param>
            /// <param name="buffer">
            /// <para>
            /// Specifies the name of the buffer object whose storage to attach to the active buffer texture.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_texture_buffer_object", Version = "", EntryPoint = "glTexBufferEXT")]
            public static extern void TexBuffer(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.ExtTextureBufferObject internalformat, Int32 buffer);

            /// <summary>[requires: EXT_texture_buffer_object]
            /// Attach the storage for a buffer object to the active buffer texture
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target of the operation and must be GL_TEXTURE_BUFFER.
            /// </para>
            /// </param>
            /// <param name="internalFormat">
            /// <para>
            /// Specifies the internal format of the data in the store belonging to buffer.
            /// </para>
            /// </param>
            /// <param name="buffer">
            /// <para>
            /// Specifies the name of the buffer object whose storage to attach to the active buffer texture.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_texture_buffer_object", Version = "", EntryPoint = "glTexBufferEXT")]
            public static extern void TexBuffer(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.ExtTextureBufferObject internalformat, UInt32 buffer);

            /// <summary>[requires: EXT_vertex_array]
            /// Define an array of texture coordinates
            /// </summary>
            /// <param name="size">
            /// <para>
            /// Specifies the number of coordinates per array element. Must be 1, 2, 3, or 4. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each texture coordinate. Symbolic constants GL_SHORT, GL_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive texture coordinate sets. If stride is 0, the array elements are understood to be tightly packed. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first coordinate of the first texture coordinate set in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glTexCoordPointerEXT")]
            public static extern void TexCoordPointer(Int32 size, OpenTK.Graphics.OpenGL.TexCoordPointerType type, Int32 stride, Int32 count, IntPtr pointer);

            /// <summary>[requires: EXT_vertex_array]
            /// Define an array of texture coordinates
            /// </summary>
            /// <param name="size">
            /// <para>
            /// Specifies the number of coordinates per array element. Must be 1, 2, 3, or 4. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each texture coordinate. Symbolic constants GL_SHORT, GL_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive texture coordinate sets. If stride is 0, the array elements are understood to be tightly packed. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first coordinate of the first texture coordinate set in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glTexCoordPointerEXT")]
            public static extern void TexCoordPointer<T4>(Int32 size, OpenTK.Graphics.OpenGL.TexCoordPointerType type, Int32 stride, Int32 count, [InAttribute, OutAttribute] T4[] pointer)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_vertex_array]
            /// Define an array of texture coordinates
            /// </summary>
            /// <param name="size">
            /// <para>
            /// Specifies the number of coordinates per array element. Must be 1, 2, 3, or 4. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each texture coordinate. Symbolic constants GL_SHORT, GL_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive texture coordinate sets. If stride is 0, the array elements are understood to be tightly packed. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first coordinate of the first texture coordinate set in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glTexCoordPointerEXT")]
            public static extern void TexCoordPointer<T4>(Int32 size, OpenTK.Graphics.OpenGL.TexCoordPointerType type, Int32 stride, Int32 count, [InAttribute, OutAttribute] T4[,] pointer)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_vertex_array]
            /// Define an array of texture coordinates
            /// </summary>
            /// <param name="size">
            /// <para>
            /// Specifies the number of coordinates per array element. Must be 1, 2, 3, or 4. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each texture coordinate. Symbolic constants GL_SHORT, GL_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive texture coordinate sets. If stride is 0, the array elements are understood to be tightly packed. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first coordinate of the first texture coordinate set in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glTexCoordPointerEXT")]
            public static extern void TexCoordPointer<T4>(Int32 size, OpenTK.Graphics.OpenGL.TexCoordPointerType type, Int32 stride, Int32 count, [InAttribute, OutAttribute] T4[,,] pointer)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_vertex_array]
            /// Define an array of texture coordinates
            /// </summary>
            /// <param name="size">
            /// <para>
            /// Specifies the number of coordinates per array element. Must be 1, 2, 3, or 4. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each texture coordinate. Symbolic constants GL_SHORT, GL_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive texture coordinate sets. If stride is 0, the array elements are understood to be tightly packed. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first coordinate of the first texture coordinate set in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glTexCoordPointerEXT")]
            public static extern void TexCoordPointer<T4>(Int32 size, OpenTK.Graphics.OpenGL.TexCoordPointerType type, Int32 stride, Int32 count, [InAttribute, OutAttribute] ref T4 pointer)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_texture3D]
            /// Specify a three-dimensional texture image
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be one of GL_TEXTURE_3D, GL_PROXY_TEXTURE_3D, GL_TEXTURE_2D_ARRAY or GL_PROXY_TEXTURE_2D_ARRAY.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level is the n sup th mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="internalFormat">
            /// <para>
            /// Specifies the number of color components in the texture. Must be one of base internal formats given in Table 1, one of the sized internal formats given in Table 2, or one of the compressed internal formats given in Table 3, below.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture image. All implementations support 3D texture images that are at least 16 texels wide.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture image. All implementations support 3D texture images that are at least 256 texels high.
            /// </para>
            /// </param>
            /// <param name="depth">
            /// <para>
            /// Specifies the depth of the texture image, or the number of layers in a texture array. All implementations support 3D texture images that are at least 256 texels deep, and texture arrays that are at least 256 layers deep.
            /// </para>
            /// </param>
            /// <param name="border">
            /// <para>
            /// This value must be 0.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_RED_INTEGER, GL_RG_INTEGER, GL_RGB_INTEGER, GL_BGR_INTEGER, GL_RGBA_INTEGER, GL_BGRA_INTEGER, GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_DEPTH_STENCIL.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_texture3D", Version = "", EntryPoint = "glTexImage3DEXT")]
            public static extern void TexImage3D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

            /// <summary>[requires: EXT_texture3D]
            /// Specify a three-dimensional texture image
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be one of GL_TEXTURE_3D, GL_PROXY_TEXTURE_3D, GL_TEXTURE_2D_ARRAY or GL_PROXY_TEXTURE_2D_ARRAY.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level is the n sup th mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="internalFormat">
            /// <para>
            /// Specifies the number of color components in the texture. Must be one of base internal formats given in Table 1, one of the sized internal formats given in Table 2, or one of the compressed internal formats given in Table 3, below.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture image. All implementations support 3D texture images that are at least 16 texels wide.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture image. All implementations support 3D texture images that are at least 256 texels high.
            /// </para>
            /// </param>
            /// <param name="depth">
            /// <para>
            /// Specifies the depth of the texture image, or the number of layers in a texture array. All implementations support 3D texture images that are at least 256 texels deep, and texture arrays that are at least 256 layers deep.
            /// </para>
            /// </param>
            /// <param name="border">
            /// <para>
            /// This value must be 0.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_RED_INTEGER, GL_RG_INTEGER, GL_RGB_INTEGER, GL_BGR_INTEGER, GL_RGBA_INTEGER, GL_BGRA_INTEGER, GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_DEPTH_STENCIL.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_texture3D", Version = "", EntryPoint = "glTexImage3DEXT")]
            public static extern void TexImage3D<T9>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T9[] pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_texture3D]
            /// Specify a three-dimensional texture image
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be one of GL_TEXTURE_3D, GL_PROXY_TEXTURE_3D, GL_TEXTURE_2D_ARRAY or GL_PROXY_TEXTURE_2D_ARRAY.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level is the n sup th mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="internalFormat">
            /// <para>
            /// Specifies the number of color components in the texture. Must be one of base internal formats given in Table 1, one of the sized internal formats given in Table 2, or one of the compressed internal formats given in Table 3, below.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture image. All implementations support 3D texture images that are at least 16 texels wide.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture image. All implementations support 3D texture images that are at least 256 texels high.
            /// </para>
            /// </param>
            /// <param name="depth">
            /// <para>
            /// Specifies the depth of the texture image, or the number of layers in a texture array. All implementations support 3D texture images that are at least 256 texels deep, and texture arrays that are at least 256 layers deep.
            /// </para>
            /// </param>
            /// <param name="border">
            /// <para>
            /// This value must be 0.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_RED_INTEGER, GL_RG_INTEGER, GL_RGB_INTEGER, GL_BGR_INTEGER, GL_RGBA_INTEGER, GL_BGRA_INTEGER, GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_DEPTH_STENCIL.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_texture3D", Version = "", EntryPoint = "glTexImage3DEXT")]
            public static extern void TexImage3D<T9>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T9[,] pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_texture3D]
            /// Specify a three-dimensional texture image
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be one of GL_TEXTURE_3D, GL_PROXY_TEXTURE_3D, GL_TEXTURE_2D_ARRAY or GL_PROXY_TEXTURE_2D_ARRAY.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level is the n sup th mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="internalFormat">
            /// <para>
            /// Specifies the number of color components in the texture. Must be one of base internal formats given in Table 1, one of the sized internal formats given in Table 2, or one of the compressed internal formats given in Table 3, below.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture image. All implementations support 3D texture images that are at least 16 texels wide.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture image. All implementations support 3D texture images that are at least 256 texels high.
            /// </para>
            /// </param>
            /// <param name="depth">
            /// <para>
            /// Specifies the depth of the texture image, or the number of layers in a texture array. All implementations support 3D texture images that are at least 256 texels deep, and texture arrays that are at least 256 layers deep.
            /// </para>
            /// </param>
            /// <param name="border">
            /// <para>
            /// This value must be 0.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_RED_INTEGER, GL_RG_INTEGER, GL_RGB_INTEGER, GL_BGR_INTEGER, GL_RGBA_INTEGER, GL_BGRA_INTEGER, GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_DEPTH_STENCIL.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_texture3D", Version = "", EntryPoint = "glTexImage3DEXT")]
            public static extern void TexImage3D<T9>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T9[,,] pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_texture3D]
            /// Specify a three-dimensional texture image
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be one of GL_TEXTURE_3D, GL_PROXY_TEXTURE_3D, GL_TEXTURE_2D_ARRAY or GL_PROXY_TEXTURE_2D_ARRAY.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level is the n sup th mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="internalFormat">
            /// <para>
            /// Specifies the number of color components in the texture. Must be one of base internal formats given in Table 1, one of the sized internal formats given in Table 2, or one of the compressed internal formats given in Table 3, below.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture image. All implementations support 3D texture images that are at least 16 texels wide.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture image. All implementations support 3D texture images that are at least 256 texels high.
            /// </para>
            /// </param>
            /// <param name="depth">
            /// <para>
            /// Specifies the depth of the texture image, or the number of layers in a texture array. All implementations support 3D texture images that are at least 256 texels deep, and texture arrays that are at least 256 layers deep.
            /// </para>
            /// </param>
            /// <param name="border">
            /// <para>
            /// This value must be 0.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_RED_INTEGER, GL_RG_INTEGER, GL_RGB_INTEGER, GL_BGR_INTEGER, GL_RGBA_INTEGER, GL_BGRA_INTEGER, GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_DEPTH_STENCIL.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_texture3D", Version = "", EntryPoint = "glTexImage3DEXT")]
            public static extern void TexImage3D<T9>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T9 pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_texture_integer]</summary>
            [AutoGenerated(Category = "EXT_texture_integer", Version = "", EntryPoint = "glTexParameterIivEXT")]
            public static extern void TexParameterI(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Int32[] @params);

            /// <summary>[requires: EXT_texture_integer]</summary>
            [AutoGenerated(Category = "EXT_texture_integer", Version = "", EntryPoint = "glTexParameterIivEXT")]
            public static extern void TexParameterI(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, ref Int32 @params);

            /// <summary>[requires: EXT_texture_integer]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_texture_integer", Version = "", EntryPoint = "glTexParameterIivEXT")]
            public static extern unsafe void TexParameterI(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Int32* @params);

            /// <summary>[requires: EXT_texture_integer]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_texture_integer", Version = "", EntryPoint = "glTexParameterIuivEXT")]
            public static extern void TexParameterI(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, UInt32[] @params);

            /// <summary>[requires: EXT_texture_integer]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_texture_integer", Version = "", EntryPoint = "glTexParameterIuivEXT")]
            public static extern void TexParameterI(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, ref UInt32 @params);

            /// <summary>[requires: EXT_texture_integer]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_texture_integer", Version = "", EntryPoint = "glTexParameterIuivEXT")]
            public static extern unsafe void TexParameterI(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, UInt32* @params);

            /// <summary>[requires: EXT_subtexture]
            /// Specify a one-dimensional texture subimage
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_1D.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="xoffset">
            /// <para>
            /// Specifies a texel offset in the x direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_DEPTH_COMPONENT, and GL_STENCIL_INDEX.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_subtexture", Version = "", EntryPoint = "glTexSubImage1DEXT")]
            public static extern void TexSubImage1D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

            /// <summary>[requires: EXT_subtexture]
            /// Specify a one-dimensional texture subimage
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_1D.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="xoffset">
            /// <para>
            /// Specifies a texel offset in the x direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_DEPTH_COMPONENT, and GL_STENCIL_INDEX.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_subtexture", Version = "", EntryPoint = "glTexSubImage1DEXT")]
            public static extern void TexSubImage1D<T6>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T6[] pixels)
                where T6 : struct
            ;

            /// <summary>[requires: EXT_subtexture]
            /// Specify a one-dimensional texture subimage
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_1D.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="xoffset">
            /// <para>
            /// Specifies a texel offset in the x direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_DEPTH_COMPONENT, and GL_STENCIL_INDEX.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_subtexture", Version = "", EntryPoint = "glTexSubImage1DEXT")]
            public static extern void TexSubImage1D<T6>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T6[,] pixels)
                where T6 : struct
            ;

            /// <summary>[requires: EXT_subtexture]
            /// Specify a one-dimensional texture subimage
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_1D.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="xoffset">
            /// <para>
            /// Specifies a texel offset in the x direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_DEPTH_COMPONENT, and GL_STENCIL_INDEX.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_subtexture", Version = "", EntryPoint = "glTexSubImage1DEXT")]
            public static extern void TexSubImage1D<T6>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T6[,,] pixels)
                where T6 : struct
            ;

            /// <summary>[requires: EXT_subtexture]
            /// Specify a one-dimensional texture subimage
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_1D.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="xoffset">
            /// <para>
            /// Specifies a texel offset in the x direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_DEPTH_COMPONENT, and GL_STENCIL_INDEX.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_subtexture", Version = "", EntryPoint = "glTexSubImage1DEXT")]
            public static extern void TexSubImage1D<T6>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T6 pixels)
                where T6 : struct
            ;

            /// <summary>[requires: EXT_subtexture]
            /// Specify a two-dimensional texture subimage
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, or GL_TEXTURE_1D_ARRAY.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="xoffset">
            /// <para>
            /// Specifies a texel offset in the x direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="yoffset">
            /// <para>
            /// Specifies a texel offset in the y direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_DEPTH_COMPONENT, and GL_STENCIL_INDEX.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_subtexture", Version = "", EntryPoint = "glTexSubImage2DEXT")]
            public static extern void TexSubImage2D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

            /// <summary>[requires: EXT_subtexture]
            /// Specify a two-dimensional texture subimage
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, or GL_TEXTURE_1D_ARRAY.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="xoffset">
            /// <para>
            /// Specifies a texel offset in the x direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="yoffset">
            /// <para>
            /// Specifies a texel offset in the y direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_DEPTH_COMPONENT, and GL_STENCIL_INDEX.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_subtexture", Version = "", EntryPoint = "glTexSubImage2DEXT")]
            public static extern void TexSubImage2D<T8>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T8[] pixels)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_subtexture]
            /// Specify a two-dimensional texture subimage
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, or GL_TEXTURE_1D_ARRAY.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="xoffset">
            /// <para>
            /// Specifies a texel offset in the x direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="yoffset">
            /// <para>
            /// Specifies a texel offset in the y direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_DEPTH_COMPONENT, and GL_STENCIL_INDEX.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_subtexture", Version = "", EntryPoint = "glTexSubImage2DEXT")]
            public static extern void TexSubImage2D<T8>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T8[,] pixels)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_subtexture]
            /// Specify a two-dimensional texture subimage
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, or GL_TEXTURE_1D_ARRAY.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="xoffset">
            /// <para>
            /// Specifies a texel offset in the x direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="yoffset">
            /// <para>
            /// Specifies a texel offset in the y direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_DEPTH_COMPONENT, and GL_STENCIL_INDEX.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_subtexture", Version = "", EntryPoint = "glTexSubImage2DEXT")]
            public static extern void TexSubImage2D<T8>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T8[,,] pixels)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_subtexture]
            /// Specify a two-dimensional texture subimage
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_2D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, or GL_TEXTURE_1D_ARRAY.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="xoffset">
            /// <para>
            /// Specifies a texel offset in the x direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="yoffset">
            /// <para>
            /// Specifies a texel offset in the y direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_BGRA, GL_DEPTH_COMPONENT, and GL_STENCIL_INDEX.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_subtexture", Version = "", EntryPoint = "glTexSubImage2DEXT")]
            public static extern void TexSubImage2D<T8>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T8 pixels)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_texture3D]
            /// Specify a three-dimensional texture subimage
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_3D or GL_TEXTURE_2D_ARRAY.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="xoffset">
            /// <para>
            /// Specifies a texel offset in the x direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="yoffset">
            /// <para>
            /// Specifies a texel offset in the y direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="zoffset">
            /// <para>
            /// Specifies a texel offset in the z direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="depth">
            /// <para>
            /// Specifies the depth of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_DEPTH_COMPONENT, and GL_STENCIL_INDEX.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_texture3D", Version = "", EntryPoint = "glTexSubImage3DEXT")]
            public static extern void TexSubImage3D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

            /// <summary>[requires: EXT_texture3D]
            /// Specify a three-dimensional texture subimage
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_3D or GL_TEXTURE_2D_ARRAY.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="xoffset">
            /// <para>
            /// Specifies a texel offset in the x direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="yoffset">
            /// <para>
            /// Specifies a texel offset in the y direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="zoffset">
            /// <para>
            /// Specifies a texel offset in the z direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="depth">
            /// <para>
            /// Specifies the depth of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_DEPTH_COMPONENT, and GL_STENCIL_INDEX.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_texture3D", Version = "", EntryPoint = "glTexSubImage3DEXT")]
            public static extern void TexSubImage3D<T10>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T10[] pixels)
                where T10 : struct
            ;

            /// <summary>[requires: EXT_texture3D]
            /// Specify a three-dimensional texture subimage
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_3D or GL_TEXTURE_2D_ARRAY.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="xoffset">
            /// <para>
            /// Specifies a texel offset in the x direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="yoffset">
            /// <para>
            /// Specifies a texel offset in the y direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="zoffset">
            /// <para>
            /// Specifies a texel offset in the z direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="depth">
            /// <para>
            /// Specifies the depth of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_DEPTH_COMPONENT, and GL_STENCIL_INDEX.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_texture3D", Version = "", EntryPoint = "glTexSubImage3DEXT")]
            public static extern void TexSubImage3D<T10>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T10[,] pixels)
                where T10 : struct
            ;

            /// <summary>[requires: EXT_texture3D]
            /// Specify a three-dimensional texture subimage
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_3D or GL_TEXTURE_2D_ARRAY.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="xoffset">
            /// <para>
            /// Specifies a texel offset in the x direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="yoffset">
            /// <para>
            /// Specifies a texel offset in the y direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="zoffset">
            /// <para>
            /// Specifies a texel offset in the z direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="depth">
            /// <para>
            /// Specifies the depth of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_DEPTH_COMPONENT, and GL_STENCIL_INDEX.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_texture3D", Version = "", EntryPoint = "glTexSubImage3DEXT")]
            public static extern void TexSubImage3D<T10>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T10[,,] pixels)
                where T10 : struct
            ;

            /// <summary>[requires: EXT_texture3D]
            /// Specify a three-dimensional texture subimage
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target texture. Must be GL_TEXTURE_3D or GL_TEXTURE_2D_ARRAY.
            /// </para>
            /// </param>
            /// <param name="level">
            /// <para>
            /// Specifies the level-of-detail number. Level 0 is the base image level. Level n is the nth mipmap reduction image.
            /// </para>
            /// </param>
            /// <param name="xoffset">
            /// <para>
            /// Specifies a texel offset in the x direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="yoffset">
            /// <para>
            /// Specifies a texel offset in the y direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="zoffset">
            /// <para>
            /// Specifies a texel offset in the z direction within the texture array.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// Specifies the width of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="height">
            /// <para>
            /// Specifies the height of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="depth">
            /// <para>
            /// Specifies the depth of the texture subimage.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// Specifies the format of the pixel data. The following symbolic values are accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, GL_DEPTH_COMPONENT, and GL_STENCIL_INDEX.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of the pixel data. The following symbolic values are accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Specifies a pointer to the image data in memory.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_texture3D", Version = "", EntryPoint = "glTexSubImage3DEXT")]
            public static extern void TexSubImage3D<T10>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T10 pixels)
                where T10 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureBufferEXT")]
            public static extern void TextureBuffer(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 buffer);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureBufferEXT")]
            public static extern void TextureBuffer(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, UInt32 buffer);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureBufferRangeEXT")]
            public static extern void TextureBufferRange(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 buffer, IntPtr offset, IntPtr size);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureBufferRangeEXT")]
            public static extern void TextureBufferRange(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, UInt32 buffer, IntPtr offset, IntPtr size);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage1DEXT")]
            public static extern void TextureImage1D(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage1DEXT")]
            public static extern void TextureImage1D<T8>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T8[] pixels)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage1DEXT")]
            public static extern void TextureImage1D<T8>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T8[,] pixels)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage1DEXT")]
            public static extern void TextureImage1D<T8>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T8[,,] pixels)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage1DEXT")]
            public static extern void TextureImage1D<T8>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T8 pixels)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage1DEXT")]
            public static extern void TextureImage1D(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage1DEXT")]
            public static extern void TextureImage1D<T8>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T8[] pixels)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage1DEXT")]
            public static extern void TextureImage1D<T8>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T8[,] pixels)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage1DEXT")]
            public static extern void TextureImage1D<T8>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T8[,,] pixels)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage1DEXT")]
            public static extern void TextureImage1D<T8>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T8 pixels)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage1DEXT")]
            public static extern void TextureImage1D(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage1DEXT")]
            public static extern void TextureImage1D<T8>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T8[] pixels)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage1DEXT")]
            public static extern void TextureImage1D<T8>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T8[,] pixels)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage1DEXT")]
            public static extern void TextureImage1D<T8>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T8[,,] pixels)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage1DEXT")]
            public static extern void TextureImage1D<T8>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T8 pixels)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage1DEXT")]
            public static extern void TextureImage1D(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage1DEXT")]
            public static extern void TextureImage1D<T8>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T8[] pixels)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage1DEXT")]
            public static extern void TextureImage1D<T8>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T8[,] pixels)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage1DEXT")]
            public static extern void TextureImage1D<T8>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T8[,,] pixels)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage1DEXT")]
            public static extern void TextureImage1D<T8>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T8 pixels)
                where T8 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage2DEXT")]
            public static extern void TextureImage2D(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage2DEXT")]
            public static extern void TextureImage2D<T9>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T9[] pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage2DEXT")]
            public static extern void TextureImage2D<T9>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T9[,] pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage2DEXT")]
            public static extern void TextureImage2D<T9>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T9[,,] pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage2DEXT")]
            public static extern void TextureImage2D<T9>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T9 pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage2DEXT")]
            public static extern void TextureImage2D(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage2DEXT")]
            public static extern void TextureImage2D<T9>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T9[] pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage2DEXT")]
            public static extern void TextureImage2D<T9>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T9[,] pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage2DEXT")]
            public static extern void TextureImage2D<T9>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T9[,,] pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage2DEXT")]
            public static extern void TextureImage2D<T9>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T9 pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage2DEXT")]
            public static extern void TextureImage2D(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage2DEXT")]
            public static extern void TextureImage2D<T9>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T9[] pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage2DEXT")]
            public static extern void TextureImage2D<T9>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T9[,] pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage2DEXT")]
            public static extern void TextureImage2D<T9>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T9[,,] pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage2DEXT")]
            public static extern void TextureImage2D<T9>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T9 pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage2DEXT")]
            public static extern void TextureImage2D(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage2DEXT")]
            public static extern void TextureImage2D<T9>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T9[] pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage2DEXT")]
            public static extern void TextureImage2D<T9>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T9[,] pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage2DEXT")]
            public static extern void TextureImage2D<T9>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T9[,,] pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage2DEXT")]
            public static extern void TextureImage2D<T9>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T9 pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage3DEXT")]
            public static extern void TextureImage3D(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage3DEXT")]
            public static extern void TextureImage3D<T10>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T10[] pixels)
                where T10 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage3DEXT")]
            public static extern void TextureImage3D<T10>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T10[,] pixels)
                where T10 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage3DEXT")]
            public static extern void TextureImage3D<T10>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T10[,,] pixels)
                where T10 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage3DEXT")]
            public static extern void TextureImage3D<T10>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T10 pixels)
                where T10 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage3DEXT")]
            public static extern void TextureImage3D(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage3DEXT")]
            public static extern void TextureImage3D<T10>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T10[] pixels)
                where T10 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage3DEXT")]
            public static extern void TextureImage3D<T10>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T10[,] pixels)
                where T10 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage3DEXT")]
            public static extern void TextureImage3D<T10>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T10[,,] pixels)
                where T10 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage3DEXT")]
            public static extern void TextureImage3D<T10>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T10 pixels)
                where T10 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage3DEXT")]
            public static extern void TextureImage3D(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage3DEXT")]
            public static extern void TextureImage3D<T10>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T10[] pixels)
                where T10 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage3DEXT")]
            public static extern void TextureImage3D<T10>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T10[,] pixels)
                where T10 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage3DEXT")]
            public static extern void TextureImage3D<T10>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T10[,,] pixels)
                where T10 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [Obsolete("Use int overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage3DEXT")]
            public static extern void TextureImage3D<T10>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T10 pixels)
                where T10 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage3DEXT")]
            public static extern void TextureImage3D(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage3DEXT")]
            public static extern void TextureImage3D<T10>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T10[] pixels)
                where T10 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage3DEXT")]
            public static extern void TextureImage3D<T10>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T10[,] pixels)
                where T10 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage3DEXT")]
            public static extern void TextureImage3D<T10>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T10[,,] pixels)
                where T10 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureImage3DEXT")]
            public static extern void TextureImage3D<T10>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T10 pixels)
                where T10 : struct
            ;

            /// <summary>[requires: EXT_light_texture]</summary>
            [AutoGenerated(Category = "EXT_light_texture", Version = "", EntryPoint = "glTextureLightEXT")]
            public static extern void TextureLight(OpenTK.Graphics.OpenGL.ExtLightTexture pname);

            /// <summary>[requires: EXT_light_texture]</summary>
            [AutoGenerated(Category = "EXT_light_texture", Version = "", EntryPoint = "glTextureMaterialEXT")]
            public static extern void TextureMaterial(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter mode);

            /// <summary>[requires: EXT_texture_perturb_normal]</summary>
            [AutoGenerated(Category = "EXT_texture_perturb_normal", Version = "", EntryPoint = "glTextureNormalEXT")]
            public static extern void TextureNormal(OpenTK.Graphics.OpenGL.ExtTexturePerturbNormal mode);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTexturePageCommitmentEXT")]
            public static extern void TexturePageCommitment(Int32 texture, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, bool resident);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTexturePageCommitmentEXT")]
            public static extern void TexturePageCommitment(UInt32 texture, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, bool resident);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureParameterfEXT")]
            public static extern void TextureParameter(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Single param);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureParameterfEXT")]
            public static extern void TextureParameter(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Single param);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureParameterfvEXT")]
            public static extern void TextureParameter(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Single[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureParameterfvEXT")]
            public static extern unsafe void TextureParameter(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Single* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureParameterfvEXT")]
            public static extern void TextureParameter(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Single[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureParameterfvEXT")]
            public static extern unsafe void TextureParameter(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Single* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureParameteriEXT")]
            public static extern void TextureParameter(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Int32 param);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureParameteriEXT")]
            public static extern void TextureParameter(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Int32 param);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureParameterIivEXT")]
            public static extern void TextureParameterI(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Int32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureParameterIivEXT")]
            public static extern void TextureParameterI(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, ref Int32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureParameterIivEXT")]
            public static extern unsafe void TextureParameterI(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureParameterIivEXT")]
            public static extern void TextureParameterI(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Int32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureParameterIivEXT")]
            public static extern void TextureParameterI(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, ref Int32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureParameterIivEXT")]
            public static extern unsafe void TextureParameterI(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureParameterIuivEXT")]
            public static extern void TextureParameterI(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, UInt32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureParameterIuivEXT")]
            public static extern void TextureParameterI(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, ref UInt32 @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureParameterIuivEXT")]
            public static extern unsafe void TextureParameterI(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, UInt32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureParameterivEXT")]
            public static extern void TextureParameter(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Int32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureParameterivEXT")]
            public static extern unsafe void TextureParameter(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureParameterivEXT")]
            public static extern void TextureParameter(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Int32[] @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureParameterivEXT")]
            public static extern unsafe void TextureParameter(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Int32* @params);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureRenderbufferEXT")]
            public static extern void TextureRenderbuffer(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 renderbuffer);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureRenderbufferEXT")]
            public static extern void TextureRenderbuffer(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, UInt32 renderbuffer);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureStorage1DEXT")]
            public static extern void TextureStorage1D(Int32 texture, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 levels, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureStorage1DEXT")]
            public static extern void TextureStorage1D(UInt32 texture, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 levels, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureStorage2DEXT")]
            public static extern void TextureStorage2D(Int32 texture, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 levels, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureStorage2DEXT")]
            public static extern void TextureStorage2D(UInt32 texture, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 levels, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureStorage2DMultisampleEXT")]
            public static extern void TextureStorage2DMultisample(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 samples, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, bool fixedsamplelocations);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureStorage2DMultisampleEXT")]
            public static extern void TextureStorage2DMultisample(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 samples, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, bool fixedsamplelocations);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureStorage3DEXT")]
            public static extern void TextureStorage3D(Int32 texture, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 levels, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureStorage3DEXT")]
            public static extern void TextureStorage3D(UInt32 texture, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 levels, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureStorage3DMultisampleEXT")]
            public static extern void TextureStorage3DMultisample(Int32 texture, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 samples, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth, bool fixedsamplelocations);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureStorage3DMultisampleEXT")]
            public static extern void TextureStorage3DMultisample(UInt32 texture, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 samples, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth, bool fixedsamplelocations);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureSubImage1DEXT")]
            public static extern void TextureSubImage1D(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureSubImage1DEXT")]
            public static extern void TextureSubImage1D<T7>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T7[] pixels)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureSubImage1DEXT")]
            public static extern void TextureSubImage1D<T7>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T7[,] pixels)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureSubImage1DEXT")]
            public static extern void TextureSubImage1D<T7>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T7[,,] pixels)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureSubImage1DEXT")]
            public static extern void TextureSubImage1D<T7>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T7 pixels)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureSubImage1DEXT")]
            public static extern void TextureSubImage1D(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureSubImage1DEXT")]
            public static extern void TextureSubImage1D<T7>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T7[] pixels)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureSubImage1DEXT")]
            public static extern void TextureSubImage1D<T7>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T7[,] pixels)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureSubImage1DEXT")]
            public static extern void TextureSubImage1D<T7>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T7[,,] pixels)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureSubImage1DEXT")]
            public static extern void TextureSubImage1D<T7>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T7 pixels)
                where T7 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureSubImage2DEXT")]
            public static extern void TextureSubImage2D(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureSubImage2DEXT")]
            public static extern void TextureSubImage2D<T9>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T9[] pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureSubImage2DEXT")]
            public static extern void TextureSubImage2D<T9>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T9[,] pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureSubImage2DEXT")]
            public static extern void TextureSubImage2D<T9>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T9[,,] pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureSubImage2DEXT")]
            public static extern void TextureSubImage2D<T9>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T9 pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureSubImage2DEXT")]
            public static extern void TextureSubImage2D(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureSubImage2DEXT")]
            public static extern void TextureSubImage2D<T9>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T9[] pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureSubImage2DEXT")]
            public static extern void TextureSubImage2D<T9>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T9[,] pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureSubImage2DEXT")]
            public static extern void TextureSubImage2D<T9>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T9[,,] pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureSubImage2DEXT")]
            public static extern void TextureSubImage2D<T9>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T9 pixels)
                where T9 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureSubImage3DEXT")]
            public static extern void TextureSubImage3D(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureSubImage3DEXT")]
            public static extern void TextureSubImage3D<T11>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T11[] pixels)
                where T11 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureSubImage3DEXT")]
            public static extern void TextureSubImage3D<T11>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T11[,] pixels)
                where T11 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureSubImage3DEXT")]
            public static extern void TextureSubImage3D<T11>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T11[,,] pixels)
                where T11 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureSubImage3DEXT")]
            public static extern void TextureSubImage3D<T11>(Int32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T11 pixels)
                where T11 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureSubImage3DEXT")]
            public static extern void TextureSubImage3D(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureSubImage3DEXT")]
            public static extern void TextureSubImage3D<T11>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T11[] pixels)
                where T11 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureSubImage3DEXT")]
            public static extern void TextureSubImage3D<T11>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T11[,] pixels)
                where T11 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureSubImage3DEXT")]
            public static extern void TextureSubImage3D<T11>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T11[,,] pixels)
                where T11 : struct
            ;

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glTextureSubImage3DEXT")]
            public static extern void TextureSubImage3D<T11>(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T11 pixels)
                where T11 : struct
            ;

            /// <summary>[requires: EXT_transform_feedback]
            /// Specify values to record in transform feedback buffers
            /// </summary>
            /// <param name="program">
            /// <para>
            /// The name of the target program object.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// The number of varying variables used for transform feedback.
            /// </para>
            /// </param>
            /// <param name="varyings">
            /// <para>
            /// An array of count zero-terminated strings specifying the names of the varying variables to use for transform feedback.
            /// </para>
            /// </param>
            /// <param name="bufferMode">
            /// <para>
            /// Identifies the mode used to capture the varying variables when transform feedback is active. bufferMode must be GL_INTERLEAVED_ATTRIBS or GL_SEPARATE_ATTRIBS.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_transform_feedback", Version = "", EntryPoint = "glTransformFeedbackVaryingsEXT")]
            public static extern void TransformFeedbackVaryings(Int32 program, Int32 count, String[] varyings, OpenTK.Graphics.OpenGL.ExtTransformFeedback bufferMode);

            /// <summary>[requires: EXT_transform_feedback]
            /// Specify values to record in transform feedback buffers
            /// </summary>
            /// <param name="program">
            /// <para>
            /// The name of the target program object.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// The number of varying variables used for transform feedback.
            /// </para>
            /// </param>
            /// <param name="varyings">
            /// <para>
            /// An array of count zero-terminated strings specifying the names of the varying variables to use for transform feedback.
            /// </para>
            /// </param>
            /// <param name="bufferMode">
            /// <para>
            /// Identifies the mode used to capture the varying variables when transform feedback is active. bufferMode must be GL_INTERLEAVED_ATTRIBS or GL_SEPARATE_ATTRIBS.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_transform_feedback", Version = "", EntryPoint = "glTransformFeedbackVaryingsEXT")]
            public static extern void TransformFeedbackVaryings(UInt32 program, Int32 count, String[] varyings, OpenTK.Graphics.OpenGL.ExtTransformFeedback bufferMode);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glUniform1uiEXT")]
            public static extern void Uniform1(Int32 location, Int32 v0);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glUniform1uiEXT")]
            public static extern void Uniform1(Int32 location, UInt32 v0);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glUniform1uivEXT")]
            public static extern void Uniform1(Int32 location, Int32 count, Int32[] value);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glUniform1uivEXT")]
            public static extern void Uniform1(Int32 location, Int32 count, ref Int32 value);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glUniform1uivEXT")]
            public static extern unsafe void Uniform1(Int32 location, Int32 count, Int32* value);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glUniform1uivEXT")]
            public static extern void Uniform1(Int32 location, Int32 count, UInt32[] value);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glUniform1uivEXT")]
            public static extern void Uniform1(Int32 location, Int32 count, ref UInt32 value);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glUniform1uivEXT")]
            public static extern unsafe void Uniform1(Int32 location, Int32 count, UInt32* value);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glUniform2uiEXT")]
            public static extern void Uniform2(Int32 location, Int32 v0, Int32 v1);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glUniform2uiEXT")]
            public static extern void Uniform2(Int32 location, UInt32 v0, UInt32 v1);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glUniform2uivEXT")]
            public static extern void Uniform2(Int32 location, Int32 count, Int32[] value);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glUniform2uivEXT")]
            public static extern unsafe void Uniform2(Int32 location, Int32 count, Int32* value);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glUniform2uivEXT")]
            public static extern void Uniform2(Int32 location, Int32 count, UInt32[] value);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glUniform2uivEXT")]
            public static extern void Uniform2(Int32 location, Int32 count, ref UInt32 value);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glUniform2uivEXT")]
            public static extern unsafe void Uniform2(Int32 location, Int32 count, UInt32* value);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glUniform3uiEXT")]
            public static extern void Uniform3(Int32 location, Int32 v0, Int32 v1, Int32 v2);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glUniform3uiEXT")]
            public static extern void Uniform3(Int32 location, UInt32 v0, UInt32 v1, UInt32 v2);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glUniform3uivEXT")]
            public static extern void Uniform3(Int32 location, Int32 count, Int32[] value);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glUniform3uivEXT")]
            public static extern void Uniform3(Int32 location, Int32 count, ref Int32 value);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glUniform3uivEXT")]
            public static extern unsafe void Uniform3(Int32 location, Int32 count, Int32* value);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glUniform3uivEXT")]
            public static extern void Uniform3(Int32 location, Int32 count, UInt32[] value);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glUniform3uivEXT")]
            public static extern void Uniform3(Int32 location, Int32 count, ref UInt32 value);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glUniform3uivEXT")]
            public static extern unsafe void Uniform3(Int32 location, Int32 count, UInt32* value);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glUniform4uiEXT")]
            public static extern void Uniform4(Int32 location, Int32 v0, Int32 v1, Int32 v2, Int32 v3);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glUniform4uiEXT")]
            public static extern void Uniform4(Int32 location, UInt32 v0, UInt32 v1, UInt32 v2, UInt32 v3);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glUniform4uivEXT")]
            public static extern void Uniform4(Int32 location, Int32 count, Int32[] value);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glUniform4uivEXT")]
            public static extern void Uniform4(Int32 location, Int32 count, ref Int32 value);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glUniform4uivEXT")]
            public static extern unsafe void Uniform4(Int32 location, Int32 count, Int32* value);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glUniform4uivEXT")]
            public static extern void Uniform4(Int32 location, Int32 count, UInt32[] value);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glUniform4uivEXT")]
            public static extern void Uniform4(Int32 location, Int32 count, ref UInt32 value);

            /// <summary>[requires: EXT_gpu_shader4]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_gpu_shader4", Version = "", EntryPoint = "glUniform4uivEXT")]
            public static extern unsafe void Uniform4(Int32 location, Int32 count, UInt32* value);

            /// <summary>[requires: EXT_bindable_uniform]</summary>
            [AutoGenerated(Category = "EXT_bindable_uniform", Version = "", EntryPoint = "glUniformBufferEXT")]
            public static extern void UniformBuffer(Int32 program, Int32 location, Int32 buffer);

            /// <summary>[requires: EXT_bindable_uniform]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_bindable_uniform", Version = "", EntryPoint = "glUniformBufferEXT")]
            public static extern void UniformBuffer(UInt32 program, Int32 location, UInt32 buffer);

            /// <summary>[requires: EXT_compiled_vertex_array]</summary>
            [AutoGenerated(Category = "EXT_compiled_vertex_array", Version = "", EntryPoint = "glUnlockArraysEXT")]
            public static extern void UnlockArrays();

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glUnmapNamedBufferEXT")]
            public static extern bool UnmapNamedBuffer(Int32 buffer);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glUnmapNamedBufferEXT")]
            public static extern bool UnmapNamedBuffer(UInt32 buffer);

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Bind stages of a program object to a program pipeline
            /// </summary>
            /// <param name="pipeline">
            /// <para>
            /// Specifies the program pipeline object to which to bind stages from program.
            /// </para>
            /// </param>
            /// <param name="stages">
            /// <para>
            /// Specifies a set of program stages to bind to the program pipeline object.
            /// </para>
            /// </param>
            /// <param name="program">
            /// <para>
            /// Specifies the program object containing the shader executables to use in pipeline.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glUseProgramStagesEXT")]
            public static extern void UseProgramStages(Int32 pipeline, Int32 stages, Int32 program);

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Bind stages of a program object to a program pipeline
            /// </summary>
            /// <param name="pipeline">
            /// <para>
            /// Specifies the program pipeline object to which to bind stages from program.
            /// </para>
            /// </param>
            /// <param name="stages">
            /// <para>
            /// Specifies a set of program stages to bind to the program pipeline object.
            /// </para>
            /// </param>
            /// <param name="program">
            /// <para>
            /// Specifies the program object containing the shader executables to use in pipeline.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glUseProgramStagesEXT")]
            public static extern void UseProgramStages(UInt32 pipeline, UInt32 stages, UInt32 program);

            /// <summary>[requires: EXT_separate_shader_objects]</summary>
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glUseShaderProgramEXT")]
            public static extern void UseShaderProgram(OpenTK.Graphics.OpenGL.ExtSeparateShaderObjects type, Int32 program);

            /// <summary>[requires: EXT_separate_shader_objects]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glUseShaderProgramEXT")]
            public static extern void UseShaderProgram(OpenTK.Graphics.OpenGL.ExtSeparateShaderObjects type, UInt32 program);

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Validate a program pipeline object against current GL state
            /// </summary>
            /// <param name="pipeline">
            /// <para>
            /// Specifies the name of a program pipeline object to validate.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glValidateProgramPipelineEXT")]
            public static extern void ValidateProgramPipeline(Int32 pipeline);

            /// <summary>[requires: EXT_separate_shader_objects]
            /// Validate a program pipeline object against current GL state
            /// </summary>
            /// <param name="pipeline">
            /// <para>
            /// Specifies the name of a program pipeline object to validate.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_separate_shader_objects", Version = "", EntryPoint = "glValidateProgramPipelineEXT")]
            public static extern void ValidateProgramPipeline(UInt32 pipeline);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantbvEXT")]
            public static extern void Variant(UInt32 id, SByte[] addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantbvEXT")]
            public static extern void Variant(UInt32 id, ref SByte addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantbvEXT")]
            public static extern unsafe void Variant(UInt32 id, SByte* addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantdvEXT")]
            public static extern void Variant(Int32 id, Double[] addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantdvEXT")]
            public static extern void Variant(Int32 id, ref Double addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantdvEXT")]
            public static extern unsafe void Variant(Int32 id, Double* addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantdvEXT")]
            public static extern void Variant(UInt32 id, Double[] addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantdvEXT")]
            public static extern void Variant(UInt32 id, ref Double addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantdvEXT")]
            public static extern unsafe void Variant(UInt32 id, Double* addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantfvEXT")]
            public static extern void Variant(Int32 id, Single[] addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantfvEXT")]
            public static extern void Variant(Int32 id, ref Single addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantfvEXT")]
            public static extern unsafe void Variant(Int32 id, Single* addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantfvEXT")]
            public static extern void Variant(UInt32 id, Single[] addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantfvEXT")]
            public static extern void Variant(UInt32 id, ref Single addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantfvEXT")]
            public static extern unsafe void Variant(UInt32 id, Single* addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantivEXT")]
            public static extern void Variant(Int32 id, Int32[] addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantivEXT")]
            public static extern void Variant(Int32 id, ref Int32 addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantivEXT")]
            public static extern unsafe void Variant(Int32 id, Int32* addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantivEXT")]
            public static extern void Variant(UInt32 id, Int32[] addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantivEXT")]
            public static extern void Variant(UInt32 id, ref Int32 addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantivEXT")]
            public static extern unsafe void Variant(UInt32 id, Int32* addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantPointerEXT")]
            public static extern void VariantPointer(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader type, Int32 stride, IntPtr addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantPointerEXT")]
            public static extern void VariantPointer<T3>(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader type, Int32 stride, [InAttribute, OutAttribute] T3[] addr)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantPointerEXT")]
            public static extern void VariantPointer<T3>(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader type, Int32 stride, [InAttribute, OutAttribute] T3[,] addr)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantPointerEXT")]
            public static extern void VariantPointer<T3>(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader type, Int32 stride, [InAttribute, OutAttribute] T3[,,] addr)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantPointerEXT")]
            public static extern void VariantPointer<T3>(Int32 id, OpenTK.Graphics.OpenGL.ExtVertexShader type, Int32 stride, [InAttribute, OutAttribute] ref T3 addr)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantPointerEXT")]
            public static extern void VariantPointer(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader type, UInt32 stride, IntPtr addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantPointerEXT")]
            public static extern void VariantPointer<T3>(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader type, UInt32 stride, [InAttribute, OutAttribute] T3[] addr)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantPointerEXT")]
            public static extern void VariantPointer<T3>(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader type, UInt32 stride, [InAttribute, OutAttribute] T3[,] addr)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantPointerEXT")]
            public static extern void VariantPointer<T3>(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader type, UInt32 stride, [InAttribute, OutAttribute] T3[,,] addr)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantPointerEXT")]
            public static extern void VariantPointer<T3>(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader type, UInt32 stride, [InAttribute, OutAttribute] ref T3 addr)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantsvEXT")]
            public static extern void Variant(Int32 id, Int16[] addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantsvEXT")]
            public static extern void Variant(Int32 id, ref Int16 addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantsvEXT")]
            public static extern unsafe void Variant(Int32 id, Int16* addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantsvEXT")]
            public static extern void Variant(UInt32 id, Int16[] addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantsvEXT")]
            public static extern void Variant(UInt32 id, ref Int16 addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantsvEXT")]
            public static extern unsafe void Variant(UInt32 id, Int16* addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantubvEXT")]
            public static extern void Variant(Int32 id, Byte[] addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantubvEXT")]
            public static extern void Variant(Int32 id, ref Byte addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantubvEXT")]
            public static extern unsafe void Variant(Int32 id, Byte* addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantubvEXT")]
            public static extern void Variant(UInt32 id, Byte[] addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantubvEXT")]
            public static extern void Variant(UInt32 id, ref Byte addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantubvEXT")]
            public static extern unsafe void Variant(UInt32 id, Byte* addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantuivEXT")]
            public static extern void Variant(UInt32 id, UInt32[] addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantuivEXT")]
            public static extern void Variant(UInt32 id, ref UInt32 addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantuivEXT")]
            public static extern unsafe void Variant(UInt32 id, UInt32* addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantusvEXT")]
            public static extern void Variant(UInt32 id, UInt16[] addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantusvEXT")]
            public static extern void Variant(UInt32 id, ref UInt16 addr);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glVariantusvEXT")]
            public static extern unsafe void Variant(UInt32 id, UInt16* addr);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayBindVertexBufferEXT")]
            public static extern void VertexArrayBindVertexBuffer(Int32 vaobj, Int32 bindingindex, Int32 buffer, IntPtr offset, Int32 stride);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayBindVertexBufferEXT")]
            public static extern void VertexArrayBindVertexBuffer(UInt32 vaobj, UInt32 bindingindex, UInt32 buffer, IntPtr offset, Int32 stride);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayColorOffsetEXT")]
            public static extern void VertexArrayColorOffset(Int32 vaobj, Int32 buffer, Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, IntPtr offset);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayColorOffsetEXT")]
            public static extern void VertexArrayColorOffset(UInt32 vaobj, UInt32 buffer, Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, IntPtr offset);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayEdgeFlagOffsetEXT")]
            public static extern void VertexArrayEdgeFlagOffset(Int32 vaobj, Int32 buffer, Int32 stride, IntPtr offset);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayEdgeFlagOffsetEXT")]
            public static extern void VertexArrayEdgeFlagOffset(UInt32 vaobj, UInt32 buffer, Int32 stride, IntPtr offset);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayFogCoordOffsetEXT")]
            public static extern void VertexArrayFogCoordOffset(Int32 vaobj, Int32 buffer, OpenTK.Graphics.OpenGL.FogPointerType type, Int32 stride, IntPtr offset);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayFogCoordOffsetEXT")]
            public static extern void VertexArrayFogCoordOffset(UInt32 vaobj, UInt32 buffer, OpenTK.Graphics.OpenGL.FogPointerType type, Int32 stride, IntPtr offset);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayIndexOffsetEXT")]
            public static extern void VertexArrayIndexOffset(Int32 vaobj, Int32 buffer, OpenTK.Graphics.OpenGL.IndexPointerType type, Int32 stride, IntPtr offset);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayIndexOffsetEXT")]
            public static extern void VertexArrayIndexOffset(UInt32 vaobj, UInt32 buffer, OpenTK.Graphics.OpenGL.IndexPointerType type, Int32 stride, IntPtr offset);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayMultiTexCoordOffsetEXT")]
            public static extern void VertexArrayMultiTexCoordOffset(Int32 vaobj, Int32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess texunit, Int32 size, OpenTK.Graphics.OpenGL.TexCoordPointerType type, Int32 stride, IntPtr offset);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayMultiTexCoordOffsetEXT")]
            public static extern void VertexArrayMultiTexCoordOffset(UInt32 vaobj, UInt32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess texunit, Int32 size, OpenTK.Graphics.OpenGL.TexCoordPointerType type, Int32 stride, IntPtr offset);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayNormalOffsetEXT")]
            public static extern void VertexArrayNormalOffset(Int32 vaobj, Int32 buffer, OpenTK.Graphics.OpenGL.NormalPointerType type, Int32 stride, IntPtr offset);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayNormalOffsetEXT")]
            public static extern void VertexArrayNormalOffset(UInt32 vaobj, UInt32 buffer, OpenTK.Graphics.OpenGL.NormalPointerType type, Int32 stride, IntPtr offset);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArraySecondaryColorOffsetEXT")]
            public static extern void VertexArraySecondaryColorOffset(Int32 vaobj, Int32 buffer, Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, IntPtr offset);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArraySecondaryColorOffsetEXT")]
            public static extern void VertexArraySecondaryColorOffset(UInt32 vaobj, UInt32 buffer, Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, IntPtr offset);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayTexCoordOffsetEXT")]
            public static extern void VertexArrayTexCoordOffset(Int32 vaobj, Int32 buffer, Int32 size, OpenTK.Graphics.OpenGL.TexCoordPointerType type, Int32 stride, IntPtr offset);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayTexCoordOffsetEXT")]
            public static extern void VertexArrayTexCoordOffset(UInt32 vaobj, UInt32 buffer, Int32 size, OpenTK.Graphics.OpenGL.TexCoordPointerType type, Int32 stride, IntPtr offset);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayVertexAttribBindingEXT")]
            public static extern void VertexArrayVertexAttribBinding(Int32 vaobj, Int32 attribindex, Int32 bindingindex);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayVertexAttribBindingEXT")]
            public static extern void VertexArrayVertexAttribBinding(UInt32 vaobj, UInt32 attribindex, UInt32 bindingindex);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayVertexAttribDivisorEXT")]
            public static extern void VertexArrayVertexAttribDivisor(Int32 vaobj, Int32 index, Int32 divisor);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayVertexAttribDivisorEXT")]
            public static extern void VertexArrayVertexAttribDivisor(UInt32 vaobj, UInt32 index, UInt32 divisor);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayVertexAttribFormatEXT")]
            public static extern void VertexArrayVertexAttribFormat(Int32 vaobj, Int32 attribindex, Int32 size, OpenTK.Graphics.OpenGL.ExtDirectStateAccess type, bool normalized, Int32 relativeoffset);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayVertexAttribFormatEXT")]
            public static extern void VertexArrayVertexAttribFormat(UInt32 vaobj, UInt32 attribindex, Int32 size, OpenTK.Graphics.OpenGL.ExtDirectStateAccess type, bool normalized, UInt32 relativeoffset);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayVertexAttribIFormatEXT")]
            public static extern void VertexArrayVertexAttribIFormat(Int32 vaobj, Int32 attribindex, Int32 size, OpenTK.Graphics.OpenGL.ExtDirectStateAccess type, Int32 relativeoffset);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayVertexAttribIFormatEXT")]
            public static extern void VertexArrayVertexAttribIFormat(UInt32 vaobj, UInt32 attribindex, Int32 size, OpenTK.Graphics.OpenGL.ExtDirectStateAccess type, UInt32 relativeoffset);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayVertexAttribIOffsetEXT")]
            public static extern void VertexArrayVertexAttribIOffset(Int32 vaobj, Int32 buffer, Int32 index, Int32 size, OpenTK.Graphics.OpenGL.ExtDirectStateAccess type, Int32 stride, IntPtr offset);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayVertexAttribIOffsetEXT")]
            public static extern void VertexArrayVertexAttribIOffset(UInt32 vaobj, UInt32 buffer, UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.ExtDirectStateAccess type, Int32 stride, IntPtr offset);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayVertexAttribLFormatEXT")]
            public static extern void VertexArrayVertexAttribLFormat(Int32 vaobj, Int32 attribindex, Int32 size, OpenTK.Graphics.OpenGL.ExtDirectStateAccess type, Int32 relativeoffset);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayVertexAttribLFormatEXT")]
            public static extern void VertexArrayVertexAttribLFormat(UInt32 vaobj, UInt32 attribindex, Int32 size, OpenTK.Graphics.OpenGL.ExtDirectStateAccess type, UInt32 relativeoffset);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayVertexAttribLOffsetEXT")]
            public static extern void VertexArrayVertexAttribLOffset(Int32 vaobj, Int32 buffer, Int32 index, Int32 size, OpenTK.Graphics.OpenGL.ExtDirectStateAccess type, Int32 stride, IntPtr offset);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayVertexAttribLOffsetEXT")]
            public static extern void VertexArrayVertexAttribLOffset(UInt32 vaobj, UInt32 buffer, UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.ExtDirectStateAccess type, Int32 stride, IntPtr offset);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayVertexAttribOffsetEXT")]
            public static extern void VertexArrayVertexAttribOffset(Int32 vaobj, Int32 buffer, Int32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribPointerType type, bool normalized, Int32 stride, IntPtr offset);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayVertexAttribOffsetEXT")]
            public static extern void VertexArrayVertexAttribOffset(UInt32 vaobj, UInt32 buffer, UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribPointerType type, bool normalized, Int32 stride, IntPtr offset);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayVertexBindingDivisorEXT")]
            public static extern void VertexArrayVertexBindingDivisor(Int32 vaobj, Int32 bindingindex, Int32 divisor);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayVertexBindingDivisorEXT")]
            public static extern void VertexArrayVertexBindingDivisor(UInt32 vaobj, UInt32 bindingindex, UInt32 divisor);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayVertexOffsetEXT")]
            public static extern void VertexArrayVertexOffset(Int32 vaobj, Int32 buffer, Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, Int32 stride, IntPtr offset);

            /// <summary>[requires: EXT_direct_state_access]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_direct_state_access", Version = "", EntryPoint = "glVertexArrayVertexOffsetEXT")]
            public static extern void VertexArrayVertexOffset(UInt32 vaobj, UInt32 buffer, Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, Int32 stride, IntPtr offset);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI1iEXT")]
            public static extern void VertexAttribI1(Int32 index, Int32 x);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI1iEXT")]
            public static extern void VertexAttribI1(UInt32 index, Int32 x);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI1ivEXT")]
            public static extern unsafe void VertexAttribI1(Int32 index, Int32* v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI1ivEXT")]
            public static extern unsafe void VertexAttribI1(UInt32 index, Int32* v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI1uiEXT")]
            public static extern void VertexAttribI1(UInt32 index, UInt32 x);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI1uivEXT")]
            public static extern unsafe void VertexAttribI1(UInt32 index, UInt32* v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI2iEXT")]
            public static extern void VertexAttribI2(Int32 index, Int32 x, Int32 y);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI2iEXT")]
            public static extern void VertexAttribI2(UInt32 index, Int32 x, Int32 y);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI2ivEXT")]
            public static extern void VertexAttribI2(Int32 index, Int32[] v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI2ivEXT")]
            public static extern void VertexAttribI2(Int32 index, ref Int32 v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI2ivEXT")]
            public static extern unsafe void VertexAttribI2(Int32 index, Int32* v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI2ivEXT")]
            public static extern void VertexAttribI2(UInt32 index, Int32[] v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI2ivEXT")]
            public static extern void VertexAttribI2(UInt32 index, ref Int32 v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI2ivEXT")]
            public static extern unsafe void VertexAttribI2(UInt32 index, Int32* v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI2uiEXT")]
            public static extern void VertexAttribI2(UInt32 index, UInt32 x, UInt32 y);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI2uivEXT")]
            public static extern void VertexAttribI2(UInt32 index, UInt32[] v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI2uivEXT")]
            public static extern void VertexAttribI2(UInt32 index, ref UInt32 v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI2uivEXT")]
            public static extern unsafe void VertexAttribI2(UInt32 index, UInt32* v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI3iEXT")]
            public static extern void VertexAttribI3(Int32 index, Int32 x, Int32 y, Int32 z);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI3iEXT")]
            public static extern void VertexAttribI3(UInt32 index, Int32 x, Int32 y, Int32 z);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI3ivEXT")]
            public static extern void VertexAttribI3(Int32 index, Int32[] v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI3ivEXT")]
            public static extern void VertexAttribI3(Int32 index, ref Int32 v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI3ivEXT")]
            public static extern unsafe void VertexAttribI3(Int32 index, Int32* v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI3ivEXT")]
            public static extern void VertexAttribI3(UInt32 index, Int32[] v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI3ivEXT")]
            public static extern void VertexAttribI3(UInt32 index, ref Int32 v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI3ivEXT")]
            public static extern unsafe void VertexAttribI3(UInt32 index, Int32* v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI3uiEXT")]
            public static extern void VertexAttribI3(UInt32 index, UInt32 x, UInt32 y, UInt32 z);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI3uivEXT")]
            public static extern void VertexAttribI3(UInt32 index, UInt32[] v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI3uivEXT")]
            public static extern void VertexAttribI3(UInt32 index, ref UInt32 v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI3uivEXT")]
            public static extern unsafe void VertexAttribI3(UInt32 index, UInt32* v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI4bvEXT")]
            public static extern void VertexAttribI4(UInt32 index, SByte[] v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI4bvEXT")]
            public static extern void VertexAttribI4(UInt32 index, ref SByte v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI4bvEXT")]
            public static extern unsafe void VertexAttribI4(UInt32 index, SByte* v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI4iEXT")]
            public static extern void VertexAttribI4(Int32 index, Int32 x, Int32 y, Int32 z, Int32 w);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI4iEXT")]
            public static extern void VertexAttribI4(UInt32 index, Int32 x, Int32 y, Int32 z, Int32 w);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI4ivEXT")]
            public static extern void VertexAttribI4(Int32 index, Int32[] v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI4ivEXT")]
            public static extern void VertexAttribI4(Int32 index, ref Int32 v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI4ivEXT")]
            public static extern unsafe void VertexAttribI4(Int32 index, Int32* v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI4ivEXT")]
            public static extern void VertexAttribI4(UInt32 index, Int32[] v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI4ivEXT")]
            public static extern void VertexAttribI4(UInt32 index, ref Int32 v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI4ivEXT")]
            public static extern unsafe void VertexAttribI4(UInt32 index, Int32* v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI4svEXT")]
            public static extern void VertexAttribI4(Int32 index, Int16[] v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI4svEXT")]
            public static extern void VertexAttribI4(Int32 index, ref Int16 v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI4svEXT")]
            public static extern unsafe void VertexAttribI4(Int32 index, Int16* v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI4svEXT")]
            public static extern void VertexAttribI4(UInt32 index, Int16[] v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI4svEXT")]
            public static extern void VertexAttribI4(UInt32 index, ref Int16 v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI4svEXT")]
            public static extern unsafe void VertexAttribI4(UInt32 index, Int16* v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI4ubvEXT")]
            public static extern void VertexAttribI4(Int32 index, Byte[] v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI4ubvEXT")]
            public static extern void VertexAttribI4(Int32 index, ref Byte v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI4ubvEXT")]
            public static extern unsafe void VertexAttribI4(Int32 index, Byte* v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI4ubvEXT")]
            public static extern void VertexAttribI4(UInt32 index, Byte[] v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI4ubvEXT")]
            public static extern void VertexAttribI4(UInt32 index, ref Byte v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI4ubvEXT")]
            public static extern unsafe void VertexAttribI4(UInt32 index, Byte* v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI4uiEXT")]
            public static extern void VertexAttribI4(UInt32 index, UInt32 x, UInt32 y, UInt32 z, UInt32 w);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI4uivEXT")]
            public static extern void VertexAttribI4(UInt32 index, UInt32[] v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI4uivEXT")]
            public static extern void VertexAttribI4(UInt32 index, ref UInt32 v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI4uivEXT")]
            public static extern unsafe void VertexAttribI4(UInt32 index, UInt32* v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI4usvEXT")]
            public static extern void VertexAttribI4(UInt32 index, UInt16[] v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI4usvEXT")]
            public static extern void VertexAttribI4(UInt32 index, ref UInt16 v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribI4usvEXT")]
            public static extern unsafe void VertexAttribI4(UInt32 index, UInt16* v);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribIPointerEXT")]
            public static extern void VertexAttribIPointer(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.NvVertexProgram4 type, Int32 stride, IntPtr pointer);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribIPointerEXT")]
            public static extern void VertexAttribIPointer<T4>(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.NvVertexProgram4 type, Int32 stride, [InAttribute, OutAttribute] T4[] pointer)
                where T4 : struct
            ;

            /// <summary>[requires: NV_vertex_program4]</summary>
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribIPointerEXT")]
            public static extern void VertexAttribIPointer<T4>(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.NvVertexProgram4 type, Int32 stride, [InAttribute, OutAttribute] T4[,] pointer)
                where T4 : struct
            ;

            /// <summary>[requires: NV_vertex_program4]</summary>
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribIPointerEXT")]
            public static extern void VertexAttribIPointer<T4>(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.NvVertexProgram4 type, Int32 stride, [InAttribute, OutAttribute] T4[,,] pointer)
                where T4 : struct
            ;

            /// <summary>[requires: NV_vertex_program4]</summary>
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribIPointerEXT")]
            public static extern void VertexAttribIPointer<T4>(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.NvVertexProgram4 type, Int32 stride, [InAttribute, OutAttribute] ref T4 pointer)
                where T4 : struct
            ;

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribIPointerEXT")]
            public static extern void VertexAttribIPointer(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.NvVertexProgram4 type, Int32 stride, IntPtr pointer);

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribIPointerEXT")]
            public static extern void VertexAttribIPointer<T4>(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.NvVertexProgram4 type, Int32 stride, [InAttribute, OutAttribute] T4[] pointer)
                where T4 : struct
            ;

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribIPointerEXT")]
            public static extern void VertexAttribIPointer<T4>(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.NvVertexProgram4 type, Int32 stride, [InAttribute, OutAttribute] T4[,] pointer)
                where T4 : struct
            ;

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribIPointerEXT")]
            public static extern void VertexAttribIPointer<T4>(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.NvVertexProgram4 type, Int32 stride, [InAttribute, OutAttribute] T4[,,] pointer)
                where T4 : struct
            ;

            /// <summary>[requires: NV_vertex_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program4", Version = "", EntryPoint = "glVertexAttribIPointerEXT")]
            public static extern void VertexAttribIPointer<T4>(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.NvVertexProgram4 type, Int32 stride, [InAttribute, OutAttribute] ref T4 pointer)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribL1dEXT")]
            public static extern void VertexAttribL1(Int32 index, Double x);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribL1dEXT")]
            public static extern void VertexAttribL1(UInt32 index, Double x);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribL1dvEXT")]
            public static extern unsafe void VertexAttribL1(Int32 index, Double* v);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribL1dvEXT")]
            public static extern unsafe void VertexAttribL1(UInt32 index, Double* v);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribL2dEXT")]
            public static extern void VertexAttribL2(Int32 index, Double x, Double y);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribL2dEXT")]
            public static extern void VertexAttribL2(UInt32 index, Double x, Double y);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribL2dvEXT")]
            public static extern void VertexAttribL2(Int32 index, Double[] v);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribL2dvEXT")]
            public static extern void VertexAttribL2(Int32 index, ref Double v);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribL2dvEXT")]
            public static extern unsafe void VertexAttribL2(Int32 index, Double* v);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribL2dvEXT")]
            public static extern void VertexAttribL2(UInt32 index, Double[] v);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribL2dvEXT")]
            public static extern void VertexAttribL2(UInt32 index, ref Double v);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribL2dvEXT")]
            public static extern unsafe void VertexAttribL2(UInt32 index, Double* v);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribL3dEXT")]
            public static extern void VertexAttribL3(Int32 index, Double x, Double y, Double z);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribL3dEXT")]
            public static extern void VertexAttribL3(UInt32 index, Double x, Double y, Double z);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribL3dvEXT")]
            public static extern void VertexAttribL3(Int32 index, Double[] v);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribL3dvEXT")]
            public static extern void VertexAttribL3(Int32 index, ref Double v);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribL3dvEXT")]
            public static extern unsafe void VertexAttribL3(Int32 index, Double* v);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribL3dvEXT")]
            public static extern void VertexAttribL3(UInt32 index, Double[] v);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribL3dvEXT")]
            public static extern void VertexAttribL3(UInt32 index, ref Double v);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribL3dvEXT")]
            public static extern unsafe void VertexAttribL3(UInt32 index, Double* v);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribL4dEXT")]
            public static extern void VertexAttribL4(Int32 index, Double x, Double y, Double z, Double w);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribL4dEXT")]
            public static extern void VertexAttribL4(UInt32 index, Double x, Double y, Double z, Double w);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribL4dvEXT")]
            public static extern void VertexAttribL4(Int32 index, Double[] v);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribL4dvEXT")]
            public static extern void VertexAttribL4(Int32 index, ref Double v);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribL4dvEXT")]
            public static extern unsafe void VertexAttribL4(Int32 index, Double* v);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribL4dvEXT")]
            public static extern void VertexAttribL4(UInt32 index, Double[] v);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribL4dvEXT")]
            public static extern void VertexAttribL4(UInt32 index, ref Double v);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribL4dvEXT")]
            public static extern unsafe void VertexAttribL4(UInt32 index, Double* v);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribLPointerEXT")]
            public static extern void VertexAttribLPointer(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.ExtVertexAttrib64bit type, Int32 stride, IntPtr pointer);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribLPointerEXT")]
            public static extern void VertexAttribLPointer<T4>(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.ExtVertexAttrib64bit type, Int32 stride, [InAttribute, OutAttribute] T4[] pointer)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribLPointerEXT")]
            public static extern void VertexAttribLPointer<T4>(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.ExtVertexAttrib64bit type, Int32 stride, [InAttribute, OutAttribute] T4[,] pointer)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribLPointerEXT")]
            public static extern void VertexAttribLPointer<T4>(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.ExtVertexAttrib64bit type, Int32 stride, [InAttribute, OutAttribute] T4[,,] pointer)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribLPointerEXT")]
            public static extern void VertexAttribLPointer<T4>(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.ExtVertexAttrib64bit type, Int32 stride, [InAttribute, OutAttribute] ref T4 pointer)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribLPointerEXT")]
            public static extern void VertexAttribLPointer(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.ExtVertexAttrib64bit type, Int32 stride, IntPtr pointer);

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribLPointerEXT")]
            public static extern void VertexAttribLPointer<T4>(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.ExtVertexAttrib64bit type, Int32 stride, [InAttribute, OutAttribute] T4[] pointer)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribLPointerEXT")]
            public static extern void VertexAttribLPointer<T4>(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.ExtVertexAttrib64bit type, Int32 stride, [InAttribute, OutAttribute] T4[,] pointer)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribLPointerEXT")]
            public static extern void VertexAttribLPointer<T4>(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.ExtVertexAttrib64bit type, Int32 stride, [InAttribute, OutAttribute] T4[,,] pointer)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_vertex_attrib_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_attrib_64bit", Version = "", EntryPoint = "glVertexAttribLPointerEXT")]
            public static extern void VertexAttribLPointer<T4>(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.ExtVertexAttrib64bit type, Int32 stride, [InAttribute, OutAttribute] ref T4 pointer)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_vertex_array]
            /// Define an array of vertex data
            /// </summary>
            /// <param name="size">
            /// <para>
            /// Specifies the number of coordinates per vertex. Must be 2, 3, or 4. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each coordinate in the array. Symbolic constants GL_SHORT, GL_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive vertices. If stride is 0, the vertices are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first coordinate of the first vertex in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glVertexPointerEXT")]
            public static extern void VertexPointer(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, Int32 stride, Int32 count, IntPtr pointer);

            /// <summary>[requires: EXT_vertex_array]
            /// Define an array of vertex data
            /// </summary>
            /// <param name="size">
            /// <para>
            /// Specifies the number of coordinates per vertex. Must be 2, 3, or 4. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each coordinate in the array. Symbolic constants GL_SHORT, GL_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive vertices. If stride is 0, the vertices are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first coordinate of the first vertex in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glVertexPointerEXT")]
            public static extern void VertexPointer<T4>(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, Int32 stride, Int32 count, [InAttribute, OutAttribute] T4[] pointer)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_vertex_array]
            /// Define an array of vertex data
            /// </summary>
            /// <param name="size">
            /// <para>
            /// Specifies the number of coordinates per vertex. Must be 2, 3, or 4. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each coordinate in the array. Symbolic constants GL_SHORT, GL_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive vertices. If stride is 0, the vertices are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first coordinate of the first vertex in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glVertexPointerEXT")]
            public static extern void VertexPointer<T4>(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, Int32 stride, Int32 count, [InAttribute, OutAttribute] T4[,] pointer)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_vertex_array]
            /// Define an array of vertex data
            /// </summary>
            /// <param name="size">
            /// <para>
            /// Specifies the number of coordinates per vertex. Must be 2, 3, or 4. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each coordinate in the array. Symbolic constants GL_SHORT, GL_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive vertices. If stride is 0, the vertices are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first coordinate of the first vertex in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glVertexPointerEXT")]
            public static extern void VertexPointer<T4>(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, Int32 stride, Int32 count, [InAttribute, OutAttribute] T4[,,] pointer)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_vertex_array]
            /// Define an array of vertex data
            /// </summary>
            /// <param name="size">
            /// <para>
            /// Specifies the number of coordinates per vertex. Must be 2, 3, or 4. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each coordinate in the array. Symbolic constants GL_SHORT, GL_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive vertices. If stride is 0, the vertices are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first coordinate of the first vertex in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "EXT_vertex_array", Version = "", EntryPoint = "glVertexPointerEXT")]
            public static extern void VertexPointer<T4>(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, Int32 stride, Int32 count, [InAttribute, OutAttribute] ref T4 pointer)
                where T4 : struct
            ;

            /// <summary>[requires: EXT_vertex_weighting]</summary>
            [AutoGenerated(Category = "EXT_vertex_weighting", Version = "", EntryPoint = "glVertexWeightfEXT")]
            public static extern void VertexWeight(Single weight);

            /// <summary>[requires: EXT_vertex_weighting]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_weighting", Version = "", EntryPoint = "glVertexWeightfvEXT")]
            public static extern unsafe void VertexWeight(Single* weight);

            /// <summary>[requires: EXT_vertex_weighting]</summary>
            [AutoGenerated(Category = "EXT_vertex_weighting", Version = "", EntryPoint = "glVertexWeightPointerEXT")]
            public static extern void VertexWeightPointer(Int32 size, OpenTK.Graphics.OpenGL.ExtVertexWeighting type, Int32 stride, IntPtr pointer);

            /// <summary>[requires: EXT_vertex_weighting]</summary>
            [AutoGenerated(Category = "EXT_vertex_weighting", Version = "", EntryPoint = "glVertexWeightPointerEXT")]
            public static extern void VertexWeightPointer<T3>(Int32 size, OpenTK.Graphics.OpenGL.ExtVertexWeighting type, Int32 stride, [InAttribute, OutAttribute] T3[] pointer)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_vertex_weighting]</summary>
            [AutoGenerated(Category = "EXT_vertex_weighting", Version = "", EntryPoint = "glVertexWeightPointerEXT")]
            public static extern void VertexWeightPointer<T3>(Int32 size, OpenTK.Graphics.OpenGL.ExtVertexWeighting type, Int32 stride, [InAttribute, OutAttribute] T3[,] pointer)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_vertex_weighting]</summary>
            [AutoGenerated(Category = "EXT_vertex_weighting", Version = "", EntryPoint = "glVertexWeightPointerEXT")]
            public static extern void VertexWeightPointer<T3>(Int32 size, OpenTK.Graphics.OpenGL.ExtVertexWeighting type, Int32 stride, [InAttribute, OutAttribute] T3[,,] pointer)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_vertex_weighting]</summary>
            [AutoGenerated(Category = "EXT_vertex_weighting", Version = "", EntryPoint = "glVertexWeightPointerEXT")]
            public static extern void VertexWeightPointer<T3>(Int32 size, OpenTK.Graphics.OpenGL.ExtVertexWeighting type, Int32 stride, [InAttribute, OutAttribute] ref T3 pointer)
                where T3 : struct
            ;

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glWriteMaskEXT")]
            public static extern void WriteMask(Int32 res, Int32 @in, OpenTK.Graphics.OpenGL.ExtVertexShader outX, OpenTK.Graphics.OpenGL.ExtVertexShader outY, OpenTK.Graphics.OpenGL.ExtVertexShader outZ, OpenTK.Graphics.OpenGL.ExtVertexShader outW);

            /// <summary>[requires: EXT_vertex_shader]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "EXT_vertex_shader", Version = "", EntryPoint = "glWriteMaskEXT")]
            public static extern void WriteMask(UInt32 res, UInt32 @in, OpenTK.Graphics.OpenGL.ExtVertexShader outX, OpenTK.Graphics.OpenGL.ExtVertexShader outY, OpenTK.Graphics.OpenGL.ExtVertexShader outZ, OpenTK.Graphics.OpenGL.ExtVertexShader outW);

        }

        public static partial class Gremedy
        {
            /// <summary>[requires: GREMEDY_frame_terminator]</summary>
            [AutoGenerated(Category = "GREMEDY_frame_terminator", Version = "", EntryPoint = "glFrameTerminatorGREMEDY")]
            public static extern void FrameTerminator();

            /// <summary>[requires: GREMEDY_string_marker]</summary>
            [AutoGenerated(Category = "GREMEDY_string_marker", Version = "", EntryPoint = "glStringMarkerGREMEDY")]
            public static extern void StringMarker(Int32 len, IntPtr @string);

            /// <summary>[requires: GREMEDY_string_marker]</summary>
            [AutoGenerated(Category = "GREMEDY_string_marker", Version = "", EntryPoint = "glStringMarkerGREMEDY")]
            public static extern void StringMarker<T1>(Int32 len, [InAttribute, OutAttribute] T1[] @string)
                where T1 : struct
            ;

            /// <summary>[requires: GREMEDY_string_marker]</summary>
            [AutoGenerated(Category = "GREMEDY_string_marker", Version = "", EntryPoint = "glStringMarkerGREMEDY")]
            public static extern void StringMarker<T1>(Int32 len, [InAttribute, OutAttribute] T1[,] @string)
                where T1 : struct
            ;

            /// <summary>[requires: GREMEDY_string_marker]</summary>
            [AutoGenerated(Category = "GREMEDY_string_marker", Version = "", EntryPoint = "glStringMarkerGREMEDY")]
            public static extern void StringMarker<T1>(Int32 len, [InAttribute, OutAttribute] T1[,,] @string)
                where T1 : struct
            ;

            /// <summary>[requires: GREMEDY_string_marker]</summary>
            [AutoGenerated(Category = "GREMEDY_string_marker", Version = "", EntryPoint = "glStringMarkerGREMEDY")]
            public static extern void StringMarker<T1>(Int32 len, [InAttribute, OutAttribute] ref T1 @string)
                where T1 : struct
            ;

        }

        public static partial class HP
        {
            /// <summary>[requires: HP_image_transform]</summary>
            [AutoGenerated(Category = "HP_image_transform", Version = "", EntryPoint = "glGetImageTransformParameterfvHP")]
            public static extern void GetImageTransformParameter(OpenTK.Graphics.OpenGL.HpImageTransform target, OpenTK.Graphics.OpenGL.HpImageTransform pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: HP_image_transform]</summary>
            [AutoGenerated(Category = "HP_image_transform", Version = "", EntryPoint = "glGetImageTransformParameterfvHP")]
            public static extern void GetImageTransformParameter(OpenTK.Graphics.OpenGL.HpImageTransform target, OpenTK.Graphics.OpenGL.HpImageTransform pname, [OutAttribute] out Single @params);

            /// <summary>[requires: HP_image_transform]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "HP_image_transform", Version = "", EntryPoint = "glGetImageTransformParameterfvHP")]
            public static extern unsafe void GetImageTransformParameter(OpenTK.Graphics.OpenGL.HpImageTransform target, OpenTK.Graphics.OpenGL.HpImageTransform pname, [OutAttribute] Single* @params);

            /// <summary>[requires: HP_image_transform]</summary>
            [AutoGenerated(Category = "HP_image_transform", Version = "", EntryPoint = "glGetImageTransformParameterivHP")]
            public static extern void GetImageTransformParameter(OpenTK.Graphics.OpenGL.HpImageTransform target, OpenTK.Graphics.OpenGL.HpImageTransform pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: HP_image_transform]</summary>
            [AutoGenerated(Category = "HP_image_transform", Version = "", EntryPoint = "glGetImageTransformParameterivHP")]
            public static extern void GetImageTransformParameter(OpenTK.Graphics.OpenGL.HpImageTransform target, OpenTK.Graphics.OpenGL.HpImageTransform pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: HP_image_transform]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "HP_image_transform", Version = "", EntryPoint = "glGetImageTransformParameterivHP")]
            public static extern unsafe void GetImageTransformParameter(OpenTK.Graphics.OpenGL.HpImageTransform target, OpenTK.Graphics.OpenGL.HpImageTransform pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: HP_image_transform]</summary>
            [AutoGenerated(Category = "HP_image_transform", Version = "", EntryPoint = "glImageTransformParameterfHP")]
            public static extern void ImageTransformParameter(OpenTK.Graphics.OpenGL.HpImageTransform target, OpenTK.Graphics.OpenGL.HpImageTransform pname, Single param);

            /// <summary>[requires: HP_image_transform]</summary>
            [AutoGenerated(Category = "HP_image_transform", Version = "", EntryPoint = "glImageTransformParameterfvHP")]
            public static extern void ImageTransformParameter(OpenTK.Graphics.OpenGL.HpImageTransform target, OpenTK.Graphics.OpenGL.HpImageTransform pname, Single[] @params);

            /// <summary>[requires: HP_image_transform]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "HP_image_transform", Version = "", EntryPoint = "glImageTransformParameterfvHP")]
            public static extern unsafe void ImageTransformParameter(OpenTK.Graphics.OpenGL.HpImageTransform target, OpenTK.Graphics.OpenGL.HpImageTransform pname, Single* @params);

            /// <summary>[requires: HP_image_transform]</summary>
            [AutoGenerated(Category = "HP_image_transform", Version = "", EntryPoint = "glImageTransformParameteriHP")]
            public static extern void ImageTransformParameter(OpenTK.Graphics.OpenGL.HpImageTransform target, OpenTK.Graphics.OpenGL.HpImageTransform pname, Int32 param);

            /// <summary>[requires: HP_image_transform]</summary>
            [AutoGenerated(Category = "HP_image_transform", Version = "", EntryPoint = "glImageTransformParameterivHP")]
            public static extern void ImageTransformParameter(OpenTK.Graphics.OpenGL.HpImageTransform target, OpenTK.Graphics.OpenGL.HpImageTransform pname, Int32[] @params);

            /// <summary>[requires: HP_image_transform]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "HP_image_transform", Version = "", EntryPoint = "glImageTransformParameterivHP")]
            public static extern unsafe void ImageTransformParameter(OpenTK.Graphics.OpenGL.HpImageTransform target, OpenTK.Graphics.OpenGL.HpImageTransform pname, Int32* @params);

        }

        public static partial class Ibm
        {
            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glColorPointerListIBM")]
            public static extern void ColorPointerList(Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, IntPtr pointer, Int32 ptrstride);

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glColorPointerListIBM")]
            public static extern void ColorPointerList<T3>(Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, [InAttribute, OutAttribute] T3[] pointer, Int32 ptrstride)
                where T3 : struct
            ;

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glColorPointerListIBM")]
            public static extern void ColorPointerList<T3>(Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, [InAttribute, OutAttribute] T3[,] pointer, Int32 ptrstride)
                where T3 : struct
            ;

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glColorPointerListIBM")]
            public static extern void ColorPointerList<T3>(Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, [InAttribute, OutAttribute] T3[,,] pointer, Int32 ptrstride)
                where T3 : struct
            ;

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glColorPointerListIBM")]
            public static extern void ColorPointerList<T3>(Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, [InAttribute, OutAttribute] ref T3 pointer, Int32 ptrstride)
                where T3 : struct
            ;

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glEdgeFlagPointerListIBM")]
            public static extern unsafe void EdgeFlagPointerList(Int32 stride, bool*[] pointer, Int32 ptrstride);

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glEdgeFlagPointerListIBM")]
            public static extern unsafe void EdgeFlagPointerList(Int32 stride, ref bool* pointer, Int32 ptrstride);

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glEdgeFlagPointerListIBM")]
            public static extern unsafe void EdgeFlagPointerList(Int32 stride, bool** pointer, Int32 ptrstride);

            /// <summary>[requires: IBM_static_data]</summary>
            [AutoGenerated(Category = "IBM_static_data", Version = "", EntryPoint = "glFlushStaticDataIBM")]
            public static extern void FlushStaticData(OpenTK.Graphics.OpenGL.IbmStaticData target);

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glFogCoordPointerListIBM")]
            public static extern void FogCoordPointerList(OpenTK.Graphics.OpenGL.FogPointerType type, Int32 stride, IntPtr pointer, Int32 ptrstride);

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glFogCoordPointerListIBM")]
            public static extern void FogCoordPointerList<T2>(OpenTK.Graphics.OpenGL.FogPointerType type, Int32 stride, [InAttribute, OutAttribute] T2[] pointer, Int32 ptrstride)
                where T2 : struct
            ;

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glFogCoordPointerListIBM")]
            public static extern void FogCoordPointerList<T2>(OpenTK.Graphics.OpenGL.FogPointerType type, Int32 stride, [InAttribute, OutAttribute] T2[,] pointer, Int32 ptrstride)
                where T2 : struct
            ;

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glFogCoordPointerListIBM")]
            public static extern void FogCoordPointerList<T2>(OpenTK.Graphics.OpenGL.FogPointerType type, Int32 stride, [InAttribute, OutAttribute] T2[,,] pointer, Int32 ptrstride)
                where T2 : struct
            ;

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glFogCoordPointerListIBM")]
            public static extern void FogCoordPointerList<T2>(OpenTK.Graphics.OpenGL.FogPointerType type, Int32 stride, [InAttribute, OutAttribute] ref T2 pointer, Int32 ptrstride)
                where T2 : struct
            ;

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [Obsolete("Use FogPointerType overload instead")]
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glFogCoordPointerListIBM")]
            public static extern void FogCoordPointerList(OpenTK.Graphics.OpenGL.IbmVertexArrayLists type, Int32 stride, IntPtr pointer, Int32 ptrstride);

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [Obsolete("Use FogPointerType overload instead")]
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glFogCoordPointerListIBM")]
            public static extern void FogCoordPointerList<T2>(OpenTK.Graphics.OpenGL.IbmVertexArrayLists type, Int32 stride, [InAttribute, OutAttribute] T2[] pointer, Int32 ptrstride)
                where T2 : struct
            ;

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [Obsolete("Use FogPointerType overload instead")]
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glFogCoordPointerListIBM")]
            public static extern void FogCoordPointerList<T2>(OpenTK.Graphics.OpenGL.IbmVertexArrayLists type, Int32 stride, [InAttribute, OutAttribute] T2[,] pointer, Int32 ptrstride)
                where T2 : struct
            ;

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [Obsolete("Use FogPointerType overload instead")]
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glFogCoordPointerListIBM")]
            public static extern void FogCoordPointerList<T2>(OpenTK.Graphics.OpenGL.IbmVertexArrayLists type, Int32 stride, [InAttribute, OutAttribute] T2[,,] pointer, Int32 ptrstride)
                where T2 : struct
            ;

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [Obsolete("Use FogPointerType overload instead")]
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glFogCoordPointerListIBM")]
            public static extern void FogCoordPointerList<T2>(OpenTK.Graphics.OpenGL.IbmVertexArrayLists type, Int32 stride, [InAttribute, OutAttribute] ref T2 pointer, Int32 ptrstride)
                where T2 : struct
            ;

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glIndexPointerListIBM")]
            public static extern void IndexPointerList(OpenTK.Graphics.OpenGL.IndexPointerType type, Int32 stride, IntPtr pointer, Int32 ptrstride);

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glIndexPointerListIBM")]
            public static extern void IndexPointerList<T2>(OpenTK.Graphics.OpenGL.IndexPointerType type, Int32 stride, [InAttribute, OutAttribute] T2[] pointer, Int32 ptrstride)
                where T2 : struct
            ;

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glIndexPointerListIBM")]
            public static extern void IndexPointerList<T2>(OpenTK.Graphics.OpenGL.IndexPointerType type, Int32 stride, [InAttribute, OutAttribute] T2[,] pointer, Int32 ptrstride)
                where T2 : struct
            ;

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glIndexPointerListIBM")]
            public static extern void IndexPointerList<T2>(OpenTK.Graphics.OpenGL.IndexPointerType type, Int32 stride, [InAttribute, OutAttribute] T2[,,] pointer, Int32 ptrstride)
                where T2 : struct
            ;

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glIndexPointerListIBM")]
            public static extern void IndexPointerList<T2>(OpenTK.Graphics.OpenGL.IndexPointerType type, Int32 stride, [InAttribute, OutAttribute] ref T2 pointer, Int32 ptrstride)
                where T2 : struct
            ;

            /// <summary>[requires: IBM_multimode_draw_arrays]</summary>
            [AutoGenerated(Category = "IBM_multimode_draw_arrays", Version = "", EntryPoint = "glMultiModeDrawArraysIBM")]
            public static extern void MultiModeDrawArrays(OpenTK.Graphics.OpenGL.PrimitiveType[] mode, Int32[] first, Int32[] count, Int32 primcount, Int32 modestride);

            /// <summary>[requires: IBM_multimode_draw_arrays]</summary>
            [AutoGenerated(Category = "IBM_multimode_draw_arrays", Version = "", EntryPoint = "glMultiModeDrawArraysIBM")]
            public static extern void MultiModeDrawArrays(ref OpenTK.Graphics.OpenGL.PrimitiveType mode, ref Int32 first, ref Int32 count, Int32 primcount, Int32 modestride);

            /// <summary>[requires: IBM_multimode_draw_arrays]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "IBM_multimode_draw_arrays", Version = "", EntryPoint = "glMultiModeDrawArraysIBM")]
            public static extern unsafe void MultiModeDrawArrays(OpenTK.Graphics.OpenGL.PrimitiveType* mode, Int32* first, Int32* count, Int32 primcount, Int32 modestride);

            /// <summary>[requires: IBM_multimode_draw_arrays]</summary>
            [AutoGenerated(Category = "IBM_multimode_draw_arrays", Version = "", EntryPoint = "glMultiModeDrawElementsIBM")]
            public static extern void MultiModeDrawElements(OpenTK.Graphics.OpenGL.PrimitiveType[] mode, Int32[] count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 primcount, Int32 modestride);

            /// <summary>[requires: IBM_multimode_draw_arrays]</summary>
            [AutoGenerated(Category = "IBM_multimode_draw_arrays", Version = "", EntryPoint = "glMultiModeDrawElementsIBM")]
            public static extern void MultiModeDrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType[] mode, Int32[] count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices, Int32 primcount, Int32 modestride)
                where T3 : struct
            ;

            /// <summary>[requires: IBM_multimode_draw_arrays]</summary>
            [AutoGenerated(Category = "IBM_multimode_draw_arrays", Version = "", EntryPoint = "glMultiModeDrawElementsIBM")]
            public static extern void MultiModeDrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType[] mode, Int32[] count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices, Int32 primcount, Int32 modestride)
                where T3 : struct
            ;

            /// <summary>[requires: IBM_multimode_draw_arrays]</summary>
            [AutoGenerated(Category = "IBM_multimode_draw_arrays", Version = "", EntryPoint = "glMultiModeDrawElementsIBM")]
            public static extern void MultiModeDrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType[] mode, Int32[] count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices, Int32 primcount, Int32 modestride)
                where T3 : struct
            ;

            /// <summary>[requires: IBM_multimode_draw_arrays]</summary>
            [AutoGenerated(Category = "IBM_multimode_draw_arrays", Version = "", EntryPoint = "glMultiModeDrawElementsIBM")]
            public static extern void MultiModeDrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType[] mode, Int32[] count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices, Int32 primcount, Int32 modestride)
                where T3 : struct
            ;

            /// <summary>[requires: IBM_multimode_draw_arrays]</summary>
            [AutoGenerated(Category = "IBM_multimode_draw_arrays", Version = "", EntryPoint = "glMultiModeDrawElementsIBM")]
            public static extern void MultiModeDrawElements(ref OpenTK.Graphics.OpenGL.PrimitiveType mode, ref Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 primcount, Int32 modestride);

            /// <summary>[requires: IBM_multimode_draw_arrays]</summary>
            [AutoGenerated(Category = "IBM_multimode_draw_arrays", Version = "", EntryPoint = "glMultiModeDrawElementsIBM")]
            public static extern void MultiModeDrawElements<T3>(ref OpenTK.Graphics.OpenGL.PrimitiveType mode, ref Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices, Int32 primcount, Int32 modestride)
                where T3 : struct
            ;

            /// <summary>[requires: IBM_multimode_draw_arrays]</summary>
            [AutoGenerated(Category = "IBM_multimode_draw_arrays", Version = "", EntryPoint = "glMultiModeDrawElementsIBM")]
            public static extern void MultiModeDrawElements<T3>(ref OpenTK.Graphics.OpenGL.PrimitiveType mode, ref Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices, Int32 primcount, Int32 modestride)
                where T3 : struct
            ;

            /// <summary>[requires: IBM_multimode_draw_arrays]</summary>
            [AutoGenerated(Category = "IBM_multimode_draw_arrays", Version = "", EntryPoint = "glMultiModeDrawElementsIBM")]
            public static extern void MultiModeDrawElements<T3>(ref OpenTK.Graphics.OpenGL.PrimitiveType mode, ref Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices, Int32 primcount, Int32 modestride)
                where T3 : struct
            ;

            /// <summary>[requires: IBM_multimode_draw_arrays]</summary>
            [AutoGenerated(Category = "IBM_multimode_draw_arrays", Version = "", EntryPoint = "glMultiModeDrawElementsIBM")]
            public static extern void MultiModeDrawElements<T3>(ref OpenTK.Graphics.OpenGL.PrimitiveType mode, ref Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices, Int32 primcount, Int32 modestride)
                where T3 : struct
            ;

            /// <summary>[requires: IBM_multimode_draw_arrays]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "IBM_multimode_draw_arrays", Version = "", EntryPoint = "glMultiModeDrawElementsIBM")]
            public static extern unsafe void MultiModeDrawElements(OpenTK.Graphics.OpenGL.PrimitiveType* mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 primcount, Int32 modestride);

            /// <summary>[requires: IBM_multimode_draw_arrays]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "IBM_multimode_draw_arrays", Version = "", EntryPoint = "glMultiModeDrawElementsIBM")]
            public static extern unsafe void MultiModeDrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType* mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[] indices, Int32 primcount, Int32 modestride)
                where T3 : struct
            ;

            /// <summary>[requires: IBM_multimode_draw_arrays]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "IBM_multimode_draw_arrays", Version = "", EntryPoint = "glMultiModeDrawElementsIBM")]
            public static extern unsafe void MultiModeDrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType* mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,] indices, Int32 primcount, Int32 modestride)
                where T3 : struct
            ;

            /// <summary>[requires: IBM_multimode_draw_arrays]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "IBM_multimode_draw_arrays", Version = "", EntryPoint = "glMultiModeDrawElementsIBM")]
            public static extern unsafe void MultiModeDrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType* mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] T3[,,] indices, Int32 primcount, Int32 modestride)
                where T3 : struct
            ;

            /// <summary>[requires: IBM_multimode_draw_arrays]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "IBM_multimode_draw_arrays", Version = "", EntryPoint = "glMultiModeDrawElementsIBM")]
            public static extern unsafe void MultiModeDrawElements<T3>(OpenTK.Graphics.OpenGL.PrimitiveType* mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, [InAttribute, OutAttribute] ref T3 indices, Int32 primcount, Int32 modestride)
                where T3 : struct
            ;

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glNormalPointerListIBM")]
            public static extern void NormalPointerList(OpenTK.Graphics.OpenGL.NormalPointerType type, Int32 stride, IntPtr pointer, Int32 ptrstride);

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glNormalPointerListIBM")]
            public static extern void NormalPointerList<T2>(OpenTK.Graphics.OpenGL.NormalPointerType type, Int32 stride, [InAttribute, OutAttribute] T2[] pointer, Int32 ptrstride)
                where T2 : struct
            ;

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glNormalPointerListIBM")]
            public static extern void NormalPointerList<T2>(OpenTK.Graphics.OpenGL.NormalPointerType type, Int32 stride, [InAttribute, OutAttribute] T2[,] pointer, Int32 ptrstride)
                where T2 : struct
            ;

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glNormalPointerListIBM")]
            public static extern void NormalPointerList<T2>(OpenTK.Graphics.OpenGL.NormalPointerType type, Int32 stride, [InAttribute, OutAttribute] T2[,,] pointer, Int32 ptrstride)
                where T2 : struct
            ;

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glNormalPointerListIBM")]
            public static extern void NormalPointerList<T2>(OpenTK.Graphics.OpenGL.NormalPointerType type, Int32 stride, [InAttribute, OutAttribute] ref T2 pointer, Int32 ptrstride)
                where T2 : struct
            ;

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glSecondaryColorPointerListIBM")]
            public static extern void SecondaryColorPointerList(Int32 size, OpenTK.Graphics.OpenGL.IbmVertexArrayLists type, Int32 stride, IntPtr pointer, Int32 ptrstride);

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glSecondaryColorPointerListIBM")]
            public static extern void SecondaryColorPointerList<T3>(Int32 size, OpenTK.Graphics.OpenGL.IbmVertexArrayLists type, Int32 stride, [InAttribute, OutAttribute] T3[] pointer, Int32 ptrstride)
                where T3 : struct
            ;

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glSecondaryColorPointerListIBM")]
            public static extern void SecondaryColorPointerList<T3>(Int32 size, OpenTK.Graphics.OpenGL.IbmVertexArrayLists type, Int32 stride, [InAttribute, OutAttribute] T3[,] pointer, Int32 ptrstride)
                where T3 : struct
            ;

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glSecondaryColorPointerListIBM")]
            public static extern void SecondaryColorPointerList<T3>(Int32 size, OpenTK.Graphics.OpenGL.IbmVertexArrayLists type, Int32 stride, [InAttribute, OutAttribute] T3[,,] pointer, Int32 ptrstride)
                where T3 : struct
            ;

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glSecondaryColorPointerListIBM")]
            public static extern void SecondaryColorPointerList<T3>(Int32 size, OpenTK.Graphics.OpenGL.IbmVertexArrayLists type, Int32 stride, [InAttribute, OutAttribute] ref T3 pointer, Int32 ptrstride)
                where T3 : struct
            ;

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glTexCoordPointerListIBM")]
            public static extern void TexCoordPointerList(Int32 size, OpenTK.Graphics.OpenGL.TexCoordPointerType type, Int32 stride, IntPtr pointer, Int32 ptrstride);

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glTexCoordPointerListIBM")]
            public static extern void TexCoordPointerList<T3>(Int32 size, OpenTK.Graphics.OpenGL.TexCoordPointerType type, Int32 stride, [InAttribute, OutAttribute] T3[] pointer, Int32 ptrstride)
                where T3 : struct
            ;

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glTexCoordPointerListIBM")]
            public static extern void TexCoordPointerList<T3>(Int32 size, OpenTK.Graphics.OpenGL.TexCoordPointerType type, Int32 stride, [InAttribute, OutAttribute] T3[,] pointer, Int32 ptrstride)
                where T3 : struct
            ;

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glTexCoordPointerListIBM")]
            public static extern void TexCoordPointerList<T3>(Int32 size, OpenTK.Graphics.OpenGL.TexCoordPointerType type, Int32 stride, [InAttribute, OutAttribute] T3[,,] pointer, Int32 ptrstride)
                where T3 : struct
            ;

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glTexCoordPointerListIBM")]
            public static extern void TexCoordPointerList<T3>(Int32 size, OpenTK.Graphics.OpenGL.TexCoordPointerType type, Int32 stride, [InAttribute, OutAttribute] ref T3 pointer, Int32 ptrstride)
                where T3 : struct
            ;

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glVertexPointerListIBM")]
            public static extern void VertexPointerList(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, Int32 stride, IntPtr pointer, Int32 ptrstride);

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glVertexPointerListIBM")]
            public static extern void VertexPointerList<T3>(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, Int32 stride, [InAttribute, OutAttribute] T3[] pointer, Int32 ptrstride)
                where T3 : struct
            ;

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glVertexPointerListIBM")]
            public static extern void VertexPointerList<T3>(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, Int32 stride, [InAttribute, OutAttribute] T3[,] pointer, Int32 ptrstride)
                where T3 : struct
            ;

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glVertexPointerListIBM")]
            public static extern void VertexPointerList<T3>(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, Int32 stride, [InAttribute, OutAttribute] T3[,,] pointer, Int32 ptrstride)
                where T3 : struct
            ;

            /// <summary>[requires: IBM_vertex_array_lists]</summary>
            [AutoGenerated(Category = "IBM_vertex_array_lists", Version = "", EntryPoint = "glVertexPointerListIBM")]
            public static extern void VertexPointerList<T3>(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, Int32 stride, [InAttribute, OutAttribute] ref T3 pointer, Int32 ptrstride)
                where T3 : struct
            ;

        }

        public static partial class Ingr
        {
            /// <summary>[requires: INGR_blend_func_separate]
            /// Specify pixel arithmetic for RGB and alpha components separately
            /// </summary>
            /// <param name="buf">
            /// <para>
            /// For glBlendFuncSeparatei, specifies the index of the draw buffer for which to set the blend functions.
            /// </para>
            /// </param>
            /// <param name="srcRGB">
            /// <para>
            /// Specifies how the red, green, and blue blending factors are computed. The initial value is GL_ONE.
            /// </para>
            /// </param>
            /// <param name="dstRGB">
            /// <para>
            /// Specifies how the red, green, and blue destination blending factors are computed. The initial value is GL_ZERO.
            /// </para>
            /// </param>
            /// <param name="srcAlpha">
            /// <para>
            /// Specified how the alpha source blending factor is computed. The initial value is GL_ONE.
            /// </para>
            /// </param>
            /// <param name="dstAlpha">
            /// <para>
            /// Specified how the alpha destination blending factor is computed. The initial value is GL_ZERO.
            /// </para>
            /// </param>
            [Obsolete("Use IngrBlendFuncSeparate overload instead")]
            [AutoGenerated(Category = "INGR_blend_func_separate", Version = "", EntryPoint = "glBlendFuncSeparateINGR")]
            public static extern void BlendFuncSeparate(OpenTK.Graphics.OpenGL.All sfactorRGB, OpenTK.Graphics.OpenGL.All dfactorRGB, OpenTK.Graphics.OpenGL.All sfactorAlpha, OpenTK.Graphics.OpenGL.All dfactorAlpha);

            /// <summary>[requires: INGR_blend_func_separate]
            /// Specify pixel arithmetic for RGB and alpha components separately
            /// </summary>
            /// <param name="buf">
            /// <para>
            /// For glBlendFuncSeparatei, specifies the index of the draw buffer for which to set the blend functions.
            /// </para>
            /// </param>
            /// <param name="srcRGB">
            /// <para>
            /// Specifies how the red, green, and blue blending factors are computed. The initial value is GL_ONE.
            /// </para>
            /// </param>
            /// <param name="dstRGB">
            /// <para>
            /// Specifies how the red, green, and blue destination blending factors are computed. The initial value is GL_ZERO.
            /// </para>
            /// </param>
            /// <param name="srcAlpha">
            /// <para>
            /// Specified how the alpha source blending factor is computed. The initial value is GL_ONE.
            /// </para>
            /// </param>
            /// <param name="dstAlpha">
            /// <para>
            /// Specified how the alpha destination blending factor is computed. The initial value is GL_ZERO.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "INGR_blend_func_separate", Version = "", EntryPoint = "glBlendFuncSeparateINGR")]
            public static extern void BlendFuncSeparate(OpenTK.Graphics.OpenGL.IngrBlendFuncSeparate sfactorRGB, OpenTK.Graphics.OpenGL.IngrBlendFuncSeparate dfactorRGB, OpenTK.Graphics.OpenGL.IngrBlendFuncSeparate sfactorAlpha, OpenTK.Graphics.OpenGL.IngrBlendFuncSeparate dfactorAlpha);

        }

        public static partial class Intel
        {
            /// <summary>[requires: INTEL_parallel_arrays]
            /// Define an array of colors
            /// </summary>
            /// <param name="size">
            /// <para>
            /// Specifies the number of components per color. Must be 3 or 4. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each color component in the array. Symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, GL_UNSIGNED_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive colors. If stride is 0, the colors are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first component of the first color element in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "INTEL_parallel_arrays", Version = "", EntryPoint = "glColorPointervINTEL")]
            public static extern void ColorPointer(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, IntPtr pointer);

            /// <summary>[requires: INTEL_parallel_arrays]
            /// Define an array of colors
            /// </summary>
            /// <param name="size">
            /// <para>
            /// Specifies the number of components per color. Must be 3 or 4. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each color component in the array. Symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, GL_UNSIGNED_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive colors. If stride is 0, the colors are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first component of the first color element in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "INTEL_parallel_arrays", Version = "", EntryPoint = "glColorPointervINTEL")]
            public static extern void ColorPointer<T2>(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, [InAttribute, OutAttribute] T2[] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: INTEL_parallel_arrays]
            /// Define an array of colors
            /// </summary>
            /// <param name="size">
            /// <para>
            /// Specifies the number of components per color. Must be 3 or 4. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each color component in the array. Symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, GL_UNSIGNED_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive colors. If stride is 0, the colors are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first component of the first color element in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "INTEL_parallel_arrays", Version = "", EntryPoint = "glColorPointervINTEL")]
            public static extern void ColorPointer<T2>(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, [InAttribute, OutAttribute] T2[,] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: INTEL_parallel_arrays]
            /// Define an array of colors
            /// </summary>
            /// <param name="size">
            /// <para>
            /// Specifies the number of components per color. Must be 3 or 4. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each color component in the array. Symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, GL_UNSIGNED_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive colors. If stride is 0, the colors are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first component of the first color element in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "INTEL_parallel_arrays", Version = "", EntryPoint = "glColorPointervINTEL")]
            public static extern void ColorPointer<T2>(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, [InAttribute, OutAttribute] T2[,,] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: INTEL_parallel_arrays]
            /// Define an array of colors
            /// </summary>
            /// <param name="size">
            /// <para>
            /// Specifies the number of components per color. Must be 3 or 4. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each color component in the array. Symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, GL_UNSIGNED_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive colors. If stride is 0, the colors are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first component of the first color element in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "INTEL_parallel_arrays", Version = "", EntryPoint = "glColorPointervINTEL")]
            public static extern void ColorPointer<T2>(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, [InAttribute, OutAttribute] ref T2 pointer)
                where T2 : struct
            ;

            /// <summary>[requires: INTEL_map_texture]</summary>
            [AutoGenerated(Category = "INTEL_map_texture", Version = "", EntryPoint = "glMapTexture2DINTEL")]
            public static extern IntPtr MapTexture2D(Int32 texture, Int32 level, Int32 access, [OutAttribute] out Int32 stride, [OutAttribute] out OpenTK.Graphics.OpenGL.IntelMapTexture layout);

            /// <summary>[requires: INTEL_map_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "INTEL_map_texture", Version = "", EntryPoint = "glMapTexture2DINTEL")]
            public static extern unsafe IntPtr MapTexture2D(Int32 texture, Int32 level, Int32 access, [OutAttribute] Int32* stride, [OutAttribute] OpenTK.Graphics.OpenGL.IntelMapTexture* layout);

            /// <summary>[requires: INTEL_map_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "INTEL_map_texture", Version = "", EntryPoint = "glMapTexture2DINTEL")]
            public static extern IntPtr MapTexture2D(UInt32 texture, Int32 level, UInt32 access, [OutAttribute] out Int32 stride, [OutAttribute] out OpenTK.Graphics.OpenGL.IntelMapTexture layout);

            /// <summary>[requires: INTEL_map_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "INTEL_map_texture", Version = "", EntryPoint = "glMapTexture2DINTEL")]
            public static extern unsafe IntPtr MapTexture2D(UInt32 texture, Int32 level, UInt32 access, [OutAttribute] Int32* stride, [OutAttribute] OpenTK.Graphics.OpenGL.IntelMapTexture* layout);

            /// <summary>[requires: INTEL_parallel_arrays]
            /// Define an array of normals
            /// </summary>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each coordinate in the array. Symbolic constants GL_BYTE, GL_SHORT, GL_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive normals. If stride is 0, the normals are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first coordinate of the first normal in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "INTEL_parallel_arrays", Version = "", EntryPoint = "glNormalPointervINTEL")]
            public static extern void NormalPointer(OpenTK.Graphics.OpenGL.NormalPointerType type, IntPtr pointer);

            /// <summary>[requires: INTEL_parallel_arrays]
            /// Define an array of normals
            /// </summary>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each coordinate in the array. Symbolic constants GL_BYTE, GL_SHORT, GL_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive normals. If stride is 0, the normals are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first coordinate of the first normal in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "INTEL_parallel_arrays", Version = "", EntryPoint = "glNormalPointervINTEL")]
            public static extern void NormalPointer<T1>(OpenTK.Graphics.OpenGL.NormalPointerType type, [InAttribute, OutAttribute] T1[] pointer)
                where T1 : struct
            ;

            /// <summary>[requires: INTEL_parallel_arrays]
            /// Define an array of normals
            /// </summary>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each coordinate in the array. Symbolic constants GL_BYTE, GL_SHORT, GL_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive normals. If stride is 0, the normals are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first coordinate of the first normal in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "INTEL_parallel_arrays", Version = "", EntryPoint = "glNormalPointervINTEL")]
            public static extern void NormalPointer<T1>(OpenTK.Graphics.OpenGL.NormalPointerType type, [InAttribute, OutAttribute] T1[,] pointer)
                where T1 : struct
            ;

            /// <summary>[requires: INTEL_parallel_arrays]
            /// Define an array of normals
            /// </summary>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each coordinate in the array. Symbolic constants GL_BYTE, GL_SHORT, GL_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive normals. If stride is 0, the normals are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first coordinate of the first normal in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "INTEL_parallel_arrays", Version = "", EntryPoint = "glNormalPointervINTEL")]
            public static extern void NormalPointer<T1>(OpenTK.Graphics.OpenGL.NormalPointerType type, [InAttribute, OutAttribute] T1[,,] pointer)
                where T1 : struct
            ;

            /// <summary>[requires: INTEL_parallel_arrays]
            /// Define an array of normals
            /// </summary>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each coordinate in the array. Symbolic constants GL_BYTE, GL_SHORT, GL_INT, GL_FLOAT, and GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive normals. If stride is 0, the normals are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first coordinate of the first normal in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "INTEL_parallel_arrays", Version = "", EntryPoint = "glNormalPointervINTEL")]
            public static extern void NormalPointer<T1>(OpenTK.Graphics.OpenGL.NormalPointerType type, [InAttribute, OutAttribute] ref T1 pointer)
                where T1 : struct
            ;

            /// <summary>[requires: INTEL_map_texture]</summary>
            [AutoGenerated(Category = "INTEL_map_texture", Version = "", EntryPoint = "glSyncTextureINTEL")]
            public static extern void SyncTexture(Int32 texture);

            /// <summary>[requires: INTEL_map_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "INTEL_map_texture", Version = "", EntryPoint = "glSyncTextureINTEL")]
            public static extern void SyncTexture(UInt32 texture);

            /// <summary>[requires: INTEL_parallel_arrays]
            /// Define an array of texture coordinates
            /// </summary>
            /// <param name="size">
            /// <para>
            /// Specifies the number of coordinates per array element. Must be 1, 2, 3, or 4. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each texture coordinate. Symbolic constants GL_SHORT, GL_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive texture coordinate sets. If stride is 0, the array elements are understood to be tightly packed. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first coordinate of the first texture coordinate set in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "INTEL_parallel_arrays", Version = "", EntryPoint = "glTexCoordPointervINTEL")]
            public static extern void TexCoordPointer(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, IntPtr pointer);

            /// <summary>[requires: INTEL_parallel_arrays]
            /// Define an array of texture coordinates
            /// </summary>
            /// <param name="size">
            /// <para>
            /// Specifies the number of coordinates per array element. Must be 1, 2, 3, or 4. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each texture coordinate. Symbolic constants GL_SHORT, GL_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive texture coordinate sets. If stride is 0, the array elements are understood to be tightly packed. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first coordinate of the first texture coordinate set in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "INTEL_parallel_arrays", Version = "", EntryPoint = "glTexCoordPointervINTEL")]
            public static extern void TexCoordPointer<T2>(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, [InAttribute, OutAttribute] T2[] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: INTEL_parallel_arrays]
            /// Define an array of texture coordinates
            /// </summary>
            /// <param name="size">
            /// <para>
            /// Specifies the number of coordinates per array element. Must be 1, 2, 3, or 4. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each texture coordinate. Symbolic constants GL_SHORT, GL_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive texture coordinate sets. If stride is 0, the array elements are understood to be tightly packed. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first coordinate of the first texture coordinate set in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "INTEL_parallel_arrays", Version = "", EntryPoint = "glTexCoordPointervINTEL")]
            public static extern void TexCoordPointer<T2>(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, [InAttribute, OutAttribute] T2[,] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: INTEL_parallel_arrays]
            /// Define an array of texture coordinates
            /// </summary>
            /// <param name="size">
            /// <para>
            /// Specifies the number of coordinates per array element. Must be 1, 2, 3, or 4. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each texture coordinate. Symbolic constants GL_SHORT, GL_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive texture coordinate sets. If stride is 0, the array elements are understood to be tightly packed. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first coordinate of the first texture coordinate set in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "INTEL_parallel_arrays", Version = "", EntryPoint = "glTexCoordPointervINTEL")]
            public static extern void TexCoordPointer<T2>(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, [InAttribute, OutAttribute] T2[,,] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: INTEL_parallel_arrays]
            /// Define an array of texture coordinates
            /// </summary>
            /// <param name="size">
            /// <para>
            /// Specifies the number of coordinates per array element. Must be 1, 2, 3, or 4. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each texture coordinate. Symbolic constants GL_SHORT, GL_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive texture coordinate sets. If stride is 0, the array elements are understood to be tightly packed. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first coordinate of the first texture coordinate set in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "INTEL_parallel_arrays", Version = "", EntryPoint = "glTexCoordPointervINTEL")]
            public static extern void TexCoordPointer<T2>(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, [InAttribute, OutAttribute] ref T2 pointer)
                where T2 : struct
            ;

            /// <summary>[requires: INTEL_map_texture]</summary>
            [AutoGenerated(Category = "INTEL_map_texture", Version = "", EntryPoint = "glUnmapTexture2DINTEL")]
            public static extern void UnmapTexture2D(Int32 texture, Int32 level);

            /// <summary>[requires: INTEL_map_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "INTEL_map_texture", Version = "", EntryPoint = "glUnmapTexture2DINTEL")]
            public static extern void UnmapTexture2D(UInt32 texture, Int32 level);

            /// <summary>[requires: INTEL_parallel_arrays]
            /// Define an array of vertex data
            /// </summary>
            /// <param name="size">
            /// <para>
            /// Specifies the number of coordinates per vertex. Must be 2, 3, or 4. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each coordinate in the array. Symbolic constants GL_SHORT, GL_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive vertices. If stride is 0, the vertices are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first coordinate of the first vertex in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "INTEL_parallel_arrays", Version = "", EntryPoint = "glVertexPointervINTEL")]
            public static extern void VertexPointer(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, IntPtr pointer);

            /// <summary>[requires: INTEL_parallel_arrays]
            /// Define an array of vertex data
            /// </summary>
            /// <param name="size">
            /// <para>
            /// Specifies the number of coordinates per vertex. Must be 2, 3, or 4. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each coordinate in the array. Symbolic constants GL_SHORT, GL_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive vertices. If stride is 0, the vertices are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first coordinate of the first vertex in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "INTEL_parallel_arrays", Version = "", EntryPoint = "glVertexPointervINTEL")]
            public static extern void VertexPointer<T2>(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, [InAttribute, OutAttribute] T2[] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: INTEL_parallel_arrays]
            /// Define an array of vertex data
            /// </summary>
            /// <param name="size">
            /// <para>
            /// Specifies the number of coordinates per vertex. Must be 2, 3, or 4. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each coordinate in the array. Symbolic constants GL_SHORT, GL_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive vertices. If stride is 0, the vertices are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first coordinate of the first vertex in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "INTEL_parallel_arrays", Version = "", EntryPoint = "glVertexPointervINTEL")]
            public static extern void VertexPointer<T2>(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, [InAttribute, OutAttribute] T2[,] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: INTEL_parallel_arrays]
            /// Define an array of vertex data
            /// </summary>
            /// <param name="size">
            /// <para>
            /// Specifies the number of coordinates per vertex. Must be 2, 3, or 4. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each coordinate in the array. Symbolic constants GL_SHORT, GL_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive vertices. If stride is 0, the vertices are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first coordinate of the first vertex in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "INTEL_parallel_arrays", Version = "", EntryPoint = "glVertexPointervINTEL")]
            public static extern void VertexPointer<T2>(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, [InAttribute, OutAttribute] T2[,,] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: INTEL_parallel_arrays]
            /// Define an array of vertex data
            /// </summary>
            /// <param name="size">
            /// <para>
            /// Specifies the number of coordinates per vertex. Must be 2, 3, or 4. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each coordinate in the array. Symbolic constants GL_SHORT, GL_INT, GL_FLOAT, or GL_DOUBLE are accepted. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive vertices. If stride is 0, the vertices are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a pointer to the first coordinate of the first vertex in the array. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "INTEL_parallel_arrays", Version = "", EntryPoint = "glVertexPointervINTEL")]
            public static extern void VertexPointer<T2>(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, [InAttribute, OutAttribute] ref T2 pointer)
                where T2 : struct
            ;

        }

        public static partial class Khr
        {
            /// <summary>[requires: KHR_debug]
            /// Specify a callback to receive debugging messages from the GL
            /// </summary>
            /// <param name="callback">
            /// <para>
            /// The address of a callback function that will be called when a debug message is generated.
            /// </para>
            /// </param>
            /// <param name="userParam">
            /// <para>
            /// A user supplied pointer that will be passed on each invocation of callback.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glDebugMessageCallbackKHR")]
            public static extern void DebugMessageCallback(DebugProcKhr callback, IntPtr userParam);

            /// <summary>[requires: KHR_debug]
            /// Specify a callback to receive debugging messages from the GL
            /// </summary>
            /// <param name="callback">
            /// <para>
            /// The address of a callback function that will be called when a debug message is generated.
            /// </para>
            /// </param>
            /// <param name="userParam">
            /// <para>
            /// A user supplied pointer that will be passed on each invocation of callback.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glDebugMessageCallbackKHR")]
            public static extern void DebugMessageCallback<T1>(DebugProcKhr callback, [InAttribute, OutAttribute] T1[] userParam)
                where T1 : struct
            ;

            /// <summary>[requires: KHR_debug]
            /// Specify a callback to receive debugging messages from the GL
            /// </summary>
            /// <param name="callback">
            /// <para>
            /// The address of a callback function that will be called when a debug message is generated.
            /// </para>
            /// </param>
            /// <param name="userParam">
            /// <para>
            /// A user supplied pointer that will be passed on each invocation of callback.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glDebugMessageCallbackKHR")]
            public static extern void DebugMessageCallback<T1>(DebugProcKhr callback, [InAttribute, OutAttribute] T1[,] userParam)
                where T1 : struct
            ;

            /// <summary>[requires: KHR_debug]
            /// Specify a callback to receive debugging messages from the GL
            /// </summary>
            /// <param name="callback">
            /// <para>
            /// The address of a callback function that will be called when a debug message is generated.
            /// </para>
            /// </param>
            /// <param name="userParam">
            /// <para>
            /// A user supplied pointer that will be passed on each invocation of callback.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glDebugMessageCallbackKHR")]
            public static extern void DebugMessageCallback<T1>(DebugProcKhr callback, [InAttribute, OutAttribute] T1[,,] userParam)
                where T1 : struct
            ;

            /// <summary>[requires: KHR_debug]
            /// Specify a callback to receive debugging messages from the GL
            /// </summary>
            /// <param name="callback">
            /// <para>
            /// The address of a callback function that will be called when a debug message is generated.
            /// </para>
            /// </param>
            /// <param name="userParam">
            /// <para>
            /// A user supplied pointer that will be passed on each invocation of callback.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glDebugMessageCallbackKHR")]
            public static extern void DebugMessageCallback<T1>(DebugProcKhr callback, [InAttribute, OutAttribute] ref T1 userParam)
                where T1 : struct
            ;

            /// <summary>[requires: KHR_debug]
            /// Control the reporting of debug messages in a debug context
            /// </summary>
            /// <param name="source">
            /// <para>
            /// The source of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="severity">
            /// <para>
            /// The severity of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// The length of the array ids.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// The address of an array of unsigned integers contianing the ids of the messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="enabled">
            /// <para>
            /// A Boolean flag determining whether the selected messages should be enabled or disabled.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glDebugMessageControlKHR")]
            public static extern void DebugMessageControl(OpenTK.Graphics.OpenGL.KhrDebug source, OpenTK.Graphics.OpenGL.KhrDebug type, OpenTK.Graphics.OpenGL.KhrDebug severity, Int32 count, Int32[] ids, bool enabled);

            /// <summary>[requires: KHR_debug]
            /// Control the reporting of debug messages in a debug context
            /// </summary>
            /// <param name="source">
            /// <para>
            /// The source of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="severity">
            /// <para>
            /// The severity of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// The length of the array ids.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// The address of an array of unsigned integers contianing the ids of the messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="enabled">
            /// <para>
            /// A Boolean flag determining whether the selected messages should be enabled or disabled.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glDebugMessageControlKHR")]
            public static extern void DebugMessageControl(OpenTK.Graphics.OpenGL.KhrDebug source, OpenTK.Graphics.OpenGL.KhrDebug type, OpenTK.Graphics.OpenGL.KhrDebug severity, Int32 count, ref Int32 ids, bool enabled);

            /// <summary>[requires: KHR_debug]
            /// Control the reporting of debug messages in a debug context
            /// </summary>
            /// <param name="source">
            /// <para>
            /// The source of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="severity">
            /// <para>
            /// The severity of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// The length of the array ids.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// The address of an array of unsigned integers contianing the ids of the messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="enabled">
            /// <para>
            /// A Boolean flag determining whether the selected messages should be enabled or disabled.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glDebugMessageControlKHR")]
            public static extern unsafe void DebugMessageControl(OpenTK.Graphics.OpenGL.KhrDebug source, OpenTK.Graphics.OpenGL.KhrDebug type, OpenTK.Graphics.OpenGL.KhrDebug severity, Int32 count, Int32* ids, bool enabled);

            /// <summary>[requires: KHR_debug]
            /// Control the reporting of debug messages in a debug context
            /// </summary>
            /// <param name="source">
            /// <para>
            /// The source of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="severity">
            /// <para>
            /// The severity of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// The length of the array ids.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// The address of an array of unsigned integers contianing the ids of the messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="enabled">
            /// <para>
            /// A Boolean flag determining whether the selected messages should be enabled or disabled.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glDebugMessageControlKHR")]
            public static extern void DebugMessageControl(OpenTK.Graphics.OpenGL.KhrDebug source, OpenTK.Graphics.OpenGL.KhrDebug type, OpenTK.Graphics.OpenGL.KhrDebug severity, Int32 count, UInt32[] ids, bool enabled);

            /// <summary>[requires: KHR_debug]
            /// Control the reporting of debug messages in a debug context
            /// </summary>
            /// <param name="source">
            /// <para>
            /// The source of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="severity">
            /// <para>
            /// The severity of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// The length of the array ids.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// The address of an array of unsigned integers contianing the ids of the messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="enabled">
            /// <para>
            /// A Boolean flag determining whether the selected messages should be enabled or disabled.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glDebugMessageControlKHR")]
            public static extern void DebugMessageControl(OpenTK.Graphics.OpenGL.KhrDebug source, OpenTK.Graphics.OpenGL.KhrDebug type, OpenTK.Graphics.OpenGL.KhrDebug severity, Int32 count, ref UInt32 ids, bool enabled);

            /// <summary>[requires: KHR_debug]
            /// Control the reporting of debug messages in a debug context
            /// </summary>
            /// <param name="source">
            /// <para>
            /// The source of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="severity">
            /// <para>
            /// The severity of debug messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// The length of the array ids.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// The address of an array of unsigned integers contianing the ids of the messages to enable or disable.
            /// </para>
            /// </param>
            /// <param name="enabled">
            /// <para>
            /// A Boolean flag determining whether the selected messages should be enabled or disabled.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glDebugMessageControlKHR")]
            public static extern unsafe void DebugMessageControl(OpenTK.Graphics.OpenGL.KhrDebug source, OpenTK.Graphics.OpenGL.KhrDebug type, OpenTK.Graphics.OpenGL.KhrDebug severity, Int32 count, UInt32* ids, bool enabled);

            /// <summary>[requires: KHR_debug]
            /// Inject an application-supplied message into the debug message queue
            /// </summary>
            /// <param name="source">
            /// <para>
            /// The source of the debug message to insert.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the debug message insert.
            /// </para>
            /// </param>
            /// <param name="id">
            /// <para>
            /// The user-supplied identifier of the message to insert.
            /// </para>
            /// </param>
            /// <param name="severity">
            /// <para>
            /// The severity of the debug messages to insert.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The length string contained in the character array whose address is given by message.
            /// </para>
            /// </param>
            /// <param name="message">
            /// <para>
            /// The address of a character array containing the message to insert.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glDebugMessageInsertKHR")]
            public static extern void DebugMessageInsert(OpenTK.Graphics.OpenGL.KhrDebug source, OpenTK.Graphics.OpenGL.KhrDebug type, Int32 id, OpenTK.Graphics.OpenGL.KhrDebug severity, Int32 length, String buf);

            /// <summary>[requires: KHR_debug]
            /// Inject an application-supplied message into the debug message queue
            /// </summary>
            /// <param name="source">
            /// <para>
            /// The source of the debug message to insert.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the debug message insert.
            /// </para>
            /// </param>
            /// <param name="id">
            /// <para>
            /// The user-supplied identifier of the message to insert.
            /// </para>
            /// </param>
            /// <param name="severity">
            /// <para>
            /// The severity of the debug messages to insert.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The length string contained in the character array whose address is given by message.
            /// </para>
            /// </param>
            /// <param name="message">
            /// <para>
            /// The address of a character array containing the message to insert.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glDebugMessageInsertKHR")]
            public static extern void DebugMessageInsert(OpenTK.Graphics.OpenGL.KhrDebug source, OpenTK.Graphics.OpenGL.KhrDebug type, UInt32 id, OpenTK.Graphics.OpenGL.KhrDebug severity, Int32 length, String buf);

            /// <summary>[requires: KHR_debug]
            /// Retrieve messages from the debug message log
            /// </summary>
            /// <param name="count">
            /// <para>
            /// The number of debug messages to retrieve from the log.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The size of the buffer whose address is given by messageLog.
            /// </para>
            /// </param>
            /// <param name="sources">
            /// <para>
            /// The address of an array of variables to receive the sources of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="types">
            /// <para>
            /// The address of an array of variables to receive the types of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// The address of an array of unsigned integers to receive the ids of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="severities">
            /// <para>
            /// The address of an array of variables to receive the severites of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="lengths">
            /// <para>
            /// The address of an array of variables to receive the lengths of the received messages.
            /// </para>
            /// </param>
            /// <param name="messageLog">
            /// <para>
            /// The address of an array of characters that will receive the messages.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glGetDebugMessageLogKHR")]
            public static extern Int32 GetDebugMessageLog(Int32 count, Int32 bufSize, [OutAttribute] OpenTK.Graphics.OpenGL.KhrDebug[] sources, [OutAttribute] OpenTK.Graphics.OpenGL.KhrDebug[] types, [OutAttribute] Int32[] ids, [OutAttribute] OpenTK.Graphics.OpenGL.KhrDebug[] severities, [OutAttribute] Int32[] lengths, [OutAttribute] StringBuilder messageLog);

            /// <summary>[requires: KHR_debug]
            /// Retrieve messages from the debug message log
            /// </summary>
            /// <param name="count">
            /// <para>
            /// The number of debug messages to retrieve from the log.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The size of the buffer whose address is given by messageLog.
            /// </para>
            /// </param>
            /// <param name="sources">
            /// <para>
            /// The address of an array of variables to receive the sources of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="types">
            /// <para>
            /// The address of an array of variables to receive the types of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// The address of an array of unsigned integers to receive the ids of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="severities">
            /// <para>
            /// The address of an array of variables to receive the severites of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="lengths">
            /// <para>
            /// The address of an array of variables to receive the lengths of the received messages.
            /// </para>
            /// </param>
            /// <param name="messageLog">
            /// <para>
            /// The address of an array of characters that will receive the messages.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glGetDebugMessageLogKHR")]
            public static extern Int32 GetDebugMessageLog(Int32 count, Int32 bufSize, [OutAttribute] out OpenTK.Graphics.OpenGL.KhrDebug sources, [OutAttribute] out OpenTK.Graphics.OpenGL.KhrDebug types, [OutAttribute] out Int32 ids, [OutAttribute] out OpenTK.Graphics.OpenGL.KhrDebug severities, [OutAttribute] out Int32 lengths, [OutAttribute] StringBuilder messageLog);

            /// <summary>[requires: KHR_debug]
            /// Retrieve messages from the debug message log
            /// </summary>
            /// <param name="count">
            /// <para>
            /// The number of debug messages to retrieve from the log.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The size of the buffer whose address is given by messageLog.
            /// </para>
            /// </param>
            /// <param name="sources">
            /// <para>
            /// The address of an array of variables to receive the sources of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="types">
            /// <para>
            /// The address of an array of variables to receive the types of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// The address of an array of unsigned integers to receive the ids of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="severities">
            /// <para>
            /// The address of an array of variables to receive the severites of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="lengths">
            /// <para>
            /// The address of an array of variables to receive the lengths of the received messages.
            /// </para>
            /// </param>
            /// <param name="messageLog">
            /// <para>
            /// The address of an array of characters that will receive the messages.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glGetDebugMessageLogKHR")]
            public static extern unsafe Int32 GetDebugMessageLog(Int32 count, Int32 bufSize, [OutAttribute] OpenTK.Graphics.OpenGL.KhrDebug* sources, [OutAttribute] OpenTK.Graphics.OpenGL.KhrDebug* types, [OutAttribute] Int32* ids, [OutAttribute] OpenTK.Graphics.OpenGL.KhrDebug* severities, [OutAttribute] Int32* lengths, [OutAttribute] StringBuilder messageLog);

            /// <summary>[requires: KHR_debug]
            /// Retrieve messages from the debug message log
            /// </summary>
            /// <param name="count">
            /// <para>
            /// The number of debug messages to retrieve from the log.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The size of the buffer whose address is given by messageLog.
            /// </para>
            /// </param>
            /// <param name="sources">
            /// <para>
            /// The address of an array of variables to receive the sources of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="types">
            /// <para>
            /// The address of an array of variables to receive the types of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// The address of an array of unsigned integers to receive the ids of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="severities">
            /// <para>
            /// The address of an array of variables to receive the severites of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="lengths">
            /// <para>
            /// The address of an array of variables to receive the lengths of the received messages.
            /// </para>
            /// </param>
            /// <param name="messageLog">
            /// <para>
            /// The address of an array of characters that will receive the messages.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glGetDebugMessageLogKHR")]
            public static extern Int32 GetDebugMessageLog(UInt32 count, Int32 bufSize, [OutAttribute] OpenTK.Graphics.OpenGL.KhrDebug[] sources, [OutAttribute] OpenTK.Graphics.OpenGL.KhrDebug[] types, [OutAttribute] UInt32[] ids, [OutAttribute] OpenTK.Graphics.OpenGL.KhrDebug[] severities, [OutAttribute] Int32[] lengths, [OutAttribute] StringBuilder messageLog);

            /// <summary>[requires: KHR_debug]
            /// Retrieve messages from the debug message log
            /// </summary>
            /// <param name="count">
            /// <para>
            /// The number of debug messages to retrieve from the log.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The size of the buffer whose address is given by messageLog.
            /// </para>
            /// </param>
            /// <param name="sources">
            /// <para>
            /// The address of an array of variables to receive the sources of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="types">
            /// <para>
            /// The address of an array of variables to receive the types of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// The address of an array of unsigned integers to receive the ids of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="severities">
            /// <para>
            /// The address of an array of variables to receive the severites of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="lengths">
            /// <para>
            /// The address of an array of variables to receive the lengths of the received messages.
            /// </para>
            /// </param>
            /// <param name="messageLog">
            /// <para>
            /// The address of an array of characters that will receive the messages.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glGetDebugMessageLogKHR")]
            public static extern Int32 GetDebugMessageLog(UInt32 count, Int32 bufSize, [OutAttribute] out OpenTK.Graphics.OpenGL.KhrDebug sources, [OutAttribute] out OpenTK.Graphics.OpenGL.KhrDebug types, [OutAttribute] out UInt32 ids, [OutAttribute] out OpenTK.Graphics.OpenGL.KhrDebug severities, [OutAttribute] out Int32 lengths, [OutAttribute] StringBuilder messageLog);

            /// <summary>[requires: KHR_debug]
            /// Retrieve messages from the debug message log
            /// </summary>
            /// <param name="count">
            /// <para>
            /// The number of debug messages to retrieve from the log.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The size of the buffer whose address is given by messageLog.
            /// </para>
            /// </param>
            /// <param name="sources">
            /// <para>
            /// The address of an array of variables to receive the sources of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="types">
            /// <para>
            /// The address of an array of variables to receive the types of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// The address of an array of unsigned integers to receive the ids of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="severities">
            /// <para>
            /// The address of an array of variables to receive the severites of the retrieved messages.
            /// </para>
            /// </param>
            /// <param name="lengths">
            /// <para>
            /// The address of an array of variables to receive the lengths of the received messages.
            /// </para>
            /// </param>
            /// <param name="messageLog">
            /// <para>
            /// The address of an array of characters that will receive the messages.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glGetDebugMessageLogKHR")]
            public static extern unsafe Int32 GetDebugMessageLog(UInt32 count, Int32 bufSize, [OutAttribute] OpenTK.Graphics.OpenGL.KhrDebug* sources, [OutAttribute] OpenTK.Graphics.OpenGL.KhrDebug* types, [OutAttribute] UInt32* ids, [OutAttribute] OpenTK.Graphics.OpenGL.KhrDebug* severities, [OutAttribute] Int32* lengths, [OutAttribute] StringBuilder messageLog);

            /// <summary>[requires: KHR_debug]
            /// Retrieve the label of a named object identified within a namespace
            /// </summary>
            /// <param name="identifier">
            /// <para>
            /// The namespace from which the name of the object is allocated.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// The name of the object whose label to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The length of the buffer whose address is in label.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable to receive the length of the object label.
            /// </para>
            /// </param>
            /// <param name="label">
            /// <para>
            /// The address of a string that will receive the object label.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glGetObjectLabelKHR")]
            public static extern void GetObjectLabel(OpenTK.Graphics.OpenGL.KhrDebug identifier, Int32 name, Int32 bufSize, [OutAttribute] Int32[] length, [OutAttribute] StringBuilder label);

            /// <summary>[requires: KHR_debug]
            /// Retrieve the label of a named object identified within a namespace
            /// </summary>
            /// <param name="identifier">
            /// <para>
            /// The namespace from which the name of the object is allocated.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// The name of the object whose label to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The length of the buffer whose address is in label.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable to receive the length of the object label.
            /// </para>
            /// </param>
            /// <param name="label">
            /// <para>
            /// The address of a string that will receive the object label.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glGetObjectLabelKHR")]
            public static extern void GetObjectLabel(OpenTK.Graphics.OpenGL.KhrDebug identifier, Int32 name, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder label);

            /// <summary>[requires: KHR_debug]
            /// Retrieve the label of a named object identified within a namespace
            /// </summary>
            /// <param name="identifier">
            /// <para>
            /// The namespace from which the name of the object is allocated.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// The name of the object whose label to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The length of the buffer whose address is in label.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable to receive the length of the object label.
            /// </para>
            /// </param>
            /// <param name="label">
            /// <para>
            /// The address of a string that will receive the object label.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glGetObjectLabelKHR")]
            public static extern unsafe void GetObjectLabel(OpenTK.Graphics.OpenGL.KhrDebug identifier, Int32 name, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder label);

            /// <summary>[requires: KHR_debug]
            /// Retrieve the label of a named object identified within a namespace
            /// </summary>
            /// <param name="identifier">
            /// <para>
            /// The namespace from which the name of the object is allocated.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// The name of the object whose label to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The length of the buffer whose address is in label.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable to receive the length of the object label.
            /// </para>
            /// </param>
            /// <param name="label">
            /// <para>
            /// The address of a string that will receive the object label.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glGetObjectLabelKHR")]
            public static extern void GetObjectLabel(OpenTK.Graphics.OpenGL.KhrDebug identifier, UInt32 name, Int32 bufSize, [OutAttribute] Int32[] length, [OutAttribute] StringBuilder label);

            /// <summary>[requires: KHR_debug]
            /// Retrieve the label of a named object identified within a namespace
            /// </summary>
            /// <param name="identifier">
            /// <para>
            /// The namespace from which the name of the object is allocated.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// The name of the object whose label to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The length of the buffer whose address is in label.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable to receive the length of the object label.
            /// </para>
            /// </param>
            /// <param name="label">
            /// <para>
            /// The address of a string that will receive the object label.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glGetObjectLabelKHR")]
            public static extern void GetObjectLabel(OpenTK.Graphics.OpenGL.KhrDebug identifier, UInt32 name, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder label);

            /// <summary>[requires: KHR_debug]
            /// Retrieve the label of a named object identified within a namespace
            /// </summary>
            /// <param name="identifier">
            /// <para>
            /// The namespace from which the name of the object is allocated.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// The name of the object whose label to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The length of the buffer whose address is in label.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable to receive the length of the object label.
            /// </para>
            /// </param>
            /// <param name="label">
            /// <para>
            /// The address of a string that will receive the object label.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glGetObjectLabelKHR")]
            public static extern unsafe void GetObjectLabel(OpenTK.Graphics.OpenGL.KhrDebug identifier, UInt32 name, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder label);

            /// <summary>[requires: KHR_debug]
            /// Retrieve the label of a sync object identified by a pointer
            /// </summary>
            /// <param name="ptr">
            /// <para>
            /// The name of the sync object whose label to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The length of the buffer whose address is in label.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable to receive the length of the object label.
            /// </para>
            /// </param>
            /// <param name="label">
            /// <para>
            /// The address of a string that will receive the object label.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glGetObjectPtrLabelKHR")]
            public static extern void GetObjectPtrLabel(IntPtr ptr, Int32 bufSize, [OutAttribute] Int32[] length, [OutAttribute] StringBuilder label);

            /// <summary>[requires: KHR_debug]
            /// Retrieve the label of a sync object identified by a pointer
            /// </summary>
            /// <param name="ptr">
            /// <para>
            /// The name of the sync object whose label to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The length of the buffer whose address is in label.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable to receive the length of the object label.
            /// </para>
            /// </param>
            /// <param name="label">
            /// <para>
            /// The address of a string that will receive the object label.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glGetObjectPtrLabelKHR")]
            public static extern void GetObjectPtrLabel(IntPtr ptr, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder label);

            /// <summary>[requires: KHR_debug]
            /// Retrieve the label of a sync object identified by a pointer
            /// </summary>
            /// <param name="ptr">
            /// <para>
            /// The name of the sync object whose label to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The length of the buffer whose address is in label.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable to receive the length of the object label.
            /// </para>
            /// </param>
            /// <param name="label">
            /// <para>
            /// The address of a string that will receive the object label.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glGetObjectPtrLabelKHR")]
            public static extern unsafe void GetObjectPtrLabel(IntPtr ptr, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder label);

            /// <summary>[requires: KHR_debug]
            /// Retrieve the label of a sync object identified by a pointer
            /// </summary>
            /// <param name="ptr">
            /// <para>
            /// The name of the sync object whose label to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The length of the buffer whose address is in label.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable to receive the length of the object label.
            /// </para>
            /// </param>
            /// <param name="label">
            /// <para>
            /// The address of a string that will receive the object label.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glGetObjectPtrLabelKHR")]
            public static extern void GetObjectPtrLabel<T0>([InAttribute, OutAttribute] T0[] ptr, Int32 bufSize, [OutAttribute] Int32[] length, [OutAttribute] StringBuilder label)
                where T0 : struct
            ;

            /// <summary>[requires: KHR_debug]
            /// Retrieve the label of a sync object identified by a pointer
            /// </summary>
            /// <param name="ptr">
            /// <para>
            /// The name of the sync object whose label to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The length of the buffer whose address is in label.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable to receive the length of the object label.
            /// </para>
            /// </param>
            /// <param name="label">
            /// <para>
            /// The address of a string that will receive the object label.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glGetObjectPtrLabelKHR")]
            public static extern void GetObjectPtrLabel<T0>([InAttribute, OutAttribute] T0[] ptr, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder label)
                where T0 : struct
            ;

            /// <summary>[requires: KHR_debug]
            /// Retrieve the label of a sync object identified by a pointer
            /// </summary>
            /// <param name="ptr">
            /// <para>
            /// The name of the sync object whose label to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The length of the buffer whose address is in label.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable to receive the length of the object label.
            /// </para>
            /// </param>
            /// <param name="label">
            /// <para>
            /// The address of a string that will receive the object label.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glGetObjectPtrLabelKHR")]
            public static extern unsafe void GetObjectPtrLabel<T0>([InAttribute, OutAttribute] T0[] ptr, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder label)
                where T0 : struct
            ;

            /// <summary>[requires: KHR_debug]
            /// Retrieve the label of a sync object identified by a pointer
            /// </summary>
            /// <param name="ptr">
            /// <para>
            /// The name of the sync object whose label to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The length of the buffer whose address is in label.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable to receive the length of the object label.
            /// </para>
            /// </param>
            /// <param name="label">
            /// <para>
            /// The address of a string that will receive the object label.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glGetObjectPtrLabelKHR")]
            public static extern void GetObjectPtrLabel<T0>([InAttribute, OutAttribute] T0[,] ptr, Int32 bufSize, [OutAttribute] Int32[] length, [OutAttribute] StringBuilder label)
                where T0 : struct
            ;

            /// <summary>[requires: KHR_debug]
            /// Retrieve the label of a sync object identified by a pointer
            /// </summary>
            /// <param name="ptr">
            /// <para>
            /// The name of the sync object whose label to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The length of the buffer whose address is in label.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable to receive the length of the object label.
            /// </para>
            /// </param>
            /// <param name="label">
            /// <para>
            /// The address of a string that will receive the object label.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glGetObjectPtrLabelKHR")]
            public static extern void GetObjectPtrLabel<T0>([InAttribute, OutAttribute] T0[,] ptr, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder label)
                where T0 : struct
            ;

            /// <summary>[requires: KHR_debug]
            /// Retrieve the label of a sync object identified by a pointer
            /// </summary>
            /// <param name="ptr">
            /// <para>
            /// The name of the sync object whose label to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The length of the buffer whose address is in label.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable to receive the length of the object label.
            /// </para>
            /// </param>
            /// <param name="label">
            /// <para>
            /// The address of a string that will receive the object label.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glGetObjectPtrLabelKHR")]
            public static extern unsafe void GetObjectPtrLabel<T0>([InAttribute, OutAttribute] T0[,] ptr, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder label)
                where T0 : struct
            ;

            /// <summary>[requires: KHR_debug]
            /// Retrieve the label of a sync object identified by a pointer
            /// </summary>
            /// <param name="ptr">
            /// <para>
            /// The name of the sync object whose label to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The length of the buffer whose address is in label.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable to receive the length of the object label.
            /// </para>
            /// </param>
            /// <param name="label">
            /// <para>
            /// The address of a string that will receive the object label.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glGetObjectPtrLabelKHR")]
            public static extern void GetObjectPtrLabel<T0>([InAttribute, OutAttribute] T0[,,] ptr, Int32 bufSize, [OutAttribute] Int32[] length, [OutAttribute] StringBuilder label)
                where T0 : struct
            ;

            /// <summary>[requires: KHR_debug]
            /// Retrieve the label of a sync object identified by a pointer
            /// </summary>
            /// <param name="ptr">
            /// <para>
            /// The name of the sync object whose label to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The length of the buffer whose address is in label.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable to receive the length of the object label.
            /// </para>
            /// </param>
            /// <param name="label">
            /// <para>
            /// The address of a string that will receive the object label.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glGetObjectPtrLabelKHR")]
            public static extern void GetObjectPtrLabel<T0>([InAttribute, OutAttribute] T0[,,] ptr, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder label)
                where T0 : struct
            ;

            /// <summary>[requires: KHR_debug]
            /// Retrieve the label of a sync object identified by a pointer
            /// </summary>
            /// <param name="ptr">
            /// <para>
            /// The name of the sync object whose label to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The length of the buffer whose address is in label.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable to receive the length of the object label.
            /// </para>
            /// </param>
            /// <param name="label">
            /// <para>
            /// The address of a string that will receive the object label.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glGetObjectPtrLabelKHR")]
            public static extern unsafe void GetObjectPtrLabel<T0>([InAttribute, OutAttribute] T0[,,] ptr, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder label)
                where T0 : struct
            ;

            /// <summary>[requires: KHR_debug]
            /// Retrieve the label of a sync object identified by a pointer
            /// </summary>
            /// <param name="ptr">
            /// <para>
            /// The name of the sync object whose label to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The length of the buffer whose address is in label.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable to receive the length of the object label.
            /// </para>
            /// </param>
            /// <param name="label">
            /// <para>
            /// The address of a string that will receive the object label.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glGetObjectPtrLabelKHR")]
            public static extern void GetObjectPtrLabel<T0>([InAttribute, OutAttribute] ref T0 ptr, Int32 bufSize, [OutAttribute] Int32[] length, [OutAttribute] StringBuilder label)
                where T0 : struct
            ;

            /// <summary>[requires: KHR_debug]
            /// Retrieve the label of a sync object identified by a pointer
            /// </summary>
            /// <param name="ptr">
            /// <para>
            /// The name of the sync object whose label to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The length of the buffer whose address is in label.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable to receive the length of the object label.
            /// </para>
            /// </param>
            /// <param name="label">
            /// <para>
            /// The address of a string that will receive the object label.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glGetObjectPtrLabelKHR")]
            public static extern void GetObjectPtrLabel<T0>([InAttribute, OutAttribute] ref T0 ptr, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] StringBuilder label)
                where T0 : struct
            ;

            /// <summary>[requires: KHR_debug]
            /// Retrieve the label of a sync object identified by a pointer
            /// </summary>
            /// <param name="ptr">
            /// <para>
            /// The name of the sync object whose label to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The length of the buffer whose address is in label.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable to receive the length of the object label.
            /// </para>
            /// </param>
            /// <param name="label">
            /// <para>
            /// The address of a string that will receive the object label.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glGetObjectPtrLabelKHR")]
            public static extern unsafe void GetObjectPtrLabel<T0>([InAttribute, OutAttribute] ref T0 ptr, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder label)
                where T0 : struct
            ;

            /// <summary>[requires: KHR_debug]</summary>
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glGetPointervKHR")]
            public static extern void GetPointer(OpenTK.Graphics.OpenGL.KhrDebug pname, [OutAttribute] IntPtr @params);

            /// <summary>[requires: KHR_debug]</summary>
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glGetPointervKHR")]
            public static extern void GetPointer<T1>(OpenTK.Graphics.OpenGL.KhrDebug pname, [InAttribute, OutAttribute] T1[] @params)
                where T1 : struct
            ;

            /// <summary>[requires: KHR_debug]</summary>
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glGetPointervKHR")]
            public static extern void GetPointer<T1>(OpenTK.Graphics.OpenGL.KhrDebug pname, [InAttribute, OutAttribute] T1[,] @params)
                where T1 : struct
            ;

            /// <summary>[requires: KHR_debug]</summary>
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glGetPointervKHR")]
            public static extern void GetPointer<T1>(OpenTK.Graphics.OpenGL.KhrDebug pname, [InAttribute, OutAttribute] T1[,,] @params)
                where T1 : struct
            ;

            /// <summary>[requires: KHR_debug]</summary>
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glGetPointervKHR")]
            public static extern void GetPointer<T1>(OpenTK.Graphics.OpenGL.KhrDebug pname, [InAttribute, OutAttribute] ref T1 @params)
                where T1 : struct
            ;

            /// <summary>[requires: KHR_debug]
            /// Label a named object identified within a namespace
            /// </summary>
            /// <param name="identifier">
            /// <para>
            /// The namespace from which the name of the object is allocated.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// The name of the object to label.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The length of the label to be used for the object.
            /// </para>
            /// </param>
            /// <param name="label">
            /// <para>
            /// The address of a string containing the label to assign to the object.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glObjectLabelKHR")]
            public static extern void ObjectLabel(OpenTK.Graphics.OpenGL.KhrDebug identifier, Int32 name, Int32 length, String label);

            /// <summary>[requires: KHR_debug]
            /// Label a named object identified within a namespace
            /// </summary>
            /// <param name="identifier">
            /// <para>
            /// The namespace from which the name of the object is allocated.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// The name of the object to label.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The length of the label to be used for the object.
            /// </para>
            /// </param>
            /// <param name="label">
            /// <para>
            /// The address of a string containing the label to assign to the object.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glObjectLabelKHR")]
            public static extern void ObjectLabel(OpenTK.Graphics.OpenGL.KhrDebug identifier, UInt32 name, Int32 length, String label);

            /// <summary>[requires: KHR_debug]
            /// Label a a sync object identified by a pointer
            /// </summary>
            /// <param name="ptr">
            /// <para>
            /// A pointer identifying a sync object.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The length of the label to be used for the object.
            /// </para>
            /// </param>
            /// <param name="label">
            /// <para>
            /// The address of a string containing the label to assign to the object.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glObjectPtrLabelKHR")]
            public static extern void ObjectPtrLabel(IntPtr ptr, Int32 length, String label);

            /// <summary>[requires: KHR_debug]
            /// Label a a sync object identified by a pointer
            /// </summary>
            /// <param name="ptr">
            /// <para>
            /// A pointer identifying a sync object.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The length of the label to be used for the object.
            /// </para>
            /// </param>
            /// <param name="label">
            /// <para>
            /// The address of a string containing the label to assign to the object.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glObjectPtrLabelKHR")]
            public static extern void ObjectPtrLabel<T0>([InAttribute, OutAttribute] T0[] ptr, Int32 length, String label)
                where T0 : struct
            ;

            /// <summary>[requires: KHR_debug]
            /// Label a a sync object identified by a pointer
            /// </summary>
            /// <param name="ptr">
            /// <para>
            /// A pointer identifying a sync object.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The length of the label to be used for the object.
            /// </para>
            /// </param>
            /// <param name="label">
            /// <para>
            /// The address of a string containing the label to assign to the object.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glObjectPtrLabelKHR")]
            public static extern void ObjectPtrLabel<T0>([InAttribute, OutAttribute] T0[,] ptr, Int32 length, String label)
                where T0 : struct
            ;

            /// <summary>[requires: KHR_debug]
            /// Label a a sync object identified by a pointer
            /// </summary>
            /// <param name="ptr">
            /// <para>
            /// A pointer identifying a sync object.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The length of the label to be used for the object.
            /// </para>
            /// </param>
            /// <param name="label">
            /// <para>
            /// The address of a string containing the label to assign to the object.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glObjectPtrLabelKHR")]
            public static extern void ObjectPtrLabel<T0>([InAttribute, OutAttribute] T0[,,] ptr, Int32 length, String label)
                where T0 : struct
            ;

            /// <summary>[requires: KHR_debug]
            /// Label a a sync object identified by a pointer
            /// </summary>
            /// <param name="ptr">
            /// <para>
            /// A pointer identifying a sync object.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The length of the label to be used for the object.
            /// </para>
            /// </param>
            /// <param name="label">
            /// <para>
            /// The address of a string containing the label to assign to the object.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glObjectPtrLabelKHR")]
            public static extern void ObjectPtrLabel<T0>([InAttribute, OutAttribute] ref T0 ptr, Int32 length, String label)
                where T0 : struct
            ;

            /// <summary>[requires: KHR_debug]
            /// Pop the active debug group
            /// </summary>
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glPopDebugGroupKHR")]
            public static extern void PopDebugGroup();

            /// <summary>[requires: KHR_debug]
            /// Push a named debug group into the command stream
            /// </summary>
            /// <param name="source">
            /// <para>
            /// The source of the debug message.
            /// </para>
            /// </param>
            /// <param name="id">
            /// <para>
            /// The identifier of the message.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The length of the message to be sent to the debug output stream.
            /// </para>
            /// </param>
            /// <param name="message">
            /// <para>
            /// The a string containing the message to be sent to the debug output stream.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glPushDebugGroupKHR")]
            public static extern void PushDebugGroup(OpenTK.Graphics.OpenGL.KhrDebug source, Int32 id, Int32 length, String message);

            /// <summary>[requires: KHR_debug]
            /// Push a named debug group into the command stream
            /// </summary>
            /// <param name="source">
            /// <para>
            /// The source of the debug message.
            /// </para>
            /// </param>
            /// <param name="id">
            /// <para>
            /// The identifier of the message.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The length of the message to be sent to the debug output stream.
            /// </para>
            /// </param>
            /// <param name="message">
            /// <para>
            /// The a string containing the message to be sent to the debug output stream.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "KHR_debug", Version = "", EntryPoint = "glPushDebugGroupKHR")]
            public static extern void PushDebugGroup(OpenTK.Graphics.OpenGL.KhrDebug source, UInt32 id, Int32 length, String message);

        }

        public static partial class Mesa
        {
            /// <summary>[requires: MESA_resize_buffers]</summary>
            [AutoGenerated(Category = "MESA_resize_buffers", Version = "", EntryPoint = "glResizeBuffersMESA")]
            public static extern void ResizeBuffers();

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos2dMESA")]
            public static extern void WindowPos2(Double x, Double y);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos2dvMESA")]
            public static extern void WindowPos2(Double[] v);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos2dvMESA")]
            public static extern void WindowPos2(ref Double v);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos2dvMESA")]
            public static extern unsafe void WindowPos2(Double* v);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos2fMESA")]
            public static extern void WindowPos2(Single x, Single y);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos2fvMESA")]
            public static extern void WindowPos2(Single[] v);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos2fvMESA")]
            public static extern void WindowPos2(ref Single v);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos2fvMESA")]
            public static extern unsafe void WindowPos2(Single* v);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos2iMESA")]
            public static extern void WindowPos2(Int32 x, Int32 y);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos2ivMESA")]
            public static extern void WindowPos2(Int32[] v);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos2ivMESA")]
            public static extern void WindowPos2(ref Int32 v);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos2ivMESA")]
            public static extern unsafe void WindowPos2(Int32* v);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos2sMESA")]
            public static extern void WindowPos2(Int16 x, Int16 y);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos2svMESA")]
            public static extern void WindowPos2(Int16[] v);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos2svMESA")]
            public static extern void WindowPos2(ref Int16 v);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos2svMESA")]
            public static extern unsafe void WindowPos2(Int16* v);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos3dMESA")]
            public static extern void WindowPos3(Double x, Double y, Double z);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos3dvMESA")]
            public static extern void WindowPos3(Double[] v);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos3dvMESA")]
            public static extern void WindowPos3(ref Double v);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos3dvMESA")]
            public static extern unsafe void WindowPos3(Double* v);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos3fMESA")]
            public static extern void WindowPos3(Single x, Single y, Single z);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos3fvMESA")]
            public static extern void WindowPos3(Single[] v);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos3fvMESA")]
            public static extern void WindowPos3(ref Single v);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos3fvMESA")]
            public static extern unsafe void WindowPos3(Single* v);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos3iMESA")]
            public static extern void WindowPos3(Int32 x, Int32 y, Int32 z);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos3ivMESA")]
            public static extern void WindowPos3(Int32[] v);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos3ivMESA")]
            public static extern void WindowPos3(ref Int32 v);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos3ivMESA")]
            public static extern unsafe void WindowPos3(Int32* v);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos3sMESA")]
            public static extern void WindowPos3(Int16 x, Int16 y, Int16 z);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos3svMESA")]
            public static extern void WindowPos3(Int16[] v);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos3svMESA")]
            public static extern void WindowPos3(ref Int16 v);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos3svMESA")]
            public static extern unsafe void WindowPos3(Int16* v);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos4dMESA")]
            public static extern void WindowPos4(Double x, Double y, Double z, Double w);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos4dvMESA")]
            public static extern void WindowPos4(Double[] v);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos4dvMESA")]
            public static extern void WindowPos4(ref Double v);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos4dvMESA")]
            public static extern unsafe void WindowPos4(Double* v);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos4fMESA")]
            public static extern void WindowPos4(Single x, Single y, Single z, Single w);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos4fvMESA")]
            public static extern void WindowPos4(Single[] v);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos4fvMESA")]
            public static extern void WindowPos4(ref Single v);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos4fvMESA")]
            public static extern unsafe void WindowPos4(Single* v);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos4iMESA")]
            public static extern void WindowPos4(Int32 x, Int32 y, Int32 z, Int32 w);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos4ivMESA")]
            public static extern void WindowPos4(Int32[] v);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos4ivMESA")]
            public static extern void WindowPos4(ref Int32 v);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos4ivMESA")]
            public static extern unsafe void WindowPos4(Int32* v);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos4sMESA")]
            public static extern void WindowPos4(Int16 x, Int16 y, Int16 z, Int16 w);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos4svMESA")]
            public static extern void WindowPos4(Int16[] v);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos4svMESA")]
            public static extern void WindowPos4(ref Int16 v);

            /// <summary>[requires: MESA_window_pos]
            /// Specify the raster position in window coordinates for pixel operations
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify the , , coordinates for the raster position.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "MESA_window_pos", Version = "", EntryPoint = "glWindowPos4svMESA")]
            public static extern unsafe void WindowPos4(Int16* v);

        }

        public static partial class NV
        {
            /// <summary>[requires: NV_transform_feedback]</summary>
            [AutoGenerated(Category = "NV_transform_feedback", Version = "", EntryPoint = "glActiveVaryingNV")]
            public static extern void ActiveVarying(Int32 program, String name);

            /// <summary>[requires: NV_transform_feedback]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_transform_feedback", Version = "", EntryPoint = "glActiveVaryingNV")]
            public static extern void ActiveVarying(UInt32 program, String name);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glAreProgramsResidentNV")]
            public static extern bool AreProgramsResident(Int32 n, Int32[] programs, [OutAttribute] bool[] residences);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glAreProgramsResidentNV")]
            public static extern bool AreProgramsResident(Int32 n, ref Int32 programs, [OutAttribute] out bool residences);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glAreProgramsResidentNV")]
            public static extern unsafe bool AreProgramsResident(Int32 n, Int32* programs, [OutAttribute] bool* residences);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glAreProgramsResidentNV")]
            public static extern bool AreProgramsResident(Int32 n, UInt32[] programs, [OutAttribute] bool[] residences);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glAreProgramsResidentNV")]
            public static extern bool AreProgramsResident(Int32 n, ref UInt32 programs, [OutAttribute] out bool residences);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glAreProgramsResidentNV")]
            public static extern unsafe bool AreProgramsResident(Int32 n, UInt32* programs, [OutAttribute] bool* residences);

            /// <summary>[requires: NV_conditional_render]
            /// Start conditional rendering
            /// </summary>
            /// <param name="id">
            /// <para>
            /// Specifies the name of an occlusion query object whose results are used to determine if the rendering commands are discarded.
            /// </para>
            /// </param>
            /// <param name="mode">
            /// <para>
            /// Specifies how glBeginConditionalRender interprets the results of the occlusion query.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_conditional_render", Version = "", EntryPoint = "glBeginConditionalRenderNV")]
            public static extern void BeginConditionalRender(Int32 id, OpenTK.Graphics.OpenGL.NvConditionalRender mode);

            /// <summary>[requires: NV_conditional_render]
            /// Start conditional rendering
            /// </summary>
            /// <param name="id">
            /// <para>
            /// Specifies the name of an occlusion query object whose results are used to determine if the rendering commands are discarded.
            /// </para>
            /// </param>
            /// <param name="mode">
            /// <para>
            /// Specifies how glBeginConditionalRender interprets the results of the occlusion query.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_conditional_render", Version = "", EntryPoint = "glBeginConditionalRenderNV")]
            public static extern void BeginConditionalRender(UInt32 id, OpenTK.Graphics.OpenGL.NvConditionalRender mode);

            /// <summary>[requires: NV_occlusion_query]</summary>
            [AutoGenerated(Category = "NV_occlusion_query", Version = "", EntryPoint = "glBeginOcclusionQueryNV")]
            public static extern void BeginOcclusionQuery(Int32 id);

            /// <summary>[requires: NV_occlusion_query]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_occlusion_query", Version = "", EntryPoint = "glBeginOcclusionQueryNV")]
            public static extern void BeginOcclusionQuery(UInt32 id);

            /// <summary>[requires: NV_transform_feedback]
            /// Start transform feedback operation
            /// </summary>
            /// <param name="primitiveMode">
            /// <para>
            /// Specify the output type of the primitives that will be recorded into the buffer objects that are bound for transform feedback.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_transform_feedback", Version = "", EntryPoint = "glBeginTransformFeedbackNV")]
            public static extern void BeginTransformFeedback(OpenTK.Graphics.OpenGL.NvTransformFeedback primitiveMode);

            /// <summary>[requires: NV_video_capture]</summary>
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glBeginVideoCaptureNV")]
            public static extern void BeginVideoCapture(Int32 video_capture_slot);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glBeginVideoCaptureNV")]
            public static extern void BeginVideoCapture(UInt32 video_capture_slot);

            /// <summary>[requires: NV_transform_feedback]
            /// Bind a buffer object to an indexed buffer target
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specify the target of the bind operation. target must be one of GL_ATOMIC_COUNTER_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, GL_UNIFORM_BUFFER or GL_SHADER_STORAGE_BUFFER.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// Specify the index of the binding point within the array specified by target.
            /// </para>
            /// </param>
            /// <param name="buffer">
            /// <para>
            /// The name of a buffer object to bind to the specified binding point.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_transform_feedback", Version = "", EntryPoint = "glBindBufferBaseNV")]
            public static extern void BindBufferBase(OpenTK.Graphics.OpenGL.NvTransformFeedback target, Int32 index, Int32 buffer);

            /// <summary>[requires: NV_transform_feedback]
            /// Bind a buffer object to an indexed buffer target
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specify the target of the bind operation. target must be one of GL_ATOMIC_COUNTER_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, GL_UNIFORM_BUFFER or GL_SHADER_STORAGE_BUFFER.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// Specify the index of the binding point within the array specified by target.
            /// </para>
            /// </param>
            /// <param name="buffer">
            /// <para>
            /// The name of a buffer object to bind to the specified binding point.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_transform_feedback", Version = "", EntryPoint = "glBindBufferBaseNV")]
            public static extern void BindBufferBase(OpenTK.Graphics.OpenGL.NvTransformFeedback target, UInt32 index, UInt32 buffer);

            /// <summary>[requires: NV_transform_feedback]</summary>
            [AutoGenerated(Category = "NV_transform_feedback", Version = "", EntryPoint = "glBindBufferOffsetNV")]
            public static extern void BindBufferOffset(OpenTK.Graphics.OpenGL.NvTransformFeedback target, Int32 index, Int32 buffer, IntPtr offset);

            /// <summary>[requires: NV_transform_feedback]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_transform_feedback", Version = "", EntryPoint = "glBindBufferOffsetNV")]
            public static extern void BindBufferOffset(OpenTK.Graphics.OpenGL.NvTransformFeedback target, UInt32 index, UInt32 buffer, IntPtr offset);

            /// <summary>[requires: NV_transform_feedback]
            /// Bind a range within a buffer object to an indexed buffer target
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specify the target of the bind operation. target must be one of GL_ATOMIC_COUNTER_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, GL_UNIFORM_BUFFER, or GL_SHADER_STORAGE_BUFFER.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// Specify the index of the binding point within the array specified by target.
            /// </para>
            /// </param>
            /// <param name="buffer">
            /// <para>
            /// The name of a buffer object to bind to the specified binding point.
            /// </para>
            /// </param>
            /// <param name="offset">
            /// <para>
            /// The starting offset in basic machine units into the buffer object buffer.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// The amount of data in machine units that can be read from the buffet object while used as an indexed target.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_transform_feedback", Version = "", EntryPoint = "glBindBufferRangeNV")]
            public static extern void BindBufferRange(OpenTK.Graphics.OpenGL.NvTransformFeedback target, Int32 index, Int32 buffer, IntPtr offset, IntPtr size);

            /// <summary>[requires: NV_transform_feedback]
            /// Bind a range within a buffer object to an indexed buffer target
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specify the target of the bind operation. target must be one of GL_ATOMIC_COUNTER_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, GL_UNIFORM_BUFFER, or GL_SHADER_STORAGE_BUFFER.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// Specify the index of the binding point within the array specified by target.
            /// </para>
            /// </param>
            /// <param name="buffer">
            /// <para>
            /// The name of a buffer object to bind to the specified binding point.
            /// </para>
            /// </param>
            /// <param name="offset">
            /// <para>
            /// The starting offset in basic machine units into the buffer object buffer.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// The amount of data in machine units that can be read from the buffet object while used as an indexed target.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_transform_feedback", Version = "", EntryPoint = "glBindBufferRangeNV")]
            public static extern void BindBufferRange(OpenTK.Graphics.OpenGL.NvTransformFeedback target, UInt32 index, UInt32 buffer, IntPtr offset, IntPtr size);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glBindProgramNV")]
            public static extern void BindProgram(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 id);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glBindProgramNV")]
            public static extern void BindProgram(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 id);

            /// <summary>[requires: NV_transform_feedback2]
            /// Bind a transform feedback object
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target to which to bind the transform feedback object id. target must be GL_TRANSFORM_FEEDBACK.
            /// </para>
            /// </param>
            /// <param name="id">
            /// <para>
            /// Specifies the name of a transform feedback object reserved by glGenTransformFeedbacks.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_transform_feedback2", Version = "", EntryPoint = "glBindTransformFeedbackNV")]
            public static extern void BindTransformFeedback(OpenTK.Graphics.OpenGL.NvTransformFeedback2 target, Int32 id);

            /// <summary>[requires: NV_transform_feedback2]
            /// Bind a transform feedback object
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target to which to bind the transform feedback object id. target must be GL_TRANSFORM_FEEDBACK.
            /// </para>
            /// </param>
            /// <param name="id">
            /// <para>
            /// Specifies the name of a transform feedback object reserved by glGenTransformFeedbacks.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_transform_feedback2", Version = "", EntryPoint = "glBindTransformFeedbackNV")]
            public static extern void BindTransformFeedback(OpenTK.Graphics.OpenGL.NvTransformFeedback2 target, UInt32 id);

            /// <summary>[requires: NV_video_capture]</summary>
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glBindVideoCaptureStreamBufferNV")]
            public static extern void BindVideoCaptureStreamBuffer(Int32 video_capture_slot, Int32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture frame_region, IntPtr offset);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glBindVideoCaptureStreamBufferNV")]
            public static extern void BindVideoCaptureStreamBuffer(UInt32 video_capture_slot, UInt32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture frame_region, IntPtr offset);

            /// <summary>[requires: NV_video_capture]</summary>
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glBindVideoCaptureStreamTextureNV")]
            public static extern void BindVideoCaptureStreamTexture(Int32 video_capture_slot, Int32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture frame_region, OpenTK.Graphics.OpenGL.NvVideoCapture target, Int32 texture);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glBindVideoCaptureStreamTextureNV")]
            public static extern void BindVideoCaptureStreamTexture(UInt32 video_capture_slot, UInt32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture frame_region, OpenTK.Graphics.OpenGL.NvVideoCapture target, UInt32 texture);

            /// <summary>[requires: NV_blend_equation_advanced]</summary>
            [AutoGenerated(Category = "NV_blend_equation_advanced", Version = "", EntryPoint = "glBlendBarrierNV")]
            public static extern void BlendBarrier();

            /// <summary>[requires: NV_blend_equation_advanced]</summary>
            [AutoGenerated(Category = "NV_blend_equation_advanced", Version = "", EntryPoint = "glBlendParameteriNV")]
            public static extern void BlendParameter(OpenTK.Graphics.OpenGL.NvBlendEquationAdvanced pname, Int32 value);

            /// <summary>[requires: NV_vertex_buffer_unified_memory]</summary>
            [AutoGenerated(Category = "NV_vertex_buffer_unified_memory", Version = "", EntryPoint = "glBufferAddressRangeNV")]
            public static extern void BufferAddressRange(OpenTK.Graphics.OpenGL.NvVertexBufferUnifiedMemory pname, Int32 index, Int64 address, IntPtr length);

            /// <summary>[requires: NV_vertex_buffer_unified_memory]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_buffer_unified_memory", Version = "", EntryPoint = "glBufferAddressRangeNV")]
            public static extern void BufferAddressRange(OpenTK.Graphics.OpenGL.NvVertexBufferUnifiedMemory pname, UInt32 index, UInt64 address, IntPtr length);

            /// <summary>[requires: NV_depth_buffer_float]
            /// Specify the clear value for the depth buffer
            /// </summary>
            /// <param name="depth">
            /// <para>
            /// Specifies the depth value used when the depth buffer is cleared. The initial value is 1.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_depth_buffer_float", Version = "", EntryPoint = "glClearDepthdNV")]
            public static extern void ClearDepth(Double depth);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glColor3hNV")]
            public static extern void Color3h(Half red, Half green, Half blue);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glColor3hvNV")]
            public static extern void Color3h(Half[] v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glColor3hvNV")]
            public static extern void Color3h(ref Half v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glColor3hvNV")]
            public static extern unsafe void Color3h(Half* v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glColor4hNV")]
            public static extern void Color4h(Half red, Half green, Half blue, Half alpha);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glColor4hvNV")]
            public static extern void Color4h(Half[] v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glColor4hvNV")]
            public static extern void Color4h(ref Half v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glColor4hvNV")]
            public static extern unsafe void Color4h(Half* v);

            /// <summary>[requires: NV_vertex_buffer_unified_memory]</summary>
            [AutoGenerated(Category = "NV_vertex_buffer_unified_memory", Version = "", EntryPoint = "glColorFormatNV")]
            public static extern void ColorFormat(Int32 size, OpenTK.Graphics.OpenGL.NvVertexBufferUnifiedMemory type, Int32 stride);

            /// <summary>[requires: NV_register_combiners]</summary>
            [AutoGenerated(Category = "NV_register_combiners", Version = "", EntryPoint = "glCombinerInputNV")]
            public static extern void CombinerInput(OpenTK.Graphics.OpenGL.NvRegisterCombiners stage, OpenTK.Graphics.OpenGL.NvRegisterCombiners portion, OpenTK.Graphics.OpenGL.NvRegisterCombiners variable, OpenTK.Graphics.OpenGL.NvRegisterCombiners input, OpenTK.Graphics.OpenGL.NvRegisterCombiners mapping, OpenTK.Graphics.OpenGL.NvRegisterCombiners componentUsage);

            /// <summary>[requires: NV_register_combiners]</summary>
            [AutoGenerated(Category = "NV_register_combiners", Version = "", EntryPoint = "glCombinerOutputNV")]
            public static extern void CombinerOutput(OpenTK.Graphics.OpenGL.NvRegisterCombiners stage, OpenTK.Graphics.OpenGL.NvRegisterCombiners portion, OpenTK.Graphics.OpenGL.NvRegisterCombiners abOutput, OpenTK.Graphics.OpenGL.NvRegisterCombiners cdOutput, OpenTK.Graphics.OpenGL.NvRegisterCombiners sumOutput, OpenTK.Graphics.OpenGL.NvRegisterCombiners scale, OpenTK.Graphics.OpenGL.NvRegisterCombiners bias, bool abDotProduct, bool cdDotProduct, bool muxSum);

            /// <summary>[requires: NV_register_combiners]</summary>
            [AutoGenerated(Category = "NV_register_combiners", Version = "", EntryPoint = "glCombinerParameterfNV")]
            public static extern void CombinerParameter(OpenTK.Graphics.OpenGL.NvRegisterCombiners pname, Single param);

            /// <summary>[requires: NV_register_combiners]</summary>
            [AutoGenerated(Category = "NV_register_combiners", Version = "", EntryPoint = "glCombinerParameterfvNV")]
            public static extern void CombinerParameter(OpenTK.Graphics.OpenGL.NvRegisterCombiners pname, Single[] @params);

            /// <summary>[requires: NV_register_combiners]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_register_combiners", Version = "", EntryPoint = "glCombinerParameterfvNV")]
            public static extern unsafe void CombinerParameter(OpenTK.Graphics.OpenGL.NvRegisterCombiners pname, Single* @params);

            /// <summary>[requires: NV_register_combiners]</summary>
            [AutoGenerated(Category = "NV_register_combiners", Version = "", EntryPoint = "glCombinerParameteriNV")]
            public static extern void CombinerParameter(OpenTK.Graphics.OpenGL.NvRegisterCombiners pname, Int32 param);

            /// <summary>[requires: NV_register_combiners]</summary>
            [AutoGenerated(Category = "NV_register_combiners", Version = "", EntryPoint = "glCombinerParameterivNV")]
            public static extern void CombinerParameter(OpenTK.Graphics.OpenGL.NvRegisterCombiners pname, Int32[] @params);

            /// <summary>[requires: NV_register_combiners]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_register_combiners", Version = "", EntryPoint = "glCombinerParameterivNV")]
            public static extern unsafe void CombinerParameter(OpenTK.Graphics.OpenGL.NvRegisterCombiners pname, Int32* @params);

            /// <summary>[requires: NV_register_combiners2]</summary>
            [AutoGenerated(Category = "NV_register_combiners2", Version = "", EntryPoint = "glCombinerStageParameterfvNV")]
            public static extern void CombinerStageParameter(OpenTK.Graphics.OpenGL.NvRegisterCombiners2 stage, OpenTK.Graphics.OpenGL.NvRegisterCombiners2 pname, Single[] @params);

            /// <summary>[requires: NV_register_combiners2]</summary>
            [AutoGenerated(Category = "NV_register_combiners2", Version = "", EntryPoint = "glCombinerStageParameterfvNV")]
            public static extern void CombinerStageParameter(OpenTK.Graphics.OpenGL.NvRegisterCombiners2 stage, OpenTK.Graphics.OpenGL.NvRegisterCombiners2 pname, ref Single @params);

            /// <summary>[requires: NV_register_combiners2]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_register_combiners2", Version = "", EntryPoint = "glCombinerStageParameterfvNV")]
            public static extern unsafe void CombinerStageParameter(OpenTK.Graphics.OpenGL.NvRegisterCombiners2 stage, OpenTK.Graphics.OpenGL.NvRegisterCombiners2 pname, Single* @params);

            /// <summary>[requires: NV_copy_image]
            /// Perform a raw data copy between two images
            /// </summary>
            /// <param name="srcName">
            /// <para>
            /// The name of a texture or renderbuffer object from which to copy.
            /// </para>
            /// </param>
            /// <param name="srcTarget">
            /// <para>
            /// The target representing the namespace of the source name srcName.
            /// </para>
            /// </param>
            /// <param name="srcLevel">
            /// <para>
            /// The mipmap level to read from the source.
            /// </para>
            /// </param>
            /// <param name="srcX">
            /// <para>
            /// The X coordinate of the left edge of the souce region to copy.
            /// </para>
            /// </param>
            /// <param name="srcY">
            /// <para>
            /// The Y coordinate of the top edge of the souce region to copy.
            /// </para>
            /// </param>
            /// <param name="srcZ">
            /// <para>
            /// The Z coordinate of the near edge of the souce region to copy.
            /// </para>
            /// </param>
            /// <param name="dstName">
            /// <para>
            /// The name of a texture or renderbuffer object to which to copy.
            /// </para>
            /// </param>
            /// <param name="dstTarget">
            /// <para>
            /// The target representing the namespace of the destination name dstName.
            /// </para>
            /// </param>
            /// <param name="dstX">
            /// <para>
            /// The X coordinate of the left edge of the destination region.
            /// </para>
            /// </param>
            /// <param name="dstY">
            /// <para>
            /// The Y coordinate of the top edge of the destination region.
            /// </para>
            /// </param>
            /// <param name="dstZ">
            /// <para>
            /// The Z coordinate of the near edge of the destination region.
            /// </para>
            /// </param>
            /// <param name="srcWidth">
            /// <para>
            /// The width of the region to be copied.
            /// </para>
            /// </param>
            /// <param name="srcHeight">
            /// <para>
            /// The height of the region to be copied.
            /// </para>
            /// </param>
            /// <param name="srcDepth">
            /// <para>
            /// The depth of the region to be copied.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_copy_image", Version = "", EntryPoint = "glCopyImageSubDataNV")]
            public static extern void CopyImageSubData(Int32 srcName, OpenTK.Graphics.OpenGL.NvCopyImage srcTarget, Int32 srcLevel, Int32 srcX, Int32 srcY, Int32 srcZ, Int32 dstName, OpenTK.Graphics.OpenGL.NvCopyImage dstTarget, Int32 dstLevel, Int32 dstX, Int32 dstY, Int32 dstZ, Int32 width, Int32 height, Int32 depth);

            /// <summary>[requires: NV_copy_image]
            /// Perform a raw data copy between two images
            /// </summary>
            /// <param name="srcName">
            /// <para>
            /// The name of a texture or renderbuffer object from which to copy.
            /// </para>
            /// </param>
            /// <param name="srcTarget">
            /// <para>
            /// The target representing the namespace of the source name srcName.
            /// </para>
            /// </param>
            /// <param name="srcLevel">
            /// <para>
            /// The mipmap level to read from the source.
            /// </para>
            /// </param>
            /// <param name="srcX">
            /// <para>
            /// The X coordinate of the left edge of the souce region to copy.
            /// </para>
            /// </param>
            /// <param name="srcY">
            /// <para>
            /// The Y coordinate of the top edge of the souce region to copy.
            /// </para>
            /// </param>
            /// <param name="srcZ">
            /// <para>
            /// The Z coordinate of the near edge of the souce region to copy.
            /// </para>
            /// </param>
            /// <param name="dstName">
            /// <para>
            /// The name of a texture or renderbuffer object to which to copy.
            /// </para>
            /// </param>
            /// <param name="dstTarget">
            /// <para>
            /// The target representing the namespace of the destination name dstName.
            /// </para>
            /// </param>
            /// <param name="dstX">
            /// <para>
            /// The X coordinate of the left edge of the destination region.
            /// </para>
            /// </param>
            /// <param name="dstY">
            /// <para>
            /// The Y coordinate of the top edge of the destination region.
            /// </para>
            /// </param>
            /// <param name="dstZ">
            /// <para>
            /// The Z coordinate of the near edge of the destination region.
            /// </para>
            /// </param>
            /// <param name="srcWidth">
            /// <para>
            /// The width of the region to be copied.
            /// </para>
            /// </param>
            /// <param name="srcHeight">
            /// <para>
            /// The height of the region to be copied.
            /// </para>
            /// </param>
            /// <param name="srcDepth">
            /// <para>
            /// The depth of the region to be copied.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_copy_image", Version = "", EntryPoint = "glCopyImageSubDataNV")]
            public static extern void CopyImageSubData(UInt32 srcName, OpenTK.Graphics.OpenGL.NvCopyImage srcTarget, Int32 srcLevel, Int32 srcX, Int32 srcY, Int32 srcZ, UInt32 dstName, OpenTK.Graphics.OpenGL.NvCopyImage dstTarget, Int32 dstLevel, Int32 dstX, Int32 dstY, Int32 dstZ, Int32 width, Int32 height, Int32 depth);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCopyPathNV")]
            public static extern void CopyPath(Int32 resultPath, Int32 srcPath);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCopyPathNV")]
            public static extern void CopyPath(UInt32 resultPath, UInt32 srcPath);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverFillPathInstancedNV")]
            public static extern void CoverFillPathInstanced(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverFillPathInstancedNV")]
            public static extern void CoverFillPathInstanced(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverFillPathInstancedNV")]
            public static extern unsafe void CoverFillPathInstanced(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverFillPathInstancedNV")]
            public static extern void CoverFillPathInstanced(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverFillPathInstancedNV")]
            public static extern void CoverFillPathInstanced(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverFillPathInstancedNV")]
            public static extern unsafe void CoverFillPathInstanced(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverFillPathInstancedNV")]
            public static extern void CoverFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[] paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverFillPathInstancedNV")]
            public static extern void CoverFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[] paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverFillPathInstancedNV")]
            public static extern unsafe void CoverFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[] paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverFillPathInstancedNV")]
            public static extern void CoverFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[] paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverFillPathInstancedNV")]
            public static extern void CoverFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[] paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverFillPathInstancedNV")]
            public static extern unsafe void CoverFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[] paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverFillPathInstancedNV")]
            public static extern void CoverFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,] paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverFillPathInstancedNV")]
            public static extern void CoverFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,] paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverFillPathInstancedNV")]
            public static extern unsafe void CoverFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,] paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverFillPathInstancedNV")]
            public static extern void CoverFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,] paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverFillPathInstancedNV")]
            public static extern void CoverFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,] paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverFillPathInstancedNV")]
            public static extern unsafe void CoverFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,] paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverFillPathInstancedNV")]
            public static extern void CoverFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,,] paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverFillPathInstancedNV")]
            public static extern void CoverFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,,] paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverFillPathInstancedNV")]
            public static extern unsafe void CoverFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,,] paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverFillPathInstancedNV")]
            public static extern void CoverFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,,] paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverFillPathInstancedNV")]
            public static extern void CoverFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,,] paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverFillPathInstancedNV")]
            public static extern unsafe void CoverFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,,] paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverFillPathInstancedNV")]
            public static extern void CoverFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T2 paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverFillPathInstancedNV")]
            public static extern void CoverFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T2 paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverFillPathInstancedNV")]
            public static extern unsafe void CoverFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T2 paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverFillPathInstancedNV")]
            public static extern void CoverFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T2 paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverFillPathInstancedNV")]
            public static extern void CoverFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T2 paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverFillPathInstancedNV")]
            public static extern unsafe void CoverFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T2 paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverFillPathNV")]
            public static extern void CoverFillPath(Int32 path, OpenTK.Graphics.OpenGL.NvPathRendering coverMode);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverFillPathNV")]
            public static extern void CoverFillPath(UInt32 path, OpenTK.Graphics.OpenGL.NvPathRendering coverMode);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverStrokePathInstancedNV")]
            public static extern void CoverStrokePathInstanced(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverStrokePathInstancedNV")]
            public static extern void CoverStrokePathInstanced(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverStrokePathInstancedNV")]
            public static extern unsafe void CoverStrokePathInstanced(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverStrokePathInstancedNV")]
            public static extern void CoverStrokePathInstanced(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverStrokePathInstancedNV")]
            public static extern void CoverStrokePathInstanced(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverStrokePathInstancedNV")]
            public static extern unsafe void CoverStrokePathInstanced(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverStrokePathInstancedNV")]
            public static extern void CoverStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[] paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverStrokePathInstancedNV")]
            public static extern void CoverStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[] paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverStrokePathInstancedNV")]
            public static extern unsafe void CoverStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[] paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverStrokePathInstancedNV")]
            public static extern void CoverStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[] paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverStrokePathInstancedNV")]
            public static extern void CoverStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[] paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverStrokePathInstancedNV")]
            public static extern unsafe void CoverStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[] paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverStrokePathInstancedNV")]
            public static extern void CoverStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,] paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverStrokePathInstancedNV")]
            public static extern void CoverStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,] paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverStrokePathInstancedNV")]
            public static extern unsafe void CoverStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,] paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverStrokePathInstancedNV")]
            public static extern void CoverStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,] paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverStrokePathInstancedNV")]
            public static extern void CoverStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,] paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverStrokePathInstancedNV")]
            public static extern unsafe void CoverStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,] paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverStrokePathInstancedNV")]
            public static extern void CoverStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,,] paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverStrokePathInstancedNV")]
            public static extern void CoverStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,,] paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverStrokePathInstancedNV")]
            public static extern unsafe void CoverStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,,] paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverStrokePathInstancedNV")]
            public static extern void CoverStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,,] paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverStrokePathInstancedNV")]
            public static extern void CoverStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,,] paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverStrokePathInstancedNV")]
            public static extern unsafe void CoverStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,,] paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverStrokePathInstancedNV")]
            public static extern void CoverStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T2 paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverStrokePathInstancedNV")]
            public static extern void CoverStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T2 paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverStrokePathInstancedNV")]
            public static extern unsafe void CoverStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T2 paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverStrokePathInstancedNV")]
            public static extern void CoverStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T2 paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverStrokePathInstancedNV")]
            public static extern void CoverStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T2 paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverStrokePathInstancedNV")]
            public static extern unsafe void CoverStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T2 paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverStrokePathNV")]
            public static extern void CoverStrokePath(Int32 path, OpenTK.Graphics.OpenGL.NvPathRendering coverMode);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glCoverStrokePathNV")]
            public static extern void CoverStrokePath(UInt32 path, OpenTK.Graphics.OpenGL.NvPathRendering coverMode);

            /// <summary>[requires: NV_fence]</summary>
            [AutoGenerated(Category = "NV_fence", Version = "", EntryPoint = "glDeleteFencesNV")]
            public static extern void DeleteFence(Int32 fences);

            /// <summary>[requires: NV_fence]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fence", Version = "", EntryPoint = "glDeleteFencesNV")]
            public static extern void DeleteFence(UInt32 fences);

            /// <summary>[requires: NV_fence]</summary>
            [AutoGenerated(Category = "NV_fence", Version = "", EntryPoint = "glDeleteFencesNV")]
            public static extern void DeleteFences(Int32 n, Int32[] fences);

            /// <summary>[requires: NV_fence]</summary>
            [AutoGenerated(Category = "NV_fence", Version = "", EntryPoint = "glDeleteFencesNV")]
            public static extern void DeleteFences(Int32 n, ref Int32 fences);

            /// <summary>[requires: NV_fence]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fence", Version = "", EntryPoint = "glDeleteFencesNV")]
            public static extern unsafe void DeleteFences(Int32 n, Int32* fences);

            /// <summary>[requires: NV_fence]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fence", Version = "", EntryPoint = "glDeleteFencesNV")]
            public static extern void DeleteFences(Int32 n, UInt32[] fences);

            /// <summary>[requires: NV_fence]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fence", Version = "", EntryPoint = "glDeleteFencesNV")]
            public static extern void DeleteFences(Int32 n, ref UInt32 fences);

            /// <summary>[requires: NV_fence]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fence", Version = "", EntryPoint = "glDeleteFencesNV")]
            public static extern unsafe void DeleteFences(Int32 n, UInt32* fences);

            /// <summary>[requires: NV_occlusion_query]</summary>
            [AutoGenerated(Category = "NV_occlusion_query", Version = "", EntryPoint = "glDeleteOcclusionQueriesNV")]
            public static extern void DeleteOcclusionQuery(Int32 ids);

            /// <summary>[requires: NV_occlusion_query]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_occlusion_query", Version = "", EntryPoint = "glDeleteOcclusionQueriesNV")]
            public static extern void DeleteOcclusionQuery(UInt32 ids);

            /// <summary>[requires: NV_occlusion_query]</summary>
            [AutoGenerated(Category = "NV_occlusion_query", Version = "", EntryPoint = "glDeleteOcclusionQueriesNV")]
            public static extern void DeleteOcclusionQueries(Int32 n, Int32[] ids);

            /// <summary>[requires: NV_occlusion_query]</summary>
            [AutoGenerated(Category = "NV_occlusion_query", Version = "", EntryPoint = "glDeleteOcclusionQueriesNV")]
            public static extern void DeleteOcclusionQueries(Int32 n, ref Int32 ids);

            /// <summary>[requires: NV_occlusion_query]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_occlusion_query", Version = "", EntryPoint = "glDeleteOcclusionQueriesNV")]
            public static extern unsafe void DeleteOcclusionQueries(Int32 n, Int32* ids);

            /// <summary>[requires: NV_occlusion_query]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_occlusion_query", Version = "", EntryPoint = "glDeleteOcclusionQueriesNV")]
            public static extern void DeleteOcclusionQueries(Int32 n, UInt32[] ids);

            /// <summary>[requires: NV_occlusion_query]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_occlusion_query", Version = "", EntryPoint = "glDeleteOcclusionQueriesNV")]
            public static extern void DeleteOcclusionQueries(Int32 n, ref UInt32 ids);

            /// <summary>[requires: NV_occlusion_query]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_occlusion_query", Version = "", EntryPoint = "glDeleteOcclusionQueriesNV")]
            public static extern unsafe void DeleteOcclusionQueries(Int32 n, UInt32* ids);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glDeletePathsNV")]
            public static extern void DeletePath(Int32 path, Int32 range);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glDeletePathsNV")]
            public static extern void DeletePath(UInt32 path, Int32 range);

            /// <summary>[requires: NV_vertex_program]
            /// Deletes a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be deleted.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glDeleteProgramsNV")]
            public static extern void DeleteProgram(Int32 programs);

            /// <summary>[requires: NV_vertex_program]
            /// Deletes a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be deleted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glDeleteProgramsNV")]
            public static extern void DeleteProgram(UInt32 programs);

            /// <summary>[requires: NV_vertex_program]
            /// Deletes a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be deleted.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glDeleteProgramsNV")]
            public static extern void DeleteProgram(Int32 n, Int32[] programs);

            /// <summary>[requires: NV_vertex_program]
            /// Deletes a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be deleted.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glDeleteProgramsNV")]
            public static extern void DeleteProgram(Int32 n, ref Int32 programs);

            /// <summary>[requires: NV_vertex_program]
            /// Deletes a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be deleted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glDeleteProgramsNV")]
            public static extern unsafe void DeleteProgram(Int32 n, Int32* programs);

            /// <summary>[requires: NV_vertex_program]
            /// Deletes a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be deleted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glDeleteProgramsNV")]
            public static extern void DeleteProgram(Int32 n, UInt32[] programs);

            /// <summary>[requires: NV_vertex_program]
            /// Deletes a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be deleted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glDeleteProgramsNV")]
            public static extern void DeleteProgram(Int32 n, ref UInt32 programs);

            /// <summary>[requires: NV_vertex_program]
            /// Deletes a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be deleted.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glDeleteProgramsNV")]
            public static extern unsafe void DeleteProgram(Int32 n, UInt32* programs);

            /// <summary>[requires: NV_transform_feedback2]</summary>
            [AutoGenerated(Category = "NV_transform_feedback2", Version = "", EntryPoint = "glDeleteTransformFeedbacksNV")]
            public static extern void DeleteTransformFeedback(Int32 ids);

            /// <summary>[requires: NV_transform_feedback2]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_transform_feedback2", Version = "", EntryPoint = "glDeleteTransformFeedbacksNV")]
            public static extern void DeleteTransformFeedback(UInt32 ids);

            /// <summary>[requires: NV_transform_feedback2]
            /// Delete transform feedback objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of transform feedback objects to delete.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// Specifies an array of names of transform feedback objects to delete.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_transform_feedback2", Version = "", EntryPoint = "glDeleteTransformFeedbacksNV")]
            public static extern void DeleteTransformFeedbacks(Int32 n, Int32[] ids);

            /// <summary>[requires: NV_transform_feedback2]
            /// Delete transform feedback objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of transform feedback objects to delete.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// Specifies an array of names of transform feedback objects to delete.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_transform_feedback2", Version = "", EntryPoint = "glDeleteTransformFeedbacksNV")]
            public static extern void DeleteTransformFeedbacks(Int32 n, ref Int32 ids);

            /// <summary>[requires: NV_transform_feedback2]
            /// Delete transform feedback objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of transform feedback objects to delete.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// Specifies an array of names of transform feedback objects to delete.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_transform_feedback2", Version = "", EntryPoint = "glDeleteTransformFeedbacksNV")]
            public static extern unsafe void DeleteTransformFeedbacks(Int32 n, Int32* ids);

            /// <summary>[requires: NV_transform_feedback2]
            /// Delete transform feedback objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of transform feedback objects to delete.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// Specifies an array of names of transform feedback objects to delete.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_transform_feedback2", Version = "", EntryPoint = "glDeleteTransformFeedbacksNV")]
            public static extern void DeleteTransformFeedbacks(Int32 n, UInt32[] ids);

            /// <summary>[requires: NV_transform_feedback2]
            /// Delete transform feedback objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of transform feedback objects to delete.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// Specifies an array of names of transform feedback objects to delete.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_transform_feedback2", Version = "", EntryPoint = "glDeleteTransformFeedbacksNV")]
            public static extern void DeleteTransformFeedbacks(Int32 n, ref UInt32 ids);

            /// <summary>[requires: NV_transform_feedback2]
            /// Delete transform feedback objects
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of transform feedback objects to delete.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// Specifies an array of names of transform feedback objects to delete.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_transform_feedback2", Version = "", EntryPoint = "glDeleteTransformFeedbacksNV")]
            public static extern unsafe void DeleteTransformFeedbacks(Int32 n, UInt32* ids);

            /// <summary>[requires: NV_depth_buffer_float]</summary>
            [AutoGenerated(Category = "NV_depth_buffer_float", Version = "", EntryPoint = "glDepthBoundsdNV")]
            public static extern void DepthBounds(Double zmin, Double zmax);

            /// <summary>[requires: NV_depth_buffer_float]
            /// Specify mapping of depth values from normalized device coordinates to window coordinates
            /// </summary>
            /// <param name="nearVal">
            /// <para>
            /// Specifies the mapping of the near clipping plane to window coordinates. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="farVal">
            /// <para>
            /// Specifies the mapping of the far clipping plane to window coordinates. The initial value is 1.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_depth_buffer_float", Version = "", EntryPoint = "glDepthRangedNV")]
            public static extern void DepthRange(Double zNear, Double zFar);

            /// <summary>[requires: NV_draw_texture]</summary>
            [AutoGenerated(Category = "NV_draw_texture", Version = "", EntryPoint = "glDrawTextureNV")]
            public static extern void DrawTexture(Int32 texture, Int32 sampler, Single x0, Single y0, Single x1, Single y1, Single z, Single s0, Single t0, Single s1, Single t1);

            /// <summary>[requires: NV_draw_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_draw_texture", Version = "", EntryPoint = "glDrawTextureNV")]
            public static extern void DrawTexture(UInt32 texture, UInt32 sampler, Single x0, Single y0, Single x1, Single y1, Single z, Single s0, Single t0, Single s1, Single t1);

            /// <summary>[requires: NV_transform_feedback2]
            /// Render primitives using a count derived from a transform feedback object
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="id">
            /// <para>
            /// Specifies the name of a transform feedback object from which to retrieve a primitive count.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "NV_transform_feedback2", Version = "", EntryPoint = "glDrawTransformFeedbackNV")]
            public static extern void DrawTransformFeedback(OpenTK.Graphics.OpenGL.NvTransformFeedback2 mode, Int32 id);

            /// <summary>[requires: NV_transform_feedback2]
            /// Render primitives using a count derived from a transform feedback object
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="id">
            /// <para>
            /// Specifies the name of a transform feedback object from which to retrieve a primitive count.
            /// </para>
            /// </param>
            [Obsolete("Use PrimitiveType overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_transform_feedback2", Version = "", EntryPoint = "glDrawTransformFeedbackNV")]
            public static extern void DrawTransformFeedback(OpenTK.Graphics.OpenGL.NvTransformFeedback2 mode, UInt32 id);

            /// <summary>[requires: NV_transform_feedback2]
            /// Render primitives using a count derived from a transform feedback object
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="id">
            /// <para>
            /// Specifies the name of a transform feedback object from which to retrieve a primitive count.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_transform_feedback2", Version = "", EntryPoint = "glDrawTransformFeedbackNV")]
            public static extern void DrawTransformFeedback(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 id);

            /// <summary>[requires: NV_transform_feedback2]
            /// Render primitives using a count derived from a transform feedback object
            /// </summary>
            /// <param name="mode">
            /// <para>
            /// Specifies what kind of primitives to render. Symbolic constants GL_POINTS, GL_LINE_STRIP, GL_LINE_LOOP, GL_LINES, GL_LINE_STRIP_ADJACENCY, GL_LINES_ADJACENCY, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_TRIANGLES, GL_TRIANGLE_STRIP_ADJACENCY, GL_TRIANGLES_ADJACENCY, and GL_PATCHES are accepted.
            /// </para>
            /// </param>
            /// <param name="id">
            /// <para>
            /// Specifies the name of a transform feedback object from which to retrieve a primitive count.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_transform_feedback2", Version = "", EntryPoint = "glDrawTransformFeedbackNV")]
            public static extern void DrawTransformFeedback(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 id);

            /// <summary>[requires: NV_vertex_buffer_unified_memory]</summary>
            [AutoGenerated(Category = "NV_vertex_buffer_unified_memory", Version = "", EntryPoint = "glEdgeFlagFormatNV")]
            public static extern void EdgeFlagFormat(Int32 stride);

            /// <summary>[requires: NV_conditional_render]</summary>
            [AutoGenerated(Category = "NV_conditional_render", Version = "", EntryPoint = "glEndConditionalRenderNV")]
            public static extern void EndConditionalRender();

            /// <summary>[requires: NV_occlusion_query]</summary>
            [AutoGenerated(Category = "NV_occlusion_query", Version = "", EntryPoint = "glEndOcclusionQueryNV")]
            public static extern void EndOcclusionQuery();

            /// <summary>[requires: NV_transform_feedback]</summary>
            [AutoGenerated(Category = "NV_transform_feedback", Version = "", EntryPoint = "glEndTransformFeedbackNV")]
            public static extern void EndTransformFeedback();

            /// <summary>[requires: NV_video_capture]</summary>
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glEndVideoCaptureNV")]
            public static extern void EndVideoCapture(Int32 video_capture_slot);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glEndVideoCaptureNV")]
            public static extern void EndVideoCapture(UInt32 video_capture_slot);

            /// <summary>[requires: NV_evaluators]</summary>
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glEvalMapsNV")]
            public static extern void EvalMap(OpenTK.Graphics.OpenGL.NvEvaluators target, OpenTK.Graphics.OpenGL.NvEvaluators mode);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glExecuteProgramNV")]
            public static extern void ExecuteProgram(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 id, Single[] @params);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glExecuteProgramNV")]
            public static extern void ExecuteProgram(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 id, ref Single @params);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glExecuteProgramNV")]
            public static extern unsafe void ExecuteProgram(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 id, Single* @params);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glExecuteProgramNV")]
            public static extern void ExecuteProgram(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 id, Single[] @params);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glExecuteProgramNV")]
            public static extern void ExecuteProgram(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 id, ref Single @params);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glExecuteProgramNV")]
            public static extern unsafe void ExecuteProgram(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 id, Single* @params);

            /// <summary>[requires: NV_register_combiners]</summary>
            [AutoGenerated(Category = "NV_register_combiners", Version = "", EntryPoint = "glFinalCombinerInputNV")]
            public static extern void FinalCombinerInput(OpenTK.Graphics.OpenGL.NvRegisterCombiners variable, OpenTK.Graphics.OpenGL.NvRegisterCombiners input, OpenTK.Graphics.OpenGL.NvRegisterCombiners mapping, OpenTK.Graphics.OpenGL.NvRegisterCombiners componentUsage);

            /// <summary>[requires: NV_fence]</summary>
            [AutoGenerated(Category = "NV_fence", Version = "", EntryPoint = "glFinishFenceNV")]
            public static extern void FinishFence(Int32 fence);

            /// <summary>[requires: NV_fence]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fence", Version = "", EntryPoint = "glFinishFenceNV")]
            public static extern void FinishFence(UInt32 fence);

            /// <summary>[requires: NV_pixel_data_range]</summary>
            [AutoGenerated(Category = "NV_pixel_data_range", Version = "", EntryPoint = "glFlushPixelDataRangeNV")]
            public static extern void FlushPixelDataRange(OpenTK.Graphics.OpenGL.NvPixelDataRange target);

            /// <summary>[requires: NV_vertex_array_range]</summary>
            [AutoGenerated(Category = "NV_vertex_array_range", Version = "", EntryPoint = "glFlushVertexArrayRangeNV")]
            public static extern void FlushVertexArrayRange();

            /// <summary>[requires: NV_vertex_buffer_unified_memory]</summary>
            [AutoGenerated(Category = "NV_vertex_buffer_unified_memory", Version = "", EntryPoint = "glFogCoordFormatNV")]
            public static extern void FogCoordFormat(OpenTK.Graphics.OpenGL.NvVertexBufferUnifiedMemory type, Int32 stride);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glFogCoordhNV")]
            public static extern void FogCoordh(Half fog);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glFogCoordhvNV")]
            public static extern unsafe void FogCoordh(Half* fog);

            /// <summary>[requires: NV_fence]</summary>
            [AutoGenerated(Category = "NV_fence", Version = "", EntryPoint = "glGenFencesNV")]
            public static extern Int32 GenFence();

            /// <summary>[requires: NV_fence]</summary>
            [AutoGenerated(Category = "NV_fence", Version = "", EntryPoint = "glGenFencesNV")]
            public static extern void GenFences(Int32 n, [OutAttribute] Int32[] fences);

            /// <summary>[requires: NV_fence]</summary>
            [AutoGenerated(Category = "NV_fence", Version = "", EntryPoint = "glGenFencesNV")]
            public static extern void GenFences(Int32 n, [OutAttribute] out Int32 fences);

            /// <summary>[requires: NV_fence]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fence", Version = "", EntryPoint = "glGenFencesNV")]
            public static extern unsafe void GenFences(Int32 n, [OutAttribute] Int32* fences);

            /// <summary>[requires: NV_fence]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fence", Version = "", EntryPoint = "glGenFencesNV")]
            public static extern void GenFences(Int32 n, [OutAttribute] UInt32[] fences);

            /// <summary>[requires: NV_fence]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fence", Version = "", EntryPoint = "glGenFencesNV")]
            public static extern void GenFences(Int32 n, [OutAttribute] out UInt32 fences);

            /// <summary>[requires: NV_fence]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fence", Version = "", EntryPoint = "glGenFencesNV")]
            public static extern unsafe void GenFences(Int32 n, [OutAttribute] UInt32* fences);

            /// <summary>[requires: NV_occlusion_query]</summary>
            [AutoGenerated(Category = "NV_occlusion_query", Version = "", EntryPoint = "glGenOcclusionQueriesNV")]
            public static extern Int32 GenOcclusionQuery();

            /// <summary>[requires: NV_occlusion_query]</summary>
            [AutoGenerated(Category = "NV_occlusion_query", Version = "", EntryPoint = "glGenOcclusionQueriesNV")]
            public static extern void GenOcclusionQueries(Int32 n, [OutAttribute] Int32[] ids);

            /// <summary>[requires: NV_occlusion_query]</summary>
            [AutoGenerated(Category = "NV_occlusion_query", Version = "", EntryPoint = "glGenOcclusionQueriesNV")]
            public static extern void GenOcclusionQueries(Int32 n, [OutAttribute] out Int32 ids);

            /// <summary>[requires: NV_occlusion_query]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_occlusion_query", Version = "", EntryPoint = "glGenOcclusionQueriesNV")]
            public static extern unsafe void GenOcclusionQueries(Int32 n, [OutAttribute] Int32* ids);

            /// <summary>[requires: NV_occlusion_query]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_occlusion_query", Version = "", EntryPoint = "glGenOcclusionQueriesNV")]
            public static extern void GenOcclusionQueries(Int32 n, [OutAttribute] UInt32[] ids);

            /// <summary>[requires: NV_occlusion_query]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_occlusion_query", Version = "", EntryPoint = "glGenOcclusionQueriesNV")]
            public static extern void GenOcclusionQueries(Int32 n, [OutAttribute] out UInt32 ids);

            /// <summary>[requires: NV_occlusion_query]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_occlusion_query", Version = "", EntryPoint = "glGenOcclusionQueriesNV")]
            public static extern unsafe void GenOcclusionQueries(Int32 n, [OutAttribute] UInt32* ids);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGenPathsNV")]
            public static extern Int32 GenPath(Int32 range);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGenProgramsNV")]
            public static extern Int32 GenProgram();

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGenProgramsNV")]
            public static extern void GenProgram(Int32 n, [OutAttribute] Int32[] programs);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGenProgramsNV")]
            public static extern void GenProgram(Int32 n, [OutAttribute] out Int32 programs);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGenProgramsNV")]
            public static extern unsafe void GenProgram(Int32 n, [OutAttribute] Int32* programs);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGenProgramsNV")]
            public static extern void GenProgram(Int32 n, [OutAttribute] UInt32[] programs);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGenProgramsNV")]
            public static extern void GenProgram(Int32 n, [OutAttribute] out UInt32 programs);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGenProgramsNV")]
            public static extern unsafe void GenProgram(Int32 n, [OutAttribute] UInt32* programs);

            /// <summary>[requires: NV_transform_feedback2]</summary>
            [AutoGenerated(Category = "NV_transform_feedback2", Version = "", EntryPoint = "glGenTransformFeedbacksNV")]
            public static extern Int32 GenTransformFeedback();

            /// <summary>[requires: NV_transform_feedback2]
            /// Reserve transform feedback object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of transform feedback object names to reserve.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// Specifies an array of into which the reserved names will be written.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_transform_feedback2", Version = "", EntryPoint = "glGenTransformFeedbacksNV")]
            public static extern void GenTransformFeedbacks(Int32 n, [OutAttribute] Int32[] ids);

            /// <summary>[requires: NV_transform_feedback2]
            /// Reserve transform feedback object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of transform feedback object names to reserve.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// Specifies an array of into which the reserved names will be written.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_transform_feedback2", Version = "", EntryPoint = "glGenTransformFeedbacksNV")]
            public static extern void GenTransformFeedbacks(Int32 n, [OutAttribute] out Int32 ids);

            /// <summary>[requires: NV_transform_feedback2]
            /// Reserve transform feedback object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of transform feedback object names to reserve.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// Specifies an array of into which the reserved names will be written.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_transform_feedback2", Version = "", EntryPoint = "glGenTransformFeedbacksNV")]
            public static extern unsafe void GenTransformFeedbacks(Int32 n, [OutAttribute] Int32* ids);

            /// <summary>[requires: NV_transform_feedback2]
            /// Reserve transform feedback object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of transform feedback object names to reserve.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// Specifies an array of into which the reserved names will be written.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_transform_feedback2", Version = "", EntryPoint = "glGenTransformFeedbacksNV")]
            public static extern void GenTransformFeedbacks(Int32 n, [OutAttribute] UInt32[] ids);

            /// <summary>[requires: NV_transform_feedback2]
            /// Reserve transform feedback object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of transform feedback object names to reserve.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// Specifies an array of into which the reserved names will be written.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_transform_feedback2", Version = "", EntryPoint = "glGenTransformFeedbacksNV")]
            public static extern void GenTransformFeedbacks(Int32 n, [OutAttribute] out UInt32 ids);

            /// <summary>[requires: NV_transform_feedback2]
            /// Reserve transform feedback object names
            /// </summary>
            /// <param name="n">
            /// <para>
            /// Specifies the number of transform feedback object names to reserve.
            /// </para>
            /// </param>
            /// <param name="ids">
            /// <para>
            /// Specifies an array of into which the reserved names will be written.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_transform_feedback2", Version = "", EntryPoint = "glGenTransformFeedbacksNV")]
            public static extern unsafe void GenTransformFeedbacks(Int32 n, [OutAttribute] UInt32* ids);

            /// <summary>[requires: NV_transform_feedback]</summary>
            [AutoGenerated(Category = "NV_transform_feedback", Version = "", EntryPoint = "glGetActiveVaryingNV")]
            public static extern void GetActiveVarying(Int32 program, Int32 index, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] out Int32 size, [OutAttribute] out OpenTK.Graphics.OpenGL.NvTransformFeedback type, [OutAttribute] StringBuilder name);

            /// <summary>[requires: NV_transform_feedback]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_transform_feedback", Version = "", EntryPoint = "glGetActiveVaryingNV")]
            public static extern unsafe void GetActiveVarying(Int32 program, Int32 index, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] Int32* size, [OutAttribute] OpenTK.Graphics.OpenGL.NvTransformFeedback* type, [OutAttribute] StringBuilder name);

            /// <summary>[requires: NV_transform_feedback]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_transform_feedback", Version = "", EntryPoint = "glGetActiveVaryingNV")]
            public static extern void GetActiveVarying(UInt32 program, UInt32 index, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] out Int32 size, [OutAttribute] out OpenTK.Graphics.OpenGL.NvTransformFeedback type, [OutAttribute] StringBuilder name);

            /// <summary>[requires: NV_transform_feedback]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_transform_feedback", Version = "", EntryPoint = "glGetActiveVaryingNV")]
            public static extern unsafe void GetActiveVarying(UInt32 program, UInt32 index, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] Int32* size, [OutAttribute] OpenTK.Graphics.OpenGL.NvTransformFeedback* type, [OutAttribute] StringBuilder name);

            /// <summary>[requires: NV_shader_buffer_load]
            /// Return parameters of a buffer object
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// Specifies the symbolic name of a buffer object parameter. Accepted values are GL_BUFFER_ACCESS, GL_BUFFER_MAPPED, GL_BUFFER_SIZE, or GL_BUFFER_USAGE.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Returns the requested parameter.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glGetBufferParameterui64vNV")]
            public static extern void GetBufferParameter(OpenTK.Graphics.OpenGL.NvShaderBufferLoad target, OpenTK.Graphics.OpenGL.NvShaderBufferLoad pname, [OutAttribute] Int64[] @params);

            /// <summary>[requires: NV_shader_buffer_load]
            /// Return parameters of a buffer object
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// Specifies the symbolic name of a buffer object parameter. Accepted values are GL_BUFFER_ACCESS, GL_BUFFER_MAPPED, GL_BUFFER_SIZE, or GL_BUFFER_USAGE.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Returns the requested parameter.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glGetBufferParameterui64vNV")]
            public static extern void GetBufferParameter(OpenTK.Graphics.OpenGL.NvShaderBufferLoad target, OpenTK.Graphics.OpenGL.NvShaderBufferLoad pname, [OutAttribute] out Int64 @params);

            /// <summary>[requires: NV_shader_buffer_load]
            /// Return parameters of a buffer object
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// Specifies the symbolic name of a buffer object parameter. Accepted values are GL_BUFFER_ACCESS, GL_BUFFER_MAPPED, GL_BUFFER_SIZE, or GL_BUFFER_USAGE.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Returns the requested parameter.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glGetBufferParameterui64vNV")]
            public static extern unsafe void GetBufferParameter(OpenTK.Graphics.OpenGL.NvShaderBufferLoad target, OpenTK.Graphics.OpenGL.NvShaderBufferLoad pname, [OutAttribute] Int64* @params);

            /// <summary>[requires: NV_shader_buffer_load]
            /// Return parameters of a buffer object
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// Specifies the symbolic name of a buffer object parameter. Accepted values are GL_BUFFER_ACCESS, GL_BUFFER_MAPPED, GL_BUFFER_SIZE, or GL_BUFFER_USAGE.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Returns the requested parameter.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glGetBufferParameterui64vNV")]
            public static extern void GetBufferParameter(OpenTK.Graphics.OpenGL.NvShaderBufferLoad target, OpenTK.Graphics.OpenGL.NvShaderBufferLoad pname, [OutAttribute] UInt64[] @params);

            /// <summary>[requires: NV_shader_buffer_load]
            /// Return parameters of a buffer object
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// Specifies the symbolic name of a buffer object parameter. Accepted values are GL_BUFFER_ACCESS, GL_BUFFER_MAPPED, GL_BUFFER_SIZE, or GL_BUFFER_USAGE.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Returns the requested parameter.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glGetBufferParameterui64vNV")]
            public static extern void GetBufferParameter(OpenTK.Graphics.OpenGL.NvShaderBufferLoad target, OpenTK.Graphics.OpenGL.NvShaderBufferLoad pname, [OutAttribute] out UInt64 @params);

            /// <summary>[requires: NV_shader_buffer_load]
            /// Return parameters of a buffer object
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the target buffer object. The symbolic constant must be GL_ARRAY_BUFFER, GL_ATOMIC_COUNTER_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_DRAW_INDIRECT_BUFFER, GL_DISPATCH_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_QUERY_BUFFER, GL_SHADER_STORAGE_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// Specifies the symbolic name of a buffer object parameter. Accepted values are GL_BUFFER_ACCESS, GL_BUFFER_MAPPED, GL_BUFFER_SIZE, or GL_BUFFER_USAGE.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Returns the requested parameter.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glGetBufferParameterui64vNV")]
            public static extern unsafe void GetBufferParameter(OpenTK.Graphics.OpenGL.NvShaderBufferLoad target, OpenTK.Graphics.OpenGL.NvShaderBufferLoad pname, [OutAttribute] UInt64* @params);

            /// <summary>[requires: NV_register_combiners]</summary>
            [AutoGenerated(Category = "NV_register_combiners", Version = "", EntryPoint = "glGetCombinerInputParameterfvNV")]
            public static extern void GetCombinerInputParameter(OpenTK.Graphics.OpenGL.NvRegisterCombiners stage, OpenTK.Graphics.OpenGL.NvRegisterCombiners portion, OpenTK.Graphics.OpenGL.NvRegisterCombiners variable, OpenTK.Graphics.OpenGL.NvRegisterCombiners pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: NV_register_combiners]</summary>
            [AutoGenerated(Category = "NV_register_combiners", Version = "", EntryPoint = "glGetCombinerInputParameterfvNV")]
            public static extern void GetCombinerInputParameter(OpenTK.Graphics.OpenGL.NvRegisterCombiners stage, OpenTK.Graphics.OpenGL.NvRegisterCombiners portion, OpenTK.Graphics.OpenGL.NvRegisterCombiners variable, OpenTK.Graphics.OpenGL.NvRegisterCombiners pname, [OutAttribute] out Single @params);

            /// <summary>[requires: NV_register_combiners]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_register_combiners", Version = "", EntryPoint = "glGetCombinerInputParameterfvNV")]
            public static extern unsafe void GetCombinerInputParameter(OpenTK.Graphics.OpenGL.NvRegisterCombiners stage, OpenTK.Graphics.OpenGL.NvRegisterCombiners portion, OpenTK.Graphics.OpenGL.NvRegisterCombiners variable, OpenTK.Graphics.OpenGL.NvRegisterCombiners pname, [OutAttribute] Single* @params);

            /// <summary>[requires: NV_register_combiners]</summary>
            [AutoGenerated(Category = "NV_register_combiners", Version = "", EntryPoint = "glGetCombinerInputParameterivNV")]
            public static extern void GetCombinerInputParameter(OpenTK.Graphics.OpenGL.NvRegisterCombiners stage, OpenTK.Graphics.OpenGL.NvRegisterCombiners portion, OpenTK.Graphics.OpenGL.NvRegisterCombiners variable, OpenTK.Graphics.OpenGL.NvRegisterCombiners pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: NV_register_combiners]</summary>
            [AutoGenerated(Category = "NV_register_combiners", Version = "", EntryPoint = "glGetCombinerInputParameterivNV")]
            public static extern void GetCombinerInputParameter(OpenTK.Graphics.OpenGL.NvRegisterCombiners stage, OpenTK.Graphics.OpenGL.NvRegisterCombiners portion, OpenTK.Graphics.OpenGL.NvRegisterCombiners variable, OpenTK.Graphics.OpenGL.NvRegisterCombiners pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: NV_register_combiners]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_register_combiners", Version = "", EntryPoint = "glGetCombinerInputParameterivNV")]
            public static extern unsafe void GetCombinerInputParameter(OpenTK.Graphics.OpenGL.NvRegisterCombiners stage, OpenTK.Graphics.OpenGL.NvRegisterCombiners portion, OpenTK.Graphics.OpenGL.NvRegisterCombiners variable, OpenTK.Graphics.OpenGL.NvRegisterCombiners pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: NV_register_combiners]</summary>
            [AutoGenerated(Category = "NV_register_combiners", Version = "", EntryPoint = "glGetCombinerOutputParameterfvNV")]
            public static extern void GetCombinerOutputParameter(OpenTK.Graphics.OpenGL.NvRegisterCombiners stage, OpenTK.Graphics.OpenGL.NvRegisterCombiners portion, OpenTK.Graphics.OpenGL.NvRegisterCombiners pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: NV_register_combiners]</summary>
            [AutoGenerated(Category = "NV_register_combiners", Version = "", EntryPoint = "glGetCombinerOutputParameterfvNV")]
            public static extern void GetCombinerOutputParameter(OpenTK.Graphics.OpenGL.NvRegisterCombiners stage, OpenTK.Graphics.OpenGL.NvRegisterCombiners portion, OpenTK.Graphics.OpenGL.NvRegisterCombiners pname, [OutAttribute] out Single @params);

            /// <summary>[requires: NV_register_combiners]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_register_combiners", Version = "", EntryPoint = "glGetCombinerOutputParameterfvNV")]
            public static extern unsafe void GetCombinerOutputParameter(OpenTK.Graphics.OpenGL.NvRegisterCombiners stage, OpenTK.Graphics.OpenGL.NvRegisterCombiners portion, OpenTK.Graphics.OpenGL.NvRegisterCombiners pname, [OutAttribute] Single* @params);

            /// <summary>[requires: NV_register_combiners]</summary>
            [AutoGenerated(Category = "NV_register_combiners", Version = "", EntryPoint = "glGetCombinerOutputParameterivNV")]
            public static extern void GetCombinerOutputParameter(OpenTK.Graphics.OpenGL.NvRegisterCombiners stage, OpenTK.Graphics.OpenGL.NvRegisterCombiners portion, OpenTK.Graphics.OpenGL.NvRegisterCombiners pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: NV_register_combiners]</summary>
            [AutoGenerated(Category = "NV_register_combiners", Version = "", EntryPoint = "glGetCombinerOutputParameterivNV")]
            public static extern void GetCombinerOutputParameter(OpenTK.Graphics.OpenGL.NvRegisterCombiners stage, OpenTK.Graphics.OpenGL.NvRegisterCombiners portion, OpenTK.Graphics.OpenGL.NvRegisterCombiners pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: NV_register_combiners]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_register_combiners", Version = "", EntryPoint = "glGetCombinerOutputParameterivNV")]
            public static extern unsafe void GetCombinerOutputParameter(OpenTK.Graphics.OpenGL.NvRegisterCombiners stage, OpenTK.Graphics.OpenGL.NvRegisterCombiners portion, OpenTK.Graphics.OpenGL.NvRegisterCombiners pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: NV_register_combiners2]</summary>
            [AutoGenerated(Category = "NV_register_combiners2", Version = "", EntryPoint = "glGetCombinerStageParameterfvNV")]
            public static extern void GetCombinerStageParameter(OpenTK.Graphics.OpenGL.NvRegisterCombiners2 stage, OpenTK.Graphics.OpenGL.NvRegisterCombiners2 pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: NV_register_combiners2]</summary>
            [AutoGenerated(Category = "NV_register_combiners2", Version = "", EntryPoint = "glGetCombinerStageParameterfvNV")]
            public static extern void GetCombinerStageParameter(OpenTK.Graphics.OpenGL.NvRegisterCombiners2 stage, OpenTK.Graphics.OpenGL.NvRegisterCombiners2 pname, [OutAttribute] out Single @params);

            /// <summary>[requires: NV_register_combiners2]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_register_combiners2", Version = "", EntryPoint = "glGetCombinerStageParameterfvNV")]
            public static extern unsafe void GetCombinerStageParameter(OpenTK.Graphics.OpenGL.NvRegisterCombiners2 stage, OpenTK.Graphics.OpenGL.NvRegisterCombiners2 pname, [OutAttribute] Single* @params);

            /// <summary>[requires: NV_fence]</summary>
            [AutoGenerated(Category = "NV_fence", Version = "", EntryPoint = "glGetFenceivNV")]
            public static extern void GetFence(Int32 fence, OpenTK.Graphics.OpenGL.NvFence pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: NV_fence]</summary>
            [AutoGenerated(Category = "NV_fence", Version = "", EntryPoint = "glGetFenceivNV")]
            public static extern void GetFence(Int32 fence, OpenTK.Graphics.OpenGL.NvFence pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: NV_fence]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fence", Version = "", EntryPoint = "glGetFenceivNV")]
            public static extern unsafe void GetFence(Int32 fence, OpenTK.Graphics.OpenGL.NvFence pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: NV_fence]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fence", Version = "", EntryPoint = "glGetFenceivNV")]
            public static extern void GetFence(UInt32 fence, OpenTK.Graphics.OpenGL.NvFence pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: NV_fence]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fence", Version = "", EntryPoint = "glGetFenceivNV")]
            public static extern void GetFence(UInt32 fence, OpenTK.Graphics.OpenGL.NvFence pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: NV_fence]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fence", Version = "", EntryPoint = "glGetFenceivNV")]
            public static extern unsafe void GetFence(UInt32 fence, OpenTK.Graphics.OpenGL.NvFence pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: NV_register_combiners]</summary>
            [AutoGenerated(Category = "NV_register_combiners", Version = "", EntryPoint = "glGetFinalCombinerInputParameterfvNV")]
            public static extern void GetFinalCombinerInputParameter(OpenTK.Graphics.OpenGL.NvRegisterCombiners variable, OpenTK.Graphics.OpenGL.NvRegisterCombiners pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: NV_register_combiners]</summary>
            [AutoGenerated(Category = "NV_register_combiners", Version = "", EntryPoint = "glGetFinalCombinerInputParameterfvNV")]
            public static extern void GetFinalCombinerInputParameter(OpenTK.Graphics.OpenGL.NvRegisterCombiners variable, OpenTK.Graphics.OpenGL.NvRegisterCombiners pname, [OutAttribute] out Single @params);

            /// <summary>[requires: NV_register_combiners]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_register_combiners", Version = "", EntryPoint = "glGetFinalCombinerInputParameterfvNV")]
            public static extern unsafe void GetFinalCombinerInputParameter(OpenTK.Graphics.OpenGL.NvRegisterCombiners variable, OpenTK.Graphics.OpenGL.NvRegisterCombiners pname, [OutAttribute] Single* @params);

            /// <summary>[requires: NV_register_combiners]</summary>
            [AutoGenerated(Category = "NV_register_combiners", Version = "", EntryPoint = "glGetFinalCombinerInputParameterivNV")]
            public static extern void GetFinalCombinerInputParameter(OpenTK.Graphics.OpenGL.NvRegisterCombiners variable, OpenTK.Graphics.OpenGL.NvRegisterCombiners pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: NV_register_combiners]</summary>
            [AutoGenerated(Category = "NV_register_combiners", Version = "", EntryPoint = "glGetFinalCombinerInputParameterivNV")]
            public static extern void GetFinalCombinerInputParameter(OpenTK.Graphics.OpenGL.NvRegisterCombiners variable, OpenTK.Graphics.OpenGL.NvRegisterCombiners pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: NV_register_combiners]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_register_combiners", Version = "", EntryPoint = "glGetFinalCombinerInputParameterivNV")]
            public static extern unsafe void GetFinalCombinerInputParameter(OpenTK.Graphics.OpenGL.NvRegisterCombiners variable, OpenTK.Graphics.OpenGL.NvRegisterCombiners pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: NV_bindless_texture]</summary>
            [AutoGenerated(Category = "NV_bindless_texture", Version = "", EntryPoint = "glGetImageHandleNV")]
            public static extern Int64 GetImageHandle(Int32 texture, Int32 level, bool layered, Int32 layer, OpenTK.Graphics.OpenGL.NvBindlessTexture format);

            /// <summary>[requires: NV_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_bindless_texture", Version = "", EntryPoint = "glGetImageHandleNV")]
            public static extern Int64 GetImageHandle(UInt32 texture, Int32 level, bool layered, Int32 layer, OpenTK.Graphics.OpenGL.NvBindlessTexture format);

            /// <summary>[requires: NV_vertex_buffer_unified_memory]</summary>
            [AutoGenerated(Category = "NV_vertex_buffer_unified_memory", Version = "", EntryPoint = "glGetIntegerui64i_vNV")]
            public static extern void GetIntegerui64(OpenTK.Graphics.OpenGL.NvVertexBufferUnifiedMemory value, Int32 index, [OutAttribute] Int64[] result);

            /// <summary>[requires: NV_vertex_buffer_unified_memory]</summary>
            [AutoGenerated(Category = "NV_vertex_buffer_unified_memory", Version = "", EntryPoint = "glGetIntegerui64i_vNV")]
            public static extern void GetIntegerui64(OpenTK.Graphics.OpenGL.NvVertexBufferUnifiedMemory value, Int32 index, [OutAttribute] out Int64 result);

            /// <summary>[requires: NV_vertex_buffer_unified_memory]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_buffer_unified_memory", Version = "", EntryPoint = "glGetIntegerui64i_vNV")]
            public static extern unsafe void GetIntegerui64(OpenTK.Graphics.OpenGL.NvVertexBufferUnifiedMemory value, Int32 index, [OutAttribute] Int64* result);

            /// <summary>[requires: NV_vertex_buffer_unified_memory]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_buffer_unified_memory", Version = "", EntryPoint = "glGetIntegerui64i_vNV")]
            public static extern void GetIntegerui64(OpenTK.Graphics.OpenGL.NvVertexBufferUnifiedMemory value, UInt32 index, [OutAttribute] UInt64[] result);

            /// <summary>[requires: NV_vertex_buffer_unified_memory]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_buffer_unified_memory", Version = "", EntryPoint = "glGetIntegerui64i_vNV")]
            public static extern void GetIntegerui64(OpenTK.Graphics.OpenGL.NvVertexBufferUnifiedMemory value, UInt32 index, [OutAttribute] out UInt64 result);

            /// <summary>[requires: NV_vertex_buffer_unified_memory]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_buffer_unified_memory", Version = "", EntryPoint = "glGetIntegerui64i_vNV")]
            public static extern unsafe void GetIntegerui64(OpenTK.Graphics.OpenGL.NvVertexBufferUnifiedMemory value, UInt32 index, [OutAttribute] UInt64* result);

            /// <summary>[requires: NV_shader_buffer_load]</summary>
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glGetIntegerui64vNV")]
            public static extern Int64 GetInteger(OpenTK.Graphics.OpenGL.NvShaderBufferLoad value);

            /// <summary>[requires: NV_shader_buffer_load]</summary>
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glGetIntegerui64vNV")]
            public static extern void GetInteger(OpenTK.Graphics.OpenGL.NvShaderBufferLoad value, [OutAttribute] Int64[] result);

            /// <summary>[requires: NV_shader_buffer_load]</summary>
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glGetIntegerui64vNV")]
            public static extern void GetInteger(OpenTK.Graphics.OpenGL.NvShaderBufferLoad value, [OutAttribute] out Int64 result);

            /// <summary>[requires: NV_shader_buffer_load]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glGetIntegerui64vNV")]
            public static extern unsafe void GetInteger(OpenTK.Graphics.OpenGL.NvShaderBufferLoad value, [OutAttribute] Int64* result);

            /// <summary>[requires: NV_shader_buffer_load]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glGetIntegerui64vNV")]
            public static extern void GetInteger(OpenTK.Graphics.OpenGL.NvShaderBufferLoad value, [OutAttribute] UInt64[] result);

            /// <summary>[requires: NV_shader_buffer_load]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glGetIntegerui64vNV")]
            public static extern void GetInteger(OpenTK.Graphics.OpenGL.NvShaderBufferLoad value, [OutAttribute] out UInt64 result);

            /// <summary>[requires: NV_shader_buffer_load]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glGetIntegerui64vNV")]
            public static extern unsafe void GetInteger(OpenTK.Graphics.OpenGL.NvShaderBufferLoad value, [OutAttribute] UInt64* result);

            /// <summary>[requires: NV_evaluators]</summary>
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glGetMapAttribParameterfvNV")]
            public static extern void GetMapAttribParameter(OpenTK.Graphics.OpenGL.NvEvaluators target, Int32 index, OpenTK.Graphics.OpenGL.NvEvaluators pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: NV_evaluators]</summary>
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glGetMapAttribParameterfvNV")]
            public static extern void GetMapAttribParameter(OpenTK.Graphics.OpenGL.NvEvaluators target, Int32 index, OpenTK.Graphics.OpenGL.NvEvaluators pname, [OutAttribute] out Single @params);

            /// <summary>[requires: NV_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glGetMapAttribParameterfvNV")]
            public static extern unsafe void GetMapAttribParameter(OpenTK.Graphics.OpenGL.NvEvaluators target, Int32 index, OpenTK.Graphics.OpenGL.NvEvaluators pname, [OutAttribute] Single* @params);

            /// <summary>[requires: NV_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glGetMapAttribParameterfvNV")]
            public static extern void GetMapAttribParameter(OpenTK.Graphics.OpenGL.NvEvaluators target, UInt32 index, OpenTK.Graphics.OpenGL.NvEvaluators pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: NV_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glGetMapAttribParameterfvNV")]
            public static extern void GetMapAttribParameter(OpenTK.Graphics.OpenGL.NvEvaluators target, UInt32 index, OpenTK.Graphics.OpenGL.NvEvaluators pname, [OutAttribute] out Single @params);

            /// <summary>[requires: NV_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glGetMapAttribParameterfvNV")]
            public static extern unsafe void GetMapAttribParameter(OpenTK.Graphics.OpenGL.NvEvaluators target, UInt32 index, OpenTK.Graphics.OpenGL.NvEvaluators pname, [OutAttribute] Single* @params);

            /// <summary>[requires: NV_evaluators]</summary>
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glGetMapAttribParameterivNV")]
            public static extern void GetMapAttribParameter(OpenTK.Graphics.OpenGL.NvEvaluators target, Int32 index, OpenTK.Graphics.OpenGL.NvEvaluators pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: NV_evaluators]</summary>
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glGetMapAttribParameterivNV")]
            public static extern void GetMapAttribParameter(OpenTK.Graphics.OpenGL.NvEvaluators target, Int32 index, OpenTK.Graphics.OpenGL.NvEvaluators pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: NV_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glGetMapAttribParameterivNV")]
            public static extern unsafe void GetMapAttribParameter(OpenTK.Graphics.OpenGL.NvEvaluators target, Int32 index, OpenTK.Graphics.OpenGL.NvEvaluators pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: NV_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glGetMapAttribParameterivNV")]
            public static extern void GetMapAttribParameter(OpenTK.Graphics.OpenGL.NvEvaluators target, UInt32 index, OpenTK.Graphics.OpenGL.NvEvaluators pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: NV_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glGetMapAttribParameterivNV")]
            public static extern void GetMapAttribParameter(OpenTK.Graphics.OpenGL.NvEvaluators target, UInt32 index, OpenTK.Graphics.OpenGL.NvEvaluators pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: NV_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glGetMapAttribParameterivNV")]
            public static extern unsafe void GetMapAttribParameter(OpenTK.Graphics.OpenGL.NvEvaluators target, UInt32 index, OpenTK.Graphics.OpenGL.NvEvaluators pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: NV_evaluators]</summary>
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glGetMapControlPointsNV")]
            public static extern void GetMapControlPoints(OpenTK.Graphics.OpenGL.NvEvaluators target, Int32 index, OpenTK.Graphics.OpenGL.NvEvaluators type, Int32 ustride, Int32 vstride, bool packed, [OutAttribute] IntPtr points);

            /// <summary>[requires: NV_evaluators]</summary>
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glGetMapControlPointsNV")]
            public static extern void GetMapControlPoints<T6>(OpenTK.Graphics.OpenGL.NvEvaluators target, Int32 index, OpenTK.Graphics.OpenGL.NvEvaluators type, Int32 ustride, Int32 vstride, bool packed, [InAttribute, OutAttribute] T6[] points)
                where T6 : struct
            ;

            /// <summary>[requires: NV_evaluators]</summary>
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glGetMapControlPointsNV")]
            public static extern void GetMapControlPoints<T6>(OpenTK.Graphics.OpenGL.NvEvaluators target, Int32 index, OpenTK.Graphics.OpenGL.NvEvaluators type, Int32 ustride, Int32 vstride, bool packed, [InAttribute, OutAttribute] T6[,] points)
                where T6 : struct
            ;

            /// <summary>[requires: NV_evaluators]</summary>
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glGetMapControlPointsNV")]
            public static extern void GetMapControlPoints<T6>(OpenTK.Graphics.OpenGL.NvEvaluators target, Int32 index, OpenTK.Graphics.OpenGL.NvEvaluators type, Int32 ustride, Int32 vstride, bool packed, [InAttribute, OutAttribute] T6[,,] points)
                where T6 : struct
            ;

            /// <summary>[requires: NV_evaluators]</summary>
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glGetMapControlPointsNV")]
            public static extern void GetMapControlPoints<T6>(OpenTK.Graphics.OpenGL.NvEvaluators target, Int32 index, OpenTK.Graphics.OpenGL.NvEvaluators type, Int32 ustride, Int32 vstride, bool packed, [InAttribute, OutAttribute] ref T6 points)
                where T6 : struct
            ;

            /// <summary>[requires: NV_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glGetMapControlPointsNV")]
            public static extern void GetMapControlPoints(OpenTK.Graphics.OpenGL.NvEvaluators target, UInt32 index, OpenTK.Graphics.OpenGL.NvEvaluators type, Int32 ustride, Int32 vstride, bool packed, [OutAttribute] IntPtr points);

            /// <summary>[requires: NV_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glGetMapControlPointsNV")]
            public static extern void GetMapControlPoints<T6>(OpenTK.Graphics.OpenGL.NvEvaluators target, UInt32 index, OpenTK.Graphics.OpenGL.NvEvaluators type, Int32 ustride, Int32 vstride, bool packed, [InAttribute, OutAttribute] T6[] points)
                where T6 : struct
            ;

            /// <summary>[requires: NV_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glGetMapControlPointsNV")]
            public static extern void GetMapControlPoints<T6>(OpenTK.Graphics.OpenGL.NvEvaluators target, UInt32 index, OpenTK.Graphics.OpenGL.NvEvaluators type, Int32 ustride, Int32 vstride, bool packed, [InAttribute, OutAttribute] T6[,] points)
                where T6 : struct
            ;

            /// <summary>[requires: NV_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glGetMapControlPointsNV")]
            public static extern void GetMapControlPoints<T6>(OpenTK.Graphics.OpenGL.NvEvaluators target, UInt32 index, OpenTK.Graphics.OpenGL.NvEvaluators type, Int32 ustride, Int32 vstride, bool packed, [InAttribute, OutAttribute] T6[,,] points)
                where T6 : struct
            ;

            /// <summary>[requires: NV_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glGetMapControlPointsNV")]
            public static extern void GetMapControlPoints<T6>(OpenTK.Graphics.OpenGL.NvEvaluators target, UInt32 index, OpenTK.Graphics.OpenGL.NvEvaluators type, Int32 ustride, Int32 vstride, bool packed, [InAttribute, OutAttribute] ref T6 points)
                where T6 : struct
            ;

            /// <summary>[requires: NV_evaluators]</summary>
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glGetMapParameterfvNV")]
            public static extern void GetMapParameter(OpenTK.Graphics.OpenGL.NvEvaluators target, OpenTK.Graphics.OpenGL.NvEvaluators pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: NV_evaluators]</summary>
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glGetMapParameterfvNV")]
            public static extern void GetMapParameter(OpenTK.Graphics.OpenGL.NvEvaluators target, OpenTK.Graphics.OpenGL.NvEvaluators pname, [OutAttribute] out Single @params);

            /// <summary>[requires: NV_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glGetMapParameterfvNV")]
            public static extern unsafe void GetMapParameter(OpenTK.Graphics.OpenGL.NvEvaluators target, OpenTK.Graphics.OpenGL.NvEvaluators pname, [OutAttribute] Single* @params);

            /// <summary>[requires: NV_evaluators]</summary>
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glGetMapParameterivNV")]
            public static extern void GetMapParameter(OpenTK.Graphics.OpenGL.NvEvaluators target, OpenTK.Graphics.OpenGL.NvEvaluators pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: NV_evaluators]</summary>
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glGetMapParameterivNV")]
            public static extern void GetMapParameter(OpenTK.Graphics.OpenGL.NvEvaluators target, OpenTK.Graphics.OpenGL.NvEvaluators pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: NV_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glGetMapParameterivNV")]
            public static extern unsafe void GetMapParameter(OpenTK.Graphics.OpenGL.NvEvaluators target, OpenTK.Graphics.OpenGL.NvEvaluators pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: NV_explicit_multisample]
            /// Retrieve the location of a sample
            /// </summary>
            /// <param name="pname">
            /// <para>
            /// Specifies the sample parameter name. pname must be GL_SAMPLE_POSITION.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the sample whose position to query.
            /// </para>
            /// </param>
            /// <param name="val">
            /// <para>
            /// Specifies the address of an array to receive the position of the sample.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_explicit_multisample", Version = "", EntryPoint = "glGetMultisamplefvNV")]
            public static extern void GetMultisample(OpenTK.Graphics.OpenGL.NvExplicitMultisample pname, Int32 index, [OutAttribute] Single[] val);

            /// <summary>[requires: NV_explicit_multisample]
            /// Retrieve the location of a sample
            /// </summary>
            /// <param name="pname">
            /// <para>
            /// Specifies the sample parameter name. pname must be GL_SAMPLE_POSITION.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the sample whose position to query.
            /// </para>
            /// </param>
            /// <param name="val">
            /// <para>
            /// Specifies the address of an array to receive the position of the sample.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_explicit_multisample", Version = "", EntryPoint = "glGetMultisamplefvNV")]
            public static extern void GetMultisample(OpenTK.Graphics.OpenGL.NvExplicitMultisample pname, Int32 index, [OutAttribute] out Single val);

            /// <summary>[requires: NV_explicit_multisample]
            /// Retrieve the location of a sample
            /// </summary>
            /// <param name="pname">
            /// <para>
            /// Specifies the sample parameter name. pname must be GL_SAMPLE_POSITION.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the sample whose position to query.
            /// </para>
            /// </param>
            /// <param name="val">
            /// <para>
            /// Specifies the address of an array to receive the position of the sample.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_explicit_multisample", Version = "", EntryPoint = "glGetMultisamplefvNV")]
            public static extern unsafe void GetMultisample(OpenTK.Graphics.OpenGL.NvExplicitMultisample pname, Int32 index, [OutAttribute] Single* val);

            /// <summary>[requires: NV_explicit_multisample]
            /// Retrieve the location of a sample
            /// </summary>
            /// <param name="pname">
            /// <para>
            /// Specifies the sample parameter name. pname must be GL_SAMPLE_POSITION.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the sample whose position to query.
            /// </para>
            /// </param>
            /// <param name="val">
            /// <para>
            /// Specifies the address of an array to receive the position of the sample.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_explicit_multisample", Version = "", EntryPoint = "glGetMultisamplefvNV")]
            public static extern void GetMultisample(OpenTK.Graphics.OpenGL.NvExplicitMultisample pname, UInt32 index, [OutAttribute] Single[] val);

            /// <summary>[requires: NV_explicit_multisample]
            /// Retrieve the location of a sample
            /// </summary>
            /// <param name="pname">
            /// <para>
            /// Specifies the sample parameter name. pname must be GL_SAMPLE_POSITION.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the sample whose position to query.
            /// </para>
            /// </param>
            /// <param name="val">
            /// <para>
            /// Specifies the address of an array to receive the position of the sample.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_explicit_multisample", Version = "", EntryPoint = "glGetMultisamplefvNV")]
            public static extern void GetMultisample(OpenTK.Graphics.OpenGL.NvExplicitMultisample pname, UInt32 index, [OutAttribute] out Single val);

            /// <summary>[requires: NV_explicit_multisample]
            /// Retrieve the location of a sample
            /// </summary>
            /// <param name="pname">
            /// <para>
            /// Specifies the sample parameter name. pname must be GL_SAMPLE_POSITION.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the sample whose position to query.
            /// </para>
            /// </param>
            /// <param name="val">
            /// <para>
            /// Specifies the address of an array to receive the position of the sample.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_explicit_multisample", Version = "", EntryPoint = "glGetMultisamplefvNV")]
            public static extern unsafe void GetMultisample(OpenTK.Graphics.OpenGL.NvExplicitMultisample pname, UInt32 index, [OutAttribute] Single* val);

            /// <summary>[requires: NV_shader_buffer_load]</summary>
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glGetNamedBufferParameterui64vNV")]
            public static extern void GetNamedBufferParameter(Int32 buffer, OpenTK.Graphics.OpenGL.NvShaderBufferLoad pname, [OutAttribute] Int64[] @params);

            /// <summary>[requires: NV_shader_buffer_load]</summary>
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glGetNamedBufferParameterui64vNV")]
            public static extern void GetNamedBufferParameter(Int32 buffer, OpenTK.Graphics.OpenGL.NvShaderBufferLoad pname, [OutAttribute] out Int64 @params);

            /// <summary>[requires: NV_shader_buffer_load]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glGetNamedBufferParameterui64vNV")]
            public static extern unsafe void GetNamedBufferParameter(Int32 buffer, OpenTK.Graphics.OpenGL.NvShaderBufferLoad pname, [OutAttribute] Int64* @params);

            /// <summary>[requires: NV_shader_buffer_load]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glGetNamedBufferParameterui64vNV")]
            public static extern void GetNamedBufferParameter(UInt32 buffer, OpenTK.Graphics.OpenGL.NvShaderBufferLoad pname, [OutAttribute] UInt64[] @params);

            /// <summary>[requires: NV_shader_buffer_load]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glGetNamedBufferParameterui64vNV")]
            public static extern void GetNamedBufferParameter(UInt32 buffer, OpenTK.Graphics.OpenGL.NvShaderBufferLoad pname, [OutAttribute] out UInt64 @params);

            /// <summary>[requires: NV_shader_buffer_load]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glGetNamedBufferParameterui64vNV")]
            public static extern unsafe void GetNamedBufferParameter(UInt32 buffer, OpenTK.Graphics.OpenGL.NvShaderBufferLoad pname, [OutAttribute] UInt64* @params);

            /// <summary>[requires: NV_occlusion_query]</summary>
            [AutoGenerated(Category = "NV_occlusion_query", Version = "", EntryPoint = "glGetOcclusionQueryivNV")]
            public static extern void GetOcclusionQuery(Int32 id, OpenTK.Graphics.OpenGL.NvOcclusionQuery pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: NV_occlusion_query]</summary>
            [AutoGenerated(Category = "NV_occlusion_query", Version = "", EntryPoint = "glGetOcclusionQueryivNV")]
            public static extern void GetOcclusionQuery(Int32 id, OpenTK.Graphics.OpenGL.NvOcclusionQuery pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: NV_occlusion_query]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_occlusion_query", Version = "", EntryPoint = "glGetOcclusionQueryivNV")]
            public static extern unsafe void GetOcclusionQuery(Int32 id, OpenTK.Graphics.OpenGL.NvOcclusionQuery pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: NV_occlusion_query]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_occlusion_query", Version = "", EntryPoint = "glGetOcclusionQueryivNV")]
            public static extern void GetOcclusionQuery(UInt32 id, OpenTK.Graphics.OpenGL.NvOcclusionQuery pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: NV_occlusion_query]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_occlusion_query", Version = "", EntryPoint = "glGetOcclusionQueryivNV")]
            public static extern void GetOcclusionQuery(UInt32 id, OpenTK.Graphics.OpenGL.NvOcclusionQuery pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: NV_occlusion_query]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_occlusion_query", Version = "", EntryPoint = "glGetOcclusionQueryivNV")]
            public static extern unsafe void GetOcclusionQuery(UInt32 id, OpenTK.Graphics.OpenGL.NvOcclusionQuery pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: NV_occlusion_query]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_occlusion_query", Version = "", EntryPoint = "glGetOcclusionQueryuivNV")]
            public static extern void GetOcclusionQuery(UInt32 id, OpenTK.Graphics.OpenGL.NvOcclusionQuery pname, [OutAttribute] UInt32[] @params);

            /// <summary>[requires: NV_occlusion_query]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_occlusion_query", Version = "", EntryPoint = "glGetOcclusionQueryuivNV")]
            public static extern void GetOcclusionQuery(UInt32 id, OpenTK.Graphics.OpenGL.NvOcclusionQuery pname, [OutAttribute] out UInt32 @params);

            /// <summary>[requires: NV_occlusion_query]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_occlusion_query", Version = "", EntryPoint = "glGetOcclusionQueryuivNV")]
            public static extern unsafe void GetOcclusionQuery(UInt32 id, OpenTK.Graphics.OpenGL.NvOcclusionQuery pname, [OutAttribute] UInt32* @params);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathColorGenfvNV")]
            public static extern void GetPathColorGen(OpenTK.Graphics.OpenGL.NvPathRendering color, OpenTK.Graphics.OpenGL.NvPathRendering pname, [OutAttribute] Single[] value);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathColorGenfvNV")]
            public static extern void GetPathColorGen(OpenTK.Graphics.OpenGL.NvPathRendering color, OpenTK.Graphics.OpenGL.NvPathRendering pname, [OutAttribute] out Single value);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathColorGenfvNV")]
            public static extern unsafe void GetPathColorGen(OpenTK.Graphics.OpenGL.NvPathRendering color, OpenTK.Graphics.OpenGL.NvPathRendering pname, [OutAttribute] Single* value);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathColorGenivNV")]
            public static extern void GetPathColorGen(OpenTK.Graphics.OpenGL.NvPathRendering color, OpenTK.Graphics.OpenGL.NvPathRendering pname, [OutAttribute] Int32[] value);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathColorGenivNV")]
            public static extern void GetPathColorGen(OpenTK.Graphics.OpenGL.NvPathRendering color, OpenTK.Graphics.OpenGL.NvPathRendering pname, [OutAttribute] out Int32 value);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathColorGenivNV")]
            public static extern unsafe void GetPathColorGen(OpenTK.Graphics.OpenGL.NvPathRendering color, OpenTK.Graphics.OpenGL.NvPathRendering pname, [OutAttribute] Int32* value);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathCommandsNV")]
            public static extern Byte GetPathCommand(Int32 path);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathCommandsNV")]
            public static extern Byte GetPathCommand(UInt32 path);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathCommandsNV")]
            public static extern void GetPathCommands(Int32 path, [OutAttribute] Byte[] commands);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathCommandsNV")]
            public static extern void GetPathCommands(Int32 path, [OutAttribute] out Byte commands);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathCommandsNV")]
            public static extern unsafe void GetPathCommands(Int32 path, [OutAttribute] Byte* commands);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathCommandsNV")]
            public static extern void GetPathCommands(UInt32 path, [OutAttribute] Byte[] commands);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathCommandsNV")]
            public static extern void GetPathCommands(UInt32 path, [OutAttribute] out Byte commands);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathCommandsNV")]
            public static extern unsafe void GetPathCommands(UInt32 path, [OutAttribute] Byte* commands);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathCoordsNV")]
            public static extern Single GetPathCoord(Int32 path);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathCoordsNV")]
            public static extern Single GetPathCoord(UInt32 path);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathCoordsNV")]
            public static extern void GetPathCoords(Int32 path, [OutAttribute] Single[] coords);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathCoordsNV")]
            public static extern void GetPathCoords(Int32 path, [OutAttribute] out Single coords);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathCoordsNV")]
            public static extern unsafe void GetPathCoords(Int32 path, [OutAttribute] Single* coords);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathCoordsNV")]
            public static extern void GetPathCoords(UInt32 path, [OutAttribute] Single[] coords);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathCoordsNV")]
            public static extern void GetPathCoords(UInt32 path, [OutAttribute] out Single coords);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathCoordsNV")]
            public static extern unsafe void GetPathCoords(UInt32 path, [OutAttribute] Single* coords);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathDashArrayNV")]
            public static extern Single GetPathDashArray(Int32 path);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathDashArrayNV")]
            public static extern Single GetPathDashArray(UInt32 path);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathDashArrayNV")]
            public static extern void GetPathDashArray(Int32 path, [OutAttribute] Single[] dashArray);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathDashArrayNV")]
            public static extern void GetPathDashArray(Int32 path, [OutAttribute] out Single dashArray);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathDashArrayNV")]
            public static extern unsafe void GetPathDashArray(Int32 path, [OutAttribute] Single* dashArray);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathDashArrayNV")]
            public static extern void GetPathDashArray(UInt32 path, [OutAttribute] Single[] dashArray);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathDashArrayNV")]
            public static extern void GetPathDashArray(UInt32 path, [OutAttribute] out Single dashArray);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathDashArrayNV")]
            public static extern unsafe void GetPathDashArray(UInt32 path, [OutAttribute] Single* dashArray);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathLengthNV")]
            public static extern Single GetPathLength(Int32 path, Int32 startSegment, Int32 numSegments);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathLengthNV")]
            public static extern Single GetPathLength(UInt32 path, Int32 startSegment, Int32 numSegments);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricRangeNV")]
            public static extern void GetPathMetricRange(Int32 metricQueryMask, Int32 firstPathName, Int32 numPaths, Int32 stride, [OutAttribute] Single[] metrics);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricRangeNV")]
            public static extern void GetPathMetricRange(Int32 metricQueryMask, Int32 firstPathName, Int32 numPaths, Int32 stride, [OutAttribute] out Single metrics);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricRangeNV")]
            public static extern unsafe void GetPathMetricRange(Int32 metricQueryMask, Int32 firstPathName, Int32 numPaths, Int32 stride, [OutAttribute] Single* metrics);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricRangeNV")]
            public static extern void GetPathMetricRange(UInt32 metricQueryMask, UInt32 firstPathName, Int32 numPaths, Int32 stride, [OutAttribute] Single[] metrics);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricRangeNV")]
            public static extern void GetPathMetricRange(UInt32 metricQueryMask, UInt32 firstPathName, Int32 numPaths, Int32 stride, [OutAttribute] out Single metrics);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricRangeNV")]
            public static extern unsafe void GetPathMetricRange(UInt32 metricQueryMask, UInt32 firstPathName, Int32 numPaths, Int32 stride, [OutAttribute] Single* metrics);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricsNV")]
            public static extern void GetPathMetric(Int32 metricQueryMask, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, Int32 pathBase, Int32 stride, [OutAttribute] Single[] metrics);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricsNV")]
            public static extern void GetPathMetric(Int32 metricQueryMask, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, Int32 pathBase, Int32 stride, [OutAttribute] out Single metrics);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricsNV")]
            public static extern unsafe void GetPathMetric(Int32 metricQueryMask, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, Int32 pathBase, Int32 stride, [OutAttribute] Single* metrics);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricsNV")]
            public static extern void GetPathMetric<T3>(Int32 metricQueryMask, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[] paths, Int32 pathBase, Int32 stride, [OutAttribute] Single[] metrics)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricsNV")]
            public static extern void GetPathMetric<T3>(Int32 metricQueryMask, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[] paths, Int32 pathBase, Int32 stride, [OutAttribute] out Single metrics)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricsNV")]
            public static extern unsafe void GetPathMetric<T3>(Int32 metricQueryMask, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[] paths, Int32 pathBase, Int32 stride, [OutAttribute] Single* metrics)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricsNV")]
            public static extern void GetPathMetric<T3>(Int32 metricQueryMask, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[,] paths, Int32 pathBase, Int32 stride, [OutAttribute] Single[] metrics)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricsNV")]
            public static extern void GetPathMetric<T3>(Int32 metricQueryMask, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[,] paths, Int32 pathBase, Int32 stride, [OutAttribute] out Single metrics)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricsNV")]
            public static extern unsafe void GetPathMetric<T3>(Int32 metricQueryMask, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[,] paths, Int32 pathBase, Int32 stride, [OutAttribute] Single* metrics)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricsNV")]
            public static extern void GetPathMetric<T3>(Int32 metricQueryMask, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[,,] paths, Int32 pathBase, Int32 stride, [OutAttribute] Single[] metrics)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricsNV")]
            public static extern void GetPathMetric<T3>(Int32 metricQueryMask, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[,,] paths, Int32 pathBase, Int32 stride, [OutAttribute] out Single metrics)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricsNV")]
            public static extern unsafe void GetPathMetric<T3>(Int32 metricQueryMask, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[,,] paths, Int32 pathBase, Int32 stride, [OutAttribute] Single* metrics)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricsNV")]
            public static extern void GetPathMetric<T3>(Int32 metricQueryMask, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T3 paths, Int32 pathBase, Int32 stride, [OutAttribute] Single[] metrics)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricsNV")]
            public static extern void GetPathMetric<T3>(Int32 metricQueryMask, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T3 paths, Int32 pathBase, Int32 stride, [OutAttribute] out Single metrics)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricsNV")]
            public static extern unsafe void GetPathMetric<T3>(Int32 metricQueryMask, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T3 paths, Int32 pathBase, Int32 stride, [OutAttribute] Single* metrics)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricsNV")]
            public static extern void GetPathMetric(UInt32 metricQueryMask, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, UInt32 pathBase, Int32 stride, [OutAttribute] Single[] metrics);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricsNV")]
            public static extern void GetPathMetric(UInt32 metricQueryMask, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, UInt32 pathBase, Int32 stride, [OutAttribute] out Single metrics);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricsNV")]
            public static extern unsafe void GetPathMetric(UInt32 metricQueryMask, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, UInt32 pathBase, Int32 stride, [OutAttribute] Single* metrics);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricsNV")]
            public static extern void GetPathMetric<T3>(UInt32 metricQueryMask, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[] paths, UInt32 pathBase, Int32 stride, [OutAttribute] Single[] metrics)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricsNV")]
            public static extern void GetPathMetric<T3>(UInt32 metricQueryMask, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[] paths, UInt32 pathBase, Int32 stride, [OutAttribute] out Single metrics)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricsNV")]
            public static extern unsafe void GetPathMetric<T3>(UInt32 metricQueryMask, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[] paths, UInt32 pathBase, Int32 stride, [OutAttribute] Single* metrics)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricsNV")]
            public static extern void GetPathMetric<T3>(UInt32 metricQueryMask, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[,] paths, UInt32 pathBase, Int32 stride, [OutAttribute] Single[] metrics)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricsNV")]
            public static extern void GetPathMetric<T3>(UInt32 metricQueryMask, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[,] paths, UInt32 pathBase, Int32 stride, [OutAttribute] out Single metrics)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricsNV")]
            public static extern unsafe void GetPathMetric<T3>(UInt32 metricQueryMask, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[,] paths, UInt32 pathBase, Int32 stride, [OutAttribute] Single* metrics)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricsNV")]
            public static extern void GetPathMetric<T3>(UInt32 metricQueryMask, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[,,] paths, UInt32 pathBase, Int32 stride, [OutAttribute] Single[] metrics)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricsNV")]
            public static extern void GetPathMetric<T3>(UInt32 metricQueryMask, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[,,] paths, UInt32 pathBase, Int32 stride, [OutAttribute] out Single metrics)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricsNV")]
            public static extern unsafe void GetPathMetric<T3>(UInt32 metricQueryMask, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[,,] paths, UInt32 pathBase, Int32 stride, [OutAttribute] Single* metrics)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricsNV")]
            public static extern void GetPathMetric<T3>(UInt32 metricQueryMask, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T3 paths, UInt32 pathBase, Int32 stride, [OutAttribute] Single[] metrics)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricsNV")]
            public static extern void GetPathMetric<T3>(UInt32 metricQueryMask, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T3 paths, UInt32 pathBase, Int32 stride, [OutAttribute] out Single metrics)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathMetricsNV")]
            public static extern unsafe void GetPathMetric<T3>(UInt32 metricQueryMask, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T3 paths, UInt32 pathBase, Int32 stride, [OutAttribute] Single* metrics)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathParameterfvNV")]
            public static extern void GetPathParameter(Int32 path, OpenTK.Graphics.OpenGL.NvPathRendering pname, [OutAttribute] Single[] value);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathParameterfvNV")]
            public static extern void GetPathParameter(Int32 path, OpenTK.Graphics.OpenGL.NvPathRendering pname, [OutAttribute] out Single value);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathParameterfvNV")]
            public static extern unsafe void GetPathParameter(Int32 path, OpenTK.Graphics.OpenGL.NvPathRendering pname, [OutAttribute] Single* value);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathParameterfvNV")]
            public static extern void GetPathParameter(UInt32 path, OpenTK.Graphics.OpenGL.NvPathRendering pname, [OutAttribute] Single[] value);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathParameterfvNV")]
            public static extern void GetPathParameter(UInt32 path, OpenTK.Graphics.OpenGL.NvPathRendering pname, [OutAttribute] out Single value);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathParameterfvNV")]
            public static extern unsafe void GetPathParameter(UInt32 path, OpenTK.Graphics.OpenGL.NvPathRendering pname, [OutAttribute] Single* value);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathParameterivNV")]
            public static extern void GetPathParameter(Int32 path, OpenTK.Graphics.OpenGL.NvPathRendering pname, [OutAttribute] Int32[] value);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathParameterivNV")]
            public static extern void GetPathParameter(Int32 path, OpenTK.Graphics.OpenGL.NvPathRendering pname, [OutAttribute] out Int32 value);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathParameterivNV")]
            public static extern unsafe void GetPathParameter(Int32 path, OpenTK.Graphics.OpenGL.NvPathRendering pname, [OutAttribute] Int32* value);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathParameterivNV")]
            public static extern void GetPathParameter(UInt32 path, OpenTK.Graphics.OpenGL.NvPathRendering pname, [OutAttribute] Int32[] value);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathParameterivNV")]
            public static extern void GetPathParameter(UInt32 path, OpenTK.Graphics.OpenGL.NvPathRendering pname, [OutAttribute] out Int32 value);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathParameterivNV")]
            public static extern unsafe void GetPathParameter(UInt32 path, OpenTK.Graphics.OpenGL.NvPathRendering pname, [OutAttribute] Int32* value);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathSpacingNV")]
            public static extern void GetPathSpacing(OpenTK.Graphics.OpenGL.NvPathRendering pathListMode, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, Int32 pathBase, Single advanceScale, Single kerningScale, OpenTK.Graphics.OpenGL.NvPathRendering transformType, [OutAttribute] Single[] returnedSpacing);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathSpacingNV")]
            public static extern void GetPathSpacing(OpenTK.Graphics.OpenGL.NvPathRendering pathListMode, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, Int32 pathBase, Single advanceScale, Single kerningScale, OpenTK.Graphics.OpenGL.NvPathRendering transformType, [OutAttribute] out Single returnedSpacing);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathSpacingNV")]
            public static extern unsafe void GetPathSpacing(OpenTK.Graphics.OpenGL.NvPathRendering pathListMode, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, Int32 pathBase, Single advanceScale, Single kerningScale, OpenTK.Graphics.OpenGL.NvPathRendering transformType, [OutAttribute] Single* returnedSpacing);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathSpacingNV")]
            public static extern void GetPathSpacing(OpenTK.Graphics.OpenGL.NvPathRendering pathListMode, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, UInt32 pathBase, Single advanceScale, Single kerningScale, OpenTK.Graphics.OpenGL.NvPathRendering transformType, [OutAttribute] Single[] returnedSpacing);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathSpacingNV")]
            public static extern void GetPathSpacing(OpenTK.Graphics.OpenGL.NvPathRendering pathListMode, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, UInt32 pathBase, Single advanceScale, Single kerningScale, OpenTK.Graphics.OpenGL.NvPathRendering transformType, [OutAttribute] out Single returnedSpacing);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathSpacingNV")]
            public static extern unsafe void GetPathSpacing(OpenTK.Graphics.OpenGL.NvPathRendering pathListMode, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, UInt32 pathBase, Single advanceScale, Single kerningScale, OpenTK.Graphics.OpenGL.NvPathRendering transformType, [OutAttribute] Single* returnedSpacing);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathSpacingNV")]
            public static extern void GetPathSpacing<T3>(OpenTK.Graphics.OpenGL.NvPathRendering pathListMode, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[] paths, Int32 pathBase, Single advanceScale, Single kerningScale, OpenTK.Graphics.OpenGL.NvPathRendering transformType, [OutAttribute] Single[] returnedSpacing)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathSpacingNV")]
            public static extern void GetPathSpacing<T3>(OpenTK.Graphics.OpenGL.NvPathRendering pathListMode, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[] paths, Int32 pathBase, Single advanceScale, Single kerningScale, OpenTK.Graphics.OpenGL.NvPathRendering transformType, [OutAttribute] out Single returnedSpacing)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathSpacingNV")]
            public static extern unsafe void GetPathSpacing<T3>(OpenTK.Graphics.OpenGL.NvPathRendering pathListMode, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[] paths, Int32 pathBase, Single advanceScale, Single kerningScale, OpenTK.Graphics.OpenGL.NvPathRendering transformType, [OutAttribute] Single* returnedSpacing)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathSpacingNV")]
            public static extern void GetPathSpacing<T3>(OpenTK.Graphics.OpenGL.NvPathRendering pathListMode, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[] paths, UInt32 pathBase, Single advanceScale, Single kerningScale, OpenTK.Graphics.OpenGL.NvPathRendering transformType, [OutAttribute] Single[] returnedSpacing)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathSpacingNV")]
            public static extern void GetPathSpacing<T3>(OpenTK.Graphics.OpenGL.NvPathRendering pathListMode, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[] paths, UInt32 pathBase, Single advanceScale, Single kerningScale, OpenTK.Graphics.OpenGL.NvPathRendering transformType, [OutAttribute] out Single returnedSpacing)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathSpacingNV")]
            public static extern unsafe void GetPathSpacing<T3>(OpenTK.Graphics.OpenGL.NvPathRendering pathListMode, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[] paths, UInt32 pathBase, Single advanceScale, Single kerningScale, OpenTK.Graphics.OpenGL.NvPathRendering transformType, [OutAttribute] Single* returnedSpacing)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathSpacingNV")]
            public static extern void GetPathSpacing<T3>(OpenTK.Graphics.OpenGL.NvPathRendering pathListMode, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[,] paths, Int32 pathBase, Single advanceScale, Single kerningScale, OpenTK.Graphics.OpenGL.NvPathRendering transformType, [OutAttribute] Single[] returnedSpacing)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathSpacingNV")]
            public static extern void GetPathSpacing<T3>(OpenTK.Graphics.OpenGL.NvPathRendering pathListMode, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[,] paths, Int32 pathBase, Single advanceScale, Single kerningScale, OpenTK.Graphics.OpenGL.NvPathRendering transformType, [OutAttribute] out Single returnedSpacing)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathSpacingNV")]
            public static extern unsafe void GetPathSpacing<T3>(OpenTK.Graphics.OpenGL.NvPathRendering pathListMode, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[,] paths, Int32 pathBase, Single advanceScale, Single kerningScale, OpenTK.Graphics.OpenGL.NvPathRendering transformType, [OutAttribute] Single* returnedSpacing)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathSpacingNV")]
            public static extern void GetPathSpacing<T3>(OpenTK.Graphics.OpenGL.NvPathRendering pathListMode, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[,] paths, UInt32 pathBase, Single advanceScale, Single kerningScale, OpenTK.Graphics.OpenGL.NvPathRendering transformType, [OutAttribute] Single[] returnedSpacing)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathSpacingNV")]
            public static extern void GetPathSpacing<T3>(OpenTK.Graphics.OpenGL.NvPathRendering pathListMode, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[,] paths, UInt32 pathBase, Single advanceScale, Single kerningScale, OpenTK.Graphics.OpenGL.NvPathRendering transformType, [OutAttribute] out Single returnedSpacing)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathSpacingNV")]
            public static extern unsafe void GetPathSpacing<T3>(OpenTK.Graphics.OpenGL.NvPathRendering pathListMode, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[,] paths, UInt32 pathBase, Single advanceScale, Single kerningScale, OpenTK.Graphics.OpenGL.NvPathRendering transformType, [OutAttribute] Single* returnedSpacing)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathSpacingNV")]
            public static extern void GetPathSpacing<T3>(OpenTK.Graphics.OpenGL.NvPathRendering pathListMode, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[,,] paths, Int32 pathBase, Single advanceScale, Single kerningScale, OpenTK.Graphics.OpenGL.NvPathRendering transformType, [OutAttribute] Single[] returnedSpacing)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathSpacingNV")]
            public static extern void GetPathSpacing<T3>(OpenTK.Graphics.OpenGL.NvPathRendering pathListMode, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[,,] paths, Int32 pathBase, Single advanceScale, Single kerningScale, OpenTK.Graphics.OpenGL.NvPathRendering transformType, [OutAttribute] out Single returnedSpacing)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathSpacingNV")]
            public static extern unsafe void GetPathSpacing<T3>(OpenTK.Graphics.OpenGL.NvPathRendering pathListMode, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[,,] paths, Int32 pathBase, Single advanceScale, Single kerningScale, OpenTK.Graphics.OpenGL.NvPathRendering transformType, [OutAttribute] Single* returnedSpacing)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathSpacingNV")]
            public static extern void GetPathSpacing<T3>(OpenTK.Graphics.OpenGL.NvPathRendering pathListMode, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[,,] paths, UInt32 pathBase, Single advanceScale, Single kerningScale, OpenTK.Graphics.OpenGL.NvPathRendering transformType, [OutAttribute] Single[] returnedSpacing)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathSpacingNV")]
            public static extern void GetPathSpacing<T3>(OpenTK.Graphics.OpenGL.NvPathRendering pathListMode, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[,,] paths, UInt32 pathBase, Single advanceScale, Single kerningScale, OpenTK.Graphics.OpenGL.NvPathRendering transformType, [OutAttribute] out Single returnedSpacing)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathSpacingNV")]
            public static extern unsafe void GetPathSpacing<T3>(OpenTK.Graphics.OpenGL.NvPathRendering pathListMode, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T3[,,] paths, UInt32 pathBase, Single advanceScale, Single kerningScale, OpenTK.Graphics.OpenGL.NvPathRendering transformType, [OutAttribute] Single* returnedSpacing)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathSpacingNV")]
            public static extern void GetPathSpacing<T3>(OpenTK.Graphics.OpenGL.NvPathRendering pathListMode, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T3 paths, Int32 pathBase, Single advanceScale, Single kerningScale, OpenTK.Graphics.OpenGL.NvPathRendering transformType, [OutAttribute] Single[] returnedSpacing)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathSpacingNV")]
            public static extern void GetPathSpacing<T3>(OpenTK.Graphics.OpenGL.NvPathRendering pathListMode, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T3 paths, Int32 pathBase, Single advanceScale, Single kerningScale, OpenTK.Graphics.OpenGL.NvPathRendering transformType, [OutAttribute] out Single returnedSpacing)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathSpacingNV")]
            public static extern unsafe void GetPathSpacing<T3>(OpenTK.Graphics.OpenGL.NvPathRendering pathListMode, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T3 paths, Int32 pathBase, Single advanceScale, Single kerningScale, OpenTK.Graphics.OpenGL.NvPathRendering transformType, [OutAttribute] Single* returnedSpacing)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathSpacingNV")]
            public static extern void GetPathSpacing<T3>(OpenTK.Graphics.OpenGL.NvPathRendering pathListMode, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T3 paths, UInt32 pathBase, Single advanceScale, Single kerningScale, OpenTK.Graphics.OpenGL.NvPathRendering transformType, [OutAttribute] Single[] returnedSpacing)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathSpacingNV")]
            public static extern void GetPathSpacing<T3>(OpenTK.Graphics.OpenGL.NvPathRendering pathListMode, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T3 paths, UInt32 pathBase, Single advanceScale, Single kerningScale, OpenTK.Graphics.OpenGL.NvPathRendering transformType, [OutAttribute] out Single returnedSpacing)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathSpacingNV")]
            public static extern unsafe void GetPathSpacing<T3>(OpenTK.Graphics.OpenGL.NvPathRendering pathListMode, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T3 paths, UInt32 pathBase, Single advanceScale, Single kerningScale, OpenTK.Graphics.OpenGL.NvPathRendering transformType, [OutAttribute] Single* returnedSpacing)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathTexGenfvNV")]
            public static extern void GetPathTexGen(OpenTK.Graphics.OpenGL.TextureUnit texCoordSet, OpenTK.Graphics.OpenGL.NvPathRendering pname, [OutAttribute] Single[] value);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathTexGenfvNV")]
            public static extern void GetPathTexGen(OpenTK.Graphics.OpenGL.TextureUnit texCoordSet, OpenTK.Graphics.OpenGL.NvPathRendering pname, [OutAttribute] out Single value);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathTexGenfvNV")]
            public static extern unsafe void GetPathTexGen(OpenTK.Graphics.OpenGL.TextureUnit texCoordSet, OpenTK.Graphics.OpenGL.NvPathRendering pname, [OutAttribute] Single* value);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathTexGenivNV")]
            public static extern void GetPathTexGen(OpenTK.Graphics.OpenGL.TextureUnit texCoordSet, OpenTK.Graphics.OpenGL.NvPathRendering pname, [OutAttribute] Int32[] value);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathTexGenivNV")]
            public static extern void GetPathTexGen(OpenTK.Graphics.OpenGL.TextureUnit texCoordSet, OpenTK.Graphics.OpenGL.NvPathRendering pname, [OutAttribute] out Int32 value);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glGetPathTexGenivNV")]
            public static extern unsafe void GetPathTexGen(OpenTK.Graphics.OpenGL.TextureUnit texCoordSet, OpenTK.Graphics.OpenGL.NvPathRendering pname, [OutAttribute] Int32* value);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glGetProgramEnvParameterIivNV")]
            public static extern void GetProgramEnvParameterI(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, Int32 index, [OutAttribute] Int32[] @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glGetProgramEnvParameterIivNV")]
            public static extern void GetProgramEnvParameterI(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, Int32 index, [OutAttribute] out Int32 @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glGetProgramEnvParameterIivNV")]
            public static extern unsafe void GetProgramEnvParameterI(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, Int32 index, [OutAttribute] Int32* @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glGetProgramEnvParameterIivNV")]
            public static extern void GetProgramEnvParameterI(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, [OutAttribute] Int32[] @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glGetProgramEnvParameterIivNV")]
            public static extern void GetProgramEnvParameterI(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, [OutAttribute] out Int32 @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glGetProgramEnvParameterIivNV")]
            public static extern unsafe void GetProgramEnvParameterI(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, [OutAttribute] Int32* @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glGetProgramEnvParameterIuivNV")]
            public static extern void GetProgramEnvParameterI(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, [OutAttribute] UInt32[] @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glGetProgramEnvParameterIuivNV")]
            public static extern void GetProgramEnvParameterI(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, [OutAttribute] out UInt32 @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glGetProgramEnvParameterIuivNV")]
            public static extern unsafe void GetProgramEnvParameterI(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, [OutAttribute] UInt32* @params);

            /// <summary>[requires: NV_vertex_program]
            /// Returns a parameter from a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the object parameter. Accepted symbolic names are GL_DELETE_STATUS, GL_LINK_STATUS, GL_VALIDATE_STATUS, GL_INFO_LOG_LENGTH, GL_ATTACHED_SHADERS, GL_ACTIVE_ATOMIC_COUNTER_BUFFERS, GL_ACTIVE_ATTRIBUTES, GL_ACTIVE_ATTRIBUTE_MAX_LENGTH, GL_ACTIVE_UNIFORMS, GL_ACTIVE_UNIFORM_BLOCKS, GL_ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH, GL_ACTIVE_UNIFORM_MAX_LENGTH, GL_COMPUTE_WORK_GROUP_SIZE GL_PROGRAM_BINARY_LENGTH, GL_TRANSFORM_FEEDBACK_BUFFER_MODE, GL_TRANSFORM_FEEDBACK_VARYINGS, GL_TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH, GL_GEOMETRY_VERTICES_OUT, GL_GEOMETRY_INPUT_TYPE, and GL_GEOMETRY_OUTPUT_TYPE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested object parameter.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetProgramivNV")]
            public static extern void GetProgram(Int32 id, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: NV_vertex_program]
            /// Returns a parameter from a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the object parameter. Accepted symbolic names are GL_DELETE_STATUS, GL_LINK_STATUS, GL_VALIDATE_STATUS, GL_INFO_LOG_LENGTH, GL_ATTACHED_SHADERS, GL_ACTIVE_ATOMIC_COUNTER_BUFFERS, GL_ACTIVE_ATTRIBUTES, GL_ACTIVE_ATTRIBUTE_MAX_LENGTH, GL_ACTIVE_UNIFORMS, GL_ACTIVE_UNIFORM_BLOCKS, GL_ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH, GL_ACTIVE_UNIFORM_MAX_LENGTH, GL_COMPUTE_WORK_GROUP_SIZE GL_PROGRAM_BINARY_LENGTH, GL_TRANSFORM_FEEDBACK_BUFFER_MODE, GL_TRANSFORM_FEEDBACK_VARYINGS, GL_TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH, GL_GEOMETRY_VERTICES_OUT, GL_GEOMETRY_INPUT_TYPE, and GL_GEOMETRY_OUTPUT_TYPE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested object parameter.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetProgramivNV")]
            public static extern void GetProgram(Int32 id, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: NV_vertex_program]
            /// Returns a parameter from a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the object parameter. Accepted symbolic names are GL_DELETE_STATUS, GL_LINK_STATUS, GL_VALIDATE_STATUS, GL_INFO_LOG_LENGTH, GL_ATTACHED_SHADERS, GL_ACTIVE_ATOMIC_COUNTER_BUFFERS, GL_ACTIVE_ATTRIBUTES, GL_ACTIVE_ATTRIBUTE_MAX_LENGTH, GL_ACTIVE_UNIFORMS, GL_ACTIVE_UNIFORM_BLOCKS, GL_ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH, GL_ACTIVE_UNIFORM_MAX_LENGTH, GL_COMPUTE_WORK_GROUP_SIZE GL_PROGRAM_BINARY_LENGTH, GL_TRANSFORM_FEEDBACK_BUFFER_MODE, GL_TRANSFORM_FEEDBACK_VARYINGS, GL_TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH, GL_GEOMETRY_VERTICES_OUT, GL_GEOMETRY_INPUT_TYPE, and GL_GEOMETRY_OUTPUT_TYPE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested object parameter.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetProgramivNV")]
            public static extern unsafe void GetProgram(Int32 id, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: NV_vertex_program]
            /// Returns a parameter from a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the object parameter. Accepted symbolic names are GL_DELETE_STATUS, GL_LINK_STATUS, GL_VALIDATE_STATUS, GL_INFO_LOG_LENGTH, GL_ATTACHED_SHADERS, GL_ACTIVE_ATOMIC_COUNTER_BUFFERS, GL_ACTIVE_ATTRIBUTES, GL_ACTIVE_ATTRIBUTE_MAX_LENGTH, GL_ACTIVE_UNIFORMS, GL_ACTIVE_UNIFORM_BLOCKS, GL_ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH, GL_ACTIVE_UNIFORM_MAX_LENGTH, GL_COMPUTE_WORK_GROUP_SIZE GL_PROGRAM_BINARY_LENGTH, GL_TRANSFORM_FEEDBACK_BUFFER_MODE, GL_TRANSFORM_FEEDBACK_VARYINGS, GL_TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH, GL_GEOMETRY_VERTICES_OUT, GL_GEOMETRY_INPUT_TYPE, and GL_GEOMETRY_OUTPUT_TYPE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested object parameter.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetProgramivNV")]
            public static extern void GetProgram(UInt32 id, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: NV_vertex_program]
            /// Returns a parameter from a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the object parameter. Accepted symbolic names are GL_DELETE_STATUS, GL_LINK_STATUS, GL_VALIDATE_STATUS, GL_INFO_LOG_LENGTH, GL_ATTACHED_SHADERS, GL_ACTIVE_ATOMIC_COUNTER_BUFFERS, GL_ACTIVE_ATTRIBUTES, GL_ACTIVE_ATTRIBUTE_MAX_LENGTH, GL_ACTIVE_UNIFORMS, GL_ACTIVE_UNIFORM_BLOCKS, GL_ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH, GL_ACTIVE_UNIFORM_MAX_LENGTH, GL_COMPUTE_WORK_GROUP_SIZE GL_PROGRAM_BINARY_LENGTH, GL_TRANSFORM_FEEDBACK_BUFFER_MODE, GL_TRANSFORM_FEEDBACK_VARYINGS, GL_TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH, GL_GEOMETRY_VERTICES_OUT, GL_GEOMETRY_INPUT_TYPE, and GL_GEOMETRY_OUTPUT_TYPE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested object parameter.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetProgramivNV")]
            public static extern void GetProgram(UInt32 id, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: NV_vertex_program]
            /// Returns a parameter from a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the object parameter. Accepted symbolic names are GL_DELETE_STATUS, GL_LINK_STATUS, GL_VALIDATE_STATUS, GL_INFO_LOG_LENGTH, GL_ATTACHED_SHADERS, GL_ACTIVE_ATOMIC_COUNTER_BUFFERS, GL_ACTIVE_ATTRIBUTES, GL_ACTIVE_ATTRIBUTE_MAX_LENGTH, GL_ACTIVE_UNIFORMS, GL_ACTIVE_UNIFORM_BLOCKS, GL_ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH, GL_ACTIVE_UNIFORM_MAX_LENGTH, GL_COMPUTE_WORK_GROUP_SIZE GL_PROGRAM_BINARY_LENGTH, GL_TRANSFORM_FEEDBACK_BUFFER_MODE, GL_TRANSFORM_FEEDBACK_VARYINGS, GL_TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH, GL_GEOMETRY_VERTICES_OUT, GL_GEOMETRY_INPUT_TYPE, and GL_GEOMETRY_OUTPUT_TYPE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested object parameter.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetProgramivNV")]
            public static extern unsafe void GetProgram(UInt32 id, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glGetProgramLocalParameterIivNV")]
            public static extern void GetProgramLocalParameterI(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, Int32 index, [OutAttribute] Int32[] @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glGetProgramLocalParameterIivNV")]
            public static extern void GetProgramLocalParameterI(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, Int32 index, [OutAttribute] out Int32 @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glGetProgramLocalParameterIivNV")]
            public static extern unsafe void GetProgramLocalParameterI(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, Int32 index, [OutAttribute] Int32* @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glGetProgramLocalParameterIivNV")]
            public static extern void GetProgramLocalParameterI(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, [OutAttribute] Int32[] @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glGetProgramLocalParameterIivNV")]
            public static extern void GetProgramLocalParameterI(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, [OutAttribute] out Int32 @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glGetProgramLocalParameterIivNV")]
            public static extern unsafe void GetProgramLocalParameterI(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, [OutAttribute] Int32* @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glGetProgramLocalParameterIuivNV")]
            public static extern void GetProgramLocalParameterI(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, [OutAttribute] UInt32[] @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glGetProgramLocalParameterIuivNV")]
            public static extern void GetProgramLocalParameterI(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, [OutAttribute] out UInt32 @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glGetProgramLocalParameterIuivNV")]
            public static extern unsafe void GetProgramLocalParameterI(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, [OutAttribute] UInt32* @params);

            /// <summary>[requires: NV_fragment_program]</summary>
            [AutoGenerated(Category = "NV_fragment_program", Version = "", EntryPoint = "glGetProgramNamedParameterdvNV")]
            public static extern void GetProgramNamedParameter(Int32 id, Int32 len, ref Byte name, [OutAttribute] Double[] @params);

            /// <summary>[requires: NV_fragment_program]</summary>
            [AutoGenerated(Category = "NV_fragment_program", Version = "", EntryPoint = "glGetProgramNamedParameterdvNV")]
            public static extern void GetProgramNamedParameter(Int32 id, Int32 len, ref Byte name, [OutAttribute] out Double @params);

            /// <summary>[requires: NV_fragment_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fragment_program", Version = "", EntryPoint = "glGetProgramNamedParameterdvNV")]
            public static extern unsafe void GetProgramNamedParameter(Int32 id, Int32 len, Byte* name, [OutAttribute] Double* @params);

            /// <summary>[requires: NV_fragment_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fragment_program", Version = "", EntryPoint = "glGetProgramNamedParameterdvNV")]
            public static extern void GetProgramNamedParameter(UInt32 id, Int32 len, ref Byte name, [OutAttribute] Double[] @params);

            /// <summary>[requires: NV_fragment_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fragment_program", Version = "", EntryPoint = "glGetProgramNamedParameterdvNV")]
            public static extern void GetProgramNamedParameter(UInt32 id, Int32 len, ref Byte name, [OutAttribute] out Double @params);

            /// <summary>[requires: NV_fragment_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fragment_program", Version = "", EntryPoint = "glGetProgramNamedParameterdvNV")]
            public static extern unsafe void GetProgramNamedParameter(UInt32 id, Int32 len, Byte* name, [OutAttribute] Double* @params);

            /// <summary>[requires: NV_fragment_program]</summary>
            [AutoGenerated(Category = "NV_fragment_program", Version = "", EntryPoint = "glGetProgramNamedParameterfvNV")]
            public static extern void GetProgramNamedParameter(Int32 id, Int32 len, ref Byte name, [OutAttribute] Single[] @params);

            /// <summary>[requires: NV_fragment_program]</summary>
            [AutoGenerated(Category = "NV_fragment_program", Version = "", EntryPoint = "glGetProgramNamedParameterfvNV")]
            public static extern void GetProgramNamedParameter(Int32 id, Int32 len, ref Byte name, [OutAttribute] out Single @params);

            /// <summary>[requires: NV_fragment_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fragment_program", Version = "", EntryPoint = "glGetProgramNamedParameterfvNV")]
            public static extern unsafe void GetProgramNamedParameter(Int32 id, Int32 len, Byte* name, [OutAttribute] Single* @params);

            /// <summary>[requires: NV_fragment_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fragment_program", Version = "", EntryPoint = "glGetProgramNamedParameterfvNV")]
            public static extern void GetProgramNamedParameter(UInt32 id, Int32 len, ref Byte name, [OutAttribute] Single[] @params);

            /// <summary>[requires: NV_fragment_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fragment_program", Version = "", EntryPoint = "glGetProgramNamedParameterfvNV")]
            public static extern void GetProgramNamedParameter(UInt32 id, Int32 len, ref Byte name, [OutAttribute] out Single @params);

            /// <summary>[requires: NV_fragment_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fragment_program", Version = "", EntryPoint = "glGetProgramNamedParameterfvNV")]
            public static extern unsafe void GetProgramNamedParameter(UInt32 id, Int32 len, Byte* name, [OutAttribute] Single* @params);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetProgramParameterdvNV")]
            public static extern void GetProgramParameter(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, OpenTK.Graphics.OpenGL.AssemblyProgramParameterArb pname, [OutAttribute] Double[] @params);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetProgramParameterdvNV")]
            public static extern void GetProgramParameter(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, OpenTK.Graphics.OpenGL.AssemblyProgramParameterArb pname, [OutAttribute] out Double @params);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetProgramParameterdvNV")]
            public static extern unsafe void GetProgramParameter(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, OpenTK.Graphics.OpenGL.AssemblyProgramParameterArb pname, [OutAttribute] Double* @params);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetProgramParameterdvNV")]
            public static extern void GetProgramParameter(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, OpenTK.Graphics.OpenGL.AssemblyProgramParameterArb pname, [OutAttribute] Double[] @params);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetProgramParameterdvNV")]
            public static extern void GetProgramParameter(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, OpenTK.Graphics.OpenGL.AssemblyProgramParameterArb pname, [OutAttribute] out Double @params);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetProgramParameterdvNV")]
            public static extern unsafe void GetProgramParameter(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, OpenTK.Graphics.OpenGL.AssemblyProgramParameterArb pname, [OutAttribute] Double* @params);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetProgramParameterfvNV")]
            public static extern void GetProgramParameter(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, OpenTK.Graphics.OpenGL.AssemblyProgramParameterArb pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetProgramParameterfvNV")]
            public static extern void GetProgramParameter(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, OpenTK.Graphics.OpenGL.AssemblyProgramParameterArb pname, [OutAttribute] out Single @params);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetProgramParameterfvNV")]
            public static extern unsafe void GetProgramParameter(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, OpenTK.Graphics.OpenGL.AssemblyProgramParameterArb pname, [OutAttribute] Single* @params);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetProgramParameterfvNV")]
            public static extern void GetProgramParameter(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, OpenTK.Graphics.OpenGL.AssemblyProgramParameterArb pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetProgramParameterfvNV")]
            public static extern void GetProgramParameter(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, OpenTK.Graphics.OpenGL.AssemblyProgramParameterArb pname, [OutAttribute] out Single @params);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetProgramParameterfvNV")]
            public static extern unsafe void GetProgramParameter(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, OpenTK.Graphics.OpenGL.AssemblyProgramParameterArb pname, [OutAttribute] Single* @params);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetProgramStringNV")]
            public static extern void GetProgramString(Int32 id, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [OutAttribute] Byte[] program);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetProgramStringNV")]
            public static extern void GetProgramString(Int32 id, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [OutAttribute] out Byte program);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetProgramStringNV")]
            public static extern unsafe void GetProgramString(Int32 id, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [OutAttribute] Byte* program);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetProgramStringNV")]
            public static extern void GetProgramString(UInt32 id, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [OutAttribute] Byte[] program);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetProgramStringNV")]
            public static extern void GetProgramString(UInt32 id, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [OutAttribute] out Byte program);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetProgramStringNV")]
            public static extern unsafe void GetProgramString(UInt32 id, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [OutAttribute] Byte* program);

            /// <summary>[requires: NV_gpu_program5]</summary>
            [AutoGenerated(Category = "NV_gpu_program5", Version = "", EntryPoint = "glGetProgramSubroutineParameteruivNV")]
            public static extern void GetProgramSubroutineParameter(OpenTK.Graphics.OpenGL.NvGpuProgram5 target, Int32 index, [OutAttribute] Int32[] param);

            /// <summary>[requires: NV_gpu_program5]</summary>
            [AutoGenerated(Category = "NV_gpu_program5", Version = "", EntryPoint = "glGetProgramSubroutineParameteruivNV")]
            public static extern void GetProgramSubroutineParameter(OpenTK.Graphics.OpenGL.NvGpuProgram5 target, Int32 index, [OutAttribute] out Int32 param);

            /// <summary>[requires: NV_gpu_program5]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program5", Version = "", EntryPoint = "glGetProgramSubroutineParameteruivNV")]
            public static extern unsafe void GetProgramSubroutineParameter(OpenTK.Graphics.OpenGL.NvGpuProgram5 target, Int32 index, [OutAttribute] Int32* param);

            /// <summary>[requires: NV_gpu_program5]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program5", Version = "", EntryPoint = "glGetProgramSubroutineParameteruivNV")]
            public static extern void GetProgramSubroutineParameter(OpenTK.Graphics.OpenGL.NvGpuProgram5 target, UInt32 index, [OutAttribute] UInt32[] param);

            /// <summary>[requires: NV_gpu_program5]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program5", Version = "", EntryPoint = "glGetProgramSubroutineParameteruivNV")]
            public static extern void GetProgramSubroutineParameter(OpenTK.Graphics.OpenGL.NvGpuProgram5 target, UInt32 index, [OutAttribute] out UInt32 param);

            /// <summary>[requires: NV_gpu_program5]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program5", Version = "", EntryPoint = "glGetProgramSubroutineParameteruivNV")]
            public static extern unsafe void GetProgramSubroutineParameter(OpenTK.Graphics.OpenGL.NvGpuProgram5 target, UInt32 index, [OutAttribute] UInt32* param);

            /// <summary>[requires: NV_bindless_texture]</summary>
            [AutoGenerated(Category = "NV_bindless_texture", Version = "", EntryPoint = "glGetTextureHandleNV")]
            public static extern Int64 GetTextureHandle(Int32 texture);

            /// <summary>[requires: NV_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_bindless_texture", Version = "", EntryPoint = "glGetTextureHandleNV")]
            public static extern Int64 GetTextureHandle(UInt32 texture);

            /// <summary>[requires: NV_bindless_texture]</summary>
            [AutoGenerated(Category = "NV_bindless_texture", Version = "", EntryPoint = "glGetTextureSamplerHandleNV")]
            public static extern Int64 GetTextureSamplerHandle(Int32 texture, Int32 sampler);

            /// <summary>[requires: NV_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_bindless_texture", Version = "", EntryPoint = "glGetTextureSamplerHandleNV")]
            public static extern Int64 GetTextureSamplerHandle(UInt32 texture, UInt32 sampler);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetTrackMatrixivNV")]
            public static extern void GetTrackMatrix(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 address, OpenTK.Graphics.OpenGL.AssemblyProgramParameterArb pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetTrackMatrixivNV")]
            public static extern unsafe void GetTrackMatrix(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 address, OpenTK.Graphics.OpenGL.AssemblyProgramParameterArb pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetTrackMatrixivNV")]
            public static extern void GetTrackMatrix(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 address, OpenTK.Graphics.OpenGL.AssemblyProgramParameterArb pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetTrackMatrixivNV")]
            public static extern unsafe void GetTrackMatrix(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 address, OpenTK.Graphics.OpenGL.AssemblyProgramParameterArb pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: NV_transform_feedback]
            /// Retrieve information about varying variables selected for transform feedback
            /// </summary>
            /// <param name="program">
            /// <para>
            /// The name of the target program object.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// The index of the varying variable whose information to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The maximum number of characters, including the null terminator, that may be written into name.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable which will receive the number of characters written into name, excluding the null-terminator. If length is NULL no length is returned.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// The address of a variable that will receive the size of the varying.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The address of a variable that will recieve the type of the varying.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// The address of a buffer into which will be written the name of the varying.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_transform_feedback", Version = "", EntryPoint = "glGetTransformFeedbackVaryingNV")]
            public static extern void GetTransformFeedbackVarying(Int32 program, Int32 index, [OutAttribute] out Int32 location);

            /// <summary>[requires: NV_transform_feedback]
            /// Retrieve information about varying variables selected for transform feedback
            /// </summary>
            /// <param name="program">
            /// <para>
            /// The name of the target program object.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// The index of the varying variable whose information to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The maximum number of characters, including the null terminator, that may be written into name.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable which will receive the number of characters written into name, excluding the null-terminator. If length is NULL no length is returned.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// The address of a variable that will receive the size of the varying.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The address of a variable that will recieve the type of the varying.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// The address of a buffer into which will be written the name of the varying.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_transform_feedback", Version = "", EntryPoint = "glGetTransformFeedbackVaryingNV")]
            public static extern unsafe void GetTransformFeedbackVarying(Int32 program, Int32 index, [OutAttribute] Int32* location);

            /// <summary>[requires: NV_transform_feedback]
            /// Retrieve information about varying variables selected for transform feedback
            /// </summary>
            /// <param name="program">
            /// <para>
            /// The name of the target program object.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// The index of the varying variable whose information to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The maximum number of characters, including the null terminator, that may be written into name.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable which will receive the number of characters written into name, excluding the null-terminator. If length is NULL no length is returned.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// The address of a variable that will receive the size of the varying.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The address of a variable that will recieve the type of the varying.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// The address of a buffer into which will be written the name of the varying.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_transform_feedback", Version = "", EntryPoint = "glGetTransformFeedbackVaryingNV")]
            public static extern void GetTransformFeedbackVarying(UInt32 program, UInt32 index, [OutAttribute] out Int32 location);

            /// <summary>[requires: NV_transform_feedback]
            /// Retrieve information about varying variables selected for transform feedback
            /// </summary>
            /// <param name="program">
            /// <para>
            /// The name of the target program object.
            /// </para>
            /// </param>
            /// <param name="index">
            /// <para>
            /// The index of the varying variable whose information to retrieve.
            /// </para>
            /// </param>
            /// <param name="bufSize">
            /// <para>
            /// The maximum number of characters, including the null terminator, that may be written into name.
            /// </para>
            /// </param>
            /// <param name="length">
            /// <para>
            /// The address of a variable which will receive the number of characters written into name, excluding the null-terminator. If length is NULL no length is returned.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// The address of a variable that will receive the size of the varying.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The address of a variable that will recieve the type of the varying.
            /// </para>
            /// </param>
            /// <param name="name">
            /// <para>
            /// The address of a buffer into which will be written the name of the varying.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_transform_feedback", Version = "", EntryPoint = "glGetTransformFeedbackVaryingNV")]
            public static extern unsafe void GetTransformFeedbackVarying(UInt32 program, UInt32 index, [OutAttribute] Int32* location);

            /// <summary>[requires: NV_gpu_shader5]
            /// Returns the value of a uniform variable
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be queried.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the value of the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glGetUniformi64vNV")]
            public static extern void GetUniform(Int32 program, Int32 location, [OutAttribute] Int64[] @params);

            /// <summary>[requires: NV_gpu_shader5]
            /// Returns the value of a uniform variable
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be queried.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the value of the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glGetUniformi64vNV")]
            public static extern void GetUniform(Int32 program, Int32 location, [OutAttribute] out Int64 @params);

            /// <summary>[requires: NV_gpu_shader5]
            /// Returns the value of a uniform variable
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be queried.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the value of the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glGetUniformi64vNV")]
            public static extern unsafe void GetUniform(Int32 program, Int32 location, [OutAttribute] Int64* @params);

            /// <summary>[requires: NV_gpu_shader5]
            /// Returns the value of a uniform variable
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be queried.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the value of the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glGetUniformi64vNV")]
            public static extern void GetUniform(UInt32 program, Int32 location, [OutAttribute] Int64[] @params);

            /// <summary>[requires: NV_gpu_shader5]
            /// Returns the value of a uniform variable
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be queried.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the value of the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glGetUniformi64vNV")]
            public static extern void GetUniform(UInt32 program, Int32 location, [OutAttribute] out Int64 @params);

            /// <summary>[requires: NV_gpu_shader5]
            /// Returns the value of a uniform variable
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be queried.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the value of the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glGetUniformi64vNV")]
            public static extern unsafe void GetUniform(UInt32 program, Int32 location, [OutAttribute] Int64* @params);

            /// <summary>[requires: NV_shader_buffer_load]
            /// Returns the value of a uniform variable
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be queried.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the value of the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glGetUniformui64vNV")]
            public static extern void GetUniform(UInt32 program, Int32 location, [OutAttribute] UInt64[] @params);

            /// <summary>[requires: NV_shader_buffer_load]
            /// Returns the value of a uniform variable
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be queried.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the value of the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glGetUniformui64vNV")]
            public static extern void GetUniform(UInt32 program, Int32 location, [OutAttribute] out UInt64 @params);

            /// <summary>[requires: NV_shader_buffer_load]
            /// Returns the value of a uniform variable
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the program object to be queried.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be queried.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the value of the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glGetUniformui64vNV")]
            public static extern unsafe void GetUniform(UInt32 program, Int32 location, [OutAttribute] UInt64* @params);

            /// <summary>[requires: NV_transform_feedback]</summary>
            [AutoGenerated(Category = "NV_transform_feedback", Version = "", EntryPoint = "glGetVaryingLocationNV")]
            public static extern Int32 GetVaryingLocation(Int32 program, String name);

            /// <summary>[requires: NV_transform_feedback]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_transform_feedback", Version = "", EntryPoint = "glGetVaryingLocationNV")]
            public static extern Int32 GetVaryingLocation(UInt32 program, String name);

            /// <summary>[requires: NV_vertex_program]
            /// Return a generic vertex attribute parameter
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the generic vertex attribute parameter to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested data.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetVertexAttribdvNV")]
            public static extern void GetVertexAttrib(Int32 index, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [OutAttribute] out Double @params);

            /// <summary>[requires: NV_vertex_program]
            /// Return a generic vertex attribute parameter
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the generic vertex attribute parameter to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested data.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetVertexAttribdvNV")]
            public static extern unsafe void GetVertexAttrib(Int32 index, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [OutAttribute] Double* @params);

            /// <summary>[requires: NV_vertex_program]
            /// Return a generic vertex attribute parameter
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the generic vertex attribute parameter to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested data.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetVertexAttribdvNV")]
            public static extern void GetVertexAttrib(UInt32 index, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [OutAttribute] out Double @params);

            /// <summary>[requires: NV_vertex_program]
            /// Return a generic vertex attribute parameter
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the generic vertex attribute parameter to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested data.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetVertexAttribdvNV")]
            public static extern unsafe void GetVertexAttrib(UInt32 index, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [OutAttribute] Double* @params);

            /// <summary>[requires: NV_vertex_program]
            /// Return a generic vertex attribute parameter
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the generic vertex attribute parameter to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested data.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetVertexAttribfvNV")]
            public static extern void GetVertexAttrib(Int32 index, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [OutAttribute] out Single @params);

            /// <summary>[requires: NV_vertex_program]
            /// Return a generic vertex attribute parameter
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the generic vertex attribute parameter to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested data.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetVertexAttribfvNV")]
            public static extern unsafe void GetVertexAttrib(Int32 index, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [OutAttribute] Single* @params);

            /// <summary>[requires: NV_vertex_program]
            /// Return a generic vertex attribute parameter
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the generic vertex attribute parameter to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested data.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetVertexAttribfvNV")]
            public static extern void GetVertexAttrib(UInt32 index, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [OutAttribute] out Single @params);

            /// <summary>[requires: NV_vertex_program]
            /// Return a generic vertex attribute parameter
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the generic vertex attribute parameter to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested data.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetVertexAttribfvNV")]
            public static extern unsafe void GetVertexAttrib(UInt32 index, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [OutAttribute] Single* @params);

            /// <summary>[requires: NV_vertex_program]
            /// Return a generic vertex attribute parameter
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the generic vertex attribute parameter to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested data.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetVertexAttribivNV")]
            public static extern void GetVertexAttrib(Int32 index, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: NV_vertex_program]
            /// Return a generic vertex attribute parameter
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the generic vertex attribute parameter to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested data.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetVertexAttribivNV")]
            public static extern unsafe void GetVertexAttrib(Int32 index, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: NV_vertex_program]
            /// Return a generic vertex attribute parameter
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the generic vertex attribute parameter to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested data.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetVertexAttribivNV")]
            public static extern void GetVertexAttrib(UInt32 index, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: NV_vertex_program]
            /// Return a generic vertex attribute parameter
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the generic vertex attribute parameter to be queried.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the symbolic name of the vertex attribute parameter to be queried. Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED, GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE, GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER, GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// Returns the requested data.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetVertexAttribivNV")]
            public static extern unsafe void GetVertexAttrib(UInt32 index, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glGetVertexAttribLi64vNV")]
            public static extern void GetVertexAttribL(Int32 index, OpenTK.Graphics.OpenGL.NvVertexAttribInteger64bit pname, [OutAttribute] Int64[] @params);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glGetVertexAttribLi64vNV")]
            public static extern void GetVertexAttribL(Int32 index, OpenTK.Graphics.OpenGL.NvVertexAttribInteger64bit pname, [OutAttribute] out Int64 @params);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glGetVertexAttribLi64vNV")]
            public static extern unsafe void GetVertexAttribL(Int32 index, OpenTK.Graphics.OpenGL.NvVertexAttribInteger64bit pname, [OutAttribute] Int64* @params);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glGetVertexAttribLi64vNV")]
            public static extern void GetVertexAttribL(UInt32 index, OpenTK.Graphics.OpenGL.NvVertexAttribInteger64bit pname, [OutAttribute] Int64[] @params);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glGetVertexAttribLi64vNV")]
            public static extern void GetVertexAttribL(UInt32 index, OpenTK.Graphics.OpenGL.NvVertexAttribInteger64bit pname, [OutAttribute] out Int64 @params);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glGetVertexAttribLi64vNV")]
            public static extern unsafe void GetVertexAttribL(UInt32 index, OpenTK.Graphics.OpenGL.NvVertexAttribInteger64bit pname, [OutAttribute] Int64* @params);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glGetVertexAttribLui64vNV")]
            public static extern void GetVertexAttribL(UInt32 index, OpenTK.Graphics.OpenGL.NvVertexAttribInteger64bit pname, [OutAttribute] UInt64[] @params);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glGetVertexAttribLui64vNV")]
            public static extern void GetVertexAttribL(UInt32 index, OpenTK.Graphics.OpenGL.NvVertexAttribInteger64bit pname, [OutAttribute] out UInt64 @params);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glGetVertexAttribLui64vNV")]
            public static extern unsafe void GetVertexAttribL(UInt32 index, OpenTK.Graphics.OpenGL.NvVertexAttribInteger64bit pname, [OutAttribute] UInt64* @params);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetVertexAttribPointervNV")]
            public static extern void GetVertexAttribPointer(Int32 index, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [OutAttribute] IntPtr pointer);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetVertexAttribPointervNV")]
            public static extern void GetVertexAttribPointer<T2>(Int32 index, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [InAttribute, OutAttribute] T2[] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetVertexAttribPointervNV")]
            public static extern void GetVertexAttribPointer<T2>(Int32 index, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [InAttribute, OutAttribute] T2[,] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetVertexAttribPointervNV")]
            public static extern void GetVertexAttribPointer<T2>(Int32 index, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [InAttribute, OutAttribute] T2[,,] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetVertexAttribPointervNV")]
            public static extern void GetVertexAttribPointer<T2>(Int32 index, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [InAttribute, OutAttribute] ref T2 pointer)
                where T2 : struct
            ;

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetVertexAttribPointervNV")]
            public static extern void GetVertexAttribPointer(UInt32 index, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [OutAttribute] IntPtr pointer);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetVertexAttribPointervNV")]
            public static extern void GetVertexAttribPointer<T2>(UInt32 index, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [InAttribute, OutAttribute] T2[] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetVertexAttribPointervNV")]
            public static extern void GetVertexAttribPointer<T2>(UInt32 index, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [InAttribute, OutAttribute] T2[,] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetVertexAttribPointervNV")]
            public static extern void GetVertexAttribPointer<T2>(UInt32 index, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [InAttribute, OutAttribute] T2[,,] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glGetVertexAttribPointervNV")]
            public static extern void GetVertexAttribPointer<T2>(UInt32 index, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [InAttribute, OutAttribute] ref T2 pointer)
                where T2 : struct
            ;

            /// <summary>[requires: NV_video_capture]</summary>
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glGetVideoCaptureivNV")]
            public static extern void GetVideoCapture(Int32 video_capture_slot, OpenTK.Graphics.OpenGL.NvVideoCapture pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glGetVideoCaptureivNV")]
            public static extern void GetVideoCapture(Int32 video_capture_slot, OpenTK.Graphics.OpenGL.NvVideoCapture pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glGetVideoCaptureivNV")]
            public static extern unsafe void GetVideoCapture(Int32 video_capture_slot, OpenTK.Graphics.OpenGL.NvVideoCapture pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glGetVideoCaptureivNV")]
            public static extern void GetVideoCapture(UInt32 video_capture_slot, OpenTK.Graphics.OpenGL.NvVideoCapture pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glGetVideoCaptureivNV")]
            public static extern void GetVideoCapture(UInt32 video_capture_slot, OpenTK.Graphics.OpenGL.NvVideoCapture pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glGetVideoCaptureivNV")]
            public static extern unsafe void GetVideoCapture(UInt32 video_capture_slot, OpenTK.Graphics.OpenGL.NvVideoCapture pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glGetVideoCaptureStreamdvNV")]
            public static extern void GetVideoCaptureStream(Int32 video_capture_slot, Int32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, [OutAttribute] Double[] @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glGetVideoCaptureStreamdvNV")]
            public static extern void GetVideoCaptureStream(Int32 video_capture_slot, Int32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, [OutAttribute] out Double @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glGetVideoCaptureStreamdvNV")]
            public static extern unsafe void GetVideoCaptureStream(Int32 video_capture_slot, Int32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, [OutAttribute] Double* @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glGetVideoCaptureStreamdvNV")]
            public static extern void GetVideoCaptureStream(UInt32 video_capture_slot, UInt32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, [OutAttribute] Double[] @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glGetVideoCaptureStreamdvNV")]
            public static extern void GetVideoCaptureStream(UInt32 video_capture_slot, UInt32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, [OutAttribute] out Double @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glGetVideoCaptureStreamdvNV")]
            public static extern unsafe void GetVideoCaptureStream(UInt32 video_capture_slot, UInt32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, [OutAttribute] Double* @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glGetVideoCaptureStreamfvNV")]
            public static extern void GetVideoCaptureStream(Int32 video_capture_slot, Int32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glGetVideoCaptureStreamfvNV")]
            public static extern void GetVideoCaptureStream(Int32 video_capture_slot, Int32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, [OutAttribute] out Single @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glGetVideoCaptureStreamfvNV")]
            public static extern unsafe void GetVideoCaptureStream(Int32 video_capture_slot, Int32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, [OutAttribute] Single* @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glGetVideoCaptureStreamfvNV")]
            public static extern void GetVideoCaptureStream(UInt32 video_capture_slot, UInt32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glGetVideoCaptureStreamfvNV")]
            public static extern void GetVideoCaptureStream(UInt32 video_capture_slot, UInt32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, [OutAttribute] out Single @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glGetVideoCaptureStreamfvNV")]
            public static extern unsafe void GetVideoCaptureStream(UInt32 video_capture_slot, UInt32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, [OutAttribute] Single* @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glGetVideoCaptureStreamivNV")]
            public static extern void GetVideoCaptureStream(Int32 video_capture_slot, Int32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glGetVideoCaptureStreamivNV")]
            public static extern void GetVideoCaptureStream(Int32 video_capture_slot, Int32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glGetVideoCaptureStreamivNV")]
            public static extern unsafe void GetVideoCaptureStream(Int32 video_capture_slot, Int32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glGetVideoCaptureStreamivNV")]
            public static extern void GetVideoCaptureStream(UInt32 video_capture_slot, UInt32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glGetVideoCaptureStreamivNV")]
            public static extern void GetVideoCaptureStream(UInt32 video_capture_slot, UInt32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glGetVideoCaptureStreamivNV")]
            public static extern unsafe void GetVideoCaptureStream(UInt32 video_capture_slot, UInt32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: NV_present_video]</summary>
            [AutoGenerated(Category = "NV_present_video", Version = "", EntryPoint = "glGetVideoi64vNV")]
            public static extern void GetVideo(Int32 video_slot, OpenTK.Graphics.OpenGL.NvPresentVideo pname, [OutAttribute] Int64[] @params);

            /// <summary>[requires: NV_present_video]</summary>
            [AutoGenerated(Category = "NV_present_video", Version = "", EntryPoint = "glGetVideoi64vNV")]
            public static extern void GetVideo(Int32 video_slot, OpenTK.Graphics.OpenGL.NvPresentVideo pname, [OutAttribute] out Int64 @params);

            /// <summary>[requires: NV_present_video]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_present_video", Version = "", EntryPoint = "glGetVideoi64vNV")]
            public static extern unsafe void GetVideo(Int32 video_slot, OpenTK.Graphics.OpenGL.NvPresentVideo pname, [OutAttribute] Int64* @params);

            /// <summary>[requires: NV_present_video]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_present_video", Version = "", EntryPoint = "glGetVideoi64vNV")]
            public static extern void GetVideo(UInt32 video_slot, OpenTK.Graphics.OpenGL.NvPresentVideo pname, [OutAttribute] Int64[] @params);

            /// <summary>[requires: NV_present_video]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_present_video", Version = "", EntryPoint = "glGetVideoi64vNV")]
            public static extern void GetVideo(UInt32 video_slot, OpenTK.Graphics.OpenGL.NvPresentVideo pname, [OutAttribute] out Int64 @params);

            /// <summary>[requires: NV_present_video]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_present_video", Version = "", EntryPoint = "glGetVideoi64vNV")]
            public static extern unsafe void GetVideo(UInt32 video_slot, OpenTK.Graphics.OpenGL.NvPresentVideo pname, [OutAttribute] Int64* @params);

            /// <summary>[requires: NV_present_video]</summary>
            [AutoGenerated(Category = "NV_present_video", Version = "", EntryPoint = "glGetVideoivNV")]
            public static extern void GetVideo(Int32 video_slot, OpenTK.Graphics.OpenGL.NvPresentVideo pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: NV_present_video]</summary>
            [AutoGenerated(Category = "NV_present_video", Version = "", EntryPoint = "glGetVideoivNV")]
            public static extern void GetVideo(Int32 video_slot, OpenTK.Graphics.OpenGL.NvPresentVideo pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: NV_present_video]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_present_video", Version = "", EntryPoint = "glGetVideoivNV")]
            public static extern unsafe void GetVideo(Int32 video_slot, OpenTK.Graphics.OpenGL.NvPresentVideo pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: NV_present_video]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_present_video", Version = "", EntryPoint = "glGetVideoivNV")]
            public static extern void GetVideo(UInt32 video_slot, OpenTK.Graphics.OpenGL.NvPresentVideo pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: NV_present_video]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_present_video", Version = "", EntryPoint = "glGetVideoivNV")]
            public static extern void GetVideo(UInt32 video_slot, OpenTK.Graphics.OpenGL.NvPresentVideo pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: NV_present_video]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_present_video", Version = "", EntryPoint = "glGetVideoivNV")]
            public static extern unsafe void GetVideo(UInt32 video_slot, OpenTK.Graphics.OpenGL.NvPresentVideo pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: NV_present_video]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_present_video", Version = "", EntryPoint = "glGetVideoui64vNV")]
            public static extern void GetVideo(UInt32 video_slot, OpenTK.Graphics.OpenGL.NvPresentVideo pname, [OutAttribute] UInt64[] @params);

            /// <summary>[requires: NV_present_video]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_present_video", Version = "", EntryPoint = "glGetVideoui64vNV")]
            public static extern void GetVideo(UInt32 video_slot, OpenTK.Graphics.OpenGL.NvPresentVideo pname, [OutAttribute] out UInt64 @params);

            /// <summary>[requires: NV_present_video]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_present_video", Version = "", EntryPoint = "glGetVideoui64vNV")]
            public static extern unsafe void GetVideo(UInt32 video_slot, OpenTK.Graphics.OpenGL.NvPresentVideo pname, [OutAttribute] UInt64* @params);

            /// <summary>[requires: NV_present_video]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_present_video", Version = "", EntryPoint = "glGetVideouivNV")]
            public static extern void GetVideo(UInt32 video_slot, OpenTK.Graphics.OpenGL.NvPresentVideo pname, [OutAttribute] UInt32[] @params);

            /// <summary>[requires: NV_present_video]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_present_video", Version = "", EntryPoint = "glGetVideouivNV")]
            public static extern void GetVideo(UInt32 video_slot, OpenTK.Graphics.OpenGL.NvPresentVideo pname, [OutAttribute] out UInt32 @params);

            /// <summary>[requires: NV_present_video]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_present_video", Version = "", EntryPoint = "glGetVideouivNV")]
            public static extern unsafe void GetVideo(UInt32 video_slot, OpenTK.Graphics.OpenGL.NvPresentVideo pname, [OutAttribute] UInt32* @params);

            /// <summary>[requires: NV_vertex_buffer_unified_memory]</summary>
            [AutoGenerated(Category = "NV_vertex_buffer_unified_memory", Version = "", EntryPoint = "glIndexFormatNV")]
            public static extern void IndexFormat(OpenTK.Graphics.OpenGL.NvVertexBufferUnifiedMemory type, Int32 stride);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glInterpolatePathsNV")]
            public static extern void InterpolatePath(Int32 resultPath, Int32 pathA, Int32 pathB, Single weight);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glInterpolatePathsNV")]
            public static extern void InterpolatePath(UInt32 resultPath, UInt32 pathA, UInt32 pathB, Single weight);

            /// <summary>[requires: NV_shader_buffer_load]</summary>
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glIsBufferResidentNV")]
            public static extern bool IsBufferResident(OpenTK.Graphics.OpenGL.NvShaderBufferLoad target);

            /// <summary>[requires: NV_fence]</summary>
            [AutoGenerated(Category = "NV_fence", Version = "", EntryPoint = "glIsFenceNV")]
            public static extern bool IsFence(Int32 fence);

            /// <summary>[requires: NV_fence]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fence", Version = "", EntryPoint = "glIsFenceNV")]
            public static extern bool IsFence(UInt32 fence);

            /// <summary>[requires: NV_bindless_texture]</summary>
            [AutoGenerated(Category = "NV_bindless_texture", Version = "", EntryPoint = "glIsImageHandleResidentNV")]
            public static extern bool IsImageHandleResident(Int64 handle);

            /// <summary>[requires: NV_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_bindless_texture", Version = "", EntryPoint = "glIsImageHandleResidentNV")]
            public static extern bool IsImageHandleResident(UInt64 handle);

            /// <summary>[requires: NV_shader_buffer_load]</summary>
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glIsNamedBufferResidentNV")]
            public static extern bool IsNamedBufferResident(Int32 buffer);

            /// <summary>[requires: NV_shader_buffer_load]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glIsNamedBufferResidentNV")]
            public static extern bool IsNamedBufferResident(UInt32 buffer);

            /// <summary>[requires: NV_occlusion_query]</summary>
            [AutoGenerated(Category = "NV_occlusion_query", Version = "", EntryPoint = "glIsOcclusionQueryNV")]
            public static extern bool IsOcclusionQuery(Int32 id);

            /// <summary>[requires: NV_occlusion_query]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_occlusion_query", Version = "", EntryPoint = "glIsOcclusionQueryNV")]
            public static extern bool IsOcclusionQuery(UInt32 id);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glIsPathNV")]
            public static extern bool IsPath(Int32 path);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glIsPathNV")]
            public static extern bool IsPath(UInt32 path);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glIsPointInFillPathNV")]
            public static extern bool IsPointInFillPath(Int32 path, Int32 mask, Single x, Single y);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glIsPointInFillPathNV")]
            public static extern bool IsPointInFillPath(UInt32 path, UInt32 mask, Single x, Single y);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glIsPointInStrokePathNV")]
            public static extern bool IsPointInStrokePath(Int32 path, Single x, Single y);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glIsPointInStrokePathNV")]
            public static extern bool IsPointInStrokePath(UInt32 path, Single x, Single y);

            /// <summary>[requires: NV_vertex_program]
            /// Determines if a name corresponds to a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies a potential program object.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glIsProgramNV")]
            public static extern bool IsProgram(Int32 id);

            /// <summary>[requires: NV_vertex_program]
            /// Determines if a name corresponds to a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies a potential program object.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glIsProgramNV")]
            public static extern bool IsProgram(UInt32 id);

            /// <summary>[requires: NV_bindless_texture]</summary>
            [AutoGenerated(Category = "NV_bindless_texture", Version = "", EntryPoint = "glIsTextureHandleResidentNV")]
            public static extern bool IsTextureHandleResident(Int64 handle);

            /// <summary>[requires: NV_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_bindless_texture", Version = "", EntryPoint = "glIsTextureHandleResidentNV")]
            public static extern bool IsTextureHandleResident(UInt64 handle);

            /// <summary>[requires: NV_transform_feedback2]
            /// Determine if a name corresponds to a transform feedback object
            /// </summary>
            /// <param name="id">
            /// <para>
            /// Specifies a value that may be the name of a transform feedback object.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_transform_feedback2", Version = "", EntryPoint = "glIsTransformFeedbackNV")]
            public static extern bool IsTransformFeedback(Int32 id);

            /// <summary>[requires: NV_transform_feedback2]
            /// Determine if a name corresponds to a transform feedback object
            /// </summary>
            /// <param name="id">
            /// <para>
            /// Specifies a value that may be the name of a transform feedback object.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_transform_feedback2", Version = "", EntryPoint = "glIsTransformFeedbackNV")]
            public static extern bool IsTransformFeedback(UInt32 id);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glLoadProgramNV")]
            public static extern void LoadProgram(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 id, Int32 len, Byte[] program);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glLoadProgramNV")]
            public static extern void LoadProgram(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 id, Int32 len, ref Byte program);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glLoadProgramNV")]
            public static extern unsafe void LoadProgram(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 id, Int32 len, Byte* program);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glLoadProgramNV")]
            public static extern void LoadProgram(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 id, Int32 len, Byte[] program);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glLoadProgramNV")]
            public static extern void LoadProgram(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 id, Int32 len, ref Byte program);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glLoadProgramNV")]
            public static extern unsafe void LoadProgram(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 id, Int32 len, Byte* program);

            /// <summary>[requires: NV_shader_buffer_load]</summary>
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glMakeBufferNonResidentNV")]
            public static extern void MakeBufferNonResident(OpenTK.Graphics.OpenGL.NvShaderBufferLoad target);

            /// <summary>[requires: NV_shader_buffer_load]</summary>
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glMakeBufferResidentNV")]
            public static extern void MakeBufferResident(OpenTK.Graphics.OpenGL.NvShaderBufferLoad target, OpenTK.Graphics.OpenGL.NvShaderBufferLoad access);

            /// <summary>[requires: NV_bindless_texture]</summary>
            [AutoGenerated(Category = "NV_bindless_texture", Version = "", EntryPoint = "glMakeImageHandleNonResidentNV")]
            public static extern void MakeImageHandleNonResident(Int64 handle);

            /// <summary>[requires: NV_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_bindless_texture", Version = "", EntryPoint = "glMakeImageHandleNonResidentNV")]
            public static extern void MakeImageHandleNonResident(UInt64 handle);

            /// <summary>[requires: NV_bindless_texture]</summary>
            [AutoGenerated(Category = "NV_bindless_texture", Version = "", EntryPoint = "glMakeImageHandleResidentNV")]
            public static extern void MakeImageHandleResident(Int64 handle, OpenTK.Graphics.OpenGL.NvBindlessTexture access);

            /// <summary>[requires: NV_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_bindless_texture", Version = "", EntryPoint = "glMakeImageHandleResidentNV")]
            public static extern void MakeImageHandleResident(UInt64 handle, OpenTK.Graphics.OpenGL.NvBindlessTexture access);

            /// <summary>[requires: NV_shader_buffer_load]</summary>
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glMakeNamedBufferNonResidentNV")]
            public static extern void MakeNamedBufferNonResident(Int32 buffer);

            /// <summary>[requires: NV_shader_buffer_load]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glMakeNamedBufferNonResidentNV")]
            public static extern void MakeNamedBufferNonResident(UInt32 buffer);

            /// <summary>[requires: NV_shader_buffer_load]</summary>
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glMakeNamedBufferResidentNV")]
            public static extern void MakeNamedBufferResident(Int32 buffer, OpenTK.Graphics.OpenGL.NvShaderBufferLoad access);

            /// <summary>[requires: NV_shader_buffer_load]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glMakeNamedBufferResidentNV")]
            public static extern void MakeNamedBufferResident(UInt32 buffer, OpenTK.Graphics.OpenGL.NvShaderBufferLoad access);

            /// <summary>[requires: NV_bindless_texture]</summary>
            [AutoGenerated(Category = "NV_bindless_texture", Version = "", EntryPoint = "glMakeTextureHandleNonResidentNV")]
            public static extern void MakeTextureHandleNonResident(Int64 handle);

            /// <summary>[requires: NV_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_bindless_texture", Version = "", EntryPoint = "glMakeTextureHandleNonResidentNV")]
            public static extern void MakeTextureHandleNonResident(UInt64 handle);

            /// <summary>[requires: NV_bindless_texture]</summary>
            [AutoGenerated(Category = "NV_bindless_texture", Version = "", EntryPoint = "glMakeTextureHandleResidentNV")]
            public static extern void MakeTextureHandleResident(Int64 handle);

            /// <summary>[requires: NV_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_bindless_texture", Version = "", EntryPoint = "glMakeTextureHandleResidentNV")]
            public static extern void MakeTextureHandleResident(UInt64 handle);

            /// <summary>[requires: NV_evaluators]</summary>
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glMapControlPointsNV")]
            public static extern void MapControlPoints(OpenTK.Graphics.OpenGL.NvEvaluators target, Int32 index, OpenTK.Graphics.OpenGL.NvEvaluators type, Int32 ustride, Int32 vstride, Int32 uorder, Int32 vorder, bool packed, IntPtr points);

            /// <summary>[requires: NV_evaluators]</summary>
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glMapControlPointsNV")]
            public static extern void MapControlPoints<T8>(OpenTK.Graphics.OpenGL.NvEvaluators target, Int32 index, OpenTK.Graphics.OpenGL.NvEvaluators type, Int32 ustride, Int32 vstride, Int32 uorder, Int32 vorder, bool packed, [InAttribute, OutAttribute] T8[] points)
                where T8 : struct
            ;

            /// <summary>[requires: NV_evaluators]</summary>
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glMapControlPointsNV")]
            public static extern void MapControlPoints<T8>(OpenTK.Graphics.OpenGL.NvEvaluators target, Int32 index, OpenTK.Graphics.OpenGL.NvEvaluators type, Int32 ustride, Int32 vstride, Int32 uorder, Int32 vorder, bool packed, [InAttribute, OutAttribute] T8[,] points)
                where T8 : struct
            ;

            /// <summary>[requires: NV_evaluators]</summary>
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glMapControlPointsNV")]
            public static extern void MapControlPoints<T8>(OpenTK.Graphics.OpenGL.NvEvaluators target, Int32 index, OpenTK.Graphics.OpenGL.NvEvaluators type, Int32 ustride, Int32 vstride, Int32 uorder, Int32 vorder, bool packed, [InAttribute, OutAttribute] T8[,,] points)
                where T8 : struct
            ;

            /// <summary>[requires: NV_evaluators]</summary>
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glMapControlPointsNV")]
            public static extern void MapControlPoints<T8>(OpenTK.Graphics.OpenGL.NvEvaluators target, Int32 index, OpenTK.Graphics.OpenGL.NvEvaluators type, Int32 ustride, Int32 vstride, Int32 uorder, Int32 vorder, bool packed, [InAttribute, OutAttribute] ref T8 points)
                where T8 : struct
            ;

            /// <summary>[requires: NV_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glMapControlPointsNV")]
            public static extern void MapControlPoints(OpenTK.Graphics.OpenGL.NvEvaluators target, UInt32 index, OpenTK.Graphics.OpenGL.NvEvaluators type, Int32 ustride, Int32 vstride, Int32 uorder, Int32 vorder, bool packed, IntPtr points);

            /// <summary>[requires: NV_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glMapControlPointsNV")]
            public static extern void MapControlPoints<T8>(OpenTK.Graphics.OpenGL.NvEvaluators target, UInt32 index, OpenTK.Graphics.OpenGL.NvEvaluators type, Int32 ustride, Int32 vstride, Int32 uorder, Int32 vorder, bool packed, [InAttribute, OutAttribute] T8[] points)
                where T8 : struct
            ;

            /// <summary>[requires: NV_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glMapControlPointsNV")]
            public static extern void MapControlPoints<T8>(OpenTK.Graphics.OpenGL.NvEvaluators target, UInt32 index, OpenTK.Graphics.OpenGL.NvEvaluators type, Int32 ustride, Int32 vstride, Int32 uorder, Int32 vorder, bool packed, [InAttribute, OutAttribute] T8[,] points)
                where T8 : struct
            ;

            /// <summary>[requires: NV_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glMapControlPointsNV")]
            public static extern void MapControlPoints<T8>(OpenTK.Graphics.OpenGL.NvEvaluators target, UInt32 index, OpenTK.Graphics.OpenGL.NvEvaluators type, Int32 ustride, Int32 vstride, Int32 uorder, Int32 vorder, bool packed, [InAttribute, OutAttribute] T8[,,] points)
                where T8 : struct
            ;

            /// <summary>[requires: NV_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glMapControlPointsNV")]
            public static extern void MapControlPoints<T8>(OpenTK.Graphics.OpenGL.NvEvaluators target, UInt32 index, OpenTK.Graphics.OpenGL.NvEvaluators type, Int32 ustride, Int32 vstride, Int32 uorder, Int32 vorder, bool packed, [InAttribute, OutAttribute] ref T8 points)
                where T8 : struct
            ;

            /// <summary>[requires: NV_evaluators]</summary>
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glMapParameterfvNV")]
            public static extern void MapParameter(OpenTK.Graphics.OpenGL.NvEvaluators target, OpenTK.Graphics.OpenGL.NvEvaluators pname, Single[] @params);

            /// <summary>[requires: NV_evaluators]</summary>
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glMapParameterfvNV")]
            public static extern void MapParameter(OpenTK.Graphics.OpenGL.NvEvaluators target, OpenTK.Graphics.OpenGL.NvEvaluators pname, ref Single @params);

            /// <summary>[requires: NV_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glMapParameterfvNV")]
            public static extern unsafe void MapParameter(OpenTK.Graphics.OpenGL.NvEvaluators target, OpenTK.Graphics.OpenGL.NvEvaluators pname, Single* @params);

            /// <summary>[requires: NV_evaluators]</summary>
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glMapParameterivNV")]
            public static extern void MapParameter(OpenTK.Graphics.OpenGL.NvEvaluators target, OpenTK.Graphics.OpenGL.NvEvaluators pname, Int32[] @params);

            /// <summary>[requires: NV_evaluators]</summary>
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glMapParameterivNV")]
            public static extern void MapParameter(OpenTK.Graphics.OpenGL.NvEvaluators target, OpenTK.Graphics.OpenGL.NvEvaluators pname, ref Int32 @params);

            /// <summary>[requires: NV_evaluators]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_evaluators", Version = "", EntryPoint = "glMapParameterivNV")]
            public static extern unsafe void MapParameter(OpenTK.Graphics.OpenGL.NvEvaluators target, OpenTK.Graphics.OpenGL.NvEvaluators pname, Int32* @params);

            /// <summary>[requires: NV_bindless_multi_draw_indirect]</summary>
            [AutoGenerated(Category = "NV_bindless_multi_draw_indirect", Version = "", EntryPoint = "glMultiDrawArraysIndirectBindlessNV")]
            public static extern void MultiDrawArraysIndirectBindles(OpenTK.Graphics.OpenGL.NvBindlessMultiDrawIndirect mode, IntPtr indirect, Int32 drawCount, Int32 stride, Int32 vertexBufferCount);

            /// <summary>[requires: NV_bindless_multi_draw_indirect]</summary>
            [AutoGenerated(Category = "NV_bindless_multi_draw_indirect", Version = "", EntryPoint = "glMultiDrawArraysIndirectBindlessNV")]
            public static extern void MultiDrawArraysIndirectBindles<T1>(OpenTK.Graphics.OpenGL.NvBindlessMultiDrawIndirect mode, [InAttribute, OutAttribute] T1[] indirect, Int32 drawCount, Int32 stride, Int32 vertexBufferCount)
                where T1 : struct
            ;

            /// <summary>[requires: NV_bindless_multi_draw_indirect]</summary>
            [AutoGenerated(Category = "NV_bindless_multi_draw_indirect", Version = "", EntryPoint = "glMultiDrawArraysIndirectBindlessNV")]
            public static extern void MultiDrawArraysIndirectBindles<T1>(OpenTK.Graphics.OpenGL.NvBindlessMultiDrawIndirect mode, [InAttribute, OutAttribute] T1[,] indirect, Int32 drawCount, Int32 stride, Int32 vertexBufferCount)
                where T1 : struct
            ;

            /// <summary>[requires: NV_bindless_multi_draw_indirect]</summary>
            [AutoGenerated(Category = "NV_bindless_multi_draw_indirect", Version = "", EntryPoint = "glMultiDrawArraysIndirectBindlessNV")]
            public static extern void MultiDrawArraysIndirectBindles<T1>(OpenTK.Graphics.OpenGL.NvBindlessMultiDrawIndirect mode, [InAttribute, OutAttribute] T1[,,] indirect, Int32 drawCount, Int32 stride, Int32 vertexBufferCount)
                where T1 : struct
            ;

            /// <summary>[requires: NV_bindless_multi_draw_indirect]</summary>
            [AutoGenerated(Category = "NV_bindless_multi_draw_indirect", Version = "", EntryPoint = "glMultiDrawArraysIndirectBindlessNV")]
            public static extern void MultiDrawArraysIndirectBindles<T1>(OpenTK.Graphics.OpenGL.NvBindlessMultiDrawIndirect mode, [InAttribute, OutAttribute] ref T1 indirect, Int32 drawCount, Int32 stride, Int32 vertexBufferCount)
                where T1 : struct
            ;

            /// <summary>[requires: NV_bindless_multi_draw_indirect]</summary>
            [AutoGenerated(Category = "NV_bindless_multi_draw_indirect", Version = "", EntryPoint = "glMultiDrawElementsIndirectBindlessNV")]
            public static extern void MultiDrawElementsIndirectBindles(OpenTK.Graphics.OpenGL.NvBindlessMultiDrawIndirect mode, OpenTK.Graphics.OpenGL.NvBindlessMultiDrawIndirect type, IntPtr indirect, Int32 drawCount, Int32 stride, Int32 vertexBufferCount);

            /// <summary>[requires: NV_bindless_multi_draw_indirect]</summary>
            [AutoGenerated(Category = "NV_bindless_multi_draw_indirect", Version = "", EntryPoint = "glMultiDrawElementsIndirectBindlessNV")]
            public static extern void MultiDrawElementsIndirectBindles<T2>(OpenTK.Graphics.OpenGL.NvBindlessMultiDrawIndirect mode, OpenTK.Graphics.OpenGL.NvBindlessMultiDrawIndirect type, [InAttribute, OutAttribute] T2[] indirect, Int32 drawCount, Int32 stride, Int32 vertexBufferCount)
                where T2 : struct
            ;

            /// <summary>[requires: NV_bindless_multi_draw_indirect]</summary>
            [AutoGenerated(Category = "NV_bindless_multi_draw_indirect", Version = "", EntryPoint = "glMultiDrawElementsIndirectBindlessNV")]
            public static extern void MultiDrawElementsIndirectBindles<T2>(OpenTK.Graphics.OpenGL.NvBindlessMultiDrawIndirect mode, OpenTK.Graphics.OpenGL.NvBindlessMultiDrawIndirect type, [InAttribute, OutAttribute] T2[,] indirect, Int32 drawCount, Int32 stride, Int32 vertexBufferCount)
                where T2 : struct
            ;

            /// <summary>[requires: NV_bindless_multi_draw_indirect]</summary>
            [AutoGenerated(Category = "NV_bindless_multi_draw_indirect", Version = "", EntryPoint = "glMultiDrawElementsIndirectBindlessNV")]
            public static extern void MultiDrawElementsIndirectBindles<T2>(OpenTK.Graphics.OpenGL.NvBindlessMultiDrawIndirect mode, OpenTK.Graphics.OpenGL.NvBindlessMultiDrawIndirect type, [InAttribute, OutAttribute] T2[,,] indirect, Int32 drawCount, Int32 stride, Int32 vertexBufferCount)
                where T2 : struct
            ;

            /// <summary>[requires: NV_bindless_multi_draw_indirect]</summary>
            [AutoGenerated(Category = "NV_bindless_multi_draw_indirect", Version = "", EntryPoint = "glMultiDrawElementsIndirectBindlessNV")]
            public static extern void MultiDrawElementsIndirectBindles<T2>(OpenTK.Graphics.OpenGL.NvBindlessMultiDrawIndirect mode, OpenTK.Graphics.OpenGL.NvBindlessMultiDrawIndirect type, [InAttribute, OutAttribute] ref T2 indirect, Int32 drawCount, Int32 stride, Int32 vertexBufferCount)
                where T2 : struct
            ;

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glMultiTexCoord1hNV")]
            public static extern void MultiTexCoord1h(OpenTK.Graphics.OpenGL.TextureUnit target, Half s);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glMultiTexCoord1hvNV")]
            public static extern unsafe void MultiTexCoord1h(OpenTK.Graphics.OpenGL.TextureUnit target, Half* v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glMultiTexCoord2hNV")]
            public static extern void MultiTexCoord2h(OpenTK.Graphics.OpenGL.TextureUnit target, Half s, Half t);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glMultiTexCoord2hvNV")]
            public static extern void MultiTexCoord2h(OpenTK.Graphics.OpenGL.TextureUnit target, Half[] v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glMultiTexCoord2hvNV")]
            public static extern void MultiTexCoord2h(OpenTK.Graphics.OpenGL.TextureUnit target, ref Half v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glMultiTexCoord2hvNV")]
            public static extern unsafe void MultiTexCoord2h(OpenTK.Graphics.OpenGL.TextureUnit target, Half* v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glMultiTexCoord3hNV")]
            public static extern void MultiTexCoord3h(OpenTK.Graphics.OpenGL.TextureUnit target, Half s, Half t, Half r);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glMultiTexCoord3hvNV")]
            public static extern void MultiTexCoord3h(OpenTK.Graphics.OpenGL.TextureUnit target, Half[] v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glMultiTexCoord3hvNV")]
            public static extern void MultiTexCoord3h(OpenTK.Graphics.OpenGL.TextureUnit target, ref Half v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glMultiTexCoord3hvNV")]
            public static extern unsafe void MultiTexCoord3h(OpenTK.Graphics.OpenGL.TextureUnit target, Half* v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glMultiTexCoord4hNV")]
            public static extern void MultiTexCoord4h(OpenTK.Graphics.OpenGL.TextureUnit target, Half s, Half t, Half r, Half q);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glMultiTexCoord4hvNV")]
            public static extern void MultiTexCoord4h(OpenTK.Graphics.OpenGL.TextureUnit target, Half[] v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glMultiTexCoord4hvNV")]
            public static extern void MultiTexCoord4h(OpenTK.Graphics.OpenGL.TextureUnit target, ref Half v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glMultiTexCoord4hvNV")]
            public static extern unsafe void MultiTexCoord4h(OpenTK.Graphics.OpenGL.TextureUnit target, Half* v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glNormal3hNV")]
            public static extern void Normal3h(Half nx, Half ny, Half nz);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glNormal3hvNV")]
            public static extern void Normal3h(Half[] v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glNormal3hvNV")]
            public static extern void Normal3h(ref Half v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glNormal3hvNV")]
            public static extern unsafe void Normal3h(Half* v);

            /// <summary>[requires: NV_vertex_buffer_unified_memory]</summary>
            [AutoGenerated(Category = "NV_vertex_buffer_unified_memory", Version = "", EntryPoint = "glNormalFormatNV")]
            public static extern void NormalFormat(OpenTK.Graphics.OpenGL.NvVertexBufferUnifiedMemory type, Int32 stride);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathColorGenNV")]
            public static extern void PathColorGen(OpenTK.Graphics.OpenGL.NvPathRendering color, OpenTK.Graphics.OpenGL.NvPathRendering genMode, OpenTK.Graphics.OpenGL.NvPathRendering colorFormat, Single[] coeffs);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathColorGenNV")]
            public static extern void PathColorGen(OpenTK.Graphics.OpenGL.NvPathRendering color, OpenTK.Graphics.OpenGL.NvPathRendering genMode, OpenTK.Graphics.OpenGL.NvPathRendering colorFormat, ref Single coeffs);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathColorGenNV")]
            public static extern unsafe void PathColorGen(OpenTK.Graphics.OpenGL.NvPathRendering color, OpenTK.Graphics.OpenGL.NvPathRendering genMode, OpenTK.Graphics.OpenGL.NvPathRendering colorFormat, Single* coeffs);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCommandsNV")]
            public static extern void PathCommands(Int32 path, Int32 numCommands, Byte[] commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, IntPtr coords);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCommandsNV")]
            public static extern void PathCommands<T5>(Int32 path, Int32 numCommands, Byte[] commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T5[] coords)
                where T5 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCommandsNV")]
            public static extern void PathCommands<T5>(Int32 path, Int32 numCommands, Byte[] commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T5[,] coords)
                where T5 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCommandsNV")]
            public static extern void PathCommands<T5>(Int32 path, Int32 numCommands, Byte[] commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T5[,,] coords)
                where T5 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCommandsNV")]
            public static extern void PathCommands<T5>(Int32 path, Int32 numCommands, Byte[] commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] ref T5 coords)
                where T5 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCommandsNV")]
            public static extern void PathCommands(Int32 path, Int32 numCommands, ref Byte commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, IntPtr coords);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCommandsNV")]
            public static extern void PathCommands<T5>(Int32 path, Int32 numCommands, ref Byte commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T5[] coords)
                where T5 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCommandsNV")]
            public static extern void PathCommands<T5>(Int32 path, Int32 numCommands, ref Byte commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T5[,] coords)
                where T5 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCommandsNV")]
            public static extern void PathCommands<T5>(Int32 path, Int32 numCommands, ref Byte commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T5[,,] coords)
                where T5 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCommandsNV")]
            public static extern void PathCommands<T5>(Int32 path, Int32 numCommands, ref Byte commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] ref T5 coords)
                where T5 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCommandsNV")]
            public static extern unsafe void PathCommands(Int32 path, Int32 numCommands, Byte* commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, IntPtr coords);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCommandsNV")]
            public static extern unsafe void PathCommands<T5>(Int32 path, Int32 numCommands, Byte* commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T5[] coords)
                where T5 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCommandsNV")]
            public static extern unsafe void PathCommands<T5>(Int32 path, Int32 numCommands, Byte* commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T5[,] coords)
                where T5 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCommandsNV")]
            public static extern unsafe void PathCommands<T5>(Int32 path, Int32 numCommands, Byte* commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T5[,,] coords)
                where T5 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCommandsNV")]
            public static extern unsafe void PathCommands<T5>(Int32 path, Int32 numCommands, Byte* commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] ref T5 coords)
                where T5 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCommandsNV")]
            public static extern void PathCommands(UInt32 path, Int32 numCommands, Byte[] commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, IntPtr coords);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCommandsNV")]
            public static extern void PathCommands<T5>(UInt32 path, Int32 numCommands, Byte[] commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T5[] coords)
                where T5 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCommandsNV")]
            public static extern void PathCommands<T5>(UInt32 path, Int32 numCommands, Byte[] commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T5[,] coords)
                where T5 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCommandsNV")]
            public static extern void PathCommands<T5>(UInt32 path, Int32 numCommands, Byte[] commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T5[,,] coords)
                where T5 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCommandsNV")]
            public static extern void PathCommands<T5>(UInt32 path, Int32 numCommands, Byte[] commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] ref T5 coords)
                where T5 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCommandsNV")]
            public static extern void PathCommands(UInt32 path, Int32 numCommands, ref Byte commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, IntPtr coords);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCommandsNV")]
            public static extern void PathCommands<T5>(UInt32 path, Int32 numCommands, ref Byte commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T5[] coords)
                where T5 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCommandsNV")]
            public static extern void PathCommands<T5>(UInt32 path, Int32 numCommands, ref Byte commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T5[,] coords)
                where T5 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCommandsNV")]
            public static extern void PathCommands<T5>(UInt32 path, Int32 numCommands, ref Byte commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T5[,,] coords)
                where T5 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCommandsNV")]
            public static extern void PathCommands<T5>(UInt32 path, Int32 numCommands, ref Byte commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] ref T5 coords)
                where T5 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCommandsNV")]
            public static extern unsafe void PathCommands(UInt32 path, Int32 numCommands, Byte* commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, IntPtr coords);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCommandsNV")]
            public static extern unsafe void PathCommands<T5>(UInt32 path, Int32 numCommands, Byte* commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T5[] coords)
                where T5 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCommandsNV")]
            public static extern unsafe void PathCommands<T5>(UInt32 path, Int32 numCommands, Byte* commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T5[,] coords)
                where T5 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCommandsNV")]
            public static extern unsafe void PathCommands<T5>(UInt32 path, Int32 numCommands, Byte* commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T5[,,] coords)
                where T5 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCommandsNV")]
            public static extern unsafe void PathCommands<T5>(UInt32 path, Int32 numCommands, Byte* commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] ref T5 coords)
                where T5 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCoordsNV")]
            public static extern void PathCoords(Int32 path, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, IntPtr coords);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCoordsNV")]
            public static extern void PathCoords<T3>(Int32 path, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T3[] coords)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCoordsNV")]
            public static extern void PathCoords<T3>(Int32 path, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T3[,] coords)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCoordsNV")]
            public static extern void PathCoords<T3>(Int32 path, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T3[,,] coords)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCoordsNV")]
            public static extern void PathCoords<T3>(Int32 path, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] ref T3 coords)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCoordsNV")]
            public static extern void PathCoords(UInt32 path, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, IntPtr coords);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCoordsNV")]
            public static extern void PathCoords<T3>(UInt32 path, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T3[] coords)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCoordsNV")]
            public static extern void PathCoords<T3>(UInt32 path, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T3[,] coords)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCoordsNV")]
            public static extern void PathCoords<T3>(UInt32 path, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T3[,,] coords)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCoordsNV")]
            public static extern void PathCoords<T3>(UInt32 path, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] ref T3 coords)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathCoverDepthFuncNV")]
            public static extern void PathCoverDepthFunc(OpenTK.Graphics.OpenGL.DepthFunction func);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathDashArrayNV")]
            public static extern void PathDashArray(Int32 path, Int32 dashCount, Single[] dashArray);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathDashArrayNV")]
            public static extern void PathDashArray(Int32 path, Int32 dashCount, ref Single dashArray);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathDashArrayNV")]
            public static extern unsafe void PathDashArray(Int32 path, Int32 dashCount, Single* dashArray);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathDashArrayNV")]
            public static extern void PathDashArray(UInt32 path, Int32 dashCount, Single[] dashArray);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathDashArrayNV")]
            public static extern void PathDashArray(UInt32 path, Int32 dashCount, ref Single dashArray);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathDashArrayNV")]
            public static extern unsafe void PathDashArray(UInt32 path, Int32 dashCount, Single* dashArray);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathFogGenNV")]
            public static extern void PathFogGen(OpenTK.Graphics.OpenGL.NvPathRendering genMode);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathGlyphRangeNV")]
            public static extern void PathGlyphRange(Int32 firstPathName, OpenTK.Graphics.OpenGL.NvPathRendering fontTarget, IntPtr fontName, Int32 fontStyle, Int32 firstGlyph, Int32 numGlyphs, OpenTK.Graphics.OpenGL.NvPathRendering handleMissingGlyphs, Int32 pathParameterTemplate, Single emScale);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathGlyphRangeNV")]
            public static extern void PathGlyphRange<T2>(Int32 firstPathName, OpenTK.Graphics.OpenGL.NvPathRendering fontTarget, [InAttribute, OutAttribute] T2[] fontName, Int32 fontStyle, Int32 firstGlyph, Int32 numGlyphs, OpenTK.Graphics.OpenGL.NvPathRendering handleMissingGlyphs, Int32 pathParameterTemplate, Single emScale)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathGlyphRangeNV")]
            public static extern void PathGlyphRange<T2>(Int32 firstPathName, OpenTK.Graphics.OpenGL.NvPathRendering fontTarget, [InAttribute, OutAttribute] T2[,] fontName, Int32 fontStyle, Int32 firstGlyph, Int32 numGlyphs, OpenTK.Graphics.OpenGL.NvPathRendering handleMissingGlyphs, Int32 pathParameterTemplate, Single emScale)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathGlyphRangeNV")]
            public static extern void PathGlyphRange<T2>(Int32 firstPathName, OpenTK.Graphics.OpenGL.NvPathRendering fontTarget, [InAttribute, OutAttribute] T2[,,] fontName, Int32 fontStyle, Int32 firstGlyph, Int32 numGlyphs, OpenTK.Graphics.OpenGL.NvPathRendering handleMissingGlyphs, Int32 pathParameterTemplate, Single emScale)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathGlyphRangeNV")]
            public static extern void PathGlyphRange<T2>(Int32 firstPathName, OpenTK.Graphics.OpenGL.NvPathRendering fontTarget, [InAttribute, OutAttribute] ref T2 fontName, Int32 fontStyle, Int32 firstGlyph, Int32 numGlyphs, OpenTK.Graphics.OpenGL.NvPathRendering handleMissingGlyphs, Int32 pathParameterTemplate, Single emScale)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathGlyphRangeNV")]
            public static extern void PathGlyphRange(UInt32 firstPathName, OpenTK.Graphics.OpenGL.NvPathRendering fontTarget, IntPtr fontName, UInt32 fontStyle, UInt32 firstGlyph, Int32 numGlyphs, OpenTK.Graphics.OpenGL.NvPathRendering handleMissingGlyphs, UInt32 pathParameterTemplate, Single emScale);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathGlyphRangeNV")]
            public static extern void PathGlyphRange<T2>(UInt32 firstPathName, OpenTK.Graphics.OpenGL.NvPathRendering fontTarget, [InAttribute, OutAttribute] T2[] fontName, UInt32 fontStyle, UInt32 firstGlyph, Int32 numGlyphs, OpenTK.Graphics.OpenGL.NvPathRendering handleMissingGlyphs, UInt32 pathParameterTemplate, Single emScale)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathGlyphRangeNV")]
            public static extern void PathGlyphRange<T2>(UInt32 firstPathName, OpenTK.Graphics.OpenGL.NvPathRendering fontTarget, [InAttribute, OutAttribute] T2[,] fontName, UInt32 fontStyle, UInt32 firstGlyph, Int32 numGlyphs, OpenTK.Graphics.OpenGL.NvPathRendering handleMissingGlyphs, UInt32 pathParameterTemplate, Single emScale)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathGlyphRangeNV")]
            public static extern void PathGlyphRange<T2>(UInt32 firstPathName, OpenTK.Graphics.OpenGL.NvPathRendering fontTarget, [InAttribute, OutAttribute] T2[,,] fontName, UInt32 fontStyle, UInt32 firstGlyph, Int32 numGlyphs, OpenTK.Graphics.OpenGL.NvPathRendering handleMissingGlyphs, UInt32 pathParameterTemplate, Single emScale)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathGlyphRangeNV")]
            public static extern void PathGlyphRange<T2>(UInt32 firstPathName, OpenTK.Graphics.OpenGL.NvPathRendering fontTarget, [InAttribute, OutAttribute] ref T2 fontName, UInt32 fontStyle, UInt32 firstGlyph, Int32 numGlyphs, OpenTK.Graphics.OpenGL.NvPathRendering handleMissingGlyphs, UInt32 pathParameterTemplate, Single emScale)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathGlyphsNV")]
            public static extern void PathGlyph(Int32 firstPathName, OpenTK.Graphics.OpenGL.NvPathRendering fontTarget, IntPtr fontName, Int32 fontStyle, Int32 numGlyphs, OpenTK.Graphics.OpenGL.NvPathRendering type, IntPtr charcodes, OpenTK.Graphics.OpenGL.NvPathRendering handleMissingGlyphs, Int32 pathParameterTemplate, Single emScale);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathGlyphsNV")]
            public static extern void PathGlyph<T2,T6>(Int32 firstPathName, OpenTK.Graphics.OpenGL.NvPathRendering fontTarget, [InAttribute, OutAttribute] T2[] fontName, Int32 fontStyle, Int32 numGlyphs, OpenTK.Graphics.OpenGL.NvPathRendering type, [InAttribute, OutAttribute] T6[] charcodes, OpenTK.Graphics.OpenGL.NvPathRendering handleMissingGlyphs, Int32 pathParameterTemplate, Single emScale)
                where T2 : struct
                where T6 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathGlyphsNV")]
            public static extern void PathGlyph<T2,T6>(Int32 firstPathName, OpenTK.Graphics.OpenGL.NvPathRendering fontTarget, [InAttribute, OutAttribute] T2[,] fontName, Int32 fontStyle, Int32 numGlyphs, OpenTK.Graphics.OpenGL.NvPathRendering type, [InAttribute, OutAttribute] T6[,] charcodes, OpenTK.Graphics.OpenGL.NvPathRendering handleMissingGlyphs, Int32 pathParameterTemplate, Single emScale)
                where T2 : struct
                where T6 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathGlyphsNV")]
            public static extern void PathGlyph<T2,T6>(Int32 firstPathName, OpenTK.Graphics.OpenGL.NvPathRendering fontTarget, [InAttribute, OutAttribute] T2[,,] fontName, Int32 fontStyle, Int32 numGlyphs, OpenTK.Graphics.OpenGL.NvPathRendering type, [InAttribute, OutAttribute] T6[,,] charcodes, OpenTK.Graphics.OpenGL.NvPathRendering handleMissingGlyphs, Int32 pathParameterTemplate, Single emScale)
                where T2 : struct
                where T6 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathGlyphsNV")]
            public static extern void PathGlyph<T2,T6>(Int32 firstPathName, OpenTK.Graphics.OpenGL.NvPathRendering fontTarget, [InAttribute, OutAttribute] ref T2 fontName, Int32 fontStyle, Int32 numGlyphs, OpenTK.Graphics.OpenGL.NvPathRendering type, [InAttribute, OutAttribute] ref T6 charcodes, OpenTK.Graphics.OpenGL.NvPathRendering handleMissingGlyphs, Int32 pathParameterTemplate, Single emScale)
                where T2 : struct
                where T6 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathGlyphsNV")]
            public static extern void PathGlyph(UInt32 firstPathName, OpenTK.Graphics.OpenGL.NvPathRendering fontTarget, IntPtr fontName, UInt32 fontStyle, Int32 numGlyphs, OpenTK.Graphics.OpenGL.NvPathRendering type, IntPtr charcodes, OpenTK.Graphics.OpenGL.NvPathRendering handleMissingGlyphs, UInt32 pathParameterTemplate, Single emScale);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathGlyphsNV")]
            public static extern void PathGlyph<T2,T6>(UInt32 firstPathName, OpenTK.Graphics.OpenGL.NvPathRendering fontTarget, [InAttribute, OutAttribute] T2[] fontName, UInt32 fontStyle, Int32 numGlyphs, OpenTK.Graphics.OpenGL.NvPathRendering type, [InAttribute, OutAttribute] T6[] charcodes, OpenTK.Graphics.OpenGL.NvPathRendering handleMissingGlyphs, UInt32 pathParameterTemplate, Single emScale)
                where T2 : struct
                where T6 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathGlyphsNV")]
            public static extern void PathGlyph<T2,T6>(UInt32 firstPathName, OpenTK.Graphics.OpenGL.NvPathRendering fontTarget, [InAttribute, OutAttribute] T2[,] fontName, UInt32 fontStyle, Int32 numGlyphs, OpenTK.Graphics.OpenGL.NvPathRendering type, [InAttribute, OutAttribute] T6[,] charcodes, OpenTK.Graphics.OpenGL.NvPathRendering handleMissingGlyphs, UInt32 pathParameterTemplate, Single emScale)
                where T2 : struct
                where T6 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathGlyphsNV")]
            public static extern void PathGlyph<T2,T6>(UInt32 firstPathName, OpenTK.Graphics.OpenGL.NvPathRendering fontTarget, [InAttribute, OutAttribute] T2[,,] fontName, UInt32 fontStyle, Int32 numGlyphs, OpenTK.Graphics.OpenGL.NvPathRendering type, [InAttribute, OutAttribute] T6[,,] charcodes, OpenTK.Graphics.OpenGL.NvPathRendering handleMissingGlyphs, UInt32 pathParameterTemplate, Single emScale)
                where T2 : struct
                where T6 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathGlyphsNV")]
            public static extern void PathGlyph<T2,T6>(UInt32 firstPathName, OpenTK.Graphics.OpenGL.NvPathRendering fontTarget, [InAttribute, OutAttribute] ref T2 fontName, UInt32 fontStyle, Int32 numGlyphs, OpenTK.Graphics.OpenGL.NvPathRendering type, [InAttribute, OutAttribute] ref T6 charcodes, OpenTK.Graphics.OpenGL.NvPathRendering handleMissingGlyphs, UInt32 pathParameterTemplate, Single emScale)
                where T2 : struct
                where T6 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathParameterfNV")]
            public static extern void PathParameter(Int32 path, OpenTK.Graphics.OpenGL.NvPathRendering pname, Single value);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathParameterfNV")]
            public static extern void PathParameter(UInt32 path, OpenTK.Graphics.OpenGL.NvPathRendering pname, Single value);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathParameterfvNV")]
            public static extern void PathParameter(Int32 path, OpenTK.Graphics.OpenGL.NvPathRendering pname, Single[] value);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathParameterfvNV")]
            public static extern unsafe void PathParameter(Int32 path, OpenTK.Graphics.OpenGL.NvPathRendering pname, Single* value);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathParameterfvNV")]
            public static extern void PathParameter(UInt32 path, OpenTK.Graphics.OpenGL.NvPathRendering pname, Single[] value);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathParameterfvNV")]
            public static extern unsafe void PathParameter(UInt32 path, OpenTK.Graphics.OpenGL.NvPathRendering pname, Single* value);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathParameteriNV")]
            public static extern void PathParameter(Int32 path, OpenTK.Graphics.OpenGL.NvPathRendering pname, Int32 value);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathParameteriNV")]
            public static extern void PathParameter(UInt32 path, OpenTK.Graphics.OpenGL.NvPathRendering pname, Int32 value);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathParameterivNV")]
            public static extern void PathParameter(Int32 path, OpenTK.Graphics.OpenGL.NvPathRendering pname, Int32[] value);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathParameterivNV")]
            public static extern unsafe void PathParameter(Int32 path, OpenTK.Graphics.OpenGL.NvPathRendering pname, Int32* value);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathParameterivNV")]
            public static extern void PathParameter(UInt32 path, OpenTK.Graphics.OpenGL.NvPathRendering pname, Int32[] value);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathParameterivNV")]
            public static extern unsafe void PathParameter(UInt32 path, OpenTK.Graphics.OpenGL.NvPathRendering pname, Int32* value);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathStencilDepthOffsetNV")]
            public static extern void PathStencilDepthOffset(Single factor, Single units);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathStencilFuncNV")]
            public static extern void PathStencilFunc(OpenTK.Graphics.OpenGL.StencilFunction func, Int32 @ref, Int32 mask);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathStencilFuncNV")]
            public static extern void PathStencilFunc(OpenTK.Graphics.OpenGL.StencilFunction func, Int32 @ref, UInt32 mask);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathStringNV")]
            public static extern void PathString(Int32 path, OpenTK.Graphics.OpenGL.NvPathRendering format, Int32 length, IntPtr pathString);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathStringNV")]
            public static extern void PathString<T3>(Int32 path, OpenTK.Graphics.OpenGL.NvPathRendering format, Int32 length, [InAttribute, OutAttribute] T3[] pathString)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathStringNV")]
            public static extern void PathString<T3>(Int32 path, OpenTK.Graphics.OpenGL.NvPathRendering format, Int32 length, [InAttribute, OutAttribute] T3[,] pathString)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathStringNV")]
            public static extern void PathString<T3>(Int32 path, OpenTK.Graphics.OpenGL.NvPathRendering format, Int32 length, [InAttribute, OutAttribute] T3[,,] pathString)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathStringNV")]
            public static extern void PathString<T3>(Int32 path, OpenTK.Graphics.OpenGL.NvPathRendering format, Int32 length, [InAttribute, OutAttribute] ref T3 pathString)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathStringNV")]
            public static extern void PathString(UInt32 path, OpenTK.Graphics.OpenGL.NvPathRendering format, Int32 length, IntPtr pathString);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathStringNV")]
            public static extern void PathString<T3>(UInt32 path, OpenTK.Graphics.OpenGL.NvPathRendering format, Int32 length, [InAttribute, OutAttribute] T3[] pathString)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathStringNV")]
            public static extern void PathString<T3>(UInt32 path, OpenTK.Graphics.OpenGL.NvPathRendering format, Int32 length, [InAttribute, OutAttribute] T3[,] pathString)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathStringNV")]
            public static extern void PathString<T3>(UInt32 path, OpenTK.Graphics.OpenGL.NvPathRendering format, Int32 length, [InAttribute, OutAttribute] T3[,,] pathString)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathStringNV")]
            public static extern void PathString<T3>(UInt32 path, OpenTK.Graphics.OpenGL.NvPathRendering format, Int32 length, [InAttribute, OutAttribute] ref T3 pathString)
                where T3 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCommandsNV")]
            public static extern void PathSubCommands(Int32 path, Int32 commandStart, Int32 commandsToDelete, Int32 numCommands, Byte[] commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, IntPtr coords);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCommandsNV")]
            public static extern void PathSubCommands<T7>(Int32 path, Int32 commandStart, Int32 commandsToDelete, Int32 numCommands, Byte[] commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T7[] coords)
                where T7 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCommandsNV")]
            public static extern void PathSubCommands<T7>(Int32 path, Int32 commandStart, Int32 commandsToDelete, Int32 numCommands, Byte[] commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T7[,] coords)
                where T7 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCommandsNV")]
            public static extern void PathSubCommands<T7>(Int32 path, Int32 commandStart, Int32 commandsToDelete, Int32 numCommands, Byte[] commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T7[,,] coords)
                where T7 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCommandsNV")]
            public static extern void PathSubCommands<T7>(Int32 path, Int32 commandStart, Int32 commandsToDelete, Int32 numCommands, Byte[] commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] ref T7 coords)
                where T7 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCommandsNV")]
            public static extern void PathSubCommands(Int32 path, Int32 commandStart, Int32 commandsToDelete, Int32 numCommands, ref Byte commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, IntPtr coords);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCommandsNV")]
            public static extern void PathSubCommands<T7>(Int32 path, Int32 commandStart, Int32 commandsToDelete, Int32 numCommands, ref Byte commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T7[] coords)
                where T7 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCommandsNV")]
            public static extern void PathSubCommands<T7>(Int32 path, Int32 commandStart, Int32 commandsToDelete, Int32 numCommands, ref Byte commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T7[,] coords)
                where T7 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCommandsNV")]
            public static extern void PathSubCommands<T7>(Int32 path, Int32 commandStart, Int32 commandsToDelete, Int32 numCommands, ref Byte commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T7[,,] coords)
                where T7 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCommandsNV")]
            public static extern void PathSubCommands<T7>(Int32 path, Int32 commandStart, Int32 commandsToDelete, Int32 numCommands, ref Byte commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] ref T7 coords)
                where T7 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCommandsNV")]
            public static extern unsafe void PathSubCommands(Int32 path, Int32 commandStart, Int32 commandsToDelete, Int32 numCommands, Byte* commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, IntPtr coords);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCommandsNV")]
            public static extern unsafe void PathSubCommands<T7>(Int32 path, Int32 commandStart, Int32 commandsToDelete, Int32 numCommands, Byte* commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T7[] coords)
                where T7 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCommandsNV")]
            public static extern unsafe void PathSubCommands<T7>(Int32 path, Int32 commandStart, Int32 commandsToDelete, Int32 numCommands, Byte* commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T7[,] coords)
                where T7 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCommandsNV")]
            public static extern unsafe void PathSubCommands<T7>(Int32 path, Int32 commandStart, Int32 commandsToDelete, Int32 numCommands, Byte* commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T7[,,] coords)
                where T7 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCommandsNV")]
            public static extern unsafe void PathSubCommands<T7>(Int32 path, Int32 commandStart, Int32 commandsToDelete, Int32 numCommands, Byte* commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] ref T7 coords)
                where T7 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCommandsNV")]
            public static extern void PathSubCommands(UInt32 path, Int32 commandStart, Int32 commandsToDelete, Int32 numCommands, Byte[] commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, IntPtr coords);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCommandsNV")]
            public static extern void PathSubCommands<T7>(UInt32 path, Int32 commandStart, Int32 commandsToDelete, Int32 numCommands, Byte[] commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T7[] coords)
                where T7 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCommandsNV")]
            public static extern void PathSubCommands<T7>(UInt32 path, Int32 commandStart, Int32 commandsToDelete, Int32 numCommands, Byte[] commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T7[,] coords)
                where T7 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCommandsNV")]
            public static extern void PathSubCommands<T7>(UInt32 path, Int32 commandStart, Int32 commandsToDelete, Int32 numCommands, Byte[] commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T7[,,] coords)
                where T7 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCommandsNV")]
            public static extern void PathSubCommands<T7>(UInt32 path, Int32 commandStart, Int32 commandsToDelete, Int32 numCommands, Byte[] commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] ref T7 coords)
                where T7 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCommandsNV")]
            public static extern void PathSubCommands(UInt32 path, Int32 commandStart, Int32 commandsToDelete, Int32 numCommands, ref Byte commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, IntPtr coords);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCommandsNV")]
            public static extern void PathSubCommands<T7>(UInt32 path, Int32 commandStart, Int32 commandsToDelete, Int32 numCommands, ref Byte commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T7[] coords)
                where T7 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCommandsNV")]
            public static extern void PathSubCommands<T7>(UInt32 path, Int32 commandStart, Int32 commandsToDelete, Int32 numCommands, ref Byte commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T7[,] coords)
                where T7 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCommandsNV")]
            public static extern void PathSubCommands<T7>(UInt32 path, Int32 commandStart, Int32 commandsToDelete, Int32 numCommands, ref Byte commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T7[,,] coords)
                where T7 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCommandsNV")]
            public static extern void PathSubCommands<T7>(UInt32 path, Int32 commandStart, Int32 commandsToDelete, Int32 numCommands, ref Byte commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] ref T7 coords)
                where T7 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCommandsNV")]
            public static extern unsafe void PathSubCommands(UInt32 path, Int32 commandStart, Int32 commandsToDelete, Int32 numCommands, Byte* commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, IntPtr coords);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCommandsNV")]
            public static extern unsafe void PathSubCommands<T7>(UInt32 path, Int32 commandStart, Int32 commandsToDelete, Int32 numCommands, Byte* commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T7[] coords)
                where T7 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCommandsNV")]
            public static extern unsafe void PathSubCommands<T7>(UInt32 path, Int32 commandStart, Int32 commandsToDelete, Int32 numCommands, Byte* commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T7[,] coords)
                where T7 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCommandsNV")]
            public static extern unsafe void PathSubCommands<T7>(UInt32 path, Int32 commandStart, Int32 commandsToDelete, Int32 numCommands, Byte* commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T7[,,] coords)
                where T7 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCommandsNV")]
            public static extern unsafe void PathSubCommands<T7>(UInt32 path, Int32 commandStart, Int32 commandsToDelete, Int32 numCommands, Byte* commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] ref T7 coords)
                where T7 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCoordsNV")]
            public static extern void PathSubCoords(Int32 path, Int32 coordStart, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, IntPtr coords);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCoordsNV")]
            public static extern void PathSubCoords<T4>(Int32 path, Int32 coordStart, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T4[] coords)
                where T4 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCoordsNV")]
            public static extern void PathSubCoords<T4>(Int32 path, Int32 coordStart, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T4[,] coords)
                where T4 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCoordsNV")]
            public static extern void PathSubCoords<T4>(Int32 path, Int32 coordStart, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T4[,,] coords)
                where T4 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCoordsNV")]
            public static extern void PathSubCoords<T4>(Int32 path, Int32 coordStart, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] ref T4 coords)
                where T4 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCoordsNV")]
            public static extern void PathSubCoords(UInt32 path, Int32 coordStart, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, IntPtr coords);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCoordsNV")]
            public static extern void PathSubCoords<T4>(UInt32 path, Int32 coordStart, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T4[] coords)
                where T4 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCoordsNV")]
            public static extern void PathSubCoords<T4>(UInt32 path, Int32 coordStart, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T4[,] coords)
                where T4 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCoordsNV")]
            public static extern void PathSubCoords<T4>(UInt32 path, Int32 coordStart, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] T4[,,] coords)
                where T4 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathSubCoordsNV")]
            public static extern void PathSubCoords<T4>(UInt32 path, Int32 coordStart, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, [InAttribute, OutAttribute] ref T4 coords)
                where T4 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathTexGenNV")]
            public static extern void PathTexGen(OpenTK.Graphics.OpenGL.NvPathRendering texCoordSet, OpenTK.Graphics.OpenGL.NvPathRendering genMode, Int32 components, Single[] coeffs);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathTexGenNV")]
            public static extern void PathTexGen(OpenTK.Graphics.OpenGL.NvPathRendering texCoordSet, OpenTK.Graphics.OpenGL.NvPathRendering genMode, Int32 components, ref Single coeffs);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPathTexGenNV")]
            public static extern unsafe void PathTexGen(OpenTK.Graphics.OpenGL.NvPathRendering texCoordSet, OpenTK.Graphics.OpenGL.NvPathRendering genMode, Int32 components, Single* coeffs);

            /// <summary>[requires: NV_transform_feedback2]
            /// Pause transform feedback operations
            /// </summary>
            [AutoGenerated(Category = "NV_transform_feedback2", Version = "", EntryPoint = "glPauseTransformFeedbackNV")]
            public static extern void PauseTransformFeedback();

            /// <summary>[requires: NV_pixel_data_range]</summary>
            [AutoGenerated(Category = "NV_pixel_data_range", Version = "", EntryPoint = "glPixelDataRangeNV")]
            public static extern void PixelDataRange(OpenTK.Graphics.OpenGL.NvPixelDataRange target, Int32 length, IntPtr pointer);

            /// <summary>[requires: NV_pixel_data_range]</summary>
            [AutoGenerated(Category = "NV_pixel_data_range", Version = "", EntryPoint = "glPixelDataRangeNV")]
            public static extern void PixelDataRange<T2>(OpenTK.Graphics.OpenGL.NvPixelDataRange target, Int32 length, [InAttribute, OutAttribute] T2[] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: NV_pixel_data_range]</summary>
            [AutoGenerated(Category = "NV_pixel_data_range", Version = "", EntryPoint = "glPixelDataRangeNV")]
            public static extern void PixelDataRange<T2>(OpenTK.Graphics.OpenGL.NvPixelDataRange target, Int32 length, [InAttribute, OutAttribute] T2[,] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: NV_pixel_data_range]</summary>
            [AutoGenerated(Category = "NV_pixel_data_range", Version = "", EntryPoint = "glPixelDataRangeNV")]
            public static extern void PixelDataRange<T2>(OpenTK.Graphics.OpenGL.NvPixelDataRange target, Int32 length, [InAttribute, OutAttribute] T2[,,] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: NV_pixel_data_range]</summary>
            [AutoGenerated(Category = "NV_pixel_data_range", Version = "", EntryPoint = "glPixelDataRangeNV")]
            public static extern void PixelDataRange<T2>(OpenTK.Graphics.OpenGL.NvPixelDataRange target, Int32 length, [InAttribute, OutAttribute] ref T2 pointer)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPointAlongPathNV")]
            public static extern bool PointAlongPath(Int32 path, Int32 startSegment, Int32 numSegments, Single distance, [OutAttribute] out Single x, [OutAttribute] out Single y, [OutAttribute] out Single tangentX, [OutAttribute] out Single tangentY);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPointAlongPathNV")]
            public static extern unsafe bool PointAlongPath(Int32 path, Int32 startSegment, Int32 numSegments, Single distance, [OutAttribute] Single* x, [OutAttribute] Single* y, [OutAttribute] Single* tangentX, [OutAttribute] Single* tangentY);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPointAlongPathNV")]
            public static extern bool PointAlongPath(UInt32 path, Int32 startSegment, Int32 numSegments, Single distance, [OutAttribute] out Single x, [OutAttribute] out Single y, [OutAttribute] out Single tangentX, [OutAttribute] out Single tangentY);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glPointAlongPathNV")]
            public static extern unsafe bool PointAlongPath(UInt32 path, Int32 startSegment, Int32 numSegments, Single distance, [OutAttribute] Single* x, [OutAttribute] Single* y, [OutAttribute] Single* tangentX, [OutAttribute] Single* tangentY);

            /// <summary>[requires: NV_point_sprite]
            /// Specify point parameters
            /// </summary>
            /// <param name="pname">
            /// <para>
            /// Specifies a single-valued point parameter. GL_POINT_FADE_THRESHOLD_SIZE, and GL_POINT_SPRITE_COORD_ORIGIN are accepted.
            /// </para>
            /// </param>
            /// <param name="param">
            /// <para>
            /// For glPointParameterf and glPointParameteri, specifies the value that pname will be set to.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// For glPointParameterfv and glPointParameteriv, specifies a pointer to an array where the value or values to be assigned to pname are stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_point_sprite", Version = "", EntryPoint = "glPointParameteriNV")]
            public static extern void PointParameter(OpenTK.Graphics.OpenGL.NvPointSprite pname, Int32 param);

            /// <summary>[requires: NV_point_sprite]
            /// Specify point parameters
            /// </summary>
            /// <param name="pname">
            /// <para>
            /// Specifies a single-valued point parameter. GL_POINT_FADE_THRESHOLD_SIZE, and GL_POINT_SPRITE_COORD_ORIGIN are accepted.
            /// </para>
            /// </param>
            /// <param name="param">
            /// <para>
            /// For glPointParameterf and glPointParameteri, specifies the value that pname will be set to.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// For glPointParameterfv and glPointParameteriv, specifies a pointer to an array where the value or values to be assigned to pname are stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_point_sprite", Version = "", EntryPoint = "glPointParameterivNV")]
            public static extern void PointParameter(OpenTK.Graphics.OpenGL.NvPointSprite pname, Int32[] @params);

            /// <summary>[requires: NV_point_sprite]
            /// Specify point parameters
            /// </summary>
            /// <param name="pname">
            /// <para>
            /// Specifies a single-valued point parameter. GL_POINT_FADE_THRESHOLD_SIZE, and GL_POINT_SPRITE_COORD_ORIGIN are accepted.
            /// </para>
            /// </param>
            /// <param name="param">
            /// <para>
            /// For glPointParameterf and glPointParameteri, specifies the value that pname will be set to.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// For glPointParameterfv and glPointParameteriv, specifies a pointer to an array where the value or values to be assigned to pname are stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_point_sprite", Version = "", EntryPoint = "glPointParameterivNV")]
            public static extern unsafe void PointParameter(OpenTK.Graphics.OpenGL.NvPointSprite pname, Int32* @params);

            /// <summary>[requires: NV_present_video]</summary>
            [AutoGenerated(Category = "NV_present_video", Version = "", EntryPoint = "glPresentFrameDualFillNV")]
            public static extern void PresentFrameDualFill(Int32 video_slot, Int64 minPresentTime, Int32 beginPresentTimeId, Int32 presentDurationId, OpenTK.Graphics.OpenGL.NvPresentVideo type, OpenTK.Graphics.OpenGL.NvPresentVideo target0, Int32 fill0, OpenTK.Graphics.OpenGL.NvPresentVideo target1, Int32 fill1, OpenTK.Graphics.OpenGL.NvPresentVideo target2, Int32 fill2, OpenTK.Graphics.OpenGL.NvPresentVideo target3, Int32 fill3);

            /// <summary>[requires: NV_present_video]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_present_video", Version = "", EntryPoint = "glPresentFrameDualFillNV")]
            public static extern void PresentFrameDualFill(UInt32 video_slot, UInt64 minPresentTime, UInt32 beginPresentTimeId, UInt32 presentDurationId, OpenTK.Graphics.OpenGL.NvPresentVideo type, OpenTK.Graphics.OpenGL.NvPresentVideo target0, UInt32 fill0, OpenTK.Graphics.OpenGL.NvPresentVideo target1, UInt32 fill1, OpenTK.Graphics.OpenGL.NvPresentVideo target2, UInt32 fill2, OpenTK.Graphics.OpenGL.NvPresentVideo target3, UInt32 fill3);

            /// <summary>[requires: NV_present_video]</summary>
            [AutoGenerated(Category = "NV_present_video", Version = "", EntryPoint = "glPresentFrameKeyedNV")]
            public static extern void PresentFrameKeye(Int32 video_slot, Int64 minPresentTime, Int32 beginPresentTimeId, Int32 presentDurationId, OpenTK.Graphics.OpenGL.NvPresentVideo type, OpenTK.Graphics.OpenGL.NvPresentVideo target0, Int32 fill0, Int32 key0, OpenTK.Graphics.OpenGL.NvPresentVideo target1, Int32 fill1, Int32 key1);

            /// <summary>[requires: NV_present_video]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_present_video", Version = "", EntryPoint = "glPresentFrameKeyedNV")]
            public static extern void PresentFrameKeye(UInt32 video_slot, UInt64 minPresentTime, UInt32 beginPresentTimeId, UInt32 presentDurationId, OpenTK.Graphics.OpenGL.NvPresentVideo type, OpenTK.Graphics.OpenGL.NvPresentVideo target0, UInt32 fill0, UInt32 key0, OpenTK.Graphics.OpenGL.NvPresentVideo target1, UInt32 fill1, UInt32 key1);

            /// <summary>[requires: NV_primitive_restart]
            /// Specify the primitive restart index
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the value to be interpreted as the primitive restart index.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_primitive_restart", Version = "", EntryPoint = "glPrimitiveRestartIndexNV")]
            public static extern void PrimitiveRestartIndex(Int32 index);

            /// <summary>[requires: NV_primitive_restart]
            /// Specify the primitive restart index
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the value to be interpreted as the primitive restart index.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_primitive_restart", Version = "", EntryPoint = "glPrimitiveRestartIndexNV")]
            public static extern void PrimitiveRestartIndex(UInt32 index);

            /// <summary>[requires: NV_primitive_restart]</summary>
            [AutoGenerated(Category = "NV_primitive_restart", Version = "", EntryPoint = "glPrimitiveRestartNV")]
            public static extern void PrimitiveRestart();

            /// <summary>[requires: NV_parameter_buffer_object]</summary>
            [AutoGenerated(Category = "NV_parameter_buffer_object", Version = "", EntryPoint = "glProgramBufferParametersfvNV")]
            public static extern void ProgramBufferParameters(OpenTK.Graphics.OpenGL.NvParameterBufferObject target, Int32 bindingIndex, Int32 wordIndex, Int32 count, Single[] @params);

            /// <summary>[requires: NV_parameter_buffer_object]</summary>
            [AutoGenerated(Category = "NV_parameter_buffer_object", Version = "", EntryPoint = "glProgramBufferParametersfvNV")]
            public static extern void ProgramBufferParameters(OpenTK.Graphics.OpenGL.NvParameterBufferObject target, Int32 bindingIndex, Int32 wordIndex, Int32 count, ref Single @params);

            /// <summary>[requires: NV_parameter_buffer_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_parameter_buffer_object", Version = "", EntryPoint = "glProgramBufferParametersfvNV")]
            public static extern unsafe void ProgramBufferParameters(OpenTK.Graphics.OpenGL.NvParameterBufferObject target, Int32 bindingIndex, Int32 wordIndex, Int32 count, Single* @params);

            /// <summary>[requires: NV_parameter_buffer_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_parameter_buffer_object", Version = "", EntryPoint = "glProgramBufferParametersfvNV")]
            public static extern void ProgramBufferParameters(OpenTK.Graphics.OpenGL.NvParameterBufferObject target, UInt32 bindingIndex, UInt32 wordIndex, Int32 count, Single[] @params);

            /// <summary>[requires: NV_parameter_buffer_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_parameter_buffer_object", Version = "", EntryPoint = "glProgramBufferParametersfvNV")]
            public static extern void ProgramBufferParameters(OpenTK.Graphics.OpenGL.NvParameterBufferObject target, UInt32 bindingIndex, UInt32 wordIndex, Int32 count, ref Single @params);

            /// <summary>[requires: NV_parameter_buffer_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_parameter_buffer_object", Version = "", EntryPoint = "glProgramBufferParametersfvNV")]
            public static extern unsafe void ProgramBufferParameters(OpenTK.Graphics.OpenGL.NvParameterBufferObject target, UInt32 bindingIndex, UInt32 wordIndex, Int32 count, Single* @params);

            /// <summary>[requires: NV_parameter_buffer_object]</summary>
            [AutoGenerated(Category = "NV_parameter_buffer_object", Version = "", EntryPoint = "glProgramBufferParametersIivNV")]
            public static extern void ProgramBufferParametersI(OpenTK.Graphics.OpenGL.NvParameterBufferObject target, Int32 bindingIndex, Int32 wordIndex, Int32 count, Int32[] @params);

            /// <summary>[requires: NV_parameter_buffer_object]</summary>
            [AutoGenerated(Category = "NV_parameter_buffer_object", Version = "", EntryPoint = "glProgramBufferParametersIivNV")]
            public static extern void ProgramBufferParametersI(OpenTK.Graphics.OpenGL.NvParameterBufferObject target, Int32 bindingIndex, Int32 wordIndex, Int32 count, ref Int32 @params);

            /// <summary>[requires: NV_parameter_buffer_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_parameter_buffer_object", Version = "", EntryPoint = "glProgramBufferParametersIivNV")]
            public static extern unsafe void ProgramBufferParametersI(OpenTK.Graphics.OpenGL.NvParameterBufferObject target, Int32 bindingIndex, Int32 wordIndex, Int32 count, Int32* @params);

            /// <summary>[requires: NV_parameter_buffer_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_parameter_buffer_object", Version = "", EntryPoint = "glProgramBufferParametersIivNV")]
            public static extern void ProgramBufferParametersI(OpenTK.Graphics.OpenGL.NvParameterBufferObject target, UInt32 bindingIndex, UInt32 wordIndex, Int32 count, Int32[] @params);

            /// <summary>[requires: NV_parameter_buffer_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_parameter_buffer_object", Version = "", EntryPoint = "glProgramBufferParametersIivNV")]
            public static extern void ProgramBufferParametersI(OpenTK.Graphics.OpenGL.NvParameterBufferObject target, UInt32 bindingIndex, UInt32 wordIndex, Int32 count, ref Int32 @params);

            /// <summary>[requires: NV_parameter_buffer_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_parameter_buffer_object", Version = "", EntryPoint = "glProgramBufferParametersIivNV")]
            public static extern unsafe void ProgramBufferParametersI(OpenTK.Graphics.OpenGL.NvParameterBufferObject target, UInt32 bindingIndex, UInt32 wordIndex, Int32 count, Int32* @params);

            /// <summary>[requires: NV_parameter_buffer_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_parameter_buffer_object", Version = "", EntryPoint = "glProgramBufferParametersIuivNV")]
            public static extern void ProgramBufferParametersI(OpenTK.Graphics.OpenGL.NvParameterBufferObject target, UInt32 bindingIndex, UInt32 wordIndex, Int32 count, UInt32[] @params);

            /// <summary>[requires: NV_parameter_buffer_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_parameter_buffer_object", Version = "", EntryPoint = "glProgramBufferParametersIuivNV")]
            public static extern void ProgramBufferParametersI(OpenTK.Graphics.OpenGL.NvParameterBufferObject target, UInt32 bindingIndex, UInt32 wordIndex, Int32 count, ref UInt32 @params);

            /// <summary>[requires: NV_parameter_buffer_object]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_parameter_buffer_object", Version = "", EntryPoint = "glProgramBufferParametersIuivNV")]
            public static extern unsafe void ProgramBufferParametersI(OpenTK.Graphics.OpenGL.NvParameterBufferObject target, UInt32 bindingIndex, UInt32 wordIndex, Int32 count, UInt32* @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramEnvParameterI4iNV")]
            public static extern void ProgramEnvParameterI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, Int32 index, Int32 x, Int32 y, Int32 z, Int32 w);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramEnvParameterI4iNV")]
            public static extern void ProgramEnvParameterI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, Int32 x, Int32 y, Int32 z, Int32 w);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramEnvParameterI4ivNV")]
            public static extern void ProgramEnvParameterI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, Int32 index, Int32[] @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramEnvParameterI4ivNV")]
            public static extern void ProgramEnvParameterI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, Int32 index, ref Int32 @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramEnvParameterI4ivNV")]
            public static extern unsafe void ProgramEnvParameterI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, Int32 index, Int32* @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramEnvParameterI4ivNV")]
            public static extern void ProgramEnvParameterI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, Int32[] @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramEnvParameterI4ivNV")]
            public static extern void ProgramEnvParameterI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, ref Int32 @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramEnvParameterI4ivNV")]
            public static extern unsafe void ProgramEnvParameterI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, Int32* @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramEnvParameterI4uiNV")]
            public static extern void ProgramEnvParameterI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, UInt32 x, UInt32 y, UInt32 z, UInt32 w);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramEnvParameterI4uivNV")]
            public static extern void ProgramEnvParameterI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, UInt32[] @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramEnvParameterI4uivNV")]
            public static extern void ProgramEnvParameterI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, ref UInt32 @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramEnvParameterI4uivNV")]
            public static extern unsafe void ProgramEnvParameterI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, UInt32* @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramEnvParametersI4ivNV")]
            public static extern void ProgramEnvParametersI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, Int32 index, Int32 count, Int32[] @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramEnvParametersI4ivNV")]
            public static extern void ProgramEnvParametersI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, Int32 index, Int32 count, ref Int32 @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramEnvParametersI4ivNV")]
            public static extern unsafe void ProgramEnvParametersI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, Int32 index, Int32 count, Int32* @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramEnvParametersI4ivNV")]
            public static extern void ProgramEnvParametersI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, Int32 count, Int32[] @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramEnvParametersI4ivNV")]
            public static extern void ProgramEnvParametersI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, Int32 count, ref Int32 @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramEnvParametersI4ivNV")]
            public static extern unsafe void ProgramEnvParametersI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, Int32 count, Int32* @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramEnvParametersI4uivNV")]
            public static extern void ProgramEnvParametersI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, Int32 count, UInt32[] @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramEnvParametersI4uivNV")]
            public static extern void ProgramEnvParametersI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, Int32 count, ref UInt32 @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramEnvParametersI4uivNV")]
            public static extern unsafe void ProgramEnvParametersI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, Int32 count, UInt32* @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramLocalParameterI4iNV")]
            public static extern void ProgramLocalParameterI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, Int32 index, Int32 x, Int32 y, Int32 z, Int32 w);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramLocalParameterI4iNV")]
            public static extern void ProgramLocalParameterI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, Int32 x, Int32 y, Int32 z, Int32 w);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramLocalParameterI4ivNV")]
            public static extern void ProgramLocalParameterI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, Int32 index, Int32[] @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramLocalParameterI4ivNV")]
            public static extern void ProgramLocalParameterI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, Int32 index, ref Int32 @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramLocalParameterI4ivNV")]
            public static extern unsafe void ProgramLocalParameterI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, Int32 index, Int32* @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramLocalParameterI4ivNV")]
            public static extern void ProgramLocalParameterI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, Int32[] @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramLocalParameterI4ivNV")]
            public static extern void ProgramLocalParameterI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, ref Int32 @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramLocalParameterI4ivNV")]
            public static extern unsafe void ProgramLocalParameterI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, Int32* @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramLocalParameterI4uiNV")]
            public static extern void ProgramLocalParameterI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, UInt32 x, UInt32 y, UInt32 z, UInt32 w);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramLocalParameterI4uivNV")]
            public static extern void ProgramLocalParameterI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, UInt32[] @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramLocalParameterI4uivNV")]
            public static extern void ProgramLocalParameterI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, ref UInt32 @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramLocalParameterI4uivNV")]
            public static extern unsafe void ProgramLocalParameterI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, UInt32* @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramLocalParametersI4ivNV")]
            public static extern void ProgramLocalParametersI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, Int32 index, Int32 count, Int32[] @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramLocalParametersI4ivNV")]
            public static extern void ProgramLocalParametersI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, Int32 index, Int32 count, ref Int32 @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramLocalParametersI4ivNV")]
            public static extern unsafe void ProgramLocalParametersI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, Int32 index, Int32 count, Int32* @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramLocalParametersI4ivNV")]
            public static extern void ProgramLocalParametersI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, Int32 count, Int32[] @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramLocalParametersI4ivNV")]
            public static extern void ProgramLocalParametersI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, Int32 count, ref Int32 @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramLocalParametersI4ivNV")]
            public static extern unsafe void ProgramLocalParametersI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, Int32 count, Int32* @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramLocalParametersI4uivNV")]
            public static extern void ProgramLocalParametersI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, Int32 count, UInt32[] @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramLocalParametersI4uivNV")]
            public static extern void ProgramLocalParametersI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, Int32 count, ref UInt32 @params);

            /// <summary>[requires: NV_gpu_program4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program4", Version = "", EntryPoint = "glProgramLocalParametersI4uivNV")]
            public static extern unsafe void ProgramLocalParametersI4(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, Int32 count, UInt32* @params);

            /// <summary>[requires: NV_fragment_program]</summary>
            [AutoGenerated(Category = "NV_fragment_program", Version = "", EntryPoint = "glProgramNamedParameter4dNV")]
            public static extern void ProgramNamedParameter4(Int32 id, Int32 len, ref Byte name, Double x, Double y, Double z, Double w);

            /// <summary>[requires: NV_fragment_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fragment_program", Version = "", EntryPoint = "glProgramNamedParameter4dNV")]
            public static extern unsafe void ProgramNamedParameter4(Int32 id, Int32 len, Byte* name, Double x, Double y, Double z, Double w);

            /// <summary>[requires: NV_fragment_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fragment_program", Version = "", EntryPoint = "glProgramNamedParameter4dNV")]
            public static extern void ProgramNamedParameter4(UInt32 id, Int32 len, ref Byte name, Double x, Double y, Double z, Double w);

            /// <summary>[requires: NV_fragment_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fragment_program", Version = "", EntryPoint = "glProgramNamedParameter4dNV")]
            public static extern unsafe void ProgramNamedParameter4(UInt32 id, Int32 len, Byte* name, Double x, Double y, Double z, Double w);

            /// <summary>[requires: NV_fragment_program]</summary>
            [AutoGenerated(Category = "NV_fragment_program", Version = "", EntryPoint = "glProgramNamedParameter4dvNV")]
            public static extern void ProgramNamedParameter4(Int32 id, Int32 len, ref Byte name, Double[] v);

            /// <summary>[requires: NV_fragment_program]</summary>
            [AutoGenerated(Category = "NV_fragment_program", Version = "", EntryPoint = "glProgramNamedParameter4dvNV")]
            public static extern void ProgramNamedParameter4(Int32 id, Int32 len, ref Byte name, ref Double v);

            /// <summary>[requires: NV_fragment_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fragment_program", Version = "", EntryPoint = "glProgramNamedParameter4dvNV")]
            public static extern unsafe void ProgramNamedParameter4(Int32 id, Int32 len, Byte* name, Double* v);

            /// <summary>[requires: NV_fragment_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fragment_program", Version = "", EntryPoint = "glProgramNamedParameter4dvNV")]
            public static extern void ProgramNamedParameter4(UInt32 id, Int32 len, ref Byte name, Double[] v);

            /// <summary>[requires: NV_fragment_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fragment_program", Version = "", EntryPoint = "glProgramNamedParameter4dvNV")]
            public static extern void ProgramNamedParameter4(UInt32 id, Int32 len, ref Byte name, ref Double v);

            /// <summary>[requires: NV_fragment_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fragment_program", Version = "", EntryPoint = "glProgramNamedParameter4dvNV")]
            public static extern unsafe void ProgramNamedParameter4(UInt32 id, Int32 len, Byte* name, Double* v);

            /// <summary>[requires: NV_fragment_program]</summary>
            [AutoGenerated(Category = "NV_fragment_program", Version = "", EntryPoint = "glProgramNamedParameter4fNV")]
            public static extern void ProgramNamedParameter4(Int32 id, Int32 len, ref Byte name, Single x, Single y, Single z, Single w);

            /// <summary>[requires: NV_fragment_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fragment_program", Version = "", EntryPoint = "glProgramNamedParameter4fNV")]
            public static extern unsafe void ProgramNamedParameter4(Int32 id, Int32 len, Byte* name, Single x, Single y, Single z, Single w);

            /// <summary>[requires: NV_fragment_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fragment_program", Version = "", EntryPoint = "glProgramNamedParameter4fNV")]
            public static extern void ProgramNamedParameter4(UInt32 id, Int32 len, ref Byte name, Single x, Single y, Single z, Single w);

            /// <summary>[requires: NV_fragment_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fragment_program", Version = "", EntryPoint = "glProgramNamedParameter4fNV")]
            public static extern unsafe void ProgramNamedParameter4(UInt32 id, Int32 len, Byte* name, Single x, Single y, Single z, Single w);

            /// <summary>[requires: NV_fragment_program]</summary>
            [AutoGenerated(Category = "NV_fragment_program", Version = "", EntryPoint = "glProgramNamedParameter4fvNV")]
            public static extern void ProgramNamedParameter4(Int32 id, Int32 len, ref Byte name, Single[] v);

            /// <summary>[requires: NV_fragment_program]</summary>
            [AutoGenerated(Category = "NV_fragment_program", Version = "", EntryPoint = "glProgramNamedParameter4fvNV")]
            public static extern void ProgramNamedParameter4(Int32 id, Int32 len, ref Byte name, ref Single v);

            /// <summary>[requires: NV_fragment_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fragment_program", Version = "", EntryPoint = "glProgramNamedParameter4fvNV")]
            public static extern unsafe void ProgramNamedParameter4(Int32 id, Int32 len, Byte* name, Single* v);

            /// <summary>[requires: NV_fragment_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fragment_program", Version = "", EntryPoint = "glProgramNamedParameter4fvNV")]
            public static extern void ProgramNamedParameter4(UInt32 id, Int32 len, ref Byte name, Single[] v);

            /// <summary>[requires: NV_fragment_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fragment_program", Version = "", EntryPoint = "glProgramNamedParameter4fvNV")]
            public static extern void ProgramNamedParameter4(UInt32 id, Int32 len, ref Byte name, ref Single v);

            /// <summary>[requires: NV_fragment_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fragment_program", Version = "", EntryPoint = "glProgramNamedParameter4fvNV")]
            public static extern unsafe void ProgramNamedParameter4(UInt32 id, Int32 len, Byte* name, Single* v);

            /// <summary>[requires: NV_vertex_program]
            /// Specify a parameter for a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the name of a program object whose parameter to modify.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the name of the parameter to modify.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// Specifies the new value of the parameter specified by pname for program.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glProgramParameter4dNV")]
            public static extern void ProgramParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, Double x, Double y, Double z, Double w);

            /// <summary>[requires: NV_vertex_program]
            /// Specify a parameter for a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the name of a program object whose parameter to modify.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the name of the parameter to modify.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// Specifies the new value of the parameter specified by pname for program.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glProgramParameter4dNV")]
            public static extern void ProgramParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Double x, Double y, Double z, Double w);

            /// <summary>[requires: NV_vertex_program]
            /// Specify a parameter for a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the name of a program object whose parameter to modify.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the name of the parameter to modify.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// Specifies the new value of the parameter specified by pname for program.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glProgramParameter4dvNV")]
            public static extern void ProgramParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, Double[] v);

            /// <summary>[requires: NV_vertex_program]
            /// Specify a parameter for a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the name of a program object whose parameter to modify.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the name of the parameter to modify.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// Specifies the new value of the parameter specified by pname for program.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glProgramParameter4dvNV")]
            public static extern void ProgramParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, ref Double v);

            /// <summary>[requires: NV_vertex_program]
            /// Specify a parameter for a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the name of a program object whose parameter to modify.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the name of the parameter to modify.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// Specifies the new value of the parameter specified by pname for program.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glProgramParameter4dvNV")]
            public static extern unsafe void ProgramParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, Double* v);

            /// <summary>[requires: NV_vertex_program]
            /// Specify a parameter for a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the name of a program object whose parameter to modify.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the name of the parameter to modify.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// Specifies the new value of the parameter specified by pname for program.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glProgramParameter4dvNV")]
            public static extern void ProgramParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Double[] v);

            /// <summary>[requires: NV_vertex_program]
            /// Specify a parameter for a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the name of a program object whose parameter to modify.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the name of the parameter to modify.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// Specifies the new value of the parameter specified by pname for program.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glProgramParameter4dvNV")]
            public static extern void ProgramParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, ref Double v);

            /// <summary>[requires: NV_vertex_program]
            /// Specify a parameter for a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the name of a program object whose parameter to modify.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the name of the parameter to modify.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// Specifies the new value of the parameter specified by pname for program.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glProgramParameter4dvNV")]
            public static extern unsafe void ProgramParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Double* v);

            /// <summary>[requires: NV_vertex_program]
            /// Specify a parameter for a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the name of a program object whose parameter to modify.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the name of the parameter to modify.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// Specifies the new value of the parameter specified by pname for program.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glProgramParameter4fNV")]
            public static extern void ProgramParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, Single x, Single y, Single z, Single w);

            /// <summary>[requires: NV_vertex_program]
            /// Specify a parameter for a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the name of a program object whose parameter to modify.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the name of the parameter to modify.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// Specifies the new value of the parameter specified by pname for program.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glProgramParameter4fNV")]
            public static extern void ProgramParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Single x, Single y, Single z, Single w);

            /// <summary>[requires: NV_vertex_program]
            /// Specify a parameter for a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the name of a program object whose parameter to modify.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the name of the parameter to modify.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// Specifies the new value of the parameter specified by pname for program.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glProgramParameter4fvNV")]
            public static extern void ProgramParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, Single[] v);

            /// <summary>[requires: NV_vertex_program]
            /// Specify a parameter for a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the name of a program object whose parameter to modify.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the name of the parameter to modify.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// Specifies the new value of the parameter specified by pname for program.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glProgramParameter4fvNV")]
            public static extern void ProgramParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, ref Single v);

            /// <summary>[requires: NV_vertex_program]
            /// Specify a parameter for a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the name of a program object whose parameter to modify.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the name of the parameter to modify.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// Specifies the new value of the parameter specified by pname for program.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glProgramParameter4fvNV")]
            public static extern unsafe void ProgramParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, Single* v);

            /// <summary>[requires: NV_vertex_program]
            /// Specify a parameter for a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the name of a program object whose parameter to modify.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the name of the parameter to modify.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// Specifies the new value of the parameter specified by pname for program.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glProgramParameter4fvNV")]
            public static extern void ProgramParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Single[] v);

            /// <summary>[requires: NV_vertex_program]
            /// Specify a parameter for a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the name of a program object whose parameter to modify.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the name of the parameter to modify.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// Specifies the new value of the parameter specified by pname for program.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glProgramParameter4fvNV")]
            public static extern void ProgramParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, ref Single v);

            /// <summary>[requires: NV_vertex_program]
            /// Specify a parameter for a program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the name of a program object whose parameter to modify.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// Specifies the name of the parameter to modify.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// Specifies the new value of the parameter specified by pname for program.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glProgramParameter4fvNV")]
            public static extern unsafe void ProgramParameter4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Single* v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glProgramParameters4dvNV")]
            public static extern void ProgramParameters4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, Int32 count, Double[] v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glProgramParameters4dvNV")]
            public static extern void ProgramParameters4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, Int32 count, ref Double v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glProgramParameters4dvNV")]
            public static extern unsafe void ProgramParameters4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, Int32 count, Double* v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glProgramParameters4dvNV")]
            public static extern void ProgramParameters4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Int32 count, Double[] v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glProgramParameters4dvNV")]
            public static extern void ProgramParameters4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Int32 count, ref Double v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glProgramParameters4dvNV")]
            public static extern unsafe void ProgramParameters4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Int32 count, Double* v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [Obsolete("Use int overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glProgramParameters4dvNV")]
            public static extern void ProgramParameters4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, UInt32 count, Double[] v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [Obsolete("Use int overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glProgramParameters4dvNV")]
            public static extern void ProgramParameters4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, UInt32 count, ref Double v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [Obsolete("Use int overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glProgramParameters4dvNV")]
            public static extern unsafe void ProgramParameters4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, UInt32 count, Double* v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glProgramParameters4fvNV")]
            public static extern void ProgramParameters4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, Int32 count, Single[] v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glProgramParameters4fvNV")]
            public static extern void ProgramParameters4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, Int32 count, ref Single v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glProgramParameters4fvNV")]
            public static extern unsafe void ProgramParameters4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 index, Int32 count, Single* v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glProgramParameters4fvNV")]
            public static extern void ProgramParameters4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Int32 count, Single[] v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glProgramParameters4fvNV")]
            public static extern void ProgramParameters4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Int32 count, ref Single v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glProgramParameters4fvNV")]
            public static extern unsafe void ProgramParameters4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Int32 count, Single* v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [Obsolete("Use int overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glProgramParameters4fvNV")]
            public static extern void ProgramParameters4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, UInt32 count, Single[] v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [Obsolete("Use int overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glProgramParameters4fvNV")]
            public static extern void ProgramParameters4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, UInt32 count, ref Single v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [Obsolete("Use int overload instead")]
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glProgramParameters4fvNV")]
            public static extern unsafe void ProgramParameters4(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, UInt32 count, Single* v);

            /// <summary>[requires: NV_gpu_program5]</summary>
            [AutoGenerated(Category = "NV_gpu_program5", Version = "", EntryPoint = "glProgramSubroutineParametersuivNV")]
            public static extern void ProgramSubroutineParameters(OpenTK.Graphics.OpenGL.NvGpuProgram5 target, Int32 count, Int32[] @params);

            /// <summary>[requires: NV_gpu_program5]</summary>
            [AutoGenerated(Category = "NV_gpu_program5", Version = "", EntryPoint = "glProgramSubroutineParametersuivNV")]
            public static extern void ProgramSubroutineParameters(OpenTK.Graphics.OpenGL.NvGpuProgram5 target, Int32 count, ref Int32 @params);

            /// <summary>[requires: NV_gpu_program5]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program5", Version = "", EntryPoint = "glProgramSubroutineParametersuivNV")]
            public static extern unsafe void ProgramSubroutineParameters(OpenTK.Graphics.OpenGL.NvGpuProgram5 target, Int32 count, Int32* @params);

            /// <summary>[requires: NV_gpu_program5]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program5", Version = "", EntryPoint = "glProgramSubroutineParametersuivNV")]
            public static extern void ProgramSubroutineParameters(OpenTK.Graphics.OpenGL.NvGpuProgram5 target, Int32 count, UInt32[] @params);

            /// <summary>[requires: NV_gpu_program5]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program5", Version = "", EntryPoint = "glProgramSubroutineParametersuivNV")]
            public static extern void ProgramSubroutineParameters(OpenTK.Graphics.OpenGL.NvGpuProgram5 target, Int32 count, ref UInt32 @params);

            /// <summary>[requires: NV_gpu_program5]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_program5", Version = "", EntryPoint = "glProgramSubroutineParametersuivNV")]
            public static extern unsafe void ProgramSubroutineParameters(OpenTK.Graphics.OpenGL.NvGpuProgram5 target, Int32 count, UInt32* @params);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform1i64NV")]
            public static extern void ProgramUniform1(Int32 program, Int32 location, Int64 x);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform1i64NV")]
            public static extern void ProgramUniform1(UInt32 program, Int32 location, Int64 x);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform1i64vNV")]
            public static extern void ProgramUniform1(Int32 program, Int32 location, Int32 count, Int64[] value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform1i64vNV")]
            public static extern void ProgramUniform1(Int32 program, Int32 location, Int32 count, ref Int64 value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform1i64vNV")]
            public static extern unsafe void ProgramUniform1(Int32 program, Int32 location, Int32 count, Int64* value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform1i64vNV")]
            public static extern void ProgramUniform1(UInt32 program, Int32 location, Int32 count, Int64[] value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform1i64vNV")]
            public static extern void ProgramUniform1(UInt32 program, Int32 location, Int32 count, ref Int64 value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform1i64vNV")]
            public static extern unsafe void ProgramUniform1(UInt32 program, Int32 location, Int32 count, Int64* value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform1ui64NV")]
            public static extern void ProgramUniform1(UInt32 program, Int32 location, UInt64 x);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform1ui64vNV")]
            public static extern void ProgramUniform1(UInt32 program, Int32 location, Int32 count, UInt64[] value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform1ui64vNV")]
            public static extern void ProgramUniform1(UInt32 program, Int32 location, Int32 count, ref UInt64 value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform1ui64vNV")]
            public static extern unsafe void ProgramUniform1(UInt32 program, Int32 location, Int32 count, UInt64* value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform2i64NV")]
            public static extern void ProgramUniform2(Int32 program, Int32 location, Int64 x, Int64 y);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform2i64NV")]
            public static extern void ProgramUniform2(UInt32 program, Int32 location, Int64 x, Int64 y);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform2i64vNV")]
            public static extern void ProgramUniform2(Int32 program, Int32 location, Int32 count, Int64[] value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform2i64vNV")]
            public static extern void ProgramUniform2(Int32 program, Int32 location, Int32 count, ref Int64 value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform2i64vNV")]
            public static extern unsafe void ProgramUniform2(Int32 program, Int32 location, Int32 count, Int64* value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform2i64vNV")]
            public static extern void ProgramUniform2(UInt32 program, Int32 location, Int32 count, Int64[] value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform2i64vNV")]
            public static extern void ProgramUniform2(UInt32 program, Int32 location, Int32 count, ref Int64 value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform2i64vNV")]
            public static extern unsafe void ProgramUniform2(UInt32 program, Int32 location, Int32 count, Int64* value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform2ui64NV")]
            public static extern void ProgramUniform2(UInt32 program, Int32 location, UInt64 x, UInt64 y);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform2ui64vNV")]
            public static extern void ProgramUniform2(UInt32 program, Int32 location, Int32 count, UInt64[] value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform2ui64vNV")]
            public static extern void ProgramUniform2(UInt32 program, Int32 location, Int32 count, ref UInt64 value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform2ui64vNV")]
            public static extern unsafe void ProgramUniform2(UInt32 program, Int32 location, Int32 count, UInt64* value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform3i64NV")]
            public static extern void ProgramUniform3(Int32 program, Int32 location, Int64 x, Int64 y, Int64 z);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform3i64NV")]
            public static extern void ProgramUniform3(UInt32 program, Int32 location, Int64 x, Int64 y, Int64 z);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform3i64vNV")]
            public static extern void ProgramUniform3(Int32 program, Int32 location, Int32 count, Int64[] value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform3i64vNV")]
            public static extern void ProgramUniform3(Int32 program, Int32 location, Int32 count, ref Int64 value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform3i64vNV")]
            public static extern unsafe void ProgramUniform3(Int32 program, Int32 location, Int32 count, Int64* value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform3i64vNV")]
            public static extern void ProgramUniform3(UInt32 program, Int32 location, Int32 count, Int64[] value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform3i64vNV")]
            public static extern void ProgramUniform3(UInt32 program, Int32 location, Int32 count, ref Int64 value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform3i64vNV")]
            public static extern unsafe void ProgramUniform3(UInt32 program, Int32 location, Int32 count, Int64* value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform3ui64NV")]
            public static extern void ProgramUniform3(UInt32 program, Int32 location, UInt64 x, UInt64 y, UInt64 z);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform3ui64vNV")]
            public static extern void ProgramUniform3(UInt32 program, Int32 location, Int32 count, UInt64[] value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform3ui64vNV")]
            public static extern void ProgramUniform3(UInt32 program, Int32 location, Int32 count, ref UInt64 value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform3ui64vNV")]
            public static extern unsafe void ProgramUniform3(UInt32 program, Int32 location, Int32 count, UInt64* value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform4i64NV")]
            public static extern void ProgramUniform4(Int32 program, Int32 location, Int64 x, Int64 y, Int64 z, Int64 w);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform4i64NV")]
            public static extern void ProgramUniform4(UInt32 program, Int32 location, Int64 x, Int64 y, Int64 z, Int64 w);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform4i64vNV")]
            public static extern void ProgramUniform4(Int32 program, Int32 location, Int32 count, Int64[] value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform4i64vNV")]
            public static extern void ProgramUniform4(Int32 program, Int32 location, Int32 count, ref Int64 value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform4i64vNV")]
            public static extern unsafe void ProgramUniform4(Int32 program, Int32 location, Int32 count, Int64* value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform4i64vNV")]
            public static extern void ProgramUniform4(UInt32 program, Int32 location, Int32 count, Int64[] value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform4i64vNV")]
            public static extern void ProgramUniform4(UInt32 program, Int32 location, Int32 count, ref Int64 value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform4i64vNV")]
            public static extern unsafe void ProgramUniform4(UInt32 program, Int32 location, Int32 count, Int64* value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform4ui64NV")]
            public static extern void ProgramUniform4(UInt32 program, Int32 location, UInt64 x, UInt64 y, UInt64 z, UInt64 w);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform4ui64vNV")]
            public static extern void ProgramUniform4(UInt32 program, Int32 location, Int32 count, UInt64[] value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform4ui64vNV")]
            public static extern void ProgramUniform4(UInt32 program, Int32 location, Int32 count, ref UInt64 value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glProgramUniform4ui64vNV")]
            public static extern unsafe void ProgramUniform4(UInt32 program, Int32 location, Int32 count, UInt64* value);

            /// <summary>[requires: NV_bindless_texture]</summary>
            [AutoGenerated(Category = "NV_bindless_texture", Version = "", EntryPoint = "glProgramUniformHandleui64NV")]
            public static extern void ProgramUniformHandle(Int32 program, Int32 location, Int64 value);

            /// <summary>[requires: NV_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_bindless_texture", Version = "", EntryPoint = "glProgramUniformHandleui64NV")]
            public static extern void ProgramUniformHandle(UInt32 program, Int32 location, UInt64 value);

            /// <summary>[requires: NV_bindless_texture]</summary>
            [AutoGenerated(Category = "NV_bindless_texture", Version = "", EntryPoint = "glProgramUniformHandleui64vNV")]
            public static extern void ProgramUniformHandle(Int32 program, Int32 location, Int32 count, Int64[] values);

            /// <summary>[requires: NV_bindless_texture]</summary>
            [AutoGenerated(Category = "NV_bindless_texture", Version = "", EntryPoint = "glProgramUniformHandleui64vNV")]
            public static extern void ProgramUniformHandle(Int32 program, Int32 location, Int32 count, ref Int64 values);

            /// <summary>[requires: NV_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_bindless_texture", Version = "", EntryPoint = "glProgramUniformHandleui64vNV")]
            public static extern unsafe void ProgramUniformHandle(Int32 program, Int32 location, Int32 count, Int64* values);

            /// <summary>[requires: NV_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_bindless_texture", Version = "", EntryPoint = "glProgramUniformHandleui64vNV")]
            public static extern void ProgramUniformHandle(UInt32 program, Int32 location, Int32 count, UInt64[] values);

            /// <summary>[requires: NV_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_bindless_texture", Version = "", EntryPoint = "glProgramUniformHandleui64vNV")]
            public static extern void ProgramUniformHandle(UInt32 program, Int32 location, Int32 count, ref UInt64 values);

            /// <summary>[requires: NV_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_bindless_texture", Version = "", EntryPoint = "glProgramUniformHandleui64vNV")]
            public static extern unsafe void ProgramUniformHandle(UInt32 program, Int32 location, Int32 count, UInt64* values);

            /// <summary>[requires: NV_shader_buffer_load]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glProgramUniformui64NV")]
            public static extern void ProgramUniform(Int32 program, Int32 location, Int64 value);

            /// <summary>[requires: NV_shader_buffer_load]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glProgramUniformui64NV")]
            public static extern void ProgramUniform(UInt32 program, Int32 location, UInt64 value);

            /// <summary>[requires: NV_shader_buffer_load]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glProgramUniformui64vNV")]
            public static extern void ProgramUniform(Int32 program, Int32 location, Int32 count, Int64[] value);

            /// <summary>[requires: NV_shader_buffer_load]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glProgramUniformui64vNV")]
            public static extern void ProgramUniform(Int32 program, Int32 location, Int32 count, ref Int64 value);

            /// <summary>[requires: NV_shader_buffer_load]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glProgramUniformui64vNV")]
            public static extern unsafe void ProgramUniform(Int32 program, Int32 location, Int32 count, Int64* value);

            /// <summary>[requires: NV_shader_buffer_load]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glProgramUniformui64vNV")]
            public static extern void ProgramUniform(UInt32 program, Int32 location, Int32 count, UInt64[] value);

            /// <summary>[requires: NV_shader_buffer_load]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glProgramUniformui64vNV")]
            public static extern void ProgramUniform(UInt32 program, Int32 location, Int32 count, ref UInt64 value);

            /// <summary>[requires: NV_shader_buffer_load]
            /// Specify the value of a uniform variable for a specified program object
            /// </summary>
            /// <param name="program">
            /// <para>
            /// Specifies the handle of the program containing the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector commands (glProgramUniform*v), specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix commands (glProgramUniformMatrix*), specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glProgramUniformui64vNV")]
            public static extern unsafe void ProgramUniform(UInt32 program, Int32 location, Int32 count, UInt64* value);

            /// <summary>[requires: NV_geometry_program4]</summary>
            [AutoGenerated(Category = "NV_geometry_program4", Version = "", EntryPoint = "glProgramVertexLimitNV")]
            public static extern void ProgramVertexLimit(OpenTK.Graphics.OpenGL.NvGeometryProgram4 target, Int32 limit);

            /// <summary>[requires: NV_framebuffer_multisample_coverage]</summary>
            [AutoGenerated(Category = "NV_framebuffer_multisample_coverage", Version = "", EntryPoint = "glRenderbufferStorageMultisampleCoverageNV")]
            public static extern void RenderbufferStorageMultisampleCoverage(OpenTK.Graphics.OpenGL.RenderbufferTarget target, Int32 coverageSamples, Int32 colorSamples, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glRequestResidentProgramsNV")]
            public static extern void RequestResidentProgram(Int32 n, Int32[] programs);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glRequestResidentProgramsNV")]
            public static extern void RequestResidentProgram(Int32 n, ref Int32 programs);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glRequestResidentProgramsNV")]
            public static extern unsafe void RequestResidentProgram(Int32 n, Int32* programs);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glRequestResidentProgramsNV")]
            public static extern void RequestResidentProgram(Int32 n, UInt32[] programs);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glRequestResidentProgramsNV")]
            public static extern void RequestResidentProgram(Int32 n, ref UInt32 programs);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glRequestResidentProgramsNV")]
            public static extern unsafe void RequestResidentProgram(Int32 n, UInt32* programs);

            /// <summary>[requires: NV_transform_feedback2]
            /// Resume transform feedback operations
            /// </summary>
            [AutoGenerated(Category = "NV_transform_feedback2", Version = "", EntryPoint = "glResumeTransformFeedbackNV")]
            public static extern void ResumeTransformFeedback();

            /// <summary>[requires: NV_explicit_multisample]</summary>
            [AutoGenerated(Category = "NV_explicit_multisample", Version = "", EntryPoint = "glSampleMaskIndexedNV")]
            public static extern void SampleMaskIndexed(Int32 index, Int32 mask);

            /// <summary>[requires: NV_explicit_multisample]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_explicit_multisample", Version = "", EntryPoint = "glSampleMaskIndexedNV")]
            public static extern void SampleMaskIndexed(UInt32 index, UInt32 mask);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glSecondaryColor3hNV")]
            public static extern void SecondaryColor3h(Half red, Half green, Half blue);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glSecondaryColor3hvNV")]
            public static extern void SecondaryColor3h(Half[] v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glSecondaryColor3hvNV")]
            public static extern void SecondaryColor3h(ref Half v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glSecondaryColor3hvNV")]
            public static extern unsafe void SecondaryColor3h(Half* v);

            /// <summary>[requires: NV_vertex_buffer_unified_memory]</summary>
            [AutoGenerated(Category = "NV_vertex_buffer_unified_memory", Version = "", EntryPoint = "glSecondaryColorFormatNV")]
            public static extern void SecondaryColorFormat(Int32 size, OpenTK.Graphics.OpenGL.NvVertexBufferUnifiedMemory type, Int32 stride);

            /// <summary>[requires: NV_fence]</summary>
            [AutoGenerated(Category = "NV_fence", Version = "", EntryPoint = "glSetFenceNV")]
            public static extern void SetFence(Int32 fence, OpenTK.Graphics.OpenGL.NvFence condition);

            /// <summary>[requires: NV_fence]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fence", Version = "", EntryPoint = "glSetFenceNV")]
            public static extern void SetFence(UInt32 fence, OpenTK.Graphics.OpenGL.NvFence condition);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilFillPathInstancedNV")]
            public static extern void StencilFillPathInstanced(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering fillMode, Int32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilFillPathInstancedNV")]
            public static extern void StencilFillPathInstanced(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering fillMode, Int32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilFillPathInstancedNV")]
            public static extern unsafe void StencilFillPathInstanced(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering fillMode, Int32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilFillPathInstancedNV")]
            public static extern void StencilFillPathInstanced(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering fillMode, UInt32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilFillPathInstancedNV")]
            public static extern void StencilFillPathInstanced(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering fillMode, UInt32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilFillPathInstancedNV")]
            public static extern unsafe void StencilFillPathInstanced(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering fillMode, UInt32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilFillPathInstancedNV")]
            public static extern void StencilFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[] paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering fillMode, Int32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilFillPathInstancedNV")]
            public static extern void StencilFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[] paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering fillMode, Int32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilFillPathInstancedNV")]
            public static extern unsafe void StencilFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[] paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering fillMode, Int32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilFillPathInstancedNV")]
            public static extern void StencilFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[] paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering fillMode, UInt32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilFillPathInstancedNV")]
            public static extern void StencilFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[] paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering fillMode, UInt32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilFillPathInstancedNV")]
            public static extern unsafe void StencilFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[] paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering fillMode, UInt32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilFillPathInstancedNV")]
            public static extern void StencilFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,] paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering fillMode, Int32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilFillPathInstancedNV")]
            public static extern void StencilFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,] paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering fillMode, Int32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilFillPathInstancedNV")]
            public static extern unsafe void StencilFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,] paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering fillMode, Int32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilFillPathInstancedNV")]
            public static extern void StencilFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,] paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering fillMode, UInt32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilFillPathInstancedNV")]
            public static extern void StencilFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,] paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering fillMode, UInt32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilFillPathInstancedNV")]
            public static extern unsafe void StencilFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,] paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering fillMode, UInt32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilFillPathInstancedNV")]
            public static extern void StencilFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,,] paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering fillMode, Int32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilFillPathInstancedNV")]
            public static extern void StencilFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,,] paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering fillMode, Int32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilFillPathInstancedNV")]
            public static extern unsafe void StencilFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,,] paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering fillMode, Int32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilFillPathInstancedNV")]
            public static extern void StencilFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,,] paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering fillMode, UInt32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilFillPathInstancedNV")]
            public static extern void StencilFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,,] paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering fillMode, UInt32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilFillPathInstancedNV")]
            public static extern unsafe void StencilFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,,] paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering fillMode, UInt32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilFillPathInstancedNV")]
            public static extern void StencilFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T2 paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering fillMode, Int32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilFillPathInstancedNV")]
            public static extern void StencilFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T2 paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering fillMode, Int32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilFillPathInstancedNV")]
            public static extern unsafe void StencilFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T2 paths, Int32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering fillMode, Int32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilFillPathInstancedNV")]
            public static extern void StencilFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T2 paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering fillMode, UInt32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilFillPathInstancedNV")]
            public static extern void StencilFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T2 paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering fillMode, UInt32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilFillPathInstancedNV")]
            public static extern unsafe void StencilFillPathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T2 paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering fillMode, UInt32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilFillPathNV")]
            public static extern void StencilFillPath(Int32 path, OpenTK.Graphics.OpenGL.NvPathRendering fillMode, Int32 mask);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilFillPathNV")]
            public static extern void StencilFillPath(UInt32 path, OpenTK.Graphics.OpenGL.NvPathRendering fillMode, UInt32 mask);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilStrokePathInstancedNV")]
            public static extern void StencilStrokePathInstanced(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, Int32 pathBase, Int32 reference, Int32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilStrokePathInstancedNV")]
            public static extern void StencilStrokePathInstanced(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, Int32 pathBase, Int32 reference, Int32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilStrokePathInstancedNV")]
            public static extern unsafe void StencilStrokePathInstanced(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, Int32 pathBase, Int32 reference, Int32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilStrokePathInstancedNV")]
            public static extern void StencilStrokePathInstanced(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, UInt32 pathBase, Int32 reference, UInt32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilStrokePathInstancedNV")]
            public static extern void StencilStrokePathInstanced(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, UInt32 pathBase, Int32 reference, UInt32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilStrokePathInstancedNV")]
            public static extern unsafe void StencilStrokePathInstanced(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, UInt32 pathBase, Int32 reference, UInt32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilStrokePathInstancedNV")]
            public static extern void StencilStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[] paths, Int32 pathBase, Int32 reference, Int32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilStrokePathInstancedNV")]
            public static extern void StencilStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[] paths, Int32 pathBase, Int32 reference, Int32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilStrokePathInstancedNV")]
            public static extern unsafe void StencilStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[] paths, Int32 pathBase, Int32 reference, Int32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilStrokePathInstancedNV")]
            public static extern void StencilStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[] paths, UInt32 pathBase, Int32 reference, UInt32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilStrokePathInstancedNV")]
            public static extern void StencilStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[] paths, UInt32 pathBase, Int32 reference, UInt32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilStrokePathInstancedNV")]
            public static extern unsafe void StencilStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[] paths, UInt32 pathBase, Int32 reference, UInt32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilStrokePathInstancedNV")]
            public static extern void StencilStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,] paths, Int32 pathBase, Int32 reference, Int32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilStrokePathInstancedNV")]
            public static extern void StencilStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,] paths, Int32 pathBase, Int32 reference, Int32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilStrokePathInstancedNV")]
            public static extern unsafe void StencilStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,] paths, Int32 pathBase, Int32 reference, Int32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilStrokePathInstancedNV")]
            public static extern void StencilStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,] paths, UInt32 pathBase, Int32 reference, UInt32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilStrokePathInstancedNV")]
            public static extern void StencilStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,] paths, UInt32 pathBase, Int32 reference, UInt32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilStrokePathInstancedNV")]
            public static extern unsafe void StencilStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,] paths, UInt32 pathBase, Int32 reference, UInt32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilStrokePathInstancedNV")]
            public static extern void StencilStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,,] paths, Int32 pathBase, Int32 reference, Int32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilStrokePathInstancedNV")]
            public static extern void StencilStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,,] paths, Int32 pathBase, Int32 reference, Int32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilStrokePathInstancedNV")]
            public static extern unsafe void StencilStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,,] paths, Int32 pathBase, Int32 reference, Int32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilStrokePathInstancedNV")]
            public static extern void StencilStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,,] paths, UInt32 pathBase, Int32 reference, UInt32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilStrokePathInstancedNV")]
            public static extern void StencilStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,,] paths, UInt32 pathBase, Int32 reference, UInt32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilStrokePathInstancedNV")]
            public static extern unsafe void StencilStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] T2[,,] paths, UInt32 pathBase, Int32 reference, UInt32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilStrokePathInstancedNV")]
            public static extern void StencilStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T2 paths, Int32 pathBase, Int32 reference, Int32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilStrokePathInstancedNV")]
            public static extern void StencilStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T2 paths, Int32 pathBase, Int32 reference, Int32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilStrokePathInstancedNV")]
            public static extern unsafe void StencilStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T2 paths, Int32 pathBase, Int32 reference, Int32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilStrokePathInstancedNV")]
            public static extern void StencilStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T2 paths, UInt32 pathBase, Int32 reference, UInt32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilStrokePathInstancedNV")]
            public static extern void StencilStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T2 paths, UInt32 pathBase, Int32 reference, UInt32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilStrokePathInstancedNV")]
            public static extern unsafe void StencilStrokePathInstanced<T2>(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, [InAttribute, OutAttribute] ref T2 paths, UInt32 pathBase, Int32 reference, UInt32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues)
                where T2 : struct
            ;

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilStrokePathNV")]
            public static extern void StencilStrokePath(Int32 path, Int32 reference, Int32 mask);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glStencilStrokePathNV")]
            public static extern void StencilStrokePath(UInt32 path, Int32 reference, UInt32 mask);

            /// <summary>[requires: NV_fence]</summary>
            [AutoGenerated(Category = "NV_fence", Version = "", EntryPoint = "glTestFenceNV")]
            public static extern bool TestFence(Int32 fence);

            /// <summary>[requires: NV_fence]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_fence", Version = "", EntryPoint = "glTestFenceNV")]
            public static extern bool TestFence(UInt32 fence);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glTexCoord1hNV")]
            public static extern void TexCoord1h(Half s);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glTexCoord1hvNV")]
            public static extern unsafe void TexCoord1h(Half* v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glTexCoord2hNV")]
            public static extern void TexCoord2h(Half s, Half t);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glTexCoord2hvNV")]
            public static extern void TexCoord2h(Half[] v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glTexCoord2hvNV")]
            public static extern void TexCoord2h(ref Half v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glTexCoord2hvNV")]
            public static extern unsafe void TexCoord2h(Half* v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glTexCoord3hNV")]
            public static extern void TexCoord3h(Half s, Half t, Half r);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glTexCoord3hvNV")]
            public static extern void TexCoord3h(Half[] v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glTexCoord3hvNV")]
            public static extern void TexCoord3h(ref Half v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glTexCoord3hvNV")]
            public static extern unsafe void TexCoord3h(Half* v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glTexCoord4hNV")]
            public static extern void TexCoord4h(Half s, Half t, Half r, Half q);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glTexCoord4hvNV")]
            public static extern void TexCoord4h(Half[] v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glTexCoord4hvNV")]
            public static extern void TexCoord4h(ref Half v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glTexCoord4hvNV")]
            public static extern unsafe void TexCoord4h(Half* v);

            /// <summary>[requires: NV_vertex_buffer_unified_memory]</summary>
            [AutoGenerated(Category = "NV_vertex_buffer_unified_memory", Version = "", EntryPoint = "glTexCoordFormatNV")]
            public static extern void TexCoordFormat(Int32 size, OpenTK.Graphics.OpenGL.NvVertexBufferUnifiedMemory type, Int32 stride);

            /// <summary>[requires: NV_texture_multisample]</summary>
            [AutoGenerated(Category = "NV_texture_multisample", Version = "", EntryPoint = "glTexImage2DMultisampleCoverageNV")]
            public static extern void TexImage2DMultisampleCoverage(OpenTK.Graphics.OpenGL.NvTextureMultisample target, Int32 coverageSamples, Int32 colorSamples, Int32 internalFormat, Int32 width, Int32 height, bool fixedSampleLocations);

            /// <summary>[requires: NV_texture_multisample]</summary>
            [AutoGenerated(Category = "NV_texture_multisample", Version = "", EntryPoint = "glTexImage3DMultisampleCoverageNV")]
            public static extern void TexImage3DMultisampleCoverage(OpenTK.Graphics.OpenGL.NvTextureMultisample target, Int32 coverageSamples, Int32 colorSamples, Int32 internalFormat, Int32 width, Int32 height, Int32 depth, bool fixedSampleLocations);

            /// <summary>[requires: NV_explicit_multisample]</summary>
            [AutoGenerated(Category = "NV_explicit_multisample", Version = "", EntryPoint = "glTexRenderbufferNV")]
            public static extern void TexRenderbuffer(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 renderbuffer);

            /// <summary>[requires: NV_explicit_multisample]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_explicit_multisample", Version = "", EntryPoint = "glTexRenderbufferNV")]
            public static extern void TexRenderbuffer(OpenTK.Graphics.OpenGL.TextureTarget target, UInt32 renderbuffer);

            /// <summary>[requires: NV_texture_barrier]</summary>
            [AutoGenerated(Category = "NV_texture_barrier", Version = "", EntryPoint = "glTextureBarrierNV")]
            public static extern void TextureBarrier();

            /// <summary>[requires: NV_texture_multisample]</summary>
            [AutoGenerated(Category = "NV_texture_multisample", Version = "", EntryPoint = "glTextureImage2DMultisampleCoverageNV")]
            public static extern void TextureImage2DMultisampleCoverage(Int32 texture, OpenTK.Graphics.OpenGL.NvTextureMultisample target, Int32 coverageSamples, Int32 colorSamples, Int32 internalFormat, Int32 width, Int32 height, bool fixedSampleLocations);

            /// <summary>[requires: NV_texture_multisample]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_texture_multisample", Version = "", EntryPoint = "glTextureImage2DMultisampleCoverageNV")]
            public static extern void TextureImage2DMultisampleCoverage(UInt32 texture, OpenTK.Graphics.OpenGL.NvTextureMultisample target, Int32 coverageSamples, Int32 colorSamples, Int32 internalFormat, Int32 width, Int32 height, bool fixedSampleLocations);

            /// <summary>[requires: NV_texture_multisample]</summary>
            [AutoGenerated(Category = "NV_texture_multisample", Version = "", EntryPoint = "glTextureImage2DMultisampleNV")]
            public static extern void TextureImage2DMultisample(Int32 texture, OpenTK.Graphics.OpenGL.NvTextureMultisample target, Int32 samples, Int32 internalFormat, Int32 width, Int32 height, bool fixedSampleLocations);

            /// <summary>[requires: NV_texture_multisample]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_texture_multisample", Version = "", EntryPoint = "glTextureImage2DMultisampleNV")]
            public static extern void TextureImage2DMultisample(UInt32 texture, OpenTK.Graphics.OpenGL.NvTextureMultisample target, Int32 samples, Int32 internalFormat, Int32 width, Int32 height, bool fixedSampleLocations);

            /// <summary>[requires: NV_texture_multisample]</summary>
            [AutoGenerated(Category = "NV_texture_multisample", Version = "", EntryPoint = "glTextureImage3DMultisampleCoverageNV")]
            public static extern void TextureImage3DMultisampleCoverage(Int32 texture, OpenTK.Graphics.OpenGL.NvTextureMultisample target, Int32 coverageSamples, Int32 colorSamples, Int32 internalFormat, Int32 width, Int32 height, Int32 depth, bool fixedSampleLocations);

            /// <summary>[requires: NV_texture_multisample]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_texture_multisample", Version = "", EntryPoint = "glTextureImage3DMultisampleCoverageNV")]
            public static extern void TextureImage3DMultisampleCoverage(UInt32 texture, OpenTK.Graphics.OpenGL.NvTextureMultisample target, Int32 coverageSamples, Int32 colorSamples, Int32 internalFormat, Int32 width, Int32 height, Int32 depth, bool fixedSampleLocations);

            /// <summary>[requires: NV_texture_multisample]</summary>
            [AutoGenerated(Category = "NV_texture_multisample", Version = "", EntryPoint = "glTextureImage3DMultisampleNV")]
            public static extern void TextureImage3DMultisample(Int32 texture, OpenTK.Graphics.OpenGL.NvTextureMultisample target, Int32 samples, Int32 internalFormat, Int32 width, Int32 height, Int32 depth, bool fixedSampleLocations);

            /// <summary>[requires: NV_texture_multisample]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_texture_multisample", Version = "", EntryPoint = "glTextureImage3DMultisampleNV")]
            public static extern void TextureImage3DMultisample(UInt32 texture, OpenTK.Graphics.OpenGL.NvTextureMultisample target, Int32 samples, Int32 internalFormat, Int32 width, Int32 height, Int32 depth, bool fixedSampleLocations);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glTrackMatrixNV")]
            public static extern void TrackMatrix(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, Int32 address, OpenTK.Graphics.OpenGL.NvVertexProgram matrix, OpenTK.Graphics.OpenGL.NvVertexProgram transform);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glTrackMatrixNV")]
            public static extern void TrackMatrix(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 address, OpenTK.Graphics.OpenGL.NvVertexProgram matrix, OpenTK.Graphics.OpenGL.NvVertexProgram transform);

            /// <summary>[requires: NV_transform_feedback]</summary>
            [AutoGenerated(Category = "NV_transform_feedback", Version = "", EntryPoint = "glTransformFeedbackAttribsNV")]
            public static extern void TransformFeedbackAttrib(Int32 count, Int32[] attribs, OpenTK.Graphics.OpenGL.NvTransformFeedback bufferMode);

            /// <summary>[requires: NV_transform_feedback]</summary>
            [AutoGenerated(Category = "NV_transform_feedback", Version = "", EntryPoint = "glTransformFeedbackAttribsNV")]
            public static extern void TransformFeedbackAttrib(Int32 count, ref Int32 attribs, OpenTK.Graphics.OpenGL.NvTransformFeedback bufferMode);

            /// <summary>[requires: NV_transform_feedback]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_transform_feedback", Version = "", EntryPoint = "glTransformFeedbackAttribsNV")]
            public static extern unsafe void TransformFeedbackAttrib(Int32 count, Int32* attribs, OpenTK.Graphics.OpenGL.NvTransformFeedback bufferMode);

            /// <summary>[requires: NV_transform_feedback]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_transform_feedback", Version = "", EntryPoint = "glTransformFeedbackAttribsNV")]
            public static extern void TransformFeedbackAttrib(UInt32 count, Int32[] attribs, OpenTK.Graphics.OpenGL.NvTransformFeedback bufferMode);

            /// <summary>[requires: NV_transform_feedback]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_transform_feedback", Version = "", EntryPoint = "glTransformFeedbackAttribsNV")]
            public static extern void TransformFeedbackAttrib(UInt32 count, ref Int32 attribs, OpenTK.Graphics.OpenGL.NvTransformFeedback bufferMode);

            /// <summary>[requires: NV_transform_feedback]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_transform_feedback", Version = "", EntryPoint = "glTransformFeedbackAttribsNV")]
            public static extern unsafe void TransformFeedbackAttrib(UInt32 count, Int32* attribs, OpenTK.Graphics.OpenGL.NvTransformFeedback bufferMode);

            /// <summary>[requires: NV_transform_feedback]</summary>
            [AutoGenerated(Category = "NV_transform_feedback", Version = "", EntryPoint = "glTransformFeedbackStreamAttribsNV")]
            public static extern void TransformFeedbackStreamAttrib(Int32 count, Int32[] attribs, Int32 nbuffers, Int32[] bufstreams, OpenTK.Graphics.OpenGL.NvTransformFeedback bufferMode);

            /// <summary>[requires: NV_transform_feedback]</summary>
            [AutoGenerated(Category = "NV_transform_feedback", Version = "", EntryPoint = "glTransformFeedbackStreamAttribsNV")]
            public static extern void TransformFeedbackStreamAttrib(Int32 count, ref Int32 attribs, Int32 nbuffers, ref Int32 bufstreams, OpenTK.Graphics.OpenGL.NvTransformFeedback bufferMode);

            /// <summary>[requires: NV_transform_feedback]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_transform_feedback", Version = "", EntryPoint = "glTransformFeedbackStreamAttribsNV")]
            public static extern unsafe void TransformFeedbackStreamAttrib(Int32 count, Int32* attribs, Int32 nbuffers, Int32* bufstreams, OpenTK.Graphics.OpenGL.NvTransformFeedback bufferMode);

            /// <summary>[requires: NV_transform_feedback]
            /// Specify values to record in transform feedback buffers
            /// </summary>
            /// <param name="program">
            /// <para>
            /// The name of the target program object.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// The number of varying variables used for transform feedback.
            /// </para>
            /// </param>
            /// <param name="varyings">
            /// <para>
            /// An array of count zero-terminated strings specifying the names of the varying variables to use for transform feedback.
            /// </para>
            /// </param>
            /// <param name="bufferMode">
            /// <para>
            /// Identifies the mode used to capture the varying variables when transform feedback is active. bufferMode must be GL_INTERLEAVED_ATTRIBS or GL_SEPARATE_ATTRIBS.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_transform_feedback", Version = "", EntryPoint = "glTransformFeedbackVaryingsNV")]
            public static extern void TransformFeedbackVaryings(Int32 program, Int32 count, Int32[] locations, OpenTK.Graphics.OpenGL.NvTransformFeedback bufferMode);

            /// <summary>[requires: NV_transform_feedback]
            /// Specify values to record in transform feedback buffers
            /// </summary>
            /// <param name="program">
            /// <para>
            /// The name of the target program object.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// The number of varying variables used for transform feedback.
            /// </para>
            /// </param>
            /// <param name="varyings">
            /// <para>
            /// An array of count zero-terminated strings specifying the names of the varying variables to use for transform feedback.
            /// </para>
            /// </param>
            /// <param name="bufferMode">
            /// <para>
            /// Identifies the mode used to capture the varying variables when transform feedback is active. bufferMode must be GL_INTERLEAVED_ATTRIBS or GL_SEPARATE_ATTRIBS.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_transform_feedback", Version = "", EntryPoint = "glTransformFeedbackVaryingsNV")]
            public static extern void TransformFeedbackVaryings(Int32 program, Int32 count, ref Int32 locations, OpenTK.Graphics.OpenGL.NvTransformFeedback bufferMode);

            /// <summary>[requires: NV_transform_feedback]
            /// Specify values to record in transform feedback buffers
            /// </summary>
            /// <param name="program">
            /// <para>
            /// The name of the target program object.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// The number of varying variables used for transform feedback.
            /// </para>
            /// </param>
            /// <param name="varyings">
            /// <para>
            /// An array of count zero-terminated strings specifying the names of the varying variables to use for transform feedback.
            /// </para>
            /// </param>
            /// <param name="bufferMode">
            /// <para>
            /// Identifies the mode used to capture the varying variables when transform feedback is active. bufferMode must be GL_INTERLEAVED_ATTRIBS or GL_SEPARATE_ATTRIBS.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_transform_feedback", Version = "", EntryPoint = "glTransformFeedbackVaryingsNV")]
            public static extern unsafe void TransformFeedbackVaryings(Int32 program, Int32 count, Int32* locations, OpenTK.Graphics.OpenGL.NvTransformFeedback bufferMode);

            /// <summary>[requires: NV_transform_feedback]
            /// Specify values to record in transform feedback buffers
            /// </summary>
            /// <param name="program">
            /// <para>
            /// The name of the target program object.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// The number of varying variables used for transform feedback.
            /// </para>
            /// </param>
            /// <param name="varyings">
            /// <para>
            /// An array of count zero-terminated strings specifying the names of the varying variables to use for transform feedback.
            /// </para>
            /// </param>
            /// <param name="bufferMode">
            /// <para>
            /// Identifies the mode used to capture the varying variables when transform feedback is active. bufferMode must be GL_INTERLEAVED_ATTRIBS or GL_SEPARATE_ATTRIBS.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_transform_feedback", Version = "", EntryPoint = "glTransformFeedbackVaryingsNV")]
            public static extern void TransformFeedbackVaryings(UInt32 program, Int32 count, Int32[] locations, OpenTK.Graphics.OpenGL.NvTransformFeedback bufferMode);

            /// <summary>[requires: NV_transform_feedback]
            /// Specify values to record in transform feedback buffers
            /// </summary>
            /// <param name="program">
            /// <para>
            /// The name of the target program object.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// The number of varying variables used for transform feedback.
            /// </para>
            /// </param>
            /// <param name="varyings">
            /// <para>
            /// An array of count zero-terminated strings specifying the names of the varying variables to use for transform feedback.
            /// </para>
            /// </param>
            /// <param name="bufferMode">
            /// <para>
            /// Identifies the mode used to capture the varying variables when transform feedback is active. bufferMode must be GL_INTERLEAVED_ATTRIBS or GL_SEPARATE_ATTRIBS.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_transform_feedback", Version = "", EntryPoint = "glTransformFeedbackVaryingsNV")]
            public static extern void TransformFeedbackVaryings(UInt32 program, Int32 count, ref Int32 locations, OpenTK.Graphics.OpenGL.NvTransformFeedback bufferMode);

            /// <summary>[requires: NV_transform_feedback]
            /// Specify values to record in transform feedback buffers
            /// </summary>
            /// <param name="program">
            /// <para>
            /// The name of the target program object.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// The number of varying variables used for transform feedback.
            /// </para>
            /// </param>
            /// <param name="varyings">
            /// <para>
            /// An array of count zero-terminated strings specifying the names of the varying variables to use for transform feedback.
            /// </para>
            /// </param>
            /// <param name="bufferMode">
            /// <para>
            /// Identifies the mode used to capture the varying variables when transform feedback is active. bufferMode must be GL_INTERLEAVED_ATTRIBS or GL_SEPARATE_ATTRIBS.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_transform_feedback", Version = "", EntryPoint = "glTransformFeedbackVaryingsNV")]
            public static extern unsafe void TransformFeedbackVaryings(UInt32 program, Int32 count, Int32* locations, OpenTK.Graphics.OpenGL.NvTransformFeedback bufferMode);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glTransformPathNV")]
            public static extern void TransformPath(Int32 resultPath, Int32 srcPath, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glTransformPathNV")]
            public static extern void TransformPath(Int32 resultPath, Int32 srcPath, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glTransformPathNV")]
            public static extern unsafe void TransformPath(Int32 resultPath, Int32 srcPath, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glTransformPathNV")]
            public static extern void TransformPath(UInt32 resultPath, UInt32 srcPath, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single[] transformValues);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glTransformPathNV")]
            public static extern void TransformPath(UInt32 resultPath, UInt32 srcPath, OpenTK.Graphics.OpenGL.NvPathRendering transformType, ref Single transformValues);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glTransformPathNV")]
            public static extern unsafe void TransformPath(UInt32 resultPath, UInt32 srcPath, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glUniform1i64NV")]
            public static extern void Uniform1(Int32 location, Int64 x);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glUniform1i64vNV")]
            public static extern void Uniform1(Int32 location, Int32 count, Int64[] value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glUniform1i64vNV")]
            public static extern void Uniform1(Int32 location, Int32 count, ref Int64 value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glUniform1i64vNV")]
            public static extern unsafe void Uniform1(Int32 location, Int32 count, Int64* value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glUniform1ui64NV")]
            public static extern void Uniform1(Int32 location, UInt64 x);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glUniform1ui64vNV")]
            public static extern void Uniform1(Int32 location, Int32 count, UInt64[] value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glUniform1ui64vNV")]
            public static extern void Uniform1(Int32 location, Int32 count, ref UInt64 value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glUniform1ui64vNV")]
            public static extern unsafe void Uniform1(Int32 location, Int32 count, UInt64* value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glUniform2i64NV")]
            public static extern void Uniform2(Int32 location, Int64 x, Int64 y);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glUniform2i64vNV")]
            public static extern void Uniform2(Int32 location, Int32 count, Int64[] value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glUniform2i64vNV")]
            public static extern void Uniform2(Int32 location, Int32 count, ref Int64 value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glUniform2i64vNV")]
            public static extern unsafe void Uniform2(Int32 location, Int32 count, Int64* value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glUniform2ui64NV")]
            public static extern void Uniform2(Int32 location, UInt64 x, UInt64 y);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glUniform2ui64vNV")]
            public static extern void Uniform2(Int32 location, Int32 count, UInt64[] value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glUniform2ui64vNV")]
            public static extern void Uniform2(Int32 location, Int32 count, ref UInt64 value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glUniform2ui64vNV")]
            public static extern unsafe void Uniform2(Int32 location, Int32 count, UInt64* value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glUniform3i64NV")]
            public static extern void Uniform3(Int32 location, Int64 x, Int64 y, Int64 z);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glUniform3i64vNV")]
            public static extern void Uniform3(Int32 location, Int32 count, Int64[] value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glUniform3i64vNV")]
            public static extern void Uniform3(Int32 location, Int32 count, ref Int64 value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glUniform3i64vNV")]
            public static extern unsafe void Uniform3(Int32 location, Int32 count, Int64* value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glUniform3ui64NV")]
            public static extern void Uniform3(Int32 location, UInt64 x, UInt64 y, UInt64 z);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glUniform3ui64vNV")]
            public static extern void Uniform3(Int32 location, Int32 count, UInt64[] value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glUniform3ui64vNV")]
            public static extern void Uniform3(Int32 location, Int32 count, ref UInt64 value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glUniform3ui64vNV")]
            public static extern unsafe void Uniform3(Int32 location, Int32 count, UInt64* value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glUniform4i64NV")]
            public static extern void Uniform4(Int32 location, Int64 x, Int64 y, Int64 z, Int64 w);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glUniform4i64vNV")]
            public static extern void Uniform4(Int32 location, Int32 count, Int64[] value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glUniform4i64vNV")]
            public static extern void Uniform4(Int32 location, Int32 count, ref Int64 value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glUniform4i64vNV")]
            public static extern unsafe void Uniform4(Int32 location, Int32 count, Int64* value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glUniform4ui64NV")]
            public static extern void Uniform4(Int32 location, UInt64 x, UInt64 y, UInt64 z, UInt64 w);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glUniform4ui64vNV")]
            public static extern void Uniform4(Int32 location, Int32 count, UInt64[] value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glUniform4ui64vNV")]
            public static extern void Uniform4(Int32 location, Int32 count, ref UInt64 value);

            /// <summary>[requires: NV_gpu_shader5]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_gpu_shader5", Version = "", EntryPoint = "glUniform4ui64vNV")]
            public static extern unsafe void Uniform4(Int32 location, Int32 count, UInt64* value);

            /// <summary>[requires: NV_bindless_texture]</summary>
            [AutoGenerated(Category = "NV_bindless_texture", Version = "", EntryPoint = "glUniformHandleui64NV")]
            public static extern void UniformHandle(Int32 location, Int64 value);

            /// <summary>[requires: NV_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_bindless_texture", Version = "", EntryPoint = "glUniformHandleui64NV")]
            public static extern void UniformHandle(Int32 location, UInt64 value);

            /// <summary>[requires: NV_bindless_texture]</summary>
            [AutoGenerated(Category = "NV_bindless_texture", Version = "", EntryPoint = "glUniformHandleui64vNV")]
            public static extern void UniformHandle(Int32 location, Int32 count, Int64[] value);

            /// <summary>[requires: NV_bindless_texture]</summary>
            [AutoGenerated(Category = "NV_bindless_texture", Version = "", EntryPoint = "glUniformHandleui64vNV")]
            public static extern void UniformHandle(Int32 location, Int32 count, ref Int64 value);

            /// <summary>[requires: NV_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_bindless_texture", Version = "", EntryPoint = "glUniformHandleui64vNV")]
            public static extern unsafe void UniformHandle(Int32 location, Int32 count, Int64* value);

            /// <summary>[requires: NV_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_bindless_texture", Version = "", EntryPoint = "glUniformHandleui64vNV")]
            public static extern void UniformHandle(Int32 location, Int32 count, UInt64[] value);

            /// <summary>[requires: NV_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_bindless_texture", Version = "", EntryPoint = "glUniformHandleui64vNV")]
            public static extern void UniformHandle(Int32 location, Int32 count, ref UInt64 value);

            /// <summary>[requires: NV_bindless_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_bindless_texture", Version = "", EntryPoint = "glUniformHandleui64vNV")]
            public static extern unsafe void UniformHandle(Int32 location, Int32 count, UInt64* value);

            /// <summary>[requires: NV_shader_buffer_load]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glUniformui64NV")]
            public static extern void Uniform(Int32 location, Int64 value);

            /// <summary>[requires: NV_shader_buffer_load]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glUniformui64NV")]
            public static extern void Uniform(Int32 location, UInt64 value);

            /// <summary>[requires: NV_shader_buffer_load]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glUniformui64vNV")]
            public static extern void Uniform(Int32 location, Int32 count, Int64[] value);

            /// <summary>[requires: NV_shader_buffer_load]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glUniformui64vNV")]
            public static extern void Uniform(Int32 location, Int32 count, ref Int64 value);

            /// <summary>[requires: NV_shader_buffer_load]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glUniformui64vNV")]
            public static extern unsafe void Uniform(Int32 location, Int32 count, Int64* value);

            /// <summary>[requires: NV_shader_buffer_load]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glUniformui64vNV")]
            public static extern void Uniform(Int32 location, Int32 count, UInt64[] value);

            /// <summary>[requires: NV_shader_buffer_load]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glUniformui64vNV")]
            public static extern void Uniform(Int32 location, Int32 count, ref UInt64 value);

            /// <summary>[requires: NV_shader_buffer_load]
            /// Specify the value of a uniform variable for the current program object
            /// </summary>
            /// <param name="location">
            /// <para>
            /// Specifies the location of the uniform variable to be modified.
            /// </para>
            /// </param>
            /// <param name="count">
            /// <para>
            /// For the vector (glUniform*v) commands, specifies the number of elements that are to be modified. This should be 1 if the targeted uniform variable is not an array, and 1 or more if it is an array.
            /// </para>
            /// <para>
            /// For the matrix (glUniformMatrix*) commands, specifies the number of matrices that are to be modified. This should be 1 if the targeted uniform variable is not an array of matrices, and 1 or more if it is an array of matrices.
            /// </para>
            /// </param>
            /// <param name="transpose">
            /// <para>
            /// For the matrix commands, specifies whether to transpose the matrix as the values are loaded into the uniform variable.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified uniform variable.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the vector and matrix commands, specifies a pointer to an array of count values that will be used to update the specified uniform variable.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_shader_buffer_load", Version = "", EntryPoint = "glUniformui64vNV")]
            public static extern unsafe void Uniform(Int32 location, Int32 count, UInt64* value);

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAUFiniNV")]
            public static extern void VDPAUFin();

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAUGetSurfaceivNV")]
            public static extern void VDPAUGetSurface(IntPtr surface, OpenTK.Graphics.OpenGL.NvVdpauInterop pname, Int32 bufSize, [OutAttribute] Int32[] length, [OutAttribute] Int32[] values);

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAUGetSurfaceivNV")]
            public static extern void VDPAUGetSurface(IntPtr surface, OpenTK.Graphics.OpenGL.NvVdpauInterop pname, Int32 bufSize, [OutAttribute] out Int32 length, [OutAttribute] out Int32 values);

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAUGetSurfaceivNV")]
            public static extern unsafe void VDPAUGetSurface(IntPtr surface, OpenTK.Graphics.OpenGL.NvVdpauInterop pname, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] Int32* values);

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAUInitNV")]
            public static extern void VDPAUInit(IntPtr vdpDevice, IntPtr getProcAddress);

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAUInitNV")]
            public static extern void VDPAUInit<T0,T1>([InAttribute, OutAttribute] T0[] vdpDevice, [InAttribute, OutAttribute] T1[] getProcAddress)
                where T0 : struct
                where T1 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAUInitNV")]
            public static extern void VDPAUInit<T0,T1>([InAttribute, OutAttribute] T0[,] vdpDevice, [InAttribute, OutAttribute] T1[,] getProcAddress)
                where T0 : struct
                where T1 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAUInitNV")]
            public static extern void VDPAUInit<T0,T1>([InAttribute, OutAttribute] T0[,,] vdpDevice, [InAttribute, OutAttribute] T1[,,] getProcAddress)
                where T0 : struct
                where T1 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAUInitNV")]
            public static extern void VDPAUInit<T0,T1>([InAttribute, OutAttribute] ref T0 vdpDevice, [InAttribute, OutAttribute] ref T1 getProcAddress)
                where T0 : struct
                where T1 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAUIsSurfaceNV")]
            public static extern void VDPAUIsSurface(IntPtr surface);

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAUMapSurfacesNV")]
            public static extern void VDPAUMapSurfaces(Int32 numSurfaces, IntPtr[] surfaces);

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAUMapSurfacesNV")]
            public static extern void VDPAUMapSurfaces(Int32 numSurfaces, ref IntPtr surfaces);

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAUMapSurfacesNV")]
            public static extern unsafe void VDPAUMapSurfaces(Int32 numSurfaces, IntPtr* surfaces);

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterOutputSurfaceNV")]
            public static extern IntPtr VDPAURegisterOutputSurface(IntPtr vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, Int32[] textureNames);

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterOutputSurfaceNV")]
            public static extern IntPtr VDPAURegisterOutputSurface(IntPtr vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, ref Int32 textureNames);

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterOutputSurfaceNV")]
            public static extern unsafe IntPtr VDPAURegisterOutputSurface(IntPtr vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, Int32* textureNames);

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterOutputSurfaceNV")]
            public static extern IntPtr VDPAURegisterOutputSurface(IntPtr vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, UInt32[] textureNames);

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterOutputSurfaceNV")]
            public static extern IntPtr VDPAURegisterOutputSurface(IntPtr vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, ref UInt32 textureNames);

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterOutputSurfaceNV")]
            public static extern unsafe IntPtr VDPAURegisterOutputSurface(IntPtr vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, UInt32* textureNames);

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterOutputSurfaceNV")]
            public static extern IntPtr VDPAURegisterOutputSurface<T0>([InAttribute, OutAttribute] T0[] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, Int32[] textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterOutputSurfaceNV")]
            public static extern IntPtr VDPAURegisterOutputSurface<T0>([InAttribute, OutAttribute] T0[] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, ref Int32 textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterOutputSurfaceNV")]
            public static extern unsafe IntPtr VDPAURegisterOutputSurface<T0>([InAttribute, OutAttribute] T0[] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, Int32* textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterOutputSurfaceNV")]
            public static extern IntPtr VDPAURegisterOutputSurface<T0>([InAttribute, OutAttribute] T0[] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, UInt32[] textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterOutputSurfaceNV")]
            public static extern IntPtr VDPAURegisterOutputSurface<T0>([InAttribute, OutAttribute] T0[] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, ref UInt32 textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterOutputSurfaceNV")]
            public static extern unsafe IntPtr VDPAURegisterOutputSurface<T0>([InAttribute, OutAttribute] T0[] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, UInt32* textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterOutputSurfaceNV")]
            public static extern IntPtr VDPAURegisterOutputSurface<T0>([InAttribute, OutAttribute] T0[,] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, Int32[] textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterOutputSurfaceNV")]
            public static extern IntPtr VDPAURegisterOutputSurface<T0>([InAttribute, OutAttribute] T0[,] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, ref Int32 textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterOutputSurfaceNV")]
            public static extern unsafe IntPtr VDPAURegisterOutputSurface<T0>([InAttribute, OutAttribute] T0[,] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, Int32* textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterOutputSurfaceNV")]
            public static extern IntPtr VDPAURegisterOutputSurface<T0>([InAttribute, OutAttribute] T0[,] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, UInt32[] textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterOutputSurfaceNV")]
            public static extern IntPtr VDPAURegisterOutputSurface<T0>([InAttribute, OutAttribute] T0[,] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, ref UInt32 textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterOutputSurfaceNV")]
            public static extern unsafe IntPtr VDPAURegisterOutputSurface<T0>([InAttribute, OutAttribute] T0[,] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, UInt32* textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterOutputSurfaceNV")]
            public static extern IntPtr VDPAURegisterOutputSurface<T0>([InAttribute, OutAttribute] T0[,,] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, Int32[] textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterOutputSurfaceNV")]
            public static extern IntPtr VDPAURegisterOutputSurface<T0>([InAttribute, OutAttribute] T0[,,] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, ref Int32 textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterOutputSurfaceNV")]
            public static extern unsafe IntPtr VDPAURegisterOutputSurface<T0>([InAttribute, OutAttribute] T0[,,] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, Int32* textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterOutputSurfaceNV")]
            public static extern IntPtr VDPAURegisterOutputSurface<T0>([InAttribute, OutAttribute] T0[,,] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, UInt32[] textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterOutputSurfaceNV")]
            public static extern IntPtr VDPAURegisterOutputSurface<T0>([InAttribute, OutAttribute] T0[,,] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, ref UInt32 textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterOutputSurfaceNV")]
            public static extern unsafe IntPtr VDPAURegisterOutputSurface<T0>([InAttribute, OutAttribute] T0[,,] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, UInt32* textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterOutputSurfaceNV")]
            public static extern IntPtr VDPAURegisterOutputSurface<T0>([InAttribute, OutAttribute] ref T0 vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, Int32[] textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterOutputSurfaceNV")]
            public static extern IntPtr VDPAURegisterOutputSurface<T0>([InAttribute, OutAttribute] ref T0 vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, ref Int32 textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterOutputSurfaceNV")]
            public static extern unsafe IntPtr VDPAURegisterOutputSurface<T0>([InAttribute, OutAttribute] ref T0 vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, Int32* textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterOutputSurfaceNV")]
            public static extern IntPtr VDPAURegisterOutputSurface<T0>([InAttribute, OutAttribute] ref T0 vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, UInt32[] textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterOutputSurfaceNV")]
            public static extern IntPtr VDPAURegisterOutputSurface<T0>([InAttribute, OutAttribute] ref T0 vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, ref UInt32 textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterOutputSurfaceNV")]
            public static extern unsafe IntPtr VDPAURegisterOutputSurface<T0>([InAttribute, OutAttribute] ref T0 vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, UInt32* textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterVideoSurfaceNV")]
            public static extern IntPtr VDPAURegisterVideoSurface(IntPtr vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, Int32[] textureNames);

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterVideoSurfaceNV")]
            public static extern IntPtr VDPAURegisterVideoSurface(IntPtr vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, ref Int32 textureNames);

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterVideoSurfaceNV")]
            public static extern unsafe IntPtr VDPAURegisterVideoSurface(IntPtr vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, Int32* textureNames);

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterVideoSurfaceNV")]
            public static extern IntPtr VDPAURegisterVideoSurface(IntPtr vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, UInt32[] textureNames);

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterVideoSurfaceNV")]
            public static extern IntPtr VDPAURegisterVideoSurface(IntPtr vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, ref UInt32 textureNames);

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterVideoSurfaceNV")]
            public static extern unsafe IntPtr VDPAURegisterVideoSurface(IntPtr vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, UInt32* textureNames);

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterVideoSurfaceNV")]
            public static extern IntPtr VDPAURegisterVideoSurface<T0>([InAttribute, OutAttribute] T0[] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, Int32[] textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterVideoSurfaceNV")]
            public static extern IntPtr VDPAURegisterVideoSurface<T0>([InAttribute, OutAttribute] T0[] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, ref Int32 textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterVideoSurfaceNV")]
            public static extern unsafe IntPtr VDPAURegisterVideoSurface<T0>([InAttribute, OutAttribute] T0[] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, Int32* textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterVideoSurfaceNV")]
            public static extern IntPtr VDPAURegisterVideoSurface<T0>([InAttribute, OutAttribute] T0[] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, UInt32[] textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterVideoSurfaceNV")]
            public static extern IntPtr VDPAURegisterVideoSurface<T0>([InAttribute, OutAttribute] T0[] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, ref UInt32 textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterVideoSurfaceNV")]
            public static extern unsafe IntPtr VDPAURegisterVideoSurface<T0>([InAttribute, OutAttribute] T0[] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, UInt32* textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterVideoSurfaceNV")]
            public static extern IntPtr VDPAURegisterVideoSurface<T0>([InAttribute, OutAttribute] T0[,] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, Int32[] textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterVideoSurfaceNV")]
            public static extern IntPtr VDPAURegisterVideoSurface<T0>([InAttribute, OutAttribute] T0[,] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, ref Int32 textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterVideoSurfaceNV")]
            public static extern unsafe IntPtr VDPAURegisterVideoSurface<T0>([InAttribute, OutAttribute] T0[,] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, Int32* textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterVideoSurfaceNV")]
            public static extern IntPtr VDPAURegisterVideoSurface<T0>([InAttribute, OutAttribute] T0[,] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, UInt32[] textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterVideoSurfaceNV")]
            public static extern IntPtr VDPAURegisterVideoSurface<T0>([InAttribute, OutAttribute] T0[,] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, ref UInt32 textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterVideoSurfaceNV")]
            public static extern unsafe IntPtr VDPAURegisterVideoSurface<T0>([InAttribute, OutAttribute] T0[,] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, UInt32* textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterVideoSurfaceNV")]
            public static extern IntPtr VDPAURegisterVideoSurface<T0>([InAttribute, OutAttribute] T0[,,] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, Int32[] textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterVideoSurfaceNV")]
            public static extern IntPtr VDPAURegisterVideoSurface<T0>([InAttribute, OutAttribute] T0[,,] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, ref Int32 textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterVideoSurfaceNV")]
            public static extern unsafe IntPtr VDPAURegisterVideoSurface<T0>([InAttribute, OutAttribute] T0[,,] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, Int32* textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterVideoSurfaceNV")]
            public static extern IntPtr VDPAURegisterVideoSurface<T0>([InAttribute, OutAttribute] T0[,,] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, UInt32[] textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterVideoSurfaceNV")]
            public static extern IntPtr VDPAURegisterVideoSurface<T0>([InAttribute, OutAttribute] T0[,,] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, ref UInt32 textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterVideoSurfaceNV")]
            public static extern unsafe IntPtr VDPAURegisterVideoSurface<T0>([InAttribute, OutAttribute] T0[,,] vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, UInt32* textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterVideoSurfaceNV")]
            public static extern IntPtr VDPAURegisterVideoSurface<T0>([InAttribute, OutAttribute] ref T0 vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, Int32[] textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterVideoSurfaceNV")]
            public static extern IntPtr VDPAURegisterVideoSurface<T0>([InAttribute, OutAttribute] ref T0 vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, ref Int32 textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterVideoSurfaceNV")]
            public static extern unsafe IntPtr VDPAURegisterVideoSurface<T0>([InAttribute, OutAttribute] ref T0 vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, Int32* textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterVideoSurfaceNV")]
            public static extern IntPtr VDPAURegisterVideoSurface<T0>([InAttribute, OutAttribute] ref T0 vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, UInt32[] textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterVideoSurfaceNV")]
            public static extern IntPtr VDPAURegisterVideoSurface<T0>([InAttribute, OutAttribute] ref T0 vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, ref UInt32 textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAURegisterVideoSurfaceNV")]
            public static extern unsafe IntPtr VDPAURegisterVideoSurface<T0>([InAttribute, OutAttribute] ref T0 vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, UInt32* textureNames)
                where T0 : struct
            ;

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAUSurfaceAccessNV")]
            public static extern void VDPAUSurfaceAccess(IntPtr surface, OpenTK.Graphics.OpenGL.NvVdpauInterop access);

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAUUnmapSurfacesNV")]
            public static extern void VDPAUUnmapSurfaces(Int32 numSurface, IntPtr[] surfaces);

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAUUnmapSurfacesNV")]
            public static extern void VDPAUUnmapSurfaces(Int32 numSurface, ref IntPtr surfaces);

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAUUnmapSurfacesNV")]
            public static extern unsafe void VDPAUUnmapSurfaces(Int32 numSurface, IntPtr* surfaces);

            /// <summary>[requires: NV_vdpau_interop]</summary>
            [AutoGenerated(Category = "NV_vdpau_interop", Version = "", EntryPoint = "glVDPAUUnregisterSurfaceNV")]
            public static extern void VDPAUUnregisterSurface(IntPtr surface);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertex2hNV")]
            public static extern void Vertex2h(Half x, Half y);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertex2hvNV")]
            public static extern void Vertex2h(Half[] v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertex2hvNV")]
            public static extern void Vertex2h(ref Half v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertex2hvNV")]
            public static extern unsafe void Vertex2h(Half* v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertex3hNV")]
            public static extern void Vertex3h(Half x, Half y, Half z);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertex3hvNV")]
            public static extern void Vertex3h(Half[] v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertex3hvNV")]
            public static extern void Vertex3h(ref Half v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertex3hvNV")]
            public static extern unsafe void Vertex3h(Half* v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertex4hNV")]
            public static extern void Vertex4h(Half x, Half y, Half z, Half w);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertex4hvNV")]
            public static extern void Vertex4h(Half[] v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertex4hvNV")]
            public static extern void Vertex4h(ref Half v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertex4hvNV")]
            public static extern unsafe void Vertex4h(Half* v);

            /// <summary>[requires: NV_vertex_array_range]</summary>
            [AutoGenerated(Category = "NV_vertex_array_range", Version = "", EntryPoint = "glVertexArrayRangeNV")]
            public static extern void VertexArrayRange(Int32 length, IntPtr pointer);

            /// <summary>[requires: NV_vertex_array_range]</summary>
            [AutoGenerated(Category = "NV_vertex_array_range", Version = "", EntryPoint = "glVertexArrayRangeNV")]
            public static extern void VertexArrayRange<T1>(Int32 length, [InAttribute, OutAttribute] T1[] pointer)
                where T1 : struct
            ;

            /// <summary>[requires: NV_vertex_array_range]</summary>
            [AutoGenerated(Category = "NV_vertex_array_range", Version = "", EntryPoint = "glVertexArrayRangeNV")]
            public static extern void VertexArrayRange<T1>(Int32 length, [InAttribute, OutAttribute] T1[,] pointer)
                where T1 : struct
            ;

            /// <summary>[requires: NV_vertex_array_range]</summary>
            [AutoGenerated(Category = "NV_vertex_array_range", Version = "", EntryPoint = "glVertexArrayRangeNV")]
            public static extern void VertexArrayRange<T1>(Int32 length, [InAttribute, OutAttribute] T1[,,] pointer)
                where T1 : struct
            ;

            /// <summary>[requires: NV_vertex_array_range]</summary>
            [AutoGenerated(Category = "NV_vertex_array_range", Version = "", EntryPoint = "glVertexArrayRangeNV")]
            public static extern void VertexArrayRange<T1>(Int32 length, [InAttribute, OutAttribute] ref T1 pointer)
                where T1 : struct
            ;

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib1dNV")]
            public static extern void VertexAttrib1(Int32 index, Double x);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib1dNV")]
            public static extern void VertexAttrib1(UInt32 index, Double x);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib1dvNV")]
            public static extern unsafe void VertexAttrib1(Int32 index, Double* v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib1dvNV")]
            public static extern unsafe void VertexAttrib1(UInt32 index, Double* v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib1fNV")]
            public static extern void VertexAttrib1(Int32 index, Single x);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib1fNV")]
            public static extern void VertexAttrib1(UInt32 index, Single x);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib1fvNV")]
            public static extern unsafe void VertexAttrib1(Int32 index, Single* v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib1fvNV")]
            public static extern unsafe void VertexAttrib1(UInt32 index, Single* v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttrib1hNV")]
            public static extern void VertexAttrib1h(Int32 index, Half x);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttrib1hNV")]
            public static extern void VertexAttrib1h(UInt32 index, Half x);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttrib1hvNV")]
            public static extern unsafe void VertexAttrib1h(Int32 index, Half* v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttrib1hvNV")]
            public static extern unsafe void VertexAttrib1h(UInt32 index, Half* v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib1sNV")]
            public static extern void VertexAttrib1(Int32 index, Int16 x);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib1sNV")]
            public static extern void VertexAttrib1(UInt32 index, Int16 x);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib1svNV")]
            public static extern unsafe void VertexAttrib1(Int32 index, Int16* v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib1svNV")]
            public static extern unsafe void VertexAttrib1(UInt32 index, Int16* v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib2dNV")]
            public static extern void VertexAttrib2(Int32 index, Double x, Double y);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib2dNV")]
            public static extern void VertexAttrib2(UInt32 index, Double x, Double y);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib2dvNV")]
            public static extern void VertexAttrib2(Int32 index, Double[] v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib2dvNV")]
            public static extern void VertexAttrib2(Int32 index, ref Double v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib2dvNV")]
            public static extern unsafe void VertexAttrib2(Int32 index, Double* v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib2dvNV")]
            public static extern void VertexAttrib2(UInt32 index, Double[] v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib2dvNV")]
            public static extern void VertexAttrib2(UInt32 index, ref Double v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib2dvNV")]
            public static extern unsafe void VertexAttrib2(UInt32 index, Double* v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib2fNV")]
            public static extern void VertexAttrib2(Int32 index, Single x, Single y);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib2fNV")]
            public static extern void VertexAttrib2(UInt32 index, Single x, Single y);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib2fvNV")]
            public static extern void VertexAttrib2(Int32 index, Single[] v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib2fvNV")]
            public static extern void VertexAttrib2(Int32 index, ref Single v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib2fvNV")]
            public static extern unsafe void VertexAttrib2(Int32 index, Single* v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib2fvNV")]
            public static extern void VertexAttrib2(UInt32 index, Single[] v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib2fvNV")]
            public static extern void VertexAttrib2(UInt32 index, ref Single v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib2fvNV")]
            public static extern unsafe void VertexAttrib2(UInt32 index, Single* v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttrib2hNV")]
            public static extern void VertexAttrib2h(Int32 index, Half x, Half y);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttrib2hNV")]
            public static extern void VertexAttrib2h(UInt32 index, Half x, Half y);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttrib2hvNV")]
            public static extern void VertexAttrib2h(Int32 index, Half[] v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttrib2hvNV")]
            public static extern void VertexAttrib2h(Int32 index, ref Half v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttrib2hvNV")]
            public static extern unsafe void VertexAttrib2h(Int32 index, Half* v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttrib2hvNV")]
            public static extern void VertexAttrib2h(UInt32 index, Half[] v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttrib2hvNV")]
            public static extern void VertexAttrib2h(UInt32 index, ref Half v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttrib2hvNV")]
            public static extern unsafe void VertexAttrib2h(UInt32 index, Half* v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib2sNV")]
            public static extern void VertexAttrib2(Int32 index, Int16 x, Int16 y);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib2sNV")]
            public static extern void VertexAttrib2(UInt32 index, Int16 x, Int16 y);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib2svNV")]
            public static extern void VertexAttrib2(Int32 index, Int16[] v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib2svNV")]
            public static extern void VertexAttrib2(Int32 index, ref Int16 v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib2svNV")]
            public static extern unsafe void VertexAttrib2(Int32 index, Int16* v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib2svNV")]
            public static extern void VertexAttrib2(UInt32 index, Int16[] v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib2svNV")]
            public static extern void VertexAttrib2(UInt32 index, ref Int16 v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib2svNV")]
            public static extern unsafe void VertexAttrib2(UInt32 index, Int16* v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib3dNV")]
            public static extern void VertexAttrib3(Int32 index, Double x, Double y, Double z);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib3dNV")]
            public static extern void VertexAttrib3(UInt32 index, Double x, Double y, Double z);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib3dvNV")]
            public static extern void VertexAttrib3(Int32 index, Double[] v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib3dvNV")]
            public static extern void VertexAttrib3(Int32 index, ref Double v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib3dvNV")]
            public static extern unsafe void VertexAttrib3(Int32 index, Double* v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib3dvNV")]
            public static extern void VertexAttrib3(UInt32 index, Double[] v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib3dvNV")]
            public static extern void VertexAttrib3(UInt32 index, ref Double v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib3dvNV")]
            public static extern unsafe void VertexAttrib3(UInt32 index, Double* v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib3fNV")]
            public static extern void VertexAttrib3(Int32 index, Single x, Single y, Single z);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib3fNV")]
            public static extern void VertexAttrib3(UInt32 index, Single x, Single y, Single z);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib3fvNV")]
            public static extern void VertexAttrib3(Int32 index, Single[] v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib3fvNV")]
            public static extern void VertexAttrib3(Int32 index, ref Single v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib3fvNV")]
            public static extern unsafe void VertexAttrib3(Int32 index, Single* v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib3fvNV")]
            public static extern void VertexAttrib3(UInt32 index, Single[] v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib3fvNV")]
            public static extern void VertexAttrib3(UInt32 index, ref Single v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib3fvNV")]
            public static extern unsafe void VertexAttrib3(UInt32 index, Single* v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttrib3hNV")]
            public static extern void VertexAttrib3h(Int32 index, Half x, Half y, Half z);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttrib3hNV")]
            public static extern void VertexAttrib3h(UInt32 index, Half x, Half y, Half z);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttrib3hvNV")]
            public static extern void VertexAttrib3h(Int32 index, Half[] v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttrib3hvNV")]
            public static extern void VertexAttrib3h(Int32 index, ref Half v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttrib3hvNV")]
            public static extern unsafe void VertexAttrib3h(Int32 index, Half* v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttrib3hvNV")]
            public static extern void VertexAttrib3h(UInt32 index, Half[] v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttrib3hvNV")]
            public static extern void VertexAttrib3h(UInt32 index, ref Half v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttrib3hvNV")]
            public static extern unsafe void VertexAttrib3h(UInt32 index, Half* v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib3sNV")]
            public static extern void VertexAttrib3(Int32 index, Int16 x, Int16 y, Int16 z);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib3sNV")]
            public static extern void VertexAttrib3(UInt32 index, Int16 x, Int16 y, Int16 z);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib3svNV")]
            public static extern void VertexAttrib3(Int32 index, Int16[] v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib3svNV")]
            public static extern void VertexAttrib3(Int32 index, ref Int16 v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib3svNV")]
            public static extern unsafe void VertexAttrib3(Int32 index, Int16* v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib3svNV")]
            public static extern void VertexAttrib3(UInt32 index, Int16[] v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib3svNV")]
            public static extern void VertexAttrib3(UInt32 index, ref Int16 v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib3svNV")]
            public static extern unsafe void VertexAttrib3(UInt32 index, Int16* v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib4dNV")]
            public static extern void VertexAttrib4(Int32 index, Double x, Double y, Double z, Double w);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib4dNV")]
            public static extern void VertexAttrib4(UInt32 index, Double x, Double y, Double z, Double w);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib4dvNV")]
            public static extern void VertexAttrib4(Int32 index, Double[] v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib4dvNV")]
            public static extern void VertexAttrib4(Int32 index, ref Double v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib4dvNV")]
            public static extern unsafe void VertexAttrib4(Int32 index, Double* v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib4dvNV")]
            public static extern void VertexAttrib4(UInt32 index, Double[] v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib4dvNV")]
            public static extern void VertexAttrib4(UInt32 index, ref Double v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib4dvNV")]
            public static extern unsafe void VertexAttrib4(UInt32 index, Double* v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib4fNV")]
            public static extern void VertexAttrib4(Int32 index, Single x, Single y, Single z, Single w);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib4fNV")]
            public static extern void VertexAttrib4(UInt32 index, Single x, Single y, Single z, Single w);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib4fvNV")]
            public static extern void VertexAttrib4(Int32 index, Single[] v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib4fvNV")]
            public static extern void VertexAttrib4(Int32 index, ref Single v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib4fvNV")]
            public static extern unsafe void VertexAttrib4(Int32 index, Single* v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib4fvNV")]
            public static extern void VertexAttrib4(UInt32 index, Single[] v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib4fvNV")]
            public static extern void VertexAttrib4(UInt32 index, ref Single v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib4fvNV")]
            public static extern unsafe void VertexAttrib4(UInt32 index, Single* v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttrib4hNV")]
            public static extern void VertexAttrib4h(Int32 index, Half x, Half y, Half z, Half w);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttrib4hNV")]
            public static extern void VertexAttrib4h(UInt32 index, Half x, Half y, Half z, Half w);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttrib4hvNV")]
            public static extern void VertexAttrib4h(Int32 index, Half[] v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttrib4hvNV")]
            public static extern void VertexAttrib4h(Int32 index, ref Half v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttrib4hvNV")]
            public static extern unsafe void VertexAttrib4h(Int32 index, Half* v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttrib4hvNV")]
            public static extern void VertexAttrib4h(UInt32 index, Half[] v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttrib4hvNV")]
            public static extern void VertexAttrib4h(UInt32 index, ref Half v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttrib4hvNV")]
            public static extern unsafe void VertexAttrib4h(UInt32 index, Half* v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib4sNV")]
            public static extern void VertexAttrib4(Int32 index, Int16 x, Int16 y, Int16 z, Int16 w);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib4sNV")]
            public static extern void VertexAttrib4(UInt32 index, Int16 x, Int16 y, Int16 z, Int16 w);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib4svNV")]
            public static extern void VertexAttrib4(Int32 index, Int16[] v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib4svNV")]
            public static extern void VertexAttrib4(Int32 index, ref Int16 v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib4svNV")]
            public static extern unsafe void VertexAttrib4(Int32 index, Int16* v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib4svNV")]
            public static extern void VertexAttrib4(UInt32 index, Int16[] v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib4svNV")]
            public static extern void VertexAttrib4(UInt32 index, ref Int16 v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib4svNV")]
            public static extern unsafe void VertexAttrib4(UInt32 index, Int16* v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib4ubNV")]
            public static extern void VertexAttrib4(Int32 index, Byte x, Byte y, Byte z, Byte w);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib4ubNV")]
            public static extern void VertexAttrib4(UInt32 index, Byte x, Byte y, Byte z, Byte w);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib4ubvNV")]
            public static extern void VertexAttrib4(Int32 index, Byte[] v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib4ubvNV")]
            public static extern void VertexAttrib4(Int32 index, ref Byte v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib4ubvNV")]
            public static extern unsafe void VertexAttrib4(Int32 index, Byte* v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib4ubvNV")]
            public static extern void VertexAttrib4(UInt32 index, Byte[] v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib4ubvNV")]
            public static extern void VertexAttrib4(UInt32 index, ref Byte v);

            /// <summary>[requires: NV_vertex_program]
            /// Specifies the value of a generic vertex attribute
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="v0">
            /// <para>
            /// For the scalar commands, specifies the new values to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            /// <param name="v">
            /// <para>
            /// For the vector commands (glVertexAttrib*v), specifies a pointer to an array of values to be used for the generic vertex attribute.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// For the packed commands (glVertexAttribP*), specified the type of packing used on the data. This parameter must be GL_INT_2_10_10_10_REV or GL_UNSIGNED_INT_2_10_10_10_REV, to specify signed or unsigned data, respectively, or GL_UNSIGNED_INT_10F_11F_11F_REV to specify floating point data.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For the packed commands, if GL_TRUE, then the values are to be converted to floating point values by normalizing. Otherwise, they are converted directly to floating-point values. If type indicates a floating-pont format, then normalized value must be GL_FALSE.
            /// </para>
            /// </param>
            /// <param name="value">
            /// <para>
            /// For the packed commands, specifies the new packed value to be used for the specified vertex attribute.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttrib4ubvNV")]
            public static extern unsafe void VertexAttrib4(UInt32 index, Byte* v);

            /// <summary>[requires: NV_vertex_buffer_unified_memory]
            /// Specify the organization of vertex arrays
            /// </summary>
            /// <param name="attribindex">
            /// <para>
            /// The generic vertex attribute array being described.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// The number of values per vertex that are stored in the array.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the data stored in the array.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// The distance between elements within the buffer.
            /// </para>
            /// </param>
            /// <param name="relativeoffset">
            /// <para>
            /// The distance between elements within the buffer.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_buffer_unified_memory", Version = "", EntryPoint = "glVertexAttribFormatNV")]
            public static extern void VertexAttribFormat(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.NvVertexBufferUnifiedMemory type, bool normalized, Int32 stride);

            /// <summary>[requires: NV_vertex_buffer_unified_memory]
            /// Specify the organization of vertex arrays
            /// </summary>
            /// <param name="attribindex">
            /// <para>
            /// The generic vertex attribute array being described.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// The number of values per vertex that are stored in the array.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the data stored in the array.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// The distance between elements within the buffer.
            /// </para>
            /// </param>
            /// <param name="relativeoffset">
            /// <para>
            /// The distance between elements within the buffer.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_buffer_unified_memory", Version = "", EntryPoint = "glVertexAttribFormatNV")]
            public static extern void VertexAttribFormat(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.NvVertexBufferUnifiedMemory type, bool normalized, Int32 stride);

            /// <summary>[requires: NV_vertex_buffer_unified_memory]</summary>
            [AutoGenerated(Category = "NV_vertex_buffer_unified_memory", Version = "", EntryPoint = "glVertexAttribIFormatNV")]
            public static extern void VertexAttribIFormat(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.NvVertexBufferUnifiedMemory type, Int32 stride);

            /// <summary>[requires: NV_vertex_buffer_unified_memory]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_buffer_unified_memory", Version = "", EntryPoint = "glVertexAttribIFormatNV")]
            public static extern void VertexAttribIFormat(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.NvVertexBufferUnifiedMemory type, Int32 stride);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL1i64NV")]
            public static extern void VertexAttribL1(Int32 index, Int64 x);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL1i64NV")]
            public static extern void VertexAttribL1(UInt32 index, Int64 x);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL1i64vNV")]
            public static extern unsafe void VertexAttribL1(Int32 index, Int64* v);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL1i64vNV")]
            public static extern unsafe void VertexAttribL1(UInt32 index, Int64* v);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL1ui64NV")]
            public static extern void VertexAttribL1(UInt32 index, UInt64 x);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL1ui64vNV")]
            public static extern unsafe void VertexAttribL1(UInt32 index, UInt64* v);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL2i64NV")]
            public static extern void VertexAttribL2(Int32 index, Int64 x, Int64 y);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL2i64NV")]
            public static extern void VertexAttribL2(UInt32 index, Int64 x, Int64 y);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL2i64vNV")]
            public static extern void VertexAttribL2(Int32 index, Int64[] v);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL2i64vNV")]
            public static extern void VertexAttribL2(Int32 index, ref Int64 v);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL2i64vNV")]
            public static extern unsafe void VertexAttribL2(Int32 index, Int64* v);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL2i64vNV")]
            public static extern void VertexAttribL2(UInt32 index, Int64[] v);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL2i64vNV")]
            public static extern void VertexAttribL2(UInt32 index, ref Int64 v);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL2i64vNV")]
            public static extern unsafe void VertexAttribL2(UInt32 index, Int64* v);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL2ui64NV")]
            public static extern void VertexAttribL2(UInt32 index, UInt64 x, UInt64 y);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL2ui64vNV")]
            public static extern void VertexAttribL2(UInt32 index, UInt64[] v);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL2ui64vNV")]
            public static extern void VertexAttribL2(UInt32 index, ref UInt64 v);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL2ui64vNV")]
            public static extern unsafe void VertexAttribL2(UInt32 index, UInt64* v);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL3i64NV")]
            public static extern void VertexAttribL3(Int32 index, Int64 x, Int64 y, Int64 z);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL3i64NV")]
            public static extern void VertexAttribL3(UInt32 index, Int64 x, Int64 y, Int64 z);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL3i64vNV")]
            public static extern void VertexAttribL3(Int32 index, Int64[] v);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL3i64vNV")]
            public static extern void VertexAttribL3(Int32 index, ref Int64 v);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL3i64vNV")]
            public static extern unsafe void VertexAttribL3(Int32 index, Int64* v);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL3i64vNV")]
            public static extern void VertexAttribL3(UInt32 index, Int64[] v);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL3i64vNV")]
            public static extern void VertexAttribL3(UInt32 index, ref Int64 v);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL3i64vNV")]
            public static extern unsafe void VertexAttribL3(UInt32 index, Int64* v);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL3ui64NV")]
            public static extern void VertexAttribL3(UInt32 index, UInt64 x, UInt64 y, UInt64 z);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL3ui64vNV")]
            public static extern void VertexAttribL3(UInt32 index, UInt64[] v);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL3ui64vNV")]
            public static extern void VertexAttribL3(UInt32 index, ref UInt64 v);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL3ui64vNV")]
            public static extern unsafe void VertexAttribL3(UInt32 index, UInt64* v);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL4i64NV")]
            public static extern void VertexAttribL4(Int32 index, Int64 x, Int64 y, Int64 z, Int64 w);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL4i64NV")]
            public static extern void VertexAttribL4(UInt32 index, Int64 x, Int64 y, Int64 z, Int64 w);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL4i64vNV")]
            public static extern void VertexAttribL4(Int32 index, Int64[] v);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL4i64vNV")]
            public static extern void VertexAttribL4(Int32 index, ref Int64 v);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL4i64vNV")]
            public static extern unsafe void VertexAttribL4(Int32 index, Int64* v);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL4i64vNV")]
            public static extern void VertexAttribL4(UInt32 index, Int64[] v);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL4i64vNV")]
            public static extern void VertexAttribL4(UInt32 index, ref Int64 v);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL4i64vNV")]
            public static extern unsafe void VertexAttribL4(UInt32 index, Int64* v);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL4ui64NV")]
            public static extern void VertexAttribL4(UInt32 index, UInt64 x, UInt64 y, UInt64 z, UInt64 w);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL4ui64vNV")]
            public static extern void VertexAttribL4(UInt32 index, UInt64[] v);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL4ui64vNV")]
            public static extern void VertexAttribL4(UInt32 index, ref UInt64 v);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribL4ui64vNV")]
            public static extern unsafe void VertexAttribL4(UInt32 index, UInt64* v);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribLFormatNV")]
            public static extern void VertexAttribLFormat(Int32 index, Int32 size, OpenTK.Graphics.OpenGL.NvVertexAttribInteger64bit type, Int32 stride);

            /// <summary>[requires: NV_vertex_attrib_integer_64bit]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_attrib_integer_64bit", Version = "", EntryPoint = "glVertexAttribLFormatNV")]
            public static extern void VertexAttribLFormat(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.NvVertexAttribInteger64bit type, Int32 stride);

            /// <summary>[requires: NV_vertex_program]
            /// Define an array of generic vertex attribute data
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Specifies the number of components per generic vertex attribute. Must be 1, 2, 3, 4. Additionally, the symbolic constant GL_BGRA is accepted by glVertexAttribPointer. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each component in the array. The symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, and GL_UNSIGNED_INT are accepted by glVertexAttribPointer and glVertexAttribIPointer. Additionally GL_HALF_FLOAT, GL_FLOAT, GL_DOUBLE, GL_FIXED, GL_INT_2_10_10_10_REV, GL_UNSIGNED_INT_2_10_10_10_REV and GL_UNSIGNED_INT_10F_11F_11F_REV are accepted by glVertexAttribPointer. GL_DOUBLE is also accepted by glVertexAttribLPointer and is the only token accepted by the type parameter for that function. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For glVertexAttribPointer, specifies whether fixed-point data values should be normalized (GL_TRUE) or converted directly as fixed-point values (GL_FALSE) when they are accessed.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive generic vertex attributes. If stride is 0, the generic vertex attributes are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a offset of the first component of the first generic vertex attribute in the array in the data store of the buffer currently bound to the GL_ARRAY_BUFFER target. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribPointerNV")]
            public static extern void VertexAttribPointer(Int32 index, Int32 fsize, OpenTK.Graphics.OpenGL.VertexAttribParameterArb type, Int32 stride, IntPtr pointer);

            /// <summary>[requires: NV_vertex_program]
            /// Define an array of generic vertex attribute data
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Specifies the number of components per generic vertex attribute. Must be 1, 2, 3, 4. Additionally, the symbolic constant GL_BGRA is accepted by glVertexAttribPointer. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each component in the array. The symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, and GL_UNSIGNED_INT are accepted by glVertexAttribPointer and glVertexAttribIPointer. Additionally GL_HALF_FLOAT, GL_FLOAT, GL_DOUBLE, GL_FIXED, GL_INT_2_10_10_10_REV, GL_UNSIGNED_INT_2_10_10_10_REV and GL_UNSIGNED_INT_10F_11F_11F_REV are accepted by glVertexAttribPointer. GL_DOUBLE is also accepted by glVertexAttribLPointer and is the only token accepted by the type parameter for that function. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For glVertexAttribPointer, specifies whether fixed-point data values should be normalized (GL_TRUE) or converted directly as fixed-point values (GL_FALSE) when they are accessed.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive generic vertex attributes. If stride is 0, the generic vertex attributes are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a offset of the first component of the first generic vertex attribute in the array in the data store of the buffer currently bound to the GL_ARRAY_BUFFER target. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribPointerNV")]
            public static extern void VertexAttribPointer<T4>(Int32 index, Int32 fsize, OpenTK.Graphics.OpenGL.VertexAttribParameterArb type, Int32 stride, [InAttribute, OutAttribute] T4[] pointer)
                where T4 : struct
            ;

            /// <summary>[requires: NV_vertex_program]
            /// Define an array of generic vertex attribute data
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Specifies the number of components per generic vertex attribute. Must be 1, 2, 3, 4. Additionally, the symbolic constant GL_BGRA is accepted by glVertexAttribPointer. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each component in the array. The symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, and GL_UNSIGNED_INT are accepted by glVertexAttribPointer and glVertexAttribIPointer. Additionally GL_HALF_FLOAT, GL_FLOAT, GL_DOUBLE, GL_FIXED, GL_INT_2_10_10_10_REV, GL_UNSIGNED_INT_2_10_10_10_REV and GL_UNSIGNED_INT_10F_11F_11F_REV are accepted by glVertexAttribPointer. GL_DOUBLE is also accepted by glVertexAttribLPointer and is the only token accepted by the type parameter for that function. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For glVertexAttribPointer, specifies whether fixed-point data values should be normalized (GL_TRUE) or converted directly as fixed-point values (GL_FALSE) when they are accessed.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive generic vertex attributes. If stride is 0, the generic vertex attributes are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a offset of the first component of the first generic vertex attribute in the array in the data store of the buffer currently bound to the GL_ARRAY_BUFFER target. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribPointerNV")]
            public static extern void VertexAttribPointer<T4>(Int32 index, Int32 fsize, OpenTK.Graphics.OpenGL.VertexAttribParameterArb type, Int32 stride, [InAttribute, OutAttribute] T4[,] pointer)
                where T4 : struct
            ;

            /// <summary>[requires: NV_vertex_program]
            /// Define an array of generic vertex attribute data
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Specifies the number of components per generic vertex attribute. Must be 1, 2, 3, 4. Additionally, the symbolic constant GL_BGRA is accepted by glVertexAttribPointer. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each component in the array. The symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, and GL_UNSIGNED_INT are accepted by glVertexAttribPointer and glVertexAttribIPointer. Additionally GL_HALF_FLOAT, GL_FLOAT, GL_DOUBLE, GL_FIXED, GL_INT_2_10_10_10_REV, GL_UNSIGNED_INT_2_10_10_10_REV and GL_UNSIGNED_INT_10F_11F_11F_REV are accepted by glVertexAttribPointer. GL_DOUBLE is also accepted by glVertexAttribLPointer and is the only token accepted by the type parameter for that function. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For glVertexAttribPointer, specifies whether fixed-point data values should be normalized (GL_TRUE) or converted directly as fixed-point values (GL_FALSE) when they are accessed.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive generic vertex attributes. If stride is 0, the generic vertex attributes are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a offset of the first component of the first generic vertex attribute in the array in the data store of the buffer currently bound to the GL_ARRAY_BUFFER target. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribPointerNV")]
            public static extern void VertexAttribPointer<T4>(Int32 index, Int32 fsize, OpenTK.Graphics.OpenGL.VertexAttribParameterArb type, Int32 stride, [InAttribute, OutAttribute] T4[,,] pointer)
                where T4 : struct
            ;

            /// <summary>[requires: NV_vertex_program]
            /// Define an array of generic vertex attribute data
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Specifies the number of components per generic vertex attribute. Must be 1, 2, 3, 4. Additionally, the symbolic constant GL_BGRA is accepted by glVertexAttribPointer. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each component in the array. The symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, and GL_UNSIGNED_INT are accepted by glVertexAttribPointer and glVertexAttribIPointer. Additionally GL_HALF_FLOAT, GL_FLOAT, GL_DOUBLE, GL_FIXED, GL_INT_2_10_10_10_REV, GL_UNSIGNED_INT_2_10_10_10_REV and GL_UNSIGNED_INT_10F_11F_11F_REV are accepted by glVertexAttribPointer. GL_DOUBLE is also accepted by glVertexAttribLPointer and is the only token accepted by the type parameter for that function. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For glVertexAttribPointer, specifies whether fixed-point data values should be normalized (GL_TRUE) or converted directly as fixed-point values (GL_FALSE) when they are accessed.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive generic vertex attributes. If stride is 0, the generic vertex attributes are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a offset of the first component of the first generic vertex attribute in the array in the data store of the buffer currently bound to the GL_ARRAY_BUFFER target. The initial value is 0.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribPointerNV")]
            public static extern void VertexAttribPointer<T4>(Int32 index, Int32 fsize, OpenTK.Graphics.OpenGL.VertexAttribParameterArb type, Int32 stride, [InAttribute, OutAttribute] ref T4 pointer)
                where T4 : struct
            ;

            /// <summary>[requires: NV_vertex_program]
            /// Define an array of generic vertex attribute data
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Specifies the number of components per generic vertex attribute. Must be 1, 2, 3, 4. Additionally, the symbolic constant GL_BGRA is accepted by glVertexAttribPointer. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each component in the array. The symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, and GL_UNSIGNED_INT are accepted by glVertexAttribPointer and glVertexAttribIPointer. Additionally GL_HALF_FLOAT, GL_FLOAT, GL_DOUBLE, GL_FIXED, GL_INT_2_10_10_10_REV, GL_UNSIGNED_INT_2_10_10_10_REV and GL_UNSIGNED_INT_10F_11F_11F_REV are accepted by glVertexAttribPointer. GL_DOUBLE is also accepted by glVertexAttribLPointer and is the only token accepted by the type parameter for that function. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For glVertexAttribPointer, specifies whether fixed-point data values should be normalized (GL_TRUE) or converted directly as fixed-point values (GL_FALSE) when they are accessed.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive generic vertex attributes. If stride is 0, the generic vertex attributes are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a offset of the first component of the first generic vertex attribute in the array in the data store of the buffer currently bound to the GL_ARRAY_BUFFER target. The initial value is 0.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribPointerNV")]
            public static extern void VertexAttribPointer(UInt32 index, Int32 fsize, OpenTK.Graphics.OpenGL.VertexAttribParameterArb type, Int32 stride, IntPtr pointer);

            /// <summary>[requires: NV_vertex_program]
            /// Define an array of generic vertex attribute data
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Specifies the number of components per generic vertex attribute. Must be 1, 2, 3, 4. Additionally, the symbolic constant GL_BGRA is accepted by glVertexAttribPointer. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each component in the array. The symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, and GL_UNSIGNED_INT are accepted by glVertexAttribPointer and glVertexAttribIPointer. Additionally GL_HALF_FLOAT, GL_FLOAT, GL_DOUBLE, GL_FIXED, GL_INT_2_10_10_10_REV, GL_UNSIGNED_INT_2_10_10_10_REV and GL_UNSIGNED_INT_10F_11F_11F_REV are accepted by glVertexAttribPointer. GL_DOUBLE is also accepted by glVertexAttribLPointer and is the only token accepted by the type parameter for that function. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For glVertexAttribPointer, specifies whether fixed-point data values should be normalized (GL_TRUE) or converted directly as fixed-point values (GL_FALSE) when they are accessed.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive generic vertex attributes. If stride is 0, the generic vertex attributes are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a offset of the first component of the first generic vertex attribute in the array in the data store of the buffer currently bound to the GL_ARRAY_BUFFER target. The initial value is 0.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribPointerNV")]
            public static extern void VertexAttribPointer<T4>(UInt32 index, Int32 fsize, OpenTK.Graphics.OpenGL.VertexAttribParameterArb type, Int32 stride, [InAttribute, OutAttribute] T4[] pointer)
                where T4 : struct
            ;

            /// <summary>[requires: NV_vertex_program]
            /// Define an array of generic vertex attribute data
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Specifies the number of components per generic vertex attribute. Must be 1, 2, 3, 4. Additionally, the symbolic constant GL_BGRA is accepted by glVertexAttribPointer. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each component in the array. The symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, and GL_UNSIGNED_INT are accepted by glVertexAttribPointer and glVertexAttribIPointer. Additionally GL_HALF_FLOAT, GL_FLOAT, GL_DOUBLE, GL_FIXED, GL_INT_2_10_10_10_REV, GL_UNSIGNED_INT_2_10_10_10_REV and GL_UNSIGNED_INT_10F_11F_11F_REV are accepted by glVertexAttribPointer. GL_DOUBLE is also accepted by glVertexAttribLPointer and is the only token accepted by the type parameter for that function. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For glVertexAttribPointer, specifies whether fixed-point data values should be normalized (GL_TRUE) or converted directly as fixed-point values (GL_FALSE) when they are accessed.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive generic vertex attributes. If stride is 0, the generic vertex attributes are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a offset of the first component of the first generic vertex attribute in the array in the data store of the buffer currently bound to the GL_ARRAY_BUFFER target. The initial value is 0.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribPointerNV")]
            public static extern void VertexAttribPointer<T4>(UInt32 index, Int32 fsize, OpenTK.Graphics.OpenGL.VertexAttribParameterArb type, Int32 stride, [InAttribute, OutAttribute] T4[,] pointer)
                where T4 : struct
            ;

            /// <summary>[requires: NV_vertex_program]
            /// Define an array of generic vertex attribute data
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Specifies the number of components per generic vertex attribute. Must be 1, 2, 3, 4. Additionally, the symbolic constant GL_BGRA is accepted by glVertexAttribPointer. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each component in the array. The symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, and GL_UNSIGNED_INT are accepted by glVertexAttribPointer and glVertexAttribIPointer. Additionally GL_HALF_FLOAT, GL_FLOAT, GL_DOUBLE, GL_FIXED, GL_INT_2_10_10_10_REV, GL_UNSIGNED_INT_2_10_10_10_REV and GL_UNSIGNED_INT_10F_11F_11F_REV are accepted by glVertexAttribPointer. GL_DOUBLE is also accepted by glVertexAttribLPointer and is the only token accepted by the type parameter for that function. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For glVertexAttribPointer, specifies whether fixed-point data values should be normalized (GL_TRUE) or converted directly as fixed-point values (GL_FALSE) when they are accessed.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive generic vertex attributes. If stride is 0, the generic vertex attributes are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a offset of the first component of the first generic vertex attribute in the array in the data store of the buffer currently bound to the GL_ARRAY_BUFFER target. The initial value is 0.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribPointerNV")]
            public static extern void VertexAttribPointer<T4>(UInt32 index, Int32 fsize, OpenTK.Graphics.OpenGL.VertexAttribParameterArb type, Int32 stride, [InAttribute, OutAttribute] T4[,,] pointer)
                where T4 : struct
            ;

            /// <summary>[requires: NV_vertex_program]
            /// Define an array of generic vertex attribute data
            /// </summary>
            /// <param name="index">
            /// <para>
            /// Specifies the index of the generic vertex attribute to be modified.
            /// </para>
            /// </param>
            /// <param name="size">
            /// <para>
            /// Specifies the number of components per generic vertex attribute. Must be 1, 2, 3, 4. Additionally, the symbolic constant GL_BGRA is accepted by glVertexAttribPointer. The initial value is 4.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// Specifies the data type of each component in the array. The symbolic constants GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, and GL_UNSIGNED_INT are accepted by glVertexAttribPointer and glVertexAttribIPointer. Additionally GL_HALF_FLOAT, GL_FLOAT, GL_DOUBLE, GL_FIXED, GL_INT_2_10_10_10_REV, GL_UNSIGNED_INT_2_10_10_10_REV and GL_UNSIGNED_INT_10F_11F_11F_REV are accepted by glVertexAttribPointer. GL_DOUBLE is also accepted by glVertexAttribLPointer and is the only token accepted by the type parameter for that function. The initial value is GL_FLOAT.
            /// </para>
            /// </param>
            /// <param name="normalized">
            /// <para>
            /// For glVertexAttribPointer, specifies whether fixed-point data values should be normalized (GL_TRUE) or converted directly as fixed-point values (GL_FALSE) when they are accessed.
            /// </para>
            /// </param>
            /// <param name="stride">
            /// <para>
            /// Specifies the byte offset between consecutive generic vertex attributes. If stride is 0, the generic vertex attributes are understood to be tightly packed in the array. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="pointer">
            /// <para>
            /// Specifies a offset of the first component of the first generic vertex attribute in the array in the data store of the buffer currently bound to the GL_ARRAY_BUFFER target. The initial value is 0.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribPointerNV")]
            public static extern void VertexAttribPointer<T4>(UInt32 index, Int32 fsize, OpenTK.Graphics.OpenGL.VertexAttribParameterArb type, Int32 stride, [InAttribute, OutAttribute] ref T4 pointer)
                where T4 : struct
            ;

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs1dvNV")]
            public static extern void VertexAttribs1(Int32 index, Int32 count, Double[] v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs1dvNV")]
            public static extern void VertexAttribs1(Int32 index, Int32 count, ref Double v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs1dvNV")]
            public static extern unsafe void VertexAttribs1(Int32 index, Int32 count, Double* v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs1dvNV")]
            public static extern void VertexAttribs1(UInt32 index, Int32 count, Double[] v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs1dvNV")]
            public static extern void VertexAttribs1(UInt32 index, Int32 count, ref Double v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs1dvNV")]
            public static extern unsafe void VertexAttribs1(UInt32 index, Int32 count, Double* v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs1fvNV")]
            public static extern void VertexAttribs1(Int32 index, Int32 count, Single[] v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs1fvNV")]
            public static extern void VertexAttribs1(Int32 index, Int32 count, ref Single v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs1fvNV")]
            public static extern unsafe void VertexAttribs1(Int32 index, Int32 count, Single* v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs1fvNV")]
            public static extern void VertexAttribs1(UInt32 index, Int32 count, Single[] v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs1fvNV")]
            public static extern void VertexAttribs1(UInt32 index, Int32 count, ref Single v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs1fvNV")]
            public static extern unsafe void VertexAttribs1(UInt32 index, Int32 count, Single* v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttribs1hvNV")]
            public static extern void VertexAttribs1h(Int32 index, Int32 n, Half[] v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttribs1hvNV")]
            public static extern void VertexAttribs1h(Int32 index, Int32 n, ref Half v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttribs1hvNV")]
            public static extern unsafe void VertexAttribs1h(Int32 index, Int32 n, Half* v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttribs1hvNV")]
            public static extern void VertexAttribs1h(UInt32 index, Int32 n, Half[] v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttribs1hvNV")]
            public static extern void VertexAttribs1h(UInt32 index, Int32 n, ref Half v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttribs1hvNV")]
            public static extern unsafe void VertexAttribs1h(UInt32 index, Int32 n, Half* v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs1svNV")]
            public static extern void VertexAttribs1(Int32 index, Int32 count, Int16[] v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs1svNV")]
            public static extern void VertexAttribs1(Int32 index, Int32 count, ref Int16 v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs1svNV")]
            public static extern unsafe void VertexAttribs1(Int32 index, Int32 count, Int16* v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs1svNV")]
            public static extern void VertexAttribs1(UInt32 index, Int32 count, Int16[] v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs1svNV")]
            public static extern void VertexAttribs1(UInt32 index, Int32 count, ref Int16 v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs1svNV")]
            public static extern unsafe void VertexAttribs1(UInt32 index, Int32 count, Int16* v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs2dvNV")]
            public static extern void VertexAttribs2(Int32 index, Int32 count, Double[] v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs2dvNV")]
            public static extern void VertexAttribs2(Int32 index, Int32 count, ref Double v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs2dvNV")]
            public static extern unsafe void VertexAttribs2(Int32 index, Int32 count, Double* v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs2dvNV")]
            public static extern void VertexAttribs2(UInt32 index, Int32 count, Double[] v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs2dvNV")]
            public static extern void VertexAttribs2(UInt32 index, Int32 count, ref Double v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs2dvNV")]
            public static extern unsafe void VertexAttribs2(UInt32 index, Int32 count, Double* v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs2fvNV")]
            public static extern void VertexAttribs2(Int32 index, Int32 count, Single[] v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs2fvNV")]
            public static extern void VertexAttribs2(Int32 index, Int32 count, ref Single v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs2fvNV")]
            public static extern unsafe void VertexAttribs2(Int32 index, Int32 count, Single* v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs2fvNV")]
            public static extern void VertexAttribs2(UInt32 index, Int32 count, Single[] v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs2fvNV")]
            public static extern void VertexAttribs2(UInt32 index, Int32 count, ref Single v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs2fvNV")]
            public static extern unsafe void VertexAttribs2(UInt32 index, Int32 count, Single* v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttribs2hvNV")]
            public static extern void VertexAttribs2h(Int32 index, Int32 n, Half[] v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttribs2hvNV")]
            public static extern void VertexAttribs2h(Int32 index, Int32 n, ref Half v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttribs2hvNV")]
            public static extern unsafe void VertexAttribs2h(Int32 index, Int32 n, Half* v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttribs2hvNV")]
            public static extern void VertexAttribs2h(UInt32 index, Int32 n, Half[] v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttribs2hvNV")]
            public static extern void VertexAttribs2h(UInt32 index, Int32 n, ref Half v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttribs2hvNV")]
            public static extern unsafe void VertexAttribs2h(UInt32 index, Int32 n, Half* v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs2svNV")]
            public static extern void VertexAttribs2(Int32 index, Int32 count, Int16[] v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs2svNV")]
            public static extern void VertexAttribs2(Int32 index, Int32 count, ref Int16 v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs2svNV")]
            public static extern unsafe void VertexAttribs2(Int32 index, Int32 count, Int16* v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs2svNV")]
            public static extern void VertexAttribs2(UInt32 index, Int32 count, Int16[] v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs2svNV")]
            public static extern void VertexAttribs2(UInt32 index, Int32 count, ref Int16 v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs2svNV")]
            public static extern unsafe void VertexAttribs2(UInt32 index, Int32 count, Int16* v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs3dvNV")]
            public static extern void VertexAttribs3(Int32 index, Int32 count, Double[] v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs3dvNV")]
            public static extern void VertexAttribs3(Int32 index, Int32 count, ref Double v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs3dvNV")]
            public static extern unsafe void VertexAttribs3(Int32 index, Int32 count, Double* v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs3dvNV")]
            public static extern void VertexAttribs3(UInt32 index, Int32 count, Double[] v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs3dvNV")]
            public static extern void VertexAttribs3(UInt32 index, Int32 count, ref Double v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs3dvNV")]
            public static extern unsafe void VertexAttribs3(UInt32 index, Int32 count, Double* v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs3fvNV")]
            public static extern void VertexAttribs3(Int32 index, Int32 count, Single[] v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs3fvNV")]
            public static extern void VertexAttribs3(Int32 index, Int32 count, ref Single v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs3fvNV")]
            public static extern unsafe void VertexAttribs3(Int32 index, Int32 count, Single* v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs3fvNV")]
            public static extern void VertexAttribs3(UInt32 index, Int32 count, Single[] v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs3fvNV")]
            public static extern void VertexAttribs3(UInt32 index, Int32 count, ref Single v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs3fvNV")]
            public static extern unsafe void VertexAttribs3(UInt32 index, Int32 count, Single* v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttribs3hvNV")]
            public static extern void VertexAttribs3h(Int32 index, Int32 n, Half[] v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttribs3hvNV")]
            public static extern void VertexAttribs3h(Int32 index, Int32 n, ref Half v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttribs3hvNV")]
            public static extern unsafe void VertexAttribs3h(Int32 index, Int32 n, Half* v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttribs3hvNV")]
            public static extern void VertexAttribs3h(UInt32 index, Int32 n, Half[] v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttribs3hvNV")]
            public static extern void VertexAttribs3h(UInt32 index, Int32 n, ref Half v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttribs3hvNV")]
            public static extern unsafe void VertexAttribs3h(UInt32 index, Int32 n, Half* v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs3svNV")]
            public static extern void VertexAttribs3(Int32 index, Int32 count, Int16[] v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs3svNV")]
            public static extern void VertexAttribs3(Int32 index, Int32 count, ref Int16 v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs3svNV")]
            public static extern unsafe void VertexAttribs3(Int32 index, Int32 count, Int16* v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs3svNV")]
            public static extern void VertexAttribs3(UInt32 index, Int32 count, Int16[] v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs3svNV")]
            public static extern void VertexAttribs3(UInt32 index, Int32 count, ref Int16 v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs3svNV")]
            public static extern unsafe void VertexAttribs3(UInt32 index, Int32 count, Int16* v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs4dvNV")]
            public static extern void VertexAttribs4(Int32 index, Int32 count, Double[] v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs4dvNV")]
            public static extern void VertexAttribs4(Int32 index, Int32 count, ref Double v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs4dvNV")]
            public static extern unsafe void VertexAttribs4(Int32 index, Int32 count, Double* v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs4dvNV")]
            public static extern void VertexAttribs4(UInt32 index, Int32 count, Double[] v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs4dvNV")]
            public static extern void VertexAttribs4(UInt32 index, Int32 count, ref Double v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs4dvNV")]
            public static extern unsafe void VertexAttribs4(UInt32 index, Int32 count, Double* v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs4fvNV")]
            public static extern void VertexAttribs4(Int32 index, Int32 count, Single[] v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs4fvNV")]
            public static extern void VertexAttribs4(Int32 index, Int32 count, ref Single v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs4fvNV")]
            public static extern unsafe void VertexAttribs4(Int32 index, Int32 count, Single* v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs4fvNV")]
            public static extern void VertexAttribs4(UInt32 index, Int32 count, Single[] v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs4fvNV")]
            public static extern void VertexAttribs4(UInt32 index, Int32 count, ref Single v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs4fvNV")]
            public static extern unsafe void VertexAttribs4(UInt32 index, Int32 count, Single* v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttribs4hvNV")]
            public static extern void VertexAttribs4h(Int32 index, Int32 n, Half[] v);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttribs4hvNV")]
            public static extern void VertexAttribs4h(Int32 index, Int32 n, ref Half v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttribs4hvNV")]
            public static extern unsafe void VertexAttribs4h(Int32 index, Int32 n, Half* v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttribs4hvNV")]
            public static extern void VertexAttribs4h(UInt32 index, Int32 n, Half[] v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttribs4hvNV")]
            public static extern void VertexAttribs4h(UInt32 index, Int32 n, ref Half v);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexAttribs4hvNV")]
            public static extern unsafe void VertexAttribs4h(UInt32 index, Int32 n, Half* v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs4svNV")]
            public static extern void VertexAttribs4(Int32 index, Int32 count, Int16[] v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs4svNV")]
            public static extern void VertexAttribs4(Int32 index, Int32 count, ref Int16 v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs4svNV")]
            public static extern unsafe void VertexAttribs4(Int32 index, Int32 count, Int16* v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs4svNV")]
            public static extern void VertexAttribs4(UInt32 index, Int32 count, Int16[] v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs4svNV")]
            public static extern void VertexAttribs4(UInt32 index, Int32 count, ref Int16 v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs4svNV")]
            public static extern unsafe void VertexAttribs4(UInt32 index, Int32 count, Int16* v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs4ubvNV")]
            public static extern void VertexAttribs4(Int32 index, Int32 count, Byte[] v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs4ubvNV")]
            public static extern void VertexAttribs4(Int32 index, Int32 count, ref Byte v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs4ubvNV")]
            public static extern unsafe void VertexAttribs4(Int32 index, Int32 count, Byte* v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs4ubvNV")]
            public static extern void VertexAttribs4(UInt32 index, Int32 count, Byte[] v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs4ubvNV")]
            public static extern void VertexAttribs4(UInt32 index, Int32 count, ref Byte v);

            /// <summary>[requires: NV_vertex_program]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_vertex_program", Version = "", EntryPoint = "glVertexAttribs4ubvNV")]
            public static extern unsafe void VertexAttribs4(UInt32 index, Int32 count, Byte* v);

            /// <summary>[requires: NV_vertex_buffer_unified_memory]</summary>
            [AutoGenerated(Category = "NV_vertex_buffer_unified_memory", Version = "", EntryPoint = "glVertexFormatNV")]
            public static extern void VertexFormat(Int32 size, OpenTK.Graphics.OpenGL.NvVertexBufferUnifiedMemory type, Int32 stride);

            /// <summary>[requires: NV_half_float]</summary>
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexWeighthNV")]
            public static extern void VertexWeighth(Half weight);

            /// <summary>[requires: NV_half_float]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_half_float", Version = "", EntryPoint = "glVertexWeighthvNV")]
            public static extern unsafe void VertexWeighth(Half* weight);

            /// <summary>[requires: NV_video_capture]</summary>
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glVideoCaptureNV")]
            public static extern OpenTK.Graphics.OpenGL.NvVideoCapture VideoCapture(Int32 video_capture_slot, [OutAttribute] Int32[] sequence_num, [OutAttribute] Int64[] capture_time);

            /// <summary>[requires: NV_video_capture]</summary>
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glVideoCaptureNV")]
            public static extern OpenTK.Graphics.OpenGL.NvVideoCapture VideoCapture(Int32 video_capture_slot, [OutAttribute] out Int32 sequence_num, [OutAttribute] out Int64 capture_time);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glVideoCaptureNV")]
            public static extern unsafe OpenTK.Graphics.OpenGL.NvVideoCapture VideoCapture(Int32 video_capture_slot, [OutAttribute] Int32* sequence_num, [OutAttribute] Int64* capture_time);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glVideoCaptureNV")]
            public static extern OpenTK.Graphics.OpenGL.NvVideoCapture VideoCapture(UInt32 video_capture_slot, [OutAttribute] UInt32[] sequence_num, [OutAttribute] UInt64[] capture_time);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glVideoCaptureNV")]
            public static extern OpenTK.Graphics.OpenGL.NvVideoCapture VideoCapture(UInt32 video_capture_slot, [OutAttribute] out UInt32 sequence_num, [OutAttribute] out UInt64 capture_time);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glVideoCaptureNV")]
            public static extern unsafe OpenTK.Graphics.OpenGL.NvVideoCapture VideoCapture(UInt32 video_capture_slot, [OutAttribute] UInt32* sequence_num, [OutAttribute] UInt64* capture_time);

            /// <summary>[requires: NV_video_capture]</summary>
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glVideoCaptureStreamParameterdvNV")]
            public static extern void VideoCaptureStreamParameter(Int32 video_capture_slot, Int32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, Double[] @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glVideoCaptureStreamParameterdvNV")]
            public static extern void VideoCaptureStreamParameter(Int32 video_capture_slot, Int32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, ref Double @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glVideoCaptureStreamParameterdvNV")]
            public static extern unsafe void VideoCaptureStreamParameter(Int32 video_capture_slot, Int32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, Double* @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glVideoCaptureStreamParameterdvNV")]
            public static extern void VideoCaptureStreamParameter(UInt32 video_capture_slot, UInt32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, Double[] @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glVideoCaptureStreamParameterdvNV")]
            public static extern void VideoCaptureStreamParameter(UInt32 video_capture_slot, UInt32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, ref Double @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glVideoCaptureStreamParameterdvNV")]
            public static extern unsafe void VideoCaptureStreamParameter(UInt32 video_capture_slot, UInt32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, Double* @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glVideoCaptureStreamParameterfvNV")]
            public static extern void VideoCaptureStreamParameter(Int32 video_capture_slot, Int32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, Single[] @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glVideoCaptureStreamParameterfvNV")]
            public static extern void VideoCaptureStreamParameter(Int32 video_capture_slot, Int32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, ref Single @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glVideoCaptureStreamParameterfvNV")]
            public static extern unsafe void VideoCaptureStreamParameter(Int32 video_capture_slot, Int32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, Single* @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glVideoCaptureStreamParameterfvNV")]
            public static extern void VideoCaptureStreamParameter(UInt32 video_capture_slot, UInt32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, Single[] @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glVideoCaptureStreamParameterfvNV")]
            public static extern void VideoCaptureStreamParameter(UInt32 video_capture_slot, UInt32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, ref Single @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glVideoCaptureStreamParameterfvNV")]
            public static extern unsafe void VideoCaptureStreamParameter(UInt32 video_capture_slot, UInt32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, Single* @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glVideoCaptureStreamParameterivNV")]
            public static extern void VideoCaptureStreamParameter(Int32 video_capture_slot, Int32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, Int32[] @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glVideoCaptureStreamParameterivNV")]
            public static extern void VideoCaptureStreamParameter(Int32 video_capture_slot, Int32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, ref Int32 @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glVideoCaptureStreamParameterivNV")]
            public static extern unsafe void VideoCaptureStreamParameter(Int32 video_capture_slot, Int32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, Int32* @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glVideoCaptureStreamParameterivNV")]
            public static extern void VideoCaptureStreamParameter(UInt32 video_capture_slot, UInt32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, Int32[] @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glVideoCaptureStreamParameterivNV")]
            public static extern void VideoCaptureStreamParameter(UInt32 video_capture_slot, UInt32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, ref Int32 @params);

            /// <summary>[requires: NV_video_capture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_video_capture", Version = "", EntryPoint = "glVideoCaptureStreamParameterivNV")]
            public static extern unsafe void VideoCaptureStreamParameter(UInt32 video_capture_slot, UInt32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, Int32* @params);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glWeightPathsNV")]
            public static extern void WeightPath(Int32 resultPath, Int32 numPaths, Int32[] paths, Single[] weights);

            /// <summary>[requires: NV_path_rendering]</summary>
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glWeightPathsNV")]
            public static extern void WeightPath(Int32 resultPath, Int32 numPaths, ref Int32 paths, ref Single weights);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glWeightPathsNV")]
            public static extern unsafe void WeightPath(Int32 resultPath, Int32 numPaths, Int32* paths, Single* weights);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glWeightPathsNV")]
            public static extern void WeightPath(UInt32 resultPath, Int32 numPaths, UInt32[] paths, Single[] weights);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glWeightPathsNV")]
            public static extern void WeightPath(UInt32 resultPath, Int32 numPaths, ref UInt32 paths, ref Single weights);

            /// <summary>[requires: NV_path_rendering]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NV_path_rendering", Version = "", EntryPoint = "glWeightPathsNV")]
            public static extern unsafe void WeightPath(UInt32 resultPath, Int32 numPaths, UInt32* paths, Single* weights);

        }

        public static partial class Nvx
        {
            /// <summary>[requires: NVX_conditional_render]
            /// Start conditional rendering
            /// </summary>
            /// <param name="id">
            /// <para>
            /// Specifies the name of an occlusion query object whose results are used to determine if the rendering commands are discarded.
            /// </para>
            /// </param>
            /// <param name="mode">
            /// <para>
            /// Specifies how glBeginConditionalRender interprets the results of the occlusion query.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "NVX_conditional_render", Version = "", EntryPoint = "glBeginConditionalRenderNVX")]
            public static extern void BeginConditionalRender(Int32 id);

            /// <summary>[requires: NVX_conditional_render]
            /// Start conditional rendering
            /// </summary>
            /// <param name="id">
            /// <para>
            /// Specifies the name of an occlusion query object whose results are used to determine if the rendering commands are discarded.
            /// </para>
            /// </param>
            /// <param name="mode">
            /// <para>
            /// Specifies how glBeginConditionalRender interprets the results of the occlusion query.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "NVX_conditional_render", Version = "", EntryPoint = "glBeginConditionalRenderNVX")]
            public static extern void BeginConditionalRender(UInt32 id);

            /// <summary>[requires: NVX_conditional_render]</summary>
            [AutoGenerated(Category = "NVX_conditional_render", Version = "", EntryPoint = "glEndConditionalRenderNVX")]
            public static extern void EndConditionalRender();

        }

        public static partial class Oes
        {
            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glAccumxOES")]
            public static extern void Accumx(OpenTK.Graphics.OpenGL.OesFixedPoint op, int value);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glAlphaFuncxOES")]
            public static extern void AlphaFuncx(OpenTK.Graphics.OpenGL.OesFixedPoint func, int @ref);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glBitmapxOES")]
            public static extern void Bitmapx(Int32 width, Int32 height, int xorig, int yorig, int xmove, int ymove, Byte[] bitmap);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glBitmapxOES")]
            public static extern void Bitmapx(Int32 width, Int32 height, int xorig, int yorig, int xmove, int ymove, ref Byte bitmap);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glBitmapxOES")]
            public static extern unsafe void Bitmapx(Int32 width, Int32 height, int xorig, int yorig, int xmove, int ymove, Byte* bitmap);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glBlendColorxOES")]
            public static extern void BlendColorx(int red, int green, int blue, int alpha);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glClearAccumxOES")]
            public static extern void ClearAccumx(int red, int green, int blue, int alpha);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glClearColorxOES")]
            public static extern void ClearColorx(int red, int green, int blue, int alpha);

            /// <summary>[requires: OES_single_precision]
            /// Specify the clear value for the depth buffer
            /// </summary>
            /// <param name="depth">
            /// <para>
            /// Specifies the depth value used when the depth buffer is cleared. The initial value is 1.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_single_precision", Version = "", EntryPoint = "glClearDepthfOES")]
            public static extern void ClearDepth(Single depth);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glClearDepthxOES")]
            public static extern void ClearDepthx(int depth);

            /// <summary>[requires: OES_single_precision]
            /// Specify a plane against which all geometry is clipped
            /// </summary>
            /// <param name="plane">
            /// <para>
            /// Specifies which clipping plane is being positioned. Symbolic names of the form GL_CLIP_PLANEi, where i is an integer between 0 and GL_MAX_CLIP_PLANES - 1, are accepted.
            /// </para>
            /// </param>
            /// <param name="equation">
            /// <para>
            /// Specifies the address of an array of four double-precision floating-point values. These values are interpreted as a plane equation.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_single_precision", Version = "", EntryPoint = "glClipPlanefOES")]
            public static extern void ClipPlane(OpenTK.Graphics.OpenGL.OesSinglePrecision plane, Single[] equation);

            /// <summary>[requires: OES_single_precision]
            /// Specify a plane against which all geometry is clipped
            /// </summary>
            /// <param name="plane">
            /// <para>
            /// Specifies which clipping plane is being positioned. Symbolic names of the form GL_CLIP_PLANEi, where i is an integer between 0 and GL_MAX_CLIP_PLANES - 1, are accepted.
            /// </para>
            /// </param>
            /// <param name="equation">
            /// <para>
            /// Specifies the address of an array of four double-precision floating-point values. These values are interpreted as a plane equation.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_single_precision", Version = "", EntryPoint = "glClipPlanefOES")]
            public static extern void ClipPlane(OpenTK.Graphics.OpenGL.OesSinglePrecision plane, ref Single equation);

            /// <summary>[requires: OES_single_precision]
            /// Specify a plane against which all geometry is clipped
            /// </summary>
            /// <param name="plane">
            /// <para>
            /// Specifies which clipping plane is being positioned. Symbolic names of the form GL_CLIP_PLANEi, where i is an integer between 0 and GL_MAX_CLIP_PLANES - 1, are accepted.
            /// </para>
            /// </param>
            /// <param name="equation">
            /// <para>
            /// Specifies the address of an array of four double-precision floating-point values. These values are interpreted as a plane equation.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_single_precision", Version = "", EntryPoint = "glClipPlanefOES")]
            public static extern unsafe void ClipPlane(OpenTK.Graphics.OpenGL.OesSinglePrecision plane, Single* equation);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glClipPlanexOES")]
            public static extern void ClipPlanex(OpenTK.Graphics.OpenGL.OesFixedPoint plane, int[] equation);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glClipPlanexOES")]
            public static extern void ClipPlanex(OpenTK.Graphics.OpenGL.OesFixedPoint plane, ref int equation);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glClipPlanexOES")]
            public static extern unsafe void ClipPlanex(OpenTK.Graphics.OpenGL.OesFixedPoint plane, int* equation);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glColor3xOES")]
            public static extern void Color3x(int red, int green, int blue);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glColor3xvOES")]
            public static extern void Color3x(int[] components);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glColor3xvOES")]
            public static extern void Color3x(ref int components);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glColor3xvOES")]
            public static extern unsafe void Color3x(int* components);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glColor4xOES")]
            public static extern void Color4x(int red, int green, int blue, int alpha);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glColor4xvOES")]
            public static extern void Color4x(int[] components);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glColor4xvOES")]
            public static extern void Color4x(ref int components);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glColor4xvOES")]
            public static extern unsafe void Color4x(int* components);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glConvolutionParameterxOES")]
            public static extern void ConvolutionParameterx(OpenTK.Graphics.OpenGL.OesFixedPoint target, OpenTK.Graphics.OpenGL.OesFixedPoint pname, int param);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glConvolutionParameterxvOES")]
            public static extern void ConvolutionParameterx(OpenTK.Graphics.OpenGL.OesFixedPoint target, OpenTK.Graphics.OpenGL.OesFixedPoint pname, int[] @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glConvolutionParameterxvOES")]
            public static extern unsafe void ConvolutionParameterx(OpenTK.Graphics.OpenGL.OesFixedPoint target, OpenTK.Graphics.OpenGL.OesFixedPoint pname, int* @params);

            /// <summary>[requires: OES_single_precision]
            /// Specify mapping of depth values from normalized device coordinates to window coordinates
            /// </summary>
            /// <param name="nearVal">
            /// <para>
            /// Specifies the mapping of the near clipping plane to window coordinates. The initial value is 0.
            /// </para>
            /// </param>
            /// <param name="farVal">
            /// <para>
            /// Specifies the mapping of the far clipping plane to window coordinates. The initial value is 1.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_single_precision", Version = "", EntryPoint = "glDepthRangefOES")]
            public static extern void DepthRange(Single n, Single f);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glDepthRangexOES")]
            public static extern void DepthRangex(int n, int f);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glEvalCoord1xOES")]
            public static extern void EvalCoord1x(int u);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glEvalCoord1xvOES")]
            public static extern unsafe void EvalCoord1x(int* coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glEvalCoord2xOES")]
            public static extern void EvalCoord2x(int u, int v);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glEvalCoord2xvOES")]
            public static extern void EvalCoord2x(int[] coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glEvalCoord2xvOES")]
            public static extern void EvalCoord2x(ref int coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glEvalCoord2xvOES")]
            public static extern unsafe void EvalCoord2x(int* coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glFeedbackBufferxOES")]
            public static extern void FeedbackBufferx(Int32 n, OpenTK.Graphics.OpenGL.OesFixedPoint type, int[] buffer);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glFeedbackBufferxOES")]
            public static extern void FeedbackBufferx(Int32 n, OpenTK.Graphics.OpenGL.OesFixedPoint type, ref int buffer);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glFeedbackBufferxOES")]
            public static extern unsafe void FeedbackBufferx(Int32 n, OpenTK.Graphics.OpenGL.OesFixedPoint type, int* buffer);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glFogxOES")]
            public static extern void Fogx(OpenTK.Graphics.OpenGL.OesFixedPoint pname, int param);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glFogxvOES")]
            public static extern void Fogx(OpenTK.Graphics.OpenGL.OesFixedPoint pname, int[] param);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glFogxvOES")]
            public static extern unsafe void Fogx(OpenTK.Graphics.OpenGL.OesFixedPoint pname, int* param);

            /// <summary>[requires: OES_single_precision]
            /// Multiply the current matrix by a perspective matrix
            /// </summary>
            /// <param name="left">
            /// <para>
            /// Specify the coordinates for the left and right vertical clipping planes.
            /// </para>
            /// </param>
            /// <param name="bottom">
            /// <para>
            /// Specify the coordinates for the bottom and top horizontal clipping planes.
            /// </para>
            /// </param>
            /// <param name="nearVal">
            /// <para>
            /// Specify the distances to the near and far depth clipping planes. Both distances must be positive.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_single_precision", Version = "", EntryPoint = "glFrustumfOES")]
            public static extern void Frustum(Single l, Single r, Single b, Single t, Single n, Single f);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glFrustumxOES")]
            public static extern void Frustumx(int l, int r, int b, int t, int n, int f);

            /// <summary>[requires: OES_single_precision]
            /// Return the coefficients of the specified clipping plane
            /// </summary>
            /// <param name="plane">
            /// <para>
            /// Specifies a clipping plane. The number of clipping planes depends on the implementation, but at least six clipping planes are supported. They are identified by symbolic names of the form GL_CLIP_PLANE where i ranges from 0 to the value of GL_MAX_CLIP_PLANES - 1.
            /// </para>
            /// </param>
            /// <param name="equation">
            /// <para>
            /// Returns four double-precision values that are the coefficients of the plane equation of plane in eye coordinates. The initial value is (0, 0, 0, 0).
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_single_precision", Version = "", EntryPoint = "glGetClipPlanefOES")]
            public static extern void GetClipPlane(OpenTK.Graphics.OpenGL.OesSinglePrecision plane, [OutAttribute] Single[] equation);

            /// <summary>[requires: OES_single_precision]
            /// Return the coefficients of the specified clipping plane
            /// </summary>
            /// <param name="plane">
            /// <para>
            /// Specifies a clipping plane. The number of clipping planes depends on the implementation, but at least six clipping planes are supported. They are identified by symbolic names of the form GL_CLIP_PLANE where i ranges from 0 to the value of GL_MAX_CLIP_PLANES - 1.
            /// </para>
            /// </param>
            /// <param name="equation">
            /// <para>
            /// Returns four double-precision values that are the coefficients of the plane equation of plane in eye coordinates. The initial value is (0, 0, 0, 0).
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_single_precision", Version = "", EntryPoint = "glGetClipPlanefOES")]
            public static extern void GetClipPlane(OpenTK.Graphics.OpenGL.OesSinglePrecision plane, [OutAttribute] out Single equation);

            /// <summary>[requires: OES_single_precision]
            /// Return the coefficients of the specified clipping plane
            /// </summary>
            /// <param name="plane">
            /// <para>
            /// Specifies a clipping plane. The number of clipping planes depends on the implementation, but at least six clipping planes are supported. They are identified by symbolic names of the form GL_CLIP_PLANE where i ranges from 0 to the value of GL_MAX_CLIP_PLANES - 1.
            /// </para>
            /// </param>
            /// <param name="equation">
            /// <para>
            /// Returns four double-precision values that are the coefficients of the plane equation of plane in eye coordinates. The initial value is (0, 0, 0, 0).
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_single_precision", Version = "", EntryPoint = "glGetClipPlanefOES")]
            public static extern unsafe void GetClipPlane(OpenTK.Graphics.OpenGL.OesSinglePrecision plane, [OutAttribute] Single* equation);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetClipPlanexOES")]
            public static extern void GetClipPlanex(OpenTK.Graphics.OpenGL.OesFixedPoint plane, [OutAttribute] int[] equation);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetClipPlanexOES")]
            public static extern void GetClipPlanex(OpenTK.Graphics.OpenGL.OesFixedPoint plane, [OutAttribute] out int equation);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetClipPlanexOES")]
            public static extern unsafe void GetClipPlanex(OpenTK.Graphics.OpenGL.OesFixedPoint plane, [OutAttribute] int* equation);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetConvolutionParameterxvOES")]
            public static extern void GetConvolutionParameterx(OpenTK.Graphics.OpenGL.OesFixedPoint target, OpenTK.Graphics.OpenGL.OesFixedPoint pname, [OutAttribute] int[] @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetConvolutionParameterxvOES")]
            public static extern void GetConvolutionParameterx(OpenTK.Graphics.OpenGL.OesFixedPoint target, OpenTK.Graphics.OpenGL.OesFixedPoint pname, [OutAttribute] out int @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetConvolutionParameterxvOES")]
            public static extern unsafe void GetConvolutionParameterx(OpenTK.Graphics.OpenGL.OesFixedPoint target, OpenTK.Graphics.OpenGL.OesFixedPoint pname, [OutAttribute] int* @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetFixedvOES")]
            public static extern int GetFixed(OpenTK.Graphics.OpenGL.OesFixedPoint pname);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetFixedvOES")]
            public static extern void GetFixed(OpenTK.Graphics.OpenGL.OesFixedPoint pname, [OutAttribute] int[] @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetFixedvOES")]
            public static extern void GetFixed(OpenTK.Graphics.OpenGL.OesFixedPoint pname, [OutAttribute] out int @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetFixedvOES")]
            public static extern unsafe void GetFixed(OpenTK.Graphics.OpenGL.OesFixedPoint pname, [OutAttribute] int* @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetHistogramParameterxvOES")]
            public static extern void GetHistogramParameterx(OpenTK.Graphics.OpenGL.OesFixedPoint target, OpenTK.Graphics.OpenGL.OesFixedPoint pname, [OutAttribute] int[] @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetHistogramParameterxvOES")]
            public static extern void GetHistogramParameterx(OpenTK.Graphics.OpenGL.OesFixedPoint target, OpenTK.Graphics.OpenGL.OesFixedPoint pname, [OutAttribute] out int @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetHistogramParameterxvOES")]
            public static extern unsafe void GetHistogramParameterx(OpenTK.Graphics.OpenGL.OesFixedPoint target, OpenTK.Graphics.OpenGL.OesFixedPoint pname, [OutAttribute] int* @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetLightxOES")]
            public static extern void GetLightx(OpenTK.Graphics.OpenGL.OesFixedPoint light, OpenTK.Graphics.OpenGL.OesFixedPoint pname, [OutAttribute] int[] @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetLightxOES")]
            public static extern void GetLightx(OpenTK.Graphics.OpenGL.OesFixedPoint light, OpenTK.Graphics.OpenGL.OesFixedPoint pname, [OutAttribute] out int @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetLightxOES")]
            public static extern unsafe void GetLightx(OpenTK.Graphics.OpenGL.OesFixedPoint light, OpenTK.Graphics.OpenGL.OesFixedPoint pname, [OutAttribute] int* @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetMapxvOES")]
            public static extern void GetMapx(OpenTK.Graphics.OpenGL.OesFixedPoint target, OpenTK.Graphics.OpenGL.OesFixedPoint query, [OutAttribute] int[] v);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetMapxvOES")]
            public static extern void GetMapx(OpenTK.Graphics.OpenGL.OesFixedPoint target, OpenTK.Graphics.OpenGL.OesFixedPoint query, [OutAttribute] out int v);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetMapxvOES")]
            public static extern unsafe void GetMapx(OpenTK.Graphics.OpenGL.OesFixedPoint target, OpenTK.Graphics.OpenGL.OesFixedPoint query, [OutAttribute] int* v);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetMaterialxOES")]
            public static extern void GetMaterialx(OpenTK.Graphics.OpenGL.OesFixedPoint face, OpenTK.Graphics.OpenGL.OesFixedPoint pname, int param);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetMaterialxvOES")]
            public static extern void GetMaterialx(OpenTK.Graphics.OpenGL.OesFixedPoint face, OpenTK.Graphics.OpenGL.OesFixedPoint pname, [OutAttribute] int[] @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetMaterialxvOES")]
            public static extern unsafe void GetMaterialx(OpenTK.Graphics.OpenGL.OesFixedPoint face, OpenTK.Graphics.OpenGL.OesFixedPoint pname, [OutAttribute] int* @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetTexEnvxvOES")]
            public static extern void GetTexEnvx(OpenTK.Graphics.OpenGL.OesFixedPoint target, OpenTK.Graphics.OpenGL.OesFixedPoint pname, [OutAttribute] int[] @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetTexEnvxvOES")]
            public static extern void GetTexEnvx(OpenTK.Graphics.OpenGL.OesFixedPoint target, OpenTK.Graphics.OpenGL.OesFixedPoint pname, [OutAttribute] out int @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetTexEnvxvOES")]
            public static extern unsafe void GetTexEnvx(OpenTK.Graphics.OpenGL.OesFixedPoint target, OpenTK.Graphics.OpenGL.OesFixedPoint pname, [OutAttribute] int* @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetTexGenxvOES")]
            public static extern void GetTexGenx(OpenTK.Graphics.OpenGL.OesFixedPoint coord, OpenTK.Graphics.OpenGL.OesFixedPoint pname, [OutAttribute] int[] @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetTexGenxvOES")]
            public static extern void GetTexGenx(OpenTK.Graphics.OpenGL.OesFixedPoint coord, OpenTK.Graphics.OpenGL.OesFixedPoint pname, [OutAttribute] out int @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetTexGenxvOES")]
            public static extern unsafe void GetTexGenx(OpenTK.Graphics.OpenGL.OesFixedPoint coord, OpenTK.Graphics.OpenGL.OesFixedPoint pname, [OutAttribute] int* @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetTexLevelParameterxvOES")]
            public static extern void GetTexLevelParameterx(OpenTK.Graphics.OpenGL.OesFixedPoint target, Int32 level, OpenTK.Graphics.OpenGL.OesFixedPoint pname, [OutAttribute] int[] @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetTexLevelParameterxvOES")]
            public static extern void GetTexLevelParameterx(OpenTK.Graphics.OpenGL.OesFixedPoint target, Int32 level, OpenTK.Graphics.OpenGL.OesFixedPoint pname, [OutAttribute] out int @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetTexLevelParameterxvOES")]
            public static extern unsafe void GetTexLevelParameterx(OpenTK.Graphics.OpenGL.OesFixedPoint target, Int32 level, OpenTK.Graphics.OpenGL.OesFixedPoint pname, [OutAttribute] int* @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetTexParameterxvOES")]
            public static extern void GetTexParameterx(OpenTK.Graphics.OpenGL.OesFixedPoint target, OpenTK.Graphics.OpenGL.OesFixedPoint pname, [OutAttribute] int[] @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetTexParameterxvOES")]
            public static extern void GetTexParameterx(OpenTK.Graphics.OpenGL.OesFixedPoint target, OpenTK.Graphics.OpenGL.OesFixedPoint pname, [OutAttribute] out int @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glGetTexParameterxvOES")]
            public static extern unsafe void GetTexParameterx(OpenTK.Graphics.OpenGL.OesFixedPoint target, OpenTK.Graphics.OpenGL.OesFixedPoint pname, [OutAttribute] int* @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glIndexxOES")]
            public static extern void Indexx(int component);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glIndexxvOES")]
            public static extern unsafe void Indexx(int* component);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glLightModelxOES")]
            public static extern void LightModelx(OpenTK.Graphics.OpenGL.OesFixedPoint pname, int param);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glLightModelxvOES")]
            public static extern void LightModelx(OpenTK.Graphics.OpenGL.OesFixedPoint pname, int[] param);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glLightModelxvOES")]
            public static extern unsafe void LightModelx(OpenTK.Graphics.OpenGL.OesFixedPoint pname, int* param);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glLightxOES")]
            public static extern void Lightx(OpenTK.Graphics.OpenGL.OesFixedPoint light, OpenTK.Graphics.OpenGL.OesFixedPoint pname, int param);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glLightxvOES")]
            public static extern void Lightx(OpenTK.Graphics.OpenGL.OesFixedPoint light, OpenTK.Graphics.OpenGL.OesFixedPoint pname, int[] @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glLightxvOES")]
            public static extern unsafe void Lightx(OpenTK.Graphics.OpenGL.OesFixedPoint light, OpenTK.Graphics.OpenGL.OesFixedPoint pname, int* @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glLineWidthxOES")]
            public static extern void LineWidthx(int width);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glLoadMatrixxOES")]
            public static extern void LoadMatrixx(int[] m);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glLoadMatrixxOES")]
            public static extern void LoadMatrixx(ref int m);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glLoadMatrixxOES")]
            public static extern unsafe void LoadMatrixx(int* m);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glLoadTransposeMatrixxOES")]
            public static extern void LoadTransposeMatrixx(int[] m);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glLoadTransposeMatrixxOES")]
            public static extern void LoadTransposeMatrixx(ref int m);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glLoadTransposeMatrixxOES")]
            public static extern unsafe void LoadTransposeMatrixx(int* m);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glMap1xOES")]
            public static extern void Map1x(OpenTK.Graphics.OpenGL.OesFixedPoint target, int u1, int u2, Int32 stride, Int32 order, int points);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glMap2xOES")]
            public static extern void Map2x(OpenTK.Graphics.OpenGL.OesFixedPoint target, int u1, int u2, Int32 ustride, Int32 uorder, int v1, int v2, Int32 vstride, Int32 vorder, int points);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glMapGrid1xOES")]
            public static extern void MapGrid1x(Int32 n, int u1, int u2);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glMapGrid2xOES")]
            public static extern void MapGrid2x(Int32 n, int u1, int u2, int v1, int v2);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glMaterialxOES")]
            public static extern void Materialx(OpenTK.Graphics.OpenGL.OesFixedPoint face, OpenTK.Graphics.OpenGL.OesFixedPoint pname, int param);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glMaterialxvOES")]
            public static extern void Materialx(OpenTK.Graphics.OpenGL.OesFixedPoint face, OpenTK.Graphics.OpenGL.OesFixedPoint pname, int[] param);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glMaterialxvOES")]
            public static extern unsafe void Materialx(OpenTK.Graphics.OpenGL.OesFixedPoint face, OpenTK.Graphics.OpenGL.OesFixedPoint pname, int* param);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glMultiTexCoord1bOES")]
            public static extern void MultiTexCoord1(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, Byte s);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glMultiTexCoord1bOES")]
            public static extern void MultiTexCoord1(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, SByte s);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glMultiTexCoord1bvOES")]
            public static extern unsafe void MultiTexCoord1(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, Byte* coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glMultiTexCoord1bvOES")]
            public static extern unsafe void MultiTexCoord1(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, SByte* coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glMultiTexCoord1xOES")]
            public static extern void MultiTexCoord1x(OpenTK.Graphics.OpenGL.OesFixedPoint texture, int s);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glMultiTexCoord1xvOES")]
            public static extern unsafe void MultiTexCoord1x(OpenTK.Graphics.OpenGL.OesFixedPoint texture, int* coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glMultiTexCoord2bOES")]
            public static extern void MultiTexCoord2(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, Byte s, Byte t);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glMultiTexCoord2bOES")]
            public static extern void MultiTexCoord2(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, SByte s, SByte t);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glMultiTexCoord2bvOES")]
            public static extern void MultiTexCoord2(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, Byte[] coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glMultiTexCoord2bvOES")]
            public static extern void MultiTexCoord2(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, ref Byte coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glMultiTexCoord2bvOES")]
            public static extern unsafe void MultiTexCoord2(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, Byte* coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glMultiTexCoord2bvOES")]
            public static extern void MultiTexCoord2(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, SByte[] coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glMultiTexCoord2bvOES")]
            public static extern void MultiTexCoord2(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, ref SByte coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glMultiTexCoord2bvOES")]
            public static extern unsafe void MultiTexCoord2(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, SByte* coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glMultiTexCoord2xOES")]
            public static extern void MultiTexCoord2x(OpenTK.Graphics.OpenGL.OesFixedPoint texture, int s, int t);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glMultiTexCoord2xvOES")]
            public static extern void MultiTexCoord2x(OpenTK.Graphics.OpenGL.OesFixedPoint texture, int[] coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glMultiTexCoord2xvOES")]
            public static extern void MultiTexCoord2x(OpenTK.Graphics.OpenGL.OesFixedPoint texture, ref int coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glMultiTexCoord2xvOES")]
            public static extern unsafe void MultiTexCoord2x(OpenTK.Graphics.OpenGL.OesFixedPoint texture, int* coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glMultiTexCoord3bOES")]
            public static extern void MultiTexCoord3(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, Byte s, Byte t, Byte r);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glMultiTexCoord3bOES")]
            public static extern void MultiTexCoord3(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, SByte s, SByte t, SByte r);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glMultiTexCoord3bvOES")]
            public static extern void MultiTexCoord3(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, Byte[] coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glMultiTexCoord3bvOES")]
            public static extern void MultiTexCoord3(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, ref Byte coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glMultiTexCoord3bvOES")]
            public static extern unsafe void MultiTexCoord3(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, Byte* coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glMultiTexCoord3bvOES")]
            public static extern void MultiTexCoord3(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, SByte[] coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glMultiTexCoord3bvOES")]
            public static extern void MultiTexCoord3(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, ref SByte coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glMultiTexCoord3bvOES")]
            public static extern unsafe void MultiTexCoord3(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, SByte* coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glMultiTexCoord3xOES")]
            public static extern void MultiTexCoord3x(OpenTK.Graphics.OpenGL.OesFixedPoint texture, int s, int t, int r);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glMultiTexCoord3xvOES")]
            public static extern void MultiTexCoord3x(OpenTK.Graphics.OpenGL.OesFixedPoint texture, int[] coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glMultiTexCoord3xvOES")]
            public static extern void MultiTexCoord3x(OpenTK.Graphics.OpenGL.OesFixedPoint texture, ref int coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glMultiTexCoord3xvOES")]
            public static extern unsafe void MultiTexCoord3x(OpenTK.Graphics.OpenGL.OesFixedPoint texture, int* coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glMultiTexCoord4bOES")]
            public static extern void MultiTexCoord4(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, Byte s, Byte t, Byte r, Byte q);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glMultiTexCoord4bOES")]
            public static extern void MultiTexCoord4(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, SByte s, SByte t, SByte r, SByte q);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glMultiTexCoord4bvOES")]
            public static extern void MultiTexCoord4(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, Byte[] coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glMultiTexCoord4bvOES")]
            public static extern void MultiTexCoord4(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, ref Byte coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glMultiTexCoord4bvOES")]
            public static extern unsafe void MultiTexCoord4(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, Byte* coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glMultiTexCoord4bvOES")]
            public static extern void MultiTexCoord4(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, SByte[] coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glMultiTexCoord4bvOES")]
            public static extern void MultiTexCoord4(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, ref SByte coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies the texture unit whose coordinates should be modified. The number of texture units is implementation dependent, but must be at least two. Symbolic constant must be one of GL_TEXTURE, where i ranges from 0 to GL_MAX_TEXTURE_COORDS - 1, which is an implementation-dependent value.
            /// </para>
            /// </param>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates for target texture unit. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glMultiTexCoord4bvOES")]
            public static extern unsafe void MultiTexCoord4(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, SByte* coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glMultiTexCoord4xOES")]
            public static extern void MultiTexCoord4x(OpenTK.Graphics.OpenGL.OesFixedPoint texture, int s, int t, int r, int q);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glMultiTexCoord4xvOES")]
            public static extern void MultiTexCoord4x(OpenTK.Graphics.OpenGL.OesFixedPoint texture, int[] coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glMultiTexCoord4xvOES")]
            public static extern void MultiTexCoord4x(OpenTK.Graphics.OpenGL.OesFixedPoint texture, ref int coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glMultiTexCoord4xvOES")]
            public static extern unsafe void MultiTexCoord4x(OpenTK.Graphics.OpenGL.OesFixedPoint texture, int* coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glMultMatrixxOES")]
            public static extern void MultMatrixx(int[] m);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glMultMatrixxOES")]
            public static extern void MultMatrixx(ref int m);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glMultMatrixxOES")]
            public static extern unsafe void MultMatrixx(int* m);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glMultTransposeMatrixxOES")]
            public static extern void MultTransposeMatrixx(int[] m);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glMultTransposeMatrixxOES")]
            public static extern void MultTransposeMatrixx(ref int m);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glMultTransposeMatrixxOES")]
            public static extern unsafe void MultTransposeMatrixx(int* m);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glNormal3xOES")]
            public static extern void Normal3x(int nx, int ny, int nz);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glNormal3xvOES")]
            public static extern void Normal3x(int[] coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glNormal3xvOES")]
            public static extern void Normal3x(ref int coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glNormal3xvOES")]
            public static extern unsafe void Normal3x(int* coords);

            /// <summary>[requires: OES_single_precision]
            /// Multiply the current matrix with an orthographic matrix
            /// </summary>
            /// <param name="left">
            /// <para>
            /// Specify the coordinates for the left and right vertical clipping planes.
            /// </para>
            /// </param>
            /// <param name="bottom">
            /// <para>
            /// Specify the coordinates for the bottom and top horizontal clipping planes.
            /// </para>
            /// </param>
            /// <param name="nearVal">
            /// <para>
            /// Specify the distances to the nearer and farther depth clipping planes. These values are negative if the plane is to be behind the viewer.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_single_precision", Version = "", EntryPoint = "glOrthofOES")]
            public static extern void Ortho(Single l, Single r, Single b, Single t, Single n, Single f);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glOrthoxOES")]
            public static extern void Orthox(int l, int r, int b, int t, int n, int f);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glPassThroughxOES")]
            public static extern void PassThroughx(int token);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glPixelTransferxOES")]
            public static extern void PixelTransferx(OpenTK.Graphics.OpenGL.OesFixedPoint pname, int param);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glPixelZoomxOES")]
            public static extern void PixelZoomx(int xfactor, int yfactor);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glPointParameterxOES")]
            public static extern void PointParameterx(OpenTK.Graphics.OpenGL.OesFixedPoint pname, int param);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glPointParameterxvOES")]
            public static extern void PointParameterx(OpenTK.Graphics.OpenGL.OesFixedPoint pname, int[] @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glPointParameterxvOES")]
            public static extern unsafe void PointParameterx(OpenTK.Graphics.OpenGL.OesFixedPoint pname, int* @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glPointSizexOES")]
            public static extern void PointSizex(int size);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glPolygonOffsetxOES")]
            public static extern void PolygonOffsetx(int factor, int units);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glPrioritizeTexturesxOES")]
            public static extern void PrioritizeTexturesx(Int32 n, Int32[] textures, int[] priorities);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glPrioritizeTexturesxOES")]
            public static extern void PrioritizeTexturesx(Int32 n, ref Int32 textures, ref int priorities);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glPrioritizeTexturesxOES")]
            public static extern unsafe void PrioritizeTexturesx(Int32 n, Int32* textures, int* priorities);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glPrioritizeTexturesxOES")]
            public static extern void PrioritizeTexturesx(Int32 n, UInt32[] textures, int[] priorities);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glPrioritizeTexturesxOES")]
            public static extern void PrioritizeTexturesx(Int32 n, ref UInt32 textures, ref int priorities);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glPrioritizeTexturesxOES")]
            public static extern unsafe void PrioritizeTexturesx(Int32 n, UInt32* textures, int* priorities);

            /// <summary>[requires: OES_query_matrix]</summary>
            [AutoGenerated(Category = "OES_query_matrix", Version = "", EntryPoint = "glQueryMatrixxOES")]
            public static extern Int32 QueryMatrixx([OutAttribute] int[] mantissa, [OutAttribute] Int32[] exponent);

            /// <summary>[requires: OES_query_matrix]</summary>
            [AutoGenerated(Category = "OES_query_matrix", Version = "", EntryPoint = "glQueryMatrixxOES")]
            public static extern Int32 QueryMatrixx([OutAttribute] out int mantissa, [OutAttribute] out Int32 exponent);

            /// <summary>[requires: OES_query_matrix]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_query_matrix", Version = "", EntryPoint = "glQueryMatrixxOES")]
            public static extern unsafe Int32 QueryMatrixx([OutAttribute] int* mantissa, [OutAttribute] Int32* exponent);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glRasterPos2xOES")]
            public static extern void RasterPos2x(int x, int y);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glRasterPos2xvOES")]
            public static extern void RasterPos2x(int[] coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glRasterPos2xvOES")]
            public static extern void RasterPos2x(ref int coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glRasterPos2xvOES")]
            public static extern unsafe void RasterPos2x(int* coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glRasterPos3xOES")]
            public static extern void RasterPos3x(int x, int y, int z);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glRasterPos3xvOES")]
            public static extern void RasterPos3x(int[] coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glRasterPos3xvOES")]
            public static extern void RasterPos3x(ref int coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glRasterPos3xvOES")]
            public static extern unsafe void RasterPos3x(int* coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glRasterPos4xOES")]
            public static extern void RasterPos4x(int x, int y, int z, int w);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glRasterPos4xvOES")]
            public static extern void RasterPos4x(int[] coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glRasterPos4xvOES")]
            public static extern void RasterPos4x(ref int coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glRasterPos4xvOES")]
            public static extern unsafe void RasterPos4x(int* coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glRectxOES")]
            public static extern void Rectx(int x1, int y1, int x2, int y2);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glRectxvOES")]
            public static extern void Rectx(int[] v1, int[] v2);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glRectxvOES")]
            public static extern void Rectx(ref int v1, ref int v2);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glRectxvOES")]
            public static extern unsafe void Rectx(int* v1, int* v2);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glRotatexOES")]
            public static extern void Rotatex(int angle, int x, int y, int z);

            /// <summary>[requires: OES_fixed_point]
            /// Specify multisample coverage parameters
            /// </summary>
            /// <param name="value">
            /// <para>
            /// Specify a single floating-point sample coverage value. The value is clamped to the range [0 ,1]. The initial value is 1.0.
            /// </para>
            /// </param>
            /// <param name="invert">
            /// <para>
            /// Specify a single boolean value representing if the coverage masks should be inverted. GL_TRUE and GL_FALSE are accepted. The initial value is GL_FALSE.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glSampleCoverageOES")]
            public static extern void SampleCoverage(int value, bool invert);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glSampleCoveragexOES")]
            public static extern void SampleCoveragex(int value, bool invert);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glScalexOES")]
            public static extern void Scalex(int x, int y, int z);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glTexCoord1bOES")]
            public static extern void TexCoord1(Byte s);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glTexCoord1bOES")]
            public static extern void TexCoord1(SByte s);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glTexCoord1bvOES")]
            public static extern unsafe void TexCoord1(Byte* coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glTexCoord1bvOES")]
            public static extern unsafe void TexCoord1(SByte* coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glTexCoord1xOES")]
            public static extern void TexCoord1x(int s);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glTexCoord1xvOES")]
            public static extern unsafe void TexCoord1x(int* coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glTexCoord2bOES")]
            public static extern void TexCoord2(Byte s, Byte t);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glTexCoord2bOES")]
            public static extern void TexCoord2(SByte s, SByte t);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glTexCoord2bvOES")]
            public static extern void TexCoord2(Byte[] coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glTexCoord2bvOES")]
            public static extern void TexCoord2(ref Byte coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glTexCoord2bvOES")]
            public static extern unsafe void TexCoord2(Byte* coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glTexCoord2bvOES")]
            public static extern void TexCoord2(SByte[] coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glTexCoord2bvOES")]
            public static extern void TexCoord2(ref SByte coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glTexCoord2bvOES")]
            public static extern unsafe void TexCoord2(SByte* coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glTexCoord2xOES")]
            public static extern void TexCoord2x(int s, int t);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glTexCoord2xvOES")]
            public static extern void TexCoord2x(int[] coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glTexCoord2xvOES")]
            public static extern void TexCoord2x(ref int coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glTexCoord2xvOES")]
            public static extern unsafe void TexCoord2x(int* coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glTexCoord3bOES")]
            public static extern void TexCoord3(Byte s, Byte t, Byte r);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glTexCoord3bOES")]
            public static extern void TexCoord3(SByte s, SByte t, SByte r);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glTexCoord3bvOES")]
            public static extern void TexCoord3(Byte[] coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glTexCoord3bvOES")]
            public static extern void TexCoord3(ref Byte coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glTexCoord3bvOES")]
            public static extern unsafe void TexCoord3(Byte* coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glTexCoord3bvOES")]
            public static extern void TexCoord3(SByte[] coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glTexCoord3bvOES")]
            public static extern void TexCoord3(ref SByte coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glTexCoord3bvOES")]
            public static extern unsafe void TexCoord3(SByte* coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glTexCoord3xOES")]
            public static extern void TexCoord3x(int s, int t, int r);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glTexCoord3xvOES")]
            public static extern void TexCoord3x(int[] coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glTexCoord3xvOES")]
            public static extern void TexCoord3x(ref int coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glTexCoord3xvOES")]
            public static extern unsafe void TexCoord3x(int* coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glTexCoord4bOES")]
            public static extern void TexCoord4(Byte s, Byte t, Byte r, Byte q);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glTexCoord4bOES")]
            public static extern void TexCoord4(SByte s, SByte t, SByte r, SByte q);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glTexCoord4bvOES")]
            public static extern void TexCoord4(Byte[] coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glTexCoord4bvOES")]
            public static extern void TexCoord4(ref Byte coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glTexCoord4bvOES")]
            public static extern unsafe void TexCoord4(Byte* coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glTexCoord4bvOES")]
            public static extern void TexCoord4(SByte[] coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glTexCoord4bvOES")]
            public static extern void TexCoord4(ref SByte coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Set the current texture coordinates
            /// </summary>
            /// <param name="s">
            /// <para>
            /// Specify s, t, r, and q texture coordinates. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glTexCoord4bvOES")]
            public static extern unsafe void TexCoord4(SByte* coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glTexCoord4xOES")]
            public static extern void TexCoord4x(int s, int t, int r, int q);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glTexCoord4xvOES")]
            public static extern void TexCoord4x(int[] coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glTexCoord4xvOES")]
            public static extern void TexCoord4x(ref int coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glTexCoord4xvOES")]
            public static extern unsafe void TexCoord4x(int* coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glTexEnvxOES")]
            public static extern void TexEnvx(OpenTK.Graphics.OpenGL.OesFixedPoint target, OpenTK.Graphics.OpenGL.OesFixedPoint pname, int param);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glTexEnvxvOES")]
            public static extern void TexEnvx(OpenTK.Graphics.OpenGL.OesFixedPoint target, OpenTK.Graphics.OpenGL.OesFixedPoint pname, int[] @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glTexEnvxvOES")]
            public static extern unsafe void TexEnvx(OpenTK.Graphics.OpenGL.OesFixedPoint target, OpenTK.Graphics.OpenGL.OesFixedPoint pname, int* @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glTexGenxOES")]
            public static extern void TexGenx(OpenTK.Graphics.OpenGL.OesFixedPoint coord, OpenTK.Graphics.OpenGL.OesFixedPoint pname, int param);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glTexGenxvOES")]
            public static extern void TexGenx(OpenTK.Graphics.OpenGL.OesFixedPoint coord, OpenTK.Graphics.OpenGL.OesFixedPoint pname, int[] @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glTexGenxvOES")]
            public static extern unsafe void TexGenx(OpenTK.Graphics.OpenGL.OesFixedPoint coord, OpenTK.Graphics.OpenGL.OesFixedPoint pname, int* @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glTexParameterxOES")]
            public static extern void TexParameterx(OpenTK.Graphics.OpenGL.OesFixedPoint target, OpenTK.Graphics.OpenGL.OesFixedPoint pname, int param);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glTexParameterxvOES")]
            public static extern void TexParameterx(OpenTK.Graphics.OpenGL.OesFixedPoint target, OpenTK.Graphics.OpenGL.OesFixedPoint pname, int[] @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glTexParameterxvOES")]
            public static extern unsafe void TexParameterx(OpenTK.Graphics.OpenGL.OesFixedPoint target, OpenTK.Graphics.OpenGL.OesFixedPoint pname, int* @params);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glTranslatexOES")]
            public static extern void Translatex(int x, int y, int z);

            /// <summary>[requires: OES_byte_coordinates]
            /// Specify a vertex
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glVertex2bOES")]
            public static extern void Vertex2(Byte x);

            /// <summary>[requires: OES_byte_coordinates]
            /// Specify a vertex
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glVertex2bOES")]
            public static extern void Vertex2(SByte x);

            /// <summary>[requires: OES_byte_coordinates]
            /// Specify a vertex
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glVertex2bvOES")]
            public static extern void Vertex2(Byte[] coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Specify a vertex
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glVertex2bvOES")]
            public static extern unsafe void Vertex2(Byte* coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Specify a vertex
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glVertex2bvOES")]
            public static extern void Vertex2(SByte[] coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Specify a vertex
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glVertex2bvOES")]
            public static extern unsafe void Vertex2(SByte* coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glVertex2xOES")]
            public static extern void Vertex2x(int x);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glVertex2xvOES")]
            public static extern void Vertex2x(int[] coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glVertex2xvOES")]
            public static extern unsafe void Vertex2x(int* coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Specify a vertex
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glVertex3bOES")]
            public static extern void Vertex3(Byte x, Byte y);

            /// <summary>[requires: OES_byte_coordinates]
            /// Specify a vertex
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glVertex3bOES")]
            public static extern void Vertex3(SByte x, SByte y);

            /// <summary>[requires: OES_byte_coordinates]
            /// Specify a vertex
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glVertex3bvOES")]
            public static extern void Vertex3(Byte[] coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Specify a vertex
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glVertex3bvOES")]
            public static extern void Vertex3(ref Byte coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Specify a vertex
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glVertex3bvOES")]
            public static extern unsafe void Vertex3(Byte* coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Specify a vertex
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glVertex3bvOES")]
            public static extern void Vertex3(SByte[] coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Specify a vertex
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glVertex3bvOES")]
            public static extern void Vertex3(ref SByte coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Specify a vertex
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glVertex3bvOES")]
            public static extern unsafe void Vertex3(SByte* coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glVertex3xOES")]
            public static extern void Vertex3x(int x, int y);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glVertex3xvOES")]
            public static extern void Vertex3x(int[] coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glVertex3xvOES")]
            public static extern void Vertex3x(ref int coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glVertex3xvOES")]
            public static extern unsafe void Vertex3x(int* coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Specify a vertex
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glVertex4bOES")]
            public static extern void Vertex4(Byte x, Byte y, Byte z);

            /// <summary>[requires: OES_byte_coordinates]
            /// Specify a vertex
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glVertex4bOES")]
            public static extern void Vertex4(SByte x, SByte y, SByte z);

            /// <summary>[requires: OES_byte_coordinates]
            /// Specify a vertex
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glVertex4bvOES")]
            public static extern void Vertex4(Byte[] coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Specify a vertex
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glVertex4bvOES")]
            public static extern void Vertex4(ref Byte coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Specify a vertex
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glVertex4bvOES")]
            public static extern unsafe void Vertex4(Byte* coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Specify a vertex
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glVertex4bvOES")]
            public static extern void Vertex4(SByte[] coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Specify a vertex
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glVertex4bvOES")]
            public static extern void Vertex4(ref SByte coords);

            /// <summary>[requires: OES_byte_coordinates]
            /// Specify a vertex
            /// </summary>
            /// <param name="x">
            /// <para>
            /// Specify x, y, z, and w coordinates of a vertex. Not all parameters are present in all forms of the command.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_byte_coordinates", Version = "", EntryPoint = "glVertex4bvOES")]
            public static extern unsafe void Vertex4(SByte* coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glVertex4xOES")]
            public static extern void Vertex4x(int x, int y, int z);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glVertex4xvOES")]
            public static extern void Vertex4x(int[] coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glVertex4xvOES")]
            public static extern void Vertex4x(ref int coords);

            /// <summary>[requires: OES_fixed_point]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "OES_fixed_point", Version = "", EntryPoint = "glVertex4xvOES")]
            public static extern unsafe void Vertex4x(int* coords);

        }

        public static partial class Pgi
        {
            /// <summary>[requires: PGI_misc_hints]
            /// Specify implementation-specific hints
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Specifies a symbolic constant indicating the behavior to be controlled. GL_LINE_SMOOTH_HINT, GL_POLYGON_SMOOTH_HINT, GL_TEXTURE_COMPRESSION_HINT, and GL_FRAGMENT_SHADER_DERIVATIVE_HINT are accepted.
            /// </para>
            /// </param>
            /// <param name="mode">
            /// <para>
            /// Specifies a symbolic constant indicating the desired behavior. GL_FASTEST, GL_NICEST, and GL_DONT_CARE are accepted.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "PGI_misc_hints", Version = "", EntryPoint = "glHintPGI")]
            public static extern void Hint(OpenTK.Graphics.OpenGL.PgiMiscHints target, Int32 mode);

        }

        public static partial class Sgi
        {
            /// <summary>[requires: SGI_color_table]
            /// Set color lookup table parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The target color table. Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The symbolic name of a texture color lookup table parameter. Must be one of GL_COLOR_TABLE_SCALE or GL_COLOR_TABLE_BIAS.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// A pointer to an array where the values of the parameters are stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "SGI_color_table", Version = "", EntryPoint = "glColorTableParameterfvSGI")]
            public static extern void ColorTableParameter(OpenTK.Graphics.OpenGL.SgiColorTable target, OpenTK.Graphics.OpenGL.SgiColorTable pname, Single[] @params);

            /// <summary>[requires: SGI_color_table]
            /// Set color lookup table parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The target color table. Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The symbolic name of a texture color lookup table parameter. Must be one of GL_COLOR_TABLE_SCALE or GL_COLOR_TABLE_BIAS.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// A pointer to an array where the values of the parameters are stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "SGI_color_table", Version = "", EntryPoint = "glColorTableParameterfvSGI")]
            public static extern void ColorTableParameter(OpenTK.Graphics.OpenGL.SgiColorTable target, OpenTK.Graphics.OpenGL.SgiColorTable pname, ref Single @params);

            /// <summary>[requires: SGI_color_table]
            /// Set color lookup table parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The target color table. Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The symbolic name of a texture color lookup table parameter. Must be one of GL_COLOR_TABLE_SCALE or GL_COLOR_TABLE_BIAS.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// A pointer to an array where the values of the parameters are stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGI_color_table", Version = "", EntryPoint = "glColorTableParameterfvSGI")]
            public static extern unsafe void ColorTableParameter(OpenTK.Graphics.OpenGL.SgiColorTable target, OpenTK.Graphics.OpenGL.SgiColorTable pname, Single* @params);

            /// <summary>[requires: SGI_color_table]
            /// Set color lookup table parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The target color table. Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The symbolic name of a texture color lookup table parameter. Must be one of GL_COLOR_TABLE_SCALE or GL_COLOR_TABLE_BIAS.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// A pointer to an array where the values of the parameters are stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "SGI_color_table", Version = "", EntryPoint = "glColorTableParameterivSGI")]
            public static extern void ColorTableParameter(OpenTK.Graphics.OpenGL.SgiColorTable target, OpenTK.Graphics.OpenGL.SgiColorTable pname, Int32[] @params);

            /// <summary>[requires: SGI_color_table]
            /// Set color lookup table parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The target color table. Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The symbolic name of a texture color lookup table parameter. Must be one of GL_COLOR_TABLE_SCALE or GL_COLOR_TABLE_BIAS.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// A pointer to an array where the values of the parameters are stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "SGI_color_table", Version = "", EntryPoint = "glColorTableParameterivSGI")]
            public static extern void ColorTableParameter(OpenTK.Graphics.OpenGL.SgiColorTable target, OpenTK.Graphics.OpenGL.SgiColorTable pname, ref Int32 @params);

            /// <summary>[requires: SGI_color_table]
            /// Set color lookup table parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The target color table. Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The symbolic name of a texture color lookup table parameter. Must be one of GL_COLOR_TABLE_SCALE or GL_COLOR_TABLE_BIAS.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// A pointer to an array where the values of the parameters are stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGI_color_table", Version = "", EntryPoint = "glColorTableParameterivSGI")]
            public static extern unsafe void ColorTableParameter(OpenTK.Graphics.OpenGL.SgiColorTable target, OpenTK.Graphics.OpenGL.SgiColorTable pname, Int32* @params);

            /// <summary>[requires: SGI_color_table]
            /// Define a color lookup table
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be one of GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, GL_POST_COLOR_MATRIX_COLOR_TABLE, GL_PROXY_COLOR_TABLE, GL_PROXY_POST_CONVOLUTION_COLOR_TABLE, or GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// The internal format of the color table. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, and GL_RGBA16.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// The number of entries in the color lookup table specified by data.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in data. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in data. The allowable values are GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data that is processed to build the color table.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "SGI_color_table", Version = "", EntryPoint = "glColorTableSGI")]
            public static extern void ColorTable(OpenTK.Graphics.OpenGL.SgiColorTable target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr table);

            /// <summary>[requires: SGI_color_table]
            /// Define a color lookup table
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be one of GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, GL_POST_COLOR_MATRIX_COLOR_TABLE, GL_PROXY_COLOR_TABLE, GL_PROXY_POST_CONVOLUTION_COLOR_TABLE, or GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// The internal format of the color table. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, and GL_RGBA16.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// The number of entries in the color lookup table specified by data.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in data. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in data. The allowable values are GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data that is processed to build the color table.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "SGI_color_table", Version = "", EntryPoint = "glColorTableSGI")]
            public static extern void ColorTable<T5>(OpenTK.Graphics.OpenGL.SgiColorTable target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T5[] table)
                where T5 : struct
            ;

            /// <summary>[requires: SGI_color_table]
            /// Define a color lookup table
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be one of GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, GL_POST_COLOR_MATRIX_COLOR_TABLE, GL_PROXY_COLOR_TABLE, GL_PROXY_POST_CONVOLUTION_COLOR_TABLE, or GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// The internal format of the color table. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, and GL_RGBA16.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// The number of entries in the color lookup table specified by data.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in data. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in data. The allowable values are GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data that is processed to build the color table.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "SGI_color_table", Version = "", EntryPoint = "glColorTableSGI")]
            public static extern void ColorTable<T5>(OpenTK.Graphics.OpenGL.SgiColorTable target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T5[,] table)
                where T5 : struct
            ;

            /// <summary>[requires: SGI_color_table]
            /// Define a color lookup table
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be one of GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, GL_POST_COLOR_MATRIX_COLOR_TABLE, GL_PROXY_COLOR_TABLE, GL_PROXY_POST_CONVOLUTION_COLOR_TABLE, or GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// The internal format of the color table. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, and GL_RGBA16.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// The number of entries in the color lookup table specified by data.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in data. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in data. The allowable values are GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data that is processed to build the color table.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "SGI_color_table", Version = "", EntryPoint = "glColorTableSGI")]
            public static extern void ColorTable<T5>(OpenTK.Graphics.OpenGL.SgiColorTable target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T5[,,] table)
                where T5 : struct
            ;

            /// <summary>[requires: SGI_color_table]
            /// Define a color lookup table
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be one of GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, GL_POST_COLOR_MATRIX_COLOR_TABLE, GL_PROXY_COLOR_TABLE, GL_PROXY_POST_CONVOLUTION_COLOR_TABLE, or GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// The internal format of the color table. The allowable values are GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, and GL_RGBA16.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// The number of entries in the color lookup table specified by data.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in data. The allowable values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in data. The allowable values are GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
            /// </para>
            /// </param>
            /// <param name="data">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data that is processed to build the color table.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "SGI_color_table", Version = "", EntryPoint = "glColorTableSGI")]
            public static extern void ColorTable<T5>(OpenTK.Graphics.OpenGL.SgiColorTable target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T5 table)
                where T5 : struct
            ;

            /// <summary>[requires: SGI_color_table]
            /// Copy pixels into a color table
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The color table target. Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="internalformat">
            /// <para>
            /// The internal storage format of the texture image. Must be one of the following symbolic constants: GL_ALPHA, GL_ALPHA4, GL_ALPHA8, GL_ALPHA12, GL_ALPHA16, GL_LUMINANCE, GL_LUMINANCE4, GL_LUMINANCE8, GL_LUMINANCE12, GL_LUMINANCE16, GL_LUMINANCE_ALPHA, GL_LUMINANCE4_ALPHA4, GL_LUMINANCE6_ALPHA2, GL_LUMINANCE8_ALPHA8, GL_LUMINANCE12_ALPHA4, GL_LUMINANCE12_ALPHA12, GL_LUMINANCE16_ALPHA16, GL_INTENSITY, GL_INTENSITY4, GL_INTENSITY8, GL_INTENSITY12, GL_INTENSITY16, GL_R3_G3_B2, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2, GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, or GL_RGBA16.
            /// </para>
            /// </param>
            /// <param name="x">
            /// <para>
            /// The x coordinate of the lower-left corner of the pixel rectangle to be transferred to the color table.
            /// </para>
            /// </param>
            /// <param name="y">
            /// <para>
            /// The y coordinate of the lower-left corner of the pixel rectangle to be transferred to the color table.
            /// </para>
            /// </param>
            /// <param name="width">
            /// <para>
            /// The width of the pixel rectangle.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "SGI_color_table", Version = "", EntryPoint = "glCopyColorTableSGI")]
            public static extern void CopyColorTable(OpenTK.Graphics.OpenGL.SgiColorTable target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 x, Int32 y, Int32 width);

            /// <summary>[requires: SGI_color_table]
            /// Get color lookup table parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The target color table. Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, GL_POST_COLOR_MATRIX_COLOR_TABLE, GL_PROXY_COLOR_TABLE, GL_PROXY_POST_CONVOLUTION_COLOR_TABLE, or GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The symbolic name of a color lookup table parameter. Must be one of GL_COLOR_TABLE_BIAS, GL_COLOR_TABLE_SCALE, GL_COLOR_TABLE_FORMAT, GL_COLOR_TABLE_WIDTH, GL_COLOR_TABLE_RED_SIZE, GL_COLOR_TABLE_GREEN_SIZE, GL_COLOR_TABLE_BLUE_SIZE, GL_COLOR_TABLE_ALPHA_SIZE, GL_COLOR_TABLE_LUMINANCE_SIZE, or GL_COLOR_TABLE_INTENSITY_SIZE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// A pointer to an array where the values of the parameter will be stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "SGI_color_table", Version = "", EntryPoint = "glGetColorTableParameterfvSGI")]
            public static extern void GetColorTableParameter(OpenTK.Graphics.OpenGL.SgiColorTable target, OpenTK.Graphics.OpenGL.SgiColorTable pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: SGI_color_table]
            /// Get color lookup table parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The target color table. Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, GL_POST_COLOR_MATRIX_COLOR_TABLE, GL_PROXY_COLOR_TABLE, GL_PROXY_POST_CONVOLUTION_COLOR_TABLE, or GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The symbolic name of a color lookup table parameter. Must be one of GL_COLOR_TABLE_BIAS, GL_COLOR_TABLE_SCALE, GL_COLOR_TABLE_FORMAT, GL_COLOR_TABLE_WIDTH, GL_COLOR_TABLE_RED_SIZE, GL_COLOR_TABLE_GREEN_SIZE, GL_COLOR_TABLE_BLUE_SIZE, GL_COLOR_TABLE_ALPHA_SIZE, GL_COLOR_TABLE_LUMINANCE_SIZE, or GL_COLOR_TABLE_INTENSITY_SIZE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// A pointer to an array where the values of the parameter will be stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "SGI_color_table", Version = "", EntryPoint = "glGetColorTableParameterfvSGI")]
            public static extern void GetColorTableParameter(OpenTK.Graphics.OpenGL.SgiColorTable target, OpenTK.Graphics.OpenGL.SgiColorTable pname, [OutAttribute] out Single @params);

            /// <summary>[requires: SGI_color_table]
            /// Get color lookup table parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The target color table. Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, GL_POST_COLOR_MATRIX_COLOR_TABLE, GL_PROXY_COLOR_TABLE, GL_PROXY_POST_CONVOLUTION_COLOR_TABLE, or GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The symbolic name of a color lookup table parameter. Must be one of GL_COLOR_TABLE_BIAS, GL_COLOR_TABLE_SCALE, GL_COLOR_TABLE_FORMAT, GL_COLOR_TABLE_WIDTH, GL_COLOR_TABLE_RED_SIZE, GL_COLOR_TABLE_GREEN_SIZE, GL_COLOR_TABLE_BLUE_SIZE, GL_COLOR_TABLE_ALPHA_SIZE, GL_COLOR_TABLE_LUMINANCE_SIZE, or GL_COLOR_TABLE_INTENSITY_SIZE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// A pointer to an array where the values of the parameter will be stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGI_color_table", Version = "", EntryPoint = "glGetColorTableParameterfvSGI")]
            public static extern unsafe void GetColorTableParameter(OpenTK.Graphics.OpenGL.SgiColorTable target, OpenTK.Graphics.OpenGL.SgiColorTable pname, [OutAttribute] Single* @params);

            /// <summary>[requires: SGI_color_table]
            /// Get color lookup table parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The target color table. Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, GL_POST_COLOR_MATRIX_COLOR_TABLE, GL_PROXY_COLOR_TABLE, GL_PROXY_POST_CONVOLUTION_COLOR_TABLE, or GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The symbolic name of a color lookup table parameter. Must be one of GL_COLOR_TABLE_BIAS, GL_COLOR_TABLE_SCALE, GL_COLOR_TABLE_FORMAT, GL_COLOR_TABLE_WIDTH, GL_COLOR_TABLE_RED_SIZE, GL_COLOR_TABLE_GREEN_SIZE, GL_COLOR_TABLE_BLUE_SIZE, GL_COLOR_TABLE_ALPHA_SIZE, GL_COLOR_TABLE_LUMINANCE_SIZE, or GL_COLOR_TABLE_INTENSITY_SIZE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// A pointer to an array where the values of the parameter will be stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "SGI_color_table", Version = "", EntryPoint = "glGetColorTableParameterivSGI")]
            public static extern void GetColorTableParameter(OpenTK.Graphics.OpenGL.SgiColorTable target, OpenTK.Graphics.OpenGL.SgiColorTable pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: SGI_color_table]
            /// Get color lookup table parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The target color table. Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, GL_POST_COLOR_MATRIX_COLOR_TABLE, GL_PROXY_COLOR_TABLE, GL_PROXY_POST_CONVOLUTION_COLOR_TABLE, or GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The symbolic name of a color lookup table parameter. Must be one of GL_COLOR_TABLE_BIAS, GL_COLOR_TABLE_SCALE, GL_COLOR_TABLE_FORMAT, GL_COLOR_TABLE_WIDTH, GL_COLOR_TABLE_RED_SIZE, GL_COLOR_TABLE_GREEN_SIZE, GL_COLOR_TABLE_BLUE_SIZE, GL_COLOR_TABLE_ALPHA_SIZE, GL_COLOR_TABLE_LUMINANCE_SIZE, or GL_COLOR_TABLE_INTENSITY_SIZE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// A pointer to an array where the values of the parameter will be stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "SGI_color_table", Version = "", EntryPoint = "glGetColorTableParameterivSGI")]
            public static extern void GetColorTableParameter(OpenTK.Graphics.OpenGL.SgiColorTable target, OpenTK.Graphics.OpenGL.SgiColorTable pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: SGI_color_table]
            /// Get color lookup table parameters
            /// </summary>
            /// <param name="target">
            /// <para>
            /// The target color table. Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, GL_POST_COLOR_MATRIX_COLOR_TABLE, GL_PROXY_COLOR_TABLE, GL_PROXY_POST_CONVOLUTION_COLOR_TABLE, or GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="pname">
            /// <para>
            /// The symbolic name of a color lookup table parameter. Must be one of GL_COLOR_TABLE_BIAS, GL_COLOR_TABLE_SCALE, GL_COLOR_TABLE_FORMAT, GL_COLOR_TABLE_WIDTH, GL_COLOR_TABLE_RED_SIZE, GL_COLOR_TABLE_GREEN_SIZE, GL_COLOR_TABLE_BLUE_SIZE, GL_COLOR_TABLE_ALPHA_SIZE, GL_COLOR_TABLE_LUMINANCE_SIZE, or GL_COLOR_TABLE_INTENSITY_SIZE.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// A pointer to an array where the values of the parameter will be stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGI_color_table", Version = "", EntryPoint = "glGetColorTableParameterivSGI")]
            public static extern unsafe void GetColorTableParameter(OpenTK.Graphics.OpenGL.SgiColorTable target, OpenTK.Graphics.OpenGL.SgiColorTable pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: SGI_color_table]
            /// Retrieve contents of a color lookup table
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in table. The possible values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in table. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="table">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data containing the contents of the color table.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "SGI_color_table", Version = "", EntryPoint = "glGetColorTableSGI")]
            public static extern void GetColorTable(OpenTK.Graphics.OpenGL.SgiColorTable target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [OutAttribute] IntPtr table);

            /// <summary>[requires: SGI_color_table]
            /// Retrieve contents of a color lookup table
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in table. The possible values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in table. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="table">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data containing the contents of the color table.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "SGI_color_table", Version = "", EntryPoint = "glGetColorTableSGI")]
            public static extern void GetColorTable<T3>(OpenTK.Graphics.OpenGL.SgiColorTable target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T3[] table)
                where T3 : struct
            ;

            /// <summary>[requires: SGI_color_table]
            /// Retrieve contents of a color lookup table
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in table. The possible values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in table. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="table">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data containing the contents of the color table.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "SGI_color_table", Version = "", EntryPoint = "glGetColorTableSGI")]
            public static extern void GetColorTable<T3>(OpenTK.Graphics.OpenGL.SgiColorTable target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T3[,] table)
                where T3 : struct
            ;

            /// <summary>[requires: SGI_color_table]
            /// Retrieve contents of a color lookup table
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in table. The possible values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in table. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="table">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data containing the contents of the color table.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "SGI_color_table", Version = "", EntryPoint = "glGetColorTableSGI")]
            public static extern void GetColorTable<T3>(OpenTK.Graphics.OpenGL.SgiColorTable target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T3[,,] table)
                where T3 : struct
            ;

            /// <summary>[requires: SGI_color_table]
            /// Retrieve contents of a color lookup table
            /// </summary>
            /// <param name="target">
            /// <para>
            /// Must be GL_COLOR_TABLE, GL_POST_CONVOLUTION_COLOR_TABLE, or GL_POST_COLOR_MATRIX_COLOR_TABLE.
            /// </para>
            /// </param>
            /// <param name="format">
            /// <para>
            /// The format of the pixel data in table. The possible values are GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
            /// </para>
            /// </param>
            /// <param name="type">
            /// <para>
            /// The type of the pixel data in table. Symbolic constants GL_UNSIGNED_BYTE, GL_BYTE, GL_BITMAP, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted.
            /// </para>
            /// </param>
            /// <param name="table">
            /// <para>
            /// Pointer to a one-dimensional array of pixel data containing the contents of the color table.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "SGI_color_table", Version = "", EntryPoint = "glGetColorTableSGI")]
            public static extern void GetColorTable<T3>(OpenTK.Graphics.OpenGL.SgiColorTable target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T3 table)
                where T3 : struct
            ;

        }

        public static partial class Sgis
        {
            /// <summary>[requires: SGIS_detail_texture]</summary>
            [AutoGenerated(Category = "SGIS_detail_texture", Version = "", EntryPoint = "glDetailTexFuncSGIS")]
            public static extern void DetailTexFunc(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 n, Single[] points);

            /// <summary>[requires: SGIS_detail_texture]</summary>
            [AutoGenerated(Category = "SGIS_detail_texture", Version = "", EntryPoint = "glDetailTexFuncSGIS")]
            public static extern void DetailTexFunc(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 n, ref Single points);

            /// <summary>[requires: SGIS_detail_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIS_detail_texture", Version = "", EntryPoint = "glDetailTexFuncSGIS")]
            public static extern unsafe void DetailTexFunc(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 n, Single* points);

            /// <summary>[requires: SGIS_fog_function]</summary>
            [AutoGenerated(Category = "SGIS_fog_function", Version = "", EntryPoint = "glFogFuncSGIS")]
            public static extern void FogFunc(Int32 n, Single[] points);

            /// <summary>[requires: SGIS_fog_function]</summary>
            [AutoGenerated(Category = "SGIS_fog_function", Version = "", EntryPoint = "glFogFuncSGIS")]
            public static extern void FogFunc(Int32 n, ref Single points);

            /// <summary>[requires: SGIS_fog_function]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIS_fog_function", Version = "", EntryPoint = "glFogFuncSGIS")]
            public static extern unsafe void FogFunc(Int32 n, Single* points);

            /// <summary>[requires: SGIS_detail_texture]</summary>
            [AutoGenerated(Category = "SGIS_detail_texture", Version = "", EntryPoint = "glGetDetailTexFuncSGIS")]
            public static extern Single GetDetailTexFunc(OpenTK.Graphics.OpenGL.TextureTarget target);

            /// <summary>[requires: SGIS_detail_texture]</summary>
            [AutoGenerated(Category = "SGIS_detail_texture", Version = "", EntryPoint = "glGetDetailTexFuncSGIS")]
            public static extern void GetDetailTexFunc(OpenTK.Graphics.OpenGL.TextureTarget target, [OutAttribute] Single[] points);

            /// <summary>[requires: SGIS_detail_texture]</summary>
            [AutoGenerated(Category = "SGIS_detail_texture", Version = "", EntryPoint = "glGetDetailTexFuncSGIS")]
            public static extern void GetDetailTexFunc(OpenTK.Graphics.OpenGL.TextureTarget target, [OutAttribute] out Single points);

            /// <summary>[requires: SGIS_detail_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIS_detail_texture", Version = "", EntryPoint = "glGetDetailTexFuncSGIS")]
            public static extern unsafe void GetDetailTexFunc(OpenTK.Graphics.OpenGL.TextureTarget target, [OutAttribute] Single* points);

            /// <summary>[requires: SGIS_fog_function]</summary>
            [AutoGenerated(Category = "SGIS_fog_function", Version = "", EntryPoint = "glGetFogFuncSGIS")]
            public static extern Single GetFogFunc();

            /// <summary>[requires: SGIS_fog_function]</summary>
            [AutoGenerated(Category = "SGIS_fog_function", Version = "", EntryPoint = "glGetFogFuncSGIS")]
            public static extern void GetFogFunc([OutAttribute] Single[] points);

            /// <summary>[requires: SGIS_fog_function]</summary>
            [AutoGenerated(Category = "SGIS_fog_function", Version = "", EntryPoint = "glGetFogFuncSGIS")]
            public static extern void GetFogFunc([OutAttribute] out Single points);

            /// <summary>[requires: SGIS_fog_function]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIS_fog_function", Version = "", EntryPoint = "glGetFogFuncSGIS")]
            public static extern unsafe void GetFogFunc([OutAttribute] Single* points);

            /// <summary>[requires: SGIS_pixel_texture]</summary>
            [AutoGenerated(Category = "SGIS_pixel_texture", Version = "", EntryPoint = "glGetPixelTexGenParameterfvSGIS")]
            public static extern Single GetPixelTexGenParameter(OpenTK.Graphics.OpenGL.SgisPixelTexture pname);

            /// <summary>[requires: SGIS_pixel_texture]</summary>
            [AutoGenerated(Category = "SGIS_pixel_texture", Version = "", EntryPoint = "glGetPixelTexGenParameterfvSGIS")]
            public static extern void GetPixelTexGenParameter(OpenTK.Graphics.OpenGL.SgisPixelTexture pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: SGIS_pixel_texture]</summary>
            [AutoGenerated(Category = "SGIS_pixel_texture", Version = "", EntryPoint = "glGetPixelTexGenParameterfvSGIS")]
            public static extern void GetPixelTexGenParameter(OpenTK.Graphics.OpenGL.SgisPixelTexture pname, [OutAttribute] out Single @params);

            /// <summary>[requires: SGIS_pixel_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIS_pixel_texture", Version = "", EntryPoint = "glGetPixelTexGenParameterfvSGIS")]
            public static extern unsafe void GetPixelTexGenParameter(OpenTK.Graphics.OpenGL.SgisPixelTexture pname, [OutAttribute] Single* @params);

            /// <summary>[requires: SGIS_pixel_texture]</summary>
            [AutoGenerated(Category = "SGIS_pixel_texture", Version = "", EntryPoint = "glGetPixelTexGenParameterivSGIS")]
            public static extern void GetPixelTexGenParameter(OpenTK.Graphics.OpenGL.SgisPixelTexture pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: SGIS_pixel_texture]</summary>
            [AutoGenerated(Category = "SGIS_pixel_texture", Version = "", EntryPoint = "glGetPixelTexGenParameterivSGIS")]
            public static extern void GetPixelTexGenParameter(OpenTK.Graphics.OpenGL.SgisPixelTexture pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: SGIS_pixel_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIS_pixel_texture", Version = "", EntryPoint = "glGetPixelTexGenParameterivSGIS")]
            public static extern unsafe void GetPixelTexGenParameter(OpenTK.Graphics.OpenGL.SgisPixelTexture pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: SGIS_sharpen_texture]</summary>
            [AutoGenerated(Category = "SGIS_sharpen_texture", Version = "", EntryPoint = "glGetSharpenTexFuncSGIS")]
            public static extern Single GetSharpenTexFunc(OpenTK.Graphics.OpenGL.TextureTarget target);

            /// <summary>[requires: SGIS_sharpen_texture]</summary>
            [AutoGenerated(Category = "SGIS_sharpen_texture", Version = "", EntryPoint = "glGetSharpenTexFuncSGIS")]
            public static extern void GetSharpenTexFunc(OpenTK.Graphics.OpenGL.TextureTarget target, [OutAttribute] Single[] points);

            /// <summary>[requires: SGIS_sharpen_texture]</summary>
            [AutoGenerated(Category = "SGIS_sharpen_texture", Version = "", EntryPoint = "glGetSharpenTexFuncSGIS")]
            public static extern void GetSharpenTexFunc(OpenTK.Graphics.OpenGL.TextureTarget target, [OutAttribute] out Single points);

            /// <summary>[requires: SGIS_sharpen_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIS_sharpen_texture", Version = "", EntryPoint = "glGetSharpenTexFuncSGIS")]
            public static extern unsafe void GetSharpenTexFunc(OpenTK.Graphics.OpenGL.TextureTarget target, [OutAttribute] Single* points);

            /// <summary>[requires: SGIS_texture_filter4]</summary>
            [AutoGenerated(Category = "SGIS_texture_filter4", Version = "", EntryPoint = "glGetTexFilterFuncSGIS")]
            public static extern void GetTexFilterFunc(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.SgisTextureFilter4 filter, [OutAttribute] Single[] weights);

            /// <summary>[requires: SGIS_texture_filter4]</summary>
            [AutoGenerated(Category = "SGIS_texture_filter4", Version = "", EntryPoint = "glGetTexFilterFuncSGIS")]
            public static extern void GetTexFilterFunc(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.SgisTextureFilter4 filter, [OutAttribute] out Single weights);

            /// <summary>[requires: SGIS_texture_filter4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIS_texture_filter4", Version = "", EntryPoint = "glGetTexFilterFuncSGIS")]
            public static extern unsafe void GetTexFilterFunc(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.SgisTextureFilter4 filter, [OutAttribute] Single* weights);

            /// <summary>[requires: SGIS_pixel_texture]</summary>
            [AutoGenerated(Category = "SGIS_pixel_texture", Version = "", EntryPoint = "glPixelTexGenParameterfSGIS")]
            public static extern void PixelTexGenParameter(OpenTK.Graphics.OpenGL.SgisPixelTexture pname, Single param);

            /// <summary>[requires: SGIS_pixel_texture]</summary>
            [AutoGenerated(Category = "SGIS_pixel_texture", Version = "", EntryPoint = "glPixelTexGenParameterfvSGIS")]
            public static extern void PixelTexGenParameter(OpenTK.Graphics.OpenGL.SgisPixelTexture pname, Single[] @params);

            /// <summary>[requires: SGIS_pixel_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIS_pixel_texture", Version = "", EntryPoint = "glPixelTexGenParameterfvSGIS")]
            public static extern unsafe void PixelTexGenParameter(OpenTK.Graphics.OpenGL.SgisPixelTexture pname, Single* @params);

            /// <summary>[requires: SGIS_pixel_texture]</summary>
            [AutoGenerated(Category = "SGIS_pixel_texture", Version = "", EntryPoint = "glPixelTexGenParameteriSGIS")]
            public static extern void PixelTexGenParameter(OpenTK.Graphics.OpenGL.SgisPixelTexture pname, Int32 param);

            /// <summary>[requires: SGIS_pixel_texture]</summary>
            [AutoGenerated(Category = "SGIS_pixel_texture", Version = "", EntryPoint = "glPixelTexGenParameterivSGIS")]
            public static extern void PixelTexGenParameter(OpenTK.Graphics.OpenGL.SgisPixelTexture pname, Int32[] @params);

            /// <summary>[requires: SGIS_pixel_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIS_pixel_texture", Version = "", EntryPoint = "glPixelTexGenParameterivSGIS")]
            public static extern unsafe void PixelTexGenParameter(OpenTK.Graphics.OpenGL.SgisPixelTexture pname, Int32* @params);

            /// <summary>[requires: SGIS_point_parameters]
            /// Specify point parameters
            /// </summary>
            /// <param name="pname">
            /// <para>
            /// Specifies a single-valued point parameter. GL_POINT_FADE_THRESHOLD_SIZE, and GL_POINT_SPRITE_COORD_ORIGIN are accepted.
            /// </para>
            /// </param>
            /// <param name="param">
            /// <para>
            /// For glPointParameterf and glPointParameteri, specifies the value that pname will be set to.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// For glPointParameterfv and glPointParameteriv, specifies a pointer to an array where the value or values to be assigned to pname are stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "SGIS_point_parameters", Version = "", EntryPoint = "glPointParameterfSGIS")]
            public static extern void PointParameter(OpenTK.Graphics.OpenGL.SgisPointParameters pname, Single param);

            /// <summary>[requires: SGIS_point_parameters]
            /// Specify point parameters
            /// </summary>
            /// <param name="pname">
            /// <para>
            /// Specifies a single-valued point parameter. GL_POINT_FADE_THRESHOLD_SIZE, and GL_POINT_SPRITE_COORD_ORIGIN are accepted.
            /// </para>
            /// </param>
            /// <param name="param">
            /// <para>
            /// For glPointParameterf and glPointParameteri, specifies the value that pname will be set to.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// For glPointParameterfv and glPointParameteriv, specifies a pointer to an array where the value or values to be assigned to pname are stored.
            /// </para>
            /// </param>
            [AutoGenerated(Category = "SGIS_point_parameters", Version = "", EntryPoint = "glPointParameterfvSGIS")]
            public static extern void PointParameter(OpenTK.Graphics.OpenGL.SgisPointParameters pname, Single[] @params);

            /// <summary>[requires: SGIS_point_parameters]
            /// Specify point parameters
            /// </summary>
            /// <param name="pname">
            /// <para>
            /// Specifies a single-valued point parameter. GL_POINT_FADE_THRESHOLD_SIZE, and GL_POINT_SPRITE_COORD_ORIGIN are accepted.
            /// </para>
            /// </param>
            /// <param name="param">
            /// <para>
            /// For glPointParameterf and glPointParameteri, specifies the value that pname will be set to.
            /// </para>
            /// </param>
            /// <param name="params">
            /// <para>
            /// For glPointParameterfv and glPointParameteriv, specifies a pointer to an array where the value or values to be assigned to pname are stored.
            /// </para>
            /// </param>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIS_point_parameters", Version = "", EntryPoint = "glPointParameterfvSGIS")]
            public static extern unsafe void PointParameter(OpenTK.Graphics.OpenGL.SgisPointParameters pname, Single* @params);

            /// <summary>[requires: SGIS_multisample]</summary>
            [AutoGenerated(Category = "SGIS_multisample", Version = "", EntryPoint = "glSampleMaskSGIS")]
            public static extern void SampleMask(Single value, bool invert);

            /// <summary>[requires: SGIS_multisample]</summary>
            [AutoGenerated(Category = "SGIS_multisample", Version = "", EntryPoint = "glSamplePatternSGIS")]
            public static extern void SamplePattern(OpenTK.Graphics.OpenGL.SgisMultisample pattern);

            /// <summary>[requires: SGIS_sharpen_texture]</summary>
            [AutoGenerated(Category = "SGIS_sharpen_texture", Version = "", EntryPoint = "glSharpenTexFuncSGIS")]
            public static extern void SharpenTexFunc(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 n, Single[] points);

            /// <summary>[requires: SGIS_sharpen_texture]</summary>
            [AutoGenerated(Category = "SGIS_sharpen_texture", Version = "", EntryPoint = "glSharpenTexFuncSGIS")]
            public static extern void SharpenTexFunc(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 n, ref Single points);

            /// <summary>[requires: SGIS_sharpen_texture]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIS_sharpen_texture", Version = "", EntryPoint = "glSharpenTexFuncSGIS")]
            public static extern unsafe void SharpenTexFunc(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 n, Single* points);

            /// <summary>[requires: SGIS_texture_filter4]</summary>
            [AutoGenerated(Category = "SGIS_texture_filter4", Version = "", EntryPoint = "glTexFilterFuncSGIS")]
            public static extern void TexFilterFunc(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.SgisTextureFilter4 filter, Int32 n, Single[] weights);

            /// <summary>[requires: SGIS_texture_filter4]</summary>
            [AutoGenerated(Category = "SGIS_texture_filter4", Version = "", EntryPoint = "glTexFilterFuncSGIS")]
            public static extern void TexFilterFunc(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.SgisTextureFilter4 filter, Int32 n, ref Single weights);

            /// <summary>[requires: SGIS_texture_filter4]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIS_texture_filter4", Version = "", EntryPoint = "glTexFilterFuncSGIS")]
            public static extern unsafe void TexFilterFunc(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.SgisTextureFilter4 filter, Int32 n, Single* weights);

            /// <summary>[requires: SGIS_texture4D]</summary>
            [AutoGenerated(Category = "SGIS_texture4D", Version = "", EntryPoint = "glTexImage4DSGIS")]
            public static extern void TexImage4D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 depth, Int32 size4d, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

            /// <summary>[requires: SGIS_texture4D]</summary>
            [AutoGenerated(Category = "SGIS_texture4D", Version = "", EntryPoint = "glTexImage4DSGIS")]
            public static extern void TexImage4D<T10>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 depth, Int32 size4d, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T10[] pixels)
                where T10 : struct
            ;

            /// <summary>[requires: SGIS_texture4D]</summary>
            [AutoGenerated(Category = "SGIS_texture4D", Version = "", EntryPoint = "glTexImage4DSGIS")]
            public static extern void TexImage4D<T10>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 depth, Int32 size4d, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T10[,] pixels)
                where T10 : struct
            ;

            /// <summary>[requires: SGIS_texture4D]</summary>
            [AutoGenerated(Category = "SGIS_texture4D", Version = "", EntryPoint = "glTexImage4DSGIS")]
            public static extern void TexImage4D<T10>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 depth, Int32 size4d, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T10[,,] pixels)
                where T10 : struct
            ;

            /// <summary>[requires: SGIS_texture4D]</summary>
            [AutoGenerated(Category = "SGIS_texture4D", Version = "", EntryPoint = "glTexImage4DSGIS")]
            public static extern void TexImage4D<T10>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 depth, Int32 size4d, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T10 pixels)
                where T10 : struct
            ;

            /// <summary>[requires: SGIS_texture4D]</summary>
            [AutoGenerated(Category = "SGIS_texture4D", Version = "", EntryPoint = "glTexSubImage4DSGIS")]
            public static extern void TexSubImage4D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 woffset, Int32 width, Int32 height, Int32 depth, Int32 size4d, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);

            /// <summary>[requires: SGIS_texture4D]</summary>
            [AutoGenerated(Category = "SGIS_texture4D", Version = "", EntryPoint = "glTexSubImage4DSGIS")]
            public static extern void TexSubImage4D<T12>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 woffset, Int32 width, Int32 height, Int32 depth, Int32 size4d, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T12[] pixels)
                where T12 : struct
            ;

            /// <summary>[requires: SGIS_texture4D]</summary>
            [AutoGenerated(Category = "SGIS_texture4D", Version = "", EntryPoint = "glTexSubImage4DSGIS")]
            public static extern void TexSubImage4D<T12>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 woffset, Int32 width, Int32 height, Int32 depth, Int32 size4d, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T12[,] pixels)
                where T12 : struct
            ;

            /// <summary>[requires: SGIS_texture4D]</summary>
            [AutoGenerated(Category = "SGIS_texture4D", Version = "", EntryPoint = "glTexSubImage4DSGIS")]
            public static extern void TexSubImage4D<T12>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 woffset, Int32 width, Int32 height, Int32 depth, Int32 size4d, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] T12[,,] pixels)
                where T12 : struct
            ;

            /// <summary>[requires: SGIS_texture4D]</summary>
            [AutoGenerated(Category = "SGIS_texture4D", Version = "", EntryPoint = "glTexSubImage4DSGIS")]
            public static extern void TexSubImage4D<T12>(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 woffset, Int32 width, Int32 height, Int32 depth, Int32 size4d, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [InAttribute, OutAttribute] ref T12 pixels)
                where T12 : struct
            ;

            /// <summary>[requires: SGIS_texture_color_mask]</summary>
            [AutoGenerated(Category = "SGIS_texture_color_mask", Version = "", EntryPoint = "glTextureColorMaskSGIS")]
            public static extern void TextureColorMask(bool red, bool green, bool blue, bool alpha);

        }

        public static partial class Sgix
        {
            /// <summary>[requires: SGIX_async]</summary>
            [AutoGenerated(Category = "SGIX_async", Version = "", EntryPoint = "glAsyncMarkerSGIX")]
            public static extern void AsyncMarker(Int32 marker);

            /// <summary>[requires: SGIX_async]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_async", Version = "", EntryPoint = "glAsyncMarkerSGIX")]
            public static extern void AsyncMarker(UInt32 marker);

            /// <summary>[requires: SGIX_polynomial_ffd]</summary>
            [AutoGenerated(Category = "SGIX_polynomial_ffd", Version = "", EntryPoint = "glDeformationMap3dSGIX")]
            public static extern void DeformationMap3(OpenTK.Graphics.OpenGL.SgixPolynomialFfd target, Double u1, Double u2, Int32 ustride, Int32 uorder, Double v1, Double v2, Int32 vstride, Int32 vorder, Double w1, Double w2, Int32 wstride, Int32 worder, Double[] points);

            /// <summary>[requires: SGIX_polynomial_ffd]</summary>
            [AutoGenerated(Category = "SGIX_polynomial_ffd", Version = "", EntryPoint = "glDeformationMap3dSGIX")]
            public static extern void DeformationMap3(OpenTK.Graphics.OpenGL.SgixPolynomialFfd target, Double u1, Double u2, Int32 ustride, Int32 uorder, Double v1, Double v2, Int32 vstride, Int32 vorder, Double w1, Double w2, Int32 wstride, Int32 worder, ref Double points);

            /// <summary>[requires: SGIX_polynomial_ffd]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_polynomial_ffd", Version = "", EntryPoint = "glDeformationMap3dSGIX")]
            public static extern unsafe void DeformationMap3(OpenTK.Graphics.OpenGL.SgixPolynomialFfd target, Double u1, Double u2, Int32 ustride, Int32 uorder, Double v1, Double v2, Int32 vstride, Int32 vorder, Double w1, Double w2, Int32 wstride, Int32 worder, Double* points);

            /// <summary>[requires: SGIX_polynomial_ffd]</summary>
            [AutoGenerated(Category = "SGIX_polynomial_ffd", Version = "", EntryPoint = "glDeformationMap3fSGIX")]
            public static extern void DeformationMap3(OpenTK.Graphics.OpenGL.SgixPolynomialFfd target, Single u1, Single u2, Int32 ustride, Int32 uorder, Single v1, Single v2, Int32 vstride, Int32 vorder, Single w1, Single w2, Int32 wstride, Int32 worder, Single[] points);

            /// <summary>[requires: SGIX_polynomial_ffd]</summary>
            [AutoGenerated(Category = "SGIX_polynomial_ffd", Version = "", EntryPoint = "glDeformationMap3fSGIX")]
            public static extern void DeformationMap3(OpenTK.Graphics.OpenGL.SgixPolynomialFfd target, Single u1, Single u2, Int32 ustride, Int32 uorder, Single v1, Single v2, Int32 vstride, Int32 vorder, Single w1, Single w2, Int32 wstride, Int32 worder, ref Single points);

            /// <summary>[requires: SGIX_polynomial_ffd]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_polynomial_ffd", Version = "", EntryPoint = "glDeformationMap3fSGIX")]
            public static extern unsafe void DeformationMap3(OpenTK.Graphics.OpenGL.SgixPolynomialFfd target, Single u1, Single u2, Int32 ustride, Int32 uorder, Single v1, Single v2, Int32 vstride, Int32 vorder, Single w1, Single w2, Int32 wstride, Int32 worder, Single* points);

            /// <summary>[requires: SGIX_polynomial_ffd]</summary>
            [AutoGenerated(Category = "SGIX_polynomial_ffd", Version = "", EntryPoint = "glDeformSGIX")]
            public static extern void Deform(Int32 mask);

            /// <summary>[requires: SGIX_polynomial_ffd]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_polynomial_ffd", Version = "", EntryPoint = "glDeformSGIX")]
            public static extern void Deform(UInt32 mask);

            /// <summary>[requires: SGIX_async]</summary>
            [AutoGenerated(Category = "SGIX_async", Version = "", EntryPoint = "glDeleteAsyncMarkersSGIX")]
            public static extern void DeleteAsyncMarkers(Int32 marker, Int32 range);

            /// <summary>[requires: SGIX_async]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_async", Version = "", EntryPoint = "glDeleteAsyncMarkersSGIX")]
            public static extern void DeleteAsyncMarkers(UInt32 marker, Int32 range);

            /// <summary>[requires: SGIX_async]</summary>
            [AutoGenerated(Category = "SGIX_async", Version = "", EntryPoint = "glFinishAsyncSGIX")]
            public static extern Int32 FinishAsync([OutAttribute] out Int32 markerp);

            /// <summary>[requires: SGIX_async]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_async", Version = "", EntryPoint = "glFinishAsyncSGIX")]
            public static extern unsafe Int32 FinishAsync([OutAttribute] Int32* markerp);

            /// <summary>[requires: SGIX_async]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_async", Version = "", EntryPoint = "glFinishAsyncSGIX")]
            public static extern Int32 FinishAsync([OutAttribute] out UInt32 markerp);

            /// <summary>[requires: SGIX_async]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_async", Version = "", EntryPoint = "glFinishAsyncSGIX")]
            public static extern unsafe Int32 FinishAsync([OutAttribute] UInt32* markerp);

            /// <summary>[requires: SGIX_flush_raster]</summary>
            [AutoGenerated(Category = "SGIX_flush_raster", Version = "", EntryPoint = "glFlushRasterSGIX")]
            public static extern void FlushRaster();

            /// <summary>[requires: SGIX_fragment_lighting]</summary>
            [AutoGenerated(Category = "SGIX_fragment_lighting", Version = "", EntryPoint = "glFragmentColorMaterialSGIX")]
            public static extern void FragmentColorMaterial(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter mode);

            /// <summary>[requires: SGIX_fragment_lighting]</summary>
            [AutoGenerated(Category = "SGIX_fragment_lighting", Version = "", EntryPoint = "glFragmentLightfSGIX")]
            public static extern void FragmentLight(OpenTK.Graphics.OpenGL.SgixFragmentLighting light, OpenTK.Graphics.OpenGL.SgixFragmentLighting pname, Single param);

            /// <summary>[requires: SGIX_fragment_lighting]</summary>
            [AutoGenerated(Category = "SGIX_fragment_lighting", Version = "", EntryPoint = "glFragmentLightfvSGIX")]
            public static extern void FragmentLight(OpenTK.Graphics.OpenGL.SgixFragmentLighting light, OpenTK.Graphics.OpenGL.SgixFragmentLighting pname, Single[] @params);

            /// <summary>[requires: SGIX_fragment_lighting]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_fragment_lighting", Version = "", EntryPoint = "glFragmentLightfvSGIX")]
            public static extern unsafe void FragmentLight(OpenTK.Graphics.OpenGL.SgixFragmentLighting light, OpenTK.Graphics.OpenGL.SgixFragmentLighting pname, Single* @params);

            /// <summary>[requires: SGIX_fragment_lighting]</summary>
            [AutoGenerated(Category = "SGIX_fragment_lighting", Version = "", EntryPoint = "glFragmentLightiSGIX")]
            public static extern void FragmentLight(OpenTK.Graphics.OpenGL.SgixFragmentLighting light, OpenTK.Graphics.OpenGL.SgixFragmentLighting pname, Int32 param);

            /// <summary>[requires: SGIX_fragment_lighting]</summary>
            [AutoGenerated(Category = "SGIX_fragment_lighting", Version = "", EntryPoint = "glFragmentLightivSGIX")]
            public static extern void FragmentLight(OpenTK.Graphics.OpenGL.SgixFragmentLighting light, OpenTK.Graphics.OpenGL.SgixFragmentLighting pname, Int32[] @params);

            /// <summary>[requires: SGIX_fragment_lighting]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_fragment_lighting", Version = "", EntryPoint = "glFragmentLightivSGIX")]
            public static extern unsafe void FragmentLight(OpenTK.Graphics.OpenGL.SgixFragmentLighting light, OpenTK.Graphics.OpenGL.SgixFragmentLighting pname, Int32* @params);

            /// <summary>[requires: SGIX_fragment_lighting]</summary>
            [AutoGenerated(Category = "SGIX_fragment_lighting", Version = "", EntryPoint = "glFragmentLightModelfSGIX")]
            public static extern void FragmentLightModel(OpenTK.Graphics.OpenGL.SgixFragmentLighting pname, Single param);

            /// <summary>[requires: SGIX_fragment_lighting]</summary>
            [AutoGenerated(Category = "SGIX_fragment_lighting", Version = "", EntryPoint = "glFragmentLightModelfvSGIX")]
            public static extern void FragmentLightModel(OpenTK.Graphics.OpenGL.SgixFragmentLighting pname, Single[] @params);

            /// <summary>[requires: SGIX_fragment_lighting]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_fragment_lighting", Version = "", EntryPoint = "glFragmentLightModelfvSGIX")]
            public static extern unsafe void FragmentLightModel(OpenTK.Graphics.OpenGL.SgixFragmentLighting pname, Single* @params);

            /// <summary>[requires: SGIX_fragment_lighting]</summary>
            [AutoGenerated(Category = "SGIX_fragment_lighting", Version = "", EntryPoint = "glFragmentLightModeliSGIX")]
            public static extern void FragmentLightModel(OpenTK.Graphics.OpenGL.SgixFragmentLighting pname, Int32 param);

            /// <summary>[requires: SGIX_fragment_lighting]</summary>
            [AutoGenerated(Category = "SGIX_fragment_lighting", Version = "", EntryPoint = "glFragmentLightModelivSGIX")]
            public static extern void FragmentLightModel(OpenTK.Graphics.OpenGL.SgixFragmentLighting pname, Int32[] @params);

            /// <summary>[requires: SGIX_fragment_lighting]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_fragment_lighting", Version = "", EntryPoint = "glFragmentLightModelivSGIX")]
            public static extern unsafe void FragmentLightModel(OpenTK.Graphics.OpenGL.SgixFragmentLighting pname, Int32* @params);

            /// <summary>[requires: SGIX_fragment_lighting]</summary>
            [AutoGenerated(Category = "SGIX_fragment_lighting", Version = "", EntryPoint = "glFragmentMaterialfSGIX")]
            public static extern void FragmentMaterial(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, Single param);

            /// <summary>[requires: SGIX_fragment_lighting]</summary>
            [AutoGenerated(Category = "SGIX_fragment_lighting", Version = "", EntryPoint = "glFragmentMaterialfvSGIX")]
            public static extern void FragmentMaterial(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, Single[] @params);

            /// <summary>[requires: SGIX_fragment_lighting]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_fragment_lighting", Version = "", EntryPoint = "glFragmentMaterialfvSGIX")]
            public static extern unsafe void FragmentMaterial(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, Single* @params);

            /// <summary>[requires: SGIX_fragment_lighting]</summary>
            [AutoGenerated(Category = "SGIX_fragment_lighting", Version = "", EntryPoint = "glFragmentMaterialiSGIX")]
            public static extern void FragmentMaterial(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, Int32 param);

            /// <summary>[requires: SGIX_fragment_lighting]</summary>
            [AutoGenerated(Category = "SGIX_fragment_lighting", Version = "", EntryPoint = "glFragmentMaterialivSGIX")]
            public static extern void FragmentMaterial(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, Int32[] @params);

            /// <summary>[requires: SGIX_fragment_lighting]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_fragment_lighting", Version = "", EntryPoint = "glFragmentMaterialivSGIX")]
            public static extern unsafe void FragmentMaterial(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, Int32* @params);

            /// <summary>[requires: SGIX_framezoom]</summary>
            [AutoGenerated(Category = "SGIX_framezoom", Version = "", EntryPoint = "glFrameZoomSGIX")]
            public static extern void FrameZoom(Int32 factor);

            /// <summary>[requires: SGIX_async]</summary>
            [AutoGenerated(Category = "SGIX_async", Version = "", EntryPoint = "glGenAsyncMarkersSGIX")]
            public static extern Int32 GenAsyncMarkers(Int32 range);

            /// <summary>[requires: SGIX_fragment_lighting]</summary>
            [AutoGenerated(Category = "SGIX_fragment_lighting", Version = "", EntryPoint = "glGetFragmentLightfvSGIX")]
            public static extern void GetFragmentLight(OpenTK.Graphics.OpenGL.SgixFragmentLighting light, OpenTK.Graphics.OpenGL.SgixFragmentLighting pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: SGIX_fragment_lighting]</summary>
            [AutoGenerated(Category = "SGIX_fragment_lighting", Version = "", EntryPoint = "glGetFragmentLightfvSGIX")]
            public static extern void GetFragmentLight(OpenTK.Graphics.OpenGL.SgixFragmentLighting light, OpenTK.Graphics.OpenGL.SgixFragmentLighting pname, [OutAttribute] out Single @params);

            /// <summary>[requires: SGIX_fragment_lighting]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_fragment_lighting", Version = "", EntryPoint = "glGetFragmentLightfvSGIX")]
            public static extern unsafe void GetFragmentLight(OpenTK.Graphics.OpenGL.SgixFragmentLighting light, OpenTK.Graphics.OpenGL.SgixFragmentLighting pname, [OutAttribute] Single* @params);

            /// <summary>[requires: SGIX_fragment_lighting]</summary>
            [AutoGenerated(Category = "SGIX_fragment_lighting", Version = "", EntryPoint = "glGetFragmentLightivSGIX")]
            public static extern void GetFragmentLight(OpenTK.Graphics.OpenGL.SgixFragmentLighting light, OpenTK.Graphics.OpenGL.SgixFragmentLighting pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: SGIX_fragment_lighting]</summary>
            [AutoGenerated(Category = "SGIX_fragment_lighting", Version = "", EntryPoint = "glGetFragmentLightivSGIX")]
            public static extern void GetFragmentLight(OpenTK.Graphics.OpenGL.SgixFragmentLighting light, OpenTK.Graphics.OpenGL.SgixFragmentLighting pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: SGIX_fragment_lighting]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_fragment_lighting", Version = "", EntryPoint = "glGetFragmentLightivSGIX")]
            public static extern unsafe void GetFragmentLight(OpenTK.Graphics.OpenGL.SgixFragmentLighting light, OpenTK.Graphics.OpenGL.SgixFragmentLighting pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: SGIX_fragment_lighting]</summary>
            [AutoGenerated(Category = "SGIX_fragment_lighting", Version = "", EntryPoint = "glGetFragmentMaterialfvSGIX")]
            public static extern void GetFragmentMaterial(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: SGIX_fragment_lighting]</summary>
            [AutoGenerated(Category = "SGIX_fragment_lighting", Version = "", EntryPoint = "glGetFragmentMaterialfvSGIX")]
            public static extern void GetFragmentMaterial(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, [OutAttribute] out Single @params);

            /// <summary>[requires: SGIX_fragment_lighting]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_fragment_lighting", Version = "", EntryPoint = "glGetFragmentMaterialfvSGIX")]
            public static extern unsafe void GetFragmentMaterial(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, [OutAttribute] Single* @params);

            /// <summary>[requires: SGIX_fragment_lighting]</summary>
            [AutoGenerated(Category = "SGIX_fragment_lighting", Version = "", EntryPoint = "glGetFragmentMaterialivSGIX")]
            public static extern void GetFragmentMaterial(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: SGIX_fragment_lighting]</summary>
            [AutoGenerated(Category = "SGIX_fragment_lighting", Version = "", EntryPoint = "glGetFragmentMaterialivSGIX")]
            public static extern void GetFragmentMaterial(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: SGIX_fragment_lighting]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_fragment_lighting", Version = "", EntryPoint = "glGetFragmentMaterialivSGIX")]
            public static extern unsafe void GetFragmentMaterial(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: SGIX_instruments]</summary>
            [AutoGenerated(Category = "SGIX_instruments", Version = "", EntryPoint = "glGetInstrumentsSGIX")]
            public static extern Int32 GetInstruments();

            /// <summary>[requires: SGIX_list_priority]</summary>
            [AutoGenerated(Category = "SGIX_list_priority", Version = "", EntryPoint = "glGetListParameterfvSGIX")]
            public static extern void GetListParameter(Int32 list, OpenTK.Graphics.OpenGL.ListParameterName pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: SGIX_list_priority]</summary>
            [AutoGenerated(Category = "SGIX_list_priority", Version = "", EntryPoint = "glGetListParameterfvSGIX")]
            public static extern void GetListParameter(Int32 list, OpenTK.Graphics.OpenGL.ListParameterName pname, [OutAttribute] out Single @params);

            /// <summary>[requires: SGIX_list_priority]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_list_priority", Version = "", EntryPoint = "glGetListParameterfvSGIX")]
            public static extern unsafe void GetListParameter(Int32 list, OpenTK.Graphics.OpenGL.ListParameterName pname, [OutAttribute] Single* @params);

            /// <summary>[requires: SGIX_list_priority]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_list_priority", Version = "", EntryPoint = "glGetListParameterfvSGIX")]
            public static extern void GetListParameter(UInt32 list, OpenTK.Graphics.OpenGL.ListParameterName pname, [OutAttribute] Single[] @params);

            /// <summary>[requires: SGIX_list_priority]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_list_priority", Version = "", EntryPoint = "glGetListParameterfvSGIX")]
            public static extern void GetListParameter(UInt32 list, OpenTK.Graphics.OpenGL.ListParameterName pname, [OutAttribute] out Single @params);

            /// <summary>[requires: SGIX_list_priority]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_list_priority", Version = "", EntryPoint = "glGetListParameterfvSGIX")]
            public static extern unsafe void GetListParameter(UInt32 list, OpenTK.Graphics.OpenGL.ListParameterName pname, [OutAttribute] Single* @params);

            /// <summary>[requires: SGIX_list_priority]</summary>
            [AutoGenerated(Category = "SGIX_list_priority", Version = "", EntryPoint = "glGetListParameterivSGIX")]
            public static extern void GetListParameter(Int32 list, OpenTK.Graphics.OpenGL.ListParameterName pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: SGIX_list_priority]</summary>
            [AutoGenerated(Category = "SGIX_list_priority", Version = "", EntryPoint = "glGetListParameterivSGIX")]
            public static extern void GetListParameter(Int32 list, OpenTK.Graphics.OpenGL.ListParameterName pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: SGIX_list_priority]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_list_priority", Version = "", EntryPoint = "glGetListParameterivSGIX")]
            public static extern unsafe void GetListParameter(Int32 list, OpenTK.Graphics.OpenGL.ListParameterName pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: SGIX_list_priority]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_list_priority", Version = "", EntryPoint = "glGetListParameterivSGIX")]
            public static extern void GetListParameter(UInt32 list, OpenTK.Graphics.OpenGL.ListParameterName pname, [OutAttribute] Int32[] @params);

            /// <summary>[requires: SGIX_list_priority]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_list_priority", Version = "", EntryPoint = "glGetListParameterivSGIX")]
            public static extern void GetListParameter(UInt32 list, OpenTK.Graphics.OpenGL.ListParameterName pname, [OutAttribute] out Int32 @params);

            /// <summary>[requires: SGIX_list_priority]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_list_priority", Version = "", EntryPoint = "glGetListParameterivSGIX")]
            public static extern unsafe void GetListParameter(UInt32 list, OpenTK.Graphics.OpenGL.ListParameterName pname, [OutAttribute] Int32* @params);

            /// <summary>[requires: SGIX_igloo_interface]</summary>
            [Obsolete("Use SgixIglooInterface overload instead")]
            [AutoGenerated(Category = "SGIX_igloo_interface", Version = "", EntryPoint = "glIglooInterfaceSGIX")]
            public static extern void IglooInterface(OpenTK.Graphics.OpenGL.All pname, IntPtr @params);

            /// <summary>[requires: SGIX_igloo_interface]</summary>
            [Obsolete("Use SgixIglooInterface overload instead")]
            [AutoGenerated(Category = "SGIX_igloo_interface", Version = "", EntryPoint = "glIglooInterfaceSGIX")]
            public static extern void IglooInterface<T1>(OpenTK.Graphics.OpenGL.All pname, [InAttribute, OutAttribute] T1[] @params)
                where T1 : struct
            ;

            /// <summary>[requires: SGIX_igloo_interface]</summary>
            [Obsolete("Use SgixIglooInterface overload instead")]
            [AutoGenerated(Category = "SGIX_igloo_interface", Version = "", EntryPoint = "glIglooInterfaceSGIX")]
            public static extern void IglooInterface<T1>(OpenTK.Graphics.OpenGL.All pname, [InAttribute, OutAttribute] T1[,] @params)
                where T1 : struct
            ;

            /// <summary>[requires: SGIX_igloo_interface]</summary>
            [Obsolete("Use SgixIglooInterface overload instead")]
            [AutoGenerated(Category = "SGIX_igloo_interface", Version = "", EntryPoint = "glIglooInterfaceSGIX")]
            public static extern void IglooInterface<T1>(OpenTK.Graphics.OpenGL.All pname, [InAttribute, OutAttribute] T1[,,] @params)
                where T1 : struct
            ;

            /// <summary>[requires: SGIX_igloo_interface]</summary>
            [Obsolete("Use SgixIglooInterface overload instead")]
            [AutoGenerated(Category = "SGIX_igloo_interface", Version = "", EntryPoint = "glIglooInterfaceSGIX")]
            public static extern void IglooInterface<T1>(OpenTK.Graphics.OpenGL.All pname, [InAttribute, OutAttribute] ref T1 @params)
                where T1 : struct
            ;

            /// <summary>[requires: SGIX_igloo_interface]</summary>
            [AutoGenerated(Category = "SGIX_igloo_interface", Version = "", EntryPoint = "glIglooInterfaceSGIX")]
            public static extern void IglooInterface(OpenTK.Graphics.OpenGL.SgixIglooInterface pname, IntPtr @params);

            /// <summary>[requires: SGIX_igloo_interface]</summary>
            [AutoGenerated(Category = "SGIX_igloo_interface", Version = "", EntryPoint = "glIglooInterfaceSGIX")]
            public static extern void IglooInterface<T1>(OpenTK.Graphics.OpenGL.SgixIglooInterface pname, [InAttribute, OutAttribute] T1[] @params)
                where T1 : struct
            ;

            /// <summary>[requires: SGIX_igloo_interface]</summary>
            [AutoGenerated(Category = "SGIX_igloo_interface", Version = "", EntryPoint = "glIglooInterfaceSGIX")]
            public static extern void IglooInterface<T1>(OpenTK.Graphics.OpenGL.SgixIglooInterface pname, [InAttribute, OutAttribute] T1[,] @params)
                where T1 : struct
            ;

            /// <summary>[requires: SGIX_igloo_interface]</summary>
            [AutoGenerated(Category = "SGIX_igloo_interface", Version = "", EntryPoint = "glIglooInterfaceSGIX")]
            public static extern void IglooInterface<T1>(OpenTK.Graphics.OpenGL.SgixIglooInterface pname, [InAttribute, OutAttribute] T1[,,] @params)
                where T1 : struct
            ;

            /// <summary>[requires: SGIX_igloo_interface]</summary>
            [AutoGenerated(Category = "SGIX_igloo_interface", Version = "", EntryPoint = "glIglooInterfaceSGIX")]
            public static extern void IglooInterface<T1>(OpenTK.Graphics.OpenGL.SgixIglooInterface pname, [InAttribute, OutAttribute] ref T1 @params)
                where T1 : struct
            ;

            /// <summary>[requires: SGIX_instruments]</summary>
            [AutoGenerated(Category = "SGIX_instruments", Version = "", EntryPoint = "glInstrumentsBufferSGIX")]
            public static extern void InstrumentsBuffer(Int32 size, [OutAttribute] Int32[] buffer);

            /// <summary>[requires: SGIX_instruments]</summary>
            [AutoGenerated(Category = "SGIX_instruments", Version = "", EntryPoint = "glInstrumentsBufferSGIX")]
            public static extern void InstrumentsBuffer(Int32 size, [OutAttribute] out Int32 buffer);

            /// <summary>[requires: SGIX_instruments]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_instruments", Version = "", EntryPoint = "glInstrumentsBufferSGIX")]
            public static extern unsafe void InstrumentsBuffer(Int32 size, [OutAttribute] Int32* buffer);

            /// <summary>[requires: SGIX_async]</summary>
            [AutoGenerated(Category = "SGIX_async", Version = "", EntryPoint = "glIsAsyncMarkerSGIX")]
            public static extern bool IsAsyncMarker(Int32 marker);

            /// <summary>[requires: SGIX_async]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_async", Version = "", EntryPoint = "glIsAsyncMarkerSGIX")]
            public static extern bool IsAsyncMarker(UInt32 marker);

            /// <summary>[requires: SGIX_fragment_lighting]</summary>
            [AutoGenerated(Category = "SGIX_fragment_lighting", Version = "", EntryPoint = "glLightEnviSGIX")]
            public static extern void LightEnv(OpenTK.Graphics.OpenGL.SgixFragmentLighting pname, Int32 param);

            /// <summary>[requires: SGIX_list_priority]</summary>
            [AutoGenerated(Category = "SGIX_list_priority", Version = "", EntryPoint = "glListParameterfSGIX")]
            public static extern void ListParameter(Int32 list, OpenTK.Graphics.OpenGL.ListParameterName pname, Single param);

            /// <summary>[requires: SGIX_list_priority]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_list_priority", Version = "", EntryPoint = "glListParameterfSGIX")]
            public static extern void ListParameter(UInt32 list, OpenTK.Graphics.OpenGL.ListParameterName pname, Single param);

            /// <summary>[requires: SGIX_list_priority]</summary>
            [AutoGenerated(Category = "SGIX_list_priority", Version = "", EntryPoint = "glListParameterfvSGIX")]
            public static extern void ListParameter(Int32 list, OpenTK.Graphics.OpenGL.ListParameterName pname, Single[] @params);

            /// <summary>[requires: SGIX_list_priority]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_list_priority", Version = "", EntryPoint = "glListParameterfvSGIX")]
            public static extern unsafe void ListParameter(Int32 list, OpenTK.Graphics.OpenGL.ListParameterName pname, Single* @params);

            /// <summary>[requires: SGIX_list_priority]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_list_priority", Version = "", EntryPoint = "glListParameterfvSGIX")]
            public static extern void ListParameter(UInt32 list, OpenTK.Graphics.OpenGL.ListParameterName pname, Single[] @params);

            /// <summary>[requires: SGIX_list_priority]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_list_priority", Version = "", EntryPoint = "glListParameterfvSGIX")]
            public static extern unsafe void ListParameter(UInt32 list, OpenTK.Graphics.OpenGL.ListParameterName pname, Single* @params);

            /// <summary>[requires: SGIX_list_priority]</summary>
            [AutoGenerated(Category = "SGIX_list_priority", Version = "", EntryPoint = "glListParameteriSGIX")]
            public static extern void ListParameter(Int32 list, OpenTK.Graphics.OpenGL.ListParameterName pname, Int32 param);

            /// <summary>[requires: SGIX_list_priority]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_list_priority", Version = "", EntryPoint = "glListParameteriSGIX")]
            public static extern void ListParameter(UInt32 list, OpenTK.Graphics.OpenGL.ListParameterName pname, Int32 param);

            /// <summary>[requires: SGIX_list_priority]</summary>
            [AutoGenerated(Category = "SGIX_list_priority", Version = "", EntryPoint = "glListParameterivSGIX")]
            public static extern void ListParameter(Int32 list, OpenTK.Graphics.OpenGL.ListParameterName pname, Int32[] @params);

            /// <summary>[requires: SGIX_list_priority]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_list_priority", Version = "", EntryPoint = "glListParameterivSGIX")]
            public static extern unsafe void ListParameter(Int32 list, OpenTK.Graphics.OpenGL.ListParameterName pname, Int32* @params);

            /// <summary>[requires: SGIX_list_priority]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_list_priority", Version = "", EntryPoint = "glListParameterivSGIX")]
            public static extern void ListParameter(UInt32 list, OpenTK.Graphics.OpenGL.ListParameterName pname, Int32[] @params);

            /// <summary>[requires: SGIX_list_priority]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_list_priority", Version = "", EntryPoint = "glListParameterivSGIX")]
            public static extern unsafe void ListParameter(UInt32 list, OpenTK.Graphics.OpenGL.ListParameterName pname, Int32* @params);

            /// <summary>[requires: SGIX_polynomial_ffd]</summary>
            [AutoGenerated(Category = "SGIX_polynomial_ffd", Version = "", EntryPoint = "glLoadIdentityDeformationMapSGIX")]
            public static extern void LoadIdentityDeformationMap(Int32 mask);

            /// <summary>[requires: SGIX_polynomial_ffd]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_polynomial_ffd", Version = "", EntryPoint = "glLoadIdentityDeformationMapSGIX")]
            public static extern void LoadIdentityDeformationMap(UInt32 mask);

            /// <summary>[requires: SGIX_pixel_texture]</summary>
            [AutoGenerated(Category = "SGIX_pixel_texture", Version = "", EntryPoint = "glPixelTexGenSGIX")]
            public static extern void PixelTexGen(OpenTK.Graphics.OpenGL.SgixPixelTexture mode);

            /// <summary>[requires: SGIX_async]</summary>
            [AutoGenerated(Category = "SGIX_async", Version = "", EntryPoint = "glPollAsyncSGIX")]
            public static extern Int32 PollAsync([OutAttribute] out Int32 markerp);

            /// <summary>[requires: SGIX_async]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_async", Version = "", EntryPoint = "glPollAsyncSGIX")]
            public static extern unsafe Int32 PollAsync([OutAttribute] Int32* markerp);

            /// <summary>[requires: SGIX_async]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_async", Version = "", EntryPoint = "glPollAsyncSGIX")]
            public static extern Int32 PollAsync([OutAttribute] out UInt32 markerp);

            /// <summary>[requires: SGIX_async]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_async", Version = "", EntryPoint = "glPollAsyncSGIX")]
            public static extern unsafe Int32 PollAsync([OutAttribute] UInt32* markerp);

            /// <summary>[requires: SGIX_instruments]</summary>
            [AutoGenerated(Category = "SGIX_instruments", Version = "", EntryPoint = "glPollInstrumentsSGIX")]
            public static extern Int32 PollInstruments([OutAttribute] out Int32 marker_p);

            /// <summary>[requires: SGIX_instruments]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_instruments", Version = "", EntryPoint = "glPollInstrumentsSGIX")]
            public static extern unsafe Int32 PollInstruments([OutAttribute] Int32* marker_p);

            /// <summary>[requires: SGIX_instruments]</summary>
            [AutoGenerated(Category = "SGIX_instruments", Version = "", EntryPoint = "glReadInstrumentsSGIX")]
            public static extern void ReadInstruments(Int32 marker);

            /// <summary>[requires: SGIX_reference_plane]</summary>
            [AutoGenerated(Category = "SGIX_reference_plane", Version = "", EntryPoint = "glReferencePlaneSGIX")]
            public static extern void ReferencePlane(Double[] equation);

            /// <summary>[requires: SGIX_reference_plane]</summary>
            [AutoGenerated(Category = "SGIX_reference_plane", Version = "", EntryPoint = "glReferencePlaneSGIX")]
            public static extern void ReferencePlane(ref Double equation);

            /// <summary>[requires: SGIX_reference_plane]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_reference_plane", Version = "", EntryPoint = "glReferencePlaneSGIX")]
            public static extern unsafe void ReferencePlane(Double* equation);

            /// <summary>[requires: SGIX_sprite]</summary>
            [AutoGenerated(Category = "SGIX_sprite", Version = "", EntryPoint = "glSpriteParameterfSGIX")]
            public static extern void SpriteParameter(OpenTK.Graphics.OpenGL.SgixSprite pname, Single param);

            /// <summary>[requires: SGIX_sprite]</summary>
            [AutoGenerated(Category = "SGIX_sprite", Version = "", EntryPoint = "glSpriteParameterfvSGIX")]
            public static extern void SpriteParameter(OpenTK.Graphics.OpenGL.SgixSprite pname, Single[] @params);

            /// <summary>[requires: SGIX_sprite]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_sprite", Version = "", EntryPoint = "glSpriteParameterfvSGIX")]
            public static extern unsafe void SpriteParameter(OpenTK.Graphics.OpenGL.SgixSprite pname, Single* @params);

            /// <summary>[requires: SGIX_sprite]</summary>
            [AutoGenerated(Category = "SGIX_sprite", Version = "", EntryPoint = "glSpriteParameteriSGIX")]
            public static extern void SpriteParameter(OpenTK.Graphics.OpenGL.SgixSprite pname, Int32 param);

            /// <summary>[requires: SGIX_sprite]</summary>
            [AutoGenerated(Category = "SGIX_sprite", Version = "", EntryPoint = "glSpriteParameterivSGIX")]
            public static extern void SpriteParameter(OpenTK.Graphics.OpenGL.SgixSprite pname, Int32[] @params);

            /// <summary>[requires: SGIX_sprite]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SGIX_sprite", Version = "", EntryPoint = "glSpriteParameterivSGIX")]
            public static extern unsafe void SpriteParameter(OpenTK.Graphics.OpenGL.SgixSprite pname, Int32* @params);

            /// <summary>[requires: SGIX_instruments]</summary>
            [AutoGenerated(Category = "SGIX_instruments", Version = "", EntryPoint = "glStartInstrumentsSGIX")]
            public static extern void StartInstruments();

            /// <summary>[requires: SGIX_instruments]</summary>
            [AutoGenerated(Category = "SGIX_instruments", Version = "", EntryPoint = "glStopInstrumentsSGIX")]
            public static extern void StopInstruments(Int32 marker);

            /// <summary>[requires: SGIX_tag_sample_buffer]</summary>
            [AutoGenerated(Category = "SGIX_tag_sample_buffer", Version = "", EntryPoint = "glTagSampleBufferSGIX")]
            public static extern void TagSampleBuffer();

        }

        public static partial class Sun
        {
            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glColor3fVertex3fSUN")]
            public static extern void Color3fVertex3(Single r, Single g, Single b, Single x, Single y, Single z);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glColor3fVertex3fvSUN")]
            public static extern void Color3fVertex3(Single[] c, Single[] v);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glColor3fVertex3fvSUN")]
            public static extern void Color3fVertex3(ref Single c, ref Single v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glColor3fVertex3fvSUN")]
            public static extern unsafe void Color3fVertex3(Single* c, Single* v);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glColor4fNormal3fVertex3fSUN")]
            public static extern void Color4fNormal3fVertex3(Single r, Single g, Single b, Single a, Single nx, Single ny, Single nz, Single x, Single y, Single z);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glColor4fNormal3fVertex3fvSUN")]
            public static extern void Color4fNormal3fVertex3(Single[] c, Single[] n, Single[] v);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glColor4fNormal3fVertex3fvSUN")]
            public static extern void Color4fNormal3fVertex3(ref Single c, ref Single n, ref Single v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glColor4fNormal3fVertex3fvSUN")]
            public static extern unsafe void Color4fNormal3fVertex3(Single* c, Single* n, Single* v);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glColor4ubVertex2fSUN")]
            public static extern void Color4ubVertex2(Byte r, Byte g, Byte b, Byte a, Single x, Single y);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glColor4ubVertex2fvSUN")]
            public static extern void Color4ubVertex2(Byte[] c, Single[] v);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glColor4ubVertex2fvSUN")]
            public static extern void Color4ubVertex2(ref Byte c, ref Single v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glColor4ubVertex2fvSUN")]
            public static extern unsafe void Color4ubVertex2(Byte* c, Single* v);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glColor4ubVertex3fSUN")]
            public static extern void Color4ubVertex3(Byte r, Byte g, Byte b, Byte a, Single x, Single y, Single z);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glColor4ubVertex3fvSUN")]
            public static extern void Color4ubVertex3(Byte[] c, Single[] v);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glColor4ubVertex3fvSUN")]
            public static extern void Color4ubVertex3(ref Byte c, ref Single v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glColor4ubVertex3fvSUN")]
            public static extern unsafe void Color4ubVertex3(Byte* c, Single* v);

            /// <summary>[requires: SUN_mesh_array]</summary>
            [Obsolete("Use PrimitiveType overload instead")]
            [AutoGenerated(Category = "SUN_mesh_array", Version = "", EntryPoint = "glDrawMeshArraysSUN")]
            public static extern void DrawMeshArrays(OpenTK.Graphics.OpenGL.BeginMode mode, Int32 first, Int32 count, Int32 width);

            /// <summary>[requires: SUN_mesh_array]</summary>
            [AutoGenerated(Category = "SUN_mesh_array", Version = "", EntryPoint = "glDrawMeshArraysSUN")]
            public static extern void DrawMeshArrays(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 first, Int32 count, Int32 width);

            /// <summary>[requires: SUN_global_alpha]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_global_alpha", Version = "", EntryPoint = "glGlobalAlphaFactorbSUN")]
            public static extern void GlobalAlphaFactor(SByte factor);

            /// <summary>[requires: SUN_global_alpha]</summary>
            [AutoGenerated(Category = "SUN_global_alpha", Version = "", EntryPoint = "glGlobalAlphaFactordSUN")]
            public static extern void GlobalAlphaFactor(Double factor);

            /// <summary>[requires: SUN_global_alpha]</summary>
            [AutoGenerated(Category = "SUN_global_alpha", Version = "", EntryPoint = "glGlobalAlphaFactorfSUN")]
            public static extern void GlobalAlphaFactor(Single factor);

            /// <summary>[requires: SUN_global_alpha]</summary>
            [AutoGenerated(Category = "SUN_global_alpha", Version = "", EntryPoint = "glGlobalAlphaFactoriSUN")]
            public static extern void GlobalAlphaFactor(Int32 factor);

            /// <summary>[requires: SUN_global_alpha]</summary>
            [AutoGenerated(Category = "SUN_global_alpha", Version = "", EntryPoint = "glGlobalAlphaFactorsSUN")]
            public static extern void GlobalAlphaFactors(Int16 factor);

            /// <summary>[requires: SUN_global_alpha]</summary>
            [AutoGenerated(Category = "SUN_global_alpha", Version = "", EntryPoint = "glGlobalAlphaFactorubSUN")]
            public static extern void GlobalAlphaFactor(Byte factor);

            /// <summary>[requires: SUN_global_alpha]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_global_alpha", Version = "", EntryPoint = "glGlobalAlphaFactoruiSUN")]
            public static extern void GlobalAlphaFactor(UInt32 factor);

            /// <summary>[requires: SUN_global_alpha]</summary>
            [AutoGenerated(Category = "SUN_global_alpha", Version = "", EntryPoint = "glGlobalAlphaFactorusSUN")]
            public static extern void GlobalAlphaFactor(Int16 factor);

            /// <summary>[requires: SUN_global_alpha]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_global_alpha", Version = "", EntryPoint = "glGlobalAlphaFactorusSUN")]
            public static extern void GlobalAlphaFactor(UInt16 factor);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glNormal3fVertex3fSUN")]
            public static extern void Normal3fVertex3(Single nx, Single ny, Single nz, Single x, Single y, Single z);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glNormal3fVertex3fvSUN")]
            public static extern void Normal3fVertex3(Single[] n, Single[] v);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glNormal3fVertex3fvSUN")]
            public static extern void Normal3fVertex3(ref Single n, ref Single v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glNormal3fVertex3fvSUN")]
            public static extern unsafe void Normal3fVertex3(Single* n, Single* v);

            /// <summary>[requires: SUN_triangle_list]</summary>
            [AutoGenerated(Category = "SUN_triangle_list", Version = "", EntryPoint = "glReplacementCodePointerSUN")]
            public static extern void ReplacementCodePointer(OpenTK.Graphics.OpenGL.SunTriangleList type, Int32 stride, IntPtr pointer);

            /// <summary>[requires: SUN_triangle_list]</summary>
            [AutoGenerated(Category = "SUN_triangle_list", Version = "", EntryPoint = "glReplacementCodePointerSUN")]
            public static extern void ReplacementCodePointer<T2>(OpenTK.Graphics.OpenGL.SunTriangleList type, Int32 stride, [InAttribute, OutAttribute] T2[] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: SUN_triangle_list]</summary>
            [AutoGenerated(Category = "SUN_triangle_list", Version = "", EntryPoint = "glReplacementCodePointerSUN")]
            public static extern void ReplacementCodePointer<T2>(OpenTK.Graphics.OpenGL.SunTriangleList type, Int32 stride, [InAttribute, OutAttribute] T2[,] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: SUN_triangle_list]</summary>
            [AutoGenerated(Category = "SUN_triangle_list", Version = "", EntryPoint = "glReplacementCodePointerSUN")]
            public static extern void ReplacementCodePointer<T2>(OpenTK.Graphics.OpenGL.SunTriangleList type, Int32 stride, [InAttribute, OutAttribute] T2[,,] pointer)
                where T2 : struct
            ;

            /// <summary>[requires: SUN_triangle_list]</summary>
            [AutoGenerated(Category = "SUN_triangle_list", Version = "", EntryPoint = "glReplacementCodePointerSUN")]
            public static extern void ReplacementCodePointer<T2>(OpenTK.Graphics.OpenGL.SunTriangleList type, Int32 stride, [InAttribute, OutAttribute] ref T2 pointer)
                where T2 : struct
            ;

            /// <summary>[requires: SUN_triangle_list]</summary>
            [AutoGenerated(Category = "SUN_triangle_list", Version = "", EntryPoint = "glReplacementCodeubSUN")]
            public static extern void ReplacementCode(Byte code);

            /// <summary>[requires: SUN_triangle_list]</summary>
            [AutoGenerated(Category = "SUN_triangle_list", Version = "", EntryPoint = "glReplacementCodeubvSUN")]
            public static extern void ReplacementCode(Byte[] code);

            /// <summary>[requires: SUN_triangle_list]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_triangle_list", Version = "", EntryPoint = "glReplacementCodeubvSUN")]
            public static extern unsafe void ReplacementCode(Byte* code);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiColor3fVertex3fSUN")]
            public static extern void ReplacementCodeuiColor3fVertex3(Int32 rc, Single r, Single g, Single b, Single x, Single y, Single z);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiColor3fVertex3fSUN")]
            public static extern void ReplacementCodeuiColor3fVertex3(UInt32 rc, Single r, Single g, Single b, Single x, Single y, Single z);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiColor3fVertex3fvSUN")]
            public static extern void ReplacementCodeuiColor3fVertex3(ref Int32 rc, Single[] c, Single[] v);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiColor3fVertex3fvSUN")]
            public static extern void ReplacementCodeuiColor3fVertex3(ref Int32 rc, ref Single c, ref Single v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiColor3fVertex3fvSUN")]
            public static extern unsafe void ReplacementCodeuiColor3fVertex3(Int32* rc, Single* c, Single* v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiColor3fVertex3fvSUN")]
            public static extern void ReplacementCodeuiColor3fVertex3(ref UInt32 rc, Single[] c, Single[] v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiColor3fVertex3fvSUN")]
            public static extern void ReplacementCodeuiColor3fVertex3(ref UInt32 rc, ref Single c, ref Single v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiColor3fVertex3fvSUN")]
            public static extern unsafe void ReplacementCodeuiColor3fVertex3(UInt32* rc, Single* c, Single* v);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiColor4fNormal3fVertex3fSUN")]
            public static extern void ReplacementCodeuiColor4fNormal3fVertex3(Int32 rc, Single r, Single g, Single b, Single a, Single nx, Single ny, Single nz, Single x, Single y, Single z);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiColor4fNormal3fVertex3fSUN")]
            public static extern void ReplacementCodeuiColor4fNormal3fVertex3(UInt32 rc, Single r, Single g, Single b, Single a, Single nx, Single ny, Single nz, Single x, Single y, Single z);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiColor4fNormal3fVertex3fvSUN")]
            public static extern void ReplacementCodeuiColor4fNormal3fVertex3(ref Int32 rc, Single[] c, Single[] n, Single[] v);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiColor4fNormal3fVertex3fvSUN")]
            public static extern void ReplacementCodeuiColor4fNormal3fVertex3(ref Int32 rc, ref Single c, ref Single n, ref Single v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiColor4fNormal3fVertex3fvSUN")]
            public static extern unsafe void ReplacementCodeuiColor4fNormal3fVertex3(Int32* rc, Single* c, Single* n, Single* v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiColor4fNormal3fVertex3fvSUN")]
            public static extern void ReplacementCodeuiColor4fNormal3fVertex3(ref UInt32 rc, Single[] c, Single[] n, Single[] v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiColor4fNormal3fVertex3fvSUN")]
            public static extern void ReplacementCodeuiColor4fNormal3fVertex3(ref UInt32 rc, ref Single c, ref Single n, ref Single v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiColor4fNormal3fVertex3fvSUN")]
            public static extern unsafe void ReplacementCodeuiColor4fNormal3fVertex3(UInt32* rc, Single* c, Single* n, Single* v);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiColor4ubVertex3fSUN")]
            public static extern void ReplacementCodeuiColor4ubVertex3(Int32 rc, Byte r, Byte g, Byte b, Byte a, Single x, Single y, Single z);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiColor4ubVertex3fSUN")]
            public static extern void ReplacementCodeuiColor4ubVertex3(UInt32 rc, Byte r, Byte g, Byte b, Byte a, Single x, Single y, Single z);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiColor4ubVertex3fvSUN")]
            public static extern void ReplacementCodeuiColor4ubVertex3(ref Int32 rc, Byte[] c, Single[] v);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiColor4ubVertex3fvSUN")]
            public static extern void ReplacementCodeuiColor4ubVertex3(ref Int32 rc, ref Byte c, ref Single v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiColor4ubVertex3fvSUN")]
            public static extern unsafe void ReplacementCodeuiColor4ubVertex3(Int32* rc, Byte* c, Single* v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiColor4ubVertex3fvSUN")]
            public static extern void ReplacementCodeuiColor4ubVertex3(ref UInt32 rc, Byte[] c, Single[] v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiColor4ubVertex3fvSUN")]
            public static extern void ReplacementCodeuiColor4ubVertex3(ref UInt32 rc, ref Byte c, ref Single v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiColor4ubVertex3fvSUN")]
            public static extern unsafe void ReplacementCodeuiColor4ubVertex3(UInt32* rc, Byte* c, Single* v);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiNormal3fVertex3fSUN")]
            public static extern void ReplacementCodeuiNormal3fVertex3(Int32 rc, Single nx, Single ny, Single nz, Single x, Single y, Single z);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiNormal3fVertex3fSUN")]
            public static extern void ReplacementCodeuiNormal3fVertex3(UInt32 rc, Single nx, Single ny, Single nz, Single x, Single y, Single z);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiNormal3fVertex3fvSUN")]
            public static extern void ReplacementCodeuiNormal3fVertex3(ref Int32 rc, Single[] n, Single[] v);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiNormal3fVertex3fvSUN")]
            public static extern void ReplacementCodeuiNormal3fVertex3(ref Int32 rc, ref Single n, ref Single v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiNormal3fVertex3fvSUN")]
            public static extern unsafe void ReplacementCodeuiNormal3fVertex3(Int32* rc, Single* n, Single* v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiNormal3fVertex3fvSUN")]
            public static extern void ReplacementCodeuiNormal3fVertex3(ref UInt32 rc, Single[] n, Single[] v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiNormal3fVertex3fvSUN")]
            public static extern void ReplacementCodeuiNormal3fVertex3(ref UInt32 rc, ref Single n, ref Single v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiNormal3fVertex3fvSUN")]
            public static extern unsafe void ReplacementCodeuiNormal3fVertex3(UInt32* rc, Single* n, Single* v);

            /// <summary>[requires: SUN_triangle_list]</summary>
            [AutoGenerated(Category = "SUN_triangle_list", Version = "", EntryPoint = "glReplacementCodeuiSUN")]
            public static extern void ReplacementCode(Int32 code);

            /// <summary>[requires: SUN_triangle_list]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_triangle_list", Version = "", EntryPoint = "glReplacementCodeuiSUN")]
            public static extern void ReplacementCode(UInt32 code);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN")]
            public static extern void ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3(Int32 rc, Single s, Single t, Single r, Single g, Single b, Single a, Single nx, Single ny, Single nz, Single x, Single y, Single z);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN")]
            public static extern void ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3(UInt32 rc, Single s, Single t, Single r, Single g, Single b, Single a, Single nx, Single ny, Single nz, Single x, Single y, Single z);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN")]
            public static extern void ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3(ref Int32 rc, Single[] tc, Single[] c, Single[] n, Single[] v);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN")]
            public static extern void ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3(ref Int32 rc, ref Single tc, ref Single c, ref Single n, ref Single v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN")]
            public static extern unsafe void ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3(Int32* rc, Single* tc, Single* c, Single* n, Single* v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN")]
            public static extern void ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3(ref UInt32 rc, Single[] tc, Single[] c, Single[] n, Single[] v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN")]
            public static extern void ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3(ref UInt32 rc, ref Single tc, ref Single c, ref Single n, ref Single v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN")]
            public static extern unsafe void ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3(UInt32* rc, Single* tc, Single* c, Single* n, Single* v);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN")]
            public static extern void ReplacementCodeuiTexCoord2fNormal3fVertex3(Int32 rc, Single s, Single t, Single nx, Single ny, Single nz, Single x, Single y, Single z);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN")]
            public static extern void ReplacementCodeuiTexCoord2fNormal3fVertex3(UInt32 rc, Single s, Single t, Single nx, Single ny, Single nz, Single x, Single y, Single z);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN")]
            public static extern void ReplacementCodeuiTexCoord2fNormal3fVertex3(ref Int32 rc, Single[] tc, Single[] n, Single[] v);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN")]
            public static extern void ReplacementCodeuiTexCoord2fNormal3fVertex3(ref Int32 rc, ref Single tc, ref Single n, ref Single v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN")]
            public static extern unsafe void ReplacementCodeuiTexCoord2fNormal3fVertex3(Int32* rc, Single* tc, Single* n, Single* v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN")]
            public static extern void ReplacementCodeuiTexCoord2fNormal3fVertex3(ref UInt32 rc, Single[] tc, Single[] n, Single[] v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN")]
            public static extern void ReplacementCodeuiTexCoord2fNormal3fVertex3(ref UInt32 rc, ref Single tc, ref Single n, ref Single v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN")]
            public static extern unsafe void ReplacementCodeuiTexCoord2fNormal3fVertex3(UInt32* rc, Single* tc, Single* n, Single* v);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiTexCoord2fVertex3fSUN")]
            public static extern void ReplacementCodeuiTexCoord2fVertex3(Int32 rc, Single s, Single t, Single x, Single y, Single z);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiTexCoord2fVertex3fSUN")]
            public static extern void ReplacementCodeuiTexCoord2fVertex3(UInt32 rc, Single s, Single t, Single x, Single y, Single z);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiTexCoord2fVertex3fvSUN")]
            public static extern void ReplacementCodeuiTexCoord2fVertex3(ref Int32 rc, Single[] tc, Single[] v);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiTexCoord2fVertex3fvSUN")]
            public static extern void ReplacementCodeuiTexCoord2fVertex3(ref Int32 rc, ref Single tc, ref Single v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiTexCoord2fVertex3fvSUN")]
            public static extern unsafe void ReplacementCodeuiTexCoord2fVertex3(Int32* rc, Single* tc, Single* v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiTexCoord2fVertex3fvSUN")]
            public static extern void ReplacementCodeuiTexCoord2fVertex3(ref UInt32 rc, Single[] tc, Single[] v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiTexCoord2fVertex3fvSUN")]
            public static extern void ReplacementCodeuiTexCoord2fVertex3(ref UInt32 rc, ref Single tc, ref Single v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiTexCoord2fVertex3fvSUN")]
            public static extern unsafe void ReplacementCodeuiTexCoord2fVertex3(UInt32* rc, Single* tc, Single* v);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiVertex3fSUN")]
            public static extern void ReplacementCodeuiVertex3(Int32 rc, Single x, Single y, Single z);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiVertex3fSUN")]
            public static extern void ReplacementCodeuiVertex3(UInt32 rc, Single x, Single y, Single z);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiVertex3fvSUN")]
            public static extern void ReplacementCodeuiVertex3(ref Int32 rc, Single[] v);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiVertex3fvSUN")]
            public static extern void ReplacementCodeuiVertex3(ref Int32 rc, ref Single v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiVertex3fvSUN")]
            public static extern unsafe void ReplacementCodeuiVertex3(Int32* rc, Single* v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiVertex3fvSUN")]
            public static extern void ReplacementCodeuiVertex3(ref UInt32 rc, Single[] v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiVertex3fvSUN")]
            public static extern void ReplacementCodeuiVertex3(ref UInt32 rc, ref Single v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glReplacementCodeuiVertex3fvSUN")]
            public static extern unsafe void ReplacementCodeuiVertex3(UInt32* rc, Single* v);

            /// <summary>[requires: SUN_triangle_list]</summary>
            [AutoGenerated(Category = "SUN_triangle_list", Version = "", EntryPoint = "glReplacementCodeuivSUN")]
            public static extern void ReplacementCode(Int32[] code);

            /// <summary>[requires: SUN_triangle_list]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_triangle_list", Version = "", EntryPoint = "glReplacementCodeuivSUN")]
            public static extern unsafe void ReplacementCode(Int32* code);

            /// <summary>[requires: SUN_triangle_list]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_triangle_list", Version = "", EntryPoint = "glReplacementCodeuivSUN")]
            public static extern void ReplacementCode(UInt32[] code);

            /// <summary>[requires: SUN_triangle_list]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_triangle_list", Version = "", EntryPoint = "glReplacementCodeuivSUN")]
            public static extern unsafe void ReplacementCode(UInt32* code);

            /// <summary>[requires: SUN_triangle_list]</summary>
            [AutoGenerated(Category = "SUN_triangle_list", Version = "", EntryPoint = "glReplacementCodeusSUN")]
            public static extern void ReplacementCode(Int16 code);

            /// <summary>[requires: SUN_triangle_list]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_triangle_list", Version = "", EntryPoint = "glReplacementCodeusSUN")]
            public static extern void ReplacementCode(UInt16 code);

            /// <summary>[requires: SUN_triangle_list]</summary>
            [AutoGenerated(Category = "SUN_triangle_list", Version = "", EntryPoint = "glReplacementCodeusvSUN")]
            public static extern void ReplacementCode(Int16[] code);

            /// <summary>[requires: SUN_triangle_list]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_triangle_list", Version = "", EntryPoint = "glReplacementCodeusvSUN")]
            public static extern unsafe void ReplacementCode(Int16* code);

            /// <summary>[requires: SUN_triangle_list]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_triangle_list", Version = "", EntryPoint = "glReplacementCodeusvSUN")]
            public static extern void ReplacementCode(UInt16[] code);

            /// <summary>[requires: SUN_triangle_list]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_triangle_list", Version = "", EntryPoint = "glReplacementCodeusvSUN")]
            public static extern unsafe void ReplacementCode(UInt16* code);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glTexCoord2fColor3fVertex3fSUN")]
            public static extern void TexCoord2fColor3fVertex3(Single s, Single t, Single r, Single g, Single b, Single x, Single y, Single z);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glTexCoord2fColor3fVertex3fvSUN")]
            public static extern void TexCoord2fColor3fVertex3(Single[] tc, Single[] c, Single[] v);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glTexCoord2fColor3fVertex3fvSUN")]
            public static extern void TexCoord2fColor3fVertex3(ref Single tc, ref Single c, ref Single v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glTexCoord2fColor3fVertex3fvSUN")]
            public static extern unsafe void TexCoord2fColor3fVertex3(Single* tc, Single* c, Single* v);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glTexCoord2fColor4fNormal3fVertex3fSUN")]
            public static extern void TexCoord2fColor4fNormal3fVertex3(Single s, Single t, Single r, Single g, Single b, Single a, Single nx, Single ny, Single nz, Single x, Single y, Single z);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glTexCoord2fColor4fNormal3fVertex3fvSUN")]
            public static extern void TexCoord2fColor4fNormal3fVertex3(Single[] tc, Single[] c, Single[] n, Single[] v);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glTexCoord2fColor4fNormal3fVertex3fvSUN")]
            public static extern void TexCoord2fColor4fNormal3fVertex3(ref Single tc, ref Single c, ref Single n, ref Single v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glTexCoord2fColor4fNormal3fVertex3fvSUN")]
            public static extern unsafe void TexCoord2fColor4fNormal3fVertex3(Single* tc, Single* c, Single* n, Single* v);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glTexCoord2fColor4ubVertex3fSUN")]
            public static extern void TexCoord2fColor4ubVertex3(Single s, Single t, Byte r, Byte g, Byte b, Byte a, Single x, Single y, Single z);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glTexCoord2fColor4ubVertex3fvSUN")]
            public static extern void TexCoord2fColor4ubVertex3(Single[] tc, Byte[] c, Single[] v);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glTexCoord2fColor4ubVertex3fvSUN")]
            public static extern void TexCoord2fColor4ubVertex3(ref Single tc, ref Byte c, ref Single v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glTexCoord2fColor4ubVertex3fvSUN")]
            public static extern unsafe void TexCoord2fColor4ubVertex3(Single* tc, Byte* c, Single* v);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glTexCoord2fNormal3fVertex3fSUN")]
            public static extern void TexCoord2fNormal3fVertex3(Single s, Single t, Single nx, Single ny, Single nz, Single x, Single y, Single z);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glTexCoord2fNormal3fVertex3fvSUN")]
            public static extern void TexCoord2fNormal3fVertex3(Single[] tc, Single[] n, Single[] v);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glTexCoord2fNormal3fVertex3fvSUN")]
            public static extern void TexCoord2fNormal3fVertex3(ref Single tc, ref Single n, ref Single v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glTexCoord2fNormal3fVertex3fvSUN")]
            public static extern unsafe void TexCoord2fNormal3fVertex3(Single* tc, Single* n, Single* v);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glTexCoord2fVertex3fSUN")]
            public static extern void TexCoord2fVertex3(Single s, Single t, Single x, Single y, Single z);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glTexCoord2fVertex3fvSUN")]
            public static extern void TexCoord2fVertex3(Single[] tc, Single[] v);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glTexCoord2fVertex3fvSUN")]
            public static extern void TexCoord2fVertex3(ref Single tc, ref Single v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glTexCoord2fVertex3fvSUN")]
            public static extern unsafe void TexCoord2fVertex3(Single* tc, Single* v);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glTexCoord4fColor4fNormal3fVertex4fSUN")]
            public static extern void TexCoord4fColor4fNormal3fVertex4(Single s, Single t, Single p, Single q, Single r, Single g, Single b, Single a, Single nx, Single ny, Single nz, Single x, Single y, Single z, Single w);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glTexCoord4fColor4fNormal3fVertex4fvSUN")]
            public static extern void TexCoord4fColor4fNormal3fVertex4(Single[] tc, Single[] c, Single[] n, Single[] v);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glTexCoord4fColor4fNormal3fVertex4fvSUN")]
            public static extern void TexCoord4fColor4fNormal3fVertex4(ref Single tc, ref Single c, ref Single n, ref Single v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glTexCoord4fColor4fNormal3fVertex4fvSUN")]
            public static extern unsafe void TexCoord4fColor4fNormal3fVertex4(Single* tc, Single* c, Single* n, Single* v);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glTexCoord4fVertex4fSUN")]
            public static extern void TexCoord4fVertex4(Single s, Single t, Single p, Single q, Single x, Single y, Single z, Single w);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glTexCoord4fVertex4fvSUN")]
            public static extern void TexCoord4fVertex4(Single[] tc, Single[] v);

            /// <summary>[requires: SUN_vertex]</summary>
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glTexCoord4fVertex4fvSUN")]
            public static extern void TexCoord4fVertex4(ref Single tc, ref Single v);

            /// <summary>[requires: SUN_vertex]</summary>
            [System.CLSCompliant(false)]
            [AutoGenerated(Category = "SUN_vertex", Version = "", EntryPoint = "glTexCoord4fVertex4fvSUN")]
            public static extern unsafe void TexCoord4fVertex4(Single* tc, Single* v);

        }

        public static partial class Sunx
        {
            /// <summary>[requires: SUNX_constant_data]</summary>
            [AutoGenerated(Category = "SUNX_constant_data", Version = "", EntryPoint = "glFinishTextureSUNX")]
            public static extern void FinishTexture();

        }

        [Slot(1908)]
        static extern void glTbufferMask3DFX(UInt32 mask);
        [Slot(30)]
        static extern void glBeginPerfMonitorAMD(UInt32 monitor);
        [Slot(109)]
        static extern void glBlendEquationIndexedAMD(UInt32 buf, OpenTK.Graphics.OpenGL.AmdDrawBuffersBlend mode);
        [Slot(114)]
        static extern void glBlendEquationSeparateIndexedAMD(UInt32 buf, OpenTK.Graphics.OpenGL.AmdDrawBuffersBlend modeRGB, OpenTK.Graphics.OpenGL.AmdDrawBuffersBlend modeAlpha);
        [Slot(118)]
        static extern void glBlendFuncIndexedAMD(UInt32 buf, OpenTK.Graphics.OpenGL.AmdDrawBuffersBlend src, OpenTK.Graphics.OpenGL.AmdDrawBuffersBlend dst);
        [Slot(123)]
        static extern void glBlendFuncSeparateIndexedAMD(UInt32 buf, OpenTK.Graphics.OpenGL.AmdDrawBuffersBlend srcRGB, OpenTK.Graphics.OpenGL.AmdDrawBuffersBlend dstRGB, OpenTK.Graphics.OpenGL.AmdDrawBuffersBlend srcAlpha, OpenTK.Graphics.OpenGL.AmdDrawBuffersBlend dstAlpha);
        [Slot(345)]
        static extern void glDebugMessageCallbackAMD(DebugProcAmd callback, [OutAttribute] IntPtr userParam);
        [Slot(351)]
        static extern unsafe void glDebugMessageEnableAMD(OpenTK.Graphics.OpenGL.AmdDebugOutput category, OpenTK.Graphics.OpenGL.AmdDebugOutput severity, Int32 count, UInt32* ids, bool enabled);
        [Slot(353)]
        static extern void glDebugMessageInsertAMD(OpenTK.Graphics.OpenGL.AmdDebugOutput category, OpenTK.Graphics.OpenGL.AmdDebugOutput severity, UInt32 id, Int32 length, String buf);
        [Slot(369)]
        static extern unsafe void glDeleteNamesAMD(OpenTK.Graphics.OpenGL.AmdNameGenDelete identifier, UInt32 num, UInt32* names);
        [Slot(373)]
        static extern unsafe void glDeletePerfMonitorsAMD(Int32 n, UInt32* monitors);
        [Slot(484)]
        static extern void glEndPerfMonitorAMD(UInt32 monitor);
        [Slot(605)]
        static extern unsafe void glGenNamesAMD(OpenTK.Graphics.OpenGL.AmdNameGenDelete identifier, UInt32 num, [OutAttribute] UInt32* names);
        [Slot(608)]
        static extern unsafe void glGenPerfMonitorsAMD(Int32 n, [OutAttribute] UInt32* monitors);
        [Slot(685)]
        static extern unsafe Int32 glGetDebugMessageLogAMD(UInt32 count, Int32 bufsize, [OutAttribute] OpenTK.Graphics.OpenGL.AmdDebugOutput* categories, [OutAttribute] UInt32* severities, [OutAttribute] UInt32* ids, [OutAttribute] Int32* lengths, [OutAttribute] StringBuilder message);
        [Slot(841)]
        static extern unsafe void glGetPerfMonitorCounterDataAMD(UInt32 monitor, OpenTK.Graphics.OpenGL.AmdPerformanceMonitor pname, Int32 dataSize, [OutAttribute] UInt32* data, [OutAttribute] Int32* bytesWritten);
        [Slot(842)]
        static extern void glGetPerfMonitorCounterInfoAMD(UInt32 group, UInt32 counter, OpenTK.Graphics.OpenGL.AmdPerformanceMonitor pname, [OutAttribute] IntPtr data);
        [Slot(843)]
        static extern unsafe void glGetPerfMonitorCountersAMD(UInt32 group, [OutAttribute] Int32* numCounters, [OutAttribute] Int32* maxActiveCounters, Int32 counterSize, [OutAttribute] UInt32* counters);
        [Slot(844)]
        static extern unsafe void glGetPerfMonitorCounterStringAMD(UInt32 group, UInt32 counter, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder counterString);
        [Slot(845)]
        static extern unsafe void glGetPerfMonitorGroupsAMD([OutAttribute] Int32* numGroups, Int32 groupsSize, [OutAttribute] UInt32* groups);
        [Slot(846)]
        static extern unsafe void glGetPerfMonitorGroupStringAMD(UInt32 group, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder groupString);
        [Slot(1080)]
        static extern bool glIsNameAMD(OpenTK.Graphics.OpenGL.AmdNameGenDelete identifier, UInt32 name);
        [Slot(1225)]
        static extern void glMultiDrawArraysIndirectAMD(OpenTK.Graphics.OpenGL.AmdMultiDrawIndirect mode, IntPtr indirect, Int32 primcount, Int32 stride);
        [Slot(1233)]
        static extern void glMultiDrawElementsIndirectAMD(OpenTK.Graphics.OpenGL.AmdMultiDrawIndirect mode, OpenTK.Graphics.OpenGL.AmdMultiDrawIndirect type, IntPtr indirect, Int32 primcount, Int32 stride);
        [Slot(1855)]
        static extern unsafe void glSelectPerfMonitorCountersAMD(UInt32 monitor, bool enable, UInt32 group, Int32 numCounters, [OutAttribute] UInt32* counterList);
        [Slot(1863)]
        static extern unsafe void glSetMultisamplefvAMD(OpenTK.Graphics.OpenGL.AmdSamplePositions pname, UInt32 index, Single* val);
        [Slot(1889)]
        static extern void glStencilOpValueAMD(OpenTK.Graphics.OpenGL.AmdStencilOperationExtended face, UInt32 value);
        [Slot(1909)]
        static extern void glTessellationFactorAMD(Single factor);
        [Slot(1910)]
        static extern void glTessellationModeAMD(OpenTK.Graphics.OpenGL.AmdVertexShaderTessellator mode);
        [Slot(2044)]
        static extern void glTexStorageSparseAMD(OpenTK.Graphics.OpenGL.AmdSparseTexture target, OpenTK.Graphics.OpenGL.AmdSparseTexture internalFormat, Int32 width, Int32 height, Int32 depth, Int32 layers, UInt32 flags);
        [Slot(2080)]
        static extern void glTextureStorageSparseAMD(UInt32 texture, OpenTK.Graphics.OpenGL.AmdSparseTexture target, OpenTK.Graphics.OpenGL.AmdSparseTexture internalFormat, Int32 width, Int32 height, Int32 depth, Int32 layers, UInt32 flags);
        [Slot(2499)]
        static extern void glVertexAttribParameteriAMD(UInt32 index, OpenTK.Graphics.OpenGL.AmdInterleavedElements pname, Int32 param);
        [Slot(82)]
        static extern void glBindVertexArrayAPPLE(UInt32 array);
        [Slot(131)]
        static extern void glBufferParameteriAPPLE(OpenTK.Graphics.OpenGL.BufferTarget target, OpenTK.Graphics.OpenGL.BufferParameterApple pname, Int32 param);
        [Slot(362)]
        static extern unsafe void glDeleteFencesAPPLE(Int32 n, UInt32* fences);
        [Slot(391)]
        static extern unsafe void glDeleteVertexArraysAPPLE(Int32 n, UInt32* arrays);
        [Slot(416)]
        static extern void glDisableVertexAttribAPPLE(UInt32 index, OpenTK.Graphics.OpenGL.AppleVertexProgramEvaluators pname);
        [Slot(433)]
        static extern void glDrawElementArrayAPPLE(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 first, Int32 count);
        [Slot(446)]
        static extern void glDrawRangeElementArrayAPPLE(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 start, UInt32 end, Int32 first, Int32 count);
        [Slot(463)]
        static extern void glElementPointerAPPLE(OpenTK.Graphics.OpenGL.AppleElementArray type, IntPtr pointer);
        [Slot(474)]
        static extern void glEnableVertexAttribAPPLE(UInt32 index, OpenTK.Graphics.OpenGL.AppleVertexProgramEvaluators pname);
        [Slot(518)]
        static extern void glFinishFenceAPPLE(UInt32 fence);
        [Slot(520)]
        static extern void glFinishObjectAPPLE(OpenTK.Graphics.OpenGL.AppleFence @object, Int32 name);
        [Slot(524)]
        static extern void glFlushMappedBufferRangeAPPLE(OpenTK.Graphics.OpenGL.BufferTarget target, IntPtr offset, IntPtr size);
        [Slot(529)]
        static extern void glFlushVertexArrayRangeAPPLE(Int32 length, [OutAttribute] IntPtr pointer);
        [Slot(599)]
        static extern unsafe void glGenFencesAPPLE(Int32 n, [OutAttribute] UInt32* fences);
        [Slot(624)]
        static extern unsafe void glGenVertexArraysAPPLE(Int32 n, [OutAttribute] UInt32* arrays);
        [Slot(822)]
        static extern unsafe void glGetObjectParameterivAPPLE(OpenTK.Graphics.OpenGL.AppleObjectPurgeable objectType, UInt32 name, OpenTK.Graphics.OpenGL.AppleObjectPurgeable pname, [OutAttribute] Int32* @params);
        [Slot(942)]
        static extern void glGetTexParameterPointervAPPLE(OpenTK.Graphics.OpenGL.AppleTextureRange target, OpenTK.Graphics.OpenGL.AppleTextureRange pname, [OutAttribute] IntPtr @params);
        [Slot(1073)]
        static extern bool glIsFenceAPPLE(UInt32 fence);
        [Slot(1108)]
        static extern bool glIsVertexArrayAPPLE(UInt32 array);
        [Slot(1109)]
        static extern bool glIsVertexAttribEnabledAPPLE(UInt32 index, OpenTK.Graphics.OpenGL.AppleVertexProgramEvaluators pname);
        [Slot(1182)]
        static extern unsafe void glMapVertexAttrib1dAPPLE(UInt32 index, UInt32 size, Double u1, Double u2, Int32 stride, Int32 order, Double* points);
        [Slot(1183)]
        static extern unsafe void glMapVertexAttrib1fAPPLE(UInt32 index, UInt32 size, Single u1, Single u2, Int32 stride, Int32 order, Single* points);
        [Slot(1184)]
        static extern unsafe void glMapVertexAttrib2dAPPLE(UInt32 index, UInt32 size, Double u1, Double u2, Int32 ustride, Int32 uorder, Double v1, Double v2, Int32 vstride, Int32 vorder, Double* points);
        [Slot(1185)]
        static extern unsafe void glMapVertexAttrib2fAPPLE(UInt32 index, UInt32 size, Single u1, Single u2, Int32 ustride, Int32 uorder, Single v1, Single v2, Int32 vstride, Int32 vorder, Single* points);
        [Slot(1228)]
        static extern unsafe void glMultiDrawElementArrayAPPLE(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32* first, Int32* count, Int32 primcount);
        [Slot(1236)]
        static extern unsafe void glMultiDrawRangeElementArrayAPPLE(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 start, UInt32 end, Int32* first, Int32* count, Int32 primcount);
        [Slot(1435)]
        static extern OpenTK.Graphics.OpenGL.AppleObjectPurgeable glObjectPurgeableAPPLE(OpenTK.Graphics.OpenGL.AppleObjectPurgeable objectType, UInt32 name, OpenTK.Graphics.OpenGL.AppleObjectPurgeable option);
        [Slot(1436)]
        static extern OpenTK.Graphics.OpenGL.AppleObjectPurgeable glObjectUnpurgeableAPPLE(OpenTK.Graphics.OpenGL.AppleObjectPurgeable objectType, UInt32 name, OpenTK.Graphics.OpenGL.AppleObjectPurgeable option);
        [Slot(1858)]
        static extern void glSetFenceAPPLE(UInt32 fence);
        [Slot(1911)]
        static extern bool glTestFenceAPPLE(UInt32 fence);
        [Slot(1913)]
        static extern bool glTestObjectAPPLE(OpenTK.Graphics.OpenGL.AppleFence @object, UInt32 name);
        [Slot(2073)]
        static extern void glTextureRangeAPPLE(OpenTK.Graphics.OpenGL.AppleTextureRange target, Int32 length, IntPtr pointer);
        [Slot(2282)]
        static extern void glVertexArrayParameteriAPPLE(OpenTK.Graphics.OpenGL.AppleVertexArrayRange pname, Int32 param);
        [Slot(2283)]
        static extern void glVertexArrayRangeAPPLE(Int32 length, [OutAttribute] IntPtr pointer);
        [Slot(7)]
        static extern void glActiveTextureARB(OpenTK.Graphics.OpenGL.TextureUnit texture);
        [Slot(22)]
        static extern void glAttachObjectARB(UInt32 containerObj, UInt32 obj);
        [Slot(32)]
        static extern void glBeginQueryARB(OpenTK.Graphics.OpenGL.ArbOcclusionQuery target, UInt32 id);
        [Slot(40)]
        static extern void glBindAttribLocationARB(UInt32 programObj, UInt32 index, String name);
        [Slot(42)]
        static extern void glBindBufferARB(OpenTK.Graphics.OpenGL.BufferTargetArb target, UInt32 buffer);
        [Slot(66)]
        static extern void glBindProgramARB(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 program);
        [Slot(108)]
        static extern void glBlendEquationiARB(UInt32 buf, OpenTK.Graphics.OpenGL.BlendEquationMode mode);
        [Slot(113)]
        static extern void glBlendEquationSeparateiARB(UInt32 buf, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend modeRGB, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend modeAlpha);
        [Slot(117)]
        static extern void glBlendFunciARB(UInt32 buf, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend src, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend dst);
        [Slot(122)]
        static extern void glBlendFuncSeparateiARB(UInt32 buf, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend srcRGB, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend dstRGB, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend srcAlpha, OpenTK.Graphics.OpenGL.ArbDrawBuffersBlend dstAlpha);
        [Slot(130)]
        static extern void glBufferDataARB(OpenTK.Graphics.OpenGL.BufferTargetArb target, IntPtr size, IntPtr data, OpenTK.Graphics.OpenGL.BufferUsageArb usage);
        [Slot(134)]
        static extern void glBufferSubDataARB(OpenTK.Graphics.OpenGL.BufferTargetArb target, IntPtr offset, IntPtr size, IntPtr data);
        [Slot(141)]
        static extern void glClampColorARB(OpenTK.Graphics.OpenGL.ArbColorBufferFloat target, OpenTK.Graphics.OpenGL.ArbColorBufferFloat clamp);
        [Slot(167)]
        static extern void glClientActiveTextureARB(OpenTK.Graphics.OpenGL.TextureUnit texture);
        [Slot(255)]
        static extern void glCompileShaderARB(UInt32 shaderObj);
        [Slot(256)]
        static extern unsafe void glCompileShaderIncludeARB(UInt32 shader, Int32 count, String[] path, Int32* length);
        [Slot(264)]
        static extern void glCompressedTexImage1DARB(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 border, Int32 imageSize, IntPtr data);
        [Slot(266)]
        static extern void glCompressedTexImage2DARB(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 border, Int32 imageSize, IntPtr data);
        [Slot(268)]
        static extern void glCompressedTexImage3DARB(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, Int32 imageSize, IntPtr data);
        [Slot(270)]
        static extern void glCompressedTexSubImage1DARB(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, IntPtr data);
        [Slot(272)]
        static extern void glCompressedTexSubImage2DARB(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, IntPtr data);
        [Slot(274)]
        static extern void glCompressedTexSubImage3DARB(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, IntPtr data);
        [Slot(333)]
        static extern Int32 glCreateProgramObjectARB();
        [Slot(335)]
        static extern Int32 glCreateShaderObjectARB(OpenTK.Graphics.OpenGL.ArbShaderObjects shaderType);
        [Slot(339)]
        static extern unsafe IntPtr glCreateSyncFromCLeventARB([OutAttribute] IntPtr* context, [OutAttribute] IntPtr* @event, UInt32 flags);
        [Slot(343)]
        static extern void glCurrentPaletteMatrixARB(Int32 index);
        [Slot(346)]
        static extern void glDebugMessageCallbackARB(DebugProcArb callback, IntPtr userParam);
        [Slot(349)]
        static extern unsafe void glDebugMessageControlARB(OpenTK.Graphics.OpenGL.ArbDebugOutput source, OpenTK.Graphics.OpenGL.ArbDebugOutput type, OpenTK.Graphics.OpenGL.ArbDebugOutput severity, Int32 count, UInt32* ids, bool enabled);
        [Slot(354)]
        static extern void glDebugMessageInsertARB(OpenTK.Graphics.OpenGL.ArbDebugOutput source, OpenTK.Graphics.OpenGL.ArbDebugOutput type, UInt32 id, OpenTK.Graphics.OpenGL.ArbDebugOutput severity, Int32 length, String buf);
        [Slot(361)]
        static extern unsafe void glDeleteBuffersARB(Int32 n, UInt32* buffers);
        [Slot(368)]
        static extern void glDeleteNamedStringARB(Int32 namelen, String name);
        [Slot(370)]
        static extern void glDeleteObjectARB(UInt32 obj);
        [Slot(377)]
        static extern unsafe void glDeleteProgramsARB(Int32 n, UInt32* programs);
        [Slot(380)]
        static extern unsafe void glDeleteQueriesARB(Int32 n, UInt32* ids);
        [Slot(404)]
        static extern void glDetachObjectARB(UInt32 containerObj, UInt32 attachedObj);
        [Slot(418)]
        static extern void glDisableVertexAttribArrayARB(UInt32 index);
        [Slot(420)]
        static extern void glDispatchComputeGroupSizeARB(UInt32 num_groups_x, UInt32 num_groups_y, UInt32 num_groups_z, UInt32 group_size_x, UInt32 group_size_y, UInt32 group_size_z);
        [Slot(426)]
        static extern void glDrawArraysInstancedARB(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 first, Int32 count, Int32 primcount);
        [Slot(431)]
        static extern unsafe void glDrawBuffersARB(Int32 n, OpenTK.Graphics.OpenGL.ArbDrawBuffers* bufs);
        [Slot(439)]
        static extern void glDrawElementsInstancedARB(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 primcount);
        [Slot(476)]
        static extern void glEnableVertexAttribArrayARB(UInt32 index);
        [Slot(486)]
        static extern void glEndQueryARB(OpenTK.Graphics.OpenGL.ArbOcclusionQuery target);
        [Slot(578)]
        static extern void glFramebufferTextureARB(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, UInt32 texture, Int32 level);
        [Slot(580)]
        static extern void glFramebufferTextureFaceARB(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, UInt32 texture, Int32 level, OpenTK.Graphics.OpenGL.TextureTarget face);
        [Slot(583)]
        static extern void glFramebufferTextureLayerARB(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, UInt32 texture, Int32 level, Int32 layer);
        [Slot(594)]
        static extern unsafe void glGenBuffersARB(Int32 n, [OutAttribute] UInt32* buffers);
        [Slot(611)]
        static extern unsafe void glGenProgramsARB(Int32 n, [OutAttribute] UInt32* programs);
        [Slot(614)]
        static extern unsafe void glGenQueriesARB(Int32 n, [OutAttribute] UInt32* ids);
        [Slot(628)]
        static extern unsafe void glGetActiveAttribARB(UInt32 programObj, UInt32 index, Int32 maxLength, [OutAttribute] Int32* length, [OutAttribute] Int32* size, [OutAttribute] OpenTK.Graphics.OpenGL.ArbVertexShader* type, [OutAttribute] StringBuilder name);
        [Slot(633)]
        static extern unsafe void glGetActiveUniformARB(UInt32 programObj, UInt32 index, Int32 maxLength, [OutAttribute] Int32* length, [OutAttribute] Int32* size, [OutAttribute] OpenTK.Graphics.OpenGL.ArbShaderObjects* type, [OutAttribute] StringBuilder name);
        [Slot(641)]
        static extern unsafe void glGetAttachedObjectsARB(UInt32 containerObj, Int32 maxCount, [OutAttribute] Int32* count, [OutAttribute] UInt32* obj);
        [Slot(644)]
        static extern Int32 glGetAttribLocationARB(UInt32 programObj, String name);
        [Slot(650)]
        static extern unsafe void glGetBufferParameterivARB(OpenTK.Graphics.OpenGL.ArbVertexBufferObject target, OpenTK.Graphics.OpenGL.BufferParameterNameArb pname, [OutAttribute] Int32* @params);
        [Slot(653)]
        static extern void glGetBufferPointervARB(OpenTK.Graphics.OpenGL.ArbVertexBufferObject target, OpenTK.Graphics.OpenGL.BufferPointerNameArb pname, [OutAttribute] IntPtr @params);
        [Slot(655)]
        static extern void glGetBufferSubDataARB(OpenTK.Graphics.OpenGL.BufferTargetArb target, IntPtr offset, IntPtr size, [OutAttribute] IntPtr data);
        [Slot(675)]
        static extern void glGetCompressedTexImageARB(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, [OutAttribute] IntPtr img);
        [Slot(686)]
        static extern unsafe Int32 glGetDebugMessageLogARB(UInt32 count, Int32 bufSize, [OutAttribute] OpenTK.Graphics.OpenGL.ArbDebugOutput* sources, [OutAttribute] OpenTK.Graphics.OpenGL.ArbDebugOutput* types, [OutAttribute] UInt32* ids, [OutAttribute] OpenTK.Graphics.OpenGL.ArbDebugOutput* severities, [OutAttribute] Int32* lengths, [OutAttribute] StringBuilder messageLog);
        [Slot(714)]
        static extern OpenTK.Graphics.OpenGL.ArbRobustness glGetGraphicsResetStatusARB();
        [Slot(715)]
        static extern Int32 glGetHandleARB(OpenTK.Graphics.OpenGL.ArbShaderObjects pname);
        [Slot(723)]
        static extern Int64 glGetImageHandleARB(UInt32 texture, Int32 level, bool layered, Int32 layer, OpenTK.Graphics.OpenGL.ArbBindlessTexture format);
        [Slot(727)]
        static extern unsafe void glGetInfoLogARB(UInt32 obj, Int32 maxLength, [OutAttribute] Int32* length, [OutAttribute] StringBuilder infoLog);
        [Slot(796)]
        static extern unsafe void glGetNamedStringARB(Int32 namelen, String name, Int32 bufSize, [OutAttribute] Int32* stringlen, [OutAttribute] StringBuilder @string);
        [Slot(797)]
        static extern unsafe void glGetNamedStringivARB(Int32 namelen, String name, OpenTK.Graphics.OpenGL.ArbShadingLanguageInclude pname, [OutAttribute] Int32* @params);
        [Slot(798)]
        static extern void glGetnColorTableARB(OpenTK.Graphics.OpenGL.ArbRobustness target, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [OutAttribute] IntPtr table);
        [Slot(799)]
        static extern void glGetnCompressedTexImageARB(OpenTK.Graphics.OpenGL.ArbRobustness target, Int32 lod, Int32 bufSize, [OutAttribute] IntPtr img);
        [Slot(800)]
        static extern void glGetnConvolutionFilterARB(OpenTK.Graphics.OpenGL.ArbRobustness target, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [OutAttribute] IntPtr image);
        [Slot(801)]
        static extern void glGetnHistogramARB(OpenTK.Graphics.OpenGL.ArbRobustness target, bool reset, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [OutAttribute] IntPtr values);
        [Slot(802)]
        static extern unsafe void glGetnMapdvARB(OpenTK.Graphics.OpenGL.ArbRobustness target, OpenTK.Graphics.OpenGL.ArbRobustness query, Int32 bufSize, [OutAttribute] Double* v);
        [Slot(803)]
        static extern unsafe void glGetnMapfvARB(OpenTK.Graphics.OpenGL.ArbRobustness target, OpenTK.Graphics.OpenGL.ArbRobustness query, Int32 bufSize, [OutAttribute] Single* v);
        [Slot(804)]
        static extern unsafe void glGetnMapivARB(OpenTK.Graphics.OpenGL.ArbRobustness target, OpenTK.Graphics.OpenGL.ArbRobustness query, Int32 bufSize, [OutAttribute] Int32* v);
        [Slot(805)]
        static extern void glGetnMinmaxARB(OpenTK.Graphics.OpenGL.ArbRobustness target, bool reset, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [OutAttribute] IntPtr values);
        [Slot(806)]
        static extern unsafe void glGetnPixelMapfvARB(OpenTK.Graphics.OpenGL.ArbRobustness map, Int32 bufSize, [OutAttribute] Single* values);
        [Slot(807)]
        static extern unsafe void glGetnPixelMapuivARB(OpenTK.Graphics.OpenGL.ArbRobustness map, Int32 bufSize, [OutAttribute] UInt32* values);
        [Slot(808)]
        static extern unsafe void glGetnPixelMapusvARB(OpenTK.Graphics.OpenGL.ArbRobustness map, Int32 bufSize, [OutAttribute] UInt16* values);
        [Slot(809)]
        static extern unsafe void glGetnPolygonStippleARB(Int32 bufSize, [OutAttribute] Byte* pattern);
        [Slot(810)]
        static extern void glGetnSeparableFilterARB(OpenTK.Graphics.OpenGL.ArbRobustness target, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 rowBufSize, [OutAttribute] IntPtr row, Int32 columnBufSize, [OutAttribute] IntPtr column, [OutAttribute] IntPtr span);
        [Slot(811)]
        static extern void glGetnTexImageARB(OpenTK.Graphics.OpenGL.ArbRobustness target, Int32 level, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [OutAttribute] IntPtr img);
        [Slot(812)]
        static extern unsafe void glGetnUniformdvARB(UInt32 program, Int32 location, Int32 bufSize, [OutAttribute] Double* @params);
        [Slot(813)]
        static extern unsafe void glGetnUniformfvARB(UInt32 program, Int32 location, Int32 bufSize, [OutAttribute] Single* @params);
        [Slot(814)]
        static extern unsafe void glGetnUniformivARB(UInt32 program, Int32 location, Int32 bufSize, [OutAttribute] Int32* @params);
        [Slot(815)]
        static extern unsafe void glGetnUniformuivARB(UInt32 program, Int32 location, Int32 bufSize, [OutAttribute] UInt32* @params);
        [Slot(821)]
        static extern unsafe void glGetObjectParameterfvARB(UInt32 obj, OpenTK.Graphics.OpenGL.ArbShaderObjects pname, [OutAttribute] Single* @params);
        [Slot(823)]
        static extern unsafe void glGetObjectParameterivARB(UInt32 obj, OpenTK.Graphics.OpenGL.ArbShaderObjects pname, [OutAttribute] Int32* @params);
        [Slot(862)]
        static extern unsafe void glGetProgramEnvParameterdvARB(OpenTK.Graphics.OpenGL.All target, UInt32 index, [OutAttribute] Double* @params);
        [Slot(863)]
        static extern unsafe void glGetProgramEnvParameterfvARB(OpenTK.Graphics.OpenGL.All target, UInt32 index, [OutAttribute] Single* @params);
        [Slot(869)]
        static extern unsafe void glGetProgramivARB(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, OpenTK.Graphics.OpenGL.AssemblyProgramParameterArb pname, [OutAttribute] Int32* @params);
        [Slot(871)]
        static extern unsafe void glGetProgramLocalParameterdvARB(OpenTK.Graphics.OpenGL.All target, UInt32 index, [OutAttribute] Double* @params);
        [Slot(872)]
        static extern unsafe void glGetProgramLocalParameterfvARB(OpenTK.Graphics.OpenGL.All target, UInt32 index, [OutAttribute] Single* @params);
        [Slot(889)]
        static extern void glGetProgramStringARB(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, OpenTK.Graphics.OpenGL.AssemblyProgramParameterArb pname, [OutAttribute] IntPtr @string);
        [Slot(894)]
        static extern unsafe void glGetQueryivARB(OpenTK.Graphics.OpenGL.ArbOcclusionQuery target, OpenTK.Graphics.OpenGL.ArbOcclusionQuery pname, [OutAttribute] Int32* @params);
        [Slot(898)]
        static extern unsafe void glGetQueryObjectivARB(UInt32 id, OpenTK.Graphics.OpenGL.ArbOcclusionQuery pname, [OutAttribute] Int32* @params);
        [Slot(902)]
        static extern unsafe void glGetQueryObjectuivARB(UInt32 id, OpenTK.Graphics.OpenGL.ArbOcclusionQuery pname, [OutAttribute] UInt32* @params);
        [Slot(915)]
        static extern unsafe void glGetShaderSourceARB(UInt32 obj, Int32 maxLength, [OutAttribute] Int32* length, [OutAttribute] StringBuilder source);
        [Slot(944)]
        static extern Int64 glGetTextureHandleARB(UInt32 texture);
        [Slot(953)]
        static extern Int64 glGetTextureSamplerHandleARB(UInt32 texture, UInt32 sampler);
        [Slot(963)]
        static extern unsafe void glGetUniformfvARB(UInt32 programObj, Int32 location, [OutAttribute] Single* @params);
        [Slot(967)]
        static extern unsafe void glGetUniformivARB(UInt32 programObj, Int32 location, [OutAttribute] Int32* @params);
        [Slot(969)]
        static extern Int32 glGetUniformLocationARB(UInt32 programObj, String name);
        [Slot(989)]
        static extern unsafe void glGetVertexAttribdvARB(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameterArb pname, [OutAttribute] Double* @params);
        [Slot(992)]
        static extern unsafe void glGetVertexAttribfvARB(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameterArb pname, [OutAttribute] Single* @params);
        [Slot(999)]
        static extern unsafe void glGetVertexAttribivARB(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameterArb pname, [OutAttribute] Int32* @params);
        [Slot(1004)]
        static extern unsafe void glGetVertexAttribLui64vARB(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameterArb pname, [OutAttribute] UInt64* @params);
        [Slot(1007)]
        static extern void glGetVertexAttribPointervARB(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribPointerParameterArb pname, [OutAttribute] IntPtr pointer);
        [Slot(1068)]
        static extern bool glIsBufferARB(UInt32 buffer);
        [Slot(1077)]
        static extern bool glIsImageHandleResidentARB(UInt64 handle);
        [Slot(1082)]
        static extern bool glIsNamedStringARB(Int32 namelen, String name);
        [Slot(1089)]
        static extern bool glIsProgramARB(UInt32 program);
        [Slot(1094)]
        static extern bool glIsQueryARB(UInt32 id);
        [Slot(1102)]
        static extern bool glIsTextureHandleResidentARB(UInt64 handle);
        [Slot(1128)]
        static extern void glLinkProgramARB(UInt32 programObj);
        [Slot(1142)]
        static extern unsafe void glLoadTransposeMatrixdARB(Double* m);
        [Slot(1144)]
        static extern unsafe void glLoadTransposeMatrixfARB(Single* m);
        [Slot(1150)]
        static extern void glMakeImageHandleNonResidentARB(UInt64 handle);
        [Slot(1152)]
        static extern void glMakeImageHandleResidentARB(UInt64 handle, OpenTK.Graphics.OpenGL.ArbBindlessTexture access);
        [Slot(1156)]
        static extern void glMakeTextureHandleNonResidentARB(UInt64 handle);
        [Slot(1158)]
        static extern void glMakeTextureHandleResidentARB(UInt64 handle);
        [Slot(1167)]
        static extern IntPtr glMapBufferARB(OpenTK.Graphics.OpenGL.BufferTargetArb target, OpenTK.Graphics.OpenGL.ArbVertexBufferObject access);
        [Slot(1193)]
        static extern void glMatrixIndexPointerARB(Int32 size, OpenTK.Graphics.OpenGL.ArbMatrixPalette type, Int32 stride, IntPtr pointer);
        [Slot(1194)]
        static extern unsafe void glMatrixIndexubvARB(Int32 size, Byte* indices);
        [Slot(1195)]
        static extern unsafe void glMatrixIndexuivARB(Int32 size, UInt32* indices);
        [Slot(1196)]
        static extern unsafe void glMatrixIndexusvARB(Int32 size, UInt16* indices);
        [Slot(1221)]
        static extern void glMinSampleShadingARB(Single value);
        [Slot(1227)]
        static extern void glMultiDrawArraysIndirectCountARB(OpenTK.Graphics.OpenGL.ArbIndirectParameters mode, IntPtr indirect, IntPtr drawcount, Int32 maxdrawcount, Int32 stride);
        [Slot(1235)]
        static extern void glMultiDrawElementsIndirectCountARB(OpenTK.Graphics.OpenGL.ArbIndirectParameters mode, OpenTK.Graphics.OpenGL.ArbIndirectParameters type, IntPtr indirect, IntPtr drawcount, Int32 maxdrawcount, Int32 stride);
        [Slot(1243)]
        static extern void glMultiTexCoord1dARB(OpenTK.Graphics.OpenGL.TextureUnit target, Double s);
        [Slot(1245)]
        static extern unsafe void glMultiTexCoord1dvARB(OpenTK.Graphics.OpenGL.TextureUnit target, Double* v);
        [Slot(1247)]
        static extern void glMultiTexCoord1fARB(OpenTK.Graphics.OpenGL.TextureUnit target, Single s);
        [Slot(1249)]
        static extern unsafe void glMultiTexCoord1fvARB(OpenTK.Graphics.OpenGL.TextureUnit target, Single* v);
        [Slot(1253)]
        static extern void glMultiTexCoord1iARB(OpenTK.Graphics.OpenGL.TextureUnit target, Int32 s);
        [Slot(1255)]
        static extern unsafe void glMultiTexCoord1ivARB(OpenTK.Graphics.OpenGL.TextureUnit target, Int32* v);
        [Slot(1257)]
        static extern void glMultiTexCoord1sARB(OpenTK.Graphics.OpenGL.TextureUnit target, Int16 s);
        [Slot(1259)]
        static extern unsafe void glMultiTexCoord1svARB(OpenTK.Graphics.OpenGL.TextureUnit target, Int16* v);
        [Slot(1265)]
        static extern void glMultiTexCoord2dARB(OpenTK.Graphics.OpenGL.TextureUnit target, Double s, Double t);
        [Slot(1267)]
        static extern unsafe void glMultiTexCoord2dvARB(OpenTK.Graphics.OpenGL.TextureUnit target, Double* v);
        [Slot(1269)]
        static extern void glMultiTexCoord2fARB(OpenTK.Graphics.OpenGL.TextureUnit target, Single s, Single t);
        [Slot(1271)]
        static extern unsafe void glMultiTexCoord2fvARB(OpenTK.Graphics.OpenGL.TextureUnit target, Single* v);
        [Slot(1275)]
        static extern void glMultiTexCoord2iARB(OpenTK.Graphics.OpenGL.TextureUnit target, Int32 s, Int32 t);
        [Slot(1277)]
        static extern unsafe void glMultiTexCoord2ivARB(OpenTK.Graphics.OpenGL.TextureUnit target, Int32* v);
        [Slot(1279)]
        static extern void glMultiTexCoord2sARB(OpenTK.Graphics.OpenGL.TextureUnit target, Int16 s, Int16 t);
        [Slot(1281)]
        static extern unsafe void glMultiTexCoord2svARB(OpenTK.Graphics.OpenGL.TextureUnit target, Int16* v);
        [Slot(1287)]
        static extern void glMultiTexCoord3dARB(OpenTK.Graphics.OpenGL.TextureUnit target, Double s, Double t, Double r);
        [Slot(1289)]
        static extern unsafe void glMultiTexCoord3dvARB(OpenTK.Graphics.OpenGL.TextureUnit target, Double* v);
        [Slot(1291)]
        static extern void glMultiTexCoord3fARB(OpenTK.Graphics.OpenGL.TextureUnit target, Single s, Single t, Single r);
        [Slot(1293)]
        static extern unsafe void glMultiTexCoord3fvARB(OpenTK.Graphics.OpenGL.TextureUnit target, Single* v);
        [Slot(1297)]
        static extern void glMultiTexCoord3iARB(OpenTK.Graphics.OpenGL.TextureUnit target, Int32 s, Int32 t, Int32 r);
        [Slot(1299)]
        static extern unsafe void glMultiTexCoord3ivARB(OpenTK.Graphics.OpenGL.TextureUnit target, Int32* v);
        [Slot(1301)]
        static extern void glMultiTexCoord3sARB(OpenTK.Graphics.OpenGL.TextureUnit target, Int16 s, Int16 t, Int16 r);
        [Slot(1303)]
        static extern unsafe void glMultiTexCoord3svARB(OpenTK.Graphics.OpenGL.TextureUnit target, Int16* v);
        [Slot(1309)]
        static extern void glMultiTexCoord4dARB(OpenTK.Graphics.OpenGL.TextureUnit target, Double s, Double t, Double r, Double q);
        [Slot(1311)]
        static extern unsafe void glMultiTexCoord4dvARB(OpenTK.Graphics.OpenGL.TextureUnit target, Double* v);
        [Slot(1313)]
        static extern void glMultiTexCoord4fARB(OpenTK.Graphics.OpenGL.TextureUnit target, Single s, Single t, Single r, Single q);
        [Slot(1315)]
        static extern unsafe void glMultiTexCoord4fvARB(OpenTK.Graphics.OpenGL.TextureUnit target, Single* v);
        [Slot(1319)]
        static extern void glMultiTexCoord4iARB(OpenTK.Graphics.OpenGL.TextureUnit target, Int32 s, Int32 t, Int32 r, Int32 q);
        [Slot(1321)]
        static extern unsafe void glMultiTexCoord4ivARB(OpenTK.Graphics.OpenGL.TextureUnit target, Int32* v);
        [Slot(1323)]
        static extern void glMultiTexCoord4sARB(OpenTK.Graphics.OpenGL.TextureUnit target, Int16 s, Int16 t, Int16 r, Int16 q);
        [Slot(1325)]
        static extern unsafe void glMultiTexCoord4svARB(OpenTK.Graphics.OpenGL.TextureUnit target, Int16* v);
        [Slot(1364)]
        static extern unsafe void glMultTransposeMatrixdARB(Double* m);
        [Slot(1366)]
        static extern unsafe void glMultTransposeMatrixfARB(Single* m);
        [Slot(1395)]
        static extern void glNamedStringARB(OpenTK.Graphics.OpenGL.ArbShadingLanguageInclude type, Int32 namelen, String name, Int32 stringlen, String @string);
        [Slot(1491)]
        static extern void glPointParameterfARB(OpenTK.Graphics.OpenGL.ArbPointParameters pname, Single param);
        [Slot(1495)]
        static extern unsafe void glPointParameterfvARB(OpenTK.Graphics.OpenGL.ArbPointParameters pname, Single* @params);
        [Slot(1532)]
        static extern void glProgramEnvParameter4dARB(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Double x, Double y, Double z, Double w);
        [Slot(1533)]
        static extern unsafe void glProgramEnvParameter4dvARB(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Double* @params);
        [Slot(1534)]
        static extern void glProgramEnvParameter4fARB(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Single x, Single y, Single z, Single w);
        [Slot(1535)]
        static extern unsafe void glProgramEnvParameter4fvARB(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Single* @params);
        [Slot(1543)]
        static extern void glProgramLocalParameter4dARB(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Double x, Double y, Double z, Double w);
        [Slot(1544)]
        static extern unsafe void glProgramLocalParameter4dvARB(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Double* @params);
        [Slot(1545)]
        static extern void glProgramLocalParameter4fARB(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Single x, Single y, Single z, Single w);
        [Slot(1546)]
        static extern unsafe void glProgramLocalParameter4fvARB(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Single* @params);
        [Slot(1563)]
        static extern void glProgramParameteriARB(UInt32 program, OpenTK.Graphics.OpenGL.AssemblyProgramParameterArb pname, Int32 value);
        [Slot(1567)]
        static extern void glProgramStringARB(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, OpenTK.Graphics.OpenGL.All format, Int32 len, IntPtr @string);
        [Slot(1649)]
        static extern void glProgramUniformHandleui64ARB(UInt32 program, Int32 location, UInt64 value);
        [Slot(1651)]
        static extern unsafe void glProgramUniformHandleui64vARB(UInt32 program, Int32 location, Int32 count, UInt64* values);
        [Slot(1736)]
        static extern void glReadnPixelsARB(Int32 x, Int32 y, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.ArbRobustness format, OpenTK.Graphics.OpenGL.ArbRobustness type, Int32 bufSize, [OutAttribute] IntPtr data);
        [Slot(1791)]
        static extern void glSampleCoverageARB(Single value, bool invert);
        [Slot(1870)]
        static extern unsafe void glShaderSourceARB(UInt32 shaderObj, Int32 count, String[] @string, Int32* length);
        [Slot(1915)]
        static extern void glTexBufferARB(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.ArbTextureBufferObject internalformat, UInt32 buffer);
        [Slot(2027)]
        static extern void glTexPageCommitmentARB(OpenTK.Graphics.OpenGL.ArbSparseTexture target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, bool resident);
        [Slot(2098)]
        static extern void glUniform1fARB(Int32 location, Single v0);
        [Slot(2100)]
        static extern unsafe void glUniform1fvARB(Int32 location, Int32 count, Single* value);
        [Slot(2104)]
        static extern void glUniform1iARB(Int32 location, Int32 v0);
        [Slot(2106)]
        static extern unsafe void glUniform1ivARB(Int32 location, Int32 count, Int32* value);
        [Slot(2116)]
        static extern void glUniform2fARB(Int32 location, Single v0, Single v1);
        [Slot(2118)]
        static extern unsafe void glUniform2fvARB(Int32 location, Int32 count, Single* value);
        [Slot(2122)]
        static extern void glUniform2iARB(Int32 location, Int32 v0, Int32 v1);
        [Slot(2124)]
        static extern unsafe void glUniform2ivARB(Int32 location, Int32 count, Int32* value);
        [Slot(2134)]
        static extern void glUniform3fARB(Int32 location, Single v0, Single v1, Single v2);
        [Slot(2136)]
        static extern unsafe void glUniform3fvARB(Int32 location, Int32 count, Single* value);
        [Slot(2140)]
        static extern void glUniform3iARB(Int32 location, Int32 v0, Int32 v1, Int32 v2);
        [Slot(2142)]
        static extern unsafe void glUniform3ivARB(Int32 location, Int32 count, Int32* value);
        [Slot(2152)]
        static extern void glUniform4fARB(Int32 location, Single v0, Single v1, Single v2, Single v3);
        [Slot(2154)]
        static extern unsafe void glUniform4fvARB(Int32 location, Int32 count, Single* value);
        [Slot(2158)]
        static extern void glUniform4iARB(Int32 location, Int32 v0, Int32 v1, Int32 v2, Int32 v3);
        [Slot(2160)]
        static extern unsafe void glUniform4ivARB(Int32 location, Int32 count, Int32* value);
        [Slot(2169)]
        static extern void glUniformHandleui64ARB(Int32 location, UInt64 value);
        [Slot(2171)]
        static extern unsafe void glUniformHandleui64vARB(Int32 location, Int32 count, UInt64* value);
        [Slot(2175)]
        static extern unsafe void glUniformMatrix2fvARB(Int32 location, Int32 count, bool transpose, Single* value);
        [Slot(2182)]
        static extern unsafe void glUniformMatrix3fvARB(Int32 location, Int32 count, bool transpose, Single* value);
        [Slot(2189)]
        static extern unsafe void glUniformMatrix4fvARB(Int32 location, Int32 count, bool transpose, Single* value);
        [Slot(2199)]
        static extern bool glUnmapBufferARB(OpenTK.Graphics.OpenGL.BufferTargetArb target);
        [Slot(2205)]
        static extern void glUseProgramObjectARB(UInt32 programObj);
        [Slot(2210)]
        static extern void glValidateProgramARB(UInt32 programObj);
        [Slot(2298)]
        static extern void glVertexAttrib1dARB(UInt32 index, Double x);
        [Slot(2301)]
        static extern unsafe void glVertexAttrib1dvARB(UInt32 index, Double* v);
        [Slot(2304)]
        static extern void glVertexAttrib1fARB(UInt32 index, Single x);
        [Slot(2307)]
        static extern unsafe void glVertexAttrib1fvARB(UInt32 index, Single* v);
        [Slot(2312)]
        static extern void glVertexAttrib1sARB(UInt32 index, Int16 x);
        [Slot(2315)]
        static extern unsafe void glVertexAttrib1svARB(UInt32 index, Int16* v);
        [Slot(2318)]
        static extern void glVertexAttrib2dARB(UInt32 index, Double x, Double y);
        [Slot(2321)]
        static extern unsafe void glVertexAttrib2dvARB(UInt32 index, Double* v);
        [Slot(2324)]
        static extern void glVertexAttrib2fARB(UInt32 index, Single x, Single y);
        [Slot(2327)]
        static extern unsafe void glVertexAttrib2fvARB(UInt32 index, Single* v);
        [Slot(2332)]
        static extern void glVertexAttrib2sARB(UInt32 index, Int16 x, Int16 y);
        [Slot(2335)]
        static extern unsafe void glVertexAttrib2svARB(UInt32 index, Int16* v);
        [Slot(2338)]
        static extern void glVertexAttrib3dARB(UInt32 index, Double x, Double y, Double z);
        [Slot(2341)]
        static extern unsafe void glVertexAttrib3dvARB(UInt32 index, Double* v);
        [Slot(2344)]
        static extern void glVertexAttrib3fARB(UInt32 index, Single x, Single y, Single z);
        [Slot(2347)]
        static extern unsafe void glVertexAttrib3fvARB(UInt32 index, Single* v);
        [Slot(2352)]
        static extern void glVertexAttrib3sARB(UInt32 index, Int16 x, Int16 y, Int16 z);
        [Slot(2355)]
        static extern unsafe void glVertexAttrib3svARB(UInt32 index, Int16* v);
        [Slot(2358)]
        static extern unsafe void glVertexAttrib4bvARB(UInt32 index, SByte* v);
        [Slot(2360)]
        static extern void glVertexAttrib4dARB(UInt32 index, Double x, Double y, Double z, Double w);
        [Slot(2363)]
        static extern unsafe void glVertexAttrib4dvARB(UInt32 index, Double* v);
        [Slot(2366)]
        static extern void glVertexAttrib4fARB(UInt32 index, Single x, Single y, Single z, Single w);
        [Slot(2369)]
        static extern unsafe void glVertexAttrib4fvARB(UInt32 index, Single* v);
        [Slot(2374)]
        static extern unsafe void glVertexAttrib4ivARB(UInt32 index, Int32* v);
        [Slot(2376)]
        static extern unsafe void glVertexAttrib4NbvARB(UInt32 index, SByte* v);
        [Slot(2378)]
        static extern unsafe void glVertexAttrib4NivARB(UInt32 index, Int32* v);
        [Slot(2380)]
        static extern unsafe void glVertexAttrib4NsvARB(UInt32 index, Int16* v);
        [Slot(2382)]
        static extern void glVertexAttrib4NubARB(UInt32 index, Byte x, Byte y, Byte z, Byte w);
        [Slot(2384)]
        static extern unsafe void glVertexAttrib4NubvARB(UInt32 index, Byte* v);
        [Slot(2386)]
        static extern unsafe void glVertexAttrib4NuivARB(UInt32 index, UInt32* v);
        [Slot(2388)]
        static extern unsafe void glVertexAttrib4NusvARB(UInt32 index, UInt16* v);
        [Slot(2390)]
        static extern void glVertexAttrib4sARB(UInt32 index, Int16 x, Int16 y, Int16 z, Int16 w);
        [Slot(2393)]
        static extern unsafe void glVertexAttrib4svARB(UInt32 index, Int16* v);
        [Slot(2397)]
        static extern unsafe void glVertexAttrib4ubvARB(UInt32 index, Byte* v);
        [Slot(2400)]
        static extern unsafe void glVertexAttrib4uivARB(UInt32 index, UInt32* v);
        [Slot(2402)]
        static extern unsafe void glVertexAttrib4usvARB(UInt32 index, UInt16* v);
        [Slot(2406)]
        static extern void glVertexAttribDivisorARB(UInt32 index, UInt32 divisor);
        [Slot(2459)]
        static extern void glVertexAttribL1ui64ARB(UInt32 index, UInt64 x);
        [Slot(2461)]
        static extern unsafe void glVertexAttribL1ui64vARB(UInt32 index, UInt64* v);
        [Slot(2501)]
        static extern void glVertexAttribPointerARB(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribPointerTypeArb type, bool normalized, Int32 stride, IntPtr pointer);
        [Slot(2521)]
        static extern void glVertexBlendARB(Int32 count);
        [Slot(2581)]
        static extern unsafe void glWeightbvARB(Int32 size, SByte* weights);
        [Slot(2582)]
        static extern unsafe void glWeightdvARB(Int32 size, Double* weights);
        [Slot(2583)]
        static extern unsafe void glWeightfvARB(Int32 size, Single* weights);
        [Slot(2584)]
        static extern unsafe void glWeightivARB(Int32 size, Int32* weights);
        [Slot(2586)]
        static extern void glWeightPointerARB(Int32 size, OpenTK.Graphics.OpenGL.ArbVertexBlend type, Int32 stride, IntPtr pointer);
        [Slot(2587)]
        static extern unsafe void glWeightsvARB(Int32 size, Int16* weights);
        [Slot(2588)]
        static extern unsafe void glWeightubvARB(Int32 size, Byte* weights);
        [Slot(2589)]
        static extern unsafe void glWeightuivARB(Int32 size, UInt32* weights);
        [Slot(2590)]
        static extern unsafe void glWeightusvARB(Int32 size, UInt16* weights);
        [Slot(2592)]
        static extern void glWindowPos2dARB(Double x, Double y);
        [Slot(2595)]
        static extern unsafe void glWindowPos2dvARB(Double* v);
        [Slot(2598)]
        static extern void glWindowPos2fARB(Single x, Single y);
        [Slot(2601)]
        static extern unsafe void glWindowPos2fvARB(Single* v);
        [Slot(2604)]
        static extern void glWindowPos2iARB(Int32 x, Int32 y);
        [Slot(2607)]
        static extern unsafe void glWindowPos2ivARB(Int32* v);
        [Slot(2610)]
        static extern void glWindowPos2sARB(Int16 x, Int16 y);
        [Slot(2613)]
        static extern unsafe void glWindowPos2svARB(Int16* v);
        [Slot(2616)]
        static extern void glWindowPos3dARB(Double x, Double y, Double z);
        [Slot(2619)]
        static extern unsafe void glWindowPos3dvARB(Double* v);
        [Slot(2622)]
        static extern void glWindowPos3fARB(Single x, Single y, Single z);
        [Slot(2625)]
        static extern unsafe void glWindowPos3fvARB(Single* v);
        [Slot(2628)]
        static extern void glWindowPos3iARB(Int32 x, Int32 y, Int32 z);
        [Slot(2631)]
        static extern unsafe void glWindowPos3ivARB(Int32* v);
        [Slot(2634)]
        static extern void glWindowPos3sARB(Int16 x, Int16 y, Int16 z);
        [Slot(2637)]
        static extern unsafe void glWindowPos3svARB(Int16* v);
        [Slot(9)]
        static extern void glAlphaFragmentOp1ATI(OpenTK.Graphics.OpenGL.AtiFragmentShader op, UInt32 dst, UInt32 dstMod, UInt32 arg1, UInt32 arg1Rep, UInt32 arg1Mod);
        [Slot(10)]
        static extern void glAlphaFragmentOp2ATI(OpenTK.Graphics.OpenGL.AtiFragmentShader op, UInt32 dst, UInt32 dstMod, UInt32 arg1, UInt32 arg1Rep, UInt32 arg1Mod, UInt32 arg2, UInt32 arg2Rep, UInt32 arg2Mod);
        [Slot(11)]
        static extern void glAlphaFragmentOp3ATI(OpenTK.Graphics.OpenGL.AtiFragmentShader op, UInt32 dst, UInt32 dstMod, UInt32 arg1, UInt32 arg1Rep, UInt32 arg1Mod, UInt32 arg2, UInt32 arg2Rep, UInt32 arg2Mod, UInt32 arg3, UInt32 arg3Rep, UInt32 arg3Mod);
        [Slot(20)]
        static extern void glArrayObjectATI(OpenTK.Graphics.OpenGL.EnableCap array, Int32 size, OpenTK.Graphics.OpenGL.AtiVertexArrayObject type, Int32 stride, UInt32 buffer, UInt32 offset);
        [Slot(28)]
        static extern void glBeginFragmentShaderATI();
        [Slot(56)]
        static extern void glBindFragmentShaderATI(UInt32 id);
        [Slot(168)]
        static extern void glClientActiveVertexStreamATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream);
        [Slot(223)]
        static extern void glColorFragmentOp1ATI(OpenTK.Graphics.OpenGL.AtiFragmentShader op, UInt32 dst, UInt32 dstMask, UInt32 dstMod, UInt32 arg1, UInt32 arg1Rep, UInt32 arg1Mod);
        [Slot(224)]
        static extern void glColorFragmentOp2ATI(OpenTK.Graphics.OpenGL.AtiFragmentShader op, UInt32 dst, UInt32 dstMask, UInt32 dstMod, UInt32 arg1, UInt32 arg1Rep, UInt32 arg1Mod, UInt32 arg2, UInt32 arg2Rep, UInt32 arg2Mod);
        [Slot(225)]
        static extern void glColorFragmentOp3ATI(OpenTK.Graphics.OpenGL.AtiFragmentShader op, UInt32 dst, UInt32 dstMask, UInt32 dstMod, UInt32 arg1, UInt32 arg1Rep, UInt32 arg1Mod, UInt32 arg2, UInt32 arg2Rep, UInt32 arg2Mod, UInt32 arg3, UInt32 arg3Rep, UInt32 arg3Mod);
        [Slot(364)]
        static extern void glDeleteFragmentShaderATI(UInt32 id);
        [Slot(432)]
        static extern unsafe void glDrawBuffersATI(Int32 n, OpenTK.Graphics.OpenGL.AtiDrawBuffers* bufs);
        [Slot(434)]
        static extern void glDrawElementArrayATI(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count);
        [Slot(447)]
        static extern void glDrawRangeElementArrayATI(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 start, UInt32 end, Int32 count);
        [Slot(464)]
        static extern void glElementPointerATI(OpenTK.Graphics.OpenGL.AtiElementArray type, IntPtr pointer);
        [Slot(481)]
        static extern void glEndFragmentShaderATI();
        [Slot(587)]
        static extern void glFreeObjectBufferATI(UInt32 buffer);
        [Slot(601)]
        static extern Int32 glGenFragmentShadersATI(UInt32 range);
        [Slot(639)]
        static extern unsafe void glGetArrayObjectfvATI(OpenTK.Graphics.OpenGL.EnableCap array, OpenTK.Graphics.OpenGL.AtiVertexArrayObject pname, [OutAttribute] Single* @params);
        [Slot(640)]
        static extern unsafe void glGetArrayObjectivATI(OpenTK.Graphics.OpenGL.EnableCap array, OpenTK.Graphics.OpenGL.AtiVertexArrayObject pname, [OutAttribute] Int32* @params);
        [Slot(816)]
        static extern unsafe void glGetObjectBufferfvATI(UInt32 buffer, OpenTK.Graphics.OpenGL.AtiVertexArrayObject pname, [OutAttribute] Single* @params);
        [Slot(817)]
        static extern unsafe void glGetObjectBufferivATI(UInt32 buffer, OpenTK.Graphics.OpenGL.AtiVertexArrayObject pname, [OutAttribute] Int32* @params);
        [Slot(922)]
        static extern unsafe void glGetTexBumpParameterfvATI(OpenTK.Graphics.OpenGL.AtiEnvmapBumpmap pname, [OutAttribute] Single* param);
        [Slot(923)]
        static extern unsafe void glGetTexBumpParameterivATI(OpenTK.Graphics.OpenGL.AtiEnvmapBumpmap pname, [OutAttribute] Int32* param);
        [Slot(975)]
        static extern unsafe void glGetVariantArrayObjectfvATI(UInt32 id, OpenTK.Graphics.OpenGL.AtiVertexArrayObject pname, [OutAttribute] Single* @params);
        [Slot(976)]
        static extern unsafe void glGetVariantArrayObjectivATI(UInt32 id, OpenTK.Graphics.OpenGL.AtiVertexArrayObject pname, [OutAttribute] Int32* @params);
        [Slot(986)]
        static extern unsafe void glGetVertexAttribArrayObjectfvATI(UInt32 index, OpenTK.Graphics.OpenGL.AtiVertexAttribArrayObject pname, [OutAttribute] Single* @params);
        [Slot(987)]
        static extern unsafe void glGetVertexAttribArrayObjectivATI(UInt32 index, OpenTK.Graphics.OpenGL.AtiVertexAttribArrayObject pname, [OutAttribute] Int32* @params);
        [Slot(1083)]
        static extern bool glIsObjectBufferATI(UInt32 buffer);
        [Slot(1178)]
        static extern IntPtr glMapObjectBufferATI(UInt32 buffer);
        [Slot(1397)]
        static extern Int32 glNewObjectBufferATI(Int32 size, IntPtr pointer, OpenTK.Graphics.OpenGL.AtiVertexArrayObject usage);
        [Slot(1421)]
        static extern void glNormalStream3bATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, SByte nx, SByte ny, SByte nz);
        [Slot(1422)]
        static extern unsafe void glNormalStream3bvATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, SByte* coords);
        [Slot(1423)]
        static extern void glNormalStream3dATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Double nx, Double ny, Double nz);
        [Slot(1424)]
        static extern unsafe void glNormalStream3dvATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Double* coords);
        [Slot(1425)]
        static extern void glNormalStream3fATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Single nx, Single ny, Single nz);
        [Slot(1426)]
        static extern unsafe void glNormalStream3fvATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Single* coords);
        [Slot(1427)]
        static extern void glNormalStream3iATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int32 nx, Int32 ny, Int32 nz);
        [Slot(1428)]
        static extern unsafe void glNormalStream3ivATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int32* coords);
        [Slot(1429)]
        static extern void glNormalStream3sATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int16 nx, Int16 ny, Int16 nz);
        [Slot(1430)]
        static extern unsafe void glNormalStream3svATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int16* coords);
        [Slot(1440)]
        static extern void glPassTexCoordATI(UInt32 dst, UInt32 coord, OpenTK.Graphics.OpenGL.AtiFragmentShader swizzle);
        [Slot(1487)]
        static extern void glPNTrianglesfATI(OpenTK.Graphics.OpenGL.AtiPnTriangles pname, Single param);
        [Slot(1488)]
        static extern void glPNTrianglesiATI(OpenTK.Graphics.OpenGL.AtiPnTriangles pname, Int32 param);
        [Slot(1794)]
        static extern void glSampleMapATI(UInt32 dst, UInt32 interp, OpenTK.Graphics.OpenGL.AtiFragmentShader swizzle);
        [Slot(1860)]
        static extern unsafe void glSetFragmentShaderConstantATI(UInt32 dst, Single* value);
        [Slot(1883)]
        static extern void glStencilFuncSeparateATI(OpenTK.Graphics.OpenGL.StencilFunction frontfunc, OpenTK.Graphics.OpenGL.StencilFunction backfunc, Int32 @ref, UInt32 mask);
        [Slot(1888)]
        static extern void glStencilOpSeparateATI(OpenTK.Graphics.OpenGL.AtiSeparateStencil face, OpenTK.Graphics.OpenGL.StencilOp sfail, OpenTK.Graphics.OpenGL.StencilOp dpfail, OpenTK.Graphics.OpenGL.StencilOp dppass);
        [Slot(1918)]
        static extern unsafe void glTexBumpParameterfvATI(OpenTK.Graphics.OpenGL.AtiEnvmapBumpmap pname, Single* param);
        [Slot(1919)]
        static extern unsafe void glTexBumpParameterivATI(OpenTK.Graphics.OpenGL.AtiEnvmapBumpmap pname, Int32* param);
        [Slot(2201)]
        static extern void glUnmapObjectBufferATI(UInt32 buffer);
        [Slot(2203)]
        static extern void glUpdateObjectBufferATI(UInt32 buffer, UInt32 offset, Int32 size, IntPtr pointer, OpenTK.Graphics.OpenGL.AtiVertexArrayObject preserve);
        [Slot(2213)]
        static extern void glVariantArrayObjectATI(UInt32 id, OpenTK.Graphics.OpenGL.AtiVertexArrayObject type, Int32 stride, UInt32 buffer, UInt32 offset);
        [Slot(2403)]
        static extern void glVertexAttribArrayObjectATI(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribPointerType type, bool normalized, Int32 stride, UInt32 buffer, UInt32 offset);
        [Slot(2522)]
        static extern void glVertexBlendEnvfATI(OpenTK.Graphics.OpenGL.AtiVertexStreams pname, Single param);
        [Slot(2523)]
        static extern void glVertexBlendEnviATI(OpenTK.Graphics.OpenGL.AtiVertexStreams pname, Int32 param);
        [Slot(2535)]
        static extern void glVertexStream1dATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Double x);
        [Slot(2536)]
        static extern unsafe void glVertexStream1dvATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Double* coords);
        [Slot(2537)]
        static extern void glVertexStream1fATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Single x);
        [Slot(2538)]
        static extern unsafe void glVertexStream1fvATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Single* coords);
        [Slot(2539)]
        static extern void glVertexStream1iATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int32 x);
        [Slot(2540)]
        static extern unsafe void glVertexStream1ivATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int32* coords);
        [Slot(2541)]
        static extern void glVertexStream1sATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int16 x);
        [Slot(2542)]
        static extern unsafe void glVertexStream1svATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int16* coords);
        [Slot(2543)]
        static extern void glVertexStream2dATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Double x, Double y);
        [Slot(2544)]
        static extern unsafe void glVertexStream2dvATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Double* coords);
        [Slot(2545)]
        static extern void glVertexStream2fATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Single x, Single y);
        [Slot(2546)]
        static extern unsafe void glVertexStream2fvATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Single* coords);
        [Slot(2547)]
        static extern void glVertexStream2iATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int32 x, Int32 y);
        [Slot(2548)]
        static extern unsafe void glVertexStream2ivATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int32* coords);
        [Slot(2549)]
        static extern void glVertexStream2sATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int16 x, Int16 y);
        [Slot(2550)]
        static extern unsafe void glVertexStream2svATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int16* coords);
        [Slot(2551)]
        static extern void glVertexStream3dATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Double x, Double y, Double z);
        [Slot(2552)]
        static extern unsafe void glVertexStream3dvATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Double* coords);
        [Slot(2553)]
        static extern void glVertexStream3fATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Single x, Single y, Single z);
        [Slot(2554)]
        static extern unsafe void glVertexStream3fvATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Single* coords);
        [Slot(2555)]
        static extern void glVertexStream3iATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int32 x, Int32 y, Int32 z);
        [Slot(2556)]
        static extern unsafe void glVertexStream3ivATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int32* coords);
        [Slot(2557)]
        static extern void glVertexStream3sATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int16 x, Int16 y, Int16 z);
        [Slot(2558)]
        static extern unsafe void glVertexStream3svATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int16* coords);
        [Slot(2559)]
        static extern void glVertexStream4dATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Double x, Double y, Double z, Double w);
        [Slot(2560)]
        static extern unsafe void glVertexStream4dvATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Double* coords);
        [Slot(2561)]
        static extern void glVertexStream4fATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Single x, Single y, Single z, Single w);
        [Slot(2562)]
        static extern unsafe void glVertexStream4fvATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Single* coords);
        [Slot(2563)]
        static extern void glVertexStream4iATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int32 x, Int32 y, Int32 z, Int32 w);
        [Slot(2564)]
        static extern unsafe void glVertexStream4ivATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int32* coords);
        [Slot(2565)]
        static extern void glVertexStream4sATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int16 x, Int16 y, Int16 z, Int16 w);
        [Slot(2566)]
        static extern unsafe void glVertexStream4svATI(OpenTK.Graphics.OpenGL.AtiVertexStreams stream, Int16* coords);
        [Slot(0)]
        static extern void glAccum(OpenTK.Graphics.OpenGL.AccumOp op, Single value);
        [Slot(3)]
        static extern void glActiveShaderProgram(UInt32 pipeline, UInt32 program);
        [Slot(6)]
        static extern void glActiveTexture(OpenTK.Graphics.OpenGL.TextureUnit texture);
        [Slot(12)]
        static extern void glAlphaFunc(OpenTK.Graphics.OpenGL.AlphaFunction func, Single @ref);
        [Slot(16)]
        static extern unsafe bool glAreTexturesResident(Int32 n, UInt32* textures, [OutAttribute] bool* residences);
        [Slot(18)]
        static extern void glArrayElement(Int32 i);
        [Slot(23)]
        static extern void glAttachShader(UInt32 program, UInt32 shader);
        [Slot(24)]
        static extern void glBegin(OpenTK.Graphics.OpenGL.PrimitiveType mode);
        [Slot(25)]
        static extern void glBeginConditionalRender(UInt32 id, OpenTK.Graphics.OpenGL.ConditionalRenderType mode);
        [Slot(31)]
        static extern void glBeginQuery(OpenTK.Graphics.OpenGL.QueryTarget target, UInt32 id);
        [Slot(33)]
        static extern void glBeginQueryIndexed(OpenTK.Graphics.OpenGL.QueryTarget target, UInt32 index, UInt32 id);
        [Slot(34)]
        static extern void glBeginTransformFeedback(OpenTK.Graphics.OpenGL.TransformFeedbackPrimitiveType primitiveMode);
        [Slot(39)]
        static extern void glBindAttribLocation(UInt32 program, UInt32 index, String name);
        [Slot(41)]
        static extern void glBindBuffer(OpenTK.Graphics.OpenGL.BufferTarget target, UInt32 buffer);
        [Slot(43)]
        static extern void glBindBufferBase(OpenTK.Graphics.OpenGL.BufferRangeTarget target, UInt32 index, UInt32 buffer);
        [Slot(48)]
        static extern void glBindBufferRange(OpenTK.Graphics.OpenGL.BufferRangeTarget target, UInt32 index, UInt32 buffer, IntPtr offset, IntPtr size);
        [Slot(51)]
        static extern unsafe void glBindBuffersBase(OpenTK.Graphics.OpenGL.BufferRangeTarget target, UInt32 first, Int32 count, UInt32* buffers);
        [Slot(52)]
        static extern unsafe void glBindBuffersRange(OpenTK.Graphics.OpenGL.BufferRangeTarget target, UInt32 first, Int32 count, UInt32* buffers, IntPtr* offsets, IntPtr* sizes);
        [Slot(53)]
        static extern void glBindFragDataLocation(UInt32 program, UInt32 color, String name);
        [Slot(55)]
        static extern void glBindFragDataLocationIndexed(UInt32 program, UInt32 colorNumber, UInt32 index, String name);
        [Slot(57)]
        static extern void glBindFramebuffer(OpenTK.Graphics.OpenGL.FramebufferTarget target, UInt32 framebuffer);
        [Slot(59)]
        static extern void glBindImageTexture(UInt32 unit, UInt32 texture, Int32 level, bool layered, Int32 layer, OpenTK.Graphics.OpenGL.TextureAccess access, OpenTK.Graphics.OpenGL.SizedInternalFormat format);
        [Slot(61)]
        static extern unsafe void glBindImageTextures(UInt32 first, Int32 count, UInt32* textures);
        [Slot(68)]
        static extern void glBindProgramPipeline(UInt32 pipeline);
        [Slot(70)]
        static extern void glBindRenderbuffer(OpenTK.Graphics.OpenGL.RenderbufferTarget target, UInt32 renderbuffer);
        [Slot(72)]
        static extern void glBindSampler(UInt32 unit, UInt32 sampler);
        [Slot(73)]
        static extern unsafe void glBindSamplers(UInt32 first, Int32 count, UInt32* samplers);
        [Slot(75)]
        static extern void glBindTexture(OpenTK.Graphics.OpenGL.TextureTarget target, UInt32 texture);
        [Slot(77)]
        static extern unsafe void glBindTextures(UInt32 first, Int32 count, UInt32* textures);
        [Slot(79)]
        static extern void glBindTransformFeedback(OpenTK.Graphics.OpenGL.TransformFeedbackTarget target, UInt32 id);
        [Slot(81)]
        static extern void glBindVertexArray(UInt32 array);
        [Slot(83)]
        static extern void glBindVertexBuffer(UInt32 bindingindex, UInt32 buffer, IntPtr offset, Int32 stride);
        [Slot(84)]
        static extern unsafe void glBindVertexBuffers(UInt32 first, Int32 count, UInt32* buffers, IntPtr* offsets, Int32* strides);
        [Slot(99)]
        static extern unsafe void glBitmap(Int32 width, Int32 height, Single xorig, Single yorig, Single xmove, Single ymove, Byte* bitmap);
        [Slot(102)]
        static extern void glBlendColor(Single red, Single green, Single blue, Single alpha);
        [Slot(105)]
        static extern void glBlendEquation(OpenTK.Graphics.OpenGL.BlendEquationMode mode);
        [Slot(107)]
        static extern void glBlendEquationi(UInt32 buf, OpenTK.Graphics.OpenGL.BlendEquationMode mode);
        [Slot(110)]
        static extern void glBlendEquationSeparate(OpenTK.Graphics.OpenGL.BlendEquationMode modeRGB, OpenTK.Graphics.OpenGL.BlendEquationMode modeAlpha);
        [Slot(112)]
        static extern void glBlendEquationSeparatei(UInt32 buf, OpenTK.Graphics.OpenGL.BlendEquationMode modeRGB, OpenTK.Graphics.OpenGL.BlendEquationMode modeAlpha);
        [Slot(115)]
        static extern void glBlendFunc(OpenTK.Graphics.OpenGL.BlendingFactorSrc sfactor, OpenTK.Graphics.OpenGL.BlendingFactorDest dfactor);
        [Slot(116)]
        static extern void glBlendFunci(UInt32 buf, OpenTK.Graphics.OpenGL.BlendingFactorSrc src, OpenTK.Graphics.OpenGL.BlendingFactorDest dst);
        [Slot(119)]
        static extern void glBlendFuncSeparate(OpenTK.Graphics.OpenGL.BlendingFactorSrc sfactorRGB, OpenTK.Graphics.OpenGL.BlendingFactorDest dfactorRGB, OpenTK.Graphics.OpenGL.BlendingFactorSrc sfactorAlpha, OpenTK.Graphics.OpenGL.BlendingFactorDest dfactorAlpha);
        [Slot(121)]
        static extern void glBlendFuncSeparatei(UInt32 buf, OpenTK.Graphics.OpenGL.BlendingFactorSrc srcRGB, OpenTK.Graphics.OpenGL.BlendingFactorDest dstRGB, OpenTK.Graphics.OpenGL.BlendingFactorSrc srcAlpha, OpenTK.Graphics.OpenGL.BlendingFactorDest dstAlpha);
        [Slot(126)]
        static extern void glBlitFramebuffer(Int32 srcX0, Int32 srcY0, Int32 srcX1, Int32 srcY1, Int32 dstX0, Int32 dstY0, Int32 dstX1, Int32 dstY1, OpenTK.Graphics.OpenGL.ClearBufferMask mask, OpenTK.Graphics.OpenGL.BlitFramebufferFilter filter);
        [Slot(129)]
        static extern void glBufferData(OpenTK.Graphics.OpenGL.BufferTarget target, IntPtr size, IntPtr data, OpenTK.Graphics.OpenGL.BufferUsageHint usage);
        [Slot(132)]
        static extern void glBufferStorage(OpenTK.Graphics.OpenGL.BufferTarget target, IntPtr size, IntPtr data, OpenTK.Graphics.OpenGL.BufferStorageFlags flags);
        [Slot(133)]
        static extern void glBufferSubData(OpenTK.Graphics.OpenGL.BufferTarget target, IntPtr offset, IntPtr size, IntPtr data);
        [Slot(135)]
        static extern void glCallList(UInt32 list);
        [Slot(136)]
        static extern void glCallLists(Int32 n, OpenTK.Graphics.OpenGL.ListNameType type, IntPtr lists);
        [Slot(137)]
        static extern OpenTK.Graphics.OpenGL.FramebufferErrorCode glCheckFramebufferStatus(OpenTK.Graphics.OpenGL.FramebufferTarget target);
        [Slot(140)]
        static extern void glClampColor(OpenTK.Graphics.OpenGL.ClampColorTarget target, OpenTK.Graphics.OpenGL.ClampColorMode clamp);
        [Slot(142)]
        static extern void glClear(OpenTK.Graphics.OpenGL.ClearBufferMask mask);
        [Slot(143)]
        static extern void glClearAccum(Single red, Single green, Single blue, Single alpha);
        [Slot(145)]
        static extern void glClearBufferData(OpenTK.Graphics.OpenGL.BufferTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.All type, IntPtr data);
        [Slot(146)]
        static extern void glClearBufferfi(OpenTK.Graphics.OpenGL.ClearBufferCombined buffer, Int32 drawbuffer, Single depth, Int32 stencil);
        [Slot(147)]
        static extern unsafe void glClearBufferfv(OpenTK.Graphics.OpenGL.ClearBuffer buffer, Int32 drawbuffer, Single* value);
        [Slot(148)]
        static extern unsafe void glClearBufferiv(OpenTK.Graphics.OpenGL.ClearBuffer buffer, Int32 drawbuffer, Int32* value);
        [Slot(149)]
        static extern void glClearBufferSubData(OpenTK.Graphics.OpenGL.BufferTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, IntPtr offset, IntPtr size, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.All type, IntPtr data);
        [Slot(150)]
        static extern unsafe void glClearBufferuiv(OpenTK.Graphics.OpenGL.ClearBuffer buffer, Int32 drawbuffer, UInt32* value);
        [Slot(151)]
        static extern void glClearColor(Single red, Single green, Single blue, Single alpha);
        [Slot(155)]
        static extern void glClearDepth(Double depth);
        [Slot(157)]
        static extern void glClearDepthf(Single d);
        [Slot(160)]
        static extern void glClearIndex(Single c);
        [Slot(163)]
        static extern void glClearStencil(Int32 s);
        [Slot(164)]
        static extern void glClearTexImage(UInt32 texture, Int32 level, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr data);
        [Slot(165)]
        static extern void glClearTexSubImage(UInt32 texture, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr data);
        [Slot(166)]
        static extern void glClientActiveTexture(OpenTK.Graphics.OpenGL.TextureUnit texture);
        [Slot(170)]
        static extern OpenTK.Graphics.OpenGL.WaitSyncStatus glClientWaitSync(IntPtr sync, OpenTK.Graphics.OpenGL.ClientWaitSyncFlags flags, UInt64 timeout);
        [Slot(171)]
        static extern unsafe void glClipPlane(OpenTK.Graphics.OpenGL.ClipPlaneName plane, Double* equation);
        [Slot(174)]
        static extern void glColor3b(SByte red, SByte green, SByte blue);
        [Slot(175)]
        static extern unsafe void glColor3bv(SByte* v);
        [Slot(176)]
        static extern void glColor3d(Double red, Double green, Double blue);
        [Slot(177)]
        static extern unsafe void glColor3dv(Double* v);
        [Slot(178)]
        static extern void glColor3f(Single red, Single green, Single blue);
        [Slot(179)]
        static extern unsafe void glColor3fv(Single* v);
        [Slot(184)]
        static extern void glColor3i(Int32 red, Int32 green, Int32 blue);
        [Slot(185)]
        static extern unsafe void glColor3iv(Int32* v);
        [Slot(186)]
        static extern void glColor3s(Int16 red, Int16 green, Int16 blue);
        [Slot(187)]
        static extern unsafe void glColor3sv(Int16* v);
        [Slot(188)]
        static extern void glColor3ub(Byte red, Byte green, Byte blue);
        [Slot(189)]
        static extern unsafe void glColor3ubv(Byte* v);
        [Slot(190)]
        static extern void glColor3ui(UInt32 red, UInt32 green, UInt32 blue);
        [Slot(191)]
        static extern unsafe void glColor3uiv(UInt32* v);
        [Slot(192)]
        static extern void glColor3us(UInt16 red, UInt16 green, UInt16 blue);
        [Slot(193)]
        static extern unsafe void glColor3usv(UInt16* v);
        [Slot(196)]
        static extern void glColor4b(SByte red, SByte green, SByte blue, SByte alpha);
        [Slot(197)]
        static extern unsafe void glColor4bv(SByte* v);
        [Slot(198)]
        static extern void glColor4d(Double red, Double green, Double blue, Double alpha);
        [Slot(199)]
        static extern unsafe void glColor4dv(Double* v);
        [Slot(200)]
        static extern void glColor4f(Single red, Single green, Single blue, Single alpha);
        [Slot(203)]
        static extern unsafe void glColor4fv(Single* v);
        [Slot(206)]
        static extern void glColor4i(Int32 red, Int32 green, Int32 blue, Int32 alpha);
        [Slot(207)]
        static extern unsafe void glColor4iv(Int32* v);
        [Slot(208)]
        static extern void glColor4s(Int16 red, Int16 green, Int16 blue, Int16 alpha);
        [Slot(209)]
        static extern unsafe void glColor4sv(Int16* v);
        [Slot(210)]
        static extern void glColor4ub(Byte red, Byte green, Byte blue, Byte alpha);
        [Slot(211)]
        static extern unsafe void glColor4ubv(Byte* v);
        [Slot(216)]
        static extern void glColor4ui(UInt32 red, UInt32 green, UInt32 blue, UInt32 alpha);
        [Slot(217)]
        static extern unsafe void glColor4uiv(UInt32* v);
        [Slot(218)]
        static extern void glColor4us(UInt16 red, UInt16 green, UInt16 blue, UInt16 alpha);
        [Slot(219)]
        static extern unsafe void glColor4usv(UInt16* v);
        [Slot(226)]
        static extern void glColorMask(bool red, bool green, bool blue, bool alpha);
        [Slot(227)]
        static extern void glColorMaski(UInt32 index, bool r, bool g, bool b, bool a);
        [Slot(229)]
        static extern void glColorMaterial(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.ColorMaterialParameter mode);
        [Slot(230)]
        static extern void glColorP3ui(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32 color);
        [Slot(231)]
        static extern unsafe void glColorP3uiv(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32* color);
        [Slot(232)]
        static extern void glColorP4ui(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32 color);
        [Slot(233)]
        static extern unsafe void glColorP4uiv(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32* color);
        [Slot(234)]
        static extern void glColorPointer(Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, IntPtr pointer);
        [Slot(238)]
        static extern void glColorSubTable(OpenTK.Graphics.OpenGL.ColorTableTarget target, Int32 start, Int32 count, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr data);
        [Slot(240)]
        static extern void glColorTable(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr table);
        [Slot(242)]
        static extern unsafe void glColorTableParameterfv(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.ColorTableParameterPName pname, Single* @params);
        [Slot(244)]
        static extern unsafe void glColorTableParameteriv(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.ColorTableParameterPName pname, Int32* @params);
        [Slot(254)]
        static extern void glCompileShader(UInt32 shader);
        [Slot(263)]
        static extern void glCompressedTexImage1D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 border, Int32 imageSize, IntPtr data);
        [Slot(265)]
        static extern void glCompressedTexImage2D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 border, Int32 imageSize, IntPtr data);
        [Slot(267)]
        static extern void glCompressedTexImage3D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, Int32 imageSize, IntPtr data);
        [Slot(269)]
        static extern void glCompressedTexSubImage1D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, IntPtr data);
        [Slot(271)]
        static extern void glCompressedTexSubImage2D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, IntPtr data);
        [Slot(273)]
        static extern void glCompressedTexSubImage3D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, IntPtr data);
        [Slot(281)]
        static extern void glConvolutionFilter1D(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr image);
        [Slot(283)]
        static extern void glConvolutionFilter2D(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr image);
        [Slot(285)]
        static extern void glConvolutionParameterf(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.ConvolutionParameter pname, Single @params);
        [Slot(287)]
        static extern unsafe void glConvolutionParameterfv(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.ConvolutionParameter pname, Single* @params);
        [Slot(289)]
        static extern void glConvolutionParameteri(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.ConvolutionParameter pname, Int32 @params);
        [Slot(291)]
        static extern unsafe void glConvolutionParameteriv(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.ConvolutionParameter pname, Int32* @params);
        [Slot(295)]
        static extern void glCopyBufferSubData(OpenTK.Graphics.OpenGL.BufferTarget readTarget, OpenTK.Graphics.OpenGL.BufferTarget writeTarget, IntPtr readOffset, IntPtr writeOffset, IntPtr size);
        [Slot(296)]
        static extern void glCopyColorSubTable(OpenTK.Graphics.OpenGL.ColorTableTarget target, Int32 start, Int32 x, Int32 y, Int32 width);
        [Slot(298)]
        static extern void glCopyColorTable(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 x, Int32 y, Int32 width);
        [Slot(300)]
        static extern void glCopyConvolutionFilter1D(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 x, Int32 y, Int32 width);
        [Slot(302)]
        static extern void glCopyConvolutionFilter2D(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 x, Int32 y, Int32 width, Int32 height);
        [Slot(304)]
        static extern void glCopyImageSubData(UInt32 srcName, OpenTK.Graphics.OpenGL.ImageTarget srcTarget, Int32 srcLevel, Int32 srcX, Int32 srcY, Int32 srcZ, UInt32 dstName, OpenTK.Graphics.OpenGL.ImageTarget dstTarget, Int32 dstLevel, Int32 dstX, Int32 dstY, Int32 dstZ, Int32 srcWidth, Int32 srcHeight, Int32 srcDepth);
        [Slot(312)]
        static extern void glCopyPixels(Int32 x, Int32 y, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelCopyType type);
        [Slot(313)]
        static extern void glCopyTexImage1D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 x, Int32 y, Int32 width, Int32 border);
        [Slot(315)]
        static extern void glCopyTexImage2D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 x, Int32 y, Int32 width, Int32 height, Int32 border);
        [Slot(317)]
        static extern void glCopyTexSubImage1D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 x, Int32 y, Int32 width);
        [Slot(319)]
        static extern void glCopyTexSubImage2D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 x, Int32 y, Int32 width, Int32 height);
        [Slot(321)]
        static extern void glCopyTexSubImage3D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 x, Int32 y, Int32 width, Int32 height);
        [Slot(332)]
        static extern Int32 glCreateProgram();
        [Slot(334)]
        static extern Int32 glCreateShader(OpenTK.Graphics.OpenGL.ShaderType type);
        [Slot(337)]
        static extern Int32 glCreateShaderProgramv(OpenTK.Graphics.OpenGL.ShaderType type, Int32 count, String[] strings);
        [Slot(340)]
        static extern void glCullFace(OpenTK.Graphics.OpenGL.CullFaceMode mode);
        [Slot(344)]
        static extern void glDebugMessageCallback(DebugProc callback, IntPtr userParam);
        [Slot(348)]
        static extern unsafe void glDebugMessageControl(OpenTK.Graphics.OpenGL.DebugSourceControl source, OpenTK.Graphics.OpenGL.DebugTypeControl type, OpenTK.Graphics.OpenGL.DebugSeverityControl severity, Int32 count, UInt32* ids, bool enabled);
        [Slot(352)]
        static extern void glDebugMessageInsert(OpenTK.Graphics.OpenGL.DebugSourceExternal source, OpenTK.Graphics.OpenGL.DebugType type, UInt32 id, OpenTK.Graphics.OpenGL.DebugSeverity severity, Int32 length, String buf);
        [Slot(360)]
        static extern unsafe void glDeleteBuffers(Int32 n, UInt32* buffers);
        [Slot(365)]
        static extern unsafe void glDeleteFramebuffers(Int32 n, UInt32* framebuffers);
        [Slot(367)]
        static extern void glDeleteLists(UInt32 list, Int32 range);
        [Slot(374)]
        static extern void glDeleteProgram(UInt32 program);
        [Slot(375)]
        static extern unsafe void glDeleteProgramPipelines(Int32 n, UInt32* pipelines);
        [Slot(379)]
        static extern unsafe void glDeleteQueries(Int32 n, UInt32* ids);
        [Slot(381)]
        static extern unsafe void glDeleteRenderbuffers(Int32 n, UInt32* renderbuffers);
        [Slot(383)]
        static extern unsafe void glDeleteSamplers(Int32 count, UInt32* samplers);
        [Slot(384)]
        static extern void glDeleteShader(UInt32 shader);
        [Slot(385)]
        static extern void glDeleteSync(IntPtr sync);
        [Slot(386)]
        static extern unsafe void glDeleteTextures(Int32 n, UInt32* textures);
        [Slot(388)]
        static extern unsafe void glDeleteTransformFeedbacks(Int32 n, UInt32* ids);
        [Slot(390)]
        static extern unsafe void glDeleteVertexArrays(Int32 n, UInt32* arrays);
        [Slot(395)]
        static extern void glDepthFunc(OpenTK.Graphics.OpenGL.DepthFunction func);
        [Slot(396)]
        static extern void glDepthMask(bool flag);
        [Slot(397)]
        static extern void glDepthRange(Double near, Double far);
        [Slot(398)]
        static extern unsafe void glDepthRangeArrayv(UInt32 first, Int32 count, Double* v);
        [Slot(400)]
        static extern void glDepthRangef(Single n, Single f);
        [Slot(402)]
        static extern void glDepthRangeIndexed(UInt32 index, Double n, Double f);
        [Slot(405)]
        static extern void glDetachShader(UInt32 program, UInt32 shader);
        [Slot(407)]
        static extern void glDisable(OpenTK.Graphics.OpenGL.EnableCap cap);
        [Slot(408)]
        static extern void glDisableClientState(OpenTK.Graphics.OpenGL.ArrayCap array);
        [Slot(411)]
        static extern void glDisablei(OpenTK.Graphics.OpenGL.IndexedEnableCap target, UInt32 index);
        [Slot(417)]
        static extern void glDisableVertexAttribArray(UInt32 index);
        [Slot(419)]
        static extern void glDispatchCompute(UInt32 num_groups_x, UInt32 num_groups_y, UInt32 num_groups_z);
        [Slot(421)]
        static extern void glDispatchComputeIndirect(IntPtr indirect);
        [Slot(422)]
        static extern void glDrawArrays(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 first, Int32 count);
        [Slot(424)]
        static extern void glDrawArraysIndirect(OpenTK.Graphics.OpenGL.PrimitiveType mode, IntPtr indirect);
        [Slot(425)]
        static extern void glDrawArraysInstanced(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 first, Int32 count, Int32 instancecount);
        [Slot(427)]
        static extern void glDrawArraysInstancedBaseInstance(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 first, Int32 count, Int32 instancecount, UInt32 baseinstance);
        [Slot(429)]
        static extern void glDrawBuffer(OpenTK.Graphics.OpenGL.DrawBufferMode mode);
        [Slot(430)]
        static extern unsafe void glDrawBuffers(Int32 n, OpenTK.Graphics.OpenGL.DrawBuffersEnum* bufs);
        [Slot(435)]
        static extern void glDrawElements(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices);
        [Slot(436)]
        static extern void glDrawElementsBaseVertex(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 basevertex);
        [Slot(437)]
        static extern void glDrawElementsIndirect(OpenTK.Graphics.OpenGL.PrimitiveType mode, OpenTK.Graphics.OpenGL.All type, IntPtr indirect);
        [Slot(438)]
        static extern void glDrawElementsInstanced(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 instancecount);
        [Slot(440)]
        static extern void glDrawElementsInstancedBaseInstance(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 instancecount, UInt32 baseinstance);
        [Slot(441)]
        static extern void glDrawElementsInstancedBaseVertex(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 instancecount, Int32 basevertex);
        [Slot(442)]
        static extern void glDrawElementsInstancedBaseVertexBaseInstance(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 instancecount, Int32 basevertex, UInt32 baseinstance);
        [Slot(445)]
        static extern void glDrawPixels(Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);
        [Slot(448)]
        static extern void glDrawRangeElements(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 start, UInt32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices);
        [Slot(449)]
        static extern void glDrawRangeElementsBaseVertex(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 start, UInt32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 basevertex);
        [Slot(452)]
        static extern void glDrawTransformFeedback(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 id);
        [Slot(453)]
        static extern void glDrawTransformFeedbackInstanced(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 id, Int32 instancecount);
        [Slot(455)]
        static extern void glDrawTransformFeedbackStream(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 id, UInt32 stream);
        [Slot(456)]
        static extern void glDrawTransformFeedbackStreamInstanced(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 id, UInt32 stream, Int32 instancecount);
        [Slot(457)]
        static extern void glEdgeFlag(bool flag);
        [Slot(459)]
        static extern void glEdgeFlagPointer(Int32 stride, IntPtr pointer);
        [Slot(462)]
        static extern unsafe void glEdgeFlagv(bool* flag);
        [Slot(465)]
        static extern void glEnable(OpenTK.Graphics.OpenGL.EnableCap cap);
        [Slot(466)]
        static extern void glEnableClientState(OpenTK.Graphics.OpenGL.ArrayCap array);
        [Slot(469)]
        static extern void glEnablei(OpenTK.Graphics.OpenGL.IndexedEnableCap target, UInt32 index);
        [Slot(475)]
        static extern void glEnableVertexAttribArray(UInt32 index);
        [Slot(477)]
        static extern void glEnd();
        [Slot(478)]
        static extern void glEndConditionalRender();
        [Slot(482)]
        static extern void glEndList();
        [Slot(485)]
        static extern void glEndQuery(OpenTK.Graphics.OpenGL.QueryTarget target);
        [Slot(487)]
        static extern void glEndQueryIndexed(OpenTK.Graphics.OpenGL.QueryTarget target, UInt32 index);
        [Slot(488)]
        static extern void glEndTransformFeedback();
        [Slot(493)]
        static extern void glEvalCoord1d(Double u);
        [Slot(494)]
        static extern unsafe void glEvalCoord1dv(Double* u);
        [Slot(495)]
        static extern void glEvalCoord1f(Single u);
        [Slot(496)]
        static extern unsafe void glEvalCoord1fv(Single* u);
        [Slot(499)]
        static extern void glEvalCoord2d(Double u, Double v);
        [Slot(500)]
        static extern unsafe void glEvalCoord2dv(Double* u);
        [Slot(501)]
        static extern void glEvalCoord2f(Single u, Single v);
        [Slot(502)]
        static extern unsafe void glEvalCoord2fv(Single* u);
        [Slot(506)]
        static extern void glEvalMesh1(OpenTK.Graphics.OpenGL.MeshMode1 mode, Int32 i1, Int32 i2);
        [Slot(507)]
        static extern void glEvalMesh2(OpenTK.Graphics.OpenGL.MeshMode2 mode, Int32 i1, Int32 i2, Int32 j1, Int32 j2);
        [Slot(508)]
        static extern void glEvalPoint1(Int32 i);
        [Slot(509)]
        static extern void glEvalPoint2(Int32 i, Int32 j);
        [Slot(512)]
        static extern unsafe void glFeedbackBuffer(Int32 size, OpenTK.Graphics.OpenGL.FeedbackType type, [OutAttribute] Single* buffer);
        [Slot(514)]
        static extern IntPtr glFenceSync(OpenTK.Graphics.OpenGL.SyncCondition condition, OpenTK.Graphics.OpenGL.WaitSyncFlags flags);
        [Slot(516)]
        static extern void glFinish();
        [Slot(522)]
        static extern void glFlush();
        [Slot(523)]
        static extern void glFlushMappedBufferRange(OpenTK.Graphics.OpenGL.BufferTarget target, IntPtr offset, IntPtr length);
        [Slot(531)]
        static extern void glFogCoordd(Double coord);
        [Slot(533)]
        static extern unsafe void glFogCoorddv(Double* coord);
        [Slot(535)]
        static extern void glFogCoordf(Single coord);
        [Slot(538)]
        static extern unsafe void glFogCoordfv(Single* coord);
        [Slot(542)]
        static extern void glFogCoordPointer(OpenTK.Graphics.OpenGL.FogPointerType type, Int32 stride, IntPtr pointer);
        [Slot(545)]
        static extern void glFogf(OpenTK.Graphics.OpenGL.FogParameter pname, Single param);
        [Slot(547)]
        static extern unsafe void glFogfv(OpenTK.Graphics.OpenGL.FogParameter pname, Single* @params);
        [Slot(548)]
        static extern void glFogi(OpenTK.Graphics.OpenGL.FogParameter pname, Int32 param);
        [Slot(549)]
        static extern unsafe void glFogiv(OpenTK.Graphics.OpenGL.FogParameter pname, Int32* @params);
        [Slot(567)]
        static extern void glFramebufferParameteri(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferDefaultParameter pname, Int32 param);
        [Slot(569)]
        static extern void glFramebufferRenderbuffer(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.RenderbufferTarget renderbuffertarget, UInt32 renderbuffer);
        [Slot(571)]
        static extern void glFramebufferTexture(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, UInt32 texture, Int32 level);
        [Slot(572)]
        static extern void glFramebufferTexture1D(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.TextureTarget textarget, UInt32 texture, Int32 level);
        [Slot(574)]
        static extern void glFramebufferTexture2D(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.TextureTarget textarget, UInt32 texture, Int32 level);
        [Slot(576)]
        static extern void glFramebufferTexture3D(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.TextureTarget textarget, UInt32 texture, Int32 level, Int32 zoffset);
        [Slot(582)]
        static extern void glFramebufferTextureLayer(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, UInt32 texture, Int32 level, Int32 layer);
        [Slot(588)]
        static extern void glFrontFace(OpenTK.Graphics.OpenGL.FrontFaceDirection mode);
        [Slot(589)]
        static extern void glFrustum(Double left, Double right, Double bottom, Double top, Double zNear, Double zFar);
        [Slot(593)]
        static extern unsafe void glGenBuffers(Int32 n, [OutAttribute] UInt32* buffers);
        [Slot(595)]
        static extern void glGenerateMipmap(OpenTK.Graphics.OpenGL.GenerateMipmapTarget target);
        [Slot(602)]
        static extern unsafe void glGenFramebuffers(Int32 n, [OutAttribute] UInt32* framebuffers);
        [Slot(604)]
        static extern Int32 glGenLists(Int32 range);
        [Slot(609)]
        static extern unsafe void glGenProgramPipelines(Int32 n, [OutAttribute] UInt32* pipelines);
        [Slot(613)]
        static extern unsafe void glGenQueries(Int32 n, [OutAttribute] UInt32* ids);
        [Slot(615)]
        static extern unsafe void glGenRenderbuffers(Int32 n, [OutAttribute] UInt32* renderbuffers);
        [Slot(617)]
        static extern unsafe void glGenSamplers(Int32 count, [OutAttribute] UInt32* samplers);
        [Slot(619)]
        static extern unsafe void glGenTextures(Int32 n, [OutAttribute] UInt32* textures);
        [Slot(621)]
        static extern unsafe void glGenTransformFeedbacks(Int32 n, [OutAttribute] UInt32* ids);
        [Slot(623)]
        static extern unsafe void glGenVertexArrays(Int32 n, [OutAttribute] UInt32* arrays);
        [Slot(626)]
        static extern unsafe void glGetActiveAtomicCounterBufferiv(UInt32 program, UInt32 bufferIndex, OpenTK.Graphics.OpenGL.AtomicCounterBufferParameter pname, [OutAttribute] Int32* @params);
        [Slot(627)]
        static extern unsafe void glGetActiveAttrib(UInt32 program, UInt32 index, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] Int32* size, [OutAttribute] OpenTK.Graphics.OpenGL.ActiveAttribType* type, [OutAttribute] StringBuilder name);
        [Slot(629)]
        static extern unsafe void glGetActiveSubroutineName(UInt32 program, OpenTK.Graphics.OpenGL.ShaderType shadertype, UInt32 index, Int32 bufsize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder name);
        [Slot(630)]
        static extern unsafe void glGetActiveSubroutineUniformiv(UInt32 program, OpenTK.Graphics.OpenGL.ShaderType shadertype, UInt32 index, OpenTK.Graphics.OpenGL.ActiveSubroutineUniformParameter pname, [OutAttribute] Int32* values);
        [Slot(631)]
        static extern unsafe void glGetActiveSubroutineUniformName(UInt32 program, OpenTK.Graphics.OpenGL.ShaderType shadertype, UInt32 index, Int32 bufsize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder name);
        [Slot(632)]
        static extern unsafe void glGetActiveUniform(UInt32 program, UInt32 index, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] Int32* size, [OutAttribute] OpenTK.Graphics.OpenGL.ActiveUniformType* type, [OutAttribute] StringBuilder name);
        [Slot(634)]
        static extern unsafe void glGetActiveUniformBlockiv(UInt32 program, UInt32 uniformBlockIndex, OpenTK.Graphics.OpenGL.ActiveUniformBlockParameter pname, [OutAttribute] Int32* @params);
        [Slot(635)]
        static extern unsafe void glGetActiveUniformBlockName(UInt32 program, UInt32 uniformBlockIndex, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder uniformBlockName);
        [Slot(636)]
        static extern unsafe void glGetActiveUniformName(UInt32 program, UInt32 uniformIndex, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder uniformName);
        [Slot(637)]
        static extern unsafe void glGetActiveUniformsiv(UInt32 program, Int32 uniformCount, UInt32* uniformIndices, OpenTK.Graphics.OpenGL.ActiveUniformParameter pname, [OutAttribute] Int32* @params);
        [Slot(642)]
        static extern unsafe void glGetAttachedShaders(UInt32 program, Int32 maxCount, [OutAttribute] Int32* count, [OutAttribute] UInt32* shaders);
        [Slot(643)]
        static extern Int32 glGetAttribLocation(UInt32 program, String name);
        [Slot(645)]
        static extern unsafe void glGetBooleani_v(OpenTK.Graphics.OpenGL.GetIndexedPName target, UInt32 index, [OutAttribute] bool* data);
        [Slot(647)]
        static extern unsafe void glGetBooleanv(OpenTK.Graphics.OpenGL.GetPName pname, [OutAttribute] bool* data);
        [Slot(648)]
        static extern unsafe void glGetBufferParameteri64v(OpenTK.Graphics.OpenGL.BufferTarget target, OpenTK.Graphics.OpenGL.BufferParameterName pname, [OutAttribute] Int64* @params);
        [Slot(649)]
        static extern unsafe void glGetBufferParameteriv(OpenTK.Graphics.OpenGL.BufferTarget target, OpenTK.Graphics.OpenGL.BufferParameterName pname, [OutAttribute] Int32* @params);
        [Slot(652)]
        static extern void glGetBufferPointerv(OpenTK.Graphics.OpenGL.BufferTarget target, OpenTK.Graphics.OpenGL.BufferPointer pname, [OutAttribute] IntPtr @params);
        [Slot(654)]
        static extern void glGetBufferSubData(OpenTK.Graphics.OpenGL.BufferTarget target, IntPtr offset, IntPtr size, [OutAttribute] IntPtr data);
        [Slot(656)]
        static extern unsafe void glGetClipPlane(OpenTK.Graphics.OpenGL.ClipPlaneName plane, [OutAttribute] Double* equation);
        [Slot(659)]
        static extern void glGetColorTable(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [OutAttribute] IntPtr table);
        [Slot(661)]
        static extern unsafe void glGetColorTableParameterfv(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.GetColorTableParameterPName pname, [OutAttribute] Single* @params);
        [Slot(664)]
        static extern unsafe void glGetColorTableParameteriv(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.GetColorTableParameterPName pname, [OutAttribute] Int32* @params);
        [Slot(674)]
        static extern void glGetCompressedTexImage(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, [OutAttribute] IntPtr img);
        [Slot(677)]
        static extern void glGetConvolutionFilter(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [OutAttribute] IntPtr image);
        [Slot(679)]
        static extern unsafe void glGetConvolutionParameterfv(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.GetConvolutionParameterPName pname, [OutAttribute] Single* @params);
        [Slot(681)]
        static extern unsafe void glGetConvolutionParameteriv(OpenTK.Graphics.OpenGL.ConvolutionTarget target, OpenTK.Graphics.OpenGL.GetConvolutionParameterPName pname, [OutAttribute] Int32* @params);
        [Slot(684)]
        static extern unsafe Int32 glGetDebugMessageLog(UInt32 count, Int32 bufSize, [OutAttribute] OpenTK.Graphics.OpenGL.DebugSource* sources, [OutAttribute] OpenTK.Graphics.OpenGL.DebugType* types, [OutAttribute] UInt32* ids, [OutAttribute] OpenTK.Graphics.OpenGL.DebugSeverity* severities, [OutAttribute] Int32* lengths, [OutAttribute] StringBuilder messageLog);
        [Slot(689)]
        static extern unsafe void glGetDoublei_v(OpenTK.Graphics.OpenGL.GetIndexedPName target, UInt32 index, [OutAttribute] Double* data);
        [Slot(692)]
        static extern unsafe void glGetDoublev(OpenTK.Graphics.OpenGL.GetPName pname, [OutAttribute] Double* data);
        [Slot(693)]
        static extern OpenTK.Graphics.OpenGL.ErrorCode glGetError();
        [Slot(698)]
        static extern unsafe void glGetFloati_v(OpenTK.Graphics.OpenGL.GetIndexedPName target, UInt32 index, [OutAttribute] Single* data);
        [Slot(701)]
        static extern unsafe void glGetFloatv(OpenTK.Graphics.OpenGL.GetPName pname, [OutAttribute] Single* data);
        [Slot(703)]
        static extern Int32 glGetFragDataIndex(UInt32 program, String name);
        [Slot(704)]
        static extern Int32 glGetFragDataLocation(UInt32 program, String name);
        [Slot(710)]
        static extern unsafe void glGetFramebufferAttachmentParameteriv(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.FramebufferParameterName pname, [OutAttribute] Int32* @params);
        [Slot(712)]
        static extern unsafe void glGetFramebufferParameteriv(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferDefaultParameter pname, [OutAttribute] Int32* @params);
        [Slot(716)]
        static extern void glGetHistogram(OpenTK.Graphics.OpenGL.HistogramTarget target, bool reset, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [OutAttribute] IntPtr values);
        [Slot(718)]
        static extern unsafe void glGetHistogramParameterfv(OpenTK.Graphics.OpenGL.HistogramTarget target, OpenTK.Graphics.OpenGL.GetHistogramParameterPName pname, [OutAttribute] Single* @params);
        [Slot(720)]
        static extern unsafe void glGetHistogramParameteriv(OpenTK.Graphics.OpenGL.HistogramTarget target, OpenTK.Graphics.OpenGL.GetHistogramParameterPName pname, [OutAttribute] Int32* @params);
        [Slot(729)]
        static extern unsafe void glGetInteger64i_v(OpenTK.Graphics.OpenGL.GetIndexedPName target, UInt32 index, [OutAttribute] Int64* data);
        [Slot(730)]
        static extern unsafe void glGetInteger64v(OpenTK.Graphics.OpenGL.GetPName pname, [OutAttribute] Int64* data);
        [Slot(731)]
        static extern unsafe void glGetIntegeri_v(OpenTK.Graphics.OpenGL.GetIndexedPName target, UInt32 index, [OutAttribute] Int32* data);
        [Slot(735)]
        static extern unsafe void glGetIntegerv(OpenTK.Graphics.OpenGL.GetPName pname, [OutAttribute] Int32* data);
        [Slot(736)]
        static extern unsafe void glGetInternalformati64v(OpenTK.Graphics.OpenGL.ImageTarget target, OpenTK.Graphics.OpenGL.SizedInternalFormat internalformat, OpenTK.Graphics.OpenGL.InternalFormatParameter pname, Int32 bufSize, [OutAttribute] Int64* @params);
        [Slot(737)]
        static extern unsafe void glGetInternalformativ(OpenTK.Graphics.OpenGL.ImageTarget target, OpenTK.Graphics.OpenGL.SizedInternalFormat internalformat, OpenTK.Graphics.OpenGL.InternalFormatParameter pname, Int32 bufSize, [OutAttribute] Int32* @params);
        [Slot(741)]
        static extern unsafe void glGetLightfv(OpenTK.Graphics.OpenGL.LightName light, OpenTK.Graphics.OpenGL.LightParameter pname, [OutAttribute] Single* @params);
        [Slot(742)]
        static extern unsafe void glGetLightiv(OpenTK.Graphics.OpenGL.LightName light, OpenTK.Graphics.OpenGL.LightParameter pname, [OutAttribute] Int32* @params);
        [Slot(753)]
        static extern unsafe void glGetMapdv(OpenTK.Graphics.OpenGL.MapTarget target, OpenTK.Graphics.OpenGL.GetMapQuery query, [OutAttribute] Double* v);
        [Slot(754)]
        static extern unsafe void glGetMapfv(OpenTK.Graphics.OpenGL.MapTarget target, OpenTK.Graphics.OpenGL.GetMapQuery query, [OutAttribute] Single* v);
        [Slot(755)]
        static extern unsafe void glGetMapiv(OpenTK.Graphics.OpenGL.MapTarget target, OpenTK.Graphics.OpenGL.GetMapQuery query, [OutAttribute] Int32* v);
        [Slot(759)]
        static extern unsafe void glGetMaterialfv(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, [OutAttribute] Single* @params);
        [Slot(760)]
        static extern unsafe void glGetMaterialiv(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, [OutAttribute] Int32* @params);
        [Slot(763)]
        static extern void glGetMinmax(OpenTK.Graphics.OpenGL.MinmaxTarget target, bool reset, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [OutAttribute] IntPtr values);
        [Slot(765)]
        static extern unsafe void glGetMinmaxParameterfv(OpenTK.Graphics.OpenGL.MinmaxTarget target, OpenTK.Graphics.OpenGL.GetMinmaxParameterPName pname, [OutAttribute] Single* @params);
        [Slot(767)]
        static extern unsafe void glGetMinmaxParameteriv(OpenTK.Graphics.OpenGL.MinmaxTarget target, OpenTK.Graphics.OpenGL.GetMinmaxParameterPName pname, [OutAttribute] Int32* @params);
        [Slot(769)]
        static extern unsafe void glGetMultisamplefv(OpenTK.Graphics.OpenGL.GetMultisamplePName pname, UInt32 index, [OutAttribute] Single* val);
        [Slot(818)]
        static extern unsafe void glGetObjectLabel(OpenTK.Graphics.OpenGL.ObjectLabelIdentifier identifier, UInt32 name, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder label);
        [Slot(824)]
        static extern unsafe void glGetObjectPtrLabel(IntPtr ptr, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder label);
        [Slot(847)]
        static extern unsafe void glGetPixelMapfv(OpenTK.Graphics.OpenGL.PixelMap map, [OutAttribute] Single* values);
        [Slot(848)]
        static extern unsafe void glGetPixelMapuiv(OpenTK.Graphics.OpenGL.PixelMap map, [OutAttribute] UInt32* values);
        [Slot(849)]
        static extern unsafe void glGetPixelMapusv(OpenTK.Graphics.OpenGL.PixelMap map, [OutAttribute] UInt16* values);
        [Slot(850)]
        static extern unsafe void glGetPixelMapxv(OpenTK.Graphics.OpenGL.OesFixedPoint map, Int32 size, [OutAttribute] int* values);
        [Slot(857)]
        static extern void glGetPointerv(OpenTK.Graphics.OpenGL.GetPointervPName pname, [OutAttribute] IntPtr @params);
        [Slot(860)]
        static extern unsafe void glGetPolygonStipple([OutAttribute] Byte* mask);
        [Slot(861)]
        static extern unsafe void glGetProgramBinary(UInt32 program, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] OpenTK.Graphics.OpenGL.BinaryFormat* binaryFormat, [OutAttribute] IntPtr binary);
        [Slot(866)]
        static extern unsafe void glGetProgramInfoLog(UInt32 program, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder infoLog);
        [Slot(867)]
        static extern unsafe void glGetProgramInterfaceiv(UInt32 program, OpenTK.Graphics.OpenGL.ProgramInterface programInterface, OpenTK.Graphics.OpenGL.ProgramInterfaceParameter pname, [OutAttribute] Int32* @params);
        [Slot(868)]
        static extern unsafe void glGetProgramiv(UInt32 program, OpenTK.Graphics.OpenGL.GetProgramParameterName pname, [OutAttribute] Int32* @params);
        [Slot(879)]
        static extern unsafe void glGetProgramPipelineInfoLog(UInt32 pipeline, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder infoLog);
        [Slot(881)]
        static extern unsafe void glGetProgramPipelineiv(UInt32 pipeline, OpenTK.Graphics.OpenGL.ProgramPipelineParameter pname, [OutAttribute] Int32* @params);
        [Slot(883)]
        static extern Int32 glGetProgramResourceIndex(UInt32 program, OpenTK.Graphics.OpenGL.ProgramInterface programInterface, String name);
        [Slot(884)]
        static extern unsafe void glGetProgramResourceiv(UInt32 program, OpenTK.Graphics.OpenGL.ProgramInterface programInterface, UInt32 index, Int32 propCount, OpenTK.Graphics.OpenGL.ProgramProperty* props, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] Int32* @params);
        [Slot(885)]
        static extern Int32 glGetProgramResourceLocation(UInt32 program, OpenTK.Graphics.OpenGL.ProgramInterface programInterface, String name);
        [Slot(886)]
        static extern Int32 glGetProgramResourceLocationIndex(UInt32 program, OpenTK.Graphics.OpenGL.ProgramInterface programInterface, String name);
        [Slot(887)]
        static extern unsafe void glGetProgramResourceName(UInt32 program, OpenTK.Graphics.OpenGL.ProgramInterface programInterface, UInt32 index, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder name);
        [Slot(888)]
        static extern unsafe void glGetProgramStageiv(UInt32 program, OpenTK.Graphics.OpenGL.ShaderType shadertype, OpenTK.Graphics.OpenGL.ProgramStageParameter pname, [OutAttribute] Int32* values);
        [Slot(892)]
        static extern unsafe void glGetQueryIndexediv(OpenTK.Graphics.OpenGL.QueryTarget target, UInt32 index, OpenTK.Graphics.OpenGL.GetQueryParam pname, [OutAttribute] Int32* @params);
        [Slot(893)]
        static extern unsafe void glGetQueryiv(OpenTK.Graphics.OpenGL.QueryTarget target, OpenTK.Graphics.OpenGL.GetQueryParam pname, [OutAttribute] Int32* @params);
        [Slot(895)]
        static extern unsafe void glGetQueryObjecti64v(UInt32 id, OpenTK.Graphics.OpenGL.GetQueryObjectParam pname, [OutAttribute] Int64* @params);
        [Slot(897)]
        static extern unsafe void glGetQueryObjectiv(UInt32 id, OpenTK.Graphics.OpenGL.GetQueryObjectParam pname, [OutAttribute] Int32* @params);
        [Slot(899)]
        static extern unsafe void glGetQueryObjectui64v(UInt32 id, OpenTK.Graphics.OpenGL.GetQueryObjectParam pname, [OutAttribute] UInt64* @params);
        [Slot(901)]
        static extern unsafe void glGetQueryObjectuiv(UInt32 id, OpenTK.Graphics.OpenGL.GetQueryObjectParam pname, [OutAttribute] UInt32* @params);
        [Slot(903)]
        static extern unsafe void glGetRenderbufferParameteriv(OpenTK.Graphics.OpenGL.RenderbufferTarget target, OpenTK.Graphics.OpenGL.RenderbufferParameterName pname, [OutAttribute] Int32* @params);
        [Slot(905)]
        static extern unsafe void glGetSamplerParameterfv(UInt32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, [OutAttribute] Single* @params);
        [Slot(906)]
        static extern unsafe void glGetSamplerParameterIiv(UInt32 sampler, OpenTK.Graphics.OpenGL.All pname, [OutAttribute] Int32* @params);
        [Slot(907)]
        static extern unsafe void glGetSamplerParameterIuiv(UInt32 sampler, OpenTK.Graphics.OpenGL.All pname, [OutAttribute] UInt32* @params);
        [Slot(908)]
        static extern unsafe void glGetSamplerParameteriv(UInt32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, [OutAttribute] Int32* @params);
        [Slot(909)]
        static extern void glGetSeparableFilter(OpenTK.Graphics.OpenGL.SeparableTarget target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [OutAttribute] IntPtr row, [OutAttribute] IntPtr column, [OutAttribute] IntPtr span);
        [Slot(911)]
        static extern unsafe void glGetShaderInfoLog(UInt32 shader, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder infoLog);
        [Slot(912)]
        static extern unsafe void glGetShaderiv(UInt32 shader, OpenTK.Graphics.OpenGL.ShaderParameter pname, [OutAttribute] Int32* @params);
        [Slot(913)]
        static extern unsafe void glGetShaderPrecisionFormat(OpenTK.Graphics.OpenGL.ShaderType shadertype, OpenTK.Graphics.OpenGL.ShaderPrecision precisiontype, [OutAttribute] Int32* range, [OutAttribute] Int32* precision);
        [Slot(914)]
        static extern unsafe void glGetShaderSource(UInt32 shader, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder source);
        [Slot(917)]
        static extern IntPtr glGetString(OpenTK.Graphics.OpenGL.StringName name);
        [Slot(918)]
        static extern IntPtr glGetStringi(OpenTK.Graphics.OpenGL.StringNameIndexed name, UInt32 index);
        [Slot(919)]
        static extern Int32 glGetSubroutineIndex(UInt32 program, OpenTK.Graphics.OpenGL.ShaderType shadertype, String name);
        [Slot(920)]
        static extern Int32 glGetSubroutineUniformLocation(UInt32 program, OpenTK.Graphics.OpenGL.ShaderType shadertype, String name);
        [Slot(921)]
        static extern unsafe void glGetSynciv(IntPtr sync, OpenTK.Graphics.OpenGL.SyncParameterName pname, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] Int32* values);
        [Slot(924)]
        static extern unsafe void glGetTexEnvfv(OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, [OutAttribute] Single* @params);
        [Slot(925)]
        static extern unsafe void glGetTexEnviv(OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, [OutAttribute] Int32* @params);
        [Slot(928)]
        static extern unsafe void glGetTexGendv(OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, [OutAttribute] Double* @params);
        [Slot(929)]
        static extern unsafe void glGetTexGenfv(OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, [OutAttribute] Single* @params);
        [Slot(930)]
        static extern unsafe void glGetTexGeniv(OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, [OutAttribute] Int32* @params);
        [Slot(932)]
        static extern void glGetTexImage(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [OutAttribute] IntPtr pixels);
        [Slot(933)]
        static extern unsafe void glGetTexLevelParameterfv(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Single* @params);
        [Slot(934)]
        static extern unsafe void glGetTexLevelParameteriv(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32* @params);
        [Slot(936)]
        static extern unsafe void glGetTexParameterfv(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Single* @params);
        [Slot(937)]
        static extern unsafe void glGetTexParameterIiv(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32* @params);
        [Slot(939)]
        static extern unsafe void glGetTexParameterIuiv(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] UInt32* @params);
        [Slot(941)]
        static extern unsafe void glGetTexParameteriv(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32* @params);
        [Slot(956)]
        static extern unsafe void glGetTransformFeedbackVarying(UInt32 program, UInt32 index, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] Int32* size, [OutAttribute] OpenTK.Graphics.OpenGL.TransformFeedbackType* type, [OutAttribute] StringBuilder name);
        [Slot(959)]
        static extern Int32 glGetUniformBlockIndex(UInt32 program, String uniformBlockName);
        [Slot(961)]
        static extern unsafe void glGetUniformdv(UInt32 program, Int32 location, [OutAttribute] Double* @params);
        [Slot(962)]
        static extern unsafe void glGetUniformfv(UInt32 program, Int32 location, [OutAttribute] Single* @params);
        [Slot(965)]
        static extern unsafe void glGetUniformIndices(UInt32 program, Int32 uniformCount, String[] uniformNames, [OutAttribute] UInt32* uniformIndices);
        [Slot(966)]
        static extern unsafe void glGetUniformiv(UInt32 program, Int32 location, [OutAttribute] Int32* @params);
        [Slot(968)]
        static extern Int32 glGetUniformLocation(UInt32 program, String name);
        [Slot(971)]
        static extern unsafe void glGetUniformSubroutineuiv(OpenTK.Graphics.OpenGL.ShaderType shadertype, Int32 location, [OutAttribute] UInt32* @params);
        [Slot(973)]
        static extern unsafe void glGetUniformuiv(UInt32 program, Int32 location, [OutAttribute] UInt32* @params);
        [Slot(988)]
        static extern unsafe void glGetVertexAttribdv(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] Double* @params);
        [Slot(991)]
        static extern unsafe void glGetVertexAttribfv(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] Single* @params);
        [Slot(994)]
        static extern unsafe void glGetVertexAttribIiv(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] Int32* @params);
        [Slot(996)]
        static extern unsafe void glGetVertexAttribIuiv(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] UInt32* @params);
        [Slot(998)]
        static extern unsafe void glGetVertexAttribiv(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] Int32* @params);
        [Slot(1001)]
        static extern unsafe void glGetVertexAttribLdv(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribParameter pname, [OutAttribute] Double* @params);
        [Slot(1006)]
        static extern void glGetVertexAttribPointerv(UInt32 index, OpenTK.Graphics.OpenGL.VertexAttribPointerParameter pname, [OutAttribute] IntPtr pointer);
        [Slot(1025)]
        static extern void glHint(OpenTK.Graphics.OpenGL.HintTarget target, OpenTK.Graphics.OpenGL.HintMode mode);
        [Slot(1027)]
        static extern void glHistogram(OpenTK.Graphics.OpenGL.HistogramTarget target, Int32 width, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, bool sink);
        [Slot(1035)]
        static extern void glIndexd(Double c);
        [Slot(1036)]
        static extern unsafe void glIndexdv(Double* c);
        [Slot(1037)]
        static extern void glIndexf(Single c);
        [Slot(1040)]
        static extern unsafe void glIndexfv(Single* c);
        [Slot(1041)]
        static extern void glIndexi(Int32 c);
        [Slot(1042)]
        static extern unsafe void glIndexiv(Int32* c);
        [Slot(1043)]
        static extern void glIndexMask(UInt32 mask);
        [Slot(1045)]
        static extern void glIndexPointer(OpenTK.Graphics.OpenGL.IndexPointerType type, Int32 stride, IntPtr pointer);
        [Slot(1048)]
        static extern void glIndexs(Int16 c);
        [Slot(1049)]
        static extern unsafe void glIndexsv(Int16* c);
        [Slot(1050)]
        static extern void glIndexub(Byte c);
        [Slot(1051)]
        static extern unsafe void glIndexubv(Byte* c);
        [Slot(1054)]
        static extern void glInitNames();
        [Slot(1058)]
        static extern void glInterleavedArrays(OpenTK.Graphics.OpenGL.InterleavedArrayFormat format, Int32 stride, IntPtr pointer);
        [Slot(1060)]
        static extern void glInvalidateBufferData(UInt32 buffer);
        [Slot(1061)]
        static extern void glInvalidateBufferSubData(UInt32 buffer, IntPtr offset, IntPtr length);
        [Slot(1062)]
        static extern unsafe void glInvalidateFramebuffer(OpenTK.Graphics.OpenGL.FramebufferTarget target, Int32 numAttachments, OpenTK.Graphics.OpenGL.FramebufferAttachment* attachments);
        [Slot(1063)]
        static extern unsafe void glInvalidateSubFramebuffer(OpenTK.Graphics.OpenGL.FramebufferTarget target, Int32 numAttachments, OpenTK.Graphics.OpenGL.FramebufferAttachment* attachments, Int32 x, Int32 y, Int32 width, Int32 height);
        [Slot(1064)]
        static extern void glInvalidateTexImage(UInt32 texture, Int32 level);
        [Slot(1065)]
        static extern void glInvalidateTexSubImage(UInt32 texture, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth);
        [Slot(1067)]
        static extern bool glIsBuffer(UInt32 buffer);
        [Slot(1070)]
        static extern bool glIsEnabled(OpenTK.Graphics.OpenGL.EnableCap cap);
        [Slot(1071)]
        static extern bool glIsEnabledi(OpenTK.Graphics.OpenGL.IndexedEnableCap target, UInt32 index);
        [Slot(1075)]
        static extern bool glIsFramebuffer(UInt32 framebuffer);
        [Slot(1079)]
        static extern bool glIsList(UInt32 list);
        [Slot(1088)]
        static extern bool glIsProgram(UInt32 program);
        [Slot(1091)]
        static extern bool glIsProgramPipeline(UInt32 pipeline);
        [Slot(1093)]
        static extern bool glIsQuery(UInt32 id);
        [Slot(1095)]
        static extern bool glIsRenderbuffer(UInt32 renderbuffer);
        [Slot(1097)]
        static extern bool glIsSampler(UInt32 sampler);
        [Slot(1098)]
        static extern bool glIsShader(UInt32 shader);
        [Slot(1099)]
        static extern bool glIsSync(IntPtr sync);
        [Slot(1100)]
        static extern bool glIsTexture(UInt32 texture);
        [Slot(1104)]
        static extern bool glIsTransformFeedback(UInt32 id);
        [Slot(1107)]
        static extern bool glIsVertexArray(UInt32 array);
        [Slot(1112)]
        static extern void glLightf(OpenTK.Graphics.OpenGL.LightName light, OpenTK.Graphics.OpenGL.LightParameter pname, Single param);
        [Slot(1113)]
        static extern unsafe void glLightfv(OpenTK.Graphics.OpenGL.LightName light, OpenTK.Graphics.OpenGL.LightParameter pname, Single* @params);
        [Slot(1114)]
        static extern void glLighti(OpenTK.Graphics.OpenGL.LightName light, OpenTK.Graphics.OpenGL.LightParameter pname, Int32 param);
        [Slot(1115)]
        static extern unsafe void glLightiv(OpenTK.Graphics.OpenGL.LightName light, OpenTK.Graphics.OpenGL.LightParameter pname, Int32* @params);
        [Slot(1116)]
        static extern void glLightModelf(OpenTK.Graphics.OpenGL.LightModelParameter pname, Single param);
        [Slot(1117)]
        static extern unsafe void glLightModelfv(OpenTK.Graphics.OpenGL.LightModelParameter pname, Single* @params);
        [Slot(1118)]
        static extern void glLightModeli(OpenTK.Graphics.OpenGL.LightModelParameter pname, Int32 param);
        [Slot(1119)]
        static extern unsafe void glLightModeliv(OpenTK.Graphics.OpenGL.LightModelParameter pname, Int32* @params);
        [Slot(1124)]
        static extern void glLineStipple(Int32 factor, UInt16 pattern);
        [Slot(1125)]
        static extern void glLineWidth(Single width);
        [Slot(1127)]
        static extern void glLinkProgram(UInt32 program);
        [Slot(1129)]
        static extern void glListBase(UInt32 @base);
        [Slot(1134)]
        static extern void glLoadIdentity();
        [Slot(1136)]
        static extern unsafe void glLoadMatrixd(Double* m);
        [Slot(1137)]
        static extern unsafe void glLoadMatrixf(Single* m);
        [Slot(1139)]
        static extern void glLoadName(UInt32 name);
        [Slot(1141)]
        static extern unsafe void glLoadTransposeMatrixd(Double* m);
        [Slot(1143)]
        static extern unsafe void glLoadTransposeMatrixf(Single* m);
        [Slot(1147)]
        static extern void glLogicOp(OpenTK.Graphics.OpenGL.LogicOp opcode);
        [Slot(1160)]
        static extern unsafe void glMap1d(OpenTK.Graphics.OpenGL.MapTarget target, Double u1, Double u2, Int32 stride, Int32 order, Double* points);
        [Slot(1161)]
        static extern unsafe void glMap1f(OpenTK.Graphics.OpenGL.MapTarget target, Single u1, Single u2, Int32 stride, Int32 order, Single* points);
        [Slot(1163)]
        static extern unsafe void glMap2d(OpenTK.Graphics.OpenGL.MapTarget target, Double u1, Double u2, Int32 ustride, Int32 uorder, Double v1, Double v2, Int32 vstride, Int32 vorder, Double* points);
        [Slot(1164)]
        static extern unsafe void glMap2f(OpenTK.Graphics.OpenGL.MapTarget target, Single u1, Single u2, Int32 ustride, Int32 uorder, Single v1, Single v2, Int32 vstride, Int32 vorder, Single* points);
        [Slot(1166)]
        static extern IntPtr glMapBuffer(OpenTK.Graphics.OpenGL.BufferTarget target, OpenTK.Graphics.OpenGL.BufferAccess access);
        [Slot(1168)]
        static extern IntPtr glMapBufferRange(OpenTK.Graphics.OpenGL.BufferTarget target, IntPtr offset, IntPtr length, OpenTK.Graphics.OpenGL.BufferAccessMask access);
        [Slot(1170)]
        static extern void glMapGrid1d(Int32 un, Double u1, Double u2);
        [Slot(1171)]
        static extern void glMapGrid1f(Int32 un, Single u1, Single u2);
        [Slot(1173)]
        static extern void glMapGrid2d(Int32 un, Double u1, Double u2, Int32 vn, Double v1, Double v2);
        [Slot(1174)]
        static extern void glMapGrid2f(Int32 un, Single u1, Single u2, Int32 vn, Single v1, Single v2);
        [Slot(1186)]
        static extern void glMaterialf(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, Single param);
        [Slot(1187)]
        static extern unsafe void glMaterialfv(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, Single* @params);
        [Slot(1188)]
        static extern void glMateriali(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, Int32 param);
        [Slot(1189)]
        static extern unsafe void glMaterialiv(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, Int32* @params);
        [Slot(1202)]
        static extern void glMatrixMode(OpenTK.Graphics.OpenGL.MatrixMode mode);
        [Slot(1216)]
        static extern void glMemoryBarrier(OpenTK.Graphics.OpenGL.MemoryBarrierFlags barriers);
        [Slot(1218)]
        static extern void glMinmax(OpenTK.Graphics.OpenGL.MinmaxTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, bool sink);
        [Slot(1220)]
        static extern void glMinSampleShading(Single value);
        [Slot(1222)]
        static extern unsafe void glMultiDrawArrays(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32* first, Int32* count, Int32 drawcount);
        [Slot(1224)]
        static extern void glMultiDrawArraysIndirect(OpenTK.Graphics.OpenGL.PrimitiveType mode, IntPtr indirect, Int32 drawcount, Int32 stride);
        [Slot(1229)]
        static extern unsafe void glMultiDrawElements(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 drawcount);
        [Slot(1230)]
        static extern unsafe void glMultiDrawElementsBaseVertex(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 drawcount, Int32* basevertex);
        [Slot(1232)]
        static extern void glMultiDrawElementsIndirect(OpenTK.Graphics.OpenGL.All mode, OpenTK.Graphics.OpenGL.All type, IntPtr indirect, Int32 drawcount, Int32 stride);
        [Slot(1242)]
        static extern void glMultiTexCoord1d(OpenTK.Graphics.OpenGL.TextureUnit target, Double s);
        [Slot(1244)]
        static extern unsafe void glMultiTexCoord1dv(OpenTK.Graphics.OpenGL.TextureUnit target, Double* v);
        [Slot(1246)]
        static extern void glMultiTexCoord1f(OpenTK.Graphics.OpenGL.TextureUnit target, Single s);
        [Slot(1248)]
        static extern unsafe void glMultiTexCoord1fv(OpenTK.Graphics.OpenGL.TextureUnit target, Single* v);
        [Slot(1252)]
        static extern void glMultiTexCoord1i(OpenTK.Graphics.OpenGL.TextureUnit target, Int32 s);
        [Slot(1254)]
        static extern unsafe void glMultiTexCoord1iv(OpenTK.Graphics.OpenGL.TextureUnit target, Int32* v);
        [Slot(1256)]
        static extern void glMultiTexCoord1s(OpenTK.Graphics.OpenGL.TextureUnit target, Int16 s);
        [Slot(1258)]
        static extern unsafe void glMultiTexCoord1sv(OpenTK.Graphics.OpenGL.TextureUnit target, Int16* v);
        [Slot(1264)]
        static extern void glMultiTexCoord2d(OpenTK.Graphics.OpenGL.TextureUnit target, Double s, Double t);
        [Slot(1266)]
        static extern unsafe void glMultiTexCoord2dv(OpenTK.Graphics.OpenGL.TextureUnit target, Double* v);
        [Slot(1268)]
        static extern void glMultiTexCoord2f(OpenTK.Graphics.OpenGL.TextureUnit target, Single s, Single t);
        [Slot(1270)]
        static extern unsafe void glMultiTexCoord2fv(OpenTK.Graphics.OpenGL.TextureUnit target, Single* v);
        [Slot(1274)]
        static extern void glMultiTexCoord2i(OpenTK.Graphics.OpenGL.TextureUnit target, Int32 s, Int32 t);
        [Slot(1276)]
        static extern unsafe void glMultiTexCoord2iv(OpenTK.Graphics.OpenGL.TextureUnit target, Int32* v);
        [Slot(1278)]
        static extern void glMultiTexCoord2s(OpenTK.Graphics.OpenGL.TextureUnit target, Int16 s, Int16 t);
        [Slot(1280)]
        static extern unsafe void glMultiTexCoord2sv(OpenTK.Graphics.OpenGL.TextureUnit target, Int16* v);
        [Slot(1286)]
        static extern void glMultiTexCoord3d(OpenTK.Graphics.OpenGL.TextureUnit target, Double s, Double t, Double r);
        [Slot(1288)]
        static extern unsafe void glMultiTexCoord3dv(OpenTK.Graphics.OpenGL.TextureUnit target, Double* v);
        [Slot(1290)]
        static extern void glMultiTexCoord3f(OpenTK.Graphics.OpenGL.TextureUnit target, Single s, Single t, Single r);
        [Slot(1292)]
        static extern unsafe void glMultiTexCoord3fv(OpenTK.Graphics.OpenGL.TextureUnit target, Single* v);
        [Slot(1296)]
        static extern void glMultiTexCoord3i(OpenTK.Graphics.OpenGL.TextureUnit target, Int32 s, Int32 t, Int32 r);
        [Slot(1298)]
        static extern unsafe void glMultiTexCoord3iv(OpenTK.Graphics.OpenGL.TextureUnit target, Int32* v);
        [Slot(1300)]
        static extern void glMultiTexCoord3s(OpenTK.Graphics.OpenGL.TextureUnit target, Int16 s, Int16 t, Int16 r);
        [Slot(1302)]
        static extern unsafe void glMultiTexCoord3sv(OpenTK.Graphics.OpenGL.TextureUnit target, Int16* v);
        [Slot(1308)]
        static extern void glMultiTexCoord4d(OpenTK.Graphics.OpenGL.TextureUnit target, Double s, Double t, Double r, Double q);
        [Slot(1310)]
        static extern unsafe void glMultiTexCoord4dv(OpenTK.Graphics.OpenGL.TextureUnit target, Double* v);
        [Slot(1312)]
        static extern void glMultiTexCoord4f(OpenTK.Graphics.OpenGL.TextureUnit target, Single s, Single t, Single r, Single q);
        [Slot(1314)]
        static extern unsafe void glMultiTexCoord4fv(OpenTK.Graphics.OpenGL.TextureUnit target, Single* v);
        [Slot(1318)]
        static extern void glMultiTexCoord4i(OpenTK.Graphics.OpenGL.TextureUnit target, Int32 s, Int32 t, Int32 r, Int32 q);
        [Slot(1320)]
        static extern unsafe void glMultiTexCoord4iv(OpenTK.Graphics.OpenGL.TextureUnit target, Int32* v);
        [Slot(1322)]
        static extern void glMultiTexCoord4s(OpenTK.Graphics.OpenGL.TextureUnit target, Int16 s, Int16 t, Int16 r, Int16 q);
        [Slot(1324)]
        static extern unsafe void glMultiTexCoord4sv(OpenTK.Graphics.OpenGL.TextureUnit target, Int16* v);
        [Slot(1328)]
        static extern void glMultiTexCoordP1ui(OpenTK.Graphics.OpenGL.TextureUnit texture, OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32 coords);
        [Slot(1329)]
        static extern unsafe void glMultiTexCoordP1uiv(OpenTK.Graphics.OpenGL.TextureUnit texture, OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32* coords);
        [Slot(1330)]
        static extern void glMultiTexCoordP2ui(OpenTK.Graphics.OpenGL.TextureUnit texture, OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32 coords);
        [Slot(1331)]
        static extern unsafe void glMultiTexCoordP2uiv(OpenTK.Graphics.OpenGL.TextureUnit texture, OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32* coords);
        [Slot(1332)]
        static extern void glMultiTexCoordP3ui(OpenTK.Graphics.OpenGL.TextureUnit texture, OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32 coords);
        [Slot(1333)]
        static extern unsafe void glMultiTexCoordP3uiv(OpenTK.Graphics.OpenGL.TextureUnit texture, OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32* coords);
        [Slot(1334)]
        static extern void glMultiTexCoordP4ui(OpenTK.Graphics.OpenGL.TextureUnit texture, OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32 coords);
        [Slot(1335)]
        static extern unsafe void glMultiTexCoordP4uiv(OpenTK.Graphics.OpenGL.TextureUnit texture, OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32* coords);
        [Slot(1360)]
        static extern unsafe void glMultMatrixd(Double* m);
        [Slot(1361)]
        static extern unsafe void glMultMatrixf(Single* m);
        [Slot(1363)]
        static extern unsafe void glMultTransposeMatrixd(Double* m);
        [Slot(1365)]
        static extern unsafe void glMultTransposeMatrixf(Single* m);
        [Slot(1396)]
        static extern void glNewList(UInt32 list, OpenTK.Graphics.OpenGL.ListMode mode);
        [Slot(1398)]
        static extern void glNormal3b(SByte nx, SByte ny, SByte nz);
        [Slot(1399)]
        static extern unsafe void glNormal3bv(SByte* v);
        [Slot(1400)]
        static extern void glNormal3d(Double nx, Double ny, Double nz);
        [Slot(1401)]
        static extern unsafe void glNormal3dv(Double* v);
        [Slot(1402)]
        static extern void glNormal3f(Single nx, Single ny, Single nz);
        [Slot(1403)]
        static extern unsafe void glNormal3fv(Single* v);
        [Slot(1408)]
        static extern void glNormal3i(Int32 nx, Int32 ny, Int32 nz);
        [Slot(1409)]
        static extern unsafe void glNormal3iv(Int32* v);
        [Slot(1410)]
        static extern void glNormal3s(Int16 nx, Int16 ny, Int16 nz);
        [Slot(1411)]
        static extern unsafe void glNormal3sv(Int16* v);
        [Slot(1415)]
        static extern void glNormalP3ui(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32 coords);
        [Slot(1416)]
        static extern unsafe void glNormalP3uiv(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32* coords);
        [Slot(1417)]
        static extern void glNormalPointer(OpenTK.Graphics.OpenGL.NormalPointerType type, Int32 stride, IntPtr pointer);
        [Slot(1431)]
        static extern void glObjectLabel(OpenTK.Graphics.OpenGL.ObjectLabelIdentifier identifier, UInt32 name, Int32 length, String label);
        [Slot(1433)]
        static extern void glObjectPtrLabel(IntPtr ptr, Int32 length, String label);
        [Slot(1437)]
        static extern void glOrtho(Double left, Double right, Double bottom, Double top, Double zNear, Double zFar);
        [Slot(1441)]
        static extern void glPassThrough(Single token);
        [Slot(1443)]
        static extern unsafe void glPatchParameterfv(OpenTK.Graphics.OpenGL.PatchParameterFloat pname, Single* values);
        [Slot(1444)]
        static extern void glPatchParameteri(OpenTK.Graphics.OpenGL.PatchParameterInt pname, Int32 value);
        [Slot(1463)]
        static extern void glPauseTransformFeedback();
        [Slot(1466)]
        static extern unsafe void glPixelMapfv(OpenTK.Graphics.OpenGL.PixelMap map, Int32 mapsize, Single* values);
        [Slot(1467)]
        static extern unsafe void glPixelMapuiv(OpenTK.Graphics.OpenGL.PixelMap map, Int32 mapsize, UInt32* values);
        [Slot(1468)]
        static extern unsafe void glPixelMapusv(OpenTK.Graphics.OpenGL.PixelMap map, Int32 mapsize, UInt16* values);
        [Slot(1469)]
        static extern unsafe void glPixelMapx(OpenTK.Graphics.OpenGL.OesFixedPoint map, Int32 size, int* values);
        [Slot(1470)]
        static extern void glPixelStoref(OpenTK.Graphics.OpenGL.PixelStoreParameter pname, Single param);
        [Slot(1471)]
        static extern void glPixelStorei(OpenTK.Graphics.OpenGL.PixelStoreParameter pname, Int32 param);
        [Slot(1472)]
        static extern void glPixelStorex(OpenTK.Graphics.OpenGL.OesFixedPoint pname, int param);
        [Slot(1478)]
        static extern void glPixelTransferf(OpenTK.Graphics.OpenGL.PixelTransferParameter pname, Single param);
        [Slot(1479)]
        static extern void glPixelTransferi(OpenTK.Graphics.OpenGL.PixelTransferParameter pname, Int32 param);
        [Slot(1485)]
        static extern void glPixelZoom(Single xfactor, Single yfactor);
        [Slot(1490)]
        static extern void glPointParameterf(OpenTK.Graphics.OpenGL.PointParameterName pname, Single param);
        [Slot(1494)]
        static extern unsafe void glPointParameterfv(OpenTK.Graphics.OpenGL.PointParameterName pname, Single* @params);
        [Slot(1498)]
        static extern void glPointParameteri(OpenTK.Graphics.OpenGL.PointParameterName pname, Int32 param);
        [Slot(1500)]
        static extern unsafe void glPointParameteriv(OpenTK.Graphics.OpenGL.PointParameterName pname, Int32* @params);
        [Slot(1504)]
        static extern void glPointSize(Single size);
        [Slot(1508)]
        static extern void glPolygonMode(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.PolygonMode mode);
        [Slot(1509)]
        static extern void glPolygonOffset(Single factor, Single units);
        [Slot(1512)]
        static extern unsafe void glPolygonStipple(Byte* mask);
        [Slot(1513)]
        static extern void glPopAttrib();
        [Slot(1514)]
        static extern void glPopClientAttrib();
        [Slot(1515)]
        static extern void glPopDebugGroup();
        [Slot(1518)]
        static extern void glPopMatrix();
        [Slot(1519)]
        static extern void glPopName();
        [Slot(1522)]
        static extern void glPrimitiveRestartIndex(UInt32 index);
        [Slot(1525)]
        static extern unsafe void glPrioritizeTextures(Int32 n, UInt32* textures, Single* priorities);
        [Slot(1528)]
        static extern void glProgramBinary(UInt32 program, OpenTK.Graphics.OpenGL.BinaryFormat binaryFormat, IntPtr binary, Int32 length);
        [Slot(1562)]
        static extern void glProgramParameteri(UInt32 program, OpenTK.Graphics.OpenGL.ProgramParameterName pname, Int32 value);
        [Slot(1569)]
        static extern void glProgramUniform1d(UInt32 program, Int32 location, Double v0);
        [Slot(1571)]
        static extern unsafe void glProgramUniform1dv(UInt32 program, Int32 location, Int32 count, Double* value);
        [Slot(1573)]
        static extern void glProgramUniform1f(UInt32 program, Int32 location, Single v0);
        [Slot(1575)]
        static extern unsafe void glProgramUniform1fv(UInt32 program, Int32 location, Int32 count, Single* value);
        [Slot(1577)]
        static extern void glProgramUniform1i(UInt32 program, Int32 location, Int32 v0);
        [Slot(1581)]
        static extern unsafe void glProgramUniform1iv(UInt32 program, Int32 location, Int32 count, Int32* value);
        [Slot(1583)]
        static extern void glProgramUniform1ui(UInt32 program, Int32 location, UInt32 v0);
        [Slot(1587)]
        static extern unsafe void glProgramUniform1uiv(UInt32 program, Int32 location, Int32 count, UInt32* value);
        [Slot(1589)]
        static extern void glProgramUniform2d(UInt32 program, Int32 location, Double v0, Double v1);
        [Slot(1591)]
        static extern unsafe void glProgramUniform2dv(UInt32 program, Int32 location, Int32 count, Double* value);
        [Slot(1593)]
        static extern void glProgramUniform2f(UInt32 program, Int32 location, Single v0, Single v1);
        [Slot(1595)]
        static extern unsafe void glProgramUniform2fv(UInt32 program, Int32 location, Int32 count, Single* value);
        [Slot(1597)]
        static extern void glProgramUniform2i(UInt32 program, Int32 location, Int32 v0, Int32 v1);
        [Slot(1601)]
        static extern unsafe void glProgramUniform2iv(UInt32 program, Int32 location, Int32 count, Int32* value);
        [Slot(1603)]
        static extern void glProgramUniform2ui(UInt32 program, Int32 location, UInt32 v0, UInt32 v1);
        [Slot(1607)]
        static extern unsafe void glProgramUniform2uiv(UInt32 program, Int32 location, Int32 count, UInt32* value);
        [Slot(1609)]
        static extern void glProgramUniform3d(UInt32 program, Int32 location, Double v0, Double v1, Double v2);
        [Slot(1611)]
        static extern unsafe void glProgramUniform3dv(UInt32 program, Int32 location, Int32 count, Double* value);
        [Slot(1613)]
        static extern void glProgramUniform3f(UInt32 program, Int32 location, Single v0, Single v1, Single v2);
        [Slot(1615)]
        static extern unsafe void glProgramUniform3fv(UInt32 program, Int32 location, Int32 count, Single* value);
        [Slot(1617)]
        static extern void glProgramUniform3i(UInt32 program, Int32 location, Int32 v0, Int32 v1, Int32 v2);
        [Slot(1621)]
        static extern unsafe void glProgramUniform3iv(UInt32 program, Int32 location, Int32 count, Int32* value);
        [Slot(1623)]
        static extern void glProgramUniform3ui(UInt32 program, Int32 location, UInt32 v0, UInt32 v1, UInt32 v2);
        [Slot(1627)]
        static extern unsafe void glProgramUniform3uiv(UInt32 program, Int32 location, Int32 count, UInt32* value);
        [Slot(1629)]
        static extern void glProgramUniform4d(UInt32 program, Int32 location, Double v0, Double v1, Double v2, Double v3);
        [Slot(1631)]
        static extern unsafe void glProgramUniform4dv(UInt32 program, Int32 location, Int32 count, Double* value);
        [Slot(1633)]
        static extern void glProgramUniform4f(UInt32 program, Int32 location, Single v0, Single v1, Single v2, Single v3);
        [Slot(1635)]
        static extern unsafe void glProgramUniform4fv(UInt32 program, Int32 location, Int32 count, Single* value);
        [Slot(1637)]
        static extern void glProgramUniform4i(UInt32 program, Int32 location, Int32 v0, Int32 v1, Int32 v2, Int32 v3);
        [Slot(1641)]
        static extern unsafe void glProgramUniform4iv(UInt32 program, Int32 location, Int32 count, Int32* value);
        [Slot(1643)]
        static extern void glProgramUniform4ui(UInt32 program, Int32 location, UInt32 v0, UInt32 v1, UInt32 v2, UInt32 v3);
        [Slot(1647)]
        static extern unsafe void glProgramUniform4uiv(UInt32 program, Int32 location, Int32 count, UInt32* value);
        [Slot(1653)]
        static extern unsafe void glProgramUniformMatrix2dv(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);
        [Slot(1655)]
        static extern unsafe void glProgramUniformMatrix2fv(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);
        [Slot(1657)]
        static extern unsafe void glProgramUniformMatrix2x3dv(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);
        [Slot(1659)]
        static extern unsafe void glProgramUniformMatrix2x3fv(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);
        [Slot(1661)]
        static extern unsafe void glProgramUniformMatrix2x4dv(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);
        [Slot(1663)]
        static extern unsafe void glProgramUniformMatrix2x4fv(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);
        [Slot(1665)]
        static extern unsafe void glProgramUniformMatrix3dv(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);
        [Slot(1667)]
        static extern unsafe void glProgramUniformMatrix3fv(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);
        [Slot(1669)]
        static extern unsafe void glProgramUniformMatrix3x2dv(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);
        [Slot(1671)]
        static extern unsafe void glProgramUniformMatrix3x2fv(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);
        [Slot(1673)]
        static extern unsafe void glProgramUniformMatrix3x4dv(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);
        [Slot(1675)]
        static extern unsafe void glProgramUniformMatrix3x4fv(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);
        [Slot(1677)]
        static extern unsafe void glProgramUniformMatrix4dv(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);
        [Slot(1679)]
        static extern unsafe void glProgramUniformMatrix4fv(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);
        [Slot(1681)]
        static extern unsafe void glProgramUniformMatrix4x2dv(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);
        [Slot(1683)]
        static extern unsafe void glProgramUniformMatrix4x2fv(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);
        [Slot(1685)]
        static extern unsafe void glProgramUniformMatrix4x3dv(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);
        [Slot(1687)]
        static extern unsafe void glProgramUniformMatrix4x3fv(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);
        [Slot(1692)]
        static extern void glProvokingVertex(OpenTK.Graphics.OpenGL.ProvokingVertexMode mode);
        [Slot(1694)]
        static extern void glPushAttrib(OpenTK.Graphics.OpenGL.AttribMask mask);
        [Slot(1695)]
        static extern void glPushClientAttrib(OpenTK.Graphics.OpenGL.ClientAttribMask mask);
        [Slot(1697)]
        static extern void glPushDebugGroup(OpenTK.Graphics.OpenGL.DebugSourceExternal source, UInt32 id, Int32 length, String message);
        [Slot(1700)]
        static extern void glPushMatrix();
        [Slot(1701)]
        static extern void glPushName(UInt32 name);
        [Slot(1702)]
        static extern void glQueryCounter(UInt32 id, OpenTK.Graphics.OpenGL.QueryCounterTarget target);
        [Slot(1704)]
        static extern void glRasterPos2d(Double x, Double y);
        [Slot(1705)]
        static extern unsafe void glRasterPos2dv(Double* v);
        [Slot(1706)]
        static extern void glRasterPos2f(Single x, Single y);
        [Slot(1707)]
        static extern unsafe void glRasterPos2fv(Single* v);
        [Slot(1708)]
        static extern void glRasterPos2i(Int32 x, Int32 y);
        [Slot(1709)]
        static extern unsafe void glRasterPos2iv(Int32* v);
        [Slot(1710)]
        static extern void glRasterPos2s(Int16 x, Int16 y);
        [Slot(1711)]
        static extern unsafe void glRasterPos2sv(Int16* v);
        [Slot(1714)]
        static extern void glRasterPos3d(Double x, Double y, Double z);
        [Slot(1715)]
        static extern unsafe void glRasterPos3dv(Double* v);
        [Slot(1716)]
        static extern void glRasterPos3f(Single x, Single y, Single z);
        [Slot(1717)]
        static extern unsafe void glRasterPos3fv(Single* v);
        [Slot(1718)]
        static extern void glRasterPos3i(Int32 x, Int32 y, Int32 z);
        [Slot(1719)]
        static extern unsafe void glRasterPos3iv(Int32* v);
        [Slot(1720)]
        static extern void glRasterPos3s(Int16 x, Int16 y, Int16 z);
        [Slot(1721)]
        static extern unsafe void glRasterPos3sv(Int16* v);
        [Slot(1724)]
        static extern void glRasterPos4d(Double x, Double y, Double z, Double w);
        [Slot(1725)]
        static extern unsafe void glRasterPos4dv(Double* v);
        [Slot(1726)]
        static extern void glRasterPos4f(Single x, Single y, Single z, Single w);
        [Slot(1727)]
        static extern unsafe void glRasterPos4fv(Single* v);
        [Slot(1728)]
        static extern void glRasterPos4i(Int32 x, Int32 y, Int32 z, Int32 w);
        [Slot(1729)]
        static extern unsafe void glRasterPos4iv(Int32* v);
        [Slot(1730)]
        static extern void glRasterPos4s(Int16 x, Int16 y, Int16 z, Int16 w);
        [Slot(1731)]
        static extern unsafe void glRasterPos4sv(Int16* v);
        [Slot(1734)]
        static extern void glReadBuffer(OpenTK.Graphics.OpenGL.ReadBufferMode mode);
        [Slot(1737)]
        static extern void glReadPixels(Int32 x, Int32 y, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [OutAttribute] IntPtr pixels);
        [Slot(1738)]
        static extern void glRectd(Double x1, Double y1, Double x2, Double y2);
        [Slot(1739)]
        static extern unsafe void glRectdv(Double* v1, Double* v2);
        [Slot(1740)]
        static extern void glRectf(Single x1, Single y1, Single x2, Single y2);
        [Slot(1741)]
        static extern unsafe void glRectfv(Single* v1, Single* v2);
        [Slot(1742)]
        static extern void glRecti(Int32 x1, Int32 y1, Int32 x2, Int32 y2);
        [Slot(1743)]
        static extern unsafe void glRectiv(Int32* v1, Int32* v2);
        [Slot(1744)]
        static extern void glRects(Int16 x1, Int16 y1, Int16 x2, Int16 y2);
        [Slot(1745)]
        static extern unsafe void glRectsv(Int16* v1, Int16* v2);
        [Slot(1749)]
        static extern void glReleaseShaderCompiler();
        [Slot(1750)]
        static extern void glRenderbufferStorage(OpenTK.Graphics.OpenGL.RenderbufferTarget target, OpenTK.Graphics.OpenGL.RenderbufferStorage internalformat, Int32 width, Int32 height);
        [Slot(1752)]
        static extern void glRenderbufferStorageMultisample(OpenTK.Graphics.OpenGL.RenderbufferTarget target, Int32 samples, OpenTK.Graphics.OpenGL.RenderbufferStorage internalformat, Int32 width, Int32 height);
        [Slot(1755)]
        static extern Int32 glRenderMode(OpenTK.Graphics.OpenGL.RenderingMode mode);
        [Slot(1780)]
        static extern void glResetHistogram(OpenTK.Graphics.OpenGL.HistogramTarget target);
        [Slot(1782)]
        static extern void glResetMinmax(OpenTK.Graphics.OpenGL.MinmaxTarget target);
        [Slot(1785)]
        static extern void glResumeTransformFeedback();
        [Slot(1787)]
        static extern void glRotated(Double angle, Double x, Double y, Double z);
        [Slot(1788)]
        static extern void glRotatef(Single angle, Single x, Single y, Single z);
        [Slot(1790)]
        static extern void glSampleCoverage(Single value, bool invert);
        [Slot(1796)]
        static extern void glSampleMaski(UInt32 index, UInt32 mask);
        [Slot(1801)]
        static extern void glSamplerParameterf(UInt32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, Single param);
        [Slot(1802)]
        static extern unsafe void glSamplerParameterfv(UInt32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, Single* param);
        [Slot(1803)]
        static extern void glSamplerParameteri(UInt32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, Int32 param);
        [Slot(1804)]
        static extern unsafe void glSamplerParameterIiv(UInt32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, Int32* param);
        [Slot(1805)]
        static extern unsafe void glSamplerParameterIuiv(UInt32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, UInt32* param);
        [Slot(1806)]
        static extern unsafe void glSamplerParameteriv(UInt32 sampler, OpenTK.Graphics.OpenGL.SamplerParameterName pname, Int32* param);
        [Slot(1807)]
        static extern void glScaled(Double x, Double y, Double z);
        [Slot(1808)]
        static extern void glScalef(Single x, Single y, Single z);
        [Slot(1810)]
        static extern void glScissor(Int32 x, Int32 y, Int32 width, Int32 height);
        [Slot(1811)]
        static extern unsafe void glScissorArrayv(UInt32 first, Int32 count, Int32* v);
        [Slot(1812)]
        static extern void glScissorIndexed(UInt32 index, Int32 left, Int32 bottom, Int32 width, Int32 height);
        [Slot(1813)]
        static extern unsafe void glScissorIndexedv(UInt32 index, Int32* v);
        [Slot(1814)]
        static extern void glSecondaryColor3b(SByte red, SByte green, SByte blue);
        [Slot(1816)]
        static extern unsafe void glSecondaryColor3bv(SByte* v);
        [Slot(1818)]
        static extern void glSecondaryColor3d(Double red, Double green, Double blue);
        [Slot(1820)]
        static extern unsafe void glSecondaryColor3dv(Double* v);
        [Slot(1822)]
        static extern void glSecondaryColor3f(Single red, Single green, Single blue);
        [Slot(1824)]
        static extern unsafe void glSecondaryColor3fv(Single* v);
        [Slot(1828)]
        static extern void glSecondaryColor3i(Int32 red, Int32 green, Int32 blue);
        [Slot(1830)]
        static extern unsafe void glSecondaryColor3iv(Int32* v);
        [Slot(1832)]
        static extern void glSecondaryColor3s(Int16 red, Int16 green, Int16 blue);
        [Slot(1834)]
        static extern unsafe void glSecondaryColor3sv(Int16* v);
        [Slot(1836)]
        static extern void glSecondaryColor3ub(Byte red, Byte green, Byte blue);
        [Slot(1838)]
        static extern unsafe void glSecondaryColor3ubv(Byte* v);
        [Slot(1840)]
        static extern void glSecondaryColor3ui(UInt32 red, UInt32 green, UInt32 blue);
        [Slot(1842)]
        static extern unsafe void glSecondaryColor3uiv(UInt32* v);
        [Slot(1844)]
        static extern void glSecondaryColor3us(UInt16 red, UInt16 green, UInt16 blue);
        [Slot(1846)]
        static extern unsafe void glSecondaryColor3usv(UInt16* v);
        [Slot(1849)]
        static extern void glSecondaryColorP3ui(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32 color);
        [Slot(1850)]
        static extern unsafe void glSecondaryColorP3uiv(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32* color);
        [Slot(1851)]
        static extern void glSecondaryColorPointer(Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, IntPtr pointer);
        [Slot(1854)]
        static extern unsafe void glSelectBuffer(Int32 size, [OutAttribute] UInt32* buffer);
        [Slot(1856)]
        static extern void glSeparableFilter2D(OpenTK.Graphics.OpenGL.SeparableTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr row, IntPtr column);
        [Slot(1864)]
        static extern void glShadeModel(OpenTK.Graphics.OpenGL.ShadingModel mode);
        [Slot(1865)]
        static extern unsafe void glShaderBinary(Int32 count, UInt32* shaders, OpenTK.Graphics.OpenGL.BinaryFormat binaryformat, IntPtr binary, Int32 length);
        [Slot(1869)]
        static extern unsafe void glShaderSource(UInt32 shader, Int32 count, String[] @string, Int32* length);
        [Slot(1871)]
        static extern void glShaderStorageBlockBinding(UInt32 program, UInt32 storageBlockIndex, UInt32 storageBlockBinding);
        [Slot(1881)]
        static extern void glStencilFunc(OpenTK.Graphics.OpenGL.StencilFunction func, Int32 @ref, UInt32 mask);
        [Slot(1882)]
        static extern void glStencilFuncSeparate(OpenTK.Graphics.OpenGL.StencilFace face, OpenTK.Graphics.OpenGL.StencilFunction func, Int32 @ref, UInt32 mask);
        [Slot(1884)]
        static extern void glStencilMask(UInt32 mask);
        [Slot(1885)]
        static extern void glStencilMaskSeparate(OpenTK.Graphics.OpenGL.StencilFace face, UInt32 mask);
        [Slot(1886)]
        static extern void glStencilOp(OpenTK.Graphics.OpenGL.StencilOp fail, OpenTK.Graphics.OpenGL.StencilOp zfail, OpenTK.Graphics.OpenGL.StencilOp zpass);
        [Slot(1887)]
        static extern void glStencilOpSeparate(OpenTK.Graphics.OpenGL.StencilFace face, OpenTK.Graphics.OpenGL.StencilOp sfail, OpenTK.Graphics.OpenGL.StencilOp dpfail, OpenTK.Graphics.OpenGL.StencilOp dppass);
        [Slot(1914)]
        static extern void glTexBuffer(OpenTK.Graphics.OpenGL.TextureBufferTarget target, OpenTK.Graphics.OpenGL.SizedInternalFormat internalformat, UInt32 buffer);
        [Slot(1917)]
        static extern void glTexBufferRange(OpenTK.Graphics.OpenGL.TextureBufferTarget target, OpenTK.Graphics.OpenGL.SizedInternalFormat internalformat, UInt32 buffer, IntPtr offset, IntPtr size);
        [Slot(1922)]
        static extern void glTexCoord1d(Double s);
        [Slot(1923)]
        static extern unsafe void glTexCoord1dv(Double* v);
        [Slot(1924)]
        static extern void glTexCoord1f(Single s);
        [Slot(1925)]
        static extern unsafe void glTexCoord1fv(Single* v);
        [Slot(1928)]
        static extern void glTexCoord1i(Int32 s);
        [Slot(1929)]
        static extern unsafe void glTexCoord1iv(Int32* v);
        [Slot(1930)]
        static extern void glTexCoord1s(Int16 s);
        [Slot(1931)]
        static extern unsafe void glTexCoord1sv(Int16* v);
        [Slot(1936)]
        static extern void glTexCoord2d(Double s, Double t);
        [Slot(1937)]
        static extern unsafe void glTexCoord2dv(Double* v);
        [Slot(1938)]
        static extern void glTexCoord2f(Single s, Single t);
        [Slot(1947)]
        static extern unsafe void glTexCoord2fv(Single* v);
        [Slot(1952)]
        static extern void glTexCoord2i(Int32 s, Int32 t);
        [Slot(1953)]
        static extern unsafe void glTexCoord2iv(Int32* v);
        [Slot(1954)]
        static extern void glTexCoord2s(Int16 s, Int16 t);
        [Slot(1955)]
        static extern unsafe void glTexCoord2sv(Int16* v);
        [Slot(1960)]
        static extern void glTexCoord3d(Double s, Double t, Double r);
        [Slot(1961)]
        static extern unsafe void glTexCoord3dv(Double* v);
        [Slot(1962)]
        static extern void glTexCoord3f(Single s, Single t, Single r);
        [Slot(1963)]
        static extern unsafe void glTexCoord3fv(Single* v);
        [Slot(1966)]
        static extern void glTexCoord3i(Int32 s, Int32 t, Int32 r);
        [Slot(1967)]
        static extern unsafe void glTexCoord3iv(Int32* v);
        [Slot(1968)]
        static extern void glTexCoord3s(Int16 s, Int16 t, Int16 r);
        [Slot(1969)]
        static extern unsafe void glTexCoord3sv(Int16* v);
        [Slot(1974)]
        static extern void glTexCoord4d(Double s, Double t, Double r, Double q);
        [Slot(1975)]
        static extern unsafe void glTexCoord4dv(Double* v);
        [Slot(1976)]
        static extern void glTexCoord4f(Single s, Single t, Single r, Single q);
        [Slot(1979)]
        static extern unsafe void glTexCoord4fv(Single* v);
        [Slot(1984)]
        static extern void glTexCoord4i(Int32 s, Int32 t, Int32 r, Int32 q);
        [Slot(1985)]
        static extern unsafe void glTexCoord4iv(Int32* v);
        [Slot(1986)]
        static extern void glTexCoord4s(Int16 s, Int16 t, Int16 r, Int16 q);
        [Slot(1987)]
        static extern unsafe void glTexCoord4sv(Int16* v);
        [Slot(1991)]
        static extern void glTexCoordP1ui(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32 coords);
        [Slot(1992)]
        static extern unsafe void glTexCoordP1uiv(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32* coords);
        [Slot(1993)]
        static extern void glTexCoordP2ui(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32 coords);
        [Slot(1994)]
        static extern unsafe void glTexCoordP2uiv(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32* coords);
        [Slot(1995)]
        static extern void glTexCoordP3ui(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32 coords);
        [Slot(1996)]
        static extern unsafe void glTexCoordP3uiv(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32* coords);
        [Slot(1997)]
        static extern void glTexCoordP4ui(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32 coords);
        [Slot(1998)]
        static extern unsafe void glTexCoordP4uiv(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32* coords);
        [Slot(1999)]
        static extern void glTexCoordPointer(Int32 size, OpenTK.Graphics.OpenGL.TexCoordPointerType type, Int32 stride, IntPtr pointer);
        [Slot(2003)]
        static extern void glTexEnvf(OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, Single param);
        [Slot(2004)]
        static extern unsafe void glTexEnvfv(OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, Single* @params);
        [Slot(2005)]
        static extern void glTexEnvi(OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, Int32 param);
        [Slot(2006)]
        static extern unsafe void glTexEnviv(OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, Int32* @params);
        [Slot(2010)]
        static extern void glTexGend(OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, Double param);
        [Slot(2011)]
        static extern unsafe void glTexGendv(OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, Double* @params);
        [Slot(2012)]
        static extern void glTexGenf(OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, Single param);
        [Slot(2013)]
        static extern unsafe void glTexGenfv(OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, Single* @params);
        [Slot(2014)]
        static extern void glTexGeni(OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, Int32 param);
        [Slot(2015)]
        static extern unsafe void glTexGeniv(OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, Int32* @params);
        [Slot(2018)]
        static extern void glTexImage1D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);
        [Slot(2019)]
        static extern void glTexImage2D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);
        [Slot(2020)]
        static extern void glTexImage2DMultisample(OpenTK.Graphics.OpenGL.TextureTargetMultisample target, Int32 samples, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, bool fixedsamplelocations);
        [Slot(2022)]
        static extern void glTexImage3D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);
        [Slot(2024)]
        static extern void glTexImage3DMultisample(OpenTK.Graphics.OpenGL.TextureTargetMultisample target, Int32 samples, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 depth, bool fixedsamplelocations);
        [Slot(2028)]
        static extern void glTexParameterf(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Single param);
        [Slot(2029)]
        static extern unsafe void glTexParameterfv(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Single* @params);
        [Slot(2030)]
        static extern void glTexParameteri(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Int32 param);
        [Slot(2031)]
        static extern unsafe void glTexParameterIiv(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Int32* @params);
        [Slot(2033)]
        static extern unsafe void glTexParameterIuiv(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, UInt32* @params);
        [Slot(2035)]
        static extern unsafe void glTexParameteriv(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Int32* @params);
        [Slot(2039)]
        static extern void glTexStorage1D(OpenTK.Graphics.OpenGL.TextureTarget1d target, Int32 levels, OpenTK.Graphics.OpenGL.SizedInternalFormat internalformat, Int32 width);
        [Slot(2040)]
        static extern void glTexStorage2D(OpenTK.Graphics.OpenGL.TextureTarget2d target, Int32 levels, OpenTK.Graphics.OpenGL.SizedInternalFormat internalformat, Int32 width, Int32 height);
        [Slot(2041)]
        static extern void glTexStorage2DMultisample(OpenTK.Graphics.OpenGL.TextureTargetMultisample2d target, Int32 samples, OpenTK.Graphics.OpenGL.SizedInternalFormat internalformat, Int32 width, Int32 height, bool fixedsamplelocations);
        [Slot(2042)]
        static extern void glTexStorage3D(OpenTK.Graphics.OpenGL.TextureTarget3d target, Int32 levels, OpenTK.Graphics.OpenGL.SizedInternalFormat internalformat, Int32 width, Int32 height, Int32 depth);
        [Slot(2043)]
        static extern void glTexStorage3DMultisample(OpenTK.Graphics.OpenGL.TextureTargetMultisample3d target, Int32 samples, OpenTK.Graphics.OpenGL.SizedInternalFormat internalformat, Int32 width, Int32 height, Int32 depth, bool fixedsamplelocations);
        [Slot(2045)]
        static extern void glTexSubImage1D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);
        [Slot(2047)]
        static extern void glTexSubImage2D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);
        [Slot(2049)]
        static extern void glTexSubImage3D(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);
        [Slot(2084)]
        static extern void glTextureView(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, UInt32 origtexture, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, UInt32 minlevel, UInt32 numlevels, UInt32 minlayer, UInt32 numlayers);
        [Slot(2088)]
        static extern void glTransformFeedbackVaryings(UInt32 program, Int32 count, String[] varyings, OpenTK.Graphics.OpenGL.TransformFeedbackMode bufferMode);
        [Slot(2092)]
        static extern void glTranslated(Double x, Double y, Double z);
        [Slot(2093)]
        static extern void glTranslatef(Single x, Single y, Single z);
        [Slot(2095)]
        static extern void glUniform1d(Int32 location, Double x);
        [Slot(2096)]
        static extern unsafe void glUniform1dv(Int32 location, Int32 count, Double* value);
        [Slot(2097)]
        static extern void glUniform1f(Int32 location, Single v0);
        [Slot(2099)]
        static extern unsafe void glUniform1fv(Int32 location, Int32 count, Single* value);
        [Slot(2101)]
        static extern void glUniform1i(Int32 location, Int32 v0);
        [Slot(2105)]
        static extern unsafe void glUniform1iv(Int32 location, Int32 count, Int32* value);
        [Slot(2107)]
        static extern void glUniform1ui(Int32 location, UInt32 v0);
        [Slot(2111)]
        static extern unsafe void glUniform1uiv(Int32 location, Int32 count, UInt32* value);
        [Slot(2113)]
        static extern void glUniform2d(Int32 location, Double x, Double y);
        [Slot(2114)]
        static extern unsafe void glUniform2dv(Int32 location, Int32 count, Double* value);
        [Slot(2115)]
        static extern void glUniform2f(Int32 location, Single v0, Single v1);
        [Slot(2117)]
        static extern unsafe void glUniform2fv(Int32 location, Int32 count, Single* value);
        [Slot(2119)]
        static extern void glUniform2i(Int32 location, Int32 v0, Int32 v1);
        [Slot(2123)]
        static extern unsafe void glUniform2iv(Int32 location, Int32 count, Int32* value);
        [Slot(2125)]
        static extern void glUniform2ui(Int32 location, UInt32 v0, UInt32 v1);
        [Slot(2129)]
        static extern unsafe void glUniform2uiv(Int32 location, Int32 count, UInt32* value);
        [Slot(2131)]
        static extern void glUniform3d(Int32 location, Double x, Double y, Double z);
        [Slot(2132)]
        static extern unsafe void glUniform3dv(Int32 location, Int32 count, Double* value);
        [Slot(2133)]
        static extern void glUniform3f(Int32 location, Single v0, Single v1, Single v2);
        [Slot(2135)]
        static extern unsafe void glUniform3fv(Int32 location, Int32 count, Single* value);
        [Slot(2137)]
        static extern void glUniform3i(Int32 location, Int32 v0, Int32 v1, Int32 v2);
        [Slot(2141)]
        static extern unsafe void glUniform3iv(Int32 location, Int32 count, Int32* value);
        [Slot(2143)]
        static extern void glUniform3ui(Int32 location, UInt32 v0, UInt32 v1, UInt32 v2);
        [Slot(2147)]
        static extern unsafe void glUniform3uiv(Int32 location, Int32 count, UInt32* value);
        [Slot(2149)]
        static extern void glUniform4d(Int32 location, Double x, Double y, Double z, Double w);
        [Slot(2150)]
        static extern unsafe void glUniform4dv(Int32 location, Int32 count, Double* value);
        [Slot(2151)]
        static extern void glUniform4f(Int32 location, Single v0, Single v1, Single v2, Single v3);
        [Slot(2153)]
        static extern unsafe void glUniform4fv(Int32 location, Int32 count, Single* value);
        [Slot(2155)]
        static extern void glUniform4i(Int32 location, Int32 v0, Int32 v1, Int32 v2, Int32 v3);
        [Slot(2159)]
        static extern unsafe void glUniform4iv(Int32 location, Int32 count, Int32* value);
        [Slot(2161)]
        static extern void glUniform4ui(Int32 location, UInt32 v0, UInt32 v1, UInt32 v2, UInt32 v3);
        [Slot(2165)]
        static extern unsafe void glUniform4uiv(Int32 location, Int32 count, UInt32* value);
        [Slot(2167)]
        static extern void glUniformBlockBinding(UInt32 program, UInt32 uniformBlockIndex, UInt32 uniformBlockBinding);
        [Slot(2173)]
        static extern unsafe void glUniformMatrix2dv(Int32 location, Int32 count, bool transpose, Double* value);
        [Slot(2174)]
        static extern unsafe void glUniformMatrix2fv(Int32 location, Int32 count, bool transpose, Single* value);
        [Slot(2176)]
        static extern unsafe void glUniformMatrix2x3dv(Int32 location, Int32 count, bool transpose, Double* value);
        [Slot(2177)]
        static extern unsafe void glUniformMatrix2x3fv(Int32 location, Int32 count, bool transpose, Single* value);
        [Slot(2178)]
        static extern unsafe void glUniformMatrix2x4dv(Int32 location, Int32 count, bool transpose, Double* value);
        [Slot(2179)]
        static extern unsafe void glUniformMatrix2x4fv(Int32 location, Int32 count, bool transpose, Single* value);
        [Slot(2180)]
        static extern unsafe void glUniformMatrix3dv(Int32 location, Int32 count, bool transpose, Double* value);
        [Slot(2181)]
        static extern unsafe void glUniformMatrix3fv(Int32 location, Int32 count, bool transpose, Single* value);
        [Slot(2183)]
        static extern unsafe void glUniformMatrix3x2dv(Int32 location, Int32 count, bool transpose, Double* value);
        [Slot(2184)]
        static extern unsafe void glUniformMatrix3x2fv(Int32 location, Int32 count, bool transpose, Single* value);
        [Slot(2185)]
        static extern unsafe void glUniformMatrix3x4dv(Int32 location, Int32 count, bool transpose, Double* value);
        [Slot(2186)]
        static extern unsafe void glUniformMatrix3x4fv(Int32 location, Int32 count, bool transpose, Single* value);
        [Slot(2187)]
        static extern unsafe void glUniformMatrix4dv(Int32 location, Int32 count, bool transpose, Double* value);
        [Slot(2188)]
        static extern unsafe void glUniformMatrix4fv(Int32 location, Int32 count, bool transpose, Single* value);
        [Slot(2190)]
        static extern unsafe void glUniformMatrix4x2dv(Int32 location, Int32 count, bool transpose, Double* value);
        [Slot(2191)]
        static extern unsafe void glUniformMatrix4x2fv(Int32 location, Int32 count, bool transpose, Single* value);
        [Slot(2192)]
        static extern unsafe void glUniformMatrix4x3dv(Int32 location, Int32 count, bool transpose, Double* value);
        [Slot(2193)]
        static extern unsafe void glUniformMatrix4x3fv(Int32 location, Int32 count, bool transpose, Single* value);
        [Slot(2194)]
        static extern unsafe void glUniformSubroutinesuiv(OpenTK.Graphics.OpenGL.ShaderType shadertype, Int32 count, UInt32* indices);
        [Slot(2198)]
        static extern bool glUnmapBuffer(OpenTK.Graphics.OpenGL.BufferTarget target);
        [Slot(2204)]
        static extern void glUseProgram(UInt32 program);
        [Slot(2206)]
        static extern void glUseProgramStages(UInt32 pipeline, OpenTK.Graphics.OpenGL.ProgramStageMask stages, UInt32 program);
        [Slot(2209)]
        static extern void glValidateProgram(UInt32 program);
        [Slot(2211)]
        static extern void glValidateProgramPipeline(UInt32 pipeline);
        [Slot(2235)]
        static extern void glVertex2d(Double x, Double y);
        [Slot(2236)]
        static extern unsafe void glVertex2dv(Double* v);
        [Slot(2237)]
        static extern void glVertex2f(Single x, Single y);
        [Slot(2238)]
        static extern unsafe void glVertex2fv(Single* v);
        [Slot(2241)]
        static extern void glVertex2i(Int32 x, Int32 y);
        [Slot(2242)]
        static extern unsafe void glVertex2iv(Int32* v);
        [Slot(2243)]
        static extern void glVertex2s(Int16 x, Int16 y);
        [Slot(2244)]
        static extern unsafe void glVertex2sv(Int16* v);
        [Slot(2249)]
        static extern void glVertex3d(Double x, Double y, Double z);
        [Slot(2250)]
        static extern unsafe void glVertex3dv(Double* v);
        [Slot(2251)]
        static extern void glVertex3f(Single x, Single y, Single z);
        [Slot(2252)]
        static extern unsafe void glVertex3fv(Single* v);
        [Slot(2255)]
        static extern void glVertex3i(Int32 x, Int32 y, Int32 z);
        [Slot(2256)]
        static extern unsafe void glVertex3iv(Int32* v);
        [Slot(2257)]
        static extern void glVertex3s(Int16 x, Int16 y, Int16 z);
        [Slot(2258)]
        static extern unsafe void glVertex3sv(Int16* v);
        [Slot(2263)]
        static extern void glVertex4d(Double x, Double y, Double z, Double w);
        [Slot(2264)]
        static extern unsafe void glVertex4dv(Double* v);
        [Slot(2265)]
        static extern void glVertex4f(Single x, Single y, Single z, Single w);
        [Slot(2266)]
        static extern unsafe void glVertex4fv(Single* v);
        [Slot(2269)]
        static extern void glVertex4i(Int32 x, Int32 y, Int32 z, Int32 w);
        [Slot(2270)]
        static extern unsafe void glVertex4iv(Int32* v);
        [Slot(2271)]
        static extern void glVertex4s(Int16 x, Int16 y, Int16 z, Int16 w);
        [Slot(2272)]
        static extern unsafe void glVertex4sv(Int16* v);
        [Slot(2297)]
        static extern void glVertexAttrib1d(UInt32 index, Double x);
        [Slot(2300)]
        static extern unsafe void glVertexAttrib1dv(UInt32 index, Double* v);
        [Slot(2303)]
        static extern void glVertexAttrib1f(UInt32 index, Single x);
        [Slot(2306)]
        static extern unsafe void glVertexAttrib1fv(UInt32 index, Single* v);
        [Slot(2311)]
        static extern void glVertexAttrib1s(UInt32 index, Int16 x);
        [Slot(2314)]
        static extern unsafe void glVertexAttrib1sv(UInt32 index, Int16* v);
        [Slot(2317)]
        static extern void glVertexAttrib2d(UInt32 index, Double x, Double y);
        [Slot(2320)]
        static extern unsafe void glVertexAttrib2dv(UInt32 index, Double* v);
        [Slot(2323)]
        static extern void glVertexAttrib2f(UInt32 index, Single x, Single y);
        [Slot(2326)]
        static extern unsafe void glVertexAttrib2fv(UInt32 index, Single* v);
        [Slot(2331)]
        static extern void glVertexAttrib2s(UInt32 index, Int16 x, Int16 y);
        [Slot(2334)]
        static extern unsafe void glVertexAttrib2sv(UInt32 index, Int16* v);
        [Slot(2337)]
        static extern void glVertexAttrib3d(UInt32 index, Double x, Double y, Double z);
        [Slot(2340)]
        static extern unsafe void glVertexAttrib3dv(UInt32 index, Double* v);
        [Slot(2343)]
        static extern void glVertexAttrib3f(UInt32 index, Single x, Single y, Single z);
        [Slot(2346)]
        static extern unsafe void glVertexAttrib3fv(UInt32 index, Single* v);
        [Slot(2351)]
        static extern void glVertexAttrib3s(UInt32 index, Int16 x, Int16 y, Int16 z);
        [Slot(2354)]
        static extern unsafe void glVertexAttrib3sv(UInt32 index, Int16* v);
        [Slot(2357)]
        static extern unsafe void glVertexAttrib4bv(UInt32 index, SByte* v);
        [Slot(2359)]
        static extern void glVertexAttrib4d(UInt32 index, Double x, Double y, Double z, Double w);
        [Slot(2362)]
        static extern unsafe void glVertexAttrib4dv(UInt32 index, Double* v);
        [Slot(2365)]
        static extern void glVertexAttrib4f(UInt32 index, Single x, Single y, Single z, Single w);
        [Slot(2368)]
        static extern unsafe void glVertexAttrib4fv(UInt32 index, Single* v);
        [Slot(2373)]
        static extern unsafe void glVertexAttrib4iv(UInt32 index, Int32* v);
        [Slot(2375)]
        static extern unsafe void glVertexAttrib4Nbv(UInt32 index, SByte* v);
        [Slot(2377)]
        static extern unsafe void glVertexAttrib4Niv(UInt32 index, Int32* v);
        [Slot(2379)]
        static extern unsafe void glVertexAttrib4Nsv(UInt32 index, Int16* v);
        [Slot(2381)]
        static extern void glVertexAttrib4Nub(UInt32 index, Byte x, Byte y, Byte z, Byte w);
        [Slot(2383)]
        static extern unsafe void glVertexAttrib4Nubv(UInt32 index, Byte* v);
        [Slot(2385)]
        static extern unsafe void glVertexAttrib4Nuiv(UInt32 index, UInt32* v);
        [Slot(2387)]
        static extern unsafe void glVertexAttrib4Nusv(UInt32 index, UInt16* v);
        [Slot(2389)]
        static extern void glVertexAttrib4s(UInt32 index, Int16 x, Int16 y, Int16 z, Int16 w);
        [Slot(2392)]
        static extern unsafe void glVertexAttrib4sv(UInt32 index, Int16* v);
        [Slot(2396)]
        static extern unsafe void glVertexAttrib4ubv(UInt32 index, Byte* v);
        [Slot(2399)]
        static extern unsafe void glVertexAttrib4uiv(UInt32 index, UInt32* v);
        [Slot(2401)]
        static extern unsafe void glVertexAttrib4usv(UInt32 index, UInt16* v);
        [Slot(2404)]
        static extern void glVertexAttribBinding(UInt32 attribindex, UInt32 bindingindex);
        [Slot(2405)]
        static extern void glVertexAttribDivisor(UInt32 index, UInt32 divisor);
        [Slot(2407)]
        static extern void glVertexAttribFormat(UInt32 attribindex, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribType type, bool normalized, UInt32 relativeoffset);
        [Slot(2409)]
        static extern void glVertexAttribI1i(UInt32 index, Int32 x);
        [Slot(2411)]
        static extern unsafe void glVertexAttribI1iv(UInt32 index, Int32* v);
        [Slot(2413)]
        static extern void glVertexAttribI1ui(UInt32 index, UInt32 x);
        [Slot(2415)]
        static extern unsafe void glVertexAttribI1uiv(UInt32 index, UInt32* v);
        [Slot(2417)]
        static extern void glVertexAttribI2i(UInt32 index, Int32 x, Int32 y);
        [Slot(2419)]
        static extern unsafe void glVertexAttribI2iv(UInt32 index, Int32* v);
        [Slot(2421)]
        static extern void glVertexAttribI2ui(UInt32 index, UInt32 x, UInt32 y);
        [Slot(2423)]
        static extern unsafe void glVertexAttribI2uiv(UInt32 index, UInt32* v);
        [Slot(2425)]
        static extern void glVertexAttribI3i(UInt32 index, Int32 x, Int32 y, Int32 z);
        [Slot(2427)]
        static extern unsafe void glVertexAttribI3iv(UInt32 index, Int32* v);
        [Slot(2429)]
        static extern void glVertexAttribI3ui(UInt32 index, UInt32 x, UInt32 y, UInt32 z);
        [Slot(2431)]
        static extern unsafe void glVertexAttribI3uiv(UInt32 index, UInt32* v);
        [Slot(2433)]
        static extern unsafe void glVertexAttribI4bv(UInt32 index, SByte* v);
        [Slot(2435)]
        static extern void glVertexAttribI4i(UInt32 index, Int32 x, Int32 y, Int32 z, Int32 w);
        [Slot(2437)]
        static extern unsafe void glVertexAttribI4iv(UInt32 index, Int32* v);
        [Slot(2439)]
        static extern unsafe void glVertexAttribI4sv(UInt32 index, Int16* v);
        [Slot(2441)]
        static extern unsafe void glVertexAttribI4ubv(UInt32 index, Byte* v);
        [Slot(2443)]
        static extern void glVertexAttribI4ui(UInt32 index, UInt32 x, UInt32 y, UInt32 z, UInt32 w);
        [Slot(2445)]
        static extern unsafe void glVertexAttribI4uiv(UInt32 index, UInt32* v);
        [Slot(2447)]
        static extern unsafe void glVertexAttribI4usv(UInt32 index, UInt16* v);
        [Slot(2449)]
        static extern void glVertexAttribIFormat(UInt32 attribindex, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribIntegerType type, UInt32 relativeoffset);
        [Slot(2451)]
        static extern void glVertexAttribIPointer(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribIntegerType type, Int32 stride, IntPtr pointer);
        [Slot(2453)]
        static extern void glVertexAttribL1d(UInt32 index, Double x);
        [Slot(2455)]
        static extern unsafe void glVertexAttribL1dv(UInt32 index, Double* v);
        [Slot(2463)]
        static extern void glVertexAttribL2d(UInt32 index, Double x, Double y);
        [Slot(2465)]
        static extern unsafe void glVertexAttribL2dv(UInt32 index, Double* v);
        [Slot(2471)]
        static extern void glVertexAttribL3d(UInt32 index, Double x, Double y, Double z);
        [Slot(2473)]
        static extern unsafe void glVertexAttribL3dv(UInt32 index, Double* v);
        [Slot(2479)]
        static extern void glVertexAttribL4d(UInt32 index, Double x, Double y, Double z, Double w);
        [Slot(2481)]
        static extern unsafe void glVertexAttribL4dv(UInt32 index, Double* v);
        [Slot(2487)]
        static extern void glVertexAttribLFormat(UInt32 attribindex, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribDoubleType type, UInt32 relativeoffset);
        [Slot(2489)]
        static extern void glVertexAttribLPointer(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribDoubleType type, Int32 stride, IntPtr pointer);
        [Slot(2491)]
        static extern void glVertexAttribP1ui(UInt32 index, OpenTK.Graphics.OpenGL.PackedPointerType type, bool normalized, UInt32 value);
        [Slot(2492)]
        static extern unsafe void glVertexAttribP1uiv(UInt32 index, OpenTK.Graphics.OpenGL.PackedPointerType type, bool normalized, UInt32* value);
        [Slot(2493)]
        static extern void glVertexAttribP2ui(UInt32 index, OpenTK.Graphics.OpenGL.PackedPointerType type, bool normalized, UInt32 value);
        [Slot(2494)]
        static extern unsafe void glVertexAttribP2uiv(UInt32 index, OpenTK.Graphics.OpenGL.PackedPointerType type, bool normalized, UInt32* value);
        [Slot(2495)]
        static extern void glVertexAttribP3ui(UInt32 index, OpenTK.Graphics.OpenGL.PackedPointerType type, bool normalized, UInt32 value);
        [Slot(2496)]
        static extern unsafe void glVertexAttribP3uiv(UInt32 index, OpenTK.Graphics.OpenGL.PackedPointerType type, bool normalized, UInt32* value);
        [Slot(2497)]
        static extern void glVertexAttribP4ui(UInt32 index, OpenTK.Graphics.OpenGL.PackedPointerType type, bool normalized, UInt32 value);
        [Slot(2498)]
        static extern unsafe void glVertexAttribP4uiv(UInt32 index, OpenTK.Graphics.OpenGL.PackedPointerType type, bool normalized, UInt32* value);
        [Slot(2500)]
        static extern void glVertexAttribPointer(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribPointerType type, bool normalized, Int32 stride, IntPtr pointer);
        [Slot(2520)]
        static extern void glVertexBindingDivisor(UInt32 bindingindex, UInt32 divisor);
        [Slot(2525)]
        static extern void glVertexP2ui(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32 value);
        [Slot(2526)]
        static extern unsafe void glVertexP2uiv(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32* value);
        [Slot(2527)]
        static extern void glVertexP3ui(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32 value);
        [Slot(2528)]
        static extern unsafe void glVertexP3uiv(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32* value);
        [Slot(2529)]
        static extern void glVertexP4ui(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32 value);
        [Slot(2530)]
        static extern unsafe void glVertexP4uiv(OpenTK.Graphics.OpenGL.PackedPointerType type, UInt32* value);
        [Slot(2531)]
        static extern void glVertexPointer(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, Int32 stride, IntPtr pointer);
        [Slot(2576)]
        static extern void glViewport(Int32 x, Int32 y, Int32 width, Int32 height);
        [Slot(2577)]
        static extern unsafe void glViewportArrayv(UInt32 first, Int32 count, Single* v);
        [Slot(2578)]
        static extern void glViewportIndexedf(UInt32 index, Single x, Single y, Single w, Single h);
        [Slot(2579)]
        static extern unsafe void glViewportIndexedfv(UInt32 index, Single* v);
        [Slot(2580)]
        static extern OpenTK.Graphics.OpenGL.WaitSyncStatus glWaitSync(IntPtr sync, OpenTK.Graphics.OpenGL.WaitSyncFlags flags, UInt64 timeout);
        [Slot(2591)]
        static extern void glWindowPos2d(Double x, Double y);
        [Slot(2594)]
        static extern unsafe void glWindowPos2dv(Double* v);
        [Slot(2597)]
        static extern void glWindowPos2f(Single x, Single y);
        [Slot(2600)]
        static extern unsafe void glWindowPos2fv(Single* v);
        [Slot(2603)]
        static extern void glWindowPos2i(Int32 x, Int32 y);
        [Slot(2606)]
        static extern unsafe void glWindowPos2iv(Int32* v);
        [Slot(2609)]
        static extern void glWindowPos2s(Int16 x, Int16 y);
        [Slot(2612)]
        static extern unsafe void glWindowPos2sv(Int16* v);
        [Slot(2615)]
        static extern void glWindowPos3d(Double x, Double y, Double z);
        [Slot(2618)]
        static extern unsafe void glWindowPos3dv(Double* v);
        [Slot(2621)]
        static extern void glWindowPos3f(Single x, Single y, Single z);
        [Slot(2624)]
        static extern unsafe void glWindowPos3fv(Single* v);
        [Slot(2627)]
        static extern void glWindowPos3i(Int32 x, Int32 y, Int32 z);
        [Slot(2630)]
        static extern unsafe void glWindowPos3iv(Int32* v);
        [Slot(2633)]
        static extern void glWindowPos3s(Int16 x, Int16 y, Int16 z);
        [Slot(2636)]
        static extern unsafe void glWindowPos3sv(Int16* v);
        [Slot(2)]
        static extern void glActiveProgramEXT(UInt32 program);
        [Slot(4)]
        static extern void glActiveShaderProgramEXT(UInt32 pipeline, UInt32 program);
        [Slot(5)]
        static extern void glActiveStencilFaceEXT(OpenTK.Graphics.OpenGL.ExtStencilTwoSide face);
        [Slot(14)]
        static extern void glApplyTextureEXT(OpenTK.Graphics.OpenGL.ExtLightTexture mode);
        [Slot(17)]
        static extern unsafe bool glAreTexturesResidentEXT(Int32 n, UInt32* textures, [OutAttribute] bool* residences);
        [Slot(19)]
        static extern void glArrayElementEXT(Int32 i);
        [Slot(35)]
        static extern void glBeginTransformFeedbackEXT(OpenTK.Graphics.OpenGL.ExtTransformFeedback primitiveMode);
        [Slot(37)]
        static extern void glBeginVertexShaderEXT();
        [Slot(44)]
        static extern void glBindBufferBaseEXT(OpenTK.Graphics.OpenGL.ExtTransformFeedback target, UInt32 index, UInt32 buffer);
        [Slot(46)]
        static extern void glBindBufferOffsetEXT(OpenTK.Graphics.OpenGL.ExtTransformFeedback target, UInt32 index, UInt32 buffer, IntPtr offset);
        [Slot(49)]
        static extern void glBindBufferRangeEXT(OpenTK.Graphics.OpenGL.ExtTransformFeedback target, UInt32 index, UInt32 buffer, IntPtr offset, IntPtr size);
        [Slot(54)]
        static extern void glBindFragDataLocationEXT(UInt32 program, UInt32 color, String name);
        [Slot(58)]
        static extern void glBindFramebufferEXT(OpenTK.Graphics.OpenGL.FramebufferTarget target, UInt32 framebuffer);
        [Slot(60)]
        static extern void glBindImageTextureEXT(UInt32 index, UInt32 texture, Int32 level, bool layered, Int32 layer, OpenTK.Graphics.OpenGL.ExtShaderImageLoadStore access, Int32 format);
        [Slot(62)]
        static extern Int32 glBindLightParameterEXT(OpenTK.Graphics.OpenGL.LightName light, OpenTK.Graphics.OpenGL.LightParameter value);
        [Slot(63)]
        static extern Int32 glBindMaterialParameterEXT(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter value);
        [Slot(64)]
        static extern void glBindMultiTextureEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, UInt32 texture);
        [Slot(65)]
        static extern Int32 glBindParameterEXT(OpenTK.Graphics.OpenGL.ExtVertexShader value);
        [Slot(69)]
        static extern void glBindProgramPipelineEXT(UInt32 pipeline);
        [Slot(71)]
        static extern void glBindRenderbufferEXT(OpenTK.Graphics.OpenGL.RenderbufferTarget target, UInt32 renderbuffer);
        [Slot(74)]
        static extern Int32 glBindTexGenParameterEXT(OpenTK.Graphics.OpenGL.TextureUnit unit, OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter value);
        [Slot(76)]
        static extern void glBindTextureEXT(OpenTK.Graphics.OpenGL.TextureTarget target, UInt32 texture);
        [Slot(78)]
        static extern Int32 glBindTextureUnitParameterEXT(OpenTK.Graphics.OpenGL.TextureUnit unit, OpenTK.Graphics.OpenGL.ExtVertexShader value);
        [Slot(85)]
        static extern void glBindVertexShaderEXT(UInt32 id);
        [Slot(88)]
        static extern void glBinormal3bEXT(SByte bx, SByte by, SByte bz);
        [Slot(89)]
        static extern unsafe void glBinormal3bvEXT(SByte* v);
        [Slot(90)]
        static extern void glBinormal3dEXT(Double bx, Double by, Double bz);
        [Slot(91)]
        static extern unsafe void glBinormal3dvEXT(Double* v);
        [Slot(92)]
        static extern void glBinormal3fEXT(Single bx, Single by, Single bz);
        [Slot(93)]
        static extern unsafe void glBinormal3fvEXT(Single* v);
        [Slot(94)]
        static extern void glBinormal3iEXT(Int32 bx, Int32 by, Int32 bz);
        [Slot(95)]
        static extern unsafe void glBinormal3ivEXT(Int32* v);
        [Slot(96)]
        static extern void glBinormal3sEXT(Int16 bx, Int16 by, Int16 bz);
        [Slot(97)]
        static extern unsafe void glBinormal3svEXT(Int16* v);
        [Slot(98)]
        static extern void glBinormalPointerEXT(OpenTK.Graphics.OpenGL.NormalPointerType type, Int32 stride, IntPtr pointer);
        [Slot(103)]
        static extern void glBlendColorEXT(Single red, Single green, Single blue, Single alpha);
        [Slot(106)]
        static extern void glBlendEquationEXT(OpenTK.Graphics.OpenGL.BlendEquationMode mode);
        [Slot(111)]
        static extern void glBlendEquationSeparateEXT(OpenTK.Graphics.OpenGL.ExtBlendEquationSeparate modeRGB, OpenTK.Graphics.OpenGL.ExtBlendEquationSeparate modeAlpha);
        [Slot(120)]
        static extern void glBlendFuncSeparateEXT(OpenTK.Graphics.OpenGL.ExtBlendFuncSeparate sfactorRGB, OpenTK.Graphics.OpenGL.ExtBlendFuncSeparate dfactorRGB, OpenTK.Graphics.OpenGL.ExtBlendFuncSeparate sfactorAlpha, OpenTK.Graphics.OpenGL.ExtBlendFuncSeparate dfactorAlpha);
        [Slot(127)]
        static extern void glBlitFramebufferEXT(Int32 srcX0, Int32 srcY0, Int32 srcX1, Int32 srcY1, Int32 dstX0, Int32 dstY0, Int32 dstX1, Int32 dstY1, OpenTK.Graphics.OpenGL.ClearBufferMask mask, OpenTK.Graphics.OpenGL.BlitFramebufferFilter filter);
        [Slot(138)]
        static extern OpenTK.Graphics.OpenGL.FramebufferErrorCode glCheckFramebufferStatusEXT(OpenTK.Graphics.OpenGL.FramebufferTarget target);
        [Slot(139)]
        static extern OpenTK.Graphics.OpenGL.ExtDirectStateAccess glCheckNamedFramebufferStatusEXT(UInt32 framebuffer, OpenTK.Graphics.OpenGL.FramebufferTarget target);
        [Slot(152)]
        static extern void glClearColorIiEXT(Int32 red, Int32 green, Int32 blue, Int32 alpha);
        [Slot(153)]
        static extern void glClearColorIuiEXT(UInt32 red, UInt32 green, UInt32 blue, UInt32 alpha);
        [Slot(161)]
        static extern void glClearNamedBufferDataEXT(UInt32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr data);
        [Slot(162)]
        static extern void glClearNamedBufferSubDataEXT(UInt32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr offset, IntPtr size, IntPtr data);
        [Slot(169)]
        static extern void glClientAttribDefaultEXT(OpenTK.Graphics.OpenGL.ClientAttribMask mask);
        [Slot(228)]
        static extern void glColorMaskIndexedEXT(UInt32 index, bool r, bool g, bool b, bool a);
        [Slot(235)]
        static extern void glColorPointerEXT(Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, Int32 count, IntPtr pointer);
        [Slot(239)]
        static extern void glColorSubTableEXT(OpenTK.Graphics.OpenGL.ColorTableTarget target, Int32 start, Int32 count, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr data);
        [Slot(241)]
        static extern void glColorTableEXT(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalFormat, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr table);
        [Slot(257)]
        static extern void glCompressedMultiTexImage1DEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 border, Int32 imageSize, IntPtr bits);
        [Slot(258)]
        static extern void glCompressedMultiTexImage2DEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 border, Int32 imageSize, IntPtr bits);
        [Slot(259)]
        static extern void glCompressedMultiTexImage3DEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, Int32 imageSize, IntPtr bits);
        [Slot(260)]
        static extern void glCompressedMultiTexSubImage1DEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, IntPtr bits);
        [Slot(261)]
        static extern void glCompressedMultiTexSubImage2DEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, IntPtr bits);
        [Slot(262)]
        static extern void glCompressedMultiTexSubImage3DEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, IntPtr bits);
        [Slot(275)]
        static extern void glCompressedTextureImage1DEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 border, Int32 imageSize, IntPtr bits);
        [Slot(276)]
        static extern void glCompressedTextureImage2DEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 border, Int32 imageSize, IntPtr bits);
        [Slot(277)]
        static extern void glCompressedTextureImage3DEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, Int32 imageSize, IntPtr bits);
        [Slot(278)]
        static extern void glCompressedTextureSubImage1DEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, IntPtr bits);
        [Slot(279)]
        static extern void glCompressedTextureSubImage2DEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, IntPtr bits);
        [Slot(280)]
        static extern void glCompressedTextureSubImage3DEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, Int32 imageSize, IntPtr bits);
        [Slot(282)]
        static extern void glConvolutionFilter1DEXT(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr image);
        [Slot(284)]
        static extern void glConvolutionFilter2DEXT(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr image);
        [Slot(286)]
        static extern void glConvolutionParameterfEXT(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.ExtConvolution pname, Single @params);
        [Slot(288)]
        static extern unsafe void glConvolutionParameterfvEXT(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.ExtConvolution pname, Single* @params);
        [Slot(290)]
        static extern void glConvolutionParameteriEXT(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.ExtConvolution pname, Int32 @params);
        [Slot(292)]
        static extern unsafe void glConvolutionParameterivEXT(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.ExtConvolution pname, Int32* @params);
        [Slot(297)]
        static extern void glCopyColorSubTableEXT(OpenTK.Graphics.OpenGL.ColorTableTarget target, Int32 start, Int32 x, Int32 y, Int32 width);
        [Slot(301)]
        static extern void glCopyConvolutionFilter1DEXT(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 x, Int32 y, Int32 width);
        [Slot(303)]
        static extern void glCopyConvolutionFilter2DEXT(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 x, Int32 y, Int32 width, Int32 height);
        [Slot(306)]
        static extern void glCopyMultiTexImage1DEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 x, Int32 y, Int32 width, Int32 border);
        [Slot(307)]
        static extern void glCopyMultiTexImage2DEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 x, Int32 y, Int32 width, Int32 height, Int32 border);
        [Slot(308)]
        static extern void glCopyMultiTexSubImage1DEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 x, Int32 y, Int32 width);
        [Slot(309)]
        static extern void glCopyMultiTexSubImage2DEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 x, Int32 y, Int32 width, Int32 height);
        [Slot(310)]
        static extern void glCopyMultiTexSubImage3DEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 x, Int32 y, Int32 width, Int32 height);
        [Slot(314)]
        static extern void glCopyTexImage1DEXT(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 x, Int32 y, Int32 width, Int32 border);
        [Slot(316)]
        static extern void glCopyTexImage2DEXT(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 x, Int32 y, Int32 width, Int32 height, Int32 border);
        [Slot(318)]
        static extern void glCopyTexSubImage1DEXT(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 x, Int32 y, Int32 width);
        [Slot(320)]
        static extern void glCopyTexSubImage2DEXT(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 x, Int32 y, Int32 width, Int32 height);
        [Slot(322)]
        static extern void glCopyTexSubImage3DEXT(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 x, Int32 y, Int32 width, Int32 height);
        [Slot(323)]
        static extern void glCopyTextureImage1DEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 x, Int32 y, Int32 width, Int32 border);
        [Slot(324)]
        static extern void glCopyTextureImage2DEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 x, Int32 y, Int32 width, Int32 height, Int32 border);
        [Slot(325)]
        static extern void glCopyTextureSubImage1DEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 x, Int32 y, Int32 width);
        [Slot(326)]
        static extern void glCopyTextureSubImage2DEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 x, Int32 y, Int32 width, Int32 height);
        [Slot(327)]
        static extern void glCopyTextureSubImage3DEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 x, Int32 y, Int32 width, Int32 height);
        [Slot(336)]
        static extern Int32 glCreateShaderProgramEXT(OpenTK.Graphics.OpenGL.ExtSeparateShaderObjects type, String @string);
        [Slot(338)]
        static extern Int32 glCreateShaderProgramvEXT(OpenTK.Graphics.OpenGL.ExtSeparateShaderObjects type, Int32 count, String[] strings);
        [Slot(341)]
        static extern unsafe void glCullParameterdvEXT(OpenTK.Graphics.OpenGL.ExtCullVertex pname, [OutAttribute] Double* @params);
        [Slot(342)]
        static extern unsafe void glCullParameterfvEXT(OpenTK.Graphics.OpenGL.ExtCullVertex pname, [OutAttribute] Single* @params);
        [Slot(366)]
        static extern unsafe void glDeleteFramebuffersEXT(Int32 n, UInt32* framebuffers);
        [Slot(376)]
        static extern unsafe void glDeleteProgramPipelinesEXT(Int32 n, UInt32* pipelines);
        [Slot(382)]
        static extern unsafe void glDeleteRenderbuffersEXT(Int32 n, UInt32* renderbuffers);
        [Slot(387)]
        static extern unsafe void glDeleteTexturesEXT(Int32 n, UInt32* textures);
        [Slot(392)]
        static extern void glDeleteVertexShaderEXT(UInt32 id);
        [Slot(394)]
        static extern void glDepthBoundsEXT(Double zmin, Double zmax);
        [Slot(409)]
        static extern void glDisableClientStateiEXT(OpenTK.Graphics.OpenGL.ArrayCap array, UInt32 index);
        [Slot(410)]
        static extern void glDisableClientStateIndexedEXT(OpenTK.Graphics.OpenGL.ArrayCap array, UInt32 index);
        [Slot(412)]
        static extern void glDisableIndexedEXT(OpenTK.Graphics.OpenGL.IndexedEnableCap target, UInt32 index);
        [Slot(413)]
        static extern void glDisableVariantClientStateEXT(UInt32 id);
        [Slot(414)]
        static extern void glDisableVertexArrayAttribEXT(UInt32 vaobj, UInt32 index);
        [Slot(415)]
        static extern void glDisableVertexArrayEXT(UInt32 vaobj, OpenTK.Graphics.OpenGL.EnableCap array);
        [Slot(423)]
        static extern void glDrawArraysEXT(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 first, Int32 count);
        [Slot(428)]
        static extern void glDrawArraysInstancedEXT(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 start, Int32 count, Int32 primcount);
        [Slot(443)]
        static extern void glDrawElementsInstancedEXT(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 primcount);
        [Slot(450)]
        static extern void glDrawRangeElementsEXT(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 start, UInt32 end, Int32 count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices);
        [Slot(460)]
        static extern unsafe void glEdgeFlagPointerEXT(Int32 stride, Int32 count, bool* pointer);
        [Slot(467)]
        static extern void glEnableClientStateiEXT(OpenTK.Graphics.OpenGL.ArrayCap array, UInt32 index);
        [Slot(468)]
        static extern void glEnableClientStateIndexedEXT(OpenTK.Graphics.OpenGL.ArrayCap array, UInt32 index);
        [Slot(470)]
        static extern void glEnableIndexedEXT(OpenTK.Graphics.OpenGL.IndexedEnableCap target, UInt32 index);
        [Slot(471)]
        static extern void glEnableVariantClientStateEXT(UInt32 id);
        [Slot(472)]
        static extern void glEnableVertexArrayAttribEXT(UInt32 vaobj, UInt32 index);
        [Slot(473)]
        static extern void glEnableVertexArrayEXT(UInt32 vaobj, OpenTK.Graphics.OpenGL.EnableCap array);
        [Slot(489)]
        static extern void glEndTransformFeedbackEXT();
        [Slot(491)]
        static extern void glEndVertexShaderEXT();
        [Slot(511)]
        static extern void glExtractComponentEXT(UInt32 res, UInt32 src, UInt32 num);
        [Slot(525)]
        static extern void glFlushMappedNamedBufferRangeEXT(UInt32 buffer, IntPtr offset, IntPtr length);
        [Slot(532)]
        static extern void glFogCoorddEXT(Double coord);
        [Slot(534)]
        static extern unsafe void glFogCoorddvEXT(Double* coord);
        [Slot(536)]
        static extern void glFogCoordfEXT(Single coord);
        [Slot(539)]
        static extern unsafe void glFogCoordfvEXT(Single* coord);
        [Slot(543)]
        static extern void glFogCoordPointerEXT(OpenTK.Graphics.OpenGL.ExtFogCoord type, Int32 stride, IntPtr pointer);
        [Slot(565)]
        static extern void glFramebufferDrawBufferEXT(UInt32 framebuffer, OpenTK.Graphics.OpenGL.DrawBufferMode mode);
        [Slot(566)]
        static extern unsafe void glFramebufferDrawBuffersEXT(UInt32 framebuffer, Int32 n, OpenTK.Graphics.OpenGL.DrawBufferMode* bufs);
        [Slot(568)]
        static extern void glFramebufferReadBufferEXT(UInt32 framebuffer, OpenTK.Graphics.OpenGL.ReadBufferMode mode);
        [Slot(570)]
        static extern void glFramebufferRenderbufferEXT(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.RenderbufferTarget renderbuffertarget, UInt32 renderbuffer);
        [Slot(573)]
        static extern void glFramebufferTexture1DEXT(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.TextureTarget textarget, UInt32 texture, Int32 level);
        [Slot(575)]
        static extern void glFramebufferTexture2DEXT(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.TextureTarget textarget, UInt32 texture, Int32 level);
        [Slot(577)]
        static extern void glFramebufferTexture3DEXT(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.TextureTarget textarget, UInt32 texture, Int32 level, Int32 zoffset);
        [Slot(579)]
        static extern void glFramebufferTextureEXT(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, UInt32 texture, Int32 level);
        [Slot(581)]
        static extern void glFramebufferTextureFaceEXT(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, UInt32 texture, Int32 level, OpenTK.Graphics.OpenGL.TextureTarget face);
        [Slot(584)]
        static extern void glFramebufferTextureLayerEXT(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, UInt32 texture, Int32 level, Int32 layer);
        [Slot(596)]
        static extern void glGenerateMipmapEXT(OpenTK.Graphics.OpenGL.GenerateMipmapTarget target);
        [Slot(597)]
        static extern void glGenerateMultiTexMipmapEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target);
        [Slot(598)]
        static extern void glGenerateTextureMipmapEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target);
        [Slot(603)]
        static extern unsafe void glGenFramebuffersEXT(Int32 n, [OutAttribute] UInt32* framebuffers);
        [Slot(610)]
        static extern unsafe void glGenProgramPipelinesEXT(Int32 n, [OutAttribute] UInt32* pipelines);
        [Slot(616)]
        static extern unsafe void glGenRenderbuffersEXT(Int32 n, [OutAttribute] UInt32* renderbuffers);
        [Slot(618)]
        static extern Int32 glGenSymbolsEXT(OpenTK.Graphics.OpenGL.ExtVertexShader datatype, OpenTK.Graphics.OpenGL.ExtVertexShader storagetype, OpenTK.Graphics.OpenGL.ExtVertexShader range, UInt32 components);
        [Slot(620)]
        static extern unsafe void glGenTexturesEXT(Int32 n, [OutAttribute] UInt32* textures);
        [Slot(625)]
        static extern Int32 glGenVertexShadersEXT(UInt32 range);
        [Slot(646)]
        static extern unsafe void glGetBooleanIndexedvEXT(OpenTK.Graphics.OpenGL.All target, UInt32 index, [OutAttribute] bool* data);
        [Slot(660)]
        static extern void glGetColorTableEXT(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [OutAttribute] IntPtr data);
        [Slot(662)]
        static extern unsafe void glGetColorTableParameterfvEXT(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.GetColorTableParameterPName pname, [OutAttribute] Single* @params);
        [Slot(665)]
        static extern unsafe void glGetColorTableParameterivEXT(OpenTK.Graphics.OpenGL.ColorTableTarget target, OpenTK.Graphics.OpenGL.GetColorTableParameterPName pname, [OutAttribute] Int32* @params);
        [Slot(673)]
        static extern void glGetCompressedMultiTexImageEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 lod, [OutAttribute] IntPtr img);
        [Slot(676)]
        static extern void glGetCompressedTextureImageEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 lod, [OutAttribute] IntPtr img);
        [Slot(678)]
        static extern void glGetConvolutionFilterEXT(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [OutAttribute] IntPtr image);
        [Slot(680)]
        static extern unsafe void glGetConvolutionParameterfvEXT(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.ExtConvolution pname, [OutAttribute] Single* @params);
        [Slot(682)]
        static extern unsafe void glGetConvolutionParameterivEXT(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.ExtConvolution pname, [OutAttribute] Int32* @params);
        [Slot(690)]
        static extern unsafe void glGetDoublei_vEXT(OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, UInt32 index, [OutAttribute] Double* @params);
        [Slot(691)]
        static extern unsafe void glGetDoubleIndexedvEXT(OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, [OutAttribute] Double* data);
        [Slot(699)]
        static extern unsafe void glGetFloati_vEXT(OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, UInt32 index, [OutAttribute] Single* @params);
        [Slot(700)]
        static extern unsafe void glGetFloatIndexedvEXT(OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, [OutAttribute] Single* data);
        [Slot(705)]
        static extern Int32 glGetFragDataLocationEXT(UInt32 program, String name);
        [Slot(711)]
        static extern unsafe void glGetFramebufferAttachmentParameterivEXT(OpenTK.Graphics.OpenGL.FramebufferTarget target, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.FramebufferParameterName pname, [OutAttribute] Int32* @params);
        [Slot(713)]
        static extern unsafe void glGetFramebufferParameterivEXT(UInt32 framebuffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] Int32* @params);
        [Slot(717)]
        static extern void glGetHistogramEXT(OpenTK.Graphics.OpenGL.ExtHistogram target, bool reset, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [OutAttribute] IntPtr values);
        [Slot(719)]
        static extern unsafe void glGetHistogramParameterfvEXT(OpenTK.Graphics.OpenGL.ExtHistogram target, OpenTK.Graphics.OpenGL.ExtHistogram pname, [OutAttribute] Single* @params);
        [Slot(721)]
        static extern unsafe void glGetHistogramParameterivEXT(OpenTK.Graphics.OpenGL.ExtHistogram target, OpenTK.Graphics.OpenGL.ExtHistogram pname, [OutAttribute] Int32* @params);
        [Slot(732)]
        static extern unsafe void glGetIntegerIndexedvEXT(OpenTK.Graphics.OpenGL.GetIndexedPName target, UInt32 index, [OutAttribute] Int32* data);
        [Slot(738)]
        static extern unsafe void glGetInvariantBooleanvEXT(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] bool* data);
        [Slot(739)]
        static extern unsafe void glGetInvariantFloatvEXT(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] Single* data);
        [Slot(740)]
        static extern unsafe void glGetInvariantIntegervEXT(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] Int32* data);
        [Slot(747)]
        static extern unsafe void glGetLocalConstantBooleanvEXT(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] bool* data);
        [Slot(748)]
        static extern unsafe void glGetLocalConstantFloatvEXT(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] Single* data);
        [Slot(749)]
        static extern unsafe void glGetLocalConstantIntegervEXT(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] Int32* data);
        [Slot(764)]
        static extern void glGetMinmaxEXT(OpenTK.Graphics.OpenGL.ExtHistogram target, bool reset, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [OutAttribute] IntPtr values);
        [Slot(766)]
        static extern unsafe void glGetMinmaxParameterfvEXT(OpenTK.Graphics.OpenGL.ExtHistogram target, OpenTK.Graphics.OpenGL.ExtHistogram pname, [OutAttribute] Single* @params);
        [Slot(768)]
        static extern unsafe void glGetMinmaxParameterivEXT(OpenTK.Graphics.OpenGL.ExtHistogram target, OpenTK.Graphics.OpenGL.ExtHistogram pname, [OutAttribute] Int32* @params);
        [Slot(771)]
        static extern unsafe void glGetMultiTexEnvfvEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, [OutAttribute] Single* @params);
        [Slot(772)]
        static extern unsafe void glGetMultiTexEnvivEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, [OutAttribute] Int32* @params);
        [Slot(773)]
        static extern unsafe void glGetMultiTexGendvEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, [OutAttribute] Double* @params);
        [Slot(774)]
        static extern unsafe void glGetMultiTexGenfvEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, [OutAttribute] Single* @params);
        [Slot(775)]
        static extern unsafe void glGetMultiTexGenivEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, [OutAttribute] Int32* @params);
        [Slot(776)]
        static extern void glGetMultiTexImageEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [OutAttribute] IntPtr pixels);
        [Slot(777)]
        static extern unsafe void glGetMultiTexLevelParameterfvEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Single* @params);
        [Slot(778)]
        static extern unsafe void glGetMultiTexLevelParameterivEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32* @params);
        [Slot(779)]
        static extern unsafe void glGetMultiTexParameterfvEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Single* @params);
        [Slot(780)]
        static extern unsafe void glGetMultiTexParameterIivEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32* @params);
        [Slot(781)]
        static extern unsafe void glGetMultiTexParameterIuivEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] UInt32* @params);
        [Slot(782)]
        static extern unsafe void glGetMultiTexParameterivEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32* @params);
        [Slot(783)]
        static extern unsafe void glGetNamedBufferParameterivEXT(UInt32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] Int32* @params);
        [Slot(785)]
        static extern void glGetNamedBufferPointervEXT(UInt32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] IntPtr @params);
        [Slot(786)]
        static extern void glGetNamedBufferSubDataEXT(UInt32 buffer, IntPtr offset, IntPtr size, [OutAttribute] IntPtr data);
        [Slot(787)]
        static extern unsafe void glGetNamedFramebufferAttachmentParameterivEXT(UInt32 framebuffer, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] Int32* @params);
        [Slot(788)]
        static extern unsafe void glGetNamedFramebufferParameterivEXT(UInt32 framebuffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] Int32* @params);
        [Slot(789)]
        static extern unsafe void glGetNamedProgramivEXT(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, OpenTK.Graphics.OpenGL.ProgramProperty pname, [OutAttribute] Int32* @params);
        [Slot(790)]
        static extern unsafe void glGetNamedProgramLocalParameterdvEXT(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, [OutAttribute] Double* @params);
        [Slot(791)]
        static extern unsafe void glGetNamedProgramLocalParameterfvEXT(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, [OutAttribute] Single* @params);
        [Slot(792)]
        static extern unsafe void glGetNamedProgramLocalParameterIivEXT(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, [OutAttribute] Int32* @params);
        [Slot(793)]
        static extern unsafe void glGetNamedProgramLocalParameterIuivEXT(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, [OutAttribute] UInt32* @params);
        [Slot(794)]
        static extern void glGetNamedProgramStringEXT(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] IntPtr @string);
        [Slot(795)]
        static extern unsafe void glGetNamedRenderbufferParameterivEXT(UInt32 renderbuffer, OpenTK.Graphics.OpenGL.RenderbufferParameterName pname, [OutAttribute] Int32* @params);
        [Slot(819)]
        static extern unsafe void glGetObjectLabelEXT(OpenTK.Graphics.OpenGL.ExtDebugLabel type, UInt32 @object, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder label);
        [Slot(853)]
        static extern unsafe void glGetPixelTransformParameterfvEXT(OpenTK.Graphics.OpenGL.ExtPixelTransform target, OpenTK.Graphics.OpenGL.ExtPixelTransform pname, [OutAttribute] Single* @params);
        [Slot(854)]
        static extern unsafe void glGetPixelTransformParameterivEXT(OpenTK.Graphics.OpenGL.ExtPixelTransform target, OpenTK.Graphics.OpenGL.ExtPixelTransform pname, [OutAttribute] Int32* @params);
        [Slot(855)]
        static extern void glGetPointeri_vEXT(OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, UInt32 index, [OutAttribute] IntPtr @params);
        [Slot(856)]
        static extern void glGetPointerIndexedvEXT(OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, [OutAttribute] IntPtr data);
        [Slot(858)]
        static extern void glGetPointervEXT(OpenTK.Graphics.OpenGL.GetPointervPName pname, [OutAttribute] IntPtr @params);
        [Slot(880)]
        static extern unsafe void glGetProgramPipelineInfoLogEXT(UInt32 pipeline, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder infoLog);
        [Slot(882)]
        static extern unsafe void glGetProgramPipelineivEXT(UInt32 pipeline, OpenTK.Graphics.OpenGL.ExtSeparateShaderObjects pname, [OutAttribute] Int32* @params);
        [Slot(896)]
        static extern unsafe void glGetQueryObjecti64vEXT(UInt32 id, OpenTK.Graphics.OpenGL.ExtTimerQuery pname, [OutAttribute] Int64* @params);
        [Slot(900)]
        static extern unsafe void glGetQueryObjectui64vEXT(UInt32 id, OpenTK.Graphics.OpenGL.ExtTimerQuery pname, [OutAttribute] UInt64* @params);
        [Slot(904)]
        static extern unsafe void glGetRenderbufferParameterivEXT(OpenTK.Graphics.OpenGL.RenderbufferTarget target, OpenTK.Graphics.OpenGL.RenderbufferParameterName pname, [OutAttribute] Int32* @params);
        [Slot(910)]
        static extern void glGetSeparableFilterEXT(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [OutAttribute] IntPtr row, [OutAttribute] IntPtr column, [OutAttribute] IntPtr span);
        [Slot(938)]
        static extern unsafe void glGetTexParameterIivEXT(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32* @params);
        [Slot(940)]
        static extern unsafe void glGetTexParameterIuivEXT(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] UInt32* @params);
        [Slot(946)]
        static extern void glGetTextureImageEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [OutAttribute] IntPtr pixels);
        [Slot(947)]
        static extern unsafe void glGetTextureLevelParameterfvEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Single* @params);
        [Slot(948)]
        static extern unsafe void glGetTextureLevelParameterivEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32* @params);
        [Slot(949)]
        static extern unsafe void glGetTextureParameterfvEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Single* @params);
        [Slot(950)]
        static extern unsafe void glGetTextureParameterIivEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32* @params);
        [Slot(951)]
        static extern unsafe void glGetTextureParameterIuivEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] UInt32* @params);
        [Slot(952)]
        static extern unsafe void glGetTextureParameterivEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.GetTextureParameter pname, [OutAttribute] Int32* @params);
        [Slot(957)]
        static extern unsafe void glGetTransformFeedbackVaryingEXT(UInt32 program, UInt32 index, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] Int32* size, [OutAttribute] OpenTK.Graphics.OpenGL.ExtTransformFeedback* type, [OutAttribute] StringBuilder name);
        [Slot(960)]
        static extern Int32 glGetUniformBufferSizeEXT(UInt32 program, Int32 location);
        [Slot(970)]
        static extern IntPtr glGetUniformOffsetEXT(UInt32 program, Int32 location);
        [Slot(974)]
        static extern unsafe void glGetUniformuivEXT(UInt32 program, Int32 location, [OutAttribute] UInt32* @params);
        [Slot(977)]
        static extern unsafe void glGetVariantBooleanvEXT(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] bool* data);
        [Slot(978)]
        static extern unsafe void glGetVariantFloatvEXT(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] Single* data);
        [Slot(979)]
        static extern unsafe void glGetVariantIntegervEXT(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] Int32* data);
        [Slot(980)]
        static extern void glGetVariantPointervEXT(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader value, [OutAttribute] IntPtr data);
        [Slot(982)]
        static extern unsafe void glGetVertexArrayIntegeri_vEXT(UInt32 vaobj, UInt32 index, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] Int32* param);
        [Slot(983)]
        static extern unsafe void glGetVertexArrayIntegervEXT(UInt32 vaobj, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] Int32* param);
        [Slot(984)]
        static extern void glGetVertexArrayPointeri_vEXT(UInt32 vaobj, UInt32 index, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] IntPtr param);
        [Slot(985)]
        static extern void glGetVertexArrayPointervEXT(UInt32 vaobj, OpenTK.Graphics.OpenGL.ExtDirectStateAccess pname, [OutAttribute] IntPtr param);
        [Slot(995)]
        static extern unsafe void glGetVertexAttribIivEXT(UInt32 index, OpenTK.Graphics.OpenGL.NvVertexProgram4 pname, [OutAttribute] Int32* @params);
        [Slot(997)]
        static extern unsafe void glGetVertexAttribIuivEXT(UInt32 index, OpenTK.Graphics.OpenGL.NvVertexProgram4 pname, [OutAttribute] UInt32* @params);
        [Slot(1002)]
        static extern unsafe void glGetVertexAttribLdvEXT(UInt32 index, OpenTK.Graphics.OpenGL.ExtVertexAttrib64bit pname, [OutAttribute] Double* @params);
        [Slot(1028)]
        static extern void glHistogramEXT(OpenTK.Graphics.OpenGL.ExtHistogram target, Int32 width, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, bool sink);
        [Slot(1034)]
        static extern IntPtr glImportSyncEXT(OpenTK.Graphics.OpenGL.ExtX11SyncObject external_sync_type, IntPtr external_sync, UInt32 flags);
        [Slot(1039)]
        static extern void glIndexFuncEXT(OpenTK.Graphics.OpenGL.ExtIndexFunc func, Single @ref);
        [Slot(1044)]
        static extern void glIndexMaterialEXT(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.ExtIndexMaterial mode);
        [Slot(1046)]
        static extern void glIndexPointerEXT(OpenTK.Graphics.OpenGL.IndexPointerType type, Int32 stride, Int32 count, IntPtr pointer);
        [Slot(1055)]
        static extern void glInsertComponentEXT(UInt32 res, UInt32 src, UInt32 num);
        [Slot(1056)]
        static extern void glInsertEventMarkerEXT(Int32 length, String marker);
        [Slot(1072)]
        static extern bool glIsEnabledIndexedEXT(OpenTK.Graphics.OpenGL.IndexedEnableCap target, UInt32 index);
        [Slot(1076)]
        static extern bool glIsFramebufferEXT(UInt32 framebuffer);
        [Slot(1092)]
        static extern bool glIsProgramPipelineEXT(UInt32 pipeline);
        [Slot(1096)]
        static extern bool glIsRenderbufferEXT(UInt32 renderbuffer);
        [Slot(1101)]
        static extern bool glIsTextureEXT(UInt32 texture);
        [Slot(1106)]
        static extern bool glIsVariantEnabledEXT(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader cap);
        [Slot(1110)]
        static extern void glLabelObjectEXT(OpenTK.Graphics.OpenGL.ExtDebugLabel type, UInt32 @object, Int32 length, String label);
        [Slot(1146)]
        static extern void glLockArraysEXT(Int32 first, Int32 count);
        [Slot(1176)]
        static extern IntPtr glMapNamedBufferEXT(UInt32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess access);
        [Slot(1177)]
        static extern IntPtr glMapNamedBufferRangeEXT(UInt32 buffer, IntPtr offset, IntPtr length, OpenTK.Graphics.OpenGL.BufferAccessMask access);
        [Slot(1192)]
        static extern void glMatrixFrustumEXT(OpenTK.Graphics.OpenGL.MatrixMode mode, Double left, Double right, Double bottom, Double top, Double zNear, Double zFar);
        [Slot(1197)]
        static extern unsafe void glMatrixLoaddEXT(OpenTK.Graphics.OpenGL.MatrixMode mode, Double* m);
        [Slot(1198)]
        static extern unsafe void glMatrixLoadfEXT(OpenTK.Graphics.OpenGL.MatrixMode mode, Single* m);
        [Slot(1199)]
        static extern void glMatrixLoadIdentityEXT(OpenTK.Graphics.OpenGL.MatrixMode mode);
        [Slot(1200)]
        static extern unsafe void glMatrixLoadTransposedEXT(OpenTK.Graphics.OpenGL.MatrixMode mode, Double* m);
        [Slot(1201)]
        static extern unsafe void glMatrixLoadTransposefEXT(OpenTK.Graphics.OpenGL.MatrixMode mode, Single* m);
        [Slot(1203)]
        static extern unsafe void glMatrixMultdEXT(OpenTK.Graphics.OpenGL.MatrixMode mode, Double* m);
        [Slot(1204)]
        static extern unsafe void glMatrixMultfEXT(OpenTK.Graphics.OpenGL.MatrixMode mode, Single* m);
        [Slot(1205)]
        static extern unsafe void glMatrixMultTransposedEXT(OpenTK.Graphics.OpenGL.MatrixMode mode, Double* m);
        [Slot(1206)]
        static extern unsafe void glMatrixMultTransposefEXT(OpenTK.Graphics.OpenGL.MatrixMode mode, Single* m);
        [Slot(1207)]
        static extern void glMatrixOrthoEXT(OpenTK.Graphics.OpenGL.MatrixMode mode, Double left, Double right, Double bottom, Double top, Double zNear, Double zFar);
        [Slot(1208)]
        static extern void glMatrixPopEXT(OpenTK.Graphics.OpenGL.MatrixMode mode);
        [Slot(1209)]
        static extern void glMatrixPushEXT(OpenTK.Graphics.OpenGL.MatrixMode mode);
        [Slot(1210)]
        static extern void glMatrixRotatedEXT(OpenTK.Graphics.OpenGL.MatrixMode mode, Double angle, Double x, Double y, Double z);
        [Slot(1211)]
        static extern void glMatrixRotatefEXT(OpenTK.Graphics.OpenGL.MatrixMode mode, Single angle, Single x, Single y, Single z);
        [Slot(1212)]
        static extern void glMatrixScaledEXT(OpenTK.Graphics.OpenGL.MatrixMode mode, Double x, Double y, Double z);
        [Slot(1213)]
        static extern void glMatrixScalefEXT(OpenTK.Graphics.OpenGL.MatrixMode mode, Single x, Single y, Single z);
        [Slot(1214)]
        static extern void glMatrixTranslatedEXT(OpenTK.Graphics.OpenGL.MatrixMode mode, Double x, Double y, Double z);
        [Slot(1215)]
        static extern void glMatrixTranslatefEXT(OpenTK.Graphics.OpenGL.MatrixMode mode, Single x, Single y, Single z);
        [Slot(1217)]
        static extern void glMemoryBarrierEXT(UInt32 barriers);
        [Slot(1219)]
        static extern void glMinmaxEXT(OpenTK.Graphics.OpenGL.ExtHistogram target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, bool sink);
        [Slot(1223)]
        static extern unsafe void glMultiDrawArraysEXT(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32* first, Int32* count, Int32 primcount);
        [Slot(1231)]
        static extern unsafe void glMultiDrawElementsEXT(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 primcount);
        [Slot(1239)]
        static extern void glMultiTexBufferEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, UInt32 buffer);
        [Slot(1336)]
        static extern void glMultiTexCoordPointerEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, Int32 size, OpenTK.Graphics.OpenGL.TexCoordPointerType type, Int32 stride, IntPtr pointer);
        [Slot(1337)]
        static extern void glMultiTexEnvfEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, Single param);
        [Slot(1338)]
        static extern unsafe void glMultiTexEnvfvEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, Single* @params);
        [Slot(1339)]
        static extern void glMultiTexEnviEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, Int32 param);
        [Slot(1340)]
        static extern unsafe void glMultiTexEnvivEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureEnvTarget target, OpenTK.Graphics.OpenGL.TextureEnvParameter pname, Int32* @params);
        [Slot(1341)]
        static extern void glMultiTexGendEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, Double param);
        [Slot(1342)]
        static extern unsafe void glMultiTexGendvEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, Double* @params);
        [Slot(1343)]
        static extern void glMultiTexGenfEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, Single param);
        [Slot(1344)]
        static extern unsafe void glMultiTexGenfvEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, Single* @params);
        [Slot(1345)]
        static extern void glMultiTexGeniEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, Int32 param);
        [Slot(1346)]
        static extern unsafe void glMultiTexGenivEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureCoordName coord, OpenTK.Graphics.OpenGL.TextureGenParameter pname, Int32* @params);
        [Slot(1347)]
        static extern void glMultiTexImage1DEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);
        [Slot(1348)]
        static extern void glMultiTexImage2DEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);
        [Slot(1349)]
        static extern void glMultiTexImage3DEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);
        [Slot(1350)]
        static extern void glMultiTexParameterfEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Single param);
        [Slot(1351)]
        static extern unsafe void glMultiTexParameterfvEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Single* @params);
        [Slot(1352)]
        static extern void glMultiTexParameteriEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Int32 param);
        [Slot(1353)]
        static extern unsafe void glMultiTexParameterIivEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Int32* @params);
        [Slot(1354)]
        static extern unsafe void glMultiTexParameterIuivEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, UInt32* @params);
        [Slot(1355)]
        static extern unsafe void glMultiTexParameterivEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Int32* @params);
        [Slot(1356)]
        static extern void glMultiTexRenderbufferEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, UInt32 renderbuffer);
        [Slot(1357)]
        static extern void glMultiTexSubImage1DEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);
        [Slot(1358)]
        static extern void glMultiTexSubImage2DEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);
        [Slot(1359)]
        static extern void glMultiTexSubImage3DEXT(OpenTK.Graphics.OpenGL.TextureUnit texunit, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);
        [Slot(1368)]
        static extern void glNamedBufferDataEXT(UInt32 buffer, IntPtr size, IntPtr data, OpenTK.Graphics.OpenGL.ExtDirectStateAccess usage);
        [Slot(1369)]
        static extern void glNamedBufferStorageEXT(UInt32 buffer, IntPtr size, IntPtr data, UInt32 flags);
        [Slot(1370)]
        static extern void glNamedBufferSubDataEXT(UInt32 buffer, IntPtr offset, IntPtr size, IntPtr data);
        [Slot(1371)]
        static extern void glNamedCopyBufferSubDataEXT(UInt32 readBuffer, UInt32 writeBuffer, IntPtr readOffset, IntPtr writeOffset, IntPtr size);
        [Slot(1372)]
        static extern void glNamedFramebufferParameteriEXT(UInt32 framebuffer, OpenTK.Graphics.OpenGL.FramebufferParameterName pname, Int32 param);
        [Slot(1373)]
        static extern void glNamedFramebufferRenderbufferEXT(UInt32 framebuffer, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.RenderbufferTarget renderbuffertarget, UInt32 renderbuffer);
        [Slot(1374)]
        static extern void glNamedFramebufferTexture1DEXT(UInt32 framebuffer, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.TextureTarget textarget, UInt32 texture, Int32 level);
        [Slot(1375)]
        static extern void glNamedFramebufferTexture2DEXT(UInt32 framebuffer, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.TextureTarget textarget, UInt32 texture, Int32 level);
        [Slot(1376)]
        static extern void glNamedFramebufferTexture3DEXT(UInt32 framebuffer, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, OpenTK.Graphics.OpenGL.TextureTarget textarget, UInt32 texture, Int32 level, Int32 zoffset);
        [Slot(1377)]
        static extern void glNamedFramebufferTextureEXT(UInt32 framebuffer, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, UInt32 texture, Int32 level);
        [Slot(1378)]
        static extern void glNamedFramebufferTextureFaceEXT(UInt32 framebuffer, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, UInt32 texture, Int32 level, OpenTK.Graphics.OpenGL.TextureTarget face);
        [Slot(1379)]
        static extern void glNamedFramebufferTextureLayerEXT(UInt32 framebuffer, OpenTK.Graphics.OpenGL.FramebufferAttachment attachment, UInt32 texture, Int32 level, Int32 layer);
        [Slot(1380)]
        static extern void glNamedProgramLocalParameter4dEXT(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, Double x, Double y, Double z, Double w);
        [Slot(1381)]
        static extern unsafe void glNamedProgramLocalParameter4dvEXT(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, Double* @params);
        [Slot(1382)]
        static extern void glNamedProgramLocalParameter4fEXT(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, Single x, Single y, Single z, Single w);
        [Slot(1383)]
        static extern unsafe void glNamedProgramLocalParameter4fvEXT(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, Single* @params);
        [Slot(1384)]
        static extern void glNamedProgramLocalParameterI4iEXT(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, Int32 x, Int32 y, Int32 z, Int32 w);
        [Slot(1385)]
        static extern unsafe void glNamedProgramLocalParameterI4ivEXT(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, Int32* @params);
        [Slot(1386)]
        static extern void glNamedProgramLocalParameterI4uiEXT(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, UInt32 x, UInt32 y, UInt32 z, UInt32 w);
        [Slot(1387)]
        static extern unsafe void glNamedProgramLocalParameterI4uivEXT(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, UInt32* @params);
        [Slot(1388)]
        static extern unsafe void glNamedProgramLocalParameters4fvEXT(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, Int32 count, Single* @params);
        [Slot(1389)]
        static extern unsafe void glNamedProgramLocalParametersI4ivEXT(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, Int32 count, Int32* @params);
        [Slot(1390)]
        static extern unsafe void glNamedProgramLocalParametersI4uivEXT(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, UInt32 index, Int32 count, UInt32* @params);
        [Slot(1391)]
        static extern void glNamedProgramStringEXT(UInt32 program, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, OpenTK.Graphics.OpenGL.ExtDirectStateAccess format, Int32 len, IntPtr @string);
        [Slot(1392)]
        static extern void glNamedRenderbufferStorageEXT(UInt32 renderbuffer, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height);
        [Slot(1393)]
        static extern void glNamedRenderbufferStorageMultisampleCoverageEXT(UInt32 renderbuffer, Int32 coverageSamples, Int32 colorSamples, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height);
        [Slot(1394)]
        static extern void glNamedRenderbufferStorageMultisampleEXT(UInt32 renderbuffer, Int32 samples, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height);
        [Slot(1418)]
        static extern void glNormalPointerEXT(OpenTK.Graphics.OpenGL.NormalPointerType type, Int32 stride, Int32 count, IntPtr pointer);
        [Slot(1481)]
        static extern void glPixelTransformParameterfEXT(OpenTK.Graphics.OpenGL.ExtPixelTransform target, OpenTK.Graphics.OpenGL.ExtPixelTransform pname, Single param);
        [Slot(1482)]
        static extern unsafe void glPixelTransformParameterfvEXT(OpenTK.Graphics.OpenGL.ExtPixelTransform target, OpenTK.Graphics.OpenGL.ExtPixelTransform pname, Single* @params);
        [Slot(1483)]
        static extern void glPixelTransformParameteriEXT(OpenTK.Graphics.OpenGL.ExtPixelTransform target, OpenTK.Graphics.OpenGL.ExtPixelTransform pname, Int32 param);
        [Slot(1484)]
        static extern unsafe void glPixelTransformParameterivEXT(OpenTK.Graphics.OpenGL.ExtPixelTransform target, OpenTK.Graphics.OpenGL.ExtPixelTransform pname, Int32* @params);
        [Slot(1492)]
        static extern void glPointParameterfEXT(OpenTK.Graphics.OpenGL.ExtPointParameters pname, Single param);
        [Slot(1496)]
        static extern unsafe void glPointParameterfvEXT(OpenTK.Graphics.OpenGL.ExtPointParameters pname, Single* @params);
        [Slot(1510)]
        static extern void glPolygonOffsetEXT(Single factor, Single bias);
        [Slot(1517)]
        static extern void glPopGroupMarkerEXT();
        [Slot(1526)]
        static extern unsafe void glPrioritizeTexturesEXT(Int32 n, UInt32* textures, Single* priorities);
        [Slot(1540)]
        static extern unsafe void glProgramEnvParameters4fvEXT(OpenTK.Graphics.OpenGL.ExtGpuProgramParameters target, UInt32 index, Int32 count, Single* @params);
        [Slot(1551)]
        static extern unsafe void glProgramLocalParameters4fvEXT(OpenTK.Graphics.OpenGL.ExtGpuProgramParameters target, UInt32 index, Int32 count, Single* @params);
        [Slot(1564)]
        static extern void glProgramParameteriEXT(UInt32 program, OpenTK.Graphics.OpenGL.AssemblyProgramParameterArb pname, Int32 value);
        [Slot(1570)]
        static extern void glProgramUniform1dEXT(UInt32 program, Int32 location, Double x);
        [Slot(1572)]
        static extern unsafe void glProgramUniform1dvEXT(UInt32 program, Int32 location, Int32 count, Double* value);
        [Slot(1574)]
        static extern void glProgramUniform1fEXT(UInt32 program, Int32 location, Single v0);
        [Slot(1576)]
        static extern unsafe void glProgramUniform1fvEXT(UInt32 program, Int32 location, Int32 count, Single* value);
        [Slot(1580)]
        static extern void glProgramUniform1iEXT(UInt32 program, Int32 location, Int32 v0);
        [Slot(1582)]
        static extern unsafe void glProgramUniform1ivEXT(UInt32 program, Int32 location, Int32 count, Int32* value);
        [Slot(1586)]
        static extern void glProgramUniform1uiEXT(UInt32 program, Int32 location, UInt32 v0);
        [Slot(1588)]
        static extern unsafe void glProgramUniform1uivEXT(UInt32 program, Int32 location, Int32 count, UInt32* value);
        [Slot(1590)]
        static extern void glProgramUniform2dEXT(UInt32 program, Int32 location, Double x, Double y);
        [Slot(1592)]
        static extern unsafe void glProgramUniform2dvEXT(UInt32 program, Int32 location, Int32 count, Double* value);
        [Slot(1594)]
        static extern void glProgramUniform2fEXT(UInt32 program, Int32 location, Single v0, Single v1);
        [Slot(1596)]
        static extern unsafe void glProgramUniform2fvEXT(UInt32 program, Int32 location, Int32 count, Single* value);
        [Slot(1600)]
        static extern void glProgramUniform2iEXT(UInt32 program, Int32 location, Int32 v0, Int32 v1);
        [Slot(1602)]
        static extern unsafe void glProgramUniform2ivEXT(UInt32 program, Int32 location, Int32 count, Int32* value);
        [Slot(1606)]
        static extern void glProgramUniform2uiEXT(UInt32 program, Int32 location, UInt32 v0, UInt32 v1);
        [Slot(1608)]
        static extern unsafe void glProgramUniform2uivEXT(UInt32 program, Int32 location, Int32 count, UInt32* value);
        [Slot(1610)]
        static extern void glProgramUniform3dEXT(UInt32 program, Int32 location, Double x, Double y, Double z);
        [Slot(1612)]
        static extern unsafe void glProgramUniform3dvEXT(UInt32 program, Int32 location, Int32 count, Double* value);
        [Slot(1614)]
        static extern void glProgramUniform3fEXT(UInt32 program, Int32 location, Single v0, Single v1, Single v2);
        [Slot(1616)]
        static extern unsafe void glProgramUniform3fvEXT(UInt32 program, Int32 location, Int32 count, Single* value);
        [Slot(1620)]
        static extern void glProgramUniform3iEXT(UInt32 program, Int32 location, Int32 v0, Int32 v1, Int32 v2);
        [Slot(1622)]
        static extern unsafe void glProgramUniform3ivEXT(UInt32 program, Int32 location, Int32 count, Int32* value);
        [Slot(1626)]
        static extern void glProgramUniform3uiEXT(UInt32 program, Int32 location, UInt32 v0, UInt32 v1, UInt32 v2);
        [Slot(1628)]
        static extern unsafe void glProgramUniform3uivEXT(UInt32 program, Int32 location, Int32 count, UInt32* value);
        [Slot(1630)]
        static extern void glProgramUniform4dEXT(UInt32 program, Int32 location, Double x, Double y, Double z, Double w);
        [Slot(1632)]
        static extern unsafe void glProgramUniform4dvEXT(UInt32 program, Int32 location, Int32 count, Double* value);
        [Slot(1634)]
        static extern void glProgramUniform4fEXT(UInt32 program, Int32 location, Single v0, Single v1, Single v2, Single v3);
        [Slot(1636)]
        static extern unsafe void glProgramUniform4fvEXT(UInt32 program, Int32 location, Int32 count, Single* value);
        [Slot(1640)]
        static extern void glProgramUniform4iEXT(UInt32 program, Int32 location, Int32 v0, Int32 v1, Int32 v2, Int32 v3);
        [Slot(1642)]
        static extern unsafe void glProgramUniform4ivEXT(UInt32 program, Int32 location, Int32 count, Int32* value);
        [Slot(1646)]
        static extern void glProgramUniform4uiEXT(UInt32 program, Int32 location, UInt32 v0, UInt32 v1, UInt32 v2, UInt32 v3);
        [Slot(1648)]
        static extern unsafe void glProgramUniform4uivEXT(UInt32 program, Int32 location, Int32 count, UInt32* value);
        [Slot(1654)]
        static extern unsafe void glProgramUniformMatrix2dvEXT(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);
        [Slot(1656)]
        static extern unsafe void glProgramUniformMatrix2fvEXT(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);
        [Slot(1658)]
        static extern unsafe void glProgramUniformMatrix2x3dvEXT(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);
        [Slot(1660)]
        static extern unsafe void glProgramUniformMatrix2x3fvEXT(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);
        [Slot(1662)]
        static extern unsafe void glProgramUniformMatrix2x4dvEXT(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);
        [Slot(1664)]
        static extern unsafe void glProgramUniformMatrix2x4fvEXT(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);
        [Slot(1666)]
        static extern unsafe void glProgramUniformMatrix3dvEXT(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);
        [Slot(1668)]
        static extern unsafe void glProgramUniformMatrix3fvEXT(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);
        [Slot(1670)]
        static extern unsafe void glProgramUniformMatrix3x2dvEXT(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);
        [Slot(1672)]
        static extern unsafe void glProgramUniformMatrix3x2fvEXT(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);
        [Slot(1674)]
        static extern unsafe void glProgramUniformMatrix3x4dvEXT(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);
        [Slot(1676)]
        static extern unsafe void glProgramUniformMatrix3x4fvEXT(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);
        [Slot(1678)]
        static extern unsafe void glProgramUniformMatrix4dvEXT(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);
        [Slot(1680)]
        static extern unsafe void glProgramUniformMatrix4fvEXT(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);
        [Slot(1682)]
        static extern unsafe void glProgramUniformMatrix4x2dvEXT(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);
        [Slot(1684)]
        static extern unsafe void glProgramUniformMatrix4x2fvEXT(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);
        [Slot(1686)]
        static extern unsafe void glProgramUniformMatrix4x3dvEXT(UInt32 program, Int32 location, Int32 count, bool transpose, Double* value);
        [Slot(1688)]
        static extern unsafe void glProgramUniformMatrix4x3fvEXT(UInt32 program, Int32 location, Int32 count, bool transpose, Single* value);
        [Slot(1693)]
        static extern void glProvokingVertexEXT(OpenTK.Graphics.OpenGL.ExtProvokingVertex mode);
        [Slot(1696)]
        static extern void glPushClientAttribDefaultEXT(OpenTK.Graphics.OpenGL.ClientAttribMask mask);
        [Slot(1699)]
        static extern void glPushGroupMarkerEXT(Int32 length, String marker);
        [Slot(1751)]
        static extern void glRenderbufferStorageEXT(OpenTK.Graphics.OpenGL.RenderbufferTarget target, OpenTK.Graphics.OpenGL.RenderbufferStorage internalformat, Int32 width, Int32 height);
        [Slot(1754)]
        static extern void glRenderbufferStorageMultisampleEXT(OpenTK.Graphics.OpenGL.RenderbufferTarget target, Int32 samples, OpenTK.Graphics.OpenGL.RenderbufferStorage internalformat, Int32 width, Int32 height);
        [Slot(1781)]
        static extern void glResetHistogramEXT(OpenTK.Graphics.OpenGL.ExtHistogram target);
        [Slot(1783)]
        static extern void glResetMinmaxEXT(OpenTK.Graphics.OpenGL.ExtHistogram target);
        [Slot(1795)]
        static extern void glSampleMaskEXT(Single value, bool invert);
        [Slot(1799)]
        static extern void glSamplePatternEXT(OpenTK.Graphics.OpenGL.ExtMultisample pattern);
        [Slot(1815)]
        static extern void glSecondaryColor3bEXT(SByte red, SByte green, SByte blue);
        [Slot(1817)]
        static extern unsafe void glSecondaryColor3bvEXT(SByte* v);
        [Slot(1819)]
        static extern void glSecondaryColor3dEXT(Double red, Double green, Double blue);
        [Slot(1821)]
        static extern unsafe void glSecondaryColor3dvEXT(Double* v);
        [Slot(1823)]
        static extern void glSecondaryColor3fEXT(Single red, Single green, Single blue);
        [Slot(1825)]
        static extern unsafe void glSecondaryColor3fvEXT(Single* v);
        [Slot(1829)]
        static extern void glSecondaryColor3iEXT(Int32 red, Int32 green, Int32 blue);
        [Slot(1831)]
        static extern unsafe void glSecondaryColor3ivEXT(Int32* v);
        [Slot(1833)]
        static extern void glSecondaryColor3sEXT(Int16 red, Int16 green, Int16 blue);
        [Slot(1835)]
        static extern unsafe void glSecondaryColor3svEXT(Int16* v);
        [Slot(1837)]
        static extern void glSecondaryColor3ubEXT(Byte red, Byte green, Byte blue);
        [Slot(1839)]
        static extern unsafe void glSecondaryColor3ubvEXT(Byte* v);
        [Slot(1841)]
        static extern void glSecondaryColor3uiEXT(UInt32 red, UInt32 green, UInt32 blue);
        [Slot(1843)]
        static extern unsafe void glSecondaryColor3uivEXT(UInt32* v);
        [Slot(1845)]
        static extern void glSecondaryColor3usEXT(UInt16 red, UInt16 green, UInt16 blue);
        [Slot(1847)]
        static extern unsafe void glSecondaryColor3usvEXT(UInt16* v);
        [Slot(1852)]
        static extern void glSecondaryColorPointerEXT(Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, IntPtr pointer);
        [Slot(1857)]
        static extern void glSeparableFilter2DEXT(OpenTK.Graphics.OpenGL.ExtConvolution target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr row, IntPtr column);
        [Slot(1861)]
        static extern void glSetInvariantEXT(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader type, IntPtr addr);
        [Slot(1862)]
        static extern void glSetLocalConstantEXT(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader type, IntPtr addr);
        [Slot(1866)]
        static extern void glShaderOp1EXT(OpenTK.Graphics.OpenGL.ExtVertexShader op, UInt32 res, UInt32 arg1);
        [Slot(1867)]
        static extern void glShaderOp2EXT(OpenTK.Graphics.OpenGL.ExtVertexShader op, UInt32 res, UInt32 arg1, UInt32 arg2);
        [Slot(1868)]
        static extern void glShaderOp3EXT(OpenTK.Graphics.OpenGL.ExtVertexShader op, UInt32 res, UInt32 arg1, UInt32 arg2, UInt32 arg3);
        [Slot(1878)]
        static extern void glStencilClearTagEXT(Int32 stencilTagBits, UInt32 stencilClearTag);
        [Slot(1894)]
        static extern void glSwizzleEXT(UInt32 res, UInt32 @in, OpenTK.Graphics.OpenGL.ExtVertexShader outX, OpenTK.Graphics.OpenGL.ExtVertexShader outY, OpenTK.Graphics.OpenGL.ExtVertexShader outZ, OpenTK.Graphics.OpenGL.ExtVertexShader outW);
        [Slot(1897)]
        static extern void glTangent3bEXT(SByte tx, SByte ty, SByte tz);
        [Slot(1898)]
        static extern unsafe void glTangent3bvEXT(SByte* v);
        [Slot(1899)]
        static extern void glTangent3dEXT(Double tx, Double ty, Double tz);
        [Slot(1900)]
        static extern unsafe void glTangent3dvEXT(Double* v);
        [Slot(1901)]
        static extern void glTangent3fEXT(Single tx, Single ty, Single tz);
        [Slot(1902)]
        static extern unsafe void glTangent3fvEXT(Single* v);
        [Slot(1903)]
        static extern void glTangent3iEXT(Int32 tx, Int32 ty, Int32 tz);
        [Slot(1904)]
        static extern unsafe void glTangent3ivEXT(Int32* v);
        [Slot(1905)]
        static extern void glTangent3sEXT(Int16 tx, Int16 ty, Int16 tz);
        [Slot(1906)]
        static extern unsafe void glTangent3svEXT(Int16* v);
        [Slot(1907)]
        static extern void glTangentPointerEXT(OpenTK.Graphics.OpenGL.NormalPointerType type, Int32 stride, IntPtr pointer);
        [Slot(1916)]
        static extern void glTexBufferEXT(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.ExtTextureBufferObject internalformat, UInt32 buffer);
        [Slot(2000)]
        static extern void glTexCoordPointerEXT(Int32 size, OpenTK.Graphics.OpenGL.TexCoordPointerType type, Int32 stride, Int32 count, IntPtr pointer);
        [Slot(2023)]
        static extern void glTexImage3DEXT(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);
        [Slot(2032)]
        static extern unsafe void glTexParameterIivEXT(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Int32* @params);
        [Slot(2034)]
        static extern unsafe void glTexParameterIuivEXT(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, UInt32* @params);
        [Slot(2046)]
        static extern void glTexSubImage1DEXT(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);
        [Slot(2048)]
        static extern void glTexSubImage2DEXT(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);
        [Slot(2050)]
        static extern void glTexSubImage3DEXT(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);
        [Slot(2053)]
        static extern void glTextureBufferEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, UInt32 buffer);
        [Slot(2054)]
        static extern void glTextureBufferRangeEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, UInt32 buffer, IntPtr offset, IntPtr size);
        [Slot(2056)]
        static extern void glTextureImage1DEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);
        [Slot(2057)]
        static extern void glTextureImage2DEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 height, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);
        [Slot(2060)]
        static extern void glTextureImage3DEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 internalformat, Int32 width, Int32 height, Int32 depth, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);
        [Slot(2063)]
        static extern void glTextureLightEXT(OpenTK.Graphics.OpenGL.ExtLightTexture pname);
        [Slot(2064)]
        static extern void glTextureMaterialEXT(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter mode);
        [Slot(2065)]
        static extern void glTextureNormalEXT(OpenTK.Graphics.OpenGL.ExtTexturePerturbNormal mode);
        [Slot(2066)]
        static extern void glTexturePageCommitmentEXT(UInt32 texture, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, bool resident);
        [Slot(2067)]
        static extern void glTextureParameterfEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Single param);
        [Slot(2068)]
        static extern unsafe void glTextureParameterfvEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Single* @params);
        [Slot(2069)]
        static extern void glTextureParameteriEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Int32 param);
        [Slot(2070)]
        static extern unsafe void glTextureParameterIivEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Int32* @params);
        [Slot(2071)]
        static extern unsafe void glTextureParameterIuivEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, UInt32* @params);
        [Slot(2072)]
        static extern unsafe void glTextureParameterivEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.TextureParameterName pname, Int32* @params);
        [Slot(2074)]
        static extern void glTextureRenderbufferEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, UInt32 renderbuffer);
        [Slot(2075)]
        static extern void glTextureStorage1DEXT(UInt32 texture, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 levels, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width);
        [Slot(2076)]
        static extern void glTextureStorage2DEXT(UInt32 texture, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 levels, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height);
        [Slot(2077)]
        static extern void glTextureStorage2DMultisampleEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 samples, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, bool fixedsamplelocations);
        [Slot(2078)]
        static extern void glTextureStorage3DEXT(UInt32 texture, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 levels, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth);
        [Slot(2079)]
        static extern void glTextureStorage3DMultisampleEXT(UInt32 texture, OpenTK.Graphics.OpenGL.ExtDirectStateAccess target, Int32 samples, OpenTK.Graphics.OpenGL.ExtDirectStateAccess internalformat, Int32 width, Int32 height, Int32 depth, bool fixedsamplelocations);
        [Slot(2081)]
        static extern void glTextureSubImage1DEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);
        [Slot(2082)]
        static extern void glTextureSubImage2DEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 width, Int32 height, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);
        [Slot(2083)]
        static extern void glTextureSubImage3DEXT(UInt32 texture, OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 width, Int32 height, Int32 depth, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);
        [Slot(2089)]
        static extern void glTransformFeedbackVaryingsEXT(UInt32 program, Int32 count, String[] varyings, OpenTK.Graphics.OpenGL.ExtTransformFeedback bufferMode);
        [Slot(2110)]
        static extern void glUniform1uiEXT(Int32 location, UInt32 v0);
        [Slot(2112)]
        static extern unsafe void glUniform1uivEXT(Int32 location, Int32 count, UInt32* value);
        [Slot(2128)]
        static extern void glUniform2uiEXT(Int32 location, UInt32 v0, UInt32 v1);
        [Slot(2130)]
        static extern unsafe void glUniform2uivEXT(Int32 location, Int32 count, UInt32* value);
        [Slot(2146)]
        static extern void glUniform3uiEXT(Int32 location, UInt32 v0, UInt32 v1, UInt32 v2);
        [Slot(2148)]
        static extern unsafe void glUniform3uivEXT(Int32 location, Int32 count, UInt32* value);
        [Slot(2164)]
        static extern void glUniform4uiEXT(Int32 location, UInt32 v0, UInt32 v1, UInt32 v2, UInt32 v3);
        [Slot(2166)]
        static extern unsafe void glUniform4uivEXT(Int32 location, Int32 count, UInt32* value);
        [Slot(2168)]
        static extern void glUniformBufferEXT(UInt32 program, Int32 location, UInt32 buffer);
        [Slot(2197)]
        static extern void glUnlockArraysEXT();
        [Slot(2200)]
        static extern bool glUnmapNamedBufferEXT(UInt32 buffer);
        [Slot(2207)]
        static extern void glUseProgramStagesEXT(UInt32 pipeline, UInt32 stages, UInt32 program);
        [Slot(2208)]
        static extern void glUseShaderProgramEXT(OpenTK.Graphics.OpenGL.ExtSeparateShaderObjects type, UInt32 program);
        [Slot(2212)]
        static extern void glValidateProgramPipelineEXT(UInt32 pipeline);
        [Slot(2214)]
        static extern unsafe void glVariantbvEXT(UInt32 id, SByte* addr);
        [Slot(2215)]
        static extern unsafe void glVariantdvEXT(UInt32 id, Double* addr);
        [Slot(2216)]
        static extern unsafe void glVariantfvEXT(UInt32 id, Single* addr);
        [Slot(2217)]
        static extern unsafe void glVariantivEXT(UInt32 id, Int32* addr);
        [Slot(2218)]
        static extern void glVariantPointerEXT(UInt32 id, OpenTK.Graphics.OpenGL.ExtVertexShader type, UInt32 stride, IntPtr addr);
        [Slot(2219)]
        static extern unsafe void glVariantsvEXT(UInt32 id, Int16* addr);
        [Slot(2220)]
        static extern unsafe void glVariantubvEXT(UInt32 id, Byte* addr);
        [Slot(2221)]
        static extern unsafe void glVariantuivEXT(UInt32 id, UInt32* addr);
        [Slot(2222)]
        static extern unsafe void glVariantusvEXT(UInt32 id, UInt16* addr);
        [Slot(2275)]
        static extern void glVertexArrayBindVertexBufferEXT(UInt32 vaobj, UInt32 bindingindex, UInt32 buffer, IntPtr offset, Int32 stride);
        [Slot(2276)]
        static extern void glVertexArrayColorOffsetEXT(UInt32 vaobj, UInt32 buffer, Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, IntPtr offset);
        [Slot(2277)]
        static extern void glVertexArrayEdgeFlagOffsetEXT(UInt32 vaobj, UInt32 buffer, Int32 stride, IntPtr offset);
        [Slot(2278)]
        static extern void glVertexArrayFogCoordOffsetEXT(UInt32 vaobj, UInt32 buffer, OpenTK.Graphics.OpenGL.FogPointerType type, Int32 stride, IntPtr offset);
        [Slot(2279)]
        static extern void glVertexArrayIndexOffsetEXT(UInt32 vaobj, UInt32 buffer, OpenTK.Graphics.OpenGL.IndexPointerType type, Int32 stride, IntPtr offset);
        [Slot(2280)]
        static extern void glVertexArrayMultiTexCoordOffsetEXT(UInt32 vaobj, UInt32 buffer, OpenTK.Graphics.OpenGL.ExtDirectStateAccess texunit, Int32 size, OpenTK.Graphics.OpenGL.TexCoordPointerType type, Int32 stride, IntPtr offset);
        [Slot(2281)]
        static extern void glVertexArrayNormalOffsetEXT(UInt32 vaobj, UInt32 buffer, OpenTK.Graphics.OpenGL.NormalPointerType type, Int32 stride, IntPtr offset);
        [Slot(2285)]
        static extern void glVertexArraySecondaryColorOffsetEXT(UInt32 vaobj, UInt32 buffer, Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, IntPtr offset);
        [Slot(2286)]
        static extern void glVertexArrayTexCoordOffsetEXT(UInt32 vaobj, UInt32 buffer, Int32 size, OpenTK.Graphics.OpenGL.TexCoordPointerType type, Int32 stride, IntPtr offset);
        [Slot(2287)]
        static extern void glVertexArrayVertexAttribBindingEXT(UInt32 vaobj, UInt32 attribindex, UInt32 bindingindex);
        [Slot(2288)]
        static extern void glVertexArrayVertexAttribDivisorEXT(UInt32 vaobj, UInt32 index, UInt32 divisor);
        [Slot(2289)]
        static extern void glVertexArrayVertexAttribFormatEXT(UInt32 vaobj, UInt32 attribindex, Int32 size, OpenTK.Graphics.OpenGL.ExtDirectStateAccess type, bool normalized, UInt32 relativeoffset);
        [Slot(2290)]
        static extern void glVertexArrayVertexAttribIFormatEXT(UInt32 vaobj, UInt32 attribindex, Int32 size, OpenTK.Graphics.OpenGL.ExtDirectStateAccess type, UInt32 relativeoffset);
        [Slot(2291)]
        static extern void glVertexArrayVertexAttribIOffsetEXT(UInt32 vaobj, UInt32 buffer, UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.ExtDirectStateAccess type, Int32 stride, IntPtr offset);
        [Slot(2292)]
        static extern void glVertexArrayVertexAttribLFormatEXT(UInt32 vaobj, UInt32 attribindex, Int32 size, OpenTK.Graphics.OpenGL.ExtDirectStateAccess type, UInt32 relativeoffset);
        [Slot(2293)]
        static extern void glVertexArrayVertexAttribLOffsetEXT(UInt32 vaobj, UInt32 buffer, UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.ExtDirectStateAccess type, Int32 stride, IntPtr offset);
        [Slot(2294)]
        static extern void glVertexArrayVertexAttribOffsetEXT(UInt32 vaobj, UInt32 buffer, UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.VertexAttribPointerType type, bool normalized, Int32 stride, IntPtr offset);
        [Slot(2295)]
        static extern void glVertexArrayVertexBindingDivisorEXT(UInt32 vaobj, UInt32 bindingindex, UInt32 divisor);
        [Slot(2296)]
        static extern void glVertexArrayVertexOffsetEXT(UInt32 vaobj, UInt32 buffer, Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, Int32 stride, IntPtr offset);
        [Slot(2410)]
        static extern void glVertexAttribI1iEXT(UInt32 index, Int32 x);
        [Slot(2412)]
        static extern unsafe void glVertexAttribI1ivEXT(UInt32 index, Int32* v);
        [Slot(2414)]
        static extern void glVertexAttribI1uiEXT(UInt32 index, UInt32 x);
        [Slot(2416)]
        static extern unsafe void glVertexAttribI1uivEXT(UInt32 index, UInt32* v);
        [Slot(2418)]
        static extern void glVertexAttribI2iEXT(UInt32 index, Int32 x, Int32 y);
        [Slot(2420)]
        static extern unsafe void glVertexAttribI2ivEXT(UInt32 index, Int32* v);
        [Slot(2422)]
        static extern void glVertexAttribI2uiEXT(UInt32 index, UInt32 x, UInt32 y);
        [Slot(2424)]
        static extern unsafe void glVertexAttribI2uivEXT(UInt32 index, UInt32* v);
        [Slot(2426)]
        static extern void glVertexAttribI3iEXT(UInt32 index, Int32 x, Int32 y, Int32 z);
        [Slot(2428)]
        static extern unsafe void glVertexAttribI3ivEXT(UInt32 index, Int32* v);
        [Slot(2430)]
        static extern void glVertexAttribI3uiEXT(UInt32 index, UInt32 x, UInt32 y, UInt32 z);
        [Slot(2432)]
        static extern unsafe void glVertexAttribI3uivEXT(UInt32 index, UInt32* v);
        [Slot(2434)]
        static extern unsafe void glVertexAttribI4bvEXT(UInt32 index, SByte* v);
        [Slot(2436)]
        static extern void glVertexAttribI4iEXT(UInt32 index, Int32 x, Int32 y, Int32 z, Int32 w);
        [Slot(2438)]
        static extern unsafe void glVertexAttribI4ivEXT(UInt32 index, Int32* v);
        [Slot(2440)]
        static extern unsafe void glVertexAttribI4svEXT(UInt32 index, Int16* v);
        [Slot(2442)]
        static extern unsafe void glVertexAttribI4ubvEXT(UInt32 index, Byte* v);
        [Slot(2444)]
        static extern void glVertexAttribI4uiEXT(UInt32 index, UInt32 x, UInt32 y, UInt32 z, UInt32 w);
        [Slot(2446)]
        static extern unsafe void glVertexAttribI4uivEXT(UInt32 index, UInt32* v);
        [Slot(2448)]
        static extern unsafe void glVertexAttribI4usvEXT(UInt32 index, UInt16* v);
        [Slot(2452)]
        static extern void glVertexAttribIPointerEXT(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.NvVertexProgram4 type, Int32 stride, IntPtr pointer);
        [Slot(2454)]
        static extern void glVertexAttribL1dEXT(UInt32 index, Double x);
        [Slot(2456)]
        static extern unsafe void glVertexAttribL1dvEXT(UInt32 index, Double* v);
        [Slot(2464)]
        static extern void glVertexAttribL2dEXT(UInt32 index, Double x, Double y);
        [Slot(2466)]
        static extern unsafe void glVertexAttribL2dvEXT(UInt32 index, Double* v);
        [Slot(2472)]
        static extern void glVertexAttribL3dEXT(UInt32 index, Double x, Double y, Double z);
        [Slot(2474)]
        static extern unsafe void glVertexAttribL3dvEXT(UInt32 index, Double* v);
        [Slot(2480)]
        static extern void glVertexAttribL4dEXT(UInt32 index, Double x, Double y, Double z, Double w);
        [Slot(2482)]
        static extern unsafe void glVertexAttribL4dvEXT(UInt32 index, Double* v);
        [Slot(2490)]
        static extern void glVertexAttribLPointerEXT(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.ExtVertexAttrib64bit type, Int32 stride, IntPtr pointer);
        [Slot(2532)]
        static extern void glVertexPointerEXT(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, Int32 stride, Int32 count, IntPtr pointer);
        [Slot(2567)]
        static extern void glVertexWeightfEXT(Single weight);
        [Slot(2568)]
        static extern unsafe void glVertexWeightfvEXT(Single* weight);
        [Slot(2571)]
        static extern void glVertexWeightPointerEXT(Int32 size, OpenTK.Graphics.OpenGL.ExtVertexWeighting type, Int32 stride, IntPtr pointer);
        [Slot(2647)]
        static extern void glWriteMaskEXT(UInt32 res, UInt32 @in, OpenTK.Graphics.OpenGL.ExtVertexShader outX, OpenTK.Graphics.OpenGL.ExtVertexShader outY, OpenTK.Graphics.OpenGL.ExtVertexShader outZ, OpenTK.Graphics.OpenGL.ExtVertexShader outW);
        [Slot(585)]
        static extern void glFrameTerminatorGREMEDY();
        [Slot(1893)]
        static extern void glStringMarkerGREMEDY(Int32 len, IntPtr @string);
        [Slot(725)]
        static extern unsafe void glGetImageTransformParameterfvHP(OpenTK.Graphics.OpenGL.HpImageTransform target, OpenTK.Graphics.OpenGL.HpImageTransform pname, [OutAttribute] Single* @params);
        [Slot(726)]
        static extern unsafe void glGetImageTransformParameterivHP(OpenTK.Graphics.OpenGL.HpImageTransform target, OpenTK.Graphics.OpenGL.HpImageTransform pname, [OutAttribute] Int32* @params);
        [Slot(1030)]
        static extern void glImageTransformParameterfHP(OpenTK.Graphics.OpenGL.HpImageTransform target, OpenTK.Graphics.OpenGL.HpImageTransform pname, Single param);
        [Slot(1031)]
        static extern unsafe void glImageTransformParameterfvHP(OpenTK.Graphics.OpenGL.HpImageTransform target, OpenTK.Graphics.OpenGL.HpImageTransform pname, Single* @params);
        [Slot(1032)]
        static extern void glImageTransformParameteriHP(OpenTK.Graphics.OpenGL.HpImageTransform target, OpenTK.Graphics.OpenGL.HpImageTransform pname, Int32 param);
        [Slot(1033)]
        static extern unsafe void glImageTransformParameterivHP(OpenTK.Graphics.OpenGL.HpImageTransform target, OpenTK.Graphics.OpenGL.HpImageTransform pname, Int32* @params);
        [Slot(236)]
        static extern void glColorPointerListIBM(Int32 size, OpenTK.Graphics.OpenGL.ColorPointerType type, Int32 stride, IntPtr pointer, Int32 ptrstride);
        [Slot(461)]
        static extern unsafe void glEdgeFlagPointerListIBM(Int32 stride, bool** pointer, Int32 ptrstride);
        [Slot(528)]
        static extern void glFlushStaticDataIBM(OpenTK.Graphics.OpenGL.IbmStaticData target);
        [Slot(544)]
        static extern void glFogCoordPointerListIBM(OpenTK.Graphics.OpenGL.FogPointerType type, Int32 stride, IntPtr pointer, Int32 ptrstride);
        [Slot(1047)]
        static extern void glIndexPointerListIBM(OpenTK.Graphics.OpenGL.IndexPointerType type, Int32 stride, IntPtr pointer, Int32 ptrstride);
        [Slot(1237)]
        static extern unsafe void glMultiModeDrawArraysIBM(OpenTK.Graphics.OpenGL.PrimitiveType* mode, Int32* first, Int32* count, Int32 primcount, Int32 modestride);
        [Slot(1238)]
        static extern unsafe void glMultiModeDrawElementsIBM(OpenTK.Graphics.OpenGL.PrimitiveType* mode, Int32* count, OpenTK.Graphics.OpenGL.DrawElementsType type, IntPtr indices, Int32 primcount, Int32 modestride);
        [Slot(1419)]
        static extern void glNormalPointerListIBM(OpenTK.Graphics.OpenGL.NormalPointerType type, Int32 stride, IntPtr pointer, Int32 ptrstride);
        [Slot(1853)]
        static extern void glSecondaryColorPointerListIBM(Int32 size, OpenTK.Graphics.OpenGL.IbmVertexArrayLists type, Int32 stride, IntPtr pointer, Int32 ptrstride);
        [Slot(2001)]
        static extern void glTexCoordPointerListIBM(Int32 size, OpenTK.Graphics.OpenGL.TexCoordPointerType type, Int32 stride, IntPtr pointer, Int32 ptrstride);
        [Slot(2533)]
        static extern void glVertexPointerListIBM(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, Int32 stride, IntPtr pointer, Int32 ptrstride);
        [Slot(124)]
        static extern void glBlendFuncSeparateINGR(OpenTK.Graphics.OpenGL.IngrBlendFuncSeparate sfactorRGB, OpenTK.Graphics.OpenGL.IngrBlendFuncSeparate dfactorRGB, OpenTK.Graphics.OpenGL.IngrBlendFuncSeparate sfactorAlpha, OpenTK.Graphics.OpenGL.IngrBlendFuncSeparate dfactorAlpha);
        [Slot(237)]
        static extern void glColorPointervINTEL(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, IntPtr pointer);
        [Slot(1181)]
        static extern unsafe IntPtr glMapTexture2DINTEL(UInt32 texture, Int32 level, UInt32 access, [OutAttribute] Int32* stride, [OutAttribute] OpenTK.Graphics.OpenGL.IntelMapTexture* layout);
        [Slot(1420)]
        static extern void glNormalPointervINTEL(OpenTK.Graphics.OpenGL.NormalPointerType type, IntPtr pointer);
        [Slot(1895)]
        static extern void glSyncTextureINTEL(UInt32 texture);
        [Slot(2002)]
        static extern void glTexCoordPointervINTEL(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, IntPtr pointer);
        [Slot(2202)]
        static extern void glUnmapTexture2DINTEL(UInt32 texture, Int32 level);
        [Slot(2534)]
        static extern void glVertexPointervINTEL(Int32 size, OpenTK.Graphics.OpenGL.VertexPointerType type, IntPtr pointer);
        [Slot(347)]
        static extern void glDebugMessageCallbackKHR(DebugProcKhr callback, IntPtr userParam);
        [Slot(350)]
        static extern unsafe void glDebugMessageControlKHR(OpenTK.Graphics.OpenGL.KhrDebug source, OpenTK.Graphics.OpenGL.KhrDebug type, OpenTK.Graphics.OpenGL.KhrDebug severity, Int32 count, UInt32* ids, bool enabled);
        [Slot(355)]
        static extern void glDebugMessageInsertKHR(OpenTK.Graphics.OpenGL.KhrDebug source, OpenTK.Graphics.OpenGL.KhrDebug type, UInt32 id, OpenTK.Graphics.OpenGL.KhrDebug severity, Int32 length, String buf);
        [Slot(687)]
        static extern unsafe Int32 glGetDebugMessageLogKHR(UInt32 count, Int32 bufSize, [OutAttribute] OpenTK.Graphics.OpenGL.KhrDebug* sources, [OutAttribute] OpenTK.Graphics.OpenGL.KhrDebug* types, [OutAttribute] UInt32* ids, [OutAttribute] OpenTK.Graphics.OpenGL.KhrDebug* severities, [OutAttribute] Int32* lengths, [OutAttribute] StringBuilder messageLog);
        [Slot(820)]
        static extern unsafe void glGetObjectLabelKHR(OpenTK.Graphics.OpenGL.KhrDebug identifier, UInt32 name, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder label);
        [Slot(825)]
        static extern unsafe void glGetObjectPtrLabelKHR(IntPtr ptr, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] StringBuilder label);
        [Slot(859)]
        static extern void glGetPointervKHR(OpenTK.Graphics.OpenGL.KhrDebug pname, [OutAttribute] IntPtr @params);
        [Slot(1432)]
        static extern void glObjectLabelKHR(OpenTK.Graphics.OpenGL.KhrDebug identifier, UInt32 name, Int32 length, String label);
        [Slot(1434)]
        static extern void glObjectPtrLabelKHR(IntPtr ptr, Int32 length, String label);
        [Slot(1516)]
        static extern void glPopDebugGroupKHR();
        [Slot(1698)]
        static extern void glPushDebugGroupKHR(OpenTK.Graphics.OpenGL.KhrDebug source, UInt32 id, Int32 length, String message);
        [Slot(1784)]
        static extern void glResizeBuffersMESA();
        [Slot(2593)]
        static extern void glWindowPos2dMESA(Double x, Double y);
        [Slot(2596)]
        static extern unsafe void glWindowPos2dvMESA(Double* v);
        [Slot(2599)]
        static extern void glWindowPos2fMESA(Single x, Single y);
        [Slot(2602)]
        static extern unsafe void glWindowPos2fvMESA(Single* v);
        [Slot(2605)]
        static extern void glWindowPos2iMESA(Int32 x, Int32 y);
        [Slot(2608)]
        static extern unsafe void glWindowPos2ivMESA(Int32* v);
        [Slot(2611)]
        static extern void glWindowPos2sMESA(Int16 x, Int16 y);
        [Slot(2614)]
        static extern unsafe void glWindowPos2svMESA(Int16* v);
        [Slot(2617)]
        static extern void glWindowPos3dMESA(Double x, Double y, Double z);
        [Slot(2620)]
        static extern unsafe void glWindowPos3dvMESA(Double* v);
        [Slot(2623)]
        static extern void glWindowPos3fMESA(Single x, Single y, Single z);
        [Slot(2626)]
        static extern unsafe void glWindowPos3fvMESA(Single* v);
        [Slot(2629)]
        static extern void glWindowPos3iMESA(Int32 x, Int32 y, Int32 z);
        [Slot(2632)]
        static extern unsafe void glWindowPos3ivMESA(Int32* v);
        [Slot(2635)]
        static extern void glWindowPos3sMESA(Int16 x, Int16 y, Int16 z);
        [Slot(2638)]
        static extern unsafe void glWindowPos3svMESA(Int16* v);
        [Slot(2639)]
        static extern void glWindowPos4dMESA(Double x, Double y, Double z, Double w);
        [Slot(2640)]
        static extern unsafe void glWindowPos4dvMESA(Double* v);
        [Slot(2641)]
        static extern void glWindowPos4fMESA(Single x, Single y, Single z, Single w);
        [Slot(2642)]
        static extern unsafe void glWindowPos4fvMESA(Single* v);
        [Slot(2643)]
        static extern void glWindowPos4iMESA(Int32 x, Int32 y, Int32 z, Int32 w);
        [Slot(2644)]
        static extern unsafe void glWindowPos4ivMESA(Int32* v);
        [Slot(2645)]
        static extern void glWindowPos4sMESA(Int16 x, Int16 y, Int16 z, Int16 w);
        [Slot(2646)]
        static extern unsafe void glWindowPos4svMESA(Int16* v);
        [Slot(8)]
        static extern void glActiveVaryingNV(UInt32 program, String name);
        [Slot(15)]
        static extern unsafe bool glAreProgramsResidentNV(Int32 n, UInt32* programs, [OutAttribute] bool* residences);
        [Slot(26)]
        static extern void glBeginConditionalRenderNV(UInt32 id, OpenTK.Graphics.OpenGL.NvConditionalRender mode);
        [Slot(29)]
        static extern void glBeginOcclusionQueryNV(UInt32 id);
        [Slot(36)]
        static extern void glBeginTransformFeedbackNV(OpenTK.Graphics.OpenGL.NvTransformFeedback primitiveMode);
        [Slot(38)]
        static extern void glBeginVideoCaptureNV(UInt32 video_capture_slot);
        [Slot(45)]
        static extern void glBindBufferBaseNV(OpenTK.Graphics.OpenGL.NvTransformFeedback target, UInt32 index, UInt32 buffer);
        [Slot(47)]
        static extern void glBindBufferOffsetNV(OpenTK.Graphics.OpenGL.NvTransformFeedback target, UInt32 index, UInt32 buffer, IntPtr offset);
        [Slot(50)]
        static extern void glBindBufferRangeNV(OpenTK.Graphics.OpenGL.NvTransformFeedback target, UInt32 index, UInt32 buffer, IntPtr offset, IntPtr size);
        [Slot(67)]
        static extern void glBindProgramNV(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 id);
        [Slot(80)]
        static extern void glBindTransformFeedbackNV(OpenTK.Graphics.OpenGL.NvTransformFeedback2 target, UInt32 id);
        [Slot(86)]
        static extern void glBindVideoCaptureStreamBufferNV(UInt32 video_capture_slot, UInt32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture frame_region, IntPtr offset);
        [Slot(87)]
        static extern void glBindVideoCaptureStreamTextureNV(UInt32 video_capture_slot, UInt32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture frame_region, OpenTK.Graphics.OpenGL.NvVideoCapture target, UInt32 texture);
        [Slot(101)]
        static extern void glBlendBarrierNV();
        [Slot(125)]
        static extern void glBlendParameteriNV(OpenTK.Graphics.OpenGL.NvBlendEquationAdvanced pname, Int32 value);
        [Slot(128)]
        static extern void glBufferAddressRangeNV(OpenTK.Graphics.OpenGL.NvVertexBufferUnifiedMemory pname, UInt32 index, UInt64 address, IntPtr length);
        [Slot(156)]
        static extern void glClearDepthdNV(Double depth);
        [Slot(182)]
        static extern void glColor3hNV(Half red, Half green, Half blue);
        [Slot(183)]
        static extern unsafe void glColor3hvNV(Half* v);
        [Slot(204)]
        static extern void glColor4hNV(Half red, Half green, Half blue, Half alpha);
        [Slot(205)]
        static extern unsafe void glColor4hvNV(Half* v);
        [Slot(222)]
        static extern void glColorFormatNV(Int32 size, OpenTK.Graphics.OpenGL.NvVertexBufferUnifiedMemory type, Int32 stride);
        [Slot(247)]
        static extern void glCombinerInputNV(OpenTK.Graphics.OpenGL.NvRegisterCombiners stage, OpenTK.Graphics.OpenGL.NvRegisterCombiners portion, OpenTK.Graphics.OpenGL.NvRegisterCombiners variable, OpenTK.Graphics.OpenGL.NvRegisterCombiners input, OpenTK.Graphics.OpenGL.NvRegisterCombiners mapping, OpenTK.Graphics.OpenGL.NvRegisterCombiners componentUsage);
        [Slot(248)]
        static extern void glCombinerOutputNV(OpenTK.Graphics.OpenGL.NvRegisterCombiners stage, OpenTK.Graphics.OpenGL.NvRegisterCombiners portion, OpenTK.Graphics.OpenGL.NvRegisterCombiners abOutput, OpenTK.Graphics.OpenGL.NvRegisterCombiners cdOutput, OpenTK.Graphics.OpenGL.NvRegisterCombiners sumOutput, OpenTK.Graphics.OpenGL.NvRegisterCombiners scale, OpenTK.Graphics.OpenGL.NvRegisterCombiners bias, bool abDotProduct, bool cdDotProduct, bool muxSum);
        [Slot(249)]
        static extern void glCombinerParameterfNV(OpenTK.Graphics.OpenGL.NvRegisterCombiners pname, Single param);
        [Slot(250)]
        static extern unsafe void glCombinerParameterfvNV(OpenTK.Graphics.OpenGL.NvRegisterCombiners pname, Single* @params);
        [Slot(251)]
        static extern void glCombinerParameteriNV(OpenTK.Graphics.OpenGL.NvRegisterCombiners pname, Int32 param);
        [Slot(252)]
        static extern unsafe void glCombinerParameterivNV(OpenTK.Graphics.OpenGL.NvRegisterCombiners pname, Int32* @params);
        [Slot(253)]
        static extern unsafe void glCombinerStageParameterfvNV(OpenTK.Graphics.OpenGL.NvRegisterCombiners2 stage, OpenTK.Graphics.OpenGL.NvRegisterCombiners2 pname, Single* @params);
        [Slot(305)]
        static extern void glCopyImageSubDataNV(UInt32 srcName, OpenTK.Graphics.OpenGL.NvCopyImage srcTarget, Int32 srcLevel, Int32 srcX, Int32 srcY, Int32 srcZ, UInt32 dstName, OpenTK.Graphics.OpenGL.NvCopyImage dstTarget, Int32 dstLevel, Int32 dstX, Int32 dstY, Int32 dstZ, Int32 width, Int32 height, Int32 depth);
        [Slot(311)]
        static extern void glCopyPathNV(UInt32 resultPath, UInt32 srcPath);
        [Slot(328)]
        static extern unsafe void glCoverFillPathInstancedNV(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues);
        [Slot(329)]
        static extern void glCoverFillPathNV(UInt32 path, OpenTK.Graphics.OpenGL.NvPathRendering coverMode);
        [Slot(330)]
        static extern unsafe void glCoverStrokePathInstancedNV(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering coverMode, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues);
        [Slot(331)]
        static extern void glCoverStrokePathNV(UInt32 path, OpenTK.Graphics.OpenGL.NvPathRendering coverMode);
        [Slot(363)]
        static extern unsafe void glDeleteFencesNV(Int32 n, UInt32* fences);
        [Slot(371)]
        static extern unsafe void glDeleteOcclusionQueriesNV(Int32 n, UInt32* ids);
        [Slot(372)]
        static extern void glDeletePathsNV(UInt32 path, Int32 range);
        [Slot(378)]
        static extern unsafe void glDeleteProgramsNV(Int32 n, UInt32* programs);
        [Slot(389)]
        static extern unsafe void glDeleteTransformFeedbacksNV(Int32 n, UInt32* ids);
        [Slot(393)]
        static extern void glDepthBoundsdNV(Double zmin, Double zmax);
        [Slot(399)]
        static extern void glDepthRangedNV(Double zNear, Double zFar);
        [Slot(451)]
        static extern void glDrawTextureNV(UInt32 texture, UInt32 sampler, Single x0, Single y0, Single x1, Single y1, Single z, Single s0, Single t0, Single s1, Single t1);
        [Slot(454)]
        static extern void glDrawTransformFeedbackNV(OpenTK.Graphics.OpenGL.PrimitiveType mode, UInt32 id);
        [Slot(458)]
        static extern void glEdgeFlagFormatNV(Int32 stride);
        [Slot(479)]
        static extern void glEndConditionalRenderNV();
        [Slot(483)]
        static extern void glEndOcclusionQueryNV();
        [Slot(490)]
        static extern void glEndTransformFeedbackNV();
        [Slot(492)]
        static extern void glEndVideoCaptureNV(UInt32 video_capture_slot);
        [Slot(505)]
        static extern void glEvalMapsNV(OpenTK.Graphics.OpenGL.NvEvaluators target, OpenTK.Graphics.OpenGL.NvEvaluators mode);
        [Slot(510)]
        static extern unsafe void glExecuteProgramNV(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 id, Single* @params);
        [Slot(515)]
        static extern void glFinalCombinerInputNV(OpenTK.Graphics.OpenGL.NvRegisterCombiners variable, OpenTK.Graphics.OpenGL.NvRegisterCombiners input, OpenTK.Graphics.OpenGL.NvRegisterCombiners mapping, OpenTK.Graphics.OpenGL.NvRegisterCombiners componentUsage);
        [Slot(519)]
        static extern void glFinishFenceNV(UInt32 fence);
        [Slot(526)]
        static extern void glFlushPixelDataRangeNV(OpenTK.Graphics.OpenGL.NvPixelDataRange target);
        [Slot(530)]
        static extern void glFlushVertexArrayRangeNV();
        [Slot(537)]
        static extern void glFogCoordFormatNV(OpenTK.Graphics.OpenGL.NvVertexBufferUnifiedMemory type, Int32 stride);
        [Slot(540)]
        static extern void glFogCoordhNV(Half fog);
        [Slot(541)]
        static extern unsafe void glFogCoordhvNV(Half* fog);
        [Slot(600)]
        static extern unsafe void glGenFencesNV(Int32 n, [OutAttribute] UInt32* fences);
        [Slot(606)]
        static extern unsafe void glGenOcclusionQueriesNV(Int32 n, [OutAttribute] UInt32* ids);
        [Slot(607)]
        static extern Int32 glGenPathsNV(Int32 range);
        [Slot(612)]
        static extern unsafe void glGenProgramsNV(Int32 n, [OutAttribute] UInt32* programs);
        [Slot(622)]
        static extern unsafe void glGenTransformFeedbacksNV(Int32 n, [OutAttribute] UInt32* ids);
        [Slot(638)]
        static extern unsafe void glGetActiveVaryingNV(UInt32 program, UInt32 index, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] Int32* size, [OutAttribute] OpenTK.Graphics.OpenGL.NvTransformFeedback* type, [OutAttribute] StringBuilder name);
        [Slot(651)]
        static extern unsafe void glGetBufferParameterui64vNV(OpenTK.Graphics.OpenGL.NvShaderBufferLoad target, OpenTK.Graphics.OpenGL.NvShaderBufferLoad pname, [OutAttribute] UInt64* @params);
        [Slot(668)]
        static extern unsafe void glGetCombinerInputParameterfvNV(OpenTK.Graphics.OpenGL.NvRegisterCombiners stage, OpenTK.Graphics.OpenGL.NvRegisterCombiners portion, OpenTK.Graphics.OpenGL.NvRegisterCombiners variable, OpenTK.Graphics.OpenGL.NvRegisterCombiners pname, [OutAttribute] Single* @params);
        [Slot(669)]
        static extern unsafe void glGetCombinerInputParameterivNV(OpenTK.Graphics.OpenGL.NvRegisterCombiners stage, OpenTK.Graphics.OpenGL.NvRegisterCombiners portion, OpenTK.Graphics.OpenGL.NvRegisterCombiners variable, OpenTK.Graphics.OpenGL.NvRegisterCombiners pname, [OutAttribute] Int32* @params);
        [Slot(670)]
        static extern unsafe void glGetCombinerOutputParameterfvNV(OpenTK.Graphics.OpenGL.NvRegisterCombiners stage, OpenTK.Graphics.OpenGL.NvRegisterCombiners portion, OpenTK.Graphics.OpenGL.NvRegisterCombiners pname, [OutAttribute] Single* @params);
        [Slot(671)]
        static extern unsafe void glGetCombinerOutputParameterivNV(OpenTK.Graphics.OpenGL.NvRegisterCombiners stage, OpenTK.Graphics.OpenGL.NvRegisterCombiners portion, OpenTK.Graphics.OpenGL.NvRegisterCombiners pname, [OutAttribute] Int32* @params);
        [Slot(672)]
        static extern unsafe void glGetCombinerStageParameterfvNV(OpenTK.Graphics.OpenGL.NvRegisterCombiners2 stage, OpenTK.Graphics.OpenGL.NvRegisterCombiners2 pname, [OutAttribute] Single* @params);
        [Slot(694)]
        static extern unsafe void glGetFenceivNV(UInt32 fence, OpenTK.Graphics.OpenGL.NvFence pname, [OutAttribute] Int32* @params);
        [Slot(695)]
        static extern unsafe void glGetFinalCombinerInputParameterfvNV(OpenTK.Graphics.OpenGL.NvRegisterCombiners variable, OpenTK.Graphics.OpenGL.NvRegisterCombiners pname, [OutAttribute] Single* @params);
        [Slot(696)]
        static extern unsafe void glGetFinalCombinerInputParameterivNV(OpenTK.Graphics.OpenGL.NvRegisterCombiners variable, OpenTK.Graphics.OpenGL.NvRegisterCombiners pname, [OutAttribute] Int32* @params);
        [Slot(724)]
        static extern Int64 glGetImageHandleNV(UInt32 texture, Int32 level, bool layered, Int32 layer, OpenTK.Graphics.OpenGL.NvBindlessTexture format);
        [Slot(733)]
        static extern unsafe void glGetIntegerui64i_vNV(OpenTK.Graphics.OpenGL.NvVertexBufferUnifiedMemory value, UInt32 index, [OutAttribute] UInt64* result);
        [Slot(734)]
        static extern unsafe void glGetIntegerui64vNV(OpenTK.Graphics.OpenGL.NvShaderBufferLoad value, [OutAttribute] UInt64* result);
        [Slot(750)]
        static extern unsafe void glGetMapAttribParameterfvNV(OpenTK.Graphics.OpenGL.NvEvaluators target, UInt32 index, OpenTK.Graphics.OpenGL.NvEvaluators pname, [OutAttribute] Single* @params);
        [Slot(751)]
        static extern unsafe void glGetMapAttribParameterivNV(OpenTK.Graphics.OpenGL.NvEvaluators target, UInt32 index, OpenTK.Graphics.OpenGL.NvEvaluators pname, [OutAttribute] Int32* @params);
        [Slot(752)]
        static extern void glGetMapControlPointsNV(OpenTK.Graphics.OpenGL.NvEvaluators target, UInt32 index, OpenTK.Graphics.OpenGL.NvEvaluators type, Int32 ustride, Int32 vstride, bool packed, [OutAttribute] IntPtr points);
        [Slot(756)]
        static extern unsafe void glGetMapParameterfvNV(OpenTK.Graphics.OpenGL.NvEvaluators target, OpenTK.Graphics.OpenGL.NvEvaluators pname, [OutAttribute] Single* @params);
        [Slot(757)]
        static extern unsafe void glGetMapParameterivNV(OpenTK.Graphics.OpenGL.NvEvaluators target, OpenTK.Graphics.OpenGL.NvEvaluators pname, [OutAttribute] Int32* @params);
        [Slot(770)]
        static extern unsafe void glGetMultisamplefvNV(OpenTK.Graphics.OpenGL.NvExplicitMultisample pname, UInt32 index, [OutAttribute] Single* val);
        [Slot(784)]
        static extern unsafe void glGetNamedBufferParameterui64vNV(UInt32 buffer, OpenTK.Graphics.OpenGL.NvShaderBufferLoad pname, [OutAttribute] UInt64* @params);
        [Slot(826)]
        static extern unsafe void glGetOcclusionQueryivNV(UInt32 id, OpenTK.Graphics.OpenGL.NvOcclusionQuery pname, [OutAttribute] Int32* @params);
        [Slot(827)]
        static extern unsafe void glGetOcclusionQueryuivNV(UInt32 id, OpenTK.Graphics.OpenGL.NvOcclusionQuery pname, [OutAttribute] UInt32* @params);
        [Slot(828)]
        static extern unsafe void glGetPathColorGenfvNV(OpenTK.Graphics.OpenGL.NvPathRendering color, OpenTK.Graphics.OpenGL.NvPathRendering pname, [OutAttribute] Single* value);
        [Slot(829)]
        static extern unsafe void glGetPathColorGenivNV(OpenTK.Graphics.OpenGL.NvPathRendering color, OpenTK.Graphics.OpenGL.NvPathRendering pname, [OutAttribute] Int32* value);
        [Slot(830)]
        static extern unsafe void glGetPathCommandsNV(UInt32 path, [OutAttribute] Byte* commands);
        [Slot(831)]
        static extern unsafe void glGetPathCoordsNV(UInt32 path, [OutAttribute] Single* coords);
        [Slot(832)]
        static extern unsafe void glGetPathDashArrayNV(UInt32 path, [OutAttribute] Single* dashArray);
        [Slot(833)]
        static extern Single glGetPathLengthNV(UInt32 path, Int32 startSegment, Int32 numSegments);
        [Slot(834)]
        static extern unsafe void glGetPathMetricRangeNV(UInt32 metricQueryMask, UInt32 firstPathName, Int32 numPaths, Int32 stride, [OutAttribute] Single* metrics);
        [Slot(835)]
        static extern unsafe void glGetPathMetricsNV(UInt32 metricQueryMask, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, UInt32 pathBase, Int32 stride, [OutAttribute] Single* metrics);
        [Slot(836)]
        static extern unsafe void glGetPathParameterfvNV(UInt32 path, OpenTK.Graphics.OpenGL.NvPathRendering pname, [OutAttribute] Single* value);
        [Slot(837)]
        static extern unsafe void glGetPathParameterivNV(UInt32 path, OpenTK.Graphics.OpenGL.NvPathRendering pname, [OutAttribute] Int32* value);
        [Slot(838)]
        static extern unsafe void glGetPathSpacingNV(OpenTK.Graphics.OpenGL.NvPathRendering pathListMode, Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, UInt32 pathBase, Single advanceScale, Single kerningScale, OpenTK.Graphics.OpenGL.NvPathRendering transformType, [OutAttribute] Single* returnedSpacing);
        [Slot(839)]
        static extern unsafe void glGetPathTexGenfvNV(OpenTK.Graphics.OpenGL.TextureUnit texCoordSet, OpenTK.Graphics.OpenGL.NvPathRendering pname, [OutAttribute] Single* value);
        [Slot(840)]
        static extern unsafe void glGetPathTexGenivNV(OpenTK.Graphics.OpenGL.TextureUnit texCoordSet, OpenTK.Graphics.OpenGL.NvPathRendering pname, [OutAttribute] Int32* value);
        [Slot(864)]
        static extern unsafe void glGetProgramEnvParameterIivNV(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, [OutAttribute] Int32* @params);
        [Slot(865)]
        static extern unsafe void glGetProgramEnvParameterIuivNV(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, [OutAttribute] UInt32* @params);
        [Slot(870)]
        static extern unsafe void glGetProgramivNV(UInt32 id, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [OutAttribute] Int32* @params);
        [Slot(873)]
        static extern unsafe void glGetProgramLocalParameterIivNV(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, [OutAttribute] Int32* @params);
        [Slot(874)]
        static extern unsafe void glGetProgramLocalParameterIuivNV(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, [OutAttribute] UInt32* @params);
        [Slot(875)]
        static extern unsafe void glGetProgramNamedParameterdvNV(UInt32 id, Int32 len, Byte* name, [OutAttribute] Double* @params);
        [Slot(876)]
        static extern unsafe void glGetProgramNamedParameterfvNV(UInt32 id, Int32 len, Byte* name, [OutAttribute] Single* @params);
        [Slot(877)]
        static extern unsafe void glGetProgramParameterdvNV(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, OpenTK.Graphics.OpenGL.AssemblyProgramParameterArb pname, [OutAttribute] Double* @params);
        [Slot(878)]
        static extern unsafe void glGetProgramParameterfvNV(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, OpenTK.Graphics.OpenGL.AssemblyProgramParameterArb pname, [OutAttribute] Single* @params);
        [Slot(890)]
        static extern unsafe void glGetProgramStringNV(UInt32 id, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [OutAttribute] Byte* program);
        [Slot(891)]
        static extern unsafe void glGetProgramSubroutineParameteruivNV(OpenTK.Graphics.OpenGL.NvGpuProgram5 target, UInt32 index, [OutAttribute] UInt32* param);
        [Slot(945)]
        static extern Int64 glGetTextureHandleNV(UInt32 texture);
        [Slot(954)]
        static extern Int64 glGetTextureSamplerHandleNV(UInt32 texture, UInt32 sampler);
        [Slot(955)]
        static extern unsafe void glGetTrackMatrixivNV(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 address, OpenTK.Graphics.OpenGL.AssemblyProgramParameterArb pname, [OutAttribute] Int32* @params);
        [Slot(958)]
        static extern unsafe void glGetTransformFeedbackVaryingNV(UInt32 program, UInt32 index, [OutAttribute] Int32* location);
        [Slot(964)]
        static extern unsafe void glGetUniformi64vNV(UInt32 program, Int32 location, [OutAttribute] Int64* @params);
        [Slot(972)]
        static extern unsafe void glGetUniformui64vNV(UInt32 program, Int32 location, [OutAttribute] UInt64* @params);
        [Slot(981)]
        static extern Int32 glGetVaryingLocationNV(UInt32 program, String name);
        [Slot(990)]
        static extern unsafe void glGetVertexAttribdvNV(UInt32 index, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [OutAttribute] Double* @params);
        [Slot(993)]
        static extern unsafe void glGetVertexAttribfvNV(UInt32 index, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [OutAttribute] Single* @params);
        [Slot(1000)]
        static extern unsafe void glGetVertexAttribivNV(UInt32 index, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [OutAttribute] Int32* @params);
        [Slot(1003)]
        static extern unsafe void glGetVertexAttribLi64vNV(UInt32 index, OpenTK.Graphics.OpenGL.NvVertexAttribInteger64bit pname, [OutAttribute] Int64* @params);
        [Slot(1005)]
        static extern unsafe void glGetVertexAttribLui64vNV(UInt32 index, OpenTK.Graphics.OpenGL.NvVertexAttribInteger64bit pname, [OutAttribute] UInt64* @params);
        [Slot(1008)]
        static extern void glGetVertexAttribPointervNV(UInt32 index, OpenTK.Graphics.OpenGL.NvVertexProgram pname, [OutAttribute] IntPtr pointer);
        [Slot(1009)]
        static extern unsafe void glGetVideoCaptureivNV(UInt32 video_capture_slot, OpenTK.Graphics.OpenGL.NvVideoCapture pname, [OutAttribute] Int32* @params);
        [Slot(1010)]
        static extern unsafe void glGetVideoCaptureStreamdvNV(UInt32 video_capture_slot, UInt32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, [OutAttribute] Double* @params);
        [Slot(1011)]
        static extern unsafe void glGetVideoCaptureStreamfvNV(UInt32 video_capture_slot, UInt32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, [OutAttribute] Single* @params);
        [Slot(1012)]
        static extern unsafe void glGetVideoCaptureStreamivNV(UInt32 video_capture_slot, UInt32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, [OutAttribute] Int32* @params);
        [Slot(1013)]
        static extern unsafe void glGetVideoi64vNV(UInt32 video_slot, OpenTK.Graphics.OpenGL.NvPresentVideo pname, [OutAttribute] Int64* @params);
        [Slot(1014)]
        static extern unsafe void glGetVideoivNV(UInt32 video_slot, OpenTK.Graphics.OpenGL.NvPresentVideo pname, [OutAttribute] Int32* @params);
        [Slot(1015)]
        static extern unsafe void glGetVideoui64vNV(UInt32 video_slot, OpenTK.Graphics.OpenGL.NvPresentVideo pname, [OutAttribute] UInt64* @params);
        [Slot(1016)]
        static extern unsafe void glGetVideouivNV(UInt32 video_slot, OpenTK.Graphics.OpenGL.NvPresentVideo pname, [OutAttribute] UInt32* @params);
        [Slot(1038)]
        static extern void glIndexFormatNV(OpenTK.Graphics.OpenGL.NvVertexBufferUnifiedMemory type, Int32 stride);
        [Slot(1059)]
        static extern void glInterpolatePathsNV(UInt32 resultPath, UInt32 pathA, UInt32 pathB, Single weight);
        [Slot(1069)]
        static extern bool glIsBufferResidentNV(OpenTK.Graphics.OpenGL.NvShaderBufferLoad target);
        [Slot(1074)]
        static extern bool glIsFenceNV(UInt32 fence);
        [Slot(1078)]
        static extern bool glIsImageHandleResidentNV(UInt64 handle);
        [Slot(1081)]
        static extern bool glIsNamedBufferResidentNV(UInt32 buffer);
        [Slot(1084)]
        static extern bool glIsOcclusionQueryNV(UInt32 id);
        [Slot(1085)]
        static extern bool glIsPathNV(UInt32 path);
        [Slot(1086)]
        static extern bool glIsPointInFillPathNV(UInt32 path, UInt32 mask, Single x, Single y);
        [Slot(1087)]
        static extern bool glIsPointInStrokePathNV(UInt32 path, Single x, Single y);
        [Slot(1090)]
        static extern bool glIsProgramNV(UInt32 id);
        [Slot(1103)]
        static extern bool glIsTextureHandleResidentNV(UInt64 handle);
        [Slot(1105)]
        static extern bool glIsTransformFeedbackNV(UInt32 id);
        [Slot(1140)]
        static extern unsafe void glLoadProgramNV(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 id, Int32 len, Byte* program);
        [Slot(1148)]
        static extern void glMakeBufferNonResidentNV(OpenTK.Graphics.OpenGL.NvShaderBufferLoad target);
        [Slot(1149)]
        static extern void glMakeBufferResidentNV(OpenTK.Graphics.OpenGL.NvShaderBufferLoad target, OpenTK.Graphics.OpenGL.NvShaderBufferLoad access);
        [Slot(1151)]
        static extern void glMakeImageHandleNonResidentNV(UInt64 handle);
        [Slot(1153)]
        static extern void glMakeImageHandleResidentNV(UInt64 handle, OpenTK.Graphics.OpenGL.NvBindlessTexture access);
        [Slot(1154)]
        static extern void glMakeNamedBufferNonResidentNV(UInt32 buffer);
        [Slot(1155)]
        static extern void glMakeNamedBufferResidentNV(UInt32 buffer, OpenTK.Graphics.OpenGL.NvShaderBufferLoad access);
        [Slot(1157)]
        static extern void glMakeTextureHandleNonResidentNV(UInt64 handle);
        [Slot(1159)]
        static extern void glMakeTextureHandleResidentNV(UInt64 handle);
        [Slot(1169)]
        static extern void glMapControlPointsNV(OpenTK.Graphics.OpenGL.NvEvaluators target, UInt32 index, OpenTK.Graphics.OpenGL.NvEvaluators type, Int32 ustride, Int32 vstride, Int32 uorder, Int32 vorder, bool packed, IntPtr points);
        [Slot(1179)]
        static extern unsafe void glMapParameterfvNV(OpenTK.Graphics.OpenGL.NvEvaluators target, OpenTK.Graphics.OpenGL.NvEvaluators pname, Single* @params);
        [Slot(1180)]
        static extern unsafe void glMapParameterivNV(OpenTK.Graphics.OpenGL.NvEvaluators target, OpenTK.Graphics.OpenGL.NvEvaluators pname, Int32* @params);
        [Slot(1226)]
        static extern void glMultiDrawArraysIndirectBindlessNV(OpenTK.Graphics.OpenGL.NvBindlessMultiDrawIndirect mode, IntPtr indirect, Int32 drawCount, Int32 stride, Int32 vertexBufferCount);
        [Slot(1234)]
        static extern void glMultiDrawElementsIndirectBindlessNV(OpenTK.Graphics.OpenGL.NvBindlessMultiDrawIndirect mode, OpenTK.Graphics.OpenGL.NvBindlessMultiDrawIndirect type, IntPtr indirect, Int32 drawCount, Int32 stride, Int32 vertexBufferCount);
        [Slot(1250)]
        static extern void glMultiTexCoord1hNV(OpenTK.Graphics.OpenGL.TextureUnit target, Half s);
        [Slot(1251)]
        static extern unsafe void glMultiTexCoord1hvNV(OpenTK.Graphics.OpenGL.TextureUnit target, Half* v);
        [Slot(1272)]
        static extern void glMultiTexCoord2hNV(OpenTK.Graphics.OpenGL.TextureUnit target, Half s, Half t);
        [Slot(1273)]
        static extern unsafe void glMultiTexCoord2hvNV(OpenTK.Graphics.OpenGL.TextureUnit target, Half* v);
        [Slot(1294)]
        static extern void glMultiTexCoord3hNV(OpenTK.Graphics.OpenGL.TextureUnit target, Half s, Half t, Half r);
        [Slot(1295)]
        static extern unsafe void glMultiTexCoord3hvNV(OpenTK.Graphics.OpenGL.TextureUnit target, Half* v);
        [Slot(1316)]
        static extern void glMultiTexCoord4hNV(OpenTK.Graphics.OpenGL.TextureUnit target, Half s, Half t, Half r, Half q);
        [Slot(1317)]
        static extern unsafe void glMultiTexCoord4hvNV(OpenTK.Graphics.OpenGL.TextureUnit target, Half* v);
        [Slot(1406)]
        static extern void glNormal3hNV(Half nx, Half ny, Half nz);
        [Slot(1407)]
        static extern unsafe void glNormal3hvNV(Half* v);
        [Slot(1414)]
        static extern void glNormalFormatNV(OpenTK.Graphics.OpenGL.NvVertexBufferUnifiedMemory type, Int32 stride);
        [Slot(1445)]
        static extern unsafe void glPathColorGenNV(OpenTK.Graphics.OpenGL.NvPathRendering color, OpenTK.Graphics.OpenGL.NvPathRendering genMode, OpenTK.Graphics.OpenGL.NvPathRendering colorFormat, Single* coeffs);
        [Slot(1446)]
        static extern unsafe void glPathCommandsNV(UInt32 path, Int32 numCommands, Byte* commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, IntPtr coords);
        [Slot(1447)]
        static extern void glPathCoordsNV(UInt32 path, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, IntPtr coords);
        [Slot(1448)]
        static extern void glPathCoverDepthFuncNV(OpenTK.Graphics.OpenGL.DepthFunction func);
        [Slot(1449)]
        static extern unsafe void glPathDashArrayNV(UInt32 path, Int32 dashCount, Single* dashArray);
        [Slot(1450)]
        static extern void glPathFogGenNV(OpenTK.Graphics.OpenGL.NvPathRendering genMode);
        [Slot(1451)]
        static extern void glPathGlyphRangeNV(UInt32 firstPathName, OpenTK.Graphics.OpenGL.NvPathRendering fontTarget, IntPtr fontName, UInt32 fontStyle, UInt32 firstGlyph, Int32 numGlyphs, OpenTK.Graphics.OpenGL.NvPathRendering handleMissingGlyphs, UInt32 pathParameterTemplate, Single emScale);
        [Slot(1452)]
        static extern void glPathGlyphsNV(UInt32 firstPathName, OpenTK.Graphics.OpenGL.NvPathRendering fontTarget, IntPtr fontName, UInt32 fontStyle, Int32 numGlyphs, OpenTK.Graphics.OpenGL.NvPathRendering type, IntPtr charcodes, OpenTK.Graphics.OpenGL.NvPathRendering handleMissingGlyphs, UInt32 pathParameterTemplate, Single emScale);
        [Slot(1453)]
        static extern void glPathParameterfNV(UInt32 path, OpenTK.Graphics.OpenGL.NvPathRendering pname, Single value);
        [Slot(1454)]
        static extern unsafe void glPathParameterfvNV(UInt32 path, OpenTK.Graphics.OpenGL.NvPathRendering pname, Single* value);
        [Slot(1455)]
        static extern void glPathParameteriNV(UInt32 path, OpenTK.Graphics.OpenGL.NvPathRendering pname, Int32 value);
        [Slot(1456)]
        static extern unsafe void glPathParameterivNV(UInt32 path, OpenTK.Graphics.OpenGL.NvPathRendering pname, Int32* value);
        [Slot(1457)]
        static extern void glPathStencilDepthOffsetNV(Single factor, Single units);
        [Slot(1458)]
        static extern void glPathStencilFuncNV(OpenTK.Graphics.OpenGL.StencilFunction func, Int32 @ref, UInt32 mask);
        [Slot(1459)]
        static extern void glPathStringNV(UInt32 path, OpenTK.Graphics.OpenGL.NvPathRendering format, Int32 length, IntPtr pathString);
        [Slot(1460)]
        static extern unsafe void glPathSubCommandsNV(UInt32 path, Int32 commandStart, Int32 commandsToDelete, Int32 numCommands, Byte* commands, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, IntPtr coords);
        [Slot(1461)]
        static extern void glPathSubCoordsNV(UInt32 path, Int32 coordStart, Int32 numCoords, OpenTK.Graphics.OpenGL.NvPathRendering coordType, IntPtr coords);
        [Slot(1462)]
        static extern unsafe void glPathTexGenNV(OpenTK.Graphics.OpenGL.NvPathRendering texCoordSet, OpenTK.Graphics.OpenGL.NvPathRendering genMode, Int32 components, Single* coeffs);
        [Slot(1464)]
        static extern void glPauseTransformFeedbackNV();
        [Slot(1465)]
        static extern void glPixelDataRangeNV(OpenTK.Graphics.OpenGL.NvPixelDataRange target, Int32 length, IntPtr pointer);
        [Slot(1489)]
        static extern unsafe bool glPointAlongPathNV(UInt32 path, Int32 startSegment, Int32 numSegments, Single distance, [OutAttribute] Single* x, [OutAttribute] Single* y, [OutAttribute] Single* tangentX, [OutAttribute] Single* tangentY);
        [Slot(1499)]
        static extern void glPointParameteriNV(OpenTK.Graphics.OpenGL.NvPointSprite pname, Int32 param);
        [Slot(1501)]
        static extern unsafe void glPointParameterivNV(OpenTK.Graphics.OpenGL.NvPointSprite pname, Int32* @params);
        [Slot(1520)]
        static extern void glPresentFrameDualFillNV(UInt32 video_slot, UInt64 minPresentTime, UInt32 beginPresentTimeId, UInt32 presentDurationId, OpenTK.Graphics.OpenGL.NvPresentVideo type, OpenTK.Graphics.OpenGL.NvPresentVideo target0, UInt32 fill0, OpenTK.Graphics.OpenGL.NvPresentVideo target1, UInt32 fill1, OpenTK.Graphics.OpenGL.NvPresentVideo target2, UInt32 fill2, OpenTK.Graphics.OpenGL.NvPresentVideo target3, UInt32 fill3);
        [Slot(1521)]
        static extern void glPresentFrameKeyedNV(UInt32 video_slot, UInt64 minPresentTime, UInt32 beginPresentTimeId, UInt32 presentDurationId, OpenTK.Graphics.OpenGL.NvPresentVideo type, OpenTK.Graphics.OpenGL.NvPresentVideo target0, UInt32 fill0, UInt32 key0, OpenTK.Graphics.OpenGL.NvPresentVideo target1, UInt32 fill1, UInt32 key1);
        [Slot(1523)]
        static extern void glPrimitiveRestartIndexNV(UInt32 index);
        [Slot(1524)]
        static extern void glPrimitiveRestartNV();
        [Slot(1529)]
        static extern unsafe void glProgramBufferParametersfvNV(OpenTK.Graphics.OpenGL.NvParameterBufferObject target, UInt32 bindingIndex, UInt32 wordIndex, Int32 count, Single* @params);
        [Slot(1530)]
        static extern unsafe void glProgramBufferParametersIivNV(OpenTK.Graphics.OpenGL.NvParameterBufferObject target, UInt32 bindingIndex, UInt32 wordIndex, Int32 count, Int32* @params);
        [Slot(1531)]
        static extern unsafe void glProgramBufferParametersIuivNV(OpenTK.Graphics.OpenGL.NvParameterBufferObject target, UInt32 bindingIndex, UInt32 wordIndex, Int32 count, UInt32* @params);
        [Slot(1536)]
        static extern void glProgramEnvParameterI4iNV(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, Int32 x, Int32 y, Int32 z, Int32 w);
        [Slot(1537)]
        static extern unsafe void glProgramEnvParameterI4ivNV(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, Int32* @params);
        [Slot(1538)]
        static extern void glProgramEnvParameterI4uiNV(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, UInt32 x, UInt32 y, UInt32 z, UInt32 w);
        [Slot(1539)]
        static extern unsafe void glProgramEnvParameterI4uivNV(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, UInt32* @params);
        [Slot(1541)]
        static extern unsafe void glProgramEnvParametersI4ivNV(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, Int32 count, Int32* @params);
        [Slot(1542)]
        static extern unsafe void glProgramEnvParametersI4uivNV(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, Int32 count, UInt32* @params);
        [Slot(1547)]
        static extern void glProgramLocalParameterI4iNV(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, Int32 x, Int32 y, Int32 z, Int32 w);
        [Slot(1548)]
        static extern unsafe void glProgramLocalParameterI4ivNV(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, Int32* @params);
        [Slot(1549)]
        static extern void glProgramLocalParameterI4uiNV(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, UInt32 x, UInt32 y, UInt32 z, UInt32 w);
        [Slot(1550)]
        static extern unsafe void glProgramLocalParameterI4uivNV(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, UInt32* @params);
        [Slot(1552)]
        static extern unsafe void glProgramLocalParametersI4ivNV(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, Int32 count, Int32* @params);
        [Slot(1553)]
        static extern unsafe void glProgramLocalParametersI4uivNV(OpenTK.Graphics.OpenGL.NvGpuProgram4 target, UInt32 index, Int32 count, UInt32* @params);
        [Slot(1554)]
        static extern unsafe void glProgramNamedParameter4dNV(UInt32 id, Int32 len, Byte* name, Double x, Double y, Double z, Double w);
        [Slot(1555)]
        static extern unsafe void glProgramNamedParameter4dvNV(UInt32 id, Int32 len, Byte* name, Double* v);
        [Slot(1556)]
        static extern unsafe void glProgramNamedParameter4fNV(UInt32 id, Int32 len, Byte* name, Single x, Single y, Single z, Single w);
        [Slot(1557)]
        static extern unsafe void glProgramNamedParameter4fvNV(UInt32 id, Int32 len, Byte* name, Single* v);
        [Slot(1558)]
        static extern void glProgramParameter4dNV(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Double x, Double y, Double z, Double w);
        [Slot(1559)]
        static extern unsafe void glProgramParameter4dvNV(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Double* v);
        [Slot(1560)]
        static extern void glProgramParameter4fNV(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Single x, Single y, Single z, Single w);
        [Slot(1561)]
        static extern unsafe void glProgramParameter4fvNV(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Single* v);
        [Slot(1565)]
        static extern unsafe void glProgramParameters4dvNV(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Int32 count, Double* v);
        [Slot(1566)]
        static extern unsafe void glProgramParameters4fvNV(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 index, Int32 count, Single* v);
        [Slot(1568)]
        static extern unsafe void glProgramSubroutineParametersuivNV(OpenTK.Graphics.OpenGL.NvGpuProgram5 target, Int32 count, UInt32* @params);
        [Slot(1578)]
        static extern void glProgramUniform1i64NV(UInt32 program, Int32 location, Int64 x);
        [Slot(1579)]
        static extern unsafe void glProgramUniform1i64vNV(UInt32 program, Int32 location, Int32 count, Int64* value);
        [Slot(1584)]
        static extern void glProgramUniform1ui64NV(UInt32 program, Int32 location, UInt64 x);
        [Slot(1585)]
        static extern unsafe void glProgramUniform1ui64vNV(UInt32 program, Int32 location, Int32 count, UInt64* value);
        [Slot(1598)]
        static extern void glProgramUniform2i64NV(UInt32 program, Int32 location, Int64 x, Int64 y);
        [Slot(1599)]
        static extern unsafe void glProgramUniform2i64vNV(UInt32 program, Int32 location, Int32 count, Int64* value);
        [Slot(1604)]
        static extern void glProgramUniform2ui64NV(UInt32 program, Int32 location, UInt64 x, UInt64 y);
        [Slot(1605)]
        static extern unsafe void glProgramUniform2ui64vNV(UInt32 program, Int32 location, Int32 count, UInt64* value);
        [Slot(1618)]
        static extern void glProgramUniform3i64NV(UInt32 program, Int32 location, Int64 x, Int64 y, Int64 z);
        [Slot(1619)]
        static extern unsafe void glProgramUniform3i64vNV(UInt32 program, Int32 location, Int32 count, Int64* value);
        [Slot(1624)]
        static extern void glProgramUniform3ui64NV(UInt32 program, Int32 location, UInt64 x, UInt64 y, UInt64 z);
        [Slot(1625)]
        static extern unsafe void glProgramUniform3ui64vNV(UInt32 program, Int32 location, Int32 count, UInt64* value);
        [Slot(1638)]
        static extern void glProgramUniform4i64NV(UInt32 program, Int32 location, Int64 x, Int64 y, Int64 z, Int64 w);
        [Slot(1639)]
        static extern unsafe void glProgramUniform4i64vNV(UInt32 program, Int32 location, Int32 count, Int64* value);
        [Slot(1644)]
        static extern void glProgramUniform4ui64NV(UInt32 program, Int32 location, UInt64 x, UInt64 y, UInt64 z, UInt64 w);
        [Slot(1645)]
        static extern unsafe void glProgramUniform4ui64vNV(UInt32 program, Int32 location, Int32 count, UInt64* value);
        [Slot(1650)]
        static extern void glProgramUniformHandleui64NV(UInt32 program, Int32 location, UInt64 value);
        [Slot(1652)]
        static extern unsafe void glProgramUniformHandleui64vNV(UInt32 program, Int32 location, Int32 count, UInt64* values);
        [Slot(1689)]
        static extern void glProgramUniformui64NV(UInt32 program, Int32 location, UInt64 value);
        [Slot(1690)]
        static extern unsafe void glProgramUniformui64vNV(UInt32 program, Int32 location, Int32 count, UInt64* value);
        [Slot(1691)]
        static extern void glProgramVertexLimitNV(OpenTK.Graphics.OpenGL.NvGeometryProgram4 target, Int32 limit);
        [Slot(1753)]
        static extern void glRenderbufferStorageMultisampleCoverageNV(OpenTK.Graphics.OpenGL.RenderbufferTarget target, Int32 coverageSamples, Int32 colorSamples, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height);
        [Slot(1779)]
        static extern unsafe void glRequestResidentProgramsNV(Int32 n, UInt32* programs);
        [Slot(1786)]
        static extern void glResumeTransformFeedbackNV();
        [Slot(1797)]
        static extern void glSampleMaskIndexedNV(UInt32 index, UInt32 mask);
        [Slot(1826)]
        static extern void glSecondaryColor3hNV(Half red, Half green, Half blue);
        [Slot(1827)]
        static extern unsafe void glSecondaryColor3hvNV(Half* v);
        [Slot(1848)]
        static extern void glSecondaryColorFormatNV(Int32 size, OpenTK.Graphics.OpenGL.NvVertexBufferUnifiedMemory type, Int32 stride);
        [Slot(1859)]
        static extern void glSetFenceNV(UInt32 fence, OpenTK.Graphics.OpenGL.NvFence condition);
        [Slot(1879)]
        static extern unsafe void glStencilFillPathInstancedNV(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, UInt32 pathBase, OpenTK.Graphics.OpenGL.NvPathRendering fillMode, UInt32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues);
        [Slot(1880)]
        static extern void glStencilFillPathNV(UInt32 path, OpenTK.Graphics.OpenGL.NvPathRendering fillMode, UInt32 mask);
        [Slot(1890)]
        static extern unsafe void glStencilStrokePathInstancedNV(Int32 numPaths, OpenTK.Graphics.OpenGL.NvPathRendering pathNameType, IntPtr paths, UInt32 pathBase, Int32 reference, UInt32 mask, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues);
        [Slot(1891)]
        static extern void glStencilStrokePathNV(UInt32 path, Int32 reference, UInt32 mask);
        [Slot(1912)]
        static extern bool glTestFenceNV(UInt32 fence);
        [Slot(1926)]
        static extern void glTexCoord1hNV(Half s);
        [Slot(1927)]
        static extern unsafe void glTexCoord1hvNV(Half* v);
        [Slot(1950)]
        static extern void glTexCoord2hNV(Half s, Half t);
        [Slot(1951)]
        static extern unsafe void glTexCoord2hvNV(Half* v);
        [Slot(1964)]
        static extern void glTexCoord3hNV(Half s, Half t, Half r);
        [Slot(1965)]
        static extern unsafe void glTexCoord3hvNV(Half* v);
        [Slot(1982)]
        static extern void glTexCoord4hNV(Half s, Half t, Half r, Half q);
        [Slot(1983)]
        static extern unsafe void glTexCoord4hvNV(Half* v);
        [Slot(1990)]
        static extern void glTexCoordFormatNV(Int32 size, OpenTK.Graphics.OpenGL.NvVertexBufferUnifiedMemory type, Int32 stride);
        [Slot(2021)]
        static extern void glTexImage2DMultisampleCoverageNV(OpenTK.Graphics.OpenGL.NvTextureMultisample target, Int32 coverageSamples, Int32 colorSamples, Int32 internalFormat, Int32 width, Int32 height, bool fixedSampleLocations);
        [Slot(2025)]
        static extern void glTexImage3DMultisampleCoverageNV(OpenTK.Graphics.OpenGL.NvTextureMultisample target, Int32 coverageSamples, Int32 colorSamples, Int32 internalFormat, Int32 width, Int32 height, Int32 depth, bool fixedSampleLocations);
        [Slot(2038)]
        static extern void glTexRenderbufferNV(OpenTK.Graphics.OpenGL.TextureTarget target, UInt32 renderbuffer);
        [Slot(2052)]
        static extern void glTextureBarrierNV();
        [Slot(2058)]
        static extern void glTextureImage2DMultisampleCoverageNV(UInt32 texture, OpenTK.Graphics.OpenGL.NvTextureMultisample target, Int32 coverageSamples, Int32 colorSamples, Int32 internalFormat, Int32 width, Int32 height, bool fixedSampleLocations);
        [Slot(2059)]
        static extern void glTextureImage2DMultisampleNV(UInt32 texture, OpenTK.Graphics.OpenGL.NvTextureMultisample target, Int32 samples, Int32 internalFormat, Int32 width, Int32 height, bool fixedSampleLocations);
        [Slot(2061)]
        static extern void glTextureImage3DMultisampleCoverageNV(UInt32 texture, OpenTK.Graphics.OpenGL.NvTextureMultisample target, Int32 coverageSamples, Int32 colorSamples, Int32 internalFormat, Int32 width, Int32 height, Int32 depth, bool fixedSampleLocations);
        [Slot(2062)]
        static extern void glTextureImage3DMultisampleNV(UInt32 texture, OpenTK.Graphics.OpenGL.NvTextureMultisample target, Int32 samples, Int32 internalFormat, Int32 width, Int32 height, Int32 depth, bool fixedSampleLocations);
        [Slot(2085)]
        static extern void glTrackMatrixNV(OpenTK.Graphics.OpenGL.AssemblyProgramTargetArb target, UInt32 address, OpenTK.Graphics.OpenGL.NvVertexProgram matrix, OpenTK.Graphics.OpenGL.NvVertexProgram transform);
        [Slot(2086)]
        static extern unsafe void glTransformFeedbackAttribsNV(UInt32 count, Int32* attribs, OpenTK.Graphics.OpenGL.NvTransformFeedback bufferMode);
        [Slot(2087)]
        static extern unsafe void glTransformFeedbackStreamAttribsNV(Int32 count, Int32* attribs, Int32 nbuffers, Int32* bufstreams, OpenTK.Graphics.OpenGL.NvTransformFeedback bufferMode);
        [Slot(2090)]
        static extern unsafe void glTransformFeedbackVaryingsNV(UInt32 program, Int32 count, Int32* locations, OpenTK.Graphics.OpenGL.NvTransformFeedback bufferMode);
        [Slot(2091)]
        static extern unsafe void glTransformPathNV(UInt32 resultPath, UInt32 srcPath, OpenTK.Graphics.OpenGL.NvPathRendering transformType, Single* transformValues);
        [Slot(2102)]
        static extern void glUniform1i64NV(Int32 location, Int64 x);
        [Slot(2103)]
        static extern unsafe void glUniform1i64vNV(Int32 location, Int32 count, Int64* value);
        [Slot(2108)]
        static extern void glUniform1ui64NV(Int32 location, UInt64 x);
        [Slot(2109)]
        static extern unsafe void glUniform1ui64vNV(Int32 location, Int32 count, UInt64* value);
        [Slot(2120)]
        static extern void glUniform2i64NV(Int32 location, Int64 x, Int64 y);
        [Slot(2121)]
        static extern unsafe void glUniform2i64vNV(Int32 location, Int32 count, Int64* value);
        [Slot(2126)]
        static extern void glUniform2ui64NV(Int32 location, UInt64 x, UInt64 y);
        [Slot(2127)]
        static extern unsafe void glUniform2ui64vNV(Int32 location, Int32 count, UInt64* value);
        [Slot(2138)]
        static extern void glUniform3i64NV(Int32 location, Int64 x, Int64 y, Int64 z);
        [Slot(2139)]
        static extern unsafe void glUniform3i64vNV(Int32 location, Int32 count, Int64* value);
        [Slot(2144)]
        static extern void glUniform3ui64NV(Int32 location, UInt64 x, UInt64 y, UInt64 z);
        [Slot(2145)]
        static extern unsafe void glUniform3ui64vNV(Int32 location, Int32 count, UInt64* value);
        [Slot(2156)]
        static extern void glUniform4i64NV(Int32 location, Int64 x, Int64 y, Int64 z, Int64 w);
        [Slot(2157)]
        static extern unsafe void glUniform4i64vNV(Int32 location, Int32 count, Int64* value);
        [Slot(2162)]
        static extern void glUniform4ui64NV(Int32 location, UInt64 x, UInt64 y, UInt64 z, UInt64 w);
        [Slot(2163)]
        static extern unsafe void glUniform4ui64vNV(Int32 location, Int32 count, UInt64* value);
        [Slot(2170)]
        static extern void glUniformHandleui64NV(Int32 location, UInt64 value);
        [Slot(2172)]
        static extern unsafe void glUniformHandleui64vNV(Int32 location, Int32 count, UInt64* value);
        [Slot(2195)]
        static extern void glUniformui64NV(Int32 location, UInt64 value);
        [Slot(2196)]
        static extern unsafe void glUniformui64vNV(Int32 location, Int32 count, UInt64* value);
        [Slot(2223)]
        static extern void glVDPAUFiniNV();
        [Slot(2224)]
        static extern unsafe void glVDPAUGetSurfaceivNV(IntPtr surface, OpenTK.Graphics.OpenGL.NvVdpauInterop pname, Int32 bufSize, [OutAttribute] Int32* length, [OutAttribute] Int32* values);
        [Slot(2225)]
        static extern void glVDPAUInitNV(IntPtr vdpDevice, IntPtr getProcAddress);
        [Slot(2226)]
        static extern void glVDPAUIsSurfaceNV(IntPtr surface);
        [Slot(2227)]
        static extern unsafe void glVDPAUMapSurfacesNV(Int32 numSurfaces, IntPtr* surfaces);
        [Slot(2228)]
        static extern unsafe IntPtr glVDPAURegisterOutputSurfaceNV(IntPtr vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, UInt32* textureNames);
        [Slot(2229)]
        static extern unsafe IntPtr glVDPAURegisterVideoSurfaceNV(IntPtr vdpSurface, OpenTK.Graphics.OpenGL.NvVdpauInterop target, Int32 numTextureNames, UInt32* textureNames);
        [Slot(2230)]
        static extern void glVDPAUSurfaceAccessNV(IntPtr surface, OpenTK.Graphics.OpenGL.NvVdpauInterop access);
        [Slot(2231)]
        static extern unsafe void glVDPAUUnmapSurfacesNV(Int32 numSurface, IntPtr* surfaces);
        [Slot(2232)]
        static extern void glVDPAUUnregisterSurfaceNV(IntPtr surface);
        [Slot(2239)]
        static extern void glVertex2hNV(Half x, Half y);
        [Slot(2240)]
        static extern unsafe void glVertex2hvNV(Half* v);
        [Slot(2253)]
        static extern void glVertex3hNV(Half x, Half y, Half z);
        [Slot(2254)]
        static extern unsafe void glVertex3hvNV(Half* v);
        [Slot(2267)]
        static extern void glVertex4hNV(Half x, Half y, Half z, Half w);
        [Slot(2268)]
        static extern unsafe void glVertex4hvNV(Half* v);
        [Slot(2284)]
        static extern void glVertexArrayRangeNV(Int32 length, IntPtr pointer);
        [Slot(2299)]
        static extern void glVertexAttrib1dNV(UInt32 index, Double x);
        [Slot(2302)]
        static extern unsafe void glVertexAttrib1dvNV(UInt32 index, Double* v);
        [Slot(2305)]
        static extern void glVertexAttrib1fNV(UInt32 index, Single x);
        [Slot(2308)]
        static extern unsafe void glVertexAttrib1fvNV(UInt32 index, Single* v);
        [Slot(2309)]
        static extern void glVertexAttrib1hNV(UInt32 index, Half x);
        [Slot(2310)]
        static extern unsafe void glVertexAttrib1hvNV(UInt32 index, Half* v);
        [Slot(2313)]
        static extern void glVertexAttrib1sNV(UInt32 index, Int16 x);
        [Slot(2316)]
        static extern unsafe void glVertexAttrib1svNV(UInt32 index, Int16* v);
        [Slot(2319)]
        static extern void glVertexAttrib2dNV(UInt32 index, Double x, Double y);
        [Slot(2322)]
        static extern unsafe void glVertexAttrib2dvNV(UInt32 index, Double* v);
        [Slot(2325)]
        static extern void glVertexAttrib2fNV(UInt32 index, Single x, Single y);
        [Slot(2328)]
        static extern unsafe void glVertexAttrib2fvNV(UInt32 index, Single* v);
        [Slot(2329)]
        static extern void glVertexAttrib2hNV(UInt32 index, Half x, Half y);
        [Slot(2330)]
        static extern unsafe void glVertexAttrib2hvNV(UInt32 index, Half* v);
        [Slot(2333)]
        static extern void glVertexAttrib2sNV(UInt32 index, Int16 x, Int16 y);
        [Slot(2336)]
        static extern unsafe void glVertexAttrib2svNV(UInt32 index, Int16* v);
        [Slot(2339)]
        static extern void glVertexAttrib3dNV(UInt32 index, Double x, Double y, Double z);
        [Slot(2342)]
        static extern unsafe void glVertexAttrib3dvNV(UInt32 index, Double* v);
        [Slot(2345)]
        static extern void glVertexAttrib3fNV(UInt32 index, Single x, Single y, Single z);
        [Slot(2348)]
        static extern unsafe void glVertexAttrib3fvNV(UInt32 index, Single* v);
        [Slot(2349)]
        static extern void glVertexAttrib3hNV(UInt32 index, Half x, Half y, Half z);
        [Slot(2350)]
        static extern unsafe void glVertexAttrib3hvNV(UInt32 index, Half* v);
        [Slot(2353)]
        static extern void glVertexAttrib3sNV(UInt32 index, Int16 x, Int16 y, Int16 z);
        [Slot(2356)]
        static extern unsafe void glVertexAttrib3svNV(UInt32 index, Int16* v);
        [Slot(2361)]
        static extern void glVertexAttrib4dNV(UInt32 index, Double x, Double y, Double z, Double w);
        [Slot(2364)]
        static extern unsafe void glVertexAttrib4dvNV(UInt32 index, Double* v);
        [Slot(2367)]
        static extern void glVertexAttrib4fNV(UInt32 index, Single x, Single y, Single z, Single w);
        [Slot(2370)]
        static extern unsafe void glVertexAttrib4fvNV(UInt32 index, Single* v);
        [Slot(2371)]
        static extern void glVertexAttrib4hNV(UInt32 index, Half x, Half y, Half z, Half w);
        [Slot(2372)]
        static extern unsafe void glVertexAttrib4hvNV(UInt32 index, Half* v);
        [Slot(2391)]
        static extern void glVertexAttrib4sNV(UInt32 index, Int16 x, Int16 y, Int16 z, Int16 w);
        [Slot(2394)]
        static extern unsafe void glVertexAttrib4svNV(UInt32 index, Int16* v);
        [Slot(2395)]
        static extern void glVertexAttrib4ubNV(UInt32 index, Byte x, Byte y, Byte z, Byte w);
        [Slot(2398)]
        static extern unsafe void glVertexAttrib4ubvNV(UInt32 index, Byte* v);
        [Slot(2408)]
        static extern void glVertexAttribFormatNV(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.NvVertexBufferUnifiedMemory type, bool normalized, Int32 stride);
        [Slot(2450)]
        static extern void glVertexAttribIFormatNV(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.NvVertexBufferUnifiedMemory type, Int32 stride);
        [Slot(2457)]
        static extern void glVertexAttribL1i64NV(UInt32 index, Int64 x);
        [Slot(2458)]
        static extern unsafe void glVertexAttribL1i64vNV(UInt32 index, Int64* v);
        [Slot(2460)]
        static extern void glVertexAttribL1ui64NV(UInt32 index, UInt64 x);
        [Slot(2462)]
        static extern unsafe void glVertexAttribL1ui64vNV(UInt32 index, UInt64* v);
        [Slot(2467)]
        static extern void glVertexAttribL2i64NV(UInt32 index, Int64 x, Int64 y);
        [Slot(2468)]
        static extern unsafe void glVertexAttribL2i64vNV(UInt32 index, Int64* v);
        [Slot(2469)]
        static extern void glVertexAttribL2ui64NV(UInt32 index, UInt64 x, UInt64 y);
        [Slot(2470)]
        static extern unsafe void glVertexAttribL2ui64vNV(UInt32 index, UInt64* v);
        [Slot(2475)]
        static extern void glVertexAttribL3i64NV(UInt32 index, Int64 x, Int64 y, Int64 z);
        [Slot(2476)]
        static extern unsafe void glVertexAttribL3i64vNV(UInt32 index, Int64* v);
        [Slot(2477)]
        static extern void glVertexAttribL3ui64NV(UInt32 index, UInt64 x, UInt64 y, UInt64 z);
        [Slot(2478)]
        static extern unsafe void glVertexAttribL3ui64vNV(UInt32 index, UInt64* v);
        [Slot(2483)]
        static extern void glVertexAttribL4i64NV(UInt32 index, Int64 x, Int64 y, Int64 z, Int64 w);
        [Slot(2484)]
        static extern unsafe void glVertexAttribL4i64vNV(UInt32 index, Int64* v);
        [Slot(2485)]
        static extern void glVertexAttribL4ui64NV(UInt32 index, UInt64 x, UInt64 y, UInt64 z, UInt64 w);
        [Slot(2486)]
        static extern unsafe void glVertexAttribL4ui64vNV(UInt32 index, UInt64* v);
        [Slot(2488)]
        static extern void glVertexAttribLFormatNV(UInt32 index, Int32 size, OpenTK.Graphics.OpenGL.NvVertexAttribInteger64bit type, Int32 stride);
        [Slot(2502)]
        static extern void glVertexAttribPointerNV(UInt32 index, Int32 fsize, OpenTK.Graphics.OpenGL.VertexAttribParameterArb type, Int32 stride, IntPtr pointer);
        [Slot(2503)]
        static extern unsafe void glVertexAttribs1dvNV(UInt32 index, Int32 count, Double* v);
        [Slot(2504)]
        static extern unsafe void glVertexAttribs1fvNV(UInt32 index, Int32 count, Single* v);
        [Slot(2505)]
        static extern unsafe void glVertexAttribs1hvNV(UInt32 index, Int32 n, Half* v);
        [Slot(2506)]
        static extern unsafe void glVertexAttribs1svNV(UInt32 index, Int32 count, Int16* v);
        [Slot(2507)]
        static extern unsafe void glVertexAttribs2dvNV(UInt32 index, Int32 count, Double* v);
        [Slot(2508)]
        static extern unsafe void glVertexAttribs2fvNV(UInt32 index, Int32 count, Single* v);
        [Slot(2509)]
        static extern unsafe void glVertexAttribs2hvNV(UInt32 index, Int32 n, Half* v);
        [Slot(2510)]
        static extern unsafe void glVertexAttribs2svNV(UInt32 index, Int32 count, Int16* v);
        [Slot(2511)]
        static extern unsafe void glVertexAttribs3dvNV(UInt32 index, Int32 count, Double* v);
        [Slot(2512)]
        static extern unsafe void glVertexAttribs3fvNV(UInt32 index, Int32 count, Single* v);
        [Slot(2513)]
        static extern unsafe void glVertexAttribs3hvNV(UInt32 index, Int32 n, Half* v);
        [Slot(2514)]
        static extern unsafe void glVertexAttribs3svNV(UInt32 index, Int32 count, Int16* v);
        [Slot(2515)]
        static extern unsafe void glVertexAttribs4dvNV(UInt32 index, Int32 count, Double* v);
        [Slot(2516)]
        static extern unsafe void glVertexAttribs4fvNV(UInt32 index, Int32 count, Single* v);
        [Slot(2517)]
        static extern unsafe void glVertexAttribs4hvNV(UInt32 index, Int32 n, Half* v);
        [Slot(2518)]
        static extern unsafe void glVertexAttribs4svNV(UInt32 index, Int32 count, Int16* v);
        [Slot(2519)]
        static extern unsafe void glVertexAttribs4ubvNV(UInt32 index, Int32 count, Byte* v);
        [Slot(2524)]
        static extern void glVertexFormatNV(Int32 size, OpenTK.Graphics.OpenGL.NvVertexBufferUnifiedMemory type, Int32 stride);
        [Slot(2569)]
        static extern void glVertexWeighthNV(Half weight);
        [Slot(2570)]
        static extern unsafe void glVertexWeighthvNV(Half* weight);
        [Slot(2572)]
        static extern unsafe OpenTK.Graphics.OpenGL.NvVideoCapture glVideoCaptureNV(UInt32 video_capture_slot, [OutAttribute] UInt32* sequence_num, [OutAttribute] UInt64* capture_time);
        [Slot(2573)]
        static extern unsafe void glVideoCaptureStreamParameterdvNV(UInt32 video_capture_slot, UInt32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, Double* @params);
        [Slot(2574)]
        static extern unsafe void glVideoCaptureStreamParameterfvNV(UInt32 video_capture_slot, UInt32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, Single* @params);
        [Slot(2575)]
        static extern unsafe void glVideoCaptureStreamParameterivNV(UInt32 video_capture_slot, UInt32 stream, OpenTK.Graphics.OpenGL.NvVideoCapture pname, Int32* @params);
        [Slot(2585)]
        static extern unsafe void glWeightPathsNV(UInt32 resultPath, Int32 numPaths, UInt32* paths, Single* weights);
        [Slot(27)]
        static extern void glBeginConditionalRenderNVX(UInt32 id);
        [Slot(480)]
        static extern void glEndConditionalRenderNVX();
        [Slot(1)]
        static extern void glAccumxOES(OpenTK.Graphics.OpenGL.OesFixedPoint op, int value);
        [Slot(13)]
        static extern void glAlphaFuncxOES(OpenTK.Graphics.OpenGL.OesFixedPoint func, int @ref);
        [Slot(100)]
        static extern unsafe void glBitmapxOES(Int32 width, Int32 height, int xorig, int yorig, int xmove, int ymove, Byte* bitmap);
        [Slot(104)]
        static extern void glBlendColorxOES(int red, int green, int blue, int alpha);
        [Slot(144)]
        static extern void glClearAccumxOES(int red, int green, int blue, int alpha);
        [Slot(154)]
        static extern void glClearColorxOES(int red, int green, int blue, int alpha);
        [Slot(158)]
        static extern void glClearDepthfOES(Single depth);
        [Slot(159)]
        static extern void glClearDepthxOES(int depth);
        [Slot(172)]
        static extern unsafe void glClipPlanefOES(OpenTK.Graphics.OpenGL.OesSinglePrecision plane, Single* equation);
        [Slot(173)]
        static extern unsafe void glClipPlanexOES(OpenTK.Graphics.OpenGL.OesFixedPoint plane, int* equation);
        [Slot(194)]
        static extern void glColor3xOES(int red, int green, int blue);
        [Slot(195)]
        static extern unsafe void glColor3xvOES(int* components);
        [Slot(220)]
        static extern void glColor4xOES(int red, int green, int blue, int alpha);
        [Slot(221)]
        static extern unsafe void glColor4xvOES(int* components);
        [Slot(293)]
        static extern void glConvolutionParameterxOES(OpenTK.Graphics.OpenGL.OesFixedPoint target, OpenTK.Graphics.OpenGL.OesFixedPoint pname, int param);
        [Slot(294)]
        static extern unsafe void glConvolutionParameterxvOES(OpenTK.Graphics.OpenGL.OesFixedPoint target, OpenTK.Graphics.OpenGL.OesFixedPoint pname, int* @params);
        [Slot(401)]
        static extern void glDepthRangefOES(Single n, Single f);
        [Slot(403)]
        static extern void glDepthRangexOES(int n, int f);
        [Slot(497)]
        static extern void glEvalCoord1xOES(int u);
        [Slot(498)]
        static extern unsafe void glEvalCoord1xvOES(int* coords);
        [Slot(503)]
        static extern void glEvalCoord2xOES(int u, int v);
        [Slot(504)]
        static extern unsafe void glEvalCoord2xvOES(int* coords);
        [Slot(513)]
        static extern unsafe void glFeedbackBufferxOES(Int32 n, OpenTK.Graphics.OpenGL.OesFixedPoint type, int* buffer);
        [Slot(550)]
        static extern void glFogxOES(OpenTK.Graphics.OpenGL.OesFixedPoint pname, int param);
        [Slot(551)]
        static extern unsafe void glFogxvOES(OpenTK.Graphics.OpenGL.OesFixedPoint pname, int* param);
        [Slot(590)]
        static extern void glFrustumfOES(Single l, Single r, Single b, Single t, Single n, Single f);
        [Slot(591)]
        static extern void glFrustumxOES(int l, int r, int b, int t, int n, int f);
        [Slot(657)]
        static extern unsafe void glGetClipPlanefOES(OpenTK.Graphics.OpenGL.OesSinglePrecision plane, [OutAttribute] Single* equation);
        [Slot(658)]
        static extern unsafe void glGetClipPlanexOES(OpenTK.Graphics.OpenGL.OesFixedPoint plane, [OutAttribute] int* equation);
        [Slot(683)]
        static extern unsafe void glGetConvolutionParameterxvOES(OpenTK.Graphics.OpenGL.OesFixedPoint target, OpenTK.Graphics.OpenGL.OesFixedPoint pname, [OutAttribute] int* @params);
        [Slot(697)]
        static extern unsafe void glGetFixedvOES(OpenTK.Graphics.OpenGL.OesFixedPoint pname, [OutAttribute] int* @params);
        [Slot(722)]
        static extern unsafe void glGetHistogramParameterxvOES(OpenTK.Graphics.OpenGL.OesFixedPoint target, OpenTK.Graphics.OpenGL.OesFixedPoint pname, [OutAttribute] int* @params);
        [Slot(743)]
        static extern unsafe void glGetLightxOES(OpenTK.Graphics.OpenGL.OesFixedPoint light, OpenTK.Graphics.OpenGL.OesFixedPoint pname, [OutAttribute] int* @params);
        [Slot(758)]
        static extern unsafe void glGetMapxvOES(OpenTK.Graphics.OpenGL.OesFixedPoint target, OpenTK.Graphics.OpenGL.OesFixedPoint query, [OutAttribute] int* v);
        [Slot(761)]
        static extern void glGetMaterialxOES(OpenTK.Graphics.OpenGL.OesFixedPoint face, OpenTK.Graphics.OpenGL.OesFixedPoint pname, int param);
        [Slot(762)]
        static extern unsafe void glGetMaterialxvOES(OpenTK.Graphics.OpenGL.OesFixedPoint face, OpenTK.Graphics.OpenGL.OesFixedPoint pname, [OutAttribute] int* @params);
        [Slot(926)]
        static extern unsafe void glGetTexEnvxvOES(OpenTK.Graphics.OpenGL.OesFixedPoint target, OpenTK.Graphics.OpenGL.OesFixedPoint pname, [OutAttribute] int* @params);
        [Slot(931)]
        static extern unsafe void glGetTexGenxvOES(OpenTK.Graphics.OpenGL.OesFixedPoint coord, OpenTK.Graphics.OpenGL.OesFixedPoint pname, [OutAttribute] int* @params);
        [Slot(935)]
        static extern unsafe void glGetTexLevelParameterxvOES(OpenTK.Graphics.OpenGL.OesFixedPoint target, Int32 level, OpenTK.Graphics.OpenGL.OesFixedPoint pname, [OutAttribute] int* @params);
        [Slot(943)]
        static extern unsafe void glGetTexParameterxvOES(OpenTK.Graphics.OpenGL.OesFixedPoint target, OpenTK.Graphics.OpenGL.OesFixedPoint pname, [OutAttribute] int* @params);
        [Slot(1052)]
        static extern void glIndexxOES(int component);
        [Slot(1053)]
        static extern unsafe void glIndexxvOES(int* component);
        [Slot(1120)]
        static extern void glLightModelxOES(OpenTK.Graphics.OpenGL.OesFixedPoint pname, int param);
        [Slot(1121)]
        static extern unsafe void glLightModelxvOES(OpenTK.Graphics.OpenGL.OesFixedPoint pname, int* param);
        [Slot(1122)]
        static extern void glLightxOES(OpenTK.Graphics.OpenGL.OesFixedPoint light, OpenTK.Graphics.OpenGL.OesFixedPoint pname, int param);
        [Slot(1123)]
        static extern unsafe void glLightxvOES(OpenTK.Graphics.OpenGL.OesFixedPoint light, OpenTK.Graphics.OpenGL.OesFixedPoint pname, int* @params);
        [Slot(1126)]
        static extern void glLineWidthxOES(int width);
        [Slot(1138)]
        static extern unsafe void glLoadMatrixxOES(int* m);
        [Slot(1145)]
        static extern unsafe void glLoadTransposeMatrixxOES(int* m);
        [Slot(1162)]
        static extern void glMap1xOES(OpenTK.Graphics.OpenGL.OesFixedPoint target, int u1, int u2, Int32 stride, Int32 order, int points);
        [Slot(1165)]
        static extern void glMap2xOES(OpenTK.Graphics.OpenGL.OesFixedPoint target, int u1, int u2, Int32 ustride, Int32 uorder, int v1, int v2, Int32 vstride, Int32 vorder, int points);
        [Slot(1172)]
        static extern void glMapGrid1xOES(Int32 n, int u1, int u2);
        [Slot(1175)]
        static extern void glMapGrid2xOES(Int32 n, int u1, int u2, int v1, int v2);
        [Slot(1190)]
        static extern void glMaterialxOES(OpenTK.Graphics.OpenGL.OesFixedPoint face, OpenTK.Graphics.OpenGL.OesFixedPoint pname, int param);
        [Slot(1191)]
        static extern unsafe void glMaterialxvOES(OpenTK.Graphics.OpenGL.OesFixedPoint face, OpenTK.Graphics.OpenGL.OesFixedPoint pname, int* param);
        [Slot(1240)]
        static extern void glMultiTexCoord1bOES(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, SByte s);
        [Slot(1241)]
        static extern unsafe void glMultiTexCoord1bvOES(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, SByte* coords);
        [Slot(1260)]
        static extern void glMultiTexCoord1xOES(OpenTK.Graphics.OpenGL.OesFixedPoint texture, int s);
        [Slot(1261)]
        static extern unsafe void glMultiTexCoord1xvOES(OpenTK.Graphics.OpenGL.OesFixedPoint texture, int* coords);
        [Slot(1262)]
        static extern void glMultiTexCoord2bOES(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, SByte s, SByte t);
        [Slot(1263)]
        static extern unsafe void glMultiTexCoord2bvOES(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, SByte* coords);
        [Slot(1282)]
        static extern void glMultiTexCoord2xOES(OpenTK.Graphics.OpenGL.OesFixedPoint texture, int s, int t);
        [Slot(1283)]
        static extern unsafe void glMultiTexCoord2xvOES(OpenTK.Graphics.OpenGL.OesFixedPoint texture, int* coords);
        [Slot(1284)]
        static extern void glMultiTexCoord3bOES(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, SByte s, SByte t, SByte r);
        [Slot(1285)]
        static extern unsafe void glMultiTexCoord3bvOES(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, SByte* coords);
        [Slot(1304)]
        static extern void glMultiTexCoord3xOES(OpenTK.Graphics.OpenGL.OesFixedPoint texture, int s, int t, int r);
        [Slot(1305)]
        static extern unsafe void glMultiTexCoord3xvOES(OpenTK.Graphics.OpenGL.OesFixedPoint texture, int* coords);
        [Slot(1306)]
        static extern void glMultiTexCoord4bOES(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, SByte s, SByte t, SByte r, SByte q);
        [Slot(1307)]
        static extern unsafe void glMultiTexCoord4bvOES(OpenTK.Graphics.OpenGL.OesByteCoordinates texture, SByte* coords);
        [Slot(1326)]
        static extern void glMultiTexCoord4xOES(OpenTK.Graphics.OpenGL.OesFixedPoint texture, int s, int t, int r, int q);
        [Slot(1327)]
        static extern unsafe void glMultiTexCoord4xvOES(OpenTK.Graphics.OpenGL.OesFixedPoint texture, int* coords);
        [Slot(1362)]
        static extern unsafe void glMultMatrixxOES(int* m);
        [Slot(1367)]
        static extern unsafe void glMultTransposeMatrixxOES(int* m);
        [Slot(1412)]
        static extern void glNormal3xOES(int nx, int ny, int nz);
        [Slot(1413)]
        static extern unsafe void glNormal3xvOES(int* coords);
        [Slot(1438)]
        static extern void glOrthofOES(Single l, Single r, Single b, Single t, Single n, Single f);
        [Slot(1439)]
        static extern void glOrthoxOES(int l, int r, int b, int t, int n, int f);
        [Slot(1442)]
        static extern void glPassThroughxOES(int token);
        [Slot(1480)]
        static extern void glPixelTransferxOES(OpenTK.Graphics.OpenGL.OesFixedPoint pname, int param);
        [Slot(1486)]
        static extern void glPixelZoomxOES(int xfactor, int yfactor);
        [Slot(1502)]
        static extern void glPointParameterxOES(OpenTK.Graphics.OpenGL.OesFixedPoint pname, int param);
        [Slot(1503)]
        static extern unsafe void glPointParameterxvOES(OpenTK.Graphics.OpenGL.OesFixedPoint pname, int* @params);
        [Slot(1505)]
        static extern void glPointSizexOES(int size);
        [Slot(1511)]
        static extern void glPolygonOffsetxOES(int factor, int units);
        [Slot(1527)]
        static extern unsafe void glPrioritizeTexturesxOES(Int32 n, UInt32* textures, int* priorities);
        [Slot(1703)]
        static extern unsafe Int32 glQueryMatrixxOES([OutAttribute] int* mantissa, [OutAttribute] Int32* exponent);
        [Slot(1712)]
        static extern void glRasterPos2xOES(int x, int y);
        [Slot(1713)]
        static extern unsafe void glRasterPos2xvOES(int* coords);
        [Slot(1722)]
        static extern void glRasterPos3xOES(int x, int y, int z);
        [Slot(1723)]
        static extern unsafe void glRasterPos3xvOES(int* coords);
        [Slot(1732)]
        static extern void glRasterPos4xOES(int x, int y, int z, int w);
        [Slot(1733)]
        static extern unsafe void glRasterPos4xvOES(int* coords);
        [Slot(1746)]
        static extern void glRectxOES(int x1, int y1, int x2, int y2);
        [Slot(1747)]
        static extern unsafe void glRectxvOES(int* v1, int* v2);
        [Slot(1789)]
        static extern void glRotatexOES(int angle, int x, int y, int z);
        [Slot(1792)]
        static extern void glSampleCoverageOES(int value, bool invert);
        [Slot(1793)]
        static extern void glSampleCoveragexOES(int value, bool invert);
        [Slot(1809)]
        static extern void glScalexOES(int x, int y, int z);
        [Slot(1920)]
        static extern void glTexCoord1bOES(SByte s);
        [Slot(1921)]
        static extern unsafe void glTexCoord1bvOES(SByte* coords);
        [Slot(1932)]
        static extern void glTexCoord1xOES(int s);
        [Slot(1933)]
        static extern unsafe void glTexCoord1xvOES(int* coords);
        [Slot(1934)]
        static extern void glTexCoord2bOES(SByte s, SByte t);
        [Slot(1935)]
        static extern unsafe void glTexCoord2bvOES(SByte* coords);
        [Slot(1956)]
        static extern void glTexCoord2xOES(int s, int t);
        [Slot(1957)]
        static extern unsafe void glTexCoord2xvOES(int* coords);
        [Slot(1958)]
        static extern void glTexCoord3bOES(SByte s, SByte t, SByte r);
        [Slot(1959)]
        static extern unsafe void glTexCoord3bvOES(SByte* coords);
        [Slot(1970)]
        static extern void glTexCoord3xOES(int s, int t, int r);
        [Slot(1971)]
        static extern unsafe void glTexCoord3xvOES(int* coords);
        [Slot(1972)]
        static extern void glTexCoord4bOES(SByte s, SByte t, SByte r, SByte q);
        [Slot(1973)]
        static extern unsafe void glTexCoord4bvOES(SByte* coords);
        [Slot(1988)]
        static extern void glTexCoord4xOES(int s, int t, int r, int q);
        [Slot(1989)]
        static extern unsafe void glTexCoord4xvOES(int* coords);
        [Slot(2007)]
        static extern void glTexEnvxOES(OpenTK.Graphics.OpenGL.OesFixedPoint target, OpenTK.Graphics.OpenGL.OesFixedPoint pname, int param);
        [Slot(2008)]
        static extern unsafe void glTexEnvxvOES(OpenTK.Graphics.OpenGL.OesFixedPoint target, OpenTK.Graphics.OpenGL.OesFixedPoint pname, int* @params);
        [Slot(2016)]
        static extern void glTexGenxOES(OpenTK.Graphics.OpenGL.OesFixedPoint coord, OpenTK.Graphics.OpenGL.OesFixedPoint pname, int param);
        [Slot(2017)]
        static extern unsafe void glTexGenxvOES(OpenTK.Graphics.OpenGL.OesFixedPoint coord, OpenTK.Graphics.OpenGL.OesFixedPoint pname, int* @params);
        [Slot(2036)]
        static extern void glTexParameterxOES(OpenTK.Graphics.OpenGL.OesFixedPoint target, OpenTK.Graphics.OpenGL.OesFixedPoint pname, int param);
        [Slot(2037)]
        static extern unsafe void glTexParameterxvOES(OpenTK.Graphics.OpenGL.OesFixedPoint target, OpenTK.Graphics.OpenGL.OesFixedPoint pname, int* @params);
        [Slot(2094)]
        static extern void glTranslatexOES(int x, int y, int z);
        [Slot(2233)]
        static extern void glVertex2bOES(SByte x);
        [Slot(2234)]
        static extern unsafe void glVertex2bvOES(SByte* coords);
        [Slot(2245)]
        static extern void glVertex2xOES(int x);
        [Slot(2246)]
        static extern unsafe void glVertex2xvOES(int* coords);
        [Slot(2247)]
        static extern void glVertex3bOES(SByte x, SByte y);
        [Slot(2248)]
        static extern unsafe void glVertex3bvOES(SByte* coords);
        [Slot(2259)]
        static extern void glVertex3xOES(int x, int y);
        [Slot(2260)]
        static extern unsafe void glVertex3xvOES(int* coords);
        [Slot(2261)]
        static extern void glVertex4bOES(SByte x, SByte y, SByte z);
        [Slot(2262)]
        static extern unsafe void glVertex4bvOES(SByte* coords);
        [Slot(2273)]
        static extern void glVertex4xOES(int x, int y, int z);
        [Slot(2274)]
        static extern unsafe void glVertex4xvOES(int* coords);
        [Slot(1026)]
        static extern void glHintPGI(OpenTK.Graphics.OpenGL.PgiMiscHints target, Int32 mode);
        [Slot(243)]
        static extern unsafe void glColorTableParameterfvSGI(OpenTK.Graphics.OpenGL.SgiColorTable target, OpenTK.Graphics.OpenGL.SgiColorTable pname, Single* @params);
        [Slot(245)]
        static extern unsafe void glColorTableParameterivSGI(OpenTK.Graphics.OpenGL.SgiColorTable target, OpenTK.Graphics.OpenGL.SgiColorTable pname, Int32* @params);
        [Slot(246)]
        static extern void glColorTableSGI(OpenTK.Graphics.OpenGL.SgiColorTable target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr table);
        [Slot(299)]
        static extern void glCopyColorTableSGI(OpenTK.Graphics.OpenGL.SgiColorTable target, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 x, Int32 y, Int32 width);
        [Slot(663)]
        static extern unsafe void glGetColorTableParameterfvSGI(OpenTK.Graphics.OpenGL.SgiColorTable target, OpenTK.Graphics.OpenGL.SgiColorTable pname, [OutAttribute] Single* @params);
        [Slot(666)]
        static extern unsafe void glGetColorTableParameterivSGI(OpenTK.Graphics.OpenGL.SgiColorTable target, OpenTK.Graphics.OpenGL.SgiColorTable pname, [OutAttribute] Int32* @params);
        [Slot(667)]
        static extern void glGetColorTableSGI(OpenTK.Graphics.OpenGL.SgiColorTable target, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, [OutAttribute] IntPtr table);
        [Slot(406)]
        static extern unsafe void glDetailTexFuncSGIS(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 n, Single* points);
        [Slot(546)]
        static extern unsafe void glFogFuncSGIS(Int32 n, Single* points);
        [Slot(688)]
        static extern unsafe void glGetDetailTexFuncSGIS(OpenTK.Graphics.OpenGL.TextureTarget target, [OutAttribute] Single* points);
        [Slot(702)]
        static extern unsafe void glGetFogFuncSGIS([OutAttribute] Single* points);
        [Slot(851)]
        static extern unsafe void glGetPixelTexGenParameterfvSGIS(OpenTK.Graphics.OpenGL.SgisPixelTexture pname, [OutAttribute] Single* @params);
        [Slot(852)]
        static extern unsafe void glGetPixelTexGenParameterivSGIS(OpenTK.Graphics.OpenGL.SgisPixelTexture pname, [OutAttribute] Int32* @params);
        [Slot(916)]
        static extern unsafe void glGetSharpenTexFuncSGIS(OpenTK.Graphics.OpenGL.TextureTarget target, [OutAttribute] Single* points);
        [Slot(927)]
        static extern unsafe void glGetTexFilterFuncSGIS(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.SgisTextureFilter4 filter, [OutAttribute] Single* weights);
        [Slot(1473)]
        static extern void glPixelTexGenParameterfSGIS(OpenTK.Graphics.OpenGL.SgisPixelTexture pname, Single param);
        [Slot(1474)]
        static extern unsafe void glPixelTexGenParameterfvSGIS(OpenTK.Graphics.OpenGL.SgisPixelTexture pname, Single* @params);
        [Slot(1475)]
        static extern void glPixelTexGenParameteriSGIS(OpenTK.Graphics.OpenGL.SgisPixelTexture pname, Int32 param);
        [Slot(1476)]
        static extern unsafe void glPixelTexGenParameterivSGIS(OpenTK.Graphics.OpenGL.SgisPixelTexture pname, Int32* @params);
        [Slot(1493)]
        static extern void glPointParameterfSGIS(OpenTK.Graphics.OpenGL.SgisPointParameters pname, Single param);
        [Slot(1497)]
        static extern unsafe void glPointParameterfvSGIS(OpenTK.Graphics.OpenGL.SgisPointParameters pname, Single* @params);
        [Slot(1798)]
        static extern void glSampleMaskSGIS(Single value, bool invert);
        [Slot(1800)]
        static extern void glSamplePatternSGIS(OpenTK.Graphics.OpenGL.SgisMultisample pattern);
        [Slot(1872)]
        static extern unsafe void glSharpenTexFuncSGIS(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 n, Single* points);
        [Slot(2009)]
        static extern unsafe void glTexFilterFuncSGIS(OpenTK.Graphics.OpenGL.TextureTarget target, OpenTK.Graphics.OpenGL.SgisTextureFilter4 filter, Int32 n, Single* weights);
        [Slot(2026)]
        static extern void glTexImage4DSGIS(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, OpenTK.Graphics.OpenGL.PixelInternalFormat internalformat, Int32 width, Int32 height, Int32 depth, Int32 size4d, Int32 border, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);
        [Slot(2051)]
        static extern void glTexSubImage4DSGIS(OpenTK.Graphics.OpenGL.TextureTarget target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 woffset, Int32 width, Int32 height, Int32 depth, Int32 size4d, OpenTK.Graphics.OpenGL.PixelFormat format, OpenTK.Graphics.OpenGL.PixelType type, IntPtr pixels);
        [Slot(2055)]
        static extern void glTextureColorMaskSGIS(bool red, bool green, bool blue, bool alpha);
        [Slot(21)]
        static extern void glAsyncMarkerSGIX(UInt32 marker);
        [Slot(356)]
        static extern unsafe void glDeformationMap3dSGIX(OpenTK.Graphics.OpenGL.SgixPolynomialFfd target, Double u1, Double u2, Int32 ustride, Int32 uorder, Double v1, Double v2, Int32 vstride, Int32 vorder, Double w1, Double w2, Int32 wstride, Int32 worder, Double* points);
        [Slot(357)]
        static extern unsafe void glDeformationMap3fSGIX(OpenTK.Graphics.OpenGL.SgixPolynomialFfd target, Single u1, Single u2, Int32 ustride, Int32 uorder, Single v1, Single v2, Int32 vstride, Int32 vorder, Single w1, Single w2, Int32 wstride, Int32 worder, Single* points);
        [Slot(358)]
        static extern void glDeformSGIX(UInt32 mask);
        [Slot(359)]
        static extern void glDeleteAsyncMarkersSGIX(UInt32 marker, Int32 range);
        [Slot(517)]
        static extern unsafe Int32 glFinishAsyncSGIX([OutAttribute] UInt32* markerp);
        [Slot(527)]
        static extern void glFlushRasterSGIX();
        [Slot(552)]
        static extern void glFragmentColorMaterialSGIX(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter mode);
        [Slot(553)]
        static extern void glFragmentLightfSGIX(OpenTK.Graphics.OpenGL.SgixFragmentLighting light, OpenTK.Graphics.OpenGL.SgixFragmentLighting pname, Single param);
        [Slot(554)]
        static extern unsafe void glFragmentLightfvSGIX(OpenTK.Graphics.OpenGL.SgixFragmentLighting light, OpenTK.Graphics.OpenGL.SgixFragmentLighting pname, Single* @params);
        [Slot(555)]
        static extern void glFragmentLightiSGIX(OpenTK.Graphics.OpenGL.SgixFragmentLighting light, OpenTK.Graphics.OpenGL.SgixFragmentLighting pname, Int32 param);
        [Slot(556)]
        static extern unsafe void glFragmentLightivSGIX(OpenTK.Graphics.OpenGL.SgixFragmentLighting light, OpenTK.Graphics.OpenGL.SgixFragmentLighting pname, Int32* @params);
        [Slot(557)]
        static extern void glFragmentLightModelfSGIX(OpenTK.Graphics.OpenGL.SgixFragmentLighting pname, Single param);
        [Slot(558)]
        static extern unsafe void glFragmentLightModelfvSGIX(OpenTK.Graphics.OpenGL.SgixFragmentLighting pname, Single* @params);
        [Slot(559)]
        static extern void glFragmentLightModeliSGIX(OpenTK.Graphics.OpenGL.SgixFragmentLighting pname, Int32 param);
        [Slot(560)]
        static extern unsafe void glFragmentLightModelivSGIX(OpenTK.Graphics.OpenGL.SgixFragmentLighting pname, Int32* @params);
        [Slot(561)]
        static extern void glFragmentMaterialfSGIX(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, Single param);
        [Slot(562)]
        static extern unsafe void glFragmentMaterialfvSGIX(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, Single* @params);
        [Slot(563)]
        static extern void glFragmentMaterialiSGIX(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, Int32 param);
        [Slot(564)]
        static extern unsafe void glFragmentMaterialivSGIX(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, Int32* @params);
        [Slot(586)]
        static extern void glFrameZoomSGIX(Int32 factor);
        [Slot(592)]
        static extern Int32 glGenAsyncMarkersSGIX(Int32 range);
        [Slot(706)]
        static extern unsafe void glGetFragmentLightfvSGIX(OpenTK.Graphics.OpenGL.SgixFragmentLighting light, OpenTK.Graphics.OpenGL.SgixFragmentLighting pname, [OutAttribute] Single* @params);
        [Slot(707)]
        static extern unsafe void glGetFragmentLightivSGIX(OpenTK.Graphics.OpenGL.SgixFragmentLighting light, OpenTK.Graphics.OpenGL.SgixFragmentLighting pname, [OutAttribute] Int32* @params);
        [Slot(708)]
        static extern unsafe void glGetFragmentMaterialfvSGIX(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, [OutAttribute] Single* @params);
        [Slot(709)]
        static extern unsafe void glGetFragmentMaterialivSGIX(OpenTK.Graphics.OpenGL.MaterialFace face, OpenTK.Graphics.OpenGL.MaterialParameter pname, [OutAttribute] Int32* @params);
        [Slot(728)]
        static extern Int32 glGetInstrumentsSGIX();
        [Slot(745)]
        static extern unsafe void glGetListParameterfvSGIX(UInt32 list, OpenTK.Graphics.OpenGL.ListParameterName pname, [OutAttribute] Single* @params);
        [Slot(746)]
        static extern unsafe void glGetListParameterivSGIX(UInt32 list, OpenTK.Graphics.OpenGL.ListParameterName pname, [OutAttribute] Int32* @params);
        [Slot(1029)]
        static extern void glIglooInterfaceSGIX(OpenTK.Graphics.OpenGL.SgixIglooInterface pname, IntPtr @params);
        [Slot(1057)]
        static extern unsafe void glInstrumentsBufferSGIX(Int32 size, [OutAttribute] Int32* buffer);
        [Slot(1066)]
        static extern bool glIsAsyncMarkerSGIX(UInt32 marker);
        [Slot(1111)]
        static extern void glLightEnviSGIX(OpenTK.Graphics.OpenGL.SgixFragmentLighting pname, Int32 param);
        [Slot(1130)]
        static extern void glListParameterfSGIX(UInt32 list, OpenTK.Graphics.OpenGL.ListParameterName pname, Single param);
        [Slot(1131)]
        static extern unsafe void glListParameterfvSGIX(UInt32 list, OpenTK.Graphics.OpenGL.ListParameterName pname, Single* @params);
        [Slot(1132)]
        static extern void glListParameteriSGIX(UInt32 list, OpenTK.Graphics.OpenGL.ListParameterName pname, Int32 param);
        [Slot(1133)]
        static extern unsafe void glListParameterivSGIX(UInt32 list, OpenTK.Graphics.OpenGL.ListParameterName pname, Int32* @params);
        [Slot(1135)]
        static extern void glLoadIdentityDeformationMapSGIX(UInt32 mask);
        [Slot(1477)]
        static extern void glPixelTexGenSGIX(OpenTK.Graphics.OpenGL.SgixPixelTexture mode);
        [Slot(1506)]
        static extern unsafe Int32 glPollAsyncSGIX([OutAttribute] UInt32* markerp);
        [Slot(1507)]
        static extern unsafe Int32 glPollInstrumentsSGIX([OutAttribute] Int32* marker_p);
        [Slot(1735)]
        static extern void glReadInstrumentsSGIX(Int32 marker);
        [Slot(1748)]
        static extern unsafe void glReferencePlaneSGIX(Double* equation);
        [Slot(1873)]
        static extern void glSpriteParameterfSGIX(OpenTK.Graphics.OpenGL.SgixSprite pname, Single param);
        [Slot(1874)]
        static extern unsafe void glSpriteParameterfvSGIX(OpenTK.Graphics.OpenGL.SgixSprite pname, Single* @params);
        [Slot(1875)]
        static extern void glSpriteParameteriSGIX(OpenTK.Graphics.OpenGL.SgixSprite pname, Int32 param);
        [Slot(1876)]
        static extern unsafe void glSpriteParameterivSGIX(OpenTK.Graphics.OpenGL.SgixSprite pname, Int32* @params);
        [Slot(1877)]
        static extern void glStartInstrumentsSGIX();
        [Slot(1892)]
        static extern void glStopInstrumentsSGIX(Int32 marker);
        [Slot(1896)]
        static extern void glTagSampleBufferSGIX();
        [Slot(180)]
        static extern void glColor3fVertex3fSUN(Single r, Single g, Single b, Single x, Single y, Single z);
        [Slot(181)]
        static extern unsafe void glColor3fVertex3fvSUN(Single* c, Single* v);
        [Slot(201)]
        static extern void glColor4fNormal3fVertex3fSUN(Single r, Single g, Single b, Single a, Single nx, Single ny, Single nz, Single x, Single y, Single z);
        [Slot(202)]
        static extern unsafe void glColor4fNormal3fVertex3fvSUN(Single* c, Single* n, Single* v);
        [Slot(212)]
        static extern void glColor4ubVertex2fSUN(Byte r, Byte g, Byte b, Byte a, Single x, Single y);
        [Slot(213)]
        static extern unsafe void glColor4ubVertex2fvSUN(Byte* c, Single* v);
        [Slot(214)]
        static extern void glColor4ubVertex3fSUN(Byte r, Byte g, Byte b, Byte a, Single x, Single y, Single z);
        [Slot(215)]
        static extern unsafe void glColor4ubVertex3fvSUN(Byte* c, Single* v);
        [Slot(444)]
        static extern void glDrawMeshArraysSUN(OpenTK.Graphics.OpenGL.PrimitiveType mode, Int32 first, Int32 count, Int32 width);
        [Slot(1017)]
        static extern void glGlobalAlphaFactorbSUN(SByte factor);
        [Slot(1018)]
        static extern void glGlobalAlphaFactordSUN(Double factor);
        [Slot(1019)]
        static extern void glGlobalAlphaFactorfSUN(Single factor);
        [Slot(1020)]
        static extern void glGlobalAlphaFactoriSUN(Int32 factor);
        [Slot(1021)]
        static extern void glGlobalAlphaFactorsSUN(Int16 factor);
        [Slot(1022)]
        static extern void glGlobalAlphaFactorubSUN(Byte factor);
        [Slot(1023)]
        static extern void glGlobalAlphaFactoruiSUN(UInt32 factor);
        [Slot(1024)]
        static extern void glGlobalAlphaFactorusSUN(UInt16 factor);
        [Slot(1404)]
        static extern void glNormal3fVertex3fSUN(Single nx, Single ny, Single nz, Single x, Single y, Single z);
        [Slot(1405)]
        static extern unsafe void glNormal3fVertex3fvSUN(Single* n, Single* v);
        [Slot(1756)]
        static extern void glReplacementCodePointerSUN(OpenTK.Graphics.OpenGL.SunTriangleList type, Int32 stride, IntPtr pointer);
        [Slot(1757)]
        static extern void glReplacementCodeubSUN(Byte code);
        [Slot(1758)]
        static extern unsafe void glReplacementCodeubvSUN(Byte* code);
        [Slot(1759)]
        static extern void glReplacementCodeuiColor3fVertex3fSUN(UInt32 rc, Single r, Single g, Single b, Single x, Single y, Single z);
        [Slot(1760)]
        static extern unsafe void glReplacementCodeuiColor3fVertex3fvSUN(UInt32* rc, Single* c, Single* v);
        [Slot(1761)]
        static extern void glReplacementCodeuiColor4fNormal3fVertex3fSUN(UInt32 rc, Single r, Single g, Single b, Single a, Single nx, Single ny, Single nz, Single x, Single y, Single z);
        [Slot(1762)]
        static extern unsafe void glReplacementCodeuiColor4fNormal3fVertex3fvSUN(UInt32* rc, Single* c, Single* n, Single* v);
        [Slot(1763)]
        static extern void glReplacementCodeuiColor4ubVertex3fSUN(UInt32 rc, Byte r, Byte g, Byte b, Byte a, Single x, Single y, Single z);
        [Slot(1764)]
        static extern unsafe void glReplacementCodeuiColor4ubVertex3fvSUN(UInt32* rc, Byte* c, Single* v);
        [Slot(1765)]
        static extern void glReplacementCodeuiNormal3fVertex3fSUN(UInt32 rc, Single nx, Single ny, Single nz, Single x, Single y, Single z);
        [Slot(1766)]
        static extern unsafe void glReplacementCodeuiNormal3fVertex3fvSUN(UInt32* rc, Single* n, Single* v);
        [Slot(1767)]
        static extern void glReplacementCodeuiSUN(UInt32 code);
        [Slot(1768)]
        static extern void glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN(UInt32 rc, Single s, Single t, Single r, Single g, Single b, Single a, Single nx, Single ny, Single nz, Single x, Single y, Single z);
        [Slot(1769)]
        static extern unsafe void glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN(UInt32* rc, Single* tc, Single* c, Single* n, Single* v);
        [Slot(1770)]
        static extern void glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN(UInt32 rc, Single s, Single t, Single nx, Single ny, Single nz, Single x, Single y, Single z);
        [Slot(1771)]
        static extern unsafe void glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN(UInt32* rc, Single* tc, Single* n, Single* v);
        [Slot(1772)]
        static extern void glReplacementCodeuiTexCoord2fVertex3fSUN(UInt32 rc, Single s, Single t, Single x, Single y, Single z);
        [Slot(1773)]
        static extern unsafe void glReplacementCodeuiTexCoord2fVertex3fvSUN(UInt32* rc, Single* tc, Single* v);
        [Slot(1774)]
        static extern void glReplacementCodeuiVertex3fSUN(UInt32 rc, Single x, Single y, Single z);
        [Slot(1775)]
        static extern unsafe void glReplacementCodeuiVertex3fvSUN(UInt32* rc, Single* v);
        [Slot(1776)]
        static extern unsafe void glReplacementCodeuivSUN(UInt32* code);
        [Slot(1777)]
        static extern void glReplacementCodeusSUN(UInt16 code);
        [Slot(1778)]
        static extern unsafe void glReplacementCodeusvSUN(UInt16* code);
        [Slot(1939)]
        static extern void glTexCoord2fColor3fVertex3fSUN(Single s, Single t, Single r, Single g, Single b, Single x, Single y, Single z);
        [Slot(1940)]
        static extern unsafe void glTexCoord2fColor3fVertex3fvSUN(Single* tc, Single* c, Single* v);
        [Slot(1941)]
        static extern void glTexCoord2fColor4fNormal3fVertex3fSUN(Single s, Single t, Single r, Single g, Single b, Single a, Single nx, Single ny, Single nz, Single x, Single y, Single z);
        [Slot(1942)]
        static extern unsafe void glTexCoord2fColor4fNormal3fVertex3fvSUN(Single* tc, Single* c, Single* n, Single* v);
        [Slot(1943)]
        static extern void glTexCoord2fColor4ubVertex3fSUN(Single s, Single t, Byte r, Byte g, Byte b, Byte a, Single x, Single y, Single z);
        [Slot(1944)]
        static extern unsafe void glTexCoord2fColor4ubVertex3fvSUN(Single* tc, Byte* c, Single* v);
        [Slot(1945)]
        static extern void glTexCoord2fNormal3fVertex3fSUN(Single s, Single t, Single nx, Single ny, Single nz, Single x, Single y, Single z);
        [Slot(1946)]
        static extern unsafe void glTexCoord2fNormal3fVertex3fvSUN(Single* tc, Single* n, Single* v);
        [Slot(1948)]
        static extern void glTexCoord2fVertex3fSUN(Single s, Single t, Single x, Single y, Single z);
        [Slot(1949)]
        static extern unsafe void glTexCoord2fVertex3fvSUN(Single* tc, Single* v);
        [Slot(1977)]
        static extern void glTexCoord4fColor4fNormal3fVertex4fSUN(Single s, Single t, Single p, Single q, Single r, Single g, Single b, Single a, Single nx, Single ny, Single nz, Single x, Single y, Single z, Single w);
        [Slot(1978)]
        static extern unsafe void glTexCoord4fColor4fNormal3fVertex4fvSUN(Single* tc, Single* c, Single* n, Single* v);
        [Slot(1980)]
        static extern void glTexCoord4fVertex4fSUN(Single s, Single t, Single p, Single q, Single x, Single y, Single z, Single w);
        [Slot(1981)]
        static extern unsafe void glTexCoord4fVertex4fvSUN(Single* tc, Single* v);
        [Slot(521)]
        static extern void glFinishTextureSUNX();
    }
}
